<document>
@* <a href=@talk-dot.html target=_top>Distributed Object Patterns</a>
<slide color=gold id=dot cap="Distributed Object Patterns">
@ Distributed Object Patterns
<ul>
<li> Software Engineering: <red> risk <-> challenge</red>
<li> CORBA - guidance <red>(OO, C/S, IDL)</red>
<li> Object-Oriented Architectures
</ul>
See CORBA Design Patterns
</slide>

<slide id=dot-scale cap="Scale ...">
@ Corba Design Patterns 
///<blue>scale</blue>
<ul>
<li> Objects/Classes
<li> MicroArchitectures
<li> Framework /// <red>(class hierarchies)</red>
<li> Applications /// <red>(wrappers)</red>
<li> System /// <red>(horizontal, vertical, metadata)</red>
<li> Enterprise /// <red>reference models, infrastructure, policies)</red>
<li> Intra/Internet /// <red>(standards)</red>
</ul>
</slide>

<slide id=dot-arch cap="Object-Oriented Architectures">
@ Object-Oriented Architectures
<ul>
<li> Application Design Patterns
<li> System Design Patterns
<li> Enterprise Design Patterns
<li> Global Design Patterns
</ul>
<hr>
<red>CORBA IDL as a baseis for interface definitions</red>
</slide>

<slide id=dot-template cap="Template Design Pattern">
<image name=local/patterns/dot>
</slide>

<slide id=dot-template-text cap="Template Design Pattern">
@ Template Design Pattern
<ul>
<li> Pattern Name
<li> Most applicable scale
<li> Solution type
<li> Intent
<li> Diagram
<li> Referemces
<li> Applicability
<li> Benefits and consequences
<li> Variations
<li> Rescaling to other levels
<li> Related solutions
<li> Example
<li> Background
<li> Resources
</ul>
</slide>

<slide dot-compete cap="The competition?">
@ Is there competition for patterns?
<ul>
<li> <red>standards</red> -- too many, no guidelines, poorly supported
</ul>
@ Criteria
<ul>
<li> interoperability
<li> portablity
</ul>
</slide>

<slide id=dot-corba cap="CORBA ...">
@ CORBA
<ul>
<li> is a commercial standard from OMG,
whose mission it is to define <red>interfaces</red>
for interoperable software using 
<red>object-oriented technology</red>
</ul>
@ Object Management Architecture
<ul>
<li> high level infra-structure for distributed computing
<li> reusable modular software
<li> distributed heterogeneous systems
</ul>
@ Key reasons for CORBA in the future
<ul>
<li> <red>IDL</red> -- universal notation for software interfaces
<li> <red>ORB</red> -- infra-structure simplifies distributed computing
</ul>
</slide>

<slide id=dot-architecture cap="Software Architecture">
<image name=local/patterns/architecture>
</slide>

<slide id=dot-arch-b cap="Architectures and Boundaries">
@ Architectures and Boundaries
<ul>
<li> surprisingly little detail is included in OOAD models
<li> <red>interfaces</red> are treated as coding details,
to be fleshed out at the programming level
</ul>
<a href=local/patterns/boundary.gif>
<image name=local/patterns/boundary>
</a>
<ul>
<li> <blue>architecture</blue> -- abstraction, management of change, complexity
<li> <blue>interfaces</blue> -- language independent
<li> <blue>implementation</blue> -- software modules
</ul>
<hr>
<p> <red>
software problems are due to poor definitions 
and transfer of software boundaries</red>
</slide>

<slide id=dot-problem cap="The Problem">
<image name=local/patterns/problem>
</slide>

<slide id=dot-solution cap="The Solution">
<image name=local/patterns/solution>
</slide>

<slide id=dot-architecture-rules cap="Architecture">
<p>
<red>architecture = set of rules, guidelines,
interface conventions</red>
<hr><p>
<blue>The architect defines a robust set of abstractions that manage complexity, change
and other forces
</blue>
<ul>
<li> issues of software partitioning /// logical separation
<li> flow of control
<li> flow of information
<li> timing and throughput
<li> interface layering
<li> hardware/software allocation
<li> error handling /// frequently overlooked
</ul>
</slide>

<slide id=dot-service cap="Service-based Architecture">
<p>
In a distributed system, the lack of a single address space
and the need for independent reusable services are addressed by having
a <red>service-based</red> architecture
</slide>

<slide id=dot-stable cap="Stable Interfaces">
<control>
<table cellspacing=10>
<tr>
<td></td><td><blue>Stable/Reusable Interfaces</blue></td>
<td><blue>Changeable Specifications</blue></td>
</tr>

<tr>
<td><blue>Data/Interface Partitioning</blue></td>
<td>IDL Interfaces</td>
<td>Data &amp; Meta Data</td>
</tr>

<tr>
<td><blue>Interface Specialization</blue></td>
<td>Horizontal Interfaces</td>
<td>Vertical Interfaces</td>
</tr>
</control>
<hr>
<p><red>... mandating a single type system for all applications is unrealistic ...</red>
</slide>

<slide id=dot-language cap="Design Pattern Language">
@ <font color=blue>Design Pattern Language</font>
@ Primal Forces
/// <font color=red>risk is the universal force</red>
<ul>
<li><red>Functionality</red> -- to meet end users requirements
<li> <red>Performance</red> -- computation/network bound
<li> <red>complexity</red> -- hotspots, redesign, abstraction
<li> <red>Change</red> -- adaptability ...
<li> <red>IT Resources</red> -- hardware / software
<li> <red>Technology Transfer</red> -- <blue>education has a price tag</blue>
</ul>
</slide>

<slide id=dot-the-patterns cap="The Patterns">
@ Application Design Patterns
<ul>
<li> maximizing parallelism 
-- <green>distributed callback, partial processing, 
independent objects</green>
<li> improving object implementations
-- <green>dynamic attributes, instance reference, object wrapper, lock</green>
<li> modifying client stubs and other tricks
-- <green>library skeleton, fine-grained framework</green>
</ul>
@ System Design patterns
<ul>
<li> Principles of object-oriented architectures
/// horizontal, vertical, meta-data
---<green>architecture mining</green>
<li> fundamental structural patterns
-- <green>repository architecture, gateway</green>
<li> advanced system design
-- <green>architecture enforcement, replication, agaents</green>
<li> Using OMG CORBA Services
-- <green>naming, trader, notification</green>
</ul>
@ Enterprise Design Patterns
<ul>
<li> /// organisational infra structure
</ul>
@ Global Design Patterns
<ul>
<li> /// open systems/Int(e)r(a)net
</ul>
</slide>
</document>
