<document>
@* <a href=@talk-embed.html target=_top>Embedded Logic</a>


@* <a href=@talk-intro.html target=_top>Introduction</a>


<slide id=embed cap="Embedded Logic">
@ Embedded Logic
<ul>
<li> (SG/X)ML-like syntax for queries
<li> logic engine in filter
<li> Note: this is an offline approach
<li> Rationale: only knowledge maintenance
</ul>
</slide>

<slide id=embed-query cap="Querying from a document">
@ Querying from a document
<ul>
<li> a simple knowledge base: <a href=people.pl.html>people</a>
<li> some rules: concerning the <a href=institute.pl.html>institute</a>
<li> a query: to collect <a href=mailinglist.in.html>email adresses</a>
</ul>
<hr>
<p>Motivation: e.g the <a href=http://www.cs.vu.nl/~eliens/imse>
IM&amp;SE Colloquium</a>.
</slide>


@* <a href=@talk-local.html target=_top>Querying a knowledge base</a>


<slide id=local-example cap="Obtaining the mailinglist">
@ Example - <a href=mailinglist.in.html>maintaining a mailing list</a>


<display>
< query kit=pl cmd=:(write(ht-ml),nl)>< / query >



< query kit=pl src=local.pl cmd=X:email_address(X)>
< param format=" %s">
< param result="">
< param display="<h4>The query</h4>">
< param header="<h4>The adresses</h4> <ul>">
< param footer="</ul>">
email_address(E) :-
	person(X),
	property(X,name:N),
	property(X,familyname:F),
	email(X,E),
	cout(['<li>', N,' ',F,' has email adress ']),
	cout([ '<a href=mailto:', E, '?subject=IM-SE>', E, '</a>',nl]).
</ query>



< query kit=pl cmd=X:email_address(X)>
< param format="">
< param result="%s,">
< param header="<h4>The mailing list</h4><a href=mailto:">
<param footer="imse-l@cs.vu.nl>mailing list</a>">
</ query>
</display>
</slide>

<slide id=local-more cap="What institute ...">
@ <a href=institute.in.html>What institute ... </a>

<program>

< p >
Bastiaan is working at the
< query kit=pl cmd=X:institute(bastiaan,X) result="%s" >< / query >.
< p >
Martijn belongs to the division
< query kit=pl cmd="X:division(martijn,X)" result="%s"> </ query >
of the < query kit=pl cmd="X:institute(martijn,X)" result="%s"></ query >.
< p >
Jacco however works currently at the
< query kit=pl cmd=X:institute(jrvosse,X) result="%s" > < / query>.
</display>
<p>
BTW. Projection to a variable is be done explicitly, as in
<tt>cmd=X:institute(jrvosse,X)</tt>.
</slide>


@* <a href=@talk-remote.html target=_top>Remote knowledge</a>


<slide id=remote cap="Distributed knowledge">
@ Remote (distributed) knowledge
<ul>
<li> maintaining knowledge is difficult
<li> don't replicate, otherwise
<li> so we need to access knowledge from remote sources
<li> and possibly mix remote and local knowledge
<li> Solution: <a href=remote.pl.html>url-enabled consults</a>
<li> Problem: availability of the (VU) server
</ul>
</slide>

<slide id=remote-example cap="example - remote knowlegde">
@ Example - <a href=remote.in.html>remote knowledge</a> 

</slide>

<slide id=remote-remarks cap="Remarks">
@ Remarks
<ul>
<li> queries may clash, we need seperate 'engines' 
<li> this is static, the next step is dynamic: signed applets
<li> this is research code, not production code
</ul>
</slide>


@ The external shell


<slide id=sh-example cap="The example">
@ Example - <a href=sh.in.html>external (prolog) shell</a>

</slide>


@* Embedding logic in C


<slide id=c-example cap="Example in C">
@ <a href=c.in.html>Example</a> - <a href=local.c.html>Embedded logic in C</a>
<hr>
See <a href=simple.c.html>simple.c</a> and <a href=sh.c.html>sh.c</a>
for some more examples.
</slide>



@* Embedding logic in Java


<slide id=java-example cap="Example in Java">
@ <a href=java.in.html>Example</a> - <a href=local.java.html>Embedded logic in Java</a>
<hr><p>
Look at the <a href=@debug-java.html>debug information</a>

<hr>
See <a href=simple.java.html>simple.java</a> and
<a href=sh.java>sh.java</a> for some more examples.
</slide>


@* <a href=@talk-corba.html target=_top>Distributed knowledge servers</a>

<slide id=corba cap="Distributed knowledge servers">
@ Distributed knowledge servers
<ul>
<li> The next step is to distribute knowledge processing
<li> A simple CORBA framework: 
<a href=client.c.html>client</a>
and <a href=server.c.html>server</a>
<li> Both <a href=client.pl.html>client</a>
and <a href=server.pl.html>server</a> can be logic-enabled.
<li> The <a href=@online/hush/examples/experimental/universe/index.html>universe</a>
is more logical than it appeared at first sight.
</ul>
</slide>

<slide id=corba-test-0 cap="Distributed knowledge processing - example">
@ Example - distributed knowledge processing
<hr><p>
Look at the <a href=@debug-corba.html>debug information</a>

</slide>

<slide id=corba-test-1 cap="Distributed knowledge processing - example (2)">
@ Example - distributed knowledge processing
<hr><p>
Look at the <a href=@debug-corba.html>debug information</a>

</slide>


<slide id=final cal=Finally>
@ Embedded CORBA clients

@ <a href=format.html>format</a>
@ <a href=result.html>result</a>
</slide>

@* Conclusions

<slide id=conclusions cap="Conclusions">
@ Conclusions
<ul>
<li> knowledge management with logic is feasible
<li> has applications in document engineering and ...
<li> embedding is relatively efficient
<li> can be done in multiple ways
<li> corba enabled logic services are possible
<li> true logic is hard to debug
</ul>
@ Future developments
<ul>
<li> dynamic: signed applets
</ul>
</slide>

</document>
