
:@* Remarks

:@+ Questionaire

<D
-[prototypes $\not=$ inheritance] --
this is addressed but may need more
emphasis, particularly in chapters 1 and 2.
D>

:@+ Assessment

:@ Organization

<D
-[slides] -- the slides in the text
have a 1-1 correspondence with
the slides included in the Instructors Guide.
On request of Alan Grove, the text is now
explicitly related to the slides
by a slide reference number.

-[introduction of terms] --
I have taken care of introducing
the terminology in a gradual way,
starting in section 1.1.1 where the
terminology related to OOP is explicitly
introduced.

-[discussion on topics] --
I agree with the reviewer on the particular
OSI section.
With reference to the OMG, I ahve explicitly
introduced the problem of application
interoperability and standards.
(In the new version, I have included an
additional subsection discussing the
ODMG-93 standardization efforts as well.)

-[general problems of programming] --
My experience in class indicates that it
is necessary to present the constructs
available to the programmer in sufficient
detail before raising general issues
of design or program organization.
renaming the chapter into
{\em Object oriented programming constructs}
may perhaps lead to a better match between
the reader's expectations and the contents
of the chapter.

D>

:@ Content

<D

-[distribution and persistence] --
Persistence is referred to a number of times.
In the new version, as already remarked,
I have included a subsection presenting
the ODMG-93 standard.
I could expand on both distribution and
persistence, but I must remark that these
are both topics of intensive research
for which no generally accepted insights
are available.

-[ML] -- Not mentioning ML is clearly
an omission. In addition, I may mention
that I recommend a suit of exercises
and a tool {\em fomega}, that is strongly
related to ML.

-[CLOS] -- I do recommend the study of CLOS,
but do not present any substantial material myself.
At the start, I have decided to concentrate
on the classical OO languages Smalltalk,
Eiffel and C++, while allowing my self a brief
digression to multi-paradigm languages.
As the reviewer aptly recognizes, there
is a strong bias towards C++.
This may be considered a weakness, or a strength.

-[breaking invariants] --
Section 10.5 given an example of the
problems involved in maintaining global invariants.
Both in section 3.3.3 and section 10.5,
I discuss the multi-object contract model.
However, I must remark that the
multi-object contract model is still in
a research stage.
Both the notat6ion and its underlying concepts
are not sufficiently well-established
to present it in class.

-[polymorphism] --
Section 9.3, entitled {\em Flavors of polymorphism},\
does address this issue.
Moreover, chapter 2 discusses overloading,
type conversion and generic classes
as examples of polymorphism.
(This may be emphasized more explicitly, though.)
Also, in sections 9.4.2 and 9.5,
I stress the importance of overloading
as one of the means to define polymorphic types.

-[errors in the examples] --
Indeed, it was a first version.
The errors will be corrected.

-[surprising assertions] --
The remark that Z has a {\em strongly
object-based flavor} may be found in the 
reference following the remark.
It may be weakened to the observation
that Z is concerned with the {\em specification
of abstract data types}.
The assertion was intended to invite
the reader to study Z.
Initially an example Z specification was
included, but I decided to leave it out
in order to avoid the introduction of
detailed Z notation.

-[bias to C++] --
Section 2.6 points to some of the deficiencies
of C++.
However, appendix C may be a good place to
list and emphasize the weaknesses of C++.

D>

:@ Style

<D

-[parentheses] -- A number of collegues
ahve remarked about my use of parentheses.
This will be fixed.

-[the writing is very wordy] --
Naturally, within my capabilities,
I will rework the passages that are considered
{\em wordy} or {\em woolly}.
I will follow the comments of the reviewer.

-[reference] -- It was a first version.
Repeated references will be avoided.
(The inconsistencies in the reference format
are due to the fact that many references
had not been detailed.
This explains the occurrence of XX in the text.)

-[font conventions] --
The font conventions can easily
be modified.
Having the reserved words in italics reflects
my taste, but I am willing to consider the use
of bold or typewriter font instead.

D>

:@ Questions
<E
-
In the new version, for each chapter there
are 8-16 questions.
Answers to the questions are given in an
appendix.
It seems best to include the answers
in the book instead of the Instructors Guide.
What do you think?
E>

:@ Mathematics
<D
-[properly connected] --
The errors will be corrected.
The reviewer, however, seems to have missed
the discussion concerning the flavors of 
polymorphism.
D>

:@ Case studies

<I

- A single running example,
although certainly a nice idea,
seems to be infeasible.
The book approaches object orientation
from a variety of perspectives.
It does {\bf not} introduce a method,
but discusses viewpoints and technical issues.
For many examples, I have already adapted
the notation in order to come to
a consistent style of presentation.
Moreover, many of the examples
belong to the classical CS and OO
repertoire.
I do not see how to have a running example
demonstrating how the concepts fit together.

- The other suggestion, to incorporate a hypermedia
application illustrating the concepts and
techniques presented previously,
seems much more realistic.
However, I can imagine that a more fully
worked out case study may better be presented
in an appendix.

I>

:@ Material

<I

- The bugs will be corrected.
- I will include an overview of the
formal work on OO, if you wish.
Appendix F, however, already
presents a number of sources on
the Internet where {\em formal} material
(overviews, articles and tools)
can be found.

I>

