\section*{Reader {\em Object Oriented Programming}}

This reader contains a collection of articles representing the multiple
facets of object-oriented programming.

Part I delineates the concept of object oriented programming and 
deals with issues of object oriented design.
Part II introduces object oriented libraries and their use in
application frameworks.
Part III presents material on abstract data types and inheritance, 
it provides the theoretical foundations for studying inheritance
and object oriented type systems.
Part IV contains papers on object-based language design.
It includes an example of a multi-paradigm language combining logic
programming with object-oriented features and parallelism.

The papers collected in this reader
cover object oriented programming from the perspective of software
engineering (part I and II), and from a theoretical perspective
(especially part III).
The relevance of object oriented programming to artificial intelligence
is touched upon in part III, discussing inheritance, and part IV,
describing the specification and implementation of 
a simple medical expert system in an object-oriented distributed
logic programming language.

The collected papers provide a starting point for research in any one
of these directions.
Recommendations for further reading are given below.

@ Object Oriented Programming
An excellent introduction to object oriented programming is given in
[_Budd91].
For those knowing C, an introduction to C++ is given in
[_Pohl89].
The language Eiffel is introduced in
[_Meyer88].
Data-abstraction and object-oriented programming in C++
is treated in
[_GOP90]. The library of C++ introduced therein is also described in 
[Gorlen87].
Strongly recommended is the treatment of C++ (and OOP) given 
by the designer of C++ in [_St91].
Another introduction to object oriented programming and C++
is given in
[_WP88].

@ Object Oriented Programming and Software Engineering
An very well written introduction to object oriented
software engineering with C++ is given in [_Ince91].
Object oriented design with applications is treated in 
[_Booch91].
Object oriented analysis is the subject of
[_CY90].
A very readable account of object oriented design is given in
[_WWW90].
Object oriented modeling is treated in [_Rum91].
In [_Graham91] an overview is given of object oriented methods,
covering the analysis, design and implementation of systems.

@ Object Oriented Programming and Artificial Intelligence
The role of object oriented programming in Artificial Intelligence
is exhaustively treated in [_Tello89].
Apart from describing numerous AI-systems embodying
object oriented notions, a number of research issues 
concerning the relation of object oriented programming
to AI is discussed.
 
@ Theoretical issues of Object Oriented Programming
A number of references to theoretical work on type-systems
for object oriented programming languages is given in
[_DT88].
As an example of a semantical treatment of inheritance look at
[_CoPa89].

@ Additional literature
A collection of research papers dealing with object oriented
notions in databases and expert systems is contained in
[_KL89].
A more systematic discussion of the problems in
combining object oriented, deductive and hypermedia technologies
is given in [_PCKW89].
A variety of research papers is further found in
[_SW87].
Object oriented programming and concurrency is the subject
of the majority of papers in [_YT87].
The design, semantics and implementation of
the distributed logic programming language DLP,
extending Prolog to a parallel object oriented language,
is described in [_Eli92].
