<document>
:@+ Inleiding Multimedia<em> -- eindtermen en doelstellingen</em>
Anton Eliens
<control>
<hr>
<hr>
</control>
<!--\vspace{1cm}-->
Deze notitie geeft een overzicht van de eindtermen en leerdoelstellingen
van de cursus Inleiding Multimedia, gepland voor de propedeuse Informatica aan de vrije Universiteit Amsterdam, aan te vangen 1999/2000.
De notitie is tot stand gekomen in samenwerking met de onderstaande
Multimedia Klankbordgroep.
<br>
Online versie: http://www.cs.vu.nl/~eliens/mm/voorstel.html


:@ <a href=mailto:Lynda.Hardman@cwi.nl,Jacco.van.Ossenbruggen@cwi.nl,Lloyd.Rutledge@cwi.nl,eliens@cs.vu.nl</a>Multimedia Klankbordgroep</a>
<ul>
<li> Lynda Hardman -- //mailto:Lynda.Hardman@cwi.nl
<li> Jacco van Ossenbruggen -- //mailto:Jacco.van.Ossenbruggen@cwi.nl
<li> Lloyd Rutledge -- //mailto:Lloyd.Rutledge@cwi.nl
</ul>

:@+ Achtergrond 
Inleiding Multimedia neemt een centrale plaats in
bij de nieuwe variant <em>Multimedia en Cultuur</em>.
Tevens wordt beoogd in Inleiding Multimedia ook voor  andere
Informatica en Bedrijfsinformatica studenten
relevant materiaal aan te bieden.

:@+ Eindtermen
De student moet na het volgen van Inleiding Multimedia
inzicht hebben in de structuur van multimedia informatiesystemen,
ervaring met het ontwerp van multimedia presentaties, en
gevoel voor de aesthetiek en de functionaliteit van multimedia.
Onder structuur verstaan we zowel de conceptuale structuur
van de informatie alsook de architectuur van
de systemen waarin multimedia informatie opgeslagen is,
waarbij inbegrepen technische aspecten zoals compressie
en bandbreedte bij transmissie over een netwerk.

:@+ Leerdoelstellingen
De aangegeven eindtermen leiden tot een
duale leerdoelstelling voor het vak Inleiding Multimedia,
namelijk een theoretische en een praktische.
In het theoretisch deel wordt aandacht besteed aan
de organisatie en query aspecten van multimedia informatie,
alsook aan technische aspecten van 'networked multimedia'.
In het praktisch deel doet de student ervaring op
met het ontwikkelen van een multimedia presentatie,
zodanig dat daarin conceptuele organisatie, aesthetische
effectiviteit, en 'bevraagbaarheid' aan de orde komen.

:@ Theoretische aspecten
<ul>
<li> toepassingen van multimedia informatie systemen 
<li> opslag en indexering van multimedia informatie
<li> information retrieval: precision en recall
<li> multimedia query talen (als uitbreiding op SQL)
<li> architectuur van multimedia informatie systemen
<li> informatie presentatie
en visuele communicatie technieken
</ul>

:@ Praktische aspecten
<ul>
<li> ontwikkeling van draaiboek voor multimedia presentatie
<li> conceptuele organisatie van multimedia informatie
<li> ontwerp van navigatie structuur
<li> ontwikkeling van multimedia inhoud
<li> aesthetische aspecten van multimedia
</ul>

:@+ Inleiding Multimedia -- realizatie

In het onderstaande wordt een schets gegeven van de 
organizatie en de inhoud van het vak Inleiding Multimedia.
Getracht is om in de beperkte tijd die voor het vak
beschikbaar is (2 studiepunten), voldoende materiaal
en oefeningen op te nemen.


:@ Algemene organizatie
Het blok voor Inleiding Multimedia beslaat 4 weken, die halftijds
aan het vak besteed kunnen worden.
In de eerste twee weken zal de nadruk op de theorie liggen,
daarna zal meer aandacht besteed worden aan de praktische
aspecten.
Het ligt in de bedoeling gastsprekers uit te nodigen,
waarbij voor het theoretische deel vooral gedacht wordt
aan leden van de klankbordgroep, en voor het praktische deel
aan ontwerpers uit de praktijk.
Dit laatste is overigens alleen mogelijk als er budget
voor is.

:@ Literatuur
<p>
V.S. Subrahmanian, <a href=http://www.mkp.com/books_catalog/1-55860-466-9.asp>Principles of Multimedia Database Systems</a>,
Morgan Kaufmann (1998), ISBN: 1-55860-466-9 <c>($54.95)</c><latex>(\$54.95)</latex>

<p>
\noindent
Dit boek is gekozen omdat daarin de theoretische
aspecten van multimedia informatie systemen op academisch
aanvaardbare wijze worden uiteengezet.
Tevens biedt het boek een multidisciplinair perspectief,
waardoor raakvlakken met de verschillende disciplines binnen
de Informatica (zoals Informatie Systemen, Kunstmatige Intelligente
en Computersystemen) duidelijk aangegeven kunnen worden.

:@ Authoring Tool
<p>
Macromedia Director Internet Studio 7, http://www.macromedia.com/director
<p>
\noindent
Macromedia Director is een toonaangevend authoring tool
waarmee professionele multimedia presentaties vervaardigd
kunnen worden, die ook voor het Internet geschikt zijn.
Van de studenten wordt verwacht dat ze een tweetal presentaties
met deze tool maken.
Het ligt overigens in de verwachting dat de tool ook
in andere onderdelen gebruikt zal worden.

:@ Indeling College
<ol>
<li> Multimedia Applicaties en voorbeeld 'scenarios'
<li> Multimedia databases en multidimensionale datastrukturen
<li> Images: similiarity-based retrieval,
Text: precision and recall
<li> Video: content organizatie en video query talen 
<li> Architectuur van gedistribueerde multimedia informatie systemen
<li> Ontwikkeling van gedistribueerde multimedia presentaties
<li> Visuele Communicatie Technieken
</ol>
Hierbij is uitgegaan van 8 colleges van elke twee
maal drie kawartier.
Het laatste college zal gebruikt worden voor een tentamen,
bestaande uit enkele open vragen.
Gezien de geringe tijd die beschikbaar is zal in een
aparte studiehandleiding aangegeven worden welke stof de
studenten geacht worden te beheersen.

:@ Indeling Praktikum

<ol>
<li> 30 uur: opdracht I: <em>Annotated Tour in Amsterdam</em> (3 min.)
<li> 10 uur: opdracht II: vrije opdracht (nader te bepalen) (1 min.)
</ol>
In opdracht I (ontwikkeld ism. Lloyd Rutledge)
is het de bedoeling dat aan de hand van een 
routebeschrijving door Amsterdam (eventueel als video aangeleverd)
een presentatie wordt gemaakt
waarin extra informatie wordt aangeboden over de locaties
die bezocht worden. Daartoe kan gebruik gemaakt worden
van het <a href=http://www.amsterdam.nl/bmz/adam/adam.html>Amsterdam Monumenten</a> archief.
Deze informatie is zowel langs een tijd-dimensie,
dwz. een historisch perspectief, te plaatsen, als een spatiele
dimensie, zoals vergelijkbare panden en architectuurstijlen
in andere delen van de stad.
Ook is een thematisch perspectief denkbaar waarin de nadruk ligt
op een architectuur-stijl of architectuur-element.
In deze opdracht wordt de studenten
een strak formaat opgelegd: (a) een deel waarin alleen
de tijds-dimensie aan de orde komt, (b) een deel waarin
de informatie van spatiele of thematisch aard mag zijn,
en (c) een deel waarin de student de vrije hand wordt gelaten.
<p>
Voor beide opdrachten moet zowel een presentatie
ingeleverd worden, alsook een beschrijving van het 'draaiboek'
en een rechtvaardiging van het gebruik van multimedia middelen.
Ook moet aangegeven worden op welke wijze de presentatie middels
een adequate query-taal te bevragen is.
<p>
De beoordeling omvat zowel de organisatie van de inhoud,
als de aesthetische kwaliteit van de presentatie,
dwz. de effectiviteit waarmee de multimedia middelen 
toegepast zijn.
<p>
Het ligt in de bedoeling gedurende
het prakticum gastsprekers/begeleiders
uit te nodigen die werkzaam zijn op het gebied van
multimedia en ontwerp.
Het prakticum wordt afgesloten met een klassikale presentatie
van de werkstukken waarbij de studenten commentaar op elkaars werk 
kunnen leveren.

:@ Budget
<ul>
<li> Licenties Macromedia: (via SURF) fl. 14950,-
<li> gastsprekers: jaarlijks fl 1000,-
<li> voorbereiding:  studentassistent/programmeur: 3 maanden
<li> begeleiding: 1 studentass. per 10 studenten (voor 20-25 uur)
<li> Practicum faciliteiten: 50 multimedia PCs (twee weken halftijds)
</ul>
Licenties voor Macromedia zijn te verkrijgen via 
<a href=http://www.surfdiensten.nl/licenties/software/xxtms.htm>SURF diensten</a>.
<p>
Om het prakticum soepel te laten verlopen,
is het nodig voor opdracht I een haalbaarheidsstudie 
uit te laten voeren, dwz. de opdracht
in zijn geheel door een studentassisten/programmeur
uit te laten voeren. Tevens dient op het practicum toegesneden
documentatie te worden ontwikkeld.
<p>
Met het oog op het snel groeiende aanbod van authoringtools,
en plugin extensies voor Macromedia Director,
wordt tevens aanbevolen om een budget van fl. 5.000/jaar
te reserveren
voor de aanschaf van additionele authoring software.

:@+ Relatie tot andere onderdelen

Hieronder is beknopt de relatie van het vak Inleiding Multimedia
tot andere (mogelijke) vakken uit het
Informatica curriculum aangegeven. 

:@ Voorkennis
<ul>
<li> Inleiding Computergebruik -- ev. extra module Director 7
<li> Taak-analyse en Web-applicaties -- tools uit Director 7
<li> Inleiding Gegevensverwerking -- SQL 
</ul>

:@ Vervolg/Verdieping
<ul>
<li> Multimedia Authoring (gepland voor het 2e jaar)
<li> Caput Hypermedia
<li> Caput Informatie Visualisatie (te ontwikkelen?)
<li> Web Applicaties (te ontwikkelen?)
</ul>

:@ Relevante onderwerpen voor andere vakken
<ul>
<li> Datastructuren -- multidimensionale indexering (bv. K-trees)
<li> Gegevensbanken -- opslag en verwerking van disk en CDROM
<li> Gespreide system -- netwerk access, streaming protocols, quality of service
</ul>

<so links>

</document>
