#		%W%
VPATH=.:..
P=
D=
BUGS=
OPT=
XOPT=

# Change this...
ROOT=Rt
TARGET = a.out

F1 = Rt.impl

IFILES= Rt.impl IO.impl \
        Q.impl O.impl X.impl D.impl P.impl U.impl T.impl L.impl  

SFILES= IO.spec Q.spec O.spec X.spec D.spec P.spec U.spec T.spec L.spec  
XFILES= Y.impl


PARSER= Semaphore..o Myerror..o Y_tokens..o

OFILES= Rt..o IO..o \
        Q..o  O..o  X..o  D..o  P..o  U..o  T..o Y..o L..o \
        $(PARSER)

PFILES= $(IFILES) $(SFILES) $(XFILES)


# -J defines large memory model for Sun-3
CFLAGS = -O -J

# And put all your user_defined_units..o here:
# Example: POOLUNITS = Knapsack..o Opttree..o KSroot..o
POOLUNITS = $(OFILES)

# setenv LPDIR /ufs/eliens/p
PD=$(LPDIR)
PB=$(LPDIR)/bin
PY=$(CODE)/yacck/src4/bin
PI=$(LPDIR)/include
#YACCPX= rsh ale /ober/ufs1/prisma/bin/yacc.px
YACCPX= $(PY)/yacc.px 
#YACCPX= $(PB)/yypx 

POOLINCL= $(PI)
POOLKEYS= -i $(POOLINCL)/thekeys.h
PREPOOL=$(PB)/plcpx  $(POOLKEYS) -b -q -D$D -I. -I.. -I$(POOLINCL)
YPREX= $(PREPOOL)
#YPREX= $(PB)/yprex $(POOLKEYS) -b -q -D$D -I. -I.. -I$(POOLINCL)

# This Makefile assumes there exists the environment variable PPCDIR
# pointing to the portable pool compiler's root directory.
# Example: setenv PPCDIR ~pool/ppc

RLIB = -L$(PPCDIR)/rlib -ltex -lnodex -liox -lothx -lpoolx
RUNINCL = $(PPCDIR)/rlib
BIN = $(PPCDIR)/bin

#.SUFFIXES:
.SUFFIXES: .i .s .h .x .y ..c ..o ..x .impl .spec


.i.x:; echo $*
.i.impl:; $(PREPOOL) $*.i > $*.impl 
.s.spec:; $(PREPOOL) $*.s > $*.spec
.y.impl:
	$(YACCPX) -v -e $*.y
	mv $*.impl $*.ypi
	mv $*.spec $*.yps
	$(YPREX) $*.ypi > $*.impl
	$(YPREX) $*.yps > $*.spec

.impl..o:
	@echo plx_front $*
	@PoolLib=$(PPCDIR)/plx_stdlib ;\
	export PoolLib ;\
	$(BIN)/plx_front $* > /dev/null
	$(BIN)/ppc $*
	cc -c $(CFLAGS) -I$(RUNINCL) $*..c

.i..o:
	@#$(PREPOOL) $*.i > $*.impl 
	@#$(PREPOOL) $*.s > $*.spec
	@echo plx_front $*
	@PoolLib=$(PPCDIR)/plx_stdlib ;\
	export PoolLib ;\
	$(BIN)/plx_front $* > /dev/null
	$(BIN)/ppc $*
	cc -c $(CFLAGS) -I$(RUNINCL) $*..c

.y..o:
	$(YACCPX) -v -e $*.y
	mv $*.impl $*.ypi
	mv $*.spec $*.yps
	$(PREPOOL) $*.ypi > $*.impl
	$(PREPOOL) $*.yps > $*.spec
	@echo plx_front $*
	@PoolLib=$(PPCDIR)/plx_stdlib ;\
	export PoolLib ;\
	$(BIN)/plx_front $* > /dev/null
	$(BIN)/ppc $*
	cc -c $(CFLAGS) -I$(RUNINCL) $*..c

OBJECTS = main.o


it: $(F1)
ttx: $(PFILES)
com: $(PFILES) 
	mppmx $(XOPT) $(ROOT)
int: $(PFILES) 
	plx_driver $(OPT) $(ROOT)
co: $(TARGET) 
	$(TARGET)

pl:; cp ../lib/*.pl ../*.pl .

$(TARGET): $(PFILES) $(OBJECTS) $(POOLUNITS)
	cc -o $(TARGET) $(CFLAGS) $(OBJECTS) $(POOLUNITS) $(RLIB) -lm

main.c: Rt.mk
	cp ../prs/* .
	$(BIN)/makemain

main.o: main.c
	cc -c $(CFLAGS) -I$(RUNINCL) main.c

$(POOLUNITS): $(BIN)/ppc

clean:
	rm -f *..o *..c main.c main.o *.pnull *.use *.list core

realclean:
	rm -f *..o *..c main.c main.o $(TARGET) *.pnull *.use *.list core

mail:
	cd COBIN; tar -cvf tarfile *.spec *.impl user.pl $(BUGS); \
	compress tarfile; \
	uuencode tarfile.Z tarfile Z.uu > tarfile.Z.uu; \
	mail beemster@uva < tarfile.Z.uu
