impl unit L		%%	@(#)L.i	1.3

df YPRS=Y
df Integer Int$_$
use IO, T, Y, Y_tokens, Text

#include "stdio.h"
#include "ctype.h"

#define DEBUG false
#define debug(X) if DEBUG then X fi


global eof := 0

class Token_value
var
	num put get : Integer
	string put get : String
	t put get : T
end Token_value

class L

var
	file put get : Text_Reader
	lookahead get : Char := ' '
	lineno get : Integer := 1
	token := Token.new()
	tag put get : Integer := 0
	string put get : String
	npos get put : Integer := 0
	nextlex put get : L

fn newstring( s : String ): L
temp
	l : L := L.new()
begin
	l@tag:= 1;
	l@string:= s;
	result l;
end newstring
	
fn newfile( f : Text_Reader ): L
temp
	l : L := L.new()
begin
	l@file:= f;
	result l;
end newfile
	

method nextchar(): Char
temp
	c: Char
begin
	case tag of
	0 then
		if file@Reader!at_end() then
			c:= eof@Char
		else
			c:= file!read_Char()
		fi
	or 1 then
		if npos >= #string then
			c:= eof@Char
		else
			npos:= npos+1;
			c := string[npos];
		fi
	else
		stdout!ws("Lc: error")!nwl;
	esac;
	if false & c = eof@Char & nextlex ~== nil then
		pop(); c := lookahead;
	fi;
	result c;
end nextchar

method push( thislex : L ): L
begin
	lookahead := thislex@lookahead;
	lineno := thislex@lineno;
	tag := thislex@tag;
	string := thislex@string;
	npos := thislex@npos;
	result self;
end push
	

method pop()
begin
	lookahead := nextlex@lookahead;
	lineno := nextlex@lineno;
	tag := nextlex@tag;
	string := nextlex@string;
	npos := nextlex@npos;
	nextlex := nextlex@nextlex;
end pop
	
#define tok(X) yy_._.YPRS._._._.X
#define mktok(T,N,S) \
		token@type := T; \
		token@value := Token_value.new(); \
		token@value@num := N; \
		token@value@string := S;
#define doubletok(C,T) \
		ch := c; c := nextchar(); \
		if c = ch then \
			mktok(tok(T._.T),0,"C"+"C") \
		else \
			lookahead := c; \
			mktok(ch@Integer,0,"C") \
		fi;

method next () : Token 
temp
	c,ch : Char
	s : String := ""
begin
%%  lexical  analysis  fn  */
%%  tokens ...,
%%  all  other  characters  are  returned  immediately  */

**bracket_off**
				
	c := lookahead;
	while c =  ' ' | c = '\t' | c = '\n'  do
		%% skip blanks
		if c = '\n' then lineno := lineno + 1; fi;
		c := nextchar();
		if c = '%' then
			while c ~= '\n' do
				c := nextchar();
			od;
		fi;
	od;

	%%  c  is  now  nonblank 
	%% the globals are used to identify lexical classes

	lookahead := ' ';
	if c = '\'' | c = '"' then
		ch := c;
		c := nextchar();
		while c ~= ch do
			s := s + c@String;
			c := nextchar();
		od;
		if ch = '"' then mktok(tok(QSTRING),0,s)
		else
			mktok(tok(LSTRING),0,s)
		fi
	elsif isalpha(c) | c = '_' | c = '$' then
		while isalnum(c) | c = '_' | c = '$' do
			s := s + c@String ;
			c := nextchar();
			od;
		lookahead := c;
		if islower(s[1]) then
			if s="class" | s="obj" | s="object" then
				mktok(tok(OBJECT),0,"class")
			elsif s="module" then
				mktok(tok(MODULE),0,s)
			elsif s="use" then
				mktok(tok(LSTRING),0,s);
			else
				mktok(tok(LSTRING),0,s)
			fi
		else
			mktok(tok(STRING),0,s);
		fi;
	elsif isdigit(c) then
		while isdigit(c) do
			s := s + c@String ;
			c := nextchar();
			od;
		lookahead := c;
		mktok(tok(INT),0,s);
	elsif c = ':' then
		c := nextchar();
		if c = '-' then
			mktok(tok(NECK),0,":-");
		elsif c = '=' then
			mktok(tok(ASSIGN),0,":=");
		elsif c = ':' then
			mktok(tok(CC),0,"::");
		else
			lookahead := c;
			mktok(':'@Integer,0,":");
		fi
	elsif c = '?' then
		c := nextchar();
		if c = '-' then
			mktok(tok(QUERY),0,"?-");
		elsif c = '?' then
			mktok(tok(QQ),0,"??");
		else
			lookahead := c;
			mktok('?'@Integer,0,"?");
		fi
	elsif c = '=' then
		c := nextchar();
		if c = '>' then
			mktok(tok(IMPLY),0,"=>");
		elsif c = '=' then
			mktok(tok(EQQ),0,"==");
		elsif c = '.' then
			c := nextchar();
			if c = '.' then
				mktok(tok(UNIV),0,"=..");
			else 
				lookahead := c;
				mktok(tok(UNID),0,"=.");
			fi;
		else
			lookahead := c;
			mktok('='@Integer,0,"=");
		fi
	elsif c = '>' then
		c := nextchar();
		if c = '=' then
			mktok(tok(GE),0,">=");
		elsif c = '>' then
			mktok(tok(GG),0,">>");
		else
			lookahead := c;
			mktok('>'@Integer,0,">");
		fi
	elsif c = '<' then
		c := nextchar();
		if c = '=' then
			mktok(tok(LE),0,"<=");
		elsif c = '<' then
			mktok(tok(LL),0,"<<");
		else
			lookahead := c;
			mktok('<'@Integer,0,"<");
		fi
	elsif c = '!' then
		c := nextchar();
		if c = '=' then
			mktok(tok(NE),0,"!=");
		elsif c = '!' then
			mktok(tok(XX),0,"!!");
		else
			lookahead := c;
			mktok('!'@Integer,0,"!");
		fi
	elsif c = '\\' then
		c := nextchar();
		if c = '+' then
			mktok(tok(PNOT),0,"\\+");
		else
			lookahead := c;
			mktok('\\'@Integer,0,"\\");
		fi
	elsif c = '-' then
		c := nextchar();
		if c = '-' then
			c := nextchar();
			if c = '>' then
				mktok(tok(GRARROW),0,"-->")
			else
				lookahead := c;
				mktok(tok(MM),0,"--")
			fi;
		elsif c = '>' then
			mktok(tok(ARROW),0,"->")
		else
			lookahead := c;
			mktok('-'@Integer,0,"-");
		fi
	elsif c = '&' then doubletok(&,A)
	elsif c = '{' then doubletok({,B)
	elsif c = '/' then doubletok(/,D)
	elsif c = '}' then doubletok(},E)
	elsif c = '|' then doubletok(|,O)
	elsif c = '+' then doubletok(+,P)
	elsif c = '.' then doubletok(.,S)
	elsif c = '*' then doubletok(*,T)
	elsif c = '$' then doubletok($,Y)
	elsif c = '@' then doubletok(@,Z)
	else
		mktok(c@Integer,0,c@String);
		%%token@type := c@Integer;
	fi;
	result token
end next

end L
