		%%	@(#)U.h	1.3

@[ We need to know the maximum number of declared DLP objects the system can take,
as well as the maximum number of non-logical variables each 
object can have. @]

df MAXOBJ = 24
df MAXCHV = 12

@[ We define some system constants to be used as defaults
in the allocation functions. @]

df P_NPROC = 10
df P_BRANCH = 2
df P_WIDTH = 4

@[ To handle the {\bf options} we give the definitions below. @]

df MAXOPT = 13

df Options = mkc(Con("trace"), mkc(Con("nosimplify"), \
	     mkc(Con("eager"), mkc(Con("sol"), \
	     mkc(Con("override"), mkc(Con("copy"), mkc(Con("branch"), \
	     mkc(Con("width"), mkc(Con("nproc"), mkc(Con("aux1"), \
	     mkc(Con("aux2"), Con("aux3") )))))))))))


df TRACE = 1
df NOSIMPLIFY = 2
df EAGER = 3
df NSOL = 4
df OVERRIDE = 5
df COPY = 6
df BRANCH = 7
df WIDTH = 8
df NPROC = 9
df AUX1 = 10
df AUX2 = 11
df AUX3 = 12

@[ To determine of a method call if it is acceptable we define the
macro $acceptable$. @]

df isacceptable(T,L) ( isconst("any",L) | member(Con(fof(T)),L) )

@[ In order to be able to check for keywords and special names or
operators in the DLP system the following definitions are provided. @]

df keyword(S) = ( S="object"|S="global"|S="channel"|\
	S="use"|S="isa"|S="inherit"|S="default"|\
	S="deterministic"|\
	S="var"|S="private"|S="set"|S="clear"|S="accept")

df isnode(T) = (isint(T) | isconst("here",T) | isunit(T) | \
	isnil(T) | fof(T)=":" | fof(T)="." )

df isctr(T) = (fof(T)=","|fof(T)="->"|fof(T)=";")

df simplifiable(S) = (S ~= "=" & S ~= ":=" & S ~= "::" & \
	S ~= "accept")


df opsym(S)=(S=","|S="."|S=";"|S="->"|S=":-"| \
	S="::"|S=":="| S="="|S="+"|S="-"|S="*"| \
	S="/"|S="//"|S="**"| S="@"|S="!"|S="?"| \
	S="#"|S=":"| S="&"|S="|"| S="=>"|S="<"| \
	S=">"|S="<="|S=">="|S="=="|S="!=")

df syspred(S) = (S="nl"|S="write"|S="[]")

@[ We use some macros in determining the level of tracing. @]

df tr_port(S) = (S="accepted"|S="goal"|S="call"|S="exit"| \
	S="fail"|S="yes"|S="cut*")
df db_port(S)= ( tr_port(S) | S[1]@N = 'D'@N )

