impl unit U		%%	@(#)U.i	1.3

use  IO Q T Text Nodes
include N U T

class U

@[ A term is converted to a string by means of
one of the functions below. @]

df funstr(T,X) = fc(T)+"("+t_str(a1(t))+X+t_str(a2(t))+")" 
df opstr(T) = "(" + str(a1(T)) + fc(T) + str(a2(T)) + ")"
df clstr(T) = " " +  opstr(T) + "\n" 
df objstr(T) = "*"+str(objof(T)@name)+"*"
df chvstr(T) = "+"+str(chvof(T)@name)+"+"
df prcstr(T) = "*"+prcof(T)@name+"*"

fn t_str(t:T):A   %%% str
{
if t == nil then result ""
elsif isfuncar(":-",2,t) then result clstr(t)
elsif isc(t) then return(isun(t),t_str(a1(t)),opstr(t))
elsif opsym(fof(t)) then return(isfun(t),opstr(t),fof(t))
else
  case tagof(t) of
  CON then result conof(t) or
  VAR then return(isnull(t),"_","_" + varof(t)@A) or
  FUN then return(isun(t),funstr(t,""),funstr(t,",")) or
  OBJ then result objstr(t) or
  PRC then result prcstr(t) or
  CHV then result chvstr(t) 
  else result "*" + tagof(t)@A + "*"
  esac;
fi
} t_str

@[ The {\bf map} functions for respectively environments,
substitutions and for cuts are given below. @]

fn m_e(e:E,t:T):T      %%% mape
{
if t==nil then result nil
elsif isvar(t) then return(isnull(t),t,Var(e(varof(t))))
elsif isfun(t) then result Fun(fc(t),m_e(e,a1(t)),m_e(e,a2(t)))
else result t fi
} m_e

fn m_s(s:S,t:T):T      %%% maps
{
if t==nil then result nil
elsif isvar(t) then return(unbound(varof(t),s),t,m_s(s,s(varof(t))))
elsif isfun(t) then result Fun(fof(t),m_s(s,a1(t)),m_s(s,a2(t)))
else result t fi
} m_s

fn m_c(m:N,s:A,t:T):T  %%% mapc
{
if t==nil then result t
elsif isctr(t) then result Op(fof(t),m_c(m,s,a1(t)),m_c(m,s,a2(t)))
else return(t_eq(Con("!"),t),Cuton(m,s),t)
fi
} m_c

@[ For allocating objects and processes,
using node expressions,
we define the function $nd$ and a number of auxiliary functions.

The functions $branch$, $width$ and $nproc$ assign default values
to the allocation parameters.
@]

fn branch(q:Q):N { return(q[BRANCH]=0,P_BRANCH,q[BRANCH]) } branch
fn width(q:Q):N { return(q[WIDTH]=0,P_WIDTH,q[WIDTH]) } width
fn nproc(q:Q):N { return(q[NPROC]=0,P_NPROC,q[NPROC]) } nproc

@[ The functions $guess$ and $ndsel$ are used to implement,
in a provisional way, the node expressions $ () $ and
${{N1,...,N sub {n} }}$, denoting respectively
an arbitrary node and any node from the set
containing $N1,...,N sub {n} $. @]

fn guess(q:Q):N { result my_node } guess 
fn ndsel(q:Q,t:T):N { result nd(q,0,a1(t)) } ndsel 

@[ The functions $level$ and $dim$ implement functions
used in the function $node$. @]

fn level(b,d:N):N { return(d<=0,0,b**d + level(b,d-1)) } level
fn dim(s:A,t:T):N { returnil(t,isfuncar(s,2,t),0,dim(s,a1(t))+dim(s,a2(t)),1) } dim

@[ We leave the details of the function $node$ to the reader. @]

fn nd(q:Q,n:N,t:T):N  %%% node
temp k,m,r:N, np:= nproc(q), pn,ln,nn,d,ms:N
{
if t==nil then result 0
elsif isnil(t) then result 0
elsif isconst("{}",t) then result my_node
elsif isfun(t) & fof(t)="{}" then result ndsel(q,argsof(t)) 
elsif isfuncar("#",2,t) then k:=width(q)**(dim(fof(t),t)-1);
  m:= nd(q,n,a1(t)) ; r:=nd(q,n,a2(t)) ; result (k*m + r)//np
elsif isfuncar(":",2,t) then k:=branch(q); r:= nd(q,0,a2(t));
  if ~(n=0) then d:=n else d:=dim(fof(t),t)-1 fi; 
  m:=nd(q,d-1,a1(t)); pn:= level(k,d-2); ln:= pn + (k**(d-1));
  if d=1 then
	ln:=0; nn:=0 
  else
	nn:=m-1-pn 
  fi; result (ln+nn*k+r)//np
elsif isfuncar(".",2,t) then k:=branch(q); m:=nd(q,0,a1(t));
  r:=nd(q,n+1,a2(t)); return(n=0,(m+r)//np,(k**n)**m + r)
elsif isconst("here",t) then result my_node
elsif isunit(t) then result guess(q)
else result int_of(t)//np
fi
} nd

@[ To support the tests, and selectors defined for terms we
define the functions below. @]

fn is_con(s:A,t:T):B { return(iscon(t),conof(t)=s,false) } is_con %%% iscon
fn is_fun(s:A,t:T):B { return(isfun(t),fc(t)=s,false) } is_fun %%% isfun
fn is_var(n:V,t:T):B { return(isvar(t),varof(t)=n,false) } is_var %%% isvar
fn is_clause(t:T):B { return(isfun(t),fof(t)=":-",false) } is_clause %%% isclause
fn is_fact(t:T):B { return(is_clause(t),isnil(a2(t)),false) } is_fact %%% isfact
fn head_of(t:T):T { return(is_clause(t),a1(t),Error) } head_of %%% headof

fn is_funcar(s:A,n:N,t:T):B   %%% isfuncar
{ 
if t==nil then result false
elsif is_con(s,t) then result n == 0
elsif is_fun(s,t) then result n == arity(t)
else result false fi
} is_funcar

fn func_of(t:T):A    %%% fof
{
if t==nil then result "error"
elsif iscon(t) then result conof(t)
elsif isfun(t) then result fc(t)
else result "error" fi
} func_of

@[ For extracting the arguments, selecting an argument and
for determining the arity of a function term we define the following
functions. @]

fn args_of(t:T):T  %%% argsof
{ 
if t==nil then result nil
elsif isfun(t) then return(a2(t)==nil,a1(t),mkc(a1(t),a2(t)))
else result t
fi
} args_of

fn get_n(n:N,t:T):T     %%% arg
{
if n = 1 then return(isc(t), a1(t), t) else result get_n(n-1,a2(t)) fi
} get_n

fn length(t:T):N { returnil(t,isc(t),0,1+length(a2(t)),1) } length %%% arity

@[ We may check whether a term represents an integer,
and also convert terms to integers. @]

df isdigit(c) = ( c >= '0') &  (c <= '9')
fn is_int(t:T):B {return(iscon(t),isdigit(conof(t)[1]),false)} is_int %%% isint
fn int_of(t:T):N { return(isint(t),conof(t)@N@1,my_node) } int_of %%% intof

@[ For extracting the list of variables occurring in a term
we use the function $varsin$. @]

fn v_in(t:T):T  %%% varsin
temp l:=mkc(Var(0),nil), v:=v_of(t,l), r:T:=a2(v) 
{ return(r==nil,Con("_"),r) } v_in

fn v_of(t,l:T):T
{
if t==nil then result l
elsif isvar(t) then atlist(t,l); result l
elsif isfun(t) then v_of(a1(t),l); v_of(a2(t),l); result l 
else result l
fi
} v_of

@[ We may also have to determine the highest variable number occurring
in term, or whether a term is ground. @]

fn max(i,j:N):N { return(i>j,i,j) } max
fn and(a,b:B):B { result a & b } and

fn max_v(t:T):N    %%% maxvar
{
if t==nil then result 0
elsif isvar(t) then result varof(t)
elsif isfun(t) then result max(max_v(a1(t)),max_v(a2(t)))
else result 0 fi 
} max_v

fn is_ground(t:T):B  %%% isground
{
if t==nil then result true
elsif isvar(t) then result false
elsif isfun(t) then result is_ground(a1(t)) & is_ground(a2(t))
else result true fi
} is_ground

@[ For testing the (syntactic) equality of terms,
or to determine whether they match, we need the following functions. @]

fn t_eq(t0,t:T):B     %%% equal
{
if t0 == nil | t == nil then result t0 == t
elsif tagof(t0) ~= tagof(t) then result false
else case tagof(t) of
     CON then result conof(t0) = conof(t) or
     VAR then result varof(t0) = varof(t) or
     FUN then
	return(fc(t0)=fc(t),t_eq(a1(t0),a1(t)) & t_eq(a2(t0),a2(t)),false) 
     else result t0 == t
     esac
fi
} t_eq

fn t_mt(t0,t:T):B    %%% match
{
if t0 == nil | t == nil then result t0 == t
elsif isvar(t0) | isvar(t) then result true
elsif tagof(t) ~= tagof(t0) then result false
else case tagof(t) of
     CON then result conof(t0) = conof(t) or
     FUN then 
	return(fc(t0)=fc(t),t_mt(a1(t0),a1(t)) & t_mt(a2(t0),a2(t)),false) 
     else result t0 == t
     esac
fi 
} t_mt

@[
We have defined two membership functions.
Both deliver the position where the term that is tested
for membership occurs in the list.
The result is zero if the term does not occur in
the list.

Both functions are parametrized with a function of type $fn(T,T):B$
that is used to perform the test whether the term equals or is similar
to an element in the list.
We remark that we have defined {P member(T,L) P} as
{P ( U.t_in(eq_t,T,L) > 0 ) P}.
@]

fn t_in(f:fn(T,T):B,t,l:T):N  %%% member, inlist
temp n:N
{
if l==nil then result 0
elsif isc(l) then if f(t,a1(l)) then result 1
		  else n := t_in(f,t,a2(l)); return(n>0,n+1,0);
		  fi
elsif f(t,l) then result 1
else result 0
fi
} t_in

@[
The function $atlist$ differs from the previous one in that
when  a similar term does not occur in the list, it is added
as a last element. @]

fn t_at(c:fn(T,T):B,t0,t:T):N %%% atlist
{
if t==nil then perror("t_at0:"+qstr(t0)); result -1001
elsif isc(t) then 
   if c(t0,a1(t)) then result 0
   elsif a2(t)==nil then a2(t):= mkc(t0,nil); result 1
   elsif ~isc(a2(t)) then
	if c(a2(t),t0) then result 1
	else
		a2(t):= mkc(a2(t),t0); result 2
	fi;
   else result 1 + t_at(c,t0,a2(t))
   fi
else perror("t_at:"+qstr(t0)); result -1001
fi
} t_at


@[ We also need a function that appends two terms. @]

fn t_app(l,t:T):T %%% append
{
if l==nil then result t
elsif t==nil then result l
elsif isc(l) then
	if a2(l)==nil then a2(l):= t
	elsif ~isc(a2(l)) then a2(l):= mkc(a2(l),t)
	else t_app(a2(l),t)
	fi; result l
else result mkc(l,t)
fi; 
} t_app

@[ We may have to copy a term. @] 

fn t_cpy(t:T):T %%% cpyof
{
if t==nil then result nil
else case tagof(t) of 
CON then result Con(conof(t)) or
VAR then result Var(varof(t)) or
FUN then result Fun(fc(t),t_cpy(a1(t)),t_cpy(a2(t))) or
OBJ then result Obj(objof(t)) or
PRC then result Prc(prcof(t)) or
CHV then result Chv(chvof(t)) 
else perror("t_cpy:"+str(t)); result t
esac; fi;
} t_cpy

@[ For converting (compound) terms to Prolog lists and
vice versa the functions {\it t_pl} and {\it pl_t} are used. @]

fn t__pl(t:T):T  %%% convert
{
returnil(t,isc(t),Nil,Dot(a1(t),t__pl(a2(t))),Dot(t,Nil))
} t__pl

fn pl__t(t:T):T     
{
if t==nil then result nil
elsif isconst("[]",t) then result nil
elsif isfc(".",t) then return(isnil(a2(t)),a1(t),mkc(a1(t),pl_t(a2(t)))) 
else result t fi
} pl__t


@[ To extract the name of a non-logical variable, possibly
containing an initialization we use the $nameof$ function. @]

fn g_n(t:T):T        %%% nameof
temp s:=fof(t)
{
return(s=":"|s="::"|s="=",g_n(a1(t)),t)
} g_n

@[ To recognize the clauses that must be retracted the function
$select$ is used. @]

fn sel(c:fn(T):B,l:T):T  %%% select
{
if l==nil then result Nil
elsif ~isc(l) then return(c(l),l,Nil) 
else return(c(a1(l)),mkc(a1(l),sel(c,a2(l))),sel(c,a2(l)))
fi
} sel

end U
