\b{tabular}[t]{|r||l|p{7.5cm}|} \hline
\multicolumn{3}{|c|}{ {\bf DLP* - an overview} } 
\\ \hline \hline
non-logical variables & $v = t$ & assigns the term $t$ to
the non-logical variable $x$
\\ &  $t = v$ & unifies the term $t$ with the value of
the non-logical variable $x$
\\ \hline \hline
object creation & $ O = new(c)$ & creates a passive instance of object $c$
\\ \cline{2-3}
  & $ O = new(c(t))$ & creates an active instance of object $c$
\\ \hline \hline
channels & $C = new(channel)$ & creates a new channel
\\ \cline{2-3}
 & $C!t$ & output statement for term $t$ over channel $C$
\\ & $C?t$ & input statement for term $t$ over channel $C$
\\ \hline \hline
\multicolumn{3}{|c|}{ {\it DLP2 - method call by rendez-vous } }
\\ \hline \hline
object creation & $ O = new(c(t))$ & creates an instance of object $c$
\\ \cline{2-3}
rendez-vous & $O!m(t)$ & calls the method $m(t)$ for $O$
\\ \cline{2-3}
 & $accept(m1,...,m_n)$ & accept methods $m1,...,m_n$
\\ \hline \hline
process creation & $Q = O!G$ & requests the evaluation of $G$ by $O$
\\ \cline{2-3}
resumption & $Q?$ & requests the answer substitutions resulting from a
goal evaluation
\\ \cline{2-3}
synchronisation & $accept(m1,...,m_n)$ & accept methods $m1,...,m_n$
\\ \hline
\e{tabular}
