\b{tabular}[t]{|r||l|p{7.5cm}|} \hline
\multicolumn{3}{|c|}{ {\bf DLP - an overview} } 
\\ \hline \hline
non-logical variables & $v := t$ & assigns the term $t$ to
the non-logical variable $v$
\\ \hline \hline
object creation & $ O = new(c)$ & creates a passive instance of object $c$
\\ \cline{3-3}
  & $ O = new(c(t))$ & creates an active instance of object $c$
\\ \cline{2-3}
allocation  & $ O = new(c@N)$ & creates a passive instance of object $c$
    allocated at node $N$
\\ \cline{3-3}
  & $ O = new(c(t)@N)$ & creates an active instance of object $c$,
    allocated at node $N$
\\ \hline \hline
channels & $C = new(channel)$ & creates a new channel
\\ \cline{2-3}
 & $C!t$ & output statement for term $t$ over channel $C$
\\ & $C?t$ & input statement for term $t$ over channel $C$
\\ \hline \hline
process creation & $Q = O!G$ & requests the evaluation of $G$ by  the object $O$
to which $O$ refers
\\ \cline{2-3}
resumptions & $Q?$ & requests the results of a remote goal evaluation
\\ \cline{2-3}
synchronisation & $accept(e1,...,e_n)$ & accept methods $m1,...,m_n$
\\ \hline \hline
\multicolumn{2}{|c|}{ {\it Abbreviations } } & Definition 
\\ \hline \hline
and-parallel operator & $A & B $ & {P A & B :- Q = self!A, B, Q?. P} \\
synchronous rendez-vous & $O!m(t)$ & {P O!G :- ismod(O),!, Q = O!G, Q?. P} \\
allocating goals & $G@N$ & {P G@N :- symbolic(G), O = new(self@N), O!G. P}
\\ \hline
\e{tabular}
\ln
