
@ Processes
Multiple processes may refer to a single object.
Apart from the constructor process,
a process is created for each method call in order to keep track of
the backtracking over the results of that call.
We have pictured an object and some processes referring to it below.

%%\begin{figure}[h] \caption{An example execution} \label{fig:exec}
\setlength{\unitlength}{1cm}

\ln
\hspace{0.5cm}
\b{tabular}[t]{|p{3.6cm}|p{3.6cm}|p{3.6cm}|} \hline
%%\multicolumn{3}{|c|}{ \it multiple processes may refer to one object } \\ \hline \hline
\b{picture}(3.5,3.6)(0.9,1)
\put(2.5,3.5){ 
\b{tabular}[b]{|p{1.2cm}|} \hline
{\small\it object} $c$   \\
\hline
\e{tabular}
%%\framebox(1.5,0.6){object}
}
%%\put(2.5,3.5){ \framebox(1.5,0.6){object} }
\put(1.2,3.2){ \circle*{0.5} }
\put(0.8,3.7){ \makebox{ \footnotesize $c(t)$ } }
\put(1.5,3.3){\line(5,2){1.1} }
\e{picture}
&
\b{picture}(3.5,3.6)(0.9,1)
\put(2.5,3.5){ 
\b{tabular}[b]{|p{1.2cm}|} \hline
{\small\it object} $c$   \\
\hline
\e{tabular}
%%\framebox(1.5,0.6){object}
}
\put(1.2,3.2){ \circle*{0.5} }
\put(0.8,3.7){ \makebox{ \footnotesize $c(t)$ } }
\put(1.5,3.3){\line(5,2){1.1} }
\put(1.8,2){ \circle{0.5} }
\put(0.9,2.4){ \makebox{ \footnotesize $m1(t1)$ } }
\put(2.1,2.3){\line(2,3){0.7} }
\e{picture}
&
\b{picture}(3.5,3.6)(0.9,1)
\put(2.5,3.5){ 
\b{tabular}[b]{|p{1.2cm}|} \hline
{\small\it object} $c$   \\
\hline
\e{tabular}
%%\framebox(1.5,0.6){object}
}
\put(1.2,3.2){ \circle*{0.5} }
\put(0.8,3.7){ \makebox{ \footnotesize $c(t)$ } }
\put(1.5,3.3){\line(5,2){1.1} }
\put(1.8,2){ \circle{0.5} }
\put(0.9,2.4){ \makebox{ \footnotesize $m1(t1)$ } }
\put(2.1,2.3){\line(2,3){0.7} }
\put(3.6,1.5){ \circle{0.5} }
\put(3.4,2.1){ \makebox{ \footnotesize $m2(t2)$ } }
\put(3.6,1.8){\line(-1,6){0.26} }
\e{picture}
\\ \hline
\nop{
\hline
\leftcomment{goal}
%%\b{picture}(0,0)\put(-0.4,0.07){\makebox(0,0)[r]{\it goal}}\e{picture}
$ O = new(c(t)) $ & $ O!m1(t1) $ & $ O!m2(t2) $ \\
\hline
%%\it effect &
%%\b{picture}(0,0)\put(-0.4,0.07){\makebox(0,0)[r]{\it effect}}\e{picture}
\leftcomment{effect}
\small \sloppy A new object is created,
and its non-logical variables are initialized.
& \small \sloppy A process is created to
evaluate the goal $m1(t1)$.
& \small \sloppy Similarly a process is created to evaluate
$m2(t2)$.
\\ \hline 
}
\nop{
\hline
\leftcomment{method}
%%\b{picture}(0,0)\put(-0.4,0.07){\makebox(0,0)[r]{\it method}}\e{picture}
%%\it method &
{P ctr() :- accept(any), ctr(). P}
& {P inc() :- n = n + 1. P}
& {P value(N) :- N = n. P}
\\ \hline
}
\e{tabular}
%%\e{figure}
\ln\ln
The call $O = new(c(t))$ results in a new instance of the object $c$
together with a constructor process evaluating $c(t)$.
Both the calls $O!m1(t1)$ and $O!m2(t2)$, which may come from
different processes,
result in a separate process for evaluating these calls.
