."@* Introduction

\noindent
We will investigate the constructs
that are needed for extending Prolog to produce a language 
suited for parallel and distributed computation,
and which fit in the framework imposed by the object oriented
programming paradigm.
The constructs introduced are all incorporated in the language DLP,
of which an overview is given in section \ref{des/dlp}.
This chapter is of an exploratory nature.
We will reflect on the design considerations in chapter
\ref{des/per}.

In section \ref{des/ext/objects}
we will introduce objects as a means for providing modularization,
and for encapsulating data.
The information contained in an object is accessible by methods
that are defined by clauses.
We will briefly discuss inheritance among objects.
We will make a distinction 
between passive, having no activity, and active objects,
having own activity.
Section \ref{des/ext/channel}
may be regarded as an intermezzo exploring communication between
active objects via channels.
In section \ref{des/ext/rendez}
we treat a synchronous rendez-vous mechanism for handling
method calls to active objects.
A discussion of the distributed backtracking that may occur
in a rendez-vous is given in section \ref{des/ext/back}.
Section \ref{des/ext/accept} deals with a construct for the
conditional acceptance of method calls.
In section \ref{des/ext/proc} we treat 
an asynchronous rendez-vous mechanism
which gives the programmer 
additional control over the parallel evaluation of goals.
In section \ref{des/ext/alloc} we deal with the constructs
needed for the allocation of objects and processes.
In section \ref{des/dlp} we define the language DLP as the collection of
constructs introduced.
And, finally, in section \ref{dlp:family} we will delineate
a number of subsets of DLP that will be studied from a formal
semantic perspective in part II.

\ln
Since the primary intention here is to give
the intuition behind the mechanisms needed for parallel object oriented
logic programming, and give motivations for the constructs proposed 
by means of examples, the description of the constructs 
will be informal.
