Calling a method of an active object results in a rendez-vous,
when that object is willing to accept the call.
The interaction between the processes involved
is pictured below.
%%@bf[hp]\caption{Communication by rendez-vous}\label{ext:rv}
\setlength{\unitlength}{0.01cm}
\nop{

@d(ud,5) @d(ul,@(2*ud)) @d(xu,@(1*ul)) @d(yu,@(1*ul)) @d(rd,@(1*ul))

@d(xln,@(40*xu)) @d(yln,@(15*yu))
@d(xd,@(xln/8)) @d(yd,@(yln/6))

@d(x0,@((8/2)*xd)) @d(y0,@((2/1)*yd))

@d(x1,@(x0+xd)) @d(x2,@(x1+(5*xd))) @d(x3,@(x2+(4*xd)))
@d(y1,@(y0+yd)) @d(y2,@(y1+(3*yd))) @d(y3,@(y2+(1*yd)))
@d(y4,@(y3+(4*yd)))

@d(px,@(x3+(6/1)*xd))) @d(py,@(y4+((2/1)*yd)))
@d(xdf,@(0)) @d(ydf,@(0))
@d(tx,p{@(px/100).2cm})
}
\ln\ln
\hspace{1.0cm}
@bt[t]{|tx|} \hline
%%@mc{1}{|c|}{ \it communication by rendez-vous } \\ \hline \hline
@bp(px,py)(xdf,ydf)

@p(x1,y4){@b{ $%a$ } }
@p(x3,y4){@b{ $%b$ } }
@p(x3,y3){@br{ $accept(...,m,...)$ } }
@p(x2,y4){ @b{ $%b'$ } }
@p(x1,y3){@bl{ $O!m(t)$ } }
@p(x1,y1){@bl{  } }
@p(x2,y1){@br{ $%h_1,%h_2,...$ } }
@p(x2,y2){@br{ $m(t)$ } }

@p(x1,y1){@c{rd}}
@p(x1,y3){@c{rd}}

@p(x2,y1){@c{rd}}
@p(x2,y2){@c*{rd}}
@p(x3,y3){@c{rd}}
@p(x3,y1){@c{rd}}

@p(x1,@(y3+rd)){@up{@(2*yd)}}
@p(x1,@(y1-rd)){@down{yd}}
%%@p(x1,@(y1+rd)){@up{@((y3-y1)-2*rd)}}
@p(x3,@(y3+rd)){@up{@(2*yd)}}
@p(x3,@(y1-rd)){@down{@(2*yd)}}

@mp(x2,@(y1+rd))(0,@(2*yu)){@((y2-y1)/(2*yu))}{@up{rd}}

@mp(@(x1+rd),y1)(rd,0){@((x2-x1)/rd)}{@right{ud}}
@p(@(x1+(2*rd)),y1){@v(-4,0){@(2*rd)}}

@mp(@(x1+rd),y3)(rd,0){@((x3-x1)/rd)}{@right{ud}}

@ep
\\ \hline
\nop{
\hline
\small
We assume that $O$ is bound to $%b$, the constructor process
for an object. Process $%b'$
is a variant of $%b$ in that they refer to the same object.
In accepting the call a goal $Q?$ is inserted,
with $Q$ bound to $%b'$.
The substitution $%h_1,%h_2,...$ are the answer substitutions 
computed in evaluating $m(t)$.
\\ \hline
}
@et
%%@ef
\ln\ln
Suppose that we have a process $%a$ that calls $O!m(t)$, with $O$
bound to the object of which $%b$ evaluates the constructor.
When $%b$ reaches an accept statement the activity
of $%b$ is interrupted, and a new process $%b'$ is started  to evaluate $m(t)$
which refers to the same object as $%b$.
Process $%b$ resumes the evaluation of the constructor as soon as
the first answer, say $%h_1$, is produced.
Thereafter $%b'$ continues to produce alternative solutions,
as may be requested by $%a$.
