
object facts {
var data=[].

facts(D):- data = D, run.

run:- accept(any), run.

holds(X):- L = data, mbr(X,L).
add(X):-
	L = data,
	append([X],L,R),
	data = R.
}

object infer {
var knowledge, facts.

infer():-
	accept(facts),
	accept(knowledge),
	F = facts,
	K = knowledge,
	write((K:F)),
	run.

run:- accept(any), run.

knowledge(K):- knowledge = K.
facts(F):- facts = F.

derive(D):- facts!holds(D).
derive(D):-
	K = knowledge,
	K!rule(S,D),
	test(S),
	facts!add(D).

test([]).
test([X|T]):-
	derive(X),
	test(T).

}

object disease {

rule([s1],d1).
rule([s2],d2).
}

object liver : disease {

rule([d1],liver_disease).
}

:-
	F = new(facts([s1,s2])),
	I = new(infer()),
	L = new(liver),
	I!facts(F), I!knowledge(L),
	I!derive(liver_disease).
