%%@bf[htb]\caption{Communication by rendez-vous}\label{op:sv}
\setlength{\unitlength}{0.01cm}
\nop{

@d(ud,5) @d(ul,@(2*ud)) @d(xu,@(1*ul)) @d(yu,@(1*ul)) @d(rd,@(1*ul))

@d(xln,@(40*xu)) @d(yln,@(20*yu))
@d(xd,@(xln/8)) @d(yd,@(yln/6))

@d(x0,@((8/2)*xd)) @d(y0,@((2/1)*yd))

@d(x1,@(x0+xd)) @d(x2,@(x1+(5*xd))) @d(x3,@(x2+(4*xd)))
@d(y1,@(y0+yd)) @d(y2,@(y1+(3*yd))) @d(y3,@(y2+(1*yd)))
@d(y4,@(y3+(4*yd)))

@d(px,@(x3+(6/1)*xd))) @d(py,@(y4+((2/1)*yd)))
@d(xdf,@(0)) @d(ydf,@(0))
@d(tx,p{@(px/100).2cm})
}

\ln
\hspace{1.0cm}
@bt[t]{|tx|} \hline
@bp(px,py)(xdf,ydf)

@p(x1,y4){@b{ $process$ } }
@p(x3,y4){@b{ $constructor$ } }
@p(x3,y3){@br{ $accept(...,m,...)$ } }
@p(x2,y4){ @b{ $ ~ $  } }
@p(x3,y1){ @br{ $resume$ } }
@p(x1,y3){@bl{ $O!m(t1,...,t_n)$ } }
@p(x1,y1){@bl{ $result$ } }
@p(x2,y1){@br{ $answer$ } }
@p(x2,y2){@br{ $m(t1,...,t_n)$ } }

@p(x1,y1){@c{rd}}
@p(x1,y3){@c{rd}}

@p(x2,y1){@c{rd}}
@p(x2,y2){@c*{rd}}
@p(x3,y3){@c{rd}}
@p(x3,y1){@c{rd}}

@p(x1,@(y3+rd)){@up{@(2*yd)}}
@p(x1,@(y1-rd)){@down{yd}}
@p(x1,@(y1+rd)){@up{@((y3-y1)-2*rd)}}
@p(x3,@(y3+rd)){@up{@(2*yd)}}
@p(x3,@(y1-rd)){@down{@(2*yd)}}

@mp(x2,@(y1+rd))(0,@(2*yu)){@((y2-y1)/(2*yu))}{@up{rd}}

@mp(@(x1+rd),y1)(rd,0){@((x2-x1)/rd)}{@right{ud}}
@p(@(x1+(2*rd)),y1){@v(-4,0){@(2*rd)}}

@mp(@(x1+rd),y3)(rd,0){@((x3-x1)/rd)}{@right{ud}}

@ep
\\ \hline
@et
\nop{
\hline
\small
We assume that $O$ is bound to $%b = (c,n,0)$, the constructor process
for the object $(c,n)$. Process $%b' = (c,n,k)$, for some $k$,
is a variant of $%b$ in that $obj(%b) = obj(%b')$.
In accepting the call $Q$ becomes bound to $%b'$.
\\ \hline
@et
%%@ef
\ln
As soon as the call $O!m(t)$, with $O$ bound to $%b$, is
accepted $%a$ inserts the goal $Q?$,
that is a request for the answer substitutions resulting from
the evaluation of $m(t)$.
The process $%b'$, which is a variant of the process $%b$
in that they refer to the same object, starts evaluating $m(t)$.
Process $%a$ must wait until the process $%b'$ has computed an answer
substitution.
When the first answer substitution is computed,
it is sent to $%a$; and the goal $Q?$ succeeds.
The process $%b$, which is the constructor process $(c,n,0)$
for the object $obj(%b) = (c,n)$,
may then proceed with the evaluation of the constructor goal.
When backtracking occurs in $%a$, the goal $Q?$ succeeds as many
times as there are alternative answer substitutions produced
by $%b'$.
Backtracking in $%b'$ runs concurrently with the activity
of process $%b$.
}
\ln
