."@* Introduction

\noindent
The language DLP introduced in the previous
chapter is meant as a vehicle for the specification and
implementation of distributed knowledge based systems.
As an illustration of such an application,
the specification and implementation of a distributed
medical expert system will be described in section \ref{xps}.
Traditional problems encountered in software engineering, such as
modularization and the distribution of control, reoccur
when implementing knowledge based systems.
Solving these problems becomes increasingly urgent
when introducing parallelism
in order to distribute the problem solving activity
among distinct computing agents.

In this chapter examples will be given that illustrate how DLP
may be applied to object oriented modeling and distributed problem
solving.
An important contribution of the object oriented
approach to programming has been the use of inheritance for
defining the behavior of objects in an incremental way.
As an example of the use of inheritance it will be shown how
to factor out control in searching a state space.
Factoring out control is also achieved by regarding 
the state space as an object that is given as a parameter to
the search procedure.
Further, an object oriented solution to the N-queens problem
will be presented, where each queen is modeled as
an active object busy satisfying the constraints imposed by the problem.
Inheritance also provides a  convenient mechanism for representing the knowledge
contained by an object, in terms of its relation to other objects.
It will be shown how inheritance is used to create objects
that may be considered as a specialization of the inherited object.
Further, examples will be given that illustrate how inheritance may
be effected dynamically by delegating messages,
and how inheritance may affect the backtracking behavior of an object.

The specification and implementation of the distributed medical expert system 
illustrates
that the object oriented paradigm provides a natural
means of distributing the problem solving tasks
following the hierarchical representation of the knowledge.
