@* <a href=@talk-embed.html target=_top>Embedded Logic</a>


@* <a href=@talk-intro.html target=_top>Introduction</a>
<hr>
<a href=contents.html>[.]</a>
<a href=intro.html>introduction</a>
<a href=local.html>query</a>
<a href=remote.html>remote</a>
<a href=sh.html>shell</a>
<a href=c.html>C</a>
<a href=java.html>java</a>
<a href=corba.html>corba</a>
<a href=conclusions.html>conclusions</a>
<a href=appendix.html>appendix</a>
<hr>


<slide id=embed cap="Embedded Logic">
@ Embedded Logic
<ul>
<li> (SG/X)ML-like syntax for queries
<li> logic engine in filter
<li> Note: this is an offline approach
<li> Rationale: only knowledge maintenance
</ul>
</slide>

<slide id=embed-query cap="Querying from a document">
@ Querying from a document
<ul>
<li> a simple knowledge base: <a href=people.pl.html>people</a>
<li> some rules: concerning the <a href=institute.pl.html>institute</a>
<li> a query: to collect <a href=mailinglist.in.html>email adresses</a>
</ul>
<hr>
<p>Motivation: e.g the <a href=http://www.cs.vu.nl/~eliens/imse>
IM&amp;SE Colloquium</a>.
</slide>
<hr>
<a href=contents.html>[.]</a>
<a href=intro.html>introduction</a>
<a href=local.html>query</a>
<a href=remote.html>remote</a>
<a href=sh.html>shell</a>
<a href=c.html>C</a>
<a href=java.html>java</a>
<a href=corba.html>corba</a>
<a href=conclusions.html>conclusions</a>
<a href=appendix.html>appendix</a>
<hr>


@* <a href=@talk-local.html target=_top>Querying a knowledge base</a>
<hr>
<a href=contents.html>[.]</a>
<a href=intro.html>introduction</a>
<a href=local.html>query</a>
<a href=remote.html>remote</a>
<a href=sh.html>shell</a>
<a href=c.html>C</a>
<a href=java.html>java</a>
<a href=corba.html>corba</a>
<a href=conclusions.html>conclusions</a>
<a href=appendix.html>appendix</a>
<hr>


<slide id=local-example cap="Obtaining the mailinglist">
@ Example - <a href=mailinglist.in.html>maintaining a mailing list</a>


<query kit=pl cmd=:(write(ht-ml),nl)></query>



<query kit=pl src=local.pl cmd=X:email_address(X)>
<param format=" %s">
<param result="">
<param display="<h4>The query</h4>">
<param header="<h4>The adresses</h4> <ul>">
<param footer="</ul>">
email_address(E) :-
	person(X),
	property(X,name:N),
	property(X,familyname:F),
	email(X,E),
	cout(['<li>', N,' ',F,' has email adress ']),
	cout([ '<a href=mailto:', E, '?subject=IM-SE>', E, '</a>',nl]).
</query>



<query kit=pl cmd=X:email_address(X)>
<param format="">
<param result="%s,">
<param header="<h4>The mailing list</h4><a href=mailto:">
<param footer="imse-l@cs.vu.nl>mailing list</a>">
</query>



</slide>

<slide id=local-more cap="What institute ...">
@ <a href=institute.in.html>What institute ... </a>


<p>
Bastiaan is working at the
<query kit=pl cmd=X:institute(bastiaan,X) result="%s"></query>.
<p>
Martijn belongs to the division
<query kit=pl cmd="X:division(martijn,X)" result="%s"> </query>
of the <query kit=pl cmd="X:institute(martijn,X)" result="%s"></query>.
<p>
Jacco however works currently at the
<query kit=pl cmd=X:institute(jrvosse,X) result="%s"> </query>.
<hr>
BTW. Projection to a variable is be done explicitly, as in
<tt>cmd=X:institute(jrvosse,X)</tt>.


</slide>
<hr>
<a href=contents.html>[.]</a>
<a href=intro.html>introduction</a>
<a href=local.html>query</a>
<a href=remote.html>remote</a>
<a href=sh.html>shell</a>
<a href=c.html>C</a>
<a href=java.html>java</a>
<a href=corba.html>corba</a>
<a href=conclusions.html>conclusions</a>
<a href=appendix.html>appendix</a>
<hr>


@* <a href=@talk-remote.html target=_top>Remote knowledge</a>
<hr>
<a href=contents.html>[.]</a>
<a href=intro.html>introduction</a>
<a href=local.html>query</a>
<a href=remote.html>remote</a>
<a href=sh.html>shell</a>
<a href=c.html>C</a>
<a href=java.html>java</a>
<a href=corba.html>corba</a>
<a href=conclusions.html>conclusions</a>
<a href=appendix.html>appendix</a>
<hr>


<slide id=remote cap="Distributed knowledge">
@ Remote (distributed) knowledge
<ul>
<li> maintaining knowledge is difficult
<li> don't replicate, otherwise
<li> so we need to access knowledge from remote sources
<li> and possibly mix remote and local knowledge
<li> Solution: <a href=remote.pl.html>url-enabled consults</a>
<li> Problem: availability of the (VU) server
</ul>
</slide>

<slide id=remote-example cap="example - remote knowlegde">
@ Example - <a href=remote.in.html>remote knowledge</a> 
<query kit=pl src=home.pl cmd=X:email_address(X)>
<param format=" %s">
<param result="<!-- %s -->">
<param display="<h4>The query</h4>">
<param header="<h4>The guests</h4> <ul>">
<param footer="</ul>">
email_address(E) :-
	person(X),
	property(X,name:N),
	property(X,familyname:F),
	institute(X,I),
	not I = 'VU',
	email(X,E),
	cout(['<li>', N,' ',F,' (', I, ')']),
	cout([ '<a href=mailto:', E, '?subject=IM-SE>', E, '</a>',nl]).
</query>

</slide>

<slide id=remote-remarks cap="Remarks">
@ Remarks
<ul>
<li> queries may clash, we need seperate 'engines' 
<li> this is static, the next step is dynamic: signed applets
<li> this is research code, not production code
</ul>
</slide>
<hr>
<a href=contents.html>[.]</a>
<a href=intro.html>introduction</a>
<a href=local.html>query</a>
<a href=remote.html>remote</a>
<a href=sh.html>shell</a>
<a href=c.html>C</a>
<a href=java.html>java</a>
<a href=corba.html>corba</a>
<a href=conclusions.html>conclusions</a>
<a href=appendix.html>appendix</a>
<hr>


@ The external shell
<hr>
<a href=contents.html>[.]</a>
<a href=intro.html>introduction</a>
<a href=local.html>query</a>
<a href=remote.html>remote</a>
<a href=sh.html>shell</a>
<a href=c.html>C</a>
<a href=java.html>java</a>
<a href=corba.html>corba</a>
<a href=conclusions.html>conclusions</a>
<a href=appendix.html>appendix</a>
<hr>


<slide id=sh-example cap="The example">
@ Example - <a href=sh.in.html>external (prolog) shell</a>
<query sh=pl src=go.pl cmd=all(email_address(_))>
<param display="<h4>The query</h4>">
<param header="<h4>The postdoc(s)</h4> <ul>">
<param footer="</ul>">
email_address(E) :-
	person(X),
	property(X,name:N),
	property(X,familyname:F),
	property(X,status:postdoc),
	email(X,E),
	cout(['<li>', N,' ',F,': ']),
	cout([ '<a href=mailto:', E, '?subject=IM-SE>', E, '</a>',nl]).
</query>

</slide>
<hr>
<a href=contents.html>[.]</a>
<a href=intro.html>introduction</a>
<a href=local.html>query</a>
<a href=remote.html>remote</a>
<a href=sh.html>shell</a>
<a href=c.html>C</a>
<a href=java.html>java</a>
<a href=corba.html>corba</a>
<a href=conclusions.html>conclusions</a>
<a href=appendix.html>appendix</a>
<hr>


@* Embedding logic in C
<hr>
<a href=contents.html>[.]</a>
<a href=intro.html>introduction</a>
<a href=local.html>query</a>
<a href=remote.html>remote</a>
<a href=sh.html>shell</a>
<a href=c.html>C</a>
<a href=java.html>java</a>
<a href=corba.html>corba</a>
<a href=conclusions.html>conclusions</a>
<a href=appendix.html>appendix</a>
<hr>


<slide id=c-example cap="Example in C">
@ <a href=c.in.html>Example</a> - <a href=local.c.html>Embedded logic in C</a>
<query sh=sh file=@file>
<param display="<h4>The command</h4>">
<param header="<h4>The aios</h4> <ul>">
<param footer="</ul>">
#sh
make local.out > @cout 2> @cerr
local.out 2>> @cerr
</query>

<pipe file=@debug-c.html>
@ The debugging information
<program>  </program>
</pipe>
<hr><p>
Look at the <a href=@debug-c.html>debug information</a>

<hr>
See <a href=simple.c.html>simple.c</a> and <a href=sh.c.html>sh.c</a>
for some more examples.
</slide>

<hr>
<a href=contents.html>[.]</a>
<a href=intro.html>introduction</a>
<a href=local.html>query</a>
<a href=remote.html>remote</a>
<a href=sh.html>shell</a>
<a href=c.html>C</a>
<a href=java.html>java</a>
<a href=corba.html>corba</a>
<a href=conclusions.html>conclusions</a>
<a href=appendix.html>appendix</a>
<hr>


@* Embedding logic in Java
<hr>
<a href=contents.html>[.]</a>
<a href=intro.html>introduction</a>
<a href=local.html>query</a>
<a href=remote.html>remote</a>
<a href=sh.html>shell</a>
<a href=c.html>C</a>
<a href=java.html>java</a>
<a href=corba.html>corba</a>
<a href=conclusions.html>conclusions</a>
<a href=appendix.html>appendix</a>
<hr>


<slide id=java-example cap="Example in Java">
@ <a href=java.in.html>Example</a> - <a href=local.java.html>Embedded logic in Java</a>
<query file=@file>
<param display="<h4>The command</h4>">
<param header="<h4>Not an aio</h4> <ul>">
<param footer="</ul>">
#sh
javac local.java > @cout 2> @cerr
java local 2>> @cerr
</query>

<pipe file=@debug-java.html>
@ The debugging information
<program> </program>
</pipe>
<hr><p>
Look at the <a href=@debug-java.html>debug information</a>

<hr>
See <a href=simple.java.html>simple.java</a> and
<a href=sh.java>sh.java</a> for some more examples.
</slide>
<hr>
<a href=contents.html>[.]</a>
<a href=intro.html>introduction</a>
<a href=local.html>query</a>
<a href=remote.html>remote</a>
<a href=sh.html>shell</a>
<a href=c.html>C</a>
<a href=java.html>java</a>
<a href=corba.html>corba</a>
<a href=conclusions.html>conclusions</a>
<a href=appendix.html>appendix</a>
<hr>


@* <a href=@talk-corba.html target=_top>Distributed knowledge servers</a>

<slide id=corba cap="Distributed knowledge servers">
@ Distributed knowledge servers
<ul>
<li> The next step is to distribute knowledge processing
<li> A simple CORBA framework: 
<a href=client.c.html>client</a>
and <a href=server.c.html>server</a>
<li> Both <a href=client.pl.html>client</a>
and <a href=server.pl.html>server</a> can be logic-enabled.
<li> The <a href=@online/hush/examples/experimental/universe/index.html>universe</a>
is more logical than it appeared at first sight.
</ul>
</slide>

<slide id=corba-test-0 cap="Distributed knowledge processing - example">
@ Example - distributed knowledge processing
<query sh=sh file=@file>
<param display="<h4>The test</h4>">
<param header="<h4>The dialog</h4><pre>">
<param footer="</pre>">
#!/bin/sh
server.out &
sleep 5
client.out <<!eof 2> @cerr
hello
happy:X
hello
member(X,[2,1,3])
X:member(X,[2,1,3])
all(X):member(X,[5,4,6])
halt
!eof
echo "Succeeded"
</query>
<hr>
I admit, the dialog is quite nonsensical
<pipe file=@debug-corba.html>
@ The debugging information
<program>

</program>
</pipe>
<hr><p>
Look at the <a href=@debug-corba.html>debug information</a>

</slide>

<slide id=corba-test-1 cap="Distributed knowledge processing - example (2)">
@ Example - distributed knowledge processing
<query sh=sh file=@file>
<param display="<h4>The query</h4>">
<param header="<h4>The dialog</h4><pre>">
<param footer="</pre>">
#!/bin/sh
server.sh 2> @cerr  &
sleep 5
old-client.out <<!eof 2>> @cerr
aio(bastiaan)
happy:X
happy:bastiaan
aio(anton)
halt
!eof
</query>
<hr>
I admit, this dialog is quite nonsensical too
<pipe file=@debug-corba.html>
@ The debugging information
<program>

</program>
</pipe>
<hr><p>
Look at the <a href=@debug-corba.html>debug information</a>

</slide>


<slide id=final cal=Finally>
@ Embedded CORBA clients

@ <a href=format.html>format</a>
@ <a href=result.html>result</a>
</slide>

@* Conclusions
<hr>
<a href=contents.html>[.]</a>
<a href=intro.html>introduction</a>
<a href=local.html>query</a>
<a href=remote.html>remote</a>
<a href=sh.html>shell</a>
<a href=c.html>C</a>
<a href=java.html>java</a>
<a href=corba.html>corba</a>
<a href=conclusions.html>conclusions</a>
<a href=appendix.html>appendix</a>
<hr>



<slide id=conclusions cap="Conclusions">
@ Conclusions
<ul>
<li> knowledge management with logic is feasible
<li> has applications in document engineering and ...
<li> embedding is relatively efficient
<li> can be done in multiple ways
<li> corba enabled logic services are possible
<li> true logic is hard to debug
</ul>
@ Future developments
<ul>
<li> dynamic: signed applets
</ul>
</slide>

<hr>
<a href=contents.html>[.]</a>
<a href=intro.html>introduction</a>
<a href=local.html>query</a>
<a href=remote.html>remote</a>
<a href=sh.html>shell</a>
<a href=c.html>C</a>
<a href=java.html>java</a>
<a href=corba.html>corba</a>
<a href=conclusions.html>conclusions</a>
<a href=appendix.html>appendix</a>
<hr>



