package hush.dv.api;

/**
 * The <i>handler</i> class is the base class for anything else
 * you can think of. The class <i>obscure</i> is even worse.
 * @version 3.0
 * @author A. Eliens
 */

public class handler extends obscure {

public static boolean nodebug;

protected final int OK = 0;
protected final int ERROR = 1;

public static kit tk;
protected Event _event;

public static void cerr(String s) {
	System.err.println(s);
	}

public static void cout(String s) {
	System.out.println(s);
	}

public void debug(String s) {
	if (! nodebug)
		System.err.println("DEBUG: " + s);
	}

//@ dispatch 

public Event dispatch(event ev) {
	_event = (Event) ev;
	operator();
	return _event;
	}
 /**
  * May be overridden when creating handlers.
  * @param none,
  * however <tt>_event</tt> may be considered as
  * an implicit  parameter.
  * @return OK or ERROR 
  */

//@ operator()

public int operator() {
	//debug("handler: ()");
	if (_event.type() == 0) return action(_event);
	else if (_event.type() == event.KeyPress) {
					keypress((event)_event);
					keypress(_event);
					}
	else if (_event.type() == event.KeyRelease) {
					keyrelease((event)_event);
					keyrelease(_event);
					}
	else if (_event.type() == event.ButtonPress) {
					press((event)_event);
					press(_event);
					}
	else if (_event.type() == event.ButtonRelease) {
					release((event)_event);
					release(_event);
					}
	else if (_event.type() == event.MotionNotify) {
					motion((event)_event);
					motion(_event);
					}
	else if (_event.type() == event.EnterNotify) {
					enter((event)_event);
					enter(_event);
					}
	else if (_event.type() == event.LeaveNotify) {
					leave((event)_event);
					leave(_event);
					}
	else return action(_event);
	return OK;
	}


public int action(event ev) { 
	debug("**** undefined Handler action ***");
	return ERROR;
	}

//@ option -- the new stuff

public String option(String k) { 
	String res = getoption(k);
	if ( res.equals("-") ) return null;
	else return res;
	}

public void option(String k, String v) { setoption(k,v); }

private native void setoption(String k, String v);
private native String getoption(String k);

//@ For old times sake -- to enable canvas handlers

public void keypress(event ev) { }
public void keyrelease(event ev) { }
public void press(event ev) { }
public void release(event ev) { }
public void motion(event ev) { }
public void enter(event ev) { }
public void leave(event ev) { }

public void keypress(Event ev) { }
public void keyrelease(Event ev) { }
public void press(Event ev) { }
public void release(Event ev) { }
public void motion(Event ev) { }
public void enter(Event ev) { }
public void leave(Event ev) { }
};
