%%:- write(loading(hush)),nl.

hush_main :- cout([starting(hush(pl)),nl]).

list_concat([],'').
list_concat([H|T],R) :-
	list_concat(T,C),
	concat(H,C,R).

%%@ use  library

:- dynamic used/1, used/2.

used(nil).
used(nil,nil).

use(library([])).
use(library([H|T])):-
	use(library(H)),
	use(library(T)).

use(library(X)) :- %% must do this by sed
	atom(X),
	not used(X),
	assert(used(X)),
	E = '.pl',
	D = '/home/eliens/hush/lib/hush/3.1/library/pl/',
	list_concat([D,X,E],R),
	consult(R).

use(library(X)) :-
	atom(X),
	used(X).

use(library(D/X)) :- use(library(D,X)).
use(library(D:X)) :- use(library(D,X)).

use(library(_,[])).

use(library(L,[H|T])):-
	use(library(L,H)),
	use(library(L,T)).

use(library(L,X)) :-
	atom(X),
	not(used(L,X)),
	assert(used(L,X)),
	E = '.pl',
	D = '/home/eliens/hush/lib/hush/3.1/library/pl/',
	list_concat([D,L,'/',X,E],R),
	consult(R).

use(library(L,X)) :-
	atom(X),
	used(L,X).

%%@ all - to force backtracking in exec-pl

all(X):-
	call(X),
	fail.

all(_).

%:-use_module(library(dlp)).
%:-use_module(library(protype)).
%:-ensure_loaded(dlproot).


%%@ from pl -> C++

%%dv_hush(_,X,_):- write(X).

hush(M,C) :-
	hush(M,C,0). 

hush(M,C,R) :-
	hush_module(M,Ma),
	hush_command(C,Ca),
	%%trace_hush(dv_hush(Ma,Ca)),!,
	dv_hush(Ma,Ca,R).

%%trace_hush(_) :- !.
%%trace_hush(X) :- write(X), nl.

hush_module(M,Ma) :- term_to_atom(M,Ma).
hush_command(C,C) :- atom(C),!.
hush_command(C,Ca) :- term_to_atom(C,Ca).

%% from C++ -> pl

dv_dispatch(Q,R):-
	term_to_atom(C,Q),
	(clause(filter(_,_),_) -> filter(C,G); C=G),
	%%cerr([dispatching(G),nl]),
	(clause(dispatch(_,_),_) -> 
		dispatch(G,A);
	dv_dispatch_goal(G,A)),
	term_to_atom(A,R).

dv_dispatch_goal(G,R) :-
	G = X:C, atom(X) -> dv_call_dispatch(X,C,R);
	G = X:C, var(X) -> X=R, dv_call_bind(C);
	%%G = (X,Y):C, var(X), var(Y) -> X=R, dv_call_bind(C);
	G = all(X):C -> setof(X,C,L), member(R,L);
	%%G = some(X):C -> setof(X,C,L), member(R,L),!;
	G = some(X):C -> X=R, dv_call_bind(C),!;
	G = X:C -> X=R, dv_call_bind(C);
	G = (X=dispatch(C)) -> dv_dispatch_goal(X=C,R);
	G = (X=C) -> X=R, dv_call_project(C,R);
	dv_call_project(G,R).
	%%dv_call_dispatch(void,G,R).
	

dv_call_dispatch(M,G,R) :-
	%%cerr([call_dispatch(M:G), nl]),
	(
	member(M,[void,test,try])
			-> (dv_call(G,_) -> R=true; R = false);
	M = user -> dv_call(G,R);
	dv_call(G,R)).
	
	

dv_call_bind(G)  :- 
	call(G).
	%%term_to_atom(A,R).
	

dv_call(G,G)  :- 
	call(G).
	%%term_to_atom(G,R).

dv_call_project(G,A) :- 
	%%cerr([call_project(A=G), nl]),
	dvtrans(G,A,P),          %% fresh variable
	call(P).
	%%term_to_atom(V,A).

dv_exec(Q)  :- 
	term_to_atom(G,Q),!,
	call(G).

dvtrans(G,A,P):-
	G =.. [F|L],
	append(L,[A],R),
	P =.. [F|R],
	!.

dv(X,true) :- dv(X).

dv(X):-
  %%write('<-- reading'), write(X), write('-->'), nl,
  preprocessor(_,'/home/eliens/hush/lib/hush/3.1/bin/dlp.sh %f'),
  consult(X).


%%:- write(loading(hush)),nl.

%%@ source -- url-enabled consult

source([]):- !.
source([H|T]) :- hush(source,H),!, source(T).

source(X) :- !, hush(source,X), !.


%%@ cout & cerr

hush_quote(X,Y) :- atom(X), list_concat(['"',X,'"'],Y).
%%hush_quote(X,X). %% :- atom(X), list_concat(['"',X,'"'],Y).

cout([]):- !.
cout([H|T]) :- cout(H),!, cout(T).

cout(X) :- not X=[_|_], hush(cout,X), !.


cerr([]):- !.
cerr([H|T]) :- cerr(H),!, cerr(T).

cerr(X) :- not X=[_|_], hush(cerr,X),!.

%%@</>
