%%@ midi.pl

:- use(library(midi:[midi,lily,music,process])).

:- declare(midi:object,class(midi),[handler],[]).

midi_midi(This) :-
	midi(This):handler(H),
	declare(H,new(midi(This)),[],[],_).

midi_process(This,F) :-
	Self = midi(This),
	list_concat([F,'.mid'],F1),
	list_concat(['@midi-',F,'.pl'],F2),
	Self:analyse(F1,F2),
	music(_):music(X),
	music(_):process(midi(F)). %%AE

midi_read(This,F) :- native(_,This,read(F),_).
midi_analyse(This,F) :- native(_,This,analyse(F),_).
midi_analyse(This,I,O) :- native(_,This,analyse(I,O),_).
midi_open(This,F) :- native(_,This,open(F),_).
midi_header(This,M) :- native(_,This,header(M,0,480),_).
midi_header(This,M,T,D) :- native(_,This,header(M,T,D),_).
midi_track(This,X) :- native(_,This,track(X),_).
midi_tempo(This,X) :- native(_,This,tempo(X),_).
midi_event(This,D,C,M,T,V) :- native(_,This,event(D,C,M,T,V),_).

midi_note(This,D,C,T,V) :-
	Self = midi(This),
	Self:event(D,C,note_on,T,V),
	Self:event(D,C,note_off,T,V).

midi_melody(This,L) :- midi(This):melody(480,1,L,64).

midi_melody(_This,_,_,[],_).

midi_melody(This,D,C,[X|R],V) :-
	Self = midi(This),
	Self:note(D,C,X,V),
	midi_melody(This,D,C,R,V).

%%</>
