#include <hush/hush.h> 
#include <hush/query.h>

#include <iostream.h>
#include <stdio.h>
#include <stdlib.h>

#include <hush/vm.h>


class pointer_handler : public handler {
int n;
char buf[512];
kit* _tk;
public:
pointer_handler(kit* x) { x->_register(this); _tk = _query = x; n = 0; }
int operator()() {
	event* e = _event;
	sprintf(buf,":eval(handler(_):dispatch(event(%d)))",(int)e);
	_tk->eval(buf);
	cerr << "HUSH called (" << n++ << ") " << e->option("handler") << " ##: " << e->ask() << endl;
	//cerr << e->type();
	for (int j = 0; j < e->argc(); j++) {
	        cerr << e->arg(j) << " ";
	        }
	cerr << endl;
	// 
	string method(e->_method());
	if (method == "query" && e->argc() == 1) {
		_query = new query("kit=pl");
		_register(_query);
		sprintf(buf,"%d",(int)_query);
		result(buf);
		return 0;
		}
	else if (method == "dummy") {
		handler* x = new pointer_handler(_query);
		_register(x);
	        sprintf(buf,"%d",(int)x);
		result(buf);
	} else if (method == "bind") {
		cerr << "bind: " << e->arg(1) << " " << e->arg(2) << endl;
		}
	else if (method == "hello") {
		vm<pointer_handler> vm((int)this);
		char* res = vm->hello(e->arg(1));
		e->result(res);
		}
	return 0;
	}
char* hello(const char* x) {
	cout << "pointer:handler::hello from " << x << endl;
	char* res = _query->evaluate("hello_from(pointer)");
	cout << "from " << res << endl;
	return res;
	}
private:
kit* _query;
};

class application : public session {  /// [3]
public:
application( int argc, char* argv[] ) : session(argc,argv,"hush") {}

int main( ) {
    cerr << "Main in control" << endl;
    char args[]="id=ok kit=pl src=pointer.pl";
    query* q = new query(args);
    _register(q);
    (*q)(); // to prepare
    q->bind("object:pointer", new pointer_handler(q));
    char* xx = 0;
    xx = q->evaluate("declare(object:pointer,new(query(_)))");
    cerr << "new object " << (void*) atoi(unquote(xx)) << endl;
    xx = q->evaluate("declare(object:pointer,new(query(my_query)))");
    //xx = q->evaluate("new_query(_)");
    //cerr << "new object " << (void*) atoi(unquote(xx)) << endl;
    q->eval("(ID=P):object(query(ID),P)");
    char* p;
    while ( (p = q->result()) ) cout << unquote(p) << endl;
    char* address = q->evaluate("some(X):object(query(_),X)");
    int px = atoi(unquote(address));
    char* R = ((kit*)px)->evaluate("R:hello(hello(world),R)");
    cout << "final: " << R << endl;
    return 0;
    }
};

int main (int argc, char  **argv) {
    session* s = new application(argc,argv);
    s->depends(0);
    s->run();
    delete s;
    session::statistics();
    return 0;
}
