@* C++ bindings

<slide id=c cap="C++ bindings">
@ C++ bindings -- <a href=@online/hush/sources/dv/objects/contents.html>objects</a>
<ul>
<li> generic binding for (pl) kit - with secondary handler dictionary
<li> handler hierarchy -- obscure, handler, event, kit, query
<li> downcall - via smart pointer  vm<type>
<li> upcall   - via embedded vm in handler
</ul>
</slide>

<slide id=support-query cap="A query handler">>
<display>
class query_object : public kit_object {
public:
query_object(kit* q, char* n = "query:object") : kit_object(q,n) { }
object_handler* _create(query* q, char* n = "query:object") {
        return new query_object(q,n);
        }
int operator()();
};
</display>
@ The kit implementation
<display>


int kit_object::operator()() {
        event* e = _event;

        vm<kit> self(e);  /// smart pointer
        string method = e->_method();

        if (method == "kit") { /// constructor
                kit* q = new kit(e->arg(1));
                _register(q);
                result( reference((void*)q) );
        } else if (method == "eval") {
                long res = self->eval(e->arg(1));
                result( itoa(res) );
        } else if (method == "result") {
                char* res = self->result( atoi(e->arg(1)) );
                result(res);
        } else if (method == "evaluate") {
                char* res = self->evaluate(e->arg(1));
                result( res );
        } else { /// dispatch up in the hierarchy
                return handler_object::operator()();
        }

        return 0;
        }


</display>
</slide>


<slide id=support cap="Up calls through VM">
@ Up calls through <a href=@online/hush/sources/hush/vm.h.html>VM</a>
<display>
// in <a href=@online/hush/sources/hush/api/handler.c.html>handler.c</a>

event* handler::dispatch(event* e) {
_event = e;
if (_vmp) {
        return ((vm<handler>*)_vmp)->dispatch(e);
} else {

         if (e->thekit()) tk = e->thekit(); // AE

         int result = this->operator()();

         if (result != OK) return 0; // jrvosse
         else return _event;
         }
}
</display>
</slide>

<slide id=support-vm cap="The native object VM">
@ The native object VM
<display>
template < class T >
class vm : public vm_type {
public:

vm(event* e) {
        int p = 0;
        char* id = e->option("ref");
        if (id) {
                p = atoi(id);
                }
        kit* k = e?e->thekit():0;
        _pointer = p;
        _self = (T*) _pointer;
        }

event* dispatch(event* e) {  /// upcall - refined in java_vm
        char buf[512];
        sprintf(buf,":handler(%d):dispatch(event(%d))",
                        (int)_pointer,(int)e);
        eval(buf);
        return e;
        }

virtual int call(const char* cmd) { /// upcall - refined in java_vm
        char buf[512]; int n = 0;
        sprintf(buf,"some(X):event(%d):%s(X)",(int)_pointer,cmd);
        char* res = evaluate(buf);
        sscanf(res,"%d",&n);
        return n;
        }

virtual inline T* operator->() { return self(); }
virtual inline T* self() { return _self; }

private:
T* _self;
long _pointer;
kit* _kit;
};


</display>
</slide>
