%%@ objects.pl


:- use(library([objects,native])).
:- use(library([hush/hush,midi/midi])).

:- cerr(consulting(objects)).

go :- cerr(going(hush)),
      run(7).

%%@ dummy and try

dummy_new(This,self(This)) :-
	dummy(This):handler(H),
	cerr(calling(dummy_new(This,self(This)))),
	declare(H,new(dummy(This)),[handler],_).

dummy_dummy(This,self(This)) :-
	cerr(dummy_dummy(This,self(This))),
	declare(_,new(dummy(This)),[handler],_).

dummy_delete(This) :-
	cerr(dummy_delete(This)).

try_new(This,self(This)) :-
	declare(_,new(try(This)),[dummy],_).

try_lt(This,X,Y) :-
	X = value(A), Y = value(B),
	self(This):[ R1 = value(A), R2 = value(B), R1 < R2 ].

try_lt(This,X,Y) :- integer(X), integer(Y), X < Y.

try_gt(This,X,Y) :- try(This):(Y<X).

%%@ run 7

run(7) :-
	cerr(start(7)),
	new(try(This,Self)),
	Self:( var(a(X)) = f(f(X)) ),
	Self:( Z = value(a(2)) ),
	cerr(Self:( Z = value(a(2)) )),
	Self:[ var(a) = 1, var(b) = 2 ],
	(Self:(value(a) < value(b)) -> cerr(ok); cerr(shit)),
	(Self:(value(a) > value(b)) -> cerr(shit); cerr(ok)),
	delete(Self),
	cerr(end(7)).

%%@ run 6

run(6) :-
	cerr(start(6)),
	new(dummy(This)), %%,Self)),
	Self = self(This),
	%%dummy(_):dummy(Self),
	Self:assign(self,Self),
	Self:value(self,X),
	cerr(Self:value(self,X)),
	Self:(var(self)=2 ),
	Self:(V = value(self)),
	cerr(Self: V = value(self)),
	%%setof(X,Y^Z^value(X,Y,Z),L), cerr(value:L),
	delete(dummy(This)),
	Self:(XX = value(self)),
	cerr(Self: XX = value(self)),
	cerr(end(6)).

%%@ run 5

run(5) :-
	cerr(start(5)),
	midi(This):midi,
	midi(This):process(a),
	cerr(end(5)).
	
%%@ run 4

run(4) :-
	cerr(start(4)),
	midi(This):midi,
	Self = midi(This),
	Self:open('a.mid'),
	Self:header(0,1,480),
	Self:track(start),
	Self:melody([48,50,51,53,55]),
	Self:track(end),
	cerr(end(4)).

%%@ and, run 1

run(1) :-
	cerr(start(1)),
	query(This):query([kit=pl,src='test.pl']),
	query(This):evaluate(X:try(X,[1,2,3]),R),
	query(This):evaluate(S:setof(X,try(X,[1,2,3]),S),S),
	%%cerr(got(ID)),
	%%query(This):result(ID,R),
	cerr(result(R:S)),
	cerr(end(1)).

%%@ run 2

run(2) :- %% core ??
	cerr(start(2)),
	query(This):query([kit=pl]),
	query(This):eval(X:try(X,[1,2,3]),ID),
	query(This):result(ID,R),
	cerr(result(R)),
	cerr(end(2)).

try(X,L) :-
	cerr(trying(X,L)),
	member(X,L),
	cerr(giving(X)).

%%@ run 3

run(3) :-
	cerr(start(3)),
	midi(_):midi,
	cerr(end(3)).

%%</>
