<HTML>
<HEAD>
<!-- This HTML file has been created by texi2html 1.52
     from sicstus.tex on 6 October 1998 -->

<TITLE>SICStus Prolog - The Prolog Library</TITLE>
</HEAD>
<BODY>
Go to the <A HREF="sicstus_1.html">first</A>, <A HREF="sicstus_13.html">previous</A>, <A HREF="sicstus_15.html">next</A>, <A HREF="sicstus_50.html">last</A> section, <A HREF="sicstus_toc.html">table of contents</A>.
<P><HR><P>


<H1><A NAME="SEC188" HREF="sicstus_toc.html#TOC188">The Prolog Library</A></H1>
<P>
<A NAME="IDX944"></A>

</P>
<P>
The Prolog library comprises a number of packages which are thought to
be useful in a number of applications.  Note that the predicates in the
Prolog library are not built-in predicates.  One has to explicitly load
each package to get access to its predicates.  The following packages
are provided:

</P>
<DL COMPACT>

<DT><CODE>arrays</CODE>
<DD>
provides an implementation of extendible arrays with logarithmic access
time.

<DT><CODE>assoc</CODE>
<DD>
uses AVL trees to implement "association lists", i.e. extendible
finite mappings from terms to terms.

<DT><CODE>atts</CODE>
<DD>
provides a means of associating with variables arbitrary attributes,
i.e. named properties that can be used as storage locations as well as
hooks into Prolog's unification.

<DT><CODE>heaps</CODE>
<DD>
implements binary heaps, the main application of which are priority queues.

<DT><CODE>lists</CODE>
<DD>
provides basic operations on lists.

<DT><CODE>terms</CODE>
<DD>
provides a number of operations on terms.

<DT><CODE>ordsets</CODE>
<DD>
defines operations on sets represented as lists with the elements ordered
in Prolog standard order.

<DT><CODE>queues</CODE>
<DD>
defines operations on queues (FIFO stores of information).

<DT><CODE>random</CODE>
<DD>
provides a random number generator.

<DT><CODE>system</CODE>
<DD>
provides access to operating system services.

<DT><CODE>trees</CODE>
<DD>
uses binary trees to represent non-extendible arrays with logarithmic
access time.  The functionality is very similar to that of
<CODE>library(arrays)</CODE>, but <CODE>library(trees)</CODE> is slightly more
efficient if the array does not need to be extendible.

<DT><CODE>ugraphs</CODE>
<DD>
provides an implementation of directed and undirected graphs with
unlabeled edges.

<DT><CODE>wgraphs</CODE>
<DD>
provides an implementation of directed and undirected graphs where
each edge has an integral weight.

<DT><CODE>sockets</CODE>
<DD>
provides an interface to system calls for manipulating sockets.

<DT><CODE>linda/client</CODE>
<DD>
<DT><CODE>linda/server</CODE>
<DD>
provides an implementation of the Linda concept for process communication.

<DT><CODE>db</CODE>
<DD>
provides storage and retrieval of terms on disk files with user-defined
multiple indexing.

<DT><CODE>clpb</CODE>
<DD>
provides constraint solving over Booleans.

<DT><CODE>clpq</CODE>
<DD>
<DT><CODE>clpr</CODE>
<DD>
provides constraint solving over Q (Rationals) or R (Reals).

<DT><CODE>clpfd</CODE>
<DD>
provides constraint solving over Finite (Integer) Domains

<DT><CODE>chr</CODE>
<DD>
provides Constraint Handling Rules

<DT><CODE>objects</CODE>
<DD>
provides the combination of the logic programming and the
object-oriented programming paradigms.

<DT><CODE>gcla</CODE>
<DD>
is a specification tool that is based on
Generalized Horn Clause Language, a generalization of Prolog.

<DT><CODE>tcltk</CODE>
<DD>
An interface to the <EM>Tcl/Tk</EM> language and toolkit.

<DT><CODE>gauge</CODE>
<DD>
is a profiling tool for Prolog programs with a graphical interface based
on <CODE>tcltk</CODE>.

<DT><CODE>charsio</CODE>
<DD>
defines I/O predicates that read from, or write to, a list of character codes.

<DT><CODE>jasper</CODE>
<DD>
An interface to the Java language.

<DT><CODE>flinkage</CODE>
<DD>
is a utility program for generating glue code for the Foreign Language
Interface when building statically linked Runtime Systems or Development
Systems.

<DT><CODE>timeout</CODE>
<DD>
provides a way of running goals with an execution time limit.

<DT><CODE>xref</CODE>
<DD>
provides a cross reference producer for debugging and program analysis.

</DL>

<P>
To load a library package <VAR>Package</VAR>, you will normally enter a query

</P>

<PRE>
| ?- use_module(library(<VAR>Package</VAR>)).
</PRE>

<P>
A library package normally consists of one or more hidden modules.

</P>
<P>
An alternative way of loading from the library is using the built-in
predicate <CODE>require/1</CODE> (see section <A HREF="sicstus_10.html#SEC94">Reading-in Programs</A>).  The index file
<TT>`INDEX.pl'</TT> needed by <CODE>require/1</CODE> can be created by the
<CODE>make_index</CODE> program.  This program is loaded as:

</P>

<PRE>
| ?- use_module(library(mkindex)).
</PRE>

<DL COMPACT>

<DT><CODE>make_index:make_library_index(<VAR>+LibraryDirectory</VAR>)</CODE>
<DD>
<A NAME="IDX945"></A>
Creates a file <TT>`INDEX.pl'</TT> in <VAR>LibraryDirectory</VAR>.  All
<TT>`*.pl'</TT> files in the directory and all its subdirectories are
scanned for <CODE>module/2</CODE> declarations.  From these declarations, the
exported predicates are entered into the index.

</DL>

<P><HR><P>
Go to the <A HREF="sicstus_1.html">first</A>, <A HREF="sicstus_13.html">previous</A>, <A HREF="sicstus_15.html">next</A>, <A HREF="sicstus_50.html">last</A> section, <A HREF="sicstus_toc.html">table of contents</A>.
</BODY>
</HTML>
