<HTML>
<HEAD>
<!-- This HTML file has been created by texi2html 1.52
     from sicstus.tex on 6 October 1998 -->

<TITLE>SICStus Prolog - Array Operations</TITLE>
</HEAD>
<BODY>
Go to the <A HREF="sicstus_1.html">first</A>, <A HREF="sicstus_14.html">previous</A>, <A HREF="sicstus_16.html">next</A>, <A HREF="sicstus_50.html">last</A> section, <A HREF="sicstus_toc.html">table of contents</A>.
<P><HR><P>


<H1><A NAME="SEC189" HREF="sicstus_toc.html#TOC189">Array Operations</A></H1>
<P>
<A NAME="IDX946"></A>

</P>
<P>
This package provides an implementation of extendible arrays with
logarithmic access time.

</P>
<P>
Beware: the atom <CODE>$</CODE> is used to indicate an unset element, and the
functor <CODE>$ /4</CODE> is used to indicate a subtree.  In general, array
elements whose principal function symbol is <CODE>$</CODE> will not work.

</P>
<P>
To load the package, enter the query

</P>

<PRE>
| ?- use_module(library(arrays)).
</PRE>

<DL COMPACT>

<DT><CODE>new_array(<VAR>-Array</VAR>)</CODE>
<DD>
<A NAME="IDX947"></A>
Binds <VAR>Array</VAR> to a new empty array.  Example:


<PRE>
| ?- new_array(A).

A = array($($,$,$,$),2) ? 

yes
</PRE>

<DT><CODE>is_array(<VAR>+Array</VAR>)</CODE>
<DD>
<A NAME="IDX948"></A>
Is true when <VAR>Array</VAR> actually is an array.

<DT><CODE>aref(<VAR>+Index</VAR>, <VAR>+Array</VAR>, <VAR>?Element</VAR>)</CODE>
<DD>
<A NAME="IDX949"></A>
<VAR>Element</VAR> is the element at position <VAR>Index</VAR> in <VAR>Array</VAR>.  It
fails if <CODE><VAR>Array</VAR>[<VAR>Index</VAR>]</CODE> is undefined.

<DT><CODE>arefa(<VAR>+Index</VAR>, <VAR>+Array</VAR>, <VAR>?Element</VAR>)</CODE>
<DD>
<A NAME="IDX950"></A>
Is like <CODE>aref/3</CODE> except that <VAR>Element</VAR> is a new array if
<CODE><VAR>Array</VAR>[<VAR>Index</VAR>]</CODE> is undefined.    Example:

<PRE>
| ?- arefa(3, array($($,$,$,$),2), E).

E = array($($,$,$,$),2) ? 

yes
</PRE>

<DT><CODE>arefl(<VAR>+Index</VAR>, <VAR>+Array</VAR>, <VAR>?Element</VAR>)</CODE>
<DD>
<A NAME="IDX951"></A>
Is as <CODE>aref/3</CODE> except that <VAR>Element</VAR> is <CODE>[]</CODE> for undefined
cells.    Example:

<PRE>
| ?- arefl(3, array($($,$,$,$),2), E).

E = [] ? 

yes
</PRE>

<DT><CODE>array_to_list(<VAR>+Array</VAR>, <VAR>-List</VAR>)</CODE>
<DD>
<A NAME="IDX952"></A>
<VAR>List</VAR> is a list with the pairs <VAR>Index</VAR>-<VAR>Element</VAR> of all the
elements of <VAR>Array</VAR>.  Example:

<PRE>

| ?- array_to_list(array($(a,b,c,d),2), List).

List = [0-a,1-b,2-c,3-d] ? 

yes
</PRE>

<DT><CODE>aset(<VAR>+Index</VAR>, <VAR>+Array</VAR>, <VAR>+Element</VAR>, <VAR>-NewArray</VAR>)</CODE>
<DD>
<A NAME="IDX953"></A>
<VAR>NewArray</VAR> is the result of setting <CODE><VAR>Array</VAR>[<VAR>Index</VAR>]</CODE>
to <VAR>Element</VAR>.  Example:

<PRE>
| ?- aset(3,array($($,$,$,$),2), a, Newarr).

Newarr = array($($,$,$,a),2) ? 

yes
</PRE>

</DL>

<P><HR><P>
Go to the <A HREF="sicstus_1.html">first</A>, <A HREF="sicstus_14.html">previous</A>, <A HREF="sicstus_16.html">next</A>, <A HREF="sicstus_50.html">last</A> section, <A HREF="sicstus_toc.html">table of contents</A>.
</BODY>
</HTML>
