<HTML>
<HEAD>
<!-- This HTML file has been created by texi2html 1.52
     from sicstus.tex on 6 October 1998 -->

<TITLE>SICStus Prolog - List Operations</TITLE>
</HEAD>
<BODY>
Go to the <A HREF="sicstus_1.html">first</A>, <A HREF="sicstus_18.html">previous</A>, <A HREF="sicstus_20.html">next</A>, <A HREF="sicstus_50.html">last</A> section, <A HREF="sicstus_toc.html">table of contents</A>.
<P><HR><P>


<H1><A NAME="SEC193" HREF="sicstus_toc.html#TOC193">List Operations</A></H1>
<P>
<A NAME="IDX995"></A>

</P>
<P>
This package defines operations on lists.  Lists are a very
basic data structure, but nevertheless certain very frequent operations
are provided in this package.

</P>
<P>
To load the package, enter the query

</P>

<PRE>
| ?- use_module(library(lists)).
</PRE>

<DL COMPACT>

<DT><CODE>append(<VAR>?Prefix</VAR>, <VAR>?Suffix</VAR>, <VAR>?Combined</VAR>)</CODE>
<DD>
<A NAME="IDX996"></A>
<VAR>Combined</VAR> is the combined list of the elements in <VAR>Prefix</VAR>
followed by the elements in <VAR>Suffix</VAR>.  It can be used to form
<VAR>Combined</VAR> or it can be used to find <VAR>Prefix</VAR> and/or
<VAR>Suffix</VAR> from a given <VAR>Combined</VAR>.

<DT><CODE>delete(<VAR>+List</VAR>, <VAR>+Element</VAR>, <VAR>?Residue</VAR>)</CODE>
<DD>
<A NAME="IDX997"></A>
<VAR>Residue</VAR> is the result of removing all <EM>identical</EM> occurrences
of <VAR>Element</VAR> in <VAR>List</VAR>.

<DT><CODE>is_list(<VAR>+List</VAR>)</CODE>
<DD>
<A NAME="IDX998"></A>
<VAR>List</VAR> is a proper list.

<DT><CODE>last(<VAR>?List</VAR>, <VAR>?Last</VAR>)</CODE>
<DD>
<A NAME="IDX999"></A>
<VAR>Last</VAR> is the last element in <VAR>List</VAR>.  Example:

<PRE>

| ?- last([x,y,z], Z).

Z = z ? 

yes
</PRE>

<DT><CODE>max_list(<VAR>+ListOfNumbers</VAR>, <VAR>?Max</VAR>)</CODE>
<DD>
<A NAME="IDX1000"></A>
<VAR>Max</VAR> is the largest of the elements in <VAR>ListOfNumbers</VAR>.

<DT><CODE>member(<VAR>?Element</VAR>, <VAR>?List</VAR>)</CODE>
<DD>
<A NAME="IDX1001"></A>
<VAR>Element</VAR> is a member of <VAR>List</VAR>.  It may be used to test for
membership in a list, but it can also be used to enumerate all the
elements in <VAR>List</VAR>.  Example:

<PRE>
| ?- member(X, [a,b,c]).

X = a ? ;

X = b ? ;

X = c ? 

yes
</PRE>

<DT><CODE>memberchk(<VAR>+Element</VAR>, <VAR>+List</VAR>)</CODE>
<DD>
<A NAME="IDX1002"></A>
<VAR>Element</VAR> is a member of <VAR>List</VAR>, but <CODE>memberchk/2</CODE> only
succeeds once and can therefore not be used to enumerate the elements in
<VAR>List</VAR>.  Example:

<PRE>
| ?- memberchk(X, [a,b,c]).

X = a ? ;

no
</PRE>

<DT><CODE>min_list(<VAR>+ListOfNumbers</VAR>, <VAR>?Min</VAR>)</CODE>
<DD>
<A NAME="IDX1003"></A>
<VAR>Min</VAR> is the smallest of the numbers in the list
<VAR>ListOfNumbers</VAR>.

<DT><CODE>nextto(<VAR>?X</VAR>, <VAR>?Y</VAR>, <VAR>?List</VAR>)</CODE>
<DD>
<A NAME="IDX1004"></A>
<VAR>X</VAR> and <VAR>Y</VAR> appears side-by-side in <VAR>List</VAR>.  Example:

<PRE>
| ?- nextto(X, Y, [1,2,3]).

X = 1,
Y = 2 ? ;

X = 2,
Y = 3 ? ;

no
</PRE>

<DT><CODE>no_doubles(<VAR>?List</VAR>)</CODE>
<DD>
<A NAME="IDX1005"></A>
<VAR>List</VAR> contains no duplicated elements.  This is true when
<CODE>dif(<VAR>X</VAR>, <VAR>Y</VAR>)</CODE> holds for all pairs of members <VAR>X</VAR> and
<VAR>Y</VAR> of the list.

<DT><CODE>non_member(<VAR>?Element</VAR>, <VAR>?List</VAR>)</CODE>
<DD>
<A NAME="IDX1006"></A>
<VAR>Element</VAR> does not occur in <VAR>List</VAR>.  This is true when
<CODE>dif(<VAR>Element</VAR>, <VAR>Y</VAR>)</CODE> holds for all members <VAR>Y</VAR> of the
list.

<DT><CODE>nth(<VAR>?N</VAR>, <VAR>?List</VAR>, <VAR>?Element</VAR>)</CODE>
<DD>
<A NAME="IDX1007"></A>
<VAR>Element</VAR> is the <VAR>N</VAR>th element of <VAR>List</VAR>.  The first element
is number 1.  Example:

<PRE>
| ?- nth(N, [a,b,c,d,e,f,g,h,i], f).

N = 6 ? 

yes
</PRE>

<DT><CODE>nth(<VAR>?N</VAR>, <VAR>?List</VAR>, <VAR>?Element</VAR>, <VAR>?Rest</VAR>)</CODE>
<DD>
<A NAME="IDX1008"></A>
<VAR>Element</VAR> is in position <VAR>N</VAR> in the <VAR>List</VAR> and <VAR>Rest</VAR> is
all elements in <VAR>List</VAR> except <VAR>Element</VAR>.

<DT><CODE>nth0(<VAR>?N</VAR>, <VAR>?List</VAR>, <VAR>?Element</VAR>)</CODE>
<DD>
<A NAME="IDX1009"></A>
<VAR>Element</VAR> is the <VAR>N</VAR>th element of <VAR>List</VAR>, counting the first
element as 0.

<DT><CODE>nth0(<VAR>?N</VAR>, <VAR>?List</VAR>, <VAR>?Element</VAR>, <VAR>?Rest</VAR>)</CODE>
<DD>
<A NAME="IDX1010"></A>
<VAR>Element</VAR> is the <VAR>N</VAR>th element of <VAR>List</VAR>, counting the first
element as 0. <VAR>Rest</VAR> is all the other elements in <VAR>List</VAR>.
Example:

<PRE>
| ?- nth0(N, [a,b,c,d,e,f,g,h,i,j], f, R).

N = 5,
R = [a,b,c,d,e,g,h,i,j] ? 

yes
</PRE>

<DT><CODE>permutation(<VAR>?List</VAR>, <VAR>?Perm</VAR>)</CODE>
<DD>
<A NAME="IDX1011"></A>
<VAR>Perm</VAR> is a permutation of <VAR>List</VAR>.

<DT><CODE>prefix(<VAR>?Prefix</VAR>, <VAR>?List</VAR>)</CODE>
<DD>
<A NAME="IDX1012"></A>
<VAR>Prefix</VAR> is a prefix of <VAR>List</VAR>.  Example:

<PRE>
| ?- prefix([1,2,3], [1,2,3,4,5,6]).

yes
</PRE>

<DT><CODE>remove_duplicates(<VAR>+List</VAR>, <VAR>?Pruned</VAR>)</CODE>
<DD>
<A NAME="IDX1013"></A>
<VAR>Pruned</VAR> is the result of removing all <EM>identical</EM> duplicate
elements in <VAR>List</VAR>.  Example:

<PRE>
| ?- remove_duplicates([1,2,3,2,3,1], P).

P = [1,2,3] ? ;

no
</PRE>

<DT><CODE>reverse(<VAR>?List</VAR>, <VAR>?Reversed</VAR>)</CODE>
<DD>
<A NAME="IDX1014"></A>
<VAR>Reversed</VAR> has the same elements as <VAR>List</VAR> but in a reversed
order.

<DT><CODE>same_length(<VAR>?List1</VAR>, <VAR>?List2</VAR>)</CODE>
<DD>
<A NAME="IDX1015"></A>
<VAR>List1</VAR> and <VAR>List2</VAR> have the same number of
elements.

<DT><CODE>same_length(<VAR>?List1</VAR>, <VAR>?List2</VAR>, <VAR>?Length</VAR>)</CODE>
<DD>
<A NAME="IDX1016"></A>
<VAR>List1</VAR> and <VAR>List2</VAR> have the same number of elements and that
number is <VAR>Length</VAR>.  Example:

<PRE>
| ?- same_length([1,2,3], [9,8,7], N).

N = 3 ? ;

no
</PRE>

<DT><CODE>select(<VAR>?Element</VAR>, <VAR>?List</VAR>, <VAR>?List2</VAR>)</CODE>
<DD>
<A NAME="IDX1017"></A>
The result of removing an occurrence of <VAR>Element</VAR> in <VAR>List</VAR> is
<VAR>List2</VAR>.

<DT><CODE>sublist(<VAR>?Sub</VAR>, <VAR>?List</VAR>)</CODE>
<DD>
<A NAME="IDX1018"></A>
<VAR>Sub</VAR> contains some of the elements of <VAR>List</VAR>, in the same order.

<DT><CODE>substitute(<VAR>+X</VAR>, <VAR>+Xlist</VAR>, <VAR>+Y</VAR>, <VAR>?Ylist</VAR>)</CODE>
<DD>
<A NAME="IDX1019"></A>
<VAR>Xlist</VAR> and <VAR>Ylist</VAR> are equal except for replacing
<EM>identical</EM> occurrences of <VAR>X</VAR> by <VAR>Y</VAR>.  Example:

<PRE>
| ?- substitute(1, [1,2,3,4], 5, X).

X = [5,2,3,4] ? 

yes
</PRE>

<DT><CODE>sum_list(<VAR>+ListOfNumbers</VAR>, <VAR>?Sum</VAR>)</CODE>
<DD>
<A NAME="IDX1020"></A>
<VAR>Sum</VAR> is the result of adding the <VAR>ListOfNumbers</VAR> together.

<DT><CODE>suffix(<VAR>?Suffix</VAR>, <VAR>?List</VAR>)</CODE>
<DD>
<A NAME="IDX1021"></A>
<VAR>Suffix</VAR> is a suffix of <VAR>List</VAR>.
</DL>

<P><HR><P>
Go to the <A HREF="sicstus_1.html">first</A>, <A HREF="sicstus_18.html">previous</A>, <A HREF="sicstus_20.html">next</A>, <A HREF="sicstus_50.html">last</A> section, <A HREF="sicstus_toc.html">table of contents</A>.
</BODY>
</HTML>
