<HTML>
<HEAD>
<!-- This HTML file has been created by texi2html 1.52
     from sicstus.tex on 6 October 1998 -->

<TITLE>SICStus Prolog - Queue Operations</TITLE>
</HEAD>
<BODY>
Go to the <A HREF="sicstus_1.html">first</A>, <A HREF="sicstus_21.html">previous</A>, <A HREF="sicstus_23.html">next</A>, <A HREF="sicstus_50.html">last</A> section, <A HREF="sicstus_toc.html">table of contents</A>.
<P><HR><P>


<H1><A NAME="SEC196" HREF="sicstus_toc.html#TOC196">Queue Operations</A></H1>
<P>
<A NAME="IDX1056"></A>

</P>
<P>
A queue is a first-in, first-out store of information.  This implementation
of queues uses difference-lists, the head of the difference-list represents
the beginning of the queue and the tail represents the end of the queue.
The members of the difference-list are the elements in the queue.
The first argument in the queue-representation is the number of elements
in the queue in unary representation.

</P>
<P>
Thus, a queue with <VAR>n</VAR> elements is represented as follows:

</P>

<PRE>
q(s(...s(0)...), [<VAR>X1</VAR>,...,<VAR>Xn</VAR>,<VAR>Y1</VAR>,...,<VAR>Ym</VAR>], [<VAR>Y1</VAR>,...,<VAR>Ym</VAR>])
</PRE>

<P>
where <VAR>n</VAR> is the length of the queue and <VAR>X1</VAR>...<VAR>Xn</VAR> are the
elements of the queue.

</P>
<P>
To load the package, enter the query

</P>

<PRE>
| ?- use_module(library(queues)).
</PRE>

<DL COMPACT>

<DT><CODE>empty_queue(<VAR>?Queue</VAR>)</CODE>
<DD>
<A NAME="IDX1057"></A>
Is true if <VAR>Queue</VAR> has no elements.

<DT><CODE>is_queue(<VAR>+Queue</VAR>)</CODE>
<DD>
<A NAME="IDX1058"></A>
is true when <VAR>Queue</VAR> is a valid queue.

<DT><CODE>queue(<VAR>?X</VAR>, <VAR>?Queue</VAR>)</CODE>
<DD>
<A NAME="IDX1059"></A>
Is true if <VAR>Queue</VAR> has one element and that is <VAR>X</VAR>.

<DT><CODE>queue_head(<VAR>?Head</VAR>, <VAR>?Queue1</VAR>, <VAR>?Queue2</VAR>)</CODE>
<DD>
<A NAME="IDX1060"></A>
<VAR>Queue1</VAR> and <VAR>Queue2</VAR> are the same queues except that
<VAR>Queue2</VAR> has <VAR>Head</VAR> inserted in the front.  It can be used to
enqueue the first element in <VAR>Queue2</VAR>.  Example:

<PRE>
| ?- queue_head(Head, Nq,
                q(s(s(s(s(0)))),[1,2,3,4|R],R)).

Head = 1,
Nq = q(s(s(s(0))),[2,3,4|_193],_193),
R = _193 ? 

yes
</PRE>

<DT><CODE>queue_head_list(<VAR>+HeadList</VAR>, <VAR>?Queue1</VAR>, <VAR>?Queue2</VAR>)</CODE>
<DD>
<A NAME="IDX1061"></A>
<VAR>Queue1</VAR> and <VAR>Queue2</VAR> have the same elements except that
<VAR>Queue2</VAR> has <VAR>HeadList</VAR> inserted in the front.

<DT><CODE>queue_last(<VAR>?Last</VAR>, <VAR>?Queue1</VAR>, <VAR>?Queue2</VAR>)</CODE>
<DD>
<A NAME="IDX1062"></A>
<VAR>Queue2</VAR> is like <VAR>Queue1</VAR> but have <VAR>Last</VAR> as the last
element in the queue.

<DT><CODE>queue_last_list(<VAR>+LastList</VAR>, <VAR>?Queue1</VAR>, <VAR>?Queue2</VAR>)</CODE>
<DD>
<A NAME="IDX1063"></A>
<VAR>Queue1</VAR> and <VAR>Queue2</VAR> are the same queues except that
<VAR>Queue2</VAR> has the list of elements <VAR>LastList</VAR> last in the queue.
Example:

<PRE>
| ?- queue_last_list([5,6], q(s(s(0)))), [1,2|R], R), NQ).

NQ = q(s(s(s(s(0)))))),[1,2,5,6|_360],_360),
R = [5,6|_360] ? 

yes
</PRE>

<DT><CODE>list_queue(<VAR>+List</VAR>, <VAR>?Queue</VAR>)</CODE>
<DD>
<A NAME="IDX1064"></A>
<VAR>Queue</VAR> is the queue representation of the elements in <VAR>List</VAR>.
Example:

<PRE>
| ?- list_queue([1,2,3,4], Q).

Q = q(s(s(s(s(0)))),[1,2,3,4|_138],_138) ? 

yes
| ?- 
</PRE>

<DT><CODE>queue_length(<VAR>+Queue</VAR>, <VAR>?Length</VAR>)</CODE>
<DD>
<A NAME="IDX1065"></A>
<VAR>Length</VAR> is the number of elements in <VAR>Queue</VAR>.  Example:

<PRE>
| ?- queue_length(q(s(s(s(s(s(0))))),[a,b,c,d,e|R],R), L).

L = 5,
R = _155 ? 

yes
</PRE>

</DL>

<P><HR><P>
Go to the <A HREF="sicstus_1.html">first</A>, <A HREF="sicstus_21.html">previous</A>, <A HREF="sicstus_23.html">next</A>, <A HREF="sicstus_50.html">last</A> section, <A HREF="sicstus_toc.html">table of contents</A>.
</BODY>
</HTML>
