<HTML>
<HEAD>
<!-- This HTML file has been created by texi2html 1.52
     from sicstus.tex on 6 October 1998 -->

<TITLE>SICStus Prolog - Random Number Generator</TITLE>
</HEAD>
<BODY>
Go to the <A HREF="sicstus_1.html">first</A>, <A HREF="sicstus_22.html">previous</A>, <A HREF="sicstus_24.html">next</A>, <A HREF="sicstus_50.html">last</A> section, <A HREF="sicstus_toc.html">table of contents</A>.
<P><HR><P>


<H1><A NAME="SEC197" HREF="sicstus_toc.html#TOC197">Random Number Generator</A></H1>
<P>
<A NAME="IDX1066"></A>

</P>
<P>
This package provides a random number generator.  To load the package,
enter the query

</P>

<PRE>
| ?- use_module(library(random)).
</PRE>

<DL COMPACT>

<DT><CODE>random(<VAR>-Number</VAR>)</CODE>
<DD>
<A NAME="IDX1067"></A>
Binds <VAR>Number</VAR> to a random float in the interval [0.0, 1.0).  Note
that 1.0 will never be generated.

<DT><CODE>random(<VAR>+Lower</VAR>, <VAR>+Upper</VAR>, <VAR>-Number</VAR>)</CODE>
<DD>
<A NAME="IDX1068"></A>
Binds <VAR>Number</VAR> to a random integer in the interval
[<VAR>Lower</VAR>,<VAR>Upper</VAR>) if <VAR>Lower</VAR> and <VAR>Upper</VAR> are integers.
Otherwise <VAR>Number</VAR> is bound to a random float between <VAR>Lower</VAR>
and <VAR>Upper</VAR>. <VAR>Upper</VAR> will never be generated.

<DT><CODE>randseq(<VAR>+K</VAR>, <VAR>+N</VAR>, <VAR>-RandomSeq</VAR>)</CODE>
<DD>
<A NAME="IDX1069"></A>
Generates a unordered set of <VAR>K</VAR> unique integers, chosen randomly in the
range <VAR>1..N</VAR>.  <VAR>RandomSeq</VAR> is not returned in any
particular order.

<DT><CODE>randset(<VAR>+K</VAR>, <VAR>+N</VAR>, <VAR>-RandomSet</VAR>)</CODE>
<DD>
<A NAME="IDX1070"></A>
Generates an ordered set of <VAR>K</VAR> unique integers, chosen randomly
in the range <VAR>1..N</VAR>.  The set is returned in standard order.

<DT><CODE>getrand(<VAR>?State</VAR>)</CODE>
<DD>
<A NAME="IDX1071"></A>
Tries to unify <VAR>State</VAR> with the term <CODE>rand(<VAR>X,Y,Z</VAR>)</CODE> where
<VAR>X</VAR>, <VAR>Y</VAR>, and <VAR>Z</VAR> are integers describing the state of the
random generator.

<DT><CODE>setrand(rand(<VAR>+X</VAR>,<VAR>+Y</VAR>,<VAR>+Z</VAR>))</CODE>
<DD>
<A NAME="IDX1072"></A>
Sets the state of the random generator. <VAR>X</VAR>, <VAR>Y</VAR>, and <VAR>Z</VAR>
must be integers in the ranges <CODE>[1,30269)</CODE>, <CODE>[1,30307)</CODE>, and
<CODE>[1,30323)</CODE>, respectively.
</DL>

<P><HR><P>
Go to the <A HREF="sicstus_1.html">first</A>, <A HREF="sicstus_22.html">previous</A>, <A HREF="sicstus_24.html">next</A>, <A HREF="sicstus_50.html">last</A> section, <A HREF="sicstus_toc.html">table of contents</A>.
</BODY>
</HTML>
