<HTML>
<HEAD>
<!-- This HTML file has been created by texi2html 1.52
     from sicstus.tex on 6 October 1998 -->

<TITLE>SICStus Prolog - Operating System Utilities</TITLE>
</HEAD>
<BODY>
Go to the <A HREF="sicstus_1.html">first</A>, <A HREF="sicstus_23.html">previous</A>, <A HREF="sicstus_25.html">next</A>, <A HREF="sicstus_50.html">last</A> section, <A HREF="sicstus_toc.html">table of contents</A>.
<P><HR><P>


<H1><A NAME="SEC198" HREF="sicstus_toc.html#TOC198">Operating System Utilities</A></H1>
<P>
<A NAME="IDX1073"></A>
<A NAME="IDX1074"></A>

</P>
<P>
This package contains utilities for invoking services from the operating
system.  To load the package, enter the query

</P>

<PRE>
| ?- use_module(library(system)).
</PRE>

<P>
Certain predicates described below take names of files or directories as
arguments.  These must be given as atoms, and the predicates below will
not call <CODE>absolute_file_name/2</CODE> on them.

</P>
<P>
Some predicates are described as invoking the default shell.  Specifically
this means invoking <TT>`/bin/sh'</TT> on UNIX platforms. On MSDOS, Windows
and OS/2, the command interpreter given by the environment variable
<CODE>COMSPEC</CODE> is invoked.

</P>
<DL COMPACT>

<DT><CODE>datime(<VAR>-Datime</VAR>)</CODE>
<DD>
<VAR>Datime</VAR> is a timestamp of the form
<CODE>datime(<VAR>Year</VAR>,<VAR>Month</VAR>,<VAR>Day</VAR>,<VAR>Hour</VAR>,<VAR>Min</VAR>,<VAR>Sec</VAR>)</CODE>
containing the current date and time.  All fields are integers.
<A NAME="IDX1075"></A>

<DT><CODE>delete_file(<VAR>+FileName</VAR>,<VAR>+Options</VAR>)</CODE>
<DD>
<VAR>FileName</VAR> is the name of an existing file or directory.
<VAR>Options</VAR> is a list of options. Possible options are
<CODE>directory</CODE>, <CODE>recursive</CODE> or <CODE>ignore</CODE>.  If <VAR>FileName</VAR>
is not a directory it is deleted, otherwise if the option
<CODE>directory</CODE> is specified but not <CODE>recursive</CODE>, the directory
will be deleted if it is empty. If <CODE>recursive</CODE> is specified and
<VAR>FileName</VAR> is a directory, the directory and all its subdirectories
and files will be deleted.  If the operation fails, an exception is
raised unless the <CODE>ignore</CODE> option is specified.
<A NAME="IDX1076"></A>

<DT><CODE>delete_file(<VAR>+FileName</VAR>)</CODE>
<DD>
<A NAME="IDX1077"></A>
Equivalent to <CODE>delete_file(<VAR>FileName</VAR>,[recursive])</CODE>.

<DT><CODE>directory_files(<VAR>+Directory</VAR>,<VAR>-FileList</VAR>)</CODE>
<DD>
<A NAME="IDX1078"></A>
<VAR>FileList</VAR> is the list of entries (files, directories, etc.) in
<VAR>Directory</VAR>.

<DT><CODE>make_directory(<VAR>+DirectoryName</VAR>)</CODE>
<DD>
<A NAME="IDX1079"></A>
Makes a new directory.

<DT><CODE>environ(<VAR>?Var</VAR>, <VAR>?Value</VAR>)</CODE>
<DD>
<A NAME="IDX1080"></A>
<VAR>Var</VAR> is the name of an environment variable, and <VAR>Value</VAR> is
its value.  Both are atoms.  Can be used to enumerate all current
environment variables.

<DT><CODE>exec(<VAR>+Command</VAR>, [<VAR>+Stdin</VAR>,<VAR>+Stdout</VAR>,<VAR>+Stderr</VAR>], <VAR>-Pid</VAR>)</CODE>
<DD>
<A NAME="IDX1081"></A>
Passes <VAR>Command</VAR> to a new default shell process for execution.  The
standard I/O streams of the new process are connected according to what
is specified by the terms <VAR>+Stdin</VAR>, <VAR>+Stdout</VAR>, and <VAR>+Stderr</VAR>
respectively.  Possible values are:

<DL COMPACT>

<DT><CODE>null</CODE>
<DD>
Connected to <TT>`/dev/null'</TT> or equivalent.

<DT><CODE>std</CODE>
<DD>
The standard stream is shared with the calling process. Note that the
standard stream may not be referring to a console if the calling process
is "windowed". To portably print the output from the subprocess on the
Prolog console, <CODE>pipe/1</CODE> must be used and the program must
explicitly read the pipe and write to the console. Similarly for the
input to the subprocess.

<DT><CODE>pipe(<VAR>-Stream</VAR>)</CODE>
<DD>
A pipe is created which connects the Prolog stream <VAR>Stream</VAR> to the
standard stream of the new process. It must be closed using
<CODE>close/1</CODE>; it is not closed automatically when the process dies.
</DL>

<VAR>Pid</VAR> is the process identifier of the new process.

On UNIX, the subprocess will be detached provided none of its standard
streams is specified as <CODE>std</CODE>. This means it will not receive an
interruption signal as a result of ^C being typed.


<DT><CODE>file_exists(<VAR>+FileName</VAR>)</CODE>
<DD>
<VAR>FileName</VAR> is the name of an existing file or directory.
<A NAME="IDX1082"></A>

<DT><CODE>file_exists(<VAR>+FileName</VAR>, <VAR>+Permissions</VAR>)</CODE>
<DD>
<VAR>FileName</VAR> is the name of an existing file or directory which can be
accessed according to <VAR>Permissions</VAR>.  <VAR>Permissions</VAR> is an atom,
an integer (see access(2)), or a list of atoms and/or integers.  The
atoms must be drawn from the list <CODE>[read,write,search,exists]</CODE>.
<A NAME="IDX1083"></A>

<DT><CODE>file_property(<VAR>+FileName</VAR>, <VAR>?Property</VAR>)</CODE>
<DD>
<VAR>FileName</VAR> has the property <VAR>Property</VAR>. The possible properties
are:

<DL COMPACT>

<DT><CODE>type(<VAR>Type</VAR>)</CODE>
<DD>
<VAR>Type</VAR> is one of <CODE>regular</CODE>, <CODE>directory</CODE>, <CODE>fifo</CODE>,
<CODE>symlink</CODE>, <CODE>socket</CODE> or <CODE>unknown</CODE>.

<DT><CODE>size(<VAR>Size</VAR>)</CODE>
<DD>
<VAR>Size</VAR> is the size of <VAR>FileName</VAR>.

<DT><CODE>mod_time(<VAR>ModTime</VAR>)</CODE>
<DD>
<VAR>ModTime</VAR> is the time of the last modification of <VAR>FileName</VAR>.

</DL>

If <VAR>Property</VAR> is uninstantiated, the predicate will enumerate the
properties on backtracking.
<A NAME="IDX1084"></A>

<DT><CODE>host_id(<VAR>-HID</VAR>)</CODE>
<DD>
<VAR>HID</VAR> is the unique identifier, represented by an atom, of the host
executing the current SICStus Prolog process.
<A NAME="IDX1085"></A>

<DT><CODE>host_name(<VAR>-HostName</VAR>)</CODE>
<DD>
<VAR>HostName</VAR> is the standard host name of the host executing the current
SICStus Prolog process.
<A NAME="IDX1086"></A>

<DT><CODE>pid(<VAR>-PID</VAR>)</CODE>
<DD>
<VAR>PID</VAR> is the identifier of the current SICStus Prolog process.
<A NAME="IDX1087"></A>

<DT><CODE>kill(<VAR>+Pid</VAR>, <VAR>+Signal</VAR>)</CODE>
<DD>
<A NAME="IDX1088"></A>
Sends the signal <VAR>Signal</VAR> to process <VAR>Pid</VAR>.

<DT><CODE>mktemp(<VAR>+Template</VAR>, <VAR>-FileName</VAR>)</CODE>
<DD>
<A NAME="IDX1089"></A>
Interface to the UNIX function mktemp(3).  A unique file name is created
and unified with <VAR>FileName</VAR>.  <VAR>Template</VAR> should contain a file
name with six trailing <KBD>X</KBD>s.  The unique file name is that template with
the six <KBD>X</KBD>s replaced by a character string.

<DT><CODE>popen(<VAR>+Command</VAR>, <VAR>+Mode</VAR>, <VAR>?Stream</VAR>)</CODE>
<DD>
<A NAME="IDX1090"></A>
Interface to the UNIX function <CODE>popen(3)</CODE>. Passes <VAR>Command</VAR> to
a new default shell process for execution.  <VAR>Mode</VAR> may be either
<CODE>read</CODE> or <CODE>write</CODE>. In the former case the output from the
process is piped to <VAR>Stream</VAR>. In the latter case the input to the
process is piped from <VAR>Stream</VAR>. <VAR>Stream</VAR> may be read/written
using the ordinary <VAR>StreamIO</VAR> predicates. It must be closed using
<CODE>close/1</CODE>; it is not closed automatically when the process dies.

<DT><CODE>rename_file(<VAR>+OldName</VAR>, <VAR>+NewName</VAR>)</CODE>
<DD>
<A NAME="IDX1091"></A>
<VAR>OldName</VAR> is the name of an existing file or directory, which will be
renamed to <VAR>NewName</VAR>.  If the operation fails, an exception is raised.

<DT><CODE>shell</CODE>
<DD>
<A NAME="IDX1092"></A>
Starts a new interactive shell named by the environment variable
<CODE>SHELL</CODE>.  The control is returned to Prolog upon termination of the
shell process.

<DT><CODE>shell(<VAR>+Command</VAR>)</CODE>
<DD>
<A NAME="IDX1093"></A>
Passes <VAR>Command</VAR> to a new shell named by the environment variable
<CODE>SHELL</CODE> for execution.  Succeeds if the return status value is 0.

On MSDOS, Windows or OS/2, if <CODE>SHELL</CODE> is defined it is expected to
name a UNIX like shell which will be invoked with the argument <CODE>-c
<VAR>Command</VAR></CODE>. If <CODE>SHELL</CODE> is undefined, the shell named by
<CODE>COMSPEC</CODE> will be invoked with the argument <CODE>/C
<VAR>Command</VAR></CODE>.

<DT><CODE>shell(<VAR>+Command</VAR>, <VAR>-Status</VAR>)</CODE>
<DD>
<A NAME="IDX1094"></A>
Passes <VAR>Command</VAR> to a new shell named by the environment variable
<CODE>SHELL</CODE> for execution.  The status value is returned in
<VAR>Status</VAR>. See also <CODE>shell/1</CODE> above.

<DT><CODE>sleep(<VAR>+Seconds</VAR>)</CODE>
<DD>
<A NAME="IDX1095"></A>
Puts the SICStus Prolog process asleep for <VAR>Second</VAR> seconds.

<DT><CODE>system</CODE>
<DD>
<A NAME="IDX1096"></A>
Starts a new interactive default shell process.  The control is returned to
Prolog upon termination of the shell process.

<DT><CODE>system(<VAR>+Command</VAR>)</CODE>
<DD>
<A NAME="IDX1097"></A>
Passes Command to a new default shell process for execution.  Succeeds if
the return status value is 0.

<DT><CODE>system(<VAR>+Command</VAR>, <VAR>-Status</VAR>)</CODE>
<DD>
<A NAME="IDX1098"></A>
Passes <VAR>Command</VAR> to a new default shell process for execution.  The
status value is returned in <VAR>Status</VAR>.

<DT><CODE>tmpnam(<VAR>-FileName</VAR>)</CODE>
<DD>
<A NAME="IDX1099"></A>
Interface to the ANSI C function tmpnam(3).  A unique file name is
created and unified with <VAR>FileName</VAR>.

<DT><CODE>wait(<VAR>+Pid</VAR>, <VAR>-Status</VAR>)</CODE>
<DD>
<A NAME="IDX1100"></A>
Waits for the child process <VAR>Pid</VAR> to terminate. The exit status is
returned in <VAR>Status</VAR>. The function is similar to that of the UNIX
function <CODE>waitpid(3)</CODE>.

<DT><CODE>working_directory(<VAR>?OldDirectory</VAR>, <VAR>?NewDirectory</VAR>)</CODE>
<DD>
<VAR>OldDirectory</VAR> is the current working directory, and the working
directory is set to <VAR>NewDirectory</VAR>.  In particular, the goal
<CODE>working_directory(<VAR>Dir</VAR>,<VAR>Dir</VAR>)</CODE> unifies <VAR>Dir</VAR> with the
current working directory without changing anything.
<A NAME="IDX1101"></A>
</DL>

<P><HR><P>
Go to the <A HREF="sicstus_1.html">first</A>, <A HREF="sicstus_23.html">previous</A>, <A HREF="sicstus_25.html">next</A>, <A HREF="sicstus_50.html">last</A> section, <A HREF="sicstus_toc.html">table of contents</A>.
</BODY>
</HTML>
