<HTML>
<HEAD>
<!-- This HTML file has been created by texi2html 1.52
     from sicstus.tex on 6 October 1998 -->

<TITLE>SICStus Prolog - Updatable Binary Trees</TITLE>
</HEAD>
<BODY>
Go to the <A HREF="sicstus_1.html">first</A>, <A HREF="sicstus_24.html">previous</A>, <A HREF="sicstus_26.html">next</A>, <A HREF="sicstus_50.html">last</A> section, <A HREF="sicstus_toc.html">table of contents</A>.
<P><HR><P>


<H1><A NAME="SEC199" HREF="sicstus_toc.html#TOC199">Updatable Binary Trees</A></H1>
<P>
<A NAME="IDX1102"></A>
<A NAME="IDX1103"></A>

</P>
<P>
This package uses binary trees to represent arrays of <VAR>N</VAR> elements
where <VAR>N</VAR> is fixed, unlike <CODE>library(arrays)</CODE>.  To load the
package, enter the query

</P>

<PRE>
| ?- use_module(library(trees)).
</PRE>

<P>
Binary trees have the following representation: <CODE>t</CODE> denotes the
empty tree, and <CODE>t(<VAR>Label</VAR>,<VAR>Left</VAR>,<VAR>Right</VAR>)</CODE> denotes the
binary tree with label <VAR>Label</VAR> and children <VAR>Left</VAR> and
<VAR>Right</VAR>.

</P>
<DL COMPACT>

<DT><CODE>gen_label(<VAR>?Index</VAR>, <VAR>+Tree</VAR>, <VAR>?Label</VAR>)</CODE>
<DD>
<A NAME="IDX1104"></A>
<VAR>Label</VAR> labels the <VAR>Index</VAR>-th element in the <VAR>Tree</VAR>.  Can be
used to enumerate all <VAR>Labels</VAR> by ascending <VAR>Index</VAR>.  Use
<CODE>get_label/3</CODE> instead if <VAR>Index</VAR> is instantiated.

<DT><CODE>get_label(<VAR>+Index</VAR>, <VAR>+Tree</VAR>, <VAR>?Label</VAR>)</CODE>
<DD>
<A NAME="IDX1105"></A>
<VAR>Label</VAR> labels the <VAR>Index</VAR>-th element in the <VAR>Tree</VAR>.

<DT><CODE>list_to_tree(<VAR>+List</VAR>, <VAR>-Tree</VAR>)</CODE>
<DD>
<A NAME="IDX1106"></A>
Constructs a binary <VAR>Tree</VAR> from <VAR>List</VAR> where
<CODE>get_label(<VAR>K</VAR>,<VAR>Tree</VAR>,<VAR>Lab</VAR>)</CODE> iff <VAR>Lab</VAR> is the
<VAR>K</VAR>th element of <VAR>List</VAR>.

<DT><CODE>map_tree(<VAR>:Pred</VAR>, <VAR>?OldTree</VAR>, <VAR>?NewTree</VAR>)</CODE>
<DD>
<A NAME="IDX1107"></A>
<VAR>OldTree</VAR> and <VAR>NewTree</VAR> are binary trees of the same shape and
<VAR>Pred(Old,New)</VAR> is true for corresponding elements of the two trees.

<DT><CODE>put_label(<VAR>+I</VAR>, <VAR>+OldTree</VAR>, <VAR>+Label</VAR>, <VAR>-NewTree</VAR>)</CODE>
<DD>
<A NAME="IDX1108"></A>
Constructs <VAR>NewTree</VAR> which has the same shape and elements as
<VAR>OldTree</VAR>, except that the <VAR>I</VAR>-th element is <VAR>Label</VAR>.

<DT><CODE>put_label(<VAR>+I</VAR>, <VAR>+OldTree</VAR>, <VAR>+Label</VAR>, <VAR>-NewTree</VAR>, <VAR>+Label</VAR>)</CODE>
<DD>
<A NAME="IDX1109"></A>
Constructs <VAR>NewTree</VAR> which has the same shape and elements as
<VAR>OldTree</VAR>, except that the <VAR>I</VAR>-th element is changed from
<VAR>OldLabel</VAR> to <VAR>NewLabel</VAR>.

<DT><CODE>tree_size(<VAR>+Tree</VAR>, <VAR>?Size</VAR>)</CODE>
<DD>
<A NAME="IDX1110"></A>
Calculates as <VAR>Size</VAR> the number of elements in the <VAR>Tree</VAR>.

<DT><CODE>tree_to_list(<VAR>+Tree</VAR>, <VAR>?List</VAR>)</CODE>
<DD>
<A NAME="IDX1111"></A>
Is the converse operation to <CODE>list_to_tree/2</CODE>.  Any mapping or
checking operation can be done by converting the tree to a list, mapping
or checking the list, and converting the result, if any, back to a tree.

</DL>

<P><HR><P>
Go to the <A HREF="sicstus_1.html">first</A>, <A HREF="sicstus_24.html">previous</A>, <A HREF="sicstus_26.html">next</A>, <A HREF="sicstus_50.html">last</A> section, <A HREF="sicstus_toc.html">table of contents</A>.
</BODY>
</HTML>
