<HTML>
<HEAD>
<!-- This HTML file has been created by texi2html 1.52
     from sicstus.tex on 6 October 1998 -->

<TITLE>SICStus Prolog - I/O on Lists of Character Codes</TITLE>
</HEAD>
<BODY>
Go to the <A HREF="sicstus_1.html">first</A>, <A HREF="sicstus_38.html">previous</A>, <A HREF="sicstus_40.html">next</A>, <A HREF="sicstus_50.html">last</A> section, <A HREF="sicstus_toc.html">table of contents</A>.
<P><HR><P>


<H1><A NAME="SEC361" HREF="sicstus_toc.html#TOC361">I/O on Lists of Character Codes</A></H1>

<P>
This package defines I/O predicates that read from, or write to, a list
of character codes (a string).  There are also predicates to open a
stream referring to a list of character codes.  The stream may be used
with general Stream I/O predicates.

</P>
<P>
To load the package, enter the query

</P>

<PRE>
| ?- use_module(library(charsio)).
</PRE>

<DL COMPACT>

<DT><CODE>format_to_chars(<VAR>+Format</VAR>, <VAR>+Arguments</VAR>, <VAR>-Chars</VAR>)</CODE>
<DD>
<DT><CODE>format_to_chars(<VAR>+Format</VAR>, <VAR>+Arguments</VAR>, <VAR>?S0</VAR>, <VAR>?S</VAR>)</CODE>
<DD>
<A NAME="IDX1529"></A>
<A NAME="IDX1530"></A>
Prints <VAR>Arguments</VAR> into a list of character codes using
<CODE>format/3</CODE> (see section <A HREF="sicstus_10.html#SEC96">Input and Output of Terms</A>).  <VAR>Chars</VAR> is unified with the
list, alternatively <VAR>S0</VAR> and <VAR>S</VAR> are unified with the head and
tail of the list, respectively.

<DT><CODE>write_to_chars(<VAR>+Term</VAR>, <VAR>-Chars</VAR>)</CODE>
<DD>
<DT><CODE>write_to_chars(<VAR>+Term</VAR>, <VAR>?S0</VAR>, <VAR>?S</VAR>)</CODE>
<DD>
<A NAME="IDX1531"></A>
<A NAME="IDX1532"></A>
A specialized <CODE>format_to_chars/(3-4)</CODE>. Writes <VAR>Term</VAR> into a
list of character codes using <CODE>write/2</CODE> (see section <A HREF="sicstus_10.html#SEC96">Input and Output of Terms</A>).
<VAR>Chars</VAR> is unified with the list, alternatively <VAR>S0</VAR> and <VAR>S</VAR>
are unified with the head and tail of the list, respectively.

<DT><CODE>atom_to_chars(<VAR>+Atom</VAR>, <VAR>-Chars</VAR>)</CODE>
<DD>
<DT><CODE>atom_to_chars(<VAR>+Atom</VAR>, <VAR>?S0</VAR>, <VAR>?S</VAR>)</CODE>
<DD>
<A NAME="IDX1533"></A>
<A NAME="IDX1534"></A>
A specialized <CODE>format_to_chars/(3-4)</CODE>.  Converts <VAR>Atom</VAR> to the
list of characters comprising its name.  <VAR>Chars</VAR> is unified with the
list, alternatively <VAR>S0</VAR> and <VAR>S</VAR> are unified with the head and
tail of the list, respectively.

<DT><CODE>number_to_chars(<VAR>+Number</VAR>, <VAR>-Chars</VAR>)</CODE>
<DD>
<DT><CODE>number_to_chars(<VAR>+Number</VAR>, <VAR>?S0</VAR>, <VAR>?S</VAR>)</CODE>
<DD>
<A NAME="IDX1535"></A>
<A NAME="IDX1536"></A>
A specialized <CODE>format_to_chars/(3-4)</CODE>.  Converts <VAR>Number</VAR> to the
list of characters comprising its name.  <VAR>Chars</VAR> is unified with the
list, alternatively <VAR>S0</VAR> and <VAR>S</VAR> are unified with the head and
tail of the list, respectively.

<DT><CODE>read_from_chars(<VAR>+Chars</VAR>, <VAR>-Term</VAR>)</CODE>
<DD>
<A NAME="IDX1537"></A>
Reads <VAR>Term</VAR> from <VAR>Chars</VAR> using <CODE>read/2</CODE>.  The <VAR>Chars</VAR>
must, as usual, be terminated by a <VAR>full-stop</VAR>, i.e. a <KBD>.</KBD>,
possibly followed by <VAR>layout-text</VAR>.

<DT><CODE>open_chars_stream(<VAR>+Chars</VAR>, <VAR>-Stream</VAR>)</CODE>
<DD>
<A NAME="IDX1538"></A>
<VAR>Stream</VAR> is opened as an input stream to an existing list of
character codes.  The stream may be read with the <EM>Stream I/O</EM>
predicates and must be closed using <CODE>close/1</CODE>.  The list is copied
to an internal buffer when the stream is opened and must therefore be a
ground list of character codes at that point.

<DT><CODE>with_output_to_chars(<VAR>+Goal</VAR>, <VAR>-Chars</VAR>)</CODE>
<DD>
<DT><CODE>with_output_to_chars(<VAR>+Goal</VAR>, <VAR>?S0</VAR>, <VAR>?S</VAR>)</CODE>
<DD>
<DT><CODE>with_output_to_chars(<VAR>+Goal</VAR>, <VAR>-Stream</VAR>, <VAR>?S0</VAR>, <VAR>?S</VAR>)</CODE>
<DD>
<A NAME="IDX1539"></A>
<A NAME="IDX1540"></A>
<A NAME="IDX1541"></A>
<VAR>Goal</VAR> is called with the <CODE>current_output</CODE> stream set to a new
stream. This stream writes to an internal buffer which is, after the
successful execution of <VAR>Goal</VAR>, converted to a list of character
codes.  <VAR>Chars</VAR> is unified with the list, alternatively <VAR>S0</VAR> and
<VAR>S</VAR> are unified with the head and tail of the list, respectively.
<CODE>with_output_to_chars/4</CODE> also passes the stream in the <VAR>Stream</VAR>
argument. It can be used only by <VAR>Goal</VAR> for writing.

</DL>

<P><HR><P>
Go to the <A HREF="sicstus_1.html">first</A>, <A HREF="sicstus_38.html">previous</A>, <A HREF="sicstus_40.html">next</A>, <A HREF="sicstus_50.html">last</A> section, <A HREF="sicstus_toc.html">table of contents</A>.
</BODY>
</HTML>
