<HTML>
<HEAD>
<!-- This HTML file has been created by texi2html 1.52
     from sicstus.tex on 6 October 1998 -->

<TITLE>SICStus Prolog - How to Run Prolog</TITLE>
</HEAD>
<BODY>
Go to the <A HREF="sicstus_1.html">first</A>, <A HREF="sicstus_3.html">previous</A>, <A HREF="sicstus_5.html">next</A>, <A HREF="sicstus_50.html">last</A> section, <A HREF="sicstus_toc.html">table of contents</A>.
<P><HR><P>


<H1><A NAME="SEC10" HREF="sicstus_toc.html#TOC10">How to Run Prolog</A></H1>

<P>
SICStus Prolog offers the user an interactive programming environment with
tools for incrementally building programs, debugging programs by following
their executions, and modifying parts of programs without having to start
again from scratch.

</P>
<P>
The text of a Prolog program is normally created in a file or a number of
files using one of the standard text editors.  The Prolog interpreter can
then be instructed to read in programs from these files; this is called
<EM>consulting</EM> the file.  Alternatively, the Prolog compiler can be used
for <EM>compiling</EM> the file.
<A NAME="IDX18"></A>
<A NAME="IDX19"></A>

</P>

<UL>
<LI><A HREF="sicstus_4.html#SEC11">Start</A>
<LI><A HREF="sicstus_4.html#SEC14">Reading In</A>
<LI><A HREF="sicstus_4.html#SEC15">Inserting Clauses</A>
<LI><A HREF="sicstus_4.html#SEC16">Directives</A>
<LI><A HREF="sicstus_4.html#SEC19">Syntax Errors</A>
<LI><A HREF="sicstus_4.html#SEC20">Undefined Predicates</A>
<LI><A HREF="sicstus_4.html#SEC21">Execution</A>
<LI><A HREF="sicstus_4.html#SEC22">Exiting</A>
<LI><A HREF="sicstus_4.html#SEC23">Nested</A>
<LI><A HREF="sicstus_4.html#SEC24">Saving</A>
<LI><A HREF="sicstus_4.html#SEC25">Emacs Interface</A>
</UL>



<H2><A NAME="SEC11" HREF="sicstus_toc.html#TOC11">Getting Started</A></H2>
<P>
<A NAME="IDX20"></A>
<A NAME="IDX21"></A>
<A NAME="IDX22"></A>

</P>
<P>
Under UNIX, SICStus Prolog is normally started from one of the shells.
On other platforms, it is normally started by clicking on an icon.
However, it is often convenient to run SICStus Prolog under GNU Emacs instead.
A GNU Emacs interface for SICStus Prolog is described later (see section <A HREF="sicstus_4.html#SEC25">Emacs Interface</A>).  From a shell, SICStus Prolog is started by typing:

</P>

<PRE>
% sicstus [-f] [-i] [-m] [-B[<VAR>abspath</VAR>]] [-R[<VAR>abspath</VAR>]] [-p <VAR>boot-path</VAR>] 
    [-base <VAR>executable</VAR>] [-r <VAR>restorefile</VAR>] [-l <VAR>prologfile</VAR>]  
    [-P[T] [<VAR>num</VAR>]] [-F <VAR>num</VAR>] [-a <VAR>argument...</VAR>]
</PRE>

<P>
where the flags have the following meaning:

</P>
<DL COMPACT>

<DT><CODE>-f</CODE>
<DD>
Fast start.  Don't read any initialization file (<TT>`~/.sicstusrc'</TT> or
<TT>`~/.sicstus.ini'</TT>) on startup.  If the flag is omitted,
SICStus Prolog will consult this file on startup if it exists.

<DT><CODE>-i</CODE>
<DD>
Forced interactive.  Prompt for user input, even if the standard input
does not appear to be a terminal.

<DT><CODE>-m</CODE>
<DD>
Use <CODE>malloc()</CODE>/<CODE>free()</CODE> in the memory manager's bottom layer.

<DT><CODE>-l <VAR>prolog-file</VAR></CODE>
<DD>
Ensure that the file <VAR>prolog-file</VAR> is loaded on startup.

<DT><CODE>-r <VAR>saved-state</VAR></CODE>
<DD>
Restore the saved state <VAR>saved-state</VAR> on startup.
This is done before any initialization file or <VAR>prolog-file</VAR>
is loaded.

<DT><CODE>-a <VAR>argument...</VAR></CODE>
<DD>
where the arguments can be retrieved from Prolog by
<CODE>prolog_flag(argv, <VAR>Args</VAR>)</CODE>, which will unify <VAR>Args</VAR> with
<VAR>argument...</VAR> represented as a list of atoms.

<DT><CODE>-p <VAR>boot-path</VAR></CODE>
<DD>
Overrides the default path for the Runtime Library, from which the value
of the <CODE>user:library_directory/1</CODE> fact is derived.  This option is
only relevant for statically linked Development Systems
(see section <A HREF="sicstus_11.html#SEC156">Development Systems</A>) as an alternative to setting the
<CODE>SP_PATH</CODE> variable (see section <A HREF="sicstus_4.html#SEC13">Environment Variables</A>). The use of this
flag is discouraged. Use the <CODE>-base</CODE> option instead.

<DT><CODE>-base <VAR>executable</VAR></CODE>
<DD>
<EM>Unix platforms only</EM>. Override the binary used when executing
SICStus from within the start-script. Useful, for example, for
statically linked Development Systems (see section <A HREF="sicstus_11.html#SEC156">Development Systems</A>) to
avoid having to set environment variables such as <CODE>SP_PATH</CODE>
(see section <A HREF="sicstus_4.html#SEC13">Environment Variables</A>) which are set by the start-script.

<DT><CODE>-P [<VAR>num</VAR>]</CODE>
<DD>
<DT><CODE>-PT [<VAR>num</VAR>]</CODE>
<DD>
The uninstrumented (-P) or trace (-PT) version of
Muse is started.  As an option, <VAR>num</VAR> specifies the initial number
of <EM>workers</EM> used (defaults to 1).
See section <A HREF="sicstus_6.html#SEC56">The Muse Model</A>.  Only available if Muse has been installed.

<DT><CODE>-F <VAR>num</VAR></CODE>
<DD>
Only useful for the Sequent Symmetry version of Muse.  Its purpose is
to preallocate shared memory for <VAR>num</VAR> workers.  If the <SAMP>`-F'</SAMP>
argument is not used, <VAR>num</VAR> is assumed to be equal to the default
number of workers.

<DT><CODE>-B[<VAR>abspath</VAR>]</CODE>
<DD>
Creates a saved state for a development system. This option is not
needed for normal use. If <VAR>abspath</VAR> is given, it specifies the
absolute pathname for the saved state.  <STRONG>Note:</STRONG> There must not be
a space before the path, or it will be interpreted as a separate option.

<DT><CODE>-R[<VAR>abspath</VAR>]</CODE>
<DD>
Equivalent to the <CODE>-B</CODE> option, except that it builds a saved state
for a runtime system instead.

</DL>

<P>
Under Unix, a saved state <VAR>file</VAR> can be executed directly by typing:

</P>

<PRE>
% <VAR>file</VAR> <VAR>argument...</VAR>
</PRE>

<P>
This is equivalent to:

</P>

<PRE>
% sicstus -r <VAR>file</VAR> [-a <VAR>argument...</VAR>]
</PRE>

<P>
<STRONG>Note:</STRONG> Beginning with SICStus version 3.7, saved-states do not
store the complete path of the binary <CODE>sp.exe</CODE>. Instead, they call
the start-script <CODE>sicstus</CODE>, which is assumed to be found in the
shell's path. If there are several versions of SICStus installed, it is
up to the user to make sure that the correct start-script is found.

</P>
<P>
Notice that the flags are not available when executing saved
states--all the command line arguments are treated as Prolog arguments.

</P>
<P>
The Development System responds with a message of identification and the prompt
<SAMP>`| ?- '</SAMP> as soon as it is ready to accept input, thus:

</P>

<PRE>
SICStus 3.7: Mon Mar  2 19:22:44 MET 1998
| ?- 
</PRE>

<P>
<A NAME="IDX23"></A>
<A NAME="IDX24"></A>
<A NAME="IDX25"></A>
<A NAME="IDX26"></A>
At this point the top-level is expecting input of a <EM>directive</EM>, i.e. a
<EM>query</EM> or <EM>command</EM>.  See section <A HREF="sicstus_4.html#SEC16">Directives:  Queries and Commands</A>.  You cannot type in
clauses immediately (see section <A HREF="sicstus_4.html#SEC15">Inserting Clauses at the Terminal</A>).  While typing in a
directive, the prompt (on following lines) becomes <SAMP>`     '</SAMP>.  That is,
the <SAMP>`| ?- '</SAMP> appears only for the first line of the directive, and
subsequent lines are indented.  
</P>

<UL>
<LI><A HREF="sicstus_4.html#SEC12">Finding Libraries at Runtime</A>
<LI><A HREF="sicstus_4.html#SEC13">Environment Variables</A>
</UL>



<H3><A NAME="SEC12" HREF="sicstus_toc.html#TOC12">Finding Libraries at Runtime</A></H3>

<P>
<A NAME="IDX27"></A>
<A NAME="IDX28"></A>
<A NAME="IDX29"></A>
<A NAME="IDX30"></A>
<A NAME="IDX31"></A>
<A NAME="IDX32"></A>

</P>
<P>
As of SICStus Prolog 3.7, development systems and runtime systems have
been reorganized around a common runtime kernel. This kernel is
delivered as a shared object/DLL, which means that the runtime linker
must be able to locate it at runtime. Under Windows, the runtime linker
usually has no problem locating the correct DLLs. The rest of this
section is therefore Unix-specific.

</P>
<P>
Most Unix systems rely partly on the so called <EM>runtime linker
search path</EM> which tells the runtime linker where it should look for
shared objects in addition to the default paths (such as <TT>`/lib'</TT>,
<TT>`/usr/lib'</TT>, <TT>`/usr/local/lib'</TT>, and so on). 

</P>
<P>
SICStus' start-script fixes this by setting the runtime linker search
path variable together with <CODE>SP_PATH</CODE> (See section <A HREF="sicstus_4.html#SEC13">Environment Variables</A>) to their correct values. There is also a flag <CODE>-base</CODE>
to the start-script which forces it to use a different executable. This
is very useful when bulding statically linked Development Systems
(see section <A HREF="sicstus_11.html#SEC156">Development Systems</A>). By using the <CODE>-base</CODE> flag, the
start-script can be used also for these. For example, to execute a
statically linked Development System called <CODE>myapp</CODE>:

</P>

<PRE>
% sicstus -base myapp
</PRE>

<P>
However, this is only possible to do with Development Systems. Runtime
Systems cannot be started using the SICStus start-script and therefore
may have to set the runtime linker search path variable explicitly. The
following is how a typical error looks like when the runtime linker
cannot find the SICStus runtime kernel:

</P>

<PRE>
ld.so.1: /home/bob/mysicstus/lib/sicstus37beta/bin/sp.exe: fatal: \
   libsprt37.so: can't open file: errno=2
Killed
</PRE>

<P>
The cure for this is to explicitly set the runtime linker search path
variable to contain the path to <TT>`libsprt37.so'</TT>. For <CODE>sh</CODE>,
<CODE>bash</CODE>, etc. this is done by:

</P>

<PRE>
% export LD_LIBRARY_PATH=${LD_LIBRARY_PATH}:/home/bob/mysicstus/lib
</PRE>

<P>
and for <CODE>csh</CODE>, <CODE>tcsh</CODE>, etc. by:

</P>

<PRE>
% setenv LD_LIBRARY_PATH ${LD_LIBRARY_PATH}:/home/bob/mysicstus/lib
</PRE>

<P>
The runtime linker search path variable is not always called
<CODE>LD_LIBRARY_PATH</CODE>; this depends on which runtime linker the system
uses and how it is configured. Other possible names are
<CODE>LD_RUN_PATH</CODE>, <CODE>LIBRARY_PATH</CODE>, and <CODE>SHLIB_PATH</CODE>. The
latter is mostly used under IRIX. Check your system documentation or ask
your system administrator for details.

</P>



<H3><A NAME="SEC13" HREF="sicstus_toc.html#TOC13">Environment Variables</A></H3>

<P>
The following environment variables can be set before starting SICStus Prolog.
Some of these override the default sizes of certain areas.  The sizes
are given in bytes, but may be followed by <KBD>K</KBD> or <KBD>M</KBD> meaning
kilobytes or megabytes respectively.

</P>
<DL COMPACT>

<DT><CODE>SP_CTYPE</CODE>
<DD>
<A NAME="IDX33"></A>
<A NAME="IDX34"></A>
Selects the appropriate character set standard: The supported
values are <CODE>euc</CODE> (for EUC) and <CODE>iso_8859_1</CODE> (for ISO 8859/1).
The latter is the default.  

<DT><CODE>SP_PATH</CODE>
<DD>
<A NAME="IDX35"></A>
This environment variable is used to determine the location of the
Runtime Library.  It is normally not necessary to set this environment
variable; under UNIX it is hard-coded into the start-up script and under
Windows it is stored in the repository. 

However, under some circumstances it is necessary to set this variable
explicitly, for example when executing Runtime System which do not
specify a path in the third argument to <CODE>SP_initialize()</CODE>.

<DT><CODE>TMPDIR</CODE>
<DD>
<A NAME="IDX36"></A>
If set, indicates the pathname where temporary files should be created.
Defaults to <TT>`/usr/tmp'</TT>.

<DT><CODE>GLOBALSTKSIZE</CODE>
<DD>
<A NAME="IDX37"></A>
Governs the initial size of the global stack.

<DT><CODE>LOCALSTKSIZE</CODE>
<DD>
<A NAME="IDX38"></A>
Governs the initial size of the local stack.

<DT><CODE>CHOICESTKSIZE</CODE>
<DD>
<A NAME="IDX39"></A>
Governs the initial size of the choicepoint stack.

<DT><CODE>TRAILSTKSIZE</CODE>
<DD>
<A NAME="IDX40"></A>
Governs the initial size of the trail stack.

<DT><CODE>PROLOGINITSIZE</CODE>
<DD>
<A NAME="IDX41"></A>
Governs the size of Prolog's initial memory allocation.

<DT><CODE>PROLOGMAXSIZE</CODE>
<DD>
<A NAME="IDX42"></A>
Defines a limit on the amount of data space which Prolog will use.

<DT><CODE>PROLOGINCSIZE</CODE>
<DD>
<A NAME="IDX43"></A>
Governs the amount of space Prolog asks the operating system for in any
given memory expansion.

<DT><CODE>PROLOGKEEPSIZE</CODE>
<DD>
<A NAME="IDX44"></A>
Governs the size of space Prolog retains after performing some
computation.  By default, Prolog gets memory from the operating system
as the user program executes and returns all free memory back to the
operating system when the user program does not need any more.  If the
programmer knows that her program, once it has grown to a certain size,
is likely to need as much memory for future computations, then she can
advise Prolog not to return all the free memory back to the operating
system by setting this variable.  Only memory that is allocated above
and beyond <CODE>PROLOGKEEPSIZE</CODE> is returned to the OS; the rest will be
kept.

</DL>

<P>
Send bug reports to <CODE>&#60;sicstus-support@sics.se&#62;</CODE>.  Bugs tend actually to
be fixed if they can be isolated, so it is in your interest to report
them in such a way that they can be easily reproduced.

</P>
<P>
The mailing list <CODE>&#60;sicstus-users@sics.se&#62;</CODE> is a mailing list for
communication among users and implementors.  To [un]subscribe, write to
<CODE>&#60;sicstus-users-request@sics.se&#62;</CODE>.

</P>



<H2><A NAME="SEC14" HREF="sicstus_toc.html#TOC14">Reading in Programs</A></H2>
<P>
<A NAME="IDX45"></A>
<A NAME="IDX46"></A>

</P>
<P>
A program is made up of a sequence of clauses, possibly interspersed with
directives to the system.  The clauses of a predicate do not have to
be immediately consecutive, but remember that their relative order may be
important (see section <A HREF="sicstus_5.html#SEC46">Procedural Semantics</A>).

</P>
<P>
To input a program from a file <VAR>file</VAR>, just type the filename inside list
brackets (followed by <KBD>.</KBD> and <KBD>RET</KBD>), thus:

</P>

<PRE>
| ?- [<VAR>file</VAR>].
</PRE>

<P>
This instructs the interpreter to read in (<EM>consult</EM>) the program.
Note that it may be necessary to surround the whole file specification
<VAR>file</VAR> with single quotes to make it a legal Prolog atom; e.g.

</P>

<PRE>
| ?- ['myfile.pl'].

| ?- ['/usr/prolog/somefile'].
</PRE>

<P>
The specified file is then read in.  Clauses in the file are stored so
that they can later be interpreted, while any directives are obeyed as
they are encountered.  When the end of the file is found, the
interpreter displays on the standard error stream the time spent for
read-in.  This indicates the completion of the directive.

</P>
<P>
Predicates that expect the name of a Prolog source file as an argument use<BR>
<CODE>absolute_file_name/2</CODE> (see section <A HREF="sicstus_10.html#SEC98">Stream I/O</A>) to look up the file.
This predicate will first search for a file with the suffix <SAMP>`.pl'</SAMP> added
to the name given as an argument.  If this fails it will look for a file
with no extra suffix added.  There is also support for libraries.

</P>
<P>
In general, this directive can be any list of filenames, such as:  

</P>

<PRE>
| ?- [myprog,extras,tests].
</PRE>

<P>
In this case all three files would be consulted.

</P>
<P>
The clauses for all the predicates in the consulted files will replace any
existing clauses for those predicates, i.e. any such previously existing
clauses in the database will be deleted.

</P>
<P>
Note that <CODE>consult/1</CODE> in SICStus Prolog behaves like <CODE>reconsult/1</CODE>
in DEC-10 Prolog.  
</P>


<H2><A NAME="SEC15" HREF="sicstus_toc.html#TOC15">Inserting Clauses at the Terminal</A></H2>
<P>
<A NAME="IDX47"></A>

</P>
<P>
Clauses may also be typed in directly at the terminal, although this is
only recommended if the clauses will not be needed permanently, and are few
in number.  To enter clauses at the terminal, you must give the special
directive:

</P>

<PRE>
| ?- [user].
|
</PRE>

<P>
and the new prompt <SAMP>`| '</SAMP> shows that the system is now in a state
where it expects input of clauses or directives.  To return to top
level, type ^D.  The system responds thus:

</P>

<PRE>
{user consulted, 20 msec 200 bytes}
</PRE>



<H2><A NAME="SEC16" HREF="sicstus_toc.html#TOC16">Directives:  Queries and Commands</A></H2>
<P>
<A NAME="IDX48"></A>

</P>
<P>
Directives are either <EM>queries</EM> or <EM>commands</EM>.  Both are
ways of directing the system to execute some goal or goals.

</P>
<P>
In the following, suppose that list membership has been defined by
loading the following clauses from a file:

</P>

<PRE>
member(X, [X|_]).
member(X, [_|L]) :- member(X, L).
</PRE>

<P>
(Notice the use of anonymous variables written <SAMP>`_'</SAMP>.)

</P>

<UL>
<LI><A HREF="sicstus_4.html#SEC17">Queries</A>
<LI><A HREF="sicstus_4.html#SEC18">Commands</A>
</UL>



<H3><A NAME="SEC17" HREF="sicstus_toc.html#TOC17">Queries</A></H3>
<P>
<A NAME="IDX49"></A>
The full syntax of a query is <SAMP>`?-'</SAMP> followed by a sequence of goals.
The top level expects queries.  This is signaled
by the initial prompt <SAMP>`| ?- '</SAMP>.  Thus a query at top level looks like:

</P>

<PRE>
| ?- member(b, [a,b,c]).
</PRE>

<P>
Remember that Prolog terms must terminate with a full stop (<KBD>.</KBD>,
possibly followed by layout text), and that therefore Prolog will not
execute anything until you have typed the full stop (and then <KBD>RET</KBD>)
at the end of the query.

</P>
<P>
If the goal(s) specified in a query can be satisfied, and if there are
no variables as in this example, then the system answers

</P>

<PRE>
yes
</PRE>

<P>
and execution of the query terminates.

</P>
<P>
If variables are included in the query, then the final value of each
variable is displayed (except for variables whose names begin with
<KBD>_</KBD>).  Thus the query

</P>

<PRE>
| ?- member(X, [a,b,c]).
</PRE>

<P>
would be answered by 

</P>

<PRE>
X = a
</PRE>

<P>
At this point the system is waiting for input of either just a
<KBD>RET</KBD> or else a <KBD>;</KBD> followed by <KBD>RET</KBD>.  Simply typing
<KBD>RET</KBD> terminates the query; the system responds with
<SAMP>`yes'</SAMP>.  However, typing <KBD>;</KBD> causes the system to
<EM>backtrack</EM> (see section <A HREF="sicstus_5.html#SEC46">Procedural Semantics</A>) looking for alternative solutions.
If no further solutions can be found it outputs <SAMP>`no'</SAMP>.  
</P>
<P>
The outcome of some queries is shown below, where a number preceded by
<KBD>_</KBD> is a system-generated name for a variable.  

</P>

<PRE>
| ?- member(X, [tom,dick,harry]).

X = tom <KBD>;</KBD>
X = dick <KBD>;</KBD>
X = harry <KBD>;</KBD>

no
| ?- member(X, [a,b,f(Y,c)]), member(X, [f(b,Z),d]).

X = f(b,c),
Y = b,
Z = c

yes
| ?- member(X, [f(_),g]).

X = f(_A)

yes
| ?-
</PRE>

<P>
Commands are like queries except that 

</P>

<OL>
<LI>

Variable bindings are not displayed if and when the command succeeds.

<LI>

You are not given the chance to backtrack through other solutions.  
</OL>



<H3><A NAME="SEC18" HREF="sicstus_toc.html#TOC18">Commands</A></H3>
<P>
<A NAME="IDX50"></A>
Commands start with the symbol <SAMP>`:-'</SAMP>.  Any required output
must be programmed explicitly; e.g. the command: 
</P>

<PRE>
:- member(3, [1,2,3]), write(ok).
</PRE>

<P>
directs the system to check whether <CODE>3</CODE> belongs to the list
<CODE>[1,2,3]</CODE>.  Execution of a command terminates when all the goals in
the command have been successfully executed.  Other alternative solutions
are not sought.  If no solution can be found, the system prints:

</P>

<PRE>
{Warning: <VAR>Goal</VAR> - goal failed}
</PRE>

<P>
as a warning.

</P>
<P>
The principal use for commands (as opposed to queries) is to allow files
to contain directives which call various predicates, but for which you do
not want to have the answers printed out.  In such cases you only want to
call the predicates for their effect, i.e. you don't want terminal
interaction in the middle of consulting the file.  A useful example would
be the use of a directive in a file which consults a whole list of other
files, e.g.

</P>

<PRE>
:- [ bits, bobs, main, tests, data, junk ].
</PRE>

<P>
If a command like this were contained in the file <TT>`myprog'</TT> then typing
the following at top-level would be a quick way of reading in your entire
program:

</P>

<PRE>
| ?- [myprog].
</PRE>

<P>
When simply interacting with the top-level 
this distinction between queries and commands is not normally very
important.  At top-level you should just type queries normally.  In a
file, queries are in fact treated as commands, i.e. if you wish to
execute some goals then the directive in the file must be preceded by
<SAMP>`:-'</SAMP> or <SAMP>`?-'</SAMP>, otherwise it would be treated as a clause.

</P>


<H2><A NAME="SEC19" HREF="sicstus_toc.html#TOC19">Syntax Errors</A></H2>
<P>
<A NAME="IDX51"></A>
<A NAME="IDX52"></A>

</P>
<P>
Syntax errors are detected during reading.  Each clause, directive or in
general any term read in by the built-in predicate <CODE>read/1</CODE> that
fails to comply with syntax requirements is displayed on the standard
error stream as soon as it is read, along with its position in the input
stream and a mark indicating the point in the string of symbols where
the parser has failed to continue analysis, e.g.:

</P>

<PRE>
| member(X, X$L).
{SYNTAX ERROR: in line 5 (within 5-6)}
** , or ) expected in arguments **
member ( X , X 
** here **
$ L ) . 
</PRE>

<P>
if <KBD>$</KBD> has not been declared as an infix operator.

</P>
<P>
Note that any comments in the faulty line are not displayed with the error
message.  If you are in doubt about which clause was wrong you can use the
<CODE>listing/1</CODE> predicate to list all the clauses which were successfully
read-in, e.g.

</P>

<PRE>
| ?- listing(member/2).
</PRE>

<P>
<STRONG>Note:</STRONG> The built in predicates <CODE>read/(1-2)</CODE> normaly raise an exception
on syntax errors (see section <A HREF="sicstus_10.html#SEC104">Error and Exception Handling</A>). The behavior is controlled by the
flag <CODE>syntax_errors</CODE> (see <CODE>prolog_flag/3</CODE>).

</P>



<H2><A NAME="SEC20" HREF="sicstus_toc.html#TOC20">Undefined Predicates</A></H2>
<P>
<A NAME="IDX53"></A>
<A NAME="IDX54"></A>
<A NAME="IDX55"></A>

</P>
<P>
There is a difference between predicates that have no definition and
predicates that have no clauses.  The latter case is meaningful e.g.
for dynamic predicates (see section <A HREF="sicstus_8.html#SEC73">Declarations</A>) that clauses are being
added to or removed from.  There are good reasons for treating calls to
undefined predicates as errors, as such calls easily arise from typing
errors.  
</P>
<P>
The system can optionally catch calls to predicates that have no
definition. First the user defined predicate
<CODE>user:unknown_predicate_handler/3</CODE> (see section <A HREF="sicstus_10.html#SEC104">Error and Exception Handling</A>) is called.  If
undefined or if the call fails the action is governed by the state of
the <CODE>unknown/2</CODE> flag which can be:

</P>
<DL COMPACT>

<DT><CODE>trace</CODE>
<DD>
which causes calls to undefined predicates to be reported and the
debugger to be entered at the earliest opportunity.

<DT><CODE>error</CODE>
<DD>
which causes calls to such predicates to raise an exception (the
default state). See section <A HREF="sicstus_10.html#SEC104">Error and Exception Handling</A>.

<DT><CODE>fail</CODE>
<DD>
which causes calls to such predicates to fail.
</DL>

<P>
Calls to predicates that have no clauses are not caught.

</P>
<P>
The built-in predicate <CODE>unknown(<VAR>?OldState</VAR>, <VAR>?NewState</VAR>)</CODE>
unifies <VAR>OldState</VAR> with the current state and sets the state to
<VAR>NewState</VAR>.  The built-in predicate <CODE>debugging/0</CODE> prints the
value of this state along with its other information.  This state is
also controlled by the flag <CODE>unknown</CODE> (see <CODE>prolog_flag/3</CODE>).

</P>


<H2><A NAME="SEC21" HREF="sicstus_toc.html#TOC21">Program Execution And Interruption</A></H2>
<P>
<A NAME="IDX56"></A>

</P>
<P>
Execution of a program is started by giving the system a directive
which contains a call to one of the program's predicates.

</P>
<P>
Only when execution of one directive is complete does the system
become ready for another directive.  However, one may interrupt the normal
execution of a directive by typing ^C.  This ^C interruption
has the effect of suspending the execution, and the following message is
displayed: 
</P>

<PRE>
Prolog interruption (h or ? for help) ?
</PRE>

<P>
At this point, the Development System accepts one-letter commands
corresponding to certain actions.  To execute an action simply type the
corresponding character (lower or upper case) followed by <KBD>RET</KBD>.
The available commands in both Development Systems are:

</P>
<DL COMPACT>

<DT><KBD>a</KBD>
<DD>
aborts the current computation.

<DT><KBD>c</KBD>
<DD>
continues the execution.

<DT><KBD>e</KBD>
<DD>
exits from SICStus Prolog, closing all files.

<DT><KBD>h</KBD>
<DD>
<DT><KBD>?</KBD>
<DD>
lists available commands.
</DL>

<P>
The following commands are also available in the sequential Development System
only:

</P>
<DL COMPACT>

<DT><KBD>b</KBD>
<DD>
invokes a recursive top-level.

<DT><KBD>d</KBD>
<DD>
<DT><KBD>z</KBD>
<DD>
<DT><KBD>t</KBD>
<DD>
switch on the debugger.  See section <A HREF="sicstus_9.html#SEC84">Debugging</A>.
</DL>

<P>
If the standard input stream is not connected to the terminal, e.g. by
redirecting standard input to a file or a pipe, the above ^C
interrupt options are not available.  Instead, typing ^C causes
SICStus Prolog to exit, and no terminal prompts are printed.

</P>



<H2><A NAME="SEC22" HREF="sicstus_toc.html#TOC22">Exiting From The Top-Level</A></H2>
<P>
<A NAME="IDX57"></A>

</P>
<P>
To exit from the top-level and return to the shell, either type
^D at the top-level, or call the built-in predicate <CODE>halt/0</CODE>,
or use the <KBD>e</KBD> (exit) command following a ^C interruption.

</P>


<H2><A NAME="SEC23" HREF="sicstus_toc.html#TOC23">Nested Executions--Break and Abort</A></H2>
<P>
<A NAME="IDX58"></A>
<A NAME="IDX59"></A>
<A NAME="IDX60"></A>
<A NAME="IDX61"></A>

</P>
<P>
The Prolog system provides a way to suspend the execution of your program
and to enter a new incarnation of the top level where you can issue
directives to solve goals etc.  This is achieved by issuing the directive
(see section <A HREF="sicstus_4.html#SEC21">Program Execution And Interruption</A>):

</P>

<PRE>
| ?- break.
</PRE>

<P>
This invokes a recursive top-level, indicated by the
message:

</P>

<PRE>
{ Break level 1 }
</PRE>

<P>
You can now type queries just as if you were at top-level.

</P>
<P>
If another call of <CODE>break/0</CODE> is encountered, it moves up to level 2,
and so on.  To close the break and resume the execution which was
suspended, type ^D.  The debugger state and current input and output
streams will be restored, and execution will be resumed at the predicate
call where it had been suspended after printing the message: 
</P>

<PRE>
{ End break }
</PRE>

<P>
Alternatively, the suspended execution can be aborted by calling the
built-in predicate <CODE>abort/0</CODE>.  
</P>
<P>
<A NAME="IDX62"></A>
<A NAME="IDX63"></A>
A suspended execution can be aborted by issuing the directive:  

</P>

<PRE>
| ?- abort.
</PRE>

<P>
within a break.  In this case no ^D is needed to close the break;
<EM>all</EM> break levels are discarded and the system returns right back
to top-level.  I/O streams remain open, but the debugger is switched off.
<CODE>abort/0</CODE> may also be called from within a program.  
</P>


<H2><A NAME="SEC24" HREF="sicstus_toc.html#TOC24">Saving and Restoring Program States</A></H2>
<P>
<A NAME="IDX64"></A>
<A NAME="IDX65"></A>
<A NAME="IDX66"></A>
<A NAME="IDX67"></A>

</P>
<P>
Once a program has been read, the system will have available all the
information necessary for its execution.  This information is called a
<EM>program state</EM>.

</P>
<P>
<A NAME="IDX68"></A>
<A NAME="IDX69"></A>
The state of a program may be saved on disk for future execution.  The
state consists of all predicates and modules
except built-in predicates and clauses of volatile predicates,
the current operator declarations, the values of all writable Prolog
flags except <CODE>debugging</CODE>, <CODE>source_info</CODE>, and the <CODE>user_*</CODE>
stream aliases (see section <A HREF="sicstus_10.html#SEC105">Information about the State of the Program</A>), any blackboard data
(see section <A HREF="sicstus_10.html#SEC110">Blackboard Primitives</A>), internal database data
(see section <A HREF="sicstus_10.html#SEC109">Internal Database</A>), and profiling data (see section <A HREF="sicstus_10.html#SEC114">Execution Profiling</A>), but no
information for source-linked debugging.

</P>
<P>
To save a program into a file <VAR>File</VAR>, type the following directive.
On UNIX platforms, the file becomes executable:

</P>

<PRE>
| ?- save_program(<VAR>File</VAR>).
</PRE>

<P>
You can also specify a goal to be run when a saved program is restored.
This is done by:

</P>

<PRE>
| ?- save_program(<VAR>File</VAR>, start).
</PRE>

<P>
where <CODE>start/0</CODE> is the predicate to be called.

</P>
<P>
<A NAME="IDX70"></A>
Once a program has been saved into a file <VAR>File</VAR>, the following directive
will restore the system to the saved state:

</P>

<PRE>
| ?- restore(<VAR>File</VAR>).
</PRE>

<P>
If a saved state has been moved or copied to another machine, the path
names of foreign resources and other files needed upon restore are
typically different at restore time from their save time values.  To
solve this problem, certain atoms will be relocated during restore
as follows:

</P>

<UL>
<LI>

Atoms that had <TT>`$SP_PATH/library'</TT> (the name of the directory
containing the Prolog Library) as prefix at save time will have that
prefix replaced by the corresponding restore time value.

<LI>

Atoms that had the name of the directory containing <VAR>File</VAR> as
prefix at save time will have that prefix replaced by the
corresponding restore time value.
</UL>

<P>
The purpose of this procedure is to be able to build and deploy an
application consisting of a saved state and other files as a directory
tree with the saved state at the root: as long as the other files
maintain their relative position in the deployed copy, they can still
be found upon restore.

</P>
<P>
<STRONG>Note:</STRONG> Foreign resources, see section <A HREF="sicstus_11.html#SEC119">Calling C from Prolog</A>, are unloaded by
<CODE>save_program/(1,2)</CODE>. The names and paths of the
resources, typically <TT>`$SP_PATH/library'</TT> relative,
are however included in the saved state. After the save, and
after restoring a saved state, this information is used to reload
the foreign resources again. The state of the foreign resource in terms
of global C variables and allocated memory is thus not
preserved. Foreign resources may define <EM>init</EM> and <EM>deinit</EM>
functions to take special action upon loading and unloading, see section <A HREF="sicstus_11.html#SEC125">Init and Deinit Functions</A>.

</P>
<P>
In the Muse Development System, the above predicates may only be called
when the system has been adjusted to one worker; see section <A HREF="sicstus_6.html#SEC56">The Muse Model</A>.

</P>



<H2><A NAME="SEC25" HREF="sicstus_toc.html#TOC25">Emacs Interface</A></H2>
<P>
<A NAME="IDX71"></A>
<A NAME="IDX72"></A>

</P>
<P>
This section explains how to use the GNU Emacs interface for SICStus Prolog,
and how to customize your GNU Emacs environment for it.

</P>
<P>
The advantages of using SICStus in the Emacs environment are
source-linked debugging, auto indentation, syntax highlighting, help
on predefined predicates (requires the SICStus info files to be
installed), loading code from inside Emacs, auto-fill
mode, and more.

</P>
<P>
The mode was developed for GNU Emacs 19.34 but it works well for
versions 19.31 through 20.2. Earlier versions may not be able to provide
syntax highlighting. The mode has also been reported to work
with XEmacs (version 19 and 20) but it will probably not work with GNU
Emacs 18 or earlier.

</P>

<P>
The Emacs interface is not part of SICStus Prolog proper, but is included
in the distribution for convenience. It was written by Emil strm and
Milan Zamazal, based on an earlier version of the mode written by
Masanobu Umeda. Contributions has also been made by Johan Andersson,
Peter Olin, Mats Carlsson, Johan Bevemyr, Stefan Andersson, and Per
Danielsson (all at SICS), and Henrik Bkman at Uppsala University,
Sweden. Some ideas and also a few lines of code have been borrowed
(with permission) from Oz.el by Ralf Scheidhauer and Michael Mehl,
the Emacs major mode for the Oz programming language.
More ideas and code have been taken from the SICStus debugger mode
by Per Mildner.

</P>


<UL>
<LI><A HREF="sicstus_4.html#SEC26">Installation</A>
<LI><A HREF="sicstus_4.html#SEC27">Basic Configuration</A>
<LI><A HREF="sicstus_4.html#SEC28">Usage</A>
<LI><A HREF="sicstus_4.html#SEC29">Mode Line</A>
<LI><A HREF="sicstus_4.html#SEC30">Configuration</A>
<LI><A HREF="sicstus_4.html#SEC31">Tips</A>
</UL>



<H3><A NAME="SEC26" HREF="sicstus_toc.html#TOC26">Customizing Emacs</A></H3>

<P>
Assuming the GNU Emacs interface for SICStus Prolog has been installed,
inserting the following lines in your <TT>`~/.emacs'</TT> (or <TT>`_emacs'</TT>
in case of Windows/DOS) will make Emacs use this mode automatically when
editing files with a <SAMP>`.pl'</SAMP> extension: 
</P>

<PRE>
(setq load-path (cons "/usr/local/lib/sicstus37" load-path))
(autoload 'run-prolog "prolog" "Start a Prolog sub-process." t)
(autoload 'prolog-mode "prolog" "Major mode for editing Prolog programs." t)
(setq prolog-use-sicstus-sd t)
(setq auto-mode-alist (cons '("\\.pl$" . prolog-mode) auto-mode-alist))
</PRE>

<P>
where the path in the first line is the file system path to
<TT>`prolog.el'</TT> (the Emacs interface) and <TT>`pltrace.el'</TT> (the process
output filter for source-linked debugging).  For example,
<TT>`~/site-lisp'</TT> means that the file is in the user's home directory,
under site-lisp. MSDOS paths can be written like
<TT>`C:/Program Files/emacs-19.34/site-lisp'</TT>.

</P>
<P>
The last line above makes sure that files ending with <SAMP>`.pl'</SAMP> are
assumed to be Prolog files and not Perl, which is the default Emacs
setting. If this is undesirable, remove that line. It is then necessary
for the user to manually switch to prolog mode by typing <CODE>M-x
prolog-mode</CODE> after opening a prolog file.

</P>
<P>
If the shell command <CODE>sicstus</CODE> is not available in the default
path, then it is necessary to set the value of the environment variable
<CODE>EPROLOG</CODE> to a shell command to invoke SICStus Prolog. This is an
example for C Shell:

</P>

<PRE>
setenv EPROLOG /usr/local/bin/sicstus
</PRE>



<H3><A NAME="SEC27" HREF="sicstus_toc.html#TOC27">Basic Configuration</A></H3>

<P>
If the following lines are not present in <TT>`~/.emacs'</TT>, we suggest
they are added, so that the font-lock mode (syntax coloring support) is
enabled for all major modes in Emacs that support it.

</P>

<PRE>
(global-font-lock-mode t)
(setq font-lock-maximum-decoration t)
</PRE>

<P>
If one wants to add font-locking only to the prolog mode, the two lines
above could be replaced by:

</P>

<PRE>
(add-hook 'prolog-mode-hook 'turn-on-font-lock)
</PRE>

<P>
If the background color of Emacs is dark and it is difficult to read the
code because of the chosen colors, then it might be useful to add

</P>

<PRE>
(setq font-lock-background-mode 'dark)
</PRE>



<H3><A NAME="SEC28" HREF="sicstus_toc.html#TOC28">Usage</A></H3>

<P>
A prolog process can be started by choosing <CODE>Run Prolog</CODE> from the
<CODE>Prolog</CODE> menu, by typing <CODE>C-c RET</CODE>, or by typing <CODE>M-x
run-prolog</CODE>. It is however not strictly necessary to start a prolog
process manually since it is automatically done when consulting or
compiling, if needed. The process can be restarted (i.e. the old one is
killed and a new one is created) by typing <CODE>C-u C-c RET</CODE>.

</P>
<P>
Programs are run and debugged in the normal way, with terminal I/O
via the <CODE>*prolog*</CODE> buffer.  The most common debugging predicates
are available from the menu or via key-bindings.

</P>
<P>
<A NAME="IDX73"></A>
<A NAME="IDX74"></A>

</P>
<P>
A particularly useful feature under the Emacs interface is source-linked
debugging. This is enabled or disabled using the <CODE>Prolog/Source
level debugging</CODE> menu entry. It can also be enabled by setting the Emacs
variable <CODE>prolog-use-sicstus-sd</CODE> to <CODE>t</CODE> in
<TT>`~/.emacs'</TT>. Both these methods set the Prolog flag
<CODE>source_info</CODE> to <CODE>on</CODE>. The flag should be <CODE>on</CODE> while
loading the code to be debugged and while debugging. If so, the debugger
will display the source code location of the current goal when it
prompts for a debugger command, by overlaying the beginning of the
current line of code with an arrow.  If <CODE>source_info</CODE> was
<CODE>off</CODE> when the code was loaded, or if it was asserted or loaded
from <CODE>user</CODE>, the current goal will still be shown but out of
context.

</P>
<P>
Note that if the code has been modified since it was last loaded,
Prolog's line number information may be invalid.  If this happens,
just reload the relevant buffer.

</P>
<P>
Consultation and compilation is either done via the menu or with the
following key-bindings:

</P>
<DL COMPACT>

<DT><KBD>C-c C-f</KBD>
<DD>
<A NAME="IDX75"></A>
 
Consult file.

<A NAME="IDX76"></A>
<DT><KBD>C-c C-b</KBD>
<DD>
Consult buffer.

<A NAME="IDX77"></A>
<DT><KBD>C-c C-r</KBD>
<DD>
Consult region.

<A NAME="IDX78"></A>
<DT><KBD>C-c C-p</KBD>
<DD>
Consult predicate.

<A NAME="IDX79"></A>
<DT><KBD>C-c C-c f</KBD>
<DD>
Compile file.

<A NAME="IDX80"></A>
<DT><KBD>C-c C-c b</KBD>
<DD>
Compile buffer.

<A NAME="IDX81"></A>
<DT><KBD>C-c C-c r</KBD>
<DD>
Compile region.

<A NAME="IDX82"></A>
<DT><KBD>C-c C-c p</KBD>
<DD>
Compile predicate.
</DL>

<P>
The boundaries used when consulting and compiling predicates are the
first and last clauses of the predicate the cursor is currently in.

</P>
<P>
Other useful key-bindings are: 

</P>
<DL COMPACT>

<DT><KBD>M-n</KBD>
<DD>
Go to the next clause.

<DT><KBD>M-p</KBD>
<DD>
Go to the previous clause.

<DT><KBD>M-a</KBD>
<DD>
Go to beginning of clause.

<DT><KBD>M-e</KBD>
<DD>
Go to end of clause.

<DT><KBD>M-C-c</KBD>
<DD>
Mark clause.

<DT><KBD>M-C-a</KBD>
<DD>
Go to beginning of predicate.

<DT><KBD>M-C-e</KBD>
<DD>
Go to end of predicate.

<DT><KBD>M-C-h</KBD>
<DD>
Mark predicate.

<DT><KBD>M-{</KBD>
<DD>
Go to the previous paragraph (i.e. empty line).

<DT><KBD>M-}</KBD>
<DD>
Go to the next paragraph (i.e. empty line).

<DT><KBD>M-h</KBD>
<DD>
Mark paragraph.

<DT><KBD>M-C-n</KBD>
<DD>
Go to matching right parenthesis.

<DT><KBD>M-C-p</KBD>
<DD>
Go to matching left parenthesis.

<DT><KBD>M-;</KBD>
<DD>
Creates a comment at <CODE>comment-column</CODE>. This comment will always
stay at this position when the line is indented, regardless of changes
in the text earlier on the line, provided that
<CODE>prolog-align-comments-flag</CODE> is set to <CODE>t</CODE>.

<DT><KBD>C-c C-t, C-u C-c C-t</KBD>
<DD>
Enable and disable tracing, respectively.

<DT><KBD>C-c C-d, C-u C-c C-d</KBD>
<DD>
Enable and disable debugging, respectively.

<DT><KBD>C-c C-z, C-u C-c C-z</KBD>
<DD>
Enable and disable zipping, respectively.

<DT><KBD>C-c C-s</KBD>
<DD>
Insert the <VAR>PredSpec</VAR> of the current predicate into the code.

<DT><KBD>C-c C-n</KBD>
<DD>
Insert the name of the current predicate into the code. This can be
useful when writing recursive predicates or predicates with several
clauses. See also the <CODE>prolog-electric-dot-flag</CODE> variable
below.

<DT><KBD>C-c C-v a</KBD>
<DD>
Convert all variables in a region to anonymous variables. This can
also be done using the <CODE>Prolog/Transform/All variables to '_'</CODE>
menu entry. See also the <CODE>prolog-electric-underscore-flag</CODE>
Emacs variable.

<DT><KBD>C-c ?</KBD>
<DD>
Help on predicate (requires the SICStus info files to be installed), and
the Emacs variable <CODE>prolog-info-predicate-index</CODE> to be set to the
predicate index of the info files (defaults to <CODE>"(sicstus)Predicate
Index"</CODE>).
</DL>



<H3><A NAME="SEC29" HREF="sicstus_toc.html#TOC29">Mode Line</A></H3>

<P>
If working with an application split into several modules, it is
recommended to let the source files begin with a "mode line":

</P>

<PRE>
%%% -*- Module: ModuleName; -*-
</PRE>

<P>
The Emacs interface will look for the mode line and notify the SICStus
Prolog module system that the predicates being incrementally reconsulted
or recompiled belong to the module <VAR>ModuleName</VAR>. If SICStus Prolog
recognizes the file as one being loaded before, it will remember what
module it belongs to. If the mode line is missing, and the file has not
been loaded before, the predicates will go into the type-in module. Even
if the file has been loaded earlier, its filename may have a slightly
different appearance to Prolog via the Emacs interface, so it is safest
to always include the mode line. A mode line can be inserted by choosing
<CODE>Insert/Module modeline</CODE> in the <CODE>Prolog</CODE> menu.

</P>


<H3><A NAME="SEC30" HREF="sicstus_toc.html#TOC30">Configuration</A></H3>

<P>
The behavior of the Emacs interface can be controlled by a set of
user-configurable settings. Some of these can be changed on the fly,
while some require Emacs to be restarted. To set a variable on the fly,
type <CODE>M-x set-variable RET VariableName RET Value RET</CODE>. Note that
variable names can be completed by typing a few characters and then
pressing <KBD>TAB</KBD>.

</P>
<P>
To set a variable so that the setting is used every time Emacs is
started, add lines of the following format to <TT>`~/.emacs'</TT>:

</P>

<PRE>
(setq VariableName Value)
</PRE>

<P>
The available settings are: 

</P>
<DL COMPACT>

<DT><CODE>prolog-system</CODE>
<DD>
<A NAME="IDX83"></A>
The Prolog system to use. Available settings are <CODE>'mercury</CODE>,
<CODE>'sicstus</CODE>, and <CODE>'swi</CODE>. Defaults to <CODE>'sicstus</CODE>.

<DT><CODE>prolog-system-version</CODE>
<DD>
<A NAME="IDX84"></A>
The version of SICStus that is used. Defaults to <CODE>'((sicstus (3 . 7)))</CODE>.
Note that the spaces are significant!

<DT><CODE>prolog-use-sicstus-sd</CODE>
<DD>
<A NAME="IDX85"></A>
Set to <CODE>t</CODE> to enable the source-linked debugging extensions by
default.  Defaults to <CODE>nil</CODE>. The debugging can be enabled via the
<CODE>Prolog</CODE> menu even if this variable is <CODE>nil</CODE>. Note that the
source-linked debugging only works if <CODE>prolog-system-version</CODE> is
set correctly.

<DT><CODE>pltrace-port-arrow-assoc</CODE>
<DD>
<A NAME="IDX86"></A>
Only relevant for source-linked debugging, this controls how the various
ports of invocation boxes (see section <A HREF="sicstus_9.html#SEC85">The Procedure Box Control Flow Model</A>) map to arrows that
point into the current line of code in source code buffers.  Initialized as:


<PRE>
'(("call" . "&#62;&#62;&#62;") ("exit" . "+++") ("ndexit" . "?++") ("redo" . "&#60;&#60;&#60;") 
  ("fail" . "---") ("exception" . "==&#62;"))
</PRE>

where <CODE>ndexit</CODE> is the non-deterministic variant of the Exit port.

<DT><CODE>prolog-indent-width</CODE>
<DD>
<A NAME="IDX87"></A>
How many positions to indent the body of a clause. Defaults to 
<CODE>tab-width</CODE>, normally 8.

<DT><CODE>prolog-paren-indent</CODE>
<DD>
<A NAME="IDX88"></A>
The number of positions to indent code inside grouping
parentheses. Defaults to 4, which gives the following indentation.


<PRE>
p :-
        (   q1
        ;   q2,
            q3
        ).
</PRE>

Note that the spaces between the parentheses and the code are
automatically inserted when <KBD>TAB</KBD> is pressed at those positions.

<DT><CODE>prolog-align-comments-flag</CODE>
<DD>
<A NAME="IDX89"></A>
Set to <CODE>nil</CODE> to prevent single <CODE>%</CODE>-comments to be automatically
aligned. Defaults to <CODE>t</CODE>.

Note that comments with one <CODE>%</CODE> are indented to comment-column, comments
with two <CODE>%</CODE> to the code level, and that comments with three <CODE>%</CODE> are
never changed when indenting.

<DT><CODE>prolog-indent-mline-comments-flag</CODE>
<DD>
<A NAME="IDX90"></A>
Set to <CODE>nil</CODE> to prevent indentation of text inside <CODE>/*
... */</CODE> comments. Defaults <CODE>t</CODE>.

<DT><CODE>prolog-object-end-to-0-flag</CODE>
<DD>
<A NAME="IDX91"></A>
Set to nil to indent the closing <CODE>}</CODE> of an object definition to
<CODE>prolog-indent-width</CODE>. Defaults to <CODE>t</CODE>.

<DT><CODE>prolog-keywords</CODE>
<DD>
<A NAME="IDX92"></A>
This is a list with keywords that are highlighted in a special color
when used as commands (i.e. as <CODE>:- <VAR>keyword</VAR></CODE>). Defaults to

<PRE>
'((sicstus ("block" "dynamic" "mode" "module" "multifile"
   "meta_predicate" "parallel" "public" "sequential" "volatile")))
</PRE>

<DT><CODE>prolog-electric-newline-flag</CODE>
<DD>
<A NAME="IDX93"></A>
Set to <CODE>nil</CODE> to prevent Emacs from automatically indenting the next
line when pressing <KBD>RET</KBD>. Defaults to <CODE>t</CODE>.

<DT><CODE>prolog-hungry-delete-key-flag</CODE>
<DD>
<A NAME="IDX94"></A>
Set to <CODE>t</CODE> to enable deletion of all white space before the cursor
when pressing the delete key (unless inside a comment, string, or quoted
atom). Defaults to <CODE>nil</CODE>.

<DT><CODE>prolog-electric-dot-flag</CODE>
<DD>
<A NAME="IDX95"></A>
Set to <CODE>t</CODE> to enable the electric dot function. If enabled,
pressing <KBD>.</KBD> at the end of a non-empty line inserts a dot and a
newline.  When pressed at the beginning of a line, a new head of the
last predicate is inserted. When pressed at the end of a line with only
whitespace, a recursive call to the current predicate is inserted. The
function respects the arity of the predicate and inserts parentheses and
the correct number of commas for separation of the arguments. Defaults
to <CODE>nil</CODE>.

<DT><CODE>prolog-electric-underscore-flag</CODE>
<DD>
<A NAME="IDX96"></A>
Set to <CODE>t</CODE> to enable the electric underscore function. When
enabled, pressing underscore (<KBD>_</KBD>) when the cursor is on a variable,
replaces the variable with the anynomous variable. Defaults to
<CODE>nil</CODE>.

<DT><CODE>prolog-old-sicstus-keys-flag</CODE>
<DD>
<A NAME="IDX97"></A>
Set to <CODE>t</CODE> to enable the key-bindings of the old Emacs interface. These
bindings are not used by default since they violate GNU Emacs
recommendations. Defaults to <CODE>nil</CODE>.

<DT><CODE>prolog-use-prolog-tokenizer-flag</CODE>
<DD>
<A NAME="IDX98"></A>
Set to <CODE>nil</CODE> to use built-in functions of Emacs for parsing the
source code when indenting. This is faster than the default but does not
handle some of the syntax peculiarities of Prolog. Defaults to <CODE>t</CODE>.

<DT><CODE>prolog-parse-mode</CODE>
<DD>
<A NAME="IDX99"></A>
What position the parsing is done from when indenting code. Two possible
settings: <CODE>'beg-of-line</CODE> and <CODE>'beg-of-clause</CODE>. The first is
faster but may result in erroneous indentation in <CODE>/* ... */</CODE>
comments.  The default is <CODE>'beg-of-line</CODE>.

<DT><CODE>prolog-imenu-flag</CODE>
<DD>
<A NAME="IDX100"></A>
Set to <CODE>t</CODE> to enable a new <CODE>Predicate</CODE> menu which contains all
predicates of the current file. Choosing an entry in the menu moves the
cursor to the start of that predicate. Defaults to <CODE>nil</CODE>.

<DT><CODE>prolog-info-predicate-index</CODE>
<DD>
<A NAME="IDX101"></A>
The info node for the SICStus predicate index. This is important if the
online help function is to be used (by pressing <CODE>C-c ?</CODE>, or
choosing the <CODE>Prolog/Help on predicate</CODE> menu entry). The default
setting is <CODE>"(sicstus)Predicate Index"</CODE>.

<DT><CODE>prolog-underscore-wordchar-flag</CODE>
<DD>
<A NAME="IDX102"></A>
Set to <CODE>nil</CODE> to not make underscore (<KBD>_</KBD>) a word-constituent
character.  Defaults to <CODE>t</CODE>.
</DL>



<H3><A NAME="SEC31" HREF="sicstus_toc.html#TOC31">Tips</A></H3>

<P>
Some general tips and tricks for using the SICStus mode and Emacs in general are given here. 

</P>

<UL>
<LI><A HREF="sicstus_4.html#SEC32">Font-locking</A>
<LI><A HREF="sicstus_4.html#SEC33">Auto-fill mode</A>
<LI><A HREF="sicstus_4.html#SEC34">Speed</A>
<LI><A HREF="sicstus_4.html#SEC35">Changing colors</A>
</UL>



<H4><A NAME="SEC32" HREF="sicstus_toc.html#TOC32">Font-locking</A></H4>

<P>
When editing large files, it might happen that font-locking is not done
because the file is too large. Typing <CODE>M-x lazy-lock-mode</CODE> results
in only the visible parts of the buffer being highlighted, which is much
faster.

</P>
<P>
If the font-locking seems to be incorrect then choose <CODE>Fontify
Buffer</CODE> from the <CODE>Prolog</CODE> menu.

</P>


<H4><A NAME="SEC33" HREF="sicstus_toc.html#TOC33">Auto-fill mode</A></H4>

<P>
Auto-fill mode is enabled by typing <CODE>M-x auto-fill-mode</CODE>. This
enables automatic line breaking with some features.  For example, the
following multiline comment was created by typing <KBD>M-;</KBD> followed by
the text. The second line was indented and a <KBD>%</KBD> was added
automatically.

</P>

<PRE>
dynamics([]).       % A list of pit furnace
                    % dynamic instances
</PRE>



<H4><A NAME="SEC34" HREF="sicstus_toc.html#TOC34">Speed</A></H4>

<P>
There are several things to do if the speed of the Emacs environment
is a problem:

</P>

<UL>
<LI>

First of all, make sure that <TT>`prolog.el'</TT> and <TT>`pltrace.el'</TT> are
compiled, i.e. that there is a <TT>`prolog.elc'</TT> and a
<TT>`pltrace.elc'</TT> file at the same location as the original files. To do
the compilation, start Emacs and type <CODE>M-x byte-compile-file RET
Path RET</CODE>, where <CODE>Path</CODE> is the path to the <SAMP>`*.el'</SAMP> file. Do not be
alarmed if there are a few warning messages as this is normal.  If all
went well, there should now be a compiled file which is used the next
time Emacs is started.

<LI>

The next thing to try is changing the setting of
<CODE>prolog-use-prolog-tokenizer-flag</CODE> to <CODE>nil</CODE>. This means that
Emacs uses built-in functions for some of the source code parsing, thus
speeding up indentation. The problem is that it does not handle all
peculiarities of the Prolog syntax, so this is a trade-off between
correctness and speed.

<LI>

The setting of the <CODE>prolog-parse-mode</CODE> variable also affects
the speed, <CODE>'beg-of-line</CODE> being faster than  <CODE>'beg-of-clause</CODE>.
</UL>



<H4><A NAME="SEC35" HREF="sicstus_toc.html#TOC35">Changing Colors</A></H4>

<P>
The prolog mode uses the default Emacs colors for font-locking as far as
possible. The only custom settings are in the prolog process buffer. The
default settings of the colors may not agree with your preferences, so
here is how to change them.

</P>
<P>
First of all, list all available faces (a face is a combined setting of
foreground and background colors, font, boldness, etc.) by typing
<CODE>M-x list-faces-display</CODE>.

</P>
<P>
There are several functions that change the appearance of a face, the
ones you will most likely need are:

</P>
<DL COMPACT>

<DT><CODE>set-face-foreground</CODE>
<DD>
<DT><CODE>set-face-background</CODE>
<DD>
<DT><CODE>set-face-underline-p</CODE>
<DD>
<DT><CODE>make-face-bold</CODE>
<DD>
<DT><CODE>make-face-bold-italic</CODE>
<DD>
<DT><CODE>make-face-italic</CODE>
<DD>
<DT><CODE>make-face-unbold</CODE>
<DD>
<DT><CODE>make-face-unitalic</CODE>
<DD>
</DL>

<P>
These can be tested interactively by typing <CODE>M-x
<VAR>function-name</VAR></CODE>. You will then be asked for the name of the face to
change and a value. If the buffers are not updated according to the new
settings, then refontify the buffer using the <CODE>Fontify Buffer</CODE> menu entry
in the <CODE>Prolog</CODE> menu.

</P>
<P>
Colors are specified by a name or by RGB values. Available color names
can be listed with <CODE>M-x list-colors-display</CODE>.

</P>
<P>
To store the settings of the faces, a few lines must be added to
<TT>`~/.emacs'</TT>. For example:

</P>

<PRE>
;; Customize font-lock faces
(add-hook 'font-lock-mode-hook 
          '(lambda ()
             (set-face-foreground font-lock-variable-name-face "#00a000")
             (make-face-bold font-lock-keyword-face)
             (set-face-foreground font-lock-reference-face "Blue")
             ))
</PRE>

<P><HR><P>
Go to the <A HREF="sicstus_1.html">first</A>, <A HREF="sicstus_3.html">previous</A>, <A HREF="sicstus_5.html">next</A>, <A HREF="sicstus_50.html">last</A> section, <A HREF="sicstus_toc.html">table of contents</A>.
</BODY>
</HTML>
