<HTML>
<HEAD>
<!-- This HTML file has been created by texi2html 1.52
     from sicstus.tex on 6 October 1998 -->

<TITLE>SICStus Prolog - Glue Code Generator</TITLE>
</HEAD>
<BODY>
Go to the <A HREF="sicstus_1.html">first</A>, <A HREF="sicstus_40.html">previous</A>, <A HREF="sicstus_42.html">next</A>, <A HREF="sicstus_50.html">last</A> section, <A HREF="sicstus_toc.html">table of contents</A>.
<P><HR><P>


<H1><A NAME="SEC363" HREF="sicstus_toc.html#TOC363">Glue Code Generator</A></H1>

<P>
This chapter describes utilities useful for generating glue code for the
Foreign Language Interface when building statically linked Runtime
Systems or Development Systems (see section <A HREF="sicstus_11.html#SEC124">Interface Predicates</A>).

</P>
<P>
This library module can be loaded by the query

</P>

<PRE>
| ?- use_module(library(flinkage)).
</PRE>

<P>
and refers to the following shared object files or DLLs:
<A NAME="IDX1542"></A>
<A NAME="IDX1543"></A>
<A NAME="IDX1544"></A>
<A NAME="IDX1545"></A>

</P>
<DL COMPACT>

<DT><EM>runtime kernel</EM>
<DD>
The SICStus runtime kernel, usually
<TT>`$SP_PATH/../libsprt37.so'</TT> under UNIX, or
<TT>`%SP_PATH%\..\sprt37.dll'</TT> under Windows, and

<DT><EM>development kernel</EM>
<DD>
The SICStus development kernel, usually
<TT>`$SP_PATH/../libspds37.so'</TT> under UNIX, or
<TT>`%SP_PATH%\..\spds37.dll'</TT> under Windows.
</DL>

<P>
The following predicate can be used to generate a glue code file
<TT>`flinkage.c'</TT> file out of any old-style <CODE>foreign_file/2</CODE> and
<CODE>foreign/(2,3)</CODE> declarations found in a set of Prolog files for use
in a statically linked executable.
<STRONG>Note:</STRONG> this is provided for backwards compatibility only.  We
recommend using foreign resources instead, which can be dynamically
linked:

</P>
<DL COMPACT>

<DT><CODE>generate_flinkage(<VAR>+Files</VAR>)</CODE>
<DD>
<A NAME="IDX1546"></A>
<VAR>Files</VAR> are loaded as by <CODE>use_module/1</CODE>. Calls to
<CODE>load_foreign_files/2</CODE> are intercepted by means of the goal
expansion mechanism. The file <TT>`flinkage.c'</TT> is generated out of the
declarations found.
Finally, compile and link the <TT>`flinkage.c'</TT> file with the user code,
libraries and the runtime and optionally the development kernel.
</DL>

<P>
The following predicates, available in Development Systems only,
provide alternative methods to building executables or linked foreign
resources compared to the methods described in section <A HREF="sicstus_11.html#SEC154">Creating the Executable</A>, section <A HREF="sicstus_11.html#SEC156">Development Systems</A> and section <A HREF="sicstus_11.html#SEC126">Creating the Linked Foreign Resource</A>.  If the default method doesn't work as expected for
some reason or you wish to use an Integrated Development Environment
etc., the following outlines the necessary steps. To build an
executable:

</P>
<P>
First, decide which foreign resources are to be statically linked and create a
<EM>resource table file</EM> as follows:

</P>
<DL COMPACT>

<DT><CODE>prepare_resource_table(<VAR>+ResourceNames</VAR>,<VAR>+CFile</VAR>)</CODE>
<DD>
<A NAME="IDX1547"></A>
where <VAR>+ResourceNames</VAR> is a list of the resource names and
<VAR>+CFile</VAR> is the file where to write the generated code.
</DL>

<P>
The next step is to create linked foreign resources from the foreign
resources which are to be statically linked. Produce, for each foreign
resource, a <EM>glue code file</EM> using:

</P>
<DL COMPACT>

<DT><CODE>prepare_foreign_resource(<VAR>+ResourceName</VAR>,<VAR>+SourceFile</VAR>,<VAR>+CFile</VAR>)</CODE>
<DD>
<A NAME="IDX1548"></A>
where <VAR>ResourceName</VAR> is the name of the resource, <VAR>SourceFile</VAR>
is the Prolog source file containing the resource conversion
declarations and <VAR>CFile</VAR> is the file where to write the generated
code.
</DL>

<P>
Finally, compile and link the glue code files with the user code,
libraries and the runtime and optionally the development kernel. Further
information (platform specific) is provided with the distribution.

</P>

<P>
To build a dynamic linked foreign resource:

</P>
<P>
Produce a glue code file using <CODE>prepare_foreign_resource/3</CODE>. Check
the provided platform specific notes for compiler options needed and
compile the glue code file and the user code files. Likewise check the
notes on how a dynamic linked foreign resource is implemented on this
platform and link the object files to an appropriate object.

</P>

<P><HR><P>
Go to the <A HREF="sicstus_1.html">first</A>, <A HREF="sicstus_40.html">previous</A>, <A HREF="sicstus_42.html">next</A>, <A HREF="sicstus_50.html">last</A> section, <A HREF="sicstus_toc.html">table of contents</A>.
</BODY>
</HTML>
