<HTML>
<HEAD>
<!-- This HTML file has been created by texi2html 1.52
     from sicstus.tex on 6 October 1998 -->

<TITLE>SICStus Prolog - Timeout Predicate</TITLE>
</HEAD>
<BODY>
Go to the <A HREF="sicstus_1.html">first</A>, <A HREF="sicstus_41.html">previous</A>, <A HREF="sicstus_43.html">next</A>, <A HREF="sicstus_50.html">last</A> section, <A HREF="sicstus_toc.html">table of contents</A>.
<P><HR><P>


<H1><A NAME="SEC364" HREF="sicstus_toc.html#TOC364">Timeout Predicate</A></H1>

<P>
The <CODE>timeout</CODE> package, which may be loaded by the query

</P>

<PRE>
| ?- use_module(library(timeout)).
</PRE>

<P>
contains the predicate:

</P>
<DL COMPACT>

<DT><CODE>time_out(<VAR>:Goal</VAR>, <VAR>+Time</VAR>, <VAR>?Result</VAR>)</CODE>
<DD>
<A NAME="IDX1549"></A>
The <VAR>Goal</VAR> is executed as if by <CODE>call/1</CODE>.  If computing
any solution takes more than <VAR>Time</VAR> milliseconds, process virtual
time, the goal will fail and <VAR>Result</VAR> is unified with the atom
<CODE>time_out</CODE>.  If the goal succeeds within the specified time
<VAR>Result</VAR> is unified with the atom <CODE>success</CODE>.  <VAR>Time</VAR> must
be a number between (not including) 0 and 2147483647.  </DL>

<P>
<CODE>time_out/3</CODE> is implemented by raising and handling
<CODE>time_out</CODE> exceptions, so any exception handler in the scope of
<VAR>Goal</VAR> must be prepared to pass on <CODE>time_out</CODE> exceptions.
The following incorrect example shows what can happen otherwise:

</P>

<PRE>
| ?- time_out(on_exception(Q,(repeat,false),true), 1000, Res).
Q = time_out,
Res = success
</PRE>

<P><HR><P>
Go to the <A HREF="sicstus_1.html">first</A>, <A HREF="sicstus_41.html">previous</A>, <A HREF="sicstus_43.html">next</A>, <A HREF="sicstus_50.html">last</A> section, <A HREF="sicstus_toc.html">table of contents</A>.
</BODY>
</HTML>
