<HTML>
<HEAD>
<!-- This HTML file has been created by texi2html 1.52
     from sicstus.tex on 6 October 1998 -->

<TITLE>SICStus Prolog - Cross Reference Producer</TITLE>
</HEAD>
<BODY>
Go to the <A HREF="sicstus_1.html">first</A>, <A HREF="sicstus_42.html">previous</A>, <A HREF="sicstus_44.html">next</A>, <A HREF="sicstus_50.html">last</A> section, <A HREF="sicstus_toc.html">table of contents</A>.
<P><HR><P>


<H1><A NAME="SEC365" HREF="sicstus_toc.html#TOC365">Cross Reference Producer</A></H1>
<P>
<A NAME="IDX1550"></A>

</P>
<P>
This package provides a cross reference producer is a useful tool for
debugging and program analysis.  It can be used to produce the call
graph of a program, and to produce a list of predicates that are used
but not defined or vice versa.  The graph processing utilities described
in previous chapters may be used to analyze the call graphs.

</P>
<P>
To load the package, enter the query

</P>

<PRE>
| ?- use_module(library(xref)).
</PRE>

<DL COMPACT>

<DT><CODE>call_graph(<VAR>:Files</VAR>, <VAR>-Graph</VAR>)</CODE>
<DD>
<A NAME="IDX1551"></A>
<VAR>Graph</VAR> is the call graph (see section <A HREF="sicstus_26.html#SEC200">Unweighted Graph Operations</A>) of the predicates in
<VAR>Files</VAR>.  The vertices of <VAR>Graph</VAR> are terms of the following
types:

<DL COMPACT>

<DT><CODE>def</CODE>
<DD>
There is an edge from <CODE>def</CODE> to every predicate that is explicitly
defined, declared, imported, or implicitly defined in a
<CODE>foreign/(2-3)</CODE> fact.

<DT><CODE>use</CODE>
<DD>
There is an edge from <CODE>use</CODE> to every predicate that is used in a
directive, exported, or declared as <CODE>public</CODE>.  If a "hook"
predicate such as <CODE>user:portray/1</CODE> is defined, there is an edge
from <CODE>use</CODE> to it too.

<DT><CODE><VAR>Module</VAR>:<VAR>Name</VAR>/<VAR>Arity</VAR></CODE>
<DD>
Denotes a predicate occurring in one of the <VAR>Files</VAR>.  There is an
edge from predicate <VAR>P</VAR> to predicate <VAR>Q</VAR> if <VAR>P</VAR> calls
<VAR>Q</VAR> and <VAR>Q</VAR> is not a built-in predicate.
</DL>

<DT><CODE>xref(<VAR>:Files</VAR>)</CODE>
<DD>
<A NAME="IDX1552"></A>
<VAR>Files</VAR> is a single file or a list of files, as accepted by
<CODE>consult/1</CODE> and friends.  The predicate prints on the current
output stream a list of predicates which are reachable from <CODE>use</CODE>
in the call graph but not defined, followed by a list of predicates
which are defined but not reachable from <CODE>use</CODE>.
</DL>

<P>
There may be references not found by <CODE>xref</CODE> because of the dynamic
nature of the Prolog language.  Note that <CODE>xref</CODE> does not consider
a predicate used unless it is reachable from a directive, an export
list, or a <CODE>public</CODE> declaration.  In non-module files, it is
therefore recommended that the entry point predicates be declared as
<CODE>public</CODE>.  Predicates reached by meta-calls only may also have to
be declared <CODE>public</CODE> to be considered used.

</P>
<P>
If a module file (file containing a module declaration) is encountered,
the module specified is used for that file <EM>and</EM> subsequent files up
to the next module file.  This enables packages consisting of several
files, which are to be loaded in the same module, to be correctly
treated.  The type-in module is the default module.

</P>

<P><HR><P>
Go to the <A HREF="sicstus_1.html">first</A>, <A HREF="sicstus_42.html">previous</A>, <A HREF="sicstus_44.html">next</A>, <A HREF="sicstus_50.html">last</A> section, <A HREF="sicstus_toc.html">table of contents</A>.
</BODY>
</HTML>
