<HTML>
<HEAD>
<!-- This HTML file has been created by texi2html 1.52
     from sicstus.tex on 6 October 1998 -->

<TITLE>SICStus Prolog - Summary of Built-In Predicates</TITLE>
</HEAD>
<BODY>
Go to the <A HREF="sicstus_1.html">first</A>, <A HREF="sicstus_43.html">previous</A>, <A HREF="sicstus_45.html">next</A>, <A HREF="sicstus_50.html">last</A> section, <A HREF="sicstus_toc.html">table of contents</A>.
<P><HR><P>


<H1><A NAME="SEC366" HREF="sicstus_toc.html#TOC366">Summary of Built-In Predicates</A></H1>

<DL COMPACT>

<DT><CODE>!</CODE>
<DD>
Commits to any choices taken in the current predicate.

<DT><CODE>(<VAR>+P</VAR>,<VAR>+Q</VAR>)</CODE>
<DD>
<VAR>P</VAR> and <VAR>Q</VAR>.

<DT><CODE>(<VAR>Head</VAR> --&#62; <VAR>Body</VAR>)</CODE>
<DD>
Not a built-in predicate; reserved syntax for grammar rules.

<DT><CODE>(<VAR>+P</VAR> -&#62; <VAR>+Q</VAR> ; <VAR>+R</VAR>)</CODE>
<DD>
If <VAR>P</VAR> then <VAR>Q</VAR> else <VAR>R</VAR>, using first solution of <VAR>P</VAR> only.

<DT><CODE>(<VAR>+P</VAR> -&#62; <VAR>+Q</VAR>)</CODE>
<DD>
If <VAR>P</VAR> then <VAR>Q</VAR> else false, using first solution of <VAR>P</VAR> only.

<DT><CODE>[]</CODE>
<DD>
<DT><CODE>[<VAR>:File</VAR>|<VAR>+Files</VAR>]</CODE>
<DD>
Updates the program with interpreted clauses from <VAR>File</VAR> and <VAR>Files</VAR>.

<DT><CODE>(:- <VAR>Command</VAR>)</CODE>
<DD>
Not a built-in predicate; reserved syntax for commands and declarations.

<DT><CODE>(?- <VAR>Query</VAR>)</CODE>
<DD>
Not a built-in predicate; reserved syntax for queries.

<DT><CODE>(<VAR>Head</VAR> :- <VAR>Body</VAR>)</CODE>
<DD>
Not a built-in predicate; reserved syntax for clauses.

<DT><CODE>(<VAR>+P</VAR>;<VAR>+Q</VAR>)</CODE>
<DD>
<VAR>P</VAR> or <VAR>Q</VAR>.

<DT><CODE><VAR>?X</VAR> = <VAR>?Y</VAR></CODE>
<DD>
The terms <VAR>X</VAR> and <VAR>Y</VAR> are unified.

<DT><CODE><VAR>+Term</VAR> =.. <VAR>?List</VAR></CODE>
<DD>
<DT><CODE><VAR>?Term</VAR> =.. <VAR>+List</VAR></CODE>
<DD>
The functor and arguments of the term <VAR>Term</VAR> comprise the list
<VAR>List</VAR>.

<DT><CODE><VAR>+X</VAR> =:= <VAR>+Y</VAR></CODE>
<DD>
<VAR>X</VAR> is numerically equal to <VAR>Y</VAR>.

<DT><CODE><VAR>?Term1</VAR> == <VAR>?Term2</VAR></CODE>
<DD>
The terms <VAR>Term1</VAR> and <VAR>Term2</VAR> are strictly identical.

<DT><CODE><VAR>+X</VAR> =\= <VAR>+Y</VAR></CODE>
<DD>
<VAR>X</VAR> is not numerically equal to <VAR>Y</VAR>.

<DT><CODE><VAR>+X</VAR> =&#60; <VAR>+Y</VAR></CODE>
<DD>
<VAR>X</VAR> is less than or equal to <VAR>Y</VAR>.

<DT><CODE><VAR>+X</VAR> &#62; <VAR>+Y</VAR></CODE>
<DD>
<VAR>X</VAR> is greater than <VAR>Y</VAR>.

<DT><CODE><VAR>+X</VAR> &#62;= <VAR>+Y</VAR></CODE>
<DD>
<VAR>X</VAR> is greater than or equal to <VAR>Y</VAR>.

<DT><CODE><VAR>?X</VAR> ^ <VAR>:P</VAR></CODE>
<DD>
Executes the procedure call <VAR>P</VAR>.

<DT><CODE>\+ <VAR>+P</VAR></CODE>
<DD>
Goal <VAR>P</VAR> is not provable.

<DT><CODE><VAR>?Term1</VAR> \== <VAR>?Term2</VAR></CODE>
<DD>
The terms <VAR>Term1</VAR> and <VAR>Term2</VAR> are not strictly identical.

<DT><CODE><VAR>+X</VAR> &#60; <VAR>+Y</VAR></CODE>
<DD>
<VAR>X</VAR> is less than <VAR>Y</VAR>.

<DT><CODE><VAR>?Term1</VAR> @=&#60; <VAR>?Term2</VAR></CODE>
<DD>
The term <VAR>Term1</VAR> precedes or is identical to the term <VAR>Term2</VAR> in
the standard order.

<DT><CODE><VAR>?Term1</VAR> @&#62; <VAR>?Term2</VAR></CODE>
<DD>
The term <VAR>Term1</VAR> follows the term <VAR>Term2</VAR> in the standard order.

<DT><CODE><VAR>?Term1</VAR> @&#62;= <VAR>?Term2</VAR></CODE>
<DD>
The term <VAR>Term1</VAR> follows or is identical to the term <VAR>Term2</VAR> in
the standard order.

<DT><CODE><VAR>?Term1</VAR> @&#60; <VAR>?Term2</VAR></CODE>
<DD>
The term <VAR>Term1</VAR> precedes the term <VAR>Term2</VAR> in the standard
order.

<DT><CODE>?=(<VAR>?X</VAR>,<VAR>?Y</VAR>)</CODE>
<DD>
<VAR>X</VAR> and <VAR>Y</VAR> are either syntactically identical or 
syntactically non-unifiable.

<DT><CODE>abolish(<VAR>:Preds</VAR>)</CODE>
<DD>
Makes the predicate(s) specified by <VAR>Preds</VAR> undefined.

<DT><CODE>abolish(<VAR>:Atom</VAR>,<VAR>+Arity</VAR>)</CODE>
<DD>
Makes the predicate specified by <CODE><VAR>Atom</VAR>/<VAR>Arity</VAR></CODE> undefined.

<DT><CODE>abort</CODE>
<DD>
Aborts execution of the current directive (returns to C in recursive calls to Prolog from C).

<DT><CODE>absolute_file_name(<VAR>+RelativeName</VAR>,<VAR>?AbsoluteName</VAR>)</CODE>
<DD>
<VAR>AbsoluteName</VAR> is the full pathname of <VAR>RelativeName</VAR>.

<DT><CODE>arg(<VAR>+ArgNo</VAR>,<VAR>+Term</VAR>,<VAR>?Arg</VAR>)</CODE>
<DD>
The argument <VAR>ArgNo</VAR> of the term <VAR>Term</VAR> is <VAR>Arg</VAR>.

<DT><CODE>assert(<VAR>:Clause</VAR>)</CODE>
<DD>
<DT><CODE>assert(<VAR>:Clause</VAR>,<VAR>-Ref</VAR>)</CODE>
<DD>
Asserts clause <VAR>Clause</VAR> with unique identifier <VAR>Ref</VAR>.

<DT><CODE>asserta(<VAR>:Clause</VAR>)</CODE>
<DD>
<DT><CODE>asserta(<VAR>:Clause</VAR>,<VAR>-Ref</VAR>)</CODE>
<DD>
Asserts <VAR>Clause</VAR> as first clause with unique identifier <VAR>Ref</VAR>.

<DT><CODE>assertz(<VAR>:Clause</VAR>)</CODE>
<DD>
<DT><CODE>assertz(<VAR>:Clause</VAR>,<VAR>-Ref</VAR>)</CODE>
<DD>
Asserts <VAR>Clause</VAR> as last clause with unique identifier <VAR>Ref</VAR>.

<DT><CODE>at_end_of_line</CODE>
<DD>
<DT><CODE>at_end_of_line(<VAR>Stream</VAR>)</CODE>
<DD>
The end of stream or end of line has been reached for <VAR>Stream</VAR>
or from the current input stream.

<DT><CODE>at_end_of_stream</CODE>
<DD>
<DT><CODE>at_end_of_stream(<VAR>Stream</VAR>)</CODE>
<DD>
The end of stream has been reached for <VAR>Stream</VAR>
or from the current input stream.

<DT><CODE>atom(<VAR>?X</VAR>)</CODE>
<DD>
<VAR>X</VAR> is currently instantiated to an atom.

<DT><CODE>atom_chars(<VAR>+Atom</VAR>,<VAR>?CharList</VAR>)</CODE>
<DD>
<DT><CODE>atom_chars(<VAR>?Atom</VAR>,<VAR>+CharList</VAR>)</CODE>
<DD>
The name of the atom <VAR>Atom</VAR> is the list of characters <VAR>CharList</VAR>.

<DT><CODE>atomic(<VAR>?X</VAR>)</CODE>
<DD>
<VAR>X</VAR> is currently instantiated to an atom or a number.

<DT><CODE>bagof(<VAR>?Template</VAR>,<VAR>:Goal</VAR>,<VAR>?Bag</VAR>)</CODE>
<DD>
<VAR>Bag</VAR> is the bag of instances of <VAR>Template</VAR> such that <VAR>Goal</VAR>
is satisfied (not just provable).

<DT><CODE>block <VAR>Specs</VAR></CODE>
<DD>
Not a built-in predicate; block declaration.

<DT><CODE>bb_delete(<VAR>+Key</VAR>,<VAR>?Term</VAR>)</CODE>
<DD>
Delete from the blackboard <VAR>Term</VAR> stored under <VAR>Key</VAR>.

<DT><CODE>bb_get(<VAR>+Key</VAR>,<VAR>?Term</VAR>)</CODE>
<DD>
Get from the blackboard <VAR>Term</VAR> stored under <VAR>Key</VAR>.

<DT><CODE>bb_put(<VAR>+Key</VAR>,<VAR>+Term</VAR>)</CODE>
<DD>
Store the term <VAR>Term</VAR> under <VAR>Key</VAR> on the blackboard.

<DT><CODE>bb_update(<VAR>:Key</VAR>, <VAR>?OldTerm</VAR>, <VAR>?NewTerm</VAR>)</CODE>
<DD>
Replace the term <VAR>OldTerm</VAR> by the term <VAR>NewTerm</VAR> under <VAR>Key</VAR>
on the blackboard.

<DT><CODE>break</CODE>
<DD>
Invokes a recursive top-level.
(not available in Runtime Systems).

<DT><CODE>'C'(<VAR>?S1</VAR>,<VAR>?Terminal</VAR>,<VAR>?S2</VAR>)</CODE>
<DD>
<EM>Grammar rules.</EM> <VAR>S1</VAR> is connected by the terminal
<VAR>Terminal</VAR> to <VAR>S2</VAR>.

<DT><CODE>call(<VAR>:Term</VAR>)</CODE>
<DD>
<DT><CODE>(<VAR>Module</VAR>:<VAR>:Term</VAR>)</CODE>
<DD>
Executes the procedure call <VAR>Term</VAR> in <VAR>Module</VAR>.

<DT><CODE>call_cleanup(<VAR>:Goal</VAR>,<VAR>:Cleanup</VAR>)</CODE>
<DD>
Executes the procedure call <VAR>Goal</VAR>.  When <VAR>Goal</VAR> succeeds
deterministically, is cut, fails, or raises an exception, <VAR>Cleanup</VAR>
is executed.

<DT><CODE>call_residue(<VAR>:Goal</VAR>,<VAR>?Residue</VAR>)</CODE>
<DD>
Executes the procedure call <VAR>Goal</VAR>.  Any floundered goals and the
variables they are blocked on occur as <VAR>VarSet-Goal</VAR> pairs in
<VAR>Residue</VAR>.

<DT><CODE>callable(<VAR>?X</VAR>)</CODE>
<DD>
<VAR>X</VAR> is currently instantiated to a compound term or an atom.

<DT><CODE>character_count(<VAR>+Stream</VAR>,<VAR>?Count</VAR>)</CODE>
<DD>
<VAR>Count</VAR> characters have been read from or written to the stream
<VAR>Stream</VAR>.

<DT><CODE>clause(<VAR>:Head</VAR>,<VAR>?Body</VAR>)</CODE>
<DD>
<DT><CODE>clause(<VAR>:Head</VAR>,<VAR>?Body</VAR>,<VAR>?Ref</VAR>)</CODE>
<DD>
<DT><CODE>clause(<VAR>?Head</VAR>,<VAR>?Body</VAR>,<VAR>+Ref</VAR>)</CODE>
<DD>
There is an interpreted clause whose head is <VAR>Head</VAR>, whose body is
<VAR>Body</VAR>, and whose unique identifier is <VAR>Ref</VAR>.

<DT><CODE>close(<VAR>+Stream</VAR>)</CODE>
<DD>
Closes stream <VAR>Stream</VAR>.

<DT><CODE>compare(<VAR>?Op</VAR>,<VAR>?Term1</VAR>,<VAR>?Term2</VAR>)</CODE>
<DD>
<VAR>Op</VAR> is the result of comparing the terms <VAR>Term1</VAR> and <VAR>Term2</VAR>.

<DT><CODE>compile(<VAR>:Files</VAR>)</CODE>
<DD>
Compiles in-core the clauses in text file(s) <VAR>Files</VAR>.

<DT><CODE>compound(<VAR>?X</VAR>)</CODE>
<DD>
<VAR>X</VAR> is currently instantiated to a term of arity &#62; 0.

<DT><CODE>consult(<VAR>:Files</VAR>)</CODE>
<DD>
Updates the program with interpreted clauses from file(s) <VAR>Files</VAR>.

<DT><CODE>copy_term(<VAR>?Term</VAR>,<VAR>?CopyOfTerm</VAR>)</CODE>
<DD>
<VAR>CopyOfTerm</VAR> is an independent copy of <VAR>Term</VAR>.

<DT><CODE>create_mutable(<VAR>+Datum</VAR>,<VAR>-Mutable</VAR>)</CODE>
<DD>
<VAR>Mutable</VAR> is a new mutable term with current value <VAR>Datum</VAR>.

<DT><CODE>current_atom(<VAR>?Atom</VAR>)</CODE>
<DD>
One of the currently defined atoms is <VAR>Atom</VAR>.

<DT><CODE>current_input(<VAR>?Stream</VAR>)</CODE>
<DD>
<VAR>Stream</VAR> is the current input stream.

<DT><CODE>current_key(<VAR>?KeyName</VAR>,<VAR>?KeyTerm</VAR>)</CODE>
<DD>
There is a recorded item in the internal database whose key is
<VAR>KeyTerm</VAR>, the name of which is <VAR>KeyName</VAR>.

<DT><CODE>current_module(<VAR>?Module</VAR>)</CODE>
<DD>
<VAR>Module</VAR> is a module currently in the system.

<DT><CODE>current_module(<VAR>?Module</VAR>,<VAR>?File</VAR>)</CODE>
<DD>
<VAR>Module</VAR> is a module currently in the system, loaded from <VAR>File</VAR>.

<DT><CODE>current_op(<VAR>?Precedence</VAR>,<VAR>?Type</VAR>,<VAR>?Op</VAR>)</CODE>
<DD>
Atom <VAR>Op</VAR> is an operator type <VAR>Type</VAR> precedence
<VAR>Precedence</VAR>.

<DT><CODE>current_output(<VAR>?Stream</VAR>)</CODE>
<DD>
<VAR>Stream</VAR> is the current output stream.

<DT><CODE>current_predicate(<VAR>?Name</VAR>,<VAR>:Head</VAR>)</CODE>
<DD>
<DT><CODE>current_predicate(<VAR>?Name</VAR>,<VAR>-Head</VAR>)</CODE>
<DD>
A user defined or library predicate is named <VAR>Name</VAR>, most general
goal <VAR>Head</VAR>.

<DT><CODE>current_stream(<VAR>?AbsFileName</VAR>,<VAR>?Mode</VAR>,<VAR>?Stream</VAR>)</CODE>
<DD>
There is a stream <VAR>Stream</VAR> associated with the file <VAR>AbsFileName</VAR>
and opened in mode <VAR>Mode</VAR>.

<DT><CODE>debug</CODE>
<DD>
Switches on debugging in <EM>leap</EM> mode
(not available in Runtime Systems).

<DT><CODE>debugging</CODE>
<DD>
Displays debugging status information
(not available in Runtime Systems).

<DT><CODE>dif(<VAR>?X</VAR>,<VAR>?Y</VAR>)</CODE>
<DD>
The terms <VAR>X</VAR> and <VAR>Y</VAR> are different.

<DT><CODE>display(<VAR>?Term</VAR>)</CODE>
<DD>
Displays the term <VAR>Term</VAR> on the standard output stream.

<DT><CODE>dynamic <VAR>Specs</VAR></CODE>
<DD>
Not a built-in predicate; dynamic declaration.

<DT><CODE>ensure_loaded(<VAR>:Files</VAR>)</CODE>
<DD>
Compiles or loads the file(s) <VAR>Files</VAR> if need be.

<DT><CODE>erase(<VAR>+Ref</VAR>)</CODE>
<DD>
Erases the clause or record whose unique identifier is <VAR>Ref</VAR>.

<DT><CODE>error_exception(<VAR>+Exception</VAR>)</CODE>
<DD>
<DT><CODE>user:error_exception(<VAR>+Exception</VAR>)</CODE>
<DD>
<EM>A hook predicate</EM>, <VAR>Exception</VAR> is an exception that traps
to the debugger if it is switched on.

<DT><CODE>expand_term(<VAR>+Term1</VAR>,<VAR>?Term2</VAR>)</CODE>
<DD>
The term <VAR>Term1</VAR> is a shorthand which expands to the term
<VAR>Term2</VAR>.

<DT><CODE>fail</CODE>
<DD>
<DT><CODE>false</CODE>
<DD>
False.

<DT><CODE>fcompile(<VAR>:Files</VAR>)</CODE>
<DD>
Compiles file-to-file the clauses in text file(s) <VAR>Files</VAR> (not
available in Runtime Systems).

<DT><CODE>file_search_path(<VAR>Alias</VAR>,<VAR>?Expansion</VAR>)</CODE>
<DD>
<DT><CODE>user:file_search_path(<VAR>Alias</VAR>,<VAR>?Expansion</VAR>)</CODE>
<DD>
<EM>A hook predicate</EM>, telling how to expand <CODE><VAR>Alias</VAR>(<VAR>File</VAR>)</CODE>
file names.

<DT><CODE>fileerrors</CODE>
<DD>
Enables reporting of file errors.

<DT><CODE>findall(<VAR>?Template</VAR>,<VAR>:Goal</VAR>,<VAR>?Bag</VAR>)</CODE>
<DD>
<DT><CODE>findall(<VAR>?Template</VAR>,<VAR>:Goal</VAR>,<VAR>?Bag</VAR>,<VAR>?Remainder</VAR>)</CODE>
<DD>
A prefix of <VAR>Bag</VAR> is the list of instances of <VAR>Template</VAR> such
that <VAR>Goal</VAR> is provable.  The rest of <VAR>Bag</VAR> is <VAR>Remainder</VAR>
or the empty list.

<DT><CODE>float(<VAR>?X</VAR>)</CODE>
<DD>
<VAR>X</VAR> is currently instantiated to a float.

<DT><CODE>flush_output</CODE>
<DD>
<DT><CODE>flush_output(<VAR>+Stream</VAR>)</CODE>
<DD>
Flushes the buffers associated with <VAR>Stream</VAR>.

<DT><CODE>foreign(<VAR>+CFunctionName</VAR>,<VAR>+Predicate</VAR>)</CODE>
<DD>
<DT><CODE>foreign(<VAR>+CFunctionName</VAR>,<VAR>+Language</VAR>,<VAR>+Predicate</VAR>)</CODE>
<DD>
<EM>Hook predicates</EM>, tell Prolog how to define <VAR>Predicate</VAR> to
invoke <VAR>CFunctionName</VAR>.

<DT><CODE>foreign_file(<VAR>+ObjectFile</VAR>,<VAR>+Functions</VAR>)</CODE>
<DD>
<EM>A hook predicate</EM>, tells Prolog that foreign functions <VAR>Functions</VAR>
are in file <VAR>ObjectFile</VAR>.  Obsolete, use <CODE>foreign_resource/2</CODE> instead.

<DT><CODE>foreign_resource(<VAR>+ResourceName</VAR>,<VAR>+Functions</VAR>)</CODE>
<DD>
<EM>A hook predicate</EM>, tells Prolog that foreign functions <VAR>Functions</VAR>
are in resource <VAR>ResourceName</VAR>.

<DT><CODE>format(<VAR>+Format</VAR>,<VAR>+Arguments</VAR>)</CODE>
<DD>
<DT><CODE>format(<VAR>+Stream</VAR>,<VAR>+Format</VAR>,<VAR>+Arguments</VAR>)</CODE>
<DD>
Writes <VAR>Arguments</VAR> according to <VAR>Format</VAR> on the stream
<VAR>Stream</VAR> or on the current output stream.

<DT><CODE>freeze(<VAR>?Var</VAR>,<VAR>:Goal</VAR>)</CODE>
<DD>
Blocks <VAR>Goal</VAR> until <CODE>nonvar(<VAR>Var</VAR>)</CODE> holds.

<DT><CODE>frozen(<VAR>-Var</VAR>,<VAR>?Goal</VAR>)</CODE>
<DD>
The goal <VAR>Goal</VAR> is blocked on the variable <VAR>Var</VAR>.

<DT><CODE>functor(<VAR>+Term</VAR>,<VAR>?Name</VAR>,<VAR>?Arity</VAR>)</CODE>
<DD>
<DT><CODE>functor(<VAR>?Term</VAR>,<VAR>+Name</VAR>,<VAR>+Arity</VAR>)</CODE>
<DD>
The principal functor of the term <VAR>Term</VAR> has name <VAR>Name</VAR> and arity
<VAR>Arity</VAR>.

<DT><CODE>garbage_collect</CODE>
<DD>
Performs a garbage collection of the global stack.

<DT><CODE>garbage_collect_atoms</CODE>
<DD>
Performs a garbage collection of the atoms.

<DT><CODE>gc</CODE>
<DD>
Enables garbage collection of the global stack.

<DT><CODE>get(<VAR>?C</VAR>)</CODE>
<DD>
<DT><CODE>get(<VAR>+Stream</VAR>,<VAR>?C</VAR>)</CODE>
<DD>
The next printing character from the stream <VAR>Stream</VAR> or from the
current input stream is <VAR>C</VAR>.

<DT><CODE>get0(<VAR>?C</VAR>)</CODE>
<DD>
<DT><CODE>get0(<VAR>+Stream</VAR>,<VAR>?C</VAR>)</CODE>
<DD>
The next character from the stream <VAR>Stream</VAR> or from the current
input stream is <VAR>C</VAR>.

<DT><CODE>get_mutable(<VAR>?Datum</VAR>,<VAR>+Mutable</VAR>)</CODE>
<DD>
The current value of the mutable term <VAR>Mutable</VAR> is <VAR>Datum</VAR>.

<DT><CODE>goal_expansion(<VAR>+Goal</VAR>,<VAR>+Module</VAR>,<VAR>-NewGoal</VAR>)</CODE>
<DD>
<DT><CODE>user:goal_expansion(<VAR>+Goal</VAR>,<VAR>+Module</VAR>,<VAR>-NewGoal</VAR>)</CODE>
<DD>
<EM>A hook predicate.</EM> Defines a transformation from <VAR>Goal</VAR>
in module <VAR>Module</VAR> to <VAR>NewGoal</VAR>.

<DT><CODE>ground(<VAR>?X</VAR>)</CODE>
<DD>
<VAR>X</VAR> is currently free of unbound variables.

<DT><CODE>halt</CODE>
<DD>
Halts Prolog.
(returns to C in recursive calls to Prolog from C).

<DT><CODE>halt(<VAR>Code</VAR>)</CODE>
<DD>
Halts Prolog immediately, returning <VAR>Code</VAR>.

<DT><CODE>help</CODE>
<DD>
<EM>Hookable</EM>, prints a help message (not available in Runtime Systems).

<DT><CODE>if(<VAR>+P</VAR>,<VAR>+Q</VAR>,<VAR>+R</VAR>)</CODE>
<DD>
If <VAR>P</VAR> then <VAR>Q</VAR> else <VAR>R</VAR>, exploring all solutions of
<VAR>P</VAR>.

<DT><CODE>incore(<VAR>+Term</VAR>)</CODE>
<DD>
Executes the procedure call <VAR>Term</VAR>.

<DT><CODE>initialization</CODE>
<DD>
Executes a list of user defined goals (not available in Runtime Systems).

<DT><CODE>initialization(<VAR>:Goal</VAR>)</CODE>
<DD>
Adds <VAR>Goal</VAR> to the list of goals executed by <CODE>initialization/0</CODE>
(not available in Runtime Systems).

<DT><CODE>instance(<VAR>+Ref</VAR>,<VAR>?Term</VAR>)</CODE>
<DD>
<VAR>Term</VAR> is a most general instance of the record or clause uniquely
identified by <VAR>Ref</VAR>.

<DT><CODE>integer(<VAR>?X</VAR>)</CODE>
<DD>
<VAR>X</VAR> is currently instantiated to an integer.

<DT><CODE><VAR>?Y</VAR> is <VAR>+X</VAR></CODE>
<DD>
<VAR>Y</VAR> is the value of the arithmetic expression <VAR>X</VAR>.

<DT><CODE>is_mutable(<VAR>?X</VAR>)</CODE>
<DD>
<VAR>X</VAR> is currently instantiated to a mutable term.

<DT><CODE>keysort(<VAR>+List1</VAR>,<VAR>?List2</VAR>)</CODE>
<DD>
The list <VAR>List1</VAR> sorted by key yields <VAR>List2</VAR>.

<DT><CODE>leash(<VAR>+Mode</VAR>)</CODE>
<DD>
Sets leashing mode to <VAR>Mode</VAR>
(not available in Runtime Systems).

<DT><CODE>length(<VAR>?List</VAR>,<VAR>?Length</VAR>)</CODE>
<DD>
The length of list <VAR>List</VAR> is <VAR>Length</VAR>.

<DT><CODE>library_directory(<VAR>?Directory</VAR>)</CODE>
<DD>
<DT><CODE>user:library_directory(<VAR>?Directory</VAR>)</CODE>
<DD>
<EM>A hook predicate</EM>, telling how to expand <CODE>library(<VAR>File</VAR>)</CODE>
file names.

<DT><CODE>line_count(<VAR>+Stream</VAR>,<VAR>?N</VAR>)</CODE>
<DD>
<VAR>N</VAR> is the number of lines read/written on stream <VAR>Stream</VAR>.

<DT><CODE>line_position(<VAR>+Stream</VAR>,<VAR>?N</VAR>)</CODE>
<DD>
<VAR>N</VAR> is the number of characters read/written on the current line of <VAR>Stream</VAR>.

<DT><CODE>link_foreign_resource(<VAR>+Resource</VAR>,<VAR>+SourceFile</VAR>,<VAR>+Option</VAR>,<VAR>+CFiles</VAR>,<VAR>+ObjectFiles</VAR>,<VAR>+Libraries</VAR>)</CODE>
<DD>
Builds a linked foreign resource (not available in Runtime Systems).

<DT><CODE>listing</CODE>
<DD>
<DT><CODE>listing(<VAR>:Specs</VAR>)</CODE>
<DD>
Lists the interpreted predicate(s) specified by <VAR>Specs</VAR> or all
interpreted predicates in the type-in module.
Any variables in the listed clauses are internally bound to ground
terms before printing.  If this causes any blocked goals to
be executed, the behavior is undefined.

<DT><CODE>load(<VAR>:Files</VAR>)</CODE>
<DD>
Loads object file(s) <VAR>Files</VAR>.

<DT><CODE>load_files(<VAR>:Files</VAR>)</CODE>
<DD>
<DT><CODE>load_files(<VAR>:Files</VAR>, <VAR>+Options</VAR>)</CODE>
<DD>
Loads source or object file(s) <VAR>Files</VAR> obeying <VAR>Options</VAR>.

<DT><CODE>load_foreign_files(<VAR>:ObjectFiles</VAR>,<VAR>+Libraries</VAR>)</CODE>
<DD>
<EM>Hookable</EM>, links object files <VAR>ObjectFiles</VAR> into Prolog.
Obsolete, use <CODE>link_foreign_resource/6</CODE> and
<CODE>load_foreign_resource/1</CODE> instead.

<DT><CODE>load_foreign_resource(<VAR>:Resource</VAR>)</CODE>
<DD>
Loads foreign resource <VAR>Resource</VAR> into Prolog.

<DT><CODE>unload_foreign_resource(<VAR>:Resource</VAR>)</CODE>
<DD>
Unloads foreign resource <VAR>Resource</VAR> from Prolog.

<DT><CODE>meta_predicate <VAR>Specs</VAR></CODE>
<DD>
Not a built-in predicate; meta-predicate declaration.

<DT><CODE>method_expansion(<VAR>+Method1</VAR>,<VAR>?Object</VAR>,<VAR>?Method2</VAR>)</CODE>
<DD>
<DT><CODE>user:method_expansion(<VAR>+Method1</VAR>,<VAR>?Object</VAR>,<VAR>?Method2</VAR>)</CODE>
<DD>
<EM>A hook predicate</EM>, defines transformations on Prolog Object methods.

<DT><CODE>mode <VAR>Specs</VAR></CODE>
<DD>
Not a built-in predicate; mode declaration.

<DT><CODE>module(<VAR>+Module</VAR>)</CODE>
<DD>
Sets the type-in module to <VAR>Module</VAR>; see section <A HREF="sicstus_7.html#SEC65">Basic Concepts</A>.

<DT><CODE>module(<VAR>+Module</VAR>, <VAR>+ExportList</VAR>)</CODE>
<DD>
<DT><CODE>module(<VAR>+Module</VAR>, <VAR>+ExportList</VAR>, <VAR>+Options</VAR>)</CODE>
<DD>
Not a built-in predicate; module declaration.

<DT><CODE>multifile <VAR>Specs</VAR></CODE>
<DD>
Not a built-in predicate; multifile declaration.

<DT><CODE>muse_flag(<VAR>?FlagName</VAR>,<VAR>?Value</VAR>)</CODE>
<DD>
<VAR>Value</VAR> is the current value of the Muse flag <VAR>FlagName</VAR>.

<DT><CODE>muse_flag(<VAR>+FlagName</VAR>,<VAR>?OldValue</VAR>,<VAR>?NewValue</VAR>)</CODE>
<DD>
<VAR>OldValue</VAR> and <VAR>NewValue</VAR> are the old and new values of the Muse
flag <VAR>FlagName</VAR>.

<DT><CODE>muse_flags</CODE>
<DD>
Display all Muse flag settings.

<DT><CODE>muse_sync</CODE>
<DD>
Synchronize for being leftmost in Muse.

<DT><CODE>muse_trace(<VAR>:Goal</VAR>)</CODE>
<DD>
<DT><CODE>muse_trace(<VAR>:Goal</VAR>,<VAR>+FilePrefix</VAR>)</CODE>
<DD>
Generate a Muse trace file for <VAR>Goal</VAR>.

<DT><CODE>name(<VAR>+Const</VAR>,<VAR>?CharList</VAR>)</CODE>
<DD>
<DT><CODE>name(<VAR>?Const</VAR>,<VAR>+CharList</VAR>)</CODE>
<DD>
The name of atom or number <VAR>Const</VAR> is the string <VAR>CharList</VAR>.

<DT><CODE>nl</CODE>
<DD>
<DT><CODE>nl(<VAR>+Stream</VAR>)</CODE>
<DD>
Outputs a new line on stream <VAR>Stream</VAR> or on the current output stream.

<DT><CODE>nodebug</CODE>
<DD>
Switches off debugging
(not available in Runtime Systems).

<DT><CODE>nofileerrors</CODE>
<DD>
Disables reporting of file errors.

<DT><CODE>nogc</CODE>
<DD>
Disables garbage collection of the global stack.

<DT><CODE>nonvar(<VAR>?X</VAR>)</CODE>
<DD>
<VAR>X</VAR> is a non-variable.

<DT><CODE>nospy <VAR>:Spec</VAR></CODE>
<DD>
Removes spy-points from the predicate(s) specified by <VAR>Spec</VAR>
(not available in Runtime Systems).

<DT><CODE>nospyall</CODE>
<DD>
Removes all spy-points
(not available in Runtime Systems).

<DT><CODE>notrace</CODE>
<DD>
<DT><CODE>nozip</CODE>
<DD>
Switches off debugging
(not available in Runtime Systems).

<DT><CODE>number(<VAR>?X</VAR>)</CODE>
<DD>
<VAR>X</VAR> is currently instantiated to a number.

<DT><CODE>number_chars(<VAR>+Number</VAR>,<VAR>?CharList</VAR>)</CODE>
<DD>
<DT><CODE>number_chars(<VAR>?Number</VAR>,<VAR>+CharList</VAR>)</CODE>
<DD>
The name of the number <VAR>Number</VAR> is the list of characters <VAR>CharList</VAR>.

<DT><CODE>numbervars(<VAR>?Term</VAR>,<VAR>+N</VAR>,<VAR>?M</VAR>)</CODE>
<DD>
Number the variables in the term <VAR>Term</VAR> from <VAR>N</VAR> to <VAR>M</VAR>-1.

<DT><CODE>on_exception(<VAR>?Pattern</VAR>,<VAR>:ProtectedGoal</VAR>,<VAR>:Handler</VAR>)</CODE>
<DD>
Executes the procedure call <VAR>ProtectedGoal</VAR>.  If during the
execution <CODE>raise_exception(<VAR>Exception</VAR>)</CODE> is called, and
<VAR>Exception</VAR> matches <VAR>Pattern</VAR>, the execution of
<VAR>ProtectedGoal</VAR> abort, <VAR>Pattern</VAR> is unified with a copy of
<VAR>Exception</VAR> and <VAR>Handler</VAR> is called.

<DT><CODE>op(<VAR>+Precedence</VAR>,<VAR>+Type</VAR>,<VAR>+Name</VAR>)</CODE>
<DD>
Makes atom(s) <VAR>Name</VAR> an operator of type <VAR>Type</VAR> precedence
<VAR>Precedence</VAR>.

<DT><CODE>open(<VAR>+FileName</VAR>,<VAR>+Mode</VAR>,<VAR>-Stream</VAR>)</CODE>
<DD>
<DT><CODE>open(<VAR>+FileName</VAR>,<VAR>+Mode</VAR>,<VAR>-Stream</VAR>,<VAR>+Options</VAR>) <EM>[ISO]</EM></CODE>
<DD>
Opens file <VAR>FileName</VAR> in mode <VAR>Mode</VAR> with options <VAR>Options</VAR> as stream <VAR>Stream</VAR>.

<DT><CODE>open_null_stream(<VAR>-Stream</VAR>)</CODE>
<DD>
Opens an output stream to the null device.

<DT><CODE>otherwise</CODE>
<DD>
True.

<DT><CODE>parallel</CODE>
<DD>
<DT><CODE>parallel <VAR>Specs</VAR></CODE>
<DD>
Not a built-in predicate; parallel declaration.

<DT><CODE>peek_char(<VAR>?N</VAR>)</CODE>
<DD>
<DT><CODE>peek_char(<VAR>+Stream</VAR>,<VAR>?N</VAR>)</CODE>
<DD>
<VAR>N</VAR> is the character code of the next character peeked at from
<VAR>Stream</VAR> or from the current input stream.

<DT><CODE>phrase(<VAR>:Phrase</VAR>,<VAR>?List</VAR>)</CODE>
<DD>
<DT><CODE>phrase(<VAR>:Phrase</VAR>,<VAR>?List</VAR>,<VAR>?Remainder</VAR>)</CODE>
<DD>
<EM>Grammar rules.</EM> The list <VAR>List</VAR> can be parsed as a phrase of type
<VAR>Phrase</VAR>.  The rest of the list is <VAR>Remainder</VAR> or empty.

<DT><CODE>portray(<VAR>+Term</VAR>)</CODE>
<DD>
<DT><CODE>user:portray(<VAR>+Term</VAR>)</CODE>
<DD>
<EM>A hook predicate</EM>, tells <CODE>print/1</CODE> what to do.

<DT><CODE>portray_clause(<VAR>+Clause</VAR>)</CODE>
<DD>
<DT><CODE>portray_clause(<VAR>+Stream</VAR>,<VAR>+Clause</VAR>)</CODE>
<DD>
Pretty prints <VAR>Clause</VAR> on the stream <VAR>Stream</VAR> or on the current
output stream.

<DT><CODE>portray_message(<VAR>+Severity</VAR>,<VAR>+Message</VAR>)</CODE>
<DD>
<DT><CODE>user:portray_message(<VAR>+Severity</VAR>,<VAR>+Message</VAR>)</CODE>
<DD>
<EM>A hook predicate</EM>, tells <CODE>print_message/2</CODE> what to do.

<DT><CODE>predicate_property(<VAR>:Head</VAR>,<VAR>?Prop</VAR>)</CODE>
<DD>
<DT><CODE>predicate_property(<VAR>-Head</VAR>,<VAR>?Prop</VAR>)</CODE>
<DD>
<VAR>Head</VAR> is the most general goal of a currently defined predicate that
has the property <VAR>Prop</VAR>.

<DT><CODE>print(<VAR>?Term</VAR>)</CODE>
<DD>
<DT><CODE>print(<VAR>+Stream</VAR>,<VAR>?Term</VAR>)</CODE>
<DD>
<EM>Hookable</EM>, portrays or else writes the term <VAR>Term</VAR> on the
stream <VAR>Stream</VAR> or on the current output stream.

<DT><CODE>print_message(<VAR>+Severity</VAR>,<VAR>+Message</VAR>)</CODE>
<DD>
<EM>Hookable</EM>, portrays or else writes <VAR>Message</VAR> of a given
<VAR>Severity</VAR> on the standard error stream.

<DT><CODE>profile_data(<VAR>:Files</VAR>,<VAR>?Selection</VAR>,<VAR>?Resolution</VAR>,<VAR>-Data</VAR>)</CODE>
<DD>
<VAR>Data</VAR> is the profiling data collected from the instrumented
predicates defined in the file(s) <VAR>Files</VAR> with selection and
resolution <VAR>Selection</VAR> and <VAR>Resolution</VAR> respectively
(not available in Runtime Systems nor in Muse).

<DT><CODE>profile_reset(<VAR>:Files</VAR>)</CODE>
<DD>
The profiling counters for the instrumented predicates in the file(s)
<VAR>Files</VAR> are zeroed
(not available in Runtime Systems nor in Muse).

<DT><CODE>prolog_flag(<VAR>?FlagName</VAR>,<VAR>?Value</VAR>)</CODE>
<DD>
<VAR>Value</VAR> is the current value of <VAR>FlagName</VAR>.

<DT><CODE>prolog_flag(<VAR>+FlagName</VAR>,<VAR>?OldValue</VAR>,<VAR>?NewValue</VAR>)</CODE>
<DD>
<VAR>OldValue</VAR> and <VAR>NewValue</VAR> are the old and new values of <VAR>FlagName</VAR>.

<DT><CODE>prolog_load_context(<VAR>?Key</VAR>,<VAR>?Value</VAR>)</CODE>
<DD>
<VAR>Value</VAR> is the value of the compilation/loading context
variable identified by <VAR>Key</VAR>.

<DT><CODE>prompt(<VAR>?Old</VAR>,<VAR>?New</VAR>)</CODE>
<DD>
Changes the prompt from <VAR>Old</VAR> to <VAR>New</VAR>.

<DT><CODE>public <VAR>Specs</VAR></CODE>
<DD>
Not a built-in predicate; public declaration.

<DT><CODE>put(<VAR>+C</VAR>)</CODE>
<DD>
<DT><CODE>put(<VAR>+Stream</VAR>,<VAR>+C</VAR>)</CODE>
<DD>
The next character sent to the stream <VAR>Stream</VAR> or to the current
output stream is <VAR>C</VAR>.

<DT><CODE>raise_exception(<VAR>+Exception</VAR>)</CODE>
<DD>
Causes abortion of a part of the execution tree scoped by the closest
enclosing <CODE>on_exception/3</CODE> invocation with its first argument
matching <VAR>Exception</VAR>.

<DT><CODE>read(<VAR>?Term</VAR>)</CODE>
<DD>
<DT><CODE>read(<VAR>+Stream</VAR>,<VAR>?Term</VAR>)</CODE>
<DD>
Reads the term <VAR>Term</VAR> from the stream <VAR>Stream</VAR> or from the current
input stream.

<DT><CODE>read_term(<VAR>?Term</VAR>,<VAR>+Options</VAR>)</CODE>
<DD>
<DT><CODE>read_term(<VAR>+Stream</VAR>,<VAR>?Term</VAR>,<VAR>+Options</VAR>)</CODE>
<DD>
Reads the term <VAR>Term</VAR> from the stream <VAR>Stream</VAR> or from the current
input stream with extra <VAR>Options</VAR>.

<DT><CODE>reconsult(<VAR>:Files</VAR>)</CODE>
<DD>
Updates the program with interpreted clauses from file(s) <VAR>Files</VAR>.

<DT><CODE>recorda(<VAR>+Key</VAR>,<VAR>?Term</VAR>,<VAR>-Ref</VAR>)</CODE>
<DD>
Makes the term <VAR>Term</VAR> the first record under key <VAR>Key</VAR> with unique
identifier <VAR>Ref</VAR>.

<DT><CODE>recorded(<VAR>?Key</VAR>,<VAR>?Term</VAR>,<VAR>?Ref</VAR>)</CODE>
<DD>
The term <VAR>Term</VAR> is currently recorded under key <VAR>Key</VAR> with unique
identifier <VAR>Ref</VAR>.

<DT><CODE>recordz(<VAR>+Key</VAR>,<VAR>?Term</VAR>,<VAR>-Ref</VAR>)</CODE>
<DD>
Makes the term <VAR>Term</VAR> the last record under key <VAR>Key</VAR> with
unique identifier <VAR>Ref</VAR>.

<DT><CODE>reinitialise</CODE>
<DD>
Initializes Prolog 
(returns to C in recursive calls to Prolog from C).

<DT><CODE>repeat</CODE>
<DD>
Succeeds repeatedly.

<DT><CODE>require(<VAR>:PredSpecs</VAR>)</CODE>
<DD>
Tries to locate and load library files that export the specified
predicates. Creates index files if necessary
(not available in Runtime Systems).

<DT><CODE>restore(<VAR>+File</VAR>)</CODE>
<DD>
Restores the state saved in file <VAR>File</VAR>.

<DT><CODE>retract(<VAR>:Clause</VAR>)</CODE>
<DD>
Erases repeatedly the next interpreted clause of form <VAR>Clause</VAR>.

<DT><CODE>retractall(<VAR>:Head</VAR>)</CODE>
<DD>
Erases all clauses whose head matches <VAR>Head</VAR>.

<DT><CODE>save_program(<VAR>+File</VAR>)</CODE>
<DD>
<DT><CODE>save_program(<VAR>+File</VAR>, <VAR>:Goal</VAR>)</CODE>
<DD>
Saves the current state of the Prolog data base in file <VAR>File</VAR>.
Upon restore, <VAR>Goal</VAR> is executed.

<DT><CODE>see(<VAR>+File</VAR>)</CODE>
<DD>
Makes file <VAR>File</VAR> the current input stream.

<DT><CODE>seeing(<VAR>?File</VAR>)</CODE>
<DD>
The current input stream is named <VAR>File</VAR>.

<DT><CODE>seek(<VAR>+Stream</VAR>,<VAR>+Offset</VAR>,<VAR>+Method</VAR>,<VAR>-NewLocation</VAR>)</CODE>
<DD>
Sets the stream <VAR>Stream</VAR> to the byte offset <VAR>Offset</VAR> relative to
<VAR>Method</VAR>, and <VAR>NewLocation</VAR> is the new byte offset from the
beginning of the file after the operation.

<DT><CODE>seen</CODE>
<DD>
Closes the current input stream.

<DT><CODE>sequential</CODE>
<DD>
<DT><CODE>sequential <VAR>Specs</VAR></CODE>
<DD>
Not a built-in predicate; sequential declaration.

<DT><CODE>set_input(<VAR>+Stream</VAR>)</CODE>
<DD>
Sets the current input stream to <VAR>Stream</VAR>.

<DT><CODE>set_output(<VAR>+Stream</VAR>)</CODE>
<DD>
Sets the current output stream to <VAR>Stream</VAR>.

<DT><CODE>set_stream_position(<VAR>+Stream</VAR>,<VAR>+Position</VAR>)</CODE>
<DD>
<VAR>Position</VAR> is a term representing a new position of
<VAR>Stream</VAR>, which is then set to the new position.

<DT><CODE>setof(<VAR>?Template</VAR>,<VAR>:Goal</VAR>,<VAR>?Set</VAR>)</CODE>
<DD>
<VAR>Set</VAR> is the set of instances of <VAR>Template</VAR> such that <VAR>Goal</VAR>
is satisfied (not just provable).

<DT><CODE>simple(<VAR>?X</VAR>)</CODE>
<DD>
<VAR>X</VAR> is currently uninstantiated or atomic.

<DT><CODE>skip(<VAR>+C</VAR>)</CODE>
<DD>
<DT><CODE>skip(<VAR>+Stream</VAR>,<VAR>+C</VAR>)</CODE>
<DD>
Skips characters from <VAR>Stream</VAR> or from the current input stream until
after character <VAR>C</VAR>.

<DT><CODE>skip_line</CODE>
<DD>
<DT><CODE>skip_line(<VAR>+Stream</VAR>)</CODE>
<DD>
Skips characters from <VAR>Stream</VAR> or from the current input stream until
the next <KBD>LFD</KBD>.

<DT><CODE>sort(<VAR>+List1</VAR>,<VAR>?List2</VAR>)</CODE>
<DD>
The list <VAR>List1</VAR> sorted into order yields <VAR>List2</VAR>.

<DT><CODE>source_file(<VAR>?File</VAR>)</CODE>
<DD>
<DT><CODE>source_file(<VAR>:Pred</VAR>,<VAR>?File</VAR>)</CODE>
<DD>
<DT><CODE>source_file(<VAR>-Pred</VAR>,<VAR>?File</VAR>)</CODE>
<DD>
The predicate <VAR>Pred</VAR> is defined in the file <VAR>File</VAR>.

<DT><CODE>spy <VAR>:Spec</VAR></CODE>
<DD>
Sets spy-points on the predicate(s) specified by <VAR>Spec</VAR>
(not available in Runtime Systems).

<DT><CODE>spypoint_condition(<VAR>:Goal</VAR>,<VAR>?Port</VAR>,<VAR>+Test</VAR>)</CODE>
<DD>
Sets conditional spy-point on the predicate for <VAR>Goal</VAR>
(not available in Runtime Systems).

<DT><CODE>statistics</CODE>
<DD>
Outputs various execution statistics.

<DT><CODE>statistics(<VAR>?Key</VAR>,<VAR>?Value</VAR>)</CODE>
<DD>
The execution statistics key <VAR>Key</VAR> has value <VAR>Value</VAR>.

<DT><CODE>stream_code(<VAR>+Stream</VAR>,<VAR>?StreamCode</VAR>)</CODE>
<DD>
<DT><CODE>stream_code(<VAR>?Stream</VAR>,<VAR>+StreamCode</VAR>)</CODE>
<DD>
<VAR>StreamCode</VAR> is an integer representing a pointer to the
internal representation of <VAR>Stream</VAR>.

<DT><CODE>stream_interrupt(<VAR>?Stream</VAR>,<VAR>?OldHandler</VAR>,<VAR>?NewHandler</VAR>)</CODE>
<DD>
Sets/reads the interrupt handler connected to the stream <VAR>Stream</VAR>
(not available in Muse).

<DT><CODE>stream_position(<VAR>+Stream</VAR>,<VAR>?Position</VAR>)</CODE>
<DD>
<VAR>Position</VAR> is a term representing the current position of
<VAR>Stream</VAR>.

<DT><CODE>stream_select(<VAR>+Streams</VAR>,<VAR>+TimeOut</VAR>,<VAR>-ReadStreams</VAR>)</CODE>
<DD>
Returns a list <VAR>ReadStreams</VAR> containing streams with pending
characters.  Only the streams in the list <VAR>Streams</VAR> are
checked. <VAR>TimeOut</VAR> specifies a timeout on the form <CODE>off</CODE> or
<CODE>Sec:MicroSec</CODE> (not available in Muse).

<DT><CODE>tab(<VAR>+N</VAR>)</CODE>
<DD>
<DT><CODE>tab(<VAR>+Stream</VAR>,<VAR>+N</VAR>)</CODE>
<DD>
Outputs <VAR>N</VAR> spaces to the stream <VAR>Stream</VAR> or to the current
output stream.

<DT><CODE>tell(<VAR>+File</VAR>)</CODE>
<DD>
Makes file <VAR>File</VAR> the current output stream.

<DT><CODE>telling(<VAR>?File</VAR>)</CODE>
<DD>
The current output stream is named <VAR>File</VAR>.

<DT><CODE>term_expansion(<VAR>+Term1</VAR>,<VAR>?TermOrTerms</VAR>)</CODE>
<DD>
<DT><CODE>term_expansion(<VAR>+Term1</VAR>,<VAR>+Layout1</VAR>,<VAR>?TermOrTerms</VAR>,<VAR>?Layout2</VAR>)</CODE>
<DD>
<DT><CODE>user:term_expansion(<VAR>+Term1</VAR>,<VAR>?TermOrTerms</VAR>)</CODE>
<DD>
<DT><CODE>user:term_expansion(<VAR>+Term1</VAR>,<VAR>+Layout1</VAR>,<VAR>?TermOrTerms</VAR>,<VAR>?Layout2</VAR>)</CODE>
<DD>
<EM>A hook predicate</EM>, tells <CODE>expand_term/2</CODE> what to do.

<DT><CODE>told</CODE>
<DD>
Closes the current output stream.

<DT><CODE>trace</CODE>
<DD>
Switches on debugging in <EM>creep</EM> mode
(not available in Runtime Systems).

<DT><CODE>true</CODE>
<DD>
Succeeds.

<DT><CODE>ttyflush</CODE>
<DD>
Flushes the standard output stream buffer.

<DT><CODE>ttyget(<VAR>?C</VAR>)</CODE>
<DD>
The next printing character input from the standard input stream is <VAR>C</VAR>.

<DT><CODE>ttyget0(<VAR>?C</VAR>)</CODE>
<DD>
The next character input from the standard input stream is <VAR>C</VAR>.

<DT><CODE>ttynl</CODE>
<DD>
Outputs a new line on the standard output stream.

<DT><CODE>ttyput(<VAR>+C</VAR>)</CODE>
<DD>
The next character output to the standard output stream is <VAR>C</VAR>.

<DT><CODE>ttyskip(<VAR>+C</VAR>)</CODE>
<DD>
Skips characters from the standard input stream until after character
<VAR>C</VAR>.

<DT><CODE>ttytab(<VAR>+N</VAR>)</CODE>
<DD>
Outputs <VAR>N</VAR> spaces to the standard output stream.

<DT><CODE>unknown(<VAR>?OldState</VAR>,<VAR>?NewState</VAR>)</CODE>
<DD>
Changes action on undefined predicates from <VAR>OldState</VAR> to <VAR>NewState</VAR>
(not available in Runtime Systems).

<DT><CODE>unknown_predicate_handler(<VAR>+Goal</VAR>,<VAR>+Module</VAR>,<VAR>-NewGoal</VAR>)</CODE>
<DD>
<DT><CODE>user:unknown_predicate_handler(<VAR>+Goal</VAR>,<VAR>+Module</VAR>,<VAR>-NewGoal</VAR>)</CODE>
<DD>
<EM>A hook predicate.</EM> Defines an alternative goal to be called in
place of a call to an unknown predicate.

<DT><CODE>update_mutable(<VAR>+Datum</VAR>,<VAR>+Mutable</VAR>)</CODE>
<DD>
Updates the current value of the mutable term <VAR>Mutable</VAR> to become
<VAR>Datum</VAR>.

<DT><CODE>use_module(<VAR>:Files</VAR>)</CODE>
<DD>
Loads the module file(s) <VAR>Files</VAR> if necessary and import all public
predicates.  

<DT><CODE>use_module(<VAR>:File</VAR>,<VAR>+Imports</VAR>)</CODE>
<DD>
Loads the module file <VAR>File</VAR> if necessary and imports the predicates
in <VAR>Imports</VAR>.

<DT><CODE>use_module(<VAR>+Module</VAR>,<VAR>?File</VAR>,<VAR>+Imports</VAR>)</CODE>
<DD>
<DT><CODE>use_module(<VAR>?Module</VAR>,<VAR>:File</VAR>,<VAR>+Imports</VAR>)</CODE>
<DD>
Equivalent to
<CODE>use_module/2</CODE> plus unifies <VAR>Module</VAR> to the module defined by
the file.

<DT><CODE>user_help</CODE>
<DD>
<DT><CODE>user:user_help</CODE>
<DD>
<EM>A hook predicate</EM>, tells <CODE>help/0</CODE> what to do.

<DT><CODE>var(<VAR>?X</VAR>)</CODE>
<DD>
<VAR>X</VAR> is currently uninstantiated.

<DT><CODE>version</CODE>
<DD>
Displays introductory and/or system identification messages (not
available in Runtime Systems).

<DT><CODE>version(<VAR>+Message</VAR>)</CODE>
<DD>
Adds the atom <VAR>Message</VAR> to the list of introductory messages (not
available in Runtime Systems).

<DT><CODE>volatile <VAR>Specs</VAR></CODE>
<DD>
Not a built-in predicate; volatile declaration.

<DT><CODE>when(<VAR>+Condition</VAR>,<VAR>:Goal</VAR>)</CODE>
<DD>
Blocks <VAR>Goal</VAR> until the <VAR>Condition</VAR> is true.

<DT><CODE>write(<VAR>+Term</VAR>)</CODE>
<DD>
<DT><CODE>write(<VAR>+Stream</VAR>,<VAR>+Term</VAR>)</CODE>
<DD>
Writes the term <VAR>Term</VAR> on the stream <VAR>Stream</VAR> or on the current
output stream.

<DT><CODE>write_canonical(<VAR>+Term</VAR>)</CODE>
<DD>
<DT><CODE>write_canonical(<VAR>+Stream</VAR>,<VAR>+Term</VAR>)</CODE>
<DD>
Writes <VAR>Term</VAR> on the stream <VAR>Stream</VAR> or on the current output
stream so that it may be read back.

<DT><CODE>write_term(<VAR>+Term</VAR>,<VAR>+Options</VAR>)</CODE>
<DD>
<DT><CODE>write_term(<VAR>+Stream</VAR>,<VAR>+Term</VAR>,<VAR>+Options</VAR>)</CODE>
<DD>
Writes the term <VAR>Term</VAR> on the stream <VAR>Stream</VAR> or on the current
output stream with extra <VAR>Options</VAR>.

<DT><CODE>writeq(<VAR>+Term</VAR>)</CODE>
<DD>
<DT><CODE>writeq(<VAR>+Stream</VAR>,<VAR>+Term</VAR>)</CODE>
<DD>
Writes the term <VAR>Term</VAR> on the stream <VAR>Stream</VAR> or on the current
output stream, quoting names where necessary.

<DT><CODE>zip</CODE>
<DD>
Switches on debugging in <EM>zip</EM> mode
(not available in Runtime Systems).

</DL>

<P><HR><P>
Go to the <A HREF="sicstus_1.html">first</A>, <A HREF="sicstus_43.html">previous</A>, <A HREF="sicstus_45.html">next</A>, <A HREF="sicstus_50.html">last</A> section, <A HREF="sicstus_toc.html">table of contents</A>.
</BODY>
</HTML>
