<HTML>
<HEAD>
<!-- This HTML file has been created by texi2html 1.52
     from sicstus.tex on 6 October 1998 -->

<TITLE>SICStus Prolog - The Prolog Language</TITLE>
</HEAD>
<BODY>
Go to the <A HREF="sicstus_1.html">first</A>, <A HREF="sicstus_4.html">previous</A>, <A HREF="sicstus_6.html">next</A>, <A HREF="sicstus_50.html">last</A> section, <A HREF="sicstus_toc.html">table of contents</A>.
<P><HR><P>


<H1><A NAME="SEC36" HREF="sicstus_toc.html#TOC36">The Prolog Language</A></H1>

<P>
<A NAME="IDX103"></A>
<A NAME="IDX104"></A>
This chapter provides a brief introduction to the syntax and semantics of
a certain subset of logic (<EM>definite clauses</EM>, also known as <EM>Horn
clauses</EM>), and indicates how this subset forms the basis of Prolog.

</P>

<UL>
<LI><A HREF="sicstus_5.html#SEC37">Syntax</A>
<LI><A HREF="sicstus_5.html#SEC45">Declarative</A>
<LI><A HREF="sicstus_5.html#SEC46">Procedural</A>
<LI><A HREF="sicstus_5.html#SEC47">Occur</A>
<LI><A HREF="sicstus_5.html#SEC48">Cut</A>
<LI><A HREF="sicstus_5.html#SEC49">Operators</A>
<LI><A HREF="sicstus_5.html#SEC50">Restrictions</A>
<LI><A HREF="sicstus_5.html#SEC51">Comments</A>
</UL>



<H2><A NAME="SEC37" HREF="sicstus_toc.html#TOC37">Syntax, Terminology and Informal Semantics</A></H2>


<UL>
<LI><A HREF="sicstus_5.html#SEC38">Terms</A>
<LI><A HREF="sicstus_5.html#SEC44">Programs</A>
</UL>



<H3><A NAME="SEC38" HREF="sicstus_toc.html#TOC38">Terms</A></H3>
<P>
<A NAME="IDX105"></A>
<A NAME="IDX106"></A>
<A NAME="IDX107"></A>
<A NAME="IDX108"></A>

</P>
<P>
The data objects of the language are called <EM>terms</EM>.  A term is either
a <EM>constant</EM>, a <EM>variable</EM> or a <EM>compound term</EM>.

</P>

<UL>
<LI><A HREF="sicstus_5.html#SEC39">Integers</A>
<LI><A HREF="sicstus_5.html#SEC40">Floats</A>
<LI><A HREF="sicstus_5.html#SEC41">Atoms</A>
<LI><A HREF="sicstus_5.html#SEC42">Variables</A>
<LI><A HREF="sicstus_5.html#SEC43">Compound Terms</A>
</UL>



<H4><A NAME="SEC39" HREF="sicstus_toc.html#TOC39">Integers</A></H4>
<P>
<A NAME="IDX109"></A>
The constants include <EM>integers</EM> such as

</P>

<PRE>
0   1   999   -512
</PRE>

<P>
Besides the usual decimal, or base 10, notation, integers may also be
written in any base from 2 to 36, of which base 2 (binary), 8 (octal),
and 16 (hex) are probably the most useful.  Letters <KBD>A</KBD> through !
<KBD>Z</KBD> (upper or lower case) are used for bases greater than 10.  E.g.

</P>

<PRE>
15   2'1111   8'17
</PRE>

<P>
all represent the integer fifteen.

</P>
<P>
There is also a special notation for character constants.  E.g.

</P>

<PRE>
0'A   0'\x41   0'\101
</PRE>

<P>
are all equivalent to <CODE>65</CODE> (the character code for <KBD>A</KBD>).
<SAMP>`0''</SAMP> followed by any character except <KBD>\</KBD> (backslash) is thus
read as an integer.  If <SAMP>`0''</SAMP> is followed by <KBD>\</KBD>, the <KBD>\</KBD>
denotes the start of an <EM>escape sequence</EM> with special meaning
(see section <A HREF="sicstus_45.html#SEC372">Escape Sequences</A>).

</P>


<H4><A NAME="SEC40" HREF="sicstus_toc.html#TOC40">Floats</A></H4>
<P>
<A NAME="IDX110"></A>
Constants also include <EM>floats</EM> such as

</P>

<PRE>
1.0   -3.141   4.5E7   -0.12e+8   12.0e-9
</PRE>

<P>
Note that there must be a decimal point in floats written with an exponent,
and that there must be at least one digit before and after the decimal point.

</P>


<H4><A NAME="SEC41" HREF="sicstus_toc.html#TOC41">Atoms</A></H4>
<P>
<A NAME="IDX111"></A>
Constants also include <EM>atoms</EM> such as

</P>

<PRE>
a   void   =   :=   'Algol-68'   []
</PRE>

<P>
Constants are definite elementary objects, and correspond to proper nouns
in natural language.  For reference purposes, here is a list of the
possible forms which an atom may take:

</P>

<OL>

<LI>

Any  sequence  of  alphanumeric characters (including <KBD>_</KBD>), starting
with a lower case letter.  
<LI>

Any sequence from the following set of characters:<BR>
<KBD>+</KBD><KBD>-</KBD><KBD>*</KBD><KBD>/</KBD><KBD>\</KBD><KBD>^</KBD><KBD>&#60;</KBD><KBD>&#62;</KBD><KBD>=</KBD><KBD>`</KBD><KBD>~</KBD><KBD>:</KBD><KBD>.</KBD><KBD>?</KBD><KBD>@</KBD><KBD>#</KBD><KBD>$</KBD><KBD>&#38;</KBD><BR>
This set can in fact be larger; see section <A HREF="sicstus_45.html#SEC371">Syntax of Tokens as Character Strings</A> for a precise
definition.

<LI>

Any sequence of characters delimited by single quotes.  If the single
quote character is included in the sequence it must be written twice,
e.g. <CODE>'can"t'</CODE>.  Backslashes in the sequence denote escape sequences
(see section <A HREF="sicstus_45.html#SEC372">Escape Sequences</A>).

<LI>

Any of: <KBD>!</KBD> <KBD>;</KBD> <KBD>[]</KBD> <KBD>{}</KBD><BR>
Note that the bracket pairs are special: <KBD>[]</KBD> and <KBD>{}</KBD> are
atoms but <KBD>[</KBD>, <KBD>]</KBD>, <KBD>{</KBD>, and <KBD>}</KBD> are not.  However,
when they are used as functors (see below) the form <CODE>{<VAR>X</VAR>}</CODE>
is allowed as an alternative to <CODE>{}(<VAR>X</VAR>)</CODE>.  The form
<CODE>[<VAR>X</VAR>]</CODE> is the normal notation for lists, as an alternative to
<CODE>.(X,[])</CODE>.  </OL>



<H4><A NAME="SEC42" HREF="sicstus_toc.html#TOC42">Variables</A></H4>
<P>
<A NAME="IDX112"></A>
Variables may be written as any sequence of alphanumeric characters
(including <KBD>_</KBD>) starting with either a capital letter or <KBD>_</KBD>; e.g.

</P>

<PRE>
X   Value   A   A1   _3   _RESULT
</PRE>

<P>
<A NAME="IDX113"></A>
If a variable is only referred to once in a clause, it does not need to be
named and may be written as an <EM>anonymous</EM> variable, indicated by the
underline character <KBD>_</KBD>.  A clause may contain several anonymous 
variables; they are all read and treated as distinct variables.

</P>
<P>
A variable should be thought of as standing for some definite but
unidentified object.  This is analogous to the use of a pronoun in natural
language.  Note that a variable is not simply a writable storage location
as in most programming languages; rather it is a local name for some data
object, cf.  the variable of pure LISP and identity declarations in
Algol68.

</P>


<H4><A NAME="SEC43" HREF="sicstus_toc.html#TOC43">Compound Terms</A></H4>
<P>
<A NAME="IDX114"></A>
<A NAME="IDX115"></A>
<A NAME="IDX116"></A>
<A NAME="IDX117"></A>
The structured data objects of the language are the compound terms.  A
compound term comprises a <EM>functor</EM> (called the principal functor of
the term) and a sequence of one or more terms called <EM>arguments</EM>.  A
functor is characterized by its name, which is an atom, and its <EM>arity</EM>
or number of arguments.  For example the compound term whose functor is
named <CODE>point</CODE> of arity 3, with arguments <CODE>X</CODE>, <CODE>Y</CODE> and
<CODE>Z</CODE>, is written 
</P>

<PRE>
point(X, Y, Z)
</PRE>

<P>
Note that an atom is considered to be a functor of arity 0.

</P>
<P>
Functors are generally analogous to common nouns in natural language.  One
may think of a functor as a record type and the arguments of a compound
term as the fields of a record.  Compound terms are usefully pictured as
trees.  For example, the term

</P>

<PRE>
s(np(john),vp(v(likes),np(mary)))
</PRE>

<P>
would be pictured as the structure

</P>

<PRE>
       s
     /   \
  np       vp
  |       /  \
john     v     np
         |     |
       likes  mary
</PRE>

<P>
Sometimes it is convenient to write certain functors as operators--2-ary
functors may be declared as infix operators and 1-ary functors as prefix or
postfix operators.  Thus it is possible to write, e.g.

</P>

<PRE>
X+Y     (P;Q)     X&#60;Y      +X     P;
</PRE>

<P>
as optional alternatives to 

</P>

<PRE>
+(X,Y)   ;(P,Q)   &#60;(X,Y)   +(X)   ;(P)
</PRE>

<P>
The use of operators is described fully below (see section <A HREF="sicstus_5.html#SEC49">Operators</A>).

</P>
<P>
<A NAME="IDX118"></A>
Lists form an important class of data structures in Prolog.  They are
essentially the same as the lists of LISP: a list either is the atom
<CODE>[]</CODE> representing the empty list, or is a compound term with
functor <CODE>.</CODE> and two arguments which are respectively the head and
tail of the list.  Thus a list of the first three natural numbers is the
structure 
</P>

<PRE>
  .
 / \
1    .
    / \
   2    .
       / \
      3   []
</PRE>

<P>
which could be written, using the standard syntax, as 

</P>

<PRE>
.(1,.(2,.(3,[])))
</PRE>

<P>
but which is normally written, in a special list notation, as 

</P>

<PRE>
[1,2,3]
</PRE>

<P>
The special list notation in the case when the tail of a list is a variable
is exemplified by

</P>

<PRE>
[X|L]     [a,b|L]
</PRE>

<P>
representing

</P>

<PRE>
   .               .
  / \             / \
X     L         a     .
                     / \
                   b     L
</PRE>

<P>
respectively.

</P>
<P>
Note that this notation does not add any new power to the language; it
simply makes it more readable.  e.g. the above examples could equally be
written

</P>

<PRE>
.(X,L)    .(a,.(b,L))
</PRE>

<P>
<A NAME="IDX119"></A>
For convenience, a further notational variant is allowed for lists of
integers which correspond to character codes.  Lists written in this
notation are called <EM>strings</EM>.  E.g.

</P>

<PRE>
"SICStus"
</PRE>

<P>
which represents exactly the same list as 

</P>

<PRE>
[83,73,67,83,116,117,115]
</PRE>

<P>
As for quoted atoms, if a double quote character is included in the
sequence it must be written twice, e.g. <CODE>'can"t'</CODE>.  Backslashes
in the sequence denote escape sequences (see section <A HREF="sicstus_45.html#SEC372">Escape Sequences</A>).

</P>



<H3><A NAME="SEC44" HREF="sicstus_toc.html#TOC44">Programs</A></H3>
<P>
<A NAME="IDX120"></A>
<A NAME="IDX121"></A>

</P>
<P>
A fundamental unit of a logic program is the <EM>goal</EM> or procedure call.
e.g. 
</P>

<PRE>
gives(tom, apple, teacher)   reverse([1,2,3], L)   X&#60;Y
</PRE>

<P>
<A NAME="IDX122"></A>
A goal is merely a special kind of term, distinguished only by the
context in which it appears in the program.  The (principal) functor of
a goal identifies what <EM>predicate</EM> the goal is for.  It corresponds
roughly to a verb in natural language, or to a procedure name in a
conventional programming language.  
</P>
<P>
<A NAME="IDX123"></A>
<A NAME="IDX124"></A>
<A NAME="IDX125"></A>
<A NAME="IDX126"></A>
A logic program consists simply of a sequence of statements called
<EM>sentences</EM>, which are analogous to sentences of natural language.
A sentence comprises a <EM>head</EM> and a <EM>body</EM>.  The head either
consists of a single goal or is empty.  The body consists of a sequence
of zero or more goals (i.e. it too may be empty).  If the head is not
empty, the sentence is called a <EM>clause</EM>.  
</P>
<P>
<A NAME="IDX127"></A>
If the body of a clause is empty, the clause is called a <EM>unit
clause</EM>, and is written in the form

</P>

<PRE>
<VAR>P</VAR>.
</PRE>

<P>
where <VAR>P</VAR> is the head goal.  We interpret this declaratively as

</P>

<BLOCKQUOTE>
<P>
Goals matching <VAR>P</VAR> are true.
</BLOCKQUOTE>

<P>
and procedurally as 

</P>

<BLOCKQUOTE>
<P>
Goals matching <VAR>P</VAR> are satisfied.
</BLOCKQUOTE>

<P>
<A NAME="IDX128"></A>
<A NAME="IDX129"></A>
If the body of a clause is non-empty, the clause is called a
<EM>non-unit clause</EM>, and is written in the form

</P>

<PRE>
<VAR>P</VAR> :- <VAR>Q</VAR>, <VAR>R</VAR>, <VAR>S</VAR>.
</PRE>

<P>
where <VAR>P</VAR> is the head goal and <VAR>Q</VAR>, <VAR>R</VAR> and <VAR>S</VAR> are the
goals which make up the body.  We can read such a clause either
declaratively as 
</P>

<BLOCKQUOTE>
<P>
<VAR>P</VAR> is true if <VAR>Q</VAR> and <VAR>R</VAR> and <VAR>S</VAR> are true.
</BLOCKQUOTE>

<P>
or procedurally as

</P>

<BLOCKQUOTE>
<P>
To satisfy goal <VAR>P</VAR>, satisfy goals <VAR>Q</VAR>, <VAR>R</VAR> and <VAR>S</VAR>.
</BLOCKQUOTE>

<P>
A sentence with an empty head is called a <EM>directive</EM>
(see section <A HREF="sicstus_4.html#SEC16">Directives:  Queries and Commands</A>), of which the most important kind is called a
<EM>query</EM> and is written in the form 
</P>

<PRE>
?- <VAR>P</VAR>, <VAR>Q</VAR>.
</PRE>

<P>
where <VAR>P</VAR> and <VAR>Q</VAR> are the goals of the body.  Such a query is
read declaratively as

</P>

<BLOCKQUOTE>
<P>
Are <VAR>P</VAR> and <VAR>Q</VAR> true?
</BLOCKQUOTE>

<P>
and procedurally as

</P>

<BLOCKQUOTE>
<P>
Satisfy goals <VAR>P</VAR> and <VAR>Q</VAR>.
</BLOCKQUOTE>

<P>
Sentences generally contain variables.  Note that variables in different
sentences are completely independent, even if they have the same
name--i.e. the <EM>lexical scope</EM> of a variable is limited to a
single sentence.  Each distinct variable in a sentence should be
interpreted as standing for an arbitrary entity, or value.  To
illustrate this, here are some examples of sentences containing
variables, with possible declarative and procedural readings:

</P>

<OL>
<LI>

<CODE>employed(<VAR>X</VAR>) :- employs(<VAR>Y</VAR>,<VAR>X</VAR>).</CODE>

"Any <VAR>X</VAR> is employed if any <VAR>Y</VAR> employs <VAR>X</VAR>."

"To find whether a person <VAR>X</VAR> is employed,
find whether any <VAR>Y</VAR> employs <VAR>X</VAR>." <LI>

<CODE>derivative(<VAR>X</VAR>,<VAR>X</VAR>,1).</CODE>

"For any <VAR>X</VAR>, the derivative of <VAR>X</VAR> with respect to <VAR>X</VAR>
is 1." 
"The goal of finding a derivative for the expression <VAR>X</VAR> with
respect to <VAR>X</VAR> itself is satisfied by the result 1." <LI>

<CODE>?- ungulate(<VAR>X</VAR>), aquatic(<VAR>X</VAR>).</CODE>

"Is it true, for any <VAR>X</VAR>, that <VAR>X</VAR> is an ungulate and <VAR>X</VAR> is
aquatic?" 
"Find an <VAR>X</VAR> which is both an ungulate and aquatic."
</OL>

<P>
<A NAME="IDX130"></A>
In any program, the <EM>predicate</EM> for a particular (principal) functor
is the sequence of clauses in the program whose head goals have that
principal functor.  For example, the predicate for a 3-ary functor
<CODE>concatenate/3</CODE> might well consist of the two clauses 
</P>

<PRE>
concatenate([], L, L).
concatenate([X|L1], L2, [X|L3]) :- concatenate(L1, L2, L3).
</PRE>

<P>
where <CODE>concatenate(<VAR>L1</VAR>,<VAR>L2</VAR>,<VAR>L3</VAR>)</CODE> means "the list
<VAR>L1</VAR> concatenated with the list <VAR>L2</VAR> is the list <VAR>L3</VAR>".
Note that for predicates with clauses corresponding to a base case and a
recursive case, the preferred style is to write the base case clause
first.

</P>
<P>
In Prolog, several predicates may have the same name but different
arities.  Therefore, when it is important to specify a predicate
unambiguously, the form <CODE><VAR>name</VAR>/<VAR>arity</VAR></CODE> is used; e.g.
<CODE>concatenate/3</CODE>.

</P>
<P>
<A NAME="IDX131"></A>
Certain predicates are predefined by built-in predicates supplied by the
Prolog system.  Such predicates are called <EM>built-in predicates</EM>.

</P>
<P>
As we have seen, the goals in the body of a sentence are linked by the
operator <SAMP>`,'</SAMP> which can be interpreted as conjunction ("and").  It
is sometimes convenient to use an additional operator <SAMP>`;'</SAMP>, standing
for disjunction ("or").  (The precedence of <SAMP>`;'</SAMP> is such that it
dominates <SAMP>`,'</SAMP> but is dominated by <SAMP>`:-'</SAMP>.)  An example is the
clause 
</P>

<PRE>
grandfather(X, Z) :-
        (mother(X, Y); father(X, Y)),
        father(Y, Z).
</PRE>

<P>
which can be read as 

</P>

<BLOCKQUOTE>
<P>
For any <VAR>X</VAR>, <VAR>Y</VAR> and <VAR>Z</VAR>, <VAR>X</VAR> has <VAR>Z</VAR> as a
grandfather if either the mother of <VAR>X</VAR> is <VAR>Y</VAR> or the father of
<VAR>X</VAR> is <VAR>Y</VAR>, and the father of <VAR>Y</VAR> is <VAR>Z</VAR>.
</BLOCKQUOTE>

<P>
Such uses of disjunction can always be eliminated by defining an extra
predicate--for instance the previous example is equivalent to

</P>

<PRE>
grandfather(X,Z) :- parent(X,Y), father(Y,Z).

parent(X,Y) :- mother(X,Y).
parent(X,Y) :- father(X,Y).
</PRE>

<P>
---and so disjunction will not be mentioned further in the following,
more formal, description of the semantics of clauses.

</P>
<P>
The token <SAMP>`|'</SAMP>, when used outside a list, is an alias for <SAMP>`;'</SAMP>.
The aliasing is performed when terms are read in, so that

</P>

<PRE>
a :- b | c.
</PRE>

<P>
is read as if it were 

</P>

<PRE>
a :- b ; c.
</PRE>

<P>
Note the double use of the <SAMP>`.'</SAMP> character.  On the one hand it is
used as a sentence terminator, while on the other it may be used in a
string of symbols which make up an atom (e.g. the list functor
<CODE>./2</CODE>).  The rule used to disambiguate terms is that a <SAMP>`.'</SAMP>
followed by <VAR>layout-text</VAR> is regarded as a sentence terminator
(see section <A HREF="sicstus_45.html#SEC371">Syntax of Tokens as Character Strings</A>).

</P>


<H2><A NAME="SEC45" HREF="sicstus_toc.html#TOC45">Declarative Semantics</A></H2>
<P>
<A NAME="IDX132"></A>
<A NAME="IDX133"></A>

</P>
<P>
The semantics of definite clauses should be fairly clear from the
informal interpretations already given.  However it is useful to have a
precise definition.  The <EM>declarative semantics</EM> of definite clauses
tells us which goals can be considered true according to a given
program, and is defined recursively as follows.

</P>

<BLOCKQUOTE>
<P>
A goal is true if it is the head of some clause instance and each of the
goals (if any) in the body of that clause instance is true, where an
instance of a clause (or term) is obtained by substituting, for each of
zero or more of its variables, a new term for all occurrences of the
variable.
</BLOCKQUOTE>

<P>
For example, if a program contains the preceding procedure for
<CODE>concatenate/3</CODE>, then the declarative semantics tells us that

</P>

<PRE>
?- concatenate([a], [b], [a,b]).
</PRE>

<P>
is true, because this goal is the head of a certain instance of the
first clause for <CODE>concatenate/3</CODE>, namely,

</P>

<PRE>
concatenate([a], [b], [a,b]) :- concatenate([], [b], [b]).
</PRE>

<P>
and we know that the only goal in the body of this clause instance is
true, since it is an instance of the unit clause which is the second
clause for <CODE>concatenate/3</CODE>.

</P>


<H2><A NAME="SEC46" HREF="sicstus_toc.html#TOC46">Procedural Semantics</A></H2>
<P>
<A NAME="IDX134"></A>
<A NAME="IDX135"></A>

</P>
<P>
Note that the declarative semantics makes no reference to the sequencing
of goals within the body of a clause, nor to the sequencing of clauses
within a program.  This sequencing information is, however, very
relevant for the <EM>procedural semantics</EM> which Prolog gives to
definite clauses.  The procedural semantics defines exactly how the
Prolog system will execute a goal, and the sequencing information is the
means by which the Prolog programmer directs the system to execute the
program in a sensible way.  The effect of executing a goal is to
enumerate, one by one, its true instances.  Here then is an informal
definition of the procedural semantics.  We first illustrate the
semantics by the simple query

</P>

<PRE>
?- concatenate(<VAR>X</VAR>, <VAR>Y</VAR>, [a,b]).
</PRE>

<P>
We find that it matches the head of the first clause for
<CODE>concatenate/3</CODE>, with <VAR>X</VAR> instantiated to <CODE>[a|<VAR>X1</VAR>]</CODE>.
The new variable <VAR>X1</VAR> is constrained by the new query produced,
which contains a single recursive procedure call: 
</P>

<PRE>
?- concatenate(<VAR>X1</VAR>, <VAR>Y</VAR>, [b]).
</PRE>

<P>
Again this goal matches the first clause, instantiating <VAR>X1</VAR> to
<CODE>[b|<VAR>X2</VAR>]</CODE>, and yielding the new query:

</P>

<PRE>
?- concatenate(<VAR>X2</VAR>, <VAR>Y</VAR>, [])
</PRE>

<P>
Now the single goal will only match the second clause, instantiating
both <VAR>X2</VAR> and <VAR>Y</VAR> to <CODE>[]</CODE>.  Since there are no further
goals to be executed, we have a solution 
</P>

<PRE>
X = [a,b]
Y = []
</PRE>

<P>
i.e. a true instance of the original goal is 

</P>

<PRE>
concatenate([a,b], [], [a,b])
</PRE>

<P>
If this solution is rejected, backtracking will generate the further
solutions

</P>

<PRE>
X = [a]
Y = [b]

X = []
Y = [a,b]
</PRE>

<P>
in that order, by re-matching, against the second clause for concatenate,
goals already solved once using the first clause.

</P>
<P>
Thus, in the procedural semantics, the set of clauses

</P>

<PRE>
<VAR>H</VAR> :- <VAR>B1</VAR>, ..., <VAR>Bm</VAR>.
<VAR>H'</VAR> :- <VAR>B1'</VAR>, ..., <VAR>Bm'</VAR>.
...
</PRE>

<P>
<A NAME="IDX136"></A>
are regarded as a <EM>procedure definition</EM> for some predicate <VAR>H</VAR>,
and in a query

</P>

<PRE>
?- <VAR>G1</VAR>, ..., <VAR>Gn</VAR>.
</PRE>

<P>
<A NAME="IDX137"></A>
<A NAME="IDX138"></A>
<A NAME="IDX139"></A>
<A NAME="IDX140"></A>
<A NAME="IDX141"></A>
<A NAME="IDX142"></A>
each <VAR>Gi</VAR> is regarded as a <EM>procedure call</EM>.  To execute a
query, the system selects by its <EM>computation rule</EM> a goal, <VAR>Gj</VAR>
say, and searches by its <EM>search rule</EM> a clause whose head matches
<VAR>Gj</VAR>.  Matching is done by the <EM>unification</EM> algorithm (see
[Robinson 65] which computes the most general unifier, <EM>mgu</EM>, of
<VAR>Gj</VAR> and <VAR>H</VAR>.  The <VAR>mgu</VAR> is unique if it exists.  If a match
is found, the current query is <EM>reduced</EM> to a new query 
</P>

<PRE>
?- (<VAR>G1</VAR>, ..., <VAR>Gj-1</VAR>, <VAR>B1</VAR>, ..., <VAR>Bm</VAR>, <VAR>Gj+1</VAR>, ..., <VAR>Gn</VAR>)<VAR>mgu</VAR>.
</PRE>

<P>
and a new cycle is started.  The execution terminates when the empty
query has been produced.

</P>
<P>
<A NAME="IDX143"></A>
If there is no matching head for a goal, the execution <EM>backtracks</EM>
to the most recent successful match in an attempt to find an alternative
match.  If such a match is found, an alternative new query is produced,
and a new cycle is started.

</P>
<P>
In SICStus Prolog, as in other Prolog systems, the search rule is
simple: "search forward from the beginning of the program".  

</P>
<P>
The computation rule in traditional Prolog systems is also simple: "pick
the leftmost goal of the current query".  However, SICStus Prolog and
other modern implementations have a somewhat more complex computation
rule "pick the leftmost <EM>unblocked</EM> goal of the current query".

</P>
<P>
A goal can be blocked on one ore more uninstantiated variables, and a
variable may block several goals.  Thus binding a variable can cause
blocked goals to become unblocked, and backtracking can cause currently
unblocked goals to become blocked again.  Moreover, if the current query
is

</P>

<PRE>
?- <VAR>G1</VAR>, ..., <VAR>Gj-1</VAR>, <VAR>Gj</VAR>, <VAR>Gj+1</VAR>, ..., <VAR>Gn</VAR>.
</PRE>

<P>
where <VAR>Gj</VAR> is the first unblocked goal, and matching <VAR>Gj</VAR>
against a clause head causes several blocked goals in <VAR>G1</VAR>, ...,
<VAR>Gj-1</VAR> to become unblocked, then these goals may become reordered.
The internal order of any two goals that were blocked on the <EM>same</EM>
variable is retained, however.  
</P>
<P>
<A NAME="IDX144"></A>
Another consequence is that a query may be derived consisting entirely
of blocked goals.  Such a query is said to have <EM>floundered</EM>.  The
top-level checks for this condition.  If detected, the outstanding
blocked subgoals are printed on the standard error stream along with the
answer substitution, to notify the user that the answer (s)he has got is
really a speculative one, since it is only valid if the blocked goals
can be satisfied.

</P>

<P>
A goal is blocked if certain arguments are uninstantiated and its
predicate definition is annotated with a matching <EM>block
declaration</EM> (see section <A HREF="sicstus_8.html#SEC77">Block Declarations</A>).  Goals of certain built-in
may also be blocked if their arguments are not sufficiently
instantiated.

</P>
<P>
When this mechanism is used, the control structure resembles that of
coroutines, suspending and resuming different threads of control.  When
a computation has left blocked goals behind, the situation is
analogous to spawning a new suspended thread.  When a blocked goal
becomes unblocked, the situation is analogous to temporarily
suspending the current thread and resuming the thread to which the
blocked goal belongs.

</P>



<H2><A NAME="SEC47" HREF="sicstus_toc.html#TOC47">Occurs-Check</A></H2>

<P>
<A NAME="IDX145"></A>
<A NAME="IDX146"></A>
<A NAME="IDX147"></A>
It is possible, and sometimes useful, to write programs which unify a
variable to a term in which that variable occurs, thus creating a cyclic
term.  The usual mathematical theory behind Logic Programming forbids
the creation of cyclic terms, dictating that an <EM>occurs-check</EM> should
be done each time a variable is unified with a term.  Unfortunately, an
occurs-check would be so expensive as to render Prolog impractical as a
programming language.  Thus cyclic terms may be created and may cause
loops trying to print them.  

</P>
<P>
SICStus Prolog mitigates the problem by its ability to unify, compare
(see section <A HREF="sicstus_10.html#SEC102">Comparison of Terms</A>), assert, and copy cyclic terms without looping.
The <CODE>write_term/2</CODE> built-in predicate can optionally handle cyclic
terms; see section <A HREF="sicstus_10.html#SEC96">Input and Output of Terms</A>.  Unification with occurs-check and predicates
testing (a)cyclicity are available in a library package; 
see section <A HREF="sicstus_20.html#SEC194">Term Utilities</A>.  Other predicates usually do not handle
cyclic terms well.

</P>


<H2><A NAME="SEC48" HREF="sicstus_toc.html#TOC48">The Cut Symbol</A></H2>
<P>
<A NAME="IDX148"></A>

</P>
<P>
<A NAME="IDX149"></A>
Besides the sequencing of goals and clauses, Prolog provides one other
very important facility for specifying control information.  This is the
<EM>cut</EM> symbol, written <CODE>!</CODE>.  It is inserted in the program just
like a goal, but is not to be regarded as part of the logic of the
program and should be ignored as far as the declarative semantics is
concerned.

</P>
<P>
The effect of the cut symbol is as follows.  When first encountered as a
goal, cut succeeds immediately.  If backtracking should later return to
the cut, the effect is to fail the <EM>parent goal</EM>, i.e. that goal
which matched the head of the clause containing the cut, and caused the
clause to be activated.  In other words, the cut operation
<EM>commits</EM> the system to all choices made since the parent goal was
invoked, and causes other alternatives to be discarded.  The goals thus
rendered <EM>determinate</EM> are the parent goal itself, any goals
occurring before the cut in the clause containing the cut, and any
subgoals which were executed during the execution of those preceding
goals.

</P>
<P>
For example:

</P>

<PRE>
member(X, [X|_]).
member(X, [_|L]) :- member(X, L).
</PRE>

<P>
This predicate can be used to test whether a given term is in a list.  E.g.

</P>

<PRE>
| ?- member(b, [a,b,c]).
</PRE>

<P>
returns the answer <SAMP>`yes'</SAMP>.  The predicate can also be used to extract
elements from a list, as in

</P>

<PRE>
| ?- member(X, [d,e,f]).
</PRE>

<P>
With backtracking this will successively return each element of the list.
Now suppose that the first clause had been written instead:

</P>

<PRE>
member(X, [X|_]) :- !.
</PRE>

<P>
In this case, the above call would extract only the first element of the
list (<CODE>d</CODE>).  On backtracking, the cut would immediately fail the whole
predicate.

</P>

<PRE>
x :- p, !, q.
x :- r.
</PRE>

<P>
This is equivalent to 

</P>

<PRE>
x := if p then q else r;
</PRE>

<P>
in an Algol-like language.

</P>
<P>
It should be noticed that a cut discards all the alternatives since the
parent goal, even when the cut appears within a disjunction.  This means
that the normal method for eliminating a disjunction by defining an extra
predicate cannot be applied to a disjunction containing a cut.

</P>
<P>
<A NAME="IDX150"></A>
<A NAME="IDX151"></A>
<A NAME="IDX152"></A>
<A NAME="IDX153"></A>
A proper use of the cut is usually a major difficulty for new Prolog
programmers.  The usual mistakes are to over-use cut, and to let cuts
destroy the logic.  A cut that doesn't destroy the logic is called a
<EM>green cut</EM>; a cut that does is called a <EM>red cut</EM>.  We would
like to advise all users to follow these general rules.  Also
see section <A HREF="sicstus_13.html#SEC173">Programming Tips and Examples</A>.

</P>

<UL>
<LI>

Write each clause as a self-contained logic rule which just defines the
truth of goals which match its head.  Then add cuts to remove any
fruitless alternative computation paths that may tie up memory.
<LI>

Cuts are usually placed right after the head, sometimes preceded by simple
tests.
<LI>

Cuts are hardly ever needed in the last clause of a predicate.
</UL>



<H2><A NAME="SEC49" HREF="sicstus_toc.html#TOC49">Operators</A></H2>
<P>
<A NAME="IDX154"></A>
<A NAME="IDX155"></A>

</P>
<P>
Operators in Prolog are simply a <EM>notational convenience</EM>.  For
example, the expression <CODE>2+1</CODE> could also be written <CODE>+(2,1)</CODE>.
This expression represents the data structure

</P>

<PRE>
   +
 /   \
2     1
</PRE>

<P>
and <EM>not</EM> the number 3.  The addition would only be performed if
the structure were passed as an argument to an appropriate predicate
such as <CODE>is/2</CODE> (see section <A HREF="sicstus_10.html#SEC101">Arithmetic</A>).  
</P>
<P>
The Prolog syntax caters for operators of three main
kinds---<EM>infix</EM>, <EM>prefix</EM> and <EM>postfix</EM>.  An infix operator
appears between its two arguments, while a prefix operator precedes its
single argument and a postfix operator is written after its single
argument.  
</P>
<P>
Each operator has a precedence, which is a number from 1 to 1200.  The
precedence is used to disambiguate expressions where the structure of
the term denoted is not made explicit through the use of parentheses.
The general rule is that it is the operator with the <EM>highest</EM>
precedence that is the principal functor.  Thus if <SAMP>`+'</SAMP> has a higher
precedence than <SAMP>`/'</SAMP>, then 
</P>

<PRE>
a+b/c     a+(b/c)
</PRE>

<P>
are equivalent and denote the term <CODE>+(a,/(b,c))</CODE>.  Note that the
infix form of the term <CODE>/(+(a,b),c)</CODE> must be written with explicit
parentheses, i.e. 
</P>

<PRE>
(a+b)/c
</PRE>

<P>
If there are two operators in the subexpression having the same highest
precedence, the ambiguity must be resolved from the types of the
operators.  The possible types for an infix operator are

</P>

<PRE>
xfx     xfy     yfx
</PRE>

<P>
Operators of type <CODE>xfx</CODE> are not associative: it is a requirement
that both of the two subexpressions which are the arguments of the
operator must be of <EM>lower</EM> precedence than the operator itself,
i.e. their principal functors must be of lower precedence, unless the
subexpression is explicitly parenthesized (which gives it zero
precedence).

</P>
<P>
Operators of type <CODE>xfy</CODE> are right-associative: only the first
(left-hand) subexpression must be of lower precedence; the right-hand
subexpression can be of the <EM>same</EM> precedence as the main operator.
Left-associative operators (type <CODE>yfx</CODE>) are the other way around.

</P>
<P>
A functor named name is declared as an operator of type <VAR>Type</VAR> and
precedence precedence by the command

</P>

<PRE>
:- op(precedence, type, name).
</PRE>

<P>
The argument name can also be a list of names of operators of the same
type and precedence.

</P>
<P>
It is possible to have more than one operator of the same name, so long
as they are of different kinds, i.e. infix, prefix or postfix.  An
operator of any kind may be redefined by a new declaration of the same
kind.  This applies equally to operators which are provided as standard.
Declarations of all the standard operators can be found elsewhere
(see section <A HREF="sicstus_46.html#SEC374">Standard Operators</A>).  
</P>
<P>
For example, the standard operators <CODE>+</CODE> and <CODE>-</CODE> are declared by

</P>

<PRE>
:- op(500, yfx, [ +, - ]).
</PRE>

<P>
so that 

</P>

<PRE>
a-b+c
</PRE>

<P>
is valid syntax, and means 

</P>

<PRE>
(a-b)+c
</PRE>

<P>
i.e. 

</P>

<PRE>
     +
   /   \
  -     c
 / \
a   b
</PRE>

<P>
The list functor <KBD>.</KBD> is not a standard operator, but if we declare it
thus:

</P>

<PRE>
:- op(900, xfy, .).
</PRE>

<P>
then <CODE>a.b.c</CODE> would represent the structure 

</P>

<PRE>
  .
 / \
a   .
   / \
  b   c
</PRE>

<P>
Contrasting this with the diagram above for <CODE>a-b+c</CODE> shows the
difference between <CODE>yfx</CODE> operators where the tree grows to the
left, and <CODE>xfy</CODE> operators where it grows to the right.  The tree
cannot grow at all for <CODE>xfx</CODE> operators; it is simply illegal to
combine <CODE>xfx</CODE> operators having equal precedences in this way.

</P>
<P>
The possible types for a prefix operator are 

</P>

<PRE>
fx      fy
</PRE>

<P>
and for a postfix operator they are 

</P>

<PRE>
xf      yf
</PRE>

<P>
The meaning of the types should be clear by analogy with those for infix
operators.  As an example, if <CODE>not</CODE> were declared as a prefix
operator of type <CODE>fy</CODE>, then

</P>

<PRE>
not not P
</PRE>

<P>
would be a permissible way to write <CODE>not(not(P))</CODE>.  If the type
were <CODE>fx</CODE>, the preceding expression would not be legal, although

</P>

<PRE>
not P
</PRE>

<P>
would still be a permissible form for <CODE>not(P)</CODE>.

</P>
<P>
If these precedence and associativity rules seem rather complex,
remember that you can always use parentheses when in any doubt.

</P>
<P>
Note that the arguments of a compound term written in standard syntax
must be expressions of precedence <EM>below</EM> 1000.  Thus it is
necessary to parenthesize the expression <CODE>P :- Q</CODE> in

</P>

<PRE>
| ?- assert((P :- Q)).
</PRE>



<H2><A NAME="SEC50" HREF="sicstus_toc.html#TOC50">Syntax Restrictions</A></H2>

<P>
Note carefully the following syntax restrictions, which serve to remove
potential ambiguity associated with prefix operators.

</P>

<OL>
<LI>

In a term written in standard syntax, the principal functor and its
following <KBD>(</KBD> must <EM>not</EM> be separated by any intervening
<VAR>layout-text</VAR>.  Thus 

<PRE>
point (X,Y,Z)
</PRE>

is invalid syntax.

<LI>

If the argument of a prefix operator starts with a <KBD>(</KBD>, this <KBD>(</KBD>
must be separated from the operator by at least one <VAR>layout-char</VAR>.
Thus 

<PRE>
:-(p;q),r.
</PRE>

(where <SAMP>`:-'</SAMP> is the prefix operator) is invalid syntax.  The system
would try to interpret it as the structure: 

<PRE>
    ,
   / \
 :-    r
  |
  ;
 / \
p   q
</PRE>

That is, it would take <SAMP>`:-'</SAMP> to be a functor of arity 1.  However,
since the arguments of a functor are required to be expressions of
precedence below 1000, this interpretation would fail as soon as the
<SAMP>`;'</SAMP> (precedence 1100) was encountered.  
In contrast, the term:


<PRE>
:- (p;q),r.
</PRE>

is valid syntax and represents the following structure.  


<PRE>
   :-
    |
    ,
   / \
  ;   r
 / \
p   q
</PRE>

</OL>



<H2><A NAME="SEC51" HREF="sicstus_toc.html#TOC51">Comments</A></H2>

<P>
Comments have no effect on the execution of a program, but they are very
useful for making programs more readily comprehensible.  Two forms of
comment are allowed in Prolog:

</P>

<OL>
<LI>

The character <KBD>%</KBD> followed by any sequence of characters up to end of
line.
<LI>

The symbol <KBD>/*</KBD> followed by any sequence of characters (including
new lines) up to <KBD>*/</KBD>.  </OL>

<P><HR><P>
Go to the <A HREF="sicstus_1.html">first</A>, <A HREF="sicstus_4.html">previous</A>, <A HREF="sicstus_6.html">next</A>, <A HREF="sicstus_50.html">last</A> section, <A HREF="sicstus_toc.html">table of contents</A>.
</BODY>
</HTML>
