<HTML><HEAD><TITLE>SWI-Prolog Reference Manual: Section 1.10</TITLE><LINK REL=home HREF="Title.html">
<LINK REL=contents HREF="Contents.html">
<LINK REL=index HREF="Index.html">
<LINK REL=summary HREF="sec-B.html">
<LINK REL=previous HREF="sec-1.9.html">
<LINK REL=next HREF="sec-1.11.html">
</HEAD>

<BODY>

<HR><CENTER><A HREF="Title.html">Home</A>
<A HREF="Contents.html">Contents</A>
<A HREF="Index.html">Index</A>
<A HREF="sec-B.html">Summary</A>
<A HREF="sec-1.9.html">Previous</A>
<A HREF="sec-1.11.html">Next</A>
</CENTER>

<HR>

<H2><A NAME="sec:1.10">1.10 Version 2.0 Release Notes</A></H2>

<P><A NAME="idx:Win32s:12"></A>Version 2.0 is first of all a freeze of 
all the features added to the various 1.9.x releases. Version 2.0.6 for 
PC has moved from the WATCOM C 32-bit windows extender to Windows&nbsp;NT 
and runs under Windows 3.1 using the Win32s NT emulator.

<P>New features offered:

<P><UL>
<LI><I>32-bit Virtual Machine</I><BR>
Removes various limits and improves performance.
<LI><I>Inline foreign functions</I><BR>
`Simple' foreign predicates no longer build a Prolog stack-frame, but 
are directly called from the VM. Notably provides a speedup for the test 
predicates such as <A NAME="idx:var/1:13"></A><A HREF="sec-3.4.html#var/1">var/1</A>, 
etc.
<LI><I>Various compatibility improvements</I><BR>
<LI><I>Stream based I/O library</I><BR>
All SWI-Prolog's I/O is now handled by the stream-package defined in the 
foreign include file <CODE>SWI-Stream.h</CODE>. Physical I/O of Prolog 
streams may be redefined through the foreign language interface, 
facilitating much simpler integration in window environments.
</UL>

<P>Version 2.0.6 offers a few incompatibilities:

<P><UL>
<LI><I><A NAME="idx:retractall/1:14"></A><A HREF="sec-3.12.html#retractall/1">retractall/1</A></I><BR>
In previous releases, the definition of <A NAME="idx:retractall/1:15"></A><A HREF="sec-3.12.html#retractall/1">retractall/1</A> 
was:

<XMP>
retractall(Term) :-
        retract(Term),
        fail.
retractall(_).
</XMP>

<P>As from version 2.0.6, <A NAME="idx:retractall/1:16"></A><A HREF="sec-3.12.html#retractall/1">retractall/1</A> 
is implemented as a deterministic foreign predicate compatible with 
Quintus Prolog. It behaves as:

<XMP>
retractall(Head) :-
        retract(Head),
        fail.
retractall(Head) :-
        retract((Head :- _)),
        fail.
retractall(_).
</XMP>

<P>I.e. the definition behaves the same when handling predicates 
consisting of facts. Clauses with a non-true body will be retracted if 
their head matches.
<LI><I>Foreign interface types</I><BR>
All foreign interface types now have names ending in <CODE>_t</CODE> to 
lessen the chance for conflicts. <CODE>term</CODE>, <CODE>atomic</CODE>, <CODE>functor</CODE> 
and
<CODE>module</CODE> have <CODE>#define</CODE>'s for backward 
compatibility.
<LI><I><A HREF="sec-5.6.html#PL_register_foreign()">PL_register_foreign()</A></I><BR>
The attributes is now a bitwise or of the attribute flags rather than a 
0 terminated list. This has no consequences for predicates that have no 
attributes (99% of them), while predicates with just one attribute will 
generate a compiler warning, but work properly otherwise. Predicates 
with more than one attributes must be changed.
<LI><I><CODE>PL_dispatch_events</CODE></I><BR>
This pointer is replaced by <A HREF="sec-5.6.html#PL_dispatch_hook()">PL_dispatch_hook()</A>. 
A function was necessary for the Win32 <CODE>.DLL</CODE> interface.
</UL>

