<HTML><HEAD><TITLE>SWI-Prolog Reference Manual: Section 1.3</TITLE><LINK REL=home HREF="Title.html">
<LINK REL=contents HREF="Contents.html">
<LINK REL=index HREF="Index.html">
<LINK REL=summary HREF="sec-B.html">
<LINK REL=previous HREF="sec-1.2.html">
<LINK REL=next HREF="sec-1.4.html">
</HEAD>

<BODY>

<HR><CENTER><A HREF="Title.html">Home</A>
<A HREF="Contents.html">Contents</A>
<A HREF="Index.html">Index</A>
<A HREF="sec-B.html">Summary</A>
<A HREF="sec-1.2.html">Previous</A>
<A HREF="sec-1.4.html">Next</A>
</CENTER>

<HR>

<H2><A NAME="sec:1.3">1.3 Should you be Using SWI-Prolog?</A></H2>

<P>There are a number of reasons why you better choose a commercial 
Prolog system, or another academic product:

<P><UL>
<LI><I>SWI-Prolog is not supported</I><BR>
Although I usually fix bugs shortly after a bug report arrives, I cannot 
promise anything. Now that the sources are provided, you can always dig 
into them yourself.
<LI><I>Memory requirements and performance are your first concerns</I><BR>
A number of commercial compilers are more keen on memory and performance 
than SWI-Prolog. I do not wish to sacrifice some of the nice features of 
the system, nor its portability to compete on raw performance.
<LI><I>You need features not offered by SWI-Prolog</I><BR>
In this case you may wish to give me suggestions for extensions. If you 
have great plans, please contact me (you might have to implement them 
yourself however).
</UL>

<P>On the other hand, SWI-Prolog offers some nice facilities:

<P><UL>
<LI><I>Nice environment</I><BR>
This includes `Do What I Mean', automatic completion of atom names, 
history mechanism and a tracer that operates on single key-strokes. 
Interfaces to standard Unix editors are provided, as well as a facility 
to maintain programs (see <A NAME="idx:make/0:1"></A><A HREF="sec-3.2.html#make/0">make/0</A>).
<LI><I>Very fast compiler</I><BR>
Even very large applications can be loaded in seconds on most machines. 
If this is not enough, there is a Quick Load Format that is slightly 
more compact and loading is almst always I/O bound.
<LI><I>Transparent compiled code</I><BR>
SWI-Prolog compiled code can be treated just as interpreted code: you 
can list it, trace it, assert to or retract from it, etc. This implies 
you do not have to decide beforehand whether a module should be loaded 
for debugging or not. Also, performance is much better than the 
performance of most interpreters.
<LI><I>Profiling</I><BR>
SWI-Prolog offers tools for performance analysis, which can be very 
useful to optimise programs. Unless you are very familiar with Prolog 
and Prolog performance considerations this might be more helpful than a 
better compiler without these facilities.
<LI><I>Flexibility</I><BR>
SWI-Prolog allows for easy and flexible integration with C, both Prolog 
calling C functions as C calling Prolog predicates. SWI-Prolog is 
provided in source form, which implies SWI-Prolog can be linked in with 
another package. Command line options and predicates to obtain 
information from the system and feedback into the system are provided.
<LI><I>Integration with XPCE</I><BR>
SWI-Prolog offers a tight integration to the Object Oriented Package for 
User Interface Development, called XPCE <CITE><A HREF="sec-C.html#P1098:C1.6">Anjewierden &amp; 
Wielemaker, 1989</A></CITE>. XPCE allows you to implement graphical user 
interfaces that are source-code compatible over Unix/X11 and Win32 
(Windows 95 and NT).
</UL>

