<HTML><HEAD><TITLE>SWI-Prolog Reference Manual: Section 1.4</TITLE><LINK REL=home HREF="Title.html">
<LINK REL=contents HREF="Contents.html">
<LINK REL=index HREF="Index.html">
<LINK REL=summary HREF="sec-B.html">
<LINK REL=previous HREF="sec-1.3.html">
<LINK REL=next HREF="sec-1.5.html">
</HEAD>

<BODY>

<HR><CENTER><A HREF="Title.html">Home</A>
<A HREF="Contents.html">Contents</A>
<A HREF="Index.html">Index</A>
<A HREF="sec-B.html">Summary</A>
<A HREF="sec-1.3.html">Previous</A>
<A HREF="sec-1.5.html">Next</A>
</CENTER>

<HR>

<H2><A NAME="sec:1.4">1.4 The XPCE GUI system for Prolog</A></H2>

<P><A NAME="idx:GUI:2"></A><A NAME="idx:XPCE:3"></A><A NAME="idx:Graphics:4"></A><A NAME="idx:Window interface:5"></A><A NAME="idx:X11:6"></A>The 
XPCE GUI system for dynamically typed languages has been with SWI-Prolog 
for a long time. It is developed by Anjo Anjewierden and Jan Wielemaker 
from the department of SWI, University of Amsterdam. It aims at a 
high-productive development environment for graphical applications based 
on Prolog.

<P>Object oriented technology has proven to be a suitable model for 
implementing GUIs, which typically deal with things Prolog is not very 
good at: event-driven control and global state. With XPCE, we designed a 
system that has similar characteristics that make Prolog such a powerful 
tool: dynamic typing, meta-programming and dynamic modification of the 
running system.

<P>XPCE is an object-system written in the C-language. It provides for 
the implementation of methods in multiple languages. New XPCE classes 
may be defined from Prolog using a simple, natural syntax. The body of 
the method is executed by Prolog itself, providing a natural interface 
between the two systems. Below is a very simple class definition.

<P>

<XMP>
:- pce_begin_class(prolog_lister, frame,
                   "List Prolog predicates").

initialise(Self) :->
        "As the C++ constructor"::
        send(Self, send_super, initialise, 'Prolog Lister'),
        send(Self, append, new(D, dialog)),
        send(D, append,
             text_item(predicate, message(Self, list, @arg1))),
        send(new(view), below, D).

list(Self, From:name) :->
        "List predicates from specification"::
        (   term_to_atom(Term, From)
        ->  get(Self, member, view, V),
            pce_open(V, write, Fd),
            set_output(Fd),
            listing(Term),
            close(Fd)
        ;   send(Self, report, error, 'Syntax error')
        ).

:- pce_end_class.

test :- send(new(prolog_lister), open).
</XMP>

<P>The 165 built-in classes deal with the meta-environment, 
data-representation and---of course---graphics. The graphics classes 
concentrate on direct-manipulation of diagrammatic representations.

<P><B>Availability.</B> XPCE runs on most Unix&reg; platforms, Windows&nbsp;95 
and Windows&nbsp;NT. It has been connected to SWI-Prolog, SICStus&reg; 
and Quintus&reg; Prolog as well as some Lisp dialects and C++. The 
Quintus version is commercially distributed and supported as 
ProWindows-3&reg;.

<P><B>Info.</B> further information is available from
<A HREF="http://www.swi.psy.uva.nl/projects/xpce/home.html">http://www.swi.psy.uva.nl/projects/xpce/home.html</A> 
or by E-mail to
<A HREF="mailto:xpce-request@swi.psy.uva.nl"">xpce-request@swi.psy.uva.nl</A>. 
There is a demo version for Windows&nbsp;95 and NT in <A HREF="ftp://swi.psy.uva.nl/pub/xpce/Windows/bin/">ftp://swi.psy.uva.nl/pub/xpce/Windows/bin/</A>, 
and one for the i386/Linux system in
<A HREF="ftp://swi.psy.uva.nl/pub/xpce/linux">ftp://swi.psy.uva.nl/pub/xpce/linux</A>. 
For information on ProWindows-3, please see <A HREF="http://www.aiil.co.uk">http://www.aiil.co.uk</A>, 
or contact
<A HREF="mailto:sales@aiil.co.uk"">sales@aiil.co.uk</A>.

