<HTML><HEAD><TITLE>SWI-Prolog Reference Manual: Section 2.1</TITLE><LINK REL=home HREF="Title.html">
<LINK REL=contents HREF="Contents.html">
<LINK REL=index HREF="Index.html">
<LINK REL=summary HREF="sec-B.html">
<LINK REL=previous HREF="sec-2.html">
<LINK REL=next HREF="sec-2.2.html">
</HEAD>

<BODY>

<HR><CENTER><A HREF="Title.html">Home</A>
<A HREF="Contents.html">Contents</A>
<A HREF="Index.html">Index</A>
<A HREF="sec-B.html">Summary</A>
<A HREF="sec-2.html">Previous</A>
<A HREF="sec-2.2.html">Next</A>
</CENTER>

<HR>

<H2><A NAME="sec:2.1">2.1 Starting SWI-Prolog from the Unix Shell</A></H2>

<P>It is advised to install SWI-Prolog as `pl' in the local binary 
directory. SWI-Prolog can then be started from the Unix shell by typing 
`<CODE>pl</CODE>'. The system will boot from the system's default boot 
file, perform the necessary initialisations and then enter the 
interactive top level.

<P>After the necessary system initialisation the system consults (see
<A NAME="idx:consult/1:41"></A><A HREF="sec-3.2.html#consult/1">consult/1</A>) 
the user's initialisation file. This initialisation file should be named 
`<CODE>.plrc</CODE>' and reside either in the current directory or in 
the user's home directory. If both exist the initialisation file from 
the current directory is loaded. The name of the initialisation file can 
be changed with the `<STRONG>-f</STRONG> <VAR>file</VAR>' option. After 
loading the initialisation file SWI-Prolog executes a user 
initialisation goal. The default goal is a system predicate that prints 
the banner message. The default can be modified with the `<STRONG>-g</STRONG> <VAR>goal</VAR>' 
option. Next the toplevel goal is started. Default is the interactive 
Prolog loop (see <A NAME="idx:prolog/0:42"></A><A HREF="sec-3.36.html#prolog/0">prolog/0</A>). 
The user can overwrite this default with the `<STRONG>-t</STRONG> <VAR>toplevel</VAR>' 
option.

<P>

<H3><A NAME="sec:2.1.1">2.1.1 Command Line Options</A></H3>

<P>The full set of command line options is given below:

<P>

<DL>

<P>
<DT><STRONG>-help</STRONG> <VAR></VAR><DD>
When given as the only option, it summarises the most important options.

<P>

<P>
<DT><STRONG>-v</STRONG> <VAR></VAR><DD>
When given as the only option, it summarises the version and the 
architecture identifier.

<P>

<P>
<DT><STRONG>-arch</STRONG> <VAR></VAR><DD>
When given as the only option, it prints the architecture identifier 
(see feature(arch, Arch)) and exits.

<P>

<P>
<DT><STRONG>-L</STRONG><VAR>size[km]</VAR><DD>
Give local stack limit (2 Mbytes default). Note that there is no space 
between the size option and its argument. By default, the argument is 
interpreted in Kbytes. Postfixing the argument with <CODE>m</CODE> 
causes the argument to be interpreted in Mbytes. The following example 
specifies 32 Mbytes local stack.

<XMP>
% pl -L32m
</XMP>

<P>A maximum is useful to stop buggy programs from claiming all memory 
resources. <STRONG>-L0</STRONG> sets the limit to the highest possible 
value.

<P>

<P>
<DT><STRONG>-G</STRONG><VAR>size[km]</VAR><DD>
Give global stack limit (4 Mbytes default). See <STRONG>-L</STRONG> for 
more details.

<P>

<P>
<DT><STRONG>-T</STRONG><VAR>size[km]</VAR><DD>
Give trail stack limit (4 Mbytes default). This limit is relatively high 
because trail-stack overflows are not often caused program bugs. See
<STRONG>-L</STRONG> for more details.

<P>

<P>
<DT><STRONG>-A</STRONG><VAR>size[km]</VAR><DD>
Give argument stack limit (1 Mbytes default). The argument stack limits 
the maximum nesting of terms that can be compiled and executed. The 
SWI-Prolog does `last-argument optimisation' to avoid many deeply nested 
structure using this stack. Enlarging this limit is only necessary in 
extreme cases. See <STRONG>-L</STRONG> for more details.

<P>

<P>
<DT><STRONG>-H</STRONG><VAR>size[km]</VAR><DD>
Give <B>malloc()</B> heap limit. The default is to raise the limit as 
high as possible. This option only applies to machines using the
<B>mmap()</B> function for allocating the Prolog stacks. See
<STRONG>-L</STRONG> for more details.

<P>

<P>
<DT><STRONG>-c</STRONG> <VAR>file ...</VAR><DD>
Compile files into an `intermediate code file'. See <A HREF="sec-2.7.html">section 
2.7</A>.

<P>

<P>
<DT><STRONG>-o</STRONG> <VAR>output</VAR><DD>
Used in combination with <STRONG>-c</STRONG> or <STRONG>-b</STRONG> to 
determine output file for compilation.

<P>

<P>
<DT><STRONG>-O</STRONG> <VAR></VAR><DD>
Optimised compilation. See <A NAME="idx:please/3:43"></A><A HREF="sec-2.8.html#please/3">please/3</A>.

<P>

<P>
<DT><STRONG>-f</STRONG> <VAR>file</VAR><DD>
Use <VAR>file</VAR> as initialisation file instead of `<CODE>.plrc</CODE>'. 
`<STRONG>-f</STRONG> <VAR>none</VAR>' stops SWI-Prolog from searching 
for an initialisation file.

<P>

<P>
<DT><STRONG>-F</STRONG> <VAR>script</VAR><DD>
Selects a startup-script from the SWI-Prolog home directory. The 
script-file is named <CODE>&lt;<VAR>script</VAR>&gt;.rc</CODE>. The 
default
<VAR>script</VAR> name is deduced from the executable, taking the 
leading alphanumerical characters (letters, digits and underscore) from 
the program-name. <STRONG>-F</STRONG> <VAR>none</VAR> stops looking for 
a script. Intended for simple management of slightly different versions. 
One could for example write a script <CODE>iso.rc</CODE> and then select 
ISO compatibility mode using <CODE>pl -F iso</CODE> or make a link from <B>iso-pl</B> 
to
<B>pl</B>.

<P>

<P>
<DT><STRONG>-g</STRONG> <VAR>goal</VAR><DD>
<VAR>Goal</VAR> is executed just before entering the top level. Default 
is a predicate which prints the welcome message. The welcome message can 
thus be suppressed by giving <STRONG>-g</STRONG> <VAR>true</VAR>. <VAR>goal</VAR> 
can be a complex term. In this case quotes are normally needed to 
protect it from being expanded by the Unix shell.

<P>

<P>
<DT><STRONG>-t</STRONG> <VAR>goal</VAR><DD>
Use <VAR>goal</VAR> as interactive toplevel instead of the default goal
<A NAME="idx:prolog/0:44"></A><A HREF="sec-3.36.html#prolog/0">prolog/0</A>. <VAR>goal</VAR> 
can be a complex term. If the toplevel goal succeeds SWI-Prolog exits 
with status 0. If it fails the exit status is 1. This flag also 
determines the goal started by <A NAME="idx:break/0:45"></A><A HREF="sec-3.36.html#break/0">break/0</A> 
and <A NAME="idx:abort/0:46"></A><A HREF="sec-3.36.html#abort/0">abort/0</A>. 
If you want to stop the user from entering interactive mode start the 
application with `<STRONG>-g</STRONG> <VAR>goal</VAR>' and give `halt' 
as toplevel.

<P>

<P>
<DT><STRONG>-tty</STRONG> <VAR></VAR><DD>
Switches tty control (using ioctl(2)) on (<STRONG>+tty</STRONG>) or off 
(<STRONG>-tty</STRONG>). Normally tty control is switched on. This 
default depends on the installation. You may wish to switch tty control 
off if Prolog is used from an editor such as Emacs. If switched off
<A NAME="idx:get_single_char/1:47"></A><A HREF="sec-3.17.html#get_single_char/1">get_single_char/1</A> 
and the tracer will wait for a return.

<P>

<P>
<DT><STRONG>-x</STRONG> <VAR>bootfile</VAR><DD>
Boot from <VAR>bootfile</VAR> instead of the system's default boot file. 
A bootfile is a file resulting from a Prolog compilation using the
<STRONG>-b</STRONG> or <STRONG>-c</STRONG> option or a program saved 
using
<A NAME="idx:qsave_program/[1,2]:48"></A><A HREF="sec-6.html#qsave_program/1">qsave_program/[1,2]</A>.

<P>

<P>
<DT><STRONG>-r</STRONG> <VAR>restorefile</VAR><DD>
Restore a state created by <A NAME="idx:save_program/[1,2]:49"></A><B>save_program/[1,2]</B> 
or <A NAME="idx:save/[1,2]:50"></A><B>save/[1,2]</B> using the new-style 
saved-states. Equivalent to <CODE>restore(restorefile)</CODE> from 
Prolog.

<P>

<P>
<DT><STRONG>-p</STRONG> <VAR>alias=path1[:path2 ... ]</VAR><DD>
Define a path alias for file_search_path. <VAR>alias</VAR> is the name 
of the alias, <VAR>path1 ...</VAR> is a <CODE><CODE>:</CODE></CODE> 
separated list of values for the alias. A value is either a term of the 
form alias(value) or pathname. The computed aliases are added to <A NAME="idx:file_search_path/2:51"></A><A HREF="sec-3.2.html#file_search_path/2">file_search_path/2</A> 
using <A NAME="idx:asserta/1:52"></A><A HREF="sec-3.12.html#asserta/1">asserta/1</A>, 
so they precede predefined values for the alias. See
<A NAME="idx:file_search_path/2:53"></A><A HREF="sec-3.2.html#file_search_path/2">file_search_path/2</A> 
for details on using this file-location mechanism.

<P>

<P>
<DT><STRONG></EM><TT>--</TT></STRONG> <VAR></VAR><DD>
Stops scanning for more arguments, so you can pass arguments for your 
application after this one.
</DL>

<P>The following options are for system maintenance. They are given for 
reference only.

<P>

<DL>

<P>
<DT><STRONG>-b</STRONG> <VAR>initfile ...<STRONG>-c</STRONG> file ...</VAR><DD>
Boot compilation. <VAR>initfile ...</VAR> are compiled by the C-written 
bootstrap compiler, <VAR>file ...</VAR> by the normal Prolog compiler. 
System maintenance only.

<P>
<DT><STRONG>-d</STRONG> <VAR>level</VAR><DD>
Set debug level to <VAR>level</VAR>. Only has effect if the system is 
compiled with the <CODE>-DO_DEBUG</CODE> flag. System maintenance only.
</DL>

