<HTML><HEAD><TITLE>SWI-Prolog Reference Manual: Section 2.3</TITLE><LINK REL=home HREF="Title.html">
<LINK REL=contents HREF="Contents.html">
<LINK REL=index HREF="Index.html">
<LINK REL=summary HREF="sec-B.html">
<LINK REL=previous HREF="sec-2.2.html">
<LINK REL=next HREF="sec-2.4.html">
</HEAD>

<BODY>

<HR><CENTER><A HREF="Title.html">Home</A>
<A HREF="Contents.html">Contents</A>
<A HREF="Index.html">Index</A>
<A HREF="sec-B.html">Summary</A>
<A HREF="sec-2.2.html">Previous</A>
<A HREF="sec-2.4.html">Next</A>
</CENTER>

<HR>

<H2><A NAME="sec:2.3">2.3 Online Help</A></H2>

<P>Online help provides a fast lookup and browsing facility to this 
manual. The online manual can show predicate definitions as well as 
entire sections of the manual.

<P>The online help is displayed from the file <CODE>library('MANUAL')</CODE>. 
The file
<CODE>library(helpidx)</CODE> provides an index into this file. <CODE>library('MANUAL')</CODE> 
is created from the LaTeX sources with a modified version of
<B>dvitty</B>, using overstrike for printing bold text and underlining 
for rendering italic text. XPCE is shipped with
<CODE>library(swi_help)</CODE>, presenting the information from the 
online help in a hypertext window. The feature <CODE>write_help_with_overstrike</CODE> 
controls whether or not <A NAME="idx:help/1:56"></A><A HREF="sec-2.3.html#help/1">help/1</A> 
writes its output using overstrike to realise bold and underlined output 
or not. If this feature is not set it is initialised by the help library 
to <CODE>true</CODE> if the <CODE>TERM</CODE> variable equals <CODE>xterm</CODE> 
and <CODE>false</CODE> otherwise. If this default does not satisfy you, 
add the following line to <CODE><CODE>~</CODE>/.plrc</CODE>.

<P>

<XMP>
:- set_feature(write_help_with_overstrike, true).
</XMP>

<P>

<DL>

<P>
<DT><A NAME="help/0"><STRONG>help</STRONG></A><DD>
Equivalent to <CODE>help(<A NAME="idx:help/1:57"></A><A HREF="sec-2.3.html#help/1">help/1</A>)</CODE>.

<P>

<P>
<DT><A NAME="help/1"><STRONG>help</STRONG>(<VAR>+What</VAR>)</A><DD>
Show specified part of the manual. <VAR>What</VAR> is one of:
<CENTER>
<TABLE BORDER=0 COLS=2 FRAME=void RULES=group>
<TR VALIGN=top><TD>&lt;<VAR>Name</VAR>&gt;/&lt;<VAR>Arity</VAR>&gt; <TD>give 
help on specified predicate </TR>
<TR VALIGN=top><TD>&lt;<VAR>Name</VAR>&gt; <TD>give help on named 
predicate with any arity or C interface function with that name </TR>
<TR VALIGN=top><TD>&lt;<VAR>Section</VAR>&gt; <TD>display specified 
section. section numbers are dash-separated numbers: <CODE>2-3</CODE> 
refers to section 2.3 of the manual. Section numbers are obtained using <A NAME="idx:apropos/1:58"></A><A HREF="sec-2.3.html#apropos/1">apropos/1</A>.</TR>
</TABLE>

</CENTER>

<P>Examples
<CENTER>
<TABLE BORDER=0 COLS=2 FRAME=void RULES=group>
<TR VALIGN=top><TD><CODE>?- help(assert).</CODE> <TD>give help on 
predicate assert </TR>
<TR VALIGN=top><TD><CODE>?- help(3-4).</CODE> <TD>display section 3.4 of 
the manual </TR>
<TR VALIGN=top><TD><CODE>?- help('PL_retry').</CODE><TD>give help on 
interface function <A HREF="sec-5.6.html#PL_retry()">PL_retry()</A> </TR>
</TABLE>

</CENTER>

<P>

<P>
<DT><A NAME="apropos/1"><STRONG>apropos</STRONG>(<VAR>+Pattern</VAR>)</A><DD>
Display all predicates, functions and sections that have </EM><EM>Pattern</EM> 
in their name or summary description. Lowercase letters in
<VAR>Pattern</VAR> also match a corresponding uppercase letter. Example:
<CENTER>
<TABLE BORDER=0 COLS=2 FRAME=void RULES=group>
<TR VALIGN=top><TD><CODE>?- apropos(file).</CODE> <TD>Display 
predicates, functions and sections that have `file' (or `File', etc.) in 
their summary description. </TR>
</TABLE>

</CENTER>

<P>

<P>
<DT><A NAME="explain/1"><STRONG>explain</STRONG>(<VAR>+ToExplain</VAR>)</A><DD>
Give an explanation on the given `object'. The argument may be any 
Prolog data object. If the argument is an atom, a term of the form <VAR>Name/Arity</VAR> 
or a term of the form </EM><EM>Module:Name/Arity</EM>, explain will try 
to explain the predicate as well as possible references to it.

<P>

<P>
<DT><A NAME="explain/2"><STRONG>explain</STRONG>(<VAR>+ToExplain, 
-Explanation</VAR>)</A><DD>
Unify <VAR>Explanation</VAR> with an explanation for <VAR>ToExplain</VAR>. 
Backtracking yields further explanations.
</DL>

