<HTML><HEAD><TITLE>SWI-Prolog Reference Manual: Section 2.4</TITLE><LINK REL=home HREF="Title.html">
<LINK REL=contents HREF="Contents.html">
<LINK REL=index HREF="Index.html">
<LINK REL=summary HREF="sec-B.html">
<LINK REL=previous HREF="sec-2.3.html">
<LINK REL=next HREF="sec-2.5.html">
</HEAD>

<BODY>

<HR><CENTER><A HREF="Title.html">Home</A>
<A HREF="Contents.html">Contents</A>
<A HREF="Index.html">Index</A>
<A HREF="sec-B.html">Summary</A>
<A HREF="sec-2.3.html">Previous</A>
<A HREF="sec-2.5.html">Next</A>
</CENTER>

<HR>

<H2><A NAME="sec:2.4">2.4 Query Substitutions</A></H2>

<A NAME="sec:history"></A>

<P>SWI-Prolog offers a query substitution mechanism similar to that of 
Unix csh (csh(1)), called `history'. The availability of this feature is 
controlled by <A NAME="idx:set_feature/2:59"></A><A HREF="sec-2.8.html#set_feature/2">set_feature/2</A>, 
using the <CODE>history</CODE> feature. By default, history is available 
if the feature <CODE>readline</CODE> is
<CODE>false</CODE>. To enable this feature, remembering the last 50 
commands, put the following into your <CODE><CODE>~</CODE>/.plrc</CODE> 
file:

<P>

<XMP>
:- set_feature(history, 50).
</XMP>

<P>The history system allows the user to compose new queries from those 
typed before and remembered by the system. It also allows to correct 
queries and syntax errors. SWI-Prolog does not offer the Unix csh 
capabilities to include arguments. This is omitted as it is unclear how 
the first, second, etc. argument should be defined.<A NAME=back-to-note-3 HREF="Notes.html#note-3"> (3)</A>

<P>The available history commands are shown in <A HREF="sec-2.4.html#tab:history">table 
1</A>.
<A HREF="sec-2.4.html#fig:history">Figure 1</A> gives some examples.

<P>
<CENTER>
<TABLE BORDER=2 COLS=2 FRAME=border RULES=group>
<TR VALIGN=top><TD><CODE>!!.</CODE> <TD>Repeat last query </TR>
<TR VALIGN=top><TD><CODE>!nr.</CODE> <TD>Repeat query numbered &lt;<VAR>nr</VAR>&gt; </TR>
<TR VALIGN=top><TD><CODE>!str.</CODE> <TD>Repeat last query starting 
with &lt;<VAR>str</VAR>&gt; </TR>
<TR VALIGN=top><TD><CODE>!?str.</CODE> <TD>Repeat last query holding &lt;<VAR>str</VAR>&gt; </TR>
<TR VALIGN=top><TD><CODE>^old^new.</CODE> <TD>Substitute &lt;<VAR>old</VAR>&gt; 
into &lt;<VAR>new</VAR>&gt; of last query </TR>
<TR VALIGN=top><TD><CODE>!nr^old^new.</CODE> <TD>Substitute in query 
numbered &lt;<VAR>nr</VAR>&gt; </TR>
<TR VALIGN=top><TD><CODE>!str^old^new.</CODE> <TD>Substitute in query 
starting with &lt;<VAR>str</VAR>&gt; </TR>
<TR VALIGN=top><TD><CODE>!?str^old^new.</CODE> <TD>Substitute in query 
holding &lt;<VAR>str</VAR>&gt; </TR>
<TR VALIGN=top><TD><CODE>h.</CODE> <TD>Show history list </TR>
<TR VALIGN=top><TD><CODE>!h.</CODE> <TD>Show this list </TR>
</TABLE>

</CENTER>
<CENTER><B>Table 1 : History commands</B></CENTER>
<A NAME="tab:history"></A>

<P>

<XMP>
/staff/jan/.plrc consulted, 0.066667 seconds, 591 bytes
Welcome to SWI-Prolog (Version \plversion)
Copyright (c) 1993-1996 University of Amsterdam.  All rights reserved.

For help, use ?- help(Topic). or ?- apropos(Word).

1 ?- append("Hello ", "World", L).

L = [72, 101, 108, 108, 111, 32, 87, 111, 114, 108, 100] 

Yes
2 ?- !!, writef('L = %s\n', [L]).
append("Hello ", "World", L), writef('L = %s\n', [L]).
L = Hello World

L = [72, 101, 108, 108, 111, 32, 87, 111, 114, 108, 100] 

Yes
3 ?- sublist(integer, [3, f, 3.4], L).

L = [3] 

Yes
4 ?- ^integer^number.
sublist(number, [3, f, 3.4], L).

L = [3, 3.400000] 

Yes
5 ?- h.
    1   append("Hello ", "World", L).
    2   append("Hello ", "World", L), writef('L = %s\n', [L]).
    3   sublist(integer, [3, f, 3.4], L).
    4   sublist(number, [3, f, 3.4], L).

5 ?- !2^World^Universe.
append("Hello ", "Universe", L), writef('L = %s\n', [L]).
L = Hello Universe

L = [72, 101, 108, 108, 111, 32, 85, 110, 105, 118, 101, 114, 115, 101] 

Yes
6 ?- halt.
</XMP>

<P><CENTER><B>Figure 1 : Some examples of the history facility</B></CENTER>
<A NAME="fig:history"></A>

<P>

<H3><A NAME="sec:2.4.1">2.4.1 Limitations of the History System</A></H3>

<P>When in top level SWI-Prolog reads the user's queries using
<A NAME="idx:read_history/6:60"></A><A HREF="sec-3.18.html#read_history/6">read_history/6</A> 
rather than <A NAME="idx:read/1:61"></A><A HREF="sec-3.18.html#read/1">read/1</A>. 
This predicate first reads the current input stream up to a full stop. 
While doing so it maps all contiguous blank space onto a single space 
and deletes
<CODE>/* ... */</CODE> and <CODE>% ...&lt;<VAR>cr</VAR>&gt;</CODE> 
comments. Parts between double quotes (<CODE>"</CODE>) or single quotes 
(<CODE>'</CODE>) are left unaltered. Note that a Prolog full stop 
consists of a `non-symbol' character, followed by a period (<CODE><CODE>.</CODE></CODE>), 
followed by a blank character. `Symbol' characters are: <CODE>#$&amp;*+-./:&lt;=&gt;?@^`~</CODE>. 
A single quote immediately preceded by a digit (0-9) is considered part 
of the &lt;<VAR>digit</VAR>&gt;'&lt;<VAR>digit</VAR>&gt;... (e.g. <CODE>2'101</CODE>; 
binary number 101) sequence.

<P>After this initial parsing the result is first checked for the 
special
<CODE>^</CODE>&lt;<VAR>old</VAR>&gt;<CODE>^</CODE>&lt;<VAR>new</VAR>&gt;. 
construction. If this fails the string is checked for all occurrences of 
the <CODE><CODE>!</CODE></CODE>, followed by a
<CODE><CODE>!</CODE></CODE>, <CODE><CODE>?</CODE></CODE>, a digit, a 
letter or an underscore. These special sequences are analysed and the 
appropriate substitution from the history list is made.

<P>From the above it follows that it is hard or impossible to correct 
quotation with single or double quotes, comment delimiters and spacing.

