<HTML><HEAD><TITLE>SWI-Prolog Reference Manual: Section 2.6</TITLE><LINK REL=home HREF="Title.html">
<LINK REL=contents HREF="Contents.html">
<LINK REL=index HREF="Index.html">
<LINK REL=summary HREF="sec-B.html">
<LINK REL=previous HREF="sec-2.5.html">
<LINK REL=next HREF="sec-2.7.html">
</HEAD>

<BODY>

<HR><CENTER><A HREF="Title.html">Home</A>
<A HREF="Contents.html">Contents</A>
<A HREF="Index.html">Index</A>
<A HREF="sec-B.html">Summary</A>
<A HREF="sec-2.5.html">Previous</A>
<A HREF="sec-2.7.html">Next</A>
</CENTER>

<HR>

<H2><A NAME="sec:2.6">2.6 Overview of the Debugger</A></H2>

<P>SWI-Prolog has a 6-port tracer, extending the standard 4-port tracer
<CITE><A HREF="sec-C.html#Clocksin:87">Clocksin &amp; Melish, 1987</A></CITE> 
with two additional ports. The optional <VAR>unify</VAR> port allows the 
user to inspect the result after unification of the head. The <VAR>exception</VAR> 
port shows exceptions raised by <A NAME="idx:throw/1:62"></A><A HREF="sec-3.8.html#throw/1">throw/1</A> 
or one of the built-in predicates. See <A HREF="sec-3.8.html">section 
3.8</A>.

<P>The standard ports are called <CODE>call</CODE>, <CODE>exit</CODE>, <CODE>redo</CODE>,
<CODE>fail</CODE> and <CODE>unify</CODE>. The tracer is started by the <A NAME="idx:trace/0:63"></A><A HREF="sec-3.38.html#trace/0">trace/0</A> 
command, when a spy point is reached and the system is in debugging mode 
(see <A NAME="idx:spy/1:64"></A><A HREF="sec-3.38.html#spy/1">spy/1</A> 
and <A NAME="idx:debug/0:65"></A><A HREF="sec-3.38.html#debug/0">debug/0</A>) 
or when an exception is raised.

<P>The interactive toplevel goal <A NAME="idx:trace/0:66"></A><A HREF="sec-3.38.html#trace/0">trace/0</A> 
means ``trace the next query''. The tracer shows the port, displaying 
the port name, the current depth of the recursion and the goal. The goal 
is printed using the Prolog predicate <A NAME="idx:write_term/2:67"></A><A HREF="sec-3.18.html#write_term/2">write_term/2</A>. 
The style can be modified to include the
<CODE>ignore_ops</CODE> and/or <CODE>portray</CODE> options using the <CODE>w</CODE>,
<CODE>p</CODE> or <CODE>d</CODE> command.

<P>

<XMP>
Yes
2 ?- visible(+all), leash(-exit).

Yes
3 ?- trace, min([3, 2], X).
  Call:  ( 3) min([3, 2], G235) ? creep
  Unify: ( 3) min([3, 2], G235)
  Call:  ( 4) min([2], G244) ? creep
  Unify: ( 4) min([2], 2)
  Exit:  ( 4) min([2], 2)
  Call:  ( 4) min(3, 2, G235) ? creep
  Unify: ( 4) min(3, 2, G235)
  Call:  ( 5) 3 < 2 ? creep
  Fail:  ( 5) 3 < 2 ? creep
  Redo:  ( 4) min(3, 2, G235) ? creep
  Exit:  ( 4) min(3, 2, 2)
  Exit:  ( 3) min([3, 2], 2)
</XMP>

<P><CENTER><B>Figure 3 : Example trace</B></CENTER>
<A NAME="fig:tracer"></A>

<P>On </EM><EM>leashed ports</EM> (set with the predicate <A NAME="idx:leash/1:68"></A><A HREF="sec-3.38.html#leash/1">leash/1</A>, 
default are
<CODE>call</CODE>, <CODE>exit</CODE>, <CODE>redo</CODE> and <CODE>fail</CODE>) 
the user is prompted for an action. All actions are single character 
commands which are executed </EM><B>without</B> waiting for a return, 
unless the command line option <STRONG>-tty</STRONG> is active. Tracer 
options:

<P>

<DL>

<P>
<DT><STRONG>Spy</STRONG> (<CODE>\Splus</CODE>)<DD>
Set a spy point (see <A NAME="idx:spy/1:69"></A><A HREF="sec-3.38.html#spy/1">spy/1</A>) 
on the current predicate.

<P>
<DT><STRONG>No spy</STRONG> (<CODE>\Sminus</CODE>)<DD>
Remove the spy point (see <A NAME="idx:nospy/1:70"></A><A HREF="sec-3.38.html#nospy/1">nospy/1</A>) 
from the current predicate.

<P>
<DT><STRONG>Find</STRONG> (<CODE>\Sdiv</CODE>)<DD>
Search for a port. After the `/', the user can enter a line to specify 
the port to search for. This line consists of a set of letters 
indicating the port type, followed by an optional term, that should 
unify with the goal run by the port. If no term is specified it is taken 
as a variable, searching for any port of the specified type. If an atom 
is given, any goal whose functor has a name equal to that atom matches. 
Examples: <CENTER>
<TABLE BORDER=0 COLS=2 FRAME=void RULES=group>
<TR VALIGN=top><TD></EM><TT>/f</TT><TD>Search for any fail port </TR>
<TR VALIGN=top><TD></EM><TT>/fe solve</TT><TD>Search for a fail or exit 
port of any goal with name <CODE>solve</CODE> </TR>
<TR VALIGN=top><TD></EM><TT>/c solve(a, _)</TT><TD>Search for a call to solve/2 
whose first argument is a variable or the atom <CODE>a</CODE> </TR>
<TR VALIGN=top><TD></EM><TT>/a member(_, _)</TT><TD>Search for any port 
on <A NAME="idx:member/2:71"></A><A HREF="sec-3.26.html#member/2">member/2</A>. 
This is equivalent to setting a spy point on <A NAME="idx:member/2:72"></A><A HREF="sec-3.26.html#member/2">member/2</A>. </TR>
</TABLE>

</CENTER>

<P>
<DT><STRONG>Repeat find</STRONG> (<CODE>\Sdot</CODE>)<DD>
Repeat the last find command (see `/')

<P>
<DT><STRONG>Alternatives</STRONG> (<CODE>A</CODE>)<DD>
Show all goals that have alternatives.

<P>
<DT><STRONG>Context</STRONG> (<CODE>C</CODE>)<DD>
Toggle `Show Context'. If <CODE>on</CODE> the context module of the goal 
is displayed between square brackets (see <A HREF="sec-4.html">section 4</A>). 
Default is <CODE>off</CODE>.

<P>
<DT><STRONG>Listing</STRONG> (<CODE>L</CODE>)<DD>
List the current predicate with <A NAME="idx:listing/1:73"></A><A HREF="sec-3.3.html#listing/1">listing/1</A>.

<P>
<DT><STRONG>Abort</STRONG> (<CODE>a</CODE>)<DD>
Abort Prolog execution (see <A NAME="idx:abort/0:74"></A><A HREF="sec-3.36.html#abort/0">abort/0</A>).

<P>
<DT><STRONG>Break</STRONG> (<CODE>b</CODE>)<DD>
Enter a Prolog break environment (see <A NAME="idx:break/0:75"></A><A HREF="sec-3.36.html#break/0">break/0</A>).

<P>
<DT><STRONG>Creep</STRONG> (<CODE>c</CODE>)<DD>
Continue execution, stop at next port. (Also return, space).

<P>
<DT><STRONG>Display</STRONG> (<CODE>d</CODE>)<DD>
Write goals using <CODE>ignore_ops</CODE> option.

<P>
<DT><STRONG>Exit</STRONG> (<CODE>e</CODE>)<DD>
Terminate Prolog (see <A NAME="idx:halt/0:76"></A><A HREF="sec-3.36.html#halt/0">halt/0</A>).

<P>
<DT><STRONG>Fail</STRONG> (<CODE>f</CODE>)<DD>
Force failure of the current goal

<P>
<DT><STRONG>Goals</STRONG> (<CODE>g</CODE>)<DD>
Show the list of parent goals (the execution stack). Note that due to 
tail recursion optimization a number of parent goals might not exist any 
more.

<P>
<DT><STRONG>Help</STRONG> (<CODE>h</CODE>)<DD>
Show available options (also `?').

<P>
<DT><STRONG>Ignore</STRONG> (<CODE>i</CODE>)<DD>
Ignore the current goal, pretending it succeeded.

<P>
<DT><STRONG>Leap</STRONG> (<CODE>l</CODE>)<DD>
Continue execution, stop at next spy point.

<P>
<DT><STRONG>No debug</STRONG> (<CODE>n</CODE>)<DD>
Continue execution in `no debug' mode.

<P>
<DT><STRONG>Print</STRONG> (<CODE>p</CODE>)<DD>
Write goals using the <CODE>portray</CODE> option (default).

<P>
<DT><STRONG>Retry</STRONG> (<CODE>r</CODE>)<DD>
Undo all actions (except for database and i/o actions) back to the call 
port of the current goal and resume execution at the call port.

<P>
<DT><STRONG>Skip</STRONG> (<CODE>s</CODE>)<DD>
Continue execution, stop at the next port of </EM><B>this</B> goal (thus 
skipping all calls to children of this goal).

<P>
<DT><STRONG>Up</STRONG> (<CODE>u</CODE>)<DD>
Continue execution, stop at the next port of </EM><B>the parent</B> goal 
(thus skipping this goal and all calls to children of this goal). This 
option is useful to stop tracing a failure driven loop.

<P>
<DT><STRONG>Write</STRONG> (<CODE>w</CODE>)<DD>
Write goals without using the <CODE>portray</CODE> option.
</DL>

<P>The ideal 4 port model as described in many Prolog books
<CITE><A HREF="sec-C.html#Clocksin:87">Clocksin &amp; Melish, 1987</A></CITE> 
is not visible in many Prolog implementations because code optimisation 
removes part of the choice- and exit points. Backtrack points are not 
shown if either the goal succeeded deterministically or its alternatives 
were removed using the cut. When running in debug mode (<A NAME="idx:debug/0:77"></A><A HREF="sec-3.38.html#debug/0">debug/0</A>) 
choice points are only destroyed when removed by the cut. In debug mode, 
tail recursion optimisation is switched off.<A NAME=back-to-note-4 HREF="Notes.html#note-4"> (4)</A>

