<HTML><HEAD><TITLE>SWI-Prolog Reference Manual: Section 2.8</TITLE><LINK REL=home HREF="Title.html">
<LINK REL=contents HREF="Contents.html">
<LINK REL=index HREF="Index.html">
<LINK REL=summary HREF="sec-B.html">
<LINK REL=previous HREF="sec-2.7.html">
<LINK REL=next HREF="sec-2.9.html">
</HEAD>

<BODY>

<HR><CENTER><A HREF="Title.html">Home</A>
<A HREF="Contents.html">Contents</A>
<A HREF="Index.html">Index</A>
<A HREF="sec-B.html">Summary</A>
<A HREF="sec-2.7.html">Previous</A>
<A HREF="sec-2.9.html">Next</A>
</CENTER>

<HR>

<H2><A NAME="sec:2.8">2.8 Environment Control</A></H2>

<P>The current system defines 3 different mechanisms to query and/or set 
properties of the environment: <A NAME="idx:please/3:92"></A><A HREF="sec-2.8.html#please/3">please/3</A>, <A NAME="idx:flag/3:93"></A><A HREF="sec-3.12.html#flag/3">flag/3</A> 
and <A NAME="idx:feature/2:94"></A><A HREF="sec-2.8.html#feature/2">feature/2</A> 
as well as a number of special purpose predicates of which <A NAME="idx:unknown/2:95"></A><A HREF="sec-3.38.html#unknown/2">unknown/2</A>, <A NAME="idx:fileerrors/2:96"></A><A HREF="sec-3.16.html#fileerrors/2">fileerrors/2</A> 
are examples. The ISO standard defines prolog_flag. It is likely that 
all these global features will be merged into a single in the future.

<P>

<DL>

<P>
<DT><A NAME="please/3"><STRONG>please</STRONG>(<VAR>+Key, -Old, +New</VAR>)</A><DD>
The predicate <A NAME="idx:please/3:97"></A><A HREF="sec-2.8.html#please/3">please/3</A><A NAME=back-to-note-5 HREF="Notes.html#note-5"> (5)</A> 
is a solution to avoid large numbers of environment control predicates. 
Later versions will support other environment control as now provided 
via the predicates <A NAME="idx:style_check/1:98"></A><A HREF="sec-3.38.html#style_check/1">style_check/1</A>, <A NAME="idx:leash/1:99"></A><A HREF="sec-3.38.html#leash/1">leash/1</A>, <A NAME="idx:unknown/2:100"></A><A HREF="sec-3.38.html#unknown/2">unknown/2</A>, 
the tracer predicates, etc. These predicates are then moved into a 
library for backwards compatibility. The currently available options 
are:

<P>

<DL>

<P>
<DT><STRONG>optimise</STRONG> (<VAR>on/off</VAR>) Default: off<DD>
Switch optimise mode for the compiler <CODE>on</CODE> or <CODE>off</CODE> 
(see also the command line option <STRONG>-O</STRONG>). Currently 
optimise compilation only implies compilation of arithmetic, making it 
fast, but invisible to the tracer. Later versions might imply various 
other optimisations such as incorporating a number of basic predicates 
in the virtual machine (<A NAME="idx:var/1:101"></A><A HREF="sec-3.4.html#var/1">var/1</A>, <A NAME="idx:fail/0:102"></A><A HREF="sec-3.6.html#fail/0">fail/0</A>, 
=/2, etc.) to gain speed at the cost of crippling the debugger. Also 
source level optimisations such as integrating small predicates into 
their callers, eliminating constant expressions and other predictable 
constructs. Source code optimisation is never applied to predicates that 
are declared dynamic (see <A NAME="idx:dynamic/1:103"></A><A HREF="sec-3.13.html#dynamic/1">dynamic/1</A>).

<P>
<DT><STRONG>autoload</STRONG> (<VAR>on/off</VAR>) Default: on<DD>
If <CODE>on</CODE> autoloading of library functions is enabled. If
<CODE>off</CODE> autoloading is disabled. See <A HREF="sec-2.9.html">section 
2.9</A>.

<P>
<DT><STRONG>verbose_autoload</STRONG> (<VAR>on/off</VAR>) Default: off<DD>
If <CODE>on</CODE> the normal consult message will be printed if a 
library is autoloaded. By default this message is suppressed. Intended 
to be used for debugging purposes (e.g. where does this predicate come 
from?).
</DL>

<P>

<P>
<DT><A NAME="feature/2"><STRONG>feature</STRONG>(<VAR>?Key, -Value</VAR>)</A><DD>
The predicate <A NAME="idx:feature/2:104"></A><A HREF="sec-2.8.html#feature/2">feature/2</A> 
defines an interface to installation features: options compiled in, 
version, home, etc. With both arguments unbound, it will generate all 
defined features. With the `Key' instantiated it unify the value of the 
feature. Features come in three types: boolean features, features with 
an atom value and features with an integer value. A boolean feature is 
true iff the feature is present </EM><B>and</B> the <VAR>Value</VAR> is 
the atom <CODE>true</CODE>. Currently defined keys:

<P>

<DL>

<P>
<DT><STRONG>arch</STRONG> (<VAR>atom</VAR>)<DD>
Identifier for the hardware and operating system SWI-Prolog is running 
on. Used to determine the startup file as well as to select foreign 
files for the right architecture. See also <A NAME="idx:load_foreign/5:105"></A><B>load_foreign/5</B>.

<P>
<DT><STRONG>version</STRONG> (<VAR>integer</VAR>)<DD>
The version identifier is an integer with value: <BLOCKQUOTE><VAR>10000 &times; <VAR>Major</VAR> 
+ 100 &times; <VAR>Minor</VAR> + <VAR>Patch</VAR></VAR></BLOCKQUOTE> 
Note that in releases upto 2.7.10 this feature yielded an atom holding 
the three numbers separated by dots. The current representation is much 
easier for implementing version-conditional statements.

<P>
<DT><STRONG>home</STRONG> (<VAR>atom</VAR>)<DD>
SWI-Prolog's notion of the home-directory. SWI-Prolog uses it's home 
directory to find its startup file as <CODE>&lt;<VAR>home</VAR>&gt;/startup/startup.&lt;<VAR>arch</VAR>&gt;</CODE> 
and to find its library as <CODE>&lt;<VAR>home</VAR>&gt;/library</CODE>.

<P>
<DT><STRONG>pipe</STRONG> (<VAR>bool</VAR>)<DD>
If true, tell(pipe(command)), etc. are supported.

<P>
<DT><STRONG>load_foreign</STRONG> (<VAR>bool</VAR>)<DD>
If true, <A NAME="idx:load_foreign/[2,5]:106"></A><A HREF="sec-5.4.html#load_foreign/2">load_foreign/[2,5]</A> 
are implemented.

<P>
<DT><STRONG>open_shared_object</STRONG> (<VAR>bool</VAR>)<DD>
If true, <A NAME="idx:open_shared_object/2:107"></A><A HREF="sec-5.3.html#open_shared_object/2">open_shared_object/2</A> 
and friends are implemented, providing access to shared libraries (.so 
files). This requires the C-library functions dlopen() and friends as 
well as the configuration option
</EM><TT>--with-dlopen</TT>.

<P>
<DT><STRONG>dynamic_stacks</STRONG> (<VAR>bool</VAR>)<DD>
If true, the system uses some form of `sparse-memory management' to 
realise the stacks. If false, malloc()/realloc() are used for the 
stacks. In earlier days this had consequenses for foreign code. As of 
version 2.5, this is no longer the case.

<P>Systems using `sparse-memory management' are a bit faster as there is 
no stack-shifter, and checking the stack-boundary is often realised by 
the hardware using a `guard-page'. Also, memory is actually returned to 
the system after a garbage collection or call to <A NAME="idx:trim_stacks/0:108"></A><A HREF="sec-3.41.html#trim_stacks/0">trim_stacks/0</A> 
(called by
<A NAME="idx:prolog/0:109"></A><A HREF="sec-3.36.html#prolog/0">prolog/0</A> 
after finishing a user-query).

<P>
<DT><STRONG>c_libs</STRONG> (<VAR>atom</VAR>)<DD>
Libraries passed to the C-linker when SWI-Prolog was linked. May be used 
to determine the libraries needed to create statically linked extensions 
for SWI-Prolog. See <A HREF="sec-5.7.html">section 5.7</A>.

<P>
<DT><STRONG>c_staticlibs</STRONG> (<VAR>atom</VAR>)<DD>
On some machines, the SWI-Prolog executable is dynamically linked, but 
requires some libraries to be statically linked. Obsolete.

<P>
<DT><STRONG>c_cc</STRONG> (<VAR>atom</VAR>)<DD>
Name of the C-compiler used to compile SWI-Prolog. Normally either gcc 
or cc. See <A HREF="sec-5.7.html">section 5.7</A>.

<P>
<DT><STRONG>c_ldflags</STRONG> (<VAR>atom</VAR>)<DD>
Special linker flags passed to link SWI-Prolog. See <A HREF="sec-5.7.html">section 
5.7</A>.

<P>
<DT><STRONG>save</STRONG> (<VAR>bool</VAR>)<DD>
If true, <A NAME="idx:save/[1,2]:110"></A><B>save/[1,2]</B> is 
implemented. Saving using <A NAME="idx:save/0:111"></A><B>save/0</B> is 
obsolete. See
<A NAME="idx:qsave_program/[1,2]:112"></A><A HREF="sec-6.html#qsave_program/1">qsave_program/[1,2]</A>.

<P>
<DT><STRONG>save_program</STRONG> (<VAR>bool</VAR>)<DD>
If true, <A NAME="idx:save_program/[1,2]:113"></A><B>save_program/[1,2]</B> 
is implemented. Saving using <A NAME="idx:save_program/0:114"></A><B>save_program/0</B> 
is obsolete. See <A NAME="idx:qsave_program/[1,2]:115"></A><A HREF="sec-6.html#qsave_program/1">qsave_program/[1,2]</A>.

<P>
<DT><STRONG>readline</STRONG> (<VAR>bool</VAR>)<DD>
If true, SWI-Prolog is linked with the readline library. This is done by 
default if you have this library installed on your system. It is also 
true for the Win32 plwin.exe version of SWI-Prolog, which realises a 
subset of the readline functionality.

<P>
<DT><STRONG>saved_program</STRONG> (<VAR>bool</VAR>)<DD>
If true, Prolog is started from a state saved with <A NAME="idx:qsave_program/[1,2]:116"></A><A HREF="sec-6.html#qsave_program/1">qsave_program/[1,2]</A>.

<P>
<DT><STRONG>runtime</STRONG> (<VAR>bool</VAR>)<DD>
If true, SWI-Prolog is compiled with -DO_RUNTIME, disabling various 
useful development features (currently the tracer and profiler).

<P>
<DT><STRONG>max_integer</STRONG> (<VAR>integer</VAR>)<DD>
Maximum integer value. Most arithmetic operations will automatically 
convert to floats if integer values above this are returned.

<P>
<DT><STRONG>min_integer</STRONG> (<VAR>integer</VAR>)<DD>
Minimum integer value.

<P>
<DT><STRONG>max_tagged_integer</STRONG> (<VAR>integer</VAR>)<DD>
Maximum integer value represented as a `tagged' value. Tagged integers 
require 4-bytes storage and are used for indexing. Larger integers are 
represented as `indirect data' and require 16-bytes on the stacks 
(though a copy requires only 4 additional bytes).

<P>
<DT><STRONG>min_tagged_integer</STRONG> (<VAR>integer</VAR>)<DD>
Start of the tagged-integer value range.

<P>
<DT><STRONG>float_format</STRONG> (<VAR>atom</VAR>)<DD>
C </EM><TT>printf()</TT> format specification used by <A NAME="idx:write/1:117"></A><A HREF="sec-3.18.html#write/1">write/1</A> 
and friends to determine how floating point numbers are printed. The 
default is </EM><TT>%g</TT>. May be changed. The specified value is 
passed to printf() without further checking. For example, if you want 
more digits printed,
</EM><TT>%.12g</TT> will print all floats using 12 digits instead of the 
default 6. See also <A NAME="idx:format/[1,2]:118"></A><A HREF="sec-3.32.html#format/1">format/[1,2]</A>, <A NAME="idx:write/1:119"></A><A HREF="sec-3.18.html#write/1">write/1</A>, <A NAME="idx:print/1:120"></A><A HREF="sec-3.18.html#print/1">print/1</A> 
and <A NAME="idx:portray/1:121"></A><A HREF="sec-3.18.html#portray/1">portray/1</A>.

<P>
<DT><STRONG>compiled_at</STRONG> (<VAR>atom</VAR>)<DD>
Describes when the system has been compiled. Only available if the 
C-compiler used to compile SWI-Prolog provides the __DATE__ and __TIME__ 
macros.

<P>
<DT><STRONG>character_escapes</STRONG> (<VAR>bool</VAR>)<DD>
If true (default), <A NAME="idx:read/1:122"></A><A HREF="sec-3.18.html#read/1">read/1</A> 
interprets <CODE>\</CODE> escape sequences in quoted atoms and strings. 
May be changed.

<P>
<DT><STRONG>allow_variable_name_as_functor</STRONG> (<VAR>bool</VAR>)<DD>
If true (default is false), <CODE>Functor(arg)</CODE> is read as if it 
was written <CODE>'Functor'(arg)</CODE>. Some applications use the 
Prolog <A NAME="idx:read/1:123"></A><A HREF="sec-3.18.html#read/1">read/1</A> 
predicate for reading an application defined script language. In these 
cases, it is often difficult to explain none-Prolog users of the 
application that constants and functions can only start with a lowercase 
letter. Variables can be turned into atoms starting with an uppercase 
atom by calling <A NAME="idx:read_term/2:124"></A><A HREF="sec-3.18.html#read_term/2">read_term/2</A> 
using the option <CODE>variable_names</CODE> and binding the variables 
to their name. Using this feature, F(x) can be turned into valid syntax 
for such script languages. Suggested by Robert van Engelen. SWI-Prolog 
specific.

<P>
<DT><STRONG>history</STRONG> (<VAR>integer</VAR>)<DD>
If <VAR>&gt; 0</VAR>, support Unix <B>csh(1)</B> like history as 
described in
<A HREF="sec-2.4.html">section 2.4</A>. Otherwise, only support reusing 
commands through the commandline editor. The default is to set this 
feature to 0 if a commandline editor is provided (see feature <CODE>readline</CODE>) 
and 15 otherwise.

<P>
<DT><STRONG>gc</STRONG> (<VAR>bool</VAR>)<DD>
If true (default), the garbage collector is active. If false, neither 
garbage-collection, nor stack-shifts will take place, even not on 
explicit request. May be changed.

<P>
<DT><STRONG>trace_gc</STRONG> (<VAR>bool</VAR>)<DD>
If true (false is the default), garbage collections and stack-shifts 
will be reported on the terminal. May be changed.

<P>
<DT><STRONG>max_arity</STRONG> (<VAR>unbounded</VAR>)<DD>
ISO feature describing there is no maximum arity to compound terms.

<P>
<DT><STRONG>integer_rounding_function</STRONG> (<VAR>down,toward_zero</VAR>)<DD>
ISO feature describing rounding by <CODE>//</CODE> and <CODE>rem</CODE> 
arithmetic functions. Value depends on the C-compiler used.

<P>
<DT><STRONG>bounded</STRONG> (<VAR>true</VAR>)<DD>
ISO feature describing integer representation is bound by
</EM><TT>min_integer</TT> and </EM><TT>min_integer</TT>.

<P>
<DT><STRONG>tty_control</STRONG> (<VAR>bool</VAR>)<DD>
Determines whether the terminal is switched to raw mode for
<A NAME="idx:get_single_char/1:125"></A><A HREF="sec-3.17.html#get_single_char/1">get_single_char/1</A>, 
which also reads the user-actions for the trace. May be set. See also 
the <STRONG>+/-tty</STRONG> command-line option.

<P>
<DT><STRONG>debug_on_error</STRONG> (<VAR>bool</VAR>)<DD>
If </EM><TT>true</TT>, start the tracer after an error is detected. 
Otherwise just continue execution. The goal that raised the error will 
normally fail. See also <A NAME="idx:fileerrors/2:126"></A><A HREF="sec-3.16.html#fileerrors/2">fileerrors/2</A> 
and the feature </EM><TT>report_error</TT>. May be changed. Default is </EM><TT>true</TT>, 
except for the runtime version.

<P>
<DT><STRONG>report_error</STRONG> (<VAR>bool</VAR>)<DD>
If </EM><TT>true</TT>, print error messages, otherwise suppress them. 
May be changed. See also the </EM><TT>debug_on_error</TT> feature. 
Default is </EM><TT>true</TT>, except for the runtime version.

<P>
<DT><STRONG>unix</STRONG> (<VAR>bool</VAR>)<DD>
<A NAME="idx:unix:127"></A>If </EM><TT>true</TT>, the operating system 
is some version of Unix. Defined if the C-compiler used to compile this 
version of SWI-Prolog either defines <CODE>__unix__</CODE> or <CODE>unix</CODE>.

<P>
<DT><STRONG>windows</STRONG> (<VAR>bool</VAR>)<DD>
<A NAME="idx:windows:128"></A>If </EM><TT>true</TT>, the operating 
system is an implementation of Microsoft Windows (3.1, 95, NT, etc.).
</DL>

<P>

<P>
<DT><A NAME="set_feature/2"><STRONG>set_feature</STRONG>(<VAR>+Key, 
+Value</VAR>)</A><DD>
Define a new feature or change its value. <VAR>Key</VAR> is an atom,
<VAR>Value</VAR> is an atom or number.
</DL>

