<HTML><HEAD><TITLE>SWI-Prolog Reference Manual: Section 2.9</TITLE><LINK REL=home HREF="Title.html">
<LINK REL=contents HREF="Contents.html">
<LINK REL=index HREF="Index.html">
<LINK REL=summary HREF="sec-B.html">
<LINK REL=previous HREF="sec-2.8.html">
<LINK REL=next HREF="sec-2.10.html">
</HEAD>

<BODY>

<HR><CENTER><A HREF="Title.html">Home</A>
<A HREF="Contents.html">Contents</A>
<A HREF="Index.html">Index</A>
<A HREF="sec-B.html">Summary</A>
<A HREF="sec-2.8.html">Previous</A>
<A HREF="sec-2.10.html">Next</A>
</CENTER>

<HR>

<H2><A NAME="sec:2.9">2.9 Automatic loading of libraries</A></H2>

<A NAME="sec:autoload"></A>

<P>If ---at runtime--- an undefined predicate is trapped the system will 
first try to import the predicate from the module's default module. If 
this fails the <EM>auto loader</EM> is activated. On first activation an 
index to all library files in all library directories is loaded in core 
(see <A NAME="idx:library_directory/1:129"></A><A HREF="sec-3.2.html#library_directory/1">library_directory/1</A>). 
If the undefined predicate can be located in the one of the libraries 
that library file is automatically loaded and the call to the 
(previously undefined) predicate is resumed. By default this mechanism 
loads the file silently. The
<A NAME="idx:please/3:130"></A><A HREF="sec-2.8.html#please/3">please/3</A> 
option <CODE>verbose_autoload</CODE> is provided to get verbose loading. 
The please option <CODE>autoload</CODE> can be used to enable/disable 
the entire auto load system.

<P>Autoloading only handles (library) source files that use the module 
mechanism described in <A HREF="sec-4.html">chapter 4</A>. The files are 
loaded with <A NAME="idx:use_module/2:131"></A><A HREF="sec-4.4.html#use_module/2">use_module/2</A> 
and only the trapped undefined predicate will be imported to the module 
where the undefined predicate was called. Each library directory must 
hold a file <CODE>INDEX.pl</CODE> that contains an index to all library 
files in the directory. This file consists of lines of the following 
format:

<P>

<XMP>
index(Name, Arity, Module, File).
</XMP>

<P>The predicate <A NAME="idx:make/0:132"></A><A HREF="sec-3.2.html#make/0">make/0</A> 
scans the autoload libraries and updates the index if it exists, is 
writable and out-of-date. It is advised to create an empty file called <CODE>INDEX.pl</CODE> 
in a library directory meant for auto loading before doing anything 
else. This index file can then be updated by running the prolog <A NAME="idx:make_library_index/1:133"></A><A HREF="sec-2.9.html#make_library_index/1">make_library_index/1</A> 
(`%' is the Unix prompt):

<P>

<XMP>
% mkdir ~/lib/prolog
% cd !$
% pl -g true -t 'make_library_index(.)'
</XMP>

<P>If there are more than one library files containing the desired 
predicate the following search schema is followed:

<P><OL>
<LI>If a there is a library file that defines the module in which the 
undefined predicate is trapped, this file is used.
<LI>Otherwise library files are considered in the order they appear in 
the <A NAME="idx:library_directory/1:134"></A><A HREF="sec-3.2.html#library_directory/1">library_directory/1</A> 
predicate and within the directory alphabetically.
</OL>

<P>

<DL>

<P>
<DT><A NAME="make_library_index/1"><STRONG>make_library_index</STRONG>(<VAR>+Directory</VAR>)</A><DD>
Create an index for this directory. The index is written to the file 
'INDEX.pl' in the specified directory. Fails with a warning if the 
directory does not exist or is write protected.
</DL>

<P>

<H3><A NAME="sec:2.9.1">2.9.1 Notes on Automatic Loading</A></H3>

<P>The autoloader is a new feature to SWI-Prolog. Its aim is to simplify 
program development and program management. Common lisp has a similar 
feature, but here the user has to specify which library is to be loaded 
if a specific function is called which is not defined. The advantage of 
the SWI-Prolog schema is that the user does not have to specify this. 
The disadvantage however is that the user might be wondering ``where the 
hell this predicate comes from''. Only experience can learn whether the 
functionality of the autoloader is appropriate. Comments are welcome.

<P>The autoloader only works if the unknown flag (see <A NAME="idx:unknown/2:135"></A><A HREF="sec-3.38.html#unknown/2">unknown/2</A>) 
is set to
<CODE>trace</CODE> (default). A more appropriate interaction with this 
flag will be considered.

