<HTML><HEAD><TITLE>SWI-Prolog Reference Manual: Section 3.10</TITLE><LINK REL=home HREF="Title.html">
<LINK REL=contents HREF="Contents.html">
<LINK REL=index HREF="Index.html">
<LINK REL=summary HREF="sec-B.html">
<LINK REL=previous HREF="sec-3.9.html">
<LINK REL=next HREF="sec-3.11.html">
</HEAD>

<BODY>

<HR><CENTER><A HREF="Title.html">Home</A>
<A HREF="Contents.html">Contents</A>
<A HREF="Index.html">Index</A>
<A HREF="sec-B.html">Summary</A>
<A HREF="sec-3.9.html">Previous</A>
<A HREF="sec-3.11.html">Next</A>
</CENTER>

<HR>

<H2><A NAME="sec:3.10">3.10 Advanced control-structures: blocks</A></H2>

<P><A NAME="idx:exception-handling:274"></A>The predicates of this 
section form a tightly related set for realising premature successful or 
failing exits from a <VAR>block</VAR>. These predicates are first of all 
useful for error-recovery. They were primarily implemented for 
compatibility reasons.

<P>

<DL>

<P>
<DT><A NAME="block/3"><STRONG>block</STRONG>(<VAR>+Label, +Goal, 
-ExitValue</VAR>)</A><DD>
Execute <VAR>Goal</VAR> in a <VAR>block</VAR>. <VAR>Label</VAR> is the 
name of the block. <VAR>Label</VAR> is normally an atom, but the system 
imposes no type constraints and may even be a variable. <VAR>ExitValue</VAR> 
is normally unified to the second argument of an <A NAME="idx:exit/2:275"></A><A HREF="sec-3.10.html#exit/2">exit/2</A> 
call invoked by <VAR>Goal</VAR>.

<P>
<DT><A NAME="exit/2"><STRONG>exit</STRONG>(<VAR>+Label, +Value</VAR>)</A><DD>
Calling <A NAME="idx:exit/2:276"></A><A HREF="sec-3.10.html#exit/2">exit/2</A> 
makes the innermost <VAR>block</VAR> which <VAR>Label</VAR> unifies 
exit. The block's <VAR>ExitValue</VAR> is unified with <VAR>Value</VAR>. 
If this unification fails the block fails.

<P>
<DT><A NAME="fail/1"><STRONG>fail</STRONG>(<VAR>+Label</VAR>)</A><DD>
Calling <A NAME="idx:fail/1:277"></A><A HREF="sec-3.10.html#fail/1">fail/1</A> 
makes the innermost <VAR>block</VAR> which <VAR>Label</VAR> unifies fail 
immediately. Implemented as

<XMP>
fail(Label) :- !(Label), fail.
</XMP>

<P>

<P>
<DT><A NAME="!/1"><STRONG>!</STRONG>(<VAR>+Label</VAR>)</A><DD>
Cut all choice-points created since the entry of the innermost
<VAR>block</VAR> which <VAR>Label</VAR> unifies.
</DL>

<P>The example below illustrate these constructs to immediately report a 
syntax-error from a `deep-down' procedure to the outside world without 
passing it as an argument `all-over-the-place'.

<P>

<XMP>
parse(RuleSet, InputList, Rest) :-
        block(syntaxerror, phrase(RuleSet, InputList, Rest), Error),
        (   var(Error)
        ->  true
        ;   format('Syntax-error: ~w~n', Error),
            fail
        ).

integer(N) -->
        digit(D1), !, digits(Ds),
        { name(N, [D1|Ds]) }.

digits([D|R]) --> digit(D), digits(R).
digits(_) --> letter(_), !, { exit(syntaxerror, 'Illegal number') }.
digits([]) --> [].

digit(D, [D|R], R)  :- between(0'0, 0'9, D).
letter(D, [D|R], R) :- between(0'a, 0'z, D).
</XMP>

