<HTML><HEAD><TITLE>SWI-Prolog Reference Manual: Section 3.12</TITLE><LINK REL=home HREF="Title.html">
<LINK REL=contents HREF="Contents.html">
<LINK REL=index HREF="Index.html">
<LINK REL=summary HREF="sec-B.html">
<LINK REL=previous HREF="sec-3.11.html">
<LINK REL=next HREF="sec-3.13.html">
</HEAD>

<BODY>

<HR><CENTER><A HREF="Title.html">Home</A>
<A HREF="Contents.html">Contents</A>
<A HREF="Index.html">Index</A>
<A HREF="sec-B.html">Summary</A>
<A HREF="sec-3.11.html">Previous</A>
<A HREF="sec-3.13.html">Next</A>
</CENTER>

<HR>

<H2><A NAME="sec:3.12">3.12 Database</A></H2>

<P>SWI-Prolog offers three different database mechanisms. The first one 
is the common assert/retract mechanism for manipulating the clause 
database. As facts and clauses asserted using <A NAME="idx:assert/1:278"></A><A HREF="sec-3.12.html#assert/1">assert/1</A> 
or one of its derivatives become part of the program these predicates 
compile the term given to them. <A NAME="idx:retract/1:279"></A><A HREF="sec-3.12.html#retract/1">retract/1</A> 
and <A NAME="idx:retractall/1:280"></A><A HREF="sec-3.12.html#retractall/1">retractall/1</A> 
have to unify a term and therefore have to decompile the program. For 
these reasons the assert/retract mechanism is expensive. On the other 
hand, once compiled, queries to the database are faster than querying 
the recorded database discussed below. See also <A NAME="idx:dynamic/1:281"></A><A HREF="sec-3.13.html#dynamic/1">dynamic/1</A>.

<P>The second way of storing arbitrary terms in the database is using 
the ``recorded database''. In this database terms are associated with a
<VAR>key</VAR>. A key can be an atom, integer or term. In the last case 
only the functor and arity determine the key. Each key has a chain of 
terms associated with it. New terms can be added either at the head or 
at the tail of this chain. This mechanism is considerably faster than 
the assert/retract mechanism as terms are not compiled, but just copied 
into the heap.

<P>The third mechanism is a special purpose one. It associates an 
integer or atom with a key, which is an atom, integer or term. Each key 
can only have one atom or integer associated with it. It again is 
considerably faster than the mechanisms described above, but can only be 
used to store simple status information like counters, etc.

<P>

<DL>

<P>
<DT><A NAME="abolish/1"><STRONG>abolish</STRONG>(<VAR>:PredicateIndicator</VAR>)</A><DD>
Removes all clauses of a predicate with functor <VAR>Functor</VAR> and 
arity
<VAR>Arity</VAR> from the database. Unlike version 1.2, all predicate 
attributes (dynamic, multifile, index, etc.) are reset to their 
defaults. Abolishing an imported predicate only removes the import link; 
the predicate will keep its old definition in its definition module. For 
`cleanup' of the dynamic database, one should use <A NAME="idx:retractall/1:282"></A><A HREF="sec-3.12.html#retractall/1">retractall/1</A> 
rather than <A NAME="idx:abolish/2:283"></A><A HREF="sec-3.12.html#abolish/2">abolish/2</A>.

<P>
<DT><A NAME="abolish/2"><STRONG>abolish</STRONG>(<VAR>+Name, +Arity</VAR>)</A><DD>
Same as <CODE>abolish(Name/Arity)</CODE>. The predicate <A NAME="idx:abolish/2:284"></A><A HREF="sec-3.12.html#abolish/2">abolish/2</A> 
conforms to the Edinburgh standard, while <A NAME="idx:abolish/1:285"></A><A HREF="sec-3.12.html#abolish/1">abolish/1</A> 
is ISO compliant.

<P>
<DT><A NAME="redefine_system_predicate/1"><STRONG>redefine_system_predicate</STRONG>(<VAR>+Head</VAR>)</A><DD>
This directive may be used both in module <CODE>user</CODE> and in 
normal modules to redefine any system predicate. If the system 
definition is redefined in module <CODE>user</CODE>, the new definition 
is the default definition for all sub-modules. Otherwise the 
redefinition is local to the module. The system definition remains in 
the module <CODE>system</CODE>.

<P>Redefining system predicate facilitates the definition of 
compatibility packages. Use in other context is discouraged.

<P>
<DT><A NAME="retract/1"><STRONG>retract</STRONG>(<VAR>+Term</VAR>)</A><DD>
When <VAR>Term</VAR> is an atom or a term it is unified with the first 
unifying fact or clause in the database. The fact or clause is removed 
from the database.

<P>
<DT><A NAME="retractall/1"><STRONG>retractall</STRONG>(<VAR>+Head</VAR>)</A><DD>
All facts or clauses in the database for which the <VAR>head</VAR> 
unifies with <VAR>Head</VAR> are removed.<A NAME=back-to-note-11 HREF="Notes.html#note-11"> (11)</A>

<P>
<DT><A NAME="assert/1"><STRONG>assert</STRONG>(<VAR>+Term</VAR>)</A><DD>
Assert a fact or clause in the database. <VAR>Term</VAR> is asserted as 
the last fact or clause of the corresponding predicate.

<P>
<DT><A NAME="asserta/1"><STRONG>asserta</STRONG>(<VAR>+Term</VAR>)</A><DD>
Equivalent to <A NAME="idx:assert/1:286"></A><A HREF="sec-3.12.html#assert/1">assert/1</A>, 
but <VAR>Term</VAR> is asserted as first clause or fact of the 
predicate.

<P>
<DT><A NAME="assertz/1"><STRONG>assertz</STRONG>(<VAR>+Term</VAR>)</A><DD>
Equivalent to <A NAME="idx:assert/1:287"></A><A HREF="sec-3.12.html#assert/1">assert/1</A>.

<P>
<DT><A NAME="assert/2"><STRONG>assert</STRONG>(<VAR>+Term, -Reference</VAR>)</A><DD>
Equivalent to <A NAME="idx:assert/1:288"></A><A HREF="sec-3.12.html#assert/1">assert/1</A>, 
but <VAR>Reference</VAR> is unified with a unique reference to the 
asserted clause. This key can later be used with
<A NAME="idx:clause/3:289"></A><A HREF="sec-3.14.html#clause/3">clause/3</A> 
or <A NAME="idx:erase/1:290"></A><A HREF="sec-3.12.html#erase/1">erase/1</A>.

<P>
<DT><A NAME="asserta/2"><STRONG>asserta</STRONG>(<VAR>+Term, -Reference</VAR>)</A><DD>
Equivalent to <A NAME="idx:assert/2:291"></A><A HREF="sec-3.12.html#assert/2">assert/2</A>, 
but <VAR>Term</VAR> is asserted as first clause or fact of the 
predicate.

<P>
<DT><A NAME="assertz/2"><STRONG>assertz</STRONG>(<VAR>+Term, -Reference</VAR>)</A><DD>
Equivalent to <A NAME="idx:assert/2:292"></A><A HREF="sec-3.12.html#assert/2">assert/2</A>.

<P>
<DT><A NAME="recorda/3"><STRONG>recorda</STRONG>(<VAR>+Key, +Term, 
-Reference</VAR>)</A><DD>
Assert <VAR>Term</VAR> in the recorded database under key <VAR>Key</VAR>. <VAR>Key</VAR> 
is an integer, atom or term. <VAR>Reference</VAR> is unified with a 
unique reference to the record (see <A NAME="idx:erase/1:293"></A><A HREF="sec-3.12.html#erase/1">erase/1</A>).

<P>
<DT><A NAME="recorda/2"><STRONG>recorda</STRONG>(<VAR>+Key, +Term</VAR>)</A><DD>
Equivalent to <CODE>recorda(<VAR>Key</VAR>, <VAR>Value</VAR>, _)</CODE>.

<P>
<DT><A NAME="recordz/3"><STRONG>recordz</STRONG>(<VAR>+Key, +Term, 
-Reference</VAR>)</A><DD>
Equivalent to <A NAME="idx:recorda/3:294"></A><A HREF="sec-3.12.html#recorda/3">recorda/3</A>, 
but puts the <VAR>Term</VAR> at the tail of the terms recorded under <VAR>Key</VAR>.

<P>
<DT><A NAME="recordz/2"><STRONG>recordz</STRONG>(<VAR>+Key, +Term</VAR>)</A><DD>
Equivalent to <CODE>recordz(<VAR>Key</VAR>, <VAR>Value</VAR>, _)</CODE>.

<P>
<DT><A NAME="recorded/3"><STRONG>recorded</STRONG>(<VAR>+Key, -Value, 
-Reference</VAR>)</A><DD>
Unify <VAR>Value</VAR> with the first term recorded under <VAR>Key</VAR> 
which does unify. <VAR>Reference</VAR> is unified with the memory 
location of the record.

<P>
<DT><A NAME="recorded/2"><STRONG>recorded</STRONG>(<VAR>+Key, -Value</VAR>)</A><DD>
Equivalent to <CODE>recorded(<VAR>Key</VAR>, <VAR>Value</VAR>, _)</CODE>.

<P>
<DT><A NAME="erase/1"><STRONG>erase</STRONG>(<VAR>+Reference</VAR>)</A><DD>
Erase a record or clause from the database. <VAR>Reference</VAR> is an 
integer returned by <A NAME="idx:recorda/3:295"></A><A HREF="sec-3.12.html#recorda/3">recorda/3</A> 
or <A NAME="idx:recorded/3:296"></A><A HREF="sec-3.12.html#recorded/3">recorded/3</A>, <A NAME="idx:clause/3:297"></A><A HREF="sec-3.14.html#clause/3">clause/3</A>, <A NAME="idx:assert/2:298"></A><A HREF="sec-3.12.html#assert/2">assert/2</A>,
<A NAME="idx:asserta/2:299"></A><A HREF="sec-3.12.html#asserta/2">asserta/2</A> 
or <A NAME="idx:assertz/2:300"></A><A HREF="sec-3.12.html#assertz/2">assertz/2</A>. 
Other integers might conflict with the internal consistency of the 
system. Erase can only be called once on a record or clause. A second 
call also might conflict with the internal consistency of the system.<A NAME=back-to-note-12 HREF="Notes.html#note-12"> (12)</A>

<P>
<DT><A NAME="flag/3"><STRONG>flag</STRONG>(<VAR>+Key, -Old, +New</VAR>)</A><DD>
<VAR>Key</VAR> is an atom, integer or term. Unify <VAR>Old</VAR> with 
the old value associated with <VAR>Key</VAR>. If the key is used for the 
first time
<VAR>Old</VAR> is unified with the integer 0. Then store the value of
<VAR>New</VAR>, which should be an integer, float, atom or arithmetic 
expression, under <VAR>Key</VAR>. <A NAME="idx:flag/3:301"></A><A HREF="sec-3.12.html#flag/3">flag/3</A> 
is a very fast mechanism for storing simple facts in the database. 
Example:

<XMP>
:- module_transparent succeeds_n_times/2.

succeeds_n_times(Goal, Times) :-
        flag(succeeds_n_times, Old, 0),
        Goal,
        flag(succeeds_n_times, N, N+1),
        fail ; flag(succeeds_n_times, Times, Old).
</XMP>

<P>
</DL>

<P>

<H3><A NAME="sec:3.12.1">3.12.1 Indexing databases</A></H3>

<P>By default, SWI-Prolog, as most other implementations, indexes 
predicates on their first argument. SWI-Prolog allows indexing on other 
and multiple arguments using the declaration <A NAME="idx:index/1:302"></A><A HREF="sec-3.13.html#index/1">index/1</A>.

<P>For advanced database indexing, it defines <A NAME="idx:hash_term/2:303"></A><A HREF="sec-3.12.html#hash_term/2">hash_term/2</A>:

<P>

<DL>

<P>
<DT><A NAME="hash_term/2"><STRONG>hash_term</STRONG>(<VAR>+Term, 
-HashKey</VAR>)</A><DD>
If <VAR>Term</VAR> is a ground term (see <A NAME="idx:ground/1:304"></A><A HREF="sec-3.4.html#ground/1">ground/1</A>), <VAR>HashKey</VAR> 
is unified with a positive integer value that may be used as a hash-key 
to the value. If <VAR>Term</VAR> is not ground, the predicate succeeds 
immediately, leaving <VAR>HashKey</VAR> an unbound variable.

<P>This predicate may be used to build hash-tables as well as to exploit 
argument-indexing to find complex terms more quickly.

<P>The hash-key does not rely on temporary information like addresses of 
atoms and may be assumed constant over different invocations of 
SWI-Prolog.
</DL>

