<HTML><HEAD><TITLE>SWI-Prolog Reference Manual: Section 3.14</TITLE><LINK REL=home HREF="Title.html">
<LINK REL=contents HREF="Contents.html">
<LINK REL=index HREF="Index.html">
<LINK REL=summary HREF="sec-B.html">
<LINK REL=previous HREF="sec-3.13.html">
<LINK REL=next HREF="sec-3.15.html">
</HEAD>

<BODY>

<HR><CENTER><A HREF="Title.html">Home</A>
<A HREF="Contents.html">Contents</A>
<A HREF="Index.html">Index</A>
<A HREF="sec-B.html">Summary</A>
<A HREF="sec-3.13.html">Previous</A>
<A HREF="sec-3.15.html">Next</A>
</CENTER>

<HR>

<H2><A NAME="sec:3.14">3.14 Examining the Program</A></H2>

<P>

<DL>

<P>
<DT><A NAME="current_atom/1"><STRONG>current_atom</STRONG>(<VAR>-Atom</VAR>)</A><DD>
Successively unifies <VAR>Atom</VAR> with all atoms known to the system. 
Note that <A NAME="idx:current_atom/1:317"></A><A HREF="sec-3.14.html#current_atom/1">current_atom/1</A> 
always succeeds if <VAR>Atom</VAR> is instantiated to an atom.

<P>
<DT><A NAME="current_functor/2"><STRONG>current_functor</STRONG>(<VAR>?Name, 
?Arity</VAR>)</A><DD>
Successively unifies <VAR>Name</VAR> with the name and <VAR>Arity</VAR> 
with the arity of functors known to the system.

<P>
<DT><A NAME="current_flag/1"><STRONG>current_flag</STRONG>(<VAR>-FlagKey</VAR>)</A><DD>
Successively unifies <VAR>FlagKey</VAR> with all keys used for flags 
(see
<A NAME="idx:flag/3:318"></A><A HREF="sec-3.12.html#flag/3">flag/3</A>).

<P>
<DT><A NAME="current_key/1"><STRONG>current_key</STRONG>(<VAR>-Key</VAR>)</A><DD>
Successively unifies <VAR>Key</VAR> with all keys used for records (see
<A NAME="idx:recorda/3:319"></A><A HREF="sec-3.12.html#recorda/3">recorda/3</A>, 
etc.).

<P>
<DT><A NAME="current_predicate/2"><STRONG>current_predicate</STRONG>(<VAR>?Name, 
?Head</VAR>)</A><DD>
Successively unifies <VAR>Name</VAR> with the name of predicates 
currently defined and <VAR>Head</VAR> with the most general term built 
from <VAR>Name</VAR> and the arity of the predicate. This predicate 
succeeds for all predicates defined in the specified module, imported to 
it, or in one of the modules from which the predicate will be imported 
if it is called.

<P>
<DT><A NAME="predicate_property/2"><STRONG>predicate_property</STRONG>(<VAR>?Head, 
?Property</VAR>)</A><DD>
Succeeds if <VAR>Head</VAR> refers to a predicate that has property
<VAR>Property</VAR>. Can be used to test whether a predicate has a 
certain property, obtain all properties known for <VAR>Head</VAR>, find 
all predicates having <VAR>property</VAR> or even obtaining all 
information available about the current program. <VAR>Property</VAR> is 
one of:

<P>

<DL>

<P>
<DT><STRONG>interpreted</STRONG><DD>
Is true if the predicate is defined in Prolog. We return true on this 
because, although the code is actually compiled, it is completely 
transparent, just like interpreted code.

<P>
<DT><STRONG>built_in</STRONG><DD>
Is true if the predicate is locked as a built-in predicate. This implies 
it cannot be redefined in its definition module and it can normally not 
be seen in the tracer.

<P>
<DT><STRONG>foreign</STRONG><DD>
Is true if the predicate is defined in the C language.

<P>
<DT><STRONG>dynamic</STRONG><DD>
Is true if the predicate is declared dynamic using the <A NAME="idx:dynamic/1:320"></A><A HREF="sec-3.13.html#dynamic/1">dynamic/1</A> 
declaration.

<P>
<DT><STRONG>multifile</STRONG><DD>
Is true if the predicate is declared multifile using the <A NAME="idx:multifile/1:321"></A><A HREF="sec-3.13.html#multifile/1">multifile/1</A> 
declaration.

<P>
<DT><STRONG>undefined</STRONG><DD>
Is true if a procedure definition block for the predicate exists, but 
there are no clauses in it and it is not declared dynamic. This is true 
if the predicate occurs in the body of a loaded predicate, an attempt to 
call it has been made via one of the meta-call predicates or the 
predicate had a definition in the past. See the library package
<VAR>check</VAR> for example usage.

<P>
<DT><STRONG>transparent</STRONG><DD>
Is true if the predicate is declared transparent using the
<A NAME="idx:module_transparent/1:322"></A><A HREF="sec-4.8.html#module_transparent/1">module_transparent/1</A> 
declaration.

<P>
<DT><STRONG>exported</STRONG><DD>
Is true if the predicate is in the public list of the context module.

<P>
<DT><STRONG>imported_from</STRONG>(<VAR>Module</VAR>)<DD>
Is true if the predicate is imported into the context module from module <VAR>Module</VAR>.

<P>
<DT><STRONG>indexed</STRONG>(<VAR>Head</VAR>)<DD>
Predicate is indexed (see <A NAME="idx:index/1:323"></A><A HREF="sec-3.13.html#index/1">index/1</A>) 
according to <VAR>Head</VAR>. <VAR>Head</VAR> is a term whose name and 
arity are identical to the predicate. The arguments are unified with `1' 
for indexed arguments, `0' otherwise.

<P>
<DT><STRONG>file</STRONG>(<VAR>FileName</VAR>)<DD>
Unify <VAR>FileName</VAR> with the name of the sourcefile in which the 
predicate is defined. See also <A NAME="idx:source_file/2:324"></A><A HREF="sec-3.2.html#source_file/2">source_file/2</A>.

<P>
<DT><STRONG>line_count</STRONG>(<VAR>LineNumber</VAR>)<DD>
Unify <VAR>LineNumber</VAR> with the line number of the first clause of 
the predicate. Fails if the predicate is not associated with a file. See 
also <A NAME="idx:source_file/2:325"></A><A HREF="sec-3.2.html#source_file/2">source_file/2</A>.

<P>
<DT><STRONG>number_of_clauses</STRONG>(<VAR>ClauseCount</VAR>)<DD>
Unify <VAR>ClauseCount</VAR> to the number of clauses associated with 
the predicate. Fails for foreign predicates.
</DL>

<P>
<DT><A NAME="dwim_predicate/2"><STRONG>dwim_predicate</STRONG>(<VAR>+Term, 
-Dwim</VAR>)</A><DD>
`Do What I Mean' (`dwim') support predicate. <VAR>Term</VAR> is a term, 
which name and arity are used as a predicate specification. <VAR>Dwim</VAR> 
is instantiated with the most general term built from <VAR>Name</VAR> 
and the arity of a defined predicate that matches the predicate 
specified by
<VAR>Term</VAR> in the `Do What I Mean' sense. See <A NAME="idx:dwim_match/2:326"></A><A HREF="sec-3.43.html#dwim_match/2">dwim_match/2</A> 
for `Do What I Mean' string matching. Internal system predicates are not 
generated, unless <CODE>style_check(+dollar)</CODE> is active. 
Backtracking provides all alternative matches.

<P>
<DT><A NAME="clause/2"><STRONG>clause</STRONG>(<VAR>?Head, ?Body</VAR>)</A><DD>
Succeeds when <VAR>Head</VAR> can be unified with a clause head and <VAR>Body</VAR> 
with the corresponding clause body. Gives alternative clauses on 
backtracking. For facts <VAR>Body</VAR> is unified with the atom <VAR>true</VAR>. 
Normally <A NAME="idx:clause/2:327"></A><A HREF="sec-3.14.html#clause/2">clause/2</A> 
is used to find clause definitions for a predicate, but it can also be 
used to find clause heads for some body template.

<P>
<DT><A NAME="clause/3"><STRONG>clause</STRONG>(<VAR>?Head, ?Body, 
?Reference</VAR>)</A><DD>
Equivalent to <A NAME="idx:clause/2:328"></A><A HREF="sec-3.14.html#clause/2">clause/2</A>, 
but unifies <VAR>Reference</VAR> with a unique reference to the clause 
(see also <A NAME="idx:assert/2:329"></A><A HREF="sec-3.12.html#assert/2">assert/2</A>, <A NAME="idx:erase/1:330"></A><A HREF="sec-3.12.html#erase/1">erase/1</A>). 
If <VAR>Reference</VAR> is instantiated to a reference the clause's head 
and body will be unified with <VAR> Head</VAR> and <VAR>Body</VAR>.

<P>
<DT><A NAME="nth_clause/3"><STRONG>nth_clause</STRONG>(<VAR>?Pred, 
?Index, ?Reference</VAR>)</A><DD>
Provides access to the clauses of a predicate using their index number. 
Counting starts at 1. If <VAR>Reference</VAR> is specified it unifies <VAR>Pred</VAR> 
with the most general term with the same name/arity as the predicate and
<VAR>Index</VAR> with the index-number of the clause. Otherwise the name 
and arity of <VAR>Pred</VAR> are used to determine the predicate. If <VAR>Index</VAR> 
is provided <VAR>Reference</VAR> will be unified with the clause 
reference. If <VAR>Index</VAR> is unbound, backtracking will yield both 
the indices and the references of all clauses of the predicate. The 
following example finds the 2nd clause of <A NAME="idx:member/2:331"></A><A HREF="sec-3.26.html#member/2">member/2</A>:

<P>

<XMP>
?- nth_clause(member(_,_), 2, Ref), clause(Head, Body, Ref).

Ref = 160088
Head = system : member(G575, [G578|G579]) 
Body = member(G575, G579)
</XMP>

<P>

<P>
<DT><A NAME="clause_property/2"><STRONG>clause_property</STRONG>(<VAR>+ClauseRef, 
-Property</VAR>)</A><DD>
Queries properties of a clause. <VAR>ClauseRef</VAR> is a reference to a 
clause as produced by <A NAME="idx:clause/3:332"></A><A HREF="sec-3.14.html#clause/3">clause/3</A>, <A NAME="idx:nth_clause/3:333"></A><A HREF="sec-3.14.html#nth_clause/3">nth_clause/3</A> 
or <A NAME="idx:prolog_frame_attribute/3:334"></A><A HREF="sec-A.1.html#prolog_frame_attribute/3">prolog_frame_attribute/3</A>.
<VAR>Property</VAR> is one of the following:

<DL>

<P>
<DT><STRONG>file</STRONG>(<VAR>FileName</VAR>)<DD>
Unify <VAR>FileName</VAR> with the name of the sourcefile in which the 
clause is defined. Fails if the clause is not associated to a file.

<P>
<DT><STRONG>line_count</STRONG>(<VAR>LineNumber</VAR>)<DD>
Unify <VAR>LineNumber</VAR> with the line number of the clause. Fails if 
the clause is not associated to a file.

<P>
<DT><STRONG>fact</STRONG><DD>
True if the clause has no body.

<P>
<DT><STRONG>erased</STRONG><DD>
True if the clause has been erased, but not yet reclaimed because it is 
referenced.
</DL>

</DL>

