<HTML><HEAD><TITLE>SWI-Prolog Reference Manual: Section 3.16</TITLE><LINK REL=home HREF="Title.html">
<LINK REL=contents HREF="Contents.html">
<LINK REL=index HREF="Index.html">
<LINK REL=summary HREF="sec-B.html">
<LINK REL=previous HREF="sec-3.15.html">
<LINK REL=next HREF="sec-3.17.html">
</HEAD>

<BODY>

<HR><CENTER><A HREF="Title.html">Home</A>
<A HREF="Contents.html">Contents</A>
<A HREF="Index.html">Index</A>
<A HREF="sec-B.html">Summary</A>
<A HREF="sec-3.15.html">Previous</A>
<A HREF="sec-3.17.html">Next</A>
</CENTER>

<HR>

<H2><A NAME="sec:3.16">3.16 Status of Input and Output Streams</A></H2>

<P>

<DL>

<P>
<DT><A NAME="wait_for_input/3"><STRONG>wait_for_input</STRONG>(<VAR>+ListOfStreams, 
-ReadyList, +TimeOut</VAR>)</A><DD>
Wait for input on one of the streams in <VAR>ListOfStreams</VAR> and 
return a list of streams on which input is available in <VAR>ReadyList</VAR>.
<A NAME="idx:wait_for_input/3:359"></A><A HREF="sec-3.16.html#wait_for_input/3">wait_for_input/3</A> 
waits for at most <VAR>TimeOut</VAR> seconds. <VAR>Timeout</VAR> may be 
specified as a floating point number to specify fractions of a second. 
If <VAR>Timeout</VAR> equals 0, <A NAME="idx:wait_for_input/3:360"></A><A HREF="sec-3.16.html#wait_for_input/3">wait_for_input/3</A> 
waits indefinitely. This predicate can be used to implement timeout 
while reading and to handle input from multiple sources. The following 
example will wait for input from the user and an explicitly opened 
second terminal. On return, <VAR>Inputs</VAR> may hold
<CODE>user</CODE> or <VAR>P4</VAR> or both.

<P>

<XMP>
?- open('/dev/ttyp4', read, P4),
   wait_for_input([user, P4], Inputs, 0).
</XMP>

<P>

<P>
<DT><A NAME="character_count/2"><STRONG>character_count</STRONG>(<VAR>+Stream, 
-Count</VAR>)</A><DD>
Unify <VAR>Count</VAR> with the current character index. For input 
streams this is the number of characters read since the open, for output 
streams this is the number of characters written. Counting starts at 0.

<P>
<DT><A NAME="line_count/2"><STRONG>line_count</STRONG>(<VAR>+Stream, 
-Count</VAR>)</A><DD>
Unify <VAR>Count</VAR> with the number of lines read or written. 
Counting starts at 1.

<P>
<DT><A NAME="line_position/2"><STRONG>line_position</STRONG>(<VAR>+Stream, 
-Count</VAR>)</A><DD>
Unify <VAR>Count</VAR> with the position on the current line. Note that 
this assumes the position is 0 after the open. Tabs are assumed to be 
defined on each 8-th character and backspaces are assumed to reduce the 
count by one, provided it is positive.

<P>
<DT><A NAME="fileerrors/2"><STRONG>fileerrors</STRONG>(<VAR>-Old, +New</VAR>)</A><DD>
Define error behaviour on errors when opening a file for reading or 
writing. Valid values are the atoms <CODE>on</CODE> (default) and <CODE>off</CODE>. 
First <VAR>Old</VAR> is unified with the current value. Then the new 
value is set to <VAR>New</VAR>.<A NAME=back-to-note-13 HREF="Notes.html#note-13"> (13)</A>
</DL>

