<HTML><HEAD><TITLE>SWI-Prolog Reference Manual: Section 3.17</TITLE><LINK REL=home HREF="Title.html">
<LINK REL=contents HREF="Contents.html">
<LINK REL=index HREF="Index.html">
<LINK REL=summary HREF="sec-B.html">
<LINK REL=previous HREF="sec-3.16.html">
<LINK REL=next HREF="sec-3.18.html">
</HEAD>

<BODY>

<HR><CENTER><A HREF="Title.html">Home</A>
<A HREF="Contents.html">Contents</A>
<A HREF="Index.html">Index</A>
<A HREF="sec-B.html">Summary</A>
<A HREF="sec-3.16.html">Previous</A>
<A HREF="sec-3.18.html">Next</A>
</CENTER>

<HR>

<H2><A NAME="sec:3.17">3.17 Primitive Character Input and Output</A></H2>

<P>

<DL>

<P>
<DT><A NAME="nl/0"><STRONG>nl</STRONG></A><DD>
Write a newline character to the current output stream. On Unix systems
<A NAME="idx:nl/0:361"></A><A HREF="sec-3.17.html#nl/0">nl/0</A> is 
equivalent to <CODE>put(10)</CODE>.

<P>
<DT><A NAME="nl/1"><STRONG>nl</STRONG>(<VAR>+Stream</VAR>)</A><DD>
Write a newline to <VAR>Stream</VAR>.

<P>
<DT><A NAME="put/1"><STRONG>put</STRONG>(<VAR>+Char</VAR>)</A><DD>
Write <VAR>Char</VAR> to the current output stream, <VAR>Char</VAR> is 
either an integer-expression evaluating to an ASCII value (<VAR>0 =&lt;<VAR>Char</VAR> 
=&lt; 255</VAR>) or an atom of one character.

<P>
<DT><A NAME="put/2"><STRONG>put</STRONG>(<VAR>+Stream, +Char</VAR>)</A><DD>
Write <VAR>Char</VAR> to <VAR>Stream</VAR>.

<P>
<DT><A NAME="tab/1"><STRONG>tab</STRONG>(<VAR>+Amount</VAR>)</A><DD>
Writes <VAR>Amount</VAR> spaces on the current output stream. <VAR>Amount</VAR> 
should be an expression that evaluates to a positive integer (see
<A HREF="sec-3.23.html">section 3.23</A>).

<P>
<DT><A NAME="tab/2"><STRONG>tab</STRONG>(<VAR>+Stream, +Amount</VAR>)</A><DD>
Writes <VAR>Amount</VAR> spaces to <VAR>Stream</VAR>.

<P>
<DT><A NAME="flush/0"><STRONG>flush</STRONG></A><DD>
Flush pending output on current output stream. <A NAME="idx:flush/0:362"></A><A HREF="sec-3.17.html#flush/0">flush/0</A> 
is automatically generated by <A NAME="idx:read/1:363"></A><A HREF="sec-3.18.html#read/1">read/1</A> 
and derivatives if the current input stream is <CODE>user</CODE> and the 
cursor is not at the left margin.

<P>
<DT><A NAME="flush_output/1"><STRONG>flush_output</STRONG>(<VAR>+Stream</VAR>)</A><DD>
Flush output on the specified stream. The stream must be open for 
writing.

<P>
<DT><A NAME="ttyflush/0"><STRONG>ttyflush</STRONG></A><DD>
Flush pending output on stream <VAR>user</VAR>. See also <A NAME="idx:flush/0:364"></A><A HREF="sec-3.17.html#flush/0">flush/0</A>.

<P>
<DT><A NAME="get0/1"><STRONG>get0</STRONG>(<VAR>-Char</VAR>)</A><DD>
Read the current input stream and unify the next character with <VAR>Char</VAR>.
<VAR>Char</VAR> is unified with -1 on end of file.

<P>
<DT><A NAME="get0/2"><STRONG>get0</STRONG>(<VAR>+Stream, -Char</VAR>)</A><DD>
Read the next character from <VAR>Stream</VAR>.

<P>
<DT><A NAME="get/1"><STRONG>get</STRONG>(<VAR>-Char</VAR>)</A><DD>
Read the current input stream and unify the next non-blank character 
with <VAR>Char</VAR>. <VAR>Char</VAR> is unified with -1 on end of file.

<P>
<DT><A NAME="get/2"><STRONG>get</STRONG>(<VAR>+Stream, -Char</VAR>)</A><DD>
Read the next non-blank character from <VAR>Stream</VAR>.

<P>
<DT><A NAME="peek_byte/1"><STRONG>peek_byte</STRONG>(<VAR>-Char</VAR>)</A><DD>
Reads the next input character like <A NAME="idx:get0/1:365"></A><A HREF="sec-3.17.html#get0/1">get0/1</A>, 
but does not remove it from the input stream. This predicate is ISO 
compliant.

<P>
<DT><A NAME="peek_byte/2"><STRONG>peek_byte</STRONG>(<VAR>+Stream, -Char</VAR>)</A><DD>
Reads the next input character like <A NAME="idx:get0/2:366"></A><A HREF="sec-3.17.html#get0/2">get0/2</A>, 
but does not remove it from the stream. This predicate is ISO compliant.

<P>
<DT><A NAME="skip/1"><STRONG>skip</STRONG>(<VAR>+Char</VAR>)</A><DD>
Read the input until <VAR>Char</VAR> or the end of the file is 
encountered. A subsequent call to <A NAME="idx:get0/1:367"></A><A HREF="sec-3.17.html#get0/1">get0/1</A> 
will read the first character after <VAR>Char</VAR>.

<P>
<DT><A NAME="skip/2"><STRONG>skip</STRONG>(<VAR>+Stream, +Char</VAR>)</A><DD>
Skip input (as <A NAME="idx:skip/1:368"></A><A HREF="sec-3.17.html#skip/1">skip/1</A>) 
on <VAR>Stream</VAR>.

<P>
<DT><A NAME="get_single_char/1"><STRONG>get_single_char</STRONG>(<VAR>-Char</VAR>)</A><DD>
Get a single character from input stream `user' (regardless of the 
current input stream). Unlike <A NAME="idx:get0/1:369"></A><A HREF="sec-3.17.html#get0/1">get0/1</A> 
this predicate does not wait for a return. The character is not echoed 
to the user's terminal. This predicate is meant for keyboard menu 
selection etc.. If SWI-Prolog was started with the <STRONG>-tty</STRONG> 
option this predicate reads an entire line of input and returns the 
first non-blank character on this line, or the ASCII code of the newline 
(10) if the entire line consisted of blank characters.

<P>
<DT><A NAME="at_end_of_stream/0"><STRONG>at_end_of_stream</STRONG></A><DD>
Succeeds after the last character of the current input stream has been 
read. Also succeeds if there is no valid current input stream.

<P>
<DT><A NAME="at_end_of_stream/1"><STRONG>at_end_of_stream</STRONG>(<VAR>+Stream</VAR>)</A><DD>
Succeeds after the last character of the named stream is read, or
<VAR>Stream</VAR> is not a valid input stream.
</DL>

