<HTML><HEAD><TITLE>SWI-Prolog Reference Manual: Section 3.18</TITLE><LINK REL=home HREF="Title.html">
<LINK REL=contents HREF="Contents.html">
<LINK REL=index HREF="Index.html">
<LINK REL=summary HREF="sec-B.html">
<LINK REL=previous HREF="sec-3.17.html">
<LINK REL=next HREF="sec-3.19.html">
</HEAD>

<BODY>

<HR><CENTER><A HREF="Title.html">Home</A>
<A HREF="Contents.html">Contents</A>
<A HREF="Index.html">Index</A>
<A HREF="sec-B.html">Summary</A>
<A HREF="sec-3.17.html">Previous</A>
<A HREF="sec-3.19.html">Next</A>
</CENTER>

<HR>

<H2><A NAME="sec:3.18">3.18 Term Reading and Writing</A></H2>

<P>This section describes the basic term reading and writing predicates. 
The predicates <A NAME="idx:term_to_atom/2:370"></A><A HREF="sec-3.20.html#term_to_atom/2">term_to_atom/2</A> 
and <A NAME="idx:atom_to_term/3:371"></A><A HREF="sec-3.20.html#atom_to_term/3">atom_to_term/3</A> 
provide means for translating atoms and strings to terms. The predicates <A NAME="idx:format/[1,2]:372"></A><A HREF="sec-3.32.html#format/1">format/[1,2]</A> 
and <A NAME="idx:writef/2:373"></A><A HREF="sec-3.32.html#writef/2">writef/2</A> 
provide formatted output.

<P>There are two ways to manipulate the output format. The predicate
<A NAME="idx:print/[1,2]:374"></A><A HREF="sec-3.18.html#print/1">print/[1,2]</A> 
may be programmed using <A NAME="idx:portray/1:375"></A><A HREF="sec-3.18.html#portray/1">portray/1</A>. 
The format of floating point numbers may be manipulated using the 
feature (see <A NAME="idx:feature/2:376"></A><A HREF="sec-2.8.html#feature/2">feature/2</A>)
<CODE>float_format</CODE>.

<P>Reading is sensitive to the feature <CODE>character_escapes</CODE>, 
which controls the interpretation of the <CODE><CODE>\</CODE></CODE> 
character in quoted atoms and strings.

<P>

<DL>

<P>
<DT><A NAME="write_term/2"><STRONG>write_term</STRONG>(<VAR>+Term, 
+Options</VAR>)</A><DD>
The predicate <A NAME="idx:write_term/2:377"></A><A HREF="sec-3.18.html#write_term/2">write_term/2</A> 
is the generic form of all Prolog term-write predicates. Valid options 
are:

<P>

<DL>

<P>
<DT><STRONG>quoted</STRONG>(<VAR><CODE>true</CODE> or <CODE>false</CODE></VAR>)<DD>
If <CODE>true</CODE>, atoms and functors that needs quotes will be 
quoted. The default is <CODE>false</CODE>.

<P>
<DT><STRONG>ignore_ops</STRONG>(<VAR><CODE>true</CODE> or <CODE>false</CODE></VAR>)<DD>
If <CODE>true</CODE>, the generic term-representation (&lt;<VAR>functor</VAR>&gt;(&lt;<VAR>args</VAR>&gt; 
... )) will be used for all terms, Otherwise (default), operators, 
list-notation and <CODE>{}</CODE>/1 will be written using their special 
syntax.

<P>
<DT><STRONG>numbervars</STRONG>(<VAR><CODE>true</CODE> or <CODE>false</CODE></VAR>)<DD>
If <CODE>true</CODE>, terms of the format <CODE>$VAR(N)</CODE>, where &lt;<VAR>N</VAR>&gt; 
is a positive integer, will be written as a variable name. The default 
is
<CODE>false</CODE>.

<P>
<DT><STRONG>portray</STRONG>(<VAR><CODE>true</CODE> or <CODE>false</CODE></VAR>)<DD>
If <CODE>true</CODE>, the hook <A NAME="idx:portray/1:378"></A><A HREF="sec-3.18.html#portray/1">portray/1</A> 
is called before printing a term that is not a variable. If <A NAME="idx:portray/1:379"></A><A HREF="sec-3.18.html#portray/1">portray/1</A> 
succeeds, the term is considered printed. See also <A NAME="idx:print/1:380"></A><A HREF="sec-3.18.html#print/1">print/1</A>. 
The default is <CODE>false</CODE>. This option is an extension to the 
ISO write_term options.
</DL>

<P>
<DT><A NAME="write_term/3"><STRONG>write_term</STRONG>(<VAR>+Stream, 
+Term, +Options</VAR>)</A><DD>
As <A NAME="idx:write_term/2:381"></A><A HREF="sec-3.18.html#write_term/2">write_term/2</A>, 
but output is sent to <VAR>Stream</VAR> rather than the current output.

<P>
<DT><A NAME="write_canonical/1"><STRONG>write_canonical</STRONG>(<VAR>+Term</VAR>)</A><DD>
Write <VAR>Term</VAR> on the current output stream using standard 
parenthesised prefix notation (i.e. ignoring operator declarations). 
Atoms that need quotes are quoted. Terms written with this predicate can 
always be read back, regardless of current operator declarations. 
Equivalent to <A NAME="idx:write_term/2:382"></A><A HREF="sec-3.18.html#write_term/2">write_term/2</A> 
using the options <CODE>ignore_ops</CODE> and
<CODE>quoted</CODE>.

<P>
<DT><A NAME="write_canonical/2"><STRONG>write_canonical</STRONG>(<VAR>+Stream, 
+Term</VAR>)</A><DD>
Write <VAR>Term</VAR> in canonical form on <VAR>Stream</VAR>.

<P>
<DT><A NAME="write/1"><STRONG>write</STRONG>(<VAR>+Term</VAR>)</A><DD>
Write <VAR>Term</VAR> to the current output, using brackets and 
operators where appropriate. See <A NAME="idx:feature/2:383"></A><A HREF="sec-2.8.html#feature/2">feature/2</A> 
for controlling floating point output format.

<P>
<DT><A NAME="write/2"><STRONG>write</STRONG>(<VAR>+Stream, +Term</VAR>)</A><DD>
Write <VAR>Term</VAR> to <VAR>Stream</VAR>.

<P>
<DT><A NAME="writeq/1"><STRONG>writeq</STRONG>(<VAR>+Term</VAR>)</A><DD>
Write <VAR>Term</VAR> to the current output, using brackets and 
operators where appropriate. Atoms that need quotes are quoted. Terms 
written with this predicate can be read back with <A NAME="idx:read/1:384"></A><A HREF="sec-3.18.html#read/1">read/1</A> 
provided the currently active operator declarations are identical.

<P>
<DT><A NAME="writeq/2"><STRONG>writeq</STRONG>(<VAR>+Stream, +Term</VAR>)</A><DD>
Write <VAR>Term</VAR> to <VAR>Stream</VAR>, inserting quotes.

<P>
<DT><A NAME="print/1"><STRONG>print</STRONG>(<VAR>+Term</VAR>)</A><DD>
Prints <VAR>Term</VAR> on the current output stream similar to <A NAME="idx:write/1:385"></A><A HREF="sec-3.18.html#write/1">write/1</A>, 
but for each (sub)term of <VAR>Term</VAR> first the dynamic predicate
<A NAME="idx:portray/1:386"></A><A HREF="sec-3.18.html#portray/1">portray/1</A> 
is called. If this predicate succeeds <VAR>print</VAR> assumes the 
(sub)term has been written. This allows for user defined term writing.

<P>
<DT><A NAME="print/2"><STRONG>print</STRONG>(<VAR>+Stream, +Term</VAR>)</A><DD>
Print <VAR>Term</VAR> to <VAR>Stream</VAR>.

<P>
<DT><A NAME="portray/1"><STRONG>portray</STRONG>(<VAR>+Term</VAR>)</A><DD>
A dynamic predicate, which can be defined by the user to change the 
behaviour of <A NAME="idx:print/1:387"></A><A HREF="sec-3.18.html#print/1">print/1</A> 
on (sub)terms. For each subterm encountered that is not a variable <A NAME="idx:print/1:388"></A><A HREF="sec-3.18.html#print/1">print/1</A> 
first calls <A NAME="idx:portray/1:389"></A><A HREF="sec-3.18.html#portray/1">portray/1</A> 
using the term as argument. For lists only the list as a whole is given 
to <A NAME="idx:portray/1:390"></A><A HREF="sec-3.18.html#portray/1">portray/1</A>. 
If portray succeeds <A NAME="idx:print/1:391"></A><A HREF="sec-3.18.html#print/1">print/1</A> 
assumes the term has been written.

<P>
<DT><A NAME="read/1"><STRONG>read</STRONG>(<VAR>-Term</VAR>)</A><DD>
Read the next Prolog term from the current input stream and unify it 
with <VAR>Term</VAR>. On a syntax error <A NAME="idx:read/1:392"></A><A HREF="sec-3.18.html#read/1">read/1</A> 
displays an error message, attempts to skip the erroneous term and 
fails. On reaching end-of-file
<VAR>Term</VAR> is unified with the atom <CODE>end_of_file</CODE>.

<P>
<DT><A NAME="read/2"><STRONG>read</STRONG>(<VAR>+Stream, -Term</VAR>)</A><DD>
Read <VAR>Term</VAR> from <VAR>Stream</VAR>.

<P>
<DT><A NAME="read_clause/1"><STRONG>read_clause</STRONG>(<VAR>-Term</VAR>)</A><DD>
Equivalent to <A NAME="idx:read/1:393"></A><A HREF="sec-3.18.html#read/1">read/1</A>, 
but warns the user for variables only occurring once in a term 
(singleton variables) which do not start with an underscore if <CODE>style_check(singleton)</CODE> 
is active (default). Used to read Prolog source files (see <A NAME="idx:consult/1:394"></A><A HREF="sec-3.2.html#consult/1">consult/1</A>). 
New code should use <A NAME="idx:read_term/2:395"></A><A HREF="sec-3.18.html#read_term/2">read_term/2</A> 
with the option <CODE>singletons(warning)</CODE>.

<P>
<DT><A NAME="read_clause/2"><STRONG>read_clause</STRONG>(<VAR>+Stream, 
-Term</VAR>)</A><DD>
Read a clause from <VAR>Stream</VAR>. See <A NAME="idx:read_clause/1:396"></A><A HREF="sec-3.18.html#read_clause/1">read_clause/1</A>.

<P>
<DT><A NAME="read_variables/2"><STRONG>read_variables</STRONG>(<VAR>-Term, 
-Bindings</VAR>)</A><DD>
Similar to <A NAME="idx:read/1:397"></A><A HREF="sec-3.18.html#read/1">read/1</A>, 
but <VAR>Bindings</VAR> is unified with a list of `<VAR><VAR>Name</VAR> 
= <VAR>Var</VAR></VAR>' tuples, thus providing access to the actual 
variable names. New code should use <A NAME="idx:read_term/2:398"></A><A HREF="sec-3.18.html#read_term/2">read_term/2</A> 
using the option
<CODE>variables(X)</CODE>.

<P>
<DT><A NAME="read_variables/3"><STRONG>read_variables</STRONG>(<VAR>+Stream, 
-Term, -Bindings</VAR>)</A><DD>
Read, returning term and bindings from <VAR>Stream</VAR>. See
<A NAME="idx:read_variables/2:399"></A><A HREF="sec-3.18.html#read_variables/2">read_variables/2</A>.

<P>
<DT><A NAME="read_term/2"><STRONG>read_term</STRONG>(<VAR>-Term, 
+Options</VAR>)</A><DD>
Read a term from the current input stream and unify the term with <VAR>Term</VAR>. 
The reading is controlled by options from the list of <VAR>Options</VAR>. 
If this list is empty, the behaviour is the same as for
<A NAME="idx:read/1:400"></A><A HREF="sec-3.18.html#read/1">read/1</A>. 
The options are upward compatible to Quintus Prolog. The argument order 
is according to the ISO standard. Options:

<P>

<DL>

<P>
<DT><STRONG>syntax_errors</STRONG>(<VAR>atom or variable</VAR>)<DD>
Define the behaviour for when a syntax error occurs. The possible values 
are:

<DL>

<P>
<DT><STRONG>fail</STRONG><DD>
Default behaviour. The error is reported as a warning and the predicate 
fails.

<P>
<DT><STRONG>quiet</STRONG><DD>
Quietly fails if a syntax error has occurred.

<P>
<DT><STRONG><VAR>Variable</VAR></STRONG><DD>
If no error occurs, the variable is unified with <CODE>none</CODE>, 
otherwise
<VAR>Variable</VAR> is unified with a term of the form

<XMP>
'$stream_position'(CharNo, LineNo, LinePos):Message
</XMP>

<P>This behaviour is a SWI-Prolog extension.
</DL>

<P>

<P>
<DT><STRONG>variable_names</STRONG>(<VAR>Vars</VAR>)<DD>
Unify <VAR>Vars</VAR> with a list of `<VAR>Name</VAR> = <VAR>Var</VAR>', 
where <VAR>Name</VAR> is an atom describing the variable name and <VAR>Var</VAR> 
is a variable that shares with the corresponding variable in <VAR>Term</VAR>.

<P>

<P>
<DT><STRONG>singletons</STRONG>(<VAR>Vars</VAR>)<DD>
As <CODE>variable_names</CODE>, but only reports the variables occurring 
only once in the <VAR>Term</VAR> read. Variables starting with an 
underscore (`<CODE>_</CODE>') are not included in this list.

<P>

<P>
<DT><STRONG>term_position</STRONG>(<VAR>Pos</VAR>)<DD>
Unifies <VAR>Pos</VAR> with the starting position of the term read. <VAR>Pos</VAR> 
if of the same format as use by <A NAME="idx:stream_position/3:401"></A><A HREF="sec-3.15.html#stream_position/3">stream_position/3</A>.

<P>

<P>
<DT><STRONG>subterm_positions</STRONG>(<VAR>TermPos</VAR>)<DD>
Describes the detailed layout of the term. The formats for the various 
types of terms if given below. All positions are character positions. If 
the input is related to a normal stream, these positions are relative to 
the start of the input, when reading from the terminal, they are 
relative to the start of the term.

<DL>

<P>
<DT><VAR>From</VAR>-<VAR>To</VAR><DD>
Used for primitive types (atoms, numbers, variables).

<P>
<DT><STRONG>string_position</STRONG>(<VAR><VAR>From</VAR>, <VAR>To</VAR></VAR>)<DD>
Used to indicate the position of a string enclosed in double quotes (<CODE>"</CODE>).

<P>
<DT><STRONG>brace_term_position</STRONG>(<VAR><VAR>From</VAR>, <VAR>To</VAR>, <VAR>Arg</VAR></VAR>)<DD>
Term of the form <CODE>{...}</CODE>, as used in DCG rules. <VAR>Arg</VAR> 
describes the argument.

<P>
<DT><STRONG>list_position</STRONG>(<VAR><VAR>From</VAR>, <VAR>To</VAR>, <VAR>Elms</VAR>, <VAR>Tail</VAR></VAR>)<DD>
A list. <VAR>Elms</VAR> describes the positions of the elements. If the 
list specifies the tail as <CODE><CODE>|</CODE></CODE>&lt;<VAR>TailTerm</VAR>&gt;, <VAR>Tail</VAR> 
is unified with the term-position of the tail, otherwise with the atom <CODE>none</CODE>.

<P>
<DT><STRONG>term_position</STRONG>(<VAR><VAR>From</VAR>, <VAR>To</VAR>, <VAR>FFrom</VAR>, <VAR>FTo</VAR>, <VAR>SubPos</VAR></VAR>)<DD>
Used for a compound term not matching one of the above. <VAR>FFrom</VAR> 
and <VAR>FTo</VAR> describe the position of the functor. <VAR>SubPos</VAR> 
is a list, each element of which describes the term-position of the 
corresponding subterm.
</DL>

</DL>

<P>
<DT><A NAME="read_term/3"><STRONG>read_term</STRONG>(<VAR>+Stream, 
-Term, +Options</VAR>)</A><DD>
Read term with options from <VAR>Stream</VAR>. See <A NAME="idx:read_term/2:402"></A><A HREF="sec-3.18.html#read_term/2">read_term/2</A>.

<P>
<DT><A NAME="read_history/6"><STRONG>read_history</STRONG>(<VAR>+Show, 
+Help, +Special, +Prompt, -Term, -Bindings</VAR>)</A><DD>
Similar to <A NAME="idx:read_variables/2:403"></A><A HREF="sec-3.18.html#read_variables/2">read_variables/2</A>, 
but allows for history substitutions.
<A NAME="idx:read_history/6:404"></A><A HREF="sec-3.18.html#read_history/6">read_history/6</A> 
is used by the top level to read the user's actions.
<VAR>Show</VAR> is the command the user should type to show the saved 
events.
<VAR>Help</VAR> is the command to get an overview of the capabilities.
<VAR>Special</VAR> is a list of commands that are not saved in the 
history.
<VAR>Prompt</VAR> is the first prompt given. Continuation prompts for 
more lines are determined by <A NAME="idx:prompt/2:405"></A><A HREF="sec-3.18.html#prompt/2">prompt/2</A>. 
A <CODE>%w</CODE> in the prompt is substituted by the event number. See <A HREF="sec-2.4.html">section 
2.4</A> for available substitutions.

<P>SWI-Prolog calls <A NAME="idx:read_history/6:406"></A><A HREF="sec-3.18.html#read_history/6">read_history/6</A> 
as follows:

<P>

<XMP>
read_history(h, '!h', [trace], '%w ?- ', Goal, Bindings)
</XMP>

<P>

<P>
<DT><A NAME="prompt/2"><STRONG>prompt</STRONG>(<VAR>-Old, +New</VAR>)</A><DD>
Set prompt associated with <A NAME="idx:read/1:407"></A><A HREF="sec-3.18.html#read/1">read/1</A> 
and its derivatives. <VAR>Old</VAR> is first unified with the current 
prompt. On success the prompt will be set to <VAR>New</VAR> if this is 
an atom. Otherwise an error message is displayed. A prompt is printed if 
one of the read predicates is called and the cursor is at the left 
margin. It is also printed whenever a newline is given and the term has 
not been terminated. Prompts are only printed when the current input 
stream is <VAR>user</VAR>.

<P>

<P>
<DT><A NAME="prompt1/1"><STRONG>prompt1</STRONG>(<VAR>+Prompt</VAR>)</A><DD>
Sets the prompt for the next line to be read. Continuation lines will be 
read using the prompt defined by <A NAME="idx:prompt/2:408"></A><A HREF="sec-3.18.html#prompt/2">prompt/2</A>.
</DL>

