<HTML><HEAD><TITLE>SWI-Prolog Reference Manual: Section 3.19</TITLE><LINK REL=home HREF="Title.html">
<LINK REL=contents HREF="Contents.html">
<LINK REL=index HREF="Index.html">
<LINK REL=summary HREF="sec-B.html">
<LINK REL=previous HREF="sec-3.18.html">
<LINK REL=next HREF="sec-3.20.html">
</HEAD>

<BODY>

<HR><CENTER><A HREF="Title.html">Home</A>
<A HREF="Contents.html">Contents</A>
<A HREF="Index.html">Index</A>
<A HREF="sec-B.html">Summary</A>
<A HREF="sec-3.18.html">Previous</A>
<A HREF="sec-3.20.html">Next</A>
</CENTER>

<HR>

<H2><A NAME="sec:3.19">3.19 Analysing and Constructing Terms</A></H2>

<P>

<DL>

<P>
<DT><A NAME="functor/3"><STRONG>functor</STRONG>(<VAR>?Term, ?Functor, 
?Arity</VAR>)</A><DD>
Succeeds if <VAR>Term</VAR> is a term with functor <VAR>Functor</VAR> 
and arity
<VAR>Arity</VAR>. If <VAR>Term</VAR> is a variable it is unified with a 
new term holding only variables. <A NAME="idx:functor/3:409"></A><A HREF="sec-3.19.html#functor/3">functor/3</A> 
silently fails on instantiation faults<A NAME=back-to-note-14 HREF="Notes.html#note-14"> (14)</A> 
If <VAR>Term</VAR> is an atom or number, <VAR>Functor</VAR> will be 
unified with
<VAR>Term</VAR> and arity will be unified with the integer 0 (zero).

<P>
<DT><A NAME="arg/3"><STRONG>arg</STRONG>(<VAR>?Arg, ?Term, ?Value</VAR>)</A><DD>
<VAR>Term</VAR> should be instantiated to a term, <VAR>Arg</VAR> to an 
integer between 1 and the arity of <VAR>Term</VAR>. <VAR>Value</VAR> is 
unified with the
<VAR>Arg</VAR>-th argument of <VAR>Term</VAR>. <VAR>Arg</VAR> may also 
be unbound. In this case <VAR>Value</VAR> will be unified with the 
successive arguments of the term. On successful unification, <VAR>Arg</VAR> 
is unified with the argument number. Backtracking yields alternative 
solutions.<A NAME=back-to-note-15 HREF="Notes.html#note-15"> (15)</A> 
The predicate <A NAME="idx:arg/3:410"></A><A HREF="sec-3.19.html#arg/3">arg/3</A> 
fails silently if <VAR><VAR>Arg</VAR> = 0</VAR> or
<VAR><VAR>Arg</VAR> &gt; </EM><EM>arity</EM></VAR> and raises the 
exception
<CODE>domain_error(not_less_then_zero, <VAR>Arg</VAR>)</CODE> if <VAR><VAR>Arg</VAR> 
&lt; 0</VAR>.

<P>

<P>
<DT><A NAME="setarg/3"><STRONG>setarg</STRONG>(<VAR>+Arg, +Term, +Value</VAR>)</A><DD>
Extra-logical predicate. Assigns the <VAR>Arg</VAR>-th argument of the 
compound term <VAR>Term</VAR> with the given <VAR>Value</VAR>. The 
assignment is undone if backtracking brings the state back into a 
position before the <A NAME="idx:setarg/3:411"></A><A HREF="sec-3.19.html#setarg/3">setarg/3</A> 
call.

<P>This predicate may be used for destructive assignment to terms, using 
them as and extra-logical storage bin.

<P>
<DT><A NAME="=../2"><VAR>?Term</VAR> <STRONG>=..</STRONG> <VAR>?List</VAR></A><DD>
<VAR>List</VAR> is a list which head is the functor of <VAR>Term</VAR> 
and the remaining arguments are the arguments of the term. Each of the 
arguments may be a variable, but not both. This predicate is called 
`Univ'. Examples:

<XMP>
?- foo(hello, X) =.. List.

List = [foo, hello, X]

?- Term =.. [baz, foo(1)]

Term = baz(foo(1))
</XMP>

<P>

<P>
<DT><A NAME="numbervars/4"><STRONG>numbervars</STRONG>(<VAR>+Term, 
+Functor, +Start, -End</VAR>)</A><DD>
Unify the free variables of <VAR>Term</VAR> with a term constructed from 
the atom <VAR>Functor</VAR> with one argument. The argument is the 
number of the variable. Counting starts at <VAR>Start</VAR>. <VAR>End</VAR> 
is unified with the number that should be given to the next variable. 
Example:

<XMP>
?- numbervars(foo(A, B, A), this_is_a_variable, 0, End).

A = this_is_a_variable(0)
B = this_is_a_variable(1)
End = 2
</XMP>

<P>In Edinburgh Prolog the second argument is missing. It is fixed to be
<CODE>$VAR</CODE>.

<P>
<DT><A NAME="free_variables/2"><STRONG>free_variables</STRONG>(<VAR>+Term, 
-List</VAR>)</A><DD>
Unify <VAR>List</VAR> with a list of variables, each sharing with a 
unique variable of <VAR>Term</VAR>. For example:

<XMP>
?- free_variables(a(X, b(Y, X), Z), L).

L = [G367, G366, G371]
X = G367
Y = G366
Z = G371
</XMP>

<P>

<P>
<DT><A NAME="copy_term/2"><STRONG>copy_term</STRONG>(<VAR>+In, -Out</VAR>)</A><DD>
Make a copy of term <VAR>In</VAR> and unify the result with <VAR>Out</VAR>. 
Ground parts of <VAR>In</VAR> are shared by <VAR>Out</VAR>. Provided <VAR>In</VAR> 
and
<VAR>Out</VAR> have no sharing variables before this call they will have 
no sharing variables afterwards. <A NAME="idx:copy_term/2:412"></A><A HREF="sec-3.19.html#copy_term/2">copy_term/2</A> 
is semantically equivalent to:

<XMP>
copy_term(In, Out) :-
        recorda(copy_key, In, Ref),
        recorded(copy_key, Out, Ref),
        erase(Ref).
</XMP>

<P>
</DL>

