<HTML><HEAD><TITLE>SWI-Prolog Reference Manual: Section 3.2</TITLE><LINK REL=home HREF="Title.html">
<LINK REL=contents HREF="Contents.html">
<LINK REL=index HREF="Index.html">
<LINK REL=summary HREF="sec-B.html">
<LINK REL=previous HREF="sec-3.1.html">
<LINK REL=next HREF="sec-3.3.html">
</HEAD>

<BODY>

<HR><CENTER><A HREF="Title.html">Home</A>
<A HREF="Contents.html">Contents</A>
<A HREF="Index.html">Index</A>
<A HREF="sec-B.html">Summary</A>
<A HREF="sec-3.1.html">Previous</A>
<A HREF="sec-3.3.html">Next</A>
</CENTER>

<HR>

<H2><A NAME="sec:3.2">3.2 Consulting Prolog Source files</A></H2>

<A NAME="sec:consulting"></A>

<P>SWI-Prolog source files normally have a suffix `<CODE>.pl</CODE>'. 
Specifying the suffix is optional. All predicates that handle source 
files first check whether a file with suffix `<CODE>.pl</CODE>' exists. 
If not the plain file name is checked for existence. Library files are 
specified by embedding the file name using the functor library/1 . Thus 
`<CODE>foo</CODE>' refers to `<CODE>foo.pl</CODE>' or `<CODE>foo</CODE>' 
in the current directory, `<CODE>library(foo)</CODE>' refers to `<CODE>foo.pl</CODE>' 
or `<CODE>foo</CODE>' in one of the library directories specified by the 
dynamic predicate <A NAME="idx:library_directory/1:151"></A><A HREF="sec-3.2.html#library_directory/1">library_directory/1</A>. 
The user may specify other `aliases' than <CODE>library</CODE> using the 
predicate
<A NAME="idx:file_search_path/2:152"></A><A HREF="sec-3.2.html#file_search_path/2">file_search_path/2</A>. 
This is strongly encouraged for managing complex applications. See also <A NAME="idx:absolute_file_name/[2,3]:153"></A><A HREF="sec-3.35.html#absolute_file_name/2">absolute_file_name/[2,3]</A>.

<P>SWI-Prolog recognises grammar rules as defined in <CITE><A HREF="sec-C.html#Clocksin:87">Clocksin &amp; 
Melish, 1987</A></CITE>. The user may define additional compilation of 
the source file by defining the dynamic predicate <A NAME="idx:term_expansion/2:154"></A><A HREF="sec-3.2.html#term_expansion/2">term_expansion/2</A>. 
Transformations by this predicate overrule the systems grammar rule 
transformations. It is not allowed to use <A NAME="idx:assert/1:155"></A><A HREF="sec-3.12.html#assert/1">assert/1</A>, <A NAME="idx:retract/1:156"></A><A HREF="sec-3.12.html#retract/1">retract/1</A> 
or any other database predicate in
<A NAME="idx:term_expansion/2:157"></A><A HREF="sec-3.2.html#term_expansion/2">term_expansion/2</A> 
other than for local computational purposes.<A NAME=back-to-note-8 HREF="Notes.html#note-8"> (8)</A>

<P>Directives may be placed anywhere in a source file, invoking any 
predicate. They are executed when encountered. If the directive fails, a 
warning is printed. Directives are specified by :-/1 or ?-/1. There is 
no difference between the two.

<P>SWI-Prolog does not have a separate <A NAME="idx:reconsult/1:158"></A><B>reconsult/1</B> 
predicate. Reconsulting is implied automatically by the fact that a file 
is consulted which is already loaded.

<P>

<DL>

<P>
<DT><A NAME="load_files/2"><STRONG>load_files</STRONG>(<VAR>+Files, 
+Options</VAR>)</A><DD>
The predicate <A NAME="idx:load_files/2:159"></A><A HREF="sec-3.2.html#load_files/2">load_files/2</A> 
is the parent of all the other loading predicates. It currently supports 
a subset of the options of Quintus
<A NAME="idx:load_files/2:160"></A><A HREF="sec-3.2.html#load_files/2">load_files/2</A>. <VAR>Files</VAR> 
is either specifies a single, or a list of source-files. The 
specification for a source-file is handled
<A NAME="idx:absolute_file_name/2:161"></A><A HREF="sec-3.35.html#absolute_file_name/2">absolute_file_name/2</A>. 
See this predicate for the supported expansions.
<VAR>Options</VAR> is a list of options using the format
<BLOCKQUOTE>
<VAR>OptionName</VAR>(<VAR>OptionValue</VAR>)
</BLOCKQUOTE> The following options are currently supported:

<P>

<DL>

<P>
<DT><STRONG>if</STRONG>(<VAR>Condition</VAR>)<DD>
Load the file only if the specified condition is satisfied. The value
<CODE>true</CODE> loads the file unconditionally, <CODE>changed</CODE> 
loads the file if it was not loaded before, or has been modified since 
it was loaded the last time, <CODE>not_loaded</CODE> loads the file if 
it was not loaded before.

<P>
<DT><STRONG>must_be_module</STRONG>(<VAR>Bool</VAR>)<DD>
If <CODE>true</CODE>, raise an error if the file is not a module file. 
Used by
<A NAME="idx:use_module/[1,2]:162"></A><A HREF="sec-4.4.html#use_module/1">use_module/[1,2]</A>.

<P>
<DT><STRONG>imports</STRONG>(<VAR>ListOrAll</VAR>)<DD>
If <CODE>all</CODE> and the file is a module file, import all public 
predicates. Otherwise import only the named predicates. Each predicate 
is refered to as &lt;<VAR>name</VAR>&gt;/&lt;<VAR>arity</VAR>&gt;. This 
option has no effect if the file is not a module file.

<P>
<DT><STRONG>silent</STRONG>(<VAR>Bool</VAR>)<DD>
If <CODE>true</CODE>, load the file without printing a message. The 
specified value is the default for all files loaded as a result of 
loading the specified files.
</DL>

<P>

<P>
<DT><A NAME="consult/1"><STRONG>consult</STRONG>(<VAR>+File</VAR>)</A><DD>
Read <VAR>File</VAR> as a Prolog source file. <VAR>File</VAR> may be a 
list of files, in which case all members are consulted in turn. <VAR>File</VAR> 
may start with the csh(1) special sequences <CODE><CODE>~</CODE></CODE>, <CODE><CODE>~</CODE>&lt;<VAR>user</VAR>&gt;</CODE> 
and
<CODE><CODE>$</CODE>&lt;<VAR>var</VAR>&gt;</CODE>. <VAR>File</VAR> may 
also be <CODE>library(Name)</CODE>, in which case the libraries are 
searched for a file with the specified name. See also <A NAME="idx:library_directory/1:163"></A><A HREF="sec-3.2.html#library_directory/1">library_directory/1</A> 
and <A NAME="idx:file_search_path/2:164"></A><A HREF="sec-3.2.html#file_search_path/2">file_search_path/2</A>. <A NAME="idx:consult/1:165"></A><A HREF="sec-3.2.html#consult/1">consult/1</A> 
may be abbreviated by just typing a number of file names in a list. 
Examples:

<P><CENTER>
<TABLE BORDER=0 COLS=2 FRAME=void RULES=group>
<TR VALIGN=top><TD><CODE>?- consult(load).</CODE> <TD>% consult <CODE>load</CODE> 
or <CODE>load.pl</CODE> </TR>
<TR VALIGN=top><TD><CODE>?- [library(quintus)]</CODE>.<TD>% load Quintus 
compatibility library </TR>
</TABLE>

</CENTER> Equivalent to load_files(Files, []).

<P>
<DT><A NAME="ensure_loaded/1"><STRONG>ensure_loaded</STRONG>(<VAR>+File</VAR>)</A><DD>
If the file is not already loaded, this is equivalent to <A NAME="idx:consult/1:166"></A><A HREF="sec-3.2.html#consult/1">consult/1</A>. 
Otherwise, if the file defines a module, import all public predicates. 
Finally, if the file is already loaded, is not a module file and the 
context module is not the global user module, <A NAME="idx:ensure_loaded/1:167"></A><A HREF="sec-3.2.html#ensure_loaded/1">ensure_loaded/1</A> 
will call <A NAME="idx:consult/1:168"></A><A HREF="sec-3.2.html#consult/1">consult/1</A>.

<P>With the semantics, we hope to get as closely possible to the clear 
semantics without the presence of a module system. Applications using 
modules should consider using <A NAME="idx:use_module/[1,2]:169"></A><A HREF="sec-4.4.html#use_module/1">use_module/[1,2]</A>.

<P>Equivalent to load_files(Files, [if(changed)]).

<P>
<DT><A NAME="require/1"><STRONG>require</STRONG>(<VAR>+ListOfNameAndArity</VAR>)</A><DD>
Declare that this file/module requires the specified predicates to be 
defined ``with their commonly accepted definition''. This predicate 
originates from the Prolog portability layer for XPCE. It is intended to 
provide a portable mechanism for specifying that this module requires 
the specified predicates.

<P>The implementation normally first verifies whether the predicate is 
already defined. If not, it will search the libraries and load the 
required library.

<P>SWI-Prolog, having autoloading, does </EM><B>not</B> load the 
library. Instead it creates a procedure header for the predicate if this 
does not exist. This will flag the predicate as `undefined'. See also <A NAME="idx:check/0:170"></A><B>check/0</B> 
and
<A NAME="idx:autoload/0:171"></A><A HREF="sec-6.html#autoload/0">autoload/0</A>.

<P>
<DT><A NAME="make/0"><STRONG>make</STRONG></A><DD>
Consult all source files that have been changed since they were 
consulted. It checks <VAR>all</VAR> loaded source files: files loaded 
into a compiled state using <CODE>pl -c ...</CODE> and files loaded 
using consult or one of its derivatives. <A NAME="idx:make/0:172"></A><A HREF="sec-3.2.html#make/0">make/0</A> 
is normally invoked by the <A NAME="idx:edit/[0,1]:173"></A><A HREF="sec-3.3.html#edit/0">edit/[0,1]</A> 
and <A NAME="idx:ed/[0,1]:174"></A><A HREF="sec-3.3.html#ed/0">ed/[0,1]</A> 
predicates. <A NAME="idx:make/0:175"></A><A HREF="sec-3.2.html#make/0">make/0</A> 
can be combined with the compiler to speed up the development of large 
packages. In this case compile the package using

<P>

<XMP>
sun% pl -g make -o my_program -c file ...
</XMP>

<P>If `my_program' is started it will first reconsult all source files 
that have changed since the compilation.

<P>
<DT><A NAME="library_directory/1"><STRONG>library_directory</STRONG>(<VAR>?Atom</VAR>)</A><DD>
Dynamic predicate used to specify library directories. Default
<CODE>./lib</CODE>, <CODE><CODE>~</CODE>/lib/prolog</CODE> and the 
system's library (in this order) are defined. The user may add library 
directories using <A NAME="idx:assert/1:176"></A><A HREF="sec-3.12.html#assert/1">assert/1</A>, <A NAME="idx:asserta/1:177"></A><A HREF="sec-3.12.html#asserta/1">asserta/1</A> 
or remove system defaults using <A NAME="idx:retract/1:178"></A><A HREF="sec-3.12.html#retract/1">retract/1</A>.

<P>

<P>
<DT><A NAME="file_search_path/2"><STRONG>file_search_path</STRONG>(<VAR>+Alias, 
?Path</VAR>)</A><DD>
Dynamic predicate used to specify `path-aliases'. This feature is best 
described using an example. Given the definition

<P>

<XMP>
file_search_path(demo, '~/demo').
</XMP>

<P>the file specification <CODE>demo(myfile)</CODE> will be expanded to
<CODE><CODE>~</CODE>/demo/myfile</CODE>. The second argument of <A NAME="idx:file_search_path/2:179"></A><A HREF="sec-3.2.html#file_search_path/2">file_search_path/2</A> 
may be another alias.

<P>Below is the initial definition of the file search path. This path 
implies <CODE>swi(&lt;<VAR>Path</VAR>&gt;)</CODE> refers to a file in 
the SWI-Prolog home directory. The alias <CODE>foreign(&lt;<VAR>Path</VAR>&gt;)</CODE> 
is intended for storing shared libraries (<CODE>.so</CODE> or <CODE>.DLL</CODE> 
files). See also
<A NAME="idx:load_foreign_library/[1,2]:180"></A><A HREF="sec-5.4.html#load_foreign_library/1">load_foreign_library/[1,2]</A>.

<P>

<XMP>
user:file_search_path(library, X) :-
        library_directory(X).
user:file_search_path(swi, Home) :-
        feature(home, Home).
user:file_search_path(foreign, swi(ArchLib)) :-
        feature(arch, Arch),
        concat('lib/', Arch, ArchLib).
user:file_search_path(foreign, swi(lib)).
</XMP>

<P>The <A NAME="idx:file_search_path/2:181"></A><A HREF="sec-3.2.html#file_search_path/2">file_search_path/2</A> 
expansion is used by all loading predicates as well as by <A NAME="idx:absolute_file_name/2:182"></A><A HREF="sec-3.35.html#absolute_file_name/2">absolute_file_name/2</A>.

<P>

<P>
<DT><A NAME="expand_file_search_path/2"><STRONG>expand_file_search_path</STRONG>(<VAR>+Spec, 
-Path</VAR>)</A><DD>
Unifies <VAR>Path</VAR> will all possible expansions of the file name 
specification <VAR>Spec</VAR>. See also <A NAME="idx:absolute_file_name/3:183"></A><A HREF="sec-3.35.html#absolute_file_name/3">absolute_file_name/3</A>.

<P>

<P>
<DT><A NAME="source_file/1"><STRONG>source_file</STRONG>(<VAR>?File</VAR>)</A><DD>
Succeeds if <VAR>File</VAR> was loaded using <A NAME="idx:consult/1:184"></A><A HREF="sec-3.2.html#consult/1">consult/1</A> 
or <A NAME="idx:ensure_loaded/1:185"></A><A HREF="sec-3.2.html#ensure_loaded/1">ensure_loaded/1</A>.
<VAR>File</VAR> refers to the full path name of the file (see
<A NAME="idx:expand_file_name/2:186"></A><A HREF="sec-3.35.html#expand_file_name/2">expand_file_name/2</A>). 
The predicate <A NAME="idx:source_file/1:187"></A><A HREF="sec-3.2.html#source_file/1">source_file/1</A> 
backtracks over all loaded source files.

<P>
<DT><A NAME="source_file/2"><STRONG>source_file</STRONG>(<VAR>?Pred, 
?File</VAR>)</A><DD>
Is true if the predicate specified by <VAR>Pred</VAR> was loaded from 
file
<VAR>File</VAR>, where <VAR>File</VAR> is an absolute path name (see
<A NAME="idx:expand_file_name/2:188"></A><A HREF="sec-3.35.html#expand_file_name/2">expand_file_name/2</A>). 
Can be used with any instantiation pattern, but the database only 
maintains the source file for each predicate. Predicates declared <CODE>multifile</CODE> 
(see <A NAME="idx:multifile/1:189"></A><A HREF="sec-3.13.html#multifile/1">multifile/1</A>) 
cannot be found this way.

<P>
<DT><A NAME="prolog_load_context/2"><STRONG>prolog_load_context</STRONG>(<VAR>?Key, 
?Value</VAR>)</A><DD>
Determine loading context. The following keys are defined:
<CENTER>
<TABLE BORDER=2 COLS=2 FRAME=border RULES=group>
<TR VALIGN=top><TD></EM><B>Key</B><TD></EM><B>Description </B></TR>
<TBODY>
<TR VALIGN=top><TD><CODE>module</CODE> <TD>Module into which file is 
loaded </TR>
<TR VALIGN=top><TD><CODE>file</CODE> <TD>File loaded </TR>
<TR VALIGN=top><TD><CODE>stream</CODE> <TD>Stream identifier (see <A NAME="idx:current_input/1:190"></A><A HREF="sec-3.15.html#current_input/1">current_input/1</A>) </TR>
<TR VALIGN=top><TD><CODE>directory</CODE> <TD>Directory in which <VAR>File</VAR> 
lives. </TR>
<TR VALIGN=top><TD><CODE>term_position</CODE> <TD>Position of last term 
read. Term of the form </EM><TT>'$stream_position'(0,&lt;<VAR>Line</VAR>&gt;,0,0,0)</TT> </TR>
</TABLE>

</CENTER> Quintus compatibility predicate. See also <A NAME="idx:source_location/2:191"></A><A HREF="sec-3.2.html#source_location/2">source_location/2</A>.

<P>
<DT><A NAME="source_location/2"><STRONG>source_location</STRONG>(<VAR>-File, 
-Line</VAR>)</A><DD>
If the last term has been read from a physical file (i.e. not from the 
file <CODE>user</CODE> or a string), unify <VAR>File</VAR> with an 
absolute path to the file and <VAR>Line</VAR> with the line-number in 
the file. New code should use <A NAME="idx:prolog_load_context/2:192"></A><A HREF="sec-3.2.html#prolog_load_context/2">prolog_load_context/2</A>.

<P>
<DT><A NAME="term_expansion/2"><STRONG>term_expansion</STRONG>(<VAR>+Term1, 
-Term2</VAR>)</A><DD>
Dynamic predicate, normally not defined. When defined by the user all 
terms read during consulting that are given to this predicate. If the 
predicate succeeds Prolog will assert <VAR>Term2</VAR> in the database 
rather then the read term (<VAR>Term1</VAR>). <VAR>Term2</VAR> may be a 
term of a the form `?- <VAR>Goal</VAR>' or `:- <VAR>Goal</VAR>'. <VAR>Goal</VAR> 
is then treated as a directive. If <VAR>Term2</VAR> is a list all terms 
of the list are stored in the database or called (for directives). If <VAR>Term2</VAR> 
is of the form below, the system will assert <VAR>Clause</VAR> and 
record the indicated source-location with it.
<BLOCKQUOTE>
</EM><TT>'$source_location'(&lt;<VAR>File</VAR>&gt;, &lt;<VAR>Line</VAR>&gt;):&lt;<VAR>Clause</VAR>&gt;</TT>
</BLOCKQUOTE> When compiling a module (see <A HREF="sec-4.html">chapter 
4</A> and the directive <A NAME="idx:module/2:193"></A><A HREF="sec-4.8.html#module/2">module/2</A>),
<A NAME="idx:expand_term/2:194"></A><A HREF="sec-3.2.html#expand_term/2">expand_term/2</A> 
will first try <A NAME="idx:term_expansion/2:195"></A><A HREF="sec-3.2.html#term_expansion/2">term_expansion/2</A> 
in the module being compiled to allow for term-expansion rules that are 
local to a module. If there is no local definition, or the local 
definition fails to translate the term, <A NAME="idx:expand_term/2:196"></A><A HREF="sec-3.2.html#expand_term/2">expand_term/2</A> 
will try user:<A NAME="idx:term_expansion/2:197"></A><A HREF="sec-3.2.html#term_expansion/2">term_expansion/2</A>. 
For compatibility with SICStus and Quintus Prolog, this feature should 
not be used. See also <A NAME="idx:expand_term/2:198"></A><A HREF="sec-3.2.html#expand_term/2">expand_term/2</A>.

<P>
<DT><A NAME="expand_term/2"><STRONG>expand_term</STRONG>(<VAR>+Term1, 
-Term2</VAR>)</A><DD>
This predicate is normally called by the compiler to perform 
preprocessing. First it calls <A NAME="idx:term_expansion/2:199"></A><A HREF="sec-3.2.html#term_expansion/2">term_expansion/2</A>. 
If this predicate fails it performs a grammar-rule translation. If this 
fails it returns the first argument.

<P>
<DT><A NAME="at_initialization/1"><STRONG>at_initialization</STRONG>(<VAR>+Goal</VAR>)</A><DD>
Register <VAR>Goal</VAR> to be ran when the system initialises. 
Initialisation takes place after reloading a .qlf (formerly .wic) file 
as well as after reloading a saved-state. The hooks are run in the order 
they were registered. A warning message is issued if <VAR>Goal</VAR> 
fails, but execution continues. See also <A NAME="idx:at_halt/1:200"></A><A HREF="sec-3.2.html#at_halt/1">at_halt/1</A>

<P>
<DT><A NAME="at_halt/1"><STRONG>at_halt</STRONG>(<VAR>+Goal</VAR>)</A><DD>
Register <VAR>Goal</VAR> to be ran when the system halts. The hooks are 
run in the order they were registered. Success or failure executing a 
hook is ignored. These hooks may not call <A NAME="idx:halt/[0,1]:201"></A><A HREF="sec-3.36.html#halt/0">halt/[0,1]</A>.

<P>
<DT><A NAME="initialization/1"><STRONG>initialization</STRONG>(<VAR>+Goal</VAR>)</A><DD>
Call <VAR>Goal</VAR> and register it using <A NAME="idx:at_initialization/1:202"></A><A HREF="sec-3.2.html#at_initialization/1">at_initialization/1</A>. 
Directives that do other things that creating clauses, records, flags or 
setting predicate attributes should normally be written using this tag 
to ensure the initialisation is executed when a saved system starts. See 
also <A NAME="idx:qsave_program/[1,2]:203"></A><A HREF="sec-6.html#qsave_program/1">qsave_program/[1,2]</A>.

<P>
<DT><A NAME="compiling/0"><STRONG>compiling</STRONG></A><DD>
Succeeds if the system is compiling source files with the <STRONG>-c</STRONG> 
option into an intermediate code file. Can be used to perform code 
optimisations in <A NAME="idx:expand_term/2:204"></A><A HREF="sec-3.2.html#expand_term/2">expand_term/2</A> 
under this condition.

<P>
<DT><A NAME="preprocessor/2"><STRONG>preprocessor</STRONG>(<VAR>-Old, 
+New</VAR>)</A><DD>
Read the input file via a Unix process that acts as preprocessor. A 
preprocessor is specified as an atom. The first occurrence of the string 
`<CODE>%f</CODE>' is replaced by the name of the file to be loaded. The 
resulting atom is called as a Unix command and the standard output of 
this command is loaded. To use the Unix C preprocessor one should 
define:

<P>

<XMP>
?- preprocessor(Old, '/lib/cpp -C -P %f'), consult(...).

Old = none
</XMP>

<P>
</DL>

<P>

<H3><A NAME="sec:3.2.1">3.2.1 Quick Load Files</A></H3>

<P>The features described in this section should be regarded </EM><B>alpha</B>.

<P>As of version 2.0.0, SWI-Prolog supports compilation of individual or 
multiple Prolog sourcefiles into `Quick Load Files'. A `Quick Load 
Files' (<CODE>.qlf</CODE> file) stores the contents of the file in a 
precompiled format very similar to compiled files created using the <STRONG>-b</STRONG> 
and <STRONG>-c</STRONG> flags (see <A HREF="sec-2.7.html">section 2.7</A>).

<P>These files load considerably faster than sourcefiles and are 
normally more compact. They are machine independent and may thus be 
loaded on any implementation of SWI-Prolog. Note however that clauses 
are stored as virtual machine instructions. Changes to the compiler will 
generally make old compiled files unusable.

<P>Quick Load Files are created using <A NAME="idx:qcompile/1:205"></A><A HREF="sec-3.2.html#qcompile/1">qcompile/1</A>. 
They may be loaded explicitly using <A NAME="idx:qload/1:206"></A><A HREF="sec-3.2.html#qload/1">qload/1</A> 
or implicitly using <A NAME="idx:consult/1:207"></A><A HREF="sec-3.2.html#consult/1">consult/1</A> 
or one of the other file-loading predicates described in
<A HREF="sec-3.2.html">section 3.2</A>. If consult is given the explicit
<CODE>.pl</CODE> file, it will load the Prolog source. When given the
<CODE>.qlf</CODE> file, it will call <A NAME="idx:qload/1:208"></A><A HREF="sec-3.2.html#qload/1">qload/1</A> 
to load the file. When no extension is specified, it will load the <CODE>.qlf</CODE> 
file when present and the fileextpl file otherwise.

<P>

<DL>

<P>
<DT><A NAME="qcompile/1"><STRONG>qcompile</STRONG>(<VAR>+File</VAR>)</A><DD>
Takes a single file specification like <A NAME="idx:consult/1:209"></A><A HREF="sec-3.2.html#consult/1">consult/1</A> 
(i.e. accepts constructs like <CODE>library(LibFile)</CODE> and creates 
a Quick Load File from <VAR>File</VAR>. The file-extension of this file 
is <CODE>.qlf</CODE>. The base name of the Quick Load File is the same 
as the input file.

<P>If the file contains `<CODE>:- consult(<VAR>+File</VAR>)</CODE>' or `<CODE>:- 
[<VAR>+File</VAR>]</CODE>' statements, the referred files are compiled 
into the same <CODE>.qlf</CODE> file. Other directives will be stored in 
the
<CODE>.qlf</CODE> file and executed in the same fashion as when loading 
the
<CODE>.pl</CODE> file.

<P>For <A NAME="idx:term_expansion/2:210"></A><A HREF="sec-3.2.html#term_expansion/2">term_expansion/2</A>, 
the same rules as described in
<A HREF="sec-2.7.html">section 2.7</A> apply.

<P>Source references (<A NAME="idx:source_file/2:211"></A><A HREF="sec-3.2.html#source_file/2">source_file/2</A>) 
in the Quick Load File refer to the Prolog source file from which the 
compiled code originates.

<P>
<DT><A NAME="qload/1"><STRONG>qload</STRONG>(<VAR>+File</VAR>)</A><DD>
Loads the `Quick Load File'. It has the same semantics as <A NAME="idx:consult/1:212"></A><A HREF="sec-3.2.html#consult/1">consult/1</A> 
for a normal sourcefile. Equivalent to <CODE>consult(<VAR>File</VAR>)</CODE> 
iff <VAR>File</VAR> refers to a `Quick Load File'.
</DL>

