<HTML><HEAD><TITLE>SWI-Prolog Reference Manual: Section 3.20</TITLE><LINK REL=home HREF="Title.html">
<LINK REL=contents HREF="Contents.html">
<LINK REL=index HREF="Index.html">
<LINK REL=summary HREF="sec-B.html">
<LINK REL=previous HREF="sec-3.19.html">
<LINK REL=next HREF="sec-3.21.html">
</HEAD>

<BODY>

<HR><CENTER><A HREF="Title.html">Home</A>
<A HREF="Contents.html">Contents</A>
<A HREF="Index.html">Index</A>
<A HREF="sec-B.html">Summary</A>
<A HREF="sec-3.19.html">Previous</A>
<A HREF="sec-3.21.html">Next</A>
</CENTER>

<HR>

<H2><A NAME="sec:3.20">3.20 Analysing and Constructing Atoms</A></H2>

<P>These predicates convert between Prolog constants and lists of ASCII 
values. The predicates <A NAME="idx:atom_chars/2:413"></A><A HREF="sec-3.20.html#atom_chars/2">atom_chars/2</A>, <A NAME="idx:number_chars/2:414"></A><A HREF="sec-3.20.html#number_chars/2">number_chars/2</A> 
and <A NAME="idx:name/2:415"></A><A HREF="sec-3.20.html#name/2">name/2</A> 
behave the same when converting from a constant to a list of ASCII 
values. When converting the other way around, <A NAME="idx:atom_chars/2:416"></A><A HREF="sec-3.20.html#atom_chars/2">atom_chars/2</A> 
will generate an atom, number_chars will generate a number or fail and <A NAME="idx:name/2:417"></A><A HREF="sec-3.20.html#name/2">name/2</A> 
will return a number if possible and an atom otherwise.

<P>

<DL>

<P>
<DT><A NAME="atom_chars/2"><STRONG>atom_chars</STRONG>(<VAR>?Atom, 
?String</VAR>)</A><DD>
Convert between an atom and a list of ASCII values. If <VAR>Atom</VAR> 
is instantiated, if will be translated into a list of ASCII values and 
the result is unified with <VAR>String</VAR>. If <VAR>Atom</VAR> is 
unbound and <VAR>String</VAR> is a list of ASCII values, it will <VAR>Atom</VAR> 
will be unified with an atom constructed from this list.

<P>
<DT><A NAME="atom_char/2"><STRONG>atom_char</STRONG>(<VAR>?Atom, ?ASCII</VAR>)</A><DD>
Convert between character and ASCII value for a single character.

<P>
<DT><A NAME="number_chars/2"><STRONG>number_chars</STRONG>(<VAR>?Number, 
?String</VAR>)</A><DD>
Similar to <A NAME="idx:atom_chars/2:418"></A><A HREF="sec-3.20.html#atom_chars/2">atom_chars/2</A>, 
but converts between a number and its representation as a list of ASCII 
values. Fails silently if <VAR>Number</VAR> is unbound and <VAR>String</VAR> 
does not describe a number.

<P>
<DT><A NAME="name/2"><STRONG>name</STRONG>(<VAR>?AtomOrInt, ?String</VAR>)</A><DD>
<VAR>String</VAR> is a list of ASCII values describing <VAR>Atom</VAR>. 
Each of the arguments may be a variable, but not both. When <VAR>String</VAR> 
is bound to an ASCII value list describing an integer and <VAR>Atom</VAR> 
is a variable <VAR>Atom</VAR> will be unified with the integer value 
described by <VAR>String</VAR> (e.g. `<CODE>name(N, "300"), 400 is N + 
100</CODE>' succeeds).

<P>
<DT><A NAME="int_to_atom/3"><STRONG>int_to_atom</STRONG>(<VAR>+Int, 
+Base, -Atom</VAR>)</A><DD>
Convert <VAR>Int</VAR> to an </EM><font size=-1>ASCII</font> 
representation using base <VAR>Base</VAR> and unify the result with <VAR>Atom</VAR>. 
If <VAR><VAR>Base</VAR> &lt;&gt; 10</VAR> the base will be prepended to <VAR>Atom</VAR>. <VAR><VAR>Base</VAR> 
= 0</VAR> will try to interpret
<VAR>Int</VAR> as an ASCII value and return <CODE>0'</CODE>&lt;<VAR>c</VAR>&gt;. 
Otherwise <VAR>2 =&lt;<VAR>Base</VAR> =&lt; 36</VAR>. Some examples are 
given below.

<P><CENTER>
<TABLE BORDER=0 COLS=3 FRAME=void RULES=group>
<TR VALIGN=top><TD>int_to_atom(45, 2, A)<TD ALIGN=center><VAR>--&gt;</VAR> <TD><VAR>A 
= 2'101101</VAR> </TR>
<TR VALIGN=top><TD>int_to_atom(97, 0, A)<TD ALIGN=center><VAR>--&gt;</VAR> <TD><VAR>A 
= 0'a</VAR> </TR>
<TR VALIGN=top><TD>int_to_atom(56, 10, A)<TD ALIGN=center><VAR>--&gt;</VAR> <TD><VAR>A 
= 56</VAR> </TR>
</TABLE>

</CENTER>

<P>

<P>
<DT><A NAME="int_to_atom/2"><STRONG>int_to_atom</STRONG>(<VAR>+Int, 
-Atom</VAR>)</A><DD>
Equivalent to <CODE>int_to_atom(Int, 10, Atom)</CODE>.

<P>
<DT><A NAME="term_to_atom/2"><STRONG>term_to_atom</STRONG>(<VAR>?Term, 
?Atom</VAR>)</A><DD>
Succeeds if <VAR>Atom</VAR> describes a term that unifies with <VAR>Term</VAR>. 
When
<VAR>Atom</VAR> is instantiated <VAR>Atom</VAR> is converted and then 
unified with
<VAR>Term</VAR>. Otherwise <VAR>Term</VAR> is ``written'' on <VAR>Atom</VAR> 
using <A NAME="idx:write/1:419"></A><A HREF="sec-3.18.html#write/1">write/1</A>.

<P>
<DT><A NAME="atom_to_term/3"><STRONG>atom_to_term</STRONG>(<VAR>+Atom, 
-Term, -Bindings</VAR>)</A><DD>
Use <VAR>Atom</VAR> as input to <A NAME="idx:read_variables/2:420"></A><A HREF="sec-3.18.html#read_variables/2">read_variables/2</A> 
and return the read term in
<VAR>Term</VAR> and the variable bindings in <VAR>Bindings</VAR>. <VAR>Bindings</VAR> 
is a list of <VAR><VAR>Name</VAR> = <VAR>Var</VAR></VAR> couples, thus 
providing access to the actual variable names. See also <A NAME="idx:read_variables/2:421"></A><A HREF="sec-3.18.html#read_variables/2">read_variables/2</A>.

<P>
<DT><A NAME="concat/3"><STRONG>concat</STRONG>(<VAR>?Atom1, ?Atom2, 
?Atom3</VAR>)</A><DD>
<VAR>Atom3</VAR> forms the concatenation of <VAR>Atom1</VAR> and <VAR>Atom2</VAR>. 
At least two of the arguments must be instantiated to atoms, integers or 
floating point numbers.

<P>
<DT><A NAME="concat_atom/2"><STRONG>concat_atom</STRONG>(<VAR>+List, 
-Atom</VAR>)</A><DD>
<VAR>List</VAR> is a list of atoms, integers or floating point numbers. 
Succeeds if <VAR>Atom</VAR> can be unified with the concatenated 
elements of <VAR>List</VAR>. If
<VAR>List</VAR> has exactly 2 elements it is equivalent to <A NAME="idx:concat/3:422"></A><A HREF="sec-3.20.html#concat/3">concat/3</A>, 
allowing for variables in the list.

<P>
<DT><A NAME="concat_atom/3"><STRONG>concat_atom</STRONG>(<VAR>+List, 
+Separator, -Atom</VAR>)</A><DD>
Creates an atom just like <A NAME="idx:concat_atom/2:423"></A><A HREF="sec-3.20.html#concat_atom/2">concat_atom/2</A>, 
but inserts <VAR>Separator</VAR> between each pair of atoms. For 
example:

<XMP>
?- concat_atom([gnu, gnat], ', ', A).

A = 'gnu, gnat'
</XMP>

<P>

<P>
<DT><A NAME="atom_length/2"><STRONG>atom_length</STRONG>(<VAR>+Atom, 
-Length</VAR>)</A><DD>
Succeeds if <VAR>Atom</VAR> is an atom of <VAR>Length</VAR> characters 
long. This predicate also works for integers and floats, expressing the 
number of characters output when given to <A NAME="idx:write/1:424"></A><A HREF="sec-3.18.html#write/1">write/1</A>.

<P>
<DT><A NAME="atom_prefix/2"><STRONG>atom_prefix</STRONG>(<VAR>+Atom, 
+Prefix</VAR>)</A><DD>
Succeeds if <VAR>Atom</VAR> starts with the characters from <VAR>Prefix</VAR>. 
Its behaviour is equivalent to <CODE>?- concat(<VAR>Prefix</VAR>, _, <VAR>Atom</VAR>)</CODE>, 
but avoids the construction of an atom for the `remainder'.
</DL>

