<HTML><HEAD><TITLE>SWI-Prolog Reference Manual: Section 3.21</TITLE><LINK REL=home HREF="Title.html">
<LINK REL=contents HREF="Contents.html">
<LINK REL=index HREF="Index.html">
<LINK REL=summary HREF="sec-B.html">
<LINK REL=previous HREF="sec-3.20.html">
<LINK REL=next HREF="sec-3.22.html">
</HEAD>

<BODY>

<HR><CENTER><A HREF="Title.html">Home</A>
<A HREF="Contents.html">Contents</A>
<A HREF="Index.html">Index</A>
<A HREF="sec-B.html">Summary</A>
<A HREF="sec-3.20.html">Previous</A>
<A HREF="sec-3.22.html">Next</A>
</CENTER>

<HR>

<H2><A NAME="sec:3.21">3.21 Representing Text in Strings</A></H2>

<A NAME="sec:strings"></A>

<P>SWI-Prolog supports the data type <VAR>string</VAR>. Strings are a 
time and space efficient mechanism to handle text in Prolog. Atoms are 
under some circumstances not suitable because garbage collection on them 
is next to impossible (Although it is possible: BIM_prolog does it). 
Representing text as a list of ASCII values is, from the logical point 
of view, the cleanest solution. It however has two drawbacks: 1) they 
cannot be distinguished from a list of (small) integers; and 2) they 
consume (in SWI-Prolog) 12 bytes for each character stored.

<P>Within strings each character only requires 1 byte storage. Strings 
live on the global stack and their storage is thus reclaimed on 
backtracking. Garbage collection can easily deal with strings.

<P>The ISO standard proposes <CODE>" ... "</CODE> is transformed into a 
string object by <A NAME="idx:read/1:425"></A><A HREF="sec-3.18.html#read/1">read/1</A> 
and derivatives. This poses problems as in the old convention <CODE>" 
... "</CODE> is transformed into a list of </EM><font size=-1>ASCII</font> 
characters. For this reason the style check option `<CODE>string</CODE>' 
is available (see <A NAME="idx:style_check/1:426"></A><A HREF="sec-3.38.html#style_check/1">style_check/1</A>).

<P>The set of predicates associated with strings is incomplete and 
tentative. Names and definitions might change in the future to confirm 
to the emerging standard.

<P>

<DL>

<P>
<DT><A NAME="string_to_atom/2"><STRONG>string_to_atom</STRONG>(<VAR>?String, 
?Atom</VAR>)</A><DD>
Logical conversion between a string and an atom. At least one of the two 
arguments must be instantiated. <VAR>Atom</VAR> can also be an integer 
or floating point number.

<P>
<DT><A NAME="string_to_list/2"><STRONG>string_to_list</STRONG>(<VAR>?String, 
?List</VAR>)</A><DD>
Logical conversion between a string and a list of ASCII characters. At 
least one of the two arguments must be instantiated.

<P>
<DT><A NAME="string_length/2"><STRONG>string_length</STRONG>(<VAR>+String, 
-Length</VAR>)</A><DD>
Unify <VAR>Length</VAR> with the number of characters in <VAR>String</VAR>. 
This predicate is functionally equivalent to <A NAME="idx:atom_length/2:427"></A><A HREF="sec-3.20.html#atom_length/2">atom_length/2</A> 
and also accepts atoms, integers and floats as its first argument.

<P>
<DT><A NAME="string_concat/3"><STRONG>string_concat</STRONG>(<VAR>?String1, 
?String2, ?String3</VAR>)</A><DD>
Similar to <A NAME="idx:concat/3:428"></A><A HREF="sec-3.20.html#concat/3">concat/3</A>, 
but the unbound argument will be unified with a string object rather 
than an atom. Also, if both <VAR>String1</VAR> and
<VAR>String2</VAR> are unbound and <VAR>String3</VAR> is bound to text, 
it breaks <VAR>String3</VAR>, unifying the start with <VAR>String1</VAR> 
and the end with <VAR>String2</VAR> as append does with lists. Note that 
this is not particularly fast on long strings as for each redo the 
system has to create two entirely new strings, while the list equivalent 
only creates a single new list-cell and moves some pointers around.

<P>
<DT><A NAME="substring/4"><STRONG>substring</STRONG>(<VAR>+String, 
+Start, +Length, -Sub</VAR>)</A><DD>
Create a substring of <VAR>String</VAR> that starts at character <VAR>Start</VAR> 
(1 base) and has <VAR>Length</VAR> characters. Unify this substring with
<VAR>Sub</VAR>.<A NAME=back-to-note-16 HREF="Notes.html#note-16"> (16)</A>
</DL>

