<HTML><HEAD><TITLE>SWI-Prolog Reference Manual: Section 3.22</TITLE><LINK REL=home HREF="Title.html">
<LINK REL=contents HREF="Contents.html">
<LINK REL=index HREF="Index.html">
<LINK REL=summary HREF="sec-B.html">
<LINK REL=previous HREF="sec-3.21.html">
<LINK REL=next HREF="sec-3.23.html">
</HEAD>

<BODY>

<HR><CENTER><A HREF="Title.html">Home</A>
<A HREF="Contents.html">Contents</A>
<A HREF="Index.html">Index</A>
<A HREF="sec-B.html">Summary</A>
<A HREF="sec-3.21.html">Previous</A>
<A HREF="sec-3.23.html">Next</A>
</CENTER>

<HR>

<H2><A NAME="sec:3.22">3.22 Operators</A></H2>

<P>

<DL>

<P>
<DT><A NAME="op/3"><STRONG>op</STRONG>(<VAR>+Precedence, +Type, +Name</VAR>)</A><DD>
Declare <VAR>Name</VAR> to be an operator of type <VAR>Type</VAR> with 
precedence
<VAR>Precedence</VAR>. <VAR>Name</VAR> can also be a list of names, in 
which case all elements of the list are declared to be identical 
operators. <VAR>Precedence</VAR> is an integer between 0 and 1200. 
Precedence 0 removes the declaration. <VAR>Type</VAR> is one of: <CODE>xf</CODE>, <CODE>yf</CODE>,
<CODE>xfx</CODE>, <CODE>xfy</CODE>, <CODE>yfx</CODE>, <CODE>yfy</CODE>, <CODE>fy</CODE> 
or <CODE>fx</CODE>. The `<CODE>f</CODE>' indicates the position of the 
functor, while <CODE>x</CODE> and <CODE>y</CODE> indicate the position 
of the arguments. `<CODE>y</CODE>' should be interpreted as ``on this 
position a term with precedence lower or equal to the precedence of the 
functor should occur''. For `<CODE>x</CODE>' the precedence of the 
argument must be strictly lower. The precedence of a term is 0, unless 
its principal functor is an operator, in which case the precedence is 
the precedence of this operator. A term enclosed in brackets <CODE>( ... 
)</CODE> has precedence 0.

<P>The predefined operators are shown in <A HREF="sec-3.22.html#tab:operators">table 
3</A>. Note that all operators can be redefined by the user.

<P>
<CENTER>
<TABLE BORDER=2 COLS=3 FRAME=border RULES=group>
<TR VALIGN=top><TD ALIGN=right>1200<TD ALIGN=char CHAR=f>xfx<TD><STRONG><CODE>--&gt;</CODE></STRONG>, <STRONG><CODE>:-</CODE></STRONG> </TR>
<TR VALIGN=top><TD ALIGN=right>1200<TD ALIGN=char CHAR=f>fx<TD><STRONG><CODE>:-</CODE></STRONG>, <STRONG><CODE>?-</CODE></STRONG> </TR>
<TR VALIGN=top><TD ALIGN=right>1150<TD ALIGN=char CHAR=f>fx<TD><STRONG>dynamic</STRONG>, <STRONG>multifile</STRONG>, <STRONG>module_transparent</STRONG>,
<STRONG>discontiguous</STRONG>, <STRONG>volatile</STRONG>, <STRONG>initialization</STRONG></TR>
<TR VALIGN=top><TD ALIGN=right>1100<TD ALIGN=char CHAR=f>xfy<TD><STRONG><CODE>;</CODE></STRONG>, <STRONG><CODE>|</CODE></STRONG> </TR>
<TR VALIGN=top><TD ALIGN=right>1050<TD ALIGN=char CHAR=f>xfy<TD><STRONG><CODE>-&gt;</CODE></STRONG> </TR>
<TR VALIGN=top><TD ALIGN=right>1000<TD ALIGN=char CHAR=f>xfy<TD><STRONG><CODE>,</CODE></STRONG> </TR>
<TR VALIGN=top><TD ALIGN=right>954<TD ALIGN=char CHAR=f>xfy<TD><STRONG><CODE>\</CODE></STRONG> </TR>
<TR VALIGN=top><TD ALIGN=right>900<TD ALIGN=char CHAR=f>fy<TD><STRONG><CODE>\+</CODE></STRONG>, <STRONG>not</STRONG> </TR>
<TR VALIGN=top><TD ALIGN=right>900<TD ALIGN=char CHAR=f>fx<TD><STRONG><CODE>~</CODE></STRONG> </TR>
<TR VALIGN=top><TD ALIGN=right>700<TD ALIGN=char CHAR=f>xfx<TD><STRONG><CODE>&lt;</CODE></STRONG>, <STRONG><CODE>=</CODE></STRONG>, <STRONG><CODE>=..</CODE></STRONG>, <STRONG><CODE>=@=</CODE></STRONG>, <STRONG><CODE>=:=</CODE></STRONG>, <STRONG><CODE>=&lt;</CODE></STRONG>, <STRONG><CODE>==</CODE></STRONG>,
<STRONG><CODE>=\=</CODE></STRONG>, <STRONG><CODE>&gt;</CODE></STRONG>, <STRONG><CODE>&gt;=</CODE></STRONG>, <STRONG><CODE>@&lt;</CODE></STRONG>, <STRONG><CODE>@=&lt;</CODE></STRONG>, <STRONG><CODE>@&gt;</CODE></STRONG>,
<STRONG><CODE>@&gt;=</CODE></STRONG>, <STRONG><CODE>\=</CODE></STRONG>, <STRONG><CODE>\==</CODE></STRONG>, <STRONG>is</STRONG> </TR>
<TR VALIGN=top><TD ALIGN=right>600<TD ALIGN=char CHAR=f>xfy<TD><STRONG><CODE>:</CODE></STRONG> </TR>
<TR VALIGN=top><TD ALIGN=right>500<TD ALIGN=char CHAR=f>yfx<TD><STRONG><CODE>+</CODE></STRONG>, <STRONG><CODE>-</CODE></STRONG>, <STRONG><CODE>/\</CODE></STRONG>, <STRONG><CODE>\/</CODE></STRONG>, <STRONG>xor</STRONG> </TR>
<TR VALIGN=top><TD ALIGN=right>500<TD ALIGN=char CHAR=f>fx<TD><STRONG><CODE>+</CODE></STRONG>, <STRONG><CODE>-</CODE></STRONG>, <STRONG><CODE>?</CODE></STRONG>, <STRONG><CODE>\</CODE></STRONG> </TR>
<TR VALIGN=top><TD ALIGN=right>400<TD ALIGN=char CHAR=f>yfx<TD><STRONG><CODE>*</CODE></STRONG>, <STRONG><CODE>/</CODE></STRONG>, <STRONG><CODE>//</CODE></STRONG>, <STRONG><CODE>&lt;&lt;</CODE></STRONG>, <STRONG><CODE>&gt;&gt;</CODE></STRONG>, <STRONG>mod</STRONG>,
<STRONG>rem</STRONG> </TR>
<TR VALIGN=top><TD ALIGN=right>200<TD ALIGN=char CHAR=f>xfx<TD><STRONG><CODE>**</CODE></STRONG> </TR>
<TR VALIGN=top><TD ALIGN=right>200<TD ALIGN=char CHAR=f>xfy<TD><STRONG><CODE>^</CODE></STRONG> </TR>
</TABLE>

</CENTER>
<CENTER><B>Table 3 : System operators</B></CENTER>
<A NAME="tab:operators"></A>

<P>

<P>
<DT><A NAME="current_op/3"><STRONG>current_op</STRONG>(<VAR>?Precedence, 
?Type, ?Name</VAR>)</A><DD>
Succeeds when <VAR>Name</VAR> is currently defined as an operator of 
type <VAR>Type</VAR> with precedence <VAR>Precedence</VAR>. See also <A NAME="idx:op/3:429"></A><A HREF="sec-3.22.html#op/3">op/3</A>.
</DL>

