<HTML><HEAD><TITLE>SWI-Prolog Reference Manual: Section 3.25</TITLE><LINK REL=home HREF="Title.html">
<LINK REL=contents HREF="Contents.html">
<LINK REL=index HREF="Index.html">
<LINK REL=summary HREF="sec-B.html">
<LINK REL=previous HREF="sec-3.24.html">
<LINK REL=next HREF="sec-3.26.html">
</HEAD>

<BODY>

<HR><CENTER><A HREF="Title.html">Home</A>
<A HREF="Contents.html">Contents</A>
<A HREF="Index.html">Index</A>
<A HREF="sec-B.html">Summary</A>
<A HREF="sec-3.24.html">Previous</A>
<A HREF="sec-3.26.html">Next</A>
</CENTER>

<HR>

<H2><A NAME="sec:3.25">3.25 Adding Arithmetic Functions</A></H2>

<P>Prolog predicates can be given the role of arithmetic function. The 
last argument is used to return the result, the arguments before the 
last are the inputs. Arithmetic functions are added using the predicate <A NAME="idx:arithmetic_function/1:442"></A><A HREF="sec-3.25.html#arithmetic_function/1">arithmetic_function/1</A>, 
which takes the head as its argument. Arithmetic functions are module 
sensitive, that is they are only visible from the module in which the 
function is defined and declared. Global arithmetic functions should be 
defined and registered from module <CODE>user</CODE>. Global definitions 
can be overruled locally in modules. The builtin functions described 
above can be redefined as well.

<P>

<DL>

<P>
<DT><A NAME="arithmetic_function/1"><STRONG>arithmetic_function</STRONG>(<VAR>+Head</VAR>)</A><DD>
Register a Prolog predicate as an arithmetic function (see <A NAME="idx:is/2:443"></A><A HREF="sec-3.23.html#is/2">is/2</A>,
<A HREF="sec-3.23.html#>/2">&gt;/2</A>, etc.). The Prolog predicate 
should have one more argument than specified by <VAR>Head</VAR>, which 
it either a term <VAR>Name/Arity</VAR>, an atom or a complex term. This 
last argument is an unbound variable at call time and should be 
instantiated to an integer or floating point number. The other arguments 
are the parameters. This predicate is module sensitive and will declare 
the arithmetic function only for the context module, unless declared 
from module <CODE>user</CODE>. Example:

<P>

<XMP>
1 ?- [user].
:- arithmetic_function(mean/2).

mean(A, B, C) :-
        C is (A+B)/2.
user compiled, 0.07 sec, 440 bytes.

Yes
2 ?- A is mean(4, 5).

A = 4.500000
</XMP>

<P>

<P>
<DT><A NAME="current_arithmetic_function/1"><STRONG>current_arithmetic_function</STRONG>(<VAR>?Head</VAR>)</A><DD>
Successively unifies all arithmetic functions that are visible from the 
context module with <VAR>Head</VAR>.
</DL>

