<HTML><HEAD><TITLE>SWI-Prolog Reference Manual: Section 3.26</TITLE><LINK REL=home HREF="Title.html">
<LINK REL=contents HREF="Contents.html">
<LINK REL=index HREF="Index.html">
<LINK REL=summary HREF="sec-B.html">
<LINK REL=previous HREF="sec-3.25.html">
<LINK REL=next HREF="sec-3.27.html">
</HEAD>

<BODY>

<HR><CENTER><A HREF="Title.html">Home</A>
<A HREF="Contents.html">Contents</A>
<A HREF="Index.html">Index</A>
<A HREF="sec-B.html">Summary</A>
<A HREF="sec-3.25.html">Previous</A>
<A HREF="sec-3.27.html">Next</A>
</CENTER>

<HR>

<H2><A NAME="sec:3.26">3.26 List Manipulation</A></H2>

<P>

<DL>

<P>
<DT><A NAME="is_list/1"><STRONG>is_list</STRONG>(<VAR>+Term</VAR>)</A><DD>
Succeeds if <VAR>Term</VAR> is bound to the empty list (<CODE></CODE>) 
or a term with functor `<CODE><CODE>.</CODE></CODE>' and arity&nbsp;2.

<P>
<DT><A NAME="proper_list/1"><STRONG>proper_list</STRONG>(<VAR>+Term</VAR>)</A><DD>
Equivalent to <A NAME="idx:is_list/1:444"></A><A HREF="sec-3.26.html#is_list/1">is_list/1</A>, 
but also requires the tail of the list to be a list (recursively). 
Examples:

<XMP>
is_list([x|A])          % true
proper_list([x|A])      % false
</XMP>

<P>

<P>
<DT><A NAME="append/3"><STRONG>append</STRONG>(<VAR>?List1, ?List2, 
?List3</VAR>)</A><DD>
Succeeds when <VAR>List3</VAR> unifies with the concatenation of <VAR>List1</VAR> 
and <VAR>List2</VAR>. The predicate can be used with any instantiation 
pattern (even three variables).

<P>
<DT><A NAME="member/2"><STRONG>member</STRONG>(<VAR>?Elem, ?List</VAR>)</A><DD>
Succeeds when <VAR>Elem</VAR> can be unified with one of the members of <VAR>List</VAR>. 
The predicate can be used with any instantiation pattern.

<P>
<DT><A NAME="memberchk/2"><STRONG>memberchk</STRONG>(<VAR>?Elem, +List</VAR>)</A><DD>
Equivalent to <A NAME="idx:member/2:445"></A><A HREF="sec-3.26.html#member/2">member/2</A>, 
but leaves no choice point.

<P>
<DT><A NAME="delete/3"><STRONG>delete</STRONG>(<VAR>+List1, ?Elem, 
?List2</VAR>)</A><DD>
Delete all members of <VAR>List1</VAR> that simultaneously unify with <VAR>Elem</VAR> 
and unify the result with <VAR>List2</VAR>.

<P>
<DT><A NAME="select/3"><STRONG>select</STRONG>(<VAR>?List1, ?Elem, 
?List2</VAR>)</A><DD>
Select an element of <VAR>List1</VAR> that unifies with <VAR>Elem</VAR>. <VAR>List2</VAR> 
is unified with the list remaining from <VAR>List1</VAR> after deleting 
the selected element. Normally used with the instantiation pattern <VAR>+List1, 
-Elem, -List2</VAR>, but can also be used to insert an element in a list 
using <VAR>-List1, +Elem, +List2</VAR>.

<P>
<DT><A NAME="nth0/3"><STRONG>nth0</STRONG>(<VAR>?Index, ?List, ?Elem</VAR>)</A><DD>
Succeeds when the <VAR>Index</VAR>-th element of <VAR>List</VAR> unifies 
with
<VAR>Elem</VAR>. Counting starts at 0.

<P>
<DT><A NAME="nth1/3"><STRONG>nth1</STRONG>(<VAR>?Index, ?List, ?Elem</VAR>)</A><DD>
Succeeds when the <VAR>Index</VAR>-th element of <VAR>List</VAR> unifies 
with
<VAR>Elem</VAR>. Counting starts at 1.

<P>
<DT><A NAME="last/2"><STRONG>last</STRONG>(<VAR>?Elem, ?List</VAR>)</A><DD>
Succeeds if <VAR>Elem</VAR> unifies with the last element of <VAR>List</VAR>.

<P>
<DT><A NAME="reverse/2"><STRONG>reverse</STRONG>(<VAR>+List1, -List2</VAR>)</A><DD>
Reverse the order of the elements in <VAR>List1</VAR> and unify the 
result with the elements of <VAR>List2</VAR>.

<P>
<DT><A NAME="flatten/2"><STRONG>flatten</STRONG>(<VAR>+List1, -List2</VAR>)</A><DD>
Transform <VAR>List1</VAR>, possibly holding lists as elements into a 
`flat' list by replacing each list with its elements (recursively). 
Unify the resulting flat list with <VAR>List2</VAR>. Example:

<XMP>
?- flatten([a, [b, [c, d], e]], X).

X = [a, b, c, d, e]
</XMP>

<P>

<P>
<DT><A NAME="length/2"><STRONG>length</STRONG>(<VAR>?List, ?Int</VAR>)</A><DD>
Succeeds if <VAR>Int</VAR> represents the number of elements of list <VAR>List</VAR>. 
Can be used to create a list holding only variables.

<P>
<DT><A NAME="merge/3"><STRONG>merge</STRONG>(<VAR>+List1, +List2, -List3</VAR>)</A><DD>
<VAR>List1</VAR> and <VAR>List2</VAR> are lists, sorted to the standard 
order of terms (see <A HREF="sec-3.5.html">section 3.5</A>). <VAR>List3</VAR> 
will be unified with an ordered list holding both the elements of <VAR>List1</VAR> 
and <VAR>List2</VAR>. Duplicates are </EM><B>not</B> removed.
</DL>

