<HTML><HEAD><TITLE>SWI-Prolog Reference Manual: Section 3.27</TITLE><LINK REL=home HREF="Title.html">
<LINK REL=contents HREF="Contents.html">
<LINK REL=index HREF="Index.html">
<LINK REL=summary HREF="sec-B.html">
<LINK REL=previous HREF="sec-3.26.html">
<LINK REL=next HREF="sec-3.28.html">
</HEAD>

<BODY>

<HR><CENTER><A HREF="Title.html">Home</A>
<A HREF="Contents.html">Contents</A>
<A HREF="Index.html">Index</A>
<A HREF="sec-B.html">Summary</A>
<A HREF="sec-3.26.html">Previous</A>
<A HREF="sec-3.28.html">Next</A>
</CENTER>

<HR>

<H2><A NAME="sec:3.27">3.27 Set Manipulation</A></H2>

<P>

<DL>

<P>
<DT><A NAME="is_set/1"><STRONG>is_set</STRONG>(<VAR>+Set</VAR>)</A><DD>
Succeeds if <VAR>Set</VAR> is a proper list (see <A NAME="idx:proper_list/1:446"></A><A HREF="sec-3.26.html#proper_list/1">proper_list/1</A>) 
without duplicates.

<P>
<DT><A NAME="list_to_set/2"><STRONG>list_to_set</STRONG>(<VAR>+List, 
-Set</VAR>)</A><DD>
Unifies <VAR>Set</VAR> with a list holding the same elements as <VAR>List</VAR> 
in the same order. If <VAR>list</VAR> contains duplicates, only the 
first is retained. See also <A NAME="idx:sort/2:447"></A><A HREF="sec-3.28.html#sort/2">sort/2</A>. 
Example:

<XMP>
?- list_to_set([a,b,a], X)

X = [a,b]
</XMP>

<P>

<P>
<DT><A NAME="intersection/3"><STRONG>intersection</STRONG>(<VAR>+Set1, 
+Set2, -Set3</VAR>)</A><DD>
Succeeds if <VAR>Set3</VAR> unifies with the intersection of <VAR>Set1</VAR> 
and
<VAR>Set2</VAR>. <VAR>Set1</VAR> and <VAR>Set2</VAR> are lists without 
duplicates. They need not be ordered.

<P>
<DT><A NAME="subtract/3"><STRONG>subtract</STRONG>(<VAR>+Set, +Delete, 
-Result</VAR>)</A><DD>
Delete all elements of set `Delete' from `Set' and unify the resulting 
set with `Result'.

<P>
<DT><A NAME="union/3"><STRONG>union</STRONG>(<VAR>+Set1, +Set2, -Set3</VAR>)</A><DD>
Succeeds if <VAR>Set3</VAR> unifies with the union of <VAR>Set1</VAR> 
and
<VAR>Set2</VAR>. <VAR>Set1</VAR> and <VAR>Set2</VAR> are lists without 
duplicates. They need not be ordered.

<P>
<DT><A NAME="subset/2"><STRONG>subset</STRONG>(<VAR>+Subset, +Set</VAR>)</A><DD>
Succeeds if all elements of <VAR>Subset</VAR> are elements of <VAR>Set</VAR> 
as well.

<P>
<DT><A NAME="merge_set/3"><STRONG>merge_set</STRONG>(<VAR>+Set1, +Set2, 
-Set3</VAR>)</A><DD>
<VAR>Set1</VAR> and <VAR>Set2</VAR> are lists without duplicates, sorted 
to the standard order of terms. <VAR>Set3</VAR> is unified with an 
ordered list without duplicates holding the union of the elements of <VAR>Set1</VAR> 
and <VAR>Set2</VAR>.
</DL>

