<HTML><HEAD><TITLE>SWI-Prolog Reference Manual: Section 3.28</TITLE><LINK REL=home HREF="Title.html">
<LINK REL=contents HREF="Contents.html">
<LINK REL=index HREF="Index.html">
<LINK REL=summary HREF="sec-B.html">
<LINK REL=previous HREF="sec-3.27.html">
<LINK REL=next HREF="sec-3.29.html">
</HEAD>

<BODY>

<HR><CENTER><A HREF="Title.html">Home</A>
<A HREF="Contents.html">Contents</A>
<A HREF="Index.html">Index</A>
<A HREF="sec-B.html">Summary</A>
<A HREF="sec-3.27.html">Previous</A>
<A HREF="sec-3.29.html">Next</A>
</CENTER>

<HR>

<H2><A NAME="sec:3.28">3.28 Sorting Lists</A></H2>

<P>

<DL>

<P>
<DT><A NAME="sort/2"><STRONG>sort</STRONG>(<VAR>+List, -Sorted</VAR>)</A><DD>
Succeeds if <VAR>Sorted</VAR> can be unified with a list holding the 
elements of <VAR>List</VAR>, sorted to the standard order of terms (see
<A HREF="sec-3.5.html">section 3.5</A>). Duplicates are removed. 
Implemented by translating the input list into a temporary array, 
calling the C-library function
<STRONG>qsort</STRONG>(3) using <A HREF="sec-5.6.html#PL_compare()">PL_compare()</A> 
for comparing the elements, after which the result is translated into 
the result list.

<P>
<DT><A NAME="msort/2"><STRONG>msort</STRONG>(<VAR>+List, -Sorted</VAR>)</A><DD>
Equivalent to <A NAME="idx:sort/2:448"></A><A HREF="sec-3.28.html#sort/2">sort/2</A>, 
but does not remove duplicates.

<P>
<DT><A NAME="keysort/2"><STRONG>keysort</STRONG>(<VAR>+List, -Sorted</VAR>)</A><DD>
<VAR>List</VAR> is a list of <CODE><VAR>Key</VAR>-<VAR>Value</VAR></CODE> 
pairs (e.g. terms of the functor `<CODE><CODE>-</CODE></CODE>' with 
arity&nbsp;2). <A NAME="idx:keysort/2:449"></A><A HREF="sec-3.28.html#keysort/2">keysort/2</A> 
sorts <VAR>List</VAR> like <A NAME="idx:msort/2:450"></A><A HREF="sec-3.28.html#msort/2">msort/2</A>, 
but only compares the keys. Can be used to sort terms not on standard 
order, but on any criterion that can be expressed on a multi-dimensional 
scale. Sorting on more than one criterion can be done using terms as 
keys, putting the first criterion as argument 1, the second as argument 
2, etc. The order of multiple elements that have the same <VAR>Key</VAR> 
is not changed.

<P>
<DT><A NAME="predsort/3"><STRONG>predsort</STRONG>(<VAR>+Pred, +List, 
-Sorted</VAR>)</A><DD>
Sorts similar to <A NAME="idx:msort/2:451"></A><A HREF="sec-3.28.html#msort/2">msort/2</A>, 
but determines the order of two terms by applying <VAR>Pred</VAR> to 
pairs of elements from <VAR>List</VAR> (see <A NAME="idx:apply/2:452"></A><A HREF="sec-3.7.html#apply/2">apply/2</A>). 
The predicate should succeed if the first element should be before the 
second.
</DL>

