<HTML><HEAD><TITLE>SWI-Prolog Reference Manual: Section 3.29</TITLE><LINK REL=home HREF="Title.html">
<LINK REL=contents HREF="Contents.html">
<LINK REL=index HREF="Index.html">
<LINK REL=summary HREF="sec-B.html">
<LINK REL=previous HREF="sec-3.28.html">
<LINK REL=next HREF="sec-3.30.html">
</HEAD>

<BODY>

<HR><CENTER><A HREF="Title.html">Home</A>
<A HREF="Contents.html">Contents</A>
<A HREF="Index.html">Index</A>
<A HREF="sec-B.html">Summary</A>
<A HREF="sec-3.28.html">Previous</A>
<A HREF="sec-3.30.html">Next</A>
</CENTER>

<HR>

<H2><A NAME="sec:3.29">3.29 Finding all Solutions to a Goal</A></H2>

<P>

<DL>

<P>
<DT><A NAME="findall/3"><STRONG>findall</STRONG>(<VAR>+Var, +Goal, -Bag</VAR>)</A><DD>
Creates a list of the instantiations <VAR>Var</VAR> gets successively on 
backtracking over <VAR>Goal</VAR> and unifies the result with <VAR>Bag</VAR>. 
Succeeds with an empty list if <VAR>Goal</VAR> has no solutions. <A NAME="idx:findall/3:453"></A><A HREF="sec-3.29.html#findall/3">findall/3</A> 
is equivalent to <A NAME="idx:bagof/3:454"></A><A HREF="sec-3.29.html#bagof/3">bagof/3</A> 
with all free variables bound with the existence operator (<STRONG><CODE>^</CODE></STRONG>), 
except that <A NAME="idx:bagof/3:455"></A><A HREF="sec-3.29.html#bagof/3">bagof/3</A> 
fails when goal has no solutions.

<P>
<DT><A NAME="bagof/3"><STRONG>bagof</STRONG>(<VAR>+Var, +Goal, -Bag</VAR>)</A><DD>
Unify <VAR>Bag</VAR> with the alternatives of <VAR>Var</VAR>, if <VAR>Goal</VAR> 
has free variables besides the one sharing with <VAR>Var</VAR> bagof 
will backtrack over the alternatives of these free variables, unifying <VAR>Bag</VAR> 
with the corresponding alternatives of <VAR>Var</VAR>. The construct
<CODE>+<VAR>Var</VAR><CODE>^</CODE><VAR>Goal</VAR></CODE> tells bagof 
not to bind <VAR>Var</VAR> in
<VAR>Goal</VAR>. <A NAME="idx:bagof/3:456"></A><A HREF="sec-3.29.html#bagof/3">bagof/3</A> 
fails if <VAR>Goal</VAR> has no solutions.

<P>The example below illustrates <A NAME="idx:bagof/3:457"></A><A HREF="sec-3.29.html#bagof/3">bagof/3</A> 
and the <STRONG><CODE>^</CODE></STRONG> operator. The variable bindings 
are printed together on one line to save paper.

<XMP>
2 ?- listing(foo).

foo(a, b, c).
foo(a, b, d).
foo(b, c, e).
foo(b, c, f).
foo(c, c, g).

Yes
3 ?- bagof(C, foo(A, B, C), Cs).

A = a, B = b, C = G308, Cs = [c, d] ;
A = b, B = c, C = G308, Cs = [e, f] ;
A = c, B = c, C = G308, Cs = [g] ;

No
4 ?- bagof(C, A^foo(A, B, C), Cs).

A = G324, B = b, C = G326, Cs = [c, d] ;
A = G324, B = c, C = G326, Cs = [e, f, g] ;

No
5 ?-
</XMP>

<P>

<P>
<DT><A NAME="setof/3"><STRONG>setof</STRONG>(<VAR>+Var, +Goal, -Set</VAR>)</A><DD>
Equivalent to <A NAME="idx:bagof/3:458"></A><A HREF="sec-3.29.html#bagof/3">bagof/3</A>, 
but sorts the result using <A NAME="idx:sort/2:459"></A><A HREF="sec-3.28.html#sort/2">sort/2</A> 
to get a sorted list of alternatives without duplicates.
</DL>

