<HTML><HEAD><TITLE>SWI-Prolog Reference Manual: Section 3.3</TITLE><LINK REL=home HREF="Title.html">
<LINK REL=contents HREF="Contents.html">
<LINK REL=index HREF="Index.html">
<LINK REL=summary HREF="sec-B.html">
<LINK REL=previous HREF="sec-3.2.html">
<LINK REL=next HREF="sec-3.4.html">
</HEAD>

<BODY>

<HR><CENTER><A HREF="Title.html">Home</A>
<A HREF="Contents.html">Contents</A>
<A HREF="Index.html">Index</A>
<A HREF="sec-B.html">Summary</A>
<A HREF="sec-3.2.html">Previous</A>
<A HREF="sec-3.4.html">Next</A>
</CENTER>

<HR>

<H2><A NAME="sec:3.3">3.3 Listing Predicates and Editor Interface</A></H2>

<A NAME="sec:listing"></A>

<P>SWI-Prolog offers an interface to the Unix <B>vi</B> editor and the 
GNU&nbsp;Emacs invocations <B>emacs</B> and <B>emacsclient</B>. Which 
editor is used is determined by the Unix environment variable
<CODE>EDITOR</CODE>, which should hold the full pathname of the editor. 
If this variable is not defined, <B>vi</B> is used.<A NAME=back-to-note-9 HREF="Notes.html#note-9"> (9)</A>

<P>After the user quits the editor, <A NAME="idx:make/0:213"></A><A HREF="sec-3.2.html#make/0">make/0</A> 
is invoked to reload all modified source files using <A NAME="idx:consult/1:214"></A><A HREF="sec-3.2.html#consult/1">consult/1</A>. 
If the editor can be quit such that an exit status non-equal to 0 is 
returned <A NAME="idx:make/0:215"></A><A HREF="sec-3.2.html#make/0">make/0</A> 
will not be invoked. <VAR>top</VAR> can do this by typing control-C, <VAR>vi</VAR> 
cannot do this.

<P>A predicate specification is either a term with the same functor and 
arity as the predicate wanted, a term of the form <VAR>Functor</VAR>/<VAR>Arity</VAR> 
or a single atom. In the latter case the database is searched for a 
predicate of this name and arbitrary arity (see <A NAME="idx:current_predicate/2:216"></A><A HREF="sec-3.14.html#current_predicate/2">current_predicate/2</A>). 
When more than one such predicate exists the system will prompt for 
confirmation on each of the matched predicates. Predicates 
specifications are given to the `Do What I Mean' system (see <A NAME="idx:dwim_predicate/2:217"></A><A HREF="sec-3.14.html#dwim_predicate/2">dwim_predicate/2</A>) 
if the requested predicate does not exist.

<P>

<DL>

<P>
<DT><A NAME="ed/1"><STRONG>ed</STRONG>(<VAR>+Pred</VAR>)</A><DD>
Invoke the user's preferred editor on the source file of <VAR>Pred</VAR>, 
providing a search specification which searches for the predicate at the 
start of a line.

<P>

<P>
<DT><A NAME="ed/0"><STRONG>ed</STRONG></A><DD>
Invoke <A NAME="idx:ed/1:218"></A><A HREF="sec-3.3.html#ed/1">ed/1</A> 
on the predicate last edited using <A NAME="idx:ed/1:219"></A><A HREF="sec-3.3.html#ed/1">ed/1</A>. 
Asks the user to confirm before starting the editor.

<P>

<P>
<DT><A NAME="edit/1"><STRONG>edit</STRONG>(<VAR>+File</VAR>)</A><DD>
Invoke the user's preferred editor on <VAR>File</VAR>. <VAR>File</VAR> 
is a file specification as for <A NAME="idx:consult/1:220"></A><A HREF="sec-3.2.html#consult/1">consult/1</A> 
(but not a list). Note that the file should exist.

<P>

<P>
<DT><A NAME="edit/0"><STRONG>edit</STRONG></A><DD>
Invoke <A NAME="idx:edit/1:221"></A><A HREF="sec-3.3.html#edit/1">edit/1</A> 
on the file last edited using <A NAME="idx:edit/1:222"></A><A HREF="sec-3.3.html#edit/1">edit/1</A>. 
Asks the user to confirm before starting the editor.

<P>

<P>
<DT><A NAME="listing/1"><STRONG>listing</STRONG>(<VAR>+Pred</VAR>)</A><DD>
List specified predicates (when an atom is given all predicates with 
this name will be listed). The listing is produced on the basis of the 
internal representation, thus loosing user's layout and variable name 
information. See also <A NAME="idx:portray_clause/1:223"></A><A HREF="sec-3.3.html#portray_clause/1">portray_clause/1</A>.

<P>
<DT><A NAME="listing/0"><STRONG>listing</STRONG></A><DD>
List all predicates of the database using <A NAME="idx:listing/1:224"></A><A HREF="sec-3.3.html#listing/1">listing/1</A>.

<P>

<P>
<DT><A NAME="portray_clause/1"><STRONG>portray_clause</STRONG>(<VAR>+Clause</VAR>)</A><DD>
Pretty print a clause as good as we can. A clause should be specified as 
a term `<CODE>&lt;<VAR>Head</VAR>&gt; :- &lt;<VAR>Body</VAR>&gt;</CODE>' 
(put brackets around it to avoid operator precedence problems). Facts 
are represented as `<CODE>&lt;<VAR>Head</VAR>&gt; :- true</CODE>'.

<P>

<P>
<DT><A NAME="edit_source/1"><STRONG>edit_source</STRONG>(<VAR>+Spec</VAR>)</A><DD>
A hook that may be defined in the module <CODE>user</CODE> to specify 
how the predicates <A NAME="idx:ed/1:225"></A><A HREF="sec-3.3.html#ed/1">ed/1</A> 
and <A NAME="idx:edit/1:226"></A><A HREF="sec-3.3.html#edit/1">edit/1</A> 
call the editor. If <A NAME="idx:ed/1:227"></A><A HREF="sec-3.3.html#ed/1">ed/1</A> 
is invoking this hook, <VAR>Spec</VAR> is a term of the format

<P><BLOCKQUOTE>
<CODE><VAR>File</VAR>:<VAR>LineNo</VAR>:<VAR>Name</VAR>/<VAR>Arity</VAR></CODE>
</BLOCKQUOTE>

<P>Where <VAR>File</VAR> and <VAR>LineNo</VAR> represents the location 
of the predicate remembered by Prolog, and <VAR>Name</VAR> and <VAR>Arity</VAR> 
specify the predicate. If invoked by <A NAME="idx:edit/1:228"></A><A HREF="sec-3.3.html#edit/1">edit/1</A>, <VAR>Spec</VAR> 
is an atom denoting the name of the file to be edited. This hook is 
defined by the library
<CODE>library(swi_prolog)</CODE> distributed with the XPCE package for 
using XPCE to edit Prolog files.
</DL>

