<HTML><HEAD><TITLE>SWI-Prolog Reference Manual: Section 3.30</TITLE><LINK REL=home HREF="Title.html">
<LINK REL=contents HREF="Contents.html">
<LINK REL=index HREF="Index.html">
<LINK REL=summary HREF="sec-B.html">
<LINK REL=previous HREF="sec-3.29.html">
<LINK REL=next HREF="sec-3.31.html">
</HEAD>

<BODY>

<HR><CENTER><A HREF="Title.html">Home</A>
<A HREF="Contents.html">Contents</A>
<A HREF="Index.html">Index</A>
<A HREF="sec-B.html">Summary</A>
<A HREF="sec-3.29.html">Previous</A>
<A HREF="sec-3.31.html">Next</A>
</CENTER>

<HR>

<H2><A NAME="sec:3.30">3.30 Invoking Predicates on all Members of a List</A></H2>

<P>All the predicates in this section call a predicate on all members of 
a list or until the predicate called fails. The predicate is called via
<A NAME="idx:apply/2:460"></A><A HREF="sec-3.7.html#apply/2">apply/2</A>, 
which implies common arguments can be put in front of the arguments 
obtained from the list(s). For example:

<P>

<XMP>
?- maplist(plus(1), [0, 1, 2], X).

X = [1, 2, 3]
</XMP>

<P>we will phrase this as ``<VAR>Predicate</VAR> is applied on ... ''

<P>

<DL>

<P>
<DT><A NAME="checklist/2"><STRONG>checklist</STRONG>(<VAR>+Pred, +List</VAR>)</A><DD>
<VAR>Pred</VAR> is applied successively on each element of <VAR>List</VAR> 
until the end of the list or <VAR>Pred</VAR> fails. In the latter case 
the
<A NAME="idx:checklist/2:461"></A><A HREF="sec-3.30.html#checklist/2">checklist/2</A> 
fails.

<P>
<DT><A NAME="maplist/3"><STRONG>maplist</STRONG>(<VAR>+Pred, ?List1, 
?List2</VAR>)</A><DD>
Apply <VAR>Pred</VAR> on all successive pairs of elements from <VAR>List1</VAR> 
and <VAR>List2</VAR>. Fails if <VAR>Pred</VAR> can not be applied to a 
pair. See the example above.

<P>
<DT><A NAME="sublist/3"><STRONG>sublist</STRONG>(<VAR>+Pred, +List1, 
?List2</VAR>)</A><DD>
Unify <VAR>List2</VAR> with a list of all elements of <VAR>List1</VAR> 
to which
<VAR>Pred</VAR> applies.
</DL>

