<HTML><HEAD><TITLE>SWI-Prolog Reference Manual: Section 3.32</TITLE><LINK REL=home HREF="Title.html">
<LINK REL=contents HREF="Contents.html">
<LINK REL=index HREF="Index.html">
<LINK REL=summary HREF="sec-B.html">
<LINK REL=previous HREF="sec-3.31.html">
<LINK REL=next HREF="sec-3.33.html">
</HEAD>

<BODY>

<HR><CENTER><A HREF="Title.html">Home</A>
<A HREF="Contents.html">Contents</A>
<A HREF="Index.html">Index</A>
<A HREF="sec-B.html">Summary</A>
<A HREF="sec-3.31.html">Previous</A>
<A HREF="sec-3.33.html">Next</A>
</CENTER>

<HR>

<H2><A NAME="sec:3.32">3.32 Formatted Write</A></H2>

<P>The current version of SWI-Prolog provides two formatted write 
predicates. The first is <A NAME="idx:writef/[1,2]:462"></A><A HREF="sec-3.32.html#writef/1">writef/[1,2]</A>, 
which is compatible with Edinburgh C-Prolog. The second is <A NAME="idx:format/[1,2]:463"></A><A HREF="sec-3.32.html#format/1">format/[1,2]</A>, 
which is compatible with Quintus Prolog. We hope the Prolog community 
will once define a standard formatted write predicate. If you want 
performance use
<A NAME="idx:format/[1,2]:464"></A><A HREF="sec-3.32.html#format/1">format/[1,2]</A> 
as this predicate is defined in C. Otherwise compatibility reasons might 
tell you which predicate to use.

<P>

<H3><A NAME="sec:3.32.1">3.32.1 Writef</A></H3>

<P>

<DL>

<P>
<DT><A NAME="write_ln/1"><STRONG>write_ln</STRONG>(<VAR>+Term</VAR>)</A><DD>
Equivalent to <CODE>write(Term), nl.</CODE>

<P>
<DT><A NAME="writef/1"><STRONG>writef</STRONG>(<VAR>+Atom</VAR>)</A><DD>
Equivalent to <CODE>writef(Atom, []).</CODE>

<P>
<DT><A NAME="writef/2"><STRONG>writef</STRONG>(<VAR>+Format, +Arguments</VAR>)</A><DD>
Formatted write. <VAR>Format</VAR> is an atom whose characters will be 
printed.
<VAR>Format</VAR> may contain certain special character sequences which 
specify certain formatting and substitution actions. <VAR>Arguments</VAR> 
then provides all the terms required to be output.

<P>Escape sequences to generate a single special character:

<P><CENTER>
<TABLE BORDER=2 COLS=2 FRAME=border RULES=group>
<TR VALIGN=top><TD><CODE>\n</CODE> <TD>Output a nemline character (see 
also <A NAME="idx:nl/[0,1]:465"></A><A HREF="sec-3.17.html#nl/0">nl/[0,1]</A>) </TR>
<TR VALIGN=top><TD><CODE>\l</CODE> <TD>Output a line separator (same as <CODE>\n</CODE>) </TR>
<TR VALIGN=top><TD><CODE>\r</CODE> <TD>Output a carriage-return 
character (ASCII 13) </TR>
<TR VALIGN=top><TD><CODE>\t</CODE> <TD>Output the ASCII character TAB 
(9) </TR>
<TR VALIGN=top><TD><CODE>\\</CODE> <TD>The character <CODE><CODE>\</CODE></CODE> 
is output </TR>
<TR VALIGN=top><TD><CODE>\%</CODE> <TD>The character <CODE><CODE>%</CODE></CODE> 
is output </TR>
<TR VALIGN=top><TD><CODE>\nnn</CODE> <TD>where &lt;<VAR>nnn</VAR>&gt; is 
an integer (1-3 digits) the character with ASCII code &lt;<VAR>nnn</VAR>&gt; 
is output (NB : &lt;<VAR>nnn</VAR>&gt; is read as <STRONG>decimal</STRONG>) </TR>
</TABLE>

</CENTER>

<P>Note that <CODE>\l</CODE>, <CODE>\\bnfmeta{nnn}</CODE> and <CODE>\\</CODE> 
are interpreted differently when character-escapes are in effect. See
<A HREF="sec-2.11.html">section 2.11.1.1</A>.

<P>Escape sequences to include arguments from <VAR>Arguments</VAR>. Each 
time a
% escape sequence is found in <VAR>Format</VAR> the next argument from <VAR>Arguments</VAR> 
is formatted according to the specification.

<P><CENTER>
<TABLE BORDER=2 COLS=2 FRAME=border RULES=group>
<TR VALIGN=top><TD><CODE>%t</CODE> <TD><A NAME="idx:print/1:466"></A><A HREF="sec-3.18.html#print/1">print/1</A> 
the next item (mnemonic: term) </TR>
<TR VALIGN=top><TD><CODE>%w</CODE> <TD><A NAME="idx:write/1:467"></A><A HREF="sec-3.18.html#write/1">write/1</A> 
the next item </TR>
<TR VALIGN=top><TD><CODE>%q</CODE> <TD><A NAME="idx:writeq/1:468"></A><A HREF="sec-3.18.html#writeq/1">writeq/1</A> 
the next item </TR>
<TR VALIGN=top><TD><CODE>%d</CODE> <TD>Write the term, ignoring 
operators. See also
<A NAME="idx:write_term/2:469"></A><A HREF="sec-3.18.html#write_term/2">write_term/2</A>. 
Mnemonic: old Edinburgh <A NAME="idx:display/1:470"></A><B>display/1</B>. </TR>
<TR VALIGN=top><TD><CODE>%p</CODE> <TD><A NAME="idx:print/1:471"></A><A HREF="sec-3.18.html#print/1">print/1</A> 
the next item (identical to <CODE>%t</CODE>) </TR>
<TR VALIGN=top><TD><CODE>%n</CODE> <TD>Put the next item as a character 
(i.e. it is an ASCII value) </TR>
<TR VALIGN=top><TD><CODE>%r</CODE> <TD>Write the next item N times where 
N is the second item (an integer) </TR>
<TR VALIGN=top><TD><CODE>%s</CODE> <TD>Write the next item as a String 
(so it must be a list of characters) </TR>
<TR VALIGN=top><TD><CODE>%f</CODE> <TD>Perform a <A NAME="idx:ttyflush/0:472"></A><A HREF="sec-3.17.html#ttyflush/0">ttyflush/0</A> 
(no items used) </TR>
<TR VALIGN=top><TD><CODE>%Nc</CODE> <TD>Write the next item Centered in <VAR>N</VAR> 
columns. </TR>
<TR VALIGN=top><TD><CODE>%Nl</CODE> <TD>Write the next item Left 
justified in <VAR>N</VAR> columns. </TR>
<TR VALIGN=top><TD><CODE>%Nr</CODE> <TD>Write the next item Right 
justified in <VAR>N</VAR> columns.
<VAR>N</VAR> is a decimal number with at least one digit. The item must 
be an atom, integer, float or string. </TR>
</TABLE>

</CENTER>

<P>
<DT><A NAME="swritef/3"><STRONG>swritef</STRONG>(<VAR>-String, +Format, 
+Arguments</VAR>)</A><DD>
Equivalent to <A NAME="idx:writef/2:473"></A><A HREF="sec-3.32.html#writef/2">writef/2</A>, 
but ``writes'' the result on <VAR>String</VAR> instead of the current 
output stream. Example:

<XMP>
?- swritef(S, '%15L%w', ['Hello', 'World']).

S = "Hello          World"
</XMP>

<P>

<P>
<DT><A NAME="swritef/2"><STRONG>swritef</STRONG>(<VAR>-String, +Format</VAR>)</A><DD>
Equivalent to <CODE>swritef(String, Format, []).</CODE>
</DL>

<P>

<H3><A NAME="sec:3.32.2">3.32.2 Format</A></H3>

<P>

<DL>

<P>
<DT><A NAME="format/1"><STRONG>format</STRONG>(<VAR>+Format</VAR>)</A><DD>
Defined as `<CODE>format(Format) :- format(Format, []).</CODE>'

<P>
<DT><A NAME="format/2"><STRONG>format</STRONG>(<VAR>+Format, +Arguments</VAR>)</A><DD>
<VAR>Format</VAR> is an atom, list of ASCII values, or a Prolog string.
<VAR>Arguments</VAR> provides the arguments required by the format 
specification. If only one argument is required and this is not a list 
of ASCII values the argument need not be put in a list. Otherwise the 
arguments are put in a list.

<P>Special sequences start with the tilde (<CODE><CODE>~</CODE></CODE>), 
followed by an optional numeric argument, followed by a character 
describing the action to be undertaken. A numeric argument is either a 
sequence of digits, representing a positive decimal number, a sequence <CODE>`&lt;<VAR>character</VAR>&gt;</CODE>, 
representing the ASCII value of the character (only useful for
<CODE>~t</CODE>) or a asterisk (<CODE><CODE>*</CODE></CODE>), in when 
the numeric argument is taken from the next argument of the argument 
list, which should be a positive integer. Actions are:

<P><UL>

<P>
<DT><CODE><CODE>~</CODE></CODE><DD>
Output the tilde itself.

<P>
<DT><CODE>a</CODE><DD>
Output the next argument, which should be an atom. This option is 
equivalent to </EM><B>w</B>. Compatibility reasons only.

<P>
<DT><CODE>c</CODE><DD>
Output the next argument as an ASCII value. This argument should be an 
integer in the range [0, ... , 255] (including 0 and 255).

<P>
<DT><CODE>d</CODE><DD>
Output next argument as a decimal number. It should be an integer. If a 
numeric argument is specified a dot is inserted <VAR>argument</VAR> 
positions from the right (useful for doing fixed point arithmetic with 
integers, such as handling amounts of money).

<P>
<DT><CODE>D</CODE><DD>
Same as </EM><B>d</B>, but makes large values easier to read by 
inserting a comma every three digits left to the dot or right.

<P>
<DT><CODE>e</CODE><DD>
Output next argument as a floating point number in exponential notation. 
The numeric argument specifies the precision. Default is 6 digits. Exact 
representation depends on the C library function printf(). This function 
is invoked with the format
</EM><TT>%.&lt;<VAR>precision</VAR>&gt;e</TT>.

<P>
<DT><CODE>E</CODE><DD>
Equivalent to </EM><B>e</B>, but outputs a capital E to indicate the 
exponent.

<P>
<DT><CODE>f</CODE><DD>
Floating point in non-exponential notation. See C library function 
printf().

<P>
<DT><CODE>g</CODE><DD>
Floating point in </EM><B>e</B> or </EM><B>f</B> notation, whichever is 
shorter.

<P>
<DT><CODE>G</CODE><DD>
Floating point in </EM><B>E</B> or </EM><B>f</B> notation, whichever is 
shorter.

<P>
<DT><CODE>i</CODE><DD>
Ignore next argument of the argument list. Produces no output.

<P>
<DT><CODE>k</CODE><DD>
Give the next argument to <A NAME="idx:displayq/1:474"></A><B>displayq/1</B> 
(canonical write).

<P>
<DT><CODE>n</CODE><DD>
Output a newline character.

<P>
<DT><CODE>N</CODE><DD>
Only output a newline if the last character output on this stream was 
not a newline. Not properly implemented yet.

<P>
<DT><CODE>p</CODE><DD>
Give the next argument to <A NAME="idx:print/1:475"></A><A HREF="sec-3.18.html#print/1">print/1</A>.

<P>
<DT><CODE>q</CODE><DD>
Give the next argument to <A NAME="idx:writeq/1:476"></A><A HREF="sec-3.18.html#writeq/1">writeq/1</A>.

<P>
<DT><CODE>r</CODE><DD>
Print integer in radix the numeric argument notation. Thus
<CODE>~16r</CODE> prints its argument hexadecimal. The argument should 
be in the range <VAR>[2, ... , 36]</VAR>. Lower case letters are used 
for digits above 9.

<P>
<DT><CODE>R</CODE><DD>
Same as </EM><B>r</B>, but uses upper case letters for digits above 9.

<P>
<DT><CODE>s</CODE><DD>
Output a string of ASCII characters or a string (see <A NAME="idx:string/1:477"></A><A HREF="sec-3.4.html#string/1">string/1</A> 
and
<A HREF="sec-3.21.html">section 3.21</A>) from the next argument.

<P>
<DT><CODE>t</CODE><DD>
All remaining space between 2 tabs tops is distributed equally over
<CODE>~t</CODE> statements between the tabs tops. This space is padded 
with spaces by default. If an argument is supplied this is taken to be 
the ASCII value of the character used for padding. This can be used to 
do left or right alignment, centering, distributing, etc. See also
<CODE>~|</CODE> and <CODE>~+</CODE> to set tab stops. A tabs top is 
assumed at the start of each line.

<P>
<DT><CODE><CODE>|</CODE></CODE><DD>
Set a tabs top on the current position. If an argument is supplied set a 
tabs top on the position of that argument. This will cause all
<CODE>~t</CODE>'s to be distributed between the previous and this tabs 
top.

<P>
<DT><CODE><CODE>+</CODE></CODE><DD>
Set a tabs top relative to the current position. Further the same as
<CODE>~|</CODE>.

<P>
<DT><CODE>w</CODE><DD>
Give the next argument to <A NAME="idx:write/1:478"></A><A HREF="sec-3.18.html#write/1">write/1</A>.
</UL>

<P>Example:

<P>

<XMP>
simple_statistics :-
    <obtain statistics>         % left to the user
    format('~tStatistics~t~72|~n~n'),
    format('Runtime: ~`.t ~2f~34|  Inferences: ~`.t ~D~72|~n',
                                            [RunT, Inf]),
    ....
</XMP>

<P>Will output

<P>

<XMP>
                             Statistics

Runtime: .................. 3.45  Inferences: .......... 60,345
</XMP>

<P>

<P>
<DT><A NAME="format/3"><STRONG>format</STRONG>(<VAR>+Stream, +Format, 
+Arguments</VAR>)</A><DD>
As <A NAME="idx:format/2:479"></A><A HREF="sec-3.32.html#format/2">format/2</A>, 
but write the output on the given <VAR>Stream</VAR>.

<P>
<DT><A NAME="sformat/3"><STRONG>sformat</STRONG>(<VAR>-String, +Format, 
+Arguments</VAR>)</A><DD>
Equivalent to <A NAME="idx:format/2:480"></A><A HREF="sec-3.32.html#format/2">format/2</A>, 
but ``writes'' the result on <VAR>String</VAR> instead of the current 
output stream. Example:

<XMP>
?- sformat(S, '~w~t~15|~w', ['Hello', 'World']).

S = "Hello          World"
</XMP>

<P>

<P>
<DT><A NAME="sformat/2"><STRONG>sformat</STRONG>(<VAR>-String, +Format</VAR>)</A><DD>
Equivalent to `<CODE>sformat(String, Format, []).</CODE>'
</DL>

<P>

<H3><A NAME="sec:3.32.3">3.32.3 Programming Format</A></H3>

<P>

<DL>

<P>
<DT><A NAME="format_predicate/2"><STRONG>format_predicate</STRONG>(<VAR>+Char, 
+Head</VAR>)</A><DD>
If a sequence <CODE>~c</CODE> (tilde, followed by some character) is 
found, the format derivatives will first check whether the user has 
defined a predicate to handle the format. If not, the built in 
formatting rules described above are used. <VAR>Char</VAR> is either an </EM><font size=-1>ASCII</font> 
value, or a one character atom, specifying the letter to be (re)defined. <VAR>Head</VAR> 
is a term, whose name and arity are used to determine the predicate to 
call for the redefined formatting character. The first argument to the 
predicate is the numeric argument of the format command, or the atom <CODE>default</CODE> 
if no argument is specified. The remaining arguments are filled from the 
argument list. The example below redefines <CODE>~n</CODE> to produce <VAR>Arg</VAR> 
times return followed by linefeed (so a (Grr.) DOS machine is happy with 
the output).

<P>

<XMP>
:- format_predicate(n, dos_newline(_Arg)).

dos_newline(Arg) :-
        between(1, Ar, _), put(13), put(10), fail ; true.
</XMP>

<P>
</DL>

