<HTML><HEAD><TITLE>SWI-Prolog Reference Manual: Section 3.33</TITLE><LINK REL=home HREF="Title.html">
<LINK REL=contents HREF="Contents.html">
<LINK REL=index HREF="Index.html">
<LINK REL=summary HREF="sec-B.html">
<LINK REL=previous HREF="sec-3.32.html">
<LINK REL=next HREF="sec-3.34.html">
</HEAD>

<BODY>

<HR><CENTER><A HREF="Title.html">Home</A>
<A HREF="Contents.html">Contents</A>
<A HREF="Index.html">Index</A>
<A HREF="sec-B.html">Summary</A>
<A HREF="sec-3.32.html">Previous</A>
<A HREF="sec-3.34.html">Next</A>
</CENTER>

<HR>

<H2><A NAME="sec:3.33">3.33 Terminal Control</A></H2>

<P>The following predicates form a simple access mechanism to the Unix 
termcap library to provide terminal independent I/O for screen 
terminals. The library package <CODE>library(tty)</CODE> builds on top 
of these predicates.

<P>

<DL>

<P>
<DT><A NAME="tty_get_capability/3"><STRONG>tty_get_capability</STRONG>(<VAR>+Name, 
+Type, -Result</VAR>)</A><DD>
Get the capability named <VAR>Name</VAR> from the termcap library. See 
termcap(5) for the capability names. <VAR>Type</VAR> specifies the type 
of the expected result, and is one of <CODE>string</CODE>, <CODE>number</CODE> 
or
<CODE>bool</CODE>. String results are returned as an atom, number result 
as an integer and bool results as the atom <CODE>on</CODE> or <CODE>off</CODE>. 
If an option cannot be found this predicate fails silently. The results 
are only computed once. Successive queries on the same capability are 
fast.

<P>
<DT><A NAME="tty_goto/2"><STRONG>tty_goto</STRONG>(<VAR>+X, +Y</VAR>)</A><DD>
Goto position (<VAR>X</VAR>, <VAR>Y</VAR>) on the screen. Note that the 
predicates
<A NAME="idx:line_count/2:481"></A><A HREF="sec-3.16.html#line_count/2">line_count/2</A> 
and <A NAME="idx:line_position/2:482"></A><A HREF="sec-3.16.html#line_position/2">line_position/2</A> 
will not have a well defined behaviour while using this predicate.

<P>
<DT><A NAME="tty_put/2"><STRONG>tty_put</STRONG>(<VAR>+Atom, +Lines</VAR>)</A><DD>
Put an atom via the termcap library function tputs(). This function 
decodes padding information in the strings returned by <A NAME="idx:tty_get_capability/3:483"></A><A HREF="sec-3.33.html#tty_get_capability/3">tty_get_capability/3</A> 
and should be used to output these strings. <VAR>Lines</VAR> is the 
number of lines affected by the operation, or 1 if not applicable (as in 
almost all cases).

<P>
<DT><A NAME="set_tty/2"><STRONG>set_tty</STRONG>(<VAR>-OldStream, 
+NewStream</VAR>)</A><DD>
Set the output stream, used by <A NAME="idx:tty_put/2:484"></A><A HREF="sec-3.33.html#tty_put/2">tty_put/2</A> 
and <A NAME="idx:tty_goto/2:485"></A><A HREF="sec-3.33.html#tty_goto/2">tty_goto/2</A> 
to a specific stream. Default is user_output.
</DL>

