<HTML><HEAD><TITLE>SWI-Prolog Reference Manual: Section 3.34</TITLE><LINK REL=home HREF="Title.html">
<LINK REL=contents HREF="Contents.html">
<LINK REL=index HREF="Index.html">
<LINK REL=summary HREF="sec-B.html">
<LINK REL=previous HREF="sec-3.33.html">
<LINK REL=next HREF="sec-3.35.html">
</HEAD>

<BODY>

<HR><CENTER><A HREF="Title.html">Home</A>
<A HREF="Contents.html">Contents</A>
<A HREF="Index.html">Index</A>
<A HREF="sec-B.html">Summary</A>
<A HREF="sec-3.33.html">Previous</A>
<A HREF="sec-3.35.html">Next</A>
</CENTER>

<HR>

<H2><A NAME="sec:3.34">3.34 Operating System Interaction</A></H2>

<P>

<DL>

<P>
<DT><A NAME="shell/2"><STRONG>shell</STRONG>(<VAR>+Command, -Status</VAR>)</A><DD>
Execute <VAR>Command</VAR> on the operating system. <VAR>Command</VAR> 
is given to the Bourne shell (/bin/sh). <VAR>Status</VAR> is unified 
with the exit status of the command.

<P>On <VAR>Win32</VAR> systems, <A NAME="idx:shell/[1,2]:486"></A><A HREF="sec-3.34.html#shell/1">shell/[1,2]</A> 
executes the command using the CreateProcess() API and waits for the 
command to terminate. If the command ends with a <CODE>&amp;</CODE> 
sign, the command is handed to the WinExec() API, which does not wait 
for the new task to terminate. See also <A NAME="idx:win_exec/2:487"></A><A HREF="sec-3.34.html#win_exec/2">win_exec/2</A>.

<P>
<DT><A NAME="shell/1"><STRONG>shell</STRONG>(<VAR>+Command</VAR>)</A><DD>
Equivalent to `<CODE>shell(Command, 0)</CODE>'.

<P>
<DT><A NAME="shell/0"><STRONG>shell</STRONG></A><DD>
Start an interactive Unix shell. Default is <CODE>/bin/sh</CODE>, the 
environment variable <CODE>SHELL</CODE> overrides this default. Not 
available for Win32 platforms.

<P>
<DT><A NAME="win_exec/2"><STRONG>win_exec</STRONG>(<VAR>+Command, +Show</VAR>)</A><DD>
Win32 systems only. Spawns a Windows task without waiting for its 
completion. <VAR>Show</VAR> is either <CODE>iconic</CODE> or <CODE>normal</CODE> 
and dictates the initial status of the window. The <CODE>iconic</CODE> 
option is notably handy to start (DDE) servers.

<P>
<DT><A NAME="getenv/2"><STRONG>getenv</STRONG>(<VAR>+Name, -Value</VAR>)</A><DD>
Get Unix environment variable (see csh(1) and sh(1)). Fails if the 
variable does not exist.

<P>
<DT><A NAME="setenv/2"><STRONG>setenv</STRONG>(<VAR>+Name, +Value</VAR>)</A><DD>
Set Unix environment variable. <VAR>Name</VAR> and <VAR>Value</VAR> 
should be instantiated to atoms or integers. The environment variable 
will be passed to <A NAME="idx:shell/[0-2]:488"></A><A HREF="sec-3.34.html#shell/0">shell/[0-2]</A> 
and can be requested using <A NAME="idx:getenv/2:489"></A><A HREF="sec-3.34.html#getenv/2">getenv/2</A>.

<P>
<DT><A NAME="unsetenv/1"><STRONG>unsetenv</STRONG>(<VAR>+Name</VAR>)</A><DD>
Remove Unix environment variable from the environment.

<P>
<DT><A NAME="get_time/1"><STRONG>get_time</STRONG>(<VAR>-Time</VAR>)</A><DD>
Return the number of seconds that elapsed since the epoch of Unix, 1 
January 1970, 0 hours. <VAR>Time</VAR> is a floating point number. Its 
granularity is system dependent. On </EM><font size=-1>SUN</font>, this 
is 1/60 of a second.

<P>
<DT><A NAME="convert_time/8"><STRONG>convert_time</STRONG>(<VAR>+Time, 
-Year, -Month, -Day, -Hour, -Minute, -Second, -MilliSeconds</VAR>)</A><DD>
Convert a time stamp, provided by <A NAME="idx:get_time/1:490"></A><A HREF="sec-3.34.html#get_time/1">get_time/1</A>, <A NAME="idx:time_file/2:491"></A><A HREF="sec-3.35.html#time_file/2">time_file/2</A>, 
etc. <VAR>Year</VAR> is unified with the year, <VAR>Month</VAR> with the 
month number (January is 1), <VAR>Day</VAR> with the day of the month 
(starting with 1),
<VAR>Hour</VAR> with the hour of the day (0--23), <VAR>Minute</VAR> with 
the minute (0--59). <VAR>Second</VAR> with the second (0--59) and <VAR>MilliSecond</VAR> 
with the milliseconds (0--999). Note that the latter might not be 
accurate or might always be 0, depending on the timing capabilities of 
the system.
</DL>

