<HTML><HEAD><TITLE>SWI-Prolog Reference Manual: Section 3.35</TITLE><LINK REL=home HREF="Title.html">
<LINK REL=contents HREF="Contents.html">
<LINK REL=index HREF="Index.html">
<LINK REL=summary HREF="sec-B.html">
<LINK REL=previous HREF="sec-3.34.html">
<LINK REL=next HREF="sec-3.36.html">
</HEAD>

<BODY>

<HR><CENTER><A HREF="Title.html">Home</A>
<A HREF="Contents.html">Contents</A>
<A HREF="Index.html">Index</A>
<A HREF="sec-B.html">Summary</A>
<A HREF="sec-3.34.html">Previous</A>
<A HREF="sec-3.36.html">Next</A>
</CENTER>

<HR>

<H2><A NAME="sec:3.35">3.35 File System Interaction</A></H2>

<P>

<DL>

<P>
<DT><A NAME="access_file/2"><STRONG>access_file</STRONG>(<VAR>+File, 
+Mode</VAR>)</A><DD>
Succeeds if <VAR>File</VAR> exists and can be accessed by this prolog 
process under mode <VAR>Mode</VAR>. <VAR>Mode</VAR> is one of the atoms
<CODE>read</CODE>, <CODE>write</CODE>, <CODE>append</CODE>, <CODE>exist</CODE>, <CODE>none</CODE> 
or
<CODE>execute</CODE>. <VAR>File</VAR> may also be the name of a 
directory. Fails silently otherwise. <CODE>access_file(File, none)</CODE> 
simply succeeds without testing anything.

<P>If `Mode' is <CODE>write</CODE> or <CODE>append</CODE>, this 
predicate also succeeds if the file does not exist and the user has 
write-access to the directory of the specified location.

<P>
<DT><A NAME="exists_file/1"><STRONG>exists_file</STRONG>(<VAR>+File</VAR>)</A><DD>
Succeeds when <VAR>File</VAR> exists. This does not imply the user has 
read and/or write permission for the file.

<P>
<DT><A NAME="file_directory_name/2"><STRONG>file_directory_name</STRONG>(<VAR>+File, 
-Directory</VAR>)</A><DD>
Extracts the directory-part of <VAR>File</VAR>. The resulting <VAR>Directory</VAR> 
name ends with the directory separator character <CODE><CODE>/</CODE></CODE>. 
If <VAR>File</VAR> is an atom that does not contain any directory 
separator characters, the empty atom <CODE>''</CODE> is returned. See 
also <A NAME="idx:file_base_name/2:492"></A><A HREF="sec-3.35.html#file_base_name/2">file_base_name/2</A>.

<P>
<DT><A NAME="file_base_name/2"><STRONG>file_base_name</STRONG>(<VAR>+File, 
-BaseName</VAR>)</A><DD>
Extracts the filename part from a path specification. If <VAR>File</VAR> 
does not contain any directory separators, <VAR>File</VAR> is returned.

<P>
<DT><A NAME="same_file/2"><STRONG>same_file</STRONG>(<VAR>+File1, +File2</VAR>)</A><DD>
Succeeds if both filenames refer to the same physical file. That is, if <VAR>File1</VAR> 
and <VAR>File2</VAR> are the same string or both names exist and point 
to the same file (due to hard or symbolic links and/or relative vs. 
absolute paths).

<P>
<DT><A NAME="exists_directory/1"><STRONG>exists_directory</STRONG>(<VAR>+Directory</VAR>)</A><DD>
Succeeds if <VAR>Directory</VAR> exists. This does not imply the user 
has read, search and or write permission for the directory.

<P>
<DT><A NAME="delete_file/1"><STRONG>delete_file</STRONG>(<VAR>+File</VAR>)</A><DD>
Unlink <VAR>File</VAR> from the Unix file system.

<P>
<DT><A NAME="rename_file/2"><STRONG>rename_file</STRONG>(<VAR>+File1, 
+File2</VAR>)</A><DD>
Rename <VAR>File1</VAR> into <VAR>File2</VAR>. Currently files cannot be 
moved across devices.

<P>
<DT><A NAME="size_file/2"><STRONG>size_file</STRONG>(<VAR>+File, -Size</VAR>)</A><DD>
Unify <VAR>Size</VAR> with the size of <VAR>File</VAR> in characters.

<P>
<DT><A NAME="time_file/2"><STRONG>time_file</STRONG>(<VAR>+File, -Time</VAR>)</A><DD>
Unify the last modification time of <VAR>File</VAR> with <VAR>Time</VAR>. <VAR>Time</VAR> 
is a floating point number expressing the seconds elapsed since Jan&nbsp;1, 
1970.

<P>
<DT><A NAME="absolute_file_name/2"><STRONG>absolute_file_name</STRONG>(<VAR>+File, 
-Absolute</VAR>)</A><DD>
Expand Unix file specification into an absolute path. User home 
directory expansion (<CODE><CODE>~</CODE></CODE> and <CODE><CODE>~</CODE>&lt;<VAR>user</VAR>&gt;</CODE>) 
and variable expansion is done. The absolute path is canonised: 
references to <CODE><CODE>.</CODE></CODE> and <CODE>..</CODE> are 
deleted. SWI-Prolog uses absolute file names to register source files 
independent of the current working directory. See also <A NAME="idx:absolute_file_name/3:493"></A><A HREF="sec-3.35.html#absolute_file_name/3">absolute_file_name/3</A>.

<P>
<DT><A NAME="absolute_file_name/3"><STRONG>absolute_file_name</STRONG>(<VAR>+Spec, 
+Options, -Absolute</VAR>)</A><DD>
Converts the given file specification into an absolute path. <VAR>Option</VAR> 
is a list of options to guide the conformation process:

<P>

<DL>

<P>
<DT><STRONG>extensions</STRONG>(<VAR>ListOfExtensions</VAR>)<DD>
List of file-extensions to try. Default is <CODE>''</CODE>. For each 
extension, <A NAME="idx:absolute_file_name/3:494"></A><A HREF="sec-3.35.html#absolute_file_name/3">absolute_file_name/3</A> 
will first add the extension and then verify the conditions imposed by 
the other options. If the condition fails, the next extension of the 
list is tried. Extensions may be specified both as <CODE>..ext</CODE> or 
plain <CODE>ext</CODE>.

<P>
<DT><STRONG>access</STRONG>(<VAR>Mode</VAR>)<DD>
Imposes the condition access_file(<VAR>File</VAR>, <VAR>Mode</VAR>). <VAR>Mode</VAR> 
is on of <CODE>read</CODE>, <CODE>write</CODE>, <CODE>append</CODE>, <CODE>exist</CODE> 
or <CODE>none</CODE>. See also <A NAME="idx:access_file/2:495"></A><A HREF="sec-3.35.html#access_file/2">access_file/2</A>.

<P>
<DT><STRONG>file_type</STRONG>(<VAR>Type</VAR>)<DD>
Defines extensions. Current mapping: <CODE>txt</CODE> implies <CODE>['']</CODE>,
<CODE>prolog</CODE> implies <CODE>['.pl', '']</CODE>, <CODE>executable</CODE> 
implies
<CODE>['.so', '']</CODE>, <CODE>qlf</CODE> implies <CODE>['.qlf', '']</CODE> 
and
<CODE>directory</CODE> implies <CODE>['']</CODE>.

<P>
<DT><STRONG>file_errors</STRONG>(<VAR>fail/true</VAR>)<DD>
Report if the path cannot be resolved or be silent. The default is to 
stay silent.

<P>
<DT><STRONG>solutions</STRONG>(<VAR>first/all</VAR>)<DD>
If <CODE>first</CODE> (default), the predicates leaves no choice-point. 
Otherwise a choice-point will be left and backtracking may yield more 
solutions.
</DL>

<P>

<P>
<DT><A NAME="is_absolute_file_name/1"><STRONG>is_absolute_file_name</STRONG>(<VAR>+File</VAR>)</A><DD>
True if <VAR>File</VAR> specifies and absolute path-name. On Unix 
systems, this implies the path starts with a `/'. For Microsoft based 
systems this implies the path starts with <CODE>&lt;<VAR>letter</VAR>&gt;:</CODE>. 
This predicate is intended to provide platform-independent checking for 
absolute paths. See also <A NAME="idx:absolute_file_name/2:496"></A><A HREF="sec-3.35.html#absolute_file_name/2">absolute_file_name/2</A> 
and <A NAME="idx:prolog_to_os_filename/2:497"></A><A HREF="sec-3.35.html#prolog_to_os_filename/2">prolog_to_os_filename/2</A>.

<P>

<P>
<DT><A NAME="file_name_extension/3"><STRONG>file_name_extension</STRONG>(<VAR>?Base, 
?Extension, ?Name</VAR>)</A><DD>
This predicate is used to add, remove or test filename extensions. The 
main reason for its introduction is to deal with different filename 
properties in a portable manner. If the file system is case-insensitive, 
testing for an extension will be done case-insensitive too. <VAR>Extension</VAR> 
may be specified with or without a leading dot (<CODE><CODE>.</CODE></CODE>). 
If an <VAR>Extension</VAR> is generated, it will not have a leading dot.

<P>
<DT><A NAME="expand_file_name/2"><STRONG>expand_file_name</STRONG>(<VAR>+WildCard, 
-List</VAR>)</A><DD>
Unify <VAR>List</VAR> with a sorted list of files or directories 
matching
<VAR>WildCard</VAR>. The normal Unix wildcard constructs `<CODE><CODE>?</CODE></CODE>', 
`<CODE><CODE>*</CODE></CODE>', `<CODE>[ ... ]</CODE>' and `<CODE>{...}</CODE>' 
are recognised. The interpretation of `<CODE>{...}</CODE>' is 
interpreted slightly different from the C shell (csh(1)). The comma 
separated argument can be arbitrary patterns, including `<CODE>{...}</CODE>' 
patterns. The empty pattern is legal as well: `<CODE>{.pl,}</CODE>' 
matches either `<CODE>.pl</CODE>' or the empty string.

<P>

<P>
<DT><A NAME="prolog_to_os_filename/2"><STRONG>prolog_to_os_filename</STRONG>(<VAR>?PrologPath, 
?OsPath</VAR>)</A><DD>
Converts between the internal Prolog pathname conventions and the 
operating-system pathname conventions. The internal conventions are Unix 
and this predicates is equivalent to =/2 (unify) on Unix systems. On DOS 
systems it will change the directory-separator, limit the filename 
length map dots, except for the last one, onto underscores.

<P>

<P>
<DT><A NAME="read_link/3"><STRONG>read_link</STRONG>(<VAR>+File, -Link, 
-Target</VAR>)</A><DD>
If <VAR>File</VAR> points to a symbolic link, unify <VAR>Link</VAR> with 
the value of the link and <VAR>Target</VAR> to the file the link is 
pointing to.
<VAR>Target</VAR> points to a file, directory or non-existing entry in 
the file system, but never to a link. Fails if <VAR>File</VAR> is not a 
link. Fails always on systems that do not support symbolic links.

<P>

<P>
<DT><A NAME="tmp_file/2"><STRONG>tmp_file</STRONG>(<VAR>+Base, -TmpName</VAR>)</A><DD>
Create a name for a temporary file. <VAR>Base</VAR> is an identifier for 
the category of file. The <VAR>TmpName</VAR> is guaranteed to be unique. 
If the system halts, it will automatically remove all created temporary 
files.

<P>

<P>
<DT><A NAME="chdir/1"><STRONG>chdir</STRONG>(<VAR>+Path</VAR>)</A><DD>
Change working directory to <VAR>Path</VAR>.<A NAME=back-to-note-17 HREF="Notes.html#note-17"> (17)</A>

<P>
</DL>

