<HTML><HEAD><TITLE>SWI-Prolog Reference Manual: Section 3.36</TITLE><LINK REL=home HREF="Title.html">
<LINK REL=contents HREF="Contents.html">
<LINK REL=index HREF="Index.html">
<LINK REL=summary HREF="sec-B.html">
<LINK REL=previous HREF="sec-3.35.html">
<LINK REL=next HREF="sec-3.37.html">
</HEAD>

<BODY>

<HR><CENTER><A HREF="Title.html">Home</A>
<A HREF="Contents.html">Contents</A>
<A HREF="Index.html">Index</A>
<A HREF="sec-B.html">Summary</A>
<A HREF="sec-3.35.html">Previous</A>
<A HREF="sec-3.37.html">Next</A>
</CENTER>

<HR>

<H2><A NAME="sec:3.36">3.36 User Toplevel Manipulation</A></H2>

<P>

<DL>

<P>
<DT><A NAME="break/0"><STRONG>break</STRONG></A><DD>
Recursively start a new Prolog top level. This Prolog top level has its 
own stacks, but shares the heap with all break environments and the top 
level. Debugging is switched off on entering a break and restored on 
leaving one. The break environment is terminated by typing the system's 
end-of-file character (control-D). If the
<STRONG>-t</STRONG> <VAR>toplevel</VAR> command line option is given 
this goal is started instead of entering the default interactive top 
level (<A NAME="idx:prolog/0:498"></A><A HREF="sec-3.36.html#prolog/0">prolog/0</A>).

<P>
<DT><A NAME="abort/0"><STRONG>abort</STRONG></A><DD>
Abort the Prolog execution and start a new top level. If the
<STRONG>-t</STRONG> <VAR>toplevel</VAR> command line options is given 
this goal is started instead of entering the default interactive top 
level. Break environments are aborted as well. All open files except for 
the terminal related files are closed. The input- and output stream 
again refers to <VAR>user</VAR>.<A NAME=back-to-note-18 HREF="Notes.html#note-18"> (18)</A>

<P>
<DT><A NAME="halt/0"><STRONG>halt</STRONG></A><DD>
Terminate Prolog execution. Open files are closed and if the command 
line option <STRONG>-tty</STRONG> is not active the terminal status (see 
Unix stty(1)) is restored. Hooks may be registered both in Prolog and in 
foreign code. Prolog hooks are registered using <A NAME="idx:at_halt/1:499"></A><A HREF="sec-3.2.html#at_halt/1">at_halt/1</A>. <A NAME="idx:halt/0:500"></A><A HREF="sec-3.36.html#halt/0">halt/0</A> 
is equivalent to <CODE>halt(0)</CODE>.

<P>
<DT><A NAME="halt/1"><STRONG>halt</STRONG>(<VAR>+Status</VAR>)</A><DD>
Terminate Prolog execution with given status. Status is an integer. See 
also <A NAME="idx:halt/0:501"></A><A HREF="sec-3.36.html#halt/0">halt/0</A>.

<P>
<DT><A NAME="prolog/0"><STRONG>prolog</STRONG></A><DD>
This goal starts the default interactive top level. Queries are read 
from the stream <CODE>user_input</CODE>. See also the <CODE>history</CODE> 
feature (<A NAME="idx:feature/2:502"></A><A HREF="sec-2.8.html#feature/2">feature/2</A>). 
The <A NAME="idx:prolog/0:503"></A><A HREF="sec-3.36.html#prolog/0">prolog/0</A> 
predicate is terminated (succeeds) by typing the end-of-file character 
(Unix: control-D).
</DL>

<P>The following two hooks allow for expanding queries and handling the 
result of a query. These hooks are used by the toplevel variable 
expansion mechanism described in <A HREF="sec-2.5.html">section 2.5</A>.

<P>

<DL>

<P>
<DT><A NAME="expand_query/4"><STRONG>expand_query</STRONG>(<VAR>+Query, 
-Expanded, +Bindings, -ExpandedBindings</VAR>)</A><DD>
Hook in module <CODE>user</CODE>, normally not defined. <VAR>Query</VAR> 
and
<VAR>Bindings</VAR> represents the query read from the user and the 
names of the free variables as obtained using <A NAME="idx:read_term/3:504"></A><A HREF="sec-3.18.html#read_term/3">read_term/3</A>. 
If this predicate succeeds, it should bind <VAR>Expanded</VAR> and <VAR>ExpandedBindings</VAR> 
to the query and bindings to be executed by the toplevel. This predicate 
is used by the toplevel (<A NAME="idx:prolog/0:505"></A><A HREF="sec-3.36.html#prolog/0">prolog/0</A>). 
See also <A NAME="idx:expand_answer/2:506"></A><A HREF="sec-3.36.html#expand_answer/2">expand_answer/2</A> 
and
<A NAME="idx:term_expansion/2:507"></A><A HREF="sec-3.2.html#term_expansion/2">term_expansion/2</A>.

<P>

<P>
<DT><A NAME="expand_answer/2"><STRONG>expand_answer</STRONG>(<VAR>+Bindings, 
-ExpandedBindings</VAR>)</A><DD>
Hook in module <CODE>user</CODE>, normally not defined. Expand the 
result of a successfully executed toplevel query. <VAR>Bindings</VAR> is 
the query
<VAR>&lt;<VAR>Name</VAR>&gt;=&lt;<VAR>Value</VAR>&gt;</VAR> binding list 
from the query. <VAR>ExpandedBindings</VAR> must be unified with the 
bindings the toplevel should print.
</DL>

