<HTML><HEAD><TITLE>SWI-Prolog Reference Manual: Section 3.38</TITLE><LINK REL=home HREF="Title.html">
<LINK REL=contents HREF="Contents.html">
<LINK REL=index HREF="Index.html">
<LINK REL=summary HREF="sec-B.html">
<LINK REL=previous HREF="sec-3.37.html">
<LINK REL=next HREF="sec-3.39.html">
</HEAD>

<BODY>

<HR><CENTER><A HREF="Title.html">Home</A>
<A HREF="Contents.html">Contents</A>
<A HREF="Index.html">Index</A>
<A HREF="sec-B.html">Summary</A>
<A HREF="sec-3.37.html">Previous</A>
<A HREF="sec-3.39.html">Next</A>
</CENTER>

<HR>

<H2><A NAME="sec:3.38">3.38 Debugging and Tracing Programs</A></H2>

<A NAME="sec:debugger"></A>

<P>

<DL>

<P>
<DT><A NAME="trace/0"><STRONG>trace</STRONG></A><DD>
Start the tracer. <A NAME="idx:trace/0:511"></A><A HREF="sec-3.38.html#trace/0">trace/0</A> 
itself cannot be seen in the tracer. Note that the Prolog toplevel 
treats <A NAME="idx:trace/0:512"></A><A HREF="sec-3.38.html#trace/0">trace/0</A> 
special; it means `trace the next goal'.

<P>
<DT><A NAME="tracing/0"><STRONG>tracing</STRONG></A><DD>
Succeeds when the tracer is currently switched on. <A NAME="idx:tracing/0:513"></A><A HREF="sec-3.38.html#tracing/0">tracing/0</A> 
itself can not be seen in the tracer.

<P>
<DT><A NAME="notrace/0"><STRONG>notrace</STRONG></A><DD>
Stop the tracer. <A NAME="idx:notrace/0:514"></A><A HREF="sec-3.38.html#notrace/0">notrace/0</A> 
itself cannot be seen in the tracer.

<P>
<DT><A NAME="trace/1"><STRONG>trace</STRONG>(<VAR>+Pred</VAR>)</A><DD>
Equivalent to <CODE>trace(<VAR>Pred</VAR>, +all)</CODE>.

<P>
<DT><A NAME="trace/2"><STRONG>trace</STRONG>(<VAR>+Pred, +Ports</VAR>)</A><DD>
Put a trace-point on all predicates satisfying the predicate 
specification
<VAR>Pred</VAR>. <VAR>Ports</VAR> is a list of portnames (<CODE>call</CODE>,
<CODE>redo</CODE>, <CODE>exit</CODE>, <CODE>fail</CODE>). The atom <CODE>all</CODE> 
refers to all ports. If the port is preceded by a <CODE><CODE>-</CODE></CODE> 
sign the trace-point is cleared for the port. If it is preceded by a <CODE><CODE>+</CODE></CODE> 
the trace-point is set.

<P>The predicate <A NAME="idx:trace/2:515"></A><A HREF="sec-3.38.html#trace/2">trace/2</A> 
activates debug mode (see <A NAME="idx:debug/0:516"></A><A HREF="sec-3.38.html#debug/0">debug/0</A>). 
Each time a port (of the 4-port model) is passed that has a trace-point 
set the goal is printed as with <A NAME="idx:trace/0:517"></A><A HREF="sec-3.38.html#trace/0">trace/0</A>. 
Unlike <A NAME="idx:trace/0:518"></A><A HREF="sec-3.38.html#trace/0">trace/0</A> 
however, the execution is continued without asking for further 
information. Examples:

<P><CENTER>
<TABLE BORDER=0 COLS=2 FRAME=void RULES=group>
<TR VALIGN=top><TD><CODE>?- trace(hello).</CODE> <TD>Trace all ports of 
hello with any arity in any module. </TR>
<TR VALIGN=top><TD><CODE>?- trace(foo/2, +fail).</CODE> <TD>Trace 
failures of foo/2 in any module. </TR>
<TR VALIGN=top><TD><CODE>?- trace(bar/1, -all).</CODE> <TD>Stop tracing bar/1.</TR>
</TABLE>

</CENTER>

<P>The predicate <A NAME="idx:debugging/0:519"></A><A HREF="sec-3.38.html#debugging/0">debugging/0</A> 
shows all currently defined trace-points.

<P>
<DT><A NAME="notrace/1"><STRONG>notrace</STRONG>(<VAR>+Goal</VAR>)</A><DD>
Call <VAR>Goal</VAR>, but suspend the debugger while <VAR>Goal</VAR> is 
executing. The current implementation cuts the choicepoints of <VAR>Goal</VAR> 
after successful completion. See <A NAME="idx:once/1:520"></A><A HREF="sec-3.7.html#once/1">once/1</A>. 
Later implementations may have the same semantics as <A NAME="idx:call/1:521"></A><A HREF="sec-3.7.html#call/1">call/1</A>.

<P>
<DT><A NAME="debug/0"><STRONG>debug</STRONG></A><DD>
Start debugger (stop at spy points).

<P>
<DT><A NAME="nodebug/0"><STRONG>nodebug</STRONG></A><DD>
Stop debugger (do not trace, nor stop at spy points).

<P>
<DT><A NAME="debugging/0"><STRONG>debugging</STRONG></A><DD>
Print debug status and spy points on current output stream.

<P>
<DT><A NAME="spy/1"><STRONG>spy</STRONG>(<VAR>+Pred</VAR>)</A><DD>
Put a spy point on all predicates meeting the predicate specification
<VAR>Pred</VAR>. See <A HREF="sec-3.3.html">section 3.3</A>.

<P>
<DT><A NAME="nospy/1"><STRONG>nospy</STRONG>(<VAR>+Pred</VAR>)</A><DD>
Remove spy point from all predicates meeting the predicate specification
<VAR>Pred</VAR>.

<P>
<DT><A NAME="nospyall/0"><STRONG>nospyall</STRONG></A><DD>
Remove all spy points from the entire program.

<P>
<DT><A NAME="leash/1"><STRONG>leash</STRONG>(<VAR>?Ports</VAR>)</A><DD>
Set/query leashing (ports which allow for user interaction). <VAR>Ports</VAR> 
is one of <VAR>+Name</VAR>, <VAR>-Name</VAR>, <VAR>?Name</VAR> or a list 
of these.
<VAR>+Name</VAR> enables leashing on that port, <VAR>-Name</VAR> 
disables it and
<VAR>?Name</VAR> succeeds or fails according to the current setting. 
Recognised ports are: <CODE>call</CODE>, <CODE>redo</CODE>, <CODE>exit</CODE>, <CODE>fail</CODE> 
and
<CODE>unify</CODE>. The special shorthand <CODE>all</CODE> refers to all 
ports,
<CODE>full</CODE> refers to all ports except for the unify port 
(default).
<CODE>half</CODE> refers to the <CODE>call</CODE>, <CODE>redo</CODE> and <CODE>fail</CODE> 
port.

<P>
<DT><A NAME="visible/1"><STRONG>visible</STRONG>(<VAR>+Ports</VAR>)</A><DD>
Set the ports shown by the debugger. See <A NAME="idx:leash/1:522"></A><A HREF="sec-3.38.html#leash/1">leash/1</A> 
for a description of the port specification. Default is <CODE>full</CODE>.

<P>
<DT><A NAME="unknown/2"><STRONG>unknown</STRONG>(<VAR>-Old, +New</VAR>)</A><DD>
Unify <VAR>Old</VAR> with the current value of the unknown system flag. 
On success <VAR>New</VAR> will be used to specify the new value. <VAR>New</VAR> 
should be instantiated to either <CODE>fail</CODE> or <CODE>trace</CODE> 
and determines the interpreters action when an undefined predicate which 
is not declared dynamic is encountered (see <A NAME="idx:dynamic/1:523"></A><A HREF="sec-3.13.html#dynamic/1">dynamic/1</A>). <CODE>fail</CODE> 
implies the predicate just fails silently. <CODE>trace</CODE> implies 
the tracer is started. Default is
<CODE>trace</CODE>. The unknown flag is local to each module and <A NAME="idx:unknown/2:524"></A><A HREF="sec-3.38.html#unknown/2">unknown/2</A> 
is module transparent. Using it as a directive in a module file will 
only change the unknown flag for that module. Using the :/2 construct 
the behaviour on trapping an undefined predicate can be changed for any 
module. Note that if the unknown flag for a module equals <CODE>fail</CODE> 
the system will not call <A NAME="idx:exception/3:525"></A><A HREF="sec-A.3.html#exception/3">exception/3</A> 
and will </EM><B>not</B> try to resolve the predicate via the dynamic 
library system. The system will still try to import the predicate from 
the public module.

<P>
<DT><A NAME="style_check/1"><STRONG>style_check</STRONG>(<VAR>+Spec</VAR>)</A><DD>
Set style checking options. <VAR>Spec</VAR> is either </EM><TT>+&lt;<VAR>option</VAR>&gt;</TT>,
</EM><TT>-&lt;<VAR>option</VAR>&gt;</TT>, </EM><TT>?&lt;<VAR>option</VAR>&gt;</TT> 
or a list of such options.
</EM><TT>+&lt;<VAR>option</VAR>&gt;</TT> sets a style checking option, </EM><TT>-&lt;<VAR>option</VAR>&gt;</TT> 
clears it and </EM><TT>?&lt;<VAR>option</VAR>&gt;</TT> succeeds or fails 
according to the current setting. <A NAME="idx:consult/1:526"></A><A HREF="sec-3.2.html#consult/1">consult/1</A> 
and derivatives resets the style checking options to their value before 
loading the file. If---for example---a file containing long atoms should 
be loaded the user can start the file with:

<XMP>
:- style_check(-atom).
</XMP>

<P>Currently available options are:

<P><CENTER>
<TABLE BORDER=2 COLS=3 FRAME=border RULES=group>
<TR VALIGN=top><TD>Name<TD ALIGN=center>Default<TD>Description </TR>
<TBODY>
<TR VALIGN=top><TD><CODE>singleton</CODE> <TD ALIGN=center>on<TD><A NAME="idx:read_clause/1:527"></A><A HREF="sec-3.18.html#read_clause/1">read_clause/1</A> 
(used by <A NAME="idx:consult/1:528"></A><A HREF="sec-3.2.html#consult/1">consult/1</A>) 
warns on variables only appearing once in a term (clause) which have a 
name not starting with an underscore. </TR>
<TR VALIGN=top><TD><CODE>atom</CODE> <TD ALIGN=center>on<TD><A NAME="idx:read/1:529"></A><A HREF="sec-3.18.html#read/1">read/1</A> 
and derivatives will produce an error message on quoted atoms or strings 
longer than 5 lines. </TR>
<TR VALIGN=top><TD><CODE>dollar</CODE> <TD ALIGN=center>off<TD>Accept 
dollar as a lower case character, thus avoiding the need for quoting 
atoms with dollar signs. System maintenance use only. </TR>
<TR VALIGN=top><TD><CODE>discontiguous</CODE> <TD ALIGN=center>on<TD>Warn 
if the clauses for a predicate are not together in the same source file. </TR>
<TR VALIGN=top><TD><CODE>string</CODE> <TD ALIGN=center>off<TD>Read and 
derivatives transform <CODE>" ... "</CODE> into a prolog string instead 
of a list of ASCII characters. </TR>
</TABLE>

</CENTER>

<P>
</DL>

