<HTML><HEAD><TITLE>SWI-Prolog Reference Manual: Section 3.39</TITLE><LINK REL=home HREF="Title.html">
<LINK REL=contents HREF="Contents.html">
<LINK REL=index HREF="Index.html">
<LINK REL=summary HREF="sec-B.html">
<LINK REL=previous HREF="sec-3.38.html">
<LINK REL=next HREF="sec-3.40.html">
</HEAD>

<BODY>

<HR><CENTER><A HREF="Title.html">Home</A>
<A HREF="Contents.html">Contents</A>
<A HREF="Index.html">Index</A>
<A HREF="sec-B.html">Summary</A>
<A HREF="sec-3.38.html">Previous</A>
<A HREF="sec-3.40.html">Next</A>
</CENTER>

<HR>

<H2><A NAME="sec:3.39">3.39 Obtaining Runtime Statistics</A></H2>

<P>

<DL>

<P>
<DT><A NAME="statistics/2"><STRONG>statistics</STRONG>(<VAR>+Key, -Value</VAR>)</A><DD>
Unify system statistics determined by <VAR>Key</VAR> with <VAR>Value</VAR>. 
The possible keys are given in the <A HREF="sec-3.39.html#tab:statistics">table 
4</A>.

<P>
<CENTER>
<TABLE BORDER=2 COLS=2 FRAME=border RULES=group>
<TR VALIGN=top><TD>cputime<TD>(User) </EM><font size=-1>CPU</font> time 
since Prolog was started in seconds </TR>
<TR VALIGN=top><TD>inferences<TD>Total number of passes via the call and 
redo ports since Prolog was started. </TR>
<TR VALIGN=top><TD>heap<TD>Estimated total size of the heap (see <A HREF="sec-2.12.html">section 
2.12.1.1</A>) </TR>
<TR VALIGN=top><TD>heapused<TD>Bytes heap in use by Prolog. </TR>
<TR VALIGN=top><TD>heaplimit<TD>Maximum size of the heap (see <A HREF="sec-2.12.html">section 
2.12.1.1</A>) </TR>
<TR VALIGN=top><TD>local<TD>Allocated size of the local stack in bytes. </TR>
<TR VALIGN=top><TD>localused<TD>Number of bytes in use on the local 
stack. </TR>
<TR VALIGN=top><TD>locallimit<TD>Size to which the local stack is 
allowed to grow </TR>
<TR VALIGN=top><TD>global<TD>Allocated size of the global stack in 
bytes. </TR>
<TR VALIGN=top><TD>globalused<TD>Number of bytes in use on the global 
stack. </TR>
<TR VALIGN=top><TD>globallimit<TD>Size to which the global stack is 
allowed to grow </TR>
<TR VALIGN=top><TD>trail<TD>Allocated size of the trail stack in bytes. </TR>
<TR VALIGN=top><TD>trailused<TD>Number of bytes in use on the trail 
stack. </TR>
<TR VALIGN=top><TD>traillimit<TD>Size to which the trail stack is 
allowed to grow </TR>
<TR VALIGN=top><TD>atoms<TD>Total number of defined atoms. </TR>
<TR VALIGN=top><TD>functors<TD>Total number of defined name/arity pairs. </TR>
<TR VALIGN=top><TD>predicates<TD>Total number of predicate definitions. </TR>
<TR VALIGN=top><TD>modules<TD>Total number of module definitions. </TR>
<TR VALIGN=top><TD>codes<TD>Total amount of byte codes in all clauses. </TR>
</TABLE>

</CENTER>
<CENTER><B>Table 4 : Keys for <A NAME="idx:statistics/2:530"></A><A HREF="sec-3.39.html#statistics/2">statistics/2</A></B></CENTER>
<A NAME="tab:statistics"></A>

<P>

<P>
<DT><A NAME="statistics/0"><STRONG>statistics</STRONG></A><DD>
Display a table of system statistics on the current output stream.

<P>
<DT><A NAME="time/1"><STRONG>time</STRONG>(<VAR>+Goal</VAR>)</A><DD>
Execute <VAR>Goal</VAR> just like <A NAME="idx:once/1:531"></A><A HREF="sec-3.7.html#once/1">once/1</A> 
(i.e. leaving no choice points), but print used time, number of logical 
inferences and the average number of <VAR>lips</VAR> (logical inferences 
per second). Note that SWI-Prolog counts the actual executed number of 
inferences rather than the number of passes through the call- and redo 
ports of the theoretical 4-port model.
</DL>

