<HTML><HEAD><TITLE>SWI-Prolog Reference Manual: Section 3.40</TITLE><LINK REL=home HREF="Title.html">
<LINK REL=contents HREF="Contents.html">
<LINK REL=index HREF="Index.html">
<LINK REL=summary HREF="sec-B.html">
<LINK REL=previous HREF="sec-3.39.html">
<LINK REL=next HREF="sec-3.41.html">
</HEAD>

<BODY>

<HR><CENTER><A HREF="Title.html">Home</A>
<A HREF="Contents.html">Contents</A>
<A HREF="Index.html">Index</A>
<A HREF="sec-B.html">Summary</A>
<A HREF="sec-3.39.html">Previous</A>
<A HREF="sec-3.41.html">Next</A>
</CENTER>

<HR>

<H2><A NAME="sec:3.40">3.40 Finding Performance Bottlenecks</A></H2>

<P>SWI-Prolog offers a statistical program profiler similar to Unix 
prof(1) for C and some other languages. A profiler is used as an aid to 
find performance pigs in programs. It provides information on the time 
spent in the various Prolog predicates.

<P>The profiler is based on the assumption that if we monitor the 
functions on the execution stack on time intervals not correlated to the 
program's execution the number of times we find a procedure on the 
environment stack is a measure of the time spent in this procedure. It 
is implemented by calling a procedure each time slice Prolog is active. 
This procedure scans the local stack and either just counts the 
procedure on top of this stack (<CODE>plain</CODE> profiling) or all 
procedures on the stack (<CODE>cumulative</CODE> profiling). To get 
accurate results each procedure one is interested in should have a 
reasonable number of counts. Typically a minute runtime will suffice to 
get a rough overview of the most expensive procedures.

<P>

<DL>

<P>
<DT><A NAME="profile/3"><STRONG>profile</STRONG>(<VAR>+Goal, +Style, 
+Number</VAR>)</A><DD>
Execute <VAR>Goal</VAR> just like <A NAME="idx:time/1:532"></A><A HREF="sec-3.39.html#time/1">time/1</A>. 
Collect profiling statistics according to style (see <A NAME="idx:profiler/2:533"></A><A HREF="sec-3.40.html#profiler/2">profiler/2</A>) 
and show the top <VAR>Number</VAR> procedures on the current output 
stream (see <A NAME="idx:show_profile/1:534"></A><A HREF="sec-3.40.html#show_profile/1">show_profile/1</A>). 
The results are kept in the database until <A NAME="idx:reset_profiler/0:535"></A><A HREF="sec-3.40.html#reset_profiler/0">reset_profiler/0</A> 
or <A NAME="idx:profile/3:536"></A><A HREF="sec-3.40.html#profile/3">profile/3</A> 
is called and can be displayed again with <A NAME="idx:show_profile/1:537"></A><A HREF="sec-3.40.html#show_profile/1">show_profile/1</A>. <A NAME="idx:profile/3:538"></A><A HREF="sec-3.40.html#profile/3">profile/3</A> 
is the normal way to invoke the profiler. The predicates below are 
low-level predicates that can be used for special cases.

<P>
<DT><A NAME="show_profile/1"><STRONG>show_profile</STRONG>(<VAR>+Number</VAR>)</A><DD>
Show the collected results of the profiler. Stops the profiler first to 
avoid interference from <A NAME="idx:show_profile/1:539"></A><A HREF="sec-3.40.html#show_profile/1">show_profile/1</A>. 
It shows the top <VAR>Number</VAR> predicates according the percentage </EM><font size=-1>CPU</font>-time 
used.<A NAME=back-to-note-20 HREF="Notes.html#note-20"> (20)</A>

<P>
<DT><A NAME="profiler/2"><STRONG>profiler</STRONG>(<VAR>-Old, +New</VAR>)</A><DD>
Query or change the status of the profiler. The status is one of
<CODE>off</CODE>, <CODE>plain</CODE> or <CODE>cumulative</CODE>. <CODE>plain</CODE> 
implies the time used by children of a predicate is not added to the 
time of the predicate. For status <CODE>cumulative</CODE> the time of 
children is added (except for recursive calls). Cumulative profiling 
implies the stack is scanned up to the top on each time slice to find 
all active predicates. This implies the overhead grows with the number 
of active frames on the stack. Cumulative profiling starts debugging 
mode to disable tail recursion optimisation, which would otherwise 
remove the necessary parent environments. Switching status from
<CODE>plain</CODE> to <CODE>cumulative</CODE> resets the profiler. 
Switching to and from status <CODE>off</CODE> does not reset the 
collected statistics, thus allowing to suspend profiling for certain 
parts of the program.

<P>
<DT><A NAME="reset_profiler/0"><STRONG>reset_profiler</STRONG></A><DD>
Switches the profiler to <CODE>off</CODE> and clears all collected 
statistics.

<P>
<DT><A NAME="profile_count/3"><STRONG>profile_count</STRONG>(<VAR>+Head, 
-Calls, -Promilage</VAR>)</A><DD>
Obtain profile statistics of the predicate specified by <VAR>Head</VAR>.
<VAR>Head</VAR> is an atom for predicates with arity 0 or a term with 
the same name and arity as the predicate required (see
<A NAME="idx:current_predicate/2:540"></A><A HREF="sec-3.14.html#current_predicate/2">current_predicate/2</A>). <VAR>Calls</VAR> 
is unified with the number of `calls' and `redos' while the profiler was 
active. <VAR>Promilage</VAR> is unified with the relative number of 
counts the predicate was active (<CODE>cumulative</CODE>) or on top of 
the stack (<CODE>plain</CODE>). <VAR>Promilage</VAR> is an integer 
between 0 and 1000.
</DL>

