<HTML><HEAD><TITLE>SWI-Prolog Reference Manual: Section 3.41</TITLE><LINK REL=home HREF="Title.html">
<LINK REL=contents HREF="Contents.html">
<LINK REL=index HREF="Index.html">
<LINK REL=summary HREF="sec-B.html">
<LINK REL=previous HREF="sec-3.40.html">
<LINK REL=next HREF="sec-3.42.html">
</HEAD>

<BODY>

<HR><CENTER><A HREF="Title.html">Home</A>
<A HREF="Contents.html">Contents</A>
<A HREF="Index.html">Index</A>
<A HREF="sec-B.html">Summary</A>
<A HREF="sec-3.40.html">Previous</A>
<A HREF="sec-3.42.html">Next</A>
</CENTER>

<HR>

<H2><A NAME="sec:3.41">3.41 Memory Management</A></H2>

<P>Note: <A NAME="idx:limit_stack/2:541"></A><A HREF="sec-3.41.html#limit_stack/2">limit_stack/2</A> 
and <A NAME="idx:trim_stacks/0:542"></A><A HREF="sec-3.41.html#trim_stacks/0">trim_stacks/0</A> 
have no effect on machines that do not offer dynamic stack expansion. On 
these machines these predicates simply succeed to improve portability.

<P>

<DL>

<P>
<DT><A NAME="garbage_collect/0"><STRONG>garbage_collect</STRONG></A><DD>
Invoke the global- and trail stack garbage collector. Normally the 
garbage collector is invoked automatically if necessary. Explicit 
invocation might be useful to reduce the need for garbage collections in 
time critical segments of the code. After the garbage collection
<A NAME="idx:trim_stacks/0:543"></A><A HREF="sec-3.41.html#trim_stacks/0">trim_stacks/0</A> 
is invoked to release the collected memory resources.

<P>

<P>
<DT><A NAME="limit_stack/2"><STRONG>limit_stack</STRONG>(<VAR>+Key, 
+Kbytes</VAR>)</A><DD>
Limit one of the stack areas to the specified value. <VAR>Key</VAR> is 
one of
<CODE>local</CODE>, <CODE>global</CODE> or <CODE>trail</CODE>. The limit 
is an integer, expressing the desired stack limit in K bytes. If the 
desired limit is smaller than the currently used value, the limit is set 
to the nearest legal value above the currently used value. If the 
desired value is larger than the maximum, the maximum is taken. Finally, 
if the desired value is either 0 or the atom <CODE>unlimited</CODE> the 
limit is set to its maximum. The maximum and initial limit is determined 
by the command line options <STRONG>-L</STRONG>, <STRONG>-G</STRONG> and <STRONG>-T</STRONG>.

<P>

<P>
<DT><A NAME="trim_stacks/0"><STRONG>trim_stacks</STRONG></A><DD>
Release stack memory resources that are not in use at this moment, 
returning them to the operating system. Trim stack is a relatively cheap 
call. It can be used to release memory resources in a backtracking loop, 
where the iterations require typically seconds of execution time and 
very different, potentially large, amounts of stack space. Such a loop 
should be written as follows:

<P>

<XMP>
loop :-
        generator,
            trim_stacks,
            potentially_expensive_operation,
        stop_condition, !.
</XMP>

<P>The prolog top level loop is written this way, reclaiming memory 
resources after every user query.

<P>

<P>
<DT><A NAME="stack_parameter/4"><STRONG>stack_parameter</STRONG>(<VAR>+Stack, 
+Key, -Old, +New</VAR>)</A><DD>
Query/set a parameter for the runtime stacks. <VAR>Stack</VAR> is one of <CODE>local</CODE>, <CODE>global</CODE>, <CODE>trail</CODE> 
or <CODE>argument</CODE>. The table below describes the <VAR>Key</VAR>/<VAR>Value</VAR> 
pairs. Old is first unified with the current value.

<P><CENTER>
<TABLE BORDER=2 COLS=2 FRAME=border RULES=group>
<TR VALIGN=top><TD><CODE>limit</CODE> <TD>Maximum size of the stack in 
bytes </TR>
<TR VALIGN=top><TD><CODE>min_free</CODE> <TD>Minimum free space at entry 
of foreign predicate </TR>
</TABLE>

</CENTER>

<P>This predicate is currently only available on versions that use the 
stack-shifter to enlarge the runtime stacks when necessary. It's 
definition is subject to change.
</DL>

