<HTML><HEAD><TITLE>SWI-Prolog Reference Manual: Section 3.43</TITLE><LINK REL=home HREF="Title.html">
<LINK REL=contents HREF="Contents.html">
<LINK REL=index HREF="Index.html">
<LINK REL=summary HREF="sec-B.html">
<LINK REL=previous HREF="sec-3.42.html">
<LINK REL=next HREF="sec-4.html">
</HEAD>

<BODY>

<HR><CENTER><A HREF="Title.html">Home</A>
<A HREF="Contents.html">Contents</A>
<A HREF="Index.html">Index</A>
<A HREF="sec-B.html">Summary</A>
<A HREF="sec-3.42.html">Previous</A>
<A HREF="sec-4.html">Next</A>
</CENTER>

<HR>

<H2><A NAME="sec:3.43">3.43 Miscellaneous</A></H2>

<P>

<DL>

<P>
<DT><A NAME="dwim_match/2"><STRONG>dwim_match</STRONG>(<VAR>+Atom1, 
+Atom2</VAR>)</A><DD>
Succeeds if <VAR>Atom1</VAR> matches <VAR>Atom2</VAR> in `Do What I 
Mean' sense. Both <VAR>Atom1</VAR> and <VAR>Atom2</VAR> may also be 
integers or floats. The two atoms match if:
<UL COMPACT>
<LI>They are identical
<LI>They differ by one character (spy <VAR>==</VAR> spu)
<LI>One character is inserted/deleted (debug <VAR>==</VAR> deug)
<LI>Two characters are transposed (trace <VAR>==</VAR> tarce)
<LI>`Sub-words' are glued differently (existsfile <VAR>==</VAR> 
existsFile <VAR>==</VAR> exists_file)
<LI>Two adjacent sub words are transposed (existsFile <VAR>==</VAR> 
fileExists)
</UL>

<P>
<DT><A NAME="dwim_match/3"><STRONG>dwim_match</STRONG>(<VAR>+Atom1, 
+Atom2, -Difference</VAR>)</A><DD>
Equivalent to <A NAME="idx:dwim_match/2:545"></A><A HREF="sec-3.43.html#dwim_match/2">dwim_match/2</A>, 
but unifies <VAR>Difference</VAR> with an atom identifying the the 
difference between <VAR>Atom1</VAR> and <VAR>Atom2</VAR>. The return 
values are (in the same order as above): <CODE>equal</CODE>,
<CODE>mismatched_char</CODE>, <CODE>inserted_char</CODE>, <CODE>transposed_char</CODE>,
<CODE>separated</CODE> and <CODE>transposed_word</CODE>.

<P>
<DT><A NAME="wildcard_match/2"><STRONG>wildcard_match</STRONG>(<VAR>+Pattern, 
+String</VAR>)</A><DD>
Succeeds if <VAR>String</VAR> matches the wildcard pattern <VAR>Pattern</VAR>. <VAR>Pattern</VAR> 
is very similar the the Unix csh pattern matcher. The patterns are given 
below:
<CENTER>
<TABLE BORDER=0 COLS=2 FRAME=void RULES=group>
<TR VALIGN=top><TD><CODE><CODE>?</CODE></CODE> <TD>Matches one arbitrary 
character. </TR>
<TR VALIGN=top><TD><CODE><CODE>*</CODE></CODE> <TD>Matches any number of 
arbitrary characters. </TR>
<TR VALIGN=top><TD><CODE>[ ... ]</CODE> <TD>Matches one of the 
characters specified between the brackets. </EM><TT>&lt;<VAR>char1</VAR>&gt;-&lt;<VAR>char2</VAR>&gt;</TT> 
indicates a range. </TR>
<TR VALIGN=top><TD><CODE>{...}</CODE> <TD>Matches any of the patterns of 
the comma separated list between the braces.</TR>
</TABLE>

</CENTER> Example:

<XMP>
?- wildcard_match('[a-z]*.{pro,pl}[%~]', 'a_hello.pl%').

Yes.
</XMP>

<P>

<P>
<DT><A NAME="gensym/2"><STRONG>gensym</STRONG>(<VAR>+Base, -Unique</VAR>)</A><DD>
Generate a unique atom from base <VAR>Base</VAR> and unify it with <VAR>Unique</VAR>.
<VAR>Base</VAR> should be an atom. The first call will return &lt;<VAR>base</VAR>&gt;1 
, the next &lt;<VAR>base</VAR>&gt;2 , etc. Note that this is no warrant 
that the atom is unique in the system.<A NAME=back-to-note-22 HREF="Notes.html#note-22"> (22)</A>

<P>

<P>
<DT><A NAME="sleep/1"><STRONG>sleep</STRONG>(<VAR>+Time</VAR>)</A><DD>
Suspend execution <VAR>Time</VAR> seconds. <VAR>Time</VAR> is either a 
floating point number or an integer. Granularity is dependent on the 
system's timer granularity. A negative time causes the timer to return 
immediately. On most non-realtime operating systems we can only ensure 
execution is suspended for </EM><B>at least</B> <VAR>Time</VAR> seconds.
</DL>

