<HTML><HEAD><TITLE>SWI-Prolog Reference Manual: Section 3.5</TITLE><LINK REL=home HREF="Title.html">
<LINK REL=contents HREF="Contents.html">
<LINK REL=index HREF="Index.html">
<LINK REL=summary HREF="sec-B.html">
<LINK REL=previous HREF="sec-3.4.html">
<LINK REL=next HREF="sec-3.6.html">
</HEAD>

<BODY>

<HR><CENTER><A HREF="Title.html">Home</A>
<A HREF="Contents.html">Contents</A>
<A HREF="Index.html">Index</A>
<A HREF="sec-B.html">Summary</A>
<A HREF="sec-3.4.html">Previous</A>
<A HREF="sec-3.6.html">Next</A>
</CENTER>

<HR>

<H2><A NAME="sec:3.5">3.5 Comparison and Unification or Terms</A></H2>

<A NAME="sec:compare"></A>

<P>

<H3><A NAME="sec:3.5.1">3.5.1 Standard Order of Terms</A></H3>

<P>Comparison and unification of arbitrary terms. Terms are ordered in 
the so called ``standard order''. This order is defined as follows:

<P><OL>
<LI><VAR><VAR>Variables</VAR> &lt; <VAR>Atoms</VAR> &lt; <VAR>Strings</VAR></VAR>
<LI><VAR><VAR>Old&nbsp;Variable</VAR> &lt; <VAR>New&nbsp;Variable</VAR></VAR><A NAME=back-to-note-10 HREF="Notes.html#note-10"> (10)</A>
<LI><VAR>Atoms</VAR> are compared alphabetically.
<LI><VAR>Strings</VAR> are compared alphabetically.
<LI><VAR>Numbers</VAR> are compared by value. Integers and floats are 
treated identically.
<LI><VAR>Terms</VAR> are first checked on their functor 
(alphabetically), then on their arity and finally recursively on their 
arguments, leftmost argument first.
</OL>

<P>

<DL>

<P>
<DT><A NAME="==/2"><VAR>+Term1</VAR> <STRONG>==</STRONG> <VAR>+Term2</VAR></A><DD>
Succeeds if <VAR>Term1</VAR> is equivalent to <VAR>Term2</VAR>. A 
variable is only identical to a sharing variable.

<P>
<DT><A NAME="\==/2"><VAR>+Term1</VAR> <STRONG>\==</STRONG> <VAR>+Term2</VAR></A><DD>
Equivalent to <CODE><CODE>\+</CODE>Term1 == Term2</CODE>.

<P>
<DT><A NAME="=/2"><VAR>+Term1</VAR> <STRONG>=</STRONG> <VAR>+Term2</VAR></A><DD>
Unify <VAR>Term1</VAR> with <VAR>Term2</VAR>. Succeeds if the 
unification succeeds.

<P>
<DT><A NAME="\=/2"><VAR>+Term1</VAR> <STRONG>\=</STRONG> <VAR>+Term2</VAR></A><DD>
Equivalent to <CODE><CODE>\+</CODE>Term1 = Term2</CODE>.

<P>
<DT><A NAME="=@=/2"><VAR>+Term1</VAR> <STRONG>=@=</STRONG> <VAR>+Term2</VAR></A><DD>
Succeeds if <VAR>Term1</VAR> is `structurally equal' to <VAR>Term2</VAR>. 
Structural equivalence is weaker than equivalence (<A HREF="sec-3.5.html#==/2">==/2</A>), 
but stronger than unification (<A HREF="sec-3.5.html#=/2">=/2</A>). Two 
terms are structurally equal if their tree representation is identical 
and they have the same `pattern' of variables. Examples:

<P><BLOCKQUOTE>
<TABLE BORDER=0 COLS=4 FRAME=void RULES=group>
<TR VALIGN=top><TD ALIGN=right></EM><TT>a</TT><TD ALIGN=center></EM><TT>=@=</TT><TD></EM><TT>A</TT><TD ALIGN=center>false </TR>
<TR VALIGN=top><TD ALIGN=right></EM><TT>A</TT><TD ALIGN=center></EM><TT>=@=</TT><TD></EM><TT>B</TT><TD ALIGN=center>true </TR>
<TR VALIGN=top><TD ALIGN=right></EM><TT>x(A,A)</TT><TD ALIGN=center></EM><TT>=@=</TT><TD></EM><TT>x(B,C)</TT><TD ALIGN=center>false </TR>
<TR VALIGN=top><TD ALIGN=right></EM><TT>x(A,A)</TT><TD ALIGN=center></EM><TT>=@=</TT><TD></EM><TT>x(B,B)</TT><TD ALIGN=center>true </TR>
<TR VALIGN=top><TD ALIGN=right></EM><TT>x(A,B)</TT><TD ALIGN=center></EM><TT>=@=</TT><TD></EM><TT>x(C,D)</TT><TD ALIGN=center>true </TR>
</TABLE>

</BLOCKQUOTE>

<P>
<DT><A NAME="\=@=/2"><VAR>+Term1</VAR> <STRONG>\=@=</STRONG> <VAR>+Term2</VAR></A><DD>
Equivalent to <CODE>`<CODE>\+</CODE>Term1 =@= Term2'</CODE>.

<P>
<DT><A NAME="@</2"><VAR>+Term1</VAR> <STRONG>@&lt;</STRONG> <VAR>+Term2</VAR></A><DD>
Succeeds if <VAR>Term1</VAR> is before <VAR>Term2</VAR> in the standard 
order of terms.

<P>
<DT><A NAME="@=</2"><VAR>+Term1</VAR> <STRONG>@=&lt;</STRONG> <VAR>+Term2</VAR></A><DD>
Succeeds if both terms are equal (<A HREF="sec-3.5.html#==/2">==/2</A>) 
or <VAR>Term1</VAR> is before <VAR>Term2</VAR> in the standard order of 
terms.

<P>
<DT><A NAME="@>/2"><VAR>+Term1</VAR> <STRONG>@&gt;</STRONG> <VAR>+Term2</VAR></A><DD>
Succeeds if <VAR>Term1</VAR> is after <VAR>Term2</VAR> in the standard 
order of terms.

<P>
<DT><A NAME="@>=/2"><VAR>+Term1</VAR> <STRONG>@&gt;=</STRONG> <VAR>+Term2</VAR></A><DD>
Succeeds if both terms are equal (<A HREF="sec-3.5.html#==/2">==/2</A>) 
or <VAR>Term1</VAR> is after <VAR>Term2</VAR> in the standard order of 
terms.

<P>
<DT><A NAME="compare/3"><STRONG>compare</STRONG>(<VAR>?Order, +Term1, 
+Term2</VAR>)</A><DD>
Determine or test the <VAR>Order</VAR> between two terms in the standard 
order of terms. <VAR>Order</VAR> is one of <CODE><CODE>&lt;</CODE></CODE>, <CODE><CODE>&gt;</CODE></CODE> 
or <CODE><CODE>=</CODE></CODE>, with the obvious meaning.
</DL>

