<HTML><HEAD><TITLE>SWI-Prolog Reference Manual: Section 4.4</TITLE><LINK REL=home HREF="Title.html">
<LINK REL=contents HREF="Contents.html">
<LINK REL=index HREF="Index.html">
<LINK REL=summary HREF="sec-B.html">
<LINK REL=previous HREF="sec-4.3.html">
<LINK REL=next HREF="sec-4.5.html">
</HEAD>

<BODY>

<HR><CENTER><A HREF="Title.html">Home</A>
<A HREF="Contents.html">Contents</A>
<A HREF="Index.html">Index</A>
<A HREF="sec-B.html">Summary</A>
<A HREF="sec-4.3.html">Previous</A>
<A HREF="sec-4.5.html">Next</A>
</CENTER>

<HR>

<H2><A NAME="sec:4.4">4.4 Importing Predicates into a Module</A></H2>

<P>As explained before, in the predicate based approach adapted by 
SWI-Prolog, each module has it's own predicate space. In SWI-Prolog, a 
module initially is completely empty. Predicates can be added to a 
module by loading a module file as demonstrated in the previous section, 
using assert or by <EM>importing</EM> them from another module.

<P>Two mechanisms for importing predicates explicitly from another 
module exist. The <A NAME="idx:use_module/[1,2]:549"></A><A HREF="sec-4.4.html#use_module/1">use_module/[1,2]</A> 
predicates load a module file and import (part of the) public predicates 
of the file. The <A NAME="idx:import/1:550"></A><A HREF="sec-4.4.html#import/1">import/1</A> 
predicate imports any predicate from any module.

<P>

<DL>

<P>
<DT><A NAME="use_module/1"><STRONG>use_module</STRONG>(<VAR>+File</VAR>)</A><DD>
Load the file(s) specified with <VAR>File</VAR> just like <A NAME="idx:ensure_loaded/1:551"></A><A HREF="sec-3.2.html#ensure_loaded/1">ensure_loaded/1</A>. 
The files should all be module files. All exported predicates from the 
loaded files are imported into the context module. The difference 
between this predicate and <A NAME="idx:ensure_loaded/1:552"></A><A HREF="sec-3.2.html#ensure_loaded/1">ensure_loaded/1</A> 
becomes apparent if the file is already loaded into another module. In 
this case <A NAME="idx:ensure_loaded/1:553"></A><A HREF="sec-3.2.html#ensure_loaded/1">ensure_loaded/1</A> 
does nothing; use_module will import all public predicates of the module 
into the current context module.

<P>
<DT><A NAME="use_module/2"><STRONG>use_module</STRONG>(<VAR>+File, 
+ImportList</VAR>)</A><DD>
Load the file specified with <VAR>File</VAR> (only one file is 
accepted).
<VAR>File</VAR> should be a module file. <VAR>ImportList</VAR> is a list 
of name/arity pairs specifying the predicates that should be imported 
from the loaded module. If a predicate is specified that is not exported 
from the loaded module a warning will be printed. The predicate will 
nevertheless be imported to simplify debugging.

<P>
<DT><A NAME="import/1"><STRONG>import</STRONG>(<VAR>+Head</VAR>)</A><DD>
Import predicate <VAR>Head</VAR> into the current context module. <VAR>Head</VAR> 
should specify the source module using the &lt;<VAR>module</VAR>&gt;:&lt;<VAR>term</VAR>&gt; 
construct. Note that predicates are normally imported using one of the 
directives <A NAME="idx:use_module/[1,2]:554"></A><A HREF="sec-4.4.html#use_module/1">use_module/[1,2]</A>. <A NAME="idx:import/1:555"></A><A HREF="sec-4.4.html#import/1">import/1</A> 
is meant for handling imports into dynamically created modules.
</DL>

<P>It would be rather inconvenient to have to import each predicate 
referred to by the module, including the system predicates. For this 
reason each module is assigned a <EM>default module</EM>. All predicates 
in the default module are available without extra declarations. Their 
definition however can be overruled in the local module. This schedule 
is implemented by the exception handling mechanism of SWI-Prolog: if an 
undefined predicate exception is raised for a predicate in some module, 
the exception handler first tries to import the predicate from the 
module's default module. On success, normal execution is resumed.

<P>

<H3><A NAME="sec:4.4.1">4.4.1 Reserved Modules</A></H3>

<P>SWI-Prolog contains two special modules. The first one is the module
<CODE>system</CODE>. This module contains all built-in predicates 
described in this manual. Module <CODE>system</CODE> has no default 
module assigned to it. The second special module is the module <CODE>user</CODE>. 
This module forms the initial working space of the user. Initially it is 
empty. The default module of module <CODE>user</CODE> is <CODE>system</CODE>, 
making all built-in predicate definitions available as defaults. 
Built-in predicates thus can be overruled by defining them in module <CODE>user</CODE> 
before they are used.

<P>All other modules default to module <CODE>user</CODE>. This implies 
they can use all predicates imported into <CODE>user</CODE> without 
explicitly importing them.

