<HTML><HEAD><TITLE>SWI-Prolog Reference Manual: Section 4.7</TITLE><LINK REL=home HREF="Title.html">
<LINK REL=contents HREF="Contents.html">
<LINK REL=index HREF="Index.html">
<LINK REL=summary HREF="sec-B.html">
<LINK REL=previous HREF="sec-4.6.html">
<LINK REL=next HREF="sec-4.8.html">
</HEAD>

<BODY>

<HR><CENTER><A HREF="Title.html">Home</A>
<A HREF="Contents.html">Contents</A>
<A HREF="Index.html">Index</A>
<A HREF="sec-B.html">Summary</A>
<A HREF="sec-4.6.html">Previous</A>
<A HREF="sec-4.8.html">Next</A>
</CENTER>

<HR>

<H2><A NAME="sec:4.7">4.7 Dynamic Modules</A></H2>

<A NAME="sec:dynamic-modules"></A>

<P>So far, we discussed modules that were created by loading a 
module-file. These modules have been introduced on facilitate the 
development of large applications. The modules are fully defined at 
load-time of the application and normally will not change during 
execution. Having the notion of a set of predicates as a self-contained 
world can be attractive for other purposes as well. For example, assume 
an application that can reason about multiple worlds. It is attractive 
to store the data of a particular world in a module, so we extract 
information from a world simply by invoking goals in this world.

<P>Dynamic modules can easily be created. Any built-in predicate that 
tries to locate a predicate in a specific module will create this module 
as a side-effect if it did not yet exist. Example:

<P>

<XMP>
?- assert(world_a:consistent),
   world_a:unknown(_, fail).
</XMP>

<P>These calls create a module called `world_a' and make the call 
`world_a:consistent' succeed. Undefined predicates will not start the 
tracer or autoloader for this module (see <A NAME="idx:unknown/2:560"></A><A HREF="sec-3.38.html#unknown/2">unknown/2</A>).

<P>Import and export from dynamically created world is arranged via the 
predicates <A NAME="idx:import/1:561"></A><A HREF="sec-4.4.html#import/1">import/1</A> 
and <A NAME="idx:export/1:562"></A><A HREF="sec-4.8.html#export/1">export/1</A>:

<P>

<XMP>
?- world_b:export(solve(_,_)).          % exports solve/2 from world_b
?- world_c:import(world_b:solve(_,_)).  % and import it to world_c
</XMP>

