<HTML><HEAD><TITLE>SWI-Prolog Reference Manual: Section 4.8</TITLE><LINK REL=home HREF="Title.html">
<LINK REL=contents HREF="Contents.html">
<LINK REL=index HREF="Index.html">
<LINK REL=summary HREF="sec-B.html">
<LINK REL=previous HREF="sec-4.7.html">
<LINK REL=next HREF="sec-4.9.html">
</HEAD>

<BODY>

<HR><CENTER><A HREF="Title.html">Home</A>
<A HREF="Contents.html">Contents</A>
<A HREF="Index.html">Index</A>
<A HREF="sec-B.html">Summary</A>
<A HREF="sec-4.7.html">Previous</A>
<A HREF="sec-4.9.html">Next</A>
</CENTER>

<HR>

<H2><A NAME="sec:4.8">4.8 Module Handling Predicates</A></H2>

<P>This section gives the predicate definitions for the remaining 
built-in predicates that handle modules.

<P>

<DL>

<P>
<DT><A NAME="module/2"><STRONG>module</STRONG>(<VAR>+Module, +PublicList</VAR>)</A><DD>
This directive can only be used as the first term of a source file. It 
declares the file to be a <EM>module file</EM>, defining <VAR>Module</VAR> 
and exporting the predicates of <VAR>PublicList</VAR>. <VAR>PublicList</VAR> 
is a list of name/arity pairs.

<P>

<P>
<DT><A NAME="module_transparent/1"><STRONG>module_transparent</STRONG> <VAR>+Preds</VAR></A><DD>
<VAR>Preds</VAR> is a comma separated list of name/arity pairs (like
<A NAME="idx:dynamic/1:563"></A><A HREF="sec-3.13.html#dynamic/1">dynamic/1</A>). 
Each goal associated with a transparent declared predicate will inherit 
the <EM>context module</EM> from its parent goal.

<P>

<P>
<DT><A NAME="meta_predicate/1"><STRONG>meta_predicate</STRONG> <VAR>+Heads</VAR></A><DD>
This predicate is defined in <CODE>library(quintus)</CODE> and provides 
a partial emulation of the Quintus predicate. See <A HREF="sec-4.9.html">section 
4.9.1</A> for details.

<P>

<P>
<DT><A NAME="current_module/1"><STRONG>current_module</STRONG>(<VAR>-Module</VAR>)</A><DD>
Generates all currently known modules.

<P>

<P>
<DT><A NAME="current_module/2"><STRONG>current_module</STRONG>(<VAR>?Module, 
?File</VAR>)</A><DD>
Is true if <VAR>File</VAR> is the file from which <VAR>Module</VAR> was 
loaded.
<VAR>File</VAR> is the internal canonical filename. See also
<A NAME="idx:source_file/[1,2]:564"></A><A HREF="sec-3.2.html#source_file/1">source_file/[1,2]</A>.

<P>

<P>
<DT><A NAME="context_module/1"><STRONG>context_module</STRONG>(<VAR>-Module</VAR>)</A><DD>
Unify <VAR>Module</VAR> with the context module of the current goal.
<A NAME="idx:context_module/1:565"></A><A HREF="sec-4.8.html#context_module/1">context_module/1</A> 
itself is transparent.

<P>

<P>
<DT><A NAME="export/1"><STRONG>export</STRONG>(<VAR>+Head</VAR>)</A><DD>
Add a predicate to the public list of the context module. This implies 
the predicate will be imported into another module if this module is 
imported with <A NAME="idx:use_module/[1,2]:566"></A><A HREF="sec-4.4.html#use_module/1">use_module/[1,2]</A>. 
Note that predicates are normally exported using the directive <A NAME="idx:module/2:567"></A><A HREF="sec-4.8.html#module/2">module/2</A>. <A NAME="idx:export/1:568"></A><A HREF="sec-4.8.html#export/1">export/1</A> 
is meant to handle export from dynamically created modules.

<P>

<P>
<DT><A NAME="export_list/2"><STRONG>export_list</STRONG>(<VAR>+Module, 
?Exports</VAR>)</A><DD>
Unifies <VAR>Exports</VAR> with a list of terms. Each term has the name 
and arity of a public predicate of <VAR>Module</VAR>. The order of the 
terms in
<VAR>Exports</VAR> is not defined. See also <A NAME="idx:predicate_property/2:569"></A><A HREF="sec-3.14.html#predicate_property/2">predicate_property/2</A>.

<P>

<P>
<DT><A NAME="default_module/2"><STRONG>default_module</STRONG>(<VAR>+Module, 
-Default</VAR>)</A><DD>
Succesively unifies <VAR>Default</VAR> with the module names from which 
a call in <VAR>Module</VAR> attempts to use the definition. For the 
module <CODE>user</CODE>, this will generate <CODE>user</CODE> and <CODE>system</CODE>. 
For any other module, this will generate the module itself, followed by <CODE>user</CODE> 
and <CODE>system</CODE>.

<P>

<P>
<DT><A NAME="module/1"><STRONG>module</STRONG>(<VAR>+Module</VAR>)</A><DD>
The call <CODE>module(<VAR>Module</VAR>)</CODE> may be used to switch 
the default working module for the interactive toplevel (see <A NAME="idx:prolog/0:570"></A><A HREF="sec-3.36.html#prolog/0">prolog/0</A>). 
This may be used to when debugging a module. The example below lists the 
clauses of file_of_label/2 in the module <CODE>tex</CODE>.

<P>

<XMP>
1 ?- module(tex).

Yes
tex: 2 ?- listing(file_of_label/2).
...
</XMP>

<P>
</DL>

