<HTML><HEAD><TITLE>SWI-Prolog Reference Manual: Section 5.2</TITLE><LINK REL=home HREF="Title.html">
<LINK REL=contents HREF="Contents.html">
<LINK REL=index HREF="Index.html">
<LINK REL=summary HREF="sec-B.html">
<LINK REL=previous HREF="sec-5.1.html">
<LINK REL=next HREF="sec-5.3.html">
</HEAD>

<BODY>

<HR><CENTER><A HREF="Title.html">Home</A>
<A HREF="Contents.html">Contents</A>
<A HREF="Index.html">Index</A>
<A HREF="sec-B.html">Summary</A>
<A HREF="sec-5.1.html">Previous</A>
<A HREF="sec-5.3.html">Next</A>
</CENTER>

<HR>

<H2><A NAME="sec:5.2">5.2 Linking Foreign Modules</A></H2>

<P>Foreign modules may be linked to Prolog in three ways. Using
<EM>static linking</EM>, the extensions, a small description file and 
the basic SWI-Prolog object file are linked together to form a new 
executable. Using <EM>dynamic linking</EM>, the extensions are linked to 
a shared library (<CODE>.so</CODE> file on most Unix systems) or 
dynamic-link library (<CODE>.DLL</CODE> file on Microsoft platforms) and 
loaded into the the running Prolog process.<A NAME=back-to-note-25 HREF="Notes.html#note-25"> (25)</A>.

<P>

<H3><A NAME="sec:5.2.1">5.2.1 What linking is provided?</A></H3>

<P>The <EM>static linking</EM> schema can be used on all versions of 
SWI-Prolog. The <A NAME="idx:feature/2:582"></A><A HREF="sec-2.8.html#feature/2">feature/2</A> 
predicate may be used to find out what other linking methods are 
provided for this version.

<P><UL>
<LI><I>feature(open_shared_object, true)</I><BR>
<A NAME="idx:dlopen:583"></A><A NAME="idx:.so files:584"></A>If this 
succeeds the system provides the <A NAME="idx:open_shared_object/2:585"></A><A HREF="sec-5.3.html#open_shared_object/2">open_shared_object/2</A> 
and related predicates that allow for handling Unix shared object files 
based on the Unix library functions <STRONG>dlopen</STRONG>(2) and 
friends. See
<A HREF="sec-5.4.html">section 5.4</A>.
<LI><I>feature(dll, true)</I><BR>
If this succeeds the system provides an interface for loading <CODE>.DLL</CODE> 
files by means of <A NAME="idx:open_dll/2:586"></A><B>open_dll/2</B> and 
friends. See <A HREF="sec-5.4.html">section 5.4</A>.
</UL>

<P>If either the feature <CODE>open_shared_object</CODE> or <CODE>dll</CODE> 
is true, the library <CODE>library(shlib)</CODE> provides a common 
interface for loading foreign files from Prolog.

<P>

<H3><A NAME="sec:5.2.2">5.2.2 What kind of loading should I be using?</A></H3>

<P>All described approaches have their advantages and disadvantages. 
Static linking is portable and allows for debugging on all platforms. It 
is relatively cumbersome and the libraries you need to pass to the 
linker may vary from system to system.

<P>Loading shared objects or DLL files provides sharing and protection 
and is generally the best choice. If a saved-state is created using
<A NAME="idx:qsave_program/[1,2]:587"></A><A HREF="sec-6.html#qsave_program/1">qsave_program/[1,2]</A>, 
an <A NAME="idx:initialization/1:588"></A><A HREF="sec-3.2.html#initialization/1">initialization/1</A> 
directive may be used to load the appropriate library at startup.

<P>Note that the definition of the foreign predicates is the same, 
regardless of the linking type used.

