<HTML><HEAD><TITLE>SWI-Prolog Reference Manual: Section 5.3</TITLE><LINK REL=home HREF="Title.html">
<LINK REL=contents HREF="Contents.html">
<LINK REL=index HREF="Index.html">
<LINK REL=summary HREF="sec-B.html">
<LINK REL=previous HREF="sec-5.2.html">
<LINK REL=next HREF="sec-5.4.html">
</HEAD>

<BODY>

<HR><CENTER><A HREF="Title.html">Home</A>
<A HREF="Contents.html">Contents</A>
<A HREF="Index.html">Index</A>
<A HREF="sec-B.html">Summary</A>
<A HREF="sec-5.2.html">Previous</A>
<A HREF="sec-5.4.html">Next</A>
</CENTER>

<HR>

<H2><A NAME="sec:5.3">5.3 Dynamic Linking of shared libraries</A></H2>

<P>The interface defined in this section allows the user to load shared 
libraries (<CODE>.so</CODE> files on most Unix systems). This interface 
is portable to all machines providing the function <STRONG>dlopen</STRONG>(2) 
or an equivalent, normally from the library <CODE>-ldl</CODE>. These 
functions provide the basic interface layer. It is advised to use the 
predicates from <A HREF="sec-5.4.html">section 5.4</A> in your 
application.

<P>

<DL>

<P>
<DT><A NAME="open_shared_object/2"><STRONG>open_shared_object</STRONG>(<VAR>+File, 
-Handle</VAR>)</A><DD>
<VAR>File</VAR> is the name of a <CODE>.so</CODE> file (see your C 
programmers documentation on how to create a <CODE>.so</CODE> file). 
This file is attached to the current process and <VAR>Handle</VAR> is 
unified with a handle to the shared object. Equivalent to
<CODE>open_shared_object(File, [global], Handle)</CODE>. See also
<A NAME="idx:load_foreign_library/[1,2]:589"></A><A HREF="sec-5.4.html#load_foreign_library/1">load_foreign_library/[1,2]</A>.

<P>

<P>
<DT><A NAME="open_shared_object/3"><STRONG>open_shared_object</STRONG>(<VAR>+File, 
+Options, -Handle</VAR>)</A><DD>
As <A NAME="idx:open_shared_object/2:590"></A><A HREF="sec-5.3.html#open_shared_object/2">open_shared_object/2</A>, 
but allows for additional flags to be passed.
<VAR>Options</VAR> is a list of atoms. <CODE>now</CODE> implies the 
symbols are resolved immediately rather than lazy (default). <CODE>global</CODE> 
implies symbols of the loaded object are visible while loading other 
shared objects (by default they are local). Note that these flags may 
not be supported by your operating system. Check the documentation of 
dlopen() or equivalent on your operating system.

<P>

<P>
<DT><A NAME="close_shared_object/1"><STRONG>close_shared_object</STRONG>(<VAR>+Handle</VAR>)</A><DD>
Detach the shared object identified by <VAR>Handle</VAR>.

<P>

<P>
<DT><A NAME="call_shared_object_function/2"><STRONG>call_shared_object_function</STRONG>(<VAR>+Handle, 
+Function</VAR>)</A><DD>
Call the named function in the loaded shared library. The function is 
called without arguments and the return-value is ignored. Normally this 
function installs foreign language predicates using calls to
<A HREF="sec-5.6.html#PL_register_foreign()">PL_register_foreign()</A>.
</DL>

