<HTML><HEAD><TITLE>SWI-Prolog Reference Manual: Section 5.7</TITLE><LINK REL=home HREF="Title.html">
<LINK REL=contents HREF="Contents.html">
<LINK REL=index HREF="Index.html">
<LINK REL=summary HREF="sec-B.html">
<LINK REL=previous HREF="sec-5.6.html">
<LINK REL=next HREF="sec-5.8.html">
</HEAD>

<BODY>

<HR><CENTER><A HREF="Title.html">Home</A>
<A HREF="Contents.html">Contents</A>
<A HREF="Index.html">Index</A>
<A HREF="sec-B.html">Summary</A>
<A HREF="sec-5.6.html">Previous</A>
<A HREF="sec-5.8.html">Next</A>
</CENTER>

<HR>

<H2><A NAME="sec:5.7">5.7 Linking embedded applications using plld</A></H2>

<A NAME="sec:plld"></A>

<P>The utility program <B>plld</B> (Win32: plld.exe) may be used to link 
a combination of C-files and Prolog files into a stand-alone executable.
<B>plld</B> automates most of what is described in the previous 
sections.

<P>In the normal usage, a copy is made of the default embedding template
<CODE>... /pl/include/stub.c</CODE>. The main() routine is modified to 
suit your application. <A HREF="sec-5.6.html#PL_initialise()">PL_initialise()</A> <STRONG>must</STRONG> 
be passed the program-name (<VAR>argv[0]</VAR>) (Win32: the executing 
program can be obtained using <B>GetModuleFileName()</B>). The other 
elements of the command-line may be modified. Next, <B>plld</B> is 
typically invoked as:

<P>

<XMP>
plld -o output stubfile.c [other-c-or-o-files] [plfiles]
</XMP>

<P><B>plld</B> will first split the options into various groups for both 
the C-compiler and the Prolog compiler. Next, it will add various 
default options to the C-compiler and call it to create an executable 
holding the user's C-code and the Prolog kernel. Then, it will call the 
SWI-Prolog compiler to create a saved state from the provided Prolog 
files and finally, it will attach this saved state to the created 
emulator to create the requested executable.

<P>Below, it is described how the options are split and which additional 
options are passed.

<P>

<DL>

<P>
<DT><STRONG>-help</STRONG> <VAR></VAR><DD>
Print brief synopsis.

<P>
<DT><STRONG>-pl</STRONG> <VAR>prolog</VAR><DD>
Select the prolog to use. This prolog is used for two purposes: get the 
home-directory as well as the compiler/linker options and create a saved 
state of the Prolog code.

<P>
<DT><STRONG>-ld</STRONG> <VAR>linker</VAR><DD>
Linker used to link the raw executable. Default is to use the C-compiler 
(Win32: link.exe).

<P>
<DT><STRONG>-cc</STRONG> <VAR>C-compiler</VAR><DD>
Compiler for <CODE>.c</CODE> files found on the commandline. Default is 
the compiler used to build SWI-Prolog (see <A NAME="idx:feature/2:623"></A><A HREF="sec-2.8.html#feature/2">feature/2</A>) 
(Win32: cl.exe).

<P>
<DT><STRONG>-c++</STRONG> <VAR>C++-compiler</VAR><DD>
Compiler for C++ sources (extensions <CODE>.cpp</CODE>, <CODE>.cxx</CODE>,
<CODE>.cc</CODE> or <CODE>.C</CODE>) files found on the commandline. 
Default is
<B>c++</B> or <B>g++</B> if the C-compiler is <B>gcc</B>) (Win32: 
cl.exe).

<P>
<DT><STRONG>-nostate</STRONG> <VAR></VAR><DD>
Just relink the kernel, do not add any Prolog code to the new kernel. 
This is used to create a new kernel holding additional foreign 
predicates on machines that do not support the shared-library (DLL) 
interface, or if building the state cannot be handled by the default 
procedure used by
<B>plld</B>. In the latter case the state is created seperately and 
appended to the kernel using <CODE>cat &lt;<VAR>kernel</VAR>&gt; &lt;<VAR>state</VAR>&gt; 
&gt; &lt;<VAR>out</VAR>&gt;</CODE> (Win32: <CODE>copy /b &lt;<VAR>kernel</VAR>&gt;+&lt;<VAR>state</VAR>&gt; &lt;<VAR>out</VAR>&gt;</CODE>)

<P>
<DT><STRONG>-pl-options</STRONG> <VAR>, ...</VAR><DD>
Additional options passed to Prolog when creating the saved state. The 
first character immediately following <CODE>pl-options</CODE> is used as 
separator and translated to spaces when the argument is built. Example: <CODE>-pl-options,-F,xpce</CODE> 
passed <CODE>-F xpce</CODE> as additional flags to Prolog.

<P>
<DT><STRONG>-ld-options</STRONG> <VAR>, ...</VAR><DD>
Passes options to the linker, similar to <STRONG>-pl-options</STRONG>.

<P>
<DT><STRONG>-cc-options</STRONG> <VAR>, ...</VAR><DD>
Passes options to the C/C++ compiler, similar to <STRONG>-pl-options</STRONG>.

<P>
<DT><STRONG>-v</STRONG> <VAR></VAR><DD>
Select verbose operation, showing the various programs and their 
options.

<P>
<DT><STRONG>-o</STRONG> <VAR>outfile</VAR><DD>
Reserved to specify the final output file.

<P>
<DT><STRONG>-l</STRONG><VAR>library</VAR><DD>
Specifies a library for the C-compiler. By default, <CODE>-lpl</CODE> 
(Win32: libpl.lib) and the libraries needed by the Prolog kernel are 
given.

<P>
<DT><STRONG>-L</STRONG><VAR>library-directory</VAR><DD>
Specifies a library directory for the C-compiler. By default the 
directory containing the Prolog C-library for the current architecture 
is passed.

<P>
<DT><STRONG><STRONG>-g</STRONG> | <STRONG>-I<VAR>include-directory</VAR></STRONG> 
| <STRONG>-D<VAR>definition</VAR></STRONG></STRONG> <VAR></VAR><DD>
These options are passed to the C-compiler. By default, the include 
directory containing <CODE>SWI-Prolog.h</CODE> is passed. <B>plld</B> 
adds two additional <STRONG>*</STRONG> <VAR>-D</VAR>def flags:

<DL>

<P>
<DT><STRONG>-D</STRONG><VAR><CODE>__SWI_PROLOG__</CODE></VAR><DD>
Indicates the code is to be connected to SWI-Prolog.

<P>
<DT><STRONG>-D</STRONG><VAR><CODE>__SWI_EMBEDDED__</CODE></VAR><DD>
Indicates the creation of an embedded program.
</DL>

<P>
<DT><STRONG></STRONG> <VAR>*.o | *.c | *.C | *.cxx | *.cpp</VAR><DD>
Passed as input files to the C-compiler

<P>
<DT><STRONG></STRONG> <VAR>*.pl | *.qlf</VAR><DD>
Passed as input files to the Prolog compiler to create the saved-state.

<P>
<DT><STRONG></STRONG> <VAR><CODE>*</CODE></VAR><DD>
I.e. all other options. These are passed as linker options to the 
C-compiler.
</DL>

<P>

<H3><A NAME="sec:5.7.1">5.7.1 A simple example</A></H3>

<P>The following is a very simple example going through all the steps 
outlined above. It provides an arithmetic expression evaluator. We will 
call the application <B>calc</B> and define it in the files <CODE>calc.c</CODE> 
and <CODE>calc.pl</CODE>. The Prolog file is simple:

<P>

<XMP>
calc(Atom) :-
        term_to_atom(Expr, Atom),
        A is Expr,
        write(A),
        nl.
</XMP>

<P>The C-part of the application parses the command-line options, 
initialises the Prolog engine, locates the calc/1 predicate and calls 
it. The coder is in <A HREF="sec-5.7.html#fig:calc">figure 9</A>.

<P>

<XMP>
#include <stdio.h>
#include <SWI-Prolog.h>

PL_extension PL_extensions [] =
{
/*{ "name",     arity,  function,       PL_FA_<flags> },*/

  { NULL,       0,      NULL,           0 }     /* terminating line */
};


#define MAXLINE 1024

int
main(int argc, char **argv)
{ char expression[MAXLINE];
  char *e = expression;
  char *program = argv[0];
  char *plav[2];
  int n;

  /* combine all the arguments in a single string */

  for(n=1; n<argc; n++)
  { if ( n != 1 )
      *e++ = ' ';
    strcpy(e, argv[n]);
    e += strlen(e);
  }

  /* make the argument vector for Prolog */

  plav[0] = program;
  plav[1] = NULL;

  /* initialise Prolog */

  if ( !PL_initialise(1, plav) )
    PL_halt(1);

  /* Lookup calc/1 and make the arguments and call */

  { predicate_t pred = PL_predicate("calc", 1, "user");
    term_t h0 = PL_new_term_refs(1);
    int rval;

    PL_put_atom_chars(h0, expression);
    rval = PL_call_predicate(NULL, FALSE, pred, h0);

    PL_halt(rval ? 0 : 1);
  }

  return 0;
}
</XMP>

<P><CENTER><B>Figure 9 : C-source for the calc application</B></CENTER>
<A NAME="fig:calc"></A>

<P>The application is now created using the following command-line:

<P>

<XMP>
% plld -o calc calc.c calc.pl
</XMP>

<P>The following indicates the usage of the application:

<P>

<XMP>
% calc pi/2
1.5708
</XMP>

