<HTML><HEAD><TITLE>SWI-Prolog Reference Manual: Section 5.8</TITLE><LINK REL=home HREF="Title.html">
<LINK REL=contents HREF="Contents.html">
<LINK REL=index HREF="Index.html">
<LINK REL=summary HREF="sec-B.html">
<LINK REL=previous HREF="sec-5.7.html">
<LINK REL=next HREF="sec-5.9.html">
</HEAD>

<BODY>

<HR><CENTER><A HREF="Title.html">Home</A>
<A HREF="Contents.html">Contents</A>
<A HREF="Index.html">Index</A>
<A HREF="sec-B.html">Summary</A>
<A HREF="sec-5.7.html">Previous</A>
<A HREF="sec-5.9.html">Next</A>
</CENTER>

<HR>

<H2><A NAME="sec:5.8">5.8 Example of Using the Foreign Interface</A></H2>

<P>Below is an example showing all stages of the declaration of a 
foreign predicate that transforms atoms possibly holding uppercase 
letters into an atom only holding lower case letters. <A HREF="sec-5.8.html#fig:lowercase-c">Figure 
10</A> shows the C-source file, <A HREF="sec-5.8.html#fig:load-foreign">figure 
11</A> illustrates compiling and loading of foreign code.

<P>

<P>

<XMP>
/*  Include file depends on local installation */
#include <SWI-Prolog.h>
#include <stdlib.h>
#include <ctype.h>

foreign_t
pl_lowercase(term_t u, term_t l)
{ char *copy;
  char *s, *q;
  int rval;

  if ( !PL_get_atom_chars(u, &s) )
    return PL_warning("lowercase/2: instantiation fault");
  copy = malloc(strlen(s)+1);

  for( q=copy; *s; q++, s++)
    *q = (isupper(*s) ? tolower(*s) : *s);
  *q = '\0';

  rval = PL_unify_atom_chars(l, copy);
  free(copy);

  return rval;
}

install_t
install()
{ PL_register_foreign("lowercase", 2, pl_lowercase, 0);
}
</XMP>

<P><CENTER><B>Figure 10 : Lowercase source file</B></CENTER>
<A NAME="fig:lowercase-c"></A>

<P>

<XMP>
% gcc -I/usr/local/lib/pl-\plversion/include -fpic -c lowercase.c
% gcc -shared -o lowercase.so lowercase.o
% pl
Welcome to SWI-Prolog (Version \plversion)
Copyright (c) 1993-1996 University of Amsterdam.  All rights reserved.

For help, use ?- help(Topic). or ?- apropos(Word).

1 ?- load_foreign_library(lowercase).

Yes
2 ?- lowercase('Hello World!', L).

L = 'hello world!' 

Yes
</XMP>

<P><CENTER><B>Figure 11 : Compiling the C-source and loading the object 
file</B></CENTER>
<A NAME="fig:load-foreign"></A>
