<HTML><HEAD><TITLE>SWI-Prolog Reference Manual</TITLE><LINK REL=home HREF="Title.html">
<LINK REL=contents HREF="Contents.html">
<LINK REL=index HREF="Index.html">
<LINK REL=summary HREF="sec-B.html">
<LINK REL=previous HREF="sec-4.9.html">
<LINK REL=next HREF="sec-5.1.html">
</HEAD>

<BODY>

<HR><CENTER><A HREF="Title.html">Home</A>
<A HREF="Contents.html">Contents</A>
<A HREF="Index.html">Index</A>
<A HREF="sec-B.html">Summary</A>
<A HREF="sec-4.9.html">Previous</A>
<A HREF="sec-5.1.html">Next</A>
</CENTER>

<HR>

<H1><A NAME="sec:5">5 Foreign Language Interface</A></H1>

<A NAME="sec:foreign"></A>

<P>

<P>SWI-Prolog offers a powerful interface to C <CITE><A HREF="sec-C.html#Kernighan:78">Kernighan &amp; 
Ritchie, 1978</A></CITE>. The main design objectives of the foreign 
language interface are flexibility and performance. A foreign predicate 
is a C-function that has the same number of arguments as the predicate 
represented. C-functions are provided to analyse the passed terms, 
convert them to basic C-types as well as to instantiate arguments using 
unification. Non-deterministic foreign predicates are supported, 
providing the foreign function with a handle to control backtracking.

<P>C can call Prolog predicates, providing both an query interface and 
an interface to extract multiple solutions from an non-deterministic 
Prolog predicate. There is no limit to the nesting of Prolog calling C, 
calling Prolog, etc. It is also possible to write the `main' in C and 
use Prolog as an embedded logical engine.

<P>

<HR><CENTER>

<H2>Section Index</H2>

</CENTER>

<HR><UL><UL>
<LI><A HREF="sec-5.1.html"><B>5.1 Overview of the Interface</B></A>
<LI><A HREF="sec-5.2.html"><B>5.2 Linking Foreign Modules</B></A><UL>
<LI><A HREF="sec-5.2.html#sec:5.2.1">5.2.1 What linking is provided?</A>
<LI><A HREF="sec-5.2.html#sec:5.2.2">5.2.2 What kind of loading should I 
be using?</A></UL>
<LI><A HREF="sec-5.3.html"><B>5.3 Dynamic Linking of shared libraries</B></A>
<LI><A HREF="sec-5.4.html"><B>5.4 Using the library shlib for <CODE>.DLL</CODE> 
and <CODE>.so</CODE> files</B></A><UL>
<LI><A HREF="sec-5.4.html#sec:5.4.1">5.4.1 Static Linking</A>
<LI><A HREF="sec-5.4.html#sec:5.4.2">5.4.2 Dynamic Linking based on <A NAME="idx:load_foreign/[2,5]:596"></A><A HREF="sec-5.4.html#load_foreign/2">load_foreign/[2,5]</A></A></UL>
<LI><A HREF="sec-5.5.html"><B>5.5 Interface Data types</B></A><UL>
<LI><A HREF="sec-5.5.html#sec:5.5.1">5.5.1 Type <CODE>term_t</CODE>: a 
reference to a Prolog term</A><UL>
<LI><A HREF="sec-5.5.html#sec:5.5.1.1">5.5.1.1 Interaction with the 
garbage collector and stack-shifter</A></UL>
<LI><A HREF="sec-5.5.html#sec:5.5.2">5.5.2 Other foreign interface types</A></UL>
<LI><A HREF="sec-5.6.html"><B>5.6 The Foreign Include File</B></A><UL>
<LI><A HREF="sec-5.6.html#sec:5.6.1">5.6.1 Argument Passing and Control</A><UL>
<LI><A HREF="sec-5.6.html#sec:5.6.1.1">5.6.1.1 Non-deterministic Foreign 
Predicates</A></UL>
<LI><A HREF="sec-5.6.html#sec:5.6.2">5.6.2 Atoms and functors</A>
<LI><A HREF="sec-5.6.html#sec:5.6.3">5.6.3 Analysing Terms via the 
Foreign Interface</A><UL>
<LI><A HREF="sec-5.6.html#sec:5.6.3.1">5.6.3.1 Testing the type of a 
term</A>
<LI><A HREF="sec-5.6.html#sec:5.6.3.2">5.6.3.2 Reading data from a term</A>
<LI><A HREF="sec-5.6.html#sec:5.6.3.3">5.6.3.3 Reading a list</A>
<LI><A HREF="sec-5.6.html#sec:5.6.3.4">5.6.3.4 An example: defining <A NAME="idx:write/1:601"></A><A HREF="sec-3.18.html#write/1">write/1</A> 
in C</A></UL>
<LI><A HREF="sec-5.6.html#sec:5.6.4">5.6.4 Constructing Terms</A>
<LI><A HREF="sec-5.6.html#sec:5.6.5">5.6.5 Unifying data</A>
<LI><A HREF="sec-5.6.html#sec:5.6.6">5.6.6 Calling Prolog from C</A><UL>
<LI><A HREF="sec-5.6.html#sec:5.6.6.1">5.6.6.1 Predicate references</A>
<LI><A HREF="sec-5.6.html#sec:5.6.6.2">5.6.6.2 Initiating a query from C</A></UL>
<LI><A HREF="sec-5.6.html#sec:5.6.7">5.6.7 Discarding Data</A>
<LI><A HREF="sec-5.6.html#sec:5.6.8">5.6.8 Foreign Code and Modules</A>
<LI><A HREF="sec-5.6.html#sec:5.6.9">5.6.9 Prolog exceptions in foreign 
code</A>
<LI><A HREF="sec-5.6.html#sec:5.6.10">5.6.10 Miscellaneous</A>
<LI><A HREF="sec-5.6.html#sec:5.6.11">5.6.11 Catching Signals (Software 
Interrupts)</A>
<LI><A HREF="sec-5.6.html#sec:5.6.12">5.6.12 Errors and warnings</A>
<LI><A HREF="sec-5.6.html#sec:5.6.13">5.6.13 Environment Control from 
Foreign Code</A>
<LI><A HREF="sec-5.6.html#sec:5.6.14">5.6.14 Querying Prolog</A>
<LI><A HREF="sec-5.6.html#sec:5.6.15">5.6.15 Registering Foreign 
Predicates</A>
<LI><A HREF="sec-5.6.html#sec:5.6.16">5.6.16 Foreign Code Hooks</A>
<LI><A HREF="sec-5.6.html#sec:5.6.17">5.6.17 Storing foreign data</A><UL>
<LI><A HREF="sec-5.6.html#sec:5.6.17.1">5.6.17.1 Examples for storing 
foreign data</A></UL>
<LI><A HREF="sec-5.6.html#sec:5.6.18">5.6.18 Embedding SWI-Prolog in a 
C-program</A></UL>
<LI><A HREF="sec-5.7.html"><B>5.7 Linking embedded applications using 
plld</B></A><UL>
<LI><A HREF="sec-5.7.html#sec:5.7.1">5.7.1 A simple example</A></UL>
<LI><A HREF="sec-5.8.html"><B>5.8 Example of Using the Foreign Interface</B></A>
<LI><A HREF="sec-5.9.html"><B>5.9 Notes on Using Foreign Code</B></A><UL>
<LI><A HREF="sec-5.9.html#sec:5.9.1">5.9.1 Memory Allocation</A>
<LI><A HREF="sec-5.9.html#sec:5.9.2">5.9.2 Debugging Foreign Code</A>
<LI><A HREF="sec-5.9.html#sec:5.9.3">5.9.3 Name Conflicts in C modules</A>
<LI><A HREF="sec-5.9.html#sec:5.9.4">5.9.4 Compatibility of the Foreign 
