<HTML><HEAD><TITLE>SWI-Prolog Reference Manual: Section 6.4</TITLE><LINK REL=home HREF="Title.html">
<LINK REL=contents HREF="Contents.html">
<LINK REL=index HREF="Index.html">
<LINK REL=summary HREF="sec-B.html">
<LINK REL=previous HREF="sec-6.3.html">
<LINK REL=next HREF="sec-6.5.html">
</HEAD>

<BODY>

<HR><CENTER><A HREF="Title.html">Home</A>
<A HREF="Contents.html">Contents</A>
<A HREF="Index.html">Index</A>
<A HREF="sec-B.html">Summary</A>
<A HREF="sec-6.3.html">Previous</A>
<A HREF="sec-6.5.html">Next</A>
</CENTER>

<HR>

<H2><A NAME="sec:6.4">6.4 Finding Application files</A></H2>

<P>If your application uses files that are not part of the saved program 
such as database files, configuration files, etc., the runtime version 
has to be able to locate these files. The <A NAME="idx:file_search_path/2:655"></A><A HREF="sec-3.2.html#file_search_path/2">file_search_path/2</A> 
mechanism in combination with the <STRONG>-p</STRONG>alias command-line 
argument is the preferred way to locate runtime files. The first step is 
to define an alias for the toplevel directory of your application. We 
will call this directory <CODE>gnatdir</CODE> in our examples.

<P>A good place for storing data associated with SWI-Prolog runtime 
systems is below the emulator's home-directory. <CODE>swi</CODE> is a 
predefined alias for this directory. The following is a useful default 
definition for the search path.

<P>

<XMP>
user:file_search_path(gnatdir, swi(gnat)).
</XMP>

<P>The application should locate all files using absolute_file_name. 
Suppose gnatdir contains a file </EM><TT>config.pl</TT> to define local 
configuration. Then use the code below to load this file:

<P>

<XMP>
configure_gnat :-
        (   absolute_file_name(gnatdir('config.pl'), ConfigFile)
            ->  consult(ConfigFile)
            ;   format(user_error, 'gnat: Cannot locate config.pl~n'),
            halt(1)
            ).
</XMP>

