<HTML><HEAD><TITLE>SWI-Prolog Reference Manual: Section 6.5</TITLE><LINK REL=home HREF="Title.html">
<LINK REL=contents HREF="Contents.html">
<LINK REL=index HREF="Index.html">
<LINK REL=summary HREF="sec-B.html">
<LINK REL=previous HREF="sec-6.4.html">
<LINK REL=next HREF="sec-6.6.html">
</HEAD>

<BODY>

<HR><CENTER><A HREF="Title.html">Home</A>
<A HREF="Contents.html">Contents</A>
<A HREF="Index.html">Index</A>
<A HREF="sec-B.html">Summary</A>
<A HREF="sec-6.4.html">Previous</A>
<A HREF="sec-6.6.html">Next</A>
</CENTER>

<HR>

<H2><A NAME="sec:6.5">6.5 Using chpl for Configuration Information</A></H2>

<P>

<H3><A NAME="sec:6.5.1">6.5.1 Changing the emulator of a runtime 
application</A></H3>

<P>The program chpl, may be used to manipulate the header of a 
SWI-Prolog bootfile or state created with <A NAME="idx:qsave_program/[1,2]:656"></A><A HREF="sec-6.html#qsave_program/1">qsave_program/[1,2]</A>.

<P>It will be used most commonly by the installer of a SWI-Prolog 
runtime application to specify the path to the emulator. If the end-user 
decided to install the SWI-Prolog runtime environment in

<P>

<XMP>
/usr/local/lib/rt-pl-2.1.4
</XMP>

<P>the gnat application can be told to use this emulator using:

<P>

<XMP>
% /usr/local/lib/rtpl-2.1.4/bin/chpl -e /usr/local/lib/rt-pl-2.1.4/bin/pl gnat
</XMP>

<P>Now, </EM><TT>gnat</TT> may be installed in any public or private 
directory for binaries.

<P>

<H3><A NAME="sec:6.5.2">6.5.2 Passing a path to the application</A></H3>

<P>Suppose the system administrator has installed the SWI-Prolog runtime 
environment in <CODE>/usr/local/lib/rt-pl-2.1.4</CODE>. A user wants to 
install <CODE>gnat</CODE>, but gnat will look for its configuration in
<CODE>/usr/local/lib/rt-pl-2.1.4/gnat</CODE> where the user cannot 
write.

<P>The user decides to install the gnat runtime files in
<CODE>/users/bob/lib/gnat</CODE>. For one-time usage, the user may 
decide to start gnat using the command:

<P>

<XMP>
% gnat -p gnatdir=/users/bob/lib/gnat
</XMP>

<P>For a more widely used executable, this is not very comfortable. The 
user may decide to edit the shell-script part of gnat. Upto the line 
holding

<P>

<XMP>
# End Header
</XMP>

<P>gnat is a simple <B>/bin/sh</B> script. After this line, the file is 
binary and may contain long lines. Most editors are not capable of 
editing such files.<A NAME=back-to-note-28 HREF="Notes.html#note-28"> (28)</A> 
Instead of editing the file directly, the program <STRONG>chpl</STRONG>(1) 
may be used to extract and replace the header of <CODE>gnat</CODE>. The 
following editing sequence will work with any editor capable of editing 
ASCII files.

<P>

<XMP>
% chpl -x gnat > gnat.hdr
% emacs gnat.hdr
% chpl -h gnat.hdr gnat
</XMP>

<P>The header may be changed to the following to install gnat properly:

<P>

<XMP>
#!/bin/sh
# SWI-Prolog version: 2.1.4
# SWI-Prolog save-version: 25
exec ${SWIPL-/usr/local/lib/rt-pl-2.1.4/bin/pl} -x $0 \
-p gnatdir=/users/bob/lib/gnat "$@"
</XMP>

