<HTML><HEAD><TITLE>SWI-Prolog Reference Manual: Section 6.6</TITLE><LINK REL=home HREF="Title.html">
<LINK REL=contents HREF="Contents.html">
<LINK REL=index HREF="Index.html">
<LINK REL=summary HREF="sec-B.html">
<LINK REL=previous HREF="sec-6.5.html">
<LINK REL=next HREF="sec-A.html">
</HEAD>

<BODY>

<HR><CENTER><A HREF="Title.html">Home</A>
<A HREF="Contents.html">Contents</A>
<A HREF="Index.html">Index</A>
<A HREF="sec-B.html">Summary</A>
<A HREF="sec-6.5.html">Previous</A>
<A HREF="sec-A.html">Next</A>
</CENTER>

<HR>

<H2><A NAME="sec:6.6">6.6 The Runtime Environment</A></H2>

<P>

<H3><A NAME="sec:6.6.1">6.6.1 The Runtime Emulator</A></H3>

<P>The sources may be used to built two versions of the emulator. By 
default, the <EM>development emulator</EM> is built. This emulator 
contains all features for interactive development of Prolog 
applications. If the system is configured using
<STRONG>--enable-runtime</STRONG>, <STRONG>make</STRONG>(1) will create 
a
<EM>runtime version</EM> of the emulator. This emulator is equivalent to 
the development version, except for the following features:

<P><UL>
<LI><I>No input editing</I><BR>
The GNU library <CODE>-lreadline</CODE> that provides EMACS compatible 
editing of input lines will not be linked to the system.
<LI><I>No tracer</I><BR>
The tracer and all its options are removed, making the system a little 
faster too.
<LI><I>No profiler</I><BR>
<A NAME="idx:profile/3:657"></A><A HREF="sec-3.40.html#profile/3">profile/3</A> 
and friends are not supported. This saves some space and provides better 
performance.
<LI><I>No interrupt</I><BR>
Keyboard interrupt (Control-C normally) is not rebound and will normally 
terminate the application.
<LI><I>feature(runtime, true) succeeds</I><BR>
This may be used to verify your application is running in the runtime 
environment rather than the development environment.
<LI><I><A NAME="idx:clause/[2,3]:658"></A><A HREF="sec-3.14.html#clause/2">clause/[2,3]</A> 
do not work on static predicates</I><BR>
This feature inhibits listing your program. It is only a very limited 
protection however.
</UL>

<P>The following fragment is an example for building the runtime 
environment in <CODE><CODE>HOME</CODE>/lib/rt-pl-2.1.4</CODE>. If 
possible, the shared-library interface should be configured to ensure it 
can serve a large number of applications.

<P>

<XMP>
% cd pl-2.1.4
% mkdir runtime
% cd runtime
% ../src/configure --enable-runtime --prefix=$HOME
% make
% make rt-install
</XMP>

<P>The runtime directory contains the components listed below. This 
directory may be tar'ed and shipped with your application.

<P><CENTER>
<TABLE BORDER=2 COLS=2 FRAME=border RULES=group>
<TR VALIGN=top><TD><CODE>README.RT</CODE> <TD>Info on the runtime 
environment </TR>
<TBODY>
<TR VALIGN=top><TD><CODE>bin/pl</CODE> <TD>The emulator itself </TR>
<TR VALIGN=top><TD><CODE>bin/chpl</CODE> <TD>The utility to change the 
runtime </TR>
<TBODY>
<TR VALIGN=top><TD><CODE>man/chpl.1</CODE> <TD>Manual page for chpl </TR>
<TR VALIGN=top><TD><CODE>man/pl.1</CODE> <TD>Manual page for pl </TR>
<TBODY>
<TR VALIGN=top><TD><CODE>swipl</CODE> <TD>pointer to the home directory 
(.) </TR>
<TBODY>
<TR VALIGN=top><TD><CODE>lib/</CODE> <TD>directory for shared libraries </TR>
<TR VALIGN=top><TD><CODE>lib/&lt;<VAR>arch</VAR>&gt;/</CODE> <TD>machine-specific 
shared libraries </TR>
</TABLE>

</CENTER>

<P>
