<HTML><HEAD><TITLE>SWI-Prolog Reference Manual</TITLE><LINK REL=home HREF="Title.html">
<LINK REL=contents HREF="Contents.html">
<LINK REL=index HREF="Index.html">
<LINK REL=summary HREF="sec-B.html">
<LINK REL=previous HREF="sec-5.9.html">
<LINK REL=next HREF="sec-6.1.html">
</HEAD>

<BODY>

<HR><CENTER><A HREF="Title.html">Home</A>
<A HREF="Contents.html">Contents</A>
<A HREF="Index.html">Index</A>
<A HREF="sec-B.html">Summary</A>
<A HREF="sec-5.9.html">Previous</A>
<A HREF="sec-6.1.html">Next</A>
</CENTER>

<HR>

<H1><A NAME="sec:6">6 Generating Runtime Applications</A></H1>

<A NAME="sec:runtime"></A>

<P>This chapter describes the features of SWI-Prolog for delivering 
applications that can run without the development version of the system 
installed.

<P>A SWI-Prolog runtime executable is a file consisting of two parts. 
The first part is the <EM>emulator</EM>, which is machine dependent. The 
second part is the <EM>resource archive</EM>, which contains the 
compiled program in a machine-independent format, startup options and 
possibly user-defined <EM>resources</EM>, see <A NAME="idx:resource/3:624"></A><A HREF="sec-6.3.html#resource/3">resource/3</A> 
and
<A NAME="idx:open_resource/3:625"></A><A HREF="sec-6.3.html#open_resource/3">open_resource/3</A>.

<P>These two parts can be connected in various different ways. The most 
common way for distributed runtime applications is to <EM>concatenate</EM> 
the two parts. This can be achieved using external commands (Unix:
<B>cat</B>, Windows: <B>copy</B>), or using the
<CODE>stand_alone</CODE> option to <A NAME="idx:qsave_program/2:626"></A><A HREF="sec-6.html#qsave_program/2">qsave_program/2</A>. 
The second option is to attach a startup script in front of the resource 
that starts the emulator with the proper options. This is the default 
under Unix. Finally, an emulator can be told to use a specified resource 
file using the <STRONG>-x</STRONG> commandline switch.

<P>

<DL>

<P>
<DT><A NAME="qsave_program/2"><STRONG>qsave_program</STRONG>(<VAR>+File, 
+ListOfOptions</VAR>)</A><DD>
Saves the current state of the program to the file <VAR>File</VAR>. The 
result is a resource archive containing a saved-state that expresses all 
Prolog data from the running program and all user-defined resources. 
Depending on the <CODE>stand_alone</CODE> option, the resource is headed 
by the emulator, a Unix shell-script or nothing.

<P><VAR>ListOfOptions</VAR> is a list of <VAR>&lt;<VAR>Key</VAR>&gt; = &lt;<VAR>Value</VAR>&gt;</VAR> 
or <VAR>&lt;<VAR>Key</VAR>&gt;(&lt;<VAR>Value</VAR>&gt;)</VAR> pairs. 
The available keys are described in <A HREF="sec-6.html#tab:qsave-options">table 
7</A>.

<P>
<CENTER>
<TABLE BORDER=2 COLS=4 FRAME=border RULES=group>
<TR VALIGN=top><TD></EM><B>Key</B><TD ALIGN=center></EM><B>Option</B><TD ALIGN=center></EM><B>Type</B><TD></EM><B>Description </B></TR>
<TBODY>
<TR VALIGN=top><TD>local<TD ALIGN=center></EM><B>-L</B><TD ALIGN=center>K-bytes<TD>Size 
(Limit) of local stack </TR>
<TR VALIGN=top><TD>global<TD ALIGN=center></EM><B>-G</B><TD ALIGN=center>K-bytes<TD>Size 
(Limit) of global stack </TR>
<TR VALIGN=top><TD>trail<TD ALIGN=center></EM><B>-T</B><TD ALIGN=center>K-bytes<TD>Size 
(Limit) of trail stack </TR>
<TR VALIGN=top><TD>argument<TD ALIGN=center></EM><B>-A</B><TD ALIGN=center>K-bytes<TD>Size 
(Limit) of argument stack </TR>
<TR VALIGN=top><TD>goal<TD ALIGN=center></EM><B>-g</B><TD ALIGN=center>atom<TD>Initialisation 
goal </TR>
<TR VALIGN=top><TD>toplevel<TD ALIGN=center></EM><B>-t</B><TD ALIGN=center>atom<TD>Prolog 
toplevel goal </TR>
<TR VALIGN=top><TD>init_file<TD ALIGN=center></EM><B>-f</B><TD ALIGN=center>atom<TD>Personal 
initialisation file </TR>
<TBODY>
<TR VALIGN=top><TD>class<TD ALIGN=center><TD ALIGN=center>atom<TD>If <CODE>runtime</CODE>, 
only read resources from the state (default). If <CODE>kernel</CODE>, 
lock all predicates as system predicates If <CODE>development</CODE>, 
change the predicates in their current state and keep reading resources 
from their source (if present). See also <A NAME="idx:resource/3:627"></A><A HREF="sec-6.3.html#resource/3">resource/3</A>. </TR>
<TR VALIGN=top><TD>autoload<TD ALIGN=center><TD ALIGN=center>bool<TD>If 
true, run <A NAME="idx:autoload/0:628"></A><A HREF="sec-6.html#autoload/0">autoload/0</A> 
first </TR>
<TR VALIGN=top><TD>map<TD ALIGN=center><TD ALIGN=center>file<TD>File to 
write info on dump </TR>
<TR VALIGN=top><TD>op<TD ALIGN=center><TD ALIGN=center></EM><TT>save/standard</TT><TD>Save 
operator declarations? </TR>
<TR VALIGN=top><TD>stand_alone<TD ALIGN=center><TD ALIGN=center>bool<TD>Include 
the emulator in the state </TR>
<TR VALIGN=top><TD>emulator<TD ALIGN=center><TD ALIGN=center>file<TD>Emulator 
attached to the (stand-alone) executable. Default is the running 
emulator. </TR>
</TABLE>

</CENTER>

<P><CENTER><B>Table 7 : &lt;<VAR>Key</VAR>&gt; = &lt;<VAR>Value</VAR>&gt; 
pairs for <A NAME="idx:qsave_program/2:629"></A><A HREF="sec-6.html#qsave_program/2">qsave_program/2</A></B></CENTER>
<A NAME="tab:qsave-options"></A>

<P>Before writing the data to file, <A NAME="idx:qsave_program/2:630"></A><A HREF="sec-6.html#qsave_program/2">qsave_program/2</A> 
will run <A NAME="idx:autoload/0:631"></A><A HREF="sec-6.html#autoload/0">autoload/0</A> 
to all required autoloading the system can discover. See <A NAME="idx:autoload/0:632"></A><A HREF="sec-6.html#autoload/0">autoload/0</A>.

<P>Provided the application does not require any of the Prolog libraries 
to be loaded at runtime, the only file from the SWI-Prolog development 
environment required is the emulator itself. The emulator may be built 
in two flavours. The default is the <EM>development emulator</EM>. The
<EM>runtime emulator</EM> is similar, but lacks the tracer.

<P>If the option <CODE>stand_alone(on)</CODE> is present, the emulator 
is the first part of the state. If the emulator is started it will test 
whether a boot-file (state) is attached to the emulator itself and load 
this state. Provided the application has all libraries loaded, the 
resulting executable is completely independent of the runtime 
environment or location where it was build.

<P>

<P>
<DT><A NAME="qsave_program/1"><STRONG>qsave_program</STRONG>(<VAR>+File</VAR>)</A><DD>
Equivalent to <CODE>qsave_program(File, [])</CODE>.

<P>

<P>
<DT><A NAME="autoload/0"><STRONG>autoload</STRONG></A><DD>
Check the current Prolog program for predicates that are referred to, 
are undefined and have a definition in the Prolog library. Load the 
appropriate libraries.

<P>This predicate is used by <A NAME="idx:qsave_program/[1,2]:633"></A><A HREF="sec-6.html#qsave_program/1">qsave_program/[1,2]</A> 
to ensure the saved state will not depend on one of the libraries. The 
predicate <A NAME="idx:autoload/0:634"></A><A HREF="sec-6.html#autoload/0">autoload/0</A> 
will find all <STRONG>direct</STRONG> references to predicates. It does 
not find predicates referenced via meta-predicates. The predicate log/2 
is defined in the library(quintus) to provide a quintus compatible means 
to compute the natural logarithm of a number. The following program will 
behave correctly if its state is executed in an environment where the 
library(quintus) is not available:

<P>

<XMP>
logtable(From, To) :-
        From > To, !.
logtable(From, To) :-
        log(From, Value),
        format('~d~t~8|~2f~n', [From, Value]),
        F is From + 1,
        logtable(F, To).
</XMP>

<P>However, the following implementation refers to log/2 through the 
meta-predicate <A NAME="idx:maplist/3:635"></A><A HREF="sec-3.30.html#maplist/3">maplist/3</A>. 
Autoload will not be able to find the reference. This problem may be 
fixed either by loading the module libtary(quintus) explicitly or use <A NAME="idx:require/1:636"></A><A HREF="sec-3.2.html#require/1">require/1</A> 
to tell the system that the predicate log/2 is required by this module.

<P>

<XMP>
logtable(From, To) :-
        findall(X, between(From, To, X), Xlist),
        maplist(log, Xlist, SineList),
        write_table(Xlist, SineList).

write_table([], []).
write_table([I|IT], [V|VT]) :-
        format('~d~t~8|~2f~n', [I, V]),
        write_table(IT, VT).
</XMP>

<P>

<P>
<DT><A NAME="volatile/1"><STRONG>volatile</STRONG> <VAR>+Name/Arity, \ldots</VAR></A><DD>
Declare that the clauses of specified predicates should <STRONG>not</STRONG> 
be saved to the program. The volatile declaration is normally used to 
avoid that the clauses of dynamic predicates that represent data for the 
current session is saved in the state file.
</DL>

<P>

<HR><CENTER>

<H2>Section Index</H2>

</CENTER>

<HR><UL><UL>
<LI><A HREF="sec-6.1.html"><B>6.1 Limitations of qsave_program</B></A>
<LI><A HREF="sec-6.2.html"><B>6.2 Runtimes and Foreign Code</B></A>
<LI><A HREF="sec-6.3.html"><B>6.3 Using Program Resources</B></A><UL>
<LI><A HREF="sec-6.3.html#sec:6.3.1">6.3.1 Predicates Definitions</A></UL>
<LI><A HREF="sec-6.4.html"><B>6.4 Finding Application files</B></A>
<LI><A HREF="sec-6.5.html"><B>6.5 Using chpl for Configuration 
Information</B></A><UL>
<LI><A HREF="sec-6.5.html#sec:6.5.1">6.5.1 Changing the emulator of a 
runtime application</A>
<LI><A HREF="sec-6.5.html#sec:6.5.2">6.5.2 Passing a path to the 
application</A></UL>
<LI><A HREF="sec-6.6.html"><B>6.6 The Runtime Environment</B></A><UL>
