<HTML><HEAD><TITLE>SWI-Prolog Reference Manual: Section A.1</TITLE><LINK REL=home HREF="Title.html">
<LINK REL=contents HREF="Contents.html">
<LINK REL=index HREF="Index.html">
<LINK REL=summary HREF="sec-B.html">
<LINK REL=previous HREF="sec-A.html">
<LINK REL=next HREF="sec-A.2.html">
</HEAD>

<BODY>

<HR><CENTER><A HREF="Title.html">Home</A>
<A HREF="Contents.html">Contents</A>
<A HREF="Index.html">Index</A>
<A HREF="sec-B.html">Summary</A>
<A HREF="sec-A.html">Previous</A>
<A HREF="sec-A.2.html">Next</A>
</CENTER>

<HR>

<H2><A NAME="sec:A.1">A.1 Examining the Environment Stack</A></H2>

<P>

<DL>

<P>
<DT><A NAME="prolog_current_frame/1"><STRONG>prolog_current_frame</STRONG>(<VAR>-Frame</VAR>)</A><DD>
Unify <VAR>Frame</VAR> with an integer providing a reference to the 
parent of the current local stack frame. A pointer to the current local 
frame cannot be provided as the predicate succeeds deterministically and 
therefore its frame is destroyed immediately after succeeding.

<P>

<P>
<DT><A NAME="prolog_frame_attribute/3"><STRONG>prolog_frame_attribute</STRONG>(<VAR>+Frame, 
+Key, -Value</VAR>)</A><DD>
Obtain information about the local stack frame <VAR>Frame</VAR>. <VAR>Frame</VAR> 
is a frame reference as obtained through <A NAME="idx:prolog_current_frame/1:659"></A><A HREF="sec-A.1.html#prolog_current_frame/1">prolog_current_frame/1</A>,
<A NAME="idx:prolog_trace_interception/4:660"></A><A HREF="sec-A.2.html#prolog_trace_interception/4">prolog_trace_interception/4</A> 
or this predicate. The key values are described below.

<P>

<DL>

<P>
<DT><STRONG>alternative</STRONG><DD>
<VAR>Value</VAR> is unified with an integer reference to the local stack 
frame in which execution is resumed if the goal associated with
<VAR>Frame</VAR> fails. Fails if the frame has no alternative frame.

<P>
<DT><STRONG>has_alternatives</STRONG><DD>
<VAR>Value</VAR> is unified with <CODE>true</CODE> if <VAR>Frame</VAR> 
still is a candidate for backtracking. <CODE>false</CODE> otherwise.

<P>
<DT><STRONG>goal</STRONG><DD>
<VAR>Value</VAR> is unified with the goal associated with <VAR>Frame</VAR>. 
If the definition module of the active predicate is not <CODE>user</CODE> 
the goal is represented as </EM><TT>&lt;<VAR>module</VAR>&gt;:&lt;<VAR>goal</VAR>&gt;</TT>. 
Do not instantiate variables in this goal unless you </EM><B>know</B> 
what you are doing!

<P>
<DT><STRONG>clause</STRONG><DD>
<VAR>Value</VAR> is unified with a reference to the currently running 
clause. Fails if the current goal is associated with a foreign (C) 
defined predicate. See also <A NAME="idx:nth_clause/3:661"></A><A HREF="sec-3.14.html#nth_clause/3">nth_clause/3</A> 
and <A NAME="idx:clause_property/2:662"></A><A HREF="sec-3.14.html#clause_property/2">clause_property/2</A>.

<P>
<DT><STRONG>level</STRONG><DD>
<VAR>Value</VAR> is unified with the recursion level of <VAR>Frame</VAR>. 
The top level frame is at level `0'.

<P>
<DT><STRONG>parent</STRONG><DD>
<VAR>Value</VAR> is unified with an integer reference to the parent 
local stack frame of <VAR>Frame</VAR>. Fails if <VAR>Frame</VAR> is the 
top frame.

<P>
<DT><STRONG>context_module</STRONG><DD>
<VAR>Value</VAR> is unified with the name of the context module of the 
environment.

<P>
<DT><STRONG>top</STRONG><DD>
<VAR>Value</VAR> is unified with <CODE>true</CODE> if <VAR>Frame</VAR> 
is the top Prolog goal from a recursive call back from the foreign 
language. <CODE>false</CODE> otherwise.

<P>
<DT><STRONG>hidden</STRONG><DD>
<VAR>Value</VAR> is unified with <CODE>true</CODE> if the frame is 
hidden from the user, either because a parent has the hide-childs 
attribute (all system predicates), or the system has no trace-me 
attribute.

<P>
<DT><STRONG>pc</STRONG><DD>
<VAR>Value</VAR> is unified with the program-pointer saved on behalve of 
the parent-goal if the parent-goal is not owned by a foreign predicate.

<P>
<DT><STRONG>argument</STRONG>(<VAR>N</VAR>)<DD>
<VAR>Value</VAR> is unified with the <VAR>N</VAR>-th slot of the frame. 
Argument 1 is the first argument of the goal. Arguments above the arity 
refer to local variables. Fails silently if <VAR>N</VAR> is out of 
range.
</DL>

</DL>

