<HTML><HEAD><TITLE>SWI-Prolog Reference Manual: Section A.2</TITLE><LINK REL=home HREF="Title.html">
<LINK REL=contents HREF="Contents.html">
<LINK REL=index HREF="Index.html">
<LINK REL=summary HREF="sec-B.html">
<LINK REL=previous HREF="sec-A.1.html">
<LINK REL=next HREF="sec-A.3.html">
</HEAD>

<BODY>

<HR><CENTER><A HREF="Title.html">Home</A>
<A HREF="Contents.html">Contents</A>
<A HREF="Index.html">Index</A>
<A HREF="sec-B.html">Summary</A>
<A HREF="sec-A.1.html">Previous</A>
<A HREF="sec-A.3.html">Next</A>
</CENTER>

<HR>

<H2><A NAME="sec:A.2">A.2 Intercepting the Tracer</A></H2>

<P>

<DL>

<P>
<DT><A NAME="prolog_trace_interception/4"><STRONG>prolog_trace_interception</STRONG>(<VAR>+Port, 
+Frame, +PC, -Action</VAR>)</A><DD>
Dynamic predicate, normally not defined. This predicate is called from 
the SWI-Prolog debugger just before it would show a port. If this 
predicate succeeds the debugger assumes the trace action has been taken 
care of and continues execution as described by <VAR>Action</VAR>. 
Otherwise the normal Prolog debugger actions are performed.

<P><VAR>Port</VAR> is one of <CODE>call</CODE>, <CODE>redo</CODE>, <CODE>exit</CODE>, <CODE>fail</CODE> 
or
<CODE>unify</CODE>. <VAR>Frame</VAR> is an integer reference to the 
current local stack frame. <VAR>PC</VAR> is the current value of the 
program-counter, relative to the start of the current clause, or 0 if it 
is invalid, for example because the current frame runs a foreign 
predicate, or no clause has been selected yet. <VAR>Action</VAR> should 
be unified with one of the atoms <CODE>continue</CODE> (just continue 
execution), <CODE>retry</CODE> (retry the current goal) or <CODE>fail</CODE> 
(force the current goal to fail). Leaving it a variable is identical to <CODE>continue</CODE>.

<P>Together with the predicates described in <A HREF="sec-3.38.html">section 
3.38</A> and the other predicates of this chapter this predicate enables 
the Prolog user to define a complete new debugger in Prolog. Besides 
this it enables the Prolog programmer monitor the execution of a 
program. The example below records all goals trapped by the tracer in 
the database.

<P>

<XMP>
prolog_trace_interception(Port, Frame, _PC, continue) :-
        prolog_frame_attribute(Frame, goal, Goal), 
        prolog_frame_attribute(Frame, level, Level), 
        recordz(trace, trace(Port, Level, Goal)).
</XMP>

<P>To trace the execution of `go' this way the following query should be 
given:

<P>

<XMP>
?- trace, go, notrace.
</XMP>

<P>

<P>
<DT><A NAME="prolog_skip_level/2"><STRONG>prolog_skip_level</STRONG>(<VAR>-Old, 
+New</VAR>)</A><DD>
Unify <VAR>Old</VAR> with the old value of `skip level' and than set 
this level according to <VAR>New</VAR>. New is an integer, or the 
special atom
<CODE>very_deep</CODE> (meaning don't skip). The `skip level' is a 
global variable of the Prolog system that disables the debugger on all 
recursion levels deeper than the level of the variable. Used to 
implement the trace options `skip' (sets skip level to the level of the 
frame) and `up' (sets skip level to the level of the parent frame (i.e. the 
level of this frame minus 1).

<P>

<P>
<DT><A NAME="user:prolog_list_goal/1"><STRONG>user:prolog_list_goal</STRONG>(<VAR>:Goal</VAR>)</A><DD>
Hook, normally not defined. This hook is called by the 'L' command of 
the tracer to list the currently called predicate. This hook may be 
defined to list only relevant clauses of the indicated <VAR>Goal</VAR> 
and/or show the actual source-code in an editor. See also <A NAME="idx:portray/1:663"></A><A HREF="sec-3.18.html#portray/1">portray/1</A> 
and
<A NAME="idx:multifile/1:664"></A><A HREF="sec-3.13.html#multifile/1">multifile/1</A>.
</DL>

