<HTML><HEAD><TITLE>SWI-Prolog Reference Manual: Section A.3</TITLE><LINK REL=home HREF="Title.html">
<LINK REL=contents HREF="Contents.html">
<LINK REL=index HREF="Index.html">
<LINK REL=summary HREF="sec-B.html">
<LINK REL=previous HREF="sec-A.2.html">
<LINK REL=next HREF="sec-A.4.html">
</HEAD>

<BODY>

<HR><CENTER><A HREF="Title.html">Home</A>
<A HREF="Contents.html">Contents</A>
<A HREF="Index.html">Index</A>
<A HREF="sec-B.html">Summary</A>
<A HREF="sec-A.2.html">Previous</A>
<A HREF="sec-A.4.html">Next</A>
</CENTER>

<HR>

<H2><A NAME="sec:A.3">A.3 Exception Handling</A></H2>

<P>A start has been made to make exception handling available to the 
Prolog user. On exceptions a dynamic and multifile defined predicate
<A NAME="idx:exception/3:665"></A><A HREF="sec-A.3.html#exception/3">exception/3</A> 
is called. If this user defined predicate succeeds Prolog assumes the 
exception has been taken care of. Otherwise the system default exception 
handler is called.

<P>

<DL>

<P>
<DT><A NAME="exception/3"><STRONG>exception</STRONG>(<VAR>+Exception, 
+Context, -Action</VAR>)</A><DD>
Dynamic predicate, normally not defined. Called by the Prolog system on 
run-time exceptions. Currently <A NAME="idx:exception/3:666"></A><A HREF="sec-A.3.html#exception/3">exception/3</A> 
is only used for trapping undefined predicates. Future versions might 
handle signal handling, floating exceptions and other runtime errors via 
this mechanism. The values for <VAR>Exception</VAR> are described below.

<P>

<DL>

<P>
<DT><STRONG>undefined_predicate</STRONG><DD>
If <VAR>Exception</VAR> is <CODE>undefined_predicate</CODE> <VAR>Context</VAR> 
is instantiated to a term <VAR>Name</VAR>/<VAR>Arity</VAR>. <VAR>Name</VAR> 
refers to the name and <VAR>Arity</VAR> to the arity of the undefined 
predicate. If the definition module of the predicate is not <VAR>user</VAR>, <VAR>Context</VAR> 
will be of the form </EM><TT>&lt;<VAR>Module</VAR>&gt;:&lt;<VAR>Name</VAR>&gt;/&lt;<VAR>Arity</VAR>&gt;</TT>. 
If the predicate fails Prolog will print the default error warning and 
start the tracer. If the predicate succeeds it should instantiate the 
last argument either to the atom <CODE>fail</CODE> to tell Prolog to 
fail the predicate or the atom
<CODE>retry</CODE> to tell Prolog to retry the predicate. This only 
makes sense if the exception handler has defined the predicate. 
Otherwise it will lead to a loop.

<P>
<DT><STRONG>warning</STRONG><DD>
If prolog wants to give a warning while reading a file, it will first 
raise the exception <VAR>warning</VAR>. The context argument is a term 
of the form <CODE>warning(&lt;<VAR>Path</VAR>&gt;, &lt;<VAR>LineNo</VAR>&gt;, &lt;<VAR>Message</VAR>&gt;)</CODE>, 
where <VAR>Path</VAR> is the absolute filename of the file prolog is 
reading; <VAR>LineNo</VAR> is an estimate of the line number where the 
error occurred and <VAR>Message</VAR> is a Prolog string indicating the 
message. The <VAR>Action</VAR> argument is ignored. The error is 
supposed to be presented to the user if the exception handler succeeds. 
Otherwise the standard Prolog warning message is printed.

<P>This exception is used by the <CODE>library(emacs_interface)</CODE>, 
that integrates error handling with <B>GNU~Emacs</B>.
</DL>

</DL>

