<HTML><HEAD><TITLE>SWI-Prolog Reference Manual: Section B.1</TITLE><LINK REL=home HREF="Title.html">
<LINK REL=contents HREF="Contents.html">
<LINK REL=index HREF="Index.html">
<LINK REL=summary HREF="sec-B.html">
<LINK REL=previous HREF="sec-B.html">
<LINK REL=next HREF="sec-B.2.html">
</HEAD>

<BODY>

<HR><CENTER><A HREF="Title.html">Home</A>
<A HREF="Contents.html">Contents</A>
<A HREF="Index.html">Index</A>
<A HREF="sec-B.html">Summary</A>
<A HREF="sec-B.html">Previous</A>
<A HREF="sec-B.2.html">Next</A>
</CENTER>

<HR>

<H2><A NAME="sec:B.1">B.1 Predicates</A></H2>

<P>The predicate summary is used by the Prolog predicate <A NAME="idx:apropos/1:667"></A><A HREF="sec-2.3.html#apropos/1">apropos/1</A> 
to suggest predicates from a keyword.

<P>
<TABLE>
<TR><TD><A HREF="sec-3.6.html#!/0">!/0</A><TD>Cut (discard choicepoints)</TR>
<TR><TD><A HREF="sec-3.10.html#!/1">!/1</A><TD>Cut block. See <A NAME="idx:block/3:668"></A><A HREF="sec-3.10.html#block/3">block/3</A></TR>
<TR><TD><A HREF="sec-3.6.html#,/2">,/2</A><TD>Conjunction of goals</TR>
<TR><TD><A HREF="sec-3.6.html#->/2">-&gt;/2</A><TD>If-then-else</TR>
<TR><TD><A HREF="sec-3.6.html#*->/2">*-&gt;/2</A><TD>Soft-cut</TR>
<TR><TD><A HREF="sec-3.24.html#./2">./2</A><TD>Consult. Also list 
constructor</TR>
<TR><TD><A HREF="sec-3.6.html#;/2">;/2</A><TD>Disjunction of goals. Same 
as <A HREF="sec-3.6.html#|/2">|/2</A></TR>
<TR><TD><A HREF="sec-3.23.html#</2">&lt;/2</A><TD>Arithmetic smaller</TR>
<TR><TD><A HREF="sec-3.5.html#=/2">=/2</A><TD>Unification</TR>
<TR><TD><A HREF="sec-3.19.html#=../2">=../2</A><TD>``Univ.'' Term to 
list conversion</TR>
<TR><TD><A HREF="sec-3.23.html#=:=/2">=:=/2</A><TD>Arithmetic equal</TR>
<TR><TD><A HREF="sec-3.23.html#=</2">=&lt;/2</A><TD>Arithmetic smaller 
or equal</TR>
<TR><TD><A HREF="sec-3.5.html#==/2">==/2</A><TD>Identical</TR>
<TR><TD><A HREF="sec-3.5.html#=@=/2">=@=/2</A><TD>Structural identical</TR>
<TR><TD><A HREF="sec-3.23.html#=\=/2">=\=/2</A><TD>Arithmetic not equal</TR>
<TR><TD><A HREF="sec-3.23.html#>/2">&gt;/2</A><TD>Arithmetic larger</TR>
<TR><TD><A HREF="sec-3.23.html#>=/2">&gt;=/2</A><TD>Arithmetic larger or 
equal</TR>
<TR><TD><A HREF="sec-3.5.html#@</2">@&lt;/2</A><TD>Standard order 
smaller</TR>
<TR><TD><A HREF="sec-3.5.html#@=</2">@=&lt;/2</A><TD>Standard order 
smaller or equal</TR>
<TR><TD><A HREF="sec-3.5.html#@>/2">@&gt;/2</A><TD>Standard order larger</TR>
<TR><TD><A HREF="sec-3.5.html#@>=/2">@&gt;=/2</A><TD>Standard order 
larger or equal</TR>
<TR><TD><A HREF="sec-3.6.html#\+/1">\+/1</A><TD>Negation by failure. 
Same as <A NAME="idx:not/1:669"></A><A HREF="sec-3.7.html#not/1">not/1</A></TR>
<TR><TD><A HREF="sec-3.5.html#\=/2">\=/2</A><TD>Not unifyable</TR>
<TR><TD><A HREF="sec-3.5.html#\==/2">\==/2</A><TD>Not identical</TR>
<TR><TD><A HREF="sec-3.5.html#\=@=/2">\=@=/2</A><TD>Not structural 
identical</TR>
<TR><TD><A HREF="sec-3.24.html#^/2">^/2</A><TD>Existential 
quantification (<A NAME="idx:bagof/3:670"></A><A HREF="sec-3.29.html#bagof/3">bagof/3</A>, <A NAME="idx:setof/3:671"></A><A HREF="sec-3.29.html#setof/3">setof/3</A>)</TR>
<TR><TD><A HREF="sec-3.6.html#|/2">|/2</A><TD>Disjunction of goals. Same 
as <A HREF="sec-3.6.html#;/2">;/2</A></TR>
<TR><TD><A HREF="sec-3.12.html#abolish/1">abolish/1</A><TD>Remove 
predicate definition from the database</TR>
<TR><TD><A HREF="sec-3.12.html#abolish/2">abolish/2</A><TD>Remove 
predicate definition from the database</TR>
<TR><TD><A HREF="sec-3.36.html#abort/0">abort/0</A><TD>Abort execution, 
return to top level</TR>
<TR><TD><A HREF="sec-3.35.html#absolute_file_name/2">absolute_file_name/2</A><TD>Get 
absolute path name</TR>
<TR><TD><A HREF="sec-3.35.html#absolute_file_name/3">absolute_file_name/3</A><TD>Get 
absolute path name with options</TR>
<TR><TD><A HREF="sec-3.35.html#access_file/2">access_file/2</A><TD>Check 
access permissions of a file</TR>
<TR><TD><A HREF="sec-3.15.html#append/1">append/1</A><TD>Append to a 
file</TR>
<TR><TD><A HREF="sec-3.26.html#append/3">append/3</A><TD>Concatenate 
lists</TR>
<TR><TD><A HREF="sec-3.7.html#apply/2">apply/2</A><TD>Call goal with 
additional arguments</TR>
<TR><TD><A HREF="sec-2.3.html#apropos/1">apropos/1</A><TD><CODE>library(online_help)</CODE> 
Show related predicates and manual sections</TR>
<TR><TD><A HREF="sec-3.19.html#arg/3">arg/3</A><TD>Access argument of a 
term</TR>
<TR><TD><A HREF="sec-3.25.html#arithmetic_function/1">arithmetic_function/1</A><TD>Register 
an evaluable function</TR>
<TR><TD><A HREF="sec-3.12.html#assert/1">assert/1</A><TD>Add a clause to 
the database</TR>
<TR><TD><A HREF="sec-3.12.html#assert/2">assert/2</A><TD>Add a clause to 
the database, give reference</TR>
<TR><TD><A HREF="sec-3.12.html#asserta/1">asserta/1</A><TD>Add a clause 
to the database (first)</TR>
<TR><TD><A HREF="sec-3.12.html#asserta/2">asserta/2</A><TD>Add a clause 
to the database (first)</TR>
<TR><TD><A HREF="sec-3.12.html#assertz/1">assertz/1</A><TD>Add a clause 
to the database (last)</TR>
<TR><TD><A HREF="sec-3.12.html#assertz/2">assertz/2</A><TD>Add a clause 
to the database (last)</TR>
<TR><TD><A HREF="sec-3.17.html#at_end_of_stream/0">at_end_of_stream/0</A><TD>Test 
for end of file on input</TR>
<TR><TD><A HREF="sec-3.17.html#at_end_of_stream/1">at_end_of_stream/1</A><TD>Test 
for end of file on stream</TR>
<TR><TD><A HREF="sec-3.2.html#at_halt/1">at_halt/1</A><TD>Register goal 
to run at <A NAME="idx:halt/1:672"></A><A HREF="sec-3.36.html#halt/1">halt/1</A></TR>
<TR><TD><A HREF="sec-3.2.html#at_initialization/1">at_initialization/1</A><TD>Register 
goal to run at start-up</TR>
<TR><TD><A HREF="sec-3.4.html#atom/1">atom/1</A><TD>Type check for an 
atom</TR>
<TR><TD><A HREF="sec-3.20.html#atom_char/2">atom_char/2</A><TD>Convert 
between atom and ASCII value</TR>
<TR><TD><A HREF="sec-3.20.html#atom_chars/2">atom_chars/2</A><TD>Convert 
between atom and list of ASCII values</TR>
<TR><TD><A HREF="sec-3.20.html#atom_length/2">atom_length/2</A><TD>Determine 
length of an atom</TR>
<TR><TD><A HREF="sec-3.20.html#atom_prefix/2">atom_prefix/2</A><TD>Test 
for start of atom</TR>
<TR><TD><A HREF="sec-3.20.html#atom_to_term/3">atom_to_term/3</A><TD>Convert 
between atom and term</TR>
<TR><TD><A HREF="sec-3.4.html#atomic/1">atomic/1</A><TD>Type check for 
primitive</TR>
<TR><TD><A HREF="sec-6.html#autoload/0">autoload/0</A><TD>Autoload all 
predicates now</TR>
<TR><TD><A HREF="sec-3.29.html#bagof/3">bagof/3</A><TD>Find all 
solutions to a goal</TR>
<TR><TD><A HREF="sec-3.23.html#between/3">between/3</A><TD>Integer range 
checking/generating</TR>
<TR><TD><A HREF="sec-3.10.html#block/3">block/3</A><TD>Start a block 
(`catch'/`throw')</TR>
<TR><TD><A HREF="sec-3.36.html#break/0">break/0</A><TD>Start interactive 
toplevel</TR>
<TR><TD><A HREF="sec-3.7.html#call/1">call/1</A><TD>Call a goal</TR>
<TR><TD><A HREF="sec-3.7.html#call/2">call/[2..]</A><TD>Call with 
additional arguments</TR>
<TR><TD><B>call_dll_function/2</B><TD>Win32: Call function in dynamic 
link library (.dll file)</TR>
<TR><TD><A HREF="sec-5.3.html#call_shared_object_function/2">call_shared_object_function/2</A><TD>UNIX: 
Call C-function in shared (.so) file</TR>
<TR><TD><A HREF="sec-3.7.html#call_with_depth_limit/3">call_with_depth_limit/3</A><TD>Prove 
goal with bounded depth</TR>
<TR><TD><A HREF="sec-3.8.html#catch/3">catch/3</A><TD>Call goal, 
watching for exceptions</TR>
<TR><TD><A HREF="sec-3.16.html#character_count/2">character_count/2</A><TD>Get 
character index on a stream</TR>
<TR><TD><A HREF="sec-3.35.html#chdir/1">chdir/1</A><TD>Change working 
directory</TR>
<TR><TD><A HREF="sec-3.30.html#checklist/2">checklist/2</A><TD>Invoke 
goal on all members of a list</TR>
<TR><TD><A HREF="sec-3.14.html#clause/2">clause/2</A><TD>Get clauses of 
a predicate</TR>
<TR><TD><A HREF="sec-3.14.html#clause/3">clause/3</A><TD>Get clauses of 
a predicate</TR>
<TR><TD><A HREF="sec-3.14.html#clause_property/2">clause_property/2</A><TD>Get 
properties of a clause</TR>
<TR><TD><A HREF="sec-3.15.html#close/1">close/1</A><TD>Close stream</TR>
<TR><TD><A HREF="sec-3.42.html#close_dde_conversation/1">close_dde_conversation/1</A><TD>Win32: 
Close DDE channel</TR>
<TR><TD><B>close_dll/1</B><TD>Win32: Close dynamic link library (.dll 
file)</TR>
<TR><TD><A HREF="sec-5.3.html#close_shared_object/1">close_shared_object/1</A><TD>UNIX: 
Close shared library (.so file)</TR>
<TR><TD><A HREF="sec-3.5.html#compare/3">compare/3</A><TD>Compare, using 
a predicate to determine the order</TR>
<TR><TD><A HREF="sec-3.2.html#compiling/0">compiling/0</A><TD>Is this a 
compilation run?</TR>
<TR><TD><A HREF="sec-3.4.html#compound/1">compound/1</A><TD>Test for 
compound term</TR>
<TR><TD><A HREF="sec-3.20.html#concat/3">concat/3</A><TD>Append two 
atoms</TR>
<TR><TD><A HREF="sec-3.20.html#concat_atom/2">concat_atom/2</A><TD>Append 
a list of atoms</TR>
<TR><TD><A HREF="sec-3.20.html#concat_atom/3">concat_atom/3</A><TD>Append 
a list of atoms with separator</TR>
<TR><TD><A HREF="sec-3.2.html#consult/1">consult/1</A><TD>Read (compile) 
a Prolog source file</TR>
<TR><TD><A HREF="sec-4.8.html#context_module/1">context_module/1</A><TD>Get 
context module of current goal</TR>
<TR><TD><A HREF="sec-3.34.html#convert_time/8">convert_time/8</A><TD>Convert 
time stamp</TR>
<TR><TD><A HREF="sec-3.19.html#copy_term/2">copy_term/2</A><TD>Make a 
copy of a term</TR>
<TR><TD><A HREF="sec-3.25.html#current_arithmetic_function/1">current_arithmetic_function/1</A><TD>Examine 
evaluable functions</TR>
<TR><TD><A HREF="sec-3.14.html#current_atom/1">current_atom/1</A><TD>Examine 
existing atoms</TR>
<TR><TD><A HREF="sec-3.14.html#current_flag/1">current_flag/1</A><TD>Examine 
existing flags</TR>
<TR><TD><A HREF="sec-5.4.html#current_foreign_library/2">current_foreign_library/2</A><TD><CODE>library(shlib)</CODE> 
Examine loaded shared libraries (.so files)</TR>
<TR><TD><A HREF="sec-3.14.html#current_functor/2">current_functor/2</A><TD>Examine 
existing name/arity pairs</TR>
<TR><TD><A HREF="sec-3.15.html#current_input/1">current_input/1</A><TD>Get 
current input stream</TR>
<TR><TD><A HREF="sec-3.14.html#current_key/1">current_key/1</A><TD>Examine 
existing database keys</TR>
<TR><TD><A HREF="sec-4.8.html#current_module/1">current_module/1</A><TD>Examine 
existing modules</TR>
<TR><TD><A HREF="sec-4.8.html#current_module/2">current_module/2</A><TD>Examine 
existing modules</TR>
<TR><TD><A HREF="sec-3.22.html#current_op/3">current_op/3</A><TD>Examine 
current operator declarations</TR>
<TR><TD><A HREF="sec-3.15.html#current_output/1">current_output/1</A><TD>Get 
the current output stream</TR>
<TR><TD><A HREF="sec-3.14.html#current_predicate/2">current_predicate/2</A><TD>Examine 
existing predicates</TR>
<TR><TD><A HREF="sec-3.9.html#current_signal/3">current_signal/3</A><TD>Current 
software signal mapping</TR>
<TR><TD><A HREF="sec-3.15.html#current_stream/3">current_stream/3</A><TD>Examine 
open streams</TR>
<TR><TD><A HREF="sec-3.42.html#dde_current_connection/2">dde_current_connection/2</A><TD>Win32: 
Examine open DDE connections</TR>
<TR><TD><A HREF="sec-3.42.html#dde_current_service/2">dde_current_service/2</A><TD>Win32: 
Examine DDE services provided</TR>
<TR><TD><A HREF="sec-3.42.html#dde_execute/2">dde_execute/2</A><TD>Win32: 
Execute command on DDE server</TR>
<TR><TD><A HREF="sec-3.42.html#dde_register_service/2">dde_register_service/2</A><TD>Win32: 
Become a DDE server</TR>
<TR><TD><A HREF="sec-3.42.html#dde_request/3">dde_request/3</A><TD>Win32: 
Make a DDE request</TR>
<TR><TD><B>dde_poke/3</B><TD>Win32: POKE operation on DDE server</TR>
<TR><TD><A HREF="sec-3.42.html#dde_unregister_service/1">dde_unregister_service/1</A><TD>Win32: 
Terminate a DDE service</TR>
<TR><TD><A HREF="sec-3.38.html#debug/0">debug/0</A><TD>Test for 
debugging mode</TR>
<TR><TD><A HREF="sec-3.38.html#debugging/0">debugging/0</A><TD>Show 
debugger status</TR>
<TR><TD><A HREF="sec-4.8.html#default_module/2">default_module/2</A><TD>Get 
the default modules of a module</TR>
<TR><TD><A HREF="sec-3.26.html#delete/3">delete/3</A><TD>Delete all 
matching members from a list</TR>
<TR><TD><A HREF="sec-3.35.html#delete_file/1">delete_file/1</A><TD>Remove 
a file from the file system</TR>
<TR><TD><A HREF="sec-3.13.html#discontiguous/1">discontiguous/1</A><TD>Indicate 
distributed definition of a predicate</TR>
<TR><TD><A HREF="sec-3.15.html#dup_stream/2">dup_stream/2</A><TD>Duplicate 
I/O streams</TR>
<TR><TD><A HREF="sec-3.43.html#dwim_match/2">dwim_match/2</A><TD>Atoms 
match in ``Do What I Mean'' sense</TR>
<TR><TD><A HREF="sec-3.43.html#dwim_match/3">dwim_match/3</A><TD>Atoms 
match in ``Do What I Mean'' sense</TR>
<TR><TD><A HREF="sec-3.14.html#dwim_predicate/2">dwim_predicate/2</A><TD>Find 
predicate in ``Do What I Mean'' sense</TR>
<TR><TD><A HREF="sec-3.13.html#dynamic/1">dynamic/1</A><TD>Indicate 
predicate definition may change</TR>
<TR><TD><A HREF="sec-3.3.html#ed/0">ed/0</A><TD>Edit last edited 
predicate</TR>
<TR><TD><A HREF="sec-3.3.html#ed/1">ed/1</A><TD>Edit a predicate</TR>
<TR><TD><A HREF="sec-3.3.html#edit/0">edit/0</A><TD>Edit last edited 
file</TR>
<TR><TD><A HREF="sec-3.3.html#edit/1">edit/1</A><TD>Edit a file</TR>
<TR><TD><A HREF="sec-3.3.html#edit_source/1">edit_source/1</A><TD><I>(hook)</I> 
Intercept editing</TR>
<TR><TD><A HREF="sec-3.2.html#ensure_loaded/1">ensure_loaded/1</A><TD>Consult 
a file if that has not yet been done</TR>
<TR><TD><A HREF="sec-3.12.html#erase/1">erase/1</A><TD>Erase a database 
record or clause</TR>
<TR><TD><A HREF="sec-A.3.html#exception/3">exception/3</A><TD><I>(hook)</I> 
Handle runtime exceptions</TR>
<TR><TD><A HREF="sec-3.35.html#exists_directory/1">exists_directory/1</A><TD>Check 
existence of directory</TR>
<TR><TD><A HREF="sec-3.35.html#exists_file/1">exists_file/1</A><TD>Check 
existence of file</TR>
<TR><TD><A HREF="sec-3.10.html#exit/2">exit/2</A><TD>Exit from named 
block. See <A NAME="idx:block/3:673"></A><A HREF="sec-3.10.html#block/3">block/3</A></TR>
<TR><TD><A HREF="sec-3.36.html#expand_answer/2">expand_answer/2</A><TD>Expand 
answer of query</TR>
<TR><TD><A HREF="sec-3.35.html#expand_file_name/2">expand_file_name/2</A><TD>Wildcard 
expansion of file names</TR>
<TR><TD><A HREF="sec-3.2.html#expand_file_search_path/2">expand_file_search_path/2</A><TD>Wildcard 
expansion of file paths</TR>
<TR><TD><A HREF="sec-3.36.html#expand_query/4">expand_query/4</A><TD>Expanded 
entered query</TR>
<TR><TD><A HREF="sec-3.2.html#expand_term/2">expand_term/2</A><TD>Compiler: 
expand read term into clause(s)</TR>
<TR><TD><A HREF="sec-2.3.html#explain/1">explain/1</A><TD><CODE>library(explain)</CODE> 
Explain argument</TR>
<TR><TD><A HREF="sec-2.3.html#explain/2">explain/2</A><TD><CODE>library(explain)</CODE> 
2nd argument is explanation of first</TR>
<TR><TD><A HREF="sec-4.8.html#export/1">export/1</A><TD>Export a 
predicate from a module</TR>
<TR><TD><A HREF="sec-4.8.html#export_list/2">export_list/2</A><TD>List 
of public predicates of a module</TR>
<TR><TD><A HREF="sec-3.6.html#fail/0">fail/0</A><TD>Always false</TR>
<TR><TD><A HREF="sec-3.10.html#fail/1">fail/1</A><TD>Immediately fail 
named block. See <A NAME="idx:block/3:674"></A><A HREF="sec-3.10.html#block/3">block/3</A></TR>
<TR><TD><A HREF="sec-2.8.html#feature/2">feature/2</A><TD>Get system 
configuration parameters</TR>
<TR><TD><A HREF="sec-3.35.html#file_base_name/2">file_base_name/2</A><TD>Get 
file part of path</TR>
<TR><TD><A HREF="sec-3.35.html#file_directory_name/2">file_directory_name/2</A><TD>Get 
directory part of path</TR>
<TR><TD><A HREF="sec-3.35.html#file_name_extension/3">file_name_extension/3</A><TD>Add, 
remove or test file extensions</TR>
<TR><TD><A HREF="sec-3.2.html#file_search_path/2">file_search_path/2</A><TD>Define 
path-aliases for locating files</TR>
<TR><TD><A HREF="sec-3.16.html#fileerrors/2">fileerrors/2</A><TD>Do/Don't 
warn on file errors</TR>
<TR><TD><A HREF="sec-3.29.html#findall/3">findall/3</A><TD>Find all 
solutions to a goal</TR>
<TR><TD><A HREF="sec-3.12.html#flag/3">flag/3</A><TD>Simple global 
variable system</TR>
<TR><TD><A HREF="sec-3.26.html#flatten/2">flatten/2</A><TD>Transform 
nested list into flat list</TR>
<TR><TD><A HREF="sec-3.4.html#float/1">float/1</A><TD>Type check for a 
floating point number</TR>
<TR><TD><A HREF="sec-3.17.html#flush/0">flush/0</A><TD>Output pending 
characters on current stream</TR>
<TR><TD><A HREF="sec-3.17.html#flush_output/1">flush_output/1</A><TD>Output 
pending characters on specified stream</TR>
<TR><TD><A HREF="sec-3.31.html#forall/2">forall/2</A><TD>Prove goal for 
all solutions of another goal</TR>
<TR><TD><A HREF="sec-5.4.html#foreign_file/1">foreign_file/1</A><TD>Examine 
loaded foreign files</TR>
<TR><TD><A HREF="sec-3.32.html#format/1">format/1</A><TD>Formatted 
output</TR>
<TR><TD><A HREF="sec-3.32.html#format/2">format/2</A><TD>Formatted 
output with arguments</TR>
<TR><TD><A HREF="sec-3.32.html#format/3">format/3</A><TD>Formatted 
output on a stream</TR>
<TR><TD><A HREF="sec-3.32.html#format_predicate/2">format_predicate/2</A><TD>Program <A NAME="idx:format/[1,2]:675"></A><A HREF="sec-3.32.html#format/1">format/[1,2]</A></TR>
<TR><TD><A HREF="sec-3.19.html#free_variables/2">free_variables/2</A><TD>Find 
unbound variables in a term</TR>
<TR><TD><A HREF="sec-3.19.html#functor/3">functor/3</A><TD>Get name and 
arity of a term or construct a term</TR>
<TR><TD><A HREF="sec-3.41.html#garbage_collect/0">garbage_collect/0</A><TD>Invoke 
the garbage collector</TR>
<TR><TD><A HREF="sec-3.43.html#gensym/2">gensym/2</A><TD>Generate unique 
atoms from a base</TR>
<TR><TD><A HREF="sec-3.17.html#get/1">get/1</A><TD>Read first non-blank 
character</TR>
<TR><TD><A HREF="sec-3.17.html#get/2">get/2</A><TD>Read first non-blank 
character from a stream</TR>
<TR><TD><A HREF="sec-3.17.html#get0/1">get0/1</A><TD>Read next character</TR>
<TR><TD><A HREF="sec-3.17.html#get0/2">get0/2</A><TD>Read next character 
from a stream</TR>
<TR><TD><A HREF="sec-3.17.html#get_single_char/1">get_single_char/1</A><TD>Read 
next character from the terminal</TR>
<TR><TD><A HREF="sec-3.34.html#get_time/1">get_time/1</A><TD>Get current 
time</TR>
<TR><TD><A HREF="sec-3.34.html#getenv/2">getenv/2</A><TD>Get shell 
environment variable</TR>
<TR><TD><A HREF="sec-3.4.html#ground/1">ground/1</A><TD>Verify term 
holds no unbound variables</TR>
<TR><TD><A HREF="sec-3.36.html#halt/0">halt/0</A><TD>Exit from Prolog</TR>
<TR><TD><A HREF="sec-3.36.html#halt/1">halt/1</A><TD>Exit from Prolog 
with status</TR>
<TR><TD><A HREF="sec-3.12.html#hash_term/2">hash_term/2</A><TD>Hash-value 
of ground term</TR>
<TR><TD><A HREF="sec-2.3.html#help/0">help/0</A><TD>Give help on help</TR>
<TR><TD><A HREF="sec-2.3.html#help/1">help/1</A><TD>Give help on 
predicates and show parts of manual</TR>
<TR><TD><A HREF="sec-3.7.html#ignore/1">ignore/1</A><TD>Call the 
argument, but always succeed</TR>
<TR><TD><A HREF="sec-4.4.html#import/1">import/1</A><TD>Import a 
predicate from a module</TR>
<TR><TD><A HREF="sec-3.13.html#index/1">index/1</A><TD>Change clause 
indexing</TR>
<TR><TD><A HREF="sec-3.2.html#initialization/1">initialization/1</A><TD>Initialization 
directive</TR>
<TR><TD><A HREF="sec-3.20.html#int_to_atom/2">int_to_atom/2</A><TD>Convert 
from integer to atom</TR>
<TR><TD><A HREF="sec-3.20.html#int_to_atom/3">int_to_atom/3</A><TD>Convert 
from integer to atom (non-decimal)</TR>
<TR><TD><A HREF="sec-3.4.html#integer/1">integer/1</A><TD>Type check for 
integer</TR>
<TR><TD><A HREF="sec-3.27.html#intersection/3">intersection/3</A><TD>Set 
intersection</TR>
<TR><TD><A HREF="sec-3.23.html#is/2">is/2</A><TD>Evaluate arithmetic 
expression</TR>
<TR><TD><A HREF="sec-3.35.html#is_absolute_file_name/1">is_absolute_file_name/1</A><TD>True 
if arg defines an absolute path</TR>
<TR><TD><A HREF="sec-3.26.html#is_list/1">is_list/1</A><TD>Type check 
for a list</TR>
<TR><TD><A HREF="sec-3.27.html#is_set/1">is_set/1</A><TD>Type check for 
a set</TR>
<TR><TD><A HREF="sec-3.28.html#keysort/2">keysort/2</A><TD>Sort, using a 
key</TR>
<TR><TD><A HREF="sec-3.26.html#last/2">last/2</A><TD>Last element of a 
list</TR>
<TR><TD><A HREF="sec-3.38.html#leash/1">leash/1</A><TD>Change ports 
visited by the tracer</TR>
<TR><TD><A HREF="sec-3.26.html#length/2">length/2</A><TD>Length of a 
list</TR>
<TR><TD><A HREF="sec-3.2.html#library_directory/1">library_directory/1</A><TD><I>(hook)</I> 
Directories holding Prolog libraries</TR>
<TR><TD><A HREF="sec-3.41.html#limit_stack/2">limit_stack/2</A><TD>Limit 
stack expansion</TR>
<TR><TD><A HREF="sec-3.16.html#line_count/2">line_count/2</A><TD>Line 
number on stream</TR>
<TR><TD><A HREF="sec-3.16.html#line_position/2">line_position/2</A><TD>Character 
position in line on stream</TR>
<TR><TD><A HREF="sec-3.27.html#list_to_set/2">list_to_set/2</A><TD>Remove 
duplicates</TR>
<TR><TD><A HREF="sec-3.3.html#listing/0">listing/0</A><TD>List program 
in current module</TR>
<TR><TD><A HREF="sec-3.3.html#listing/1">listing/1</A><TD>List predicate</TR>
<TR><TD><A HREF="sec-3.2.html#load_files/2">load_files/2</A><TD>Load 
source files with options</TR>
<TR><TD><A HREF="sec-5.4.html#load_foreign/2">load_foreign/2</A><TD>Load 
foreign (C) module</TR>
<TR><TD><B>load_foreign/5</B><TD>Load foreign (C) module</TR>
<TR><TD><A HREF="sec-5.4.html#load_foreign_library/1">load_foreign_library/1</A><TD><CODE>library(shlib)</CODE> 
Load shared library (.so file)</TR>
<TR><TD><A HREF="sec-5.4.html#load_foreign_library/2">load_foreign_library/2</A><TD><CODE>library(shlib)</CODE> 
Load shared library (.so file)</TR>
<TR><TD><A HREF="sec-3.2.html#make/0">make/0</A><TD>Reconsult all 
changed source files</TR>
<TR><TD><B>make_fat_filemap/1</B><TD>Win32: Create file containing 
non-FAT filenames</TR>
<TR><TD><A HREF="sec-2.9.html#make_library_index/1">make_library_index/1</A><TD>Create 
autoload file INDEX.pl</TR>
<TR><TD><A HREF="sec-3.30.html#maplist/3">maplist/3</A><TD>Transform all 
elements of a list</TR>
<TR><TD><A HREF="sec-3.26.html#member/2">member/2</A><TD>Element is 
member of a list</TR>
<TR><TD><A HREF="sec-3.26.html#memberchk/2">memberchk/2</A><TD>Deterministic <A NAME="idx:member/2:676"></A><A HREF="sec-3.26.html#member/2">member/2</A></TR>
<TR><TD><A HREF="sec-3.26.html#merge/3">merge/3</A><TD>Merge two sorted 
lists</TR>
<TR><TD><A HREF="sec-3.27.html#merge_set/3">merge_set/3</A><TD>Merge two 
sorted sets</TR>
<TR><TD><A HREF="sec-3.8.html#message_hook/3">message_hook/3</A><TD>Intercept <A NAME="idx:print_message/2:677"></A><A HREF="sec-3.8.html#print_message/2">print_message/2</A></TR>
<TR><TD><A HREF="sec-4.8.html#meta_predicate/1">meta_predicate/1</A><TD>Quintus 
compatibility</TR>
<TR><TD><A HREF="sec-4.8.html#module/1">module/1</A><TD>Query/set 
current type-in module</TR>
<TR><TD><A HREF="sec-4.8.html#module/2">module/2</A><TD>Declare a module</TR>
<TR><TD><A HREF="sec-4.8.html#module_transparent/1">module_transparent/1</A><TD>Indicate 
module based meta predicate</TR>
<TR><TD><A HREF="sec-3.28.html#msort/2">msort/2</A><TD>Sort, do not 
remove duplicates</TR>
<TR><TD><A HREF="sec-3.13.html#multifile/1">multifile/1</A><TD>Indicate 
distributed definition of predicate</TR>
<TR><TD><A HREF="sec-3.20.html#name/2">name/2</A><TD>Convert between 
atom and list of ASCII characters</TR>
<TR><TD><A HREF="sec-3.17.html#nl/0">nl/0</A><TD>Generate a newline</TR>
<TR><TD><A HREF="sec-3.17.html#nl/1">nl/1</A><TD>Generate a newline on a 
stream</TR>
<TR><TD><A HREF="sec-3.38.html#nodebug/0">nodebug/0</A><TD>Disable 
debugging</TR>
<TR><TD><A HREF="sec-3.4.html#nonvar/1">nonvar/1</A><TD>Type check for 
bound term</TR>
<TR><TD><A HREF="sec-3.37.html#noprotocol/0">noprotocol/0</A><TD>Disable 
logging of user interaction</TR>
<TR><TD><A HREF="sec-3.38.html#nospy/1">nospy/1</A><TD>Remove spy point</TR>
<TR><TD><A HREF="sec-3.38.html#nospyall/0">nospyall/0</A><TD>Remove all 
spy points</TR>
<TR><TD><A HREF="sec-3.7.html#not/1">not/1</A><TD>Negation by failure 
(argument not provable). Same as <A HREF="sec-3.6.html#\+/1">\+/1</A></TR>
<TR><TD><A HREF="sec-3.38.html#notrace/0">notrace/0</A><TD>Stop tracing</TR>
<TR><TD><A HREF="sec-3.38.html#notrace/1">notrace/1</A><TD>Do not debug 
argument goal</TR>
<TR><TD><A HREF="sec-3.26.html#nth0/3">nth0/3</A><TD>N-th element of a 
list (0-based)</TR>
<TR><TD><A HREF="sec-3.26.html#nth1/3">nth1/3</A><TD>N-th element of a 
list (1-based)</TR>
<TR><TD><A HREF="sec-3.14.html#nth_clause/3">nth_clause/3</A><TD>N-th 
clause of a predicate</TR>
<TR><TD><A HREF="sec-3.4.html#number/1">number/1</A><TD>Type check for 
integer or float</TR>
<TR><TD><A HREF="sec-3.20.html#number_chars/2">number_chars/2</A><TD>Convert 
between number and atom</TR>
<TR><TD><A HREF="sec-3.19.html#numbervars/4">numbervars/4</A><TD>Enumerate 
unbound variables of a term using a given base</TR>
<TR><TD><A HREF="sec-3.9.html#on_signal/3">on_signal/3</A><TD>Handle a 
software signal</TR>
<TR><TD><A HREF="sec-3.7.html#once/1">once/1</A><TD>Call a goal 
deterministically</TR>
<TR><TD><A HREF="sec-3.22.html#op/3">op/3</A><TD>Declare an operator</TR>
<TR><TD><A HREF="sec-3.15.html#open/3">open/3</A><TD>Open a file 
(creating a stream)</TR>
<TR><TD><A HREF="sec-3.15.html#open/4">open/4</A><TD>Open a file 
(creating a stream)</TR>
<TR><TD><A HREF="sec-3.42.html#open_dde_conversation/3">open_dde_conversation/3</A><TD>Win32: 
Open DDE channel</TR>
<TR><TD><A HREF="sec-3.15.html#open_null_stream/1">open_null_stream/1</A><TD>Open 
a stream to discard output</TR>
<TR><TD><A HREF="sec-6.3.html#open_resource/3">open_resource/3</A><TD>Open 
a program resource as a stream</TR>
<TR><TD><A HREF="sec-5.3.html#open_shared_object/2">open_shared_object/2</A><TD>UNIX: 
Open shared library (.so file)</TR>
<TR><TD><A HREF="sec-5.3.html#open_shared_object/3">open_shared_object/3</A><TD>UNIX: 
Open shared library (.so file)</TR>
<TR><TD><A HREF="sec-3.17.html#peek_byte/1">peek_byte/1</A><TD>Read 
character without removing</TR>
<TR><TD><A HREF="sec-3.17.html#peek_byte/2">peek_byte/2</A><TD>Read 
character without removing</TR>
<TR><TD><A HREF="sec-3.11.html#phrase/2">phrase/2</A><TD>Activate 
grammar-rule set</TR>
<TR><TD><A HREF="sec-3.11.html#phrase/3">phrase/3</A><TD>Activate 
grammar-rule set (returning rest)</TR>
<TR><TD><A HREF="sec-2.8.html#please/3">please/3</A><TD>Query/change 
environment parameters</TR>
<TR><TD><A HREF="sec-3.23.html#plus/3">plus/3</A><TD>Logical integer 
addition</TR>
<TR><TD><A HREF="sec-3.18.html#portray/1">portray/1</A><TD><I>(hook)</I> 
Modify behaviour of <A NAME="idx:print/1:678"></A><A HREF="sec-3.18.html#print/1">print/1</A></TR>
<TR><TD><A HREF="sec-3.3.html#portray_clause/1">portray_clause/1</A><TD>Pretty 
print a clause</TR>
<TR><TD><A HREF="sec-3.14.html#predicate_property/2">predicate_property/2</A><TD>Query 
predicate attributes</TR>
<TR><TD><A HREF="sec-3.28.html#predsort/3">predsort/3</A><TD>Sort, using 
a predicate to determine the order</TR>
<TR><TD><A HREF="sec-3.2.html#preprocessor/2">preprocessor/2</A><TD>Install 
a preprocessor before the compiler</TR>
<TR><TD><A HREF="sec-3.18.html#print/1">print/1</A><TD>Print a term</TR>
<TR><TD><A HREF="sec-3.18.html#print/2">print/2</A><TD>Print a term on a 
stream</TR>
<TR><TD><A HREF="sec-3.8.html#print_message/2">print_message/2</A><TD>Print 
message from (exception) term</TR>
<TR><TD><A HREF="sec-3.40.html#profile/3">profile/3</A><TD>Obtain 
execution statistics</TR>
<TR><TD><A HREF="sec-3.40.html#profile_count/3">profile_count/3</A><TD>Obtain 
profile results on a predicate</TR>
<TR><TD><A HREF="sec-3.40.html#profiler/2">profiler/2</A><TD>Obtain/change 
status of the profiler</TR>
<TR><TD><A HREF="sec-3.36.html#prolog/0">prolog/0</A><TD>Run interactive 
toplevel</TR>
<TR><TD><A HREF="sec-A.1.html#prolog_current_frame/1">prolog_current_frame/1</A><TD>Reference 
to goal's environment stack</TR>
<TR><TD><A HREF="sec-A.1.html#prolog_frame_attribute/3">prolog_frame_attribute/3</A><TD>Obtain 
information on a goal environment</TR>
<TR><TD><B>prolog_list_goal/1</B><TD>Hook. Intercept tracer 'L' command</TR>
<TR><TD><A HREF="sec-3.2.html#prolog_load_context/2">prolog_load_context/2</A><TD>Context 
information for directives</TR>
<TR><TD><A HREF="sec-A.2.html#prolog_skip_level/2">prolog_skip_level/2</A><TD>Indicate 
deepest recursion to trace</TR>
<TR><TD><A HREF="sec-3.35.html#prolog_to_os_filename/2">prolog_to_os_filename/2</A><TD>Convert 
between Prolog and OS filenames</TR>
<TR><TD><A HREF="sec-A.2.html#prolog_trace_interception/4">prolog_trace_interception/4</A><TD><CODE>library(user)</CODE> 
Intercept the Prolog tracer</TR>
<TR><TD><A HREF="sec-3.18.html#prompt1/1">prompt1/1</A><TD>Change prompt 
for 1 line</TR>
<TR><TD><A HREF="sec-3.18.html#prompt/2">prompt/2</A><TD>Change the 
prompt used by <A NAME="idx:read/1:679"></A><A HREF="sec-3.18.html#read/1">read/1</A></TR>
<TR><TD><A HREF="sec-3.26.html#proper_list/1">proper_list/1</A><TD>Type 
check for list</TR>
<TR><TD><A HREF="sec-3.37.html#protocol/1">protocol/1</A><TD>Make a log 
of the user interaction</TR>
<TR><TD><A HREF="sec-3.37.html#protocola/1">protocola/1</A><TD>Append 
log of the user interaction to file</TR>
<TR><TD><A HREF="sec-3.37.html#protocolling/1">protocolling/1</A><TD>On 
what file is user interaction logged</TR>
<TR><TD><A HREF="sec-3.17.html#put/1">put/1</A><TD>Write a character</TR>
<TR><TD><A HREF="sec-3.17.html#put/2">put/2</A><TD>Write a character on 
a stream</TR>
<TR><TD><A HREF="sec-3.2.html#qcompile/1">qcompile/1</A><TD>Compile 
source to Quick Load File</TR>
<TR><TD><A HREF="sec-3.2.html#qload/1">qload/1</A><TD>Load Quick Load 
File as <A NAME="idx:consult/1:680"></A><A HREF="sec-3.2.html#consult/1">consult/1</A></TR>
<TR><TD><A HREF="sec-6.html#qsave_program/1">qsave_program/1</A><TD>Create 
runtime application</TR>
<TR><TD><A HREF="sec-6.html#qsave_program/2">qsave_program/2</A><TD>Create 
runtime application</TR>
<TR><TD><A HREF="sec-3.18.html#read/1">read/1</A><TD>Read Prolog term</TR>
<TR><TD><A HREF="sec-3.18.html#read/2">read/2</A><TD>Read Prolog term 
from stream</TR>
<TR><TD><A HREF="sec-3.18.html#read_clause/1">read_clause/1</A><TD>Read 
clause</TR>
<TR><TD><A HREF="sec-3.18.html#read_clause/2">read_clause/2</A><TD>Read 
clause from stream</TR>
<TR><TD><A HREF="sec-3.18.html#read_history/6">read_history/6</A><TD>Read 
using history substitution</TR>
<TR><TD><A HREF="sec-3.35.html#read_link/3">read_link/3</A><TD>Read a 
symbolic link</TR>
<TR><TD><A HREF="sec-3.18.html#read_term/2">read_term/2</A><TD>Read term 
with options</TR>
<TR><TD><A HREF="sec-3.18.html#read_term/3">read_term/3</A><TD>Read term 
with options from stream</TR>
<TR><TD><A HREF="sec-3.18.html#read_variables/2">read_variables/2</A><TD>Read 
clause including variable names</TR>
<TR><TD><A HREF="sec-3.18.html#read_variables/3">read_variables/3</A><TD>Read 
clause including variable names from stream</TR>
<TR><TD><A HREF="sec-3.12.html#recorda/2">recorda/2</A><TD>Record term 
in the database (first)</TR>
<TR><TD><A HREF="sec-3.12.html#recorda/3">recorda/3</A><TD>Record term 
in the database (first)</TR>
<TR><TD><A HREF="sec-3.12.html#recorded/2">recorded/2</A><TD>Obtain term 
from the database</TR>
<TR><TD><A HREF="sec-3.12.html#recorded/3">recorded/3</A><TD>Obtain term 
from the database</TR>
<TR><TD><A HREF="sec-3.12.html#recordz/2">recordz/2</A><TD>Record term 
in the database (last)</TR>
<TR><TD><A HREF="sec-3.12.html#recordz/3">recordz/3</A><TD>Record term 
in the database (last)</TR>
<TR><TD><A HREF="sec-3.12.html#redefine_system_predicate/1">redefine_system_predicate/1</A><TD>Abolish 
system definition</TR>
<TR><TD><A HREF="sec-3.35.html#rename_file/2">rename_file/2</A><TD>Change 
name of file</TR>
<TR><TD><A HREF="sec-3.6.html#repeat/0">repeat/0</A><TD>Succeed, leaving 
infinite backtrack points</TR>
<TR><TD><A HREF="sec-3.2.html#require/1">require/1</A><TD>This file 
requires these predicates</TR>
<TR><TD><A HREF="sec-3.40.html#reset_profiler/0">reset_profiler/0</A><TD>Clear 
statistics obtained by the profiler</TR>
<TR><TD><A HREF="sec-6.3.html#resource/3">resource/3</A><TD>Declare a 
program resource</TR>
<TR><TD><B>restore/1</B><TD>Restore saved-state (<A NAME="idx:save/1:681"></A><B>save/1</B>, <A NAME="idx:save_program/1:682"></A><B>save_program/1</B>)</TR>
<TR><TD><A HREF="sec-3.12.html#retract/1">retract/1</A><TD>Remove clause 
from the database</TR>
<TR><TD><A HREF="sec-3.12.html#retractall/1">retractall/1</A><TD>Remove 
unifying clauses from the database</TR>
<TR><TD><A HREF="sec-3.26.html#reverse/2">reverse/2</A><TD>Inverse the 
order of the elements in a list</TR>
<TR><TD><A HREF="sec-3.35.html#same_file/2">same_file/2</A><TD>Succeeds 
if arguments refer to same file</TR>
<TR><TD><A HREF="sec-3.15.html#see/1">see/1</A><TD>Change the current 
input stream</TR>
<TR><TD><A HREF="sec-3.15.html#seeing/1">seeing/1</A><TD>Query the 
current input stream</TR>
<TR><TD><A HREF="sec-3.15.html#seek/4">seek/4</A><TD>Modify the current 
position in a stream</TR>
<TR><TD><A HREF="sec-3.15.html#seen/0">seen/0</A><TD>Close the current 
input stream</TR>
<TR><TD><A HREF="sec-3.26.html#select/3">select/3</A><TD>Select element 
of a list</TR>
<TR><TD><A HREF="sec-2.8.html#set_feature/2">set_feature/2</A><TD>Define 
a system feature</TR>
<TR><TD><A HREF="sec-3.15.html#set_input/1">set_input/1</A><TD>Set 
current input stream from a stream</TR>
<TR><TD><A HREF="sec-3.15.html#set_output/1">set_output/1</A><TD>Set 
current output stream from a stream</TR>
<TR><TD><A HREF="sec-3.33.html#set_tty/2">set_tty/2</A><TD>Set `tty' 
stream</TR>
<TR><TD><A HREF="sec-3.19.html#setarg/3">setarg/3</A><TD>Destructive 
assignment on term</TR>
<TR><TD><A HREF="sec-3.34.html#setenv/2">setenv/2</A><TD>Set shell 
environment variable</TR>
<TR><TD><A HREF="sec-3.29.html#setof/3">setof/3</A><TD>Find all unique 
solutions to a goal</TR>
<TR><TD><A HREF="sec-3.32.html#sformat/2">sformat/2</A><TD>Format on a 
string</TR>
<TR><TD><A HREF="sec-3.32.html#sformat/3">sformat/3</A><TD>Format on a 
string</TR>
<TR><TD><A HREF="sec-3.34.html#shell/0">shell/0</A><TD>Execute 
interactive subshell</TR>
<TR><TD><A HREF="sec-3.34.html#shell/1">shell/1</A><TD>Execute OS 
command</TR>
<TR><TD><A HREF="sec-3.34.html#shell/2">shell/2</A><TD>Execute OS 
command</TR>
<TR><TD><A HREF="sec-3.40.html#show_profile/1">show_profile/1</A><TD>Show 
results of the profiler</TR>
<TR><TD><A HREF="sec-3.35.html#size_file/2">size_file/2</A><TD>Get size 
of a file in characters</TR>
<TR><TD><A HREF="sec-3.17.html#skip/1">skip/1</A><TD>Skip to character 
in current input</TR>
<TR><TD><A HREF="sec-3.17.html#skip/2">skip/2</A><TD>Skip to character 
on stream</TR>
<TR><TD><A HREF="sec-A.4.html#rl_add_history/1">rl_add_history/1</A><TD>Add 
line to readline(3) history</TR>
<TR><TD><A HREF="sec-A.4.html#rl_read_init_file/1">rl_read_init_file/1</A><TD>Read 
readline(3) init file</TR>
<TR><TD><A HREF="sec-3.43.html#sleep/1">sleep/1</A><TD>Suspend execution 
for specified time</TR>
<TR><TD><A HREF="sec-3.28.html#sort/2">sort/2</A><TD>Sort elements in a 
list</TR>
<TR><TD><A HREF="sec-3.2.html#source_file/1">source_file/1</A><TD>Examine 
currently loaded source files</TR>
<TR><TD><A HREF="sec-3.2.html#source_file/2">source_file/2</A><TD>Obtain 
source file of predicate</TR>
<TR><TD><A HREF="sec-3.2.html#source_location/2">source_location/2</A><TD>Location 
of last read term</TR>
<TR><TD><A HREF="sec-3.38.html#spy/1">spy/1</A><TD>Force tracer on 
specified predicate</TR>
<TR><TD><A HREF="sec-3.41.html#stack_parameter/4">stack_parameter/4</A><TD>Some 
systems: Query/Set runtime stack parameter</TR>
<TR><TD><A HREF="sec-3.39.html#statistics/0">statistics/0</A><TD>Show 
execution statistics</TR>
<TR><TD><A HREF="sec-3.39.html#statistics/2">statistics/2</A><TD>Obtain 
collected statistics</TR>
<TR><TD><A HREF="sec-3.15.html#stream_position/3">stream_position/3</A><TD>Get/seek 
to position in file</TR>
<TR><TD><A HREF="sec-3.4.html#string/1">string/1</A><TD>Type check for 
string</TR>
<TR><TD><A HREF="sec-3.21.html#string_concat/3">string_concat/3</A><TD><A NAME="idx:concat/3:683"></A><A HREF="sec-3.20.html#concat/3">concat/3</A> 
for strings (non-deterministic)</TR>
<TR><TD><A HREF="sec-3.21.html#string_length/2">string_length/2</A><TD>Determine 
length of a string</TR>
<TR><TD><A HREF="sec-3.21.html#string_to_atom/2">string_to_atom/2</A><TD>Conversion 
between string and atom</TR>
<TR><TD><A HREF="sec-3.21.html#string_to_list/2">string_to_list/2</A><TD>Conversion 
between string and list of ASCII</TR>
<TR><TD><A HREF="sec-3.38.html#style_check/1">style_check/1</A><TD>Change 
level of warnings</TR>
<TR><TD><A HREF="sec-3.30.html#sublist/3">sublist/3</A><TD>Determine 
elements that meet condition</TR>
<TR><TD><A HREF="sec-3.27.html#subset/2">subset/2</A><TD>Generate/check 
subset relation</TR>
<TR><TD><A HREF="sec-3.21.html#substring/4">substring/4</A><TD>Get part 
of a string</TR>
<TR><TD><A HREF="sec-3.27.html#subtract/3">subtract/3</A><TD>Delete 
elements that do not meet condition</TR>
<TR><TD><A HREF="sec-3.23.html#succ/2">succ/2</A><TD>Logical integer 
successor relation</TR>
<TR><TD><A HREF="sec-3.32.html#swritef/2">swritef/2</A><TD>Formatted 
write on a string</TR>
<TR><TD><A HREF="sec-3.32.html#swritef/3">swritef/3</A><TD>Formatted 
write on a string</TR>
<TR><TD><A HREF="sec-3.17.html#tab/1">tab/1</A><TD>Output number of 
spaces</TR>
<TR><TD><A HREF="sec-3.17.html#tab/2">tab/2</A><TD>Output number of 
spaces on a stream</TR>
<TR><TD><A HREF="sec-3.15.html#tell/1">tell/1</A><TD>Change current 
output stream</TR>
<TR><TD><A HREF="sec-3.15.html#telling/1">telling/1</A><TD>Query current 
output stream</TR>
<TR><TD><A HREF="sec-3.2.html#term_expansion/2">term_expansion/2</A><TD><I>(hook)</I> 
Convert term before compilation</TR>
<TR><TD><A HREF="sec-3.20.html#term_to_atom/2">term_to_atom/2</A><TD>Convert 
between term and atom</TR>
<TR><TD><A HREF="sec-3.8.html#throw/1">throw/1</A><TD>Raise an exception 
(see <A NAME="idx:catch/3:684"></A><A HREF="sec-3.8.html#catch/3">catch/3</A>)</TR>
<TR><TD><A HREF="sec-3.39.html#time/1">time/1</A><TD>Determine time 
needed to execute goal</TR>
<TR><TD><A HREF="sec-3.35.html#time_file/2">time_file/2</A><TD>Get last 
modification time of file</TR>
<TR><TD><A HREF="sec-3.35.html#tmp_file/2">tmp_file/2</A><TD>Create a 
temporary filename</TR>
<TR><TD><A HREF="sec-3.15.html#told/0">told/0</A><TD>Close current 
output</TR>
<TR><TD><A HREF="sec-3.38.html#trace/0">trace/0</A><TD>Start the tracer</TR>
<TR><TD><A HREF="sec-3.38.html#trace/1">trace/1</A><TD>Set trace-point 
on predicate</TR>
<TR><TD><A HREF="sec-3.38.html#trace/2">trace/2</A><TD>Set/Clear 
trace-point on ports</TR>
<TR><TD><A HREF="sec-3.38.html#tracing/0">tracing/0</A><TD>Query status 
of the tracer</TR>
<TR><TD><A HREF="sec-3.41.html#trim_stacks/0">trim_stacks/0</A><TD>Release 
unused memory resources</TR>
<TR><TD><A HREF="sec-3.6.html#true/0">true/0</A><TD>Succeed</TR>
<TR><TD><A HREF="sec-3.33.html#tty_get_capability/3">tty_get_capability/3</A><TD>Get 
terminal parameter</TR>
<TR><TD><A HREF="sec-3.33.html#tty_goto/2">tty_goto/2</A><TD>Goto 
position on screen</TR>
<TR><TD><A HREF="sec-3.33.html#tty_put/2">tty_put/2</A><TD>Write control 
string to terminal</TR>
<TR><TD><A HREF="sec-3.17.html#ttyflush/0">ttyflush/0</A><TD>Flush 
output on terminal</TR>
<TR><TD><A HREF="sec-3.27.html#union/3">union/3</A><TD>Union of two sets</TR>
<TR><TD><A HREF="sec-3.38.html#unknown/2">unknown/2</A><TD>Trap 
undefined predicates</TR>
<TR><TD><A HREF="sec-5.4.html#unload_foreign_library/1">unload_foreign_library/1</A><TD><CODE>library(shlib)</CODE> 
Detach shared library (.so file)</TR>
<TR><TD><A HREF="sec-3.34.html#unsetenv/1">unsetenv/1</A><TD>Delete 
shell environment variable</TR>
<TR><TD><A HREF="sec-4.4.html#use_module/1">use_module/1</A><TD>Import a 
module</TR>
<TR><TD><A HREF="sec-4.4.html#use_module/2">use_module/2</A><TD>Import 
predicates from a module</TR>
<TR><TD><A HREF="sec-3.4.html#var/1">var/1</A><TD>Type check for unbound 
variable</TR>
<TR><TD><A HREF="sec-3.38.html#visible/1">visible/1</A><TD>Ports that 
are visible in the tracer</TR>
<TR><TD><A HREF="sec-6.html#volatile/1">volatile/1</A><TD>Predicates 
that are not saved</TR>
<TR><TD><A HREF="sec-3.16.html#wait_for_input/3">wait_for_input/3</A><TD>Wait 
for input with optional timeout</TR>
<TR><TD><A HREF="sec-3.43.html#wildcard_match/2">wildcard_match/2</A><TD>Csh(1) 
style wildcard match</TR>
<TR><TD><A HREF="sec-3.34.html#win_exec/2">win_exec/2</A><TD>Win32: 
spawn Windows task</TR>
<TR><TD><A HREF="sec-3.18.html#write/1">write/1</A><TD>Write term</TR>
<TR><TD><A HREF="sec-3.18.html#write/2">write/2</A><TD>Write term to 
stream</TR>
<TR><TD><A HREF="sec-3.32.html#write_ln/1">write_ln/1</A><TD>Write term, 
followed by a newline</TR>
<TR><TD><A HREF="sec-3.18.html#write_canonical/1">write_canonical/1</A><TD>Write 
a term with quotes, ignore operators</TR>
<TR><TD><A HREF="sec-3.18.html#write_canonical/2">write_canonical/2</A><TD>Write 
a term with quotes, ignore operators on a stream</TR>
<TR><TD><A HREF="sec-3.18.html#write_term/2">write_term/2</A><TD>Write 
term with options</TR>
<TR><TD><A HREF="sec-3.18.html#write_term/3">write_term/3</A><TD>Write 
term with options to stream</TR>
<TR><TD><A HREF="sec-3.32.html#writef/1">writef/1</A><TD>Formatted write</TR>
<TR><TD><A HREF="sec-3.32.html#writef/2">writef/2</A><TD>Formatted write 
on stream</TR>
<TR><TD><A HREF="sec-3.18.html#writeq/1">writeq/1</A><TD>Write term, 
insert quotes</TR>
<TR><TD><A HREF="sec-3.18.html#writeq/2">writeq/2</A><TD>Write term, 
insert quotes on stream</TR>
</TABLE>

