%
% CWI Table of Contents style
%
% File		: cwicontents.sty
% Version	: 1.4
% Modified	: 3/7/95 11:14:03
% Author	: Jan van der Steen (jansteen@cwi.nl)
%

\def\tableofcontents{%
    \@restonecolfalse
    \if@twocolumn
	\@restonecoltrue
	\onecolumn
    \fi
    \chapter*{Table of Contents}
    \@starttoc{toc}%
    \if@restonecol\twocolumn\fi
}

%
% The macros actually displaying the contents entries
%
\def\l@part#1#2{%
    \addpenalty{-\@highpenalty}
    \addvspace{2.25em plus 1pt}
    \begingroup
	\@tempdima 3em
	\parindent \z@
	\rightskip \@pnumwidth
	\parfillskip -\@pnumwidth 
	{\large \bf \leavevmode #1\hfil \hbox to\@pnumwidth{\hss #2}}\par
	\nobreak \global\@nobreaktrue
	\everypar{%
	    \global\@nobreakfalse\everypar{}%
	}
    \endgroup
}

\def\l@chapter#1#2{%
    \addpenalty{-\@highpenalty} 
    \vskip 1.0em plus 1pt
    \@tempdima 1.5em
    \begingroup
	\parindent \z@
	\rightskip \@pnumwidth 
	\parfillskip -\@pnumwidth 
	\bf \leavevmode
	\advance\leftskip\@tempdima
	\hskip -\leftskip #1\nobreak\hfil
	\nobreak\hbox to\@pnumwidth{\hss #2}\par
	\penalty\@highpenalty
    \endgroup
}

\def\l@section		{\@dottedtocline{1}{1.5em}{2.3em}}
\def\l@subsection	{\@dottedtocline{2}{3.8em}{3.2em}}
\def\l@subsubsection	{\@dottedtocline{3}{7.0em}{4.1em}}
\def\l@paragraph	{\@dottedtocline{4}{10em}{5em}}
\def\l@subparagraph	{\@dottedtocline{5}{12em}{6em}}

\def\listoffigures{%
    \@restonecolfalse
    \if@twocolumn
	\@restonecoltrue\onecolumn
    \fi
    \chapter*{List of Figures\@mkboth {LIST OF FIGURES}{LIST OF FIGURES}}%
    \@starttoc{lof}%
    \if@restonecol\twocolumn\fi
}

\def\l@figure		{\@dottedtocline{1}{1.5em}{2.3em}}
\def\listoftables{%
    \@restonecolfalse\if@twocolumn\@restonecoltrue\onecolumn\fi
    \chapter*{List of Tables\@mkboth {LIST OF TABLES}{LIST OF TABLES}}%
    \@starttoc{lot}\if@restonecol\twocolumn\fi
}
\let\l@table\l@figure

%
% \@dottedtocline{LEVEL}{INDENT}{NUMWIDTH}{TITLE}{PAGE}
%
\def\@dottedtocline#1#2#3#4#5{%
    \ifnum #1>\c@tocdepth
    \else
	\vskip \z@ plus .2pt
	{%
	    \def\@dotsep{2.5}
	    \leftskip #2\relax
	    \rightskip \@tocrmarg
	    \parfillskip -\rightskip
	    \parindent #2\relax
	    \@afterindenttrue
	    \interlinepenalty\@M
	    \leavevmode 
	    \@tempdima #3\relax
	    \advance\leftskip \@tempdima
	    \hbox{}\hskip -\leftskip
	    #4\nobreak\leaders\hbox{%
		$\m@th \mkern \@dotsep mu.\mkern \@dotsep mu$%
	    }%
	    \hfill \nobreak \hbox to\@pnumwidth{\hfil\rm #5}\par
	}%
    \fi
}

