%
% CWI Math handling
%
% File		: cwimath.sty
% Version	: 1.1
% Modified	: 2/3/93 10:02:34
% Author	: Jan van der Steen (jansteen@cwi.nl)
% Based on	: Peter de Waal/Rob van der Horst
%
% 1. We always want equations to be left adjusted (by \mathindent)
% 2. We want the section number in the equation number
% 3. We want subequations
%

%
% Original definition from article.sty
% 1. Include the section number in the equation number.
%
\iffalse
    \def\theequation{\arabic{equation}}
\else
    \def\theequation{\thesection.\arabic{equation}}
\fi

%
% Taken from fleqn.sty --- jansteen@cwi.nl
%
\newdimen\mathindent\mathindent 30pt
\def\[{%
    \relax\ifmmode\@badmath\else\begin{trivlist}\item[]\leavevmode
    \hbox to\linewidth\bgroup$ \displaystyle
    \hskip\mathindent\bgroup\fi
}
\def\]{%
    \relax\ifmmode \egroup $\hfil \egroup \end{trivlist}\else \@badmath \fi
}
\def\equation{%
    \refstepcounter{equation}\trivlist \item[]\leavevmode
    \hbox to\linewidth\bgroup $ \displaystyle
    \hskip\mathindent
}
\def\endequation{%
    $\hfil \displaywidth\linewidth\@eqnnum\egroup \endtrivlist
}
\def\eqnarray{%
    \stepcounter{equation}\let\@currentlabel=\theequation
    \global\@eqnswtrue
    \global\@eqcnt\z@\tabskip\mathindent\let\\=\@eqncr
    %
    % Adjusted code --- jansteen@cwi.nl
    %
    \iffalse
	\abovedisplayskip\topsep\ifvmode\advance\abovedisplayskip\partopsep\fi
	\belowdisplayskip\abovedisplayskip
	\belowdisplayshortskip\abovedisplayskip
	\abovedisplayshortskip\abovedisplayskip
    \else
	\ifvmode\nointerlineskip\fi
    \fi
    $$\halign to\linewidth
    \bgroup
    \@eqnsel\hskip\@centering$\displaystyle\tabskip\z@
    {##}$&\global\@eqcnt\@ne \hskip 2\arraycolsep \hfil${##}$\hfil
    &\global\@eqcnt\tw@ \hskip 2\arraycolsep $\displaystyle{##}$\hfil 
    \tabskip\@centering&\llap{##}\tabskip\z@\cr
}
\def\endeqnarray{%
    \@@eqncr
    \egroup
    \global\advance\c@equation\m@ne$$\global\@ignoretrue
}

%
% Original definition taken from subeqn.sty
%
\newtoks\@stequation
\def\subequations{%
    \refstepcounter{equation}%
    \edef\@savedequation{\the\c@equation}%
    \@stequation=\expandafter{\theequation}%	%only want \theequation
    \edef\@savedtheequation{\the\@stequation}%	%expanded once
    \edef\oldtheequation{\theequation}%
    \setcounter{equation}{0}%
    \def\theequation{\oldtheequation\alph{equation}}%
}
\def\endsubequations{%
    \setcounter{equation}{\@savedequation}%
    \@stequation=\expandafter{\@savedtheequation}%
    \edef\theequation{\the\@stequation}%
    \global\@ignoretrue
}
