%	  @(#) cwiquarterly.sty  version:1.7  dated:95/11/02
%	  SCCS file:	SCCS/s.cwiquarterly.sty
%	  SCCS id :	cwiquarterly.sty 1.7
%	  Last edited:	02 Nov 1995 16:08:48
%
% CWI Quarterly style file
% Author	: Jan of der Steen (jansteen@cwi.nl)
% Contributor	: Miente Bakker (miente@cwi.nl)
% Based on	: Peter de Waal/Rob of der Horst
%
% CWI report style, adapted from LaTeX article style 
% Peter de Waal, lastmodification date: 1990:04:18

\input article.sty
%\input art1\@ptsize.sty
%\renewcommand{\markboth}[2]{
%	{\sf \thepage \hfil{\ssqs #1}}
%	{{\ssqs #2} \hfil \sf \thepage}
%}
\def\ps@myheadings{\let\@mkboth\@gobbletwo
\def\@oddhead{\hbox{}\ssqs\rightmark \hfil
\sf\thepage}\def\@oddfoot{}\def\@evenhead{\sf \thepage\hfil\ssqs\leftmark\hbox
{}}\def\@evenfoot{}\def\chaptermark##1{}\def\sectionmark##1{}%
\def\subsectionmark##1{}}

% added following preloaded fonts
%--begin  cwifonts.sty--------------------------------------------
% add preloaded fonts: small point sizes of \sf family and define the
% \sfi family (sans serif italics
\font\sevsf  = cmss10  \@ptscale7 % sans serif
\font\sevsfi = cmssi10 \@ptscale7 % italic sans serif
\font\egtsf  = cmss8    % sans serif
\font\egtsfi = cmssi8   % italic sans serif
\font\ninsfi = cmssi9   % italic sans serif
\font\tensfi = cmssi10  % italic sans serif
\font\elvsfi = cmssi10  \@halfmag % italic sans serif
\font\twlsfi = cmssi10  \@magscale1 % italic sans serif
%\font\frtnsf  = cmss10   \@magscale2 % sans serif
%\font\frtnsfi = cmssi10  \@magscale2 % italic sans serif
\font\frtnsf  = cmss12   \@magscale1 % sans serif
\font\frtnsfi = cmssi12 \@magscale1 % italic sans serif
\newfont{\ssqs}{cmssqi8 scaled 900}
% Added by LM:
\font\tensf    = cmss10			% sans serif

% The following part is suspicious, if it is used, keywords like
% \large and \Large no longer work

\def\sfi{\protect\psfi}

\newfam\sfifam		% \sfi is fam 11 ? (see lfonts.tex)

% save original defs of \vpt, \vipt, \viipt, etc.

\let\vpt@=\vpt
\let\vipt@=\vipt
\let\viipt@=\viipt
\let\viiipt@=\viiipt
\let\ixpt@=\ixpt
\let\xpt@=\xpt
\let\xipt@=\xipt
\let\xiipt@=\xiipt
\let\xivpt@=\xivpt
\let\xviipt@=\xviipt
\let\xxpt@=\xxpt
\let\xxvpt@=\xxvpt

\def\vpt{\vpt@
\def\psf{\@subfont\sf\rm}%
\def\psfi{\@subfont\sfi\rm}%
}

\def\@vpt{}

\def\vipt{\vipt@
\def\psf{\@subfont\sf\rm}%
\def\psfi{\@subfont\sfi\rm}%
}

\def\@vipt{}

\def\viipt{\viipt@
\def\psf{\@getfont\psf\sffam\@viipt{cmss10\@ptscale7}}%
\def\psfi{\@getfont\psfi\sfifam\@viipt{cmssi10\@ptscale7}}%
}

\def\@viipt{}

\def\viiipt{\viiipt@
\def\psf{\@getfont\psf\sffam\@viiipt{cmss8}}%
\def\psfi{\@getfont\psfi\sfifam\@viiiipt{cmssi8}}%
}

\def\@viiipt{}

\def\ixpt{\ixpt@
\def\psf{\@getfont\psf\sffam\@ixpt{cmss9}}%
\def\psfi{\@getfont\psfi\sfifam\@ixpt{cmssi9}}%
}

\def\@ixpt{}

\def\xpt{\xpt@
\def\psf{\fam\sffam\tensf}\textfont\sffam\tensf
    \scriptfont\sffam\tensf \scriptscriptfont\sffam\tensf
\def\psfi{\fam\sfifam\tensfi}\textfont\sfifam\tensfi
    \scriptfont\sfifam\tensfi \scriptscriptfont\sfifam\tensfi
}

\def\@xpt{}

\def\xipt{\xipt@
\def\psf{\fam\sffam\elvsf}\textfont\sffam\elvsf
    \scriptfont\sffam\tensf \scriptscriptfont\sffam\tensf
\def\psfi{\fam\sfifam\elvsfi}\textfont\sfifam\elvsfi
    \scriptfont\sfifam\tensfi \scriptscriptfont\sfifam\tensfi
}

\def\@xipt{}

\def\xiipt{\xiipt@
\def\psf{\fam\sffam\twlsf}\textfont\sffam\twlsf
    \scriptfont\sffam\tensf \scriptscriptfont\sffam\tensf
\def\psfi{\fam\sfifam\twlsfi}\textfont\sfifam\twlsfi
    \scriptfont\sfifam\tensfi \scriptscriptfont\sfifam\tensfi
}

\def\@xiipt{}

\def\xivpt{\xivpt@
\def\psf{\@getfont\psf\sffam\@xivpt{\@mss\@magscale2}}%
\def\psfi{\@getfont\psfi\sfifam\@xivpt{cmssi12\@magscale1}}%
}

\def\@xivpt{}

% SPECIAL LaTeX character definitions

% Definitions of math operators added by LaTeX
\mathchardef\mho"0A30
\mathchardef\Join"3A31
\mathchardef\Box"0A32
\mathchardef\Diamond"0A33
\mathchardef\leadsto"3A3B
\mathchardef\sqsubset"3A3C
\mathchardef\sqsupset"3A3D
\def\lhd{\mathbin{< \hbox to -.43em{}\hbox{\vrule 
      \@width .065em \@height .55em \@depth .05em}\hbox to .2em{}}}
\def\rhd{\mathbin{\hbox to .3em{}\hbox{\vrule \@width .065em \@height 
       .55em \@depth .05em}\hbox to -.43em{}>}}
\def\unlhd{\mathbin{\leq \hbox to -.43em{}\hbox
        {\vrule \@width .065em \@height .63em \@depth -.08em}\hbox to .2em{}}}
\def\unrhd{\mathbin{ \hbox to .3em{}\hbox
 {\vrule \@width .065em \@height .63em \@depth -.08em}\hbox to -.43em{}\geq}}

% Definition of \$ to work in italic font (since it produces a pound sterling
% sign in the cmit font.

\def\${\protect\pdollar}
\def\pdollar{{\ifdim \fontdimen\@ne\font >\z@ \sl \fi\char`\$}}

% Definition of pound sterling sign.
% Modified 10 Apr 89 to work in math mode.

\def\pounds{\protect\ppounds}
\def\ppounds{\relax\ifmmode\mathchar"424\else{\it \char'44}\fi}


% Definition of \copyright changed so it works in other type styles,
% and so it is robust
\def\copyright{\protect\pcopyright}
\def\pcopyright{{\rm\ooalign{\hfil
     \raise.07ex\hbox{c}\hfil\crcr\mathhexbox20D}}}
%------------- end cwifonts.sty--------------------------------------

\def\cwiaddress{{\egtsfi Centre for Mathematics and Computer Science}\\
{\egtsfi P.O.Box 4079, 1009 AB Amsterdam, The Netherlands}}

% PRdW 1991:07:12
% adjusted the section subsection and subsubsection counters
% (temporarily removed again)
%% \def\thesection{\arabic{section}.}
%% \def\thesubsection{\thesection\arabic{subsection}.}
%% \def\thesubsubsection{\thesubsection\arabic{subsubsection}}

% \input jeep.sty		% for \symbolnote
%---- begin of  cwiq.sty
% redefine title page settings

\def\titlepage{\@restonecolfalse\if@twocolumn\@restonecoltrue\onecolumn
     \else \newpage \fi \thispagestyle{empty}\c@page\z@}

\def\endtitlepage{\if@restonecol\twocolumn \else \newpage \fi}
%
% trying to hack \author and \thanks to get correct CWI fonts
% \thanks should save everyting in a box split by authors (in correct
% font) and addresses (with a different font)
% 
%\newbox\tmpauthorbox
%\newbox\authorbox
%\setbox\tmpauthorbox\hbox{} % initialize
%\setbox\authorbox\hbox{\par}
%\renewcommand{\author}[1]{
%	\setbox\tmpauthorbox=\hbox{\authorbox}
%	\setbox\authorbox=\hbox{\unhbox\authorbox {\tensf #1\\}}}
% 
%\def\thanks#1{{\egtsfi #1}}
% \def\thanks#1{\gdef\@author{\@author \\
% {\tensfi #1}}}
% 
% \def\@thanks{}
% 
% \def\and{\gdef\@author{\@author \\[1.0ex]}}
% 

% redefine caption definition: put '.' in between title and text of
% caption in stead of ':'

\long\def\@makecaption#1#2{
   \vskip 10pt 
   \setbox\@tempboxa\hbox{#1. #2}
   \ifdim \wd\@tempboxa >\hsize   % IF longer than one line:
       #1. #2\par                 %   THEN set as ordinary paragraph.
     \else                        %   ELSE  center.
       \hbox to\hsize{\hfil\box\@tempboxa\hfil}  
   \fi}

\def\fnum@figure{{\sc Figure \thefigure}}  %'Figure' set in SmallCaps
\def\fnum@table{{\sc Table \thetable}}

% redefine title page to get the correct fonts and sizes, includes
% redefinition of abstract environment.
%%% \def\maketitle{\par
%%%  \begingroup
%%%    \def\thefootnote{\fnsymbol{footnote}}
%%%    \def\@makefnmark{\hbox   
%%%        to 0pt{$^{\@thefnmark}$\hss}}   
%%%    \if@twocolumn               
%%%      \twocolumn[\@maketitle]   
%%%      \else \newpage
%%%      \global\@topnum\z@        % Prevents figures from going at top of page.
%%% %     \@maketitle \fi\thispagestyle{titlepagestyle}\@thanks
%%%      \@maketitle \fi\thispagestyle{plain}\@thanks
%%%  \endgroup
%%%  \setcounter{footnote}{0}
%%%  \let\maketitle\relax
%%%  \let\@maketitle\relax
%%%  \gdef\@thanks{}\gdef\@author{}\gdef\@title{}\let\thanks\relax}
%%% 
%%% \def\@maketitle{\newpage
%%%  \null
%%%  \vskip 2em                 % Vertical space above title.
%%%  \begin{center}
%%%   {\baselineskip20pt\frtnsf \@title \par}     
%%%     % PRdW: Title set in 14pt Sans Serif size. 
%%%     % changed 1990:07:03: vertical spacing adjusted 20pt
%%%   \vskip 1.5em                % Vertical space after title.
%%%  {\tensf		%PRdW: author's name in 10pt. Sans Serif in a
%%%    \lineskip .5em       % tabular environment
%%% %   \begin{tabular}[t]{c}\@author 
%%%    \begin{tabular}[t]{c}\box\authorbox
%%%    \end{tabular}\par}                   
%%%   \vskip 1em            % Vertical space after author.
%%% %  {\large \@date}      % Date set in \large size.
%%% % PRdW: no date on title page
%%%  \end{center}
%%%  \par
%%%  \vskip 1.5em}                % Vertical space after date.

\def\title#1{{\null % fix point at top of page
	\vskip 2em
	\begin{center}
	\baselineskip20pt\frtnsf #1
	\end{center}}}
\def\author#1{{\sf
	\begin{center}
	{#1}
	\end{center}}}
\def\thanks#1{\\
	{\egtsfi #1}}
\def\and{\\[1.0em]}
\def\maketitle{\vskip2.0em}

% In these new definitions everything is written directly. Nothing is
% saved in boxes for later use. This means
% that the \title, \author, \thanks and \and macros should come after
% the \begin{document}!

\def\abstract{\if@twocolumn
\section*{Abstract}\small\sf
\else \noindent\small\sf		% abstract in 8pt sans serif
\begin{center}
\small\sf
\noindent
\end{center}
\quote
\fi}

\def\endabstract{\if@twocolumn\else\endquote\vskip 2.6em\fi}

% redefine page style, get correct fonts

%PRdW: redefinition of pagestyle 'plain'
%      prints pagenumber in topcorner in \sf font
%\renewcommand\ps@plain{\let\@mkboth\@gobbletwo
%     \def\@oddhead{\hbox{} \hfil \sf\thepage}\def\@oddfoot{}\def\@evenfoot{}
%     \def\@evenhead{\sf\thepage \hfil \hbox{}}}% \let\@evenfoot\@oddfoot}


% PRdW: definition of titlepagestyle
% Mainly used to make the right foottext for the reportnumber
% this style is called in maketitlepage
%
% First is needed the definition of the command 'reportnumber'
% that sets the variable '@reportnumber' to the correct string
% 

% bibliography, changed from article style:
% items are put closer together
%% \def\thebibliography#1{\section*{References\@mkboth
%%   {REFERENCES}{REFERENCES}}\list
%%   { {\arabic{enumi}.} }{\settowidth\labelwidth{[#1]}\leftmargin\labelwidth
%%     \advance\leftmargin\labelsep
%%     \usecounter{enumi}}
%%     \itemsep=0pt\parskip=0pt\parsep=0pt
%%     \def\newblock{\hskip .11em plus .33em minus .07em}
%%     \sloppy\clubpenalty4000\widowpenalty4000
%%    \sfcode`\.=1000\relax}
\def\thebibliography#1{\section*{References\@mkboth
  {REFERENCES}{REFERENCES}}\list
  { {\arabic{enumi}.}}{\settowidth\labelwidth{[#1]}
	\settowidth\leftmargin{[#1]}
	\usecounter{enumi}}
%  {\settowidth\labelwidth{[#1]}\leftmargin\labelwidth
%    \advance\leftmargin\labelsep
%    \usecounter{enumi}}
% this is really a kludge, should be done better
    \itemsep=0pt\parskip=0pt\parsep=0pt
    \def\newblock{\hskip .11em plus .33em minus .07em}
    \sloppy\clubpenalty4000\widowpenalty4000
    \sfcode`\.=1000\relax}

\let\endthebibliography=\endlist

%\def\@biblabel#1{[#1]\hfill}%
% this definition does not seem to work

%PRdW: New additions to numbering styles

\def\sfarabic#1{\sf\@arabic{\@nameuse{c@#1}}}

%PRdW: set correct pagestyle
\pagestyle{plain}
%---- end of  cwiq.sty
%---- begin    cwiq10.sty
% redefine various page settings

% last change : 1992:08:27
% log: 1992:08:27 changed textheight

\topmargin 0pt	%PRdW
\headsep 0.6cm	%PRdW
\def\vec#1{\mathchoice{\mbox{\boldmath$\displaystyle\bf#1$}}
{\mbox{\boldmath$\textstyle\bf#1$}}
{\mbox{\boldmath$\scriptstyle\bf#1$}}
{\mbox{\boldmath$\scriptscriptstyle\bf#1$}}}
 
\def\@sect#1#2#3#4#5#6[#7]#8{\ifnum #2>\c@secnumdepth
  \def\@svsec{}\else
  \refstepcounter{#1}\edef\@svsec{\csname the#1\endcsname .\enspace }\fi
  \@tempskipa #5\relax
   \ifdim \@tempskipa>\z@
  \begingroup #6\relax
  \noindent{\hskip #3\relax\@svsec}{\interlinepenalty \@M #8\par}
  \endgroup
    \csname #1mark\endcsname{#7}\addcontentsline
   {toc}{#1}{\ifnum #2>\c@secnumdepth \else
            \protect\numberline{\csname the#1\endcsname}\fi
          #7}\else
  \def\@svsechd{#6\hskip #3\@svsec #8\csname #1mark\endcsname
            {#7}\addcontentsline
             {toc}{#1}{\ifnum #2>\c@secnumdepth \else
               \protect\numberline{\csname the#1\endcsname}\fi
             #7}}\fi
  \@xsect{#5}}
 
\def\part{\par \addvspace{4ex} \@afterindentfalse \secdef\@part\@spart}
 
\def\@part[#1]#2{\ifnum \c@secnumdepth >\m@ne \refstepcounter{part}
\addcontentsline{toc}{part}{\thepart \hspace{1em}#1}\else
\addcontentsline{toc}{part}{#1}\fi { \parindent 0pt \raggedright
 \ifnum \c@secnumdepth >\m@ne \Large \bf
 Part\thepart\par\nobreak\fi\huge
\bf #2\markboth{}{}\par } \nobreak \vskip 3ex \@afterheading }
 
\def\@spart#1{{\parindent 0pt \raggedright
 \huge \bf
 #1\par} \nobreak \vskip 3ex \@afterheading }
 
\def\section{\@startsection {section}{1}{\z@}{-18pt plus -4pt minus
-4pt}{1pt plus -.22em minus -0.1em}{\normalsize\sc
\pretolerance=10000\relax\rightskip=0pt plus8em}}
\def\subsection{\@startsection{subsection}{2}{\z@}{-18pt plus-4pt minus
 -4pt}{1pt plus -.22em minus -0.1em}{\normalsize\it
\pretolerance=10000\relax\rightskip=0pt plus8em}}
\def\subsubsection{\@startsection{subsubsection}{3}{\z@}{-18pt plus-4pt
 minus -4pt}{-0.5em plus -.22em minus -0.1em}{\normalsize\it
 \pretolerance=10000\relax\rightskip=0pt plus8em}}
\def\paragraph{\@startsection{paragraph}{4}{\z@}{-12pt plus -4pt minus
 -4pt}{-0.5em plus -.22em minus -0.1em}{\normalsize\it}}
\def\subparagraph#1{\typeout{Warning: You should not use
\protect\subparagraph \space in this style.}\vskip0.5cm
You should not use $\backslash${\tt subparagraph} in this
style.\vskip0.5cm}
 
\def\header{\@startsection{paragraph}{4}{\z@}{-12pt plus -4pt minus
 -4pt}{-0.5em plus -.22em minus -0.1em}{\normalsize\it}}

\setcounter{secnumdepth}{2}
 
\def\appendix{\par
 \setcounter{section}{0}
 \setcounter{subsection}{0}
 \def\thesection{\Alph{section}}}
 
\leftmargini 17pt     \leftmarginii 17pt
\leftmarginiii 17pt   \leftmarginiv 17pt
\leftmarginv 10pt       \leftmarginvi 10pt
\leftmargin\leftmargini \labelwidth\leftmargini
\advance\labelwidth-\labelsep
\labelsep 5pt
\parsep 0pt plus 1pt
\def\@listi{\leftmargin\leftmargini}
\def\@listii{\leftmargin\leftmarginii
 \labelwidth\leftmarginii\advance\labelwidth-\labelsep
 \topsep 0pt plus 1pt}
\def\@listiii{\leftmargin\leftmarginiii
 \labelwidth\leftmarginiii\advance\labelwidth-\labelsep
 \topsep 0pt plus 1pt}
\def\@listiv{\leftmargin\leftmarginiv
 \labelwidth\leftmarginiv\advance\labelwidth-\labelsep
 \topsep 0pt plus 1pt}
\def\@listv{\leftmargin\leftmarginv
 \labelwidth\leftmarginv\advance\labelwidth-\labelsep
 \topsep 0pt plus 1pt}
\def\@listvi{\leftmargin\leftmarginvi
 \labelwidth\leftmarginvi\advance\labelwidth-\labelsep
 \topsep 0pt plus 1pt}
 
\def\labelenumi{\arabic{enumi}.}
\def\theenumi{\arabic{enumi}}
\def\labelenumii{(\alph{enumii})}
\def\theenumii{\alph{enumii}}
\def\p@enumii{\theenumi}
\def\labelenumiii{\roman{enumiii}.}
\def\theenumiii{\roman{enumiii}}
\def\p@enumiii{\theenumi(\theenumii)}
\def\labelenumiv{\Alph{enumiv}.}
\def\theenumiv{\Alph{enumiv}}
\def\p@enumiv{\p@enumiii\theenumiii}
 
\def\labelitemi{\bf --}
\def\labelitemii{$\bullet$}
\def\labelitemiii{$\ast$}
\def\labelitemiv{$\cdot$}
 
\def\verse{\let\\=\@centercr
 \list{}{\itemsep\z@ \itemindent -1.5em\listparindent \itemindent
 \rightmargin\leftmargin\advance\leftmargin 1.5em}\item[]}
\let\endverse\endlist
\def\quotation{\list{}{\listparindent 1.5em
 \itemindent\listparindent
 \rightmargin\leftmargin}\item[]}
\let\endquotation=\endlist
\def\quote{\list{}{\rightmargin\leftmargin}\item[]}
\let\endquote=\endlist
 
\def\descriptionlabel#1{\hspace\labelsep \bf #1}
\def\description{\list{}{\labelwidth\z@ \itemindent-\leftmargin
 \let\makelabel\descriptionlabel}}
\let\enddescription\endlist
% 
\def\theequation{\arabic{equation}}
% 
\def\titlepage{\@restonecolfalse\if@twocolumn\@restonecoltrue\onecolumn
\else \newpage \fi \thispagestyle{empty}\c@page\z@}
\def\endtitlepage{\if@restonecol\twocolumn \else \newpage \fi}
\arraycolsep 5pt \tabcolsep 6pt \arrayrulewidth .4pt \doublerulesep 2pt
\tabbingsep \labelsep
%
\skip\@mpfootins = \skip\footins
\fboxsep = 3pt \fboxrule = .4pt

 
%
\def\thepart{\Roman{part}}
\def\thesection {\arabic{section}}
\def\thesubsection {\thesection.\arabic{subsection}}
\def\thesubsubsection {\thesubsection.\arabic{subsubsection}}
\def\theparagraph {\thesubsubsection.\arabic{paragraph}}
% 
\def\@pnumwidth{1.55em}
\def\@tocrmarg {2.55em}
\def\@dotsep{4.5}
\setcounter{tocdepth}{3}
% 
\def\tableofcontents{\section*{Table of Contents}
 \@starttoc{toc}}
\def\l@part#1#2{\addpenalty{\@secpenalty}
 \addvspace{2.25em plus 1pt} \begingroup
 \@tempdima 3em \parindent \z@ \rightskip \@pnumwidth \parfillskip
-\@pnumwidth
 {\Large \bf \leavevmode #1\hfil \hbox to\@pnumwidth{\hss #2}}\par
 \nobreak \endgroup}
%
\def\numberline#1{\advance\hangindent by\@tempdima%
\hbox to\@tempdima{\hss#1\enspace}}
%
\def\bf@dottedtocline#1#2#3#4#5{\ifnum #1>\c@tocdepth \else
  \vskip \z@ plus .2pt
  {\leftskip #2\relax \rightskip \@tocrmarg \parfillskip -\rightskip
    \parindent #2\relax\@afterindenttrue
   \interlinepenalty\@M
   \leavevmode
   \@tempdima #3\relax \advance\leftskip \@tempdima \hbox{}\hskip
   -\leftskip
{\bf#4}\nobreak\leaders\hbox{$\m@th \mkern \@dotsep mu.\mkern \@dotsep
       mu$}\hfill \nobreak \hbox to\@pnumwidth{\hfil\rm #5}\par}\fi}
%
\def\l@section{\vskip2mm\bf@dottedtocline{1}{0em}{1.7em}}
\def\l@subsection{\@dottedtocline{2}{1.7em}{2.3em}}
\def\l@subsubsection{\@dottedtocline{3}{4em}{2em}}
\def\l@paragraph{\@dottedtocline{4}{6em}{2em}}
\def\l@subparagraph{\@dottedtocline{5}{8em}{2em}}
\def\listoffigures{\section*{List of Figures\markboth
 {List of Figures}{List of Figures}}\@starttoc{lof}}
\def\l@figure{\@dottedtocline{1}{1.5em}{2.3em}}
\def\listoftables{\section*{List of Tables\markboth
 {List of Tables}{List of Tables}}\@starttoc{lot}}
\let\l@table\l@figure
% 
\def\endthebibliography{\endlist\normalsize}
% 
\newif\if@restonecol
\def\theindex{\@restonecoltrue\if@twocolumn\@restonecolfalse\fi
\columnseprule \z@
\columnsep 35pt\twocolumn[\section*{Index}]
 \markboth{Index}{Index}\thispagestyle{plain}\parindent\z@
 \parskip\z@ plus .3pt\relax\let\item\@idxitem}
\def\@idxitem{\par\hangindent 40pt}
\def\subitem{\par\hangindent 40pt \hspace*{20pt}}
\def\subsubitem{\par\hangindent 40pt \hspace*{30pt}}
\def\endtheindex{\if@restonecol\onecolumn\else\clearpage\fi}
\def\indexspace{\par \vskip 10pt plus 5pt minus 3pt\relax}
% 
\def\footnoterule{\kern-3\p@\hrule width 2 true cm\kern 2.6\p@}
% 
\long\def\@makefntext#1{\@setpar{\@@par\@tempdima \hsize
  \advance\@tempdima-1em\parshape \@ne 1em\@tempdima}\par
  \parindent 1em\noindent \hbox to \z@{\hss$^{\@thefnmark}$\ }#1}
% 
\setcounter{topnumber}{2}
\def\topfraction{.9}
\setcounter{bottomnumber}{1}
\def\bottomfraction{.3}
\setcounter{totalnumber}{3}
\def\textfraction{.15}
\def\floatpagefraction{.85}
\setcounter{dbltopnumber}{2}
\def\dbltopfraction{.85}
\def\dblfloatpagefraction{.85}
 
%

\long\def\@makecaption#1#2{
\vskip 10pt
\setbox\@tempboxa\hbox{{\sc #1}. #2}
\ifdim \wd\@tempboxa >\hsize \unhbox\@tempboxa
\par \else \hbox
to\hsize{\hfil\box\@tempboxa\hfil}
\fi}
% 
\long\def\@caption#1[#2]#3{\addcontentsline{\csname
  ext@#1\endcsname}{#1}{\protect\numberline{\csname
  the#1\endcsname}{\ignorespaces #2}}\par
  \begingroup
    \@parboxrestore
    \@makecaption{\csname fnum@#1\endcsname}{\ignorespaces #3}\par
  \endgroup}
% 
\newdimen\instindent
 
\def\institute#1{\gdef\@institute{#1}}
 
\def\institutename{\par
 \begingroup
 \parskip=0pt
 \setcounter{@inst}{1}%
 \def\and{\par\stepcounter{@inst}%
 \hangindent\instindent\hangafter=0\noindent
 \llap{$^{\the@inst}$\enspace}\ignorespaces}%
 \setbox0=\vbox{\def\thanks##1{}\@institute}%
 \ifnum\c@@inst>9\relax\setbox0=\hbox{$^{88}$\enspace}%
                 \else\setbox0=\hbox{$^{8}$\enspace}\fi
 \instindent=\wd0\relax
 \ifnum\c@@inst=1\relax\else
 \setcounter{footnote}{\c@@inst}%
 \setcounter{@inst}{1}%
 \hangindent\instindent\hangafter=0\noindent
 \llap{$^{\the@inst}$\enspace}\fi\ignorespaces
 \@institute\par
 \endgroup}
 
\def\@thanks{}

\def\@fnsymbol#1{\ifcase#1\or\star\or{\star\star}\or{\star\star\star}%
   \or \dagger\or \ddagger\or
   \mathchar "278\or \mathchar "27B\or \|\or **\or \dagger\dagger
   \or \ddagger\ddagger\else\@ctrerr\fi\relax}
 
\def\inst#1{\unskip\/$^{#1}$}
%---- end      cwiq10.sty
%---- begin    cwiqtheorem.sty -------------------------
% 
% New theorem-like environment
%
% Adapted from theorem environment of LaTeX 
%
%  	Peter de Waal, CWI, Amsterdam. (1989)
%
% The old theorem environment is redefined to get SmallCaps titles and
% a new 'remark' environment is defined that works exactly like the
% theorem environment, except that it prints the body of the text in
% roman (in stead of italics)
%
% 'newtheorem' and 'newremark' can be used together, i.e.
%	\newtheorem{theorem}{Theorem}[section]
%	\newremark{example}[theorem]{Example}
% works as one would expect it.

% redefine theorem environment
%	Peter de Waal, CWI, Amsterdam
%	1989:09:20
%	body text in italics
%	label in SmallCaps
%
%\def\@thmcountersep{} % seperator character between section and
		      % theorem number
		      % to get things to work properly with
		      % (sub)section counter that end with a period.
		      % The original definition in latex.tex is
		      % \@thmcountersep equal to {.}, but this gives a
		      % double period in the output.
% (definition temporarily removed again)

\def\newtheorem#1{\@ifnextchar[{\@othm{#1}}{\@nthm{#1}}}

\def\@nthm#1#2{%
\@ifnextchar[{\@xnthm{#1}{#2}}{\ynthm{#1}{#2}}}

\def\@xnthm#1#2[#3]{\expandafter\@ifdefinable\csname #1\endcsname
{\@definecounter{#1}\@addtoreset{#1}{#3}%
\expandafter\xdef\csname the#1\endcsname{\expandafter\noexpand
  \csname the#3\endcsname \@thmcountersep \@thmcounter{#1}}%
\global\@namedef{#1}{\@thm{#1}{#2}}\global\@namedef{end#1}{\@endtheorem}}}

\def\ynthm#1#2{\expandafter\@ifdefinable\csname #1\endcsname
{\@definecounter{#1}%
\expandafter\xdef\csname the#1\endcsname{\@thmcounter{#1}}%
\global\@namedef{#1}{\@thm{#1}{#2}}\global\@namedef{end#1}{\@endtheorem}}}

\def\@othm#1[#2]#3{\expandafter\@ifdefinable\csname #1\endcsname
  {\global\@namedef{the#1}{\@nameuse{the#2}}%
\global\@namedef{#1}{\@thm{#2}{#3}}%
\global\@namedef{end#1}{\@endtheorem}}}

\def\@thm#1#2{\refstepcounter
    {#1}\@ifnextchar[{\@ythm{#1}{#2}}{\@xthm{#1}{#2}}}

%\def\@xthm#1#2{\@begintheorem{#2}{\csname the#1\endcsname}\ignorespaces}
\def\@xthm#1#2{\@begintheorem{#2}{\csname the#1\endcsname}\ignorespaces}
\def\@ythm#1#2[#3]{\@opargbegintheorem{#2}{\csname
       the#1\endcsname}{#3}\ignorespaces}

%DEFAULT VALUES
%\def\@begintheorem#1#2{\it \trivlist \item[\hskip \labelsep{\sc #1\ #2.}]}
%\def\@opargbegintheorem#1#2#3{\it \trivlist
%      \item[\hskip \labelsep{\sc #1\ #2.\ (#3)}]}
% the previous definition is temporarily restored to the old version
% again

%\def\@begintheorem#1#2{\it \trivlist \item[\hskip \labelsep{\sc #1\ #2}]}
\def\@begintheorem#1#2{\it \trivlist \item[\hskip \labelsep{\sc #1\ #2.}]}
\def\@opargbegintheorem#1#2#3{\it \trivlist
      \item[\hskip \labelsep{\sc #1\ #2\ (#3)}]}
% various periods are added here: after the theorem number and after
% the parenthesis that closes the optional argument

% definition remark environment
%
%	Peter de Waal, CWI, Amsterdam
%
%	1989:09:20
%	body text in roman
%	label of theorem in SmallCaps
\def\newremark#1{\@ifnextchar[{\@othmrm{#1}}{\@nthmrm{#1}}}

\def\@nthmrm#1#2{%
\@ifnextchar[{\@xnthmrm{#1}{#2}}{\ynthmrm{#1}{#2}}}

\def\@xnthmrm#1#2[#3]{\expandafter\@ifdefinable\csname #1\endcsname
{\@definecounter{#1}\@addtoreset{#1}{#3}%
\expandafter\xdef\csname the#1\endcsname{\expandafter\noexpand
  \csname the#3\endcsname \@thmcountersep \@thmcounter{#1}}%
\global\@namedef{#1}{\@thmrm{#1}{#2}}\global\@namedef{end#1}{\@endremark}}}

\def\ynthmrm#1#2{\expandafter\@ifdefinable\csname #1\endcsname
{\@definecounter{#1}%
\expandafter\xdef\csname the#1\endcsname{\@thmcounter{#1}}%
\global\@namedef{#1}{\@thmrm{#1}{#2}}\global\@namedef{end#1}{\@endremark}}}

\def\@othmrm#1[#2]#3{\expandafter\@ifdefinable\csname #1\endcsname
  {\global\@namedef{the#1}{\@nameuse{the#2}}%
\global\@namedef{#1}{\@thmrm{#2}{#3}}%
\global\@namedef{end#1}{\@endremark}}}

\def\@thmrm#1#2{\refstepcounter
    {#1}\@ifnextchar[{\@ythmrm{#1}{#2}}{\@xthmrm{#1}{#2}}}

\def\@xthmrm#1#2{\@beginremark{#2}{\csname the#1\endcsname}\ignorespaces}
\def\@ythmrm#1#2[#3]{\@opargbeginremark{#2}{\csname
       the#1\endcsname}{#3}\ignorespaces}

\def\@endremark{\endtrivlist}

%DEFAULT VALUES
%\def\@beginremark#1#2{\rm \trivlist \item[\hskip \labelsep{\sc #1\ #2.}]}
%\def\@opargbeginremark#1#2#3{\rm \trivlist
%      \item[\hskip \labelsep{\sc #1\ #2.\ (#3)}]}
\def\@beginremark#1#2{\rm \trivlist \item[\hskip \labelsep{\sc #1\ #2}]}
\def\@opargbeginremark#1#2#3{\rm \trivlist
      \item[\hskip \labelsep{\sc #1\ #2\ (#3)}]}
%---- end      cwiqtheorem.sty -------------------------
%--- begin subeqn.sty
%%% File: subeqn.sty
%%% The subequations environment %%%
%
% Within the subequations environment, the only change is that
% equations are labeled differently.  The number stays the same,
% and lower case letters are appended.  For example, if after doing
% three equations, numbered 1, 2, and 3, you start a subequations
% environmment and do three more equations, they will be numbered
% 4a, 4b, and 4c.  After you end the subequations environment, the
% next equation will be numbered 5.
%
% Both text and equations can be put inside the subequations environment.
%
% If you make any improvements, I'd like to hear about them.
%
% Stephen Gildea
% MIT Earth Resources Lab
% Cambridge, Mass. 02139
% mit-erl!gildea
% gildea@erl.mit.edu
%
\newtoks\@stequation

\def\subequations{\refstepcounter{equation}%
  \edef\@savedequation{\the\c@equation}%
  \@stequation=\expandafter{\theequation}%   %only want \theequation
  \edef\@savedtheequation{\the\@stequation}% %expanded once
  \edef\oldtheequation{\theequation}%
  \setcounter{equation}{0}%
  \def\theequation{\oldtheequation\alph{equation}}}

\def\endsubequations{%
  \setcounter{equation}{\@savedequation}%
  \@stequation=\expandafter{\@savedtheequation}%
  \edef\theequation{\the\@stequation}%
  \global\@ignoretrue}

% More from John Hobby
% Fix Plain's \bigl, \Bigl, etc. macros so that they try to scale with
% LaTeX size changes.  This uses the fact that \@setsize sets \ht\strutbox
% to be 70% of the normal unstretched baselineskip.

\def\big#1{{\hbox{$\left#1\vcenter to1.428\ht\strutbox{}\right.\n@space$}}}
\def\Big#1{{\hbox{$\left#1\vcenter to2.142\ht\strutbox{}\right.\n@space$}}}
\def\bigg#1{{\hbox{$\left#1\vcenter to2.857\ht\strutbox{}\right.\n@space$}}}
\def\Bigg#1{{\hbox{$\left#1\vcenter to3.571\ht\strutbox{}\right.\n@space$}}}
%--- end subeqn.sty
%--- begin fleqn.sty	% floating left equations are standard
% fleqn.sty  9-Mar-87


\def\[{\relax\ifmmode\@badmath\else\begin{trivlist}\item[]\leavevmode
 \hbox to\linewidth\bgroup$ \displaystyle
 \hskip\mathindent\bgroup\fi}
\def\]{\relax\ifmmode \egroup $\hfil \egroup \end{trivlist}\else \@badmath \fi}
\def\equation{\refstepcounter{equation}\trivlist \item[]\leavevmode
 \hbox to\linewidth\bgroup $ \displaystyle
\hskip\mathindent}

\def\endequation{$\hfil \displaywidth\linewidth\@eqnnum\egroup \endtrivlist}
\def\eqnarray{\stepcounter{equation}\let\@currentlabel=\theequation
\global\@eqnswtrue
\global\@eqcnt\z@\tabskip\mathindent\let\\=\@eqncr
\abovedisplayskip\topsep\ifvmode\advance\abovedisplayskip\partopsep\fi
\belowdisplayskip\abovedisplayskip
\belowdisplayshortskip\abovedisplayskip
\abovedisplayshortskip\abovedisplayskip
$$\halign to
\linewidth\bgroup\@eqnsel\hskip\@centering$\displaystyle\tabskip\z@
 {##}$&\global\@eqcnt\@ne \hskip 2\arraycolsep \hfil${##}$\hfil
 &\global\@eqcnt\tw@ \hskip 2\arraycolsep $\displaystyle{##}$\hfil 
 \tabskip\@centering&\llap{##}\tabskip\z@\cr}
\def\endeqnarray{\@@eqncr\egroup
 \global\advance\c@equation\m@ne$$\global\@ignoretrue }
\newdimen\mathindent 
\mathindent = \leftmargini

%--- end fleqn.sty	% floating left equations are standard
%--- begin openfont.sty	% defines font \msbm and \oA - \oZ letters
%   @(#) ams_openfont.sty  version:1.1  dated:93/01/05
% 
%   TeX library
%   
%   SCCS file  :	SCCS/s.ams_openfont.sty
%   Type       :	LaTeX
%   SCCS id    :	ams_openfont.sty 1.1
%   Last edited:	1/5/93 15:50:57
% ------------------------------------------------------------%
% 
%   Author: 	Jos Roerdink
% 
% ------------------------------------------------------------%
% Load extra fonts to print OPEN characters. This is a new version
% that should work with the AmsTeX 2.0 fonts. Available soon

\font\twlmsbm = msbm10 \@magscale1 % the new AmsTeX2.0 fonts.
\font\elvmsbm = msbm10 \@halfmag
\font\tenmsbm = msbm10
\font\ninmsbm = msbm9
\font\egtmsbm = msbm8
\font\sevmsbm = msbm7
\font\sixmsbm = msbm6
\font\fivmsbm = msbm5
\newfam\msbmfam
\newcount\msbmfamcount
\msbmfamcount=\msbmfam \multiply\msbmfamcount by 256
\def\msbm{\fam\msbmfam\tenmsbm}
\textfont\msbmfam=\ifcase\@ptsize\tenmsbm\or\elvmsbm\or\twlmsbm\fi
\scriptfont\msbmfam=\ifcase\@ptsize\sevmsbm\or\egtmsbm\or\ninmsbm\fi
\scriptscriptfont\msbmfam=\ifcase\@ptsize\fivmsbm\or\sixmsbm\or\sevmsbm\fi

% OPEN letters are define as \oA (for OPEN A) etc.

\def\oA{{\msbm A}}
\def\oB{{\msbm B}}
\def\oC{{\msbm C}}
\def\oD{{\msbm D}}
\def\oE{{\msbm E}}
\def\oF{{\msbm F}}
\def\oG{{\msbm G}}
\def\oH{{\msbm H}}
\def\oI{{\msbm I}}
\def\oJ{{\msbm J}}
\def\oK{{\msbm K}}
\def\oL{{\msbm L}}
\def\oM{{\msbm M}}
\def\oN{{\msbm N}}
\def\oO{{\msbm O}}
\def\oP{{\msbm P}}
\def\oQ{{\msbm Q}}
\def\oR{{\msbm R}}
\def\oS{{\msbm S}}
\def\oT{{\msbm T}}
\def\oU{{\msbm U}}
\def\oV{{\msbm V}}
\def\oW{{\msbm W}}
\def\oX{{\msbm X}}
\def\oY{{\msbm Y}}
\def\oZ{{\msbm Z}}

\def\ol{\fam\mf\mathsymbols}

%--- end openfont.sty	% defines font \msbm and \oA - \oZ letters
%--- begin gothicfont.sty	% defines font \eufm and \gothA - \gtohZ letters
% Load extra fonts to print gothic characters. Uses the new AmsTeX2.0
% fonts.

\font\twleufm = eufm10 \@magscale1 % the new AmsTeX2.0 fonts.
\font\elveufm = eufm10 \@halfmag
\font\teneufm = eufm10
\font\nineufm = eufm9
\font\egteufm = eufm8
\font\seveufm = eufm7
\font\sixeufm = eufm6
\font\fiveufm = eufm5
\newfam\eufmfam
\newcount\eufmfamcount
\eufmfamcount=\eufmfam \multiply\eufmfamcount by 256
\def\eufm{\fam\eufmfam\teneufm}
\textfont\eufmfam=\ifcase\@ptsize\teneufm\or\elveufm\or\twleufm\fi
\scriptfont\eufmfam=\ifcase\@ptsize\seveufm\or\egteufm\or\nineufm\fi
\scriptscriptfont\eufmfam=\ifcase\@ptsize\fiveufm\or\sixeufm\or\seveufm\fi

% Gothic letters are defined as \gothA (for GOTHIC A) etc.

\def\gothA{{\eufm A}}
\def\gothB{{\eufm B}}
\def\gothC{{\eufm C}}
\def\gothD{{\eufm D}}
\def\gothE{{\eufm E}}
\def\gothF{{\eufm F}}
\def\gothG{{\eufm G}}
\def\gothH{{\eufm H}}
\def\gothI{{\eufm I}}
\def\gothJ{{\eufm J}}
\def\gothK{{\eufm K}}
\def\gothL{{\eufm L}}
\def\gothM{{\eufm M}}
\def\gothN{{\eufm N}}
\def\gothO{{\eufm O}}
\def\gothP{{\eufm P}}
\def\gothQ{{\eufm Q}}
\def\gothR{{\eufm R}}
\def\gothS{{\eufm S}}
\def\gothT{{\eufm T}}
\def\gothU{{\eufm U}}
\def\gothV{{\eufm V}}
\def\gothW{{\eufm W}}
\def\gothX{{\eufm X}}
\def\gothY{{\eufm Y}}
\def\gothZ{{\eufm Z}}

\def\gotha{{\eufm a}}
\def\gothb{{\eufm b}}
\def\gothc{{\eufm c}}
\def\gothd{{\eufm d}}
\def\gothe{{\eufm e}}
\def\gothf{{\eufm f}}
\def\gothg{{\eufm g}}
\def\gothh{{\eufm h}}
\def\gothi{{\eufm i}}
\def\gothj{{\eufm j}}
\def\gothk{{\eufm k}}
\def\gothl{{\eufm l}}
\def\gothm{{\eufm m}}
\def\gothn{{\eufm n}}
\def\gotho{{\eufm o}}
\def\gothp{{\eufm p}}
\def\gothq{{\eufm q}}
\def\gothr{{\eufm r}}
\def\goths{{\eufm s}}
\def\gotht{{\eufm t}}
\def\gothu{{\eufm u}}
\def\gothv{{\eufm v}}
\def\gothw{{\eufm w}}
\def\gothx{{\eufm x}}
\def\gothy{{\eufm y}}
\def\gothz{{\eufm z}}
%--- end gothicfont.sty	% defines font \eufm and \gothA - \gtohZ letters
\ds@twoside		% twoside option is standard


% Define \symbolnote{<num>}{<text>} to produce a note with footnote
% mark <num> (less than 10).  The commands \symbolmark{<num>}
% and \symboltext{<num>}{<text>} are analogues of
% \footnotemark[<num>] and \footnotetext[<num>]{<text>}.

\def\symbolnote#1#2{\let\@thefootn=\thefootnote%
\renewcommand{\thefootnote}{\fnsymbol{footnote}}%
\footnotemark[#1]%
\footnotetext[#1]{#2}%
\let\thefootnote=\@thefootn
}

\def\symbolmark#1{\let\@thefootn=\thefootnote%
\renewcommand{\thefootnote}{\fnsymbol{footnote}}%
\footnotemark[#1]%
\let\thefootnote=\@thefootn
}

\def\symboltext#1#2{\let\@thefootn=\thefootnote%
\renewcommand{\thefootnote}{\fnsymbol{footnote}}%
\footnotetext[#1]{#2}%
\let\thefootnote=\@thefootn
}

\textheight=19.0cm
\textwidth=12.0cm
%\raggedbottom
%\pagestyle{myheadings}
