%
% CWI report style
%
% File		: cwireport.sty
% Version	: 1.2
% Modified	: 5/26/93 16:26:24
% Author	: Jan van der Steen (jansteen@cwi.nl)
% Based on	: Peter de Waal/Rob van der Horst
%
\input report.sty			% Based on Lamports report style

%
% CWI report dimensions
%
\if@twoside
    \oddsidemargin    0in		% Left margin on odd-numbered pages.
    \evensidemargin\oddsidemargin	% Left margin on even-numbered pages.
    \marginparwidth 107pt		% Width of marginal notes.
\else
    \oddsidemargin    0in		% Left margin on odd-numbered pages.
    \evensidemargin\oddsidemargin	% Left margin on even-numbered pages.
    \marginparwidth 107pt		% Width of marginal notes.
\fi

\textwidth	   15.5cm		% Width of text line.
\textheight	   21.5cm		% \textheight is the height of text
					% (including footnotes and figures,
					% excluding running head and foot.
\topmargin	      0pt
\headsep	    0.6cm
\raggedbottom

\def\appendix{%
    \par
    \setcounter{chapter}{0}
    \setcounter{section}{0}
    \def\@chapapp{Appendix}
    \def\thechapter{\Roman{chapter}}
    \if@twoside
	\def\chaptermark##1{%
	    \markboth{%
		\uppercase{%
		    \ifnum \c@secnumdepth >\m@ne
			\@chapapp\ \thechapter. \ %
		    \fi
		    ##1%
		}%
	    }{}%
	}%
    \else
	\def\chaptermark##1{%
	    \markright{%
		\uppercase{%
		    \ifnum \c@secnumdepth >\m@ne
			\@chapapp\ \thechapter. \ %
		    \fi
		    ##1%
		}%
	    }%
	}
    \fi
}

%
% General initialisation
%
\input cwigeneral.sty\relax
