<document>

\slyname{13}

@* Creating and delivering networked multimedia presentations

<slide id=13-intro cap="Networked multimedia presentations">
@ Networked multimedia presentations
/// <box>creation and delivery</box>
<ul>
<li> multimedia presentation -- media objects with spatial and temporal constraints
<li> difference constraints -- arithmetic linear constraints
<li> presentation plans -- solving sets of difference constraints
<li> authoring and presentation environments -- ...
</ul>
</slide>

<slide id=13-present cap="Multimedia presentations">
@ Multimedia presentations
/// <em>basic questions</em>
<ul>
<li> what objects to present
<li> when to present these objects
<li> where should they be presented
</ul>
:@ Responsibilities
<ul>
<li> what -- author
<li> when, where -- constraints
</ul>
:@ Issues
<ul>
<li> interaction between presentation and retrieval scheduler (p. 333)
</ul>
</slide>

\clearpage
@+ Objects in multimedia presentations


<slide id=13-obj cap="Objects in multimedia presentations">
:@ Virtual object
<ul>
<li> $VO = {{ (O_i,Q_i,C_i) | 1 <= i <= k }} $
</ul>
:@ where
<ul>
<li> $C_1,...,C_k$ -- mutually exclusive conditions
<li> $Q_1,...,Q_k$ -- queries
<li> $O_1,...,O_k$ -- objects
</ul>
:@ Application
<ul>
<li> choice of objects
</ul>
<p><text>See p. 336 for an example.</text>
</slide>

\clearpage
@+ Specifying multimedia objects with temporal constraints


<slide id=13-sp-constr cap="Specifiying multimedia objects">
@ Specifying multimedia objects 
///  <box>temporal constraints</box>
<ul>
<li> virtual objects -- $VO = {{ VO_1,...,VO_n }} $
</ul>
:@ Constraints
<ul>
<li> constants -- $c$
<li> variables -- $s_i$ and $e_i$ for $VO_i$, (start,end)
<li> terms -- constants and variables
<li> difference constraints -- $ t1 - t2 <= c $
</ul>
:@ Remark
<ul>
<li> $ t1 - t2 = c  <->  t1 - t2 <= c /\ t2 - t1 <= -c $
</ul>
</slide>

<slide id=13-defs-tp cap="Temporal presentation">
@ Temporal presentation
<ul>
<li> $TP = (VO,DC)$ -- virtual objects $VO$, difference constraints $DC$
</ul>
:@ Solution to DC
<ul>
<li> assignment of integers to each of $ s_i $ and $ e_i $
</ul>
:@ TP is feasible
<ul>
<li> iff the set $ DC $ has a solution
</ul>
/// etcetera
</slide>

<so q-13>
\clearpage
</document>
