<document>
@* Multimedia data structures

\slyname{4}

<slide id=4-intro cap="Multimedia data structures">
@ Multimedia data structures
/// <box>2d, 3d, space-time</box>
<ul>
<li> multimedia data -- reasoning about time and space
<li> n-dimensional data -- attributes from n-dim space
</ul>
</slide>

<slide id=4-hier cap="Hierarchical decomposition">
@ Hierarchical decompositions -- tree
<ul>
<li> k-d tree
<li> point quad tree
<li> MX quad tree
<li> R-trees
<li> TV trees
</ul>
</slide>

<slide id=4-kd-tree cap="k-d trees -- node structure">
@ k-d trees -- node structure <math>(k = 2)</math>
<display>
nodetype = record
  info : infotype;
  xval : real;
  yval : real;
  llink : *nodetype;
  rlink : *nodetype;
end
</display>
</slide>


<slide id=4-kd-constraints cap="Definition and constraints">
:@ Definition
<display>
	    0             if N is the root
level(N) =
	    level(P) + 1  if N's parent is P
</display>
@ Conditions
<display>
level(N) even:  L is subtree at N.llink: L.xval < N.xval
		R is subtree at N.rlink: R.xval >= N.xval
  
level(N) odd:   L is subtree at N.llink: L.yval < N.yval
		R is subtree at N.rlink: R.yval >= N.yval 
</display>
</slide>

<slide id=4-kd-insert cap="Insertion">
:@ Insertion -- node N
<display>
/// try T, level(T) is even
 if T.xval = N.xval & T.yval = N.yval then T = N;
 else if N.xval < T.val then branch left
 else if N.xval >= T.val then branch right
</display>
:@ Search
/// <em>similar</em>
</slide>

<slide id=4-kd-del cap="Deletion">
:@ Deletion -- node N
<display>
  1. search for node N
  2. if N is leaf, delete
     else 
      1. find candidate replacement node K in T1, i e {l,r}
      2. replace N's non-links fields by those of K
      3. delete K from Ti
</display>
</slide>

<slide id=4-kd-K cap="Conditions -- replacement node">
:@ Conditions -- K must satisfy
<display>
  1. level(N) even: 
	all L in Tl, L.xval < K.xval
        all R in Tr, R.xval >= K.xval

  2. level(N) odd :
	all L in Tl, L.yval < K.yval
        all R in Tr, R.yval >= K.yval
</display>
:@ Heuristics - right subtree, Tr not empty
<ul>
<li> label(N) even, node with smallest <em>xval</em> in Tr 
<li> label(N) odd, node with smallest <em>yval</em> in Tr 
</ul>
:@ left subtree
<ul>
<li> maximal <em>xval</em> or <em>yval</em>, must be unique
</ul>
</slide>

<slide id=4-range-q cap="Range queries">
:@ Range queries
<ul>
<li> a range query wrt. a 2-d tree T is a query
that specifies a point <math>(x_c,y_c)</math> and distance $r$
</ul>
:@ Answer
<ul>
<li> set of all points $(x,y)$ s.t. $(x,y)$ within distance $r$ from
$(x_c,y_c)$
</ul>
</slide>

<slide id=4-region cap="Ranges and nodes">
:@ Range and nodes
<ul>
<li> each node in a 2-d tree implicitly represents
a region <math>R_N</math>.
<li> in general, each node $N$ has at most four associated
constraints that jointly define the region represented by that node.
</ul>
:@ Region 
<display>
   XLB: x >= c1; XUB: x < c2; YLB: y >= c3; XUB: y < c4;
</display>
</slide>

<slide id=4-bounds cap="Regions and bounds">
<center>
<image name=@figures/mm/bounds>
</center>
</slide>

<slide id=4-bounds-cond cap="Bounds -- conditions"> 
:@ Conditions
<ul>
<li> 1. root: XLB = YLB = -inf; XUB = YUB = inf
<li> 2. node N has node P as its parent and level(P) is even:
</ul>
<display>
  N.xlb = P.xlb  if N = P.llink
  N.xlb = P.xval if N = P.rlink
  N.xub = P.xval if N = P.llink
  N.xub = P.xub  if N = P.rlink
  N.ylb = P.ylb; N.yub = P.yub
</display>
<ul>
<li> 3. node N has node P as its parent and level(P) is odd:
</ul>
<display>
  N.ylb = P.ylb  if N = P.llink
  N.ylb = P.yval if N = P.rlink
  N.yub = P.yval if N = P.llink
  N.yub = P.yub  if N = P.rlink
  N.xlb = P.xlb; N.xub = P.xub
</display>
</slide>

<so q-4>
\clearpage
</document>
