<document>
@* Text/Document databases

\slyname{6}


<slide id=6-intro cap="Text/Document databases">
@ Text/Document databases
<ul>
<li> querying a text database
<li> precision and recall -- performance
</ul>
:@ Abstractions
<ul>
<li> clustering similar documents
<li> a query is a `document'
</ul>
<p>
<text>
Sections: 6.1, 6.2
</text>
</slide>

<slide id=6-main cap="Main approach">
:@ Main approach
<ul>
<li> document database + string matching
</ul>
:@ Disadvantages
<ul>
<li> synonymy -- topic T does not occur literally in document D
<li> polysemy -- some words may have many meanings
</ul>
:@ Solutions
<ul>
<li> LSI -- vector(d) of term frequencies in a document d
</ul>
</slide>


\clearpage
@+ Precision and recall

<slide id=6-pr-fig cap="Precision and recall">
<image name=@figures/mm/text>
</slide>

<slide id=6-pr-txt cap="Precision and recall">
@ Precision and recall
<ul>
<li> precision = ( returned and relevant ) / returned 
<li> recall = ( returned and relevant ) / relevant 
</ul>
</slide>

<slide id=6-pr-form cap="Precision and recall">
:@ Definitions
<ul>
<li> D a set of documents
<li> A an algorithm, t a topic -- A(t) subset of D = returned
<li> predicates: returned(t), relevant(t)
</ul>
:@ Precision
<ul>
<li> precision(t) = \# (returned(t) <raw>$\cap$</raw> relevant(t)) / \#returned(t) 
<li> precision = sum(t in topics) precision(t) / \#topics
</ul>
:@ Recall
<ul>
<li> recall(t) = \# (returned(t) <raw>$\cap$</raw> relevant(t)) / \#relevant(t) 
<li> recall = sum(t in topics) recall(t) / \#topics
</ul>
:@ In summary
<ul>
<li> precision -- how many answers are correct
<li> recall -- how many of the right documents are returned
</ul>
</slide>

\clearpage
@+ Stop lists, word stems, frequency tables

<slide id=6-etc cap="Stop lists, word stems, frequency tables">
:@ Reduction
<ul>
<li> stop list -- irrelevant words
<li> word stems -- reduce different words to relevant part
</ul>
@ Frequency table
<ul>
<li> freqT(i,j) = \# occurrences of ti in document dj
</ul>
:@ Relevance
<ul>
<li> ratio: \#occurrences/\#words
</ul>
</slide>

<slide id=6-example cap="Example">
:@ Example
<p><center>
<table><!-- { | r | c | c | c | }-->
<tr><th>term/document</th><th>d0</th><th>d1</th><th>d2</th></tr>
<tr><td>snacks</td><td>1</td><td>0</td><td>0</td></tr>
<tr><td>drinks</td><td>1</td><td>0</td><td>3</td></tr>
<tr><td>rock-roll</td><td>0</td><td>1</td><td>1</td></tr>
</table>
</center>
</slide>

<slide id=6-closeness cap="Closeness and distance">
:@ Closeness
<ul>
<li> find all documents related to <em>snacks</em>
and <em>rock-roll</em>
</ul>
:@ Distance -- query Q, document r
<ul> 
<li> vecQ(i) = \# occurrences(ti) in Q
<li> $d(Q,r) = \sqrt{ %S_{i} (vecQ(i) - FreqT(i,r))^{2}  } $
</ul>
:@ Algorithm
<ul>
<li> compare term frequencies per document -- O(M*N)
</ul>
:@ Reduction of complexity
<ul>
<li>  reduce M*N matrix to K*K matrix using LSI
</ul>
</slide>

<slide id=6-lsi cap="Latent semantic indexing">
@ Latent semantic indexing
<ul>
<li> basic idea -- similar documents have similar word frequencies
<li> reduce the size of the frequency table -- M*N to K*K, K << M,N
</ul>
</slide>

\clearpage
:@+ Other retrieval techniques

<slide id=6-retrieve cap="Other retrieval techniques">
@ Inverted indexes
<ul>
<li> document: id + postings (list of terms)
<li> term: string + postings (list of documents)
<li> hash tables: Doc and Term
</ul>
<p>To find all documents associated with a term, we merely return
the postings list.
<p>To find all documents associated with a set of terms,
we perform an intersection on the posting lists.
@ Signature file
<ul>
<li> signature -- a representation of an ordered list
of terms that describes the document
</ul>
</slide>

<so q-6>
%%</ignore>
\clearpage
</document>
