<document>

\slyname{13}

@* Creating and delivering networked multimedia presentations

<slide id=13-intro cap="Networked multimedia presentations">
@ Networked multimedia presentations
/// <box>creation and delivery</box>
<ul>
<li> multimedia presentation -- media objects with spatial and temporal constraints</li>
<li> difference constraints -- arithmetic linear constraints</li>
<li> presentation plans -- solving sets of difference constraints</li>
<li> authoring and presentation environments -- ...</li>
</ul>
</slide>

<slide id=13-present cap="Multimedia presentations">
@ Multimedia presentations
/// <em>basic questions</em>
<ul>
<li> what objects to present</li>
<li> when to present these objects</li>
<li> where should they be presented</li>
</ul>
:@ Responsibilities
<ul>
<li> what -- author</li>
<li> when, where -- constraints</li>
</ul>
:@ Issues
<ul>
<li> interaction between presentation and retrieval scheduler (p. 333)</li>
</ul>
</slide>

\clearpage
@+ Objects in multimedia presentations


<slide id=13-obj cap="Objects in multimedia presentations">
:@ Virtual object
<ul>
<li> $VO = {{ (O_i,Q_i,C_i) | 1 <= i <= k }} $</li>
</ul>
:@ where
<ul>
<li> $C_1,...,C_k$ -- mutually exclusive conditions</li>
<li> $Q_1,...,Q_k$ -- queries</li>
<li> $O_1,...,O_k$ -- objects</li>
</ul>
:@ Application
<ul>
<li> choice of objects</li>
</ul>
</slide>

\clearpage
@+ Specifying multimedia objects with temporal constraints


<slide id=13-sp-constr cap="Specifiying multimedia objects">
@ Specifying multimedia objects 
///  <box>temporal constraints</box>
<ul>
<li> virtual objects -- $VO = {{ VO_1,...,VO_n }} $</li>
</ul>
:@ Constraints
<ul>
<li> constants -- $c$</li>
<li> variables -- $s_i$ and $e_i$ for $VO_i$, (start,end)</li>
<li> terms -- constants and variables</li>
<li> difference constraints -- $ t1 - t2 <= c $</li>
</ul>
:@ Remark
<ul>
<li> $ t1 - t2 = c  <->  t1 - t2 <= c /\ t2 - t1 <= -c $</li>
</ul>
</slide>

<slide id=13-defs-tp cap="Temporal presentation">
@ Temporal presentation
<ul>
<li> $TP = (VO,DC)$ -- virtual objects $VO$, difference constraints $DC$</li>
</ul>
:@ Solution to DC
<ul>
<li> assignment of integers to each of $ s_i $ and $ e_i $</li>
</ul>
:@ TP is feasible
<ul>
<li> iff the set $ DC $ has a solution</li>
</ul>
</slide>

\slyname{14}

@* Distributed media servers

<slide id=14-intro cap="Distributed media servers">
@ Distributed media servers
<ul>
<li> retrieval of multimedia presentations </li>
:@ Retrieval plan
/// <box>cost function</box>
<li> retrieving (media) objects in a timely manner </li>
<li> <em>just in time</em> -- when block $i$ is consumed, $ i + 1 $ must be ready  </li>
</ul>
</slide>

<slide id=14-placement cap="Placement mapping">
@ Placement mapping
<ul>
<li> $ (movie,block) |-> {{ s | s $ is a server $ }} $ </li>
</ul>
:@ Model characteristics
<ul>
<li> server </li>
<li> customer </li>
<li> network/links </li>
</ul>
</slide>

<slide id=14-retrieval cap="Retrieval parameters">
:@ Server parameters
/// <box>retrieval</box>
<ul>
<li> server buffer size </li>
</ul>
:@ Customer parameters
<ul>
<li> consumption rate -- in MB/sec </li>
<li> buffer size </li>
</ul>
:@ Network parameters
<ul>
<li> server-server bandwidth </li>
<li> customer-server bandwidth </li>
</ul>
</slide>

</document>
