<document>
:@- Components 
%%systems for embedded software development
<p>
Spreker: Chris Laffra <a href=http://www.oti.com>AMS/OTI</a> //mailto:Chris_Laffra@oti.com
<br>
Lab Director, Object Technology International,
Amstelveen
<br> dinsdag 14 november, <include file=kader>
<p>
:@ Abstract
<p align=right><a href=components.ppt>components.ppt</a></p>
<p>
In this talk I will discuss various component systems. I will start
with a brief ontology to deal with the burdening topics of "what is a
component", "component interfaces", "deployment models", and
"communication models". Yearly returning workshop at conferences
such as ECOOP has been solely devoted to these fundamental
questions, and the overall conclusion is: there is no "one solution
that fits all needs". Instead, solutions are much more tailored to the
specific needs of the problem they try to solve. A component system
for industrial automation may worry about safety critical issues, such
as not being able to use more than 8 bit processors running at 1Mhz
clock cycles having a total memory budget of 256K bytes (including the
communication software and OS). Clearly, not a friendly environment
for component systems like CORBA that cater to replicated servers
running back-office mission-critical data in multi-language,
heterogenuous
enterprise network environments. Other component systems focus on
network-based delivery of dynamically installable services, where
servers and individual devices engage in a negotiation to discuss the
current configuration of the device, and selectively download the
missing
components to the loosely couple network of embedded devices.
<p>
The various solutions address different facets in the wide spectrum of
software engineering techniques. The emphasis on varying features
(inter-component communication, life-cycle management, plug-and-play,
minimal overhead, and others) drive the design of such component
systems, and therefore the tools that support them. In the short time
available in this talk, I will discuss a few representative component
systems and show where they are similar, but more importantly where
they differ.
:@ About Chris Laffra
Chris graduated as an average doctorandus from the Vrije Universiteit
in 1988. The late Professor Jan van den Bos apparently saw something
in him, and invited Chris to do a PhD-study with him. Under his
guidance,
Chris graduated in 1992 on the design and implementation of Procol, an
object-oriented language based on C that added classes with
delegation,
paralellism, method resolution based on protocols and constraints.
In other words, our own interpretation of a Swiss army knife of
computer
languages. After persuading IBM Netherlands to sponsor him, he joined
IBM T.J. Watson Research Center to continue to work on language
design,
user interface development, and program visualization. In 1994 IBM
almost
went broke and Chris moved to Morgan Stanley to work on Wall Street on
(again) user interfaces. With his colleagues he became one of the
earliest
adopters of CORBA-based products of IONA. Companies like Morgan
Stanley are some of the largest consumers of state-of-the-art
computational
power, and receive first class attention from vendors like Sun.
Therefore,
Chris happened to be in a meeting with people like Guy Steele who came
to
visit Wall Street to preach these stock brokers that C++ was dead, and
this unknown (at that time crappy) little language called Java was to
crush
it, and if we were willing to completely throw away our invested
millions
in
C++ based infrastructures. Well, that didn't happen overnight, but
Chris
had
definitely caught the Java virus. He read up as much on the topic as
he
could, and in spare evenings and weekends, he wrote a book that
complained
about pitfalls in the language. After his first son was born, and IBM
managed
to not go broke, he rejoined IBM Watson in 1997 to work on tools to
transform
Java class files. The most important result that came out of this work
was
Jax, a Java application extractor (basically a compression tool to
shrink
the
size of a standard Java application). After son number 2 was born, he
and
his
wife Carla (who graduated as a more than average doctoranda in Math at
the VU), wanted to move back to the Netherlands and got in touch with
OTI.
One thing led to the other, and in September of 1999, the Amsterdam
lab
of OTI was opened with 1 employee. Currently the lab has 7 full-time
software developers that contribute to the IBM VisualAge Micro Edition
product. In addition to (1) being responsible for packaging technology
of
the product, the lab also (2) manages the PalmOS port of VAME (and
represents IBM as an expert group member in Java Specification Request
JSR-00075, to define class libraries for PDAs), and (3) is involved in
an
IST
4th Framework project with ABB, Univ. of Bern, and FZI Karlsruhe, to
develop
a light-weight component system for field devices. In addition to
running
the
OTI lab, fruitlessly trying to keep his email inbox empty, learning
Dutch
sign
language, and spending time with his family, he sometimes finds time
to
isolate himself from the world to do some extreme programming and hack
cool software.
<p>
<include file=contact>
</document>
