<document>
%%<a href=@talk-index.html target=_top>
<h1><gold> Practicum Object-Oriented Software Development</gold></h1>
%%</a>
<include file=navigate>
<p align=right><a href=studiegids.html>studiegids</a></p>
<p align=right><a href=@talk-practicum.html><img src=@base/eye.gif width=25 height=25></a></p>
  
<slide color=blue mode=hide cap="Objectives">
<h4>Objectives</h4>
/// <a href=notes-past.html>notes from the past</a>
<p>To gain practical experience in deploying 
object-oriented design and implementation techniques.</p>
See also the <a href=../contents.html>lectures OO</a>.
</slide>
<p>
<font color=blue>
<slide id=prac-2001>
:@ Notes <font color=red>2001</red>
<p>
The course has been very much centered around <em>components</em> and
<em>patterns</em>.
Interesting items that have been discussed include,
embedded software (components), the new <em>.NET</em> technology,
and XML.
<p>
It is only natural that these topics will also be prominent
in the practical assignments.
</slide>


<slide color=gold mode=hide cap="Major challenges">
:@ Challenges
<p>
<green>If you wish to participate in the practicum, you must
be willing to take on a challenge.</green>
<p> Major challenges in O-O software construction (still) are:
<ul>
<li> framework development
<li> separation of 'logic' from 'control'
<li> distributed (CORBA) object technology
<li> adequate visualisation of structure and processes
<li> knowledge intensive applications
<li> integration of technologies (XML, Java ... ) 
<li> advanced UI, preferably with 3D technology
</ul>
<p>
</slide>
</font>

<red>
<slide color=red mode=hide cap="discouragement">
<p>
All these subjects have been treated, or at least
hinted at in the <a href=../contents.html>OO Lectures</a>.
If you did not visit any of these lectures, I do actually
want to discourage you to participate in the practicum.
You do not learn much from writing an other Java program, do you?
</slide>
</font>


<slide color=yellow mode=hide cap="Assignements">
<h4> Assignments</h4>
<p> The suggested assignment, 
<a href=assignments.html>The Virtual Dealing Room</a>,
incorporates all the challenges mentioned above.
It is ambitious, indeed, but certainly relevant,
since virtual communities will become a dominant phenomenon
on the Internet. It is an example of a knowledge-intensive,
distributed application area, for which O-O provides,
in principle, the solutions required for their realization.
<p>
Of course, you are welcome to think of variations on this theme
an if you see no other option you may pick an assignment from
the <a href=assignments-97.html>the old list</a>.
<p>
If you think that the technology will be too much to master,
don't worry.
There is a <a href=http://hush.cs.vu.nl/onderwijs/oo/bbs.cgi>forum</a>
in which you can ask technical questions and discuss other
topics with your fellow students.
And, if needed we will organise periodic meetings
where you can exchange ideas, ask for information and get advice
on the technology.
<p> 
Although it would be nice to have a real 3D interface
to the community, I am aware of the fact that most of
the technology involved is still somewhat unstable.
See <a href=http://www.cs.vu.nl/~eliens/onderwijs/mm/vrml/mma1-material.html>MMA1 Web3D</a>
for more information on VRML/Web3D technology.
However, even without using 3D technology, you must
strive for an intuitive interface that that is suited for the
application domain.
%%<p>
%%Examples of virtual communities can be found at
%%http://www.colonycity.com 
%%http://www.blaxxun.com and
%%http://www.activeworlds.com .
</slide>

<slide color=green mode=hide cap="Procedure">
<a name=Procedure">
<h4>Procedure</h4>
<p>
%%In contrast with previous years, a synopsis alone
%%does not suffice. 
To enter the practicum, you need to write a synopsis and
%%send it to //mailto:eliens@cs.vu.nl or use the
register yourself using the
<a href=register.html>online registration</a>. If required by
the supervisor, you  must make an appointment
to talk about the synopsis with the supervisor.
%%<p>
%%Before the actual start of the semester there will also be a meeting
%%with all the participants, in which you are required
%%to give a short, 5-10 minutes, presentation
%%about your intended system or framework.
<p>
See also the <a href=#Regulations>Regulations</a> below.
</slide>

<h4>Supervision</h4>
  
<p>Anton Eli&euml;ns 
<a href="mailto:eliens@cs.vu.nl">eliens@cs.vu.nl</a> 
   
<slide color=yellow mode=hide cap="Software Environment">
<h4>Software environment</h4>
  
<p>Programs have to be written in either Java or the C++ programming
    language, or a combination of these.
    The use of CORBA, and a combination of C++
    and Java is strongly encouraged.
    <p>
    You have to choose one of the
    following options, depending on your personal interest and
    programming skills:</p>

<ol>
  <li>Java with AWT or Swing 
  <li>C++, Java and CORBA (preferred) 
%%<li>C++ with the hush toolkit, or the Qt toolkit</li> 
</ol>
<p>
<b>Note:</b> The use of XML technology is encouraged.
<p>
See also <a href=links.html>resources</a>
and  the (somewhat outdated) list of available <a href=software.html>software</a>.
You may download your own software. This must then be part of
the distribution (when packaging your assignment)
so that the program can be tested.
</slide>

<slide color=green mode=hide cap="Softcopies">
<p>Soft-copies of the <a href="documentation.html"> documentation
</a> need to be available in HTML.  Other languages,
toolkits or file formats may only be used after consulting the
supervisor(s).</p>
</slide>
   
<slide mode=hide cap="Regulations">
<a name=Regulations>
<h4>Regulations</h4>
<p>The practical work can be done in groups of two persons or on an
individual basis, after choosing one of the <a href="assignments.html">given assignments</a>. 
Students are
required to send the URL of a <a href="synopsis.html">synopsis</a> (a short, comprehensive
description of the requirements and functionality of the
application in HTML)
to <a href="mailto:eliens@cs.vu.nl">eliens@cs.vu.nl</a> first.  
Note, submission in any other format will not be considered.
<p>
During the course of the project, the synopsis page must also
give information about progress and other documentation.
See the <a href=#Procedure>Procedure</a> above.
<p>
Read the
section about the <a href="review.html#review">review procedure</a>
and the <a href="style.html">style guide</a> before you start!</p>
   
<p>After approval of your synopsis, a <a href="groups.html">group account</a>
can be requested by <a href="mailto:eliens@cs.vu.nl">eliens@cs.vu.nl</a>. These
accounts will expire on September 30, and can only be obtained and extended
after an explicit request to the helpdesk.</p>
   
<p>A soft-copy of the final application and <a href="documentation.html">documentation</a> 
has to be send by
e-mail to <a href="mailto:eliens@cs.vu.nl">eliens@cs.vu.nl</a> (a
uuencoded compressed tarfile, see the Makefile of the example
project), as well as a filled in "tentamenbriefje" and a hardcopy
of the corresponding <a href="documentation.html">documentation</a>
(requirements spec, user manual, design, etc) (mailbox of 
Anton Eli&euml;ns in the "Stafkamer", next to S3.03). Do <b>not</b> use
plastic covers, staples will do!</p>
</slide>
<font color=red>
<so inleveren>
</font>

<slide color=blue mode=hide cap="Requirements">
<h4>Requirements</h4>
<p>Quality of design is an absolute requirement.
This must be reflected both in the implementation by the definition
of adequate interfaces and the use of inheritance and delegation
and in the documentation explaining the rationale of the design.
The use of <a href="http://hillside.net/patterns/patterns.html">design
patterns</a> is strongly encouraged.  Also you're invited to define
separately IDL interfaces for the major components of your
application, whether or not you use actual <a href="http://www.cs.vu.nl/~eliens/oo/corba.html">CORBA
technology</a> for the implementation.
</slide>

   
<slide color=red mode=hide cap="Time schedule">
<h4>Time schedule</h4><p></p>
<ul>
<li><a href="orientatie.html">Info meeting</a>: on request only</li>
<li>Deadline synopsis: February 15, 2001</li>
<li>Deadline final version: August 31, 2001</li>
</ul>

<p>Note: <b>Students are responsible for a steady progress and
should contact the supervisors in case of problems in an early
phase</b>.

If you miss the August deadline, you may continue working on
your assignment, but no help will be available, and new versions of
Java or CORBA may be installed.
Additionally, after submitting, your
assignment will probably not be reviewed within the usual time
frame. </p>
</slide> 

%%<h4>Example</h4>
%%<p>An example may be copied from 
%%<tt>/home/oo/hush/oo98/examples/</tt></p>
   
%%<slide mode=hide cap="Questions">
%%<h4>Questions</h4>
%%<p>Read the <a href="FAQ/index.html">FAQ</a> first!</p>
%%<p>The <a href="http://www.cs.vu.nl/~se/tutorials/">SE tutorials</a> provide
%%introductions to make(1), C++ debugging, Tcl/Tk, the Tk-packer,
%%widget cooking, ...  When using Java, you will have to rely
%%primarily on the
%%standard <a href=http://www.javasoft.com/docs/books/tutorial/index.html>Java</a>
%%and <a href=http://www.javasoft.com/docs/books/tutorial/ui/swing/index.html>Swing</a> 
%%documentation.
%%<p>
%%The documentation for <i>(Java) hush</i> is
%%part of the <a href=http://www.cs.vu.nl/~eliens/online/hush/sources/java/examples/native/index.html><i>hush</i> documentation</a>.</p>
%%</slide>

</document>
