</document>
<h2><gold>Hush Developer Studio (TM)</gold></h2>
<include file=navigate>
Programming and software development becoming more
and more facilitated by interactive and graphical tools.
Apart from speeding up software development, these tools may also
be useful to bridge (to some extent)
the gap between realization and design, by providing appropriate
(graphic) abstractions, such as a class hierarchy diagram.

<h2>Rationale</h2>
A collection of software development tools may conveniently be called
a Studio. Often the tools in a Studio do nothing more than
providing a graphical user interface to existing utility programs such
as make, or the Orbix command line operations.
Other tools, such as a Class Diagram Tool, contain more 
imminent functionality, in this case for displaying classes
and  their relations in a graphical way.
The use of distributed object technology and in particular
the specification via <a href="http://www.omg.org/corba.htm">CORBA</a>
IDL is encouraged.
See <a href=../corba.html>Corba at the VU</a>.

<h2>Components</h2>
<ul>
<li> <b>Interface Builder</b>
<li> <b>Class Diagram Tool</b>
<li> <b>Smart Code Editor</b>
<li> <b>Project Manager</b>
<li> <b>Software Documentation Tool</b>
<li> <b>Client/Server Management Tool</b> (for Orbix)
</ul>

<h2>Design</h2>
The designer/developer must specify the rationale for 
each individual tool, as well as its design
and possibly the patterns or software idioms used to implement it.
The use of the tool must be fully documented, preferably
with an online demo. Otherwise a tutorial on how to use
the tool must be included in the documentation.
See the <a href=documentation.html>Guidelines for Documentation</a>.


<h2>Comments</h2>
Make a selection of what you consider to be useful tools
for hush. 
If you think of a tool not in the list, that is OK,
provided you motivate the tool by giving a rationale as well
as some examples.
If you take a more generic approach, be sure to test
the tools for hush programs.
Don't be too generic. Tools is generally a slippery affair.
</document>
