//@ universe in java -- adapted from Orbacus

package universe;

import org.omg.CORBA.*;
import java.io.*;
import hush.broker; /// see <a href=broker.java.html>broker.java</a>

public class client 
{
    public static void main(String args[])
    {
	//Runtime.runFinalizersOnExit(true);

	broker _broker = new broker(true); // true means client only

	try
	{
	    _broker.init(args);  /// init orb

	    org.omg.CORBA.Object obj = _broker.object("world.ref"); /// get a reference

	    world world = worldHelper.narrow(obj); /// and create the world
	    if (world == null)
		throw new RuntimeException();
	    
//@ main loop -- say hello

	    System.out.println("Enter 'h' for hello or 'x' for exit:");
	    int c;

	    try  // this is java, ...
	    {
		String input;
		do
		{
		    System.out.print("> ");
		    DataInputStream dataIn = new DataInputStream(System.in);
		    BufferedReader in =
			new BufferedReader(new InputStreamReader(dataIn));
		    input = in.readLine();

		    if (input.equals("q")) {
			world.halt();
			System.exit(0);
			}
		    else if (input.equals("h")) {
			world.hello();
 			world.ask("How is Clinton these days?");
			System.out.println("client: " + world.tell() );
			}
		}
		while(!input.equals("x"));
	    }
	    catch(IOException ex)
	    {
		System.err.println("Can't read from `" +
				   ex.getMessage() + "'");
		System.exit(1);
	    }
	}
	catch(COMM_FAILURE ex)
	{
	    _broker.print(ex);
	    //System.err.println(ex.getMessage());
	    //ex.printStackTrace();
	    System.exit(1);
	}

	System.exit(0);
    }
}

//</>
