@+ <a href=@talk-patterns.html target=_top>Patterns</a>

<slide id=patterns-why cap="A Catalogue of Design patterns">
@ A Catalogue of Design patterns
<ul>
<li> a common design vocabulary
<li> documentation and learning aid
<li> an adjunct to existing methods
<li> a target for redesign
</ul>
<p>see the
<a href=http://hillside.net/patterns/books/#Gamma>GOF Design Patterns</a>
and the <a href=http://hillside.net/patterns/patterns.html>Patterns Homepage</a>
</slide>

<slide id=patterns-schema cap="The Pattern Schema">
<center>
<table border=1>
<tr><td bgcolor=blue>
<h4>The Pattern Schema</h4>
</td></tr>
</table>
</center>
<p align=right><font color=red>structure</font>
@ Name - <font color=green>handle</font> 
*- increases design <i>vocabulary</i>
@ Problem - <font color=green>when to apply</font>
*- explains the <i>problem</i> and the <i>conflict</i>
@ Solution - <font color=green>general arrangement</font>
*- design, <i>responsibilities</i>, <i>collaborations</i>
@ Consequences - <font color=green>tradeoffs</font>
*- to understand the costs and benefits
</slide>

<slide id=patterns-causes cap="Causes for Redesign">
@ Causes for Redesign
<p align=right><font color=red>design for change</font>
<ol>
<li> creating an object by specifying a class explicitly
<font color=blue>-- Abstract Factory, Factory Method, Prototype</font>
<li> dependence on specific operations
<font color=blue>Chain of Responsibilty, Command</font>
<li> dependence on hardware &amp; software platforms
<font color=blue>-- Abstract Factory, bridge</font>
<li> dependence on object implementation or representation
<font color=blue>Abstract Factory, Bridge, Memento, Proxy</font>
<li> algorithm dependence
<font color=blue>-- Builder, Iterator, Strategy, Template Method,
Visitor</font>
<li> extending functionality by subclassing
<font color=blue>-- Bridge, Chain, Composite, Decorator, Observer</font> 
<li> tight coupling 
<font color=blue>-- Abstract Factpry, Bridge, Chain of Responsibilities,
Command, Facade, Mediator, Observer</font>
<li> inability to alter classes conveniently
<font color=blue>-- Adaptor, Decorator, Visitor</font>
</ol>
</slide>

<slide id=patterns-kinds cap="Kinds of Patterns">
@ Kinds of Patterns
<ul>
<li> creational patterns -- <i>factory, singleton</i>, ...
<li> structural patterns -- <i>adaptor, composite, bridge</i>, ...
<li> behavioral patterns -- <i>mediator, observer, command</i>, ...
</ul>
<p>see also
<p><font color=blue>see <a href=@talk-uml.html target=_top>UML</a></font>
</slide>
