@* <a href=@talk-creational.html target=_top>Creational Patterns</a>

<slide color=green id=p-factory cap="Factory">
@ Factory
<font color=red>
<p>
provide interface for creating family of
related or dependent objects without
specifying their concrete classes
</font>
@ <a href=local/factory.gif>Example</a>
@ Also known as <a href=@online/hush/sources/hush/api/kit-h.html><font color=blue>kit</font></a>
@ Paricipants
<ul>
<li> AbstractFactory, Concrete Factory, Abstract Product, Concrete Product
</ul>
@ Consequences
<ul>
<li> isolate concrete classes
<li> makes exchanging product families easy
<li> promotes consistency among products
<li> <font color=red>supporting new kinds of products is difficult</font>
</ul>
@ Implementation
See GOF
</slide>

<slide color=green id=p-f-m cap="Factory Method">
@ Factory Method
<font color=red>
<p>
define interface for creating an object, but
let subclass decide which class to instantiate
</font>
@ Also know as
<font color=blue><p>virtual constructor</font>
@ Motivation
<ul>
<li> encapsulates knowledge of which subclass to instantiate
</ul>
@ Applicability
<ul>
<li> when a class can not anticpate the class of the objects it creates
<li> to delegate responsibility of object creation
</ul>
@ Structure
<a href=local/factory-method.gif>
<image src=local/factory-method.gif height=200 width=350>
</a>
@ Participants
<ul>
<li> Product, ConcreteProduct, Creator, ConcreteCreator
</ul>
@ Consequences
<ul>
<li> provide hooks for subclasses
<li> connects parallel class hierarchies
</ul>
@ Related
*- Factory, Prototype
</slide>

<slide color=green id=p--sing cap="Singleton">
@ Singleton
<font color=red><p>
ensure a class has only one instance
and provide a global point of access
</font>
@ Applicability
<ul>
<li> only one instance of a class
<li> instance must be extendable by subclassing
</ul>
@ Implementation
<program>
   // .h file 

   class Singleton {
   public:
	static Singleton instance();
   protected: /// limit access
	Singleton();
   private:
	static Singleton* _instance;
   };


   // .c file

   Singleton* Singleton::_instance = 0;

   Singleton* Singleton::instance() {
	if (_instance == 0)
		_instance = new Singleton();
	return _instance;
	}
</program>
@ Consequences
<ul>
<li> coordinate access to a single instance
<li> reduced namespace
<li> permit refinement
<li> permit variable number of instances
</ul>
@ Etcetera
see GOF
</slide>

<slide color=green id=p-proto cap="Prototype">
@ Prototype
<font color=red><p>
specify kinds of objects to create using a prototypical instance and create by copying
this prototype
</font>
@ Motivation
*- flexibility, reduce number of classes
@ Applicability
<ul>
<li> when classes to instantiate are specified at runtime
<li> to avoid building a class hierarchy of factories
<li> <a href=@online/hush/sources/hush/widgets/@slide-h-button--button-0.html>to reduce static dependencies</a>
</ul>
@ Participants
*- Prototype, ConcretePrototype, Client
@ Consequences
<ul>
<li> adding and removing <font color=blue><i>product types</i></font>
at runtime
<li> specifying new <font color=red>objects</font> by varying
<font color=red>value/structure</font>
<li> reduced subclassing
<li> configure an application with classes dynamically
see <a href=@online/hush/sources/hush/api/@slide-h-factory*-defaults-43.html>kit.h</a> and <a href=@online/hush/sources/dv/tk/kit-c.html>dv/tk/kit.c</a>
</ul>
@ Related
*- AbstractFactory versus Prototype
</slide>

