<document>
<h1>Alternative OOP Assignments</h1>
<include file=navigate>
These assignments are merely meant as a suggestion in case
you strongly resist to complete an assignment within one
of the primary themes.
You may also look at some of these assignments
as an extension of the themes introduced in the previous
<a href=assignments.html>assignments</a>.
   <ul>
    <li><b>CORBA</b> For those interested in distributed object technology,
     Alessio Raedelli compiled some <a href="corba.html">interesting 
     assignments</a> based on OMG's Common Object Request Broker Architecture.

    <li><b>Interactive video game</b> -- (E.g. a volleyball or tennis
     game for one or more players) Sufficient options need to be
     implemented (e.g. speed factor, score display, replay).
     Literature: [Coplien, 1992]
     
    <li><b>OO Case tool</b> -- a simple case tool, as described in
     [Coad and Yourdon, 1991], or a tool supporting CRC card methods.
     Literature: [Coad and Yourdon, 1991]
     
    <li> <b>Interactive text editor</b> -- Minimal functionality:
     xedit.  The emphasis should be on a flexible and extensible OO
     design.  Literature: A. Diller, Z -- An introduction to formal
     specification, Wiley (1992)
     
    <li> <b>Direct manipulation score editor</b> -- The editor should
     support simple interactive editing and manipulation of musical
     scores.  (some musical background or knowledge of music theory
     required!)  Literature: [Pope, 1991]
     
    <li> <b>Object-oriented expert system</b> Implementation and GUI
     needs to be object-oriented.  Integration of OO methods with the
     chosen knowledge representation formalism is optional. An example
     knowledge-base is required.  Literature: [Eliens,1991], David Hu,
     C/C++ for expert systems, MIS Press (1989)
     
    <!-- <li> <b>3D animation</b> The system has at least an editor
     capable of creating and manipulating (moving, scaling, rotating)
     3D objects. Continuous repetition of these manipulations should be
     supported as well.  Literature: L. Ammeraal, Programming
     principles in computer graphics, Wiley (2nd edition.) 
    -->
     
    <li> <b>Graphical ETAG-editor</b> This assignment can be done by
     students which followed the HCI course, after consulting the
     supervisor.
     
    <li><b>Hypermedia PIM</b> This project consists of developing a
     so-called 'personal information manager'. A pim is essentially a
     free form database which enables the user to store all kinds of
     data and retrieve that information in a flexible way. Examples
     are all kinds of notes, addresses, literature references,
     etc. Additionally, a hypermedia pim should offer the possibility
     to store other kinds of objects, like HTML pages, images or
     movies and, of course, hyperlinks.

    <li><b>Interactive GUI builder for hush</b>
     (see <tt>/usr/local/public/bin.sol/xf</tt> for an example).
     The GUI builder should adapt to user defined widgets and 
     generate readable and reusable Tcl code.
     The generation of C++ and binding to hush handler objects is optional.

   </ul>
 </document>
