<document>
<h1>Games</h1>
<include file=navigate>
Games have proven to be a popular subject for OOP assignments.
Some really fine state of the art games have been produced already.
Consequently, we strongly discourage you to deliver a trivial
one person game such as minesweeper.
Instead, we invite you to create interesting multi-user games with
flashy graphics and sound.

<h2>Rationale</h2>

Game programming is an effective way of learning how to deal
with the complexities of OO modelling and implementation issues,
since games involve dynamic state changes, 'smart' components,
and a variety of user interaction facilities.


<h2>Components</h2>
Basic components of a (distributed) multiuser game include:
<ul>
<li> <b>User interface</b> 
<li> <b>Animation facility</b> 
<li> <b>Local state management</b>
<li> <b>Strategy component</b>
<li> <b>Shared score server</b>
</ul>

<h2>Design</h2>
Game components must be developed in a modular fashion.
That is to say that each of the components might (ideally)
be reused, possibly after refinement, to create
a similar but different game.

<h2>Comments</h2>
For those interested, we have
<i>The black art of Java game programming</i> available.
Contact <a href=mailto:eliens@cs.vu.nl>eliens@cs.vu.nl</a>.
</document>
