mail(E) :-
	person(X),
	valid(X,present),
	email(X,E),
	cout([E,',',nl]).

account(X,A) :- person(X,L), member(account=A,L),!.
account(_,'-').

email(X,E) :- person(X,L), member(email=E,L),!.
email(X,E) :- person(X), list_concat([X,'@cs.vu.nl'],E).

person(X) :- person(X,_).

valid(X,V) :- property(X,valid,V).

property(X,K,V):-
	person(X,P),
	member(K=V,P),!.

property(_,_,'?').


project(E) :- project(E,present).
past(E)    :- project(E,past).

project(E,V) :-
        person(X),
	valid(X,V),
        property(X,date,D),
        property(X,name,N),
        property(X,title,T),
        property(X,url,U),
	property(X,status,S),
	account(X,A),
        property(X,remarks,R),
        email(X,E), !,
	cout([
	'date="',D,'";',nl,
	'student="',N,'";',nl,
	'email="',E,'";',nl,
	'title="',T,'";',nl,
	'url="',U,'";',nl,
	'status="',S,'";', nl,
	'account="',A,'";', nl,
	'remarks="',R,'";',nl,
	'project();', nl,
	nl]).

