;; The utility definitions 

(define upperalpha
  (list #\A #\B #\C #\D #\E #\F #\G #\H #\I #\J #\K #\L #\M
        #\N #\O #\P #\Q #\R #\S #\T #\U #\V #\W #\X #\Y #\Z))
 
(define loweralpha
  (list #\a #\b #\c #\d #\e #\f #\g #\h #\i #\j #\k #\l #\m
        #\n #\o #\p #\q #\r #\s #\t #\u #\v #\w #\x #\y #\z))
 
(define (ISALPHA? c)
   (if (or (member c upperalpha) (member c loweralpha)) #t #f))
 
(define (EQUIVLOWER c a1 a2)
  (cond ((null? a1) '())
        ((char=? c (car a1)) (car a2))
        ((char=? c (car a2)) c)
        (else (EQUIVLOWER c (cdr a1) (cdr a2)))))
 
(define (char-downcase c)
  (EQUIVLOWER c upperalpha loweralpha))
 
(define (LOCASE slist)
  (if (null? slist)
      '()
      (cons (char-downcase (car slist)) (LOCASE (cdr slist)))))

(define (STR2LIST s)
  (let ((start 0)
        (len (string-length s)))
    (let loop ((i start) (l len))
         (if (= i len)
             '()
              (cons (string-ref s i) (loop (+ i 1) l))))))
 
(define (LIST2STR x)
  (apply string x))
 
(define (STRING-DOWNCASE s)
  (LIST2STR (LOCASE (STR2LIST s))))
