<document>
@* <a href=@talk-overview.html target=_top>Further reading in OO</a>
\label{further-reading}


<include file=navigate>

%%<?latex> <so g-overview> <?/latex>

<control>
The papers listed in the online section
on <a href=landmark.html>Landmark Papers</a>
provide a starting point for
studying the various areas and applications of object-oriented
technology presented in the book.
</control>
Recommendations for further reading are given below.

:@ Object-Oriented Programming
An exhaustive, yet excellent description of C++ is given in [_St91].
An excellent introduction to C++ is given in [_Lippman91].
In [_Coplien92] a number of advanced idioms and styles for
using C++ are treated.
An introduction to object-oriented programming is given in
[_Budd91], which covers a variety of languages.
The language Eiffel is introduced in
[_Meyer88].
The original introduction to Smalltalk is by [_GR83].
Data abstraction and object-oriented programming in C++
is dealt with in [_GOP90].
Another introduction to object-oriented programming and C++
is given in [_WP88].
An early book on OOP is [_Cox86].
[_Graham91] gives a very readable overview of object-oriented
methods.
[_Winblad90] survey a number of important issues in object-oriented software
development.
An overview of applications of object-oriented programming is given by
[_Pinson90] and [_Harmon93].

:@ Data abstraction and algorithms in C++
The number of books providing a university course level
introduction to the use of C++ for the development of
abstract data types and algorithms is steadily increasing.
We have, among others, [_Heading],
[_Sedgewick92], [_Budd94], [_Bergin94] and [_Weiss93]
(of which nearly identical texts are available for C and Ada).


:@ Object-Oriented Programming and Software Engineering
Object-oriented design with applications is covered in 
[_Booch94].
Object-oriented analysis is the subject of
[_CY90].
A very readable account of object-oriented design is given in
[_WWW90].
[_Ince91] gives an introduction to software engineering with C++.
[_McGregor92] deal with the advantages of an object-oriented
approach from the perspective of reuse.
In [_Jacobs92] a method for object-oriented development
is described together with an accompanying case tool.
[_Hend92] gives a concise overview of the issues in object-oriented
analysis and design.
Further, we have [_Champeaux93],
which covers analysis and design,
and [_Wilkie93], which provides a professional guide
to object-oriented software engineering.
In [_Rum91] a method for modeling object-oriented systems is introduced.
Also worth mentioning is [_Henderson93],
which presents a canonical approach to map formal designs 
to C++ code,
and [_Fusion] which presents a promising synthesis
of a number of object-oriented development methods.

:@ Object-Oriented Programming and Artificial Intelligence
The role of object-oriented programming in artificial intelligence
is exhaustively treated in [_Tello89].
Apart from describing numerous AI systems embodying
object-oriented notions, a number of research issues 
concerning the relation of object-oriented programming
to AI are discussed.
The CLOS perspective on OOP is presented in [_Paepcke93].
Also worth mentioning is [_Blum92], which
presents an object-oriented framework for developing connectionist
systems and neural networks in C++.
 
:@ Theoretical Issues of Object-Oriented Programming
In [_DT88] an overview is given of theoretical work on type-systems
for object-oriented programming languages.
In [_BRR90] a number of research papers are collected together dealing
with the foundations
of object-oriented programming languages.
Specification and verification techniques for abstract data types
are covered in [_Dahl92].
Also worth mentioning is [_Palsberg94],
which presents an encompassing study (including tools)
of the type theoretical aspects of OOP.

:@ Object-oriented databases
A collection of research papers concerning object-oriented
notions in databases and expert systems is contained in
[_KL89].
A more systematic discussion of the problems in
combining object-oriented, deductive and hypermedia technologies
is given in [_PCKW89].

:@ Additional literature
Object-oriented programming and concurrency is the subject
of the majority of papers in [_YT87] and [_AWY93].
A variety of research papers may further be found in
[_SW87].
Of particular interest  are the standardization efforts
reported in [_OMG] and [_Cattell94].
Finally, an invaluable source of material is provided
by the various conference proceedings, including those of
OOPSLA, ECOOP and TOOLS,
and the numerous magazines concerning object-oriented programming,
such as {\em JOOP}, the {\em C++Report}, {\em IEEE Computer}, 
{\em IEEE Software}
and the {\em ACM SIGPLAN Notices}.
</document>
