<document>
@+ <a href=@talk-paradigms-procedure.html target=_top>Procedural programming</a>
<include file=navigate>

The procedural style of programming is most closely related to the 
school of structured programming, of which for instance [_Dijkstra76] and
[_Gries] are important proponents.
The procedural style supports a method of program development that is
known as {\em stepwise refinement}.
Stepwise refinement is an important heuristic for developing
complex algorithms. 
Instead of writing out a complex algorithm in all its detail, the method
allows for refining the elementary steps of the basic algorithm by means
of increasingly detailed procedures.

<slide id=1-art caption="Programming as an art">
%%:@ Procedural programming
\vspace{0.3cm}
<program>
while ( programming == art )  {

	incr( pleasure );
	decr( bugs );
	incr( portability );
	incr( maintainability );
	incr( quality );
	incr( salary );

} // live happily ever after
</program>
%%\ifsli{\ln\vspace{-1cm}}{\vspace{-0.2cm}}
\vspace{-0.3cm}
</slide>

As a playful example of this style of programming, consider the fragment
that may be found on the cover of [_Knuth92].
\see{1-art}
Ignoring the contents, clearly the structure shows an
algorithm that is conceived as the repeated execution of
a number of less complex steps.
</document>
