<document>
@+ Object terminology

<include file=navigate>

Object-orientation originally grew out of
research in programming languages.
The first object-oriented language was Simula.
However, Smalltalk may be held responsible for the initial popularity
of the object-oriented approach.
The terminology Smalltalk introduced was at the time 
unfamiliar and, for many, somewhat hard to grasp. 
Nowadays, students and IT specialists, have at least heard the
object-oriented jargon. Let's briefly look at it.
See \sliref{1-speak}.
<p>
Objects provide the means by which to structure a system.
In Smalltalk (and most other object-oriented languages) objects are considered to
be grouped in classes. A {\em class} specifies the behavior of the objects that
are its instances. Also, classes act as templates from which actual objects may be created.
Inheritance is defined for classes only.
From the perspective of design, inheritance is primarily meant
to promote the reuse of specifications.

<slide id=1-speak caption="Object terminology">
\footnotesize
@ Object terminology
/// <box>object speak</box>
<I
- objects -- {\em packet containing data and procedures}
- methods -- {\em deliver service}
- message -- {\em request to execute a method}
- class -- {\em template for creating objects}
- instance -- {\em an object that belongs to a class}
- encapsulation -- {\em information hiding supported by objects}
- inheritance -- {\em mechanism allowing the reuse of class specifications}
- class hierarchy -- {\em tree structure representing inheritance relations}
- polymorphism -- <em>to hide different implementations behind a
<latex>\hspace{1cm}</latex>
common interface</em>
I>
\ifsli{\vspace{-1cm}}{}
</slide>

The use of inheritance results in a class hierarchy
that, from an operational point of view,
determines the dispatching behavior of objects,
that is what method will be selected in response to a message.
If certain restrictions are met
(see sections <ref file=@online/oo/I/3/contracts>contracts</ref>,
<ref file=@online/oo/III/9/subtypes>subtypes</ref>
and <ref file=@online/oo/III/10/subtyping>behavioral-types</ref>),
the class hierarchy corresponds to a type hierarchy,
specifying the subtype relation between classes of objects.
<p>
Finally, an important feature of object-oriented
languages is their support for polymorphism.
Polymorphism is often incorrectly identified with inheritance.
Polymorphism by inheritance makes it possible
to hide different implementations behind a common interface.
However, other forms of polymorphism may arise by overloading functions
and the use of generic (template) classes or functions.
See sections <ref file=@online/oo/I/2/poly-cc>polymorphism</ref> and
<ref file=@online/oo/III/9/flavors>flavors</ref>.
</document>
