<document>

@* <a href=@talk-themes.html target=_top>Themes and variations</a>

<include file=navigate>

<control>
<slide color=silver mode=hide id=1.1-sub>
:@ Subsections:
<ul>
<li> <a href=speak.html>Object terminology</a>
<li> <a href=computation.html>Object computation</a>
<li> <a href=contracts.html>Design by Contract</a>
</ul>
</slide>
<hr>
</control>

Nowadays, many have at least some notion of
object orientation.
Undergraduate courses teaching programming in Java are becoming
standard practice.
And, in industry and business, object-oriented technology is
being adopted on an increasingly large scale.
Nevertheless, to some extent, object orientation is still an
emerging technology with many open questions.
So, we will start with a brief survey of what object orientation
is about,
what solutions it offers and what is needed to put
these solutions effectively into practice.
We will also briefly review some <em>object terminology</em>,
reflect on the notion of <em>object computation</em>,
and discuss <em>design by contract</em>.

<slide id="1-themes" caption="Themes and variations">
:@ Themes and variations
<ul>
<li> abstraction -- <em>the object metaphor</em>
<li> modeling  -- <em>understanding structure and behavior</em>
<li> software architecture -- <em>mastering complexity</em>
<li> frameworks -- <em>patterns for problem solving</em>
<li> components -- <em>scalable software</em>
</ul>
</slide>

@ Object metaphor
In an object-oriented approach, objects are our primary
abstraction device.
Objects provide a metaphor that helps us in each phase of the software 
life-cycle.
During analysis, we may partition the domain into objects,
that have properties, possibly responsibilities, and
relations among each other.
<p>
In design, objects are our primary unit of decomposition.
In our design, objects may reflect real life entities,
such as <em>Employer</em> and <em>Employee</em>,
but may also represent system artefacts, such as <em>stacks</em>
or <em>graphics</em>.
<p>
In actual development, that is in the implementation,
objects are our unit of implementation.
Each object itself may be regarded as a collection of functions.
But it is the collection of functions, and the behavior
that they describe, that we take as our unit;
not the individual function.

@ Modeling
Taking objects as the unit of analysis, design and implementation,
allows us to define the structure and behavior of a software
system in a natural way.
Nevertheless, although this may at first sight seem to simplify our task,
it does actually become more difficult to develop
software. Why?
Simply, because it takes more effort to find the right kinds of objects!
It is difficult to arrive at stable abstractions,
to define the  corresponding objects, to define the objects'
interfaces and to define the appropriate relations
between the objects, and to implement them
so that everything works.
<p>
A consequence of adopting an object-oriented approach is that we
have to spend more time in describing and understanding the 
structure and behavior of the system,
and to learn the formalisms and tools that enable us to do so.

@ Software architecture
Objects not only provide a metaphor.
Objects also define a computational platform.
Computation in an object-oriented system
consists of objects sending messages to one another.
This may give rise to very complicated
sequences of instructions, in particular when the
system is dependent on events from the outside,
for example the window or network environment.
<p>
To master this complexity,
we need to think about how objects can be made to fit together.
To benefit from an object-oriented approach,
we need to design a software architecture that defines
and regulates the interactions between objects.

@ Frameworks
When does an object-oriented approach pay off?
It does pay off when we have arrived at (more or less) stable
abstractions for which we have good implementations,
that may be reused for a variety of other applications.
<p>
A framework is a kind of library of reusable objects.
However, in contrast with ordinary software libraries,
frameworks may at times take over control.
The best-known examples of frameworks are in the GUI domain;
frameworks in other domains (e.g. the business process domain)
are emerging.
<p>
Using a framework may simplify your life,
since a framework provides generic solutions for
a particular application domain.
But the price you pay is twofold.
You have to understand what (patterns of)
solutions the framework provides,
and you have to comply with the rules of the game 
imposed by the framework.

@ Components
Frameworks consist of components.
Simplistically, components correspond to objects in a one-to-one way.
However, life is more complicated.
Components usually consist of a collection of objects
that provide additional functionality that allows 
components to interact together.
A typical example of components are distributed objects,
objects that may be accessed over a network.
These objects must have,
preferably in a non-visible way,
all the functionality needed to make a network connection
and send data (arguments and results) over a network.


@so speak
@so features
@so computation
@so contracts

%%@so what/features
%%@so what/poly
%%@so what/respons

</document>
