<document>
@+ <a name=self-reference>Virtual self-reference</a>

<include file=navigate>

A special feature of the <i>hush</i> widget class
library is its support for the definition of
new composite widgets, which provide to the application
programmer the interface of a built-in (or possibly
other composite) widget.
To realize this flexibility, we introduced 
a <i>self()</i> function that adds
another level of indirection to self-reference.
For example, look at the <em>item</em> class below:


<slide type=hide cap="Item with self()">
@ds local/lib/java/self/item.java
</slide>

The <em>item</em> class has an instance variable {P _self P},
that can be set to an arbitrary instance of <em>item</em>
by invoking <em>redirect</em>.
Now, when we ask for the <em>name</em> of the <em>item</em>,
it is checked whether a redirection <em>exists</em>.
If so, the call is redirected to the instance referenced
by {P self() P}, otherwise the name of the <em>item</em>
itself is returned.


<slide type=hide cap="item: go">
@ds local/lib/java/self/go.java
</slide>


In combination with the <em>handle/body</em> idiom, 
we can create composites offering the interface
of <em>item</em>, providing access to one or
more (inner) items.
This will be further illustrated in chapter 4.
<p>
Those well-versed in design patterns will recognize the <i>Decorator</i>
patterns (as applied in the Interviews <i>MonoGlyph</i> class,
[_Interviews]).
</document>
