<document>
@+ Creational patterns

<include file=navigate>

Design for change means to defer commitment
to particular object implementations as long as possible.
Due to inheritance, or rather subtyping, 
the client, calling a particular method,
can choose the most abstract class, highest in the hierarchy.
However, when it comes to creating objects,
there seems to be no other choice than naming 
the implementation class explicitly.
Wrong. 
Creational patterns are meant to take care of that,
that is to hide the actual class used as far away as possible.

<slide cap="Creational patterns">
@ Creational patterns
<ul>
<li> Factory -- hide concrete classes 
<li> Factory Method -- virtual constructors
<li> Prototype -- dynamic creation by cloning
<li> Singleton -- one instance only
</ul>
<c>See <a href=@online/lectures/oo/patterns/contents.html>Pattern Lectures</a></a></c>
</slide>

Creational patterns come in various flavors.
In section <ref file=@online/oo/I/2/poly-java>delegation-in-Java</ref>
some example realizations were presented.
The <em>factory</em> class, for example,
is a rather static way of hiding the implementation classes.
As an alternative, you may use a <em>factory method</em>,
similar to the <em>instance</em> method of the <em>singleton</em>
class.
<p>
If you prefer a more dynamic approach, the <em>prototype</em>
pattern might be better.
A <em>prototype</em> is an object that may be used to create
copies or clones, in a similar way as 
instances are created from a class.
However, cloning is much more dynamic, the more so 
if delegation is used instead of inheritance to share
resources with some ancestor class.
See section <ref file=@online/oo/II/5/prototype>prototypes</ref>.
<p>
The advantage of using a <em>factory</em>, or any of the other 
creational patterns, is that exchanging product families
becomes very easy.
Just look for example at the Java Swing library.
Swing is supported under Unix, Windows and MacOS.
The key to multiple platform support is here, indeed,
the use of factories to create widgets.
Factories are also essential when using CORBA,
simply because calling a constructor is of no use
for creating objects on a remote site.
</document>
