<document>

@+ Polymorphism in C++
\label{1-poly}
\label{polymorphism}

<include file=navigate>

Polymorphism essentially characterizes the type
of a variable, function or object.
Polymorphism may be due to overloading, parametrized types or inheritance.
Polymorphism due to inheritance is often considered
as the greatest contribution of object-oriented languages.
This may be true, but the importance of generic (template) types
and overloading should not be overlooked.

<slide id=1-polymorphism caption="Polymorphic type declarations">
@ Overloading
/// <box>print</box>
<program>
extern void print(int);
extern void print(float);
</program>
<h4> Generic class <em> -- templates</em></h4>
/// <box> {P list< T > P} </box>
<program>
template< class T > class list { ... }
list<int>* alist; 
</program>
@ Polymorphism by inheritance
/// <box> shape </box> 
<program>
class shape { ... };
class circle : public shape { ... } 
shape* s = new circle;
</program>
</slide>

In \sliref{1-polymorphism} some examples are given of
declarations involving polymorphic types.
The function $print$ is separately defined for $int$ and $float$.
Also, a generic $list$ class is defined by means by employing
$templates$.
The list may be used for any kind of objects, for example integers.
Finally, a $shape$ class is defined from which a $circle$ class
is derived.
An instance of the $circle$ may be referred to by using a $shape$
pointer, because the type $shape$ encompasses $circle$ objects.

<so stl>

</document>
