<document>
@* <a href=@talk-polymorphism.html target=_top>Polymorphism</a>

<include file=navigate>

<c>
<slide color=silver mode=hide id=2.1-sub>
:@ Subsections:
<ul>
<li> <a href=poly-java.html>Inheritance and delegation in Java</a>
<li> <a href=poly-cc.html>Polymorphism in C++</a>
<li> <a href=assert.html>Assertions in C++</a>
<li> <a href=canonical.html>Canonical class idioms</a>
</ul>
</slide>
<hr>
</c>

Polymorphism is an intriguing notion.
Briefly put, polymorphism is the ability of a particular
entity (which may be an object, a function, or a variable)
to present itself as belonging to multiple types.
Object-oriented languages are not unique in their
support for polymorphism,
but it is safe to say that polymorphism is an important
feature of object-oriented languages.
As explained in chapter <ref file=@online/oo/III/9/9>9</ref>, polymorphism comes in various flavors.
With regard to object-oriented languages,
we usually mean inheritance or <em>inclusion</em>
polymorphism.
Even within this restricted interpretation, we
have to make a distinction between syntactic polymorphism,
which requires merely that interfaces conform,
and semantic polymorphism,
where conformance requirements also include behavioral
properties.
<p>
In this section, we will look at some simple examples in Java
that illustrate how we may use the mechanisms of 
inheritance and (simple) delegation to define objects that
have similar functionality but differ in the way that functionality
is realized.
These examples prepare the way for the more complex idioms
and patterns presented later in this chapter.
<p>
In the rest of this section we will look briefly at
the polymorphic constructs offered by C++.
We will also study how behavioral conformance can
be enforced in C++ by including invariants and assertions.
These sections may be skipped on first reading.


<so poly-java>
<so poly-cc>
<so assert>
<so canonical>

</document>
