<document>

:@+ The Standard Template Library (STL)
\label{STL}

The Standard Template Library for C++ provides a generic library
of data structures to store, access and manipulate data.
It is a generic library based on templates.
In fact, it uses templates in such an aggressive way
that the C++ standardization committee was forced
to reconsider its definition of
the generic template facility in C++. See [_STL].

<slide id=stl cap="The Standard Template Library">
:@ Standard Template Library
/// <box>STL</box>
<ul>
<li> containers -- <em>to hold objects</em>
<li> algorithms  -- <em>act on containers</em>
<li> iterators -- <em>to traverse containers</em>
<li> functions -- <em>as objects</em>
<li> adaptors -- <em>to transform objects</em>
<li> allocators -- <em>for memory management</em>
</ul>
</slide>
The Standard Template Library (STL) offers
<em>containers</em>, to hold objects,
<em>algorithms</em>, that act on containers, and
<em>iterators</em>, to traverse containers.
Algorithms, which are implemented as objects,
may use <em>functions</em>, which are also defined as objects,
overloading the application $operator()$ method.
In addition, STL offers 
<em>adaptors</em>, to transform objects, and
<em>allocators</em>, for memory management.
<p>
STL is supported by C++ compilers that adhere to the C++
standard, including Microsoft Visual C++ and the Cygnus/GNU C++ compilers.
A more extensive discussion of STL is beyond the scope of this
book, but the reader is advised to consult [_STL],
which gives an introduction to STL and its history,
as well as a thorough course on programming with STL.
</document>
