<document>

@* <a href=@talk-contracts.html target=_top>Contracts</a>
\label{contracts}

<include file=navigate>

<control>
<slide color=silver id=3.3-sub mode=hide>
:@ Subsections:
<ul>
<li> <a href=contracts-formal.html>Specifying contractual obligations</a>
<li> <a href=contracts-inherit.html>Refining a contract</a>
<li> <a href=contracts-validate.html>Runtime consistency checking</a>
</ul>
</slide>
<hr>
</control>

To establish the interaction between objects in a more
precise way, we need a notion of {\em contracts},
specifying the requirements a client must comply with
when requesting a service from a server object.
Our notion of contracts will be based on the notion of {\em types}.

In the universe of programming,
{\em types} are above all a means to create
order and regularity.
Also, in an object-oriented approach,
types may play an important role in
organizing classes and their relationships.
As observed in [_HOB87],
the notion of types gives a natural criterion
for {\em modularization},
perhaps not so much as a guideline to arrive at a particular
object decomposition,
but as a means to judge whether the modular
structure of a system is consistently defined,
that is technically well-typed.
%%\see{3-types}


\clearfalse
\vstr{1}
<slide id=3-obligations cap="Contractual obligations">
@ Contractual obligations
<center>
<control>
<table cellpadding=10 border=1>
<tr><td></td><td>client</td><td>supplier</td></tr>
<tr><td>pre-condition</td><td>obligation</td><td>benefit</td>
<tr><td>post-condition</td><td>benefit<td>obligation</td>
</table>
</control>
<latex>
\vspace{-0.2cm}
\ifsli{\vspace{-1cm}}{}
\mbox{}\nl\mbox{}\hspace{1cm}\begin{tabular}{r | c c |} & {\it client} & {\it supplier} \\ \hline
{\it pre-condition} & obligation & benefit \\
{\it post-condition} & benefit & obligation \\ \hline
\end{tabular}\nl
\vspace{-0.2cm}
</latex>
</center>
</slide>

The meaning of a type must be understood as
a formal characterization of the behavior of the
elements belonging to the type.
A type consists of a (possibly infinite)
collection of elements which is characterized by the definition
of the type.
For example, a {\em class} defines such a collection,
namely the instances of the class, whose behavior
is constrained by the specification of the class.

<so contracts-formal>
<so contracts-inherit>
<so contracts-validate>

</document>
