<document>
@* <a href=@talk-methods.html target=_top>Development methods</a>
\label{env-methods}
\label{methods}

<include file=navigate>

<control>
<slide color=silver mode=hide id=3.1-sub>
:@ Subsections:
<ul>
<li> <a href=methods-model.html>Perspectives of modeling</a>
<li> <a href=methods-fusion.html>Requirements engineering -- Fusion</a>
<li> <a href=methods-compare.html>Methods for analysis and design -- a comparative study</a>
%%<li> <a href=methods-functional.html>Functional versus object-oriented development</a>
</ul>
</slide>
<hr>
</control>


Object-oriented software development is
a relatively new technology.
Consequently, ideas with respect to
methodologies supporting an object-oriented
approach are still in flux.
Nevertheless, a plethora of methods and tools 
does exist supporting object-oriented analysis
and design.
\see{11-methods}

\vfig{1}
<slide id=11-methods cap="Software development methods">
@ Methods
<I
- OOA/D <em> -- incremental</em> /// [_CY91b]
- Objectory <em> -- use-case analysis</em> /// [_Jacobs92]
- OOSA <em> -- model-driven</em> /// [_Kurtz90]
- OOSD <em> -- structured</em> /// [_Wasserman89]
- CRC <em> -- cards</em> /// [_BC89]
- RDD <em> -- responsibility-driven</em> /// [_Wirfs89]
- OMT <em> -- object modeling</em> /// [_Rum91]
- OOD <em> -- development</em> /// [_Booch91]
- Fusion <em> -- lifecycle</em> /// <!-- \mbox{}\hspace{0.1cm} --> [_Fusion] <!-- \mbox{}\hspace{-0.2cm}\mbox{} -->
I>
:@ Unified Modeling Language -- <em>standard notation</em>
/// <box><a href=@online/oo/appendix/uml/uml.html>UML</a></box>
*- class diagrams, object interaction, packages, state and activity
</slide>

<ignore>
In the list above, we have collected
a number of development methods.
With the exception of OOSA
(which proposes a model-driven approach to analysis), OOSD (which introduces 
a structured design representation method)
and Fusion
(which presents a promising synthesis of ideas
found in a number of other methods, such
as CRC, RDD and OMT)
we have encountered these methods previously
in chapters 1 and 3.

We have based our discussion of the
object-oriented lifecycle in section
\ref{life} on the OOA/D method
proposed in [_CY90] and [_CY91b],
which stresses the gradual transition from
the analysis to the design and implementation phase.
In section \ref{process} we have briefly discussed
the Objectory method, which proposes
employing a {\em use case analysis}
to arrive at a model specifying
system requirements.
In section \ref{process} and \ref{contracts},
we have discussed the responsibility-driven approach proposed in
[_Wirfs89], and 
the various modeling perspectives suggested by [_Rum91].
Our discussion of object-oriented development in section \ref{identifying}
has been based on Booch (1986, 1991, 1994).
</ignore>
Some of these methods (and corresponding tools)
directly stem from a more conventional (read <em>structured</em>)
approach to software development.
Others are more radical and propose new tools
to support the decomposition principles
underlying object-oriented technology.
Naturally, those who wish to make a gradual
shift from conventional technology to adopting
an object-oriented approach may benefit
from methods that adapt familiar techniques
to the new concepts.
<p>
In this section we will look at a variety of existing
methods and the tools they offer.
We do not discuss the tools and diagram techniques
used in any detail.
However,
we will discuss the Fusion method in somewhat more detail.
Fusion is a strongly systematic approach to object-oriented
software development that integrates various concepts
and modeling techniques from the other methods,
notably OMT, Booch OOD, Objectory and CRC.
We will discuss the process view underlying Fusion and sketch
the models it supports in relation to the other methods.
For the reader this section may
supply an overview and references
needed for a more detailed study of a particular
method or tool.

<p>
%%:@ Unified Modeling Language
A recent development is the Unified Modeling Language (UML),
which has been approved as a standard in 1998.
UML brings together the models and notations featured
by the various methods. 
%%The <em>three amigos</em>,
Jim Rumbaugh, Grady Booch and Ivar Jacobson, all leading experts
in object-oriented development, joined forces to achieve
this.
<p>
The importance of such a standardization can hardly
be overemphasized.
However, it must be noted that UML does not provide
a method, in the sense of delineating the steps that
must be taken in the development of a system.
UML itself may be regarded as a toolbox, providing
notations and modeling techniques that may be deployed
when needed.
A brief overview of UML is given in 
<ref file=@online/oo/appendix/uml/uml>UML</ref>.
An excellent introduction to UML, including advice
how to apply it in actual projects may be found
in [_Fowler97].


@ Structured methods
Initially, structured methods (which were developed
at the beginning of the 1970s)
were primarily concerned with modeling processes
in a modular way.
Based on software engineering principles such
as {\em module coupling} and {\em cohesion}, tools were 
developed to represent the structure of a design
(within what we have previously called the procedural
or modular paradigm); see, for example, [_Yourdon79].
Apart from diagrams to describe the modular 
architecture of a system 
(such as {\em structure charts} and {\em process specifications}),
structured methods
also employ {\em data flow diagrams}
to depict processes and the flow of data
between them,
and {\em hierarchy diagrams} to model
the structure of the data involved.
\see{11-structured}

\vstr{1}
<slide id=11-structured cap="Tools for a structured approach">
:@ Structured methods
\zline{\fbox{tools}}
\ifsli{\vspace{-0.5cm}}{}
<I
- structure chart
- process specification
- dataflow diagrams
- hierarchy diagram
- entity-relationship diagrams
- data dictionary
- state transition diagram
I>
\ifsli{\vspace{-1cm}}{}
</slide>

Later, structured methods were extended to encompass
analysis, and the focus shifted
to modeling the data by means of
{\em entity-relationship diagrams} and {\em data dictionaries}.
Also, {\em state transition diagrams} were employed
to represent the behavioral aspects of a system.

As observed in [_Fichman], in the late 1970s and
early 1980s, planning and modeling of data began to take on a more
central role in system development,
culminating in data oriented methodologies, such as
information engineering
(which may be regarded as precursors to object-oriented
methods).
Information engineering, however, is
primarily concerned with analysis and strategic planning.
In addition to the modeling techniques mentioned,
tools were developed to model the information needs
of an enterprise and to perform risk analysis.
Also, extensions to the {\em data dictionary} were
proposed in order to have an integrated
repository, serving all phases of
the development.
Currently, repository-based techniques are again
of interest since, in combination
with modern hypermedia technology, they may serve
as the organizational basis for reuse.


<so methods-model>
<so methods-fusion>
<so methods-compare>
%%<so methods-functional>
%%<latex> \marksection{Identifying objects} </latex>

</document>
