<document>
%%<latex>\newpage</latex>
@* <a href=@talk-objects.html target=_top>Identifying objects</a>
\label{3-objects}
\label{identifying}

<include file=navigate>

<control>
<slide id=objects-sections mode=hide color=silver>
:@ Subsections:
<ul>
<li> <a href=objects-heuristics.html>Modeling heuristics</a>
<li> <a href=objects-respons.html>Assigning responsibilities</a>
<li> <a href=objects-roles.html>Object roles</a>
</ul>
</slide>
<hr>
</control>


Object-oriented design aims at describing 
a system in terms of objects (as the primary
components) and the interaction between them.
Motivated by the wish to arrive at stable
abstractions, object-oriented design is often
characterized as {\em modeling reality},
that is the application domain.
However, many applications require, at least
partly, a {\em system-oriented} view towards
design, since they involve system artifacts
for which there exist no clearly identifiable counterparts
in the application domain.
As an example, think of a window-based system.
Many of the items (widgets) introduced in such a
system belong to an artificial reality,
which at best is only vaguely analogous with
reality as we normally understand it.

Irrespective of whether the design is intended
as a preliminary study before the implementation
or as a {\em post hoc} justification of the actual system,
the most important and difficult part of design
is the {\em identification of objects} and the
characterization of their role in the system
and interaction with other objects.

As observed in [_McGregor92], object-oriented design
is best seen as {\em class oriented},
that is directed towards the {\em static} description
of (classes of) objects, rather than a description of the
dynamic interaction between actual objects.
In section <ref file=@online/oo/II/5/prototype>prototypes</ref>,
we will discuss 
{\em class-less} languages which are well suited for
exploratory programming.
However, from the perspective of design,
we are more interested in a (static) 
abstract specification of the components
that constitute the system.


\vfig{0.5}
%%\ifsli{\mbox{}\vspace{-1.5cm}}{}
<slide id=3-design cap="Object-oriented design">
@ Object-oriented design <em> -- decomposition into objects</em>
*- application/system/class oriented
@ Identifying objects <em> -- responsibilities</em>
*- data/procedure oriented
@ Layers of abstraction
*- components, subsystems, frameworks
\ifsli{\vspace{-1cm}}{}
</slide>

In comparison with a functional approach,
object-oriented design is clearly
{\em data oriented}.
However, although a data-oriented approach may
provide a first guideline in developing the system,
the primary concern in object-oriented design
should be the {\em responsibilities}
of an object rather than how it acts as a
{\em data manager}, so to speak.
%%See also the discussion in section \ref{X}.

For larger systems, the complexity of the design may
necessitate the introduction of additional layers
of abstraction.
Apart from objects, which must be regarded
as the basic components of a system,
we may need to isolate subsystems,
consisting of a number of related object classes.
When we have developed a subsystem that
can be used in a variety of contexts, such a
subsystem may be used as a {\em framework}.
A framework is generally not only a collection of
classes but must also be seen as an approach or
method in its own way, since it usually
imposes additional constraints
on the development.
For example, most development environments
for window-based applications provide
a framework consisting of a number
of predefined classes and functions, and guidelines
or recipes that prescribe how to use or adapt
these classes and functions.
Also, most frameworks impose a specific 
control model, such as the {\em event-driven}
control model imposed by window programming environments.
%%See chapter \ref{Composition mechanisms}.

<so objects-heuristics>
<so objects-respons>
<so objects-roles>

</document>
