<document>
@* <a href=@talk-valid.html target=_top>Validation and testing</a>
\label{validation}

<include file=navigate>

<control>
<hr>
:@ Subsections
<ul>
<li> <a href=valid-methods.html>Test methods</a>
<li> <a href=valid-inheritance.html>Testing and inheritance</a>
<li> <a href=valid-objects.html>Testing object behavior</a>
</ul>
<hr>
</control>


When validating a system a number of aspects
play a role.
First, it must be determined whether the
software satisfies the original requirements
and goals set by the user, as specified during analysis.
Secondly, it must be established whether the system meets
the specification laid down in the design document.
The latter is usually referred to as `verification'.
Verification is only one of the aspects of validation,
since validation is meant to establish whether
the system is a {\em good} system in terms of
user satisfaction, whereas the phrase verification
is generally used to describe the process of
establishing the correctness of software in
a more formal sense.
A third aspect of validation concerns the robustness of the 
system, that is the extent to which it can handle
exceptional circumstances,
such as excessive amounts of data and heavy workloads.


\vfig{1}
<slide id=4-quality cap="Software quality">
@ Software quality
\ifsli{\vspace{-0.5cm}}{}
<I
- correctness -- satisfies requirements and goals
- robustness  -- handles exceptional circumstances
I>
@ Structural criteria
\ifsli{\vspace{-0.5cm}}{}
<I
- maintenance -- ease of adapting the software
- reuse -- reusable components
- compatibility -- plug-compatible components
I>
\ifsli{\vspace{-1cm}}{}
</slide>

Validation is primarily concerned with the functional
properties of a system.
Questions that need to be answered are:
Is the system capable of doing what it is expected to do?
And, is the user satisfied with how the system does it?

In practice, the validation of a system
is often restricted to functionality and user interface issues.
However, other criteria, related to structural
properties, are important as well.
\see{4-quality}
For example, a customer may want to know that
the system may easily be adapted to changing circumstances
or different platforms.
Also, the customer may be interested in reusing
components of the system to develop other applications.
Actually, with the trend shifting from single
applications to application frameworks and libraries,
structural criteria are becoming increasingly important,
since they determine the ease and reliability with which
components may be used as building blocks for composing
new applications.
Correspondingly, the verification of the components
constituting a system (or library) will become more
important as well.

Testing is still the method most used  for
experimentally verifying the functional properties
of a piece of software.
In general, testing involves the execution of
a program rather than formal methods of proof.
In the sections that follow we will investigate
what benefits we may expect from an object-oriented
approach when it comes to testing.

<?latex>
<so valid-methods>
<so valid-inheritance>
<so valid-objects>
<?/latex>

</document>
