<document>
@+ <a href=@talk-develop-class.html target=_top>Individual class design</a>

<include file=navigate>

%%@ Class design
<ignore>
We have nearly completed a first tour around
the various landmarks of object-oriented design.
Identifying objects, expressing the interaction
between objects by means of client/server contracts
and describing the collaboration between objects
in terms of behavioral compositions belong
to a craft that will only be learned in the
practice of developing real systems.
</ignore>

A class should represent a faithful model of a single concept,
and be a reusable, plug-compatible component
that is robust, well-designed and extensible.
In \sliref{class-design}, we list a number of suggestions
put forward by [_McGregor92].

\cleartrue
\vfig{1}
<slide id=class-design cap="Individual class design">
@ Class design <em> -- guidelines</em>
\ifsli{\vspace{-0.5cm}}{}
<I
- only methods public
{\em -- information hiding}
- do not expose implementation details
- public members available to all classes
{\em -- strong cohesion}
- as few dependencies as possible
{\em -- weak coupling}
- explicit information passing
- root class should be abstract model
{\em -- abstraction}
I>
\ifsli{\vspace{-1.0cm}}{}
</slide>

The first two guidelines enforce the principle of 
{\em information hiding},
advising that only methods should be public and
all implementation details should be hidden.
The third guideline states a principle
of {\em strong cohesion} by requiring that
classes implement a single protocol
that is valid for all potential clients.
A principle of {\em weak coupling} is enforced by
requiring a class to have as few dependencies as possible,
and to employ explicit information passing
using messages instead of inheritance
(except when inheritance may be used in a type
consistent fashion).
When using inheritance, the root class should be
an abstract model of its derived classes,
whether inheritance is used to realize 
a partial type or to define a specialization
in a conceptual hierarchy.


The properties of classes, including their interfaces
and relations with other classes, must be laid
down in the design document.
Ideally, the design document should present
a complete and formal description of the
structural, functional and dynamic aspects of the system,
including an argument showing that the various models
are consistent.
However, in practice this will seldom be realized,
partly because object-oriented design techniques
are as yet not sufficiently matured to allow
a completely formal treatment, and partly because
most designers will be satisfied with a non-formal
rendering of the architecture of their system.
Admittedly, the task of designing is already
sufficiently complex, even without the additional
complexity of a completely formal treatment.
Nevertheless, studying the formal underpinnings
of object-oriented modeling based on types and polymorphism
is still worthwhile, since it will sharpen the
intuition with respect to the notion of behavioral
conformance and the refinement of contracts,
which are both essential for
developing reliable object models.
And reliability is the key to reuse!

</document>
