import hush.dv.api.*;
import hush.dv.widgets.frame;
import hush.dv.widgets.canvas;

public class drawtool extends canvas implements application {

widget root;
tablet tablet;

public drawtool() { System.out.println("meta handler created"); } 

public drawtool(String p, String options) {
        super(p,"*");                 // create empty tablet
	init(options);
	debug("drawtool created");
	}

public int operator() {
	System.out.println("Calling drawtool:" + _event.args(0) );
	String[] argv = _event.argv();
	if ("self".equals(argv[1])) tk.result(self().path());
	else if ("drawtool".equals(argv[0]))
		create(argv[1],_event.args(2)); // replaces quote
	else if ("path".equals(argv[1])) tk.result(path()); 
	else if ("pack".equals(argv[1])) pack(_event.args(2));
	else self().eval( _event.args(1) );  // send through
	return OK;
	}

void create(String name, String options) {
	drawtool m = new drawtool(name,options);
	}

void init(String options) {
	root = new frame(path(),"-class Meta");

	frame frame = new frame(root,"frame");

	tablet = new tablet(frame,"tablet",options);

	toolbox toolbox = new toolbox(frame,tablet);
	menubar menubar = new menubar(root,tablet,toolbox);

        toolbox.pack("-side left -fill y -expand 0");
	tablet.pack("-side left -fill both -expand 1");

	menubar.pack();
	frame.pack("-expand 1 -fill both");


	redirect( tablet );  // the widget of interest

	//alias( this );  // to install the widget command
	}

// application

public void prelude() {
	debug("application.prelude (Java) ...");
	}
public int main() {
	debug("application.main (Java) ...");
	tk.trace();
	canvas c = new drawtool("draw","");
	tk.bind("drawtool",c);
	c.circle(20,20,20,"-fill red");
	c.rectangle(30,30,70,70,"-fill blue");
	c.pack();

	// tk.source("figure.tcl"); BUG -- crashes afterwards due to JNI class
	tk.pack("quit");
	return OK;
	}

public static void main(String args[]) {
    session s = new session( new drawtool() );
    s.depends("hush:dv:widgets"); // in this order
    s.run();
    s.destroy();
    s.statistics();
    }

};
