import hush.dv.api.*;
import hush.dv.widgets.*;

public class tablet extends canvas {

int _mode;
canvas canvas;
handler[] handlers;

final int DRAW 	= 0;
final int MOVE  = 1;
final int CIRCLE = 2;
final int BOX = 3;
final int ARROW = 5;

public tablet(widget w, String name, String options) {

	super(w,name,"*");

	handlers = new handler[12];

        init(options);

        redirect(canvas); // to delegate to canvas
        bind(this); // to intercept user actions 
	
        handlers[DRAW] = new DrawHandler(canvas);
        handlers[MOVE] = new MoveHandler(canvas);
        handlers[BOX] = new BoxHandler(canvas);
        handlers[CIRCLE] = new CircleHandler(canvas);
        handlers[ARROW] = new ArrowHandler(canvas);

        _mode = 0; // drawmode.draw;
        }


public int operator() { 
	handlers[_mode].dispatch(_event);
	return OK;
	}

public int mode(String s) { 
	int m = -1;
	if ("draw".equals(s)) m = DRAW; 
	if ("move".equals(s)) m = MOVE; 
	if ("box".equals(s)) m = BOX; 
	if ("circle".equals(s)) m = CIRCLE;
	if ("arrow".equals(s)) m = ARROW; 
	if (m >= 0) _mode = m;
	return _mode;
	}

void init(String options) {

        widget root = new frame(path(),"-class tablet");

	canvas = new canvas(root,"canvas",options);
	canvas.configure("-relief sunken -background white");
	canvas.geometry(200,100);
	
	scrollbar scrollx = new Scrollbar(root,"scrollx");
	scrollx.orient("horizontal");
	scrollx.pack("-side bottom -fill x -expand 0");
	
	scrollbar scrolly = new Scrollbar(root,"scrolly");
	
	scrolly.orient("vertical");
	scrolly.pack("-side right -fill y -expand 0");
	
	canvas.pack("-side top -fill both -expand 1");
	
	canvas.xscroll(scrollx); scrollx.xview(canvas);
	canvas.yscroll(scrolly); scrolly.yview(canvas);
	}

};
