<document>

:@* Design
<include file=navigate-guide>

<slipar>
:@ Objectives
This section deals with the transition from
specification to design.
It discusses the distinction between structural
and behavioral aspects by comparing semantic modeling
with an object-oriented approach.
It introduces model-based specification techniques
and discusses
in an informal way a design methodology
based on the notion of abstract systems and events.
In this approach, a notion of events is employed
as a means to characterize user actions, and as
a structuring device that aids in maintaining global
consistency.

:@ Points to emphasize
<I
- {\em modeling} -- structural versus behavioral
- {\em specification} -- model-based
- {\em abstract systems} -- as a design methodology
- {\em events} -- to manage object interactions
I>

:@ Hints
You may comment on the efforts to integrate
the object model of programming languages such
as C++ and the object model of object data bases,
as for example reported in [_Cattell94].
This research is currently only in its initial
phase,
but clearly indicates that many of the features employed in 
semantic modeling, such as {\em n-m} relations, will
in the future be supported at a language level.

:@ Questions
<N \setcounter{enumi}{12}
- Characterize the differences between semantic
modeling and object-oriented modeling.
- How would you characterize the notion of
abstract systems?
- Explain how events may be employed to
maintain system integrity.
N>

:@ Comments
The notion of abstract systems is introduced by means
of an example.
The idea of using {\em events} as a means to maintain
global consistency is clearly suggested in
[_Henderson93] but not developed formally as an essential
ingredient of the method.
The use of events to interrelate distinct 
components of a system, however, seems to be very promising.
See also sections \ref{events} and \ref{duality}.

\clearpage
</slipar>
</document>
