<document>
@* <a href=@talk-dimensions.html target=_top>Design dimensions of object-oriented languages</a>
\label{dimensions}

<include file=navigate>

<c>
<slide color=silver id=5.3-sub mode=hide>
:@ Subsections:
<ul>
<li> <a href=dimensions-object.html>Object-based versus object-oriented</a>
<li> <a href=dimensions-ortho.html>Towards and orthogonal approach -- type extensions</a>
<li> <a href=dimensions-multi.html>Multi-paradigms languages -- logic</a>
<li> <a href=dimensions-active.html>Active objects -- synchronous Java/C++</a>
</ul>
</slide>
<hr>
</c>

Despites the widespread adoption of object-oriented terminology in
the various areas of computer science and software
development practice, there is  considerable confusion about
the precise meaning of the terms employed and the (true)
nature of object-oriented computing.
In an attempt to resolve this confusion, [_Wegner87]
(in the landmark paper {\em Dimensions of object-based language design})
introduces the distinction between {\em object-based}
and {\em object-oriented}.
\see{5-object-based}
This distinction comes down to, roughly, the distinction between
languages providing only encapsulation (object-based) or encapsulation plus
inheritance (object-oriented). See section \ref{object-based}.
Another issue in the debate about object-orientation
is the relation between {\em classes}
and {\em types}.
[_Wegner87] concludes that the notions of objects, classes
and inheritance (that constitute the classical object model)
are highly interrelated, and instead
proposes an orthogonal approach by outlining the various dimensions
along which to design an object-oriented language.
These dimensions may be characterized by the phrases: {\em objects},
{\em types}, {\em delegation} and {\em abstraction}.




\vfig{0.5}
<slide id=5-object-based cap="Object-based versus object-oriented">
@ Object-oriented language design
<ul>
<li> {\bf object}: state + operations
<li> {\bf class}: template for object creation
<li> {\bf inheritance}: super/base and subclasses
</ul>
<display>
object-oriented = 
      objects + classes + inheritance 
</display>
@ data abstraction <em> -- state accessible by operations</em>
@ strong typing <em> -- compile time checking</em>
</slide>

In this section we will look at the arguments presented in [_Wegner87]
in somewhat more detail.
Also, we will look at the viability of combining seemingly
disparate paradigms (such as the logic programming paradigm)
with the object-oriented language paradigm.
In the sections that follow, we will discuss some alternatives and extensions to
the object model.




<so dimensions-object>
<so dimensions-ortho>
<so dimensions-multi>
<so dimensions-active>
</document>
