<document>
\noindent
When developing an object-oriented system, at some time 
a choice has to be made for an actual programming language
or environment.
It goes without saying that the optimal environment will be one
that is in accord with the method chosen for design.
Naturally, other desiderata (involving efficiency, portability
or client-imposed constraints) may play an equally significant role.

\cleartrue
\vfig{1}
<slide color=gold id=5-chapter cap="Object-oriented programming languages">
@ Object-oriented programming languages
/// <box>5</box>
<I
- the object paradigm
- language design dimensions
- classless prototypes
- meta-level architectures
I>
<p><blue>Additional keywords and phrases:
<em> programming languages, orthogonality, reliability, complexity, types, delegation, multiple paradigms, prototypes,
reflection</em>
</silver>
</slide>

This chapter will present an overview of the numerous languages that exist
for object-oriented development.
A comparison of Smalltalk, Eiffel, C++ and Java will be given,
and
we will look at the considerations underlying 
the design of the various object-oriented (extensions of)
programming languages.
Also, some possible modifications
and alternatives to the traditional class-based object model
will be discussed, including active objects, prototypes and meta-level
architectures.
</document>
