<document>
\vspace{0.2cm}
@+ Object linking and embedding -- COM

<include file=navigate>

\vspace{0.1cm}
Reuse is not necessarily code sharing.
In effect, there seems to be a trend
towards sharing components at a higher level
of granularity, as possibly independent applications.
This approach has, for example, been taken by the
Microsoft object linking and embedding
facility (OLE), which offers support for
embedding (a copy) of a component in a (container)
component, for including a link to another component,
and for storing compound objects.
\see{11-ole}

\index{OLE}
\vfig{1}
<slide id=11-ole cap="Object-enabling technology -- OLE">
\vspace{0.1cm}
@ Object-enabling technology
\zline{\fbox{OLE}}
<I
- document centered
{\em -- text, graphics, reports}
- component software
{\em -- standard programmatic interface}
- distributed object systems 
{\em -- component object model}
/// <box>(D)COM</box>
I>
:@ Features
<I
- linking, embedding, storage
I>
:@ Alternatives
<I
- IBM SOM/DSOM, Apple OpenDoc
I>
%%<latex>\mbox{}\vspace{-0.2cm}\mbox{}</latex>
</slide>

The OLE technology, which builds upon (D)COM technology,
is characterized by
its developers as {\em object-enabling}
technology, to contrast it with 
a more classical language-dependent object-oriented
approach relying on inheritance.
<p>
The object-linking technology allows
the user to maintain a link from one application
to another,
so that for example a text processor may
directly employ the results of a spreadsheet.
Moreover, object linking is dynamic and allows
any updates in the spreadsheet application
to be reflected
directly in the outcome of the text processor.
In contrast, object embedding works more as 
the traditional {\em cut and paste} techniques
in that it results in including only a copy
of the material.
To be embedded or linked,
applications must satisfy a standard programmatic interface.
In effect, the interface must provide the facility
to request an update of the display
of the information contained in the application.
In this respect, the OLE technology may be characterized
as {\em document-centered}.
<ignore>
The component object model underlying OLE
allows for distribution along the DCE standard
discussed in section \ref{DCE}.
The commercial competitors are currently
the Apple OpenDoc framework and the IBM SOM/DSOM
realization of the OMG CORBA standard.
It is interesting to note that future releases of
OLE are also promised to be compatible with the CORBA standard.
</ignore>
</document>
