<document>

@+ Object Request Brokers -- CORBA
\label{OMG}

<include file=navigate>

The ultimate goal of object technology
may be phrased as the development of 
plug-compatible software that allows one
to construct a particular application
from off-the-shelf components.
To achieve this goal, it is necessary to
develop standards with respect to object
interaction and communication interfaces
that support {\em information sharing}
between distinct components.
Such standards are developed by
the OMG (the Object Management Group, in
which the leading vendors of software systems
participate, including Digital Equipment Corporation,
Hewlett-Packard Company, HyperDesk Corporation, NCR Corporation, 
Object Design Inc. and Sunsoft Inc.).
The OMG aims at defining standards for information
sharing in widely distributed, heterogeneous
(multi-vendor) networks
to support the reusability and portability of
commercially available components,
and more generally, to develop the technology and 
guidelines that allow the interoperability of applications.
\see{11-standards}


\index{OMG}
\index{OMA}
\index{IDL}
\index{CORBA}
<slide id=11-standards cap="The OMG standardization effort">
@ Standardization <em> -- <c>system</c> integration</em>
\zline{\fbox{OMG}}
<I
- information sharing <em> -- <c>technology,</c> policy</em>
I>
@ Object Management Architecture <em> -- interface standards</em>
\zline{\fbox{IDL}}
<I
- Object Services
- Object Request Broker \zline{\fbox{CORBA}}
- Common Facilities {\em -- file manipulation, print queuing, email}
- Application Objects {\em -- spreadsheets, word processor}
I>
\ifsli{\vspace{-1cm}}{}
</slide>

The OMG proceeds from the assumption that 
object technology (including encapsulation, polymorphism
and inheritance) provides the mechanism necessary for
language-, platform- and vendor-independent,
{\em system integration}.
The OMG has proposed an {\em abstract object model}
and discusses technical and political objectives
in the OMA Guide (Object Management Architecture Guide).
The architecture specified in OMA
provides a generic description of the components
that constitute a system and defines
the interface standards to which the components
must comply.

An important aspect of OMA is the 
{\em interface description language} (IDL)
that is introduced as a standard to describe object
interfaces in a language-independent manner.

According to OMA, a system must support a number
of {\em Object Services}
(dealing with the lifecycle of objects, persistence,
naming an event notification),
and a so-called {\em Object Request Broker}
(which is an intermediary between the object providing
a service and the client requesting a service).
Also a system will need, generally,
{\em Common Facilities}
(such as file manipulation and print queuing),
and in addition will contain
a number of {\em Application Objects}
(such as a spreadsheet or word-processor)
that constitute the proper application.

The OMG is primarily concerned with the adoption of technology
by the producers and vendors of common facilities
and application objects.
Its contribution in this respect is the definition of a set of
common object services and a standard interface
to invoke such services by means
of an object request broker.
This standard has been adopted in CORBA
(the Common Object Request Broker Architecture)
which allows for the interaction between
an application and distinct object request brokers.

The {\em object services} envisioned in OMA
are intended to deal with objects in a language-
and platform-independent manner.
\see{11-services}

<slide id=11-services cap="The OMG Object Services">
@ Object Services
<I
- life cycle <em> -- creation and deletion</em>
- persistence <em> -- management of <c>object</c> storage</em>
- naming <em> -- mapping <c>names</c> to references</em>
- event notification <em> -- registration <c>of events</c></em>
I>
:@ Future
<I
- transactions, concurrency, relationships, ... ,time
I>
\ifsli{\vspace{-1cm}}{}
</slide>

These services encompass the creation and deletion
of objects, the management of object storage,
the mapping of names to references
and the registration of events as triggers
for actions.
In addition, services will be defined that
allow transactions, concurrency,
relationships between objects and time-based properties
of objects to be specified.
To a large extent, such services are provided by individual 
languages (such as Java, C++ or Smalltalk) 
with their accompanying libraries
and development frameworks.
However, the efforts of the OMG are directed towards
(the ambitious goal of) providing such services
in a generic fashion, independent of a particular
language or environment.
</document>
