<document>
\noindent
Many applications, for example in the area of telecomputing,
banking and multimedia (but also in high performance computing
and operating systems), require support
for distribution and concurrency.
Due to their complexity,
these applications are likely candidates for
an object-oriented approach.
However, with regard to their distributed nature,
some marriage between object-oriented computing
and distributed computing must be realized.

\cleartrue
\vfig{1}
<slide color=gold id=ch-6 cap="Component technology">
@ Component technology
/// <box>6</box>
<I
- objects versus components -- definitions
- interoperability
- requirements for distribution
- a simple workgroup application
- extending <em>hush</em> with CORBA
I>
<p><blue>Additional keywords and phrases:
<em> (D)COM, Java, CORBA, OLE, persistent objects, ODMG, workgroup
</em></silver>
</slide>

In this chapter we will study component technology,
which combines object-oriented features
such as encapsulation and (interface) inheritance
with (logical and/or physical) distribution.
In reality, component technology is not a clear-cut
category but rather, according to [_Szyperski97],
a battlefield in action (with (D)COM, CORBA and Java
as the main players), from which eventually
a winner will arise, or perhaps a merge
of technologies.
In this chapter, we will explore the forces at work,
and in addition we will look at a case study
deploying CORBA and Java for the creation of a workgroup application,
and the integration of CORBA with an existing framework,
<em>hush</em>.

</document>
