<document>
@+ Component myths

<include file=navigate>

Component software engineering may be characterized
as an approach that relies on the availability of
reusable `off-the-shelf' components that may be composed
into applications.
This includes applications for banking,
medical services,
corporate management,
entertainment,
etcetera.

<slide id=myths cap="Components: myths and reality">
@ Components: myths and reality
<ul>
<li> component-ware allows for combining components
</ul><p align=right><font color=red>if semantical issues can be resolved</font> 
<ul><li> component-ware simplifies software distribution and maintenance
</ul><p align=right><font color=red>development becomes more complex</font> 
<ul><li> component-ware supports <font color=green>mega</font> applications
     
</ul><p align=right><font color=red>it affects performance significantly</font> 
<ul><li> component-ware is a revolution
</ul><p align=right><font color=red>wrong, it is an <font color=green>evolution</font> from OO and C/S</font>
%%<p><font color=blue>See <a href=@talk-corba.html target=_top>CORBA</a></font>
<c>
<p align=right>unknown source
</c>
\vspace{-0.1cm}
</slide>

From a market perspective, a successful component-based approach
requires interoperability between components from different
vendors,
and standards with respect to the services components offer.
Such standards are necessary to insulate clients
(i.e. corporations) from vendor-specific, proprietary
solutions.
Clearly, on the technology side,
this surpasses the mere wiring or plumbing standards
that form part of (D)COM, ORBs and JavaRMI.
In addition, suitable component standards are required
for components to interact,
as for example offered by ActiveX, JavaBeans or OpenDoc,
as well as general services, as for example defined by the
OMG, to manage such systems.

\vspace{-0.05cm}
:@ Software engineering perspectives
From a software engineering perspective,
we encounter a number of unsolved questions,
as phrased in [_Szyperski97]:
<slide mode=hide id=issues-questions>
%%\vspace{-0.05cm}
<ul>
<li> How to describe the interaction between components?
<li> How to manage variety and flexibility?
<li> How to guarantee critical system-wide properties?
</ul>
%%\vspace{-0.05cm}
</slide>
\noindent
In addition, we need to deal with the practical aspects
of developing component-oriented applications,
that is master the distributed (object) technology involved,
and manage multi-tier architectures.
<p>
And, as indicated in \sliref{myths},
%%which is quoted from an unknown source,
do not underestimate the complexities
of developing such applications.
Given the failure of many OO projects, as described in [_Surviving],
component-oriented solutions which involve client/server aspects
are not likely to be better off, see  [_CS2001].
Another area that needs to be studied is the performance of
such systems, see for example [_CorbaPatterns].
<p>
Yet, in conclusion, 
just as object orientation may be regarded as
a natural evolution from data-oriented approaches,
we may look at component-oriented approaches
as a natural evolution from object orientation into
the realm of distributed systems.

</document>
