<document>
\vspace{0.2cm}
@+ The technology matrix
\label{Technology}

<include file=navigate>

The component technology field is currently dominated
by three players:
Microsoft (D)COM,
OMG CORBA, 
and (the youngest player)
Sun Microsystems Java.
When comparing these technologies with respect to attributes
such as
distribution,
mobility,
language and platform independence, and
reflective capabilities,
we see that there are many differences.

<slide color=blue type=fig id=technology-matrix cap="The technology matrix">
<latex>\mbox{}\vspace{0.5cm}\mbox{}\hspace{-0.1cm}</latex>
<table><!--{|l|c|c|c|c|c|c|}-->
<tr><td></td>
<td>distribution</td>
<td>mobility</td>
<td>language</td>
<td>platform</td>
<td>reflection</td>
</tr>
<tr><td>COM</td>
<td>--</td>
<td>--</td>
<td>*</td>
<td>--</td>
<td>+/--</td>
</tr>
<tr><td>DCOM</td>
<td>+</td>
<td>--</td>
<td>*</td>
<td>+/--</td>
<td>+/--</td>
</tr>
<tr><td>CORBA</td>
<td>+</td>
<td>--</td>
<td>*</td>
<td>*</td>
<td>+/--</td>
</tr>
<tr><td>Java/Beans</td>
<td>--</td>
<td>classes</td>
<td>Java</td>
<td>*</td>
<td>+</td>
</tr>
<tr><td>Java/RMI</td>
<td>+</td>
<td>classes</td>
<td>Java</td>
<td>*</td>
<td>+</td>
</tr>
<tr><td>Voyager</td>
<td>+</td>
<td>objects</td>
<td>Java</td>
<td>*</td>
<td>+</td>
</tr>
</table>
<latex>\vspace{0.1cm}</latex>
</slide>

First of all, notice that component technology does
not automatically mean distribution.
For example, JavaBeans and Microsoft COM do not support
distribution.
Secondly, whereas language independence seemed to be
of importance in the pre-Java era, that is for (D)COM and CORBA,
it is not so for the Java-based solutions.
Finally, platform independence is hard to achieve.
But, fortunately, it is on the agenda of all three
technologies, including (D)COM.
<p>
It is worth mentioning that the three major technologies have
a rather different origin.
Microsoft (D)COM is primarily a desktop technology,
with Office as its killer application,
whereas CORBA originated from the need to have an enterprise-wide
solution for distributed objects.
Java is a special case. It started as a Web-based language,
but rapidly took position in the desktop and enterprise world as well.
<p>
Java distinguishes itself from the other technologies
both with respect to mobility and reflection.
As a Web-based language, Java allows for downloading
code dynamically, that is class descriptions for instantiating new
objects.
True mobile objects,
that is instantiated objects that migrate themselves,
are only possible when using a system such as Voyager,
or any of the other Java-based agent ORBs.
Java also provides a powerful Reflection API,
which allows for various kinds of meta-programming,
including the creation of new classes.
In comparison, meta-programming facilities of
the two other technologies are limited
to querying the availability and functionality of interfaces,
dynamic method invocation
and some dynamic typing.


\vspace{-0.2cm}
:@ Trends -- interoperability
It is hard to predict the outcome of the `battle of component technologies'.
However, one can observe a convergence of technologies, that is
bridges between 
Java and CORBA,
CORBA and (D)COM, and
Java and (D)COM/ActiveX.
Each of these technologies sets a standard for interoperability.
So, eventually some new standard may arise that encompasses them all.
In the meantime, we may study the strengths of each of these
technologies and establish what major challenges lie ahead.
For example, Microsoft COM has demonstrated itself in an unescapable
way in Microsoft Office.
A related technology, OpenDoc, failed to gain a market
position, but is nevertheless taken on by the OMG
as document-oriented component technology.
<p>
An interesting project in this respect is the
K-Office project,
which aims at developing an Office Application Suite for the 
Unix/X11 desktop.
It is built upon the KDE GUI environment,
and employs a CORBA-based component technology,
(nick)named <em>KOM</em>, to interconnect
(embed and link) the various document components
and their associated tools. See http://koffice.kde.com<!---->.

</document>
