<document>
@+ From technology to style
<include file=navigate>

We distinguish between three different architectural styles:
<slide id=styles mode=hide>
<ul>
<li> the distributed objects style
<li> the (dynamically) downloadable code style
<li> the mobile objects style
</ul>
</slide>
\noindent
This distinction is arbitrary, in the sense that other
distinctions are conceivable.
However, the distinction above is well motivated 
by the technology matrix introduced in 
section <ref file=../6/issues-technology>Technology</ref>,
as reflected in the feature-based description given
below.
%%in \sliref{features}.

<slide type=fig id=Features cap="Feature classification">
%%<center>
<latex> \footnotesize \mbox{}\hspace{-0.8cm}\mbox{}</latex><table><!--{|l|l|l|l|}-->
<tr><th></th>
<th><b>distributed objects</b></th>
<th><b>downloadable code</b></th>
<td><b>mobile objects</b></td></tr>
%%\hline
<tr><td><b>Component</b></td><td>object</td><td>object/class</td><td>agent</td></tr>
<tr><td><b>Connector</b></td><td>ORB</td><td>various</td><td>methods</td></tr>
<tr><td><b>Creation</b></td><td>server</td><td>client</td><td>any</td></tr>
<tr><td><b>Location</b></td><td>server</td><td>client</td><td>any</td></tr>
<tr><td><b>Client</b></td><td>fixed</td><td>extensible</td><td>extensible</td></tr>
<tr><td><b>Server</b></td><td>extensible</td><td>fixed</td><td>extensible</td></tr>
</table>
<!--\normalsize-->
%%</center>
</slide>

<p>
The <em>distributed objects</em> style comprises software architectures
which consist of software components providing services to client
applications.
Each object is located at a single, fixed place.
Objects on different machines are connected by an ORB (Object Request Broker).
Example technologies supporting this architectural style
are CORBA and DCOM.
<p>
The second architectural style
is the <em>(dynamically) downloadable code</em> style.
Classes may be downloaded, to be used on client machines
for instantiating objects, which will run on the client machine.
Example technologies supporting this style are
Java applets, JavaBeans, and ActiveX controls. 
<p>
Finally, in the <em>mobile objects</em> style,
objects may migrate from host to host, carrying both functionality
and data when they move.
Consequently, mobile objects may communicate
with the local objects of the host they currently reside on.
Mobile objects are a means to implement agents
which wander through a network,
collecting information, negotiating with other agents,
periodically reporting back results to the user who launched the agents.
Technologies supporting the mobile object style
are agent ORBs such as Voyager.
<p>
:@ Features
In \sliref{Features}, an overview is given of
the characteristic features of each style.
Clearly, the styles differ in what are considered as
constituent parts (components and connectors),
location issues (which determine where 
objects are created and where
they are located during their lifetime),
and functionality issues
(that is whether either the client or server is functionally
extensible).
<p>
We may regard the location issues as the
prime discriminators of the architectural styles discussed.
Adopting the distributed objects architectural style,
new objects can be added at the server-side, where
they will stay for the remainder of their lifetime.
In contrast, adopting the downloadable code style,
objects may be created at the client-side,
from classes obtained from the server.
Most flexible is the mobile objects style,
which allows for objects to reside on either
server or client machines.
<p>
The location properties directly affect
the way that the system is extensible
with new functionality.
Clearly, the mobile code style offers the maximum
of flexibility and functional extensibility.
Nevertheless, as we will discuss shortly,
there are tradeoffs involved.
The maximum in flexibility and extensibility does not
necessarily offer the optimal solution!
</document>
