<document>

@* <a href=@talk-styles.html>Architectural patterns and styles</a>
\label{Styles}

<include file=navigate>

<c>
<slide color=silver id=style-sections mode=hide>
:@ Subsections:
<ul>
<li> <a href=style-tech.html>From technology to style</a>
<li> <a href=style-case.html>Case study -- perspectives in visualization</a>
</ul>
</slide>
</c>

%%The notion of architecture is most prominent
%%when we consider distributed object systems.
When constructing a system, how does one determine an appropriate
style?
There is no simple answer to this question.
According to [_Practice], several forces play a role,
for example quality requirements concerning availability 
and performance and technological constraints that have
to do with the platform on which the system is intended to run.
Also, as frankly admitted in [_Practice], 
personal experiences and preferences of the architect play a role.
<p>
Architectural choices lead to a particular decomposition
into components and a characterization of
the relation between components.
Classifying groups of software architectures,
we may speak of <em>architectural styles</em>,
which may be defined, following [_Shaw96],
as <em>descriptions of component types and patterns
of runtime control and data transfer</em>.
<p>
In this section we will  look at architectural styles
for distributed object systems.
Three styles will be introduced, and we will discuss
how these styles are related to technological constraints
imposed by particular component technologies.
Then we will investigate how these styles work out in practice,
by a simple case study in which we explore the consequences
of a particular style for the solution of a specific problem,
in our case the problem of dynamically changing a viewpoint
or perspective in an interactive visualization system.

<so style-tech>
<so style-case>
</document>
