<document>
@* Objects as behavioral types
\label{types-behavioral}
\label{behavioral-types}

<include file=navigate>

<c>
<slide color=silver id=subtypes-sections mode=hide>
:@ Subsections:
<ul>
<li> <a href=subtyping-abstract.html>Abstraction and representation</a>
<li> <a href=subtyping-corresp.html>Correspondence</a>
</ul>
</slide>
<hr>
</c>



A syntax-directed correctness calculus as presented in 
section \ref{10:verification}
provides, in principle, excellent support for a problem-oriented
approach to program development,
provided that the requirements a program has to meet can be made explicit in a 
mathematical, logical framework.

When specifying requirements, we are primarily interested
in the abstract properties of a program, as may be expressed in some
mathematical domain.
However, when actually implementing the program
(and verifying its correctness) we mostly need to take recourse
to details we do not wish to bother with when reasoning
on an abstract level.
In this section we will discuss how we may verify
that an abstract type is correctly implemented by
a behavioral (implementation) subtype, following
[_Am90].
Also, we will define precise guidelines for determining
whether two (behavioral) types satisfy
the (behavioral) subtype relation, following [_Liskov93].

<so subtyping-abstract>
<so subtyping-corresp>
</document>
