<document>
@* <a href=@talk-algebra.html target=_top>Algebraic specification</a>
\label{ADT-algebra}
\label{algebraic}
\label{Algebra}

<include file=navigate>

<c>
<slide color=silver id=algebra-sections mode=hide>
:@ Subsections:
<ul>
<li> <a href=algebra-sign.html>Signatures -- generators and observers</a>
<li> <a href=algebra-eq.html>Equations -- specifying constraints</a>
<li> <a href=algebra-init.html>Initial algebra semantics</a>
<li> <a href=algebra-objects.html>Objects as algebras</a>
</ul>
</slide>
<hr>
</c>


Algebraic specification techniques have 
been developed as a means to specify the design
of complex software systems in a formal way.
The algebraic approach has been motivated by
the notion of {\em information hiding}
put forward in [_Parnas72a] and the ideas
concerning {\em abstraction} expressed in [_Ho72].
Historically, the ADJ-group (see Goguen <i>et al.</i>, 1978) provided
a significant impetus to the algebraic approach
by showing that abstract data types may be interpreted
as (many sorted) algebras.
(In the context of algebraic specifications the
notion of $sorts$ has the same meaning as $types$.
We will, however, generally speak of $types$.)

As an example of an algebraic specification,
look at the module defining the data type $Bool$,
as given in \sliref{8-Bool}.

@$=P

<slide id=8-Bool cap="The ADT <em>Bool</em>">
@ Algebraic specification <em> -- ADT</em>
/// <box>$Bool$</box>
[P
adt $bool$ is
functions
  true : bool
  false : bool
  and, or : bool * bool -> bool
  not : bool -> bool
axioms
  [B1]  and(true,x) = x
  [B2]  and(false,x) = false
  [B3]  not(true) = false
  [B4]  not(false) = true
  [B5]  or(x,y) = not(and(not(x),not(y)))
end
P]
\ifsli{\ln\vspace{-1.5cm}}{}
</slide>

In this specification two constants are introduced
(the zero-ary functions
$true$ and $false$), three functions (respectively
{\it and}, $or$ and $not$).
The $or$ function is defined by employing $not$
and {\it and}, according to a well-known logical law.
These functions may all be considered to be (strictly)
related to the type $bool$.
Equations are used to specify the desired characteristics
of elements of type $bool$.
Obviously, this specification may mathematically be interpreted
as (simply) a boolean algebra.

@ Mathematical models
The mathematical framework of algebras allows for
a direct characterization of the behavioral
aspects of abstract data types by means of equations,
provided the specification is consistent.
Operationally, this allows for the execution
of such specifications by means of term rewriting,
provided that some (technical) constraints are met.
The model-theoretic semantics of algebraic
specifications centers around the notion
of {\em initial algebras}, which gives
us the preferred model of a specification.

To characterize the behavior of {\em objects}
(that may modify their state) in an algebraic way,
we need to extend the basic framework of initial 
algebra models either by allowing
so-called {\em multiple world} semantics or by
making a distinction between hidden and observable
sorts (resulting in the notion of
an object as an {\em abstract machine}).
As a remark, in our treatment we obviously cannot
avoid the use of some logico-mathematical formalism.
If needed, the concepts introduced will be explained
on the fly.
Where this does not suffice, the interested reader
is referred to any standard textbook on mathematical
logic for further details.


<so algebra-sign>
<so algebra-eq>
<so algebra-init>
<so algebra-objects>
</document>
