<document>

\noindent
From a theoretical perspective,
%%we may characterize
object orientation
may be characterized 
%% <latex>\hspace{0.1cm}</latex>
as combining {\em abstract data types}
and {\em polymorphism}.
These notions may be considered as the theoretical counterparts
of the more operational notions of <em>encapsulation</em>
and <em>inheritance</em>.

\cleartrue
\vfig{1}
<slide color=gold id=ch-9 cap="Polymorphism">
@ Polymorphism
/// <box>9</box>
<I
- abstract inheritance
- subtypes
- type abstraction
- self-reference
I>
<p><blue>Additional keywords and phrases:
<em>exceptions, type calculi,
parametric types, coercion, ad hoc polymorphism,
universal types, existential types,
unfolding, intersection types</em>
</font>
</slide>

In this chapter we will study the notion of polymorphism.
We start our exploration by looking at the
role of inheritance in knowledge representation.
%%structures employed in artificial intelligence.
Then we will formally characterize the (signature)
subtype relation and explain the {\em contravariance} rule
for function subtypes.
To better understand polymorphism and its relation to
inheritance, we will 
develop a type calculus,
allowing us to define abstract types using
universally and existentially quantified type
expressions.
In a similar way, we will look at polymorphism due
to overloading and generic type definitions.
Finally, we will look at the role of
self-reference in typing object descriptions derived by inheritance.
Together with developing the calculi,
examples will be given that illustrate
the properties of the C++ and Eiffel
type systems.
</document>
