<a name=sets>
@+ Types as sets
<include file=navigate>

A type, basically, denotes a set of elements.
A type may be defined either extensionally,
by listing all the elements constituting the type,
or descriptively, as a constraint that must be satisfied
by an individual to be classified as an element of the type.

\vfig{2}
<slide id=9-types cap="The interpretation of types as sets">
<raw height=500>
@ Types as sets of values
\ifsli{\vspace{-0.5cm}}{}
*-  <raw>$V \approx Int  \cup ... \cup   V \times V   \cup  V -> V  $</raw>
@ Ideals <em> -- over $V$</em>
\ifsli{\vspace{-0.5cm}}{}
<I
- subtypes -- {\em ordered by set inclusion}
- lattice -- $Top = V$, $Bottom = \emptyset$
I>
@ Type system
\zline{\fbox{\em subtypes correspond to subsets}} 
\ifsli{\vspace{-0.5cm}}{}
<I>- a collection of <em>ideals</em> of $V$
\ifsli{\vspace{-1cm}}{}
</raw>
</slide>

@$=raw
Formally, we may define the value set of a type with
subtypes as an isomorphism of the form
<display>
$V \approx Int  \cup ... \cup   V \times V  \cup  V -> V  $
</display>
\vspace{-0.3cm}
which expresses that the collection of values $V$
consists of (the union of) basic types
(such as $Int$)
and compound types  (of which $V$ itself may be a component)
such as record types (denoted by the product $V \times V$)
and function types (being part of the function space $V -> V$).
@$=math

Within this value space $V$, subtypes correspond to subsets
that are ordered by set inclusion.
Technically, the subsets corresponding to the subtypes
must be {\em ideals}, which comes down to the requirement
that any two types have a maximal  type containing
both (in the set inclusion sense).

Intuitively, the subtype relation may be characterized
as a refinement relation, constraining the 
set of individuals belonging to a type.
The subtype refinement relation may best be understood
in terms of improving our knowledge with
respect to (the elements of) the type.
For a similar view, see [_GO90].
In case we have no knowledge of a particular element
we simply (must) assume that it belongs to
the value set $V$.
Having no knowledge is represented by the
maximal element of the lattice $Top$, which denotes
the complete set $V$.
Whenever we improve our knowledge, we may be more
specific about the type of the element, since fewer
elements will satisfy the constraints implied by our information.
The bottom element $Bottom$ of our type lattice denotes
the type with no elements, and may be taken to consist
of the elements for which we have contradictory information.
\see{9-types}

Mathematically, a type system is nothing but a collection with
ideals within some lattice $V$.
In our subsequent treatment, however, we will primarily
look at the refinement relation between two elements,
rather than the set inclusion relation between their
corresponding types.

