:@+ The SIM library
The BPSIM library is an extension of the simulation library SIM [_SIM].
SIM is a C++ library offering classes supporting
discrete event simulation, based on standard simulation techniques
[_Watkins93].

In discrete event simulation,
the components of the model consists of events,
which are
activated at certain points in time and in this way affect the overall state
of the system.
The simulation library consists of the following classes:
<slide cap="Simulation classes">
:@ Simulation classes
<ul>
<li><i>simulation</i> -- the scheduler
<li><i>event</i> -- representing the events
<li><i>entity</i> -- process consisting of events
<li><i>generator</i> -- random distributions 
<li><i>resource</i> -- to model passive objects
<li><i>queue</i> -- to hold waiting events 
<li><i>histogram</i> -- to plot the results 
<li><i>analysis</i> -- for statistical analyses
</ul>
</slide>
The SIM library is integrated with the <i>hush</i> library,
which may be used for defining a script interface to the simulation
package, for developing a graphical user interface
and for visualising simulation models.
