<document>
@+ So many users, so many perspectives
%%@+ Interactive Information Visualization

<include file=navigate>

The title of this section is from an article, [_Perspectives].
It is meant to express that visualization must be flexible
in order 
to accommodate the individual user's information needs.
Originally, visualization was primarily used for the
analysis of scientific data, resulting from measurements
or some physical model.
Nowadays, visualization is increasingly applied to
non-scientific data, for better understanding of
the contents and the relations between the data.
In business data visualization there is not necessarily
a physical model underlying the data.
Nevertheless, it is worthwhile to visualize
the data in order to explore structural patterns and temporal
relations.
<p>
<slide id=in3d-arch type=fig cap="In3D architecture">
<image name=@figures/vis/in3d-arch>
</slide>
<p>
The In3D toolkit, [_In3D], 
provides an object-oriented framework
for the visualization of business data.
It is based on the <em>Model--View--Control</em>
paradigm, and provides the functionality to define
data models or containers,
observers for these models,
mappings to transform the data to be displayed,
a variety of views to display the data,
sensors and controllers to create interactive applications,
and frames and viewers for displaying visualizations
on the screen.
The In3D toolkit is built on OpenGL and allows
for VRML import and export.
An overview of the In3D architecture is given in \sliref{in3d-arch}.


<slide id=interact cap="User interaction">
:@ Interaction -- <em>visualization</em>
<ul>
<li> <em>selection</em> -- clicking a view $ -> $ action
<li> <em>brushing</em> -- display detailed information
<li> <em>controllers</em> -- sliders and buttons for manipulation
<li> <em>filtering</em> -- apply constraints on the data
<li> <em>sensors</em> -- triggered by user navigation
<li> <em>navigation</em> -- move around and explore
<li> <em>commands</em> -- user-defined macros
</ul>
</slide>

Creating an effective visualization may be quite demanding.
First of all, one has to make the choice for
an appropriate metaphor.
Basically, the choice is between a <em>literal</em>
metaphor, such as the geographical metaphor used in \sliref{3d-usa},
or an abstract metaphor, such as a data cube or an abstract
topology.
Next, it is important to organize the data,
and to find suitable visual primitives to display the data
content and the inherent relationships of the data.
Finally, user interaction capabilities must be added,
to allow for explorative behavior and drill down.
See \sliref{interact}.

:@ Available systems
The In3D toolkit (http://www.vdi.com) was one of the first around
for business data visualization.
Recently, a number of VRML-based visualization kits
have been introduced (for example http://www.em7.com and http://www.platinum.com).
<p>
%%In interesting research system is 
%%<a href=http://nipper.gsfc.nasa.gov/visage/doc/visage.html>Visage</a>, see [_Visage].

</document>
