<document>
@+ Trends and technologies 
<include file=navigate>

The Web came as a surprise, both
to the hypertext community and to 
the distributed systems community.
As a surprise because, despite its simplicity,
or probably because of its simplicity,
the adoption of the Web is unsurpassed,
in absolute volume and growth rate.
Its simplicity lies both in terms of the underlying 
TCP/IP-based HTTP transport protocol,
and the (conceptual) functionality of
the HTML hypertext format, which more or less defines
the services offered by the Web.

<slide  id=trends caption="Transport and services">
:@ Transport and Services
<center>
<table><!--{ | c | c | c | }-->
<tr><td></td><td>Web</td><td>Corba</td></tr>
<tr><td>Services</td><td>HTML</td><td>IDL</td></tr>
<tr><td>Transport</td><td>HTTP</td><td>ORB/IIOP</td></tr>
</table>
</center>
:@ Alternatives
<ul>
<li> <a href=http://www5conf.inria.fr/fich_html/slides/dday/objects/madsen/overview.htm>ANSAWeb</a> -- CORBA-based Web infrastructure
<li> WebBroker -- HTTP as a transport protocol for ORBs
<li> orblets -- Java applets with ORB
</ul>
</slide>

It is probably not an exaggeration to say that the entire academic
community was shocked to see the sudden mass-scale adoption of 
a technology that was only a shallow reflection
of the original conceptions of globally distributed systems
and hypermedia.
Not surprisingly, however, academia
and other research and development institutes
reacted to the Web by redirecting their research programs,
in order to jump on the wagon.

<slide id=java-orb type=fig cap="Java applet with ORB">
<image name=@figures/web/orb>
</slide>


<p>
As an example, in the August/September 1996 issue of
the Object Expert (Europe) the question was
posed <em>`How to survive the Internet revolution?'</em>.
In answer to that question, the Web was first criticized
for offering a monolithic HTML/HTTP-based structure
that gave rise to many proprietary extensions.
Then, as a solution, CORBA was praised as an infrastructure
that allows for the creation of well-behaved
extensions through the use of IDL.
The most radical alternative, indeed,
would be to base the Web entirely on CORBA, of which
the ANSAWeb proposal is an example.
A rather different route is to adopt HTTP
as the transport protocol for object request brokers
and turn the Web into a global infrastructure
for distributed object computing,
as for example suggested in the WebBroker proposal
that will be discussed later.


<p>
A more modest, and realistic, approach is
to enhance Java applets with the capability to connect with
CORBA servers, as indicated in \sliref{java-orb} and \sliref{steps}.
<p>
In \sliref{java-orb}, we see a browser with an HTML page
that contains a Java applet,
which may connect through an ORB directly to, for example,
a database server.
Alternatively, a request may pass through a CGI process to
an ORB attached to the HTTP server.

<slide id=steps type=fig cap="Processing steps">
<image name=@figures/web/steps>
</slide>

In more detail, when we look at the processing steps,
as depicted in \sliref{steps},
we may distinguish between
<slide id=list mode=hide>
<ol>
<li> get the HTML page,
<li> load the applet,
<li> start the applet,
<li> connect to a CORBA server from the applet,
<li> get access to the remote objects,
<li> connect optionally to a database, and
<li> send output either in HTML format or directly
to the applet.
</ol>
</slide>
Based on this setup, we may think of several alternatives
and refinements,
as for example the use of Java RMI
or an extension of the Java ORB with full server
functionality, to allow for
callbacks from the objects (server) to the client (applet).

:@ The WebBroker proposal
In the scenario sketched above, Java and CORBA were used
to extend the basic functionality of the Web.
In a similar vein, Microsoft DCOM, as an alternative
distributed object technology, might have been
used to incorporate objects in the Web.
The <a href=http://www.datachannel.com/xml_resources/webbroker>WebBroker proposal</a>, as explained in the technical note
submitted to the W3C, <a href=http://www.w3.org/TR/1998/NOTE-webbroker-19980511>11 May 1998</a>,
attempts to unify distributed object technology and
the Web publishing infrastructure by providing a common
<em>Web computing</em> standard based on
HTTP and XML.
(XML, the eXtendable Markup Language, may be considered
as a lightweight version of SGML, suitable for the
description of the structure and content of arbitrary documents.)
<p>
The objective of the <em>WebBroker</em> is, as stated
in the proposal, to
have a system which is less complicated than
the OMG CORBA and Microsoft COM+
distributed computing systems and which is more 
powerful than HTML forms and CGI.
The principal advantage of the WebBroker approach
is that it is Web-native.
However, with the universal adoption of IIOP,
which is now also the transport protocol of Java RMI,
the advantage of a more efficient protocol gains more weight.
</document>
