<document>
@* Objects and the Web
<include file=navigate>

<c>
<slide color=silver id=objects-sections mode=hide>
:@ Subsections:
<ul>
<li> <a href=objects-trends.html>Trends and technologies</a>
<li> <a href=objects-web.html>The Object Web -- CORBA/Java versus Microsoft</a>
</ul>
</slide>
<hr>
</c>

The Web originated from an initiative at CERN,
nicknamed the World Wide Web (WWW),
to provide an infrastructure for the exchange
of information between scientists.
Undoubtedly, the initiative succeeded beyond expectation.
As described by [_Practice],
at the time there were other such initiatives.
Nevertheless, the effort at CERN contained two novel ideas:
the use of hypertext, to allow for easy navigation between
documents, and the deployment of a client/server
architecture, to separate presentation from the delivery
of documents.

<slide id=Pair type=fig caption="Client/server pair">
<image name=@figures/web/pair>
</slide>

Among the original requirements of the WWW
was <em>extensibility</em>.
As \sliref{Pair} indicates, which is an adapted
rendering from a chapter about the Web in [_Practice], both
the browser (client) and the (HTTP) server may be extended
with, respectively, additional viewers on the client side
and arbitrary programs through the Common Gateway Interface (CGI)
on the server side.
Together with these extensions the original infrastructure,
which consists of HTML (Hypertext Markup Language)
as the document format
and HTTP (Hypertext Transfer Protocol)
for the transport of documents,
proved to be sufficient for the Web to be widely adopted.
In retrospect, one may wonder why the Web
was not based on, for example, distributed object
technology or remote procedure calls.
Accepting the Web as it is, we may still ask ourselves
what role objects may play in
developing Web applications.

<so objects-trends>
<so objects-web>


</document>
