<document>
@* Programming the Web -- a search for APIs
\label{Web}
\index{Web}
<include file=navigate>

<c>
<slide color=silver id=web-sections mode=hide>
:@ Subsections:
<ul>
<li> <a href=web-model.html>Models of computation</a>
<li> <a href=web-agents.html>Intelligent agents</a>
</ul>
</slide>
<hr>
</c>

Leaving the Object Web for what it is, in construction obviously,
we may raise the question as to what support should be provided
for developing Web applications that are more finely tuned
to the needs of end-users.
To answer this question, or more appropriately,
to gain insight into the requirements and
state-of-the-art technology that was available,
I organized a series of two workshops,
one for the WWW5 Conference, 
entitled <a href=@online/workshops/www5/contents.html><em>`Programming the Web -- a search for APIs'</em></a>,
and one for the WWW6 Conference,
entitled <a href=@online/workshops/www6/contents.html><em>`Logic Programming and the Web'</em></a>.
<p>
In this section we will discuss some of the issues treated
in these workshops.
In particular, we will reflect on the computation model
underlying the Web, taking the views of Luca Cardelli
presented at the WWW5 workshop as a starting point,
to establish general requirements for APIs for programming the Web.
Then we will look at another interesting phenomenon, intelligent
agents on the Web,
and discuss what would constitute a suitable framework for
agent technology.

<so web-model web-agents>


</document>
