//@ broker.h  - adapted from hush broker

#ifndef _h_ooc_broker_h
#define _h_ooc_broker_h

#include <OB/CORBA.h>
#include <OB/Util.h>

#include <fstream.h>


class corba {  /// just because I don't like CORBA_ syntax
typedef CORBA_Object object;
typedef CORBA_SystemException exception;
};


class ooc_broker { // see //online/hush/sources/hush/broker.h
public:

ooc_broker() { }

void init(int& argc, char**& argv, int fl=0) {
       		_orb = CORBA_ORB_init(argc, argv);
       		if (!fl) _boa = _orb -> BOA_init(argc, argv);
		}
}

//@ run -- server only

int operator()() {
        _boa -> impl_is_ready(CORBA_ImplementationDef::_nil());
	}


//@ util -- object references

char* ref(corba::object* x) {
	_str = _orb -> object_to_string((CORBA_Object*)x);
	return (char*) _str;
	}

corba::object* ref(const char* s) {
	corba::object* objp = _orb -> string_to_object(s);
	return objp;
	}

corba::object* object(const char* f) {
	char* url = filein(f);
	return ref(url);
	}

void refout(const char* f, corba::object* x) {
	fileout(f,ref(x));
	}

//@ fileout and filein  -- in hush these are url-enabled

void fileout(const char* f, const char* s) {
        if (f && s) {
                ofstream out(f);
                if (out.fail()) {
                        cerr << "handler::fileout fail " << f << endl;
                } else {
                        out << s << endl;
                }
        }
}


char* filein(const char* f) {
static char file_result[1024];
        ifstream in;
        in.open(f);
        if (in.fail()) {
                cerr << "handler::filein fail " << f << endl;   
        } else {
                in >> (char*) file_result;
                return (char*) file_result;
        }
}

//@ print exceptions 

void print(corba::exception& ex) {
	OBPrintException(ex);
	}


public: //@ dangerous

void* orb() { return (CORBA_ORB*) _orb; }
void* boa() { return (CORBA_BOA*) _boa; }

public: //@ ...
CORBA_ORB_var _orb;
CORBA_BOA_var _boa;
CORBA_String_var _str;
};

#ifndef broker
#define broker ooc_broker
#endif

#endif
