%%@ broker.pl  -- adapted from swi corba pl - hush

:- write(consulting(broker)),nl.

broker(client(M:F)) :-
	atom(M),
	concat(libplclt,M,LIB),
	concat('PL_',M,N1), concat(N1,'__Initialize',FUN),
	load_foreign_library(LIB, FUN),
	corba_initialize_orb([], _),
	factory(F).



%%@ Creating a server agent(?)

:- use_module('/home/eliens/hush/lib/hush/3.1/library/pl/corba/ior').
%%:- use_module('pl/ior').
:- use_module(library(shlib)).

:- dynamic mod_name/1.

broker(server(M:I)) :-
	write('In main_pred'),nl,
	use_module(M),
	unix(argv(Args)),
	(append(_,['-mod',ModName|_],Args)
        ->  write('Reading for mod')
        ;   ModName = I,
	    write('Default mod : ')
	),
	write(ModName),nl,
	corba_initialize_server([server,server(test),timeout(infinite)],Servr),
	concat(I,'_create_true',_Create),
	concat(I,'Server',_Server),
	G =.. [_Create,_Server,Self],
	write(calling(G)),nl,
	call(G),
	%%'world_create_true'('worldServer',Self),
	corba_object_to_string(Self,IOR),
	assertz(mod_name(ModName)),
	concat(ModName,'.ref',IORFile),
	open(IORFile,write,Fd),
	format(Fd,'~w',[IOR]),
	close(Fd),
	write(entering(corba_main_loop(Servr))),nl,
	corba_main_loop(Servr).

%%</>

%%@ never mind

progress(Goal) :-
	progress_message(Goal),
	(   Goal
	->  format('ok~n', [])
	;   format('FAILED~n', [])
	).
	
progress_message(call(Pred, _, _)) :-
	format('~N~w ... ', [Pred]),
	flush.


		 /*******************************
		 *	     INTERFACES		*
		 *******************************/

:- dynamic
	interface_cache/2.

interface(Name, Interface) :-
	interface_cache(Name, Interface), !.
interface(Name, Interface) :-
	factory(Factory),
	concat_atom([factory_make, Name], '_', Pred),
	call(Pred, Factory, Interface),
	asserta(interface_cache(Name, Interface)).


		 /*******************************
		 *	     FACTORY		*
		 *******************************/

:- dynamic
	'_test_factory'/1.

factory(Ref) :-
	'_test_factory'(Ref), !.
factory(Ref) :-
	read_ior('world.ref', IOR),
	corba_string_to_object(IOR, Ref),
	asserta('_test_factory'(Ref)).

read_ior(File, Atom) :-
	open(File, read, Fd),
	get0(Fd, C0),
	read_stream(C0, Fd, Chars),
	atom_chars(Atom, Chars).

read_stream(-1, _, []) :- !.
read_stream(X, Fd, T) :-		% delete blank space while reading
	X =< 32, !,
	%%AE write(reading(X,Fd,T)), nl,
	get0(Fd,C1),
	read_stream(C1,Fd, T).
read_stream(C0, Fd, [C0|T]) :-
	get0(Fd, C1),
	read_stream(C1, Fd, T).
%%</>
