<document>
:@+ The interface -- IDL

<include file=navigate>

An <em>interface</em> written in IDL is the point
of reference for every CORBA application.
It informs the client what to expect from a server,
and it tells the server what services it is to deliver.
<p>
The definition below defines a module <em>universe</em>
that contains an interface named <em>world</em>.
The <em>world</em> interface provides the method <em>hello</em>
and two additional methods <em>ask</em> and <em>tell</em>.

<slide mode=hide cap="universe.idl">
%%@ <a href=universe.idl.html>universe.idl</a>
<program>
<include file=universe.idl>
</program>
</slide>

The <em>ask</em> and <em>tell</em> methods were introduced
to show how CORBA deals with <em>in</em> and <em>out</em> or
result parameters.
<p>
In addition, the <em>world</em> interface supports a method <em>halt</em>,
which was introduced to stop the world on the client's demand.
In actual applications, you do not want to provide
such a method without ensuring that the client has the
right to stop the <em>world</em>.
</document>
