<document>
CORBA is an impressive technology.
It allows for writing heterogeneous platform-independent
and language-independent client/server object systems.
Most software developers, including those trained
in object orientation, are unfamiliar with
developing distributed applications.
As a consequence, writing a CORBA application may
seem to be beyond reach.
<p>
This example is meant to break that barrier,
and to show the elementary steps to be taken in writing
a CORBA application.
To complicate matters a bit, we write a three-language system,
consisting of three servers and three clients, written
respectively in C++, Java and Prolog.

\slyname{H}
<slide color=yellow cap="Hello (CORBA) Universe">
:@ Hello (CORBA) Universe
/// <box>H</box>
<ul>
<li> platform-independent
<li> language-independent
<li> server -- C++, Java, Prolog, ...
<li> client -- C++, Java, Prolog, ...
<li> 9 combinations -- <a href=test.sh.html>test.sh</a>
</ul>
</slide>

Admittedly, the <em>Hello Universe</em> example
presented here is slightly more complex than the 
<a href=../java/objects><em>Hello World</em></a> example
given in the appendix 
on <a href=../java/contents.html>Java</a>.
<p>
In the example, it is shown in complete detail how to write clients and servers
in the three respective languages, how to write a test program
to test all possible combinations and how to manage the configuration
of a CORBA application.
<p>
The example is based on the original <em>Hello World</em> example
that came with Orbacus 3.1 from 
<a href=COPYRIGHT-OOC.txt.html>Object-Oriented Concepts</a>
and examples from the experimental
<a href=COPYRIGHT-SWI.txt.html>SWI-Prolog</a> CORBA binding
for Orbacus 3.1.
</document>
