<document>

@# <a href=talk.html target=_top>The language DLP</a>
\label{DLP}
\markitright{The language DLP}

<include file=navigate>

\slyname{E}
Apart from what may be considered the
mainstream languages Smalltalk, Eiffel, C++ and Java,
there are numerous
other (experimental) languages incorporating
the object paradigm in one way or another.
See section \ref{classification} and, for example,
[_Davison93] for an overview. 
Of particular interest
is the combination of the logic programming
paradigm with object orientation,
of which the language DLP is an example.


\slyname{E}
\vfig{1}
<slide id=app-E caption="The language DLP">
:@ DLP <em> -- introduces logic into object orientation</em>
<zline><box>E</box></zline>
<ul><li> <em>DLP = LP + OO + <math>||</math></em></ul>
:@ Design principles <em> -- support for knowledge-intensive applications</em>
<ul>
<li> objects {\em -- dynamic states}
<li> processes {\em -- communication by rendezvous}
<li> distributed backtracking {\em -- exhaustive search}
</ul>
</slide>
\vfig{1}

The DLP language combines logic programming (LP)
with object orientation (OO) and parallelism ($||$).
DLP is a (very) high-level language, meant to support
the development of knowledge-intensive applications.
In addition to the logic programming features,
it provides {\em objects}
(that may change their state dynamically),
{\em processes} (such as active objects, that communicate
by rendezvous),
and it allows for {\em distributed backtracking}
(to enable exhaustive search in a logic programming style).
See  [_Eliens92] for a full treatment.

<include file=txt>
</document>
