<document>

<include file=navigate>

:@ Inheritance
DLP supports static inheritance, by code sharing,
as do Smalltalk, Eiffel, C++ and Java.
For a discussion of dynamic inheritance, by delegation,
see section <ref file=@online/oo/I/5/prototypes>prototypes</ref>.
As an example of inheritance in DLP,
look at the refinement of the $travel$ object
into a veritable $agency$.
\see{dlp-inheritance}


<slide id=dlp-inheritance caption="DLP -- inheritance">
<v>
<program>
object agency : travel { /// <box>agency</box>
agency() :- accept( any ), agency().
book(X,Y) :-
	reachable(X),
	price(X,Y).
price(amsterdam,5).
 ...
}
</program>
\ifsli{}{\vspace{-0.2cm}}
</slide>

An $agency$ offers the user, in addition to the
functionality offered by $travel$,
the opportunity to $book$ for a particular
destination and be informed of its price.
<p>
Inheritance in DLP conforms to the subsumption
relation for logical theories,
in that it extends the functionality of a given object
in a strict manner.
DLP allows for multiple inheritance and even checks
for cycles to protect the user from repetitions
or cycles in the inheritance chain.
</document>
