<document>

<include file=navigate>

<slide id=eiffel-expr caption="Eiffel -- type expressions">
:@ Type expressions <em> -- conformance</em>
\ifsli{\vspace{-0.5cm}}{}
<I
- basic types <em> -- Boolean, Integer</em>
- formal parameter types <em> -- Array[T], List[T]</em>
- class types <em> -- user-defined</em>
- anchored types <em> -- <b>like</b> current</em>
I>
\ifsli{\vspace{-0.5cm}}{}
:@ Value expressions
\ifsli{\vspace{-0.5cm}}{}
<I>- arithmetic, comparison, method evaluation <em> -- $o.m(...)$ </em>
\ifsli{\vspace{-0.5cm}}{}
:@ Assignment
\ifsli{\vspace{-0.5cm}}{}
<I>- $ var := expression $
\ifsli{\vspace{-1cm}}{}
</slide>

:@ Expressions
Eiffel is a strongly typed language.
In Eiffel,
variables must be explicitly typed by
means of a declaration involving type expressions.
Type  expressions range over {\em basic types}
(such as $Boolean$ and $Integer$),
{\em formal type parameters} of generic types
(as the $T$ in $Array[T]$, which stands for the
type of the elements of the array),
{\em class types}
(that are defined by the user)
and
{\em anchored types},
for instance {\em like current}
(which results in the type of the $current$ object,
or $self$ in Smalltalk terminology).
Anchored types present some problems for the type safety
of Eiffel programs. See section \ref{self-reference} for a discussion.
<p>
In [_Meyer88] {\em conformance} rules are specified
which are used to determine
whether a given type is
a subtype of another type.
See section \ref{subtypes} for an extensive discussion
of the subtyping relationship.
<p>
Value expressions in Eiffel  comprise the familiar
arithmetical and comparison operations,
as well as the message expressions of the form
$o.m(...)$
that result in the evaluation of the method $m$
by the object $o$.
Parameter passing in Eiffel
is positional.
\see{eiffel-expr}
</document>
