<document>

<include file=navigate>

:@ Inheritance
Eiffel supports multiple inheritance.
As an example, look at the class
{\em FixedList} in \sliref{eiffel-inheritance},
which is implemented as
a combination (by inheritance) of
a generic $List$ and a generic $Array$.

<slide id=eiffel-inheritance caption="Eiffel -- inheritance">
:@ Multiple inheritance
<program>
<i>class</i> Fixed_List[T] <i>export</i> ...
<i>inherit</i>
	List[T]
	Array[T]
<i>feature</i>
 ...
<i>end</i>
</program>
\vspace{-0.5cm}
</slide>

Using (multiple) inheritance implies
that a $FixedList$ may be regarded as
a subtype of both $Array$ and $List$.
However, the $export$ list in the end determines
what interface is provided
and hence what type the class embodies.
</document>
