<document>

<include file=navigate>

:@ Terminology
The design of Eiffel also reflects a concern with the
software engineering issues involved in the development
and maintenance of class libraries.
The language is built around a number of keywords,
which accounts for an easy to read, albeit somewhat verbose,
layout of programs.

\vstr{1}
<slide id=eiffel-term caption="Eiffel -- terminology">
:@ The language Eiffel <em> -- keywords</em>
<ul>
<li> {\it class} -- a model for a set of objects
<li> {\it feature} -- attribute, function, procedure
<li> {\it export} -- interface declaration
<li> {\it inherit} -- class inclusion and subtyping (!)
<li> {\it redefine, rename} -- to change inherited features
<li> {\it deferred} -- to postpone the implementation
<li> {\it require, ensure, invariant} -- assertions
</ul>
<ignore>
\ifsli{\vspace{-0.5cm}}{}
<!-- \nl
{%%\footnotesize -->
{\it class} -- a model for a set of objects<br>
{\it feature} -- attribute, function, procedure<br>
{\it export} -- interface declaration<br>
{\it inherit} -- class inclusion and subtyping (!)<br>
{\it redefine, rename} -- to change inherited features<br>
{\it deferred} -- to postpone the implementation<br>
{\it require, ensure, invariant} -- assertions<br>
<!-- } -->
</ignore>
</slide>

The keyword {\em class} precedes a class definition,
which,
%%in the terminology of [_Meyer88]
according to [_Meyer88],
may be considered as a model for a collection of objects.
The keyword {\em feature} precedes the attributes, functions
and procedures defined by a class.
The keyword {\em export} precedes the list of visible
features, in other words the interface declaration of the class.
The keyword {\em inherit} precedes the list of inherited
classes, specifying class inclusion and the subtyping
relationships.
The keywords {\em rename} and {\em redefine}
are used to change inherited features.
The keyword {\em deferred} may be used to indicate
that a feature will be implemented (in the future) in an inherited
class,
and the keyword {\em obsolete} may be used to indicate
that a feature will not be supported in a future release.
Finally, the keywords {\em require}, {\em ensure}
and {\em invariant} indicate assertions that specify
respectively the pre- and post-conditions
for a (method) feature and the class invariant.
</document>
