<slide id=10-answers color=red type=hide cap="Answers">
:@+ <a href=@online/oo/III/10/@slide-Questions.html>Chapter 10</a>
<include file=navigate>

<N

- Conformance not only involves
syntactic properties, but behavioral
properties as well.
Behavioral properties include
invariant properties and history
properties.
See <sliref id=10-properties file=@online/oo/III/10/types>.
%%\see{10-properties}

- See <sliref id=10-history file=@online/oo/III/10/types>.
%%\see{10-history}

- Static constraints may be expressed
directly in the signature,
but also by means of pre- and post-conditions.
To a certain, but definitely lesser, extent,
the reverse is also true.
See <sliref id=10-constraints file=@online/oo/III/10/types>.
%%\see{10-constraints}

- States may be modeled as functions
and state transformations as 
function modifications.
See <sliref id=10-verification file=@online/oo/III/10/verification> 
and <sliref id=10-subst file=@online/oo/III/10/verification>.

- There are two ways to verify the
behavior of a program:
(a) prove for each possible
transition that the formula holds;
and
(b) employ the correctness calculus
given in 
<sliref id=10-correctness file=@online/oo/III/10/verification>.

- For each syntactical kind of statement
allowed by the language,
a transition system specifies 
a corresponding execution step,
or series of such steps,
by means of a transition derivation rule.
An example transition system for
a simple object-based language,
supporting object creation and message
passing, is given in
section <ref file=@online/oo/III/10/behavior>behavior</ref>.

- To prove that a realization is 
correct with respect to its
abstract specification,
one must prove that each concrete operation
satisfies the constraints imposed on
the abstract level.
See <sliref id=10-ADT file=@online/oo/III/10/subtyping>.

- See <sliref id=10-specification file=@online/oo/III/10/subtyping>,
<sliref id=10-realization file=@online/oo/III/10/subtyping> and 
<sliref id=10-absf file=@online/oo/III/10/subtyping>.

- Correspondence between subtypes
involves syntactic constraints,
defined by the subtyping rules
given in chapter 9,
behavioral constraints,
as characterized by the refinement
relation for pre- and post-conditions
and invariants,
and constraints for the extensions,
as expressed by the diamond rule.
See <sliref id=10-correspondence file=@online/oo/III/10/subtyping>
and <sliref id=10-subtyping file=@online/oo/III/10/subtyping>.

- See <sliref id=10-ex-subtype file=@online/oo/III/10/subtyping>,
<sliref id=10-ex-correspondence file=@online/oo/III/10/subtyping>
and <sliref id=10-ex-proof file=@online/oo/III/10/subtyping>.

- Invariance properties of objects cannot
completely be checked locally, within the confines of
a single object.
See <sliref id=10-invariants file=@online/oo/III/10/invariants>.
Checking invariants explicitly for each object,
however, is likely to be too expensive.

- Formal methods to specify
the interaction between objects
include model-based specification
methods,
the specification of contracts
as behavioral compositions,
the specification of cooperating
actors by means of scripts,
the specification of
multi-party interactions,
and the specification of joint action systems.
See <sliref id=10-interaction file=@online/oo/III/10/composition>.
%%\see{10-interaction}
N>
</slide>
