<slide id=5-answers color=red type=hide cap="Answers">
:@+ <a href=@online/oo/II/5/@slide-Questions.html>Chapter 5</a>
<include file=navigate>

<N
- Object-oriented languages
generally offer a facility for
creating objects,
the capability of message passing,
classes and inheritance.
See <sliref id=5-classification file=@online/oo/II/5/paradigm-cat>.
%%\see{5-classification}

- A classification of object-oriented
languages may distinguish between
hybrid languages, frame-based
languages as employed in artificial
intelligence,
parallel/distributed languages
and languages supporting prototypes.
%%\see{5-classification}
See <sliref id=5-classification file=@online/oo/II/5/paradigm-cat>.

- Characteristic for the object model supported
by C++ is the unification of classes
with the $struct$
record type.
%%\see{5-structure}
See <sliref id=5-structure file=@online/oo/II/5/paradigm-ext>.

- Friends may be classes or functions.
They are allowed access to the private parts
of an object.
They may be necessary for reasons of efficiency.
Friends are a relatively safe feature,
since they must explicitly be declared
by the class itself.
They are not inherited.
Neither is it possible for a class or
function to declare itself as a friend
of a class.
Nevertheless, friends may jeopardize
the integrity of an object.
Treat friends with care.


- Object-based implies support for
encapsulation,
whereas object-oriented implies
support for encapsulation and inheritance.
%%\see{5-object-based}
See <sliref id=5-object-based file=@online/oo/II/5/dimensions>.

- As orthogonal dimensions along
which to describe the design of
object-oriented languages you may
distinguish between objects, types,
delegation and abstraction.
%%\see{5-orthogonal}
See <sliref id=5-orthogonal file=@online/oo/II/5/dimensions>.

- Active objects are, basically, objects with threads.
Synchronous active objects, as supported by sC++,
support method call by rendez-vous, protecting
the object from unsafe access.
Active objects may be used instead of event-loops
and callbacks, thus avoiding the need to merge
multiple event-loops.
See section <ref file=@online/oo/II/5/dimensions-active>Active</ref>.

- Prototype-based languages support an object
model based on exemplars.
Their most characteristic feature
is support for dynamic delegation.

- Inheritance is static;
it amounts to creation-time sharing,
whereas delegation supports lifetime
sharing.
%%\see{5-prototypes}
See <sliref id=5-prototypes file=@online/oo/II/5/prototype-share>.
<p>
Both C++ and Java support the forwarding
of member function calls.
Forwarding does not, however, allow
for binding self-reference to the forwarding
object.

- In classical object-oriented languages,
the notion of class stands for
object generator and interface description.
A class may further be a repository
for sharing resources
and act as an object capable of
answering (class) methods.
%%\see{5-class}
See <sliref id=5-class file=@online/oo/II/5/meta>.

- See <sliref id=meta-architecture file=@online/oo/II/5/meta>.

- The first three postulates
given in <sliref id=5-postulates file=@online/oo/II/5/meta>
pertain to Smalltalk.
With some minor modifications,
these postulates hold for other
classical languages.
The fourth postulate of <sliref id=5-postulates file=@online/oo/II/5/meta>
specifies the constraint that must be met
by a reflective architecture:
class variables of an object must be
instance variables of the class of
the object (when considering the
class as an object).
N>
</slide>
