<document>
<slide id=9-answers color=red type=hide cap="Answers">
:@+ <a href=@online/oo/III/9/@slide-Questions.html>Chapter 9</a>
<include file=navigate>
@$=raw
<N
<li> In knowledge representation,
inheritance is primarily applied
to describe taxonomic structures
in a declarative way.
Employing exceptions in inheritance
networks leads to non-monotony.
Non-monotonic inheritance networks
may give rise to inconsistencies.
%%\see{9-knowledge}
See <sliref id=9-knowledge file=@online/oo/III/9/inheritance>.

<li> The meaning of an inheritance lattice
may be expressed as a first-order logic
formula.
An example is given in
<sliref id=9-logic file=@online/oo/III/9/inheritance>.

<li> A type denotes a set of individuals.
The subtyping relation is essentially
the set inclusion relation,
with some additional constraints.
However, the subtype relation is best
defined by means of subtype refinement
rules.

<li> 
%%\see{9-subtypes}
See <sliref id=9-subtypes file=@online/oo/III/9/subtypes-refine>.

<li> The contravariant nature of the
function subtype refinement rule
may be explained by relying on the
business service metaphor:
refining a service means better work
for less money.
Or, put differently,
refining a function means imposing 
less constraints on the client,
yet delivering a result that is
more tightly defined.
%%\see{9-functions}
See <sliref id=9-functions file=@online/oo/III/9/subtypes-refine>.

<li> The notion of {\em objects as records}
is introduced simply to justify
the interpretation of objects as records or
tuples of values and functions.
Again employing a business metaphor,
regarding an object as a collection 
of services, improving such a collection
means offering more, and possibly
better, services.
%%\see{9-objects}
See <sliref id=9-objects file=@online/oo/III/9/subtypes-objects>.

<li> Typed formalisms provide protection
against errors.
Yet, untyped formalisms are generally more
flexible.
In the practice of computer science
and mathematics, untyped formalisms
are surprisingly popular.

<li> A first distinction may be made between
universal polymorphism and {\it ad hoc} polymorphism,
which accounts for overloading and 
coercion.
Universal polymorphism may be subdivided
into parametric polymorphism,
which covers template classes,
and inclusion polymorphism,
which results from derivation by inheritance.
%%\see{9-flavors}
See <sliref id=9-flavors file=@online/oo/III/9/flavors>.

<li> Inheritance allows for
the incremental development of object descriptions.
A child class may be regarded as
modifying the parent base class,
as it may include additional attributes
and methods and may refine inherited
attributes or methods.

<li> See slides <sliref id=9-c-subtypes file=@online/oo/III/9/types>,
<sliref id=9-c-intersection file=@online/oo/III/9/types>
and <sliref id=9-c-bounded file=@online/oo/III/9/types>.

<li> (a) $ {{ a : Int , f : Int -> Int }} $,
(b) $ Int -> Int $,
(c) $ {{ a : Bool, f : Bool -> Int }} -> Int $.

<li> (a) No, since $ 1..4 \not<= 2..5 $.
(b) No, since
$ f : Bool -> Int \not<= f : Int -> Int $,
because $ Int \not<= Bool $.
(c) Yes, since 
$ {{ a : Bool, f : Bool -> Int }} <= {{ a : Bool }} $.

<li> To give an example, 
if you have a record $x$ of
type
$ \E %a. {{ val : %a . op : %a -> Int }} $
then you do not need to know the precise
nature of the (hidden) type $%a$
to be able to type the expression
$ x.op( x.val ) $ as $Int$.
%%\see{9-ADT}
See <sliref id=9-ADT file=@online/oo/III/9/existential>.

<li> A possible realization is given by the
record
$ {{ a = 0, f = %l  x.E }} $,
for $ E = if \, even(x) \, then \, true \, else \, false $.
The corresponding package is given
by the expression
$ pack [ %a = Int \, in \, {{ a : %a , f : %a -> Bool }} ] ( 0, %l x.E ) $.
Another realization is given by the record
type
$ {{ a : R, f : R -> Bool }} $
where $R$ stands for
$ {{ x : Int, y : Int }} $.

<li> The proof involves unrolling.
Let $ T_1 =  %m %a.{{ c : %a, b : %a -> %a }} $
and
$ T_2 = %m %a.{{ b : %a -> %a }} $.
Now suppose that $ T_1 <= T_2 $ then,
by unrolling, we would have
that
$ {{ c : T_1, b : T_1 -> T_1 }} <= {{ b : T_2 -> T_2 }} $,
and hence, by the function subtyping rule,
that $ T_2 <= T_1 $ and $ T_1 <= T_2 $.
This would only hold if $ T_1 = T_2 $,
which is obviously not the case.

<li> Let $ %s = %m %a.{{ c : %a, b : %t -> %a }} $
and assume that $ %s <= %t $,
then by unrolling
we have that
${{ c : %s, b : %t -> %s }} <= {{ b : %t -> %t }} $
which clearly holds since
$ b : %t -> %s <= b : %t -> %t $.
And, by applying the refinement rule
for recursive types
(given in <sliref id=9-recursion file=@online/oo/III/9/self>),
we indeed have that $ %s <= %t $.
N>
</slide>
</document>
