<document>
:@+ Language bindings

<include file=navigate>

A language binding for IDL must satisfy a number of requirements.
<c>See <a href=http://www.infosys.tuwien.ac.at/Research/Corba/OMG/cmap.htm#2981>CORBA Reference</a>.</c>

<slide cap="Language bindings">
:@ Language bindings
*- types, references, access, ORB and BOA support
:@ The <em>Object</em> interface
<display>
interface Object { /// <box>PIDL</box> 
	InterfaceDef get_interface();
	Object duplicate();
	...
}
</display>
\vspace{-0.5cm}
</slide>

Naturally, the mapping must support
IDL basic and constructed types, references to
objects and constants, and access to attributes and
operations.
<p>
In addition it must provide the signatures
for operations defined by the Object Request Broker
(which transmits requests over the network)
and the Basic Object Adaptor (which translates
method requests to actual object method or function invocations). 
<p>
Access to the ORB and BOA is usually provided by means
of so-called pseudo-objects, objects described by interfaces
in IDL which are not necessarily implemented as ordinary objects. 
As an example, the <em>Object</em> interface describes
the functionality that each IDL-defined object has.

</document>
