<document>
:@+ Interfaces and inheritance

<include file=navigate>

Interfaces define polymorphic object types.
An interface may be realized by any object
that supports the operations specified in
the interface.

<slide cap="Interfaces and inheritance">
@ Interfaces and inheritance
*- no overriding, no overloading
@ Multiple (interface) inheritance
<display>
interface A {  };
interface B {  };
interface C : A { };
interface D : B, A { };
</display>
\vspace{-0.5cm}
</slide>
<p>
Interfaces can inherit from other interfaces.
This results in augmenting the interfaces
with the attributes and operations of the inherited interface.
However, in contrast to class inheritance in C++,
IDL does not allow for operations to be overridden,
nor for overloading operations,
that is different signatures for the same operation.
<p>
Multiple (interface) inheritance is supported however,
provided that no clashes or overloading occurs.

:@ The Object interface
Each object type defined in IDL may be assumed to be
derived from the interface <em>Object</em>.
For example, when defining an <em>iterator</em> type
the interface may look as follows:
<slide mode=hide id=idl-iter cap="iterator">
<program>
interface iterator { /// <box>iterator</box>
        Object next();
        };
</program>
</slide>
It is the responsibility of the implementation
to downcast the object type to its actual type.

</document>
