The Interface Definition Language (IDL) 
that accompanies CORBA-2.0 provides the constructs
needed to specify interfaces only.
<p>
IDL allows for specifying modules, consisting of interfaces.
An interface specification may contain (read only) attributes
and operations. Operations are synchronous, unless 
annotated as <em>oneway</em>.
Operations may raise exceptions upon failure.

\slyname{G}
<slide cap="Interface Definition Language -- IDL">
@ Interface Definition Language
/// <box>IDL</box>
<ul>
<li> modules -- for clustering
<li> interfaces -- correspond with objects
<li> attributes -- may be read only
<li> operations -- best effort invocation
<li> exceptions -- for handling failure
</ul>
\vspace{-0.2cm}
:@ Language bindings
*- C, Smalltalk, C++, Java
<control>
<hr>
See http://www.infosys.tuwien.ac.at/Research/Corba/OMG
</control>
\vspace{-0.15cm}
</slide>

<p>
Although IDL is syntactically very similar to C++ or Java,
it completely lacks the algorithmic constructs of these languages.
Objects specified in IDL must be realized in one of the
languages for which an official IDL language binding exists,
such as C, Smalltalk, C++ or Java, or an unofficial binding,
such as Python, Perl and Prolog.
