<document>
:@+ Operations and exceptions

<include file=navigate>

An operation or method specifies a service
that a client may request of an object.
Operations may result in a value. 
Each parameter of an operation has a type and
a modifier indicating whether it is an input, output,
or combined <em>inout</em> parameter.

<slide cap="Operations and exceptions">
:@ Operations
*- in, out, inout -- parameter attributes
:@ Exceptions
<display>
exception out_of_range { long count; }

interface writer {
  void position(in long pos) raises(out_of_range);
  }
</display>
\vspace{-0.5cm}
</slide>

The signature or type of an operation may also 
include one or more exceptions that may be raised.
Exceptions may contain data fields.
<p>
The signature of operations may also be assembled
dynamically, through the <em>dynamic invocation interface</em>
of the ORB.
The semantics for such requests are the same as
for requests via the operation stub generated
from the interface specification.

</document>
