<document>
<!--\def\parll{\parallel}-->

<include file=navigate>

:@ Expressions
Java supports {\em basic types}
(including $int$, $char$ and $float$)
and {\em compound types} similar to C++.
It does not offer pointer or reference
types.
However, it  offers <em>Array</em> and <em>String</em> types.
No need to say that
it also allows for user-definable classes.

@$=P

<slide caption="Java -- expressions (1)">
:@ Type expressions
<I
- basic types <tt> -- int, char, float, ... </tt>
- Array  -- <em> int $ar[SIZE]$ </em>
- String  -- <em> $String[] args$  </em>
- class -- <em> user-defined</em>
I>
\vspace{-0.15cm}
</slide>

It will be no surprise that the expressions also
are similar to those of C++. 
However, Java does <red><em>not</em></red> allow
for operator overloading. That means that 
the operators, as listed below, may only be used
for the built-in types.
<p>
The operators defined for the built-in types
do sometimes behave in an unexpected way.
For example, whereas the $ + $ operator defined for
<em>String</em> concatenates two strings (as expected),
the comparison operator $ == $ does not compare the values
of the two strings, but instead the (opaque)
references. One must use $ s1.equals(s2) $
to compare the values of the strings $s1$ and $s2$.

<slide caption="Java -- expressions (2)">
:@ Expressions
<I
- operators --  $ + , - $,..,$ < $, $ <= $,..,$ == $, $ ! = $,.., &amp;&amp; , <math>||</math>  
- indexing -- <em> $o[ e ]$ </em>
- access -- <em> $o.m(...)$ </em>
- in/decrement  -- <em> <tt>o++</tt>, <tt>o--</tt></em>
- conditional -- <em> $ b?e1:e2$ </em>
I>
\vspace{-0.15cm}
:@ Assignment
<I
- $ var = expression $
- modifying -- $+=$. $-=$, ...
I>
\vspace{-0.15cm}
</slide>

Value expressions may be created using
arithmetic and comparison operators
(including <tt> == </tt> for equality and <tt> != </tt>
for inequality).
<p>
As logical operators Java includes, as C++,
conjunction (<tt>&amp;&amp;</tt>) 
and disjunction (<tt><math> || </math></tt>),
as well as a number of bitwise logical operators.
Also, we have an {\em indexing} operator
which, unlike for C++, may be <red>not</red> defined 
for arbitrary types.
Access to both static and dynamic methods involves
the use of the <em>dot</em> operator.
<p>
The <em>increment</em> and <em>decrement</em>
are defined only for the scalar types. 
Also, we have a conditional expression of the form
<em> b?<math>e_1</math>:<math>e_2</math></em> testing the condition
<em>b</em> to
deliver <math>e_1</math> when it evaluates to true
and <math>e_2</math> otherwise.
<p>
Assignments in Java, like in C++,
are written as <em>var = expression</em> with a single <em>=</em>
symbol.
As remarked previously,
this convention is known to cause mistakes by programmers
raised with languages such as Pascal or Modula-2.
<p>
In addition, Java offers, like C++, modifying assignments,
which may be used as, for example, in <em>n += 1</em>,
which is identical in meaning to <em>n = n + 1</em>.
</document>
