<document>

@# <a href=talk.html target=_top>The language Java</a>
\markitright{The language Java}

<include file=navigate>

\slyname{D}
Java has a direct heritage from C++.
Started as an interpreted C++ like language under the name Oak,
it became a hype due to its introduction
as <em>the dial-tone of the Internet</em> in 1995.


\vfig{1}
<slide id=appendix-java caption="The language Java">
\footnotesize
:@ Java <em> -- the dial-tone of the Internet</em>
/// <box>D</box>
<control>
<display>
 1995   Introduction at WWW3
 1996   1.0 with AWT
 1997   1.1.x with modified event handling
 1998   version 1.2 (beta) with Swing
</display>
</control>
<latex>
\begin{verse}
 1995 \ \   Introduction at WWW3 \\
 1996 \ \   1.0 with AWT \\
 1997 \ \   1.1.x with modified event handling \\
 1998 \ \   version 1.2 (beta) with Swing
\end{verse}
\vspace{-0.2cm}
</latex>
\ifsli{\vspace{1cm}}{}
:@ Design principles <em> -- safety</em>
<ul>
<li> a modern programming language 
<li> C++ syntax, no pointers 
<li> virtual machine (runs on many platforms) 
<li> libraries: threads, networking, AWT 
<li> downloadable classes 
<li> support for applets 
<li> extensions and APIs: Beans, Swing, MEDIA, 3D 
</ul>
<p>See: http://www.javasoft.com
<br>and http://java.sun.com/docs/books/tutorial
\ifsli{\vspace{-1cm}}{}
\vspace{0.1cm}
</slide>

<p>
The impact of Java has been enormous,
not only in terms of its adoption in the software
industry, but also in terms of the number of books written
and sold.
%%<p>
Java has also become the language of choice for 
introductory programming courses.
<p>
The original design purpose stated for Java
was to provide a safe environment for executing
so-called applets, written in a general purpose
programming language, in a Web-browser. 
For that reason Java programs are executed by a virtual
machine, in which the programs can be executed as
in a <em>sandbox</em> protecting the environment
from possibly malicious programs.
In addition, the virtual machine gives a high degree
of platform independence.
The slogan that has accompanied the introduction of Java,
<em>write once, run everywhere</em> does nevertheless
not completely hold true when it concerns user interfaces,
since the particularities of the various platforms have proved to
be hard to master.
<p>
Whatever one may think of Java as a language, 
a lot of effort is put into coming to an agreement
about the numerous APIs that are part of the Java platform.
These include the Swing GUI framework, the component Beans,
the reflection API, the native code interface,
the multimedia framework, not forgetting the Java3D
and VRML classes.
This makes the Java platform indeed a very powerful
and productive environment.
<p>
Java is very well documented.
Apart from the many books about Java, there
is also an excellent tutorial online, for free.
See the URLs in \sliref{appendix-java}.

<include file=txt>
</document>
