<document>

<include file=navigate>

:@ Objects
An object is an instance of a class.
In Java, a program is executed by calling the
static $main$ method a class.
Look for example at the $HelloWorld$ class
in \sliref{Java-objects-1}.

<slide cap="Java -- objects (1)"> 
:@ Hello World -- Java (1)
<display>
%%// Author: Martin Mellody
public class HelloWorld {
public static void main(String[] args) {
       System.out.println("Hello World");
       }
};
</display>
\vspace{-0.3cm}
</slide>

The $HelloWorld$ example is taken from a collection
of <em>hello world</em> programs 
%%written in a large variety of languages
located
at http://www.latech.edu/~acm/HelloWorld.shtml<!---->.
<control>See <a href=hello.html>hello</a> for
a sample of this collection.</control>
<p>
To illustrate the use of <em>interface</em> definitions,
\sliref{Java-objects-2} presents a slightly modified version.
The actual $HelloWorld$ class announces that it
<em>implements</em> the $World$ interface.


<slide cap="Java -- objects (2)"> 
:@ Hello World - interface
<display>
public interface World {
public void hello();
};
</display>
:@ Hello World - class
<display>
public class HelloWorld implements World {
public void hello() {
       System.out.println("Hello World");
       }
};
</display>
\vspace{-0.3cm}
</slide>

Both classes make use of the standard out stream defined
in the class $System$ to emit their message to the world.
</document>
