<document>

<include file=navigate>

:@ Technology
The Java platform, that is the Java language enriched 
with the numerous libraries, frameworks
and extensions, offers the software developer a
rich environment for developing (distributed)
Internet-aware applications.
<p>
Perhaps the most well-known feature of Java
is its support for so-called <em>applets</em>,
light weight applications that may enrich your Web-browser
with graphics, multimedia and additional communication
facilities.
Browsers such as Netscape and Microsoft Internet Explorer
have an embedded Java Virtual Machine that enables them
to execute Java applets. 
Applets may also be executed by the Java
plugin that has been provided by Sun Microsystems
as an alternative to the browsers' built-in virtual machines.

<slide cap="Java -- techniques">
:@ Java -- techniques
<ul>
<li> applets -- extend your browser
<li> servlets -- extend your server
<li> networking -- urls, sockets
<li> RMI -- remote method invocation
<li> reflection -- meta-information
<li> beans -- component technology
<li> JNI -- writing native methods
<li> javadoc -- online class documentation
</ul>
</slide>

Server-side extensions are made possible by <em>servlets</em>.
The server must then be written in Java,
or provide for a virtual machine.
<p>
Java offers a number of facilities for networking,
including support for retrieving resources by URL,
sockets, and remote method invocation.
Remote method invocation (RMI) may be considered a
light weight alternative for CORBA distributed
programming.
<p>
In contrast with CORBA (version 2.0),
Java allows for sending objects over the network
due to its powerful <em>Reflection API</em>
that gives runtime access to the properties
of objects, including class types and methods.
<p>
The <em>Beans</em> framework offers
component technology, that allows developers to
exchange (beans) objects and inspect their properties
in a uniform manner. For example GUI elements,
written as beans, can be incorporated at runtime
to add the desired functionality to a user interface.
<p>
Another well-designed and powerful feature of Java is
its <em>native interface</em>,
which enables the experienced programmer to embed
native code in Java applications.
No need to say that from a purists' point of view one should avoid this.
<p>
Last but not least, the <em>javadoc</em>
facility must be mentioned.
The <em>javadoc</em> tool allows for creating documentation
directly from the class definitions, that may be annotated
with signature descriptions, and
information about its author, possible exceptions
and comments.

</document>
