<document>

@# <a href=talk.html target=_top>Software development projects</a>
\label{Projects}
\markitright{Software development projects}

\slyname{I}
<control>
<hr>
See also the <a href=http://www.cs.vu.nl/~oo>OO at the VU</a>
homepage.
<hr>
</control>

\label{app-program}
\label{F}

An object-oriented approach to software
development requires an attitude that must
be formed by experience with a practical programming
task, employing object-oriented technology.
In \sliref{vu-prog}, a number of projects are listed
that have served as programming assignments
at the Vrije Universiteit, Amsterdam.


\slyname{I}
<slide id=projects caption="Software development projects">
@ Software development projects
<zline><box>I</box></zline>
<I
- gambling machine 
- interactive video game  /// [_Coplien92]
- simple hypermedia system /// [_Meyro86]
- direct manipulation score editor /// [_Pope91]
- an object-oriented expert system /// [_Hu89]
- 3D animation editor /// [_Ammeraal]
- a simple case tool /// [_CY91b]
- route planner
I>
\ifsli{\vspace{-1cm}}{}
</slide>

The programming language (mandatorily) employed
was C++.
The {\em hush} library
was used for developing graphical user interfaces.
Students were allowed to work in groups of two.
Before starting a project, students were required
to write a synopsis giving a global outline
of the intended functionality of their system.

The minimal design documentation required
was a description of each class interface
in the style of CRC cards.
Students were encouraged to make documentation and help
available online, preferably in a hypertext format.

The programming projects are based on suggestions
found in the literature, with the exception of
the {\em gambling machine} and the {\em routeplanner}.
The {\em gambling machine} seemed nice to allow students
to experiment with animation techniques.

:@ The projects
A typical example of a {\em gambling machine}
is a {\em one armed bandit} with three columns of fruit.
It is important to offer a realistic interface.
Further, one must employ stochastic techniques
to determine the chance of winning.
<p>
An example of an {\em interactive video game}
is a volley or tennis game for one or two players.
One must allow for an option to determine the speed
of the ball and an option for replay.
See [_Coplien92].
<p>
A {\em simple hypermedia} system must be capable of
presenting text and graphics and must allow for
the traversal of links between such items.
An important aspect of this project is
the development of an adequate object model
for the items supported, including links.
See [_Meyro86] and [_Conklin87].
<p>
A {\em direct manipulation score editor}
allows for editing musical fragments interactively.
Some musical knowledge is required for such a project.
The layout of music notation appears to be a difficult
issue, because it is essentially two-dimensional
and involves many special symbols.
See [_Pope91].
<p>
The notion of an {\em object-oriented expert system}
is quite open-ended.
An approach one may take is to implement
a traditional rule-based expert system
in an object-oriented way, using C++.
Take care to include an example knowledge-base
to test the functionality of the system.
See [_Hu89].
A more general approach to employing
object-oriented technology for the development
of knowledge-based systems is described in Eli\"ens (1992).
<p>
A {\em 3D animation editor}
supports the creation of (simple) 3D figures
and must minimally allow for some basic manipulations in 3D
space, such as rotations and translations.
As an additional requirement, there must be a facility
to replay a series of manipulations.
See [_Ammeraal].
<p>
A {\em simple case tool}
allows for the interactive development of
a simple object model,
including the description of attributes of objects
and the inheritance relations between object types.
For an example of such tools, see [_CY91b] and [_Rum91].
<p>
A {\em routeplanner} allows the user to indicate
a starting location and an end location.
The system then calculates an appropriate route,
for example the fastest or cheapest.
As an additional requirement, the system must
allow for the user to ask additional
information about the route and the intermediate
locations situated along the selected route.
This information should preferably be in multimedia format.

:@ Comments
The {\em routeplanner} has successfully been used
as an assignment as part of a CS2 Software Engineering
course.
Students, indeed, took the opportunity to experiment
with the multimedia facilities of {\em hush}.
Some of the other project assignments, such as the
{\em score editor} and the {\em 3D editor}, have led to
quite remarkable results.
For example, the {\em 3D editor} project led students
to develop a system to wander in 3D virtual space.
Somewhat disappointingly, however,
the {\em object-oriented expert system}
project has not
been chosen thus far.
Perhaps it is regarded as too difficult or as not interesting enough.
<p>
Since the assignments were meant primarily as a means to
gain experience with practical aspects of object-oriented
programming,
students were left free to choose a particular design method.
The use of CRC-style documentation, however, was mandatory.
Quite often, students developed a design employing OMT
notation, which did not necessarily lead to a better result.
<p>
To gain experience with object-oriented
design and analysis, a practical course
focusing on modeling and requirements analysis
is advisable.
Any of the assignments above may be used in such
a course.
Other suggestions may be found in [_Fusion]
and [_Sanden94] (which may be obtained by anonymous ftp at
ftp://isse.gmu.edu/pub/techrep/94_102_sanden.ps.gz).
</document>
