<document>

@# <a href=talk.html target=_top>The language Smalltalk</a>
\marksection{The language Smalltalk}
%%\markleft{The language Smalltalk}

<include file=navigate>
<!--\slyname{A}-->


Smalltalk has been, without doubt,
the most influential of all object-oriented
programming languages.
Originally meant as an {\em easy-to-use}
programming language for the {\em Dynabook}
(a laptop {\em avant-la-lettre}
developed in 1972 at Xerox Parc),
it has developed into a powerful
general purpose programming language
(which has stabilized in Smalltalk-80)
that runs on many platforms.
From the start, an interactive programming environment
has been an integral part of the language
implementation.
Later implementations also include support
for the interactive construction of user interfaces.

<slide id=app-A caption="The language Smalltalk">
\clearfalse
:@ Smalltalk <em> -- a radical change <c>in programming</c></em>
/// <box>A</box>
\ifsli{\vspace{-0.5cm}}{}
<control>
<display>
1972  Dynabook {I -- Alan Kay I}
1976  SmallTalk76
1980  SmallTalk80
1990  ObjectWorks/SmallTalk <em>-- VisualWorks</em>
</display>
</control>
<latex>
\begin{verse}
1972 \ \  Dynabook {I -- Alan Kay I}\\
1976 \ \  SmallTalk76\\
1980 \ \  SmallTalk80\\
1990 \ \  ObjectWorks/SmallTalk <em>-- VisualWorks</em>
\end{verse}
\vspace{-0.2cm}
</latex>
\ifsli{\vspace{1cm}}{}
:@ Design principles <em> -- rapid prototyping</em>
\ifsli{\vspace{-0.5cm}}{}
<I
- uniform object model {\em -- control}
- dynamic typing {\em -- flexible}
- standard libraries {\em -- functionality}
I>
\ifsli{\vspace{-1cm}}{}
\vspace{-0.1cm}
</slide>

Influenced by the ideas of objects and classes embodied in Simula,
the design philosophy underlying Smalltalk
clearly reflects the desire
to effect nothing less than a radical
change in programming practice.
Characteristic for the design of
Smalltalk is a 
{\em uniform object model}
(which is even used to support common
control constructs),
{\em dynamic typing}
(which accounts for much of the flexibility
of Smalltalk)
and a sizeable collection of 
{\em standard library classes}
(providing the functionality necessary
to build complex applications).
Smalltalk has successfully been used,
in particular, for rapid prototyping.

<include file=txt>
</document>
