<document>
\markitright{Unified Modeling Language}
:@+ State and activity diagrams

<include file=navigate>

The characterization of behavior given by interaction
diagrams primarily concerns, as the name says,
the interaction between objects.
The dynamic behavior of the objects themselves and the global
activity can only be inferred from such diagrams.
<p>
An explicit characterization of the dynamic
behavior of an individual object may be given by a state 
transition diagram.

<slide id=uml-state type=fig cap="State diagrams">
<image name=@figures/uml/state>
</slide>

A state transition diagram consists of 
states and transitions between states, indicated by arrows.
The arrows may be indicated by expressions of the form
<slide id=state-label mode=hide>
<display>
  event(arguments)[conditions]/action
</display>
\vspace{-0.4cm}
</slide>
\noindent
indicating that a transition can take place
when a particular event occurs and certain conditions
are satisfied.
The transition will then result in an action,
which may possibly modify state/instance variables.
<p>
Individual states may contain the specification
of actions in response to particular events
and the entry and exit of the state.
States may be grouped to form a single (super)state,
such as <em>state-0</em> in the diagram on the left in \sliref{uml-state}.
<p>
To characterize the overall activity of a system, or parts thereof,
<em>activity diagrams</em> may be used.
Activity diagrams consist of nodes
indicating activities.

<p>
Since activity diagrams are rather unspecific with respect to the
actual objects involved,
such diagrams are most appropriate in analysing aspects of workflow.
In contrast, state diagrams are usually tied to
the implementation of objects, such as event-schedulers,
with complex dynamic behavior.
<p>
Both state diagrams and activity diagrams allow for
parallelism.
In activity diagrams, parallel activity may be assigned to
so-called <em>swim-lanes</em>,
activity falling under the responsibility of
a particular role, an actor or a part of the system.

</document>
