<document>
:@+ Use cases

<include file=navigate>

Use cases define typical interactions between the user and the system.
In other words, use cases define the boundaries between a system
and its users.
Use cases are critical in eliciting the functional requirements
a system must satisfy.

<slide type=fig cap="Use cases">
<image name=@figures/uml/use-case>
</slide>

A typical use case consists of an actor or role
and a more or less detailed description of the actions
that an actor performs to accomplish some task.
A task may for example be the insertion of
text, or the creation of a particular figure in a drawing editor.
A distinction must be made between the overall goals
of a user, like making a decent drawing, and
the actions that must be performed to satisfy these goals.
Only the latter can be the subject of use cases.
<p>
When defining a use case, other use cases can be (re)used,
either through the <em>extends</em> or through the <em>uses</em>
relation.
The <em>extends</em> relation is similar to the inheritance
relation for classes.
The extending use case may override aspects of the extended use case.
The <em>uses</em> relation is used to factor out common parts.
</document>
