<include file=navigate>
:@ Background and motivations
My own interest in object-oriented languages and
software development stems from my research on the
language DLP, a language
integrating logic programming with object-oriented features
and parallelism (Eliens, 1992).
When looking for material for a course on
object-oriented programming, I could not find a book
that paid sufficient attention to foundational
and formal aspects.
Most of the books were 
written from a perspective on OOP that did not quite suit 
my purposes.
What I was looking for could to some extent only be
found in research papers.
As a consequence, I organized my OOP course
around a small number of papers,
selecting
the papers that, to my mind,
can be considered as {\em landmark papers},
papers that have become known as originally presenting
some significant notion or insight.
The apparent disadvantage of basing a course on OOP
on papers is the obvious lack of a unified view,
and of a consistent use of terminology.
The advantage of such an approach, however,
is that students are encouraged to assess
the contribution of each paper and to form their
own view by comparing critically the different viewpoints
expressed in the papers.
Personally, I favor the use of original papers,
since these somehow show more clearly
how the ideas put forward originated.
Later, more polished, renderings of these same ideas
often lack this quality of `discovery'.
<p>
The idea of organizing a book around
slides came quite naturally,
as the result of structuring the growing collection of 
slides, and the wish to maintain the compact representation 
offered by the slides.
<p>
The choice of material reflects my
personal preference for foundational issues,
in other words, papers that are focused on concepts
rather than (mal)practice.
The choice of material has also been colored by my interest
in (distributed) hypermedia systems, the Web and, to some extent, by
my previous work on distributed logic programming.
Although the book is certainly not focused on language constructs,
modeling issues as well as foundational issues are generally related
to existing or conceivable language constructs,
and (whenever possible) illustrated by working examples developed
for that purpose.
<p>
The choice for Java as the main vehicle for presenting
the program fragments and examples is motivated simply by
the popularity of Java.
The presentation of some of the other examples in C++ reflects
my belief
that C++ must still be considered as
a valid programming language for object-oriented software development.
However, I also believe that in the (near) future multi-paradigm
approaches (extending Java and C++) will play a significant role.
<p>
The approach taken in this book may be characterized
as {\em abstract},
in the sense that attention is paid primarily to concepts
rather than particular details of a solution
or implementation language.
By chance, in response to a discussion in my class,
I looked up the meaning of {\em abstract}
in a dictionary, where to my surprise I learned
that one of its meanings 
is {\em to steal}, {\em to take away dishonestly}.
Jokingly, I remarked that this meaning sheds a different
light on the notion of {\em abstract data types},
but at a deeper level I recognized the extent
to which the ideas presented in this book have profited
from the ideas originally developed by others.
My rendering of these ideas in a more abstract form
is, however, not meant to appropriate them in a dishonest way,
but rather to give these ideas the credit they deserve by
fitting them in a context, a framework encompassing
both theoretical and pragmatical aspects of object-oriented computing.
As one of the meanings of the adjective {\em abstract},
the dictionary also lists the word {\em abstruse}
(not easy to understand).
There is no need to say that, within the limits of
my capabilities, I have tried to avoid becoming abstruse.
<p>


Finally,
in presenting the material, I have tried to retain a sufficient degree
of objectivity.
Nevertheless, whenever personal judgments  have slipped in,
they are meant rather to provoke a discussion than provide
a final answer.
