<include file=navigate>
\newpage
\vspace{-0.5cm}
:@ Features of this book
<ul>

<slide mode=hide cap="Features (1)">
<li> The book provides an introduction to object-oriented programming,
covering design, languages, and foundational issues.
It pays attention to issues such as reuse, component technology,
design patterns and in particular the application of object technology
in Web applications.
</slide>

<slide mode=hide cap="Features (2)">
<li> It contains guidelines for developing object-oriented applications.
Apart from practical examples it provides an overview of 
development methods as well as an introduction to UML,
the standard for object-oriented modeling.
In particular <em>design patterns</em> will act as a recurrent
theme, or rather as a perspective from which examples
and solutions will be discussed.
</slide>

<slide mode=hide cap="Features (3)">
<li> Distributed object technology will be a major theme.
The book provides an introduction to CORBA that allows the student to
gain hands-on experience with developing CORBA applications.
It also provides a discussion of competing technologies,
and in particular it will elucidate the distinction between
component technology and distributed objects.
Examples in Java and C++ will be included.
</slide>

<slide mode=hide cap="Features (4)">
<li>
Another major theme of the book is to establish precisely
the relation between
the guidelines and prescriptions emerging from
software engineering practice
on the one hand, and
the constraints and insights originating from theoretical research.
In the book attention will be paid to foundational issues
as well as the pragmatical solutions the designers of object-oriented
languages have chosen to realize their ideas.
</slide>

<slide mode=hide cap="Features (5)">
<li> Many of the notions introduced and problems discussed are clarified
by short programs, mostly in Java, some in C++. 
The examples cover GUI development,
business process reengineering
and Web applications.
No extensive knowledge
of the programming languages used is required since a brief tutorial
on a number of object-oriented programming languages, including C++,
Smalltalk, Eiffel and Java, is given in the appendix.
</slide>

<slide mode=hide cap="Features (6)">
<li> The material is organized around <em>slides</em>.
The slides occur in the text in reduced format, 
but are also available in Powerpoint and Netscape Presentation format.
Each slide captures some important notion or concept
which is explained and commented upon in the accompanying text.
An online Instructor's Guide is available that provides hints
for presenting the slides
and answers to the questions posed at the end of each chapter.
</slide>

<slide mode=hide cap="Features (7)">
<li>
The entire book, including the software from the examples and
the <em>Instructor's Guide</em> is available electronically,
on the accompanying CDROM as well as on the Internet.
The electronic version contains links to other material on
the Internet. The electronic version may be accessed
also in <em>slide mode</em> that allows for 
presenting the material in a classroom equipped with
a beamer. 
</slide>
</ul>
