<document>
@* Music search facilities on the Web
<include file=navigate>

There is a wealth of  powerful search engines on the Web.
Technically, search engines rely either on classification schemes
(as for example Yahoo)
or content-based (keyword) indexing
(as for example Excite or AltaVista).
Searching on the Web, nowadays, is moderately effective
when text-based documents are considered.
For multimedia objects (such as images or music)
existing search facilities are far less effective,
simply because indexing on category or keywords can
not be done automatically.

:@ Keywords and categories
For musical material, in particular MIDI,
there are a number of sites that offer search over
a body of collected works.
One example is the Aria Database [_Aria], that allows
to search for an aria part of an opera based on title,
category and even voice part.
Another example is the MIDI Farm [_Farm],
which provides may MIDI-related resources, and
also allows for searching for MIDI material
by filename, author, artist and ratings.
A category can be selected to limit the search.
The MIDI Farm employs voting to achieve collaborative
filtering on the results for a query.
<p>
Search indexes for sites based on categories and keywords
are usually created by hand, sometimes
erreonously. For example, when searching for a Twinkle fragment,
Bach's variations for Twinle were found,
whereas to the best of our knowledge 
there exist only Twinkle variations by Mozart.
<p>
The Digital Tradition Folksong Database [_Folk] provides
in addition a powerful lyrics (free text) search facility based
on the AskSam search engine [_AskSam].
<p>
An alternative way of searching is to employ a meta-search engine.
Meta-search engines assist the user in formulating an appropriate
query, while leaving the actual search to (possibly multiple)
search engines.
Searching for musical content is generally restricted to the lyrics,
but see below (and section <ref file=match>Match</ref>).

:@ Content-based search
Although content-based search for images and sound have
been a topic of interest for over a decade [_MM],
few results have been made available to the public.
As an example, the MuscleFish Datablade for Informix [_Muscle],
allows for obtaining information from audio based on a content
analysis of the audio object.
<p>
As far as content-based musical search facilities for the Web
are concerned, we know of only one example,
the Meldex system of the New Zealand Digital Library
initiative, an experimental system that allows for searching tunes
in a folksong database with approximately 1000 records.
Querying facilities for the Meldex include queries 
based on transcriptions from audio input, that is humming a tune!
We will discuss the approach taken for the Meldex system in more
detail in section <ref file=match>Match</ref>,
to assess its viability for retrieving musical fragments
in a large database.
</document>
