<document>

@* Queries -- the user interface
<include file=navigate>

Assuming that we have an adequate solution
for indexing musical data, we need to define how end users may access these data, 
that is search for musical objects in the information space
represented by the database, for the ACOI project the World Wide Web.

<slide id=midi-keyboard type=fig cap="Query interface">
<image pre="\hspace{2.0cm}" name=local/screen1>
</slide>

For a limited category of users, those with some musical skills,
a direct interface such as a keyboard
or a score editor, as provided by the <em>hush</em> framework
[_Jamming], might provide a suitable interface for
quierying the musical database.
Yet, for many others, a textual description, or a form-based
query will be more appropriate.

<slide type=fig cap="User Query Processing">
<image pre="\hspace{2.0cm}" name=local/acoi/query>
</slide>

In processing a query, we may in some cases
derive a partial melody or rhythmic structure from the query,
as well as some additional features or criteria.
As explained in the previous section, the output of indexing MIDI files
consists of both information concerning features
as well as a musical rendering of some of these features.
These features can be used to match against
the criteria formulated in the query.
The musical renderings, which include a partial score,
may be presented to the user in response to a query,
to establish whether the result is acceptable.
<p>
In summary, the user should be provided with an
interface that allows to include the following elements in a query:
<slide mode=hide cap="Query interface">
/// <em>user interface elements</em>
<ul>
<li> composer
<li> fragment of a melody
<li> melodic contour
<li> rhythmic structure
<li> fragment of the lyrics
<li> instruments
<li> other information
</ul>
</slide>
Fragments of a melody may be encoded in MIDI,
which can be generated either from a score editor,
or from a raw audio file, using the algorithm described in
[_Meldex], see below, or a public domain WAV to MIDI converter.
How to provide an interface for indicating rhytmhic
structure is not altogether clear. One possibility would be to 
allow for tapping on a keyboard. Another possibility is
to provide the user with a menu of rhythmic patterns.


%%<so meldex>


%%See [_Jamming]

</document>
