<h1>Business Modelling</h1>
<include file=navigate>
Dramatic improvements in business performance 
and productivity may be achieved by critically
examining some of the rules 
that govern a business process.
Business Process Redesign (BPR) is the 
generic label for many emerging methodologies aimed at producing these 
improvements. Re-design 
implies that the current state of affairs is no longer acceptable and 
can no longer be refined or evolved.

The BPR perspective demands that its users understand the nature of the 
business they are in, and the processes that can be re-engineered. 
In order to achieve this understanding, 
part of the BPR approach is to map out an 
organisations processes. 
The model created during this phase is used to 
communicate the BPR team's ideas
and will also be used to plan changes to the current processes.

Following Davenport and Short [_Davenport90]
we define a <i>business process</i>
as <i>"a set of logically related tasks
performed to achieve some well-defined business
outcome"</i>.
It is important to note that business processes
have <i>customers</i> that, somehow, receive
the outcome of these processes.
Also, to stress the functional nature of
business processes, it may be remarked that business
processes often transgress departmental boundaries
within an organization.
<p>
Despite the importance of qualitative assessments
in BPR [_Hammer90], for modelling
we favor a more quantitative approach
for which we provide support by means of
a simulation library (BPSIM) based
on the Logistics-based Business Modelling method (LBM)
presented in [_Gerrits95].
<p>
Logistics-based modelling 
allows for analysing
the time spent in executing a business process.
The <i>product lead time</i> is defined as the time
that passes between the moment a customer orders
a product and the moment a product is delivered.
In more detail, we can distinguish between
<i>processing time</i>
(the time actually worked on a job or operation),
<i>queue time</i>
(the time a jobs waits for a resource to become available),
<i>setup time</i>
(the time that passes between the moment
a resource becomes available and the moment
work on the job is started),
<i>wait time</i>
(the time that is spent waiting for another job
to complete), and
<i>transport time</i>
(the time that is needed to move a job from
a resource at a certain location to a resource
at another location).
<p>
For a particular model,
measurements may be obtained by
running a series of simulations.
Based on an analysis of the simulation results
alternative models may be proposed.
For example, when the setup time for a job is
relatively large, combining jobs into a single task
for an employee may be more efficient.

@ Modelling Business Processes
The LBM method offers a number of primitives,
with associated graphic icons,
from which a business process model may be constructed
as a network of resources 
connected by transport arcs.
The primitive entities offered by LBM are:
<ul>
<li> <i>operation</i> -- 
processing component
<li> <i>task</i> -- a series of consecutive operations
<li> <i>transport</i> -- transport of information
<li> <i>choice</i> --  affects flow of information
</ul>
Operations are atomic in the sense that wait time,
queue time and transport time may not be part 
of an operation.
Only setup time and process time are part of an operation.

Tasks are introduced to allow for a series of jobs 
or operations
to be processed, for example by one employee,
in order to reduce the setup time needed.

Transport entities represent the time it takes
for information to flow from one resource 
(that is operation or task) to another.
Transport implicitly defines the 
sequential structure of a process.
However, duplications of information, and consequently
parallel operations, are allowed.
<p>
In addition to the primitives mentioned above,
LBM allows us to characterize
<ul>
<li><i>organizational units</i> --
to represent departmental boundaries, 
<li> <i>external agents</i> --
to represent opaque information producing or
consuming entities,
and
<li><i>archives</i> --
to represent paper-based storage facilities.
</ul>
Also, employees may need additional
<i>means</i>
to engage in an operation or task.
<include file=navigate>
