@* Introduction
<include file=navigate>
Business Process Redesign (BPR) is a method to perform organizational change.
Instead of functions and departments it takes business processes as the main
subject to redesign the way work is done in a particular organization. 
[_Davenport90,Davenport93,Davenport94,Hammer90,Wastell94]
Davenport and Short [_Davenport90] argue that business process redesign 
should be combined with the capabilities of Information Technology (IT). 
They show that IT can play two roles in BPR:
on the one hand it is an enabler of new process structures. An example
would be the use of expert systems to assist bank clerks handling loan
requests. On the other hand IT can provide 
support for the implementation of new process designs.
By, for example, 
simulating the logistic aspects of the redesigned loan request process.
<p>
By modelling different redesign alternatives
and subjecting them to simulation
studies the participants in the business process redesign project
can assess
the alternatives with respect to the redesign project goals. Possible goals
include cost reduction, lead time reduction, raising output quality and
improving the quality of worklife. Visualization and animation of 
the simulation models can provide insight into both the structure and 
dynamics of the modelled alternatives and thus improve decision making.
<p>
In this paper we advocate an integrated presentation of redesign 
alternatives, visualized simulation experiments and the results of 
simulation studies in a single active document.
Our approach allows authors to write hypermedia
documents with embedded simulation models and experiments. These documents 
can be viewed on the Internet, or on a company Intranet, using an 
adapted Internet Web browser. 
<p>
Our system has been implemented using the 
<i>hush</i> [_Hush] hypermedia framework developed at the Vrije 
Universiteit. This framework provides support for multimedia user 
interfaces, a discrete event simulation library [_SIM] and embedding of 
applications in the Web [_Applications,Animate]. To model business 
processes we use Logistics-based Business Modelling (LBM) [_Gerrits95]. 
The class library BPSIM (Business Process Simulation) facilitates the 
modelling of business processes using LBM and provides additional support 
for embedding and running simulations on the Web.

@ Structure
In the following sections we will introduce
the concepts underlying logistics-based business modelling
and we will describe the software support for
simulating business processes, in particular the 
classes provided by the BPSIM library.
We will present an example illustrating the
construction of a business process model and its visualisation
in a hypermedia environment.
Then, we will briefly characterize the hypermedia environment
and its relation to the World Wide Web.
And, finally, we will discuss the merits and limitations of our 
approach.
<include file=navigate>
