<h1>Requests for loans</h1>
<include file=navigate>

Now let us take a look at an example business process model based on the objects made available in BPSIM. The example will detail possible situations before and after business process redesign has taken place.

<dl>
<dt>Current Situation:
<dd>Our first model, which represents the current situation,
consists of a client producing,
for example requests for a loan at a bank. The requests are initially handled by a clerk whose task is to send requests for amounts greater than 10000 dollars to the boss. The boss, whose task is to approve or denigh the loan, sends the result back to the clerk for processing. If the amount is less than 10000 dollars, the clerk has authority to process the request himself.


<dt>Redesign Alternative:
<dd>In our second model, which is the result of
a redesign effort, requests are handled by a clerk
who enters the data into a computer. The computer now makes the decision as to whether the loan is improved - for loans of value less than and greater than 10000 dollars. The clerk then passes the results on to another clerk for the task of dispatching loans.
</dl>

<include file=dump.txt>

<p>
Figure 1 shows the visual representation of
the model resulting from the redesign effort,
embedded in a Web page.
In addition to the model, the page contains
some results obtained by running a simulation.
For example, the text indicates that
an employee is busy handling incoming requests
only 33\% of the time.
The histogram depicts the distribution
of the lead times of incoming loan requests,
that is the time that passes between receiving
a request and giving an answer.
The Web page further contains a button to
start a simulation run,
a description of the model
and links to alternative models.


@ The script
Below we show some fragments of the script.

<program>
histogram leadtimes
agent client generate leadtimes
client -duration 60 poisson
transport t1 
t1 -duration 20
employee clerk
operation receive clerk
receive -duration 20.0 5.0 normal 
</program>
In this fragment a histogram for recording leadtimes
is created as well as an
agent generating requests and a transport to a 
clerk handling the requests.
The duration of the agent is specified
using a poisson distribution with $\lambda = 60$.
The clerk is declared to perform a receive operation,
the duration of which takes values from a 
normal distribution with $\mbox{\it means} = 20$ and 
$\mbox{\it standard deviation} = 5.0$.

<program>
client -next t1
t1 -next clerk
</program>
The fragment above shows how the various components
of a model (for this fragment the agent, transport and
employee) may be connected.
<p>
After defining the components of the model
and their connection a simulation may be started by
pressing the start button.
If desired, users may change the parameters concerning
for example setup and wait time, to explore
the various scenarios a model has to satisfy.
<include file=navigate>
