<h1>Introduction</h1>

Business Process Redesign (BPR) is a method to perform organizational change.
Instead of functions and departments it takes business processes as the main
subject to redesign the way work is done in organizations. [refs]
Davenport and Short [ref] argue that business process redesign should be 
combined with the capabilities of Information Technology (IT). 
IT can serve as a enabler of new process structures _and_ it can provide 
support for the implementation of new process designs. An example of the 
former would be the use of expert systems to assist bank clerks handling 
loan requests. An example of the latter would be the use of simulation to 
predict the performance of redesigned processes.
<p>
By modelling different redesign alternatives and subjecting them to simulation
studies the participants in the business process redesign project can asses
the alternatives with respect to the redesign project goals. Possible goals
include cost reduction, lead time reduction, raising output quality and
improving the quality of worklife. Visualization and animation of 
the simulation models can provide insight into both the structure and 
dynamics of the modelled alternatives and thus improve decision making.
<p> 
In this paper we advocate an integrated presentation of redesign 
alternatives, visualized simulation experiments and the results of 
simulation studies in a single active document to enhance the support 
of simulation for BPR. Our approach allows authors to write hypermedia
documents with embedded simulation models and experiments. These documents 
can be viewed on the internet, or on a company intranet, using an 
adjusted Internet browser.
<p>
The above mentioned approach has been implemented using the 
hush~\cite{DV:hush-XR} hypermedia framework developed at the Vrije 
Universiteit. This framework provides support for multimedia user 
interfaces, a discrete event simulation library and embedding of 
applications in the web~\cite{DV:darmstadt-95}. To model business 
processes we use Logistics Based Business Modelling (LBBM)~\cite{Gerrits:95}. 
The class library BPSIM (Business Process Simulation) facilitates the 
modelling of business processes using LBBM and provides additional support 
for embedding and running simulations on the web.
<p>
The next section introduces business modelling with LBBM. The third section
describes the hush framework which provides the necessary software support.
Next, section 4 presents the integration of the different components and
finally the last section contains our conclusions and some 
directions for future research.

