<document>
@* The <i>Hush Online Technology</i> Toolkit

Even with the existence of numerous tools
for software documentation
a number of issues come up when one attempts to arrive
at a fully documented system.
<p>
First of all there are several kinds of document types,
plain or structured text such as for example requirements
specifications,
but also code, in a bewildering variety,
and configuration information.
<p>
Secondly, one needs s preferably uniform style
of annotation for the various kinds of program code
and configuration code.

<slide id=hot cap="The <i>Hush Online Technology</i> Toolkit">
@ Issues
<ul>
<li> document types -- code, configuration, text  
<li> annotation -- C++, Java, IDL, scripts
<li> documentation format -- <a href=../../hush/manuals/man/man8/literate.html><i>dot-tee</i></a> pseudo SGML
<li> tools -- Java/C++/IDL Doc
<li> conceptual graphs -- ciao, acasia , dotty
<li> indexing -- file level (find), content level (glimpse)
</ul>
</slide>

For presenting the documentation, furthermore,
one needs some suitable
formatting language, such as HTML, LaTeX, or SGML.
For <i>hush</i> I used the <a href=../../hush/manuals/man/man8/literate.html><i>dot-tee</i></a> format, which
is somewhere in between SGML and HTML. An euphemism, indeed.
<p>
The formatting language must be (conforming to) the output
of the various tools that are in use.
In reality, I had to modify these tools to make
them conform to my standard! 
<p>
Text being text,
it is nice, in addition, to
be able to create
conceptual graphs, preferably in a reverse engineering fashion.
<p>
And finally, a point which also holds for the previous issue,
given the size of the potential document base,
there must be support for indexing,
both on a file level as well as on a content level.


@ Tools
The actual toolkit consists of a small collection
of filters and scripts
that may be used to generate HTML documents.

<slide id=tools cap="Tools">
@ Tools
<ul>
<li> literate tools-  man:literate(8)
<li> source/text processing - //sources/util/filters/
<li> basic html -- //sources/util/html/
<li> reverse engineering -- //sources/util//ciao/
<li> doecumentation tools -- Doc++, IDL   (ala javadoc)
</ul>
</slide>

In addition, I used several utilities
such as Acacia and  
[_Ciao] for creating graphs,
Doc++ for creating structured documentation
for C++ and Java
and IDLDoc for documenting CORBA IDL. 
Minor modifications of these utilities were necessary though,
in order to arrive at a consistent format.
</document>
