<document>
@* Introduction

Put radically, software engineering is requirements engineering,
and as a consequence, in the average project
considerable effort is put in managing the documents that are delivered
as milestones, documentation or reports, coming
from analysts, system developers, steering committees, and what more.

<slide id=se cap="Software Engineering is Requirements Engineering!">
@ Software Engineering is Requirements Engineering!
<ul>
<li>
<a href=../../hush/examples/hush/coffee/requirements/requirements.sgml.in.html>Analysis</a>, 
<a href=../../hush/examples/hush/coffee/design/design.sgml.in.html>Design</a>, 
<a href=../../hush/examples/hush/coffee/design/src.sgml.in.html>Implementation</a>, 
<a href=../../hush/examples/hush/coffee/src/index.html>Maintenance</a> 
<li> Automatic Indexing -- for retrieval
<li> Reverse Engineering Support
</ul>
<p>
Toy example: //examples/hush/coffee/
</slide>

Each of the phases in the software engineering life-cycle
is characterized by its own collection
of documents.
For example for the analysis phase,
the IEEE advocates the use of its 
<a href=../../hush/examples/hush/coffee/templates/requirements.dtd.in.html>ANSI/IEEE 830 standard</a>
to specify the requirements a system must meet.
Such documents accumulate over the subsequent phases
and during maintenance, in particular,
retrieval becomes a problem,
unless adequate document management support is offered.
Another problem is that the original meaning of specifications
may get lost or, worse, that specifications may become
outdated, making (diagrammatic) reverse engineering support 
desirable.
<p>
As an experiment, we augmented the standard documentation
format for our Software Engineering course with
hypertextual support, that is (among others) links, allowing students
to jump from documentation to code, and back.
To be clear, students had to write the documentation and code
themselves!
In the following, I will discuss the issues that are involved in
providing hypertextual support for requirements
engineering and software documentation.
But first of all let's look at the requirements such documentation must meet.
</document>
