<document>
@* Conclusions
<include file=navigate>

This report presents an approach to the detection
of musical features which is based on the use of feature
grammars as developed in the ACOI framework
to describe the structural properties of musical data.
<p>
The goal of this work is to support the user
in finding a musical piece of his likening, by 
lyrics, by
genre, by musical instruments, tempo,
similarity to other pieces, melody and mood.
<p>
At this stage we have a prototype for the extraction of relatively
simple features from a MIDI file, which uses an embedded logic
to extract content-related properties of
that data. 
<p>
The next step in our research will consist of
creating suitable ways for querying the musical database.
We will have to explore how to present
a possibly large collection of matches,
and how to assist the end user in refining a
query as to obtain the desired result.
<p>
The greatest effort, however, will be to arrive at a matching
schema, that allows the retrieval of musical information from
a large database. Looking at the literature, in particular [_Compare],
we discovered suitable dynamic programming algorithms that
may be used to detect similarities in melodic and rhythmic
structure. However, due to the structural complexity of
the algorithms, actual search in a large database will
be prohibitively expensive, unless some compact representation
of the original musical material can be thought of, to restrict
the matching process to what may be regarded as a minimal invariant
abstraction of the original piece of music.
An alternative solution would be to create additional indexes
based on, for example, the distribution of instrument usage,
intervals, and note durations, that may augment the matching
process by acting as an extra filter.

</document>
