<document>

@* Queries -- the user interface
<include file=navigate>

Assuming that we have an adequate solution
for indexing musical data, we need to define how end-users may access these data, 
that is search for musical objects in the information space
represented by the database, for the ACOI project the World Wide Web.

<slide id=query-interface type=fig cap="Query interface">
<a href=http://www.cs.vu.nl/~eliens/tune/in.html target=_top>
<image pre="\hspace{2.0cm}" name=local/screen1>
</a>
</slide>

For a limited category of users, those with some musical skills,
a direct interface such as a keyboard
or a score editor, as provided by the <em>hush</em> framework
[_Jamming], might provide a suitable interface for
querying the musical database.
Yet, for many others, a textual description, or a form-based
query will be more appropriate.
<p>
In \sliref{query-interface} our envisaged user interface
for querying is depicted.
It provides limited score editing facilities, to enable
the user to indicate a melody (including rhythmic structure)
in common musical notation.
In this stage, we assume some basic musical skills, indeed.
In addition to the melodic fragment, which is depicted
in the middle frame, we allow the user to give additional
information, such as the composer, the name of the song,
and (possibly) a text-based outline.
The user may also indicate a genre, the instrumentation
and additional descriptive features in a free text format,
which may include fragments of the lyrics.
As concerns  the matching algorithm used,
the user may express a preference for either strict
or approximate matching for the melody or melodic contour,
with or without rhythm. See section <ref file=match>Match</ref> for a discussion
of matching algorithms.


<slide type=fig cap="User Query Processing">
<image pre="\hspace{2.0cm}" name=local/acoi/query>
</slide>

In processing a query, we may 
derive a partial melody or rhythmic structure from the query,
as well as some additional features or criteria.
As explained in the previous section, the output of indexing MIDI files
consists of both information concerning features
as well as a musical rendering of some of these features.
These features can be used to match against
the criteria formulated in the query.
The musical renderings, which include a partial score,
may be presented to the user in response to a query,
to establish whether the result is acceptable.
<p>
The output of a query will be a ranked list
of items found in the database.
Each item in the list will be represented by a
thumbnail of the score,
an auditory icon representing the musical fragment found,
the name of the song, the composer and a reference
to the original musical object on the Web.

<ignore>
<p>
In summary, the user should be provided with an
interface that allows to include the following elements in a query:
<slide mode=hide cap="Query interface">
/// <box><em>user interface elements</em></box>
<ul>
<li> composer
<li> fragment of a melody
<li> melodic contour
<li> rhythmic structure
<li> fragment of the lyrics
<li> instruments
<li> other information
</ul>
</slide>
Fragments of a melody may be encoded in MIDI,
which can be generated either from a score editor,
or from a raw audio file, using the algorithm described in
[_Meldex], see below, or a public domain WAV to MIDI converter.
How to provide an interface for indicating rhytmhic
structure is not altogether clear. One possibility would be to 
allow for tapping on a keyboard. Another possibility is
to provide the user with a menu of rhythmic patterns.
</ignore>


%%<so meldex>


%%See [_Jamming]

</document>
