<H4><A NAME="SECTION00141030000000000000">
Interference versus non-interference</A>
</H4>

<P>
The common basis for the collaborators is the primary model, for instance, 
embodied by a simulation. Several derived models can depend on the primary 
model, and derived model could be related to a number of presentation models. 
When collaborating, the common basis should be the same for all the cooperators 
at every moment in time. To assure consistency, it is best to have the 
simulation act autonomously without the slightest interference. We will refer to 
this as <EM>non-interference</EM>. Non-interference does not restrict the 
possibility for each user to create his own perspective in any way. It does 
prevent somebody from rewinding, changing parameters or restarting the 
simulation while others do not want or expect this.

<P>
However, the need to stop, rewind or change parameters in a simulation is 
imminent. Considering multiple <EM>what-if</EM> situations, for example, is 
necessary when looking at different re-design alternatives, each with its own 
set of parameters. One way to meet this requirement, while upholding 
non-interference, is to store all past events in a database or to allow copies 
with different parameters of the simulation to be started.

<P>
While interaction with the primary model should be avoided as much as possible, 
derived models can be used in a more flexible manner. Several derived models can 
be created, all depending on one primary model. While the primary model can be 
considered a common basis that should not be interfered with, the derived model 
can be seen as a common workspace that permits <EM>interference</EM>. All 
participants of a session could use the same derived model or multiple derived 
models could be created, depending on the need to share information concepts or 
to be independent of the other users.

<P>
