<H2><A NAME="SECTION00151000000000000000">
Software components</A>
</H2>

<P>
<slide id=architecture cap="Architecture>
<BR>
<DIV ALIGN="CENTER"><A NAME="arch.arch">&#160;</A><A NAME="271">&#160;</A>
<TABLE WIDTH="50%">
<CAPTION><STRONG>Figure 2:</STRONG>
The main components of D<SMALL>IVA</SMALL></CAPTION>
<TR><TD>
<DIV ALIGN="CENTER">
<image src=architecture.gif>
</DIV></TD></TR>
</TABLE>
</DIV>
</slide>
<BR>

<P>
Figure <A HREF="node15.html#arch.arch">2</A> shows the main components of the architecture. In the 
following list, the three components that were already present in an earlier 
version of the D<SMALL>IVA</SMALL> architecture (<A NAME="tex2html213"
 HREF="node22.html#Diva:NPIVM97">Sch&#246;nhage &amp; Eli&#235;ns, 1997</A>; <A NAME="tex2html214"
 HREF="node22.html#Diva:bradford98">Sch&#246;nhage &amp; Eli&#235;ns, 1998</A>), are 
listed first. The last three components in the list extend D<SMALL>IVA</SMALL>. 

<P>
<UL>
<LI>generator -- embodies the primary model
<LI>shared concept space -- information store that contains the derived model
<LI>presentation component -- the actual information visualization
<LI>D<SMALL>IVA</SMALL> services directory -- central registering of components
<LI>collaborative session manager -- overall coordination of virtual meetings
<LI>local collaboration component -- local collaboration support
</UL>

<P>
In a normal situation, one D<SMALL>IVA</SMALL> services directory and more than one of 
each of the other components could exist. A presentation component and a local 
collaboration component are present at the desktop of each participant. A short 
description is given for each of the components.

<P>
The <EM>generator</EM> embodies the primary model and generates all data needed 
for the visualization. Examples of generators are simulations of business processes. The 
generated raw data is transferred to the shared concept space.

<P>
The <EM>shared concept space</EM> stores information in an expressive and adaptive 
way. The information is contained in the form of concepts that are stored in a 
hierarchical manner. Each concept has one or more data properties that represent 
the information. The data properties are updated with data coming from the 
generator. The received data can be stored directly or can be used to compute 
and store derived information. 

<P>
The <EM>presentation component</EM> actually visualizes concepts from the shared 
concept space. It makes use of gadgets, which are generic 
visualization primitives that present certain types of information.
As an example, cone trees are primitives (gadgets) to visualize hierarchical 
information&nbsp;(<A
 HREF="node22.html#InfoVis:Robertson">Robertson et&nbsp;al., 1993</A>).

<P>
Examples of gadgets are a rotating object which indicates a certain action or 
a histogram which displays data. 

<P>
The <EM>D<SMALL>IVA</SMALL> services directory (DSD)</EM> is the central directory 
component. D<SMALL>IVA</SMALL> components (or services) can register here, identifying 
themselves and giving their location. Once they are registered, the DSD can 
inform other objects about the availability and whereabouts of these services.

<P>
The <EM>collaboration session manager (CSM)</EM> coordinates components. It deals 
with interaction protocols, which means it knows about the participants and 
their roles, sharing perspectives, user to user communication and consistency.

<P>
The <EM>local collaboration component</EM> is directly connected to the session manager. It is 
present at each participants desktop and handles interactions 
and information related to a collaborative session. It may for example display
a list of participants and offer communication facilities.

<P>
