<H2><A NAME="SECTION00153000000000000000">
CORBA and the Web</A>
</H2>

<P>
D<SMALL>IVA</SMALL> is designed as a distributed object oriented system. The 
D<SMALL>IVA</SMALL> components are written in C++ and Java, and can run on different 
platforms. We use the Common Object Request Broker Architecture (CORBA) to let 
our distributed objects communicate with each other. CORBA&nbsp;(<A NAME="tex2html253"
 HREF="node22.html#CORBA:Orfali">Orfali &amp; Harkey, 1997</A>; <A NAME="tex2html254"
 HREF="node22.html#CORBA:Siegel">Siegel, 1996</A>) abstracts from hardware, operating systems and programming 
languages. By using the interface definition language (IDL) to describe the 
interfaces between components and by making use of the object request broker 
(ORB), distributed components are able to communicate.

<P>
Voyager&nbsp;(<A
 HREF="node22.html#CORBA:voyager">ObjectSpace, 1997</A>) is an agent ORB written purely in Java, which 
supports CORBA. Voyager allows us to use mobile objects, a feature which CORBA
does not have. We use Voyager to construct the mobile controller components. 
These components are able to "dock" at a user environment and can subsequently 
show their user interface on the screen to let the user interact with it. 

<P>
We use VRML&nbsp;(<A
 HREF="node22.html#VRML:ISO">ISO, 1997</A>) as the main visualization tool. The users are able to navigate through 
the VRML worlds by using a VRML-browser. The External Authoring Interface (EAI) 
makes it possible to control the VRML worlds dynamically via the Java and Javascript 
languages.

<P>
The visualization gadgets in the presentation component are represented by 
mobile display agents. These agents are constructed using Voyager. Display 
agents can also "dock" in a user environment and, in addition, get access to the 
local VRML world. They collect the needed information from shared concept spaces 
to build and maintain the 3D visualization.

<P>
The combination of CORBA and the Web enables access to information resources
by means of HTML, Java and VRML (see also <A
 HREF="node22.html#InfoVis:Rohrer">Rohrer &amp; Swing, 1997</A>).
For example, the simulation and shared concept
space can be hosted on a Unix server while the presentation components are
executed in a Web-browser on Windows client machines.

<P>
