
<H1><A NAME="SECTION00130000000000000000">&#160;</A>
<A NAME="diva">&#160;</A>
<BR>
Multi-user visualization
</H1>

As the above example illustrates, it is useful to take visualization from the single user domain into the realm of distributed multi-user systems. This makes it possible to discuss shared information sources. 

<P>
However, multiple users with different backgrounds have different information requirements. In the example above some managers might be interested in the resource allocation (who is using what) of the re-design alternative, while others might be more interested in the financial aspects. To support these different information requirements, multiple perspectives (or views) on the information are required. So, based on the same simulation, we distinguish alternative perspectives that visualize different aspects of the re-designed process.

<P>
The need to have multiple perspectives was the main motivation for designing the <EM>distributed visualization architecture</EM> ( D<SMALL>IVA</SMALL>). Additional requirements were the support for interactive visualization to allow for experimentation, and visualization at the user's desktop by means of a networked or web-based architecture (<A
 HREF="node22.html#Diva:bradford98">Sch&#246;nhage &amp; Eli&#235;ns, 1998</A>).

<P>
We regard the process of visualization as a transition of data through a sequence of models, starting with the generation of data and ending with the presentation of a visualization (<A
 HREF="node22.html#Diva:NPIVM97">Sch&#246;nhage &amp; Eli&#235;ns, 1997</A>). To allow for multiple perspectives on the data, we introduce an intermediate model between the generation and presentation of information. This intermediate model contains information based on the originally generated data, adapted to the information requirements of its users.

<P>
<slide id=concept cap="Conceptual Architecture">
<BR>
<DIV ALIGN="CENTER"><A NAME="fig:concept">&#160;</A><A NAME="110">&#160;</A>
<TABLE WIDTH="50%">
<CAPTION><STRONG>Figure 1:</STRONG>
Conceptual architecture</CAPTION>
<TR><TD>
<image src=concept.gif>
<IGNORE
 WIDTH="153" HEIGHT="34"
 SRC="img1.gif"
 ALT="\begin{figure}
\begin{center}
\epsfig{file=concept.eps, height=\linewidth, angle=-90, clip=} \end{center}\end{figure}"></TD></TR>
</TABLE>
</DIV>
</slide>
<BR>

<P>
Figure&nbsp;<A HREF="node6.html#fig:concept">1</A> depicts our architecture on a conceptual level. The primary model is the source of the information and contains explicitly or implicitly all information available. A conceptual mapping gives us the ability to adapt the raw information in the primary model to our information needs. Consequently, information in the derived model differs from data in the primary model in two ways. Primarily, only valuable information is selected to be present in the derived model and, secondly, information derived from primary data is added in the derived model.

<P>
How we present the derived information is specified in the presentational mapping. Here, information concepts in the derived model are mapped onto generic visualization primitives. The final presentation is the content of the presentation model. For example, when using  D<SMALL>IVA</SMALL> for 3D visualization, the presentation component contains a 3D scene through which end users can navigate. For a more detailed description of  D<SMALL>IVA</SMALL> see <A
 HREF="node22.html#Diva:NPIVM97">Sch&#246;nhage &amp; Eli&#235;ns (1997)</A> and (<A
 HREF="node22.html#Diva:bradford98">1998</A>).

<P>
