:@+ <a href=question.html>Chapter 10</a>

<N

- Conformance not only involves
syntactic properties, but behavioral
properties as well.
Behavioral properties include
invariant properties and history
properties.
\see{10-properties}

- \see{10-history}

- Static constraints may be expressed
directly in the signature,
but also by means of pre- and post-conditions.
To a certain, but definitely lesser, extent,
the reverse is also true.
\see{10-constraints}

- States may be modeled as functions
and state transformations as 
function modifications.
See slides \ref{sli-10-verification} and
\ref{sli-10-subst}.

- There are two ways to verify the
behavior of a program:
(a) prove for each possible
transition that the formula holds;
and
(b) employ the correctness calculus
given in 
\sliref{10-correctness}.

- For each syntactical kind of statement
allowed by the language,
a transition system specifies 
a corresponding execution step,
or series of such steps,
by means of a transition derivation rule.
An example transition system for
a simple object-based language,
supporting object creation and message
passing, is given in
section \ref{behavior}.

- To prove that a realization is 
correct with respect to its
abstract specification,
one must prove that each concrete operation
satisfies the constraints imposed on
the abstract level.
\see{10-ADT}

- See slides \ref{sli-10-specification},
\ref{sli-10-realization} and 
\ref{sli-10-absf}.

- Correspondence between subtypes
involves syntactic constraints,
defined by the subtyping rules
given in chapter 9,
behavioral constraints,
as characterized by the refinement
relation for pre- and post-conditions
and invariants,
and constraints for the extensions,
as expressed by the diamond rule.
See slides \ref{sli-10-correspondence}
and \ref{sli-10-subtyping}.

- See slides \ref{sli-10-ex-subtype},
\ref{sli-10-ex-correspondence}
and \ref{sli-10-ex-proof}.

- Invariance properties of objects cannot
completely be checked locally, within the confines of
a single object.
See \sliref{10-invariants}.
Checking invariants explicitly for each object,
however, is likely to be too expensive.

- Formal methods to specify
the interaction between objects
include model-based specification
methods,
the specification of contracts
as behavioral compositions,
the specification of cooperating
actors by means of scripts,
the specification of
multi-party interactions,
and the specification of joint action systems.
\see{10-interaction}
N>

