<document>

@# <a href=slic.html>The language DLP</a>
\markitright{The language DLP}


Apart from what may be considered the
mainstream languages Smalltalk, Eiffel
and  C++, there are numerous
other (experimental) languages incorporating
the object paradigm in one way or another.
See section \ref{classification} and, for example,
[_Davison93] for an overview. 
Of particular interest
is the combination of the logic programming
paradigm with object orientation,
of which the language DLP is an example.


\vfig{1}
<slide id=app-D caption="The language DLP">
:@ DLP <em> -- introduces logic <c>into object orientation</c></em>
\zline{\fbox{D}}
<ul><li> <raw>{\em DLP = LP + OO + $||$}</raw></ul>
:@ Design principles <em> -- support for knowledge-based systems</em>
<I
- objects {\em -- dynamic states}
- processes {\em -- communication by rendezvous}
- distributed backtracking {\em -- exhaustive search}
I>
\ifsli{\vspace{-1cm}}{}
</slide>
\vfig{1}

The DLP language combines logic programming ({\em LP})
with object orientation ($OO$) and parallelism ($||$).
DLP is a (very) high-level language, meant to support
the development of knowledge-based systems.
In addition to the logic programming features,
it provides {\em objects}
(that may change their state dynamically),
{\em processes} (such as active objects, that communicate
by rendezvous),
and it allows for {\em distributed backtracking}
(to enable exhaustive search in a logic programming style).
See  [_Eliens92] for a full treatment.

<latex>
<so term express control object inherit tech final>
</latex>
</document>
