<document>

:@ Expressions
The expressiveness of DLP is derived to a large extent
from its heritage from Prolog.
The basic syntactic units in Prolog are {\em terms},
which are either {\em constants}
(such as characters, integers, strings, or the empty list
$ [ ] $),
{\em variables}
(which by convention start with a capital or underscore),
or
{\em compound terms}
(which may be written as a function symbol with
argument terms or as a list of the form $[ H | T ]$,
where $H$ stands for the head of the list and $T$ for its
tail).
\see{dlp-expr}


\vstr{1}
<slide id=dlp-expr caption="DLP -- expressions">
:@ Expressions <em> -- terms</em>
\zline{\fbox{Prolog}}
\ifsli{\vspace{-0.5cm}}{}
<I
- constants <em> -- a, "a string", $[ ]$</em>
- variables <em> -- $X,Y,Z$</em>
- compound <em> -- $f(a,X)$, $[ H | T ]$</em>
I>
@ Unification <em> -- bi-directional <c>parameter passing</c></em>
\ifsli{\vspace{-0.5cm}}{}
<I
- <raw>$ f(X,a) = f(b,Y)$ \zline{ $ \leadsto $ $X = b$ , $ Y = a $ }</raw>
I>
\ifsli{\vspace{-1cm}}{}
</slide>

Terms allow for what is called {\em unification},
which is an extended form of pattern matching.
Unification results in binding variables to terms,
in such a way that the two unified terms become
syntactically equal.
As an example, unifying $f(X,a)$ with $f(b,Y)$
results in binding $X$ to $a$ and $Y$ to $b$.
Unification is the primary mechanism of parameter
passing in Prolog.
It is essentially bi-directional and satisfies
the {\em one-assignment-only} property,
which means that evaluating a goal must result
in a consistent binding, otherwise the goal fails.
</document>
