<document>

:@ Inheritance
DLP supports static inheritance, by code sharing,
as do Smalltalk, Eiffel and C++.
For a discussion of dynamic inheritance, by delegation,
see section \ref{prototypes}.
As an example of inheritance in DLP,
look at the refinement of the $travel$ object
into a veritable $agency$.
\see{dlp-inheritance}


<slide id=dlp-inheritance caption="DLP -- inheritance">
\ifsli{}{\vspace{0.1cm}}
<!-- \ifsli{ 
:@ Inheritance
\ifsli{\vspace{-0.5cm}}{}
<program>
object agency : travel { /// \fbox{agency}
agency() :-
	accept( any ),
	agency().
book(X,Y) :-
	reachable(X),
	price(X,Y).
price(amsterdam,5).
$...$
}
P]
\ifsli{\ln\vspace{-1.5cm}}{}
}{ -->
<program>
object agency : travel { /// \fbox{agency}
agency() :- accept( any ), agency().
book(X,Y) :-
	reachable(X),
	price(X,Y).
price(amsterdam,5).
$...$
}
</program>
\ifsli{}{\vspace{-0.2cm}}
<!--}-->
</slide>

An $agency$ offers the user, in addition to the
functionality offered by $travel$,
the opportunity to $book$ for a particular
destination and be informed of its price.
<p>
Inheritance in DLP conforms to the subsumption
relation for logical theories,
in that it extends the functionality of a given object
in a strict manner.
DLP allows for multiple inheritance and even checks
for cycles to protect the user from repetitions
or cycles in the inheritance chain.
</document>
