<document>

:@ Objects
Objects in Eiffel are defined by classes.
A typical class definition is given in \sliref{eiffel-objects}.

The class $counter$ exports the features $inc$
and $val$. The feature $count$ is hence private to
an instance of $counter$, since it does not appear
in the interface defined by the {\em export} part.

<slide id=eiffel-objects caption="Eiffel -- objects">
<program>
 <i> class </i> counter <i> export </i> inc val <i> feature </i>
 count : Integer
 create <i> is do </i> count := 0 <i> end </i>
 inc( n : Integer ) <i> is </i>
	<i> require </i> n > 0 <i> do </i>
	count := count + n
	<i> ensure </i> count = <i> old </i> count + n
	<i> end </i>
 val : Integer <i> is do </i> <i> Result </i> := count <i> end </i>
 <i> invariant </i> count >= 0
 <i> end </i> -- class counter
P]
\ifsli{\ln\vspace{-1.5cm}}{}
</slide>

The {\em create} feature is automatically exported,
and is used to create an instance of $counter$ by the
statement $x.create$ for a variable $x$ of type $counter$.
The reserved word $Result$
is used to return a value from a function
feature.
The method feature $inc$ specifies both
a pre-condition and a post-condition.
The reserved word $old$
is used to access the value
of the instance variable $count$ before evaluating $inc$.
Finally, the invariance states the constraint
that a $counter$ instance never has a value below zero.
</document>
