<document>
The {\em hush} widget class library
encapsulates the standard Tk widgets.
In addition, a hypertext widget is offered.
The widget classes are organized as a tree,
with the class $widget$ at the root.

<so f_wg>

Each concrete widget class offers the functionality
supported by the (abstract) $widget$ class
and may in addition define functions
specific to the particular widget class.
The member functions for a widget class
have usually a straightforward correspondence
with the command interface defined by the
Tcl/Tk toolkit.
See [_Ousterhout94] for the most recent description.

Each function listed in the class interface
is $public$ unless it is explicitly
indicated as $protected$.
The interface descriptions start with the
pseudo-keyword {\em interface}.
This is merely done to avoid the explicit
indication of {\em public}
for both the ancestor and the member functions of the
class.

Each widget class specifies two constructors,
one with only a path and one which allows
both for a widget and a path.
In the latter case, the actual path consists
of the concatenation of the path of
the widget and the path specified by the
string parameter.
For the concrete widget classes, no
widget will be created when the $options$ parameter
is zero.
This convention is adopted to allow composite
widgets to inherit from the standard widgets,
yet define their own components.

In addition, each widget class has
a destructor, which is omitted for brevity.
The destructor may be used to reclaim the storage for a
widget object.
To remove a widget from the screen, the
function $widget::destroy$ must be used.
</document>
