@# Internet addresses
\markitright{Internet addresses}
\label{internet}
\slyname{G}

\c{
The Internet is increasingly becoming a rich source
for a variety of information.
Below, a number of addresses are given, from which
to obtain programs, software libraries
or technical papers. 
These addresses are partly taken from [_Locke].
}


\clearfalse
%%\vfig{1}
\slide{in-email}{Internet -- email facilities}{
@ Email
\ifsli{\vspace{-0.5cm}}{}
<I
- {\tt ftpmail@decwrl.dec.com} -- subject: $help$
- {\tt netlib@research.att.com} -- {\em send index}
- {\tt omg@omg.org} -- OMG
I>
\ifsli{\vspace{-1cm}}{}
}

\c{
For those who have only an email facility at their disposal,
software may be obtained by sending email to
{\tt ftpmail@decwrl.dec.com} (put $help$ in the subject field)
or {\tt ftpmail@decwrl.dec.com} (write {\em send index} in the message body).
Information concerning the activities of the OMG
may be obtained by sending email to
{\tt omg@omg.org}.
\see{in-email}
}

\vstr{1}
\slide{in-news}{Internet -- newsgroups}{
@ Newsgroups
\ifsli{\vspace{-0.5cm}}{}
<I
- {\tt comp.lang.c++}
- {\tt comp.lang.eiffel}
- {\tt comp.lang.smalltalk}
- {\tt comp.databases.object}
I>
\ifsli{\vspace{-1cm}}{}
}

\c{
Another valuable source of information and programs are the
Internet newsgroups {\tt comp.lang.c++}, {\tt comp.lang.eiffel},
{\tt comp.lang.smalltalk} and {\tt comp.databases.object}.
\see{in-news}
}

\slide{in-ftp}{Internet -- ftp sites}{
@ Ftp sites
\zline{\fbox{$ftp$}}
\ifsli{\vspace{-0.5cm}}{}
<I
- {\tt ftp.th\_darmstadt.de} -- /pub/programming/languages/C++
- {\tt ftp.cdrom.com} -- /pub/cdrom/cdroms/cug/capsule.tst
- {\tt ftp.uu.net} -- /usenet/comp.sources.reviewed
- {\tt netlib.att.com} -- Ode/O++
- {\tt sunsite.unc.edu} -- miscellaneous
{\tt iamsun.unibe.ch}
I>
\ifsli{\vspace{-1cm}}{}
}


\c{
For those that may use $ftp$,
source code posted to either one of the newsgroups
may be obtained by anonymous ftp from {\tt ftp.uu.net}.
Other valuable ftp sites are those mentioned in
sections  \ref{pde} and \ref{libraries},
among which  {\tt research.att.com},{\tt sunsite.unc.edu} and
{\tt iamsun.unibe.ch}.
\see{in-ftp}
}

\slide{in-misc}{Internet -- miscellaneous}{
:@ Tcl/Tk
\zline{\fbox{$ftp$}}
\ifsli{\vspace{-0.5cm}}{}
<I
- {\tt sprite.berkeley.edu} -- Tcl/Tk
- {\tt harbor.ecn.purdue.edu} -- Tcl/Tk contributions
I>
:@ Concurrent extensions of C++
\ifsli{\vspace{-0.5cm}}{}
<I
- {\tt actor.cs.vt.edu:/pub/act++} -- ACT++
- {\tt plg.uwaterloo.ca:/pub/uSystem} -- $%m${}C++
- {\tt cs.caltech.edu:/comp/CC++} -- Compositional C++
- {\tt uvacs.cs.virginia.edu:/pub/mentat} -- Mentat/C++
I>
\ifsli{\vspace{-1cm}}{}
}

\c{
Further, two sites are listed from which Tcl/Tk and
contributed software may be obtained,
as well as the addresses from which to obtain the concurrent
extensions to C++ discussed in section \ref{extensions}.
\see{in-misc}
}


\slide{in-doc}{Internet -- documentation}{
:@ Research papers and standards
\zline{\fbox{$ftp$}}
\ifsli{\vspace{-0.5cm}}{}
<I
- {\tt ftp.dcs.ed.ac.uk:pub/bcp} -- $fomega$
- {\tt cui.unige.ch:OO-articles} -- active objects
- {\tt omg.org} -- OMG
I>
\ifsli{\vspace{-1cm}}{}
}

\c{
A valuable collection of research papers may be obtained from
{\tt ftp.dcs.ed.ac.uk:pub/bcp}, among which is an introductory paper on type theoretical
aspects of OOP which comes with a collection of exercises
and an accompanying tool $fomega$.
Other research papers may be found at {\tt cui.unige.ch:OO-articles}.

Also available via anonymous ftp are the writings
of the OMG, which may be collected at {\tt omg.org}.
\see{in-doc}
}

\c{
:@ World Wide Web
Apart from email, news and ftp, you may access
the Internet by means of dedicated information retrieval
programs, such as the Mosaic browser for the
World Wide Web. See [_WWW].
}

\index{World Wide Web}
\slide{in-web}{Internet -- World Wide Web}{
:@ World Wide Web
\zline{\fbox{WWW}}
\ifsli{\vspace{-0.5cm}}{}
<I
- {\tt ftp.ncsa.uiuc.edu:/Mosaic} -- Mosiac browser
- {\tt info.cern.ch:/pub/www/doc} -- WWW documentation
I>
:@ Resources
\ifsli{\vspace{-0.5cm}}{}
<I
- {\tt http://cui\_www.unige.ch/OSG/OOinfo/}  -- OOP
- {\tt http://info.desy.de/user/projects/\c{C++.html}} -- C++ 
- {\tt http://hepunx.rl.ac.uk/atlas/oo/\c{eiffel/intro.html}} -- Eiffel
- {\tt http://www.osf.org:8001/} -- OSF DCE
\ifsli{}{
- {\tt http://www.sco.com/IXI/of\_interest/tcl/Tcl.html} -- Tcl/Tk
}
I>
\ifsli{\vspace{-1cm}}{}
}

\c{
The World Wide Web is an initiative
from CERN (the European Library for
Particle Physics, Switzerland),
intended to make a variety of material available
in a common hypermedia format (HTML, see section \ref{hypermedia-model}).
The Mosaic browser provides a graphical interface to the World Wide Web.
It is available for X-windows, MS-windows and the Macintosh
by anonymous ftp
from {\tt ftp.ncsa.uiuc.edu:/Mosaic}, where you can
also find documentation.
More information concerning the World Wide Web initiative
may be obtained from {\tt info.cern.ch:/pub/www/doc}.

The addresses listed in \sliref{in-web}
are HTML information resource identifiers,
which provide you with a starting point for
a journey in cyberspace documents on OOP.
}
