<document>

@# <a href=slic.html>The language Smalltalk</a>
\marksection{The language Smalltalk}
%%\markleft{The language Smalltalk}



Smalltalk has been, without doubt,
the most influential of all object-oriented
programming languages.
Originally meant as an {\em easy-to-use}
programming language for the {\em Dynabook}
(a laptop {\em avant-la-lettre}
developed in 1972 at Xerox Parc),
it has developed into a powerful
general purpose programming language
(which has stabilized in Smalltalk-80)
that runs on many platforms.
From the start, an interactive programming environment
has been an integral part of the language
implementation.
Later implementations also include support
for the interactive construction of user interfaces.

<slide id=app-A caption="The language Smalltalk">
\clearfalse
:@ Smalltalk <em> -- a radical change <c>in programming</c></em>
\zline{\fbox{A}}
\ifsli{\vspace{-0.5cm}}{}
<display>
 1972   Dynabook {I -- Alan Kay I}
 1976   SmallTalk76
 1980   SmallTalk80
 1990   ObjectWorks/SmallTalk <em> -- VisualWorks</em>
</display>
\ifsli{\vspace{1cm}}{}
:@ Design principles <em> -- <c>rapid</c> prototyping</em>
\ifsli{\vspace{-0.5cm}}{}
<I
- uniform object model {\em -- control}
- dynamic typing {\em -- flexible}
- standard libraries {\em -- functionality}
I>
\ifsli{\vspace{-1cm}}{}
</slide>

Influenced by the ideas of objects and classes embodied in Simula,
the design philosophy underlying Smalltalk
clearly reflects the desire
to effect nothing less than a radical
change in programming practice.
Characteristic for the design of
Smalltalk is a 
{\em uniform object model}
(which is even used to support common
control constructs),
{\em dynamic typing}
(which accounts for much of the flexibility
of Smalltalk)
and a sizable collection of 
{\em standard library classes}
(providing the functionality necessary
to build complex applications).
Smalltalk has successfully been used,
in particular for rapid prototyping.
<?latex>
<so term express control object inherit tech final>
<?/latex>
</document>
