@* Abstract type hierarchies

.so structural

@+ Inheritance versus delegation


\sli{
@ Design -- key abstractions
\nl
{\footnotesize
{\bf 1. Datastructures}: List, Set, Bag\n
{\bf 2. Storage}: Un/Bounded, Managed, Controlled\n
{\bf 3. Concurrency Managers}: Semaphore, Monitor\n
{\bf 4. Exceptions}: Over/Underflow, Null, Position\_Error\n
{\bf 5. Tools}: pipes, filters, sorts, searches\nl
\indent \fbox{5} $->$ \fbox{1} $->$ \fbox{2} $->$ \fbox{3} 
\nl
\indent \fbox{$ < DataStructure, StorageMgr, ConcurrencyMgr > $}
}
@ Inheritance {\em -- forest}
{\footnotesize
*- structure, complexity/overhead, ontology
$[]$ {\em Layered abstractions} -- reuse\n
$[]$ {\em Polymorphism} -- virtual functions, redefinition\n
$[]$ {\em Design structure} -- interfaces\n
$[]$ {\em Composition} -- private use
\n
}
}


@+ Designing for reuse


\sli{
@ Naming
*- favor consistency over specificity
{\footnotesize
Standard feature names:\nl
\indent {\em item} -- access operation \n
\indent {\em count} -- number of items \n
\indent {\em has} -- membership test\n
\indent {\em put} -- insert or replace item\n
\indent {\em force} -- like put\n
\indent {\em remove} -- remove an item\n
\indent {\em wipe\_out} -- remove all items\n
\indent {\em empty} -- absence of items\n
\indent {\em full} -- no more space
}
@ Conventions \n
{\em verbs} -- procedures\n
{\em nouns} -- attributes, functions\n
{\em adjectives, question-verbs} -- boolean queries\n
}

:@+ Using multiple inheritance

\sli{
\footnotesize
@ Classification
{\em -- taxonomy of data-structures}
\nl
{\em Access method} -- keys, order of insertion\n
{\em Traversing}  -- order\n
{\em Storage} -- fixed, resizable, unbounded
@ Traversal:
\curl{traversable}{hierarchical}{linear $ <- $ bi-directional}
@ Storage:
\curl{box}{infinite (lazy)}{\curl{finite}{unbounded}{\curl{bounded}{resizable}{fixed}}}
\nl\rm
}


\sli{
@ Access:\nl\it
\curl{container}{
   \curl{collection}{set}{\curl{bag}{
				\curl{dispenser}{stack}{queue}
				}{
				\curl{cursor}{list}{tree}
				}
			 }
		}{
   \curl{table}{indexable}{hash}
   }
}
