<document>

@* <a href=guide/what.html>What is object-orientation?</a>
%%@* <a href=@talk-what.html target=_top>What is object-orientation?</a>
\label{what}

%%<control><hr><a href=g-1.html>Instructors Guide</a><hr></control>
<?latex><so guide/what><?/latex>

Prior to any other characterization,
it must be stressed that object-oriented
programming does not deal with programming in
the sense of developing algorithms or data structures,
but must be studied as a (collection of) means
for the organization of programs and, more generally,
techniques for designing
programs.
From this perspective, OOP may be regarded as
an emerging methodology. See \sliref{1-objects}.

As the primary means for structuring a program or
design, OOP provides {\em objects}.
Objects may model real life entities,
may function to capture abstractions of arbitrary
complex phenomena, or may represent system
artifacts such as stacks or graphics.

Operationally, objects control the computation.
From the perspective of program development,
however, the most important characteristic of objects
is not their behavior as such, but the fact
that the behavior of an object may be described
by an abstract characterization of its interface.
Having such an abstract characterization suffices
for design.
The actual behavior of the object may be implemented
later and refined according to need.

\ifsli{\mbox{}\vspace{-1cm}}{}
%%\slide{1-objects}{Objects and inheritance}{
<slide id="1-objects" caption="Objects and inheritance">
\ifsli{\vspace{0.1cm}}{}
:@ OOP <em> -- objects and inheritance</em>
\ifsli{\vspace{-0.5cm}}{} 
<ul>
<li>  is not about programming but about program organization
</ul>
\ifsli{\vspace{-0.5cm}}{}
:@ Objects <em> -- abstractions</em>
\ifsli{\vspace{-0.5cm}}{}
<ul>
<li> real life / modeling
<li> system artifacts
</ul>
\ifsli{\vspace{-0.5cm}}{}
:@ Inheritance <em> -- incremental development</em>
\ifsli{\vspace{-0.5cm}}{}
<ul>
<li> abstract interfaces
<li> (implementation) refinement
</ul>
\ifsli{\vspace{-1.1cm}}{}
</slide>


Perhaps the most important contribution
of object orientation to the practice of
programming is the use of inheritance to
specify relations between (classes of)
objects.
Inheritance provides a means to add functionality
to a specification incrementally.
Inheritance thus enables better conceptual
modeling, since it allows a factoring out of the common
parts of a specification and the reuse of specifications.
When used in a disciplined fashion, inheritance
allows stepwise refinement of the
specification of the type of a class of objects,
and it allows us to view different objects of different types
as belonging to a common (super) type.

@so what/history
@so what/speak
@so what/features
@so what/poly
@so what/respons

</document>
