<document>
@+ Object speak

Smalltalk may be held responsible for the initial popularity
of the object-oriented approach.
However, the terminology it introduced was somewhat unfamiliar,
and for many evidently hard to grasp. 
See \sliref{1-oo-prog}.

\ifsli{\mbox{}\vspace{0.5cm}}{}
<slide id=1-oo-prog caption="Object Oriented Programming">
\ifsli{\vspace{0.1cm}}{}
:@ What is object-oriented programming?
\zline{\fbox{1982}}
\ifsli{\vspace{-1.5cm}}{}\ln
<p>
<em>What is object-oriented programming?</em>
My guess is that object-oriented programming
will be in the 1980s/1990s
what {\em structured programming}
was in the 1970s.
Everybody will be in favor of it.
Every manufacturer will promote his products as
supporting it.
Every manager will pay lip service to it.
Every programmer will practice it.
<em>And no one will know just what it is.</em>
\ln
\zline{untraced quotation}
</slide>

Perhaps unfortunately, it is not true that currently every programmer
uses an object-oriented language.
Nor is it true that everybody is in favor of object orientation.
To study object-oriented programming, however, the least one
can do is to become familiar with the terminology employed.

In this section, we will discuss the terminology associated
with object orientation, and look
at what features and benefits are generally acclaimed
by proponents of an object-oriented approach.


:@ Object terminology
Objects provide the means by which to structure a system.
In Smalltalk (and most other object-oriented languages) objects are considered to
be grouped in classes. A {\em class} specifies the behavior of the objects that
are its instances. Also, classes act as templates from which actual objects may be created.
Inheritance is defined for classes only.
From the perspective of design, inheritance is primarily meant
to promote the reuse of specifications.
See \sliref{1-speak}.

<slide id=1-speak caption="Object terminology">
\footnotesize
@ Object terminology
\zline{\fbox{object speak}}
<I
- objects -- {\em packet containing data and procedures}
- methods -- {\em deliver service}
- message -- {\em request to execute a method}
- class -- {\em template for creating objects}
- instance -- {\em an object that belongs to a class}
- encapsulation -- {\em information hiding supported by objects}
- inheritance -- {\em mechanism allowing the reuse of class specifications}
- class hierarchy -- {\em tree structure representing inheritance relations}
- polymorphism -- {\em to hide different implementations behind a common interface}
I>
\ifsli{\vspace{-1cm}}{}
</slide>

The use of inheritance results in a class hierarchy
that, from an operational point of view,
determines the dispatching behavior of objects,
that is what method will be selected in response to a message.
If certain restrictions are met (see sections \ref{contracts},
\ref{subtypes} and \ref{types-behavioral}),
the class hierarchy corresponds to a type hierarchy,
specifying the subtype relation between classes of objects.

Finally, an important feature of object-oriented
languages is their support for polymorphism.
Polymorphism is often incorrectly identified with inheritance.
Polymorphism by inheritance makes it possible
to hide different implementations behind a common interface.
However, other forms of polymorphism may arise by overloading functions
and the use of generic (template) classes or functions.
See sections \ref{1-poly} and \ref{flavors}.
</document>
