<document>
@ Coherent models
The OMT {\em object model}, however,
only captures the static structure of the system.
To model the dynamic and functional aspects, the
object model  is augmented with a
{\em dynamic model}, which is given by state diagrams,
and a {\em functional model}, which is handled
by data flow diagrams.
From a formal point of view this solution is rather
unsatisfactory since, as argued in [_Hayes91],
it is hard to establish the consistency of the
combined model, consisting of an object,
dynamic and functional model.

<slide id=3-coherent cap="Coherent models -- criteria">
@ Model criteria <em> -- formal approach</em>
\ifsli{\clearfalse\vspace{-0.5cm}}{}
<I
- {\em unambiguous} --  single meaning
- {\em abstract} -- no unnecessary detail
- {\em consistent} -- absence of conflict
I>
\ifsli{\clearfalse\vspace{-1cm}}{}
</slide>

Consistency checking, or at least the possibility
to do so, is important to increase our belief
in the reliability (and reusability) of a model.
To be able to determine whether
a model is consistent, the model should be
phrased in an unambiguous way, that is, in a notation
with a clear and precise meaning.
\see{3-coherent}
Also, to make the task of consistency checking manageable,
a model should be as abstract as possible, by leaving
out all irrelevant details.
To establish the consistency of the combined
model, covering structural, functional and dynamic aspects,
the interaction between the various models must be clearly
defined.

Currently, to my knowledge, there is no
completely developed method encompassing the
structural, functional and dynamic aspects
of a system in a manner that is amenable to
a rigorous formal approach.
However, there is an emerging understanding of how to
deal with these various aspects.
Moreover, there are attempts towards a standardization of the notions
employed in the various methods.
See sections \ref{OMG} and \ref{methods}.
</document>
