<document>
\ifsli{\vspace{1cm}}{}

@* <a href=g-con.html>Contracts</a>

\label{contracts}

To establish the interaction between objects in a more
precise way, we need a notion of {\em contracts},
specifying the requirements a client must comply with
when requesting a service from a server object.
Our notion of contracts will be based on the notion of {\em types}.

In the universe of programming,
{\em types} are above all a means to create
order and regularity.
Also, in an object-oriented approach,
types may play an important role in
organizing classes and their relationships.
As observed in [_HOB87],
the notion of types gives a natural criterion
for {\em modularization},
perhaps not so much as a guideline to arrive at a particular
object decomposition,
but as a means to judge whether the modular
structure of a system is consistently defined,
that is technically well-typed.
\see{3-types}


\vfig{0.5}
<slide id=3-types cap="Types and inheritance">
:@ Object-Oriented Methodology
<p>
increases programmer 
productivity by enhancing software maintainability, extensibility and
reusability 
<I
- {\bf types} -- {\em organizing principle in OO}
- {\bf inheritance} -- {\em to specify relations between types}
I>
:@ OOP blurs design and implementation
*- types -- natural basis for modularization
*- well designed type structure -- minimize and localize dependencies  
</slide>

The meaning of a type must be understood as
a formal characterization of the behavior of the
elements belonging to the type.
A type consists of a (possibly infinite)
collection of elements which is characterized by the definition
of the type.
For example, a {\em class} defines such a collection,
namely the instances of the class, whose behavior
is constrained by the specification of the class.

@so contract/formal


@so contract/confor

@so contract/reali
@so contract/oror
</document>
