<document>
This chapter presented an overview
of the issues involved in the design
of object-oriented software.
The approach taken may be characterized
as eclectic, in that various methods are referred to
when illustrating design issues
without commitment to a particular method
or approach.
}

\clearfalse
%%\vfig{0.5}
<slide id=3-1 cap="Section 3.1: The process of design">
:@ <a href=process.html>The process of design</a>
\zline{\fbox{1}}
\ifsli{\vspace{-0.5cm}}{}
<I
- {\em software development process} -- components, aspects
- {\em modeling reality} -- perspectives of modeling
- {\em design model} -- as a justification
- {\em dimensions of modeling} -- object, dynamic, functional
I>
\ifsli{\vspace{-1cm}}{}
</slide>

In section 1,
we discussed the components or aspects
of the software development process
and characterized the perspectives of
modeling associated with the various
phases of development.
We also looked at the various modeling
dimensions distinguished in the OMT method.

\clearfalse
\vstr{1}
<slide id=3-2 cap="Section 3.2: Identifying objects">
:@ <a href=objects.html>Identifying objects</a>
\zline{\fbox{2}}
\ifsli{\vspace{-0.5cm}}{}
<I
- {\em object-oriented design} -- decomposition into objects
- {\em object model} -- objects suffer and require
- {\em heuristics} -- balance between nouns and verbs
- {\em evaluation} -- eliminating spurious classes
- {\em class design} -- class, responsibilities and collaborations
I>
\ifsli{\vspace{-1cm}}{}
</slide>

In section 2,
we then discussed the issues that arise in
defining an object model.
We looked at heuristics for identifying objects,
based on a linguistic analysis of the requirements document,
and  discussed the evaluation criteria
that may be used for eliminating
spurious classes.
Also, the CRC method,
which approaches class design by delineating responsibilities and collaborations,
was illustrated with some examples.

\clearfalse
<slide id=3-3 cap="Section 3.3: Contracts">
:@ <a href=contract.html>Contracts</a>
\zline{\fbox{3}}
\ifsli{\vspace{-0.5cm}}{}
<I
- {\em types} -- as an organizing principle
- {\em contracts} -- obligations and benefits
- {\em subtyping} -- the substitutability requirement
- {\em partial types} -- designed to have subtypes
I>
\ifsli{\vspace{-1cm}}{}
</slide>

The object model resulting from
an initial exploration may be formalized
by employing types.
In section 3, we discussed the notion of $contracts$
as a means to characterize the behavioral
aspects of types,
specifying the restrictions and obligations
of an object and its clients.
We also looked at the requirements
for subtype refinement
and discussed the notion of partial types.

\clearfalse
<slide id=3-4 cap="Section 3.4: From specification to design">
:@ <a href=design.html>From specification to design</a>
\zline{\fbox{4}}
\ifsli{\vspace{-0.5cm}}{}
<I
- {\em modeling} -- structural versus behavioral
- {\em specification} -- state and operations
- {\em abstract systems} -- as a design methodology
I>
\ifsli{\vspace{-1cm}}{}
</slide>

In section 4,
we discussed the distinction between
structural and behavioral modeling.
Also we looked at a model-based specification
formalism and
and discussed a design methodology
employing {\em abstract systems} and events
to realize the specification of user actions.
</document>
