<document>
@* <a href=g-proc.html>The process of design</a>
\label{3-process}
\label{process}



Initially, object-oriented software development
was language-driven.
The motivation to adopt an object-oriented approach
came first from the need to cope with increasingly 
complex software systems.
Research in object-oriented programming was
primarily concerned with the development 
of language mechanisms to support the new approach.

Only recently, has the attention shifted from language
support mechanisms and the pragmatics of program development
to issues of analysis and design.
Research concerning language mechanisms, however, is
still important, for example in the area
of concurrent/distributed programming and 
the support of persistent objects. See part II.

\vfig{1}
<slide id=3-development cap="Object-oriented development">
:@ Object-Oriented Development
*- to manage the complexity of massive software intensive systems
{\bf OOD/P} -- will be in the 90s what structured programming was in the 70s.
:@ Criterion for decomposition: \fbox{object}
*- each {\em object} must correspond to an object or concept of the problem domain
:@ Abstractions of the problem space
*- {\em model of reality} -- promotes an understanding of the system
\ifsli{\vspace{-0.5cm}}{}
</slide>


The common denominator in both analysis and design
in an object-oriented approach
may be characterized as a {\em decomposition into objects}.
\see{3-development}
Objects, according to [_Booch86], are {\em crisp}
entities, that {\em suffer} and {\em require} actions,
which (must) have a clear relation to concepts 
or entities of the problem domain.

Ideally, we have a seamless transition between the phases of analysis, design
and implementation.
Seamless in the sense that the various phases
employ a common object model, that is gradually
refined as the project progresses.
In other words, such a transition presupposes a notion
of objects that may unify the activities in the respective phases.
The central imperative of the object-oriented movement,
namely to provide a {\em model of reality}, still betrays
the conception of object-oriented programming as {\em simulation},
as originally expressed by [_DaNy66].
The initial motivation underlying this approach is the idea that a natural representation
of the problem domain in a software system may reduce the complexity of
understanding the system implementing a solution.
The presupposition here is that {\em modeling} involves the use
of objects to represent the entities in the problem domain.
Assuming the presupposition to hold, our task then reduces to
identifying the right objects and showing that that particular
decomposition is valid with respect to the original problem.
The goal of design may then be stated as arriving at an architectural
structure that adequately reflects the relevant properties of
the problem domain.


@so architec
@so model
@so function
</document>
