<document>
@* <a href=g-ext.html>Extensions to the object model <em> -- abnormal events</em></a>
\marksection{Extensions to the object model {\em -- abnormal events}}


When studying the literature on OOP, one can discern a tendency of convergence between the
distinct (language) camps.
For instance, as already noted, interpreted languages are being 
optimized to compete with C/C++, and on the other hand, proposals are being made
to extend C++ with some of the more exotic features found in, for 
instance, Smalltalk or Flavors,
features such as dynamic typing and meta classes.
Also, there is an interesting convergence and mutual influence between
Eiffel and C++.
For instance, the newer version of Eiffel also supports constructors
and overloading,
whereas rumors have it that multiple inheritance in C++ has 
primarily been inspired by its use in Eiffel.
<p>
In the following we will briefly explore some extensions
to the basic object model, and try to establish why they may
be considered useful.
\see{2-extensions}

\vfig{1}
<slide id=2-extensions caption="Extensions to the object model">
@ Meta classes
*- class wide values, runtime type information
@ Object identity
*- unique references, distribution
@ Persistence
*- storage of objects (OODBMS)
@ Active objects
*- autonomous behavior, concurrency
</slide>

<p>
Meta classes are a feature of Smalltalk supporting 
the definition of class-wide variables and so-called class methods.
Class methods must be used to create new instances of the class.
Neither Eiffel nor C++ support meta classes, although C++
supports so-called $static$ data and function members, which are
accessible by all instances of a class.
The action of creating objects (as instances of classes)
is for both languages taken care of by special creation functions
or $constructors$.
A feature that is felt to be lacking in C++ is the possibility
of obtaining type information during runtime.
Although libraries exist that provide the required functionality
(to some extent), it seems likely that the language will be extended
by constructs supporting this directly.
(Currently, the ANSI standardization committee for C++ is studying proposals
to introduce features supporting dynamic type information in C++.)
See also section \ref{OMG}.

In most object-oriented systems, references to objects are system dependent
(addresses in some memory space) and are usually lost when  program
execution stops.
To facilitate debugging it would be convenient to be able to deal with
(unique) symbolic references to objects.
A more flexible scheme of object naming may also be important for
distributed systems, since symbolic identities may also have meaning
outside the program's execution space.
See section \ref{distribution}.
<p>
Object identity also plays an important role in object-oriented
data bases, since the persistent storage of objects requires
a naming scheme that allows objects to be written to stable storage
and retrieved independently from the current execution.
%%See section \ref{XX} for a further discussion of OODBMS.
<p>
To my mind, one of the most interesting extensions
to the basic object model is the notion of $active$ objects,
objects with autonomous behavior.
Important issues that relate to this extension are, what concurrency model
must be supported and what to do with distribution.
See chapter \ref{Distribution and concurrency}.
Moreover, from the perspective of design we must ask,
are active objects useful and how do they fit in with the design
of sequential systems?


\marksection{Extensions to the object model {\em -- abnormal events}}
<so except>
\marksection{Extensions to the object model {\em -- abnormal events}}
</document>
