<document>
@+ Base class hierarchies

Inheritance allows the programmer to define
a class hierarchy which corresponds to
a hierarchy of (polymorphic) pointer types.
In particular, the root class (at the top
of the hierarchy) corresponds to a pointer type
that acts as a generic type with respect
to the pointer types corresponding with the
other classes in the hierarchy.
In addition, the root class specifies
an interface common to all classes lower in the
hierarchy.

<slide id=2-base caption="Base class polymorphism">
@ Class hierarchies
\ifsli{\vspace{-0.5cm}}{}
@ds lib/shapelis.s
\ifsli{\ln\vspace{-1.5cm}}{}
</slide>

The polymorphic property of (base class) pointers
allows for the definition of a generic container
for element types ranging over the pointer types
corresponding to the descendants of the base class.
<p>
As an example, look at the $shapelist$
defined in \sliref{2-base}.
The class $shapelist$ declares instance variables
$hd$ (of type $shape*$) and $tl$
(of type $shapelist*$).
The insertion of a new element results
in the creation of a new $shapelist$ which has the
element as a head and the original list as its tail.
Note that the head of each list
is a pointer to an instance of $shape$
or one of its derived classes.
A pointer is needed since the size of
the actual object will vary depending on the
actual type of the object inserted.
For example, a $circle$ extends a $shape$
by including an additional instance
variable giving its radius.
<p>
Employing base class hierarchies offers
a safe, yet limited, means by which to define
generic (container) types.
(Limited, because the base class imposes
constraints on the actual types for which
the generic data type may be used.)

<so gen-void>
</document>
