<document>

\label{multiple-inheritance}

@ Multiple inheritance
Graphical shapes are a typical example
of objects allowing for a tree-shaped
taxonomy.
Sometimes, however, we wish to define
a class not from a single base class,
but by deriving it from multiple base classes,
by employing multiple inheritance.

<slide id=2-multi-1 caption="Multiple inheritance">
\ifsli{ \vspace{0.5cm} }{\vspace{0.1cm}}
<program><include file=lib/s_a.s></program>
\ifsli{\ln\vspace{-1.5cm}}{\vspace{-0.2cm}}
</slide>

In \sliref{2-multi-1}, one of the classical
examples of multiple inheritance is depicted,
defining a <em>student_assistant</em> 
by inheriting from {\em student} and {\em assistant}.
<p>
Dynamic binding for instances of a class derived by multiple
inheritance works in the same way as
in the case of single inheritance.
However, ambiguities between member function
names must be resolved by the programmer.

<slide id=2-multi-2 caption="Virtual base classes">
\ifsli{ \vspace{0.5cm} }{\vspace{0.1cm}}
<program><include file=lib/p_s_a.s></program>
\ifsli{\ln\vspace{-1.5cm}}{\vspace{-0.2cm}}
</slide>

When using multiple inheritance,
one may encounter situations where the classes
involved are derived from a common base class,
as illustrated in \sliref{2-multi-2}.
<p>
To ensure that {\em student\_assistant}
contains only one copy of the $person$
class, both the $student$ and $assistant$
classes must indicate that the $person$
is inherited in a virtual manner.
Otherwise, we may not have a declaration of the form
[P
person* p = new student_assistant(20,6777,300);
P]
since the compiler would not know
which $person$ was meant
(that is, how to apply the
conversion from {\em student\_assistant} to $person$).
</document>
