<document>

The C++ compiler offers
only protection from mistakes, not from abuse.
For example, we may access the private
base class by employing casts,
as illustrated in \sliref{2-priv}.

\clearfalse
<slide id=2-priv caption="Casting to private base classes">
\ifsli{}{\vspace{0.1cm}}
<program><include file=lib/p-i.s></program>
\ifsli{\ln\vspace{-1.5cm}}{\vspace{-0.2cm}}
</slide>

In \sliref{2-priv} we have defined a class
$A$, and a class $B$ that privately inherits from
$A$.
As illustrated in the program fragment
<!--\nslide{}{}{-->
[P
A* a = new B; ///// error
A* b = (A*) new B; ///// accepted 
b->print(); ///// XAX
P]
<!--}-->

\noid
we can access the $B$ part of $A$
by using a cast.
However, we can also gain access by
completely bypassing the public interface
of a class, as illustrated by the fragment below
<!--\nslide{}{}{-->
[P
char* p = (char*) b;
while( *p != 'X' ) p++;
cout << p << endl; ///// XAX
P]
<!--}-->

\noid
The trick is to cast the object pointer
to an array of $char$, which allows us to
inspect each byte of the object.

Casting is the most dangerous feature
offered by C and C++.
It allows programmers to circumvent
the type system in completely arbitrary ways.
</document>
