<document>
This chapter looked at
system development from a
software engineering perspective.
How may we establish that software
is reliable and to what extent can our
experience be generalized to an object-oriented approach?

\vfig{1}
\clearfalse
<slide id=4-1 cap="Section 4.1: Validating software">
:@ <a href=valid.html>Validating software</a>
\zline{\fbox{1}}
\ifsli{\vspace{-0.5cm}}{}
<I
- {\em software quality} -- structural criteria
- {\em testing} -- strategy, tactics, operational
- {\em inheritance} -- inherited code must be retested
I>
\ifsli{\vspace{-1cm}}{}
</slide>

We discussed the notions of software
quality, including structural criteria,
and testing, as an empirical way in which to
validate software.
An example has been given,
illustrating that inherited code may
need to be retested.

\clearfalse
\vfig{3}
<slide id=4-2 cap="Section 4.2: A framework for testing object-oriented programs">
:@ <a href=frame.html>A framework for testing object-oriented programs</a>
\zline{\fbox{2}}
\ifsli{\vspace{-0.5cm}}{}
<I
- {\em levels of testing} -- influence of errors
- {\em object test methods} -- state transitions
- {\em contracts} -- interaction protocols
- {\em static testing} -- careful reading
I>
\ifsli{\vspace{-1cm}}{}
</slide>
%%\vfig{3}
\vfig{1}

We developed (the beginnings of)
a framework for testing object-oriented
software,
discussed the influence of errors
and looked at object test methods
directed at verifying
state transitions.
We also discussed how {\em contracts}
may provide a guideline for testing,
indicating state invariant interaction
protocols.
Testing may also be done by carefully reading the code,
preferably with a group of colleagues.

\clearfalse
<slide id=4-3 cap="Section 4.3: Guidelines for design">
:@ <a href=lines.html>Guidelines for design</a>
\zline{\fbox{3}}
\ifsli{\vspace{-0.5cm}}{}
<I
- {\em metrics} -- objects, attributes, communication
- {\em law of demeter} -- class interfaces
- {\em reuse} -- individual class design
I>
\ifsli{\vspace{-1cm}}{}
</slide>

A number of metrics for object-oriented design have been proposed.
These metrics may be used to establish
the complexity of object models.
The metrics given are meant only
as a starting point
for further research and empirical
validation.
They cover aspects such as
the complexity of the relation
between the definition and usage of attributes
and the complexity of communication
patterns between objects.


Related to the issues of complexity,
we discussed the Law of Demeter
which gives a guideline for good
object-oriented design,
including suggestions for class
transformations to improve a particular
design.
Also we looked at some guidelines 
for individual class design.

\clearfalse
<slide id=4-4 cap="Section 4.4: Towards a formal approach">
:@ Towards a formal approach
\zline{\fbox{4}}
\ifsli{\vspace{-0.5cm}}{}
<I
- {\em contracts} -- formal specification
- {\em verification} -- as a design methodology
- {\em runtime consistency} -- invariance
I>
\ifsli{\vspace{-1cm}}{}
</slide>

Finally, we reflected on the possible
contribution of formal methods to
the software engineering of
object-oriented systems,
and concluded that the notion of
{\em contracts} may play an invaluable role,
both as a design methodology and as
a means to establish the runtime
consistency of a system.
</document>
