\slipar{
:@ Objectives
In this section a number of metrics are introduced that may be
used to establish quantitative measures of object oriented
design.
Also formal evaluation criteria for these metrics are discussed,
which give a guideline for the interpretation of the outcome
of applying the metrics to actual designs.

:@ Points to emphasize
<N \setcounter{enumi}{7}
- {\em object definition} -- WMC, DIN, LCO
- {\em attributes} -- RFC, LCO
- {\em communication} -- RFC, CBO
N>

:@ Possible difficulties
The formal definition of the metrics and the proofs concerning
their behavior under the evaluation criteria given are in itself
not very difficult, but may (with respect to the
experience of your audience) be somewhat hard to swallow at first sight.

:@ Hints
It needs to be stressed that the metrics discussed are
not supported by any empirical validation.
Clearly, this is needed to establish their usefulness 
in actual software development projects.

:@ Questions
<N \setcounter{enumi}{6}
- What metrics can you think of for object oriented design?
What is the intuition underlying these metrics?
- What evaluation criteria for metrics can you think of?
Are these sufficient for applying such metrics in actual software
projects? Explain.
- Give a formal definition of the following metric:
WMC, DIN. NOC, CBO, RFC, and LCO.
Explain their meaning from a software engineering viewpoint.
N>

:@ Comments
This section must be regarded as a starting point for further exploration and research.
One can think of incorporating such metrics in a browsing
tool.
More importantly, however, are empirical results with regard
to the validity of these metrics.
\clearpage
}
