#include </usr/prac/se/hush/include/adt/assert.h>
#include "bool.h"


template< class E > /// \fbox{OOP}
class list {
public:
list() { }
virtual ~list() { }
virtual int empty()=0;
virtual E head()=0;
virtual list<E>* tail()=0;
virtual int operator==(list<E>* m)=0;
};

//template<class E> int list<E>::empty() { return 1; }


template< class E >
class nil : public list<E> {
public:
nil() {}
int empty() { return 1; }
E head() { require( false ); return E(); }
list<E>* tail() { require( 0 ); return 0; }
int operator==(list<E>* m) { return m->empty(); }
};

template< class E >
class cons : public list<E> {
public:
cons(E e, list<E>* l) : _e(e), next(l) {}
~cons() { delete next; }
int empty() { return 0; }
E head() { return _e; }
list<E>* tail() { return next; }
int operator==(list<E>* m);
protected:
E _e;
list<E>* next;
};

template< class E > 
bool cons<E>::operator==(list<E>* m) {
	return !m->empty() &&
	head() == m->head() &&
	tail() == m->tail();
	}
	
	
class interval : public list<int> {
public:
interval(int x, int y) : _x(x), _y(y) {
	require( x <= y );
	}
int empty() { return 0; }
int head() { return _x; }
list<int>* tail() {
	return (_x+1 <=_y)?new interval(_x+1,_y): new nil<int>;
	}
int operator==(list<int>* m) { 
	return !m->empty() && _x == m->head() && tail() == m->tail();
	}
protected:
int _x;
int _y;
};


void main () {
list<int>* r = new cons<int>(1, new cons<int>(2, new interval(3,7) )); 
while (! r->empty()) { 
	cout << r->head() << endl;
	r = r->tail();
	}
delete r;
}
