typedef int element;

enum { NIL, CELL, INTERVAL };

struct list {
int tag;
element e; 
union { element z; list* next; }
};
}


list* nil(list* l) {
	l = new list; l->tag = NIL; return l;
	}

list* cons( element e, list* l) { 
	list* x = new list;
	x->tag = CELL; x->e = e; x->next = l;
	return x;
	}

list* interval( element x, element y ) {
	require( x <= y );
	list* x = new list; x.e = x; x.z = y;
	return x;
	}

int empty(list* l) { return l->tag = NIL; }

element head(list* l) { 
	require( ! empty(l) );
	switch( l->tag ) {
		case CELL: return l->e;
		case INTERVAL: return l->x;
		}
	}

list* tail(list* l) {
	require( ! empty(l) );
	switch( l->tag ) {
		case CELL: return l->next;
		case INTERVAL: return interval(x+1,y);
		}
	}

int equal(list* l, list* m) {
	switch( l->tag) {
		case NIL: return empty(m);
		case CELL: return !empty(m) && 
			l->e == m->e &&
			equal(tail(l),tail(m));
		case INTERVAL: return !empty(m) &&
			m->tag == INTERVAL &&
			m->e = l->e && equal(l->next,m->next);
	}
