<document>
\index{formal models for OOP}

:@ Formal models
There is a wide variety of formal models  available
in the literature.
These include algebraic models (to characterize the meaning
of abstract data types), models based on
the lambda-calculus and its extensions (that are primarily
used for a type theoretical analysis of object-oriented
language constructs),
algebraic process calculi (that may be used to characterize the
behavior of concurrent objects),
operational and denotational semantic models
(to capture behavioral and  properties of programs),
and various specification languages based on
first or higher-order logics
(that may be used to specify the desired behavior
of collections of objects).

We will limit ourselves to studying
algebraic models capturing the properties of abstract data
types and objects (section \ref{algebra}),
type calculi based on typed extensions of the lambda calculus
capturing the various flavors of polymorphism and subtyping
(sections \ref{flavors}--\ref{self-reference}), and
an operational semantic model characterizing the behavior
of objects sending messages (section \ref{behavior}).

Both the algebraic and type theoretical models
are primarily intended to clarify the means we have
to express the desired behavior of objects
and the restrictions that must be adhered to
when defining objects and their relations.
The operational characterization of object behavior,
on the other hand, is intended to give a more
precise characterization of the notion of state
and state changes underlying the verification
of object behavior by means of assertion logics.

Despite the numerous models introduced there are
still numerous approaches not covered here.
One approach worth mentioning is the work based
on the {\em pi-calculus}.
The {\em pi-calculus} is an extension of algebraic
process calculi that allow for communication via
named channels.
Moreover, the {\em pi-calculus} allows for a notion
of migration and the creation and renaming 
of channels.
A semantics of object-based languages based
on the {\em pi-calculus} is given in 
[_Walker90].
However, this semantics does not cover
inheritance or subtyping.
A higher-order object-oriented programming
language based on the {\em pi-calculus} is
presented in [_PRT93].

Another approach of interest, also based on process calculi,
is the object calculus (OC) described in [_Nier93].
OC allows for modeling the operational
semantics of concurrent objects.
It merges the notions of agents, as used in process calculi,
with the notion of functions, as present in the lambda calculus.

For alternative models the reader may look 
in the {\tt comp.theory} newsgroup to which information
concerning formal calculi for OOP is posted
by Tom Mens of the Free University, Brussels.
</document>
