<document>

This chapter has presented an introduction
to the theoretical foundations of
abstract data types.
In particular, a characterization was
given of {\em types as constraints}.

\vfig{1}
<slide id=8-1 cap="Section 8.1: Abstraction and types">
:@ <a href=types.html>Abstraction and types</a>
\zline{\fbox{1}}
<I
- {\em abstraction} -- control and data
- {\em abstract data types} -- values in a semantic domain
- {\em types as constraints} -- mathematical models
I>
\ifsli{\vspace{-0.5cm}}{}
</slide>

In section 1,
we discussed the notion of abstraction
in programming languages and
distinguished between control and
data abstractions.
Abstract data types were characterized as values in some domain,
and we looked at the various ways in which
to define mathematical models
for types.

\cleartrue
<slide id=8-2 cap="Section 8.2: Algebraic specification">
:@ <a href=algebra.html>Algebraic specification</a>
\zline{\fbox{2}}
<I
- {\em signature} -- producers and observers
- {\em generator universe} -- equivalence classes
- {\em initial model} -- no junk, no confusion
- {\em objects} -- multiple world semantics
I>
\ifsli{\vspace{-0.5cm}}{}
</slide>
\vfig{0}

In section 2,
we studied the algebraic specification
of abstract data types by means of
a signature characterizing producers
and observers.
We discussed the notions of equivalence
classes and initial models,
which consist of precisely the equivalence
classes that are needed.


\clearfalse
<slide id=8-3 cap="Section 8.3: Decomposition -- modules versus objects">
:@ <a href=modules.html>Decomposition -- modules versus objects</a>
\zline{\fbox{3}}
<I
- {\em data abstraction} -- generators/observers matrix
- {\em modules} -- operation oriented
- {\em objects} -- data oriented
I>
\ifsli{\vspace{-0.5cm}}{}
</slide>

Also, we looked at the interpretation of
objects as algebras, and we discussed
a multiple world semantics allowing for
dynamic state changes.

In section 3,
we looked at the various ways we may realize data abstractions
and we distinguished between a modular
approach, defining a collection of
operations, and a data oriented approach,
employing objects.

\clearfalse
<slide id=8-4 cap="Section 8.4: Types versus classes">
:@ <a href=classes.html>Types versus classes</a>
\zline{\fbox{4}}
<I
- {\em types} -- syntactically, semantically, pragmatically
- {\em compatible modifications} -- type, signature, class
I>
\ifsli{\vspace{-0.5cm}}{}
</slide>

Finally, in section 4, we discussed the differences
between a syntactic, semantic and operational
interpretation of types,
and how these viewpoints affect our
notion of refinement or compatible
modification.
</document>
