<document>

@$=tt

:@ Hiding in C++
Naturally, the classical way of data hiding in C++
is to employ $private$ or $protected$ access protection.
Nevertheless, an equally important means
is to employ an abstract interface class
in combination with forwarding, as discussed
in section \ref{delegation}.


\cleartrue
<slide id=9-cc-hide cap="Hiding in C++">
\ifsli{}{\vspace{0.1cm}}
[P
class event { /// \fbox{event}
protected:
event(event* x) : ev(x) {}
public:
int type() { return ev->type(); }
void* rawevent() { return ev; }
private:
event* ev;
};

class xevent : public event { ///\fbox{X}
public:
int type() { return X->type(); }
private:
struct XEvent* X;
};
P]
\ifsli{\ln\vspace{-1.5cm}}{\vspace{-0.2cm}}
</slide>

For example, as depicted in
\sliref{9-cc-hide},
we may offer the user a class $event$
which records information concerning
events occurring in a window environment,
while hiding completely the underlying
implementation.
The actual $xevent$ class realizing the type
$event$ may itself need access to other
structures,
as for example those provided by the X window
environment.
Yet, the $xevent$ class itself may remain entirely
hidden from the user, since events
are not something created directly
(note the protected constructor)
but only indirectly,
generally by the system in response
to some action by the user.
</document>
