<document>

This chapter has treated polymorphism
from a foundational perspective.

In section 1,
we looked at abstract inheritance as
employed in knowledge representation.

\vfig{1}
\clearfalse
<slide id=9-1 cap="Section 9.1: Abstract inheritance">
:@ <a href=abstract.html>Abstract inheritance</a>
\zline{\fbox{1}}
\ifsli{\vspace{-0.5cm}}{}
<I
- {\em abstract inheritance} --
declarative \c{relation}
- {\em inheritance networks} --
non-monotonic \c{reasoning}
- {\em taxonomic structure} --
predicate\ifsli{s}{ calculus}
I>
\ifsli{\vspace{-1cm}}{}
</slide>

We discussed the non-monotonic aspects
of inheritance networks
and looked at a first order logic
interpretation of taxonomic
structures.

\clearfalse
<slide id=9-2 cap="Section 9.2: The subtype relation">
:@ <a href=subtypes.html>The subtype relation</a>
\zline{\fbox{2}}
\ifsli{\vspace{-0.5cm}}{}
<I
- {\em types} -- sets of values
- {\em the subtype relation} -- refinement \c{rules}
- {\em functions} -- contravariance
- {\em objects} -- as records
I>
\ifsli{\vspace{-1cm}}{}
</slide>

In section 2,
a characterization of types as sets of values
was given.
We looked at a formal definition of the
subtype relation and discussed
the refinement rules for functions and objects.

%%\cleartrue
<slide id=9-3 cap="Section 9.3: Flavors of polymorphism">
:@ <a href=flavors.html>Flavors of polymorphism</a>
\zline{\fbox{3}}
\ifsli{\vspace{-0.5cm}}{}
<I
- {\em typing} -- protection against errors
- {\em flavors} -- parametric,
inclusion, overloading, coercion
- {\em inheritance} --
incremental modification mechanism
I>
\ifsli{\vspace{-1cm}}{}
</slide>

In section 3,
we discussed types as a means to prevent errors,
and distinguished between various flavors
of polymorphism,
including parametric polymorphism,
inclusion polymorphism, overloading and
coercion.
Inheritance was characterized as an incremental
modification mechanism, resulting in
inclusion polymorphism.

\vfig{1}
\ifsli{\clearpage\vfig{0.0}}{}
\vfig{0}
\clearfalse
<slide id=9-4 cap="Section 9.4: Type abstraction">
:@ <a href=types.html>Type abstraction</a>
\zline{\fbox{4}}
\ifsli{\vspace{-0.5cm}}{}
<I
- {\em subtypes} -- typed lambda calculus
- {\em overloading} -- intersection types
- {\em bounded polymorphism} --
generics and inheritance
I>
\ifsli{\vspace{-1cm}}{}
</slide>

In section 4,
some formal type calculi were presented,
based on the typed lambda calculus.
These included a calculus for simple subtyping,
a calculus for overloading,
employing intersection types,
and a calculus for bounded polymorphism,
employing type abstraction.
Examples were discussed illustrating the (lack of) features
of the C++ type system.

\clearfalse
<slide id=9-5 cap="Section 9.5: Existential types">
:@ <a href=existent.html>Existential types</a>
\zline{\fbox{5}}
\ifsli{\vspace{-0.5cm}}{}
<I
- {\em hiding} -- existential types
- {\em packages} -- abstract data types
I>
\ifsli{\vspace{-1cm}}{}
</slide>

In section 5,
we looked at a calculus employing
existential types, modeling abstract
data types
and hiding by means of packages
and type abstraction.


\clearfalse
<slide id=9-6 cap="Section 9.6: Self reference">
:@ <a href=self.html>Self reference</a>
\zline{\fbox{6}}
\ifsli{\vspace{-0.5cm}}{}
<I
- {\em self-reference} -- recursive types
- {\em object semantics} -- unrolling
- {\em inheritance} -- dynamic binding
- {\em subtyping} -- inconsistencies
I>
\ifsli{\vspace{-1cm}}{}
</slide>

Finally, in section 6, we discussed self-reference
and looked at a calculus employing recursive
types.
It was shown how object semantics may be determined
by unrolling, and we studied the semantic
interpretation of dynamic binding.
Concluding this chapter, an example was given
showing an inconsistency in the
Eiffel type system.
</document>
