<document>

This chapter extended the notion of
subtyping to include
behavioral properties.

In section 1,
we discussed the interpretation of types
as behavior and we looked at
the issues involved in preserving 
invariance and history properties.

<slide id=10-1 style=guide cap="Section 10.1: Types as behavior">
:@ <a href=types.html>Types as behavior</a>
\zline{\fbox{1}}
\ifsli{\vspace{-0.5cm}}{}
<I
- {\em subtype requirements} --
preservation of behavioral properties
- {\em behavioral properties} --
invariance, history
- {\em duality} --
static versus dynamic constraints
I>
\ifsli{\vspace{-1cm}}{}
</slide>


Also, we discussed the duality between
static and dynamic type constraints.

In section 2,
a brief characterization of an assertion logic 
for verifying behavioral properties
was given.

<slide id=10-2 style=guide cap="Section 10.2: Verifying behavioral properties">
:@ <a href=verifica.html>Verifying behavioral properties</a>
\zline{\fbox{2}}
\ifsli{\vspace{-0.5cm}}{}
<I
- {\em states} -- transformations
- {\em verification} -- correctness formulae
- {\em axioms} -- consequence rules, abstraction
I>
\ifsli{\vspace{-1cm}}{}
</slide>

We looked at a formal characterization of
states and state transitions and correctness
formulae were introduced as a means to
verify the correctness of transitions.

We also looked at an axiomatic characterization of the
correctness properties of programming
language constructs.

<slide id=10-3 style=guide cap="Section 10.3: On the notion of behavior">
:@ <a href=behavior.html>On the notion of behavior</a>
\zline{\fbox{3}}
\ifsli{\vspace{-0.5cm}}{}
<I
- {\em syntax} -- expressions, statements
- {\em rules} -- assignment, object creation,
method call
- {\em compound rules} --
composition, conditional, iteration
I>
\ifsli{\vspace{-1cm}}{}
</slide>

In section 3,
we looked at how the behavior of
an object may be defined in a formal
way by means of a transition system.
A transition system for an object-based
language specifies the rules for assignment,
object creation and method call,
as well as the computation steps
resulting from the evaluation
of compound statements.

<slide id=10-4 style=guide cap="Section 10.4: Objects as behavioral types">
:@ <a href=subtypin.html>Objects as behavioral types</a>
\zline{\fbox{4}}
\ifsli{\vspace{-0.5cm}}{}
<I
- {\em abstract data types} --
representation function
- {\em correspondence} --
abstraction, renaming, extension
- {\em behavioral subtypes} -- correspondence
I>
\ifsli{\vspace{-1cm}}{}
</slide>

In section 4,
it was shown how actual objects may be related to abstract types
by means of a representation abstraction function.
Further, we discussed explicit guidelines
for defining a subtype
correspondence relation between behavioral types.

\clearfalse
<slide id=10-5 style=guide cap="Section 10.5: Specifying behavioral compositions">
:@ <a href=composit.html>Specifying behavioral compositions</a>
\zline{\fbox{5}}
\ifsli{\vspace{-0.5cm}}{}
<I
- {\em global invariants} --
dynamic aliasing
- {\em model-based specification} --
state and operations
- {\em compositions} --
contracts, scripts, interaction, joint actions
I>
\ifsli{\vspace{-1cm}}{}
</slide>

Finally, in section 5, we looked at the problems involved
in determining global invariants and
we discussed what formal means we have available
to specify behavioral properties of
a collection of objects.
</document>
