#include "splash.h"

int lexicographic(list<string>& a, list<string>& b) { 
	if ( a.count() != b.count() ) return 0;
	else {
	for ( int i = 0; i < a.count() ; i++ ) {
		if ( b[i] < a[i] ) return 0;
		else if ( a[i] < b[i] ) return 1;
		}
	return 1;
	}
}

class line {
list<string> words;
int rot;
public:
line() { rot = 0; words.compare(lexicographic); }
line(line& l) : words(l.words) { }

int operator<(line& l) { return words < l.words; } 

line& operator<<(char* s) { words.insert(s); return *this; }

operator void*() { return (void*) ! ( rot > length()); }

int length() { return words.count(); }

line& rotate() { rot++; words = words.rotate(); return *this; } 

friend ostream& operator<<(ostream& os, line& l);
};

class text {
line base;
list<line> lines;
public:
text() { }
text& operator<<(line& l) { base = l; return *this; }
void generate() {
	cout << base << endl;
	line l;
	while ( l = base.rotate() ) { cout << l; lines << l; } 
	cout << "lines:\n" << lines << endl;
	lines = lines.sort();
	cout << "sorted:\n" << lines << endl;
	}
friend ostream& operator<<(ostream& os, text& t);
};

ostream& operator<<(ostream& os, line& l) {
for (int i = 0; i < l.length(); i++ ) {
os << l.words[i] << " ";
}
os << endl;
return os;
}

ostream& operator<<(ostream& os, text& t) {
os << "base: " << t.base << endl;
os << "lines:\n" << t.lines << endl;
return os;
}


main() {
string s1 = "the", s2 = "brown", s3 = "fox";
line l;
l << "the" << "wild" << "brown" << "fox";
cout << "line: " << l;

text t;
t << l;
cout << t << endl;
cout << "generating: " << endl;
t.generate();
cout << t << endl;
}
