:@* Libraries for C++
\comment{See [_BV90].}
\sli{
@ C++ Booch Components
*- reusable component library 
$[]$ basic collection/container abstractions\n
$[]$ template for templates\n
$[]$ tradeoff of inheritance structures
{\footnotesize
@ Goals\n
{\em Efficiency} -- minimal runtime/memory overhead\n
{\em Ease of use} -- clear and consistent organization\n
{\em Extensibility} -- e.g. new storage mechanisms\n
{\em Adaptability} -- local tailoring
}
@ Scope:\n
{\em -- like NIH Class Library} \zline{[_GOP90]}\n
{\em -- not like Interviews}    \zline{[_LVC89]}
@ Support for concurrency\n
{\em $\bullet$ multiple threads, multiprocessing }
\n
}
\sli{
@ Design -- Key Abstractions
\nl
{\footnotesize
{\bf 1. Datastructures}: List, Set, Bag\n
{\bf 2. Storage}: Un/Bounded, Managed, Controlled\n
{\bf 3. Concurrency Managers}: Semaphore, Monitor\n
{\bf 4. Exceptions}: Over/Underflow, Null, Position\_Error\n
{\bf 5. Tools}: pipes, filters, sorts, searches\nl
\indent \fbox{5} $->$ \fbox{1} $->$ \fbox{2} $->$ \fbox{3} 
\nl
\indent \fbox{$ < DataStructure, StorageMgr, ConcurrencyMgr > $}
}
@ Inheritance {\em -- forest}
{\footnotesize
*- structure, complexity/overhead, ontology
$[]$ {\em Layered abstractions} -- reuse\n
$[]$ {\em Polymorphism} -- virtual functions, redefinition\n
$[]$ {\em Design structure} -- interfaces\n
$[]$ {\em Composition} -- private use
\n
}
}
\sli{
@ Using type parametrization
*- {\em Template $->$ Class $->$ Object }
@ Implementation mechanisms 
\zline{\bf [reuse]}\n
{\em Classes/inheritance} \xline{$+$} \n
{\em Templates} -- type parametrization \xline{$-$}\n
{\em Exceptions} -- uniform error reporting \xline{$-$}\n
{\em Task library} -- concurrency control \xline{$+$}
@ Exceptions
{\em -- in type system}\n
{\rm $\bullet$ non-fatal user errors}\n
{\rm $\bullet$ fatal resource/corruption errors} 
@ Tasking
{\em -- in C++ library}
\zline{[AT\&T 2.0]}\n
Assume: {\em Semaphore, Monitor}\n
Forms: {\em Concurrent, Multiple, Controlled}\n
Primitives: {\em Lock, Read\_Lock, Write\_Lock}
\n
}






