<document>

:@ Some history
In sections \ref{what} and \ref{abstraction}, we have sketched the history
underlying the development of object-oriented
programming languages, as directed towards
increasingly powerful abstractions and constructs
for developing reliable software.
}

@so ravioli

In short, we may characterize the genesis of 
{\em structured programming} as the outcome of the
war against the {\em goto} and its associated
{\em spaghetti code}.
The subsequent development of object-oriented
programming may then be understood as
the realization that {\em data} is as important
as {\em control}.
Ironically, the disciplined use of encapsulation
and inheritance (as mechanisms for data abstraction)
may lead to another proliferation of control,
threatening the integrity and manageability of
object-oriented code.

One part of the control problem of object orientation
is known as {\em ravioli code},
which expresses depictively the existence of
a large number of (small) objects with well-defined
interfaces, which interact in a complex way.
\see{11-history}
The other part of the control problem
is known as the {\em yo-yo problem},
which characterizes the difficulty of locating control
in a class hierarchy with virtual functions.
These problems are notoriously hard to solve,
yet lie at the core of good library design.
As a partial solution to the problem of structuring
the interaction between objects we have
discussed the notion of {\em events} to define
generic interactions.
However, essential to a successful component-based
approach, we need sufficiently high-level components
to start with.
</document>
