#include <iostream.h>
#include "bool.h"

#include "cell.s"

#include "iter.s"
#include "listiter.s"

#include "list.s"

#include "impl-it.s"


template<class T>
class bag {
public:
bag() { s = new list<T>; }
bag(const bag<T>& b) { s = b.s; }
bag<T>& operator=(const bag<T>& b) { s = b.s; return *this; }
bool operator==(const bag<T>&);
virtual void insert(const T& e) { s->insert(e); }
operator iter<T>() const { return *s; }
int count(const T& e) const;
void map(T f(const T& e));
protected:
list<T>* s;
};


template< class T > 
int bag<T>::count(const T& e) {
iter<T> it = *this;
T* p = 0; int cnt = 0;
while ( p = it() )
	if ( e == ((const T&) *p) ) cnt++;
return cnt;
}

template< class T > 
void bag<T>::map(T f(const T& e)) {
iter<T> it = *this;
T* p = 0; 
while ( p = it() ) *p = f(*p);
}

template< class T > 
int operator==(const bag<T>& b) {
iter<T> it = *this;
T* p = 0; int eq = 1;
while ( eq && p = it() ) 
	if ( count(*p) != b.count(*p) ) eq = false;
return eq;
}



template<class T>
class set : public bag<T> {
public:
void insert(const T& e) {
	if (!member(e)) bag<T>::insert(e);
	}
int member(const T& e) {
	return count(e) == 1;
	}
///bool operator==(const set<T>& s);
/// { return ((bag<T>&)*this) == (const bag<T>&) s; }
};


template< class T > 
int operator==(const set<T>& s, const set<T>& b) {
iter<T> it = s;
T* p = 0; int eq = 1;
while ( eq && (p = it()) ) 
	if ( s.count(*p) != b.count(*p) ) eq = false;
return eq;
}


template< class T >
class power : public set< set<T> > {
};


int S(const int& x) { return x+1; }

template< class T >
ostream& operator<<(ostream& os, const set<T>& s) {
iter<T> it = s;
int* p = 0;
while ( p = it() ) {
	cout << *p << endl;
	}
return os;
}

void main() {
set<int> s1;
s1.insert(1); s1.insert(2);
set<int> s2;
s2.insert(2); s2.insert(3);
power<int> b;
b.insert(s1); b.insert(s2);
//cout << b;
/*
iter< set<int> > it = b; /// get the iterator
int* p = 0; /// start
while ( p = it() ) {
	cout << "item;" << *p << endl;  /// take the value
	}
*/
}
	
