<document>

This chapter has dealt with the implications
an object-oriented approach has
for practical application development.

\vfig{2}
<slide id=11-1 cap="Section 11.1: Application development">
:@ <a href=applicat.html>Application integration</a>
\zline{\fbox{1}}
<I
- {\em integration} -- interface standards
- {\em object services} -- object request broker
- {\em persistent objects} -- design principles
- {\em events} -- actions involving objects
I>
\ifsli{\vspace{-1cm}}{}
</slide>

In section 1,
the Microsoft object linking and embedding
facility and 
the OMG proposal
for the integration of disparate
components, which involves
an interface description language (IDL),
general object services and
an object request broker (ORB), were discussed.
We also looked at the ODMG standard for
persistent objects, which extends the
OMG proposal with object storage facilities.
Further, we discussed the duality between
objects and events, which plays a role
in analysis, design and implementation.


In section 2,
we looked at the issues that arise in the
design of reusable software libraries,
and we discussed the conventions and
support tools that were developed for the Eiffel
libraries.
We also looked at the realization of
template classes for the abstract data structures $bag$ and $set$
in C++.

\vstr{2}
<slide id=11-2 cap="Section 11.2: Library design">
\ifsli{\markitright{Summary}}{}
:@ <a href=design.html>Library design</a>
\zline{\fbox{2}}
<I
- {\em reuse} -- library design
- {\em conventions} -- naming, taxonomy
- {\em indexing} -- archival and querying
- {\em template classes} -- bags and sets
I>
\ifsli{\vspace{-1cm}}{}
}

In section 3,
when considering methods and tools
for object-oriented application development,
we discussed the heritage from structured
approaches and looked at the Fusion method as an example of a strongly
systematic approach to the process of development.
The Fusion method has been compared with a number of other methods,
including Objectory, OMT, Booch OOD
and CRC.
Further, we looked at some CASE tools
and programming environments,
as well as some of the object database
systems for C++.


\vfig{4}
<slide id=11-3 cap="Section 11.3: Methods and tools">
\ifsli{\markitright{Summary}}{}
:@ <a href=methods.html>Methods and tools</a>
\zline{\fbox{3}}
<I
- {\em methods} -- structural $ -> $ object-oriented
- {\em tools} --
analysis, design, implementation
- {\em comparative study} -- Fusion
- {\em program development} --
environments for C++
- {\em object database systems} --
with C++ interface
I>
\ifsli{\vspace{-1cm}}{}
</slide>


<slide id=11-4 cap="Section 11.4: Libraries for C++">
:@ <a href=librarie.html>Libraries for C++</a>
\zline{\fbox{4}}
<I
- {\em criteria for libraries} --
user specific, domain, features
- {\em requirements} --
data structures, mathematics, simulation, GUI
I>
\ifsli{\vspace{-1cm}}{}
</slide>

We concluded, in section 4, with an overview of the
libraries for C++.
In particular, we looked at the criteria
guiding the choice for a particular
library,
including user-specific criteria,
domain-specific criteria and features
concerning documentation and support.
</document>
