<document>
@* <a href=g-con.html>The concept of hypermedia</a>


Due to the rapidly evolving software
and hardware technology,
including the mass storage provided by CD-ROM,
hypermedia have become accessible to the general
public.
Hypermedia provide the technology to manage large
amounts of information of various kinds
by means of the computer.

From a historical perspective,
hypermedia may be understood as the combination
of hypertext and (interactive) multimedia.
Hypertext was conceived shortly after
the second world war as a means by which to support
mechanically the storage and retrieval
of large amounts of information.
Interactive multimedia have been developed
as the result of integrating computing
with media (notably audio and video display).


@+ Nodes and links <em> -- presentation and navigation</em>

The basic model underlying hypertext
may be characterized as (text) {\em nodes}
and {\em links} between nodes or components thereof.
For the user, the conception of {\em text}
as consisting of nodes and links results
in what may be called {\em non-linear text}.
According to [_Bush], who was the first to
put the idea into print, the interpretation
of text as a network is a natural way for
humans to think about and deal with information.

The importance of {\em hypertext}
is thus not the idea of an associative organization
of information (that allows one to travel
from one node to another by traversing a link),
but rather the realization of {\em
machine-supported links}.
Machine-supported links give great flexibility
in dealing with text as a network.
For example, instead of walking to a library
to consult a reference on infections diseases
when reading about a virus, one may simply
traverse a link by clicking
on an item to have the material available
for consultation.

Multimedia comes into the picture when we,
once more, 
generalize the notion of {\em text}
to comprise ordinary text as well as
graphics, audio and video.
Combining the notions of hypertext and multimedia
results in what we know as {\em hypermedia},
allowing the user flexible access to a variety
of information.
Underlying the notion of hypermedia, however,
is the assumption that the information is 
somehow
available in electronic form,
and that this information may be managed
by means of computation.
Hypermedia systems, in other words,
require {\em programmable media}.
The restriction to plain text of the earlier
systems may be explained by the observation
that text processing and display technology
is relatively easy and cheap.
Graphics, and in particular audio and video,
require considerably more extensive resources
for storage and computation.


\vfig{1}
<slide id=12-hypertext cap="The concept of hypermedia">
@ Hypertext <em> -- nodes and links</em>
<I
- non-linear text {\em -- As we may think}
\zline{[_Bush]}
I>
:@ Machine-supported links <em> -- text as a network</em>
<I
- \fbox{\parbox{3.5cm}{ \mbox{}   {P ... \fbox\{virus\} ... P}  }} $->$
\fbox{\parbox{3cm}{ \mbox{}  {P ...  infection ...  P}  }}
I>
@ Hypermedia systems <em> -- programmable media</em>
<I
- components 
{\em -- text, graphics, audio, video}
- links
{\em -- relations between components}
- presentation
{\em -- structured display}
I>
\ifsli{\vspace{-1cm}}{}
</slide>


A hypermedia system may, in a general way,
be conceived of as consisting of a
collection of stored {\em components}
(containing text, graphics, audio or
video fragments),
a collection of {\em links}
(which allow the user to retrieve
components in an associative manner)
and
{\em presentation facilities}
(to enable a structured display of the
components selected by the user).

The ease of use of a hypermedia system
depends to a great extent upon the 
organization of the material (components)
and the presentation of the associative
relations (links) between the components.
In particular, a powerful user interface is
required to allow the user
to navigate through the information
without losing orientation.



@ Direct manipulation interfaces
Graphical user interfaces 
with buttons and menus, 
and windows for the display of
text and graphics,
have become the standard 
for a variety of applications,
including text processing, spreadsheets
and CAD systems.
Originally menu-based,
user interfaces have developed
into what are often called
{\em object-oriented} user interfaces,
or more appropriately
{\em direct manipulation} interfaces.

Direct manipulation interfaces
allow for the association of
actions with the items displayed.
For example, clicking on an icon
may
result 
in opening the window associated
with that icon.
Conversely, clicking on a specific
part of the window may result
in iconifying the window into a small
graphical item on the screen.
The reason for calling such interfaces
{\em object-oriented}, obviously,
is the analogy with sending
a message or command to an object
considered as the target.
However, direct manipulation interfaces
need not necessarily be implemented
or designed in an object-oriented way,
although in my opinion they
had better be.


<slide id=12-direct cap="Direct manipulation interfaces">
:@ Direct manipulation interfaces <em> -- object-oriented</em>
<I>- $ target <- command $
:@ Requirements
\zline{\fbox{WYSIWYG}}
<I
- documents {\em -- open, close}
- blocks {\em -- select, copy, paste}
- links {\em -- $ source -> destination $}
I>
\ifsli{\vspace{-1cm}}{}
</slide>

Hypermedia systems may be used 
for browsing or authoring,
or a combination of both.
Browsing hypertext requires
an interface resembling the interface
of a WYSIWYG ({\em What You See Is What
You Get}) text processor,
in that it must support a readable
display of the material and the facility
to open and close documents.
In addition, it must enable the selection
of specific parts of the document,
which may be blocks or single words,
to activate links that lead to another
block. 
\see{12-direct}
Often, as in the Intermedia system
described in [_Meyro86],
the user is allowed to copy parts
into a private notebook, containing
the material selected while
browsing the system.
\see{12-navigation}
Naturally, the display facilities
of hypermedia as opposed to hypertext
systems must be far more encompassing.
These facilities and the issues involved
in authoring will be discussed in
section \ref{hypermedia-model}.

@ Navigation
One of the major problems in
hypermedia interface design is
the support for navigation.
Experiments indicate that users
have considerable trouble in maintaining
a sense of orientation, and often rely
on using a keyword index or the
traditional hierarchical structure
of the document instead of the associative access allowed by following links.
See [_McK91].



<slide id=12-navigation casp="Navigation and retrieval">
:@ Navigation
<em> -- maps</em>
\zline{\fbox{Intermedia}}
<I>- web = {\em documents + links}
@ Retrieval by attributes <em> -- selection</em>
<I
- block {\em -- to apply filters}
- link {\em -- conditional traversal}
I>
\ifsli{\vspace{-1cm}}{}
</slide>

To support navigation based
on content characteristics or
personal preference, the Intermedia
system allows for the creation of 
{\em webs}.
A {\em web} is a particular collection
of documents and links, which is a
subset of the total collection
satisfying user-specific criteria,
such as field of interest
or level of aptitude.
Moreover, the Intermedia system
supports the graphical display 
of the structure of a web by means of
maps, showing the blocks and the
links between them.
An example of a web is the private notebook mentioned above, which contains
the blocks and links satisfying the
condition {\em selected}.

To support the selection of (parts of)
documents and links, the Intermedia 
system maintains attributes for both
blocks and links.
The value of block attributes determine
whether a particular block is selected
or filtered out,
and the value of link attributes determine
whether activating a link results
in traversal or not.

The latter facilities, by the way,
suggest that hypermedia offer
significantly more than merely
user interface gadgets.
My opinion in this respect,
following [_Wood90],
is that hypermedia technology
may be regarded as a {\em unifying paradigm}
allowing the integration of
disparate elements in a common
presentation framework.

@+ Hypermedia applications

Hypermedia technology may best be thought
of as technology that may be embedded
in a variety of applications.
This is reflected in the classification
of hypertext and hypermedia systems
given in [_Conklin87], pictured in \sliref{12-classification}.

\cleartrue
<slide id=12-classification cap="Hypermedia systems -- classification">
@ Classification of hypermedia systems
\zline{[_Conklin87]}
<I
- macro-literary systems
{\em -- publishing, reading, criticism}
- problem exploration tools
{\em -- authoring, outlining, programming}
- browsing systems
{\em -- teaching, references, information}
- general hypermedia technology
{\em -- authoring, browsing, collaboration}
I>
:@ Applications
{\em -- embedded}
<I
- CASE, decision support, catalogs
I>
\ifsli{\vspace{-1cm}}{}
</slide>

[_Conklin87] makes a distinction between
{\em macro-literary systems}
which support publishing, reading
and criticism
and may serve as online annotated libraries,
{\em problem exploration tools}
which support authoring, outlining and programming
and may be characterized as 
{\em idea processors},
{\em browsing systems}
which support the display and content-based
retrieval of information
and may be used for teaching,
reference or online help,
and systems that explore general hypermedia
technology 
which offer a combination of authoring,
browsing and collaboration facilities
(of which the Intermedia system is an example).
In general, for systems that primarily support browsing, the presentation facilities will be most important,
whereas for authoring systems
the functional or programming capabilities
will count most.

Applications for which hypermedia technology
is an essential ingredient encompass
CASE tools, decision support systems
and product catalogs.
All these applications have in common
that a large amount of material,
that may come in various media formats,
needs to be related, to allow the user
flexible access both in a structured
and associative manner.
Despite the differences due to the particular application domains,
we may discern
a common hypermedia model underlying
the associative structure of these 
applications.

It is interesting to note that
when looking at successful applications
of object-oriented programming,
such as those reported in [_Harmon93],
these almost invariably include
an embedded hypermedia component,
as well as functionality that
is derived from a rule-based reasoning
facility.

@so model
</document>
