<document>
@+ Binding actions to events
\label{Binding}

Handler objects may be bound to Tcl commands or events.
Events are generated by the (X) window environment
in response to actions of the user.
These actions include pressing a mouse button,
releasing a mouse button, moving the mouse, etc.
Instead of explicitly dealing with all incoming
events,
applications delegate control to the environment by
associating a callback function
with each event that is relevant for a particular widget.
This mechanism frees the programmer from the
responsibility of deciding to which widget the event belongs
and what action to take.

Nevertheless, from the perspective of program
design, the proper organization of
the callback functions is not a trivial
matter.
Common practice is to write only a limited number of
callback functions and perform explicit
dispatching according to the type of event.

An object-oriented approach may be advantageous
as a means to organize a collection of
callback functions as member functions of
a single class.
One way of doing this is to define
an abstract event handler class which
provides a virtual member function for
each of the most commonly occurring events.
In effect, such a handler class  hides
the dispatching according to the type
of the event.
A concrete handler class may then
be defined simply by overriding
the member functions corresponding to
the events of interest.

Before studying the
abstract {\em handler} class in more detail,
we will briefly look at the definition
of the {\em event} class.

@so event
@so handler

@so action
</document>
