<document>
\label{canvas}

:@ The $canvas$ widget
The Tk canvas widget offers a powerful means for
creating structured graphics.
The $hush$ class $canvas$ provides merely
a simplified interface to
the corresponding Tk widget.
}

@so draw-move


As an example of the use of a canvas, consider the
definition of the <em>move_handler</em>
class in \sliref{draw-move}.
The <em>move_handler</em> class is derived from the class
$handler$.
It makes use of the $dispatch$ and $operator()$ function defined for 
$handler$,
but redefines the (virtual) functions
$press$, $motion$ and $release$.


When creating an instance of <em>move_handler</em>,
a pointer to the canvas must be given to the constructor.
In addition, the class has data members to record
position coordinates
and whether a particular item is being moved.
Actually, moving an item occurs by pressing the (left)
mouse button on an item and dragging the item along.
When the mouse button is released, moving stops.
To identify the item, the function $overlapping$
is used.
The movement is determined by the distance
between the last recorded position and the
current position of the cursor.

@so hyper-eps

In an analogous manner,
a <em>box_handler</em> may be defined.
The <em>box_handler</em> sets dragging
to true when the button is pressed
and creates a rectangle of zero width and height.
Each time the function $motion$ is called,
the item created in the previous round is deleted
and a new rectangle is created by calling
[P
 c->rectangle(x,y,e.x(),e.y());
P]
where $c$ is a pointer to the canvas
and $x$ and $y$ the button pointer coordinates
stored when dragging began.
For circles and lines, it suffices to replace the call
to rectangle with  a call to the appropriate
figure creation function.
</document>
