<document>

@so draw-tablet

:@ Defining actions 
The most important component of our {\em drawtool}
application is defined by the {\em tablet} widget class
depicted in \sliref{draw-tablet}.


The various modes supported by the drawing tool are
enumerated in a separate class {\em drawmode}.
The {\em tablet} class itself inherits from the $canvas$
widget class.
This has the advantage that it offers the full functionality
of a canvas.
In addition to the constructor and $operator()$ function,
which delegates the incoming event to the appropriate
handler
according to the {\em \_mode} variable,
it offers a function $mode$, which sets the mode of the
canvas as indicated by its string argument,
and a function {\em init} that determines the creation
and geometrical layout of the component widgets.
As instance variables, it contains an integer {\em \_mode}
variable and an array of handlers that contains
the handlers corresponding to the modes supported.
See section \ref{canvas} for an example of a typical
canvas handler.


@ Dispatching
Although the $tablet$ must act as a canvas,
the actual $tablet$ widget is nothing but a $frame$
that contains a canvas widget as one of its components.
See \sliref{tablet-op}.

@so draw-handlers

This is reflected in the invocation of the
canvas constructor (a).
By convention, when the options parameter is $0$
instead of the empty string, no actual widget
is created but only an abstract widget,
as happens when calling the $widget$ class constructor.
Instead of creating a canvas right away,
the $tablet$ constructor creates a top frame,
initializes the actual component widgets,
and redirects the $eval$, $configure$, $bind$
and $handler$ invocations to the subordinate $canvas$
widget (b).
It then
declares itself to be its own handler,
which results in declaring itself to be the handler for the
canvas component (c).
Note that reversing the order of calling $redirect$
and $handler$ would be disastrous.
After that it creates the handlers for the various modes
and sets the initial mode to $move$.

The $operator()$ function takes care of dispatching calls
to the appropriate handler.
The $dispatch$ function must be called to pass
the $tk$, $argc$ and $argv$ parameters.
</document>
