<document>
@so draw-eps

In this section we will look at the realization of simple drawing tool.
The example illustrates how to use the
{\em hush} library widgets, and
serves to illustrate
in particular how handlers may be attached
to widgets, either by declaration or
by inheritance, and how to construct
compound widgets.

Our approach may be considered object-oriented, in the sense that each component
of the user interface is defined by a class
derived from a widget class.
It must be pointed out beforehand that the main difficulty
in defining compound or mega widgets is not the construction
of the components themselves, but delegating the configuration
and binding instructions to the appropriate components. 
Section \ref{new} shows
how a compound widget
defined in C++ may be made to correspond
to a widget command that may be used
in a Tcl script.
Ideally, defining a new widget
includes both the definition
of a C++ class interface and
the definition of the corresponding Tcl
command.


%%@ Example -- drawtool
Our drawing tool consists of a $tablet$,
which is a canvas with scrollbars
to allow for a large size canvas
of which only a part is displayed,
a {\em menu\_bar}, having a {\em File}
and an {\em Edit} menu, and a {\em toolbox},
which is a collection of buttons for
selecting from among the drawing facilities.
In addition, a help facility is offered.
See \sliref{eps-drawtool}.


@so draw-tool

In \sliref{draw-tool-x} the application class for {\em drawtool}
is depicted.
Before the main event loop is started,
the components of the drawing tool are
created and packed to the root widget.
In addition to the {\em tablet}, {\em menu\_bar} and {\em toolbox},
a $frame$ widget is created to pack the
menubar and tablet together.
This is needed to ensure that the geometrical
layout of the widget comes out right.
Each of the component widgets is given
a pointer to the root widget.
In addition, a pointer to the tablet
is given to the {\em toolbox} and a pointer to
the {\em toolbox} is given to the {\em menu\_bar}.
The reason for this will become clear
when discussing the {\em toolbox} and
{\em menu\_bar} in sections \ref{buttons} and \ref{menus},
respectively.
In the example, no attention will be paid to memory management.
</document>
