<document>

Hypermedia programming is by its nature complex,
partly because of the variety of content
that must be dealt with,
and partly because the graphical user
interface forms an essential part of the
hypermedia application.

In this section, we will look at
an approach to graphical interface programming
that may best be characterized
as {\em multi-paradigm programming}.
Our approach,
embodied in the $hush$ library (Eliens, 1994),
combines the use of C++
and the script language Tcl.
The advantage of using C++ is its
robustness. The advantage of using
scripts is, clearly, flexibility.
A multi-paradigm approach offers
the best of both worlds.
Or the worst, for that matter.



The {\em hush} 
library offers an interface to the Tcl/Tk 
(window programming) toolkit,
and a
number
of multimedia devices,
including real-time synthesized audio and MPEG (Motion Pictures Experts Group)
software video.

The principal contribution of the approach
embodied in $hush$ is that it offers
a type-secure solution for connecting
script code with C++ (and vice versa).
In particular, it allows one to associate
events with actions by means of
{\em handler} objects.
In addition, the {\em hush} library
allows the programmer to employ inheritance for
the development of possibly compound
widgets.


{\em Hush} stands for
{\em hyper utility shell}.
The standard interpreter associated with
the {\em hush} library is a shell,
called {\em hush}, including 
a number of the available extensions of
Tcl/Tk and widgets developed by ourselves.
\nop{
(such as a {\em filechooser} and an MPEG video widget).
}
The {\em hush} library offers
a C++ interface to the Tcl/Tk toolkit
and its extensions.
Moreover, a program created with {\em hush}
is itself an interpreter extending the
{\em hush} interpreter.

@so tcl
</document>
