#include "hush.h"

double newton(double arg) { 
double r = arg, x = 1, eps = 0.0001;
while( fabs(r - x) > eps ) {
	r = x;
	x = r - ( ( r * r - arg ) / ( 2 * r ));
	}
return r;
}

char fbuf[56];
char* ftoa( double f) { sprintf(fbuf,"%f",f); return fbuf; }


class generator : public handler {
public:

generator() {
	s = (scale*) new widget(".s");
	m = (message*) new widget(".m");
	}

~generator() {
	s->destroy();
	m->destroy();
	}

int operator()() {
	cout << s->get() << endl;
	float f = s->get();
	m->text( ftoa( newton(f) ) );
	return OK;
	}

private:
scale* s; message* m;
};


void program( kit* tk, int, char** ) {
    tk->trace();
    
    tk->source("interface.tcl");
    generator* g = new generator();

    tk->action("generate",g);
}


int main (int  argc, char  **argv) {
    session* s = new session(argc,argv,"scale");
    return s->run(program);
}
