\label{menus}


.so draw-menubar

\c{
:@ Menus
The second component of our drawing tool is the {\em menubar}.
The class {\em menu\_bar}, depicted in \sliref{draw-menubar}
is derived from the {\em hush} widget $menubar$.
Its constructor requires an ancestor widget,
a {\em tablet} and a {\em toolbox}.
The tablet is passed as a parameter to the {\em file\_menu},
and the $toolbox$ to the {\em edit\_menu}.
In addition, a {\em help\_button} is created, which provides
online help in a hypertext format when pressed.
The help facility will be discussed in section \ref{hyper}.
}

.so draw-file

\c{
A menubar consists of menubuttons to which actual menus are attached.
Each menu consists of a number of entries,
which may possibly lead to cascaded menus.

The {\em file\_menu} class, depicted in \sliref{draw-file},
defines a menu, but is derived from {\em menubutton}
in order to attach the menu to its {\em menubar}
ancestor (a).
Its constructor defines the appearance of
the button and creates a {\em file\_handler} (b).
It then defines the actual menu (c).
The menu must explicitly be attached to
the menubutton by invoking the {\em menubar}
member function {\em menu}.
For creating the menu, the keyword {\em class} is needed
to disambiguate between the creation of an instance of the class
menu and the call of the $menubar::menu$ function.


Before defining the various entries of the menu,
the {\em file\_menu} instance is declared
as the handler for the menu entries (d).
However, except for the entry {\em Quit}, which is handled
by calling the $kit::quit$ function (e),
the calls are delegated to the previously created {\em file\_handler}.
}

."so draw-edit

\c{
The second button of the {\em menu\_bar} is defined by the
{\em edit\_menu}.
The {\em edit\_menu} requires a $toolbox$ and creates
a menubutton.
It configures the button and
defines a menu containing two entries,
one of which is a cascaded menu.
Both the main menu and the cascaded menu
are given the $toolbox$ as a handler.
This makes sense only because 
for our simple application,
the functionality offered by
the $toolbox$ and {\it edit\_menu} coincide.
}

