\c{
@ Handlers
A note on terminology is in place here.
The reader may be a little astonished by
the fact that we have both a {\em handler}
class and a {\em handler} function,
which is more properly written
as $widget::handler$.
The situation may even seem more confusing
when realizing that the {\em widget}
class itself is a descendant of the
{\em handler} class.
Schematically, we have the situation as depicted
in \sliref{h-disc}.
}

\slide{h-disc}{Handler classes and functions}{
\ifsli{\vspace{0.5cm}}{\vspace{0.1cm}}
[P
 class widget : public handler {
 public:
 ...
 void handler(class handler* h) { ... }
 ...
 };
P]
\ifsli{\ln\vspace{-1.5cm}}{\vspace{-0.2cm}}
}

\c{
Note that there is no ambiguity here.
A {\em handler} object is an object
that may be invoked in response to a Tcl command
or an event.
The {\em handler} function declares
a {\em handler} object to be responsible
for dealing with the events
that are of interest to the widget.
Note that since a widget is a $handler$ instance,
it may declare itself as a handler for the incoming
events.
}
