

\c{
@ The $canvas$ class
Apart from the two standard constructors,
it offers the functions $tag$, $tags$ and $move$
that merely repeat the functions offered by the $item$ class,
except that $move$ may also be given a tag to identify
the items to be moved.
}


\slide{class-canvas}{The {\em canvas} class}{
[P
interface canvas : widget { /// \fbox{canvas}
canvas(char *p, char* options="");
canvas(widget* w, char *p, char* options="");

void tag(int id, char* tag);
char* tags(int id);

void move(int id, int x, int y);
void move(char* id, int x, int y);

item bitmap(int x1, int y1, char* bitmap, char* options="");
item line(int x1, int y1, int x2, int y2, char* options ="");
item line(char* linespec, char* options ="");
item oval(int x1, int y1, int x2, int y2, char* options ="");
item polygon(char* linespec, char* options ="");
item rectangle(int x1, int y1, int x2, int y2, char* options ="");
item text(int x1, int y1, char* txt, char* options=""); 
item window(int x1, int y1, char* win, char* options="");

item current();
item overlapping(int x, int y);

itemconfigure(int it, char* options);
itemconfigure(char* tag, char* options);
itembind(int it, char* s, action& a, char* args = "" );
itembind(char* tag, char* s, action& a, char* args = "" );
};
P]
}


\c{
Currently, the graphic items $bitmap$, $line$,
$oval$, $polygon$ and $rectangle$ may created
and, in addition, $text$ items and $window$ items consisting
of a widget.
The function $overlapping$ may be used to retrieve
the item overlapping a particular position.

In addition, the $canvas$ class auxiliary functions
needed to support
the functionality provided by the $item$ class.
}
