<document>

\noindent
Object-oriented technology is
essentially a technology in search
of applications.
Applications range over
business information modeling,
distributed systems programming,
knowledge-based problem solving
and hypermedia systems.


\cleartrue
\vfig{1}
<slide num=12 id=ch-12 cap="Chapter 12: Hypermedia frameworks">
@ Hypermedia frameworks
\zline{\fbox{12}}
<I
- the concept of hypermedia
- hypermedia model {\em -- links}
- multi-paradigm programming {\em -- hush}
- heterogeneous systems
I>
Additional keywords and phrases:
<em>multimedia, hypertext, Dexter reference model,
browsing systems, authoring, 
link types, link attributes,
script languages,
linguistic symbiosis</em>
</slide>

In this chapter,
we will conclude our study of object-oriented technology by looking at
the design and implementation issues
that arise in developing hypermedia
systems.

First, we will introduce the concept of
hypermedia from a user perspective.
In particular, we will discuss the
problems of presentation and navigation.
Then we will discuss a hypermedia model
supporting multimedia presentation channels
and timing constraints.
We explore the nature of (hyper) links
and discuss the notion of {\em active documents},
and we will look at how a
multi-paradigm approach to hypermedia
programming may be realized by discussing
the design underlying {\em hush}
(the {\em hyper utility shell} library for C++).
Finally,
we will discuss the software engineering issues involved
in developing hypermedia systems.
In particular, we will look at the contribution
of object-oriented technology to the development of heterogeneous
systems, and simultaneously (concluding this chapter and book)
at the possible future of object orientation.
</document>
