@+ The $hypertext$ widget

\c{
Both the Tk canvas and text widget allow to bind
actions to particular items
and hence to define dynamically what we may call
{\em hyperstructures}.

A different, in a way more static, approach is offered
by the $hypertext$ widget developed by {P george.howlett@att.com P}.
The $hush$ class interface to the hypertext widget
is given below.
}

\sli{
[P
interface hypertext : widget { /// \fbox{hypertext}
hypertext(char* p, char* options = "");
hypertext(widget* w, char* p, char* options = "");

void file(char* f); /// to read in hypertext file
};
P]
}

\c{
Apart from the standard constructors,
it offers the function $file$ to read in a hypertext file.
Such a hypertext file allows to embed widgets
in the text by inserting them in escape sequences.
}

\c{
@ Example
An example of a hypertext file as may be used by
a $help$ manager is given below.
}

\sli{
[P
If you do not wish to read the following text,
click on the \%\% 
button \$this.goto -text button -command "\$this gotoline \$EOT"
\$this append \$this.goto
\%\% to jump to the end.

              ... help text ...

\%\%
global EOT
set EOT [expr \$thisline-1 ]
\%\%
Press \%\%
button \$this.quit -command { destroy . } -text quit 
\$this append \$this.quit
\%\% to remove the window.
P]
}

\c{
Widgets created when reading in a hypertext file may be
given a pathname relative to the pathname of the
hypertext widget by using the variable {\em this}.
In addition the hypertext widget offers the variables
{\em thisline} and {\em thisfile} to identify the
current line number and current file name.

Any of the widgets and commands offered by Tcl/Tk or supported
by $hush$ may be included in a hypertext file.
However, this is for more advance programmers only
since it requires intimate knowledge of the Tcl/Tk
intrinsics.
}
