."@* Introduction

\c{
Hypermedia programming is by its nature complex,
partly because of the variety of contents
that must be dealt with,
and partly because the graphical user
inerface forms an essential part of the
hypermedia application.
}

\c{
In this section, we will look at
an approach to (GUI) programming
that may best be characterized
as {\em multi-paradigm programming}.
Our approach combines the use of C++
and a script language (Tcl).
The advantage of using C++ is its
robustness. The advantage of using
scripts is, clearly, flexibility.
A multi-paradigm approach offers
the best of both worlds.
Or the worst, for that matter.
}




\sli{
@ Hush
{\em -- the C++ API for Tcl/Tk}
<I
- session, kit, event, action, handler
I>
@ Widgets
{\em -- for the GUI}
<I
- button, menu, message, text, filechooser,
barchart, xygraph
I>
@ Graphic items
{\em -- canvas}
<I
- oval, bitmap, text, rectangle, line, polygon
I>
\ifsli{\vspace{-1cm}}{}
}

\c{
The {\em hush} (hyper utility shell)
library offers an interface to the Tcl/Tk 
(window programming) toolkit,
as well as to a (limited) number
of multimedia devices.
including audio and (mpeg) video.
}

\c{
The principal contribution of the approach
embodied in $hush$ is that it offers
a type-secure solution for connecting
script code with C++ (and vice versa).
In particular, it allows to associate
events with actions by means of
{\em handler} objects.

The $hush$ library offers
a class $session$
(as an abstraction from the main event
loop),
the class $kit$
(that embodies the interface to the
underlying (Tcl) interpreter),
the class $event$
(that characterizes user interaction
and X-windows events),
the class $action$
(that enables to link C++ code with Tcl)
and the class $handler$
(that allows for an object oriented
approach to associating actions with
events).

For programming the graphical user interface,
the $hush$ library provides a number
of common widget classes
and graphical items (as listed above).
}

.so tcl
