@+ The class $item$

\c{
The canvas widget allows the programmer to
create a number of built-in graphic items.
Items are given a numerical index when created and,
in addition, they may be given a (string) tag.
Tags allow items to be manipulated in a group-wise fashion.
To deal with items in a C++ context, the $hush$ library
contains a class $item$ of which the functionality
is shown below.
}

\sli{
[P
interface item {
operator int();  /// returns item index

void tag(char* s);
char* tags();
void move(int x, int y);
};
P]
}

\c{
Instances of $item$ may not be created directly by
the user, but instead are created by the canvas
widget.
For an item, its index may be obtained by casting
the item to $int$.
If the index does not identify an existing item,
it will be zero.
Existing items may be moved, in a relative way,
by the function $move$.
In the future, the class $item$ is likely to be extended.
Also, it is conceivable that more specific
$item$ classes, corresponding to
the item types offered by the canvas widget,
will be defined as subclasses of $item$.
}

