."@* Background -- Tcl/Tk





\c{
@ Tcl/Tk
The language Tcl has first been presented
in [_Ousterhout90].
Tcl was announced as a flexible cshell-like
language, intended to be used for developing
an X11-based toolkit.
A year later, the Tk toolkit (based on Tcl)
was presented in [_Ousterhout91].
From the start Tcl/Tk has received a lot of attention,
since it provides a flexible and convenient way
to develop rather powerful window applications.
}

\clearfalse
\sli{
@ Tcl 
{\em -- an extensible script language}
<I>- variables, procedures, built-ins
@ Tk
{\em -- an X-window toolkit}
<I>- widgets, window management
\ifsli{\vspace{-1cm}}{}
}


\c{
The Tcl language offers variables, assignment
and a procedure construct.
Also it provides a number of control constructs,
facilities for manipulating strings 
and built-in primitives giving access to the underlying
operating system.
The basic Tcl language may easily be extended
by associating a function written in C
with a (new) command name.
Arguments given to the command are passed 
as strings to the function defining the command.
(Thus far a number of extensions to Tcl have been
proposed, including extensions offering
facilities for distributed programming.)

The Tk toolkit is an extension of Tcl
with commands to create and configure widgets
for displaying text and graphics,
and providing facilities for window management.
The Tk toolkit, and the $wish$ interpreter
based on Tk, provides a convenient way
to program X-window based applications.
}

\c{
."@ Wish
The $wish$ program is an interpreter for executing
Tcl/Tk scripts.
As an example of a $wish$ script, look
at the {\em hello world} program below.
}

\sli{
@ Scripts
{\em -- hello world}
\zline{\fbox{\em wish}}
[P
button .b -text "hello world" 
.b configure -command { puts stdout "hello world" }
pack append . .b top
P]
}


\c{
The {\em hello world} script defines a button that
displays {\em hello world}, and prints {\em hello world}
to standard output when it is
activated by pressing the left mouse button.
The language used to write this script
is simply Tcl with the commands defined by Tk,
as for example the $button$ command (needed to create
a button) and the $pack$ command (that is used to map
the button to the screen).
As concerns for example the configuration of widgets,
the Tcl/Tk approach is clearly object-based. In other
respects, however, the Tcl language is typically procedural.
}

\c{
The $wish$ program actually provides an example
of a simple application based on Tcl/Tk.
Despite being based on Tcl, the performance of Tk (and $wish$)
is comparable
with (and in some respects even better than)
C or C++ based toolkits.
}

\nop{
Tcl is an interpreted language. Tcl interpreters may be incorporated
in a C program, hence Tcl may be thought of
a being embeddable in C/C++.
The Tcl/Tk environment defines an interface to C.
Lacking thus far, however, for Tcl/Tk is an adequate programmer interface
(API) to C++.
Such an interface is provided by $hush$.
}

\nop{
It may easily be extended to include for example
3D-graphics by linking the appropriate
C libraries and defining the functions making 
this functionality available as (new) Tcl commands.
}


