<document>

This chapter discussed the application of
object-oriented technology to
the area of hypermedia.
Hypermedia has been defined as the combination of
hypertext and multimedia.

\clearfalse
<slide id=12-1 cap="Section 12.1: The concept of hypermedia">
:@ <a href=concepts.html>The concept of hypermedia</a>
\zline{\fbox{1}}
\ifsli{\vspace{-0.5cm}}{}
<I
- {\em hypertext} -- nodes and links
- {\em multimedia} -- programmable media
- {\em hypermedia} -- hypertext and multimedia
- {\em components} -- anchors and synchronization
- {\em links} -- active documents
I>
\ifsli{\vspace{-1cm}}{}
</slide>

Hypertext consists of document nodes and machine-supported
links between these nodes.
Multimedia, in the context of hypermedia, as been
characterized as {\em programmable media}.
We looked at the requirements for hypermedia
user  interfaces and discussed a number of applications
of hypermedia technology.


%%\clearfalse

A hypermedia model has been presented, 
that combines the Dexter hypertext reference model
and a multimedia model supporting channels
and synchronization.
We also reflected on the nature of links,
and discussed the notion of {\em active documents}.



\clearfalse
<slide id=12-2 cap="Section 12.2: Multi-paradigm programming">
:@ <a href=hush/hush.html>Multi-paradigm programming</a>
\zline{\fbox{2}}
\ifsli{\vspace{-0.5cm}}{}
<I
- {\em hush} -- a C++ API for Tcl/Tk
- {\em handlers} -- C++ binding to actions and events
- {\em events} -- interactions with the user
- {\em widgets} -- graphical interface development
- {\em hypertext} -- embedded widget commands
I>
\ifsli{\vspace{-1cm}}{}
</slide>

In section 2, we looked at the multi-paradigm $hush$ toolkit
for developing hypermedia interfaces.
The $hush$ toolkit provides a large number of
widgets and graphics features, and supports the
combination of the scripts written in Tcl/Tk with
handler objects defined in C++.

<slide id=12-3 cap="Section 12.3: Heterogeneous systems">
:@ Heterogeneous systems
\zline{\fbox{3}}
\ifsli{\vspace{-0.5cm}}{}
<I
- {\em hybrid components} -- symbiosis
- {\em object technology} --
wrapping, embedding, distribution
I>
\ifsli{\vspace{-1cm}}{}
</slide>

Finally, in section 3, we discussed the contribution
of object-oriented technology in relation
to heterogeneous systems, consisting of multiple
hybrid components.
We reflected on the future of OOP,
and concluded that standardization and consolidation
is needed to
realize the potential of OOP.
</document>
