@* Composing user interfaces
\comment{See [_LVC89].}
\sly{views}{
@ Composing User Interfaces
*- {\bf Interviews} -- predefined objects, composition mechanisms
{\footnotesize
$[]$ What constitutes a good set of abstractions for building user interfaces ?
@ Observations\n
$[]$ All UI's need not look alike,\n
$[]$ need not be purely graphical.\n
$[]$ Code should be object oriented !
}
@ Objects
support {\em direct manipulation}, \n
and abstraction, encapsulation (state), extension by inheritance\n

{\footnotesize
@ Customization 
{\footnotesize --  separate {\em interface}/{\em functionality}}\n
{\em Subjects} -- abstract functionality\n
{\em Views} -- interactive interface

@ Layers:
Application $->$ Interviews $->$ Windows $->$ OS
}
\n
}
\sli{
@ Composition mechanisms
{\em -- propagation}
*- adding protocol \& operations 
{\footnotesize
{\bf interactor} -- buttons, menus\n
{\bf graphic} -- circles, polygons \zline{(structured)}\n
{\bf text} -- words, white space\nl
}
$[]$ {\em Hierarchical composition gives flexibility} !
{\footnotesize
\nl
{\bf scene} -- interactor + component management\n
{\bf picture} -- list of component graphics\n
{\bf clause} -- list of text components
}
\footnotesize
@ Interactor composition:\n
{\em boxes and glue} \n
{\em tray} -- scene\n
{\em deck} -- pages\n
{\em menu} -- monoscene
@ Scene composition:
tiled, overlapping
\n
}
\sli{
@ Direct manipulation:
\fbox{\footnotesize graphical representation}\nl
{\footnotesize
{\em $\bullet$ drawing editor}\n
{\em $\bullet$ music editor}\n
{\em $\bullet$ schema editor}\n
{\em $\bullet$ class browser} \xline{\fbox{{\bf C}++}}\n
{\em $\bullet$ hypertext} 
}

@ Semantics
{\em -- propagation}\nl
\fbox{\em Graphics} --  {\footnotesize parents override children} \n
$\bullet$ pictures, transformations, zooming
\nl
\fbox{\em Text}  -- {\footnotesize multiple connections}\n
$\bullet$ phrase, text-list, display, sentence, 
paragraph, chapter, trail, web ...\n
\nl
$[]${\it Distinguish {\bf subject} (abstract) and {\bf view} (interactive)} !
\n
}
