<document>

This chapter explored
techniques that may be used to
structure object-oriented programs.
These techniques may be regarded as
idioms or guidelines augmenting
the mechanisms provided by object-oriented languages.

\clearfalse
\vfig{1}
<slide id=7-1 cap="Section 7.1: Composition by inheritance">
:@ <a href=inherita.html>Composition by inheritance</a>
\zline{\fbox{1}}
<I
- {\em virtual functions} -- scoping, recursion
- {\em invariant properties} -- hidden features
- {\em the diamond structure} -- hiding realizations
I>
\ifsli{\vspace{-1cm}}{}
</slide>

In section 1,
we looked at the  problems
that may occur when employing
virtual functions and explicit scoping,
in particular in the presence of recursion,
how to maintain invariance when using
inheritance,
and we discussed the diamond structure
for the realization of compound objects.

\clearfalse
\vfig{3}
<slide id=7-2 cap="Section 7.2: Interaction through delegation">
:@ <a href=delegati.html>Interaction through delegation</a>
\zline{\fbox{2}}
<I
- {\em hiding} -- functional behavior, interface
- {\em smart pointers} -- object management
- {\em abstraction} -- interface, realization
- {\em roles} -- dynamic switching
I>
\ifsli{\vspace{-1cm}}{}
</slide>
\vfig{4}

In section 2,
an example was given demonstrating
implicit delegation in C++.
Also, we looked at the notion
of {\em smart pointers}.
Delegation underlies the envelope/letter
idiom which allows for separating the
interface of a data type from its
realization.
We also discussed an example
of dynamic role switching,
employing explicit delegation.

\clearfalse
<slide id=7-3 cap="Section 7.3: Indirect cooperation">
:@ <a href=cooperat.html>Indirect cooperation</a>
\zline{\fbox{3}}
<I
- {\em gadgets} -- require, damage and draw
- {\em events} -- interception, callbacks
- <em>MV(C)</em> -- model, view, control
I>
\ifsli{\vspace{-1cm}}{}
</slide>

In section 3,
we looked at some patterns of
cooperation between objects.
The examples were inspired
by solutions employed in the Interviews
user interface development library.
Also, a schematic implementation
of the Smalltalk MV(C) paradigm
was given.

\clearfalse
<slide id=7-4 cap="Section 7.4: Event-driven control">
:@ <a href=events.html>Event-driven control</a>
\zline{\fbox{4}}
<I
- {\em abstract system} -- functional behavior
- {\em user interface} -- displayer, prompter
- {\em events} -- to define interactions
- {\em dependencies} -- interconnections between events
I>
\ifsli{\vspace{-1cm}}{}
</slide>

Finally, in section 4, we looked at an example demonstrating
event-driven control.
Events provide a powerful abstraction
to define the interaction of objects
in response to a user action.
</document>
