<document>
This chapter has given an introduction
to the problems involved in extending
the object paradigm with distribution
and concurrency.

\clearfalse
<slide id=6-1 cap="Section 6.1: A modeling perspective">
:@ <a href=modeling.html>A modeling perspective</a>
\zline{\fbox{1}}
\ifsli{\vspace{-0.5cm}}{}
<I
- {\em active objects} -- client/server model
- {\em cooperation} -- concurrent problem solving
I>
\ifsli{\vspace{-1cm}}{}
</slide>

In section 1,
we looked at the client/server model
and observed that the notion of active objects
fits in naturally.
We discussed concurrent problem solving
and identified some common patterns
of cooperation.

\clearfalse
<slide id=6-2 cap="Section 6.2: Objects and processes">
:@ <a href=process.html>Objects and processes</a>
\zline{\fbox{2}}
\ifsli{\vspace{-0.5cm}}{}
<I
- {\em language support} --
processes, communication, fault-tolerance
- {\em concurrency} --
processes, active objects, asynchrony
- {\em active objects} --
sequential processes
I>
\ifsli{\vspace{-1cm}}{}
</slide>

In section 2 we discussed language
support for concurrency and the notion
of active objects.
Language support for concurrency and
distribution consists of adding
processes, communication facilities
and fault-tolerance.
For concurrency, in particular,
we have the choice of adding processes
as additional data types,
introducing active objects or
employing asynchronous communication.
Active objects unify the notions
of objects and processes.
They are analogous to communicating
sequential processes as introduced in
[_Ho78].

\clearfalse
<slide id=6-3 cap="Section 6.3: Concurrent extensions of C++">
:@ <a href=extens.html>Concurrent extensions of C++</a>
\zline{\fbox{3}}
\ifsli{\vspace{-0.5cm}}{}
<I
- {\em design issues} --
active/passive objects
- {\em Concurrent C++ } --
\c{an} orthogonal \c{approach}
- {\em ACT++} -- the actor model
- {\em $%m${}C++} -- write once variables
- {\em Mentat/C++} -- data flow
I>
\ifsli{\vspace{-1cm}}{}
</slide>

In section 3,
we looked at a number of concurrent extensions
of C++,
including Concurrent C++, ACT++,
$%m${}C++, Compositional C++ and Mentat/C++,
and we discussed their design rationale.

\ifsli{\clearpage\vfig{0}}{}
<slide id=6-4 cap="Section 6.4: Inheritance on processes">
:@ <a href=inherit.html>Inheritance on processes</a>
\zline{\fbox{4}}
\ifsli{\vspace{-0.5cm}}{}
<I
- {\em concurrency control} -- \c{centralized,}
decentralized
- {\em behavioral extensions} --
ACT++
- {\em inheritance} --
distributed termination \c{detection}
I>
\ifsli{\vspace{-1cm}}{}
</slide>

Further, in section 4, we looked at the problems involved
in combining processes and inheritance.
An example was given demonstrating how
inheritance and multi-threaded objects
may be used to model distributed
termination detection in a natural
way.

\clearfalse
<slide id=6-5 cap="Section 6.5: Requirements for distribution">
:@ <a href=distrib.html>Requirements for distribution</a>
\zline{\fbox{5}}
\ifsli{\vspace{-0.5cm}}{}
<I
- {\em transparency} --
\c{distributed} abstractions
- {\em distributed object computing} --
remote object method invocation
- {\em remote object invocation} --
dual objects\c{, annotations, placement}
I>
\ifsli{\vspace{-1cm}}{}
</slide>

Finally, in section 5,
we discussed a number of abstraction
or transparency requirements and
looked at an environment
for distributed object computing.
We also discussed
the issues involved
in replicating objects and
and remote object method invocation.
Finally, we looked at some 
network protocols.
</document>
