<document>
<slipar>
:@ Objectives
This section presents an overview and
classification of object-oriented languages.
It starts with a discussion of the
various viewpoints from which the notion 
{\em object-oriented} may be approached,
and characterizes the research
activities that have originally been inspired
by the language Simula.
A large number of actual languages 
are briefly discussed.

:@ Points to emphasize
<I
- {\em notion of object} -- viewpoints
- {\em classification} -- object extensions
I>

:@ Hints
In presenting the overview you may
need to explain the various underlying paradigms,
such as frame-based knowledge representation
techniques and distributed programming
issues in somewhat more detail.
In particular, languages such as Lisp
and Prolog which underly a number of
hybrid extensions may not be sufficiently
known to your audience.

:@ Questions
<N \setcounter{enumi}{0}
- What are the basic characteristics
of object-oriented languages?
- How would you classify object-oriented
languages?
Name a few representatives of each category.
- What do you consider to be the major
characteristic of the object model
supported by C++? Explain.
N>

:@ Comments
It is noteworthy that the hybrid languages,
such as Objective-C and C++,
and also the Lisp-based extensions,
have attracted much interest.
Partially, this may be explained by the need
for a gradual transition between paradigms.
Another subject for discussion, I would say.
\clearpage
</slipar>
</document>
