<document>

This chapter presented an overview
of object-oriented programming languages.
We discussed the heritage of Simula
and the various areas of research and
development the ideas introduced by
Simula has generated.

\clearfalse
\vfig{0.5}
<slide id=5-1 cap="Section 5.1: The object paradigm">
:@ <a href=paradigm.html>The object paradigm</a>
\zline{\fbox{1}}
\ifsli{\vspace{-0.5cm}}{}
<I
- {\em notion of object} -- viewpoints
- {\em classification} -- object extensions
I>
\ifsli{\vspace{-1cm}}{}
</slide>

A classification and overview of
existing object-oriented languages
was given and we noted the prominence
of hybrid languages derived from Lisp
and C.

\clearfalse
<slide id=5-2 cap="Section 5.2: Comparing Smalltalk, Eiffel and C++">
:@ <a href=comparis.html>Comparing Smalltalk, Eiffel and C++</a>
\zline{\fbox{2}}
\ifsli{\vspace{-0.5cm}}{}
<I
- {\em criteria} -- libraries, environments,
language characteristics
- {\em comparison} -- language characteristics
I>
\ifsli{\vspace{-1cm}}{}
</slide>

In section 2,
we looked at a comparison
of Smalltalk, Eiffel and C++,
including criteria such as the
availability of libraries,
programming environments and
language characteristics.

\clearfalse
<slide id=5-3 cap="Section 5.3: Design dimensions of object-oriented languages">
:@ <a href=design.html>Design dimensions of object-oriented languages</a>
\zline{\fbox{3}}
\ifsli{\vspace{-0.5cm}}{}
<I
- {\em object-oriented} -- object-based + inheritance
- {\em orthogonal dimensions} --
objects, types, delegation, abstraction
- {\em open systems} --
dimensions of modularity
I>
\ifsli{\vspace{-1cm}}{}
</slide>

In section 3,
we discussed the design dimensions
of object-oriented languages and
characterized an orthogonal set of
dimensions consisting of
objects, types, delegation and abstraction.
We also discussed the notion of open systems
and multi-paradigm languages
combining logic programming with
object-oriented features.


\ifsli{\clearpage\vspace{-2cm}}{}
\vfig{0.01}
<slide id=5-4 cap="Section 5.4: Prototypes -- delegation versus inheritance">
:@ <a href=proto.html>Prototypes -- delegation versus inheritance</a>
\zline{\fbox{4}}
\ifsli{\vspace{-0.5cm}}{}
<I
- {\em prototypes} -- cloning and delegation
- {\em performance} -- dynamic compilation
I>
\ifsli{\vspace{-1cm}}{}
</slide>

In section 4,
we dealt with classless prototype-based
languages, supporting dynamic delegation
instead of inheritance.

We also discussed performance issues
and observed that dynamic compilation
based on runtime type information
may achieve good results.

\clearfalse
<slide id=5-5 cap="Section 5.5: Meta-level architectures">
:@ Meta-level architectures
\zline{\fbox{5}}
\ifsli{\vspace{-0.5cm}}{}
<I
- {\em class} -- the concept of class
- {\em meta architecture} --
subclass and instance hierarchy
- {\em reflection} -- postulates
I>
\ifsli{\vspace{-1cm}}{}
</slide>

Finally, in section 5, we reflected on the concept
of class and discussed a reflective
architecture unifying the interpretation
of a class as an object, capable of
answering messages, and as a description
of the properties of its instances.
</document>
