<document>

@+ Abstraction

Since this is merely an exploratory tour,
there are no results in the sense of
<em> categories of usage</em>
or a deeper analysis in any sense.
Nevertheless, the list below more or less truthfully
reflects what can be found on the Web and
it does give an impression of the variety
of meanings that adhere to abstraction.
Abstraction is an abstract concept, indeed.
<p>
Surprisingly, there is only one page that
carries <a href=http://actor.cs.vt.edu/~kafura/cs2704/abstraction.html>
<em>Abstraction</em></a>
as it sole title.
It explains that <em> Abstraction is a design technique
that focuses on the essential aspects of an
entity and ignores or conceals less important or non-essential aspects</em>.
<p>
The next reference explains the opposition 
of <a href=http://homer.isye.gatech.edu/~tg/courses/6219/rpg/node9.html </a>
<em>Functional Abstraction versus Structural Decomposition</em></a>,
which is explained by saying that: <em>
The behavior of a system can be analyzed in two ways. One is by decomposition into
parts the behavior of which is known in isolation, The behavior of the system is described in terms
of cause-and-effect relations. Another is by abstraction to a functional level and separation of the
loops of interaction of interest.</em>
In other words, there is (just) a difference in focus, so it seems.
<p>
The next document found
introduced <a href=http://iue.tuwien.ac.at/diss/halama/diss/node42.html>
<em>The Tool Abstraction Concept</em></a>,
but alas,
the idea of Tool Abstraction remains unexplained
because this is (or was) a dead link!
<p>
Looking outside the realm of Computer Science
may be informative as well.
The page about <a href=http://www.cup.org/Titles/33/0521330858.html>
<em>Painterly Abstraction in Modernist American Poetry</em></a>
with the intriguing subtitle
<em>Infinite Incantations of Ourselves</em>
argues that <em>modernist poets have tended to resist
the received values of their contemporary
culture by finding idealizing principles in modes 
of pure abstraction</em>.
Interesting, but complex.
No doubt, Computer Science may be characterized
as <em>Applied Abstraction</em> at best.
<p>
The next page, promising to pave the
road <a href=http://www.parc.xerox.com/spl/groups/eca/pubs/abstracts/Kiczales:IMSA92.html>
<em>Towards a New Model of Abstraction in Software Engineering</em></a>
looks somewhat more familiar:
<em>The view of abstraction on which software engineering is based does not support the reality of
practice: it suggests that abstractions hide their implementation, whereas the evidence is that this
is not generally possible. This discrepancy between our basic conceptual foundations and practice
appears to be at the heart of a number of portability and complexity problems. </em>
<p>
Could it be that the Abstraction commonly applied
in Software Engineering is close
to <a href=http://uc2.unicall.be/pmmk/mc-lyr.htm>
<em>The Lyrical Abstraction</em></a>
which is aptly characterized by
Jackson Pollock's utterance: <em>"When I'm in
my painting, I'm not aware of what
I'm doing".</em>
<p>
Well, it's time to sober up.
So let's look at a new promising
trend in Software Engineering <a href=http://www_is.cs.utwente.nl:8080/keulen/me/docs/ecoop93-patterns.html>
<em>Design Patterns : Abstraction and Reuse of Object-Oriented Design</em></a>
which proposes <em>design patterns as a new mechanism for expressing object-oriented design
expertise. Design patterns identify, name, and abstract common themes in object-oriented design.
They capture the intent behind a design by identifying objects, their collaborations, and the
distribution of responsibilities.</em>
The abstraction of a craft, in a nutshell.
<p>
For convenience I have omitted links
to papers about the role
of <a href=http://theory.stanford.edu/~rvg/abstraction/node2.html>
<em>abstraction in semantics</em></a>,
documents referring to research such
as <a href=http://ai.eecs.umich.edu/people/vanlent/www/related/abstraction.html>
<em>Planning: Complexity and Expressivity and Abstraction
in Problem Solving</em></a>.
Also, I did not mention that there is
a <a href=http://www.cec.wustl.edu/~csm4/a8p2f1.html> 
<em>CS455 Manual: Abstraction</em></a> nor that there
is a <a href=http://www.usf.uni-kassel.de/mirror/www.ciesin.org/sedac-2.3/iamcc.tg/TGsec3-1-4.html>
<em>Thematic guide on Flexibility, 
Abstraction and Accessibility</em></a>.
<p>
From the examples discussed, it is clear to me
that abstraction does not merely conceal or
hide irrelevant aspects.
Abstraction captures something important, it discloses
another layer of reality.
We only have to find out what that is, precisely.
</document>

