<document>

@+ Complexity

Apparently, Complexity comes in many guises.
After scanning the list of references I tend
to agree with the quote on the page
about <a href=http://www.astro.wisc.edu/~erwin/chaos.html>
<em>Chaos and Complexity</em></a>
which characterizes Complexity by saying
<em>"I can't define it, but I know it when I see it."</em>
Or was it Chaos?
<p>
Apart from the
aforementioned <a href=http://192.215.52.3/www/catalog/cm.htm>
<em>Journal of Complexity</em></a>
(which publishes original research papers that contain substantial
mathematical results on complexity as broadly conceived)
there is a load of pages 
from <a href=http://ballade.cs.ucla.edu:8080/~abkclass/cs180/slides/s80.html>
<em>CS180: Algorithms and Complexity</em></a>.
<p>
An interesting reference is
the <a href=http://www.fmb.mmu.ac.uk/~bruce/combib/combib.html>
<em>Hypertext Bibliography of Measures of Complexity</em></a>
covering <em>some of the philosophical and practical references to the concept
and measurement of Complexity. It does not attempt to cover all the new sciences that might
come under the "Complexity" banner, unless they are relevant to the idea of Complexity per se.</em>
<p>
It is also interesting to ponder
about the <a href=http://www.jhuapl.edu/colloq/math.htm>
<em>Mathematical Complexity of Simple Economics</em></a>
since, <em> relative to the physical and biological
sciences, one tends to think of economics and other social and...  </em>
Well, you may fill this in to your own taste.
I wonder in what respect this differs from
the <a href=http://www.ict.co.jp/japa-bus/Business-culture-1.html>
<em>Complexity of Japanese Business Culture</em></a>.
Naturally,
<em>business culture, or corporate culture, is a
difficult and subtle topic to discuss</em>.
<p>
<a href=http://www.informatik.uni-leipzig.de/privat/wellner/public_html/emerg.html><em>Complexity International</em></a>
is another journal about Complexity.
It deals with
<em>the field of complex systems, the
generation of complex behavior from the interaction of multiple parallel processes. Relevant
topics include (but are not restricted to): artificial life, cellular automata, chaos theory, control
theory, evolutionary programming, fractals, genetic algorithms, information systems, neural
networks, non-linear dynamics, and parallel computation</em>.
<p>
With the <a href=http://i44s11.info.uni-karlsruhe.de/~frick/karla/complexity.html>
<em>Complexity of Methods and Classes</em></a>,
we are again on familiar ground:
<em>The choice of an implementation out of several possible alternatives is usually governed by
efficiency considerations. Depending on the structure of the problem at hand, different
implementations will have different runtime characteristics and space requirements. We refer to
these as the (time or space) complexity. Other measures exist.</em>
Fortunately so.
Although the title is at first sight somewhat misleading
this falls clearly within the area covered 
by <a href=http://www.cs.uiowa.edu/~mfleck/vision-html/handbook/automata.html>
<em>Automata, Formal Languages, and Complexity</em> [_Hopcroft],
about which it is said:
<em>Since God created computer science, the
standard textbook in this area has been Hopcroft and Ullman.</em>
<p>
By the way, the Complexity treated in [_Hopcroft]
has nothing to do with
<a href=http://irb.cs.uni-magdeburg.de/se/explain/complexity.html> <em>Software Complexity</em></a>
which goes back to 1960s:
<em>In general, the complexity of an object is a function of the 
relationships among the components of
the object.</em>
<p>
Most relevant to our investigation is
the title <a href=http://www.cs.washington.edu/homes/pardo/papers.d/aic.html>
<em>Abstraction-Induced Complexity</em></a>.
As the author says:
<em>Abstraction reduces the apparent complexity 
of an implementation by hiding all but "the most
relevant" details. However, no interface is suitable
for all the users of the implementation for
exactly the same reason:
each user has a slightly different view
of what is "most relevant." 
Thus, although abstractions can reduce complexity,
working around their limitations can introduce other
complexities.
Some abstractions are designed to minimize the added complexity.</em>
Well said, but it needs to be digested.
<p>
For refreshment look at 
<a href=http://www.uwm.edu/~ndell/litprn.htm><em>Simple Complexity</em></a>,
which combines
<em>fantasy, satire, philosophy ...</em>
It is a review of The Little Prince by Antoine de Saint-Exupry.
Read it.

</document>
