<document>

<control>
<a href=contents.html>
<img src=phrase.gif></a>
</control>

<h1>Introduction</h1>

The short musical phrase above is
taken from the Notebook of Anna Magdalena Bach.
I have used twelve of these phrases in my book
on the <em>Principles of Object-Oriented Software
Development</em> [_OOP], as decorations and,
to some extent, for pedagogical reasons.
As I say in the Preface of my Book:
<em>Despite their apparent simplicity, they are
acknowledged by experienced scientists as being
hard to play properly, yet they are
among the standard exercises for beginning pianists</em>.
I also explain how these phrases reflect the concepts
underlying object-oriented programming,
easy to learn but hard to play.
<p>
Apparently, it is not very hard to acquire some fluency
in <em>object-speak</em>, yet true understanding
requires more serious effort.
Deceptively simple, yet intrinsically difficult.
<p>
Some still regard Object-Oriented Programming
merely as a trend, to be replaced sooner or later
by some other trend.
Perhaps particular programming languages will be
replaced by some others.
For example C++, which is by many regarded as too complex,
might be replaced by Java. Time will tell.
Perhaps, some methods of software development
will be replaced by others. Undoubtedly.
Nevertheless, in the history of Computer Science,
Object-Orientation is definitely a step forward,
building on the control-flow abstractions
from the Structured Programming doctrine
and the data abstractions taught by the Abstract Data Type
school.
<p>
Object-Orientation allows for mastering
complexity by abstraction.
Reflecting on my experience in teaching
Object-Oriented Programming, I am painfully aware
of the difficulty of transferring this knowledge.
Object-Oriented Programming is not about Programming.
It is not about Algorithms.
It is about how to organize programs, how to
represent programs in a flexible manner
making use of Object-Oriented Technology.
Teaching Object-Oriented Programming requires
abstracting from the complexities of a technology
that enables one to master complexity by
employing abstractions.
Enough!
The lingo of Computer Science seems to be
playing a game with us.
What is Abstraction?
What is Complexity?
And how are they related?
<p>
For those who wish to bear with me,
I will explore the meaning of the ABC of Computer
Science, Abstraction and Complexity,
by investigating how they are deployed
in various contexts of usage.
This investigation includes some empirical research,
that is an inventory of their occurrence on the
Web,
as well as sucking my favorite resource, my thumb.
For those who doubt the fruitfulness of this endeavor,
have a beer. And read on.

</document>
