<document>

@ Complexity
Our model of a computing device [_Hopcroft] does quite
precisely delimit the domain of computable problems,
and gives us an indication of what we can expect the
machine to do for us, and what not.
Also, it illustrates what means we have available
to program such a device, in order to let it
act in the way we want.
Historically, the Turing machine model may be regarded
as a mathematical description of what is called the
Von Neumann machine architecture, on which most of our present
day computers are based.
The Von Neumann machine  consists of a memory and
a processor that fetches data from the memory,
does some computation and stores the data back in memory.
This architecture has been heavily criticized,
but no other model has yet taken its place.
This criticism has been motivated strongly by its influence
on the practice of programming.
Traditionally, programs for the Von Neumann architecture
are conceived as
sequences of instructions that may modify the state 
of the machine.
In opposition to this limited, machine oriented view of
programming a number of proposals have been made
that intended to arrive at a more abstract notion of programming,
where the machine is truly at the service of the programmer
and not the other way around.
<p>
One of these proposals to arrive at a more abstract notion of programming
is advocated as the {\em object-oriented approach}.
Before studying the intrinsics of the object-oriented approach,
however, it may be useful to reflect on what we may expect from it.
Do we hope to be able to solve more problems,
or to solve known problems better?
In other words, what precisely is the contribution of
an object-oriented approach?
<p>
Based on the characterization of a computing device,
some answers are quite straightforward.
We cannot expect to be able to solve more problems,
nor can we expect to reduce the computational complexity
of the problems that we can solve.
What an object-oriented approach can contribute to,
however, is simply in providing better means
with which to program the machine.
Better means to reduce the chance of (human)
errors, better means also, to manage the complexity
of the task of programming (but not to reduce
the computational complexity of the problem itself).
In other words, by providing abstractions that
are less machine oriented and more human oriented,
we may enlarge the class of problems that we can
tackle in the reality of software engineering.
However, we simply cannot expect that an object-oriented
approach may in any sense enlarge our notion
of what is computable.
</document>
