<document>
:@* Curriculum Vitae
Anton Eliens
<br>
\noindent
Date of Birth: 12/3/1952
<p>
\noindent
Online version with links: http://www.cs.vu.nl/~eliens/online/projects/cv
<c>
<hr>
<a href=doc.ps>Postscript</a>
<hr>
</c>

:@+ Summary Description
<slide id=summary mode=hide>
<p>
In my student years I explored the intellectual and aesthetic
arena, including the visual arts, electronic computer music,
and what in retrospect may be regarded as the foundations
of artificial intelligence.
At a certain stage, I took up an interest in theoretical
computer science,
which resulted in a Ph.D. degree on the design, semantics
and implementation of a distributed logic programming language,
about which I published a book, [_DLP].
During my employment at the VU, the focus shifted towards
software engineering, and in particular object oriented
programming, which resulted in a text book of which a second edition is
soon to appear, [_OO]. Gradually, I developed an interest in
hypermedia and multimedia user interfaces, which took shape
in the DejaVU project. The DejaVU project has led the
the <a href=@online/hush/index.html>hush</a> library,
to a number of publications concerning the Web,
which appeared on a number of successive Int. WWW Conferences,
[_DoornEl94,vOssenEl95,Jamming,Markup] and [_Animate,BPSIM],
as well as two consecutive workshops, see below.
The DejaVU project attracted a number of students
of which a selection became research assistents,
studying topics such as, hypermedia, simulation and visualization,
and task modeling and groupware.
Recently, I got involved in multimedia retrieval research,
in an exchange with the CWI, which resulted in a 
<a href=@online/papers/midi/contents.html>musical feature detector for MIDI</a> as well as an <a href=@online/projects/rif/request.html>NWO proposal</a> to
extend this approach to virtual worlds.
Today my interest in logic-based approaches is still strong, 
as testified by the approach taken in multimedia feature detection,
and a <a href=http://www.cs.vu.nl/~eliens/logic>study group</a>
at the VU focussed
on the application of logic-based programming in software engineering
applications. My current interests encompass, in brief,
knowledge management,
visualization and retrieval in 3D VRML-based virtual worlds.
<p>
As a comment, I have also been working at creating the
<a href=@online/contents.html>online documentation</a> of my research and written work, including
the documentation for <a href=@online/hush/index.html>hush</a>
and the online version of my book <a href=@online/oo/contents.html>Principles of Object-Oriented
Software Development</a>.
</slide>

:@+ Diplomas
<slide id=diplomas mode=hide>
<ul>
<li> 1979 -- Doctoraal Philosophy (UvA)
<li> 1979 -- Gerrit Rietveld Academy - painting
<li> 1985 -- Doctoraal Psychology (UvA)
<li> 1986 -- Doctoraal Informatica (UvA, cum laude)
<li> 1991 -- Ph.D. Informatica, prof dr. de Bakker, prof dr Klint
</ul>
</slide>

:@+ Employment
<slide id=employment mode=hide>
<ul>
<li> 1997-82: project medewerker Institue of Sonology (Unov of Utrecht)
<li> 1981-82: assistent researcher, Dept of Philosophy, UvA
<li> 1996-90: assistent researcher, CWI
<li> 1990-..: universitair docent, Dept of CS, VU
<li> 1998-..: senior researcher, CWI (part-time, in exchange with VU)
</ul>
</slide>

:@ Further information
prof dr J.C. van Vliet (VU),
prof dr J. Treur (VU),
prof dr M.L. Kersten (CWI),
prof dr P. de Bra (TUE/CWI)
prof dr. J.W. de Bakker (CWI)

:@+ Research Activities

<slide id=projects mode=hide>
:@ Projects
<ul>
<li> 1994-..: DejaVU Project (Distributed Hypermedia)  
<li> 1997-2001: SINS, VU/UFS Project, with prof dr vd Riet
<li> 1999-2001: <a href=@online/projects/wasp/request.html>WASP - Web Agent Support Program</a>, with prof dr J. Treur (VU/AI) and prof dr P. de Bra (TUE/CWI)
</ul>
</slide>

<slide id=prepare mode=hide>
:@ In preparation
<ul>
<li> NWO/GBE: <a href=@online/projects/rif/request.html>RIF - Retrieving Information in Virtual Worlds Using Feature Detectors</a>
with prof dr. M.L. Kersten (CWI) and prof dr. P. de Bra (TUE/CWI)
</ul>
</slide>

<slide id=workshops mode=hide>
:@ Workshops
<ul>
<li> <a href=@online/projects/www5/index.html>WWW5: Programming the Web</a>
<li> <a href=@online/projects/www6/index.html>WWW6: Logic Programming and the Web</a>
</ul>
</slide>

<slide id=program mode=hide>
:@ Program Committees
<ul>
<li> EDPD: International Conference on Electronic
Publishing, Document Manipulation and Typography 
<li> Webnet 99: <a href=http://www.aace.org/conf/webnet>World Conference of the WWW and Internet</a>
</ul>
</slide>

:@+ Educational Activities

<slide id=courses mode=hide>
:@ Academic courses
<ul>
<li> 1991-..: Practicum Software Engineering
<li> 1992-..: College/Practicum Object-Oriented Programming
<li> 1994-97: College Formal Methods
<li> 1995-..: Caput Hypermedia
<li> 1999: in preparation: Introduction Multimedia
</ul>
</slide>


<slide id=student mode=hide>
:@ Student projects
<ul>
<li> internal projects in DejaVU Framework
<li> stages in OO development, CORBA, Web applications
</ul>
In total I supervised well over 50 students,
including 4 foreign students
</slide>

<slide id=phd mode=hide>
:@ PhD Students
<ul>
<li> J.R. van Ossenbruggen,  expected end of 1999
<li> S.P.C. Schonhage
<li> M. van Welie, in cooperation with dr G. vd Veer
</ul>
</slide>

<slide id=extra mode=hide>
:@ Extra academic courses
<ul>
<li> CMG Course Web Applications (1998-99)
<li> CMG Course Object-Oriented Software Engineering (1998-99)
<li> SIKS AIO Course: <a href=@online/courses/siks98/contents.html>Multimedia</a>, may 1998
</ul>
</slide>

<slide id=admin mode=hide>
:@+ Administrative Activities
<ul>
<li> 1992-95: Stuurgroep BWI
<li> 1996-97: Chair Facultaire Onderwijscommissie
<li> 1998-..: Opleidingscie Informatica
<li> 1998: Advisor Facultaire Web Commissie
<li> 1998-..: Advisor Web en Onderwijs
<li> 1998-..: Advisor TwinSite-2000
</ul>
</slide>

<slide id=present mode=hide>
<so presentations>
</slide>

%%<slide id=publish mode=hide>
<so publications>
%%</slide>
</document>
