@* Introduction 
 
With an increasing growth of information, hypermedia
will become more and more important.
Hypermedia must be regarded as a merge between multimedia and hypertext.
Multimedia capture the need of displaying information in a
non-textual form, such as graphics, sound or video animation.
Hypertext technology provides associative information storage and retrieval
by means of machine supported links between pieces of information.
Combined, multimedia and hypertext offer a very powerful technology
for information management, that we call hypermedia.
<p> 
In order to deal with the mass of information involved, the integration
of expert system technology and hypermedia has been proposed [Parsay et al, 1989]. 
With reference to our earlier work on    distributed logic programming  [Eliens, 1992],
we wish to explore this development towards    distributed logic-based hypermedia,
supporting knowledge-based information storage and retrieval.
 
@ Hypermedia applications 
range from computer-based training,
technical documentation and online encyclopedias to
interactive help systems and information systems that aid
in decision making, as for instance on the occurrence of environmental
disaster.
As prospective business applications one may think of
product catalogs, blueprints and bulletin boards for advertisement.
Electronic publishing is also likely to grow more important.
<p> 
Another interesting application area of hypermedia technology
lies in the software engineering of complex systems.
Hypermedia may provide the support to monitor the behavior of
a distributed program by means of animation techniques.
Visual programming formalisms (like some CASE tools offer)
may be naturally embedded in a hypermedia environment.
See [Bigelow, 1988], [Meyer, 1990] and [Raeder, 1985].
<p> 
One of the major challenges of hypermedia systems is to support    connectivity,
that is to allow the integration of    heterogeneous  systems
and to provide the support for a compatible, homogeneous user interface.
We expect that knowledge-based information handling and display
will provide the support for such systems, as an example of which one may
think of future office information systems.
 
@ Project aims 
The DejaVu project aims at providing a framework for the development
of open, heterogeneous distributed object oriented intelligent hypermedia systems.
The phrase    open  means here that the framework offered must be extendible
by a user to make it fit his or her own needs.
By    heterogeneous  is meant that the framework must support the development
of systems consisting of multiple, loosely coupled, components.
Similarly, the framework must support the development of    distributed 
systems, that are intended to run on a network of computers.
The phrase    object oriented  clearly reflects a choice for a
particular approach to software development, that is known as object oriented
programming.
Finally, the adjective    intelligent  indicates our intention
to provide logic-based retrieval and navigation capabilities,
alike those proposed for intelligent information systems.
<p> 
Our aim is to provide a framework that integrates distributed logic programming
with hypermedia technology, to support the development of distributed knowledge-based
hypermedia systems.
The starting point of our project will be to extend the distributed logic
programming language DLP, as described in [Eliens, 1992], with hypermedia facilities
and a suitable programming environment.
<p> 
Since our own expertise lies primarily in software engineering,
computer systems and programming languages,
we will focus our research initially to the development of hypermedia
technology to support 
the construction and maintenance of complex software systems.
The description of the background and motivations of the project is written from
this perspective.
It is, however, explicitly not our intention to restrict ourselves
to this application area.
On the contrary, we will look for opportunities to explore other application
areas as well, such as for example environmental monitoring and computer-based training
systems.
In this initial phase, however, the inlooking nature of
our approach seems unavoidable. Cf. [Graham, 1991].
 
@ Software engineering 
The DejaVu project is meant to serve as a vehicle for 
research in hypermedia systems, software reuse,
object oriented programming, distributed logic programming and
intelligent information systems.
Along with the actual realization of the framework we hope that valid insights and
guidelines will emerge, that will contribute to the software engineering theory
concerning heterogeneous distributed hypermedia systems.
Also we expect to have (scientifically valid) spinoff from our accompanying theoretical studies
of the areas mentioned.
 
