<latex>
\documentclass{article}
\usepackage{latexsym}
\begin{document}
\def\bibname{Publications}
</latex>
@cite=1
<control>

:@* NWO/GBE grant request <a href=local/sion-handleiding-3.html>MM 98/99</a>
<control><hr>
<a href=doc.ps>Postscript</a>,
URL: http://www.cs.vu.nl/~eliens/online/projects/rif/request.html
(<a href=tender.html>tender</a>)
<a href=urls.html>URLS</a>
<hr></control>
</control>
%%
%%       LATEX FILE FOR NWO/GBE  GRANTS REQUESTS
%%

%% Complete the file as much as possible. Answer all questions in english.

%% File number. To be filled in by NWO
\def\filenumber{}

%% Question 1. Applicant(s)
<control>
:@+ 1 Applicants
Dr. A. Eliens (VU/CWI) (contact person: //mailto:eliens@cs.vu.nl )
FEW/CS, De Boelelaan 1081, 1081 HV Amsterdam
<br> Prof Dr M. Kersten  (CWI/UVA)
<br> Prof Dr P. De Bra (TUE/CWI)
<br>
Email: 
<a href="mailto:eliens@cwi.nl,Martin.Kersten@cwi.nl,Paul.De.Bra@cwi.nl">eliens@cwi.nl Martin.Kersten@cwi.nl Paul.De.Bra@cwi.nl</a>
</control>
%% 1a. Name
<!--\def\name{
Dr. A. Eliens (VU/CWI) (contact person: //mailto:eliens@cs.vu.nl )
<br>Prof Dr M. Kersten  (CWI/UVA) 
<br>Prof Dr P. De Bra (TUE/CWI)
}-->
<!--
%% 1b. Position
\def\position{UD}
%% 1c. Address
\def\address{VU, FEW/CS, De Boelelaan 1081, 1081 HV Amsterdam}
%% 1d. Phone
\def\phone{020-4447741}
%% 1e. E-mail
\def\mail{eliens@cs.vu.nl}
-->

%% Question  2. Research Title
<c>
:@+ 2 Research Title
</c>
<!--\def\title{-->
RIF - Retrieving Information in Virtual Worlds Using Feature Detectors
<!--}-->

%% Question 3a. Institute where research will be carried out.
<c>
:@+ 3 Institute where research will be carried out
</c>
<!--\def\place{-->
The OIO will work at the CWI under the supervision of dr. A. Eliens
<!--}-->

%% Question 3b. Field of research.
%% Choose one of the following disciplines: Astronomy, Computer science, Mathematics.
\def\field{Computer Science}

%% Question 4. Summary of proposed research.
%% At most 15 lines.
<c>
:@+ 4 Summary of proposed research
</c>
<!--\def\summary{-->
Based on the observation that multi-user virtual worlds
are becoming an increasingly important phenomenon in the
Internet-based Cyberspace (see for example http://www.blaxxun.com and http://www.colonycity.com), we propose to investigate
the indexing and retrieval problem for multi-user virtual worlds.
<p>
Our research is meant to extend the <a href=http://www.cwi.nl/~acoi>ACOI</a>
framework for the 
indexing and retrieval of multimedia objects by providing
special purpose feature detectors for virtual worlds,
that fit within the ACOI architecture.
The ACOI architecture is built around a Monet database
that stores information concerning the structure and contents
of multimedia objects available on the World Wide Web.
The assumption underlying the indexing and retrieval model
underlying the ACOI framework is that the structure and contents
of multimedia objects may be expressed by a grammar that is augmented
with media-specific detectors for analysing the object.
These detectors act as token generators, providing the
information to be stored in the Monet database.
<p>
For the construction of feature detectors for multi-user
virtual worlds, we need to develop the technology
to analyse world description files and VRML encodings
of the geometric structure and objects contained in a world,
and an ontology or knowledge representation to store
and reason about the contents of the world and its relation to
other worlds.
Further we need to investigate how we can assist the end user
in formulating and refining queries with respect to locations
within a world, informational resources contained within a world,
and navigational preferences, that is the wish to migrate
to different worlds.
<p>
The initial approach will be to extend the musical feature
detector, see [_MIDI], which is based on a combination of
feature grammars and descriptive logic, to the contents
of virtual world.
In a later stage, we will combine our virtual world
feature detector with the other multimedia feature
detectors developed within the ACOI framework.
To validate our approach, we intend to create
a small virtual world ourselves, in order to establish
the effectiveness of our indexing and retrieval method.
<p>
Our research will result in actual feature detectors running
within the ACOI framework, a knowledge representation
or ontology for collecting information about virtual worlds,
and appropriate applets to formulate queries and deliver
a report of the outcome of consulting the ACOI index database.
<p>
An online version of this proposal, including links,
is available at:<br>
URL: http://www.cs.vu.nl/~eliens/online/projects/rif
<!--}-->

%% Question 5. Composition of the research group involved.
%% Provide the following information: name, title, research expertise,affiliation
%% hours/week each person will spent on proposed research in 1999. 
<control>
:@+ 5 Composition of research group
<table><!--{ l | c | c | c }-->
<tr><td>Name<td>Research field<td>Affiliation<td>hours/week</tr>
<tr><td>Dr. A. Eliens<td>OO/Hypermedia<td>VU/CWI<td>8</tr>
<tr><td>Prof. Dr. M. Kersten<td>MM Databases<td>CWI/UvA<td>1</tr>
<tr><td>Prof Dr. P. de Bra<td>Hypermedia/HCI<td>TUE/CWI<td>1</tr>
<tr><td>Drs. B. Schonhage<td>Visualisation<td>VU/GAK<td>4</tr>
</table>
</control>
<latex>
%% Person 1
\def\nameone{Dr. A. Eliens}
\def\fieldone{OO/Hypermedia}
\def\affilone{VU/CWI}
\def\hoursone{8}
%% Person 2
\def\nametwo{Prof. Dr. M. Kersten}
\def\fieldtwo{MM Databases}
\def\affiltwo{CWI/UvA}
\def\hourstwo{1}
%% Person 3
\def\namethree{Prof Dr. P. de Bra}
\def\fieldthree{Hypermedia/HCI}
\def\affilthree{TUE/CWI}
\def\hoursthree{1}
%% Person 4
\def\namefour{Drs. B. Schonhage}
\def\fieldfour{Visualisation}
\def\affilfour{VU/GAK}
\def\hoursfour{4}
%% Person 5
\def\namefive{}
\def\fieldfive{}
\def\affilfive{}
\def\hoursfive{}
</latex>

%% Question  6. Required funding period
<c>
:@+ 6 Required funding period
Period: 4 years. Starting date: 1/1/2000, for 1 OIO
</c>
<latex>
%% Period in years
\def\period{4 years}
%% Starting date: dd-mm-yyyy
\def\start{1/1/2000}
</latex>

%% Question 7. Classification: science field and discipline.
<c>
:@+ 7 <a href=local/classification.html>Classification</a>(<a href=http://www.acm.uiuc.edu/signet/JHSI/cr.html>CR</a>)
</c>
<!--\def\discipline{-->
<ul>
<li> 2.1. Multimedia databases
<li> 2.3. Information Retrieval
<li> H.1 Information Systems - Models and Principles
<li> H.4 Information Systems - Information Systems Applications
<li> H.5.1 Information Systems - Multimedia Information Systems
</ul>
<!--}-->

%% Question 8: Scientific justification.
<c>
:@+ 8 Description of the proposed research
</c>
%% At most 2 pages text.
<!--\def\justification{-->

:@- 1 Content

:@ Problem description
In our research we tackle the information indexing
and retrieval problem for multi-user virtual worlds.
Basically,
the information retrieval problem consists of detecting containment relations between worlds,
and gathering information about the objects in that world, which includes geometric shapes as well as text,
image and sound objects. 

:@ Solution
Our solution to the information extraction problem in virtual worlds
is primarily based on the deployment of black-box feature
detectors as developed in the AMIS project [_ACOI,MONET].
<p>
A black-box feature detector takes an arbitrary multimedia
object and extracts a set of features that may be used
as predicates or functions in a query.
For example, a feature detector for a sound object may deliver,
after subjecting the object to a suitable analysis, information with
respect to the composer, the melody and lyrics of that sound object.
When, to continue the example, the music object is a midi file, we need
to extract this information using a special-purpose
midi file decoder and translate the properties into
a format that allows us to store these in a database.
The actual approach taken in this respect is to represent
the musical events as Prolog facts and to employ predicates
written in Prolog to extract the properties of interest.
These properties are then fed as tokens into a standard
feature detector that puts these properties in the (feature) 
database. See reference [_MIDI] for a more extensive description.
<p>
For the dissection of VRML worlds we extend the approach
as developed for the analysis of MIDI files.
In particular, we need to develop a special purpose VRML
file decoder to extract basic properties.
Such properties are the
geometric objects described, the containment of other (VRML) worlds,
links to other Web-based resources and the use of text and
other multimedia items such as images and sound objects.
For text and multimedia objects, we can deploy already existing
feature detectors, as developed in the AMIS and U-AID projects.
Technology to inspect VRML files is available in the
public domain or may (preferably) be bought. 
<p>
Embedded logic is used for the assembly relevant properties.
This technique has been developed in recent years at the Vrije
Universiteit to significantly simplify large portions of knowledge
intense software systems [_OO,WASP].
<p>
In addition, we need to define
a suitable ontology 
that allows us to maintain knowledge about virtual worlds
and their geometric/topological relations.
We expect that a significant amount of the information pertaining
to a virtual world will be contextual, gathered from
clues coming from text and multimedia objects contained in
the world and clues coming from inspecting the contexts
providing access to the world. 
<p>
To validate our approach, we propose a constructive approach
as we have taken for the analysis of musical data,
that is
to set up a small
multi-user community server ourselves.
This allows us to experiment with the actual information content
of virtual worlds and the subsequent retrieval of information.

:@ Desired results
<ul>
<li> virtual world and VRML feature detectors in ACOI framework
<li> query and report interface  (implemented as applets)
<li> integration with other ACOI feature detectors
<li> validation study against a small experimental virtual world
</ul>

<!--}-->
<!--\def\restjustification{-->

:@ Significance
The scientific innovation of this project lies in the challenge
to extract indexing information from a collection of complex,
geometric multimedia objects comprising
a virtual world, and to manage this knowledge for
the visitors and inhabitants of that virtual world.
This translates into requirements on the precision, scale and
semantic structure of the database schemas, but also on
the primitive and computational model to answer the queries posed.

:@- 2 Societal Usefulness
Our research is related to the MM and DISH themes.
Establishments of virtual worlds is an increasingly important
facet of Internet use. They quickly mature towards 
virtual communities around special areas of interest,
ranging from chat-arenas to CSCW environments.
Many communities will use VRML as a cheap presentation vehicle for providing
access to information and communication facilities.
As with the earlier forms of information dissemination, the
navigation and orientation problem (lost in cyberspace)
will inevitably occur, for which we have a timely answer.
The transfer of our results will take place
along the usual academic channels.

:@- 3 Collaboration of subdisciplines
The partners 
are members of SIKS (the Dutch Research School
for Information and Knowledge Systems, http://www.siks.nl).
Apart from pure computer science the RIF project involves research 
in knowledge management for virtual worlds.

:@- 4 National and International Initiatives or Activities 

This project is embedded and extends ongoing National multi-media indexing and
search projects, AMIS and DMW, which provides for the infrastructure
and modelling base. In particular, we have already developed
techniques to index sound and image objects and we provide a database
framework to manage multi-media features efficiently.
For the VRML worlds and their interrelations
we have to develop new new feature detectors, along the line of
our MIDI feature detector, that
have knowledge of the syntax and structural properties of
VRML worlds. We have gained experience with VRML
in the SINS project, see references [_VRML,Perspectives,DIVA].

<p>
Summarizing, the research is embedded in the following projects:
<ul>
<li> WASP -- NWO/SION Project 1998-2000 (VU/TUE) (Eliens)
<li> AMIS -- NWO/SION 1997-2001 (Kersten)
<li> U-AID -- CWI/TUE (De Bra/Kersten)
<li> DMW : Digital Media Warehouses - Telematic Institute (1998-2002) (Kersten)
<li> SINS/DIVA -- USF Project VU, 1997-2001 (Eliens/Schonhage)
</ul>

To explain, WASP stands for Web Agent Support Program.
AMIS is the Advanced Multimedia Indexing and Searching project.
U-AID stands for User-Aided Indexing of Databases.
DMW  stands for Digital Media Warehouses
and DIVA stands for Distributed Visualization Architecture.


<!--}-->
<!--\def\restrestjustification{-->

<include file=urls>

:@- 5 Plans for implementation

:@ Activities -- Summary
<ul>
<li> First year: explorative studies, analysis of VRML and
virtual world description files, modeling properties in logic;
also the construction of a set of reference worlds for
validation
<li> Second year: definition of a knowledge representation
or ontology to capture the contents of a world and
its relations to other worlds; exploration of
the integration with other detectors developed 
within the ACOI framework.
<li> Third year: query facilities, including means
to refine the search for properties or locations in worlds;
offering to the Web community
<li> Fourth year: Stabilization of the actual world detector
and its integration with other detectors developed within
the ACOI framework; validation of the approach; and writing of the
thesis.
</ul>

About the first year, the start of the project,
we can be somewhat more precise.
It is important to start with a requirements analysis
of what queries users find important.
In particular, we need to investigate what simililarity criteria
can be applied, and how locations and navigation in virtual worlds
may be indicated.
To aid our understanding, it is also important to have a small
set of virtual worlds for experimentation.
We will set up such an environment also at the beginning
of the project, first to explore indexing, and in a later
stage for the initial validation of our approach.
In addition we need to develop the technology to
extract features from VRML files.
This should not be a major problem, given the availability
of VRML processing software.
Nevertheless, we need to gain experience with this software
and integrate it with the ACOI framework.



:@ Personel planning
The OIO will work at the CWI under the direct supervision
of dr. Eliens. There will be a close cooperation with the
other members of the INS1 group at the CWI.
prof. dr. M.L. Kersten will act as promotor. 

:@ Facilities
Facilities will be provided by CWI.
We wish to purchase some addtional software,
(1) TGS 3D Master-suite (http://www.tgs.com/3DMS),
for the analysis of VRML files,
and (2) Blaxxun Community Server Developer License (http://www.blaxxun.com/developer), to set up a small community for validating
approach to indexing and retrieval.

<!--}-->
<!--\def\restrestrestjustification{-->

:@ Financial planning
This concerns the salary of the OIO, for a period of
4 years, and the purchase
of software.
In addition we request fl. 1700,-/year for travel expenses.

:@ Deliverables
<ol>
<li> Year 1: Prototype VRML Feature Detector  
<li> Year 2: Prototype Virtual World Detector (VRML + Ontology)
<li> Year 3: Query and retrieval component for Virtual World Detector 
<li> Year 4: Validation study, thesis
</ol>

:@- 6 Available expertise
Our group INS1 at CWI, directed by prof.dr. M.L. Kersten,
has considerable expertise in multimedia databases and
in particular the indexing and retrieval problem for multimedia
objects. Dr. de Bra (TUE/CWI) brings in expertise wrt. task-related
aspects of information retrieval.
Dr Eliens, who is working part-time at the CWI in an exchange
with the VU, has developed the MIDI musical feature detector in ACOI
and, together with other members of his group at the VU, he
brings in the expertise concerning VRML and virtual communities.


:@- Publications
<include file=references>
<!--}-->

%% Question 9. Work programme.
%% At most 20 lines.
<c>
:@+ 9 Work programme
</c>
<!--\def\workplan{-->
Our approach will be to develop a VRML file
detector, by adapting the MIDI file adapter, in
the very early stages of the project.
We also plan to setup a small collection of VRML files
and a community server to create an experimental
virtual world for validating our approach.
The development of the logical representation of worlds
and the interaction with other feature detectors
will be the next step.
In the later stages of our research we will stablize our
detector and make a query facility available
to the World Wide Web community.
We will then roam the Web to  create an index to
existing virtual worlds, such as http://www.colonycity.com .
<!--}-->

%% Question 10. Observations
%% For astronomy only. 
%% Are new observational data required (delete as applicable)
<latex>
\def\new{}
%% Specification if new data are required
\def\specification{}
%% Is observing time requested/allocated
\def\time{}
%% Indicate when the required data become available
\def\data{}
</latex>

%% Question 11.  Requested budget.
%% Provide the following information: requested personnel (in staff years)
%% to carry out the research proposal, required travel grant (in the Netherlands
%% and abroad, instruments/equipment and consumables for each of the years. 
<c>

:@+ 11 Requested budget

:@ Personel
1 OIO for 4 year, is approx. 200 KF.
Coaching is done by dr. A. Eliens,
the promotor is prof. dr. M.L. Kersten
:@ Software
approx 50 KF, for purchase of Blaxxun Community Server and
3D Master-Suite
</c>

<latex>
%% Request 1999
%% Staff years
\def\ftexa{}
%% Travel costs in the Netherlands
\def\nethxa{}
%% Travel costs abroad
\def\abroadxa{}
%% Equipment (see also information in call for proposals)
\def\equipxa{}
%% Consumables
\def\consumxa{}

%% Forward Look 2000 - 2003
%% Staff years
\def\ftexb{1}
\def\ftexc{1}
\def\ftexd{1}
\def\ftexe{1}
%% Travel costs in the Netherlands
\def\nethxb{}
\def\nethxc{}
\def\nethxd{}
\def\nethxe{}
%% Travel costs abroad
\def\abroadxb{}
\def\abroadxc{}
\def\abroadxd{}
\def\abroadxe{}
%% Equipment
\def\equipxb{}
\def\equipxc{}
\def\equipxd{}
\def\equipxe{}
%% Consumables
\def\consumxb{}
\def\consumxc{}
\def\consumxd{}
\def\consumxe{}

%% Question 12a. Specification of requested personnel
%% Request for Ph.D. student or postdoctoral fellow (delete as applicable.)
\def\request{Ph.D. student }
%% If Ph.D. student, who is responsible for coaching and who is the thesis supervisor ?
\def\supervisor{Dr. A. Eliens/ prof. dr. M.L. Kersten (promotor)}
%% Candidate (if known)
\def\candidate{}
%% Question 12b. Specification of material costs
\def\equip{
approx 50 KF, for purchase of Blaxxun Community Server and
3D Master-Suite, and related software
}
</latex>
<c>
:@+ Signature
</c>
%% Signature 
%% Applicant(s)
\def\applicantone{A. Eliens}
\def\applicanttwo{M.L. Kersten}
\def\applicantthree{P. de Bra}
\def\applicantfour{}
%% Date 
\def\date{25/1/99}
<latex>
%% start van opbouw tabellen
\setlength{\textwidth}{16.5cm}
%%\setlength{\textheight}{22.5cm}
\setlength{\textheight}{20.5cm}
\topmargin=0.0pt
\evensidemargin=0mm
\oddsidemargin=0mm
\headheight=0mm
\headsep=0mm
\footskip=0mm
\pagestyle{empty}
%%
%%
{\bf {\Large NWO/GBE  grant request form }}
%%
%% Eerste tabel; items 1 t/m 4
%%
\begin{table}[h]
\begin{tabular}{|l@{ }p{3cm}|p{12cm}|}
\hline
\multicolumn{2}{|l|}{\bf 1999} & \bf{File number \filenumber } \\
\hline 
1. & Applicant(s) & \name \\
   & . Position     & \position \\
   & . Address      & \address \\
   & . Phone        & \phone \\
   & . E-mail       & \mail \\
\hline
2. & \raggedright Research title & \title \\
\hline
3. & . Institute where research will be carried out & \place \\
   & . Field of research & \field \\
\hline
4. & \raggedright Summary of proposed research & \summary \\
\hline
\end{tabular}
\end{table}
%%  
%%
%% Tweede tabel met item 5
%%
\begin{table}[h]
\begin{tabular}{|l@{ }p{3cm}|p{4.8cm}@{ }p{2.5cm}@{ }p{2.5cm}@{ }p{2cm}|}
\hline
5. & \raggedright Composition of the research group involved & Name+title & 
\raggedright Research field & Affiliation & hours/week in 1999 to be spent on proposed
research \\
\hline
& . person 1& \nameone & \fieldone & \affilone & \hoursone \\
& . person 2& \nametwo & \fieldtwo & \affiltwo & \hourstwo \\
& . person 3& \namethree & \fieldthree & \affilthree & \hoursthree \\
& . person 4& \namefour & \fieldfour & \affilfour & \hoursfour \\
& . person 5& \namefive & \fieldfive & \affilfive & \hoursfive \\
\hline
\end{tabular}
\end{table}
%%
%% Derde tabel met items 6 en 7
%%
\begin{table}[h]
\begin{tabular}{|l@{ }p{3cm}|p{12cm}|}
\hline
6. & \raggedright Required funding period & Period: \period \\
& & Starting date: \start \\
\hline
7. & Classification & Science field + discipline \\ & & \discipline \\
\hline
\end{tabular}
\end{table}
%%
%%\newpage
%%
%% Vierde tabel met item 8 op nieuwe pagina
%%
\clearpage
%%\begin{table}[h]
\begin{tabular}{|l@{ }p{3cm}|p{12cm}|}
\hline
8. & \raggedright Description of proposed research & \justification \\
\end{tabular}
\begin{tabular}{|l@{ }p{3cm}|p{12cm}|}
   &  & \restjustification \\
\end{tabular}
\begin{tabular}{|l@{ }p{3cm}|p{12cm}|}
   &  & \restrestjustification \\
\end{tabular}
\begin{tabular}{|l@{ }p{3cm}|p{12cm}|}
   &  & \restrestrestjustification \\
\hline
\end{tabular}
%%\end{table}
%%
\clearpage
\newpage
%%
%% Vijfde tabel met items 9 en 10 op een nieuwe pagina
%%
\begin{table}[h]
\begin{tabular}{|l@{ }p{3cm}|p{12cm}|}
\hline
9. & Workplan & \workplan \\
& & \\
\hline
10. & Observations & Are new observational data required? \new \\
& & \\
& & Specification if new data are required: \specification \\
& & \\
& & Is observing time requested/allocated? \time \\
& & \\
& & Indicate when the required data become available: \data \\
\hline
\end{tabular}
\end{table}
%%
%% Zesde tabel met item 11 op nieuwe pagina
%%
\newpage
%%
\begin{table}[h]
\begin{tabular}{|l@{ }p{1.5cm}|p{1.5cm}|p{1cm}|p{1.6cm}|p{1.7cm}|p{1.6cm}|p{1.6cm}|p{1.9cm}|}
\hline
11. & Budget &  &  & personnel & \multicolumn{2}{|l|}{travel costs} & \multicolumn{2}{|l|}{material costs}  \\
\cline{5-9}
&    & & year & staff yrs & Netherlands & Abroad & \raggedright Equipment & consumables \\
& & & & & & & & \\
\cline{3-9}
& & & & & & & & \\
& & Request & 1999 & \ftexa & \nethxa & \abroadxa & \equipxa & \consumxa \\ 
& & & & & & & & \\
\cline{3-9}
& & forward look & 2000 & \ftexb & \nethxb & \abroadxb & \equipxb & \consumxb \\  
\cline{3-9}
& & forward look & 2001 & \ftexc & \nethxc & \abroadxc & \equipxc & \consumxc \\  
\cline{3-9}
& & forward look & 2002 & \ftexd & \nethxd & \abroadxd & \equipxd & \consumxd \\  
\cline{3-9}
& & forward look & 2003 & \ftexe & \nethxe & \abroadxe & \equipxe & \consumxe \\  
\hline
\end{tabular}
\end{table}
%%
%% Zevende tabel met item 12
%%
\begin{table}[h]
\begin{tabular}{|l@{ }p{3cm}|p{12cm}|}
\hline
12. & Specifications & \\
& a. Specification of requested personnel & \request \\
& & In case of Ph.D. student; who is responsible for coaching and who is promotor? \\
& & Supervisor: \supervisor \\
& & \\
& & Candidate (if known): \candidate \\
& & \\
\hline
& & \\
& b. Specification of material costs & \\
& & \\
& & \equip \\
\hline
\end{tabular}
\end{table}
%%
%% Afsluitende tabel
%%
\begin{table}[h]
\begin{tabular}{|l@{ }p{3cm}|p{12cm}|}
\hline
13. & Signature & Applicant(s): \\
& & \applicantone \\
& & \applicanttwo \\
& & \applicantthree \\
& & \applicantfour \\
& & \\
& & Date: \date  \\
\hline
\end{tabular}
\end{table}
\end{document}
</latex>
