<document style=report packs=a4>

@* Tender <a href=local/sion-handleiding-3.html>MM 98/99</a>

<control><hr>
<a href=@text-tender.ps>Postscript</a>,
URL: http://www.cs.vu.nl/~eliens/online/projects/rif/tender.html
<hr></control>

@ Title

RIF - Retrieving Information in Virtual Worlds Using Feature Detectors

@ Authors

Dr. A. Eliens (VU/CWI) (contact person)
FEW/CS, De Boelelaan 1081, 1081 HV Amsterdam
<br> Prof Dr M. Kersten  (CWI/UVA)
<br> Prof Dr P. De Bra (TUE/CWI)
<br>
Email: 
<a href="mailto:eliens@cwi.nl,Martin.Kersten@cwi.nl,Paul.De.Bra@cwi.nl">eliens@cwi.nl Martin.Kersten@cwi.nl Paul.De.Bra@cwi.nl
</a>


@ Research Goals and Aspects



Multi-user virtual worlds are becoming an increasingly important
phenomenon in the Internet-based Cyberspace.
Virtuals worlds are composed of 3D scenes representing a particular 
area in that world, its inhabitants (the user)
represented by means of life-like avatars,
multi-user interaction facilities, such as chat and video conferencing, 
and static information resources, such as large digital libraries
and digital marketplaces.
Examples of such virtual communities can be found at
http://www.activeworlds.com, and
http://www.blaxxun.com and http://www.colonycity.com .
<p>
As in any complex information space, users are confronted
with the problems of localization (where am I), searching (where do I
find ...)  and navigation (how do I go to ...).
To assist the user in living in this artificial life,
we propose to explore the effectiveness of multi-media based
search and navigation in this geometrical rich environment.
The approach taken is based on the construction of an index
database to be queried for solving the problems encountered.
<p>
This is feasible, because the cyberspace worlds considered 
are rich geometrical structures. This provides 
a good handle for object and scene recognition. which leads to
a semantically rich feature database.
In querying the database for advice, we can (and should)
take into account the context from which the user poses the query.
For example, asking advice on the whereabouts of another avatar,
we should ensure that the path to reach its inhabited place is not
blocked by access measures.
<p>
The problem of retrieving information in virtual worlds may
be solved by an extension and combination of the techniques
that are deployed in information retrieval for multimedia databases.
In particular, when we proceed from the assumption that
an actual world is represented in VRML (which is becoming the standard
for 3D worlds), the information retrieval problem consists
of detecting containment relations between worlds, and gathering
information about the objects in that world, which 
includes geometric shapes as well as text, image and sound objects.
<p>
This project is embedded and extends ongoing National multi-media indexing and
search projects, AMIS and DMW, which provides for the infrastructure
and modelling base. In particular, we have already developed
techniques to index sound and image objects and we provide a database
framework to manage multi-media features efficiently.
For the VRML worlds and their interrelations
we have to develop new techniques, that is new feature detectors that
have knowledge of the syntax and structural properties of 
VRML worlds.
<p>
The scientific innovation of this project lies in the challenge
to extract indexing information from a collection of complex, 
geometric multimedia objects comprising
a virtual world, and to manage this knowledge for
the visitors and inhabitants of that virtual world.
This translates into requirements on the precision, scale and 
semantic structure of the database schemas, but also on 
the primitive and computational model to answer the queries posed.

<!-- MK tot hier -->

@ Requested Support: 1 OIO for 4 years

@ Description of the Research

Our solution to the information extraction problem in virtual worlds
is primarily based on the deployment of black-box feature
detectors as developed in the AMIS project.
<p>
A black-box feature detector takes an arbitrary multimedia
object and extracts a set of features that may be used
as predicates or functions in a query.
For example, a feature detector for a sound object may deliver,
after subjecting the object to a suitable analysis, information with
respect to the composer, the melody and lyrics of that sound object.
When, to continue the example, the music object is a midi file, we need
to extract this information using a special-purpose
midi file decoder and translate the properties into
a format that allows us to store these in a database.
The actual approach taken in this respect is to represent
the musical events as Prolog facts and to employ predicates
written in Prolog to extract the properties of interest.
These properties are then fed as tokens into a standard
feature detector that puts these properties in the (feature) 
database.
<p>
For the dissection of VRML worlds we envisage a similar approach.
In particular, we need to develop a special purpose VRML
file decoder to extract basic properties.
Such properties are the
geometric objects described, the containment of other (VRML) worlds,
links to other Web-based resources and the use of text and
other multimedia items such as images and sound objects.
For text and multimedia objects, we can deploy already existing
feature detectors, as developed in the AMIS and U-AID projects.
Technology to inspect VRML files is available in the
public domain. 
<p>
Embedded logic is used for the assembly relevant properties.
This technique has been developed in recent years at the Vrije
Universiteit to significantly simplify large portions of knowledge
intense software systems.
<p>
Scientifically, we are confronted with the problem of
defining a suitable ontology 
that allows us to maintain knowledge about virtual worlds
and their geometric/topological relations.
We expect that a significant amount of the information pertaining
to a virtual world will be contextual, gathered from
clues coming from text and multimedia objects contained in
the world and clues coming from inspecting the contexts
providing access to the world. 


@ Societal Relevance
Establishments of virtual worlds is an increasingly important
facet of Internet use. They quickly mature towards 
virtual communities around special areas of interest,
ranging from chat-arenas to CSCW environments.
Many communities will use VRML as a cheap presentation vehicle for providing
access to information and communication facilities.
As with the earlier forms of information dissemination, the
navigation and orientation problem (lost in cyberspace)
will inevitably occur, for which we have a timely answer.


@ Multidisciplinary Relations

The partners 
are members of SIKS.
Apart from pure computer science the RIF project involves research 
in knowledge management for virtual worlds.

@ Embedding in Current Activities

<ul>
<li> WASP -- NWO/SION Project 1998-2000 (VU/TUE)
<li> AMIS -- NWO/SION 1997-2001
<li> U-AID -- CWI/TUE
<li> DMW : Digital Media Warehouses - Telematic Institute (1998-2002)
</ul>
<p> The OIO will work at CWI under the direct supervision of dr. Eliens.

</document>
