<document>
<h2>b. Method</h2>

For each of the aspects indicated above,
that is <i>modeling</i>, <i>realization</i>
and <i>architecture</i>, we briefly describe
the way we plan to tackle the problems involved.

<h4>Modeling the behavior of cooperative agents</h4>
Our approach will be based on the work already done in the context of 
DESIRE [_Desire,KAW95,Multiagents,Compositional]. In effect, DESIRE 
provides a compositional modeling framework
in which the cooperation between multiple components can be expressed in 
a declarative manner (with temporal semantics
[_KAW96,JELIA94,ECAI94,META94]). In particular, DESIRE has been
employed for describing cooperative multi-agent systems for project
coordination, negotiation and monitoring processes
[_Modeling,ModelAge96,ModelAge97,ATAL96,ICMAS96,Cooperation].
Research in this area
will be focussed on defining cooperation in information-retrieval tasks
and on expressing user-preferences and information-needs in an adequate
way. Other topics of interest include modeling users as agents and the
verification of agent specifications.

<h4>Realizing Web-aware agents</h4>
The development of Web-aware applications
has been addressed in the DejaVu project [_Applications,Music].
The approach taken in this project was to employ
object-oriented design technology
to realize a component-based approach
to the integration of multimedia in 
Web-based hypermedia applications.
The development of generic components
for realizing agent-based systems will
be addressed in the same fashion,
in order to allow for the integration
of adequate multimedia and graphical
user interface support.
<p>
It is our intention to employ the distributed
logic programming language DLP [_DLP] as a high-level
vehicle for programming the behavior of agents.
We strive on the one hand for a close integration
of the DESIRE framework and DLP and on the
other hand to extend DLP with the primitives needed
to access the Web and to create adequate graphical
and multimedia user interfaces.

<h4>Architectural support</h4>
To support cooperating agents over a network
we need to provide
point-to-point communication as well
as event-based notification.
We intend to use the Orbix/CORBA Object Request Broker
as an object-level mediator for the communication between agents
and the communication of agents with Web server and client
applications.
<p>
Currently, we are actively employing Orbix/CORBA
to develop an workbench for groupware task analysis and
a distributed architecture for visualisation (DIVA).
<p>
To allow for managing the information retrieval and management tasks involved
in dealing with the Web, helper applications must be developed which
employ the native HTTP protocol of the Web, and which perform automatic
Web navigation. Such tools are often called robots or spiders.
An information retrieval tool [_Bra,Fish,Search] has been developed at the
TUE. Two implementations of this tool exist: one which is integrated in
a WWW browser, and one which is a CGI-script for use on servers.
The latter implementation now exists in a multi-threaded version,
using multiple search-agents operating in parallel. Current Web developments
make it possible to integrate such agents into browsers in a flexible way
by means of applets or plug-ins. For server-based applications servlets
or server plug-ins can be used to avoid the overhead generated by the
CGI protocol and by invoking individual instantiations of CGI-scripts.
<p>
A method for improving the use of the internal structure of documents has been
defined and implemented by means of object-oriented databases.
An intelligent retrieval helper application needs to be aware of the internal
structure of documents, and needs to be able to store the information it
finds using a similar structure. Also, it needs to have direct access to the
links between documents; this information is embedded within the text of the
documents. A Web-server based on the object-oriented database Ode has been
developed for this purpose [_OODB]

<h4>Pamela</h4>
First of all, it must be remarked that the target
system <i>Pamela</i> is explicitly intended to stimulate and
regulate the cooperation between the participating
research groups.
<p>
With respect to its functionality,
the final version of <i>Pamela</i> should include
<ul>
<li> autonomous and on-demand search capabilities
<li> (user- and system) modifiable user preferences, and
<li> (multimedia) presentation facilities
</ul>
A more detailed specification of its functionality, however,
must be considered as one of the tasks of the project.

<h4>Discussion</h4>
With respect to technology, the realization of WASP
(and in particular Pamela) is based on the programming
language DLP (extended with Internet capability),
and the facilities provided by the <i>hush</i> library
and its extensions (both developed by SE/VU,
see refs [17,19,20]).
<p>
In addition, at the level of design, we exploit
DESIRE (developed by AI/VU, see refs [1,2,16,22] of the proposal).
In effect, the integration these technologies (DESIRE and DLP)
contributes to the originality of our approach.
<p>
From an architectural point of view our approach
is basically a client-server architecture, with <i>agents</i>
as user-dedicated clients.
For the communication and Internet capabilities
we exploit existing technology (TCP/IP, HTTP, CORBA).
<p>
Needless to say, we wish to maintain
a close integration between the efforts involved
in the research concerning the aspects mentioned.
In particular, we intend to develop a prototype agent
application <i>Pamela</i> (Personal Assistent for Managing
Electronic Archives) as a point of reference
and as a means of coordinating the research done
by the parties involved.
In addition, the Pamela application will serve as means
to demonstrate the power of our approach to the scientific
community and the rest of the world.
</document>
