<document>
<h1>12. Project implementation</h1>

Participants of the project are
<ul>
<li> SE/VU -- Software Engineering (VU) 
<li> AI/VU -- Artificial Intelligence (VU)
<li> IS/TUE -- Information Systems (TUE)
</ul>
Since there are three groups involved, it is important to have a
well-defined organizational structure and a clear division
of responsibilities.
<h4>Organization</h4>
For the duration of the project, Prof. Dr. J. Treur (AI/VU)
will act as the Scientific Director, with as a principal 
responsibility the supervision and coordination of the
activities from a scientific perspective.
Dr. A. Eliens (VU/SE) will have the role of Coordinator
or Managing Director, and take care of organizational matters such as
periodic meetings and the distribution of software. 
He will also be the principal coordinator for the development of
Pamela.
The OIOs will further be supervised by the leaders
of the respective sections that participate in the project,
which will also be the first supervisers of the OIO's thesis.
All participants will be a member of the Scientific Board,
that will monitor scientific progress by periodic meetings.

<h2>a. Activities</h2>

The first year of the project we plan to have
two OIO's working on a number of the technical issues
concerning the software architecture needed
for realizing Web-aware agents for assisting a Web user
in finding and maintaining information.
One OIO, working in the SE/VU group, will concentrate on the
agent and communication techniques, while another OIO, working
in the IS/TUE group, will concentrate on the information
retrieval and discovery aspects.
In the second year and third year, we plan to have
a post-doc stationed at the AI/VU group to coordinate the two
OIO's and to work on the modeling and
foundational issues involved in realizing
the behavior of agents and intelligent information retrieval.
The remainder of the time, after the end of the post-doc's contract,
is devoted to publications and writing and defending the doctoral
theses.
The activities planned over four years, as divided
between the participating groups, are summarized below.


<h4>SE/VU</h4>

Year 1:
<ul>
<li> The extension of DLP to an agent-based programming language
<li> The definition of high-level components
for developing Web-aware applications
</ul>

Year 2:
<ul>
<li> The definition of user interface components for managing agents
<li> The realization of a distributed object architecture for
agents using CORBA
</ul>

Year 3:
<ul>
<li> A framework for developing distributed agent applications
</ul>

Year 4:
<ul>
<li> Completion of Pamela, publications and thesis
</ul>


<h4>AI/VU</h4>
<br>
Year 2 and 3:
<ul>
<li> A modeling framework for cooperative agents
<li> Logical foundations of agent behavior
<li> The development of task- or application-specific
generic agent models
<li> Verification and validation of agent specifications
</ul>


<h4>IS/TUE</h4>

Year 1:
<ul>
<li> Study of information retrieval and (automatic) navigation tools
<li> Definition of suitable data structures for storing found information
<li> Development of a translation of user preferences into retrieval commands
</ul>
 
Year 2:
<ul>
<li> Development of tools for agent-based information management
<li> Optimization of search strategies for agent-based retrieval engines
</ul>
 
Year 3:
<ul>
<li> Definition of an object-oriented data structure (and database) for
retrieved information and for user preferences
<li> Development of search tools for extracting information from the database
<li> Development of a communication protocol for combining the knowledge
acquired by different agents.
</ul>
 
Year 4:
<ul>
<li> Completion of Pamela, publications and thesis
</ul>


<h4>Joint work on</h4>

<ul>
<li> A methodology for developing agent-based systems
<li> Pamela - a generic agent-based application
</ul>

<h4>Pamela</h4>
In the design and development of <i>Pamela</i>
the following phases can be distinguished:
  <ol>
  <li> Functional Design (Year 1..2)
  <li> Prototype Realization (Year 2)
  <li> Evaluation  (Year 2..3)
  <li> Final Design and Realization (Year 3..4)
  </ol>
We will specify the functional design
in DESIRE.
Also in the first year, work will be done on
components for the realization of the prototype,
in particular for retrieval capability, Internet access,
and presentation facilities.
The evaluation of the prototype realization
will be done in cooperation with the ASZ-GAK group
and Rabofacet.
<p>
Apart from the supervision by the Scientific Director and
the Scientific Board, the post-doc will be be actively involved in
guiding and coordinating the joint work, which has as a target
the development of Pamela.

<h2>b. Personell</h2>

Funding is requested for two OIO's for four years,
who will be placed at the SE/VU group and the IS/TUE group,
and one post-doc (for two years)
who will be placed in the
the Artificial Intelligence section of the VU (AI/VU).
<p>
The main candidate for the postdoc position in the project is J.
Engelfriet. He is an excellent AIO researcher with both formal and
applied interests and capabilities. His Ph.D. Thesis will be finished
within one and a half year and he is highly
interested in participating in this project.


<so structure finances output>

<h2>f. Collaboration</h2>
The combined expertiese of the groups involved
allows us to cover the modeling aspects, the realization aspects
and the issues of information retrieval in an adequate way.
Being organized in SIKS the groups already know eachother
and have frequent contacts, although has not resulted
in any formal cooperation thus far.
How the collaboration will be organised has been outlined above.

</document>
