<document>
<h4>Web Agent Support Program</h4>

The project concerns the development
of Web Agent Support to enable average users
to keep track of relevant information on the Web.
<p>
In a relatively short time, the Web has become
a de facto standard for the dissemination
and retrieval of information.
Due to the exponential growth of the Web
and the information that it provides,
finding relevant information has become more and more
difficult.
In particular, browsing is in most cases no longer
appropriate for the user who is searching
for particular pieces of information.
<p>
It is our view that, in the near future,
access to the Web will increasingly be mediated
by intelligent helper applications,
<i>software agents</i>,
that assist the user in finding relevant
and  interesting information.
The goal of our project <i>WASP</i> is to provide support
for developing such agents.
<p>
By combining our joint expertise,
we plan to develop a framework that encompasses
modeling aspects as well as the realization of
software assistants for intelligent Web access.
As testified by the references, our expertise
covers
<ul>
<li> the realization of Web-aware applications,
<li> client- and server-side support
for information retrieval and information
maintenance, and
<li> modeling and specification of cooperative agents in
a multi-agent framework.
</ul>
Combining our experience and the technology that resulted
from our previous research activities
enables us to develop a practical framework for
designing and implementing
intelligent Web agents and to tackle the research
issues involved in the definition and realization
of personal software assistents that help
the average user to disentangle the complexities of the Web.
<p>
The project is envisaged to result in a framework
providing support for:
<ul>
<li> intelligent navigation and information retrieval,
<li> information and document maintenance,
<li> user interfaces for Web-aware applications,
<li> dynamic documents with user-defined applets,
<li> declarative descriptions of agent-behavior based
on user-preferences,
<li> declarative modeling of coordinated and cooperative
behavior of software agents, and
<li> programming single and multi-agent systems.
</ul>
As an target product for the WASP project, which allows
us to demonstrate our results to the scientific community
and other interested parties, we envisage to develop
<b>Pamela</b> (<i>Personal Assistant for Maintaining
Electronic Archives</i>),
an application combining the functional and
architectural features mentioned above.
</document>
