<h2>a. Scientific Problem</h2>

The notion of <i>agents</i> has become a powerful metaphor
for designating autonomous intelligent processes
that aid the user in managing the complexity
of a variety of tasks, including information retrieval,
activity scheduling and process monitoring.
<p>
Our project aims at providing insight in and solutions
for 
<ul>
<li> modeling the behavior of cooperating agents
<li> generic means for realizing actual agents in a Web-aware context
<li> architectural support for programming agent-based systems
</ul>
In effect, <i>agents</i> have been characterized
as the dominant human-computer interface of the future [_Negro].
The aspects of our research as indicated above 
address the problems involved in defining and realizing
the potential of the <i>agent</i> metaphor as a
human-computer interface in the distributed information
system domain, in particular the Web.


<h4>Modeling agent behavior</h4>
The ability to model the behavior of solipsistic
and cooperative agents is a prerequisite for
(a) managing the complexity of defining agent behavior,
and (b) for adapting the behavior of agents to
user preferences or circumstantial conditions.

<h4>Realizing agents</h4>
We choose for aiming our project at realizing
agents in a Web-aware context
(a) because the Web provides a rich reservoir
of information,
and (b) the Web offers a suitable infrastructure
for defining an actual graphical user interface
for employing agents.
In particular, agents may be integrated with
standard means for accessing the Web by means 
of applets.
Further we wish to supply a language that allows
us to program the behavior of agents in a straightforward
way, adequate with respect to the models described
at a more abstract level.

<h4>Architectural support</h4>
The architectural requirements for realizing agents
in a Web-aware context consists of
(a) high-level support for distribution
to allow for notification and the communication between
agents,
(b) access to the Web both in terms
of server-side and client-side computation,
and (c) support for information retrieval and 
data management.

<h4>Discussion</h4>
Currently agents are in the focus of interest
of numerous research groups
[_Internet,Softbots,Software,Architecture,Survey].
However, one may observe a divergence between
purely formal approaches and purely pragmatical
approaches, that provide an operational realization
of agents lacking a solid foundation.
<p>
Although many of the ideas and concepts
underlying agents have been a topic of
research for decades, notably issues
concerning distributed systems and
programming language design, the notion of agents
itself hase become a major research topic
only recently.
A survey of agent theories, architectures
and languages is given in [_Survey].
As concerns agent theories, the main focus of
attention lies on a logical analysis
of intentional notions underlying the behavior
of single agents, whereas for agent architectures
issues of communication and cooperation between agents
have been addressed in more detail.
In [_Survey], concurrent logic programming languages
are considered to be the ancestors of agent languages.
Of immediate relevance for our own work is the
Oasis programming language described in [_Oasis],
which bears a close resemblance to the
distributed logic programming language DLP [_DLP].
<p>
Recently, commercial agent systems have been developed for the Web.
For example, General Magic has launched its
Telescript Agent System, a system that employs
mobile agents defined in General Magic's Telescript language.
Also in [_Internet], a number of agent-like programs
are described.
We are reluctant to qualify these systems as 'agents',
however, since they are defined in a purely operational way.
We find, for complex agents anyway, a more explicit
representation of the intentional aspects desirable.
<p>
In a recent issue of the CACM( 37(7), July 1994),
some current trends and applications of agent research
are presented.
From our perspective we consider as important representatives
of ongoing research:
[_Software],
that describes the agent communication language
KQML (Knowledge Query and Manipulation Language);
[_Architecture], which describes the complexity of of integrating
collections of agents;
and [_Softbots], which describes a number of simple agents
for facilitating access to the Web.
