<document>

@* Tender <a href=dish.txt>DISH</a>

<control><hr>
<a href=tender.ps>Postscript</a>
<hr></control>

@ Title

WASP - Web Agent Support Program

@ Authors

Dr. A. Eliens (Vrije Universiteit, Amsterdam, SE);
Prof Dr P. De Bra (Technische Universiteit Eindhoven, IS);
Prof dr J. Treur  (Vrije Universiteit, Amsterdam, AI);
Dr F. Brazier (Vrije Universiteit, Amsterdam, AI).

@ Requested: 2 OIOs and 1 PD

@ Goal

The project concerns the development
of Web Agent Support to enable average users
to keep track of relevant information on the Web.
<p>
It is our view that, in the near future,
access to the Web will increasingly be mediated
by intelligent helper applications,
<i>software agents</i>,
that assist the user in finding relevant
and  interesting information.
The goal of our project <i>WASP</i> is to provide support
for developing such agents.
<p>
By combining our joint expertise,
we plan to develop a framework that encompasses
modeling aspects as well as the realization of
software assistants for intelligent Web access.
Our expertise covers
the realization of Web-aware applications (SE/VU),
client- and server-side support
for information retrieval and information
maintenance (IS/TUE), and
modeling and specification of cooperative agents in
a multi-agent framework(AI/VU).
<p>
The project is envisaged to result in a framework
providing support for:
<ul>
<li> intelligent navigation and information retrieval,
<li> information and document maintenance,
<li> user interfaces for Web-aware applications,
<li> dynamic documents with user-defined applets,
<li> declarative descriptions of agent-behavior based
on user-preferences,
<li> declarative modeling of coordinated and cooperative
behavior of software agents, and
<li> programming single and multi-agent systems.
</ul>
<p>
As a reference target product for the WASP project we plan to develop
<b>Pamela</b> (<i>Personal Assistant for Maintaining
Electronic Archives</i>),
an application combining the features mentioned above.

@ Classification

Agents, Information Retrieval, Intelligent User Interfaces

@ Sketch

Our project aims at providing insight in and solutions
for: 
<dl>
<dt> <em>Modeling the behavior of cooperative agents</em>
<dd>
Research in this area will be focussed on
defining cooperation in information-retrieval tasks
and on expressing user-preferences and information-needs
Other topics of interest include modeling users as agents
and the verification of agent specifications.
(This will draw on the expertise in AI/VU),
 
<dt> <em>Realizing Web-aware agents</em>
<dd>
The project will employ
object-oriented design technology
for realizing a component-based approach
to integrating multimedia in Web-based applications.
(This will draw on the expertise in SE/VU).

<dt> <em>Architectural support</em>
<dd>
We will develop agent-programming support
by extending the distributed
logic programming language DLP in a suitable way (SE/VU).
We strive for a close integration between DLP
and the modelling language DESIRE.
To allow for managing the information retrieval and management tasks
involved in dealing with the Web,
helper applications must be developed which
employ the native HTTP protocol of the Web. 
(This will draw on the expertise of IS/TUE in collaboration with
SE/VU).
</dl>

@ Societal Relevance

Intelligent agents seem to become the dominant
user interface metaphor for the average user
of information systems in general,
and Web-based applications in particular.
Our project aims at satisfying the conditions
for developing agent-based Web-aware applications,
which allow the average user to concentrate
on the task at hand rather than the tools
and mechanisms needed to access information.

@ Multidisciplinary Relations

The partners (SE/VU, IS/TUE, AI/VU)
are members of SIKS.
Apart from pure computer science the WASP project involves research in
human-computer interaction, in which a lot of expertise is available
at the IPO institute at the TUE.
There is also a clear relation to the field of
Library and Information Sciences (De Bra). 

@ Embedding in Current Activities

<ul>
<li> SE/VU -- DejaVu OOP/Hypermedia Project
<li> IS/TUE -- Information Retrieval, Web Access Agents
<li> AI/VU --  Modelling of Cooperative Agents, DESIRE
</ul>

@ Contact
Dr. A. Eliens,
Fac. Wisk en Inf,
De Boelelaan 1081,
081 HV Amsterdam.
Email: <tt>eliens@cs.vu.nl</tt>


</document>
