<document>
<h1> Challenges in OO</h1>
<slide color=gold id=announce caption="Challenges in OO">
<center>
<a href=@slide-slogan-title.html><image name=title></a>
</center>
</slide>

<slide color=yellow id=abstract mode=hide>
:@ Challenges in OO
<h5 align=right> <a href=mailto:eliens@cs.vu.nl><i><red>Anton Eliens  VU/CWI</red></i></a></h5>
<p>
In this talk we will look at the motivations
and rationale of OO and why OO has failed
to realize its original promises with respect to reuse
and maintenance.
</slide>
<slide color=yellow id=abstract-1 mode=hide>
<p>
Facing the challenges of the current Web-driven frenzy
of software construction, we will discuss how classical
notions of OO may be integrated with the new component-oriented
technologies.
</slide>
<slide color=yellow id=abstract-2 mode=hide>
<p>
Centering around the notions of software architecture
and frameworks, we will delineate the
research issues for the next century, as another attempt
at taming the forces underlying the ever present software crisis.
<hr>
Based on <a href=@online/oo/chapter.html><red>Principles of OO Software Development</red></a> (2nd edn soon to appear, Addison-Wesley, 2000)
<br>
Online at: <a href=contents.html>http://www.cs.vu.nl/~eliens/online/talks/ipa99/lecture.html
</slide>

:@ Introduction


<slide color=gold id=intro-fig cap="Guess ...">
<a href=@online/oo/chapter.html>
<image src=local/wiel.gif>
</a>
</slide>



<slide style=gold id=ctx cap="Contents">
<h5 align=right><gold>Challenges in OO</gold></h5>
<ul>

<li> <a href=intro.html>Introduction</a> 
<li> <a href=trends.html>Trends and Technologies</a>
<li> <a href=components.html>Objects versus Components</a>
<li> <a href=architecture.html>The notion of Software Architecture</a>
<li> <a href=issues.html>Research Issues</a>
<li> <a href=conclusions.html>Conclusions</a>
</ul>
<hr>
<a href=contents.html><gold>http://www.cs.vu.nl/~eliens/online/talks/ipa99</gold>
<p>
<a href=@online/oo/chapter.html><blue>Principles of OO Software Development</a></blue>
</slide>

<slide color=red id=question-oo cap="What is the Question?">
<table>
<tr> <td>If</td> </tr>
<tr> <td></td><td><b>OO</b></td> </tr>
<tr> <td></td><td></td><td>is the Answer,</td>
<tr> <td>What is</td> </tr>
<tr> <td></td><td></td><td>the Question?</td>
</table>
<h5 align=right>See <a href=@online/oo/I/1/themes.html>Ch 1: Themes and Variations</a></h5>
</slide>


<slide id=trends-1 color=blue cap="Trends and Technologies">
:@ Trends <em>-- modeling</em>
<ul>
<li> <em>patterns</em> -- examples of design
<li> UML -- Unified Modeling Language
</ul>
</slide>
<slide id=trends-2 color=blue cap="Trends and Technologies">
:@ Technologies <em>-- components</em>
<ul>
<li> Web -- global infrastructure
<li> CORBA/DCOM - the software bus
<li> Java -- the platform?
</ul>
</slide>
<slide id=trends-3 color=blue cap="Trends and Technologies">
:@ Challenges
*- Applications $ -> $ Frameworks $ <- $ Patterns

<h5 align=right>See <a href=@online/lectures/oo/overview/@slide-technology.html>Overview</a></red></h5>
</slide>


<slide id=challenge-1 color=red cap="Challenges">
:@ Challenges in O-O
<ul>
<li> vertical framework development -- finance, medical care, insurance
<li> separation of <blue>business</blue> 'logic' from 'control'

</ul>
</slide>
<slide id=challenge-2 color=red cap="Challenges">
<ul>
<li> distributed object technology
<li> visualisation  --  structure and processes
<li> knowledge intensive applications
<li> heterogeneous systems -- fragmented 

</ul>

<h5 align=right>See <a href=@online/lectures/oo/practicum/contents.html>Practicum OO</a></h5>
</slide>

<slide color=blue id=question-components cap="What is the Answer?">
<table>
<tr> <td>If</td> </tr>
<tr> <td></td><td><b>Components</b></td> </tr>
<tr> <td></td><td></td><td>is the Question,</td>
<tr> <td>What is</td> </tr>
<tr> <td></td><td></td><td>the Answer?</td>
</table>
<h5 align=right>See <a href=@online/oo/I/1/trends.html>Ch 1: Beyond Object-Orientation?</a></h5>
</slide>

@* Trends and technologies

<slide color=gold id=trends-fig cap="Guess ...">
<a href=@slide-slogan-trends.html>
<image src=local/themes.gif>
</a>
</slide>


<slide color=blue id=abstraction cap="Object-Orientation: The power of abstraction">
<p><red>Object-Orientation:</red>
<center>
<h1>The Power of Abstraction</h1> 
</center>
<h5 align=right><a href=@online/lectures/oo/overview/project.html>Project Failures</a></h5>
</slide>

<slide color=yellow id="themes-1" caption="Themes and Variations">
:@ Themes and Variations
<ul>
<li> abstraction -- <em>the object metaphor</em>
<li> modeling  -- <em>structure and behavior</em>
</ul>
/// <a href=@online/oo/II/5/paradigm.html><font color=red>The heritage of Simula</font></a>
</slide>
<slide color=yellow id="themes-2" caption="Themes and Variations">
<ul>
<li> architecture -- <em>mastering complexity</em>
<li> frameworks -- <em>patterns for problem solving</em>
<li> components -- <em>scalable software</em>
</ul>

/// See <a href=@online/oo/I/1/@slide-1-speak.html><font color=blue>Object Speak</font></a> and <a href=@online/oo/I/1/@slide-1-features.html><font color=blue>Features of OOP</font></a>

</slide>


<slide color=red id=survive cap="How to survive the Web revolution?">
<center>
<h1>
How to survive the Web revolution?
</h1>
</center>
<h5 align=right> <a href=@online/talks/siks96/contents.html>Beyond Object-Orientation?:</a>
<a href=@online/talks/siks96/@slide-6.html>6</a>
<a href=@online/talks/siks96/@slide-7.html>7</a>
<a href=@online/talks/siks96/@slide-8.html>8</a>
</h5>
</slide>

<slide id=object-web cap="The Object Web">
<image name=@figures/web/orb>
<h5 align=right><a href=@online/oo/IV/12/objects-trends.html>The Object Web</a></h5>
</slide>

<slide color=green id=web-applications caption="Recurring questions">
@ Recurring questions 
<h5 align=right>Web Applications</h5>
<ul>
<li> What is the economic model?
<li> Does it scale?
<li> Can you maintain the stuff?
<li> Is there an <i>installed base</i>?
</ul>
<h5 align=right><a href=@online/courses/web/contents.html>Web Applications</a></h5>
</slide>




@* Objects versus Components


<slide color=gold id=components-fig cap="...">
<a href=@slide-slogan-components.html>
<image src=local/sf.gif>
</a>
</slide>


<slide id=component-definition cap="Definitions">
:@ Component
<h5 align=right> <red>substitutability</red></h5>
<ul>
<li> unit of independent deployment
<li> unit of third party composition
<li> no persistent state
</ul>
</slide>


<slide id=object-definition cap="Definitions">
:@ Object
<h5 align=right><red>identity</red></h5>
<ul>
<li> unit of instantiation
<li> (persistent) state
<li> encapsulation of state and behavior
</ul>
<h5 align=right><a href=@online/oo/II/6/issues-definitions.html>Definitions</a></h5>
</slide>

<slide id=propose cap="Off-the-shelf ...">
<h2>
[_Szyperski97]:



<em>component-oriented</em> approach,
to deliver reusable <em>"off-the-shelf"</em> components
for a composing large applications.
</h2>
<h5 align=right><a href=@online/oo/I/1/trends.html>Beyond Object-Orientation?</a></h5>
</slide>

<slide color=yellow id=c-def cap="Definition">
<c><p></c>
<quote><em>
A software component is a unit of composition
with contractually specified interfaces and
explicit context dependencies only.
A software component can be deployed independently
and is subject to composition by third parties.
</em></quote><c><p></c>
<h5 align=right><a href=@online/oo/II/6/issues-myths.html>Component Myths</a></h5>
</slide>

<slide color=gold cap="Component Questions">
<ul>
<li> How to describe the interaction between components?
<li> How to manage variety and flexibility?
<li> How to guarantee critical system-wide properties?
</ul>
<h5 align=right><a href=@online/oo/II/6/components.html>Component Questions</a></h5>
</slide>


<slide color=green type=fig id=technology-matrix cap="The technology matrix">
<table><!--{|l|c|c|c|c|c|c|}-->
<tr><td></td>
<td>distribution</td>
<td>mobility</td>
<td>language</td>
<td>platform</td>

</tr>
<tr><td>COM</td>
<td>-</td>
<td>-</td>
<td>*</td>
<td>-</td>

</tr>
<tr><td>DCOM</td>
<td>+</td>
<td>-</td>
<td>*</td>
<td>+/-</td>

</tr>
<tr><td>CORBA</td>
<td>+</td>
<td>-</td>
<td>*</td>
<td>*</td>

</tr>
<tr><td>Java/Beans</td>
<td>-</td>
<td>classes</td>
<td>Java</td>
<td>*</td>

</tr>






</tr>
<tr><td>Voyager</td>
<td>+</td>
<td>objects</td>
<td>Java</td>
<td>*</td>

</tr>
</table>
<h5 align=right><a href=@online/oo/II/6/issues-technology.html>The technology matrix</a></h5>
</slide>

<slide color=blue id=war cap="The Component War">
<center>
<h1>
The Component War is as yet undecided!
</h1>
</center>
<pre>


</pre>

/// <a href=@online/oo/II/6/java.html><font color=red>The Java Platform?</red></a>
</slide>


@* The notion of Software Architecture


<slide color=gold id=architecture-fig cap="Guess ...">
<a href=@slide-slogan-architect.html>
<image src=local/patterns.gif>
</a>
</slide>


<slide color=yellow id=Elements-1 cap="Elements of Architecture -- models and views">
:@ Elements of Architecture 
<h5 align=right> [_Wolf]</h5>
<ul>
<li> processing elements -- data transformations
<li> data elements -- contain information
<li> connections -- glueing elements together
</ul>
</slide>

<slide color=yellow id=Elements-2 cap="Elements of Architecture -- models and views">
:@ Models and Views

<ul>
<li> logical -- functional requirements
<li> process -- performance, availability, ...
<li> physical -- scalability, configuration
<li> development -- organization of software
<li> scenarios -- instances of use cases
</ul>




<h5 align=right><a href=@online/oo/II/7/architecture.html>Elements of Architecture</a></h5>
</slide>

<slide id=arch-notion cap="Our building metaphor is wrong!">
<h4> <red>Our <blue>building</blue> metaphor is wrong!</red> </h4>
<p>
Architectural decisions must strive for an ecology of change,
that is a flexible arrangement of components
to promote changes in business-logic and adaptiveness to
a changing environment.
<h5 align=right><a href=@online/oo/IV/12/architecture.html>Software Architecture Revisited</a></h5>
</slide>

<slide color=green id=styles cap="Architectural software styles">
:@ Architectural software styles

<ul>
<li> <em>component types</em> -- process, event, ...
<li> <em>runtime relations</em> -- topology
<li> <em>semantic constraints</em> -- immutability
<li> <em>communication, coordination</em> -- connectors
</ul>
<h5 align=right><a href=@online/oo/II/7/7.html>Software Architecture</a></h5>
</slide>

<slide color=yellow id=arch-themes cap="Themes and variations">
:@ Themes and variations

<ul>
<li> OO -- simple call and return
<li> CORBA -- independent components
<li> WWW -- data centered
<li> events -- independent components
<li> logic -- virtual machine architecture
</ul>
<h5 align=right><a href=@online/oo/I/1/trends.html>Beyond Object-Orientation?</a></h5>
</slide>

<slide  id=web-architecture cap="Architectural issues">
<h4> <red>Architectural issues for the Web</red></h4>
<ul>
<li> <blue>managing growth, maintaining installed base</blue>
<li> <blue>enhanced functionality -- <em>multimedia</em></blue>
<li> <blue>improved infrastructure -- <em>HTTP-NG</em></blue>
</ul>
<h5 align=right><a href=@online/courses/web/1.html>Application Infrastructure</a></h5>
</slide>


@* Research Issues

<slide color=gold id=issues-fig cap="Guess ...">
<a href=@slide-slogan-pattern.html>
<image src=local/bullet.gif>
</a>
</slide>


<slide color=blue id=better cap="Are components better objects?">
<h1>Are Components <i>better</i> Objects?</h1>
<h5 align=right><a href=@online/oo/II/6/6.html>Component Technology</a></h5>
</slide>

<slide id=respons-1 caption="Responsibilities in OOP">
:@ Responsibilities
<ul>
<li> <em> to specify behavior</em> /// <box><b>what</b> rather than <b>how</b></box>
</ul>
</slide>

<slide id=respons-2 caption="Responsibilities in OOP">

:@ Client
<ul>
<li> makes request to perform a service
</ul>
:@ Server
<ul>
<li> provides service upon request
</ul>
<h5 align=right><a href=@online/oo/I/1/contracts.html>Client/Server Model</a></h5>
</slide>

<slide id=1-contracts caption="Contracts and behavioral refinement">

:@ Contracts
*- a set of services
<p>
{\bf Behavioral refinement}
*- improving contracts
<h5 align=right><a href=@online/oo/I/3/contracts.html>Contracts</a></h5>
</slide>


<slide id=1-conformance caption="Behavioral refinement">
<h4><blue> Conformance</blue></h4>

<center>
<p>
if B refines A
then
   B may be used
   wherever A is allowed
</center>

/// <a href=@online/oo/III/10/10.html><font color=red>Behavioral Refinement</font></a>

</slide>

<slide id=properties-1 cap="Subtyping and behavior">
@ Subtype <em> -- signature and behavior</em>
<I>- preservation of behavioral properties
</slide>
<slide id=properties-2 cap="Subtyping and behavior">
@ Behavioral properties
<I
- invariant properties {\em -- true of all states}
- history properties {\em -- all execution sequences}
I>
<h5 align=right><a href=@online/oo/III/10/types.html>Types as Behavior</a></h5>
</slide>


<slide id=10-history cap="History properties -- example">
:@ Example <em> -- IntSet \not<= FatSet</em>
<I
- $FatSet$ -- {\em insert, select, size}
- $IntSet$ -- {\em insert, delete, select, size}
I>
</slide>
<slide id=10-history-2 cap="History properties -- example">
@ History <em> -- not satisfied by IntSet</em>
<img src=fatset.gif height=200 width=800>
<h5 align=right><a href=@online/oo/III/10/subtyping.html>Objects as Behavioral Types</a></h5>
</slide>

<slide color=blue id=research-1 cap="Research Challenges">
:@ From Metaphor to Calculus
<ul>
<li> <em>a strong object is a weak agent</em>
</ul>
<h5 align=right><a href=@online/oo/IV/12/web-agents.html>Agents for the Web</a></h5>
</slide>
<slide color=blue id=research-2 cap="Research Challenges">
:@ Case Study: Verifiable (Component) Software
<ul>
<li> e.g. CMG Test Frame -- UML Use cases -> Test Action Words
</ul>
<h5 align=right><a href=@online/oo/I/3/formal.html>Towards a formal approach</a></h5>
</slide>


@* Conclusions


<slide color=gold id=book-fig cap="Guess ...">
<a href=@slide-slogan-bullet.html>
<image src=local/book.gif>
</a>
</slide>


<slide color=yellow id=brave cap="It is a brave architect ...">
<c><p></c>
<quote><em>
It is a brave architect who, in today's environment,
does not develop, or at least consider,
an object-oriented design.</em>
<p align=right>[_Practice] p. 10
</quote>
<c><p></c>
<h5 align=right><a href=@online/oo/IV/12/architecture.html>Software Architecture Revisited</h5>
</slide>


<slide mode=hide color=blue id=poosd-1 cap="Back to the Principles">
<p>
<a href=@online/oo/IV/12/architecture.html>...</a>, ignoring details,
plugin architectures indicate what may become
the dominant paradigm of the future,
</slide>

<slide mode=hide color=blue id=poosd-2 cap="Back to the Principles">
<p>
framework-like environments that are extensible by components
following a clearly defined pattern or protocol.
</slide>


<slide mode=hide color=blue id=poosd-3 cap="Back to the Principles">
<p>
That is to say, components created according
to the <a href=@slide-post.html><red>Principles of Object-Oriented Software Development</red></a>.
</slide>

<slide color=red id=post caption="Challenges in OO">
<center>
<a href=@online/oo/chapter.html><image name=title></a>
</center>
</slide>

</document>
