# TCL based java cup animator
# inline image version

set T1_data {
    R0lGODlhQgBkAPUAANbWxs7Wxs7OxsbOxsbGxsbGvb3Gvca9vcDAwL21vbW1vbW1tbWtta2t
    ta2ltaWltaWlraWctaWcrZycrZyUrZSUrZSMrZSMpYyMrYyMpYyEpYSEpYR7pYR7nHp7pYRz
    pYRynHtzpXtznHtrnHNrnHNjnGtjnGtjlGtalGNalGNSlGNSjFpSlFpKlFpKjFJKjFJCjFI5
    jEo5jEo5hEoxhEIxhDkphDkhhAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAACwAAAAAQgBkAAAG
    /kCEcEgsGo/IpHLJbDqf0Kh0Sq1ar9isdsvter/gsHhMLpvP6LR6zW673/C4fE6v2+/4vH7P
    7/v/gIGCg4SFhoeIiYqLjI2Oj5CRkpOUlZaXmJmOBZxXnAQEnKIIBUQJCguoDKkIBgWhpUev
    CA4TDwgEUpwKERUaHCIiJCQjIiEUQhwqKiwqLjDQMCwoIha3oUO5ESMuLSwtLSIMsU4Tzi4o
    JBwWFA8ODQoMCkIMq6sNDQ4UFhwlzC4qSGhgkMvCsAoM6E0oAWMCOSUFGrgQcauAgAACSqGa
    l6SAK1EaJXBA0SIDBw0KBiCg8EtEBgEWYCxoooAigFwIJGgQYQIF/goTAjk6sXhxAwwFnHRO
    mEmAwoQAIUo8lCWhRgoOElJVkJBQFCwhCRqkYlUE1QMKHEywoBCrQaeIMCgQeOCi3AkYMmRI
    S5EuxEkN7OApkGDhF4fDxoSVMAFUBAWkRxI0a+XghVAkBSqMsFCBwj4OI0igSKGCdLN0wYKd
    zGDBwUYhn6YOKUCioQECGk7INpIArQgUKkr87TyhAYIDQxQgLkYsRIcQIDjcgi2Lw8RYKaAz
    MXCgAs8UJrZGmOA5AkeQBlqRKsIpvYMQDx4S4NCCxIJSKJpFYMIgnPlSF2ygAQWuCUHAAp6x
    E4EEE5BXQQUWYLABBySoAIMLHBSBWwso/jxwIAoyzMAWEw3AEEJCt6nUwAQagCDCYcCQwJcK
    6QD3DDQxwNDCCSg9NIAGKpwwgQAOtDADDBbsdkQDIPhkwosDPgDPAg1EAME++1jTnhAKdAnb
    VAR04EIJFAhwwQs0sBDfE7cZwEAE++yU2joOtDcKE7GUcoIKH6RSmwwnQCZFKAo8cE2es7my
    HnuxKTDgAA6owEEBjoL3wqRUNDBCCnyRYMFMRSDoWYPvyBPPA738lt1KKTxgpjolrDDiFAWU
    cAMKE+CipAMRZMDTCSSUQMIJPQHLwWOcrDKBCBpokAIJgmYqQgosxIAOCS8iJEQD7HR2QbMh
    WCCEK7Ck90Cz/oAFu+YVigpTwTsLyJOcBJ6N6plxRihA3E4cOKTkFCU6FMoAA7wiygAZgURA
    ekYsEJYFGTSATRccQEMjti8eZsEFFuA7z2WkEJAAl7iEQekEhQHGzgQR4INUKLB8pYAFJaQA
    KhleKdwAByEkFswHIoxQQn4AcYBvGRosisDICCjQAIMJGnZYBsUd4JEZBIhQwgPzKFwAwggL
    IHbOQzCtxZ1NL0BlKmmhIOwwHGTg2YMUEBdtKzBfbQWlhMHoHIXBnvABBGE9UMKNMKhgQgnG
    nNQO0wVQoI4FEohFyr9GzDIYaaPxxWy0rCjKQJUMQvxBaMOgNMQChcU4DAkZ6PoV/hIUoP4i
    Z7g/YHZHIPXeyWyONgsaCi4AOoLjXP8uhAAvPpCQ2Akr38UpXW60Ij8yPkMmwwj8KAI8QWtQ
    +eXSixEb37WhcHQBERz2rdZ8leCBBcXNY3XevQ8VG/6+F5CACDYgATlmYYD27aRmLngBNADC
    GGxxQEAWUJDzqpcctc2DARN4kNRgtJxhnKAFV0kIEhYAJ34IQwUhqkENYFCCE5BmGf9wwWmA
    5UGgXAAVtfCFMIgRLMbFLQIPYFACcMI7TjQoH2eJQIs2poEMYMAp5XGAvFrBCYS9ImzQG1vT
    arGTEQhIhE7QjLA+MKDOxClGwuoJtWi0uBIUIxjDSE2wQ4iHl7ywQDjGwZws/NcAlgBjaKQJ
    JDVuoQBeUeACoFkMcFqgQL1IgxpRSsjsqHA/gy0tHvmAx2z2BxIupaJrnVxCEAAAOw==
}
    
set T2_data {
    R0lGODlhQgBkAPUAANbWxs7Wxs7OxsbOxsbGxsbGvb3Gvca9vcDAwLS9vb21vbW1vbW1tbWt
    ta2tta2ltaWltaWctaWcrZycrZyUrZSUrZSMrZSMpYyMrYyMpYyEpYSEpYx7pYR7pYR7nIRz
    pYRynHtzpXtznHtrnHNrnHNjnGtjnGtjlGtalGNalGNSlGNSjFpSlFpKlFpKjFJKjFpCjFJC
    jEpCjFI5jEo5jEo5hEoxhEIxhAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAACwAAAAAQgBkAAAG
    /kCEcEgsGo/IpHLJbDqf0Kh0Sq1ar9isdsvter/gsHhMLpvP6LR6zW673/C4fE6v2+/4vH7P
    7/v/gIGCg4SFhoeIiYqLjI2Oj5CRkpOUlZaXmIkFm1ebBlmbnAgKC6VCFBURDlKcDhMTDwui
    UQQFCA4UFhoaGRYXFhAICxUTDg1QBQYQHSQiIig0LiIUDrZNmwsWIh0aFLEIm7XWtcILDE4T
    IRoQCw8TKTQxNzYxIk4VJtITBQQID7m7NHAL1mECg24PhNgyYI1IAQsVGkQYEaOiChcxSLBo
    wULFgk9IGqC44eJcBGbNMkyAYMyUsCHWFjhg8ECVLFsLJFDQ0OJG/gsSBQs0YNFAQwwVN1Ik
    KaAhxYMQHTCSsBDLnIMIEypc6ADBlgaoIkY049YhbIkUKEYwo3Gi684TGgy0KAEt140OSRZo
    cCaChl+/NWjYuEGYcLQXLjDG8Fvxb4yfERl0CNF1HIMSJEgI0HADggAVLZQQcIBSBAkTJ1Kc
    IBFiBGoTJWKbQHEC84htGSpIWFVLmYQCB4o0qMiAQIcYDgiMoLGkgICTJCYIEMAvFMxQDENp
    5xRqujWW4DrcsGBLAgpwFF4sMbhJhAsU076B084QAUgjMrMKPF1iWzUHNJRQwAIECFSAAgaY
    oIQBFgClgW4UlNUMVB1wAxEFFEQAnhFG/lXEAgodUAUOOCe4QIQKCRUwQQzN3SKBBQ4EIAAC
    NGE4ASoYVuCLBRMgwUADsohjSwIF0vCAAQoMwIwtBaSgFBObCCBZMxpYYAEFCAi5HS0X0PAb
    ge8IQYAFNKzChAEReOBCCODUMsCMQizwkpxGZMfPfWJSQMMEBMjigAqrFCABDRU0tESCQIlA
    lQMQYBmKkHiW4kBNFGwgARFjutCVAgX8GQE/FdBA3hMPpbBTDCaMkMILJpBwG1/OkBAbCqjV
    JoI6N4HTlCzoqVBZBzRQYOg1GtCgQgwgFNPAAyw5YMyPpdAZznTUMbCTKhiMWCCgUqLQQnJT
    jBABAxNkoAIN/h8280GF3GhwQQZVBlTWCLdpMIGcMTlTwAAXuPBBfVEUEGEAtpQ1QQOMZmWl
    QB+EZVps2xTT5rArBeDAbA8MS+oEvjpQQo/2bRfOvtMFYDJ1C+yUkEO1QDACCsLiOQUFJNCQ
    ggUplODAAgoYoQADuOxF1wmKrqwQAhBoQJsFWYJSVgXuVRSDCx2hEFsJqNGqVgWrTDeANQ6I
    gNk6s3TC8XQAUBADCimowAINNcTwggqrdQPBAwm/q0EEQzzAQHVelOBCMy1kMJPLg8fbsKxs
    uxBPCiJwDdMYERgVtwstgJbCbLVlJtY2VVYAATlmFABBqyVU9IIFDMjkrDHOuqPL/oNmgqEd
    TBas4KcGJLCNwu8oqHBRDCyoBnrtMFUgLBXVLdCoBRl0UMEQFYyQQZbJKNDABLqUJcIGV0rA
    Us9HMEDCFJ1OwLsIVe5Gp0IDGjGyyBoXMcIxUCxwwmJEzVd/FwsogRHwJjMioIAEDaCACrBX
    QC8IgBv9IMICREA+hwzAAioAwCc6oAIRZCACxxhZLUaopdsBJzvyC8cFUlDBiZHgSEWAEQJK
    kC3nMMACL0MLrUrwqldZiAITiIAENMSouwkRdkCaVASqdz7qcOIBGSCBBopgiwZxgwUs6AAF
    ZDEdA7SDewJxBl1oAzwnCc9tmaPaGaW2mKToQiwHjA0H1KoBkwFoIGOm24s8bmAsoFjAfSGj
    FrUGQEgCfM0aPwJahFAgAzZirngOogY4PsEPBEwAMzDpR046gII22kAGcKPBDKYmvLaZsYxn
    dAFiMLcCt8HAIlpUxUwEMABx0KgCJBDeFI/gCXNoIDHSkwAYBUIhXuziA6dpWwtcMMrNOcw0
    JDgBbDJTEJ3wLngo+MClIticbKRGBCyRxZsESU4BkGN7GRBbChz3l3hMDXOrCVEsrIMMA0xg
    G72jzVi4cYFf+GIXpkEN1n4nvLRYaCXHMICQkBAEADs=
}
    
set T3_data {
    R0lGODlhQgBkAPUAANbWxs7Wxs7OxsbOxsbGxsbGvb3Gvca9vcDAwLS9vb21vbW1vbW1tbWt
    ta2tta2ltaWltaWctaWcrZycrZyUrZSUrZSMrZSMpYyMrYyMpYyEpYSEpYx7pYR7pYR7nIRz
    pYRynHtzpXtznHtrnHNrnHNjnGtjnGtjlGtalGNalGNSlFpSlFpKlFpKjFJKjFJCjEo5jEo5
    hEoxhEIxhEIphAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAACwAAAAAQgBkAAAG
    /kCEcEgsGo/IpHLJbDqf0Kh0Sq1ar9isdsvter/gsHhMLpvP6LR6zW673/C4fE6v2+/4vH7P
    7/v/gIGCg4SFhoeIiYqLjI2Oj5CRkpOUlZaXmJlmBgUEBQVCCwwLC0Kfp6gFBgdLn56nnlKd
    CA4VHSQoKy0rKSciHRkSFBUWxRQTExEPDg2mr0MKEBQaHSMkJB0OCKpMnQwVJCovLysoIhcR
    DhPTIiImJSUoKSjyKysq+CooJCAWEAcPRIQQscGCBhEqZMBgocLEAwNKCkA4wSJFBwoPnH0i
    kgoVxCELHEg7uI/CtgEKLHTQUAGCAwYkUqRohqRAhBYWGAwQAApa/hVOnVQ1EGmhhIoRGpJ2
    WEqCYSkkC6Y9gCBBW9CNWGZ1eGFhxIZjLksVeDBuQhIGIvxNM3oCW4V0LxVs2+bq6qkiISmI
    SFHCQay7pizQQ7FEw4gPFSSoFIGrhYtxLvKhgHdN4MoKFBpAqEDNw0AKCwR8PELgxK0TrRAw
    uGDiaIYJEB4MlYCMwjFhKjVYSBb76VNXCEwiMdDghQOcTBaYSAsBQUhhDlR1rJvqyKcJJpIQ
    MDHCAgttSxjMQ2qh6lOfCRCkLyW3JgEEE3A5GE2EAIUXGvAT7uZghooMBi11kQQLvDIdVhs5
    QEEHJbRWQU9FFMBACzC8oEIL2TUhEWMi/miAQVIGZUCMbbZVYKKJEywAQYC6SYCAAPdBxcIM
    JpDwAgtOsNKABijYshRjI8RT4wgjrPShBRREwAAETDKjDo8rWGAEKPgsOE50TUzQAn6h8TTA
    gag454AE1HQggjVFYhDBXBxB0CMCIczQwgMQLrFABix4RYED2gB1Cn1GQNTJTjzVaQoELZgk
    gn8MGNrKAhWI0MIMN6ZAQggFVQDbMqVANFpIVK1T0BE5FSACDCRQUcACRVrgwAOciVDCCfLg
    Mw8J7VjTVgcfhINCCFIeMUADKLzwYBUOVNRhBDQ5Y8pHCpAilgHRaABDC+dtQ8ACIrxQwgKO
    QgGRBY2xsCU5/iGAtmNS7JoZjwr3mBYdJ5480EELfb2XRVBCNICMbA4okMAEullAjG5gNROU
    igSXkMIHfoVbBSii0CWoRrD8WQQEHXBQQUZYbcFABykcBZ5c6YWCgFwCt2wKR58AqkUBFdDw
    QjZieaIzmAMgEAFoaECAkAu77MpuwcVkwO4H7nwrBiqvfKmiQWWemesvv6zkjwMacEHvRgw8
    8LMFFyC0DF0G6ixAAGuzzdMCEqhAwisGykKAAQp20JoKMrVlmQYF7WaEXAtq0KsJKbDwQoX0
    1NghBRA0E8ujeineAgodXACBWFc9kwTHHWyQ1FsvgSqNQYy9I0IFCk9ehAb4kOAq/toSd7Oz
    5wj4+d4EHOBirj3LgTaLKS2EIEChahi6wAQv/DJCCBeAu80DJcgOHgKerJK8AyqERosGJ1jg
    aQF87kkABBpA7gApQ2Q8HUjZdtPJAyrQgAIoBhAAAAUq0CdAV0JwgAUYYxR9zAMF7zBBAuGh
    QMeNIC0pqklQFPCAASpOBNFZQAWvkREjFKsEHWgJM1R0AQ1cSnS9okwINPCv3B3AT4BZQAMi
    MEBxxGAGM0ABgKqBKw24SGZC2MwtjCQBCKzjIB+4BQkaVDJb3YNvB0SgCWoFrxa0QAXVO4zW
    1KcAfiWhLq/gHoE6VwCe5M45C1AAn0RSRGWssRQHGJSBOapjBQtYUR/XqMxSqJGUDYROAxcw
    iAWUppsSImwZ7eECKDQztnYJyExMKQGacDWQIi0FSRHY3BOCAAA7
}
    
set T4_data {
    R0lGODlhQgBkAPcAAL3g3tbWxr3e1s7WxsbWzr3W1s7OxsbOzsbOxr3Ozr3OxsbGxsbGvb3G
    xr3Gvca9vce9tbXBxsDAwLS9vb21vb21tbW1vceurbW1tb2trbWtta2ttb2lrb2lpa2ltaWl
    taWlrZyltcaUnKWctb2UnKWcrZycrb2MnJyUrcaEjJSUrb2EjJSMrZSMpZ+Hob17jL17hIyM
    rYyMpcZze71ze4yEpc5rc8Zre4SEpcZrc4CDrb1re5F7nIx7pZx2k8Zjc4R7pa5rgsZja4R7
    nHp7pb1hcIRzpcZaa4RynMZaY3tzpXtznMZSa41nj8ZSY8ZSWm9wpXtrnM5NWnNrnMZKWr1L
    X69ObHNjnMZCWmtjnMZCUmtjlINUg8Y5UmtalMY5SmNalI5GdMYxSsYxQmNSlM4pPbowTFpS
    lKU1XXdGfsYpQs4hOVpKlMYhQlpKjMYhOVJKjM4bL5AwYl9ChH81bsYYOcYYMVJCjKkiSrgb
    PW81dEpCjEdClFc4hFI5jMYQKUo5jEo5hH8jXkoxhEIxhLoAHUIphAAAAAAAAAAAAAAAAAAA
    AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
    AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
    AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
    AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
    AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
    AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
    AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAACwAAAAAQgBkAAAI/gAlCBxIsKDBgwgTKlzIsKHD
    hxAjSpxIsaLFixgzatzIsaPHjyBDihxJsqTJkyhTqlzJsqXLlzBjypxJs6bNmzhz6tzJs6fP
    n0CDCh1KtKjRo0iTKl3KtKnTp1CjKnSQgclPBT+SJPCpYAyJBjwbcLihpkLPBjC+dAEb1omW
    tT0diNEihu1OuVXU2NXZQAwVNT0pJKjyRQ0HBzwRpIijZsXehwwiM8goGbEECxYwWBDowwee
    PEUUUIDMwIIHFCo+WIhsGeKCyR9QxKhRQwaL2x8kRAjjwkyhOmYbTh6hJMoSJVsAuZnCYsNk
    4Qw0yIgCpIaJDQIlR5ag4ImIN3ns/gR5jBCFkhoeMMQmA+gOoUF3pkh4MFUCCy9sloxgsMDC
    BxUy0AbEgLnx1kYTaOChgASTOfAcQQywgAIGJkxxxx1ugOHGHVGQwQYZZ2Cg0AZeDAKHiCYA
    McUUSLBQggcbYCZQBmY4YEYXEPxxwgQeaOCBCR6shtgGJqgAhBuEkDEFECaURsYGNexBRpIJ
    MSADGBsYgQQcgDCXHgYbfGACCizUoIMVWCTQhCBKpEHHFNTVoMQSU2RBhhdL1HBFlx4wYAIL
    W+AgwRlXeAHImIQAkRAFNRi3BCCQBhIIIIEQYqmlhvAxRx9w3NHHHnfsASql7ZGxhAmZGQFE
    n5b1l8UV/lEMUAMhIxjgoUILbIADnEgscUWhVywBhK9XTJGGHlAUqwcXRNDBRQwtoPCBiK9J
    4AEIDCD24AYXrgbEHRsssEQgCzFgwAdAZIGCAQYggEBlDyiwxgwEPHDAGzkAIIUNBLD2gIOR
    sSuQBSNgx4ARhLAwnBcMouDGQtdFdiQYS6SmgUAPECAEFfUyoEAZOQhQxA4JjHbZaWXSuUUW
    eTq3QSBTMDDBAjUAsQAFDDCckAMsRKFEDy6aUIMRSxyHhBJAyMGDCmSGgEYQBRRBw4ISOFDD
    hXCQkQUQKBjMoBcPD/Rkw3eUK4EG/20wwAJnx4ZCCFbwEAIKqLWABgoJOPGC/mgDyaidQDMD
    AYhzFiCwRBSTMXBnQ4gZoIGKed6GggQQaIfABU8s0AAVXzVEMyAflLYACjovIMPgwo2wxB2K
    LvCuwAJRMIHsHXR+RAXaSsZ2QQuoALroHpxx8QImAILCgws5kMWSS8gwwo8qCKmd5hJU8MIE
    mXkgJgtMErRAC270SQECH5zR5/fG7y4cC2CgcHWwGm6xIp2HRxHFFFdsoX8WWwQLBAurSVwN
    wLAaCSyABWRg1epQoD6HWAkQZLjDqTawAQ/ASAMx0sxmshMwdhmAARswUgk2wIKBMAAIZMCA
    ATYAhhQizyEWmIJqPoBAQJzBC8US1hAGhAPaCKgG/jgoGpzOM4LNPAcDPuNPDdwAhBc6EAVA
    GEBpgICEEmAAbSOgmwpaULNhHW5F57Eig6pFkBEOwAMrCxdFGDCCM4zgA1cogQMs8C/tRMZ1
    5jLAAAYgsBACITcQes0IpuCF4zkxIhUCBBhqQIYrBGkzGxwY2qAYhSx4YQtLaA6EKJAiL2RB
    BQyiDBXNw4Y7tAcObjgDGPjHP/0FqwZdk4AHLbMBX0VBBqFroEX8RAYE6NFhlmwhpTBEBvn1
    QAUl+MAHSuA+2pRgIDHizyEvcgU3wMoN6FHPFJZTAxXUjE5XAIOGQOUFJcQyOyP5wNUm5YYP
    3dCSnpxfFFRVAwmFbpof/mHAB7xwvwvdgQUauCIGN3DFMP2JNirAjkFMhpG/ZYcFIYpODKKw
    BS+Is4Ue6hQbVimsGigUQipQAT6nwp+2qWA2/xsICm7JoO34BwUBGlA3TfCiiyEkhhMBIRRf
    mZoNMLSlB7GjHVuDkCiIqCBENYgFvGBKMhiRAfQZCQauYJAPeCCpBOGnBUxABgNmiyQGMEIN
    dGmBJUTShAhAYAAQg8I8jZCDr4mrNIWarbpG5l8DAZgSwVAQaU7hqgWJgQckMIUaMMgAFkDB
    ErIABi94Un4riuwSgMY0E1gWSMsUkwk+QMHObg9ODHjXdtRZ2L7ax2c1OIMblJDQPE4mTDAd
    9RqdXtVKx3qBDOIEkW5xG8EL7QEQhAAD9+oEhl8V1jloXVVkPCAnJBECEGzIwhBiIK0YMciX
    HmyX6/B4RA1gEIqG8ieGznCnJclAjF+tFgq2EIW8voZg6dqQpfxgyklhyJ1kyG9+McqGdvqz
    naokw4buQAauFSxG2t0OCa9AXoUF9b0WWCITpcVMFnBxQP+zMPd8tYUWlhIOYGCvo1b02Pmh
    4E8qauEW/rgdhkyGBXaKwgipld0as+tdEsDACGRghHByCVKQupAbUskyWPpUmhGJzAiqEwXH
    9m8KSKtObVoQ00o6Nn+OFScmcRCtghnxNVBFSEAAADs=
}
    
set T5_data {
    R0lGODlhQgBkAPcAAL3g3tbWxs7WxsbWzs7OxsbOzsbOxr3Ozr3OxsbGxsbGvb3Gxr3Gvca9
    vce9tcDAwLS9vca1tb21vb21tbW1vbW1tb2ttb2trbWtta2ttb2lrb2lpa2ltcacn72cpaWl
    tZyltcaUnKWctb2UnKWcrb2UlMePkpyctZycrZOet72MlKWUpb2MjJyUrcaEjL2ElJSUrZCU
    tb2EjIyUrch8hJSMrZSMpZ+Hob17jL17hIyMrYyMpZSEpb1zhL1ze4yEpc5rc8Zre4SEpcZr
    c71re4x7pZx2k4R7pcZja4R7nM5daHp7pY1znL1hcIRzpYRynMZaY3tzpXtznMZSY8ZSWm9w
    pXtrnM5NWnNrnMZKY8ZKWplafmtrnMZKUr1LX3NjnMZCWmtjnMZCUmtjlLFEYc45S4NUg8Y5
    UmtalMY5SmNalM4xSs4yQo5GdGNSlGNSjFpSlHdGfsYpQmtJhsYpOVpKlMYhQlpKjMYhOVJK
    jJAwYsYYMVJCjKkiSm81dM4QKcYQKUo5jEo5hJMcT8YIKcYIIWsmakoxhEIxhM8ACMYAGMYA
    CEIphAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
    AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
    AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
    AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
    AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
    AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
    AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAACwAAAAAQgBkAAAI/gAfCBxIsKDBgwgTKlzIsKHD
    hxAjSpxIsaLFixgzatzIsaPHjyBDihxJsqTJkyhTqlzJsqXLlzBjypxJs6bNmzhz6tzJs6fP
    n0CDCh1KtKjRo0iTKh25AKiFIE17HtDSBIEEnghy4Im6k8GFQiO46lwgp8uBngtyFJrgcwGg
    KQeu8gSjyIPYmlERTFmU5i7NBSMuIJBRSFEOqzgvpGEr5wwhCzkXlLBzQIacJnIQRFax58CU
    KU20xMW5YAOhB2dwZCGiWSegEVk8TMGBGCeCND6ajPAhwy9NBESyZFEhg7bcmwhcnIHSREaP
    2i0ZKEigQIFAChUqQPCQxsUfGlcM/lQfz6DBwurUx1OXOP1BBhhHsKCBcweOmjBSnrRZ0afN
    IB4xtIACCiJwkAEGAk1X3UASfNDCD0dYgQUWR2TwgAIMMDRdBTBg4QYffMCBhhQ2iJABCg8+
    EQcacRiChiFzhKEGHHC4YaMbaGDxRA0fNMCBFFFIIUQNP0jhxiGB1OFGGBxkmJACH4xRhxpH
    tMBBgukNxEAEVAxhQiI0IPFHAwkQREEGDhaZYwsXGiBBDUf8AMMHGVSAhRpqIIiQAiLcUUMF
    BhBgHYMGXdBEGhKk4QUAZ4jRmpboYYgBmjV84YYVP2R6xKZYKElBQhQ8yMEHJFio4IIElSaG
    HAu8kIZV/nho8GSZR/BRgxVCCEjnpwpwACIKCVUgBY8PWjoGhTCYWOdVCHSwxxoDRFCGAgMo
    gcQA5pmZQQtSqPFFBuuNN5ACNaBh7kI/WOEEDCTAKYV8d+QBYh42vuFHHFxgEYcVS5jRRgot
    YPABDBAmEWQLFBDg5EEJjBHfGOc9UIENYVy6AwofcDApCQOeYEQfILQwQxtMxHADGRl/+oDK
    6D3AJkIMYMBHBn4yRAF+PK6cAQktZIChAg0UwMYQ2A4ABAvRarGeQdWhEEZCCYRhRQ11WLhQ
    BWqggWkNpaoskASS0bEABWCroMICF0zBdJkoyJfBwgQl0AIfP9CNRkMKZICI/hs7ELlplSRA
    kEAZIYgXaQIOIJHhgtse8UXFMAxakAIV3BEIH27c8TTeH7wrxQ86ZErkDFvoEXILLcCgOgw2
    GEHBB37/wPUDBMyNEAV1IBIGFnzU4ZB5GPyABnybvmvF41VgYYUVcYZeQwsfCPwBnZOiIDwc
    NTD9gI0t1Dqz5AqhcAfdCQtq+Hjoi3smCRAeIYWEzOsgwoWTfzD8A1EgcgcH4CtEwQ51wFXP
    LCQd9MHNIItLQKAE1b8LfeAObJLC3irQQIUogAIwkMIdENE7NWAhCkOqAcYM9KkMLexMpELR
    kA7yJwVIIRBYoMgFmVeDDHCAYFL4whjQoAYbZQ0L/lJ4HxaOdQQneAgNUcjeQQyAATTwIXIV
    ycCUPicCPWEpQU6SAAW2eCEGNOgHgbiD1y6UAApIgQ9foEAFH5KhGsCrDuMLURQQFrxM2dF9
    X0CDG2rkMJ9JhzocOMIdvlWmjChIIBgYkMYyIAEIWK8GNYABkZ6HMQQp6HXW+4IanACuNcpw
    ZRW4EIboR0b0pWeUBPnAEYoAgyuhaiMVOEIPrWC1q0BgIJ+6SiN3mSCCkOcjCoABI/hQIV5R
    55jpQ58BHiAChKGkc27IQ32IaEfZQbIGO7CjE6QQhjSKxJTVEc/riNS+9wXRClJw36ZkR6cf
    cOSPC6oAB5pZAxsYyUCi/jzlMQkgAH72U1AUIIEbsJCeU7InAQxoXMXcgKdjASlOIQRWQa7S
    vR8YUUZ14MPlzLW7z0EPQUuzYKikkNE7oOEINvgAr06VpYSo8ghCyFSy6oRCBxHpXd2UAgws
    GVKC/MBGWKhhPj15HmS29AEFbA8KiiAfONIIPwhrT4LuEAUCMFAl/aMACviQTitEwQZqvBAH
    vhBUqz2AOuXBagbckDD3/GAMNTBh3rYFrg/8AHoZ4GKCIpVMyenVIejhgBsYgQbrMCABAWiB
    G+BGgFsJJAM1eJelcJQ1NHQzDJf9wuMwC0R0inCMvlSQBDgQ2YxKwWcUIO2ErmQQJ37hCHM6
    rdDrbPCDD8bUiJr94A8UidQGJFVcK8OACCL7IUEgAhFo6FuEgPgDEiAVIQOLT/NI8AEUFckJ
    8cHC43rowxoxtLKWDQMPbUSfO7iBrOqK0/PoJIFDPklB6VkrCdRYUAUI6rlblEAG9kuqDxRo
    v3l9QAOmY4BTpu8iNbiDeXM0ISCuM04/EAJMf2CDSWZTdrSVnZUY6RHrCIyed/ybOuPzBfgB
    MUjM29TzRKDShwQEADs=
}
    
set T6_data {
    R0lGODlhQgBkAPcAANbWxr3e1s7WxsbWzr3Wzs7OxsbOxr3Ozr3OxsbGxsbGvb3Gxr3Gvca9
    vb29xrXBxsDAwLS9vay+x721vb21tbW1vbW1tb2tta2zvb2trbWttcelpa2ttb2lrb2lpaWt
    ta2ltb2cpaWltb2cnKWlrZ2lvZyltcaUnKWctb2UnKWcrb2UlMePkrGVo5yctZycrZOet72M
    nL2MlL2MjJyUrcaEjL2ElJSUrb2EjJSMrZSMpb17jL17hIyMrYyMpbJ8jsZzhIOMsMZze5SE
    pb1zhL1ze4yEpcZre4SEpYCDrb1re4x7pZx2k8Zjc4R7pa5rgsZja4R7nHp7pb1hcIRzpcZa
    a4RynMZaY3tzpXtznI1nj8ZSY3trnHNrnMZKWplafr1LX3djlHNjnMZCWmtjnMZCUmtjlINU
    g3ZXjsY5UmtalMY5SmNalI5GdMYxSsYxQmNSlGNSjLowTFpSlKU1XXdGfsYpQmtJhsYpOWNK
    jFpKlFpKjMYhOVBLlMYhMVJKjF9ChH81bsYYOcYYMVJCjMYYKcYQMVI5jMYQKV80eko5jEo5
    hH8jXsYIKcYIIUoxhEIxhMYAIcYAGMYAEKkINMYACDkphDkhhAAAAAAAAAAAAAAAAAAAAAAA
    AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
    AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
    AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
    AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
    AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
    AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAACwAAAAAQgBkAAAI/gAhCBxIsKDBgwgTKlzIsKHD
    hxAjSpxIsaLFixgzatzIsaPHjyBDihxJsqTJkyhTqlzJsqXLlzBjypxJs6bNmzhz6tzJs6fP
    n0CDCh1K1OACoBlwHO25IMSWpTsnHIAC5gAFngwoOOIBVecCO36YLkjjqENXm0dDeJFk1usF
    so48nK25IMOgSYba6qTAB69cnngmIdKb80AZPoZ2IJiQM8MCHnam2EGQsykOCH5CDFJaeQuF
    JkpCOLqK00GHMgy8EBlUhjLOBTOmhODjphKPAzkRKNmi1g3bESPmwpRaJU2ALYMEeXBD2iaC
    LXwIuMEDpskV3DcfS4KQZkoVNzgW/t9k0EFSCi9TithJIVzm1ybeR+RlUHlHmhVjEAz6q9NN
    hjUX2MGVV2vIwEMZQqyB3UQKNHhRgwkk0OCEEDRwQBpVECCHEnLEEIEGFlQAAQMKSKgAQiVC
    AMILIkCQgEQNVoDCDUY4kUUWXXTBxY0ljLFFEHkkAggge/RByJFzqJFFDi1KONCLKHCxhx5z
    6KFHFhqc+NALcOyxhxpdOJEDDSKAwEEFGjzgBhgSVNDCIHLIwQEINOTghBhwzLEHHF0YocGL
    OeR4gwYCafCCGIS8oOVCCnCwRxYtKlCAAAWcWEGI9DVCBGUIHCFJJF4cMKGDFajghBp6+OCE
    ERUYAAEN/jVm4UMBORBiQUMVQArAixCoYEQWZKihBhld9GCDJI4JhIAdjRSiFGMDSTopEoRU
    0KCvL9yaAA0vCICFGIuiqAIkbDihQog3qEDoqAa8oSAFHGgQQQys4QHVpSLQ4AQZc9CgJQcO
    NkoIDQmIsIdDL5hBiCKKEDIHG2Bi4cQSPQxByQ8PWKBCDkYkEcgZjGghBY5ikEFsFjRYe9AE
    c8AxIgh/iKiQAjdwkcMNNNTpBBddqMEGHD8nAgcZYtyYBRdJtPEFHUw4EKJAEIZLkAJdJMpA
    AkaYIfXK+mahBhxirGoEzjRgQIQdS1XghI1YoFEHGmfYaIUTLUJ9kAJOPKol/htYWMEQAw3c
    ACwbZKSLwgvcoiCHWQ1MSB8CNTRxQhXYNUgfCFiIEG4CTujRhQUnqtEyCgxpcCUKKuuAhBE0
    gPAAECwMoAG3Y6KggglPfMHEFzAYgYQTXcBByB5OFIS1HmqIkIAFaiiyiL8McUAIFoRe7SoH
    L9QYxto2dgExHGDe0eWRhBxCiB5msBquAUbAYcYLBYCgxyKE5LA1QhxYISwZWaxK5pkV4AAK
    SFCnOuXgAxuAAgGa4IEIVEBmDiJIAqKwBzHQoAA6+MMj5qC5h1yNARpAQZ1+ZTQxgcByFCrC
    BRwQAhTZzQxwoEKIqqYIM6hMIhKqgAiapKVFKYBE/oBrwFGWMqEcss4AIICDExRQASMQ7g9L
    pAgHuMAGiHUhB7cqiAVyljMXiCBeIdKACGbkNb69ig0iwGCYxBAH6DFIDJdQwwtcdD8VocAH
    WTCDGMTQBTGYIVhmCFPKGgSiF2TBCE7swg2lmAU2zOEQX+pC/wYlEA6MCWccMwIWciAQEpmI
    PiJApBECJYYOXoREEMDRDcxkAQ3IDAKl4iK3csaBg1QAZ9nrn6LqOBHpKUpCBjBAiSZkgEqN
    KgH0MYgFJmBJH3DASR1xwpHAJ8n+rS0HOshBLWHJzaklAFoi4tVHmPiCTOZgTC9AAQfONEwT
    mQiWORADG7JIkiIekwNO/sBCFvR5IyocTQyi25MTtlkSI0BgUeDkgAoQN0LuOcEHL+BA45JJ
    kgRkoZQiOqYCilnMAnjUngOBlkYoJJBLWYADIdqXGviYo4fm7AY4w+UiRyQhCVGUIkzcGPew
    EAXg9dEMVCABM0Ughj2Qb2hFkxjrRAAtBdAgTDlQAUoPykuDpKhUP/MZxA65yKehUgMCXGgO
    fEAFnuWIVQOxAMe6l6Mu+ICO70QIDczav5vZlakMGZVeSQq1JiJyZ2rYQw254D8RWCtcBeif
    CAjlUWNG0CMTeOADQ4Q9O3nPqBakKPuycKajGUGqVH3sSKKW06qpgaAKQMHadPArea5UCjmI
    9aiIGlfTvTrEnrXda4MmkAVLdMGHL2KAalvLhj384Uh7MpkknbC6c9IABYuV7EBMKiJDwbRG
    DuXe0XJkBj2Ui1AIsYAI7YQjODgPEpAghB9/Bof26mkPLVNDILlLLB1cakU0wpGO+li0h0J3
    oRMQJ4om9IKIgiBfKDCCFbBpBB/0YJbPBYErO9mgYpaoo439KCxX9CsurA68DqkZH6nAOrKt
    lWRdCJYjwUc0MezoRjkyWh8DuzCGzSFstazq3RTATFjZCKA/C7KSWlQBEIhQBzsr2df0cNyG
    OUxJSyVUXClC22FCILJgNdMrcTuqkoYoo11eSEAAADs=
}
    
set T7_data {
    R0lGODlhQgBkAPcAANbWxr3e1s7WxsbWzr3W1r3Wzs7OxsbOzsbOxr3Ozr3OxrTOz8bGxsbG
    vb3Gxr3Gvca9vce9tbXBxsDAwL29tbS9vb21vb21tbW1vbW1tb2tta2zvb2trbWttcelpa2t
    tb2lrb2lpbWlra2ltb2cpaWltb2cnJyltaWctb2UnKWcrb2UlMePkpyctZycrb2MlL2MjJyU
    rcaEjL2ElJSUrZCUtb2EjJSMrZSMpZ+Hob17jL17hIyMrYyMpbJ8joOMsMZze5SEpb1zhL1z
    e4yEpcZre4SEpcZrc71re4x7pZx2k8Zjc4R7pYR7nHp7pY1znL1hcIRzpcZaa4RynMZaY3tz
    pXtznKxgfMZSa41nj8ZSY8ZSWntrnM5NWnNrnMZKY8ZKWplafmtrnL1LX69ObHdjlHNjnMZC
    WmtjnMZCUmtjlINUg3ZXjsY5UmtalMY5SmNalMYxUo5GdMYxSsYxQmNSlGNSjLowTFpSlKU1
    XXdGfsYpQsYpOc4hOVpKlFpKjMYhOVBLlMYhMVJKjM4bL5AwYn81blpCjMYYOcYYMVJCjKki
    SsYYKW81dEpCjMYQMVc4hFI5jMYQKcYQIUo5jEo5hEI5jMYIKcYIIUoxhM4AGs4AEEIxhMYA
    IcYAGMYAEKkINMYACLoAHQAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
    AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
    AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
    AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
    AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
    AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAACwAAAAAQgBkAAAI/gAnCBxIsKDBgwgTKlzIsKHD
    hxAjSpxIsaLFixgzatzIsaPHjyBDihxJsqTJkyhTqlzJsqXLlzBjypxJs6WFmgYdJFDgwIEC
    njgn+LwwQ0obQIniaNlxwcHMnjb2YOqEaE+bo5c+dSriFKYDEHsunZnRVEGCnhdSfAnVZiBQ
    lQ5SYMIy4azACxce6CQQ4MWnOQpCaAGh4ObJuIlSFJhAYcLPniR0SIGC5MUOT1gSvJgzo7DJ
    BxwQETYMYomWGWDAQIGipc2lTpI8vShwYc6LriQdvBGS4ILAuGD2dPqUZkIAnROKZE3TkwMg
    37lXAC7ooIADosJ1KPCdIMQlSRMu/iRQnYBkgiVDehe08VuzpB0JKIgf0sm3AiRvPIt0IIUE
    7ruAgOCABRQkAAImt1ngwAuX2LfEHv+FNMRBFmAChgJ3JXAZCI4tgYlACWCxB4YkhXCQA4CA
    V5AkEE4ACITigdFGfCzxF8ptA9lIQghzQLGdAoD4aNhKF2BCh11CpeCJFgSkcVtcnYQQYUpQ
    ghECCOJx0MYZLzB3gQJzADZkjSC0gcgjgEihARVzIBKCXn6lMCVLO+H1BRQpJAJFeRZMAkZ5
    MSnAgRAmbLdDCnQ45QAdKga6RCdpcCjUGTbwlMYn/sXkQBt7kACoAyFAUYAFdISi3ZgsPdDj
    WU1pMAEJ/iRMIIhsc8K1hxSLfflCG01dkAgjGtSa0nhvlNcUB5ek0BsjgCioqQ2NCpSIFqMm
    MocDD8yUiBAYKgjGhwnQ8YawKilQRCJdOUDCJ0AEIMV0NL1nrAJtJJJACojU5IAOl4TX1Lrw
    7SEnTQq8cYYCUoinRScKCKEFjTQ9YgMHWjglyRcOzAHdU97Z8MKe685gg5A0QSnFDmkUEKeV
    5K4UlydgIDEHATZ4IgQYLbtMglhQAKJZJ2cgoR9NF+yxBxSdTJBCJ4nYkLPLVCACxSdFgOAJ
    gk+r9IAQemLyiHfJZg0XIEL0QYgMafRLUQMNZIsR22wLZAEGGVTQtBx5XOHD/idOPxT3By64
    MAIGcUvEQAMTfBDDDUQQ0cMNONxQQiIvKLEIGRtIIiZDbZfAhBdWWOEGJX9YEcMHiDfENgY3
    WMEEETEMPgHcCHigiQYebDLHAmSIAoLbCrlQBRElYDCCC3BQoggnmShihUM0oFG6Cw0wMMEI
    izeexA9rLPIAE6DcUUMOoByRAAQTPJA6QQ3cQEMHKHChyPx1/KGIF3j4gUcdGABvUAdu4MQf
    MjABFHwOdD1wQQkGJ4LEOMBuY1AAAvgwBwl8oAMfQMEHCIc4DKggBkTwAyf84AUmUK8DeOgA
    ERRRB07AISENIAIcRlAFJtjPCzcYHN0yeAIlFIIJ/ihgACLC4AQmrMEQXuDC65hgBS6YAQ5u
    UKIXKKGGEjQAhGogwgP8YIbRLY4TTEgIBogQOitQ4oxnrAQlMsGJNnLCEqQLBCTmpwhHOGJ+
    aFQECd+XASZUwYqpY0AGzOAFLxiACJwogQHq4AeFMOADB7SCF9CgBjiowQtV4IIb1KAGM4iB
    DY1Agxu8UAZDcMEIPaCBCj4wgcM9oAQqaAD6CNKB+WWAAUxQxAcYwAVKLKQBBjCgF1xgAANU
    D24DgcAAgLCFAUygdn04JjLhVszUlYCVDWACJ26AOBW4YXYxGMRCXJABtlnhD24wnexmd7gG
    IAAMHlAABDTEnCFhAHA0/iDC59BgBteh7gOUMEMDMMAAfTbAAg9Ag0IecIMSEkGVMWAi6GrI
    hNfd4AZ5iAEKVLCBNqSnMbNb4fzw4AYm5HB2s1PDHwhShxHMzgWK+GXiVHCDDwjAABPIAPZi
    4ILFtSAMWaBB5GLABw4YJAMdIFw7EVeBglJiBA+wAAI+h7gGwOGFnANmH0FHhIvGoJVs60IE
    DncAGPzpIQzAASViSVDkCYQBN6AEKxnyABQ04Q9VYKc7cdqUHTjtAhaQQBtwJBD1sY0B/mtl
    DCjhAgYQ7gN1wKYKKEGD9S0koSW0Qg4/UIIYWIABEQBCOxHAggsJBAP3HAEKYmAEFRAErn+w
    /qIFGgBZFFSPBpTgpt9uAAcQKgINXIDDINBAyjJUIXRV0AMbvNBFSnbSCsPjYEjhQDhw1gGQ
    TKBEDCyrOiJQog6KmIILLjiCa35gBEn1QQcqgAGBHLaYxswACDXIA5QWNLIGyIAb/LDLiXAB
    BRlwQQ/qQAmSgi4KFW3CE3oQhB50tXH6bCIXrEAEF7Q3dRgInTtx8IcoqE8iV2SCABDHRBdg
    sAQuoMFFiWCEKDRRkmbopwmxebiCKFAAHxDlCLjrNxdc9wNmcEFh4UbkwyGgmAJIsjExAEKX
    su9wJdDkdhMrkRhMEQ68NcMGUTUBC2RAcWTsoho062T3TqAERNjk/g1amZFsWoEG56TjH/bn
    hhibgZJuAC4TaMDKYiIgdR+wAiGJV7i3+biYAIiBItwAhzrggRKVUMQg6nBJ2C2Qsy7AgYNR
    MJARlLPGHTHDH0Dnhx58IANRHvWDXcxcRv9BeXB481xRKhIUrDDSf/ADI+Egyk4WkgugsygN
    SgDqkjSgBMQ1w/wGcYMM3PMD0MbgeV3AuIfO+iNEHkj77PBYIniB0W4ItxvqUD9F4MGSriPC
    td1Lg+2u7XAY6OwNerDngdCACz0Aa1Q7QO0IW8EIN4iBCq7JZYFkwAsToa0LvE3hG6yyvdoe
    qEEOS+RsK4QLHYgIBtSgiAJnHJkjwYAZ/gwygg9QeSCj7EAM6qBvkhjgddYjSIa57M4b1AEA
    2WJCHazQAxR8/JiHC/pSKz47CBh24ofFARzGdEwvQLUgNZ2AGeqr1RtoEop5NsOEX5zugLtg
    oyi4ZgkWuNELXjC1KLg3wo0ZtxH0wAtEKAjiGvo6POCBCTEgXDEfYLx+M1HQ4VaDuK9Kbkfr
    es6Fp2PHXcg4YI8yxklAnbYRQIQdH5uMy+PEd0vo8A2mD5jw9TMCEMCAP6cOqV+OqBvuKGf9
    wcGhp5tdtqo3ARcQUtvW8yAT3LD4TDgC0pSIhCL+QO5GE37whf/DIP6Qazs4+hD0w7sGT20A
    0sctAzTwArnjd34QtvE9A0Rg/p5V0G99UtRxjYvCJBvthz8In9dcL6Qa+FlIE37Q2+N2QxRc
    G/Nfsq6SVnBNhHNkoVeABlBj/NYDggYHr4ZGyjN8uXZJJjU4IOc3D+ACrvNtmxRsr4MDkQM5
    jSNJlHRn4UZuUWRRCpRxD7BUCBEQADs=
}
    
set T8_data {
    R0lGODlhQgBkAPcAAL3g3tbWxr3e1s7WxsbWzr3W1r3Wzs7Oxs7OvcbOzsbOxr3Ozr3OxsbG
    xsbGvb3Gxr3Gvca9vce9tb29xrXBxsDAwL29tbS9vca1tb21vb21tbW1vbW1tb2tta2zvb2t
    rbWttbWtrcelpa2ttaSvvr2lrb2lpa2ltcacn62lrb2cpaWltb2cnJyltcaUnKWctb2UnKWc
    rb2UlMePkpycrZOet72MnL2MlL2MjJyUrcaEjL2ElJSUrb2EjIyUrch8hJSMrZSMpZ+Hob17
    jL17hIyMrYyMpcZze71zhL1ze4yEpc5rc8Zre4SEpcZrc4CDrb1re5F7nIx7pZx2k8Zjc4R7
    pa5rgsZja4R7nHp7pb1hcIRzpcZaa4RynMZaY3tzpXtznKxgfMZSa7Fac8ZSY29wpXtrnM5N
    WnNrnMZKY8ZKWplafmtrnL1LX85EUXdjlHNjnMZCWmtjnMZCUmtjlLFEYc45S4NUg3ZXjsY5
    UmtalMY5SmNalM4yQmtSlI5GdMYxSsYxQmNSlLowTFpSlKU1XXdGfsYpQsYpOWNKjM4hOVpK
    lMYhQlpKjMYhOcYhMVJKjJAwYn81blpCjMYYOcYYMVJCjKkiSrgbPW81dM4QKcYQMVc4hMYQ
    KV80eko5jEo5hJMcT8YIKcYIIcYIGGsmakoxhLkILc4AGkIxhMYAIcYAGMYAEKkINMYACMYA
    AEIphAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
    AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
    AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
    AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
    AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAACwAAAAAQgBkAAAI/gArCBxIsKDBgwgTKlzIsKHD
    hxAjSpxIsaLFixgzatzIsaPHjyBDihxJsqTJkyhTqlzJsqXLlzBjymyYYSbDBwwW5GQwwSZB
    nBpuUEkTR42WDwx8PqhwI06lVZ0AaUHC5RCUpDIfmADEyhWrqHm4IDFRIY4WBjVfPqCyypWo
    OD06DPyg4sOCOTcMqJ3zqhOVEg8eQPhZAUIHQDeWsnwQx1WaDkkHH8ywQMseLYpTMkCyasiC
    CoFNfED4oEcPqp9RQihBqocBDQxu5MmTWEPhgh+4LIgDI3NJBnPILIDNpZINwQ+Gd4DAgIHi
    HhVMxPFNUsMcgQuoVAIduEccRqoY/nGBYgJrBQZkEpt8IINI4BudbD+Av0lLnkOARK0SxWRp
    hgdDeJEaSQ8QocJSj/QQGBGsABJdHJuIQgkRFTiioAUPwHDISQ84AVkPE0IAAytU6AVIJUN8
    AEMaQ6iwB1oZqlKCZCNpwAVoc1RCxQOjqPGZI5108FlgR8Cwh0ClsaJeSXPIVckmHzAxigbZ
    rfLBA7YJxIAKjlSQAQNUuJIEWiQxkId7onRSASJafNbJHAtYUBiWDCQhykCHuEIFmSMxAEUe
    BjiySQWHwLAAC6wo+J8KCq4ZSGAwrLJKEtSBNEEJiDyghiqaGkrEKgfC5oQXAkDhyA6gkeGI
    KksSCEgP/hqoYgIUPRTAllznQYFEBZ3AoIFhiJChygc0jlTaIQUEW8IQBmhhJZYLqOGibpRd
    QQYgjlQq0gOB4BDpjA9wVkIFC8AAiBqPDnQmK2elVVJpjyywR6YZrsLCAyocssmGSFKBhCOi
    ZInSA4VqsMqeFWwCQwViqJHHbTUZ6UqjmlElABeslFCAGocw6uADNS2VxytiaEvSAlzAWUEl
    ZJggCnmOaIDleTBU4pjJI30ZxyGBsaBKGnnIEIcNDMhHBSuj9NfSA44AEhgSojzghVFkMuaY
    zC2txq4BMKjyMBl79EYlF6vcMOBKVJKxSgkLBMJEDzCQ0QaSNZfAJ0vlklgA/hFzYJkEVUkd
    dqW7KSUHwaclM7AHsyrcQMRZD9B2t0o3cHEiEkmVUMmVvXEhhgCPD+cSDET0BjIDTABCZmV5
    PEBGTDhldlebtqFeaKs2oegfA0P06hOSJoxyYAYQqECEKr7+Pt+gSDpxQyVccIEzS37yPBAg
    H1g1hwnTp0RZVTByKa8WWlg/E3CVLMWAE4MI0EYcGrBCxOSqOdCAAw6ANsgpHGxAsBMAWIIi
    BHAGVGDgfhCIwELwdz/82S9/EbFfBUbAgyqgQQ+EaAQnMqGHL3QhFEJowRoiUYMptGINLYjB
    CUYAAoE8EIJeWkEOlFAFM6ABDVUYQQUcUCyE2I8D/jxAgyAsYQlC6AEMQIgBJi4hhCJIwhBs
    QAMeMsEHOfihFIQghCC2KAg9oKELQFhBBE4Ahi+AoQlAUAIYBGGKTyxCEHI4QQ8L4oAV0GER
    fKhCDk7gQgcoQASj6JIFNDEDBRDACX1IQANEgIolbWAEMlSjF3OwQwVkAAhVUAIPVjACDqCB
    D3xooQ9f0AggcEABB4Chl0rDsgJAIRDDWUAbhEOlPPhoIBBgIA9BAEkgwEEQZlCCMKtATDS8
    cQMJ2cAMT7CCGOjwhQ5gABce0ZtKyIBOZwLZfBDRE4NIsAqWAIIZmpADGnASmQ44ARFpkBAO
    IDGSv6QDDnnwghQMog4M/rgCnCLQAAnYQQIKwJ8C7CAC3zwyB2DgAxxGcL8d4m8gDgCCHia6
    ECWYYQs8iAEmwXBBQkyCE0X0RCL44MU3ZAINZvhCFXzwhylsYAU8oCEWzJiDDRxgjgNpAB0s
    SIcFVoADQZADMI1gTnumgASFCEMNytmCQkShCUoAQg5IEAYrUEAgyHRoAypASYRAAASWGEEp
    GbIBObyzAhs4AQn+EAYCuMARD1QACtxwvwYm4Ac6MA9EHUADOSSkAXIwAxAWocOFcICkwUyi
    B0IQB9AUCmQaoEAbElOTDGTgAjAYDUS3SoMLjgCnDciBJZQwWj00xAEjSIUgjAAEKdyhC09Y
    /sMYKCDQuQbUgQ/FnwJHkIMqwEGoPFAlRDnQiE9YQhCN8OtpV8DRL0RhCkUoQiGkUAQeBKEG
    a0AhD7a7XRq8NI2ZTGIFDiBahGxgEamQAxossQiHKBAEStADJpvQBUmUAQ1w0AMbDGGILFSB
    ulHNwQs4sIICs3AENIgvIYDgzQpssbdEHIFwEUKDRozWpgiQayEdqIAzuOC2+XtkDGhYBTDY
    0AxVKMILdkjHFeiBBxX4QioacYIJm9cIixjnHkcAmwc2IAJXSshg7IfKVE64jo2gJBhUywEb
    J8QBG+ABGBqRCvbyAQ1nDAIPWrCCFSJzMDR6ZDNpkAM0HsSUDgDD/ifQQBEooxgIIzhBTMEA
    BzrogQ9bJCmWTYwGeVZhC0LsIIMPogAQ6MESwa3ICPAIBiW8QJQu3OoOJZOBDVh60hlYgRI+
    0YisRnoDYLAEHDbgZIcMBggXbMQiLFzEL9QUvsKMdYnzKwgt7lTCubzfCarQiIVKGiMPFAgI
    aECDE/DysgkGAhB4kEapmrOFD3xpguHAhy0wtNQTCTEHHDrkSOO2gTwsyAr+ywM+PpQjHKgC
    ns1Q2JpcYCDIrOwFLpsWVToQp8DmASwskUN01hWauBVoBV5QU5QwVxCQaAQh/BzrqCobCEaI
    9RbAIIdRi+TbAoXyCtJIYhODweMlJmZU/jmpBI7k+qEcOAHBgRCENa5Qqw6s6wEGMHOap3ID
    MRAEGhoIbonYDwK8rYJQBQFKeZYxk2gEAjsLUpPeKgHQcuDDIixh3Imqt9E5WEELG7pAZYJh
    6o3QQxWCsAJ0vrCBChl3FaCqyRd0UswyTCNHKw4GHkCb6wVRwhbRAGeYt/nfaBdILhlYARpI
    4YKrzqJZaypBFzbiCwcwskqEuwEaWAIMNfxCEEi9wxPAge+FrQACFZgS1ArCphNUAh2AAGbU
    8pahms76CC7dR4DjFt6ePq39TiAIWOghfxBoQAByIIhiHUCcAhkBEDj6yy6SVA8Vl0P04fBb
    6WPZDEj0rg8f1JiBEyx/6mCQcFpRjQY+GuTQcKjCJln40iAoAQ1fgCqgqQ9/JRCbjwkc/O3R
    CoIXLH+IoJAKqaAHrFVDWKYEMXAbBwFTFpRJRRADK0BmarQFFoRfUcdFfKBFRPd80CcHd7ZF
    GdQIgvB5FxVespcBwfZkPoY/IyAIMUBqPOcAqXQblpYBI3CDzbQCL7BCN4hMEUBk4BZwFwEE
    jSCCXnRDWCZymaQETbB2ShAEzRZxUeV+AbZChKMR+QMCOpgDHEdixBRyFgQHJ4ZlZoRixCRV
    L1B2DxEQADs=
}
    
set T9_data {
    R0lGODlhQgBkAPcAANbWxr3e1s7WxsbWzr3W1r3Wzs7OxsbOxr3Ozr3OxsbGxsbGvb3Gxr3G
    vca9vb29xrXBxsDAwL29tbS9vca1tay+x721vb21tbW1vceurbW1tb2tta2zvb2trbWttcel
    pa2ttaSvvr2lrb2lpaWtta2ltcacn72cpaWltb2cnKWlrZ2lvZyltaWctb2UnKWcrb2UlMeP
    krGVo5yctZycrZOet72MlL2MjJyUrcaEjL2ElJSUrb2EjJSMrZSMpb17jL17hIyMrYyMpcZz
    hMZze5SEpb1zhIyErb1ze4yEpcZre4SEpcZrc4CDrb1re5x2k8Zjc4R7pYR7nHp7pb1hcIRz
    pcZaa4RynMZaY3tzpXtznKxgfMZSa41nj8ZSY29wpXtrnHNrnMZKY8ZKWplafr1LX69ObHdj
    lHNjnMZCWmtjnMZCUmtjlLFEYYNUg2tanHZXjsY5UmtalMY5SmNalM4yQlxanGtSlI5GdMYx
    SsYxQmNSlGNSjLowTMYpSlpSlKU1XXdGfsYpQmtJhsYpOVpKlMYhQlpKjMYhOcYhMVJKjF9C
    hH81bsYYOcYYMVJCjMYYKbgbPW81dM4QKcYQMVc4hFI5jMYQKV80eko5jEo5hJMcT38jXsYI
    KcYIIcYIGEoxhLkILUIxhMYAIcYAGMYAEMYACMYAADkphDkhhAAAAAAAAAAAAAAAAAAAAAAA
    AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
    AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
    AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
    AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
    AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAACwAAAAAQgBkAAAI/gAjCBxIsKDBgwgTKlzIsKHD
    hxAjSpxIsaLFixgzatzIsaPHjyBDihxJsqTJkyhTqlzJsqXLlzBjypxJs6bNmwgTMNipE6fA
    BBe45BEkyIgICQgY2EwAhRIiQaMa5cnTKM6PCAwSyGQQx5ETKkZGNLDhRY8hSpfSILmg1GWC
    NIIYKBlzIsEGHiMi6Jxj6pMfG1pZMuDhiUoeKiM6WMAqcDEDMYacCOLRNmUDC5BIUcrTAYFe
    pTuVNthAhUkHQRtUMrggiJCLgXmNpInj5ceJgVaoMGBCxXPHBgkZjLhU6gQCC0ypIEmT4kKc
    U4kYWGAAwxCQDnEqb+xw4SCDE53m/vgR2OCEoAgiGhRwUiqPFydaRcRZ42KNBI4NOnBByAAR
    ISdrIHABAl4g4dl3pDhChAucfTeHcmt0t1ECShhoEAMpmPLDGPBFwFoHEUw3hik28KCHE0AQ
    oMQaTlhRRkcMCOKCdj9BQYoIiMzIgA1xYeUCIYh0oEcaTkARQCI8MBGHbhsJd0lqF8ZByQVB
    6mVFHEAxJUgZUIwBRBo8WLEGAXABkcBiGQ3myEHIjUFJB6PYsFMeZQgYQVlcEMIDD3Fcksdq
    iOiRnkYWIGCFIIEVxAAVpfBAihc6CeKFZxd4QRslJzBhSh562UDKGjRelEAcdaJJ0GClINIJ
    IgPOUaeH/l6UQYUjeXSyH1Z5lCInRwm4h8B9BzUyRiOjuFDAGGn8eoETSojRiClrFBCBoZuG
    elGMvZl6KmGdjIIEAVQg6iEPSIzS7QlKrUFKJ+h2hICvwF6ox7peFGDDmrgi4oUgnazmCFE9
    duTClmfy58IopMSBQAeNdCbGGAXEsW4HjozBJxUeMYDEGn8qJEK3aZwZJBdeBOCEF1RoZkUE
    dHlhrUUdKOHEJQrtSAopVGg1hyB5BPCDwjaUIkYAVLjQQRovV4SEFy54sqtByHlBSCeUcTVK
    AyPEoRcPnYQIBAMicMoRA0DkEXaA2hKkRxmegBgjEBGjy5Ujq1kwGqtjp3CJ/g1NS6joEGsg
    gggD5dFtRG8RbECKFXcpdYIjfmt0gSdxEBDHHAU8oKgRSDSalRegrmEBUliQ0gHjeikxOIxW
    kLIBA3mM4fZOF9hwQiJrANWfCz84sZMIpOyJhO6EZOvRJWN4RoUhhuQxXxxOzIGvcIhEYMWA
    F3QyBgNpODYciBnrUAoQSUXggg02jICADZ2IkNXHnInOdSkbGAHfgGNMChJT43vWAAIFIJsj
    2mWEqVDBBnrw0xrWFAe3jQByImGAF0wxBoHwJg5xGNBgoLAoKCDhBzYwmRhcMCm25IEHiQIJ
    2UbhCSswSwQFuIvbEJCGAvEETFCgDIGSl7aPAMUL/p3wRCfykIY1UCE1F+gVEgTCFvqswTg8
    QITmTuKZDozABSNggG+wogfAOEYMPAKR0wqGktAoJXKCAB9WnHCvC1hhdVsZgdg8pDEbUMIF
    l4BPDwVjhORhpQNeiMAIOmGF9gEnJoXiEAI2AATWdMcpcIzIAiZ5kUkqQAGTXIAD9JCBBHxA
    DxYY4AT6EIo2TMADGIhAAxaAyQUghJURKAENUBABBUhkkhhowQ6SEAUtaCEMZ2BEFppABkJc
    gBF72EMlFrEIRTzimX+QgxZ6QEtMDsSWLQDDIQrxh0IUQgsecOVDaLCHQxxCDmGIQg9wEIIt
    GGECFSDVBUIhAwjEoQ06/uBACXDQgyigYQ9/OMQewpAED9iyB2EIww48IBAP0AANj6CBOBey
    ABAcQgu0XIABBGCABSxKBhOIwCWMcAKaJWAMUGBLJjMZAQy8IApyKIQQopAEDBwgAjjgpRaE
    YIAePEIDDcEARgFgywi8IAlaUIMcBqGGL3RhTVSYQ1JO+KuDaHSjS3gEBiZ5VBoAVQE4oIEA
    soCGib7yBaKgQxReoAEM7OAFHmBADG5ggAGsYQwByIMTKuCBSNhgAmnDgAZQgIMoqOEPOBAn
    CChZ0UfgQAEoOIRDaMCGR2QiE4/4Ax3Q6YYrLCEIm3gCB/ogAxI8YRNSiIJqtZCFX6JBDWoI
    /oMWcLBVNv1hD6osgSJSqZAF7AAMPdgBDvgZBTCEQQ5q2AMdMLGIN9whEFmYghsYQVMh9KAE
    guWtJc1KkAWEIaINUEAS2MBdNhVWC3LYAxpomoQd9IAGJehEDkxmBAgsgRPQNS4YsiCFLFwh
    CrQUSHkjsIAoXFScdPAvQxrggB0klQ5qeGsLaIADFgCiDwzoQB0oMIAYTCIDSuHuJIFTgiyg
    wKwKiEIhwqABV8rhti1giAe+2YLa+mAJScABB2RAChMMwAZkmEEN8GCGFdCAwjtwbxCWEIUw
    7OERh4hCQcRbCDmgQAEakEMmNJFYhoDgEVlgaHhvCoIZdIETcGBy/hSmEAZJSMIOckADG8r5
    zEdY4hGFYENNzXqAJOyBDTQwQAkKoYlH9GDABwHBFeSAXC3QlJ2RoAIESqCCFvBzBz6gJiUF
    goFOC5i7CpDCIdCAAwP4QBGg+MOJHxLeBnjA0j44QjDBMAV1lmDELGWIOF055yq09buZYENt
    JYJJDJAgBGOIwU0JPBBXOtsgmSx2jg9Qgj1EYQEYSAKEFXFtioAADHSgwyAkUYSQFkQDww0r
    fEGASgx4AAW6RG+CcUoHFJg6nWjgQ5cnsgA0pEIOLNDBB5ZtkBK0QAhJZUMY0BAGNihV4VGg
    7SQ9oAEaaCEJ2g7DsL2tBToUIrPodPRC/gUCgnUK1wcYz0IPyMPKEUcABRhPAkLRsOqLrDIC
    v9xBCUCgAVQOxKXpDutwQXAQt4YVqVGQKKIn8mWJYvIAB2j5JA/Q0ZUq4JDntkDJhQACa3Yk
    Cs/cQ8gdrdoeZJroLU17dxWAplQW9SPY5ifGe7BOGrQABCDYKiZb2cqW9gANdABqSaJtdRBE
    obWt9WUVtAAGNLxYoFFAe0mSwOzGcBoEL6Cw3FWrWiHQAAQOWADWR6IALdA8lVZfANWpboDW
    E34ge6xIrluqAQ3wHAOGjXNC0ymE4SYZB8KlwcZVuXfRV9Kl/VQtf5u8cDZUQQVaRwEaDlHn
    PagBDax9NArQ/rQAHKSzBy/gOYGXDm1bupQOYg+3NPc8kLaq0pUeAEELMt8DIVTBuAmtaft7
    oNPdh0EItSR1CYED+OdowXWA26drK7WAmyZg2YZxxSUHhxBsYKB9W2VWBuBoKMBQrVd1DdgR
    FtBpndZWIEAD/RQGdEB9pIZ1faYFecd4SRB+4/eBIrFd2PYC3yUHkrcALaBaKGd6m4UGU/Be
    eRcBoVd8C+gQhIeEDLgAFqAFqBAGEwVLDdCDSAV4h+BMUGZ9seVoOEZ3ONACGyiCP1d7qeRQ
    ScZLnLeGjJdQbFAIasVQCKEBltZPv7QHWyYKovAIcoZ+yQRQ5nRbcqBwbhhbPiBYp7K0S78U
    BsaFBtgXBUIghplnAW/3Spl0ZCBQAoTVAklwBWaXBEIQBEIXhiXgc++neh2lAKzXga7XUrKE
    VGCAY3LoEL/FcFWQY8K1ea4VBkpFB4J4fWgABr60iMO4cBJoWZf1B+tFdORnVU4IAjnVS46H
    ftQoTbSEAQaHAz5QXK+VXoXgTJgFcheHAxsYgM24EEfYciHibplYhJ/Wcq20admFeivFEAEB
    ADs=
}
    
set T10_data {
    R0lGODlhQgBkAPcAAL3g3tbWxr3e1s7WxsbWzr3W1r3Wzs7Oxs7OvcbOzsbOxr3Ozr3OxsbG
    xsbGvb3Gxr3Gvca9vce9tb29xrXBxsDAwL29tbS9vca1tay+x721vb21tbW1vceurbW1tb2t
    ta2zvb2trbWttcelpa2ttaSvvr2lrb2lpbWlra2ltcacn72cpaWltb2cnJ2lvcaUnKWctb2U
    nKWcrb2UlMePkrGVo5yctZycrZOet72MnL2MlKWUpb2MjJyUrb2ElJSUrZCUtb2EjJSMrZSM
    pb17jL17hIyMrc5zeoyMpYOMsMZze71zhL1ze4yEpcZre4SEpcZrc4CDrb1re5F7nM5jc4x7
    pZx2k8Zjc4R7pa5rgsZja4R7nHp7pb1hcIRzpcZac8Zaa8ZaY3tzpXtznM5SY8ZSa8ZSY8ZS
    Wm9wpXtrnHNrnMZKY8ZKWplafsZKUr1LX69ObHNjnMZCWmtjnMZCUmtjlM45S4NUg3ZXjsY5
    UmtalMY5SmNalM4yQo5GdMYxSsYxQmNSlGNSjM4pPbowTMYpSlpSlKU1XXdGfsYpQsYpOc4h
    OVpKlMYhQlpKjMYhOVBLlMYhMVJKjJAwYlpCjMYYOcYYMVJCjKkiSsYYKW81dEpCjMYQMUJC
    jFc4hFI5jMYQKcYQIUo5jEo5hJMcT38jXkI5jMYIKcYIIUoxhM4AGkMxjEIxhMYAIcYAGMYA
    EMYACAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
    AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
    AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
    AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
    AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAACwAAAAAQgBkAAAI/gArCBxIsKDBgwgTKlzIsKHD
    hxAjSpxIsaLFixgzatzIsaPHjyBDihxJsqTJkyhTqlzJsqXLlzBjVoAwQaZCBg8qbAgRYsMD
    nDYFPljwoYgZOnny0JFDR8oJoDAfPNDBRk6XGB8sDFzBJA+bFgtSSiXIYEWiP0EqLMhJ8OfU
    P2xOrl0RY+CDJa7AQE0o9ZGZBRpCjnWSiI2PChoYMHGlI2xDCBssrWDbMWeQP6fyTM45FVUL
    iBoWQNlDeSODGGtCuQqytoLWDaiKCLgSo/TCD6BMQOC44IqZN49MLNggMDSbPTiLrFmg9XGi
    2hsfsOkSpNKHB8SFrkC1Wccf2wof/jzSAZ7iAqsrToWwzWBPIgY+Z1SCuAEUdIwLwMh5kKlx
    doEQmOAKE9gxQIQlD02FYEYPVFeAG3QMVxADV7gSAgSJXZFIeQctcJRjF0V2QgionADeA5Vs
    KBADebzBnEOgBMEhRAuwYQYAbPwhYVsnuLIEA4FVAAoRDDTEwBKgMBgDKMTFeGKF621wZCs+
    6TBZeI84UeRFDwACRgEtWPIfWXlUQhkoZkjlRBFAIrRAGI+whd0HEz1wAighiPbeQQ9YYgZ8
    DCiBCnEMdMEEiAU9sIIrtUkZwx5jPkThHwwwYMYegB10iowV9AnGcPmliZB4bAz3QAySzRhe
    IkX81OKL/m2ZwB0EnRH3AASJMCpVaQucAQt0HwSnqkLBhlBBe38FadcMnBBXYx6VrmDJK0QU
    UAEPdQnkoY9C7dHFFSfsFtGpG26wQB7IGdTgd51awsRsrVxRSQhBPJJjYxXk0YgJ8PX2ihxX
    SjRVIwWCYQl4R8oRVn06yMGJCSFw8kclMTgWAhs/arsdGJ1S9EARcWowlYUFhfbbwqC0sp8B
    TsAix7FDxVDGB0XCt4YrdBhg0ZEHD2RJqROa0YVUQbhyBU4fZOLEAkRBcdYSG9AKxR9mtDLD
    sAsxIEXPnerwSsCIeWiGAF7/JZAldAhQgcF0HPZTsHk8QAQqFyUGxilt/YHK/nXZFdrFB660
    YqIGj2SygA6nJHJCawzkwAkUTNNhJpdFvGIiQYmgkuduDDiRhyKJmFFAZEyC0cqPRZrLxCkz
    mPoIpRht0IqWyj5g8BXGLhADLDYyUUQle+ch5k8xlHoFJyG0KV6cGDEgB/MELWDCGpWAkkgi
    rSTCSSGvgEFEK4pw5t0GTjwicpAMmB5pnSu8Ql6iwxHBhCWrVaBDIoeHQqgTnECAaqfN6VQL
    3Ic1hjCADZHgEAMWkIhHFKEAiWhMJMhzl70JaTLKEoq9dnQRSyxtfSKjAxNa4IQ9CKALbLBW
    CxhTgD98KoNCOUGJCrgQO4FiBW1KlA4esYA/6KAC/qj4Q21AkcIZMCkhR9oTRk5liYoZxCdX
    UIr2HnECOSRCTB6KkEIWQIcyIKoiD2hBJa5wLJxIZYEbiMQrQHEKLSyAARt8QCKksKWETMCB
    ObQIdtbwiDx0wQc6CIIT/sAJNtzMFUVg2utuhUcYJsoEljABDRkivS484hSteMUpzPCU3rji
    Ee4BRWLEQ8eFqI4Ok2QIBFpjghiEBjt2ekUegmAJTsghCAXoAiA4yJc/XK4ypZlKK07BL1Dk
    4Xq/m4HOGPKB9X0kjJXwoxkYtYDLgMIVXxiLTQCxh1P0QQWDUEsF/PKHRLTOIQ5wgLguks50
    FocDF0CcK9rggkPA4SdS/pAC2aimEHeS4AY3SAEH3CmRBjigAiTogRCa0AQkCEEIQyjBHlCB
    gxuAgBCyUQIdfwKGPxxEnSzAghrGMAY9iMIRY+gBCQ7akHRyQAhjwEITeiDQCrRTARhgIxUS
    AIEV7CED1MGOBgzwhkMV5AZiaAILOJCCG/BBFJdgRSouMQaH/GAOKL2BAxpQgRQolKFVSMId
    MPGBSViBA0ZogwzYsB5t8YANOXSAEH4gAhik4RJ4DYQjLqEGQzDCEIHgwDoNIgI9sMIRHqgA
    DEQ6UiTcgAUCRQEnKsYBOkhSASN4AwVIIIIUlCALXSBABCrAARn0oAmMYAUj1IAFrYrAECJo
    /sIlAsEKPiTEAU3gQwrEgIW9qkEIAuWAB0ggAxtYgRRYkIECVtAGLmABEXhQQxpkioU7IAIN
    fNDDdNUgijqwwAGnrUMTIMCIOJhUoazAQkI40ASSjkEU8IXvKESRClawwhSr6IQoGHEJSOwV
    Ep6A6iVGsYlNfMIQaqCrB7Aghu+ytAEeiIMa1HCAJrCCBQcIBCMU0gASMHYMaphDHfhQBzWI
    YQya0EMd4sBi885BE3EgKRaAYAVMkMCmIJWBA0ZLEBHg1QMNwMIlSNCANIhiIQ44wGLVcIMD
    HGCrDiAAGBKxm3ZGgGVkUEA6CdCBRbxAAThO8pMFwoIbOwALrBDC/kFloAeb9kASC7mBB9I5
    BkfoIaUpoAATVIEBLaczAgp4QdwQE0bFMUAE//xBE0Q6hxhjYaUkEEUcHMCBBizaARqAwBwU
    AgEhsLYJPzAtFkCchlLcIQoynWsPbHCIHYDAJyv4Q1uRgNdLGEIPWACuTW1aB0cQJBApsOkN
    LoFkhMpACCQYwAEqQIFDHMIFPejBD6INhElMYdo6kUNbBSICDwzUoO68gKVFkQIMKUCkB3UA
    H2zLkHQeYMFqiIIf/ICDHoQ5ATQ4gpYjMJUWFLABQxCFjivtVIE0QAiiuLEqYbAFlE5ABXaQ
    gAIQQJANEOEBF6gdgNrZgMFWoAE9EMUN/howUBIEwswyEMUPWKrKObCWC5OoAQhMi+MGRADc
    69TABThAghTAoAdPkAFBDu6I72rAASaHwVZ/IAo1P0SufDgtJOaQBj5IwuVpcK971cDiOoh4
    xWNI6kDTnduBujkQDsaCKHrAcnQ2QRSBoKoMOJuCMpOAsx4QAQf2LpB0NsDJT/bAaWFAAiPs
    2tInf7ceGEHkiaQBBh64ARICIYpbj9QLWMg8Q4eAhCYslKGjTkPWm3ADDuyatCR1gAKG4Agv
    QKDt6OwBFgZw0FHfANEsuMEPHrpoL4wh61x39A3MbNCjsmAAJJiDHlIA+6ffAO0kiMMNNt5O
    jqveyQPI/pM5/nDaYBMEyixIgx7Y7nGJ9IC7fBACH+JAAg44UgPDPe0YzFuHMeh6IAdlQRNU
    LISPZ+TMY/ADdVZrjgBYetBiIqYHVIcFP3BjTqZlAkEC86cGSkVQGOEAz+dkAdADl6AHfBAI
    hiAKo3AJkhAIJTZTkEUCucd5TQADA5ECc1Z8HREHjjBSjIAEJOAB4VeDntcEvsd1HugIUMUH
    AahwpxcSMCBbI+gIjKBhfKB8KzZhaTBSqfYDLCCDJeEALOBycYBXkiAE3nZ3d4doPXcDn9eA
    IlF9+CcEglByTaAGHqgHcqgHgaBXtkZiMdUERoh/09Z86GRQHMACCoUEDDgQP5AG/kjwceqk
    ASJghotGUk8gBD0gA2XmSALhAWowEUh3A284Bp43d6aHf5RmEH5XfWqoEGkgAhHBAXVwCZWn
    iu1EEhwQBwaRAiRQfgOhB2ogAj0QCIqIix1xADLFVQTBAWPgSKonBIEQALuBBYEwBkgAA7AI
    ZQZVjeBmiukWAa/XfBw3BHyQQVCmBuVWEMhWAXFgeEnmAUIgftmlgHGQdb8nY57XAzcAAzIA
    A2XGApBlj5zFWTznc4eYiU/mTimABBRYEAflaTJlCIaABT0wUE4GAUzliKM2f3JYB3O4bnUI
    gk1YgBtZa65YWws1hbrIYlWwUvinAE3AfFrYXlHFCnDH31pCAIozIWaAdwAKkJMN4GeX2G0J
    hQV6sAkgyYSGwAefplI2VWVcdQMShn9cVVpAGZKpsAkiKAqfcAmOUIcfqJEZuZGOIAmOwISC
    AIKUkFcOSXg5iJPgVgEe8ANqUIdNgBDpJJEe0ARhyYAy4IiLxlsy1Xk+GGIfyAiOcJVPGI8g
    pgZeJ2GsdQOm9YZ0qAdeIHTEiGQvNWJjUGYDpQA3uZlOVnyNiATzxwdCGF8CFpaMUGK5JlCx
    CBHqdAMxBYcqRoUyNQRD8FBDwFAgJmJxoHx0GAjalWqPpYoQcI0IERAAOw==
}
    
set T11_data {
    R0lGODlhQgBkAPcAANbWxr3e1s7WxsbWzr3W1r3Wzs7OxsbOzsbOxr3Ozr3OxsbGxsbGvb3G
    xr3Gvca9vce9tb29xrXBxsDAwL29tbS9vca1tay+x721vb21tbW1vceurbW1tb2ttb2trbWt
    tcalrcelpa2ttb2lrb2lpa2ltcacn72cpaWltb2cnKWctb2UnKWcrb2UlMePkrGVo5yctZyc
    rZOet72MnL2MlKWUpb2MjJyUrcaEjL2ElJSUrZCUtb2EjMh8hJSMrZSMpZ+Hob17jL17hIyM
    rYyMpYOMsMZze71zhL1ze4yEpcZre4SEpcZrc71re4x7pZx2k8Zjc4R7pcZja4R7nM5daHp7
    pY1znL1hcIRzpcZaa4RynMZaY3tzpXtznKxgfMZSa7Fac41nj8ZSY8ZSWm9wpXtrnM5NWnNr
    nMZKY8ZKWplafmtrnL1LX69ObHdjlHNjnMZCWmtjnMZCUmtjlINUg3ZXjsY5UmtalMY5SmNa
    lM4yQsYxUo5GdMYxSlpalMYxQmNSlM4pPcYpSlpSlKU1XXdGfsYpQmtJhsYpOWNKjFpKlMYh
    QlpKjMYhOVBLlMYhMVJKjM4bL5AwYl9ChH81bsYYOcYYMVJCjMYYKVJChMYQMcYQKV80eko5
    jEo5hJMcT38jXkI5jMYIKcYIIcYIGGsmakoxhLkILc4AGs4AEEIxhMYAIcYAGMYAEKkINMYA
    CMYAAEIphAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
    AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
    AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
    AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
    AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAACwAAAAAQgBkAAAI/gAnCBxIsKDBgwgTKlzIsKHD
    hxAjSpxIsaLFixgzatzIsaPHjyBDihxJsqTJkyhTqlzJsqXLlzBjypx5sUEDBQps2qQp8GaD
    CSeEQGkihMaKEx58yhyBJEulVqxWaWpEtVEfNFlo3Ey5s6cSVobg9MHTp2yjSniO5LjCIw0c
    IT9Jbh2RYmCHPitWNDJUyZCYJjlOZGiwos8VAh6ywMEwUgEJNKI2CUojZoIDIXBEGbpC4maC
    rjYtbUmQ4IghhnEl/kTTalMWDAo6ZEjRxxKaEw0+T8BAgWCDAkJWZZhQIIsYBQkbHBmR2qGC
    FZZYQWkQgEefSqMqXcmgu3dBBRiQ/qTZw0rrhAyNOgh0YFBBmivIHzZQ0soSCQInzuKxdGWC
    AgfN+XYEHlmc0MEqcigw2B9CIDfCcAQl0IQcCXiHWhav9JEBATy0ggYbYnSAnII0qOfbBHYs
    VkADGWjGYgJipPEZD0fEt5sCX7CRAGOopZEhcUewcsQXVyQwwU9Q2PHFCOz1lEElRwSQAXMe
    rGLJcAlcAYeRGaTBo0AK4IGEjQo1AMcrlnhQQJA0/FVABs9pgsYERhZkCRMT9LEKK5bUZoh6
    CVCWwGBi4DYQBo10xpACULSyygoFBNEKDVB88WZprRjCHIQCBYpHDq1oAgUNcrRSFphwFDkY
    HCvE1QAP/gl+iZADI2zCihgFnNBKFhnAAR6jq/BAZk80PMIDK1ncVIAHorCSBngTNGJeBoh4
    MJACcpi3UANjbKJJUoaMMkEQ1ioQhCgk1FlQA4bgYQcNXILbSqsTkPAIYwkY0YerK8gR4EEO
    kNCIKExw+Mpx6jVwwrcsGvRqK3aIONgJfWTWyItSPCvQI9o2YAe920JhSSMCNbJJx40YMehB
    7FJIZgNpTPpTBpicQOcYdtRJ2BH/IiQHfwQcMUoWnXEnhSHDDkQYKx00kAOEP/UhcwJ4XHET
    D6N00GRPDTVAgiHVKtBIGkdY64AHo6TQs39jRSDHEQOl0AgmlkARABx25LZC/nnQro1QAy1s
    IuMKkzKBpRiIrE3rKkfcVucJUJCSA5RZXAwcK0rsSEEDQsDlEOet8EAAHJtk0N95owQBbXtZ
    sKJhDp6zK0aHm+BBQAZ2rKJ6TyucJl+Qw43i5XSviqIQ2qt4oEQanWaBiNybfJGlJmnAKRAG
    DeDBg7qo8VBJAjS8IgQF/QVqR9JgovFKC0Lk7J8Qo6ygCYIjWGLHCNw3QAMefgM8Qh8JgAIr
    BAOFI21mZQTBnq6y4IFF9OQEoljBH1rRCDs0IgcrklWgaiSrhuBhBWKwxAgmcDpL8OBfyLGE
    JTpgCZA1IgVZgMURsmAH/3TwPI2wlkRGQAI4wOEE/gEcYQv/NQNEtKIDcnDfBAxBgxPAIgtC
    6AP6jtS7/iUnA2i4QgsSwL4GbAJknSIcK1aQgUfZxA6HoQoPrpQcHviKIqZjwgknYAQW0msw
    rxqFKFJAgDSwwgP5akQCTsCKGTxCCDtCiAKOoKqJYCALQajRBB70ngQ4oAA0iA4r4BAAwmni
    PC3soxyEcLEyCSEIVkwOW5TgqgwQbQVK0Azu8lYWSwQQD8tihRAMwQQEIiQDnFKNEGzAA1kp
    YAZiEINWCvCFRfRBCFfQRAMa0QICbKEVStgEk0TSgBQY4TzdHE4GAKSbAnSoCQEQQyX0wiJL
    jOIKjQhmSE7XgCDIKCc2/lEQE/rwxQI0wRJiOAwS8IAG0jFnJPoD2SIs0YS8KCGJ/QnCHwhA
    g1WcrABva0IaRKG6G4rEAU1ohCYMkQYhcMc/aGhCASyxig4QAC9QuAIeMJFKj+iGTmRygB3E
    owkSBKERTClgn/wzEwdUbhXvymFbCpAnS+SgpiYx2BYK0NPC/CQBQgDLTDhnMhqs839NSgAJ
    VqExmNQTipsQRQtIsC+BcEcIrVDUS7yGhxPELC9saACPIkACViABqhlxAAMWwAAGCEQDHNDA
    BzbBhAWkogc9kMIACjtYC6BCZfIcSGEJS1nCSmSwExCBDqJwhjsMghGDyEMcuACKMNTAFZ8g
    /sQTdHCDGNwABSw4xQwk8IDBFvZQKLhBEqJQhjOcIQoimAADtpaQwXJAB2cAxCUuMYg7dOEH
    KhCBbYdAiTIcohBrKMUk4nCHPPhhEIngRB4AcYczaMEHKHhACbrAhS4swQdJ6AIgTNEJRQAi
    DiVgrkEYgII5KCIPUbhBCQTiW8MeaQR6YEAgTGAEJRjBBQegQBASIIcrSEAEwc1ve2+gXARg
    wAdRSIIOUCACDpwhD3n4QHNVwAgfcAABBnDw9SKkzDZloK0rcEAQDNeHJm12uR8AsQ/eAIgy
    JOHJUYjyGfyrgYRoQLglwG1yG6xjwvhrX2KASwOusAIvsUFtBQFt/hQu4YMyLKG2LK4yA0ow
    3RgkhANdgK9wmTyH4+oguyL4AAb6sAEm4CAEaUAAAmxgBhwYAbLc04AIbtCFPLxBBJ6lrGZ9
    cIdOLyQJZcCCDliA4i6UlhGQuIQjMsGJOHCCDIWowxmqQAk38CEMaoDBB1Cgg+FOob430IAB
    BEyQBcyBtHNYiGE58IM4NJkIMUBBCT5wgTbwAQV8gIEXgACDHUiCDmp4ghdYIIIqT8Dcm50A
    iWf1gUuIoMYM0UAc8oyCc4uABTe4QA8qwQAluIABIGAAAlwQiRDYYQMuWABCChuDOCRkAXEo
    gw8UkdyFcCAPd3CyD8jNAQXQQBQZoEET/qAlAbTRgA1wuSFoY1BaERB7Agu4wSWSMPM7NIQB
    IlAFIIiA3yWEgRJAuEEOEEBZBOiBCRswwwF+q+lJR+ENztaBjgnCAA4wohOXAAQjHH5zFJi6
    C0nwthpkYAUi6MAHN4DBEz4BAyDo4Owx0AAK8JvijU/AADJHiAYUoYo4nOESinDIAybwgSTc
    YQdaoMQSqmDcN9zB72UoQxGcMIQkoF0FHECB5gOtXcMPwgcDngAgAHGDNbt76gmJASNmXgEI
    UMEERKes7DtrbxYMNwpdKG4ZojAEFSg3zSi4gw4mwAVVMKIEqLcyERThZjC8oAIYEKzsXz4Q
    9gwWxzlOPoEZ/kHiLuicA8lXCAM0oIMyOCIUl2BEHs7AhfvqINolKLdl5n9YELPAtvc9iI0Z
    0IVOnIEi49cFUfADIlACvdYFbzAH5TV6GHcGXZB7Z9BnUYAF0XUHXAB6B4EAH3AHlyB1FSEC
    BwZ2KiBjmqVwytUkGKABKniCGIACSdAJjGBuDLYAGtAFl/AGGhB+D8EePnBqirB61MUFwVZ4
    T1aEuOd4gDAIgHBsIrBcvlUCUcAIl2aCGOFbAvEBMRAD0yYCGFABMWB5PnB2lgdnMuZbcveF
    b5AHWIBpOgiA58YByrVcv6dcnHVkhSVgKBAFTqADC/ZbHMEBUbBeZVBxjFEBA1Fl/ozRhYrI
    YFR3hx/BADoQC5eAXHJGWJY4e7KHABOgAsGGEl4HCJCAWhJYhGDoAz5ABEWIBV0QBzgoErLH
    WUQnd/h1e7n3gGUggAJYdyyWBBwhWJw1ARxQApzoAz+gX/EXh3VoiQYgAMvIjDmmASwACGfA
    WXX4WQvgAE7nbIAAY31GXyl2Xz5gZwXBGKWXBBQYB3mgCJeAdZ3md2B3WzLmWcp2ZV2gjoxw
    BwOIAnLWYL+YEHkYBUvwZH/WYpKmeTeAX6bGil2gA2UojwWRBKN3Bj6wZVY4Eb51iTomfSvn
    BKX1g4MwCPMWbKDFYIzABQaQfSqBehoQA5cggGXABT+Q/oPKVQJvIJEVB3PLNXgpgXOAIGyh
    lQRz4APsIVgiMGmY5oK3VW4y2FmY6IfnJoM3N1glAAixcAeG5QALAAA3AAjMZQBtJhAi4AOm
    xmTshXGPB3WsyIpo6Y63GI5Q2YiEhQElIJbq2AVNqAFzaVwLZhAc+AZRsGKBJnc/kATsF5AU
    +AY1yQVJkIUL5gAPoJGadm4foAJiKV2eoAqqcAc8R1wOmAQsQH8GwWuklWJDwAIoYFv5hQWk
    dQZQt14MqITbaJaPR16ueVqMAAg1GWp1l5QYUJELd5GFJQKAwAI5SI0MkGPzp4IYUJT2hwIq
    EH9FWWW9tQAIUIezdxE+wAi3NdlexuWAUTZcT7YEAJkEP4Bfp/hkxIieCsaFHmFYuzaMRhhl
    UZaLrKl7Dlhfuxdll6ePDxEQADs=
}
    
set T12_data {
    R0lGODlhQgBkAPcAANbWxr3e1s7Wxr3W1r3Wzs7OxsbOxr3Ozr3OxrTOz8bGxsbGvb3Gxr3G
    vca9vce9tb29xrXBxsDAwL29tbS9vca1tay+x721vb21tbW1vbW1tb2tta2zvb2trbWttcel
    pa2ttaSvvr2lrb2lpbWlra2ltcacn72cpaWltb2cnKWlrZ2lvZyltcaUnKWctb2UnKWcrb2U
    lMePkrGVo5yctZycrZOet72MnKWUrb2MlL2MjJyUrcaEjL2ElJSUrZCUtb2EjMh8hJSMrZSM
    pZ+Hob17jL17hIyMrYyMpbJ8jpSEpb1zhL1ze4yEpcZre4SEpcZrc4CDrb1re5x2k8Zje8Zj
    c4R7pcZja4R7nHp7pY1znL1hcIRzpcZac8Zaa4RynMZaY3tzpXtznKxgfMZSa7Fac41nj8ZS
    Y8ZSWm9wpXtrnHNrnMZKY8ZKWplafmtrnMZKUr1LX85EUa9ObHdjlHNjnMZCWmtjnMZCUmtj
    lLFEYc45S4NUg2tanHZXjsY5UmtalMY5SmNalFxanI5GdMYxSsYxQmNSlGNSjM4pPbowTFpS
    lKU1XXdGfsYpQmtJhsYpOWNKjFpKlMYhQlpKjMYhOcYhMVJKjJAwYl9ChH81bsYYOcYYMVJC
    jKkiSsYYKbgbPW81dEpCjM4QKcYQMVc4hFI5jMYQKcYQIUo5jM4JIEo5hJMcT38jXsYIKcYI
    IWsmakoxhEIxhMYAIc8ACMYAGMYAEMYACLoAHTkphDkhhAAAAAAAAAAAAAAAAAAAAAAAAAAA
    AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
    AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
    AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
    AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAACwAAAAAQgBkAAAI/gAlCBxIsKDBgwgTKlzIsKHD
    hxAjSpxIsaLFixgzatzIsaPHjyBDihxJsqTJkyhTqlzJsqXLlzBjypzJcgNNhgyu5GBwMyGC
    IlUOmLzgEwEDngwQHOBJEIGTOAiIikxqVAIGDA0YLN1g5AwbPI4cFWKTgqmECwfw/DkwIeTS
    EUvIBKpEytWkP2cqbdrSI8WJES+Y/JlVBcFABpb+mN14AMMGDFUcbXI0yc6ZLVRQ3Zo8ScoL
    CQ0kHD0wghQQBhgOQOFkZzFG1FW8jBAh5QSDDpUKMSk0i3WPqy+WvDiAoCqCE4a0rvYSKKrG
    n3iMXNA6QASQqyfqOnIiIkWODgcG/nRY4sULkxESCLCRUuUWE8tsMzLw0ib1gQ5M2uDpkfVP
    oQ4MBLfECQhsYIcjf8RhRyWzFLLBErVU4kgHs5yGUWiFSEFcB2dscoZtR1lmmGiopeDFH0wY
    IUUOBwQAhC2nuOJIGyeccYpGDDiyBXFFuGIHeA1g8JMRASx2wBJ/nOAIJ2eo9QIZrrxywitL
    vPiCaxOlhcdSTtSSAwFWHSVCFTEYEYMIVzEARZKznKEVAVIs0UAVpxRRCBC1FDGiRQwAwYkE
    CAAxywmNZWUEg5yQImEhhfwRiCtsnAIFmAKNBoQjeE6SgnMYfcLiBqewKOQGgeyVAgYkWoWB
    IR3gcQYB/lIJJCSKJ4oWa0UHnNEcA4WA0dgBQGyyhFauAYvGDYVgyYAIhZwBCZYUNdDBKy8Q
    4MQrAiFQhSsjCNVWQQxEF8gIWCJgR4YWZoRAG44cIEKbRxlRywgIoHpQB4VscUZ8BB1QRSEv
    NHArRqdIQQAZdx5wQp6NIYQAkniIEFq/UMQBLZ8p1HLCCVvgMZwjgfBr0HRtcLKEc0dJ4K+b
    HiEgRS0YAHGpBC/YcmVCy9aS7EAPvlCFFBdbdAECZMyCwQkphNxGJUGLhkctIqD2cINbAJGD
    vR2Z64poGHjBACcaYg1uDrc4Ua9VqFwhAoc3e8TAFqfYCwRuEit0ihNCpdYk/ph2vLCn24XY
    JloHdkx80AGG2CGUaCNU4ncXRhwwMEcMgEEuBkt04DVCB7ChmAQjTOeIFEUY8cffHzEgRQfH
    gbFBugUd4AUZRr3ABgHMvQAEHjo0rdEIRUiQwxaoE0TG6qx7zMArKVQZiEmVY5DD5yNXaUQV
    AQaC+ykMtHFZ8al70R3Tt2qFgRNsGKEVGkZIUIsdEjgSx04lIcDEsKcMJ9pSJ5TMxmdWMQQG
    UmCLJYwgEF4QHEkCBIcA2OgEHUhBFSrhIxG84Aysy0EbCICnIqTAMh04Ca+MMIA2vIIUmwhE
    EUJzhjZkywkaygEpjJADPMRBbCTBQCWIxJMDuIsN/pUAWqX+oD4GVMIJMfhDG8glQhGIhQ1t
    +EOMvJAagpjmKDoCgh3asKNvleQoOfBCHNazgcUNBAOz2AkC/POCQhThFTj8og+JcxAMuOI0
    8+EEBjjRgbCYESWompxoOGE2BjCBaY4YloQw4DuUIOAKjjiKDhyBgTO0iwFO4ETbZMIJHdwn
    SSOoRVkO8AI9ziRQlRBNDqTDiUCgBnH7mgmvmNAYJ6QACrcwQVK8gK2HLOCXF/mlAhTwy2Kq
    jAeKedsMSICLJGQgAnPgBAMWQMwFIISaEihBDVAgAQVI5JcZcIEPmmAFMYhhDWtQgxisMAVX
    YiETh1hEJjJxiU50ohSL/gCEGITATWIOxJsuUAMlJLEISUhCDB6w5kNqcAhKUAIQa7CCEHaA
    ghKAQAMcuIHibqCHCGRgEmOwAAw8oYUn1CGelDjEGprgAW8KAZ0+8IBAPFCDOnSiBgpdyAJA
    QAkxcHMBBRBAAayZAQ1o4ABXiEMAoBAEoziCBwPggSoeYABgZgAGVgCEJJBghSZkwAAS2AE5
    xYCEAgihExpoSAZ8CgBvSgAGTRDDHQABiDus4QhgO0AgWKfDbhkiDg0TCFCD+oROZOCXcK1B
    WhWwgxoIIAx1yOk1YSALQVgBBhrIgA9gINNiGuAKtDDB7hKwhCUoggInGBRTioqCHVjhDovY
    /oFCQQDMnXZiBwpAASUcUoM8dCIVqejEIgQB0TB0tQmsYMUMQDGDKRDCDHyIAiE0kQVzrqEO
    d7CrGHZw2INcYBGHAE0JLpEBnfpADULwwQ52IAQrqGENgBDEIQ4Bi0gg4hGhEIMm1ECHLyB3
    CiAoanklIEzJEmQBa7hpAxTQhDwY2LuuFQMgDlGH46p3BXMohAxMmIItEOILashCIzSRhnWK
    4QtW4KZgD7IAK/RUoYIIwxcY0gAH+ECugrjDZl2AAxaUwRMa2EIl9vCBUbRAMR84xQcW88vQ
    lCAMKJCsAqwgiTVowJqAAK8LGOKBg7qgu0N4QhNYAANOnEAGcuAE/hEYQYgp6MECjNCDDXwg
    BCEc4QlWWMMhOkEJKxSEwZIABAoUoAFApGIVsmUICDoRBpkuGKwcIAImxJAFM7SCD2FoxR1C
    MYhQ+OENDbVnJ0zRCUnkwauSNUATDpGHGhSgBJJYRSeE8GCEgOALdL3DOptgAz0sIQIR0ENI
    WTEFJbB5DsAUSAaWLVgDKwALlKjDDgowhEvEYhFRfsiCG+ABF+xgCE3QBB2qSwg3WCAIiTgA
    GCrxhw5AQJADUag183AILmQ2wanIQ3clQswMhCAJZDCAAkZwhftMAgMVCMQHFsATwxG4wBlo
    wg4MUIJDWGEBEc/xJS5OERCoQRB9CEUj/n5Q3ukw4Aw5iMAQdkCDGsAABSDwwLI9gAJxSjjG
    YRUECqgd0TogItETWUAddHEHIpDBAQqdGCMvAAIXxPUOeajDdfMw1zxElLu/9IAGaiCGJjRB
    EGvYd8fDEIlMiCKfa1inD9IqARBMVL3gbkIYhCCQBlCzyRJAgdeb8NI6ZPsidufBeyl6UZkP
    5KrrXW8N1guCg2i2sXG1Ak5r3fFOwODuBqhqNRdggKEWk5oOH4gGmC4EJIDAnx2xgj0PAVFz
    WuH1QhiCEBovgfIOON4KkEp53foRjLPX63VurAtAEOC7V7OatRdCHQTBdpIUc/PUBIEVwiAG
    6puTC2JQQx2y/pxSK9C+JE0g8EB0DwIYLP73r389EmoAAqSHPiQKEIPfy/t5Yna+8wXI//Nz
    Cm+KGFPZRnVRGfBagCB16GQFSLBePqBe6lUDYgcaxERM7xcRGAcD7fV6YYAFeTZ1XKACTIcC
    dUAJonYId1AH1ddVFCUVC7ADESUEMHBRD+dL3nRV8hVfxNV1YpdZoGFNHtB05ld6XPBe6ORV
    oicEY4VO6IQE3XR3lBdWQrhO6RWFKNB/8fZ5VphsghVxXudegEAJ+aYGKIgChyVZBbBOKCBT
    +ed5WNgRF7Bsy5ZZIFAD7bUGgiCC0mY4qiYGAZZ9TfCCD7eGIlFgFZhggPB9C+AC/q8HbvJH
    XHWQBULAfuWFdBF4hQ6xf5N4hb90AWKQC2uQU9jUAIgYV8tHCfXEZySoXVYgZsHnAmfohodn
    VOVFUwtITulXi9mHTnkgCZYlUwihAd7WXud0CIcmC7LQCXWQB/I1XyhFCeAFCFaHi3Y1BEWl
    TeN0Tul0XSaIgKxofhfAe9dUTDXAfiXQWk73BbHXBEhwBI21Xi5QAoa3g5w3VAqAf2mof7Wn
    TXGlBmLGiw5xXlLHBRKnXuh3TlI3V4LQjCVYB+pkXWlnXdsngsCVCotQYY3XhN/IdGJVTtsn
    XxypT9yUASXgbUPgXtg1YZJQT8ElXPokcWe4hBbJEJJ4E3dnkQE9aFG3Z4mfB4DMZoUMERAA
    Ow==
}
    
set T13_data {
    R0lGODlhQgBkAPcAAL3g3tbWxr3e1s7WxsbWzr3W1r3Wzs7OxrXW1sbOzsbOxr3Ozr3OxsbG
    xsbGvb3Gxr3Gvca9vbXBxsDAwL29tbS9vay+x721vb21tbW1vceurbW1tb2tta2zvb2trbWt
    tcalrcelpa2ttaSvvr2lrb2lpaWtta2ltcacn72cpaWltb2cnJ2lvZyltaWctb2UnKWcrb2U
    lMePkpycrZOet72MnL2MlKWUpZyUrb2ElJSUrZCUtb2EjMh8hJSMrZSMpZ+Hob17jL17hIyM
    rc5zeoyMpbJ8joOMsMZze71zhIyErb1ze4yEpcZre4SEpcZrc4CDrb1re4x7pZx2k8Zjc4R7
    pcZja4R7nHp7pb1hcIRzpcZac8Zaa4RynMZaY3tzpXtznKxgfMZSa7Fac41nj8ZSY8ZSWm9w
    pXtrnM5NWnNrnMZKY8ZKWplafmtrnMZKUr1LX69ObHdjlHNjnMZCWmtjnMZCUmtjlLFEYYNU
    g3ZXjsY5UmtalMY5SmNalGtSlI5GdMYxSsYxQmNSlGNSjLowTMYpSlpSlKU1XXdGfsYpQmtJ
    hsYpOc4hOVpKlMYhQlpKjMYhOVBLlFJKjJAwYl9ChH81blpCjMYYOcYYMVJCjKkiSsYYKbgb
    PUpCjEdClM4QKcYQMVc4hFI5jMYQKV80esYQIUo5jM4JIEo5hEI5lJMcT38jXsYIKcYIIcYI
    GGsmakoxhM4AGs4AEEIxhMYAIc8ACMYAGMYAEKkINMYACLoAHZQMQwAAAAAAAAAAAAAAAAAA
    AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
    AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
    AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
    AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAACwAAAAAQgBkAAAI/gAnCBxIsKDBgwgTKlzIsKHD
    hxAjSpxIsaLFixgzatzIsaPHjyBDihxJsqTJkygZYpjwgMGCBzBTQoRAgkqZNVFKBOGxQGbE
    FDao2FFkiAsDnw9hLmDwIkofOiVWInV4YYGXJIFIpXgw1SEED4w4kDLatWFVNktiROJaluED
    HpgeMNraduGDJLgwlMmyQGpdgxgWsNGVI0ifo38NXnhAIhKdLCsyJS6oFAOpLELYcGjlAcLf
    mBhW8ODSio6BJmIgkCrBtqyHIE2icMlCJcrWBVmyPAj1onVICL4PXsBAwgaPFAwKQLjAgIuN
    Ca16g3QJAQMHEh5atiy4gAQbV7jC/tcSwtYOBg+kPHxk8CBIGUWYMrUipYiLECF+F1C5FYpN
    EuN74BJEATyUQeBaHQG3hGM8kMABBhd48AIPPASh3gMUBBKKDS2x98ACTbhSghglGEAFXxw9
    4AF8QqwAWxZc2DaBAexNwAAJpcU0wQUTrMQBG7jwAFMfdGn0QAqkuLKHHWyssYciewRSSyBJ
    CLTAC60s0RN3HmSiSC0lLMADGwzwmBEEKbiiCyZJJPFIK4qEEkkgduyRRBATRrflQEdRUYtm
    t7yAgSIcdMQJLlyQYMctdHhgwAMYuBeIDQxgggkJkA60AARNkBIIF0mQ4IoNgRSpkSCuvDCB
    Ka4I8UIS/rUJcRwPayxqAwAfMsAAB01gEgkPBWTxwhNKrhDcRYxI9gApjFxggxA25LCEGHtE
    wkYWkYSSCRVCNMFFIJnsISSka2BgCqHHVvRAGbiQYIAimTwAHEwuvfRAFLhQ24cdgewBRxQe
    1GhiH4qUIe9GD7yACx0F7JedmQINN4EHfWDw3QIGZFyAAFt68K2nexoZCC4leHCLEH0d9AAb
    LywgSC08eMDDhGyIEcWie2ShiEcJcxLIAnb0kbJBDDSxhABLuOJdFDYI8koQQgQSSBZrKIJB
    uhatHEgUE6SXLk0GP+BlTxxUO+ZlNjyy8wMQZ3QkG328YIMdZaqcRAoGLKFL/iAMYBDKGjbA
    +QIVrZSBWEcPCJFFIBhYoSUFCGWH5C26kcLtLU2UEEUWYU5nRRQ7s4y1QA9EwkUmJQTiuC48
    GHD1S5B/9IDNa5VhqkEL7DHbUHbwgIsNQ4/0QBZJ7GyDeggtwAUcPEQSBSkkvJJDCdKR1JwQ
    5o2uX6m8pWpHFhcw3qP1USyRhZAIMfBemv5lwgMjBfQuQA7oi5RwGRM0wVJBfe9BBw+ZwEkk
    5vSCFPQBUnvwy0jYcLUSbEVXPQlCKzBBh0C8YA1ZcMUtBBE/IQigDEI4nEgYsIQkdOdE5SvD
    I+bknBRkogxeYMMtniOICZAgEzkYXUcwsAcKwCQF/jwQQhBYkzGs1GJuKwhFaBgGJA6ZZAFl
    YIMBWOKSjCXOdC+IRAn2kAJcTCgLEIjEHlICgUCUa0cesMEWFKGIHAjgCXT4URRqUQaovUAR
    WZDJA9bQCvm0ohV7iAG9rsXDPjQtEjVAgh2i4JmU3IhCgnpJjwQThdJFYgIKS4EQ9oIUegWH
    ATAyQLYmkDtBrAEOZUDeZ17QhwLAQVll0AWjyuDEydRwDaQgZRZ8VYtaNMEAbSuLVTZXCxtF
    gQ0kuAUmSBHCxHwlEnaohQYSEAJFeEAQ8WmVDgviAAc08iLd7GbENiCBLOCiFlPQgQoKgac9
    HHMJKfjmQcQpghnM4AQZ/hCnRBrggAmIAAc+YAITiuCDH+gACKjYBSJY0IExmMEAZXgDLes2
    TwiooApqAAMY+HAKSIABByLoZ0O6mQEfgKEKTMABPicQTgWEoBaCQEUPDLCCQkjAhXdUYEFm
    8AUmqCADJ5iBH06hCVrEQhNgcIgO6uDRGTigARM4AUAFKoUjkCEXGMhDLgoxBEQYAQF9QAIb
    2EAAgzjABzr4gAvQoIm2DgISmlDDIRxxiEFkQJ4F+QAfaAGJDUzABRjNaBFmoAIRfCADnYjE
    Amxwi0I0oQeMWEAO8JCETqgAn+LMAAxwwARH0MIRaqiCUz9wiA8wQRODoIUfEuIAJvjhBF+o
    /gJc1eADfGZgAyJwwQyAsApAjAAEe2hDHrpgCT2cIRGAoEQVwICGOfiBD2jA6CnuoAIHcPYO
    TICAI+bAUYDSogoJyQATNAqGU5jXvKk4RSxowV5VfMITjtDEJUShCVF4whNtlYR5NQHatG6g
    Cl+orkgbsIE5qEENB2ACLVRwgEE4QiENEEFgwaCGOtzBD3fIKBr4AIs/uGEOclgEHxahBjkk
    Agt54EUbTCCCCfDTojBwQATy2tYNNKAKmhBBA9BwioU44ACAVcMMDnCAp3YzAXYABQRQ0AAN
    mKEBbHCABtJAABnYAgUKiAAEwklkkRaWpVWghQ/6CQM+sBQHk1jI/gw20E0wQIIPHz3BBh7Q
    g1logAhsEEAPniAAL6zgBVkIVrwmkIF66oAJGK3DHE4aUhGcYg4OyEADEO2AC0CgDgqBgA9C
    ywQdbHa5akADGFgBiCOsYgo0QMQURhAGI5QhBhNwhW4mcNq2HoIPVagtS1l6B0gQZBAnYOkM
    NOFjf8LAByIYwAEm8AEL4GEVLMhFG2iAAx2gdQqIkKIVXEGQDRzWyOKswKRPcYLlKACj/XSA
    H1bLkG4e4L+hHkIbeDEDQTQC3A5wKSpYE4laQvgHp4ixpIUqkAb44BQtZggEXHAFSHzhAgrQ
    gCx6YIVc7ihioISDAXIQgy2FswF4bQAO/k4xgwbkUwSDaLEDYHAKHYhU4XUILRh2sIk43CAX
    KVBAOJ+qgSYcpQSExu0JXIADJ8CAIAaHRHUv4ACUu+CpOjjFmB9yVj/gYAii0IMcYHGImIta
    o1/QuhoMzIc7WHjRPc1nul2bzzMPQsBVOAUOXu4QByjhFJUQBRQQgYcOnKCwIjDsYTNwgQwI
    pJsNIHKRN8BZF4hgCLuedMrfzQdH6FgiF8ACIuAwA0CUQhK3zqgWqkB6gRbhB0wIqECXiwZR
    M2EGhhdpBjSa7x9AQgtblogDWgCIHhDgBZT46AdEoIIZWDugVdAChSk8h0WLVuX83KkKBiCC
    OvDhBHSHiAOA/lAJv6uhBZ7Z8s4Rn28iD+D8Rc4AZ4NNECOrYMNzxytEhoMDNZzCDz8YxBxE
    QHjF4JazYMBddwAGujYQ/aQCTFB2PuBiGeEAy6UDbtZWmgAJdcUHzTcHFsYHdRBdOtBiRKZz
    AiECAagGPqVPGOEAMzAIRBYAOKAJfOAHg3AIp5AKmjAJg5BhKXVZxDcDP1AETOACAyFnRuYR
    cwAJGeUIRSACG/B+Rph6TKB8Y/eCkEBUfgAGHWiAI+ECp0WDkOAIDuYH1ncHBhZqGYVSaKUC
    0WcSDqACMTcHbTUJPrABhRZ4hhV4QaV6VxgSO2eAPkAIJ8cEavCCfDCIfDAIb6UJ/oeAYSfF
    BAnXfjowdxRhZBmgAgBVBFWgAwOhA2hQBC7mTRfwATOAfBrlBD6AAzBQWME0EBugBhPRdDMA
    iGCQejDAf+0XaWaFb+O3EGjwARGRAXegCadQWixlgiGRAXNgECcgAvI3EHygBh+AA4PQicvY
    EQeAUlBFELOXivnmA4MQAJ5RBYMABkXgArxIfvx0jvw0fuIkY+J3i0/1A37QNkamBuVWEMg2
    AXMAeT+2AT6wYc+lgXPwdV9nhjgwAy4AAy5QWCpwWQdZh4clAkOniaxYZOJ0AkVAgtw0AZuG
    UodwCFWAA/lEZBAAVKGIaBrFXWVHiOtmiDHohRTIkhII+oyqFVBoEIhjNwdSEFIGqABMgH1r
    OF5FRQunMAih5QOzaHhbpniKpwBM2QA6J1Le9n9VwAf4JYFdmIicBlIs5RlPNQEzYGAGCFWa
    NZUyGQueMIOnMAoTaIgwuJIqyZKQMAmQ0IWEEIOX4FYf6XhKeAAKkI4TsAE6oAaGyAQI0U0j
    uQFMMJeXCAMliWixhVI++IQVBoOOAAlqCYbMpVEHZnZjKFqbBYiFyAdacHTX6GMldWFgUFj5
    pABK2ZpEFn2gWAQB6AdTeF5ENYFdmGG5hlnEOFIQMAMnFYhlV4Yo9QM/4AMFJVAUdnbWV4iD
    AF1mSFi8CAHpmH0DERAAOw==
}
    
set T14_data {
    R0lGODlhQgBkAPcAAL3g3tbWxr3e1s7WxsbWzr3W1r3Wzs7OxsbOzsbOxr3Ozr3OxrTOz8bG
    xsbGvb3Gxr3Gvca9vce9tb29xrXBxsDAwL29tbS9vca1tb21vb21tbW1vceurbW1tb2tta2z
    vb2trbWttcelpa2ttaSvvr2lrb2lpbWlra2lta2lrb2cpaWltb2cnJ2lvZyltcaUnKWctb2U
    nKWcrb2UlMePkrGVo5ycrZOet72MnL2MlJyUrcaEjL2ElJSUrZCUtb2EjIyUrch8hJSMrZSM
    pZ+Hob17jL17hIyMrYyMpbJ8jsZzhIOMsMZze5SEpb1zhL1ze4yEpc5rc8Zre4SEpcZrc4CD
    rb1re5F7nIx7pZx2k8Zje8Zjc4R7pcZja4R7nHp7pY1znL1hcIRzpcZac8Zaa4RynMZaY3tz
    pXtznKxgfM5SY8ZSa7Fac41nj8ZSY29wpXtrnM5NWnNrnMZKY8ZKWplafmtrnMZKUr1LX85E
    Ua9ObHdjlHNjnMZCWmtjnMZCUmtjlLFEYYNUg8Y5UmtalMY5SmNalM4yQlxanMYxUmtSlI5G
    dMYxSlpalMYxQmNSlLowTMYpSlpSlKU1XXdGfsYpQsYpOc4hOVpKlMYhQlpKjMYhOcYhMVJK
    jM4bL19ChH81bsYYOcYYMVJCjMYYKbgbPW81dM4QKcYQMVI5jMYQKV80esYQIUo5jM4JIEo5
    hJMcT38jXsYIKcYIIcYIGGsmakoxhLkILc4AGkIxhMYAIc8AAMYAGMYAEKkINMYACMYAAJQM
    Q0IphAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
    AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
    AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
    AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAACwAAAAAQgBkAAAI/gArCBxIsKDBgwgTKlzIsKHD
    hxAjSpxIsaLFixgzatzIsaPHjyBDihxJkuODkhsfxPBwEuXFBzk2eVjg8qIGVrKcaFBAs6bE
    BVt+8crUx0iFlj4faqjUq1CYPoxyKBC44AEIDRCSIsw6hpeoQbN+0amggYoHDXO0KlxgQgqe
    LVYYjc1RycQTIz3VGnywgGdfEztBVNoSBqneghksZEh8UoNVUZUOQ8yggAkvEFlHPtj8AALn
    iapyGO7IVwOLH1LCzHFjRcVohgsYhVGQwePmH33oDKrEm5EoVarIOH44QZSj1xgfmIhUyAgd
    VJvC/DChwsggWYWGNwTBixFyiw94/mxyYqKS0E2MGFWaA6JAhTWiYtBe+OBHLzoLamuEOShu
    r01GqFCCByDEEAZvOQAAQiY/KKCBQg8UgkoY+W3kQXqy9PKHAgYYoAAEGjimQA5/4PGgKD8Y
    8ABPoz0wgyib/PDdRAu48csmZPQxVQ45MjLIID4WUYEKdGiQgShKWLEFeVURZMkfljy4nwm9
    DFKCGyqEIZcTObBQQgkFSlGIEwqAsMYsvagyCB2ZMGLCSbFVEt1UGmkgihsGaOBGKGv88MQg
    okCHnhtFgEAGGZvwsgl0K1ZABy+uMZKJI6JwtAAddACQAyp08ECHLJwWoQIIFfDgxhxhlNDL
    LCpAQAcj/n3wVUAlqmxSKyolzBgRBCU4osAMqMRghZoxrNjkAyyEQYYboujSKm10yGlFGKL0
    wgsqbmiXkQJkWKFBInr24YECJyk2EF8P0PGLFAaUIAUjuswSliyVMKJKCXRyNAgIbhgahgEL
    2cnLv1sAc4cHOWyhmwEgqEKqSSX8YQILRZCpH0IPGPGLE5jy4oQbFSzgxBqqmKBAJXiZ9ENh
    FYCgq0APhCJKbL/8AIAVZFT1hC5PFICpgxst0MUPedH3wy9GKKAKnjFo8IdjKuiC54FFJ0dG
    sQ49YMkmCsSASgUZuLGAdAUYIUofBoSxycsPZeDYE641hGwvORRARRgCFPGE/oMaLPAHHXik
    nUmFF/F71KgOKUBHIXyF4dq+MMdQiROFFMDIhsn9QIcCFjyk3CY7/ZAiHbNRVckTUmwoy2xS
    VvRAEWHo5DkjP+S9udkC7WSEKgow4kQJvLyJ0QJWuIEl2wL14YQAUgxylCp4OWYCKoWAIIpz
    hQD9Eh1/SKd9Qg84UewgeFSggCOMZ7CABpsYaMQmbqjigUZ+ixKGLCa3vtfhEz5gQBeqqM0D
    VCALJmSgC3Rww+ny9RL7mKFWUoHZhyrgGQWYYA59EEUOFrAAI8yiBBBQwNHoUIAnhKEQVqAD
    8pQiC/TFxQ2bMYIUStCyGJCBF7IgQwb4UgS6kSso/nOoyiDcoCwrcC4lltAFGRzhBBhtQXOV
    CAUvcCiFnYTMCb1glwYG0QstrMgKlmAECOYgI5OQ4ReMiF8m3ICHeqGCF3TIQcgEooAn/GIL
    BSgBcFQwFRP4jhEsiJJHjnQfLs5CSDzAmRVEZT5H9QKPOeDFH3IFgiKUQAMekCEjGLifGcwC
    W3PoRS/m8IACnGQzHujCLGTxgwLkoBdkwAEZDNAH0SxgDSaYk/40ooAtoCKNTwgFMFDEFw88
    gRF4kI8BVECLQ1YCJvgJj5J4sUuTMOtHP9iCKnrBiCL8wAksiIER5gCvNaFCAyBAxZvQojEn
    DDAkYwsFHvpAxC0UYhOh/hhEbqSzmumBSRaiecCyWPEHA0xnhRPpGpBiF4YwGOFBfCEXGTzJ
    gnQGdAaZIMW9SvAEhFJkM0WAVQ5I1ROo0SEUMTCBsxwEAaZcLwZSmF9JqvIDSYUhBkcBERV4
    8YMKzIJMfdMYKkCAGqLVhC8qUGAl/vCHPvBiDgXYBB3y9AANzAJ0IKCCCqpZkhUpBwca+IEu
    KvADUqhANBXYRCHMV4SkqcVtR1kRJ9xQAFFIIQYpYsQsBGiFGXhUIxBwgAMa4ACB1OAWJ6gB
    L2KgBgkwYRdxIEAEEtAFDjwgAgsRLGEFO9jCRmSwFRhBD7ggB0JIAhOfWMUbBBGLLATiBpOA
    /kUdfKADG6TBBigYQQgE0lnPgm0FOoACF+AgBzlwYQQVcEBmFDLYDvRADo8YxSgkQQg0NIEE
    kJhECwQBCkoQYg+KMIUhDEEIQ0hCEo9I7yMIIYcyCGEFEUABGs6AhikIAQpoeIQtWoGJR/gB
    Bcs9iANWAAhMGIILOkABbwmbAE6QQQBUwMUhJJAAJuACA4QN8AZGAFz8slcHyU1ABoTABSj0
    YAUj6IAcxrtbhDgABpoQQgcScADfgk0DDOjDIARwNCtsJgzU3IpmlRsCDguBD4+AAxSWzIUm
    y6G/G0jIBoKLghXIALm9LaxVSFGCHPwioHjohWsuJuAGVIALoxAC/hymUFsUR9kBKJCuDRLS
    ATS8N7hIBoRxewCDEYyAAmGoFS4K0YAE5GEXUSAAZ21cgQ3rAA2G4MMICJtcwQ7EAUIghKYX
    AgU4iKEHMiAxGkqriU5IFxOrSLUp+CAHSsSCEl8ocQ90EIIV9EC4XqCvDjZwgAAXpAGAIC0g
    MluBDgzBD0lGgg1WgIIQoIAEbPBFHUigh0m44AqLgEUTbAADZke50bwFLYi3EoJRjCDGDNmA
    H+y8gkaPQAYJToAJVHGKQwiABq7AMA1wwYEEcFbADrCBHxLSAD/AQQiYQO5COkBeJQvhyt+u
    AIrwsLYLhEI0FKiEjMi84ArYoLQj8LVA/hqgg1FAweSEaIgDRpCLRyDhvlwoAxcWEQgKnGIL
    BGjAIWiQAALkYQeSDXdodcAFPiC7B4zmbQc00YpRPEITA1f5CkaNhiX7AAzBOMIVgnEFHehg
    EkTowQ0WkYUe2GADK4A5FB5egQOUHCEbwEQu/CCHUWDCIZgNARQIMdolsPYLb6gFIfjwBkpQ
    ogpQaEIdZg2DDqzg8bodgQ32LgkhGKSw6SW6dEeQ9IPYQBMm5/UARHCJFwggCJeYrAM8wXPB
    lmDDMhAuF9BAXDhw4QgwSG5BBsz3CpwhF5pAQecPsgEkYML2NkhBKXJgABGcQgQIcEAhZrmV
    5Bb6ADVO+oA1/gFiNLS8A8N38QZ6gAZNCCMVjbCDKUBxBCC0IRAkyG3El7thK9tAB/Y9iIwd
    gIZWyIEiDrABtjcEH1ADk9AGVbAHhAAIyPYI5CUHaEB7cqBnXCAG0EUIZ2B5B5EAIUAIo4B0
    FTECBlZ1epAEFyAQgeVZyiUQGbABLphcEJABKwAFraAJEWd9G4AGo8AHGxB+DZEVQrBikoAI
    oGd3Z7BrerdkSjh7fEAIj4BewcZ5gUVYKMAFmiBpZpYRnQU2IWADuFVkGXABkycEQtAD9yUE
    bbZbnYV2k8cHhiAGk+aDElFYG9ABlZYVKrhZQyZYvrYCXIAFPaBglsYRHcAFhpBk/gpXGyco
    EFFWG2H4iLxFEJwlclrYA8IwCsf1ZoS1iYvWiQlQATCwazUxdY/QCZogCRSohGtHhkKABEoo
    BmjgBzwoEou2Wf6Gdvcle7QXgXCABrPXZGuHYlDAEVNoaR2AAqEoBEOQX7lVaXq4iQcwANEo
    jTW2ATLwCHKwWXo4hw0AASNAdA04Xno2XyVmX0IwZ4hRAUQHBRboB4aACaPQdJpGd1WnAyuw
    W5SWWVOGBvCoCYTABUOwAm/WW5ulEH7IBVOwZHyWYvUHXPc1arKIBj2ghvlYEFCQXnIgBFi2
    hRPRWZzoWykIWjaABaWFCacoCeu2a6DFW5pwBtg3iDXB/mgbYAOj4ItwcAZD0IPJhQKsppED
    kWGY5RMr9wi8FlpQAAhCkBWB5Wc6MGkzaI8j8ILhlmWdOBBS6RCahQKPIAyEUFgQ0AABoAOP
    EGAHoGYCMQJCMGpItl7kRQiy6AdvyQdGB5cQ2IvneIOS2FkZgAJpCY9owHkbwJfFpWAG4YF8
    wAUnpltoNwRQIAdnkJAWKJeOCQVeqGAQEAEh+W+NFgIwkJbR9Qq5kAuE8HLDBYFQIAMUhBC2
    RloldgQysAL3h19iQFpyYHSHmF7mhZtt6ZZ+UF7pJQmaoAmPwGqeVmJoiGIZwJEu5pGCNQKP
    IAM9qI0OUGOp6YIZ4Gcc9powSpBbfhZlETBYCaCHVWkRQhCc61VcxeWLJVZiUDAFCAkFQ3CG
    rrh2jLl2CTYCHKeFFVBrybiETdZk6lmbtQeB9GV7TYaG3YaXChEQADs=
}
    
set T15_data {
    R0lGODlhQgBkAPcAANbWxr3e1s7WxsbWzr3W1r3Wzs7OxrXW1sbOxr3Ozr3OxrTOz8bGxsbG
    vb3Gxr3Gvca9vb29xrXBxsDAwL29tbS9vay+x721vb21tbW1vceurbW1tb2ttb2trbWttcel
    pa2ttaSvvr2lrb2lpaWtta2lta2lrb2cpaWltb2cnKWlrZyltaWctb2UnKWcrbGVo5yctZyc
    rZOet72MlL2MjJyUrcaEjL2ElJSUrZCUtb2EjIyUrch8hJSMrZSMpb17jL17hIyMrYyMpYOM
    sMZze71zhL1ze4yEpc5rc8Zre4SEpcZrc4CDrb1re4x7pZx2k8Zjc4R7pa5rgsZja4R7nHp7
    pb1hcIRzpcZaa4RynMZaY3tzpXtznMZSa41nj8ZSY8ZSWm9wpXtrnM5NWnNrnMZKY8ZKWpla
    fr1LX3djlHNjnMZCWmtjnMZCUmtjlLFEYc45S4NUg3ZXjsY5UmtalMY5SmNalM4xSs4yQmtS
    lI5GdMYxSlpalMYxQmNSlGNSjLowTFpSlKU1XXdGfsYpQsYpOWNKjM4hOVpKlMYhQlpKjMYh
    OVBLlMYhMVJKjJAwYl9ChH81bsYYOcYYMVJCjKkiSsYYKbgbPW81dM4QKcYQMVc4hFI5jMYQ
    KV80eko5jEo5hJMcT38jXsYIKcYIIUoxhMYAKUIxhMYAIcYAGMYAEMYACLoAHTkphDkhhAAA
    AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
    AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
    AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
    AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
    AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAACwAAAAAQgBkAAAI/gAnCBxIsKBBgw6atHBwsKHD
    hxAjFnTQ4gtDiRgzaiTooM6IixtDijSoYE8TBRdGqhypYE6bBBRWysx4QcGXTjNzYnQwQ9VC
    nUAfdvoCM6hRjkBIUQB51KiCLnsmPGjaVMGPLyKoVsXAQavXr2DDih1LtqzZs2jTql3Ltu3R
    BA4udJjgQIHbgwk6QNmTiBChNj8cTL07QUGHNprW6OiAocOMOXMwMCXroDLBBEAWWemQQEEE
    ug4K6JDUAaQDDBgETjYKpMiM1KfXrOGQYDDBCwUyD0yQwohADjpWz3SQAAOUNX0IceigqUnt
    lAcvJGhjpYCDJIRSJ/gCRPjKBCfK/rT5YsWKmTakkhSA7tBBikkd+FoRkUBHH+8ZmT5wsGSO
    jgt1JTABKWYkwB5Ei4ySRBONJDACKjPgh9EMBGHwhRF1CQTgHpNIWFBJQPTUwgmpQGGXSgks
    eGIEJ3DGEQ2rBIdRTTdJAoURJZ7Ikg6dzDXQdSLY5gCHHn7YhRktWJHICQKqRJEqc+g4AQcz
    2DZBB6kkgdJE3jmA5AQn0CVTBISsYsWWP3JUBCqp/agABi2IYBlBD4hQx49FPuSADqlAKKEC
    bSxiWgdzjKKJJoSkwJQDWABhV30yjuSAX5p8BFEnUao2QyqLzECBcaNYOlCYAmGxho8iUTTK
    Ep202ZB7/qmscRpFqZgxJwFLrIGmmA78YEVtKikABSE8QqRAEZM0oVojBQ70QHFtCDcninVY
    MYMmVpLUhH90zcCmbVBgcVVcE40wHLEjjOLqQQo0gQVqJRXCFHCj1DGZAklYkSdEk7SAASk/
    NaSAEURNgAEqWOw6AQFQrJIESPgSsu9DGIzSQgKTONpeC1pUBoRPk3VgBRSdXPTACK1O7BAH
    pMxAwBdzFNUQBlbQNYm8HyYRJylz1dQHGMXN9G8R4E2yrkEPLNTTCfqJcBJzWVHEs04OTGKG
    Ag60oUWTr07QSYFHd+UA1IXtUQfXMimABU4OnGBJV+0RsohqcF2kQAtLiJAy/paBUT1CKgs5
    MEcTBRwN4AWTCFqcDk20hsFUizgmyX4/kHK0TEOeLdAcNxTAEXid7FGcGaZ8XQTTDkgCxASS
    WJQ1IVLO9EAHqMiIwRpWSGZXC2ugAgUBTaQiiQ4TwFU4IXnv0XJlrRsIFI2pcMDQdeOZIcko
    hIyQwByrWHQiTzZaUYcOhKg2yZkH5uRAGZPQhYGAJ8yQAgdY9wF4kwm0QMgcJ8gN/NZLOV/Q
    jJIALCxCMrCxjJdIIb3HXaB3WiKE6CawBx85YBEnoUoCjCAJRXGkBan4SEoQRwjOLKIRxMGC
    cwaiiUhV5QRmAIJtFGAGoqQEUH1IQIpUIYK7leEi/u6xRPqOUpms/GgRfZuA3uR0wYKdICYG
    K2AGwWKlB2hCC4Vzz32U2KOpmOYEFjmLA6bgE89hYA/0m4HEkDYDuJ3lAWso0cKw8AUCnGBu
    hBmIAm7QCU2EqRMzSEAfZhA7t1TGDKq4AQgnMANB5VFDEyiAFVIxASjUgQBlyNRIGsBJmXCS
    AQzgpCiL14etEeIEC3gDGjIAAg9kQCoNCGUDGhLLCZQgBiiYAANCwskMsAAHR4gCF7hABjKI
    gQtMOMMeChAHSPiBD57YBCMoQc1A0IELPchlKAeySxaIQRGICAQiEMEFD8wyIzHwgyIUQQcy
    RKEHNUBBCUCwgQyosQBS/nhDBTwggTdcwgQ18EEU1OCHQCjCD2Q4ggd22YNi4sADAvFADNRA
    iRicEyINAIEiuJDLBhhAAAaYZQY2sIEEEIEQBCDCFzxnsEwsYQCiFKkLokAHRAghCkfIAAIm
    UINgckEIBugBJTYgkQxwFAC7nIALjsAFNtCBDmwgQw4AoYUDfIEH+LOC6Nbl0Y8qgRIZ4ORS
    Y0BUBtQgBgLYghouSksXnMIOUXBBPXHgAoiKEgEayMQIHnCJF4yUn0ZAA9dGioIaRIENgajB
    OUHQyYxSogYMQIEiMBIDN1DiE5+gRCDs0M4tRMEJOzhDKCxQhEugoAfBjEIkskCFYZJBDWyI
    /ioXahDW6ATCD1IpgSNe+ZAG4EAMPcBBDWrQgyiIgQx0sIMf7GAIT9iBDZiIwxa4IAYmeEEP
    OCjBSHn7SbYSpAFkqOgDGHAEN3g3OoblAh38oAacHkG4NbAAGg4xtlG8gAlZqEIaRGFMLggz
    C1HIpUDOO4EGRGGj57TDFrIQkQdAAAdNfS5dWRCDGqzgCaoAQgC0AIcBQIABI6ggA6zEyamU
    YAsoYCsDooAIMmxglnS4LQsi4gFysqC2PlDCEWoAggpMYg8D8EAlnpCDeAriCYXFAQ56EAQl
    RIEMfqCEIqJQEPIigg4oYMAG6PAJUCg2IiCgxBYgOt6dgiAGR4iE/iiyMIQ4RKIKfmCDJ9q5
    XkVQkxKcoAQi3JBTtiLgCH5wQwwMUAJEgIISPSDwQUCQhaeywb87DsELWCEFC0hBECvwAQz0
    cAYSlFggGQj1gL3LACooQg01MIAPHFGKQKQ4I+N9gAdYQNwjbGG/g9jBEy7xAQYo4ANj2GlE
    zjlLN/jhCvUM7yfcUNuQhDIDKECBAvCAB7sswgYCasAXNKAACGRLlM/eMQJK4IcoNCADR3iu
    I8w9EhCIwQ6cDcMj5iABwQEBJhl4whlWcNZ5ujIDHkDBL9WrYJ7aAQWqdqca/vBlkTRADa6g
    Qw0cgIQ7wGUKWB0ICFDAVDa44bVkcINT/j8eBdpy0gMbiAEXjpBuMjS73VywQyAo4Yk8kEEO
    cZABRCcAAngK1wcs30IPBPKAWH6a4yxvqBpeLZOiT4CYOADBDV4gAaKC2gXDHW6FeXyQDAgX
    zf61qKJFEmaxNwABRr9rSGM64oNs4AI9FwIItmmUKFDTD+0cZhT23gMf9AAEoJ4AbwcSS+i8
    MqlNOXetj9ADeMaABSAAQVhDKUtZCr4HarCD1cECbraDIArTne4wr0BdNcT4oFEAvFiOUOCB
    GB4ELtg6ave+dyHEAAQQaEC2tMIALiz9lWw/uwEQYIDir93org/KKEFNUnpm4LB0UEMx3SmE
    4Sq5Bl9/uVQo/q97T2bABcXd+xao8OTXuuEKKoA7CtRg57uzQQ1c8OyOUQCdBtTAnT1wAT0L
    PHaD1PL7ypVcnLVyL1dPsDQBHgACLBB7PSAEV3BcxZRTA7EBs0dM0ycEupR2DlEDEOhfwfWB
    9DdsMTWCnUR46MZyxkUHirBsYoBT8RRWbGUA/oUCEGV8MUUVFxBqoVZPZ1ZcZGAHdoZqtvFn
    XCB51HUE+sd/Jch5afd94UUHqldgLLB3QOd7nKUGVdADt/dKucd9I4gRneeFJNgAF8AFrUAG
    F1VLDzCFTJV5iuAI1HRQsUUG/qVjjVcDLECDOjgQI2WAEqVkqUV7tEddxeQGiABXxjvndrRW
    XMTkB112CqdACWrgBsrlB5ZoUIpwW3TwcYUYVT4wUrcETBZ4XGoAf1EgBHkYexeAeLQkSjFw
    eyVQWCxwBFnQd0cgBEFwVsPFAiXgSkTHScQXS8RnfDYoeLfEVGKgY4koEb8lfVewY/BVgSDn
    VDKHd++nBsfkWnToWqZnZ5j1CYHQXoDXfwfBSXDXU8Jkesq1jteUSxlQArQmUGIAW+uFCHCY
    WZp1TfMHUZanEl2IfDmYgPM0eGF4g4JXT8BnkA8REAA7
}
    
foreach i [info globals T*_data] {
	image create photo $i -data [set $i]
	unset $i
}

set sequence {
	1 2 3 1 2 3 1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 10 11 12 13 14 15
	10 11 12 13 14 15 10 11 12 13 14 15 10 11 12 13 14 15 10 11 12 13 14 15
}

proc cycle {{count 0} {delay 150}} {
	global sequence

	if {$count >= [llength $sequence]} {
		set count 0
	}
	.l configure -image T[lindex $sequence $count]_data
	update
	after $delay "cycle [incr count] $delay"
}

label .l -bg white
pack .l
catch {wm title . "Java cup"}
cycle
