<document>
<hr>
<slide id=position caption="Position paper: Web Agent Support Program">
@* <a href=@talk-proposal.html target=_top>Proposal: Web Agent Support Program</a>
<p>presented at <a href=http://www.cs.vu.nl/~eliens/WWW6> WWW6 -- Logic Programming Workshop </a>
<hr>
<p>Anton Eli&euml;ns, Paul de Bra, Jan Treur, Frances Brazier, Hans van Vliet
<hr>

<h4>Abstract</h4>
<p>The WASP project concerns the development
of Web Agent Support to enable average users
to keep track of relevant information on the Web.
</slide>
<p>
In a relatively short time, the Web has become
a de facto standard for the dissemination
and retrieval of information.
Due to the exponential growth of the Web
and the information that it provides,
finding relevant information has become more and more
difficult.
In particular, browsing is in most cases no longer
appropriate for the user who is searching
for particular pieces of information.
<p>
It is our view that, in the near future,
access to the Web will increasingly be mediated
by intelligent helper applications,
<i>software agents</i>,
that assist the user in finding relevant
and  interesting information.
The goal of our project <i>WASP</i> is to provide support
for developing such agents.
<p>
By combining our joint expertise,
we plan to develop a framework that encompasses
modeling aspects as well as the realization of
software assistants for intelligent Web access.
As testified by the references,
<slide id=expertise caption="Our expertise">
<p>our expertise covers
<ul>
<li> the realization of Web-aware applications,
<li> client- and server-side support
for information retrieval and information
maintenance, and
<li> modeling and specification of cooperative agents in
a multi-agent framework.
</ul>
</slide>
Combining our experience and the technology that resulted
from our previous research activities
enables us to develop a practical framework for
designing and implementing
intelligent Web agents and to tackle the research
issues involved in the definition and realization
of personal software assistents that help
the average user to disentangle the complexities of the Web.
<slide id=framework caption="Framework">
<p>
The project is envisaged to result in a framework
providing support for:
<ul>
<li> intelligent navigation and information retrieval,
<li> information and document maintenance,
<li> user interfaces for Web-aware applications,
<li> dynamic documents with user-defined applets,
<li> declarative descriptions of agent-behavior based
on user-preferences,
<li> declarative modeling of coordinated and cooperative
behavior of software agents, and
<li> programming single and multi-agent systems.
</ul>
</slide>
As an target product for the WASP project, which allows
us to demonstrate our results to the scientific community
and other interested parties, we envisage to develop
<b>Pamela</b> (<i>Personal Assistant for Maintaining
Electronic Archives</i>),
an application combining the functional and
architectural features mentioned above.




<h2>Agents</h2>

The notion of <i>agents</i> has become a powerful metaphor
for designating autonomous intelligent processes
that aid the user in managing the complexity
of a variety of tasks, including information retrieval,
activity scheduling and process monitoring.
<slide id=aims caption="Our project aims ...">
<p>
Our project aims at providing insight in and solutions
for 
<ul>
<li> modeling the behavior of cooperating agents
<li> generic means for realizing actual agents in a Web-aware context
<li> architectural support for programming agent-based systems
</ul>
</slide>
In effect, <i>agents</i> have been characterized
as the dominant human-computer interface of the future&nbsp;<cite file=index><a href="index.html#Negro">Negro</a></cite>.
The aspects of our research as indicated above 
address the problems involved in defining and realizing
the potential of the <i>agent</i> metaphor as a
human-computer interface in the distributed information
system domain, in particular the Web.


<h4>Modeling agent behavior</h4>
The ability to model the behavior of solipsistic
and cooperative agents is a prerequisite for
(a) managing the complexity of defining agent behavior,
and (b) for adapting the behavior of agents to
user preferences or circumstantial conditions.

<h4>Realizing agents</h4>
We choose for aiming our project at realizing
agents in a Web-aware context
(a) because the Web provides a rich reservoir
of information,
and (b) the Web offers a suitable infrastructure
for defining an actual graphical user interface
for employing agents.
In particular, agents may be integrated with
standard means for accessing the Web by means 
of applets.
Further we wish to supply a language that allows
us to program the behavior of agents in a straightforward
way, adequate with respect to the models described
at a more abstract level.

<h4>Architectural support</h4>
The architectural requirements for realizing agents
in a Web-aware context consists of
(a) high-level support for distribution
to allow for notification and the communication between
agents,
(b) access to the Web both in terms
of server-side and client-side computation,
and (c) support for information retrieval and 
data management.

<h4>Discussion</h4>
Currently agents are in the focus of interest
of numerous research groups&nbsp;<cite><a href="index.html#Internet">Internet</a>,<a href="index.html#Softbots">Softbots</a>,<a href="index.html#Software">Software</a>,<a href="index.html#Architecture">Architecture</a>,<a href="index.html#Survey">Survey</a></cite>.
However, one may observe a divergence between
purely formal approaches and purely pragmatical
approaches, that provide an operational realization
of agents lacking a solid foundation.
<p>
Although many of the ideas and concepts
underlying agents have been a topic of
research for decades, notably issues
concerning distributed systems and
programming language design, the notion of agents
itself hase become a major research topic
only recently.
A survey of agent theories, architectures
and languages is given in &nbsp;[<cite><a href="index.html#Survey">Survey</a></cite>].
As concerns agent theories, the main focus of
attention lies on a logical analysis
of intentional notions underlying the behavior
of single agents, whereas for agent architectures
issues of communication and cooperation between agents
have been addressed in more detail.
In &nbsp;[<cite><a href="index.html#Survey">Survey</a></cite>], concurrent logic programming languages
are considered to be the ancestors of agent languages.
Of immediate relevance for our own work is the
Oasis programming language described in &nbsp;[<cite><a href="index.html#Oasis">Oasis</a></cite>],
which bears a close resemblance to the
distributed logic programming language DLP &nbsp;[<cite><a href="index.html#DLP">DLP</a></cite>].
<p>
Recently, commercial agent systems have been developed for the Web.
For example, General Magic has launched its
Telescript Agent System, a system that employs
mobile agents defined in General Magic's Telescript language.
Also in &nbsp;[<cite><a href="index.html#Internet">Internet</a></cite>], a number of agent-like programs
are described.
We are reluctant to qualify these systems as 'agents',
however, since they are defined in a purely operational way.
We find, for complex agents anyway, a more explicit
representation of the intentional aspects desirable.
<p>
In a recent issue of the CACM( 37(7), July 1994),
some current trends and applications of agent research
are presented.
From our perspective we consider as important representatives
of ongoing research:
&nbsp;[<cite><a href="index.html#Software">Software</a></cite>],
that describes the agent communication language
KQML (Knowledge Query and Manipulation Language);
&nbsp;[<cite><a href="index.html#Architecture">Architecture</a></cite>], which describes the complexity of integrating
collections of agents;
and &nbsp;[<cite><a href="index.html#Softbots">Softbots</a></cite>], which describes a number of simple agents
for facilitating access to the Web.




<h2>Realization</h2>

For each of the levels or facets indicated,
that is <i>modeling</i>, <i>realization</i>
and <i>architecture</i>, we will briefly describe
the way we plan to tackle the problems involved.

<h4>Modeling the behavior of cooperative agents</h4>
Our approach will be based on the work already done in the context of 
DESIRE &nbsp;[<cite><a href="index.html#Desire,KAW95,Multiagents,Compositional">Desire,KAW95,Multiagents,Compositional</a></cite>]. In effect, DESIRE 
provides a compositional modeling framework
in which the cooperation between multiple components can be expressed in 
a declarative manner (with temporal semantics
&nbsp;[<cite><a href="index.html#KAW96,JELIA94,ECAI94,META94">KAW96,JELIA94,ECAI94,META94</a></cite>]). In particular, DESIRE has been
employed for describing cooperative multi-agent systems for project
coordination, negotiation and monitoring processes
&nbsp;[<cite><a href="index.html#Modeling,ModelAge96,ModelAge97,ATAL96,ICMAS96,Cooperation">Modeling,ModelAge96,ModelAge97,ATAL96,ICMAS96,Cooperation</a></cite>].
Research in this area
will be focussed on defining cooperation in information-retrieval tasks
and on expressing user-preferences and information-needs in an adequate
way. Other topics of interest include modeling users as agents and the
verification of agent specifications.

<h4>Realizing Web-aware agents</h4>
The development of Web-aware applications
has been addressed in the DejaVu project &nbsp;[<cite><a href="index.html#Applications,Music">Applications,Music</a></cite>].
The approach taken there was to employ
object-oriented design technology
for realizing a component-based approach
to integrating multimedia in 
Web-based hypermedia applications.
The development of generic components
for realizing agent-based systems will
be addressed in the same fashion,
in order to allow for the integration
of adequate multimedia and graphical
user interface support.
<p>
It is our intention to employ the distributed
logic programming language DLP &nbsp;[<cite><a href="index.html#DLP">DLP</a></cite>] as a high-level
vehicle for programming the behavior of agents.
We strive on the one hand for a close integration
of the DESIRE framework and DLP and on the
other hand to extend DLP with the primitives needed
to access the Web and to create adequate graphical
and multimedia user interfaces.

<h4>Architectural support</h4>
To support cooperating agents over a network
we need to provide
point-to-point communication as well
as event-based notification.
We intend to use the Orbix/CORBA Object Request Broker
as an object-level mediator for the communication between agents
and the communication of agents with Web server and client
applications.
<p>
Currently, we are actively employing Orbix/CORBA
to develop an workbench for groupware task analysis and
a distributed architecture for visualisation (DIVA).
<p>
To allow for managing the information retrieval and management tasks involved
in dealing with the Web, helper applications must be developed which
employ the native HTTP protocol of the Web, and which perform automatic
Web navigation. Such tools are often called robots or spiders.
An information retrieval tool &nbsp;[<cite><a href="index.html#Bra,Fish,Search">Bra,Fish,Search</a></cite>] has been developed at the
TUE. Two implementations of this tool exist: one which is integrated in
a WWW browser, and one which is a CGI-script for use on servers.
The latter implementation now exists in a multi-threaded version,
using multiple search-agents operating in parallel. Current Web developments
make it possible to integrate such agents into browsers in a flexible way
by means of applets or plug-ins. For server-based applications servlets
or server plug-ins can be used to avoid the overhead generated by the
CGI protocol and by invoking individual instantiations of CGI-scripts.
<p>
A method for improving the use of the internal structure of documents has been
defined and implemented by means of object-oriented databases.
An intelligent retrieval helper application needs to be aware of the internal
structure of documents, and needs to be able to store the information it
finds using a similar structure. Also, it needs to have direct access to the
links between documents; this information is embedded within the text of the
documents. A Web-server based on the object-oriented database Ode has been
developed for this purpose &nbsp;[<cite><a href="index.html#OODB">OODB</a></cite>]

<h4>Pamela</h4>
First of all, it must be remarked that the target
system <i>Pamela</i> is explicitly intended to stimulate and
regulate the cooperation between the participating
research groups.
<slide id=pp caption=PAMELA>
<display>
  <b><i>P</i></b><font color=red>ersonal</font>
    <b><i>A</i></b><font color=red>ssistant for</font>
      <b><i>M</i></b><font color=red>anaging</font>
        <b><i>EL</i></b><font color=red>ectronic</font>
          <b><i>A</i></b><font color=red>rchives</font>
</display>
<p>as a target application ...
</slide>
<p>
As concerns its functionality,
<slide id=pamela caption="target application: PAMELA">
<p><i>Pamela</i> provides
<ul>
<li> autonomous and on-demand search capabilities
<li> (user- and system) modifiable user preferences, and
<li> (multimedia) presentation facilities
</ul>
</slide>
A more detailed specification of its functionality, however,
must be considered as one of the tasks of the project.

<slide id=technology caption="As concerns technology">
<h4>Discussion</h4>
<p>As concerns technology, the realization of WASP
(and in particular Pamela) is based on the programming
language DLP (extended with Internet capability),
and the facilities provided by the <i>hush</i> library
and its extensions (both developed by SE/VU,
see refs [17,19,20]).
<p>
In addition, at the level of design, we exploit
DESIRE (developed by AI/VU, see refs [1,2,16,22] of the proposal).
In effect, the integration of these technologies (DESIRE and DLP)
contributes to the originality of our approach.
<p>
From an architectural point of view our approach
is basically a client-server architecture, with <i>agents</i>
as user-dedicated clients.
For the communication and Internet capabilities
we exploit existing technology (TCP/IP, HTTP, CORBA).
</slide>
<p>
Needless to say that we wish to maintain
a close integration between the efforts involved
in the research concerning the aspects mentioned.
In particular, we intend to develop a prototype agent
application <i>Pamela</i> (Personal Assistent for Managing
Electronic Archives) as a point of reference
and as a means of coordinating the research done
by the parties involved.
In addition, the Pamela application will serve as means
to demonstrate the power of our approach to the scientific
community and the rest of the world.




<h2>A framework for Web-aware agents</h2>

The WASP project is aimed to result in
a framework (in its extended meaning) for the
development of agent-based Web-aware applications.
<slide id=web-aware caption="A framework for Web-aware agents">
<p>A framework for Web-aware agents includes
<ul>
<li> a <i>methodology</i> for developing agent-based applications, as well as
<li> a <i>logical foundation</i> for modeling agent behavior; and in addition
<li> <i>guidelines</i> for realizing actual agent applications, and
<li> <i>software components</i> that can be used as building blocks, including
<li> a <i>language</i> for programming agent behavior.
</ul>
</slide>
In addition we wish our work to result in a generic
agent application <i>Pamela</i> that demonstrates the
capabilities of our approach.
The intended results, divided over the various aspects
of our project, are summarized below.

<slide id=modeling caption="Modeling">
<h4>Modeling the behavior of cooperative agents</h4>
<ul>
<li> a formalism for modeling cooperative agents
<li> logical foundations of agent behavior
<li> modeling user preferences in information retrieval
<li> modeling circumstantial awareness and negotiation
</ul>
</slide>
<slide id=realizing caption="Realizing Web-aware agents">
<h4>Realizing Web-aware agents</h4>
<ul>
<li> generic agent software components
<li> user interface components for managing agents
<li> communication primitives for agent communication
<li> guidelines for developing agent systems
</ul>
</slide>
<slide id=support caption="Architectural support">
<h4>Architectural support</h4>
<ul>
<li> an agent-based programming language
<li> a high-level API for Web-aware applications
<li> an object-based framework for distributed agent applications
<li> tools for agent-based information retrieval and management
</ul>
</slide>
<h4>Pamela</h4>
The Pamela application is intended as a vehicle
to demonstrate the various aspects of our project.
For a selected domain, which will be chosen in the
course of the project, we will produce
a Personal Agent for Maintaining an Electronic Archive
that assists the human user in gathering material for
which a preference has been indicated.
Gathering information will be done in cooperation
with personal assistants defined for other human
users. Pamela will be able to notify the human
user about the discovery of any relevant material
and will provide for multimedia facilities to
present the material and to browse related information.





<h2>References</h4>

<bibliography><dl>

<dt><a name=Support>Support</a>
<dd>A.T.M. Aerts, P.M.E. De Bra and J.T. De Munk,
Supporting Hyperdocuments on World Wide Web, Proceedings of the Interdisciplinary 
Conference on "Informatiewetenschap", Delft, 1996.

<dt><a name=Tasks>Tasks</a>
<dd>Brazier, F.M.T., Treur, J., Wijngaards, N.J.E., and Willems, M.
Formal specification of hierarchically (de)composed tasks. In: Gaines, B.R.
and Musen, M. (eds.), Proc. of the 9th Banff Knowledge Acquisition
for Knowledge-Based Systems Workshop, University of Calgary, 
1995.

<dt><a name=Multiagents>Multiagents</a>
<dd>Brazier, F.M.T., Dunin Keplicz, B., Jennings, N. and Treur, J.,
Formal specification of multi-agent systems: a real world case. In: Lesser, V.
(ed.). Proc. 1st International Conference on Multi-Agent Systems
ICMAS 95. pp. 25-32. AAAI Press, Menlo Park, 1995.

<dt><a name=Modeling>Modeling</a>
<dd>F.M.T. Brazier, B. Dunin-Keplicz, N. Jennings and J. Treur,
Modelling distributed industrial processes in a multi-agent framework, In: G.
O' Hare and S. Kirn (eds.), Towards the Intelligent Organisation - The
Coordination Perspective, Springer Verlag, 1996

<dt><a name=Compositional>Compositional</a>
<dd>Brazier, F.M.T., Dunin Keplicz, B., Jennings, N. and Treur, J.,
DESIRE: Modelling Multi-Agent Systems in a Compositional Formal Framework. International Journal of Cooperative Information Systems vol. 6,
M. Huhns, M. Singh (eds.), Special Issue on Formal Methods in
Cooperative Information Systems: Multi-Agent Systems, 1997.


<dt><a name=ModelAge96>ModelAge96</a>
<dd>F.M.T. Brazier, P.A.T. van Eck, J. Treur,
Modelling cooperative behaviour for resource access in a compositional multi-agent environment, Proc. MODELAGE'96 Workshop, Portugal

<dt><a name=ModelAge97>ModelAge97</a>
<dd>F.M.T. Brazier, B. Dunin Keplicz, J. Treur, R. Verbrugge,
Modelling internal dynamic behaviour of BDI agents. Proc.  MODELAGE'97 Workshop, Italy

<dt><a name=ATAL96>ATAL96</a>
<dd>Brazier, F.M.T., Jonker, C.M., Treur, J.,
Formalisation of a cooperation model based on joint intentions, In: J. Muller, M.  Wooldridge, N.R. Jennings (eds.),
Intelligent Agents III, (Proc.  Third Int. Workshop on
Agent Theories, Architectures and Languages,
ATAL'96), Lecture Notes in AI, Springer Verlag, 1997, to appear


<dt><a name=KAW96>KAW96</a>
<dd>Brazier, F.M.T., Treur, J., Wijngaards, N.J.E.,Willems, M.,
Temporal Semantics of Complex Reasoning Tasks. In: B. Gaines, M.
Musen (eds.), Proc. 10th Banff Knowledge Acquisition Workshop,
KAW'96, University of Calgary, 1996



<dt><a name=User>User</a>
<dd>F.M.T. Brazier, J. Treur, N.J.E. Wijngaards,
Modelling Interaction with Experts: the Role of a Shared Task Model, In: W. Wahlster (ed.),
Proc. European Conference on AI,  ECAI'96, John Wiley and Sons,
1996


<dt><a name=Cooperation>Cooperation</a>
<dd>F.M.T. Brazier, C.M. Jonker, J. Treur,
Modelling Project Coordination in a Multi-Agent Framework. Proc. Fifth Workshops on Enabling 
Technologies: Infrastructure for Collaborative Enterprises (WET 
ICE'96), IEEE Computer Society Press, 1996


<dt><a name=Tower>Tower</a>
<dd>P. De Bra, G.J. Houben, Y. Kornatzky,
An Extensible Data Model for Hyperdocuments, Proc. 4-th ACM Conf. on Hypertext, pp. 222-231, 1992.
Also at: <A HREF="http://www.win.tue.nl/~debra/echt92/final.ps">http://www.win.tue.nl/~debra/echt92/final.ps</A>

<dt><a name=Browsing>Browsing</a>
<dd>P. De Bra, G.J. Houben, Y. Kornatzky,
A Formal Approach to Analyzing the Browsing Semantics of Hypertext, Proc. CSN-94 Conference, pp. 78-89, 1994.
Also at: <A HREF="http://www.win.tue.nl/~debra/csn94/csn94.ps">http://www.win.tue.nl/~debra/csn94/csn94.ps</A>

<dt><a name=Bra>Bra</a>
<dd>P. De Bra, G.J. Houben, Y. Kornatzky, R. Post,
Information Retrieval in Distributed Hypertexts, Proc. RIAO-94 Conference, pp. 481-492, New York, 1994.
Also at:
<A HREF="http://www.win.tue.nl/~debra/riao94/explore.ps">http://www.win.tue.nl/~debra/riao94/explore.ps</A>

<dt><a name=Dress>Dress</a>
<dd>P.M.E. de Bra and A. Aerts,
Multi-user publishing in the Web: DreSS, a document repository service station, Proc. NLUUG Autumn Conference "Publishing on the World Wide Web", pp. 13-26,
1995.
Also at:
<A HREF="http://www.win.tue.nl/~debra/dress/dress-paper.html">http://www.win.tue.nl/~debra/dress/dress-paper.html</A>



<dt><a name=Fish>Fish</a>
<dd>P.M.E. de Bra and R.D.J. Post,
Searching for arbitrary information in the WWW: the Fish-search for Mosaic, (on-line) Proc. 2nd Int. World Wide Web Conf., 1994.
Available at:
<A HREF="http://www.ncsa.uiuc.edu/SDG/IT94/Proceedings/Searching/debra/article.html">http://www.ncsa.uiuc.edu/SDG/IT94/Proceedings/Searching/debra/article.html</A>

<dt><a name=Search>Search</a>
<dd>P.M.E. de Bra and R.D.J. Post,
Information retrieval in the World-Wide Web: making client-based searching feasible Proc. of the 1st Int. World Wide Web Conf., Journal on Computer Networks and
ISDN Systems, No 27, pp. 183-192, Elsevier, 1994.
Also at
<A HREF="http://www.cern.ch/PapersWWW94/reinpost.ps">http://www.cern.ch/PapersWWW94/reinpost.ps</A>

<dt><a name=Applications>Applications</a>
<dd>M. van Doorn and A. Eli&euml;ns,
Integrating WWW and Applications, Proc. of the 3th Int. World Wide Web Conf. --
Technology, Tools and Applications,
Computer Networks and ISDN systems,
Vol 27. No 6, Elsevier, 1995, pp. 1105-1110,
Also at
<A HREF="http://www.igd.fhg.de/www/www95/proceedings/papers/48/main.html">http://www.igd.fhg.de/www/www95/proceedings/papers/48/main.html</A>

<dt><a name=Compositional>Compositional</a>
<dd>Dunin-Keplicz, B. and Treur, J.,
Compositional formal specification of multi-agent systems. In: Wooldridge, M. and Jennings, N.R. (eds.)
Intelligent Agents. Lecture Notes in Artificial Intelligence, Vol. 890,
Springer-Verlag, pp. 102-117, 1995.

<dt><a name=ICMAS96>ICMAS96</a>
<dd>B. Dunin-Keplicz, L.C. Verbrugge,
Collective commitments, Proc. of the Second International Conference on Multi-Agent
Systems, ICMAS'96, MIT Press, 1996

<dt><a name=DLP>DLP</a>
<dd>A. Eli&euml;ns,
<i><a href=http://www.cs.vu.nl/~eliens/books/dlp> DLP - A language for distributed logic programming</a>, </i>Wiley (1992)


<dt><a name=OO>OO</a>
<dd>A. Eli&euml;ns,
<i><a href=http://www.cs.vu.nl/~eliens/book/poosd.html> Principles of Object-Oriented Software Development</a>, </i>Addison-Wesley (1995)

<dt><a name=Hush>Hush</a>
<dd>A. Eli&euml;ns,
<a href=http://www.cs.vu.nl/~eliens/hush/> Hush -- a C++ API for Tcl/Tk</a>, The X Resource, Issue 14, April 1995, pp. 111-155

<dt><a name=Animate>Animate</a>
<dd>A. Eli&euml;ns, J.R. van Ossenbruggen, S.P.C. Sch&ouml;nhage,
Animating the Web -- an SGML-based approach Proc. Int. Conf. on 3D and Multimedia on the Internet, WWW and Network,
Bradford, 17-18 April 1996, Britisch Computer Society

<dt><a name=JELIA94>JELIA94</a>
<dd>J. Engelfriet, J. Treur,
Temporal Theories of Reasoning. In: C.
MacNish, D.Pearce, L.M. Pereira (eds.), Logics in Artifical
Intelligence, Proceedings JELIA 94, Lecture Notes in Artificial
Intelligence, Vol. 838, Springer-Verlag, 1994, pp. 279-299. Also in:
Journal of Applied Non-Classical Logics 5(2), 1995, pp. 239-261.

<dt><a name=ECAI94>ECAI94</a>
<dd>Gavrila, I.S. and Treur, J.
A formal model for the dynamics of compositional reasoning systems, In A.G. Cohn (ed.), Proc.
11th European Conference on Artificial Intelligence, ECAI'94 ,
John Wiley & Sons, Chichester, 1994, pp. 307-311.



<dt><a name=Desire>Desire</a>
<dd>Langevelde, I.A. van, Philipsen, A.W. and Treur, J.,
Formal specification of compositional architectures. In: B. Neumann (ed.) Proc. 10th
European Conference on Artificial Intelligence, ECAI'92, John Wiley
and Sons, Chichester, 1992, pp. 272-276.

<dt><a name=OODB>OODB</a>
<dd>J.T. de Munk, A.T.M. Aerts, P.M.E. De Bra,
OODB Support for WWW Applications: Disclosing the internal structure of Hyperdocuments, TUE Computing Science Reports No. 96-08, ISSN 0926-4515, 1996.
Also at: <A HREF="http://www.win.tue.nl/~wsinatma/dbswww.html">http://www.win.tue.nl/~wsinatma/dbswww.html</A>
 
<dt><a name=Music>Music</a>
<dd>J.R. van Ossenbruggen and A. Eli&euml;ns,
Bringing Music to the Web, Proc. of the 4th Int. World Wide Web Conference '95 --
The Web revolution,
World Wide Web Journal, O'Reilly and Assoc., Inc., pp. 309-314,
Also at 
<A HREF="http://www.w3.org/pub/Conferences/WWW4/Papers/143/">http://www.w3.org/pub/Conferences/WWW4/Papers/143/</A>

<dt><a name=Logical>Logical</a>
<dd>Treur, J. and Willems, M.,
A logical foundation for verification. In: Cohn,
A.G. (ed.) Proc. of the 11th European Conf. on AI, ECAI'94. pp.
745-749, John Wiley & Sons, Chichester, 1994.

<dt><a name=Verification>Verification</a>
<dd>Treur, J. and Willems, M.,
Formal notions for verification of dynamics of knowledge-based systems. In: Ayel, M. and Rousset, M.C. (eds.)
Proc. of the European Symp. on the Validation and Verification of
Knowledge-Based Systems EUROVAV'95. pp. 189-199. Chambery:
ADERIAS-LIA, 1995.

<dt><a name=META94>META94</a>
<dd>Treur J.,
Temporal Semantics of Meta-Level Architectures for Dynamic Control of Reasoning. In: L. Fribourg and F. Turini (ed.),
Logic Program Synthesis and Transformation-Meta-Programming in
Logic, Proceedings of the Fourth International Workshop on
Meta-Programming in Logic, META'94. Springer Verlag, Lecture
Notes in Computer Science, vol. 883, 1994, pp. 353-376.

<dt><a name=VE95>VE95</a>
<dd>C. Visser and A. Eli&euml;ns,
A Language System Architecture for the Interoperability of Distributed Multi-Paradigm Objects, European Research Seminar on Advances in Distributed Systems,
L'Alpe d'Huez, April 3-7, 1995

<dt><a name=SE>SE</a>
<dd>J.C. van Vliet,
<i>Software Engineering -- Principles and Practice </i>Wiley (1993)
 
<dt><a name=Chatting>Chatting</a>
<dd>M. van Welie and A. Eli&euml;ns,
<a href=http://www.cs.vu.nl/~martijn/chatting.html>Chatting on the Web</a> ERCIM W4G Workshop, 7-9 febr 1996, GMD St Augustin, Germany
(availble at 
<A HREF="http://www.cs.vu.nl/~martijn/chatting.html">http://www.cs.vu.nl/~martijn/chatting.html</A>
 

<dt><a name=Oasis>Oasis</a>
<dd>F-C. Cheong,
<i>Oasis: an agent-oriented programming  language for heterogeneous distributed  environment, </i>Dissertation Univ. of Michigan, 1992

<dt><a name=Internet>Internet</a>
<dd>F-C. Cheong,
<i>Internet Agents: Spiders, Wanderers, Brokers and Bots </i>New Riders, 1996

<dt><a name=Softbots>Softbots</a>
<dd>O. Etzioni and D. Weld,
A Softbot-based interface to the Web, CACM 37(7), 1994, pp. 72-76

<dt><a name=IsIt>IsIt</a>
<dd>S. Franklin and A. Graesser,
Is it an Agent, or just a Program?: A taxonomy for autonomous agents, Report Institute of Intelligent Systems, University of Memphis 

<dt><a name=Software>Software</a>
<dd>M.R. Genesereth and S.P. Ketchpel,
Software Agents CACM 37(7), 1994, pp. 48-53

<dt><a name=Java>Java</a>
<dd>J. Gosling and H. McGilton,
The Java(tm) Language Environment: A White Paper Sun Microsystems, available at 
<A HREF="http://java.sun.com/whitePaper/java-whitepaper-1.html">http://java.sun.com/whitePaper/java-whitepaper-1.html</A>

<dt><a name=Negro>Negro</a>
<dd>N. Negroponte
<i>Being Digital </i>New Riders, 1995


<dt><a name=Architecture>Architecture</a>
<dd>D. Riecken
M: An architecture of integrated agents CACM 37(7), 1994, pp. 107-116

<dt><a name=Survey>Survey</a>
<dd>M. Wooldridge and N.R. Jennings
Agent Theories, Architectures and Languages: A Survey In: Wooldridge, M. and Jennings, N.R. (eds.)
Intelligent Agents, Lecture Notes in AI, Vol. 890, pp. 1-39, Springer-
Verlag, 1995.

</dl></bibliography>





<!--</document>-->
