// MovingUpAndDown.java

import com.sun.java.swing.*;
import com.sun.java.swing.event.*;
import java.awt.*;
import java.awt.event.*;

class MovingUpAndDown extends JFrame
implements ActionListener, ChangeListener
{
	private JTextArea m_text;
	private JProgressBar m_bar;
	
	MovingUpAndDown()
	{
		JSlider slider = new JSlider(SwingConstants.HORIZONTAL, 0, 200, 50);
		slider.setMajorTickSpacing(50);
		slider.setMinorTickSpacing(5);
		slider.setPaintTicks(true);
		slider.setPaintLabels(true);
		slider.setToolTipText("Move to change the progress bar");
		slider.addChangeListener(this);

		m_bar = new JProgressBar();
		m_bar.setOrientation(SwingConstants.VERTICAL);
		m_bar.setMinimum(0);
		m_bar.setMaximum(200);
		m_bar.setValue(50);
		
		m_text = new JTextArea(5, 40);
		JScrollPane scroll = new JScrollPane(m_text);
		
		JButton quit = new JButton("Quit");
		quit.setToolTipText("Use this button or windowclose to exit");
		quit.setActionCommand("quit");
		quit.addActionListener(this);
		
		addWindowListener(new MyWindowAdapter());	
		setTitle("Moving Up and Down");
		Container c = getContentPane();
		c.setLayout(new BorderLayout());
		c.add(slider, "North");
		c.add(m_bar, "West");
		c.add(quit, "South");
		c.add(scroll, "Center");
	}

	// ActionListener
	public void actionPerformed(ActionEvent event)
	{
		String command = event.getActionCommand();
		if (command.equals("quit")) quit();
	}
	
	// ChangeListener
	public void stateChanged(ChangeEvent event)
	{
		JSlider slider = (JSlider) event.getSource();
		int value = slider.getValue();
		m_text.append("New value: "+value+"\n");
		m_bar.setValue(value);
	}
	
	// WindowListener
	class MyWindowAdapter extends WindowAdapter
	{
		public void windowClosing(WindowEvent event)
		{
			JFrame frame = (JFrame) event.getSource();
			frame.dispose();
			quit();
		}
	}
		
	private void quit()
	{
		System.out.println("Gracefully exiting the application");
		System.exit(0);
	}

	public static void main(String args[])
	{
		Frame frame = new MovingUpAndDown();
		frame.pack();
		frame.setVisible(true);
	}
}