<html><head><title></title></head>
<body bgcolor=#ffffff>
 
<a href="cover.html">[Top]</a> <a href="obmod2.html">[Prev]</a> <a href="idlsyn.html">[Next]</a> <a href="corb2pra.html">[Bottom]</a>
<hr><br>
 
<a name="446864">
<h1> CORBA Overview  </h1>
</a><dl>
<p align=right clear=all>
<b><font size=7>
2 
</font></b>
</p>
<hr><a name="446181">
 The Common Object Request Broker Architecture (CORBA) is structured to allow integration of a wide variety of object systems. The motivation for some of the features may not be apparent at first, but as we discuss the range of implementations, policies, optimizations, and usages we expect to encompass, the value of the flexibility becomes more clear.<p>
</a><a name="446345">
FIG.  2	 A Request Being Sent Through the Object Request Broker<img src="local/images/arch2a.gif"> <p>
</a></dl>
<a name="446346">
<h1>	2.1	  Structure of an Object Request Broker</h1>
</a><a name="446350">
 <a href="arch2.html#446345">FIG. 2 on page 2-1</a> shows a request being sent by a client to an object implementation.The Client is the entity that wishes to perform an operation on the object and the Object Implementation is the code and data that actually implements the object. The ORB is responsible for all of the mechanisms required to find the object implementation for the request, to prepare the object implementation to receive the request, and to communicate the data making up the `request. The interface the client sees is completely independent of where the object is located, what programming language it is implemented in, or any other aspect which is not reflected in the object's interface.<p>
</a><a name="445904">
FIG.  3	 The Structure of Object Request Broker Interfaces<img src="local/images/arch2a1.gif"> <p>
</a><a name="445908">
<a href="arch2.html#445904">FIG. 3 on page 2-2</a> shows the structure of an individual Object Request Broker (ORB). The interfaces to the ORB are shown by striped boxes, and the arrows indicate whether the ORB is called or performs an up-call across the interface.<p>
</a><a name="445909">
To make a request, the Client can use the Dynamic Invocation interface (the same interface independent of  the target object's interface) or an OMG IDL stub (the specific stub depending on the interface of the target object). The Client can also directly interact with the ORB for some functions.<p>
</a><a name="445910">
The Object Implementation receives a request as an up-call either through the OMG IDL generated skeleton or through a dynamic skeleton. The Object Implementation may call the Object Adapter and the ORB while processing a request or at other times.<p>
</a><a name="445911">
Definitions of the interfaces to objects can be defined in two ways. Interfaces can be defined statically in an interface definition language,  called the OMG Interface Definition Language (OMG IDL). This language defines the types of objects according to the operations that may be performed on them and the parameters to those operations. Alternatively, or in addition, interfaces can be added to an Interface Repository service; this service represents the components of an interface as objects, permitting runtime access to these components. In any ORB implementation, the Interface Definition Language (which may be extended beyond its definition in this document) and the Interface Repository have equivalent expressive power. <p>
</a><a name="445916">
FIG.  4	 A Client using the Stub or Dynamic Invocation Interface<img src="local/images/arch2a2.gif"> <p>
</a><a name="445917">
The client performs a request by having access to an Object Reference for an object and knowing the type of the object and the desired operation to be performed. The client initiates the request by calling stub routines that are specific to the object or by constructing the request dynamically (see <a href="arch2.html#445916">FIG. 4 on page 2-3</a>).<p>
</a><a name="445921">
The dynamic and stub interface for invoking a request satisfy the same request semantics, and the receiver of the message cannot tell how the request was invoked.<p>
</a><a name="445926">
FIG.  5	 An Object Implementation Receiving a Request<img src="local/images/arch2a3.gif"> <p>
</a><a name="445927">
The ORB locates the appropriate implementation code, transmits parameters and transfers control to the Object Implementation through an IDL skeleton or a dynamic skeleton (see <a href="arch2.html#445926">FIG. 5 on page 2-4</a>). Skeletons are specific to the interface and the object adapter. In performing the request, the object implementation may obtain some services from the ORB through the Object Adapter. When the request is complete, control and output values are returned to the client.<p>
</a><a name="445931">
The Object Implementation may choose which Object Adapter to use. This decision is based on what kind of services the Object Implementation requires.<p>
</a><a name="445936">
FIG.  6	 Interface and Implementation Repositories<img src="local/images/arch2a4.gif"> <p>
</a><a name="445940">
<a href="arch2.html#445936">FIG. 6 on page 2-5</a> shows how interface and implementation information is made available to clients and object implementations. The interface is defined in OMG IDL and/or in the Interface Repository; the definition is used to generate the client Stubs and the object implementation Skeletons. <p>
</a><a name="445941">
The object implementation information is provided at installation time and is stored in the Implementation Repository for use during request delivery.<p>
</a><a name="445942">
<h2>	2.1.1	  Object Request Broker</h2>
</a><a name="445943">
 In the architecture, the ORB is not required to be implemented as a single component, but rather it is defined by its interfaces. Any ORB implementation that provides the appropriate interface is acceptable. The interface is organized into three categories:<p>
</a><a name="445944">
	1.	 Operations that are the same for all ORB implementations<p>
</a><a name="445945">
	2.	 Operations that are specific to particular types of objects<p>
</a><a name="445946">
	3.	 Operations that are specific to particular styles of object implementations<p>
</a><a name="445947">
Different ORBs may make quite different implementation choices, and, together with the  IDL compilers, repositories, and various Object Adapters, provide a set of services to clients and implementations of objects that have different properties and qualities.<p>
</a><a name="445948">
There may be multiple ORB implementations (also described as multiple ORBs) which have different representations for object references and different means of performing invocations. It may be possible for a client to simultaneously have access to two object references managed by different ORB implementations. When two ORBs are intended to work together, those ORBs must be able to distinguish their object references. It is not the responsibility of the client to do so. <p>
</a><a name="445949">
The ORB Core is that part of the ORB that provides the basic representation of objects and communication of requests. CORBA is designed to support different object mechanisms, and it does so by structuring the ORB with components above the ORB Core, which provide interfaces that can mask the differences between ORB Cores.<p>
</a><a name="445950">
<h2>	2.1.2	 Clients</h2>
</a><a name="445951">
 A client of an object has access to an object reference for the object, and invokes operations on the object. A client knows only the logical structure of the object according to its interface and experiences the behavior of the object through invocations. Although we will generally consider a client to be a program or process initiating requests on an object, it is important to recognize that something is a client relative to a particular object. For example, the implementation of one object may be a client of other objects.<p>
</a><a name="445952">
Clients generally see objects and ORB interfaces through the perspective of a language mapping, bringing the ORB right up to the programmer's level. Clients are maximally portable and should be able to work without source changes on any ORB that supports the desired language mapping with any object instance that implements the desired interface. Clients have no knowledge of the implementation of the object, which object adapter is used by the implementation, or which ORB is used to access it. <p>
</a><a name="445953">
<h2>	2.1.3	 Object Implementations</h2>
</a><a name="445954">
 An object implementation provides the semantics of the object, usually by defining data for the object instance and code for the object's methods. Often the implementation will use other objects or additional software to implement the behavior of the object. In some cases, the primary function of the object is to have side-effects on other things that are not objects.<p>
</a><a name="445955">
A variety of object implementations can be supported, including separate servers, libraries, a program per method, an encapsulated application, an object-oriented database, etc. Through the use of additional object adapters, it is possible to support virtually any style of object implementation.<p>
</a><a name="445956">
Generally, object implementations do not depend on the ORB or how the client invokes the object. Object implementations may select interfaces to ORB-dependent services by the choice of Object Adapter. <p>
</a><a name="445958">
<h2>	2.1.4	 Object References</h2>
</a><a name="445959">
 An Object Reference is the information needed to specify an object within an ORB. Both clients and object implementations have an opaque notion of object references according to the language mapping, and thus are insulated from the actual representation of them. Two ORB implementations may differ in their choice of Object Reference representations.<p>
</a><a name="445960">
The representation of an object reference handed to a client is only valid for the lifetime of that client. <p>
</a><a name="445961">
All ORBs must provide the same language mapping to an object reference (usually referred to as an Object) for a particular programming language. This permits a program written in a particular language to access object references independent of the particular ORB. The language mapping may also provide additional ways to access object references in a typed way for the convenience of the programmer. <p>
</a><a name="445962">
There is a distinguished object reference, guaranteed to be different from all object references, that denotes no object. <p>
</a><a name="445963">
<h2>	2.1.5	  OMG Interface Definition Language</h2>
</a><a name="445964">
 The OMG Interface Definition Language (OMG IDL) defines the types of objects by specifying their interfaces. An interface consists of a set of named operations and the parameters to those operations. Note that although IDL provides the conceptual framework for describing the objects manipulated by the ORB, it is not necessary for there to be IDL source code available for the ORB to work. As long as the equivalent information is available in the form of stub routines or a runtime interface repository, a particular ORB may be able to function correctly.<p>
</a><a name="445965">
IDL is the means by which a particular object implementation tells its potential clients what operations are available and how they should be invoked. From the IDL definitions, it is possible to map CORBA objects into particular programming languages or object systems.<p>
</a><a name="445966">
<h2>	2.1.6	 Mapping of OMG IDL to Programming Languages</h2>
</a><a name="445967">
 Different object-oriented or non-object-oriented programming languages may prefer to access CORBA objects in different ways. For object-oriented languages, it may be desirable to see CORBA objects as programming language objects. Even for non-object-oriented languages, it is a good idea to hide the exact ORB representation of the object reference, method names, etc. A particular  mapping of OMG IDL to a programming language  should be the same for all ORB implementations. Language mapping includes definition of the language-specific data types and procedure interfaces to access objects through the ORB. It includes the structure of the client stub interface (not required for object-oriented languages), the dynamic invocation interface, the implementation skeleton, the object adapters, and the direct ORB interface. <p>
</a><a name="445968">
A language mapping also defines the interaction between object invocations and the threads of control in the client or implementation. The most common mappings provide synchronous calls, in that the routine returns when the object operation completes. Additional mappings may be provided to allow a call to be initiated and control returned to the program. In such cases, additional language-specific routines must be provided to synchronize the program's threads of control with the object invocation.<p>
</a><a name="445969">
<h2>	2.1.7	  Client Stubs</h2>
</a><a name="446904">
 For the mapping of a  non-object-oriented language, there will be a programming interface to the stubs for each interface type. Generally, the stubs will present access to the OMG IDL-defined operations on an object in a way that is easy for programmers to predict once they are familiar with OMG IDL and the language mapping for the particular programming language. The stubs make calls on the rest of the ORB using interfaces that are private to, and presumably optimized for, the particular ORB Core. If more than one ORB is available, there may be different stubs corresponding to the different ORBs. In this case, it is necessary for the ORB and language mapping to cooperate to associate the correct stubs with the particular object reference.<p>
</a><a name="446946">
Object-oriented programming languages, such as C++ and Smalltalk, do not require stub interfaces.<p>
</a><a name="445971">
<h2>	2.1.8	 Dynamic Invocation Interface</h2>
</a><a name="445972">
 An interface is also available that allows the dynamic construction of object invocations, that is, rather than calling a stub routine that is specific to a particular operation on a particular object, a client may specify the object to be invoked, the operation to be performed, and the set of parameters for the operation through a call or sequence of calls. The client code must supply information about the operation to be performed and the types of the parameters being passed (perhaps obtaining it from an Interface Repository or other runtime source). The nature of the dynamic invocation interface may vary substantially from one programming language mapping to another. <p>
</a><a name="445973">
<h2>	2.1.9	  Implementation Skeleton</h2>
</a><a name="445974">
 For a particular language mapping, and possibly depending on the object adapter, there will be an interface to the methods that implement each type of object. The interface will generally be an up-call interface, in that the object implementation writes routines that conform to the interface and the ORB calls them through the skeleton. <p>
</a><a name="445975">
The existence of a skeleton does not imply the existence of a corresponding client stub (clients can also make requests via the dynamic invocation interface). <p>
</a><a name="445976">
It is possible to write an object adapter that does not use skeletons to invoke implementation methods. For example, it may be possible to create implementations dynamically for languages such as Smalltalk. <p>
</a><a name="445977">
<h2>	2.1.10	 Dynamic Skeleton Interface</h2>
</a><a name="445978">
 An interface is available which allows dynamic handling of object invocations. That is, rather than being accessed through a skeleton that is specific to a particular operation, an object's implementation is reached through an interface that provides access to the operation name and parameters in a manner analagous to the client side's Dynamic Invocation Interface. Purely static knowledge of those parameters may be used, or dynamic knowledge (perhaps determined through an Interface Repository) may be also used, to determine the parameters.<p>
</a><a name="445979">
The implementation code must provide descriptions of all the operation parameters to the ORB, and the ORB provides the values of any input parameters for use in performing the operation. The implementation code provides the values of any output parameters, or an exception, to the ORB after performing the operation. The nature of the dynamic skeleton interface may vary substantially from one programming language mapping or object adapter to another, but will typically be an up-call interface.<p>
</a><a name="445980">
 Dynamic skeletons may be invoked both through client stubs and through the dynamic invocation interface; either style of client request construction interface provides identical results.<p>
</a><a name="445981">
<h2>	2.1.11	 Object Adapters</h2>
</a><a name="445982">
 An object adapter is the primary way that an object implementation accesses services provided by the ORB. There are expected to be a few object adapters that will be widely available, with interfaces that are appropriate for specific kinds of objects. Services provided by the ORB through an Object Adapter often include: generation and interpretation of object references, method invocation, security of interactions, object and implementation activation and deactivation, mapping object references to implementations, and registration of implementations. <p>
</a><a name="445983">
The wide range of object granularities, lifetimes, policies, implementation styles, and other properties make it difficult for the ORB Core to provide a single interface that is convenient and efficient for all objects. Thus, through Object Adapters, it is possible for the ORB to target particular groups of object implementations that have similar requirements with interfaces tailored to them.<p>
</a><a name="446033">
<h2>	2.1.12	 ORB Interface</h2>
</a><a name="446034">
The ORB Interface is the interface that goes directly to the ORB which is the same for all ORBs and does not depend on the object's interface or object adapter. Because most of the functionality of the ORB is provided through the object adapter, stubs, skeleton, or dynamic invocation, there are only a few operations that are common across all objects. These operations are useful to both clients and implementations of objects.<p>
</a><a name="446035">
<h2>	2.1.13	 Interface Repository</h2>
</a><a name="446036">
The Interface Repository is a service that provides persistent objects that represent the IDL information in a form available at runtime. The Interface Repository information may be used by the ORB to perform requests. Moreover, using the information in the Interface Repository, it is possible for a program to encounter an object whose interface was not known when the program was compiled, yet, be able to determine what operations are valid on the object and make an invocation on it.<p>
</a><a name="446037">
In addition to its role in the functioning of the ORB, the Interface Repository is a common place to store additional information associated with interfaces to ORB objects. For example, debugging information, libraries of stubs or skeletons, routines that can format or browse particular kinds of objects, etc., might be associated with the Interface Repository.<p>
</a><a name="446038">
<h2>	2.1.14	 Implementation Repository</h2>
</a><a name="446039">
The Implementation Repository contains information that allows the ORB to locate and activate implementations of objects. Although most of the information in the Implementation Repository is specific to an ORB or operating environment, the Implementation Repository is the conventional place for recording such information. Ordinarily, installation of implementations and control of policies related to the activation and execution of object implementations is done through operations on the Implementation Repository.<p>
</a><a name="446040">
In addition to its role in the functioning of the ORB, the Implementation Repository is a common place to store additional information associated with implementations of ORB objects. For example, debugging information, administrative control, resource allocation, security, etc., might be associated with the Implementation Repository.<p>
</a><a name="446041">
<h1>	2.2	 Example ORBs</h1>
</a><a name="446042">
 There are a wide variety of ORB implementations possible within the Common ORB Architecture. This section will illustrate some of the different options. Note that a particular ORB might support multiple options and protocols for communication.<p>
</a><a name="446043">
<h2>	2.2.1	 Client- and Implementation-resident ORB</h2>
</a><a name="446044">
 If there is a suitable communication mechanism present, an ORB can be implemented in routines resident in the clients and implementations. The stubs in the client either use a location-transparent IPC mechanism or directly access a location service to establish communication with the implementations. Code linked with the implementation is responsible for setting up appropriate databases for use by clients.<p>
</a><a name="446045">
<h2>	2.2.2	 Server-based ORB</h2>
</a><a name="446046">
 To centralize the management of the ORB, all clients and implementations can communicate with one or more servers whose job it is to route requests from clients to implementations. The ORB could be a normal program as far as the underlying operating system is concerned, and normal IPC could be used to communicate with the ORB.<p>
</a><a name="446047">
<h2>	2.2.3	 System-based ORB</h2>
</a><a name="446048">
 To enhance security, robustness, and performance, the ORB could be provided as a basic service of the underlying operating system. Object references could be made unforgeable, reducing the expense of authentication on each request. Because the operating system could know the location and structure of clients and implementations, it would be possible for a variety of optimizations to be implemented, for example, avoiding marshalling when both are on the same machine.<p>
</a><a name="446049">
<h2>	2.2.4	 Library-based ORB</h2>
</a><a name="446050">
 For objects that are light-weight and whose implementations can be shared, the implementation might actually be in a library. In this case, the stubs could be the actual methods. This assumes that it is possible for a client program to get access to the data for the objects and that the implementation trusts the client not to damage the data.<p>
</a><a name="446051">
<h1>	2.3	 Structure of a Client</h1>
</a><a name="446052">
 A client of an object has an object reference that refers to that object. An object reference is a token that may be invoked or passed as a parameter to an invocation on a different object. Invocation of an object involves specifying the object to be invoked, the operation to be performed, and parameters to be given to the operation or returned from it.<p>
</a><a name="446053">
The ORB manages the control transfer and data transfer to the object implementation and back to the client. In the event that the ORB cannot complete the invocation, an exception response is provided. Ordinarily, a client calls a routine in its program that performs the invocation and returns when the operation is complete.<p>
</a><a name="446056">
Clients access object-type-specific stubs as library routines in their program (see <a href="arch2.html#446065">FIG. 7 on page 2-12</a>). The client program thus sees routines callable in the normal way in its programming language. All implementations will provide a language-specific data type to use to refer to objects, often an opaque pointer. The client then passes that object reference to the stub routines to initiate an invocation. The stubs have access to the object reference representation and interact with the ORB to perform the invocation. (See Chapter <a href="cmap.html#2968">14</a> for additional, general information on language mapping of object references.) <p>
</a><a name="446065">
FIG.  7	 The Structure of a Typical Client <img src="local/images/arch2a5.gif"><p>
</a><a name="446066">
An alternative set of library code is available to perform invocations on objects, for example when the object was not defined at compile time. In that case, the client program provides additional information to name the type of the object and the method being invoked, and performs a sequence of calls to specify the parameters and initiate the invocation.<p>
</a><a name="446067">
Clients most commonly obtain object references by receiving them as output parameters from invocations on other objects for which they have references. When a client is also an implementation, it receives object references as input parameters on invocations to objects it implements. An object reference can also be converted to a string that can be stored in files or preserved or communicated by different means and subsequently turned back into an object reference by the ORB that produced the string.<p>
</a><a name="446068">
<h1>	2.4	 Structure of an Object Implementation</h1>
</a><a name="446069">
 An object implementation provides the actual state and behavior of an object. The object implementation can be structured in a variety of ways. Besides defining the methods for the operations themselves, an implementation will usually define procedures for activating and deactivating objects and will use other objects or non-object facilities to make the object state persistent, to control access to the object, as well as to implement the methods.<p>
</a><a name="446073">
The object implementation (see <a href="arch2.html#446078">FIG. 8 on page 2-13</a>) interacts with the ORB in a variety of ways to establish its identity, to create new objects, and to obtain ORB-dependent services. It primarily does this via access to an Object Adapter, which provides an interface to ORB services that is convenient for a particular style of object implementation.<p>
</a><a name="446078">
FIG.  8	 The Structure of a Typical Object Implementation<img src="local/images/arch2a6.gif"> <p>
</a><a name="446079">
Because of the range of possible object implementations, it is difficult to be definitive about how in general an object implementation is structured. See the Basic Object Adapter chapter  for the structure of object implementations that use the Basic Object Adapter.<p>
</a><a name="446083">
When an invocation occurs, the ORB Core, object adapter, and skeleton arrange that a call is made to the appropriate method of the implementation. A parameter to that method specifies the object being invoked, which the method can use to locate the data for the object. Additional parameters are supplied according to the skeleton definition. When the method is complete, it returns, causing output parameters or exception results to be transmitted back to the client.<p>
</a><a name="446084">
When a new object is created, the ORB may be notified so that the it knows where to find the implementation for that object. Usually, the implementation also registers itself as implementing objects of a particular interface, and specifies how to start up the implementation if it is not already running.<p>
</a><a name="446085">
Most object implementations provide their behavior using facilities in addition to the ORB and object adapter. For example, although the Basic Object Adapter provides some persistent data associated with an object, that relatively small amount of data is typically used as an identifier for the actual object data stored in a storage service of the object implementation's choosing. With this structure, it is not only possible for different object implementations to use the same storage service, it is also possible for objects to choose the service that is most appropriate for them.<p>
</a><a name="446086">
<h1>	2.5	 Structure of an Object Adapter</h1>
</a><a name="446090">
 An object adapter (see <a href="arch2.html#446107">FIG. 9 on page 2-15</a>) is the primary means for an object implementation to access ORB services such as object reference generation. An object adapter exports a public interface to the object implementation, and a private interface to the skeleton. It is built on a private ORB-dependent interface.<p>
</a><a name="446091">
Object adapters are responsible for the following functions:<p>
</a><ul><a name="446092">
<li>Generation and interpretation of object references
</a><a name="446093">
<li>Method invocation
</a><a name="446094">
<li>Security of interactions
</a><a name="446095">
<li>Object and implementation activation and deactivation
</a><a name="446096">
<li>Mapping object references to the corresponding object implementations
</a><a name="446097">
<li>registration of implementations
</a><a name="446098">
These functions are performed using the ORB Core and any additional components necessary. Often, an object adapter will maintain its own state to accomplish its tasks. It may be possible for a particular object adapter to delegate one or more of its responsibilities to the Core upon which it is constructed. <p>
</a><a name="446102">
As shown in <a href="arch2.html#446107">FIG. 9 on page 2-15</a>, the Object Adapter is implicitly involved in invocation of the methods, although the direct interface is through the skeletons. For example, the Object Adapter may be involved in activating the implementation or authenticating the request.<p>
</a><a name="446107">
FIG.  9	 The Structure of a Typical Object Adapter<img src="local/images/arch2a7.gif"> <p>
</a><a name="446108">
The Object Adapter defines most of the services from the ORB that the Object Implementation can depend on. Different ORBs will provide different levels of service and different operating environments may provide some properties implicitly and require others to be added by the Object Adapter. For example, it is common for Object Implementations to want to store certain values in the object reference for easy identification of the object on an invocation. If the Object Adapter allows the implementation to specify such values when a new object is created, it may be able to store them in the object reference for those ORBs that permit it. If the ORB Core does not provide this feature, the Object Adapter would record the value in its own storage and provide it to the implementation on an invocation. With Object Adapters, it is possible for an Object Implementation to have access to a service whether or not it is implemented in the ORB Core-if the ORB Core provides it, the adapter simply provides an interface to it; if not, the adapter must implement it on top of the ORB Core. Every instance of a particular adapter must provide the same interface and service for all the ORBs it is implemented on.<p>
</a><a name="446143">
It is also not necessary for all Object Adapters to provide the same interface or functionality. Some Object Implementations have special requirements, for example, an object-oriented database system may wish to implicitly register its many thousands of objects without doing individual calls to the Object Adapter. In such a case, it would be impractical and unnecessary for the object adapter to maintain any per-object state. By using an object adapter interface that is tuned towards such object implementations, it is possible to take advantage of particular ORB Core details to provide the most effective access to the ORB.<p>
</a></ul><a name="446144">
<h1>	2.6	 Example Object Adapters</h1>
</a><a name="446145">
 There are a variety of possible object adapters. However, since the object adapter interface is something that object implementations depend on, it is desirable that there be as few as practical. Most object adapters are designed to cover a range of object implementations, so only when an implementation requires radically different services or interfaces should a new object adapter be considered. In this section, we describe three object adapters that might be useful.<p>
</a><a name="446146">
<h2>	2.6.1	 Basic Object Adapter</h2>
</a><a name="446147">
 This specification defines an object adapter that can be used for most ORB objects with conventional implementations. (See the Basic Object Adapter chapter for more information.)  For this object adapter, implementations are generally separate programs. It allows there to be a program started per method, a separate program for each object, or a shared program for all instances of the object type. It provides a small amount of persistent storage for each object, which can be used as a name or identifier for other storage, for access control lists, or other object properties. If the implementation is not active when an invocation is performed, the BOA will start one.<p>
</a><a name="446151">
<h2>	2.6.2	 Library Object Adapter</h2>
</a><a name="446152">
 This object adapter is primarily used for objects that have library implementations. It accesses persistent storage in files, and does not support activation or authentication, since the objects are assumed to be in the clients program.<p>
</a><a name="446153">
<h2>	2.6.3	 Object-Oriented Database Adapter</h2>
</a><a name="446154">
 This adapter uses a connection to an object-oriented database to provide access to the objects stored in it. Since the OODB provides the methods and persistent storage, objects may be registered implicitly and no state is required in the object adapter.<p>
</a><a name="446155">
<h1>	2.7	 The Integration of Foreign Object Systems</h1>
</a><a name="446156">
 The Common ORB Architecture is designed to allow interoperation with a wide range of object systems (see <a href="arch2.html#446167">FIG. 10 on page 2-17</a>). Because there are many existing object systems, a common desire will be to allow the objects in those systems to be accessible via the ORB. For those object systems that are ORBs themselves, they may be connected to other ORBs through the mechanisms described in  chapters 9, 10, 11, 12, and 13 in this manual.<p>
</a><a name="446167">
FIG.  10	 Different Ways to Integrate Foreign Object Systems<img src="local/images/arch2a8.gif"> <p>
</a><a name="446168">
For object systems that simply want to map their objects into ORB objects and receive invocations through the ORB, one approach is to have those object systems appear to be implementations of the corresponding ORB objects. The object system would register its objects with the ORB and handle incoming requests, and could act like a client and perform outgoing requests.<p>
</a><a name="446169">
In some cases, it will be impractical for another object system to act like a BOA object implementation. An object adapter could be designed for objects that are created in conjunction with the ORB and that are primarily invoked through the ORB. Another object system may wish to create objects without consulting the ORB, and might expect most invocations to occur within itself rather than through the ORB. In such a case, a more appropriate object adapter might allow objects to be implicitly registered when they are passed through the ORB.<p>
</a>
<hr><br>
 
<a href="cover.html">[Top]</a> <a href="obmod2.html">[Prev]</a> <a href="idlsyn.html">[Next]</a> <a href="corb2pra.html">[Bottom]</a>
<hr><br>
 


<address>
<a href="mailto:pubs@omg.org">pubs@omg.org</a>
</address>

<i>Copyright &#169; 1995, <a href="http://www.omg.org">Object Management Group.</a>  All rights
reserved.</i>

<!-- This file was created with Quadralay WebWorks Publisher 3.0.4 -->
<!-- -->
<!-- For more information on how this document, and how the rest of -->
<!-- this server was created, email pubs@omg.org -->
<!-- -->
<!-- Last updated: 06/10/96 08:47:28 -->

</body>
</html>
