<html><head><title></title></head>
<body bgcolor=#ffffff>
 
<a href="cover.html">[Top]</a> <a href="orbif2.html">[Prev]</a> <a href="appxtype.html">[Next]</a> <a href="corb2pra.html">[Bottom]</a>
<hr><br>
 
<a name="77">
<h1> The Basic Object Adapter</h1>
</a><dl>
<p align=right clear=all>
<b><font size=7>
8 
</font></b>
</p>
<hr></dl>
<a name="88">
An object adapter is the primary interface that an implementation uses to access ORB functions. The <em>Basic Object Adapter</em> (BOA) is an interface intended to be widely available and to support a wide variety of common object implementations. It includes convenient interfaces for generating object references, registering implementations that consist of one or more programs, activating implementations, and authenticating requests. It also provides a limited amount of persistent storage for objects that can be used for connecting to a larger or more general storage facility, for storing access control information, or other purposes.<p>
</a><a name="81">
Most of the <em>Basic Object Adapter</em> interface can be expressed in OMG IDL, since the interface is to the operations on the object adapter. Some of the operations to bind the implementation to the object adapter depend on the language mapping. Such dependencies are noted in this chapter, but OMG IDL will be used to describe the interface.<p>
</a><a name="259">
All types defined in this chapter are part of the CORBA module. When referenced in OMG IDL, the type names must be prefixed by "CORBA::".<p>
</a><a name="98">
<h1>	8.1	 Role of the Basic Object Adapter</h1>
</a><a name="157">
One object adapter, called the Basic Object Adapter, should be available in every ORB implementation; although the BOA will generally have an ORB-dependent implementation, object implementations that use it should be able to run on any ORB that supports the required language mapping, assuming they have been installed appropriately.<p>
</a><a name="264">
Other Object Adapters are likely to be created. Ordinarily, it is not necessary for a client of an object to be concerned about which Object Adapter is used by the implementation.<p>
</a><a name="519">
<p>
</a><a name="520">
<p>
</a><a name="521">
<p>
</a><a name="89">
The following functions are provided through the Basic Object Adapter:<p>
</a><ul><a name="90">
<li>Generation and interpretation of object references
</a><a name="142">
<li>Authentication of the principal making the call
</a><a name="262">
<li>Activation and deactivation of the implementation
</a><a name="263">
<li>Activation and deactivation of individual objects
</a><a name="265">
<li>Method invocation through skeletons
</a></ul><a name="99">
The Basic Object Adapter supports object implementations that are constructed from one or more programs<a href="#113"><sup>1</sup></a>. The BOA activates and communicates with these programs using operating system facilities that are not part of the ORB. Therefore the BOA requires some information that is inherently non-portable. Although not defining this information, the BOA does define the concept of an Implementation Repository which can hold this information, allowing each system to install and start implementations in the way that is appropriate for that system.<p>
</a><a name="114">
The mechanism for binding the program to the BOA and ORB is also not specified because it is inherently system and language-dependent. We assume that the BOA can connect the methods to the skeleton by some means, whether at the time the implementation is compiled, installed, or activated, etc. Subsequent to activation, the BOA can make calls on routines in the implementation and the implementation can make calls on the BOA.<p>
</a><a name="266">
<a href="boa2.html#74">Figure 14 on page 8-3</a> shows the structure of the Basic Object Adapter, and some of the interactions between the BOA and an Object Implementation. The Basic Object Adapter will start a program to provide the Object Implementation, in this example, a per-class server (1). The Object Implementation notifies the BOA that it has finished initializing and is prepared to handle requests (2). When the first request for a particular object arrives, the implementation is notified to activate the object (3). On subsequent requests, the BOA calls the appropriate method using the per-interface skeleton (4). At various times, the implementation may access BOA services such as object creation, deactivation, and so forth. (5).<p>
</a><a name="74">
FIGURE 14.&#32; The Structure and Operation of the Basic Object Adapter <img src="local/images/boa2a.gif"><p>
</a><a name="184">
The BOA exports operations that are accessed by the Object Implementation. The BOA also calls the Object Implementation under certain circumstances. The interface between a particular version of the BOA and the ORB Core it runs on is private, as is the interface between the BOA and the skeletons. Thus, the BOA can exploit features or overcome limitations of a specific ORB Core, and can cooperate with the ORB Core and skeletons to provide a set of portable interfaces for the object implementation.<p>
</a><a name="76">
<h1>	8.2	 Basic Object Adapter Interface</h1>
</a><a name="94">
The BOA interface is specified in OMG IDL, so that the way it is accessed in any programming language is specified by the client side language mapping for that language. Some data structures used by the BOA are specific to a given language mapping, so most IDL compilers will not be able to accept this definition literally.<p>
</a><a name="156">
In practice, the BOA is most likely to be implemented partially as a separate component and partially as a library in the Object Implementation. The separate component is required to do activation when the implementation is not present. The library portion is needed to establish the linkage between the methods and the skeleton. The exact partitioning of functionality between these parts is implementation dependent. Generally, there will appear to be a BOA object in the object implementation. When it is invoked, some operations are satisfied in the library, some in an external server, and some in the ORB Core.<p>
</a><a name="170">
The following is the approximate interface definition for the BOA object. More details will be provided as the operations are discussed.<p>
</a><a name="117">
 module CORBA {<p>
</a><a name="258">
 						interface InterfaceDef;									// from Interface Repository									// PIDL<p>
</a><a name="72">
 						interface ImplementationDef;									// from Implementation Repository<p>
</a><a name="78">
 						interface Object;									// an object reference<p>
</a><a name="92">
 						interface Principal;									// for the authentication service<p>
</a><a name="73">
 						typedef sequence &lt;octet, 1024&gt; ReferenceData;<p>
</a><a name="95">
 <p>
</a><a name="150">
 						interface BOA {<p>
</a><a name="126">
 							Object create (<p>
</a><a name="229">
 								in ReferenceData 							id, <p>
</a><a name="230">
 								in InterfaceDef 							intf,<p>
</a><a name="232">
 								in ImplementationDef 							impl<p>
</a><a name="233">
 							);<p>
</a><a name="116">
 							void dispose (in Object obj);<p>
</a><a name="168">
 							ReferenceData get_id (in Object obj);<p>
</a><a name="238">
 <p>
</a><a name="268">
 							void change_implementation (<p>
</a><a name="234">
 								in Object 							obj,<p>
</a><a name="115">
 								in ImplementationDef 							impl<p>
</a><a name="235">
 							);<p>
</a><a name="267">
 <p>
</a><a name="179">
 							Principal get_principal (<p>
</a><a name="127">
 								in Object 							obj, <p>
</a><a name="236">
 								in Environment 							ev<p>
</a><a name="237">
 							);<p>
</a><a name="239">
 <p>
</a><a name="209">
 							void set_exception (<p>
</a><a name="212">
 								in exception_type 							major, 			// NO, USER,<p>
</a><a name="890">
 																		//or SYSTEM_EXCEPTION<p>
</a><a name="213">
 								in string 							userid,			// exception type id<p>
</a><a name="210">
 								in void 							*param			// pointer to associated data<p>
</a><a name="214">
 							);<p>
</a><a name="269">
 <p>
</a><a name="270">
 							void impl_is_ready (in ImplementationDef impl);<p>
</a><a name="271">
 							void deactivate_impl (in ImplementationDef impl);<p>
</a><a name="272">
 							void obj_is_ready (in Object obj, in ImplementationDef impl);<p>
</a><a name="273">
 							void deactivate_obj (in Object obj);<p>
</a><a name="260">
 	};<p>
</a><a name="274">
 					 			};<p>
</a><a name="885">
<p>
</a><a name="886">
<p>
</a><a name="887">
<p>
</a><a name="888">
<p>
</a><a name="889">
<p>
</a><a name="151">
Requests by an implementation on the BOA are of the following kinds:<p>
</a><ul><a name="128">
<li>Operations to create or destroy object references, or query or update the information the BOA maintains for an object reference.
</a><a name="153">
<li>Operations associated with a particular request.
</a><a name="154">
<li>Operations to maintain a registry of active objects and implementations.
</a></ul><a name="71">
Requests by the BOA to an implementation are made with skeletons or using an implementation's runtime language mapping information, and are of these kinds:<p>
</a><ul><a name="256">
<li>Activating an implementation.
</a><a name="261">
<li>Activating an object.
</a><a name="257">
<li>Performing an operation (through a skeleton method).
</a></ul><a name="176">
Each of the BOA operations is described in detail later in this section; the requests of the BOA to an implementation are described in the language mapping section.<p>
</a><a name="84">
<h2>	8.2.1	 Registration of Implementations</h2>
</a><a name="211">
The Basic Object Adapter expects information describing the implementations to be stored in an <em>Implementation Repository</em>. The Implementation Repository ordinarily is updated at program installation time, but may be set up incrementally or otherwise. There are objects with an OMG IDL interface called <strong>ImplementationDef</strong>, which capture this information. The Implementation Repository may contain additional information for debugging, administration, etc. Note that the Implementation Repository is logically distinct from the Interface Repository, although they may in fact be implemented together.<p>
</a><a name="107">
The<em> Interface Repository</em> contains information about interfaces. There are objects with an OMG IDL interface called <strong>InterfaceDef</strong>, which capture this information. The Interface Repository may contain additional information for debugging, administration, browsing, etc. The ORB Core may or may not make use of the Interface Repository or the Implementation Repository, but the ORB and BOA use these objects to associate object references with their interfaces and implementations.<p>
</a><a name="83">
<h2>	8.2.2	 Activation and Deactivation of Implementations</h2>
</a><a name="165">
There are two kinds of activation that a BOA needs to perform as part of operation invocation. The first, discussed in this section, is <em>implementation activation</em>, which occurs when no implementation for an object is currently available to handle the request. The second, discussed later, is <em>object activation</em>, which occurs when no instance of the object is available to handle the request. <p>
</a><a name="183">
Implementation activation requires coordination between the BOA and the program(s) containing the implementation. This manual uses the term <em>server</em> as the separately executable entity that the BOA can start on a particular system. In a POSIX environment, a server would be a process. In most systems, a server corresponds to the notion of a program, but it can correspond to whatever the appropriate system facility is in a particular environment.<p>
</a><a name="202">
The BOA initiates activity by the implementation by starting the appropriate server, probably in an operating system-dependent way. The implementation initializes itself, then notifies the BOA that it is prepared to handle requests by calling <strong>impl_is_ready</strong> or <strong>obj_is_ready</strong><a href="#108"><sup>2</sup></a>. <p>
</a><a name="928">
Between the time that the program is started and it indicates it is ready, the BOA will prevent any other requests from being delivered to the server. After that point, the BOA, through the skeletons, will make calls on the methods of the implementation.<p>
</a><a name="276">
 void impl_is_ready (in ImplementationDef impl);																					// PIDL<p>
</a><a name="124">
 void obj_is_ready 	(<p>
</a><a name="240">
 						in Object 						obj, <p>
</a><a name="241">
 						in ImplementationDef 						impl<p>
</a><a name="242">
 									 );<p>
</a><a name="149">
An <em>activation policy</em> describes the rules that a given implementation follows when there are multiple objects or implementations active. There are four policies that all BOA implementations support for implementation activation:<p>
</a><a name="534">
<p>
</a><ul><a name="136">
<li>A <em>shared server</em> policy, where multiple active objects of a given implementation share the same server.
</a><a name="137">
<li>An <em>unshared server</em> policy, where only one object of a given implementation at a time can be active in one server.
</a><a name="138">
<li>A <em>server-per-method</em> policy, where each invocation of a method is implemented by a separate server being started, with the server terminating when the method completes.
</a><a name="139">
<li><em>Persistent server</em> policy, where the server is activated by something outside the BOA. The server nonetheless must register with the BOA to receive invocations. A persistent server is assumed to be shared by multiple active objects.
</a></ul><a name="277">
These kinds of implementation activation are illustrated in <a href="boa2.html#278">Figure 15 on page 8-7</a>. Case A is a shared server, where the BOA starts a process which then registers itself with the BOA. Case B is the case of a persistent server, which is very similar but just registers itself with the BOA, without the BOA having had to start a process. An unshared server is illustrated in case C, where the process started by the BOA can only hold one object; the server-per-method policy in case D causes each method invocation to be done by starting a process.<p>
</a><a name="278">
FIGURE 15.&#32; Implementation Activation Policies<img src="local/images/boa2a1.gif"><p>
</a><a name="174">
<h3>		 Shared Server Activation Policy</h3>
</a><a name="175">
In a shared server, multiple objects may be implemented by the same program. This is likely to be the most common kind of server. The server is activated the first time a request is performed on any object implemented by that server. When the server has initialized itself, it notifies the BOA that it is ready by calling <strong>impl_is_ready</strong>. Subsequently, the BOA will deliver requests or object activations for any objects implemented by that server. The server remains active and will receive requests until it calls <strong>deactivate_impl</strong>. The BOA will not activate another server for that implementation if one is active.<p>
</a><a name="91">
Before the first request is delivered for a particular object, the object activate routine of the server is called. An object remains active as long as its server is active, unless the server calls <strong>deactivate_obj</strong> for that object.<p>
</a><a name="123">
<h3>		 Unshared Server Activation Policy</h3>
</a><a name="109">
In an unshared server, each object is implemented in a different server. This kind of server is convenient if a object is intended to encapsulate an application or if the server requires exclusive access to a resource such as a printer. A new server is activated the first time a request is performed on the object. When the server has initialized itself, it notifies the BOA that it is ready by calling <strong>obj_is_ready</strong>. Subsequently, the BOA will deliver requests for that object. The server remains active and will receive requests until it calls <strong>deactivate_obj</strong>.<p>
</a><a name="122">
A new server is started whenever a request is made for an object that is not yet active, even if a server for another object with the same implementation is active.<p>
</a><a name="177">
<h3>		 Server-per-Method Activation Policy</h3>
</a><a name="181">
Under the server-per-method policy, a new server is always started each time a request is made. The server runs only for the duration of the particular method. Several servers for the same object or even the same method of the same object may be active simultaneously. Because a new server is started for each request, it is not necessary for the implementation to notify the BOA when an object is ready or deactivated.<p>
</a><a name="220">
The BOA activates an implementation for each request, whether or not another request for that operation, object, or implementation is active at the same time.<p>
</a><a name="217">
<h3>		 Persistent Server Activation Policy</h3>
</a><a name="155">
Persistent servers are those servers which are activated by means outside the BOA. Such implementations notify the BOA that they are available using the <strong>impl_is_ready</strong> operation. Once the BOA knows about a persistent server, it treats the server as a shared server, sending it activations for individual objects and method calls. If no implementation is ready when a request arrives, an error is returned for that request.<p>
</a><a name="103">
<h2>	8.2.3	 Generation and Interpretation of Object References</h2>
</a><a name="206">
Object references are generated by the BOA using the ORB Core when requested by an implementation. The BOA and the ORB Core work together to associate some information with a particular object reference. This information is later provided to the implementation upon the activation of an object. Note that this is the only information an implementation may use portably to distinguish different object references. The BOA operation used to create a new object reference is:<p>
</a><a name="182">
 Object create	 (																						// PIDL<p>
</a><a name="243">
 						in ReferenceData 										id, 	<p>
</a><a name="245">
 						in InterfaceDef			 							intf,	<p>
</a><a name="244">
 						in ImplementationDef 										impl<p>
</a><a name="246">
 								);<p>
</a><a name="106">
The <strong>id</strong> is immutable identification information, chosen by the implementation at object creation time, and never changed during the lifetime of the object. The <strong>intf</strong> is the Interface Repository object that specifies the complete set of interfaces implemented by the object. The <strong>impl</strong> is the Implementation Repository object that specifies the implementation to be used for the object.<p>
</a><a name="111">
A typical implementation will use the <strong>id </strong>value to distinguish different objects, but it is free to use it in any way it chooses or to assign the same value to different object references. Two object references created with the same parameters are <em>not</em> the same object reference as far as the ORB is concerned, although the implementation may or may not treat them as references to the same object. Note that the object reference itself is opaque and may be different for different ORBs, but the <strong>id</strong> value is available portably in all ORBs. Only the implementation can normally interpret the <strong>id</strong> value. The operation to get the <strong>id </strong>is a BOA operation:<p>
</a><a name="192">
 ReferenceData get_id (in Object obj);																						// PIDL<p>
</a><a name="939">
It is possible for the implementation associated with an object reference to be changed. This will cause subsequent requests to be handled according to the information in the new implementation. The operation to set the implementation<strong> </strong>is a BOA operation:<p>
</a><a name="941">
 void change_implementation	 (																						// PIDL<p>
</a><a name="942">
 						in Object 								obj,			<p>
</a><a name="131">
 						in ImplementationDef 								impl<p>
</a><a name="248">
 												);<p>
</a><a name="224">
Note &#175;  Care must be taken in order to change the implementation after the object has been created. There are issues of synchronization with activation, security, and whether or not the new implementation is prepared to handle requests for that object. The <strong>change_implementation</strong> operation affects all copies of that particular object reference.<p>
</a><a name="204">
If an object reference is copied, all copies have the same <strong>id</strong>, <strong>intf</strong>, and <strong>impl.</strong><p>
</a><a name="201">
An implementation is allowed to dispose of an object it has created by asking the BOA to invalidate the object reference. The implementation is responsible for deallocating all other information about the object. After a <strong>dispose</strong> is done, the ORB Core and BOA act as if the object had never been created, and attempts to issue requests on any existing object references for that object will fail.<p>
</a><a name="166">
 void dispose (in Object obj);																						// PIDL<p>
</a><a name="97">
Note that all of the operations on object references in this section may be done whether or not the object is active.<p>
</a><a name="130">
<h2>	8.2.4	 Authentication and Access Control</h2>
</a><a name="196">
The BOA does not enforce any specific style of security management. It guarantees that for every method invocation (or object activation) it will identify the principal on whose behalf the request is performed. The object implementation can obtain this principal by the operation:<p>
</a><a name="197">
 Principal get_principal	 (																						// PIDL<p>
</a><a name="249">
 						in Object 						obj, <p>
</a><a name="250">
 						in Environment 						ev<p>
</a><a name="251">
 											);<p>
</a><a name="167">
The <strong>obj</strong> parameter is the object reference passed to the method. If another object is used the result is undefined. The <strong>ev</strong> parameter is the language-mapping-specific request environment passed to the method.<p>
</a><a name="132">
The meaning of the principal depends on the security environment that the implementation is running in. The decision of whether or not to permit a particular operation is left up to the implementation. Typically, an implementation will associate access rights with particular objects and principals, and will examine those access rights to determine if the principal making the request has the privileges required by the particular method. An implementation could store a reference to the access control information for an object in the <strong>id</strong> for the object.<p>
</a><a name="85">
<h2>	8.2.5	 Persistent Storage</h2>
</a><a name="93">
Objects (or, more precisely, object references) are made persistent by the BOA and the ORB Core, in that a client that has an object reference can use it at any time without warning, even if the implementation has been deactivated or the system has been restarted. Although the ORB Core and BOA maintain the persistence of object references, the implementation must participate in keeping any data outside the ORB Core and BOA persistent.<p>
</a><a name="231">
Toward this end, the BOA provides a small amount of storage for an object in the <strong>id</strong> value. In most cases, this storage is insufficient and inconvenient for the complete state of the object. Instead, the implementation provides and manages that storage, using the <strong>id</strong> value to locate the actual storage. For example, the <strong>id</strong> value might contain the name of a file, or a key for a database system that holds the persistent state.<p>
</a><a name="275">
<p>
</a>
<hr><br>
 
<a href="cover.html">[Top]</a> <a href="orbif2.html">[Prev]</a> <a href="appxtype.html">[Next]</a> <a href="corb2pra.html">[Bottom]</a>
<hr><br>
 
<sup>1</sup><a name="113">
 The term "program" is meant to include a wide range of possible constructs, including scripts, loadable modules, etc., in addition to the traditional notions of an application or server.<p>
</a><sup>2</sup><a name="108">
 The latter is for per-object servers.<p>
</a>

<address>
<a href="mailto:pubs@omg.org">pubs@omg.org</a>
</address>

<i>Copyright &#169; 1995, <a href="http://www.omg.org">Object Management Group.</a>  All rights
reserved.</i>

<!-- This file was created with Quadralay WebWorks Publisher 3.0.4 -->
<!-- -->
<!-- For more information on how this document, and how the rest of -->
<!-- this server was created, email pubs@omg.org -->
<!-- -->
<!-- Last updated: 06/10/96 08:48:36 -->

</body>
</html>
