<html><head><title></title></head>
<body bgcolor=#ffffff>
 
<a href="cover.html">[Top]</a> <a href="inarch.html">[Prev]</a> <a href="giop.html">[Next]</a> <a href="corb2pra.html">[Bottom]</a>
<hr><br>
 
<a name="553">
<h1> Building Inter-ORB Bridges	</h1>
</a><dl>
<p align=right clear=all>
<b><font size=7>
11 
</font></b>
</p>
<hr></dl>
<a name="569">
This chapter provides an implementation-oriented conceptual framework for the construction of bridges to provide interoperability between ORBs. It focuses on the layered <em>request level bridges</em> that the CORBA Core specifications facilitate, although ORBs may always be internally modified to support bridges. Specifications for the CORBA Core are contained in Chapters 1 - 8 in this manual. <p>
</a><a name="625">
Key feature of the specifications for inter-ORB bridges are as follows:<p>
</a><ul><a name="626">
<li>Enables requests from one ORB to be translated to requests on another 
</a><a name="616">
<li>Provides support for managing tables keyed by object references
</a></ul><a name="640">
The OMG IDL specification for interoperable object references, which are important to inter-ORB bridging, is shown in <a href="inarch.html#3674">Section &#32;10.6.2, "Interoperable Object References: IORs," on page &#32;10-14</a>.<p>
</a><a name="434">
<h1>	11.1	 In-Line and Request-Level Bridging</h1>
</a><a name="435">
Bridging of an invocation between a client in one domain and a server object in another domain can be mediated through a standardized mechanism, or done immediately using nonstandard ones.<p>
</a><a name="559">
The question of how this bridging is constructed is broadly independent of whether the bridging uses a standardized mechanism. There are two possible options for where the bridge components are located:<p>
</a><ul><a name="436">
<li>Code inside the ORB may perform the necessary translation or mappings; this is termed <em>in-line bridging</em>.
</a><a name="437">
<li>Application style code outside the ORB can perform the translation or mappings; this is termed <em>request level bridging</em>.
</a></ul><a name="438">
Request level bridges which mediate through a common protocol (using networking, shared memory, or some other IPC provided by the host operating system) between distinct execution environments will involve components, one in each ORB, known as "half bridges".<p>
</a><a name="895">
When that mediation is purely internal to one execution environment, using a shared programming environment's binary interfaces to CORBA- and OMG-IDL-defined data types, this is known as a "full bridge"<a href="#1226"><sup>1</sup></a>. From outside the execution environment this will appear identical to some kinds of in-line bridging, since only that environment knows the construction techniques used. However, full bridges more easily support portable policy mediation components, because of their use of only standard CORBA programming interfaces.<p>
</a><a name="390">
Network protocols may be used immediately "in-line", or to mediate between request-level half bridges. The <a href="giop.html#199">Chapter 12, "General Inter-ORB Protocol"</a> can be used in either manner. In addition, this specification provides for Environment Specific Inter-ORB Protocols (ESIOP), allowing for alternative mediation mechanisms.<p>
</a><a name="572">
Note that mediated, request level half-bridges can be built by anyone who as access to an ORB, without needing information about the internal construction of that ORB. Immediate-mode request level half-bridges (i.e., ones using nonstandard mediation mechanisms) can similarly be built without needing information about ORB internals. Only in-line bridges (using either standard or nonstandard mediation mechanisms) need potentially proprietary information about ORB internals.<p>
</a><a name="449">
<h2>	11.1.1	 In-line Bridging<img src="local/images/bridgea.gif"></h2>
</a><a name="450">
Figure 11-1	 In-Line bridges are built using <em>ORB internal APIs</em>.<p>
</a><a name="451">
In this approach, the required bridging functionality can be provided by a combination of software components at various levels:<p>
</a><ul><a name="452">
<li>As additional or alternative services provided by the underlying ORBs
</a><a name="453">
<li>As additional or alternative stub and skeleton code.
</a></ul><a name="454">
In-line bridging is in general the most direct method of bridging between ORBs. It is structurally similar to the engineering commonly used to bridge between systems within a single ORB (e.g. mediating using some common inter-process communications scheme, such as a network protocol). This means that implementing in-line bridges involves as fundamental a set of changes to an ORB as adding a new inter-process communications scheme. (Some ORBs may be designed to facilitate such modifications, though.)<p>
</a><a name="458">
<h2>	11.1.2	 Request-level bridging<img src="local/images/bridgea1.gif"></h2>
</a><a name="459">
Figure 11-2	 Request-Level bridges are built using <em>public ORB APIs</em>.<p>
</a><a name="460">
The general principle of request-level bridging is as follows:<p>
</a><a name="461">
	1.	 the original request is passed to a proxy object in the client ORB;<p>
</a><a name="462">
	2.	 the proxy object translates the request contents (including the target object reference) to a form that will be understood by the server ORB;<p>
</a><a name="463">
	3.	 the proxy invokes the required operation on the apparent server object;<p>
</a><a name="464">
	4.	 any operation result is passed back to the client via a complementary route.<p>
</a><a name="465">
The request translation involves performing object reference mapping for all object references involved in the request (the target, explicit parameters, and perhaps implicit ones such as transaction context). As elaborated later, this translation may also involve mappings for other domains: the security domain of CORBA::Principal<code> </code>parameters, type identifiers, and so on.<p>
</a><a name="466">
It is a language mapping requirement of the CORBA Core specification that all dynamic typing APIs (e.g. Any<strong>, </strong>NamedValue) support such manipulation of parameters even when the bridge was not created with compile-time knowledge of the data types involved.<p>
</a><a name="616">
<h2>	11.1.3	 Collocated ORBs</h2>
</a><a name="617">
In the case of immediate bridging (i.e. not via a standardized, external protocol) the means of communication between the client-side bridge component and that on the server-side is an entirely private matter. One possible engineering technique optimizes this communication by coalescing the two components into the same system or even the same address space. In the latter case, accommodations must be made by both ORBs to allow them to share the same execution environment.<p>
</a><a name="618">
Similar observations apply to request level bridges, which in the case of collocated ORBs use a common binary interface to all OMG IDL-defined data as their mediating data format.<img src="local/images/bridgea2.gif"><p>
</a><a name="622">
Figure 11-3	 When the two ORBs are collocated in a bridge execution environment, network communications will be purely intra-ORB. If the ORBs are not collocated, such communications must go between ORBs.<p>
</a><a name="623">
An advantage of using bridges spanning collocated ORBs is that all external messaging can be arranged to be intra-ORB, using whatever message passing mechanisms each ORB uses to achieve distribution within a single ORB, multiple machine system. That is, for bridges between networked ORBs such a bridge would add only a single "hop," a cost analogous to normal routing.<p>
</a><a name="470">
<h1>	11.2	 Proxy Creation and Management</h1>
</a><a name="471">
Bridges need to support arbitrary numbers of proxy objects, because of the (bidirectional) object reference mappings required. The key schemes for creating and managing proxies are <em>reference translation</em> and <em>reference encapsulation</em>, as discussed in <a href="inarch.html#3650">"Handling of Referencing Between Domains" on page 10-12</a>.<p>
</a><ul><a name="475">
<li>Reference translation approaches are possible with CORBA V2.0 Core APIs. Proxies themselves can be created as normal objects using the Basic Object Adapter (BOA) and the <em>Dynamic Skeleton Interface</em> (DSI).
</a><a name="479">
<li>Reference Encapsulation is not supported by the BOA, since it would call for knowledge of more than one ORB. Some ORBs could provide other object adapters which support such encapsulation.
</a></ul><a name="480">
Note that from the perspective of clients, they only ever deal with local objects; clients do not need to distinguish between proxies and other objects. Accordingly, all CORBA operations supported by the local ORB are also supported through a bridge. The ORB used by the client might, however, be able to recognize that encapsulation is in use, depending on how the ORB is implemented.<p>
</a><a name="481">
Also, note that the CORBA::InterfaceDef used when creating proxies (e.g. the one passed to CORBA::BOA::create) could be either a proxy to one in the target ORB, or could be an equivalent local one. When the domains being bridged include a type domain, then the InterfaceDef objects cannot be proxies since type descriptions will not have the same information. When bridging CORBA V2.0 compliant ORBs, type domains by definition do not need to be bridged.<p>
</a><a name="485">
<h1>	11.3	 Interface-specific Bridges and Generic Bridges</h1>
</a><a name="486">
Request-level bridges may be:<p>
</a><ul><a name="487">
<li><em>Interface-specific</em>: they support predetermined IDL interfaces only, and are built using IDL-compiler generated stub and skeleton interfaces;
</a><a name="488">
<li><em>Generic</em>: capable of bridging requests to server objects of arbitrary IDL interfaces, using the interface repository and other dynamic invocation support (DII and DSI).
</a></ul><a name="489">
Interface-specific bridges may be more efficient in some cases (a generic bridge could conceivably create the same stubs and skeletons using the interface repository), but the requirement for prior compilation means that this approach offers less flexibility than use of generic bridges.<p>
</a><a name="428">
<h1>	11.4	 Building Generic Request-Level Bridges </h1>
</a><a name="429">
The CORBA Core specifications (Chapters 1 - 8) define the following interfaces. These interfaces are of particular significance when building a generic request-level bridge:<p>
</a><ul><a name="430">
<li>Dynamic Invocation Interface (DII) lets the bridge make arbitrary invocations on object references whose types may not have been known when the bridge was developed or deployed.
</a><a name="431">
<li>Dynamic Skeleton Interface (DSI<em>)</em> lets the bridge handle invocations on proxy object references which it implements, even when their types may not have been known when the bridge was developed or deployed.
</a><a name="432">
<li>IInterface Repositories are consulted by the bridge to acquire the information used to drive DII and DSI, such as the typecodes for operation parameters, return values, and exceptions.
</a><a name="433">
<li>Object Adapters <em>(such as the Basic Object Adapter)</em> are used to create proxy object references both when bootstrapping the bridge and when mapping object references which are dynamically passed from one ORB to the other.
</a><a name="434">
<li>CORBA Object References support operations to fully describe their interfaces and to create tables mapping object references to their proxies (and vice versa).
</a></ul><a name="435">
Interface repositories accessed on either side of a half bridge need not have the same information, though of course the information associated with any given repository ID (e.g. an interface type ID, exception ID) or operation ID must be the same.<p>
</a><a name="436">
Using these interfaces and an interface to some common transport mechanism such as TCP, portable request-level half bridges connected to an ORB can:<p>
</a><ul><a name="437">
<li>Use DSI to translate all CORBA invocations on proxy objects to the form used by some mediating protocol such as IIOP (see <a href="giop.html#199">Chapter 12, "General Inter-ORB Protocol"</a>).
</a><a name="441">
<li>Translate requests made using such a mediating protocol into DII requests on objects in the ORB.
</a></ul><a name="445">
As noted in <a href="bridge.html#434">"In-Line and Request-Level Bridging" on page 11-1</a>, translating requests and responses (including exceptional responses) involves mapping object references (and other explicit and implicit parameter data) from the form used by the ORB to the form used by the mediating protocol, and vice versa. Explicit parameters, which are defined by an operation's OMG-IDL definition, are presented through DII or DSI and are listed in the Interface Repository entry for any particular operation.<p>
</a><a name="446">
Operations on object references such as hash() and is_equivalent() may be used to maintain tables that support such mappings. When such a mapping does not exist, an object adapter is used to create a ORB-specific proxy object references, and bridge-internal interfaces are used to create the analogous data structure for the mediating protocol.<p>
</a><a name="500">
<h1>	11.5	 Bridging Non-Referencing Domains</h1>
</a><a name="501">
In the simplest form of request-level bridging, the bridge operates only on IDL-defined data, and bridges only object reference domains. In this case, a proxy object in the client ORB acts as a representative of the target object and is, in almost any practical sense, indistinguishable from the target server object - indeed, even the client ORB will not be aware of the distinction.<p>
</a><a name="502">
However, as alluded to above, there may be multiple domains that need simultaneous bridging. The transformation and encapsulation schemes described above may not apply in the same way to Principal or type identifiers. Request level bridges may need to translate such identifiers, in addition to object references, as they are passed as explicit operation parameters.<p>
</a><a name="503">
Moreover, there is an emerging class of "implicit context" information that ORBs may need to convey with any particular request, such as transaction and security context information. Such parameters are not defined as part of an operation's OMG-IDL signature, hence are "implicit" in the invocation context. Bridging the domains of such implicit parameters could involve additional kinds of work, needing to mediate more policies, than bridging the object reference, Principal, and type domains directly addressed by CORBA.<p>
</a><a name="790">
CORBA does not yet have a generic way (including support for both static and dynamic invocations) to expose such implicit context information. <p>
</a><a name="510">
<h1>	11.6	 Bootstrapping Bridges</h1>
</a><a name="511">
A particularly useful policy for setting up bridges is to create a pair of proxies for two Naming Service naming contexts (one in each ORB) and then install those proxies as naming contexts in the other ORB's naming service. (The Naming Service is described in <em>CORBAservices</em>.) This will allow clients in either ORB to transparently perform naming context lookup operations on the other ORB, retrieving (proxy) object references for other objects in that ORB. In this way, users can access facilities that have been selectively exported from another ORB, through a naming context, with no administrative action beyond exporting those initial contexts. (See <a href="orbif2.html#819">"Obtaining Initial Object References" on page 7-10</a> for additional information).<p>
</a><a name="512">
This same approach may be taken with other discovery services, such as a trading service or any kind of object that could provide object references as operation results (and in "out" parameters). While bridges can be established which only pass a predefined set of object references, this kind of minimal connectivity policy is not always desirable.<p>
</a><a name="141">
<p>
</a>
<hr><br>
 
<a href="cover.html">[Top]</a> <a href="inarch.html">[Prev]</a> <a href="giop.html">[Next]</a> <a href="corb2pra.html">[Bottom]</a>
<hr><br>
 
<sup>1</sup><a name="1226">
 Special initialization support ing object referencing domains (e.g. two protocols) to be exposed to application programmers to support construction of this style bridge.<p>
</a>

<address>
<a href="mailto:pubs@omg.org">pubs@omg.org</a>
</address>

<i>Copyright &#169; 1995, <a href="http://www.omg.org">Object Management Group.</a>  All rights
reserved.</i>

<!-- This file was created with Quadralay WebWorks Publisher 3.0.4 -->
<!-- -->
<!-- For more information on how this document, and how the rest of -->
<!-- this server was created, email pubs@omg.org -->
<!-- -->
<!-- Last updated: 06/10/96 08:48:58 -->

</body>
</html>
