<html><head><title></title></head>
<body bgcolor=#ffffff>
 
<a href="cover.html">[Top]</a> <a href="tagapp.html">[Prev]</a> <a href="plusov.html">[Next]</a> <a href="corb2pra.html">[Bottom]</a>
<hr><br>
 
<a name="154">
<h1> C Language Mapping </h1>
</a><dl>
<p align=right clear=all>
<b><font size=7>
14 
</font></b>
</p>
<hr><a name="406">
 CORBA is independent of the programming language used to construct clients or implementations. In order to use the ORB, it is necessary for programmers to know how to access ORB functionality from their programming languages. This chapter defines the mapping of OMG IDL constructs to the C programming language. <p>
</a><a name="3562">
<p>
</a></dl>
<a name="2981">
<h1>	14.1	 Requirements for a Language Mapping</h1>
</a><a name="3556">
All language mappings have approximately the same structure. They must define the means of expressing in the language:<p>
</a><ul><a name="411">
<li>All OMG IDL basic data types 
</a><a name="156">
<li>All OMG IDL constructed data types 
</a><a name="400">
<li>References to constants defined in OMG IDL 
</a><a name="401">
<li>References to objects defined in OMG IDL 
</a><a name="402">
<li>Invocations of operations, including passing parameters and receiving results 
</a><a name="403">
<li>Exceptions, including what happens when an operation raises an exception and how the exception parameters are accessed 
</a><a name="404">
<li>Access to attributes 
</a><a name="408">
<li>Signatures for the operations defined by the ORB, such as the dynamic invocation interface, the object adapters, and so forth.
</a></ul><a name="3550">
A complete language mapping will allow a programmer to have access to all ORB functionality in a way that is convenient for the particular programming language. To support source portability, all ORB implementations must support the same mapping for a particular language.<p>
</a><a name="3551">
<h2>	14.1.1	 Basic Data Types</h2>
</a><a name="449">
 A language mapping must define the means of expressing all of the data types defined in <a href="idlsyn.html#512">Section &#32;3.8.1, "Basic Types," on page &#32;3-20</a>. The ORB defines the range of values supported, but the language mapping defines how a programmer sees those values. For example, the C mapping might define TRUE as 1 and FALSE as 0, whereas the LISP mapping might define TRUE as T and FALSE as NIL. The mapping must specify the means to construct and operate on these data types in the programming language.<p>
</a><a name="450">
<h2>	14.1.2	 Constructed Data Types</h2>
</a><a name="453">
 A language mapping must define the means of expressing the constructed data types defined in <a href="idlsyn.html#538">Section &#32;3.8.2, "Constructed Types," on page &#32;3-22</a>. The ORB defines aggregates of basic data types that are supported, but the language mapping defines how a programmer sees those aggregates. For example, the C mapping might define an OMG IDL struct as a C struct, whereas the LISP mapping might define an OMG IDL struct as a list. The mapping must specify the means to construct and operate on these data types in the programming language. <p>
</a><a name="454">
<h2>	14.1.3	 Constants</h2>
</a><a name="474">
 OMG IDL definitions may contain named constant values that are useful as parameters for certain operations. The language mapping should provide the means to access these constants by name.<p>
</a><a name="475">
<h2>	14.1.4	 Objects</h2>
</a><a name="476">
 There are two parts of defining the mapping of ORB objects to a particular language. The first specifies how an object is represented in the program and passed as a parameter to operations. The second is how an object is invoked. The representation of an object reference in a particular language is generally opaque, that is, some language-specific data type is used to represent the object reference, but the program does not interpret the values of that type. The language-specific representation is independent of the ORB representation of an object reference, so that programs are not ORB-dependent. In an object-oriented programming language, it may be convenient to represent an ORB object as a programming language object. Any correspondence between the programming language object types and the OMG IDL types including inheritance, operation names, etc., is up to the language mapping. <p>
</a><a name="3567">
There are only three uses that a program can make of an object reference: it may specify it as a parameter to an operation (including receiving it as an output parameter), it can invoke an operation on it, or it can perform an ORB operation (including object adapter operations) on it.<p>
</a><a name="479">
<h2>	14.1.5	 Invocation of Operations</h2>
</a><a name="480">
 An operation invocation requires the specification of the object to be invoked, the operation to be performed, and the parameters to be supplied. There are a variety of possible mappings, depending to a large extent on the procedure mechanism in the particular language. Some possible choices for language mapping of invocation include: interface-specific stub routines, a single general-purpose routine, a set of calls to construct a parameter list and initiate the operation, or mapping ORB operations to operations on objects defined in an object-oriented programming language.<p>
</a><a name="481">
The mapping must define how parameters are associated with the call, and how the operation name is specified. It is also necessary to specify the effect of the call on the flow of control in the program, including when an operation completes normally and when an exception is raised.<p>
</a><a name="482">
The most natural mapping would be to model a call on an ORB object as the corresponding call in the particular language. However, this may not always be possible for languages where the type system or call mechanism is not powerful enough to handle ORB objects. In this case, multiple calls may be required. For example, in C, it is necessary to have a separate interface for dynamic construction of calls, since C does not permit discovery of new types at runtime. In LISP, however, it may be possible to make a language mapping that is the same for objects whether or not they were known at compile time.<p>
</a><a name="483">
In addition to defining how an operation is expressed, it is necessary to specify the storage allocation policy for parameters, for example, what happens to storage of input parameters, and how and where output parameters are allocated. It is also necessary to describe how a return value is handled, for operations that have one.<p>
</a><a name="484">
<h2>	14.1.6	 Exceptions</h2>
</a><a name="485">
 There are two aspects to the mapping of exceptions into a particular language. First is the means for handling an exception when it occurs, including deciding which exception occurred. If the programming language has a model of exceptions that can accommodate ORB exceptions, that would likely be the most convenient choice; if it does not, some other means must be used, for example, passing additional parameters to the operations that receive the exception status.<p>
</a><a name="486">
It is commonly the case that the programmer associates specific code to handle each kind of exception. It is desirable to make that association as convenient as possible.<p>
</a><a name="487">
Second, when an exception has been raised, it must be possible to access the parameters of the exception. If the language exception mechanism allows for parameters, that mechanism could be used. Otherwise, some other means of obtaining the exception values must be provided.<p>
</a><a name="488">
<h2>	14.1.7	 Attributes</h2>
</a><a name="489">
 The ORB models attributes as a pair of operations, one to set and one to get the attribute value. The language mapping defines the means of expressing these operations. One reason for distinguishing attributes from pairs of operations is to allow the language mapping to define the most natural way for accessing them. Some possible choices include defining two operations for each attribute, defining two operations that can set or get, respectively, any attribute, defining operations that can set or get groups of attributes, and so forth.<p>
</a><a name="490">
<h2>	14.1.8	 ORB Interfaces</h2>
</a><a name="491">
 Most of a language mapping is concerned with how the programmer-defined objects and data are accessed. Programmers who use the ORB must also access some interfaces implemented directly by the ORB, for example, to convert an object reference to a string. A language mapping must also specify how these interfaces appear in the particular programming language.<p>
</a><a name="492">
Various approaches may be taken, including defining a set of library routines, allowing additional ORB-related operations on objects, or defining interfaces that are similar to the language mapping for ordinary objects.<p>
</a><a name="493">
The last approach is called defining pseudo-objects. A pseudo-object has an interface that can (with a few exceptions) be defined in IDL, but is not necessarily implemented as an ORB object. Using stubs a client of a pseudo-object writes calls to it in the same way as if it were an ordinary object. Pseudo-object operations cannot be invoked with the Dynamic Invocation Interface. However, the ORB may recognize such calls as special and handle them directly. One advantage of pseudo-objects is that the interface can be expressed in IDL independent of the particular language mapping, and the programmer can understand how to write calls by knowing the language mapping for the invocations of ordinary objects.<p>
</a><a name="494">
It is not necessary for a language mapping to use the pseudo-object approach. However, this document defines interfaces in subsequent chapters using OMG IDL wherever possible. A language mapping must define how these interfaces are accessed, either by defining them as pseudo-objects and supporting a mapping similar to ordinary objects, by defining language-specific interfaces for them, or in some other way.<p>
</a><a name="157">
<h1>	14.2	 Scoped Names</h1>
</a><a name="158">
 The C programmer must always use the global name for a type, constant, exception, or operation. The C global name corresponding to an OMG IDL global name is derived by converting occurrences of "<strong>::</strong>" to "_" (an underscore) and eliminating the leading underscore.<p>
</a><a name="159">
Consider the following example:<p>
</a><a name="160">
 typedef string&lt;256&gt; filename_t;<p>
</a><a name="145">
<blockquote>interface example0 {</blockquote>
</a><a name="153">
<blockquote>						enum color {red, green, blue};</blockquote>
</a><a name="155">
<blockquote>						union bar switch (enum foo {room, bell}) { ... };</blockquote>
</a><a name="294">
<blockquote>						&#183; &#183; &#183;</blockquote>
</a><a name="295">
 };<p>
</a><a name="161">
Code to use this interface would look as follows:<p>
</a><a name="420">
 #include "example0.h"																					/* C */<p>
</a><a name="296">
 <p>
</a><a name="297">
 filename_t FN;<p>
</a><a name="298">
 example0_color C = example0_red;<p>
</a><a name="299">
 example0_bar myUnion;<p>
</a><a name="300">
 <br>switch (myUnion._d) {<p>
</a><a name="301">
 	case example0_bar_room: &#183; &#183; &#183;<p>
</a><a name="302">
 	case example0_bar_bell: &#183; &#183; &#183;<p>
</a><a name="303">
 };<p>
</a><a name="163">
Note that the use of underscores to replace the "<strong>::</strong>" separators can lead to ambiguity if the OMG IDL specification contains identifiers with underscores in them. Consider the following example:<p>
</a><a name="164">
 typedef long foo_bar;<p>
</a><a name="304">
<blockquote>interface foo {</blockquote>
</a><a name="305">
<blockquote>						typedef short bar;					/* A legal OMG IDL statement,					but ambiguous 	in C */</blockquote>
</a><a name="306">
<blockquote>						&#183; &#183; &#183;</blockquote>
</a><a name="307">
 };<p>
</a><a name="165">
Due to such ambiguities, it is advisable to avoid the indiscriminate use of underscores in identifiers.<p>
</a><a name="166">
<h1>	14.3	 Mapping for Interfaces</h1>
</a><a name="167">
 All interfaces must be defined at global scope (<em>no</em> nested interfaces). The mapping for an interface declaration is as follows:<p>
</a><a name="309">
 interface example1 {<p>
</a><a name="142">
 						long op1(in long arg1);<br>};<p>
</a><a name="169">
The preceding example generates the following C declarations<a href="#152"><sup>1</sup></a>:<p>
</a><a name="170">
 typedef CORBA_Object example1;																					/* C */<p>
</a><a name="737">
 extern CORBA_long example1_op1(<p>
</a><a name="748">
 						example1 o, <p>
</a><a name="751">
 						CORBA_long arg1,<p>
</a><a name="1153">
 						CORBA_Environment *ev<p>
</a><a name="749">
 );<p>
</a><a name="310">
 <p>
</a><a name="171">
All object references (typed interface references to an object) are of the well-known, opaque type CORBA_Object. The representation of CORBA_Object<strong> </strong>is a pointer. To permit the programmer to decorate a program with typed references, a type with the name of the interface is defined to be a CORBA_Object. The literal<p>
</a><a name="3684">
CORBA_OBJECT_NIL is legal wherever a CORBA_Object may be used; it is guaranteed to pass the <strong>is_nil</strong> operation defined in <a href="orbif2.html#129">Section &#32;7.2.3, "Nil Object References," on page &#32;7-4</a>. <p>
</a><a name="172">
OMG IDL permits specifications in which arguments, return results, or components of constructed types may be interface references. Consider the following example:<p>
</a><a name="173">
 #include "example1.idl"<p>
</a><a name="312">
<blockquote></blockquote>
</a><a name="313">
<blockquote>interface example2 {</blockquote>
</a><a name="314">
<blockquote>						example1 op2();</blockquote>
</a><a name="315">
 };<p>
</a><a name="174">
This is equivalent to the following C declaration:<p>
</a><a name="175">
 #include "example1.h"																					/* C */<p>
</a><a name="316">
 <p>
</a><a name="318">
 typedef CORBA_Object example2;<p>
</a><a name="317">
 extern example1 example2_op2(example2 o, CORBA_Environment *ev);<p>
</a><a name="176">
A C fragment for invoking such an operation is as follows:<p>
</a><a name="177">
 #include "example2.h"																					/* C */<p>
</a><a name="319">
 <p>
</a><a name="320">
 example1 ex1;<p>
</a><a name="321">
 example2 ex2;<p>
</a><a name="322">
 CORBA_Environment ev;<p>
</a><a name="323">
 <p>
</a><a name="326">
 /* code for binding ex2 */<p>
</a><a name="324">
 <p>
</a><a name="325">
 ex1 = example2_op2(ex2, &amp;ev);<p>
</a><a name="178">
<h1>	14.4	 Inheritance and Operation Names</h1>
</a><a name="179">
 OMG IDL permits the specification of interfaces that inherit operations from other interfaces. Consider the following example:<p>
</a><a name="180">
 interface example3 : example1 {<p>
</a><a name="327">
<blockquote>						void op3(in long arg3, out long arg4);</blockquote>
</a><a name="328">
 };<p>
</a><a name="181">
This is equivalent to the following C declarations:<p>
</a><a name="182">
 typedef CORBA_Object example3;																					/* C */<p>
</a><a name="329">
 extern CORBA_long example3_op1(<p>
</a><a name="738">
 						example3 o, <p>
</a><a name="740">
 						CORBA_long arg1,<p>
</a><a name="1161">
 						CORBA_Environment *ev<p>
</a><a name="741">
 );<p>
</a><a name="330">
 extern void example3_op3(<p>
</a><a name="728">
 						example3 o, <p>
</a><a name="730">
 						CORBA_long arg3, <p>
</a><a name="731">
 						CORBA_long *arg4,<p>
</a><a name="1167">
 						CORBA_Environment *ev<p>
</a><a name="727">
 );<p>
</a><a name="183">
As a result, an object written in C can access <strong>op1</strong> as if it was directly declared in <strong>example3</strong>. Of course, the programmer could also invoke example1_op1 on an Object of type example3; the virtual nature of operations in interface definitions will cause invocations of either function to cause the same method to be invoked.<p>
</a><a name="311">
<h1>	14.5	 Mapping for Attributes</h1>
</a><a name="518">
The mapping for attributes is best explained through example. Consider the following specification:<p>
</a><a name="331">
 interface foo {<p>
</a><a name="521">
<blockquote>						struct position_t {</blockquote>
</a><a name="522">
<blockquote>						float x, y;</blockquote>
</a><a name="523">
<blockquote>	};</blockquote>
</a><a name="332">
<blockquote></blockquote>
</a><a name="525">
<blockquote>						attribute float radius;</blockquote>
</a><a name="526">
<blockquote>						readonly attribute position_t position;</blockquote>
</a><a name="527">
 };<p>
</a><a name="529">
This is exactly equivalent to the following illegal OMG IDL specification:<p>
</a><a name="531">
 interface foo {<p>
</a><a name="532">
<blockquote>						struct position_t {</blockquote>
</a><a name="533">
<blockquote>						float x, y;</blockquote>
</a><a name="534">
<blockquote>	};</blockquote>
</a><a name="535">
<blockquote></blockquote>
</a><a name="536">
<blockquote>						float 			_get_radius();</blockquote>
</a><a name="537">
<blockquote>						void 			_set_radius(in float r);</blockquote>
</a><a name="538">
<blockquote>						position_t 			_get_position();</blockquote>
</a><a name="539">
 };<p>
</a><a name="542">
This latter specification is illegal, since OMG IDL identifiers are not permitted to start with the underscore (<strong>_</strong>) character. <p>
</a><a name="546">
The language mapping for attributes then becomes the language mapping for these equivalent operations. More specifically, the function signatures generated for the above operations are as follows:<p>
</a><a name="548">
 typedef struct foo_position_t {																				/* C */<p>
</a><a name="549">
 						CORBA_float x, y;<p>
</a><a name="550">
 } foo_position_t;<p>
</a><a name="551">
 <p>
</a><a name="552">
 extern CORBA_float foo__get_radius(foo o, CORBA_Environment *ev);<p>
</a><a name="553">
 extern void foo__set_radius(<p>
</a><a name="742">
 						foo o, <p>
</a><a name="744">
 						CORBA_float r,<p>
</a><a name="1173">
 						CORBA_Environment *ev<p>
</a><a name="745">
 );<p>
</a><a name="554">
 extern foo_position_t foo__get_position(foo o, CORBA_Environment *ev);<p>
</a><a name="557">
Note that two underscore characters (__) separate the name of the interface from the words "get" or "set" in the names of the functions.<p>
</a><a name="561">
If the "set" accessor function fails to set the attribute value, the method should return one of the standard exceptions defined in <a href="idlsyn.html#690">Section &#32;3.15, "Standard Exceptions," on page &#32;3-33</a>. <p>
</a><a name="184">
<h1>	14.6	 Mapping for Constants</h1>
</a><a name="185">
 Constant identifiers can be referenced at any point in the user's code where a literal of that type is legal. In C, these constants are #defined.<p>
</a><a name="186">
The fact that constants are #defined may lead to ambiguities in code. All names which are mandated by the mappings for any of the structured types below start with an underscore. <p>
</a><a name="187">
<h1>	14.7	 Mapping for Basic Data Types</h1>
</a><a name="188">
 The basic data types have the mappings shown in <a href="cmap.html#188">Table 19 on page 14-8</a>. Implementations are responsible for providing typedefs for CORBA_short, CORBA_long, and so forth. consistent with OMG IDL requirements for the corresponding data types. 
<Table Border="3">
<caption><a name="333">
Table 19:  Data Type Mappings <p>
</a></caption>
<tr><th><a name="335">
 OMG IDL<p>
</a><th><a name="336">
 C<p>
</a>
<tr><td><a name="337">
 short <p>
</a><td><a name="338">
 CORBA_short<p>
</a>
<tr><td><a name="339">
 long <p>
</a><td><a name="340">
 CORBA_long<p>
</a>
<tr><td><a name="341">
 unsigned short <p>
</a><td><a name="343">
 CORBA_unsigned_short<p>
</a>
<tr><td><a name="421">
 unsigned long <p>
</a><td><a name="423">
 CORBA_unsigned_long<p>
</a>
<tr><td><a name="424">
 float <p>
</a><td><a name="425">
 CORBA_float<p>
</a>
<tr><td><a name="426">
 double <p>
</a><td><a name="428">
 CORBA_double<p>
</a>
<tr><td><a name="429">
 char <p>
</a><td><a name="430">
 CORBA_char<p>
</a>
<tr><td><a name="432">
 boolean <p>
</a><td><a name="434">
 CORBA_boolean<p>
</a>
<tr><td><a name="442">
 octet <p>
</a><td><a name="443">
 CORBA_octet<p>
</a>
<tr><td><a name="444">
 enum <p>
</a><td><a name="445">
 CORBA_enum<p>
</a>
<tr><td><a name="732">
 any<p>
</a><td><a name="733">
 typedef struct CORBA_any { CORBA_TypeCode _type; void *_value; }<p>
</a><a name="746">
  CORBA_any;<p>
</a>

</Table>

<Table>
<tr><td>
</Table>
 <p>
</a><a name="2170">
The C mapping of the OMG IDL <strong>boolean</strong> types is unsigned char with only the values 1 (TRUE) and 0 (FALSE) defined; other values produce undefined behavior. CORBA_boolean is provided for symmetry with the other basic data type mappings.<p>
</a><a name="752">
The C mapping of OMG IDL<strong> enum</strong> types is an unsigned integer type capable of representing 232 enumerations. Each enumerator in an <strong>enum</strong> is #defined with an appropriate unsigned integer value conforming to the ordering constraints described in <a href="idlsyn.html#568">"Enumerations" on page &#32;3-24</a>.<p>
</a><a name="3017">
TypeCodes are described in <a href="intrep2.html#969">Section &#32;6.7, "TypeCodes," on page &#32;6-33</a>. The _value member for an <strong>any</strong> is a pointer to the actual value of the datum.<p>
</a><a name="2469">
The <strong>any</strong> type supports the notion of ownership of its _value member. By setting a release flag in the <strong>any</strong> when a value is installed, programmers can control ownership of the memory pointed to by _value. The location of this release flag is implementation-dependent, so the following two ORB-supplied functions allow for the setting and checking of the <strong>any</strong> release flag:<p>
</a><a name="2474">
 void CORBA_any_set_release(CORBA_any*, CORBA_boolean);																					/* C */<br>CORBA_boolean CORBA_any_get_release(CORBA_any*);<p>
</a><a name="2475">
CORBA_any_set_release can be used to set the state of the release flag. If the flag is set to TRUE, the <strong>any</strong> effectively "owns" the storage pointed to by _value; if FALSE, the programmer is responsible for the storage. If, for example, an <strong>any</strong> is returned from an operation with its release flag set to FALSE, calling CORBA_free() on the returned any* will not deallocate the memory pointed to by _value. Before calling CORBA_free() on the _value member of an <strong>any</strong> directly, the programmer should check the release flag using CORBA_any_get_release. If it returns FALSE, the programmer should not invoke CORBA_free() on the _value member; doing so produces undefined behavior. Also, passing a null pointer to either CORBA_any_set_release or CORBA_any_get_release produces undefined behavior.<p>
</a><a name="2574">
If CORBA_any_set_release is never called for a given instance of <strong>any</strong>, the default value of the release flag for that instance is FALSE.<p>
</a><a name="2034">
<h1>	14.8	 Mapping Considerations for Constructed Types</h1>
</a><a name="2037">
 The mapping for OMG IDL structured types (structs, unions, arrays, and sequences) can vary slightly depending on whether the data structure is <em>fixed-length</em> or <em>variable-length</em>. A type is <em>variable-length</em> if it is one of the following types:<p>
</a><ul><a name="2040">
<li>The type <strong>any</strong>
</a><a name="2042">
<li>A bounded or unbounded string
</a><a name="2044">
<li>A bounded or unbounded sequence
</a><a name="2048">
<li>An object reference or reference to a transmissible pseudo-object<a href="#2047"><sup>2</sup></a>
</a><a name="2049">
<li>A struct or union that contains a member whose type is variable-length
</a><a name="2050">
<li>An array with a variable-length element type
</a><a name="2051">
<li>A typedef to a variable-length type
</a><a name="2057">
The reason for treating fixed- and variable-length data structures differently is to allow more flexibility in the allocation of <strong>out</strong> parameters and return values from an operation. This flexibility allows a client-side stub for an operation that returns a sequence of strings, for example, to allocate all the string storage in one area that is deallocated in a single call.<p>
</a><a name="2035">
 The mapping of a variable-length type as an <strong>out</strong> parameter or operation return value is a pointer to the associated class or array, as shown in <a href="cmap.html#502">Table 20 on page 14-19</a>.<p>
</a><a name="2349">
For types whose parameter passing modes require heap allocation, an ORB implementation will provide allocation functions. These types include variable-length <strong>struct</strong>, variable-length <strong>union</strong>, <strong>sequence</strong>, <strong>any</strong>, <strong>string</strong>, and array of a variable-length type. The return value of these allocation functions must be freed using CORBA_free(). For one of these listed types T, the ORB implementation will provide the following type-specific allocation function:<p>
</a><a name="2350">
 T *T__alloc();																				/* C */<p>
</a><a name="2345">
The functions are defined at global scope using the fully-scoped name of T converted into a C language name (as described in <a href="cmap.html#157"> Section 14.2</a>) followed by the suffix "__alloc" (note the double underscore). For <strong>any</strong> and <strong>string</strong>, the allocation functions are:<p>
</a><a name="2434">
 CORBA_any *CORBA_any_alloc();<br>char *CORBA_string_alloc();<p>
</a><a name="2435">
respectively.<p>
</a></ul><a name="734">
<h1>	14.9	 Mapping for Structure Types</h1>
</a><a name="191">
 OMG IDL structures map directly onto C structs. Note that all OMG IDL types that map to C structs may potentially include padding.<p>
</a><a name="192">
<h1>	14.10	 Mapping for Union Types</h1>
</a><a name="193">
 OMG IDL discriminated unions are mapped onto C structs. Consider the following OMG IDL declaration:<p>
</a><a name="194">
 union Foo switch (long) {<p>
</a><a name="344">
<blockquote>						case 1: long x;</blockquote>
</a><a name="345">
<blockquote>						case 2: float y;</blockquote>
</a><a name="346">
<blockquote>						default: char z;</blockquote>
</a><a name="347">
 };<p>
</a><a name="195">
This is equivalent to the following <strong>struct</strong> in C:<p>
</a><a name="196">
 typedef struct {																				/* C */<p>
</a><a name="348">
 						CORBA_long _d;<p>
</a><a name="349">
 						union {<p>
</a><a name="350">
 						CORBA_long x;<p>
</a><a name="351">
 						CORBA_float y;<p>
</a><a name="352">
 						CORBA_char z;<p>
</a><a name="353">
 						} _u;<p>
</a><a name="354">
 } Foo;<p>
</a><a name="197">
The discriminator in the struct is always referred to as _d; the union in the struct is always referred to as _u.<p>
</a><a name="198">
Reference to union elements is as in normal C:<p>
</a><a name="199">
 Foo *v;																				/* C */<p>
</a><a name="355">
 <p>
</a><a name="356">
 /* make a call that returns a pointer to a Foo in v */<br><br>switch(v-&gt;_d) {<p>
</a><a name="357">
 						case 1:			printf("x = %ld\n", v-&gt;_u.x); break;<p>
</a><a name="358">
 						case 2:			printf("y = %f\n", v-&gt;_u.y); break;<p>
</a><a name="359">
 						default:			printf("z = %c\n", v-&gt;_u.z); break;<p>
</a><a name="360">
 }<p>
</a><a name="2023">
An ORB implementation need not use a C union to hold the OMG IDL <strong>union</strong> elements; a C struct may be used instead. In either case, the programmer accesses the union elements via the _u member.<p>
</a><a name="200">
<h1>	14.11	 Mapping for Sequence Types</h1>
</a><a name="201">
 The OMG IDL data type <strong>sequence</strong> permits passing of unbounded arrays between objects. Consider the following OMG IDL declaration:<p>
</a><a name="202">
 typedef sequence&lt;long,10&gt; vec10;<p>
</a><a name="203">
In C, this is converted to:<p>
</a><a name="204">
 typedef struct {																					/* C */<p>
</a><a name="361">
 						CORBA_unsigned_long _maximum;<p>
</a><a name="362">
 						CORBA_unsigned_long _length;<p>
</a><a name="363">
 						CORBA_long *_buffer;<p>
</a><a name="364">
 } vec10;<p>
</a><a name="205">
An instance of this type is declared as follows:<p>
</a><a name="206">
 vec10 x = {10L, 0L, (CORBA_long *)NULL);																					/* C */<p>
</a><a name="207">
Prior to passing &amp;x as an in parameter, the programmer must set the _buffer member to point to a CORBA_long array of 10 elements, and must set the _length member to the actual number of elements to transmit.<p>
</a><a name="1963">
Prior to passing the address of a vec10* as an out parameter (or receiving a vec10* as the function return), the programmer does nothing. The client stub will allocate storage for the returned sequence; for bounded sequences, it also allocates a buffer of the specified size, while for unbounded sequences, it also allocates a buffer big enough to hold what was returned by the object. Upon successful return from the invocation, the _maximum member will contain the size of the allocated array, the _buffer member will point at allocated storage, and the _length member will contain the number of values that were returned in the _buffer member. The client is responsible for freeing the allocated sequence using CORBA_free().<p>
</a><a name="3576">
Prior to passing &amp;x as an <strong>inout</strong> parameter, the programmer must set the _buffer member to point to a CORBA_long array of 10 elements. The _length member must be set to the actual number of elements to transmit. Upon successful return from the invocation, the _length member will contain the number of values that were copied into the buffer pointed to by the _buffer member. If more data must be returned than the original buffer can hold, the callee can deallocate the original _buffer member using CORBA_free() (honoring the release flag) and assign _buffer to point to new storage. <p>
</a><a name="3581">
For bounded sequences, it is an error to set the _length or _maximum member to a value larger than the specified bound.<p>
</a><a name="2506">
Sequence types support the notion of ownership of their _buffer members. By setting a release flag in the sequence when a buffer is installed, programmers can control ownership of the memory pointed to by _buffer. The location of this release flag is implementation-dependent, so the following two ORB-supplied functions allow for the setting and checking of the sequence release flag:<p>
</a><a name="2507">
 void CORBA_sequence_set_release(void*, CORBA_boolean);																					/* C */<br>CORBA_boolean CORBA_sequence_get_release(void*);<p>
</a><a name="2508">
CORBA_sequence_set_release can be used to set the state of the release flag. If the flag is set to TRUE, the sequence effectively "owns" the storage pointed to by _buffer; if FALSE, the programmer is responsible for the storage. If, for example, a sequence is returned from an operation with its release flag set to FALSE, calling CORBA_free() on the returned sequence pointer will not deallocate the memory pointed to by _buffer. Before calling CORBA_free() on the _buffer member of a sequence directly, the programmer should check the release flag using CORBA_sequence_get_release. If it returns FALSE, the programmer should not invoke CORBA_free() on the _buffer member; doing so produces undefined behavior. Also, passing a null pointer or a pointer to something other than a sequence type to either CORBA_sequence_set_release or CORBA_sequence_get_release produces undefined behavior.<p>
</a><a name="2596">
CORBA_sequence_set_release should only be used by the creator of a sequence. If it is not called for a given sequence instance, then the default value of the release flag for that instance is FALSE.<p>
</a><a name="2597">
Two sequence types are the same type if their sequence element type and size arguments are identical. For example,<p>
</a><a name="212">
 const long SIZE = 25;<p>
</a><a name="365">
<blockquote>typedef long seqtype;</blockquote>
</a><a name="366">
<blockquote></blockquote>
</a><a name="367">
<blockquote>typedef sequence&lt;long, SIZE&gt; s1;</blockquote>
</a><a name="368">
<blockquote>typedef sequence&lt;long, 25&gt; s2;</blockquote>
</a><a name="369">
<blockquote>typedef sequence&lt;seqtype, SIZE&gt; s3;</blockquote>
</a><a name="370">
 typedef sequence&lt;seqtype, 25&gt; s4;<p>
</a><a name="213">
declares <strong>s1</strong>, <strong>s2</strong>, <strong>s3</strong>, and <strong>s4</strong> to be of the same type.<p>
</a><a name="214">
The OMG IDL type<p>
</a><a name="4047">
<p>
</a><a name="215">
 sequence&lt;type,size&gt;<p>
</a><a name="216">
maps to<p>
</a><a name="217">
 #ifndef _CORBA_sequence_type_defined																					/* C */<p>
</a><a name="371">
 #define _CORBA_sequence_type_defined<p>
</a><a name="372">
 typedef struct {<p>
</a><a name="373">
 						CORBA_unsigned_long _maximum;<p>
</a><a name="374">
 						CORBA_unsigned_long _length;<p>
</a><a name="375">
 						type *_buffer;<p>
</a><a name="376">
 } CORBA_sequence_type;<p>
</a><a name="377">
 #endif 			/* _CORBA_sequence_type_defined */<p>
</a><a name="218">
The ifdef's are needed to prevent duplicate definition where the same type is used more than once. The type name used in the C mapping is the type name of the effective type, e.g. in<p>
</a><a name="219">
 typedef CORBA_long FRED;																					/* C */<p>
</a><a name="378">
 typedef sequence&lt;FRED,10&gt; FredSeq;<p>
</a><a name="220">
the sequence is mapped onto struct { ... } CORBA_sequence_long;<p>
</a><a name="716">
If the <strong>type</strong> in <p>
</a><a name="717">
 sequence&lt;type,size&gt;<p>
</a><a name="718">
consists of more than one identifier (e.g. unsigned long), then the generated type name consists of the string "CORBA_sequence_" concatenated to the string consisting of the concatenation of each identifier separated by underscores (e.g. "unsigned_long"). <p>
</a><a name="719">
If the <strong>type</strong> is a <strong>string</strong>, the string "string" is used to generate the type name. If the <strong>type</strong> is a <strong>sequence</strong>, the string "sequence" is used to generate the type name, recursively. For example<p>
</a><a name="720">
 sequence&lt;sequence&lt;long&gt; &gt;<p>
</a><a name="721">
generates a type of <p>
</a><a name="722">
 CORBA_sequence_sequence_long<p>
</a><a name="221">
These generated type names may be used to declare instances of a sequence type.<p>
</a><a name="2357">
In addition to providing a type-specific allocation function for each sequence, an ORB implementation must provide a buffer allocation function for each sequence type. These functions allocate vectors of type T for sequence&lt;T&gt;. They are defined at global scope and are named similarly to sequences:<p>
</a><a name="2368">
 T *CORBA_sequence_T_allocbuf(CORBA_unsigned_long len);																					/* C */<p>
</a><a name="2373">
Here, "T" refers to the type name. For the type<p>
</a><a name="2378">
<blockquote>sequence&lt;sequence&lt;long&gt; &gt;</blockquote>
</a><a name="2379">
for example, the sequence buffer allocation function is named<p>
</a><a name="2382">
 T *CORBA_sequence_sequence_long_allocbuf(CORBA_unsigned_long len);<p>
</a><a name="2391">
Buffers allocated using these allocation functions are freed using CORBA_free().<p>
</a><a name="222">
<h1>	14.12	 Mapping for Strings</h1>
</a><a name="223">
 OMG IDL strings are mapped to 0-byte terminated character arrays; i.e. the length of the string is encoded in the character array itself through the placement of the 0-byte. Note that the storage for C strings is one byte longer than the stated OMG IDL bound. Consider the following OMG IDL declarations:<p>
</a><a name="224">
 typedef string&lt;10&gt; sten;<p>
</a><a name="379">
 typedef string sinf;<p>
</a><a name="225">
In C, this is converted to:<p>
</a><a name="226">
 typedef CORBA_char *sten;																					/* C */<p>
</a><a name="380">
 typedef CORBA_char *sinf;<p>
</a><a name="227">
Instances of these types are declared as follows:<p>
</a><a name="228">
 sten s1 = NULL;																					/* C */<p>
</a><a name="381">
 sinf s2 = NULL;<p>
</a><a name="229">
Two string types are the same type if their size arguments are identical. For example,<p>
</a><a name="230">
 const long SIZE = 25;																					/* C */<p>
</a><a name="382">
 <p>
</a><a name="384">
 typedef string&lt;SIZE&gt; sx;<p>
</a><a name="383">
 typedef string&lt;25&gt; sy;<p>
</a><a name="231">
declares <strong>sx</strong> and <strong>sy</strong> to be of the same type.<p>
</a><a name="232">
Prior to passing s1 or s2 as an <strong>in</strong> parameter, the programmer must assign the address of a character buffer containing a 0-byte terminated string to the variable. The caller cannot pass a null pointer as the string argument.<p>
</a><a name="233">
Prior to passing &amp;s1 or &amp;s2 as an <strong>out</strong> parameter (or receiving an sten or sinf as the return result), the programmer does nothing. The client stub will allocate storage for the returned buffer; for bounded strings, it allocates a buffer of the specified size, while for unbounded strings, it allocates a buffer big enough to hold the returned string. Upon successful return from the invocation, the character pointer will contain the address of the allocated buffer. The client is responsible for freeing the allocated storage using CORBA_free().<p>
</a><a name="3592">
Prior to passing &amp;s1 or &amp;s2 as an <strong>inout</strong> parameter, the programmer must assign the address of a character buffer containing a 0-byte terminated array to the variable. If the returned string is larger than the original buffer, the client stub will call CORBA_free() on the original string and allocate a new buffer for the new string. The client should therefore never pass an <strong>inout</strong> string parameter that was not allocated using CORBA_string_alloc. The client is responsible for freeing the allocated storage using CORBA_free(), regardless of whether or not a reallocation was necessary.<p>
</a><a name="2392">
Strings are dynamically allocated using the following ORB-supplied function:<p>
</a><a name="5167">
 <br>char *CORBA_string_alloc(CORBA_unsigned_long len);<p>
</a><a name="5171">
This function allocates len+1 bytes, enough to hold the string and its terminating NUL character.<p>
</a><a name="2396">
Strings allocated in this manner are freed using CORBA_free().<p>
</a><a name="235">
<h1>	14.13	 Mapping for Arrays</h1>
</a><a name="236">
 OMG IDL arrays map directly to C arrays. All array indices run from 0 to &lt;size - 1&gt;.<p>
</a><a name="2004">
For each named array type in OMG IDL, the mapping provides a C typedef for pointer to the array's <em>slice</em>. A slice of an array is another array with all the dimensions of the original except the first. For example, given the following OMG IDL definition:<p>
</a><a name="2005">
<blockquote>typedef long LongArray[4][5];</blockquote>
</a><a name="2006">
The C mapping provides the following definitions:<p>
</a><a name="2007">
 typedef CORBA_long LongArray[4][5];<br>typedef CORBA_long LongArray_slice[5];<p>
</a><a name="2008">
The generated name of the slice typedef is created by appending "_slice" to the original array name.<p>
</a><a name="455">
If the return result, or an <strong>out</strong> parameter for an array holding a variable-length type, of an operation is an array, the array storage is dynamically allocated by the stub; a pointer to the array slice of the dynamically allocated array is returned as the value of the client stub function. When the data is no longer needed, it is the programmer's responsibility to return the dynamically allocated storage by calling CORBA_free().<p>
</a><a name="2409">
For an array T of a variable-length type is dynamically allocated using the following ORB-supplied function:<p>
</a><a name="2412">
 T_slice *T__alloc();																					/* C */<p>
</a><a name="2417">
This function is identical to the allocation functions described in <a href="cmap.html#2034">Section &#32;14.8, "Mapping Considerations for Constructed Types," on page &#32;14-9</a>, except that the return type is pointer to array slice, not pointer to array.<p>
</a><a name="237">
<h1>	14.14	 Mapping for Exception Types</h1>
</a><a name="238">
 Each defined exception type is defined as a struct tag and a typedef with the C global name for the exception. An identifier for the exception, in string literal form, is also #defined, as is a type-specific allocation function. For example:<p>
</a><a name="239">
 exception foo {<p>
</a><a name="385">
<blockquote>						long dummy;</blockquote>
</a><a name="386">
 };<p>
</a><a name="240">
yields the following C declarations:<p>
</a><a name="241">
 typedef struct foo {																					/* C */<p>
</a><a name="387">
 						CORBA_long dummy;<br>						/* ...may contain additional<br>						 &#32;* implementation-specific members...<br>						 */<p>
</a><a name="388">
 } foo;<p>
</a><a name="389">
 #define ex_foo &lt;unique identifier for exception&gt;<br>foo *foo__alloc();<p>
</a><a name="242">
The identifier for the exception uniquely identifies this exception type. For example, it could be the Interface Repository identifier for the exception (see <a href="intrep2.html#4116">Section &#32;6.5.19, "ExceptionDef," on page &#32;6-23</a>).<p>
</a><a name="5172">
The allocation function dynamically allocates an instance of the exception and returns a pointer to it. Each exception type has its own dynamic allocation function. Exceptions allocated using a dynamic allocation function are freed using CORBA_free().<p>
</a><a name="243">
<h1>	14.15	 Implicit Arguments to Operations</h1>
</a><a name="244">
 From the point of view of the C programmer, all operations declared in an interface have additional leading parameters preceding the operation-specific parameters:<p>
</a><a name="132">
1.	 	The first parameter to each operation is a CORBA_Object input param	eter; this parameter designates the object to process the request.<p>
</a><a name="140">
2.	 The last parameter to each operation is a (CORBA_Environment *) 	output parameter; this parameter permits the return of exception information. <p>
</a><a name="141">
3.	 If an operation in an OMG IDL specification has a context specification, then a CORBA_Context input parameter precedes the (CORBA_Environment *) parameter and follows any operation-specific arguments. <p>
</a><a name="245">
As described above, the CORBA_Object type is an opaque type. The CORBA_Environment type is partially opaque; <a href="cmap.html#1194"> Section 14.20</a> provides a description of the non-opaque portion of the exception structure and an example of how to handle exceptions in client code. The CORBA_Context type is opaque; see the Dynamic Invocation Interface chapter for more information on how to create and manipulate context objects.<p>
</a><a name="246">
<h1>	14.16	 Interpretation of Functions with Empty Argument Lists</h1>
</a><a name="247">
 A function declared with an empty argument list is defined to take <em>no</em> operation-specific arguments.<p>
</a><a name="248">
<h1>	14.17	 Argument Passing Considerations</h1>
</a><a name="249">
 For all OMG IDL types (except arrays), if the OMG IDL signature specifies that an argument is an <strong>out</strong> or <strong>inout</strong> parameter, then the caller must always pass the address of a variable of that type (or the value of a pointer to that type); the callee must dereference the parameter to get to the type. For arrays, the caller must pass the address of the first element of the array.<p>
</a><a name="129">
For <strong>in</strong> parameters, the value of the parameter must be passed for all of the basic types, enumeration types, and object references. For all arrays, the address of the first element of the array must be passed. For all other structured types, the address of a variable of that type must be passed, regardless of whether they are fixed- or variable-length. For strings, a char* must be passed.<p>
</a><a name="2120">
For <strong>inout</strong> parameters, the address of a variable of the correct type must be passed for all of the basic types, enumeration types, object references, and structured types. For strings, the address of a char* must be passed. For all arrays, the address of the first element of the array must be passed.<p>
</a><a name="250">
Consider the following OMG IDL specification:<p>
</a><a name="251">
 interface foo {<p>
</a><a name="390">
<blockquote>	typedef long Vector[25];</blockquote>
</a><a name="391">
<blockquote></blockquote>
</a><a name="392">
<blockquote>						void bar(out Vector x, out long y);</blockquote>
</a><a name="393">
 };<p>
</a><a name="252">
Client code for invoking the <strong>bar</strong> operation would look like:<p>
</a><a name="253">
 foo object;																					/* C */<p>
</a><a name="394">
 foo_Vector_slice x;<p>
</a><a name="130">
 CORBA_long y;<p>
</a><a name="395">
 CORBA_Environment ev;<p>
</a><a name="396">
 <p>
</a><a name="397">
 /* code to bind object to instance of foo */<p>
</a><a name="398">
 <p>
</a><a name="399">
 foo_bar(object, &amp;x, &amp;y, &amp;ev);<p>
</a><a name="723">
For <strong>out</strong> parameters of type variable-length <strong>struct</strong>, variable-length <strong>union</strong>, <strong>string</strong>, <strong>sequence</strong>, an array holding a variable-length type, or <strong>any</strong>, the ORB will allocate storage for the output value using the appropriate type-specific allocation function. The client may use and retain that storage indefinitely, and must indicate when the value is no longer needed by calling the procedure CORBA_free, whose signature is:<p>
</a><a name="4056">
<p>
</a><a name="724">
 extern void CORBA_free (void *storage);																					/* C */<p>
</a><a name="2425">
The parameter to CORBA_free() is the pointer used to return the <strong>out</strong> parameter. CORBA_free() releases the ORB-allocated storage occupied by the <strong>out</strong> parameter, including storage indirectly referenced, such as in the case of a sequence of strings or array of object reference. If a client does not call CORBA_free() before reusing the pointers that reference the <strong>out</strong> parameters, that storage might be wasted. Passing a null pointer to CORBA_free() is allowed; CORBA_free() simply ignores it and returns without error.<p>
</a><a name="255">
<h1>	14.18	 Return Result Passing Considerations</h1>
</a><a name="256">
 When an operation is defined to return a non-void return result, the following rules hold:<p>
</a><a name="257">
<strong>1</strong>. If the return result is one of the types <strong>float</strong>, <strong>double</strong>, <strong>long</strong>, <strong>short</strong>, <strong>unsigned long</strong>, <strong>unsigned short</strong>, <strong>char</strong>, <strong>boolean</strong>, <strong>octet</strong>, <strong>Object</strong>, or an <strong>enumeration</strong>, then the value is returned as the operation result.<p>
</a><a name="258">
<strong>2</strong>. If the return result is one of the fixed-length types <strong>struct</strong> or <strong>union</strong>, then the value of the C struct representing that type is returned as the operation result. If the return result is one of the variable-length types <strong>struct</strong>, <strong>union</strong>, <strong>sequence</strong>, or <strong>any</strong>, then a pointer to a C struct representing that type is returned as the operation result.<p>
</a><a name="254">
<strong>3</strong>. If the return result is of type <strong>string</strong>, then a pointer to the first character of the string is returned as the operation result. <p>
</a><a name="695">
<strong>4</strong>. If the return result is of type <strong>array</strong>, then a pointer to the slice of the array is returned as the operation result. <p>
</a><a name="259">
Consider the following interface:<p>
</a><a name="405">
 interface X {<p>
</a><a name="146">
<blockquote>						struct y {</blockquote>
</a><a name="148">
<blockquote>							long a;</blockquote>
</a><a name="264">
<blockquote>							float b;</blockquote>
</a><a name="270">
<blockquote>						};</blockquote>
</a><a name="271">
<blockquote></blockquote>
</a><a name="272">
<blockquote>						long op1();</blockquote>
</a><a name="273">
<blockquote>						y op2();</blockquote>
</a><a name="275">
 }<p>
</a><a name="261">
The following C declarations ensue from processing the specification:<p>
</a><a name="412">
 typedef CORBA_Object X;																					/* C */<p>
</a><a name="276">
 typedef struct X_y {<p>
</a><a name="287">
 						CORBA_long a;<p>
</a><a name="413">
 						CORBA_float b;<p>
</a><a name="416">
 } X_y;<p>
</a><a name="417">
 <p>
</a><a name="418">
 extern CORBA_long X_op1(X object, CORBA_Environment *ev);<p>
</a><a name="419">
 extern X_y X_op2(X object, CORBA_Environment *ev);<p>
</a><a name="726">
For operation results of type variable-length <strong>struct</strong>, variable-length <strong>union</strong>, <strong>string</strong>, <strong>sequence</strong>, <strong>array</strong>, or <strong>any</strong>, the ORB will allocate storage for the return value using the appropriate type-specific allocation function. The client may use and retain that storage indefinitely, and must indicate when the value is no longer needed by calling the procedure CORBA_free() described in <a href="cmap.html#248">Section &#32;14.17, "Argument Passing Considerations</a>. <p>
</a><a name="3843">
<h1>	14.19	 Summary of Argument/Result Passing</h1>
</a><a name="502">
 <a href="cmap.html#502">Table 20 on page 14-19</a> summarizes what a client passes as an argument to a stub and receives as a result. 
<Table Border="3">
<caption><a name="1440">
Table 20:  Basic Argument and Result Passing<p>
</a></caption>
<tr><th><a name="1450">
 Data Type<p>
</a><th><a name="1452">
 In<p>
</a><th><a name="1454">
 Inout<p>
</a><th><a name="1456">
 Out<p>
</a><th><a name="1458">
 Return<p>
</a>
<tr><td><a name="1460">
 short<p>
</a><td><a name="1462">
 short<p>
</a><td><a name="1464">
 short*<p>
</a><td><a name="1466">
 short*<p>
</a><td><a name="1468">
 short<p>
</a>
<tr><td><a name="1470">
 long<p>
</a><td><a name="1472">
 long<p>
</a><td><a name="1474">
 long*<p>
</a><td><a name="1476">
 long*<p>
</a><td><a name="1478">
 long<p>
</a>
<tr><td><a name="1480">
 unsigned short<p>
</a><td><a name="1482">
 unsigned_short<p>
</a><td><a name="1484">
 unsigned_short*<p>
</a><td><a name="1486">
 unsigned_short*<p>
</a><td><a name="1488">
 unsigned_short<p>
</a>
<tr><td><a name="1490">
 unsigned long<p>
</a><td><a name="1492">
 unsigned_long<p>
</a><td><a name="1494">
 unsigned_long*<p>
</a><td><a name="1496">
 unsigned_long*<p>
</a><td><a name="1498">
 unsigned_long<p>
</a>
<tr><td><a name="1500">
 float<p>
</a><td><a name="1502">
 float<p>
</a><td><a name="1504">
 float*<p>
</a><td><a name="1506">
 float*<p>
</a><td><a name="1508">
 float<p>
</a>
<tr><td><a name="1510">
 double<p>
</a><td><a name="1512">
 double<p>
</a><td><a name="1514">
 double*<p>
</a><td><a name="1516">
 double*<p>
</a><td><a name="1518">
 double<p>
</a>
<tr><td><a name="1520">
 boolean<p>
</a><td><a name="1522">
 boolean<p>
</a><td><a name="1524">
 boolean*<p>
</a><td><a name="1526">
 boolean*<p>
</a><td><a name="1528">
 boolean<p>
</a>
<tr><td><a name="1530">
 char<p>
</a><td><a name="1532">
 char<p>
</a><td><a name="1534">
 char*<p>
</a><td><a name="1536">
 char*<p>
</a><td><a name="1538">
 char<p>
</a>
<tr><td><a name="1540">
 octet<p>
</a><td><a name="1542">
 octet<p>
</a><td><a name="1544">
 octet*<p>
</a><td><a name="1546">
 octet*<p>
</a><td><a name="1548">
 octet<p>
</a>
<tr><td><a name="1550">
 enum<p>
</a><td><a name="1552">
 enum<p>
</a><td><a name="1554">
 enum*<p>
</a><td><a name="1556">
 enum*<p>
</a><td><a name="1558">
 enum<p>
</a>
<tr><td><a name="1563">
 object reference ptr<a href="#1562"><sup>1</sup></a><p>
</a><td><a name="1565">
 objref_ptr<p>
</a><td><a name="1567">
 objref_ptr*<p>
</a><td><a name="1569">
 objref_ptr*<p>
</a><td><a name="1571">
 objref_ptr<p>
</a>
<tr><td><a name="1573">
 struct, fixed<p>
</a><td><a name="1575">
 struct*<p>
</a><td><a name="1577">
 struct*<p>
</a><td><a name="1579">
 struct*<p>
</a><td><a name="1581">
 struct<p>
</a>
<tr><td><a name="1583">
 struct, variable<p>
</a><td><a name="1585">
 struct*<p>
</a><td><a name="1587">
 struct*<p>
</a><td><a name="1589">
 struct**<p>
</a><td><a name="1591">
 struct*<p>
</a>
<tr><td><a name="1593">
 union, fixed<p>
</a><td><a name="1595">
 union*<p>
</a><td><a name="1597">
 union*<p>
</a><td><a name="1599">
 union*<p>
</a><td><a name="1601">
 union<p>
</a>
<tr><td><a name="1603">
 union, variable<p>
</a><td><a name="1605">
 union*<p>
</a><td><a name="1607">
 union*<p>
</a><td><a name="1609">
 union**<p>
</a><td><a name="1611">
 union*<p>
</a>
<tr><td><a name="1613">
 string<p>
</a><td><a name="1615">
 char*<p>
</a><td><a name="1617">
 char**<p>
</a><td><a name="1619">
 char**<p>
</a><td><a name="1621">
 char*<p>
</a>
<tr><td><a name="1623">
 sequence<p>
</a><td><a name="1625">
 sequence*<p>
</a><td><a name="1627">
 sequence*<p>
</a><td><a name="1629">
 sequence**<p>
</a><td><a name="1631">
 sequence*<p>
</a>
<tr><td><a name="1633">
 array, fixed<p>
</a><td><a name="1635">
 array<p>
</a><td><a name="1637">
 array<p>
</a><td><a name="1639">
 array<p>
</a><td><a name="1644">
 array slice*<a href="#1643"><sup>2</sup></a><p>
</a>
<tr><td><a name="1646">
 array, variable<p>
</a><td><a name="1648">
 array<p>
</a><td><a name="1650">
 array<p>
</a><td><a name="1652">
 array slice**2<p>
</a><td><a name="1654">
 array slice*2<p>
</a>
<tr><td><a name="1656">
 any<p>
</a><td><a name="1658">
 any*<p>
</a><td><a name="1660">
 any*<p>
</a><td><a name="1662">
 any**<p>
</a><td><a name="1664">
 any*<p>
</a>

</Table>

<Table>
<tr><td><sup>1</sup><a name="1562">
 Including pseudo-object references.<p>
</a><sup>2</sup><a name="1643">
 A slice is an array with all the dimensions of the original except the first one.<p>
</a>
</Table>
<a href="#2247"><sup>3</sup></a><p>
</a><a name="1864">
A client is responsible for providing storage for all arguments passed as <strong>in</strong> arguments. 
<Table Border="3">
<caption><a name="1689">
Table 21:  Client Argument Storage Responsibilities<p>
</a></caption>
<tr><th><a name="1697">
 Type<p>
</a><th><a name="1699">
 Inout Param<p>
</a><th><a name="1701">
 Out Param<p>
</a><th><a name="1703">
 Return Result<p>
</a>
<tr><td><a name="1705">
 short<p>
</a><td><a name="1707">
 1<p>
</a><td><a name="1709">
 1<p>
</a><td><a name="1711">
 1<p>
</a>
<tr><td><a name="1713">
 long<p>
</a><td><a name="1715">
 1<p>
</a><td><a name="1717">
 1<p>
</a><td><a name="1719">
 1<p>
</a>
<tr><td><a name="1721">
 unsigned short<p>
</a><td><a name="1723">
 1<p>
</a><td><a name="1725">
 1<p>
</a><td><a name="1727">
 1<p>
</a>
<tr><td><a name="1729">
 unsigned long<p>
</a><td><a name="1731">
 1<p>
</a><td><a name="1733">
 1<p>
</a><td><a name="1735">
 1<p>
</a>
<tr><td><a name="1737">
 float<p>
</a><td><a name="1739">
 1<p>
</a><td><a name="1741">
 1<p>
</a><td><a name="1743">
 1<p>
</a>
<tr><td><a name="1745">
 double<p>
</a><td><a name="1747">
 1<p>
</a><td><a name="1749">
 1<p>
</a><td><a name="1751">
 1<p>
</a>
<tr><td><a name="1753">
 boolean<p>
</a><td><a name="1755">
 1<p>
</a><td><a name="1757">
 1<p>
</a><td><a name="1759">
 1<p>
</a>
<tr><td><a name="1761">
 char<p>
</a><td><a name="1763">
 1<p>
</a><td><a name="1765">
 1<p>
</a><td><a name="1767">
 1<p>
</a>
<tr><td><a name="1769">
 octet<p>
</a><td><a name="1771">
 1<p>
</a><td><a name="1773">
 1<p>
</a><td><a name="1775">
 1<p>
</a>
<tr><td><a name="1777">
 enum<p>
</a><td><a name="1779">
 1<p>
</a><td><a name="1781">
 1<p>
</a><td><a name="1783">
 1<p>
</a>
<tr><td><a name="1785">
 object reference ptr<p>
</a><td><a name="1787">
 2<p>
</a><td><a name="1789">
 2<p>
</a><td><a name="1791">
 2<p>
</a>
<tr><td><a name="1793">
 struct, fixed<p>
</a><td><a name="1795">
 1<p>
</a><td><a name="1797">
 1<p>
</a><td><a name="1799">
 1<p>
</a>
<tr><td><a name="1801">
 struct, variable<p>
</a><td><a name="1803">
 1<p>
</a><td><a name="1805">
 3<p>
</a><td><a name="1807">
 3<p>
</a>
<tr><td><a name="1809">
 union, fixed<p>
</a><td><a name="1811">
 1<p>
</a><td><a name="1813">
 1<p>
</a><td><a name="1815">
 1<p>
</a>
<tr><td><a name="1817">
 union, variable<p>
</a><td><a name="1819">
 1<p>
</a><td><a name="1821">
 3<p>
</a><td><a name="1823">
 3<p>
</a>
<tr><td><a name="1825">
 string<p>
</a><td><a name="1827">
 4<p>
</a><td><a name="1829">
 3<p>
</a><td><a name="1831">
 3<p>
</a>
<tr><td><a name="1833">
 sequence<p>
</a><td><a name="1835">
 5<p>
</a><td><a name="1837">
 3<p>
</a><td><a name="1839">
 3<p>
</a>
<tr><td><a name="1841">
 array, fixed<p>
</a><td><a name="1843">
 1<p>
</a><td><a name="1845">
 1<p>
</a><td><a name="1847">
 6<p>
</a>
<tr><td><a name="1849">
 array, variable<p>
</a><td><a name="1851">
 1<p>
</a><td><a name="1853">
 6<p>
</a><td><a name="1855">
 6<p>
</a>
<tr><td><a name="1857">
 any<p>
</a><td><a name="1859">
 5<p>
</a><td><a name="1861">
 3<p>
</a><td><a name="1863">
 3<p>
</a>

</Table>

<Table>
<tr><td>
</Table>
<p>
</a><a name="1908">
 
<Table Border="3">
<caption><a name="1875">
Table 22:  Argument Passing Cases<p>
</a></caption>
<tr><th><a name="1885">
 Case<a href="#1884"><sup>1</sup></a><p>
</a><th><a name="1887">
 <p>
</a>
<tr><td><a name="1889">
 1<p>
</a><td><a name="1891">
 Caller allocates all necessary storage, except that which may be encapsulated and managed within the parameter itself. For inout parameters, the caller provides the initial value, and the callee may change that value. For out parameters, the caller allocates the storage but need not initialize it, and the callee sets the value. Function returns are by value.<p>
</a>
<tr><td><a name="1893">
 2<p>
</a><td><a name="1895">
 Caller allocates storage for the object reference. For inout parameters, the caller provides an initial value; if the callee wants to reassign the inout parameter, it will first call CORBA_Object_release on the original input value. To continue to use an object reference passed in as an inout, the caller must first duplicate the reference. The client is responsible for the release of all out and return object references. Release of all object references embedded in other out and return structures is performed automatically as a result of calling CORBA_free.<p>
</a>
<tr><td><a name="1897">
 3<p>
</a><td><a name="1899">
 For out parameters, the caller allocates a pointer and passes it by reference to the callee. The callee sets the pointer to point to a valid instance of the parameter's type. For returns, the callee returns a similar pointer. The callee is not allowed to return a null pointer in either case. In both cases, the caller is responsible for releasing the returned storage. Following the completion of a request, the caller is not allowed to modify any values in the returned storage-to do so, the caller must first copy the returned instance into a new instance, then modify the new instance.<p>
</a>
<tr><td><a name="1901">
 4<p>
</a><td><a name="1903">
 For inout strings, the caller provides storage for both the input string and the char* pointing to it. The callee may deallocate the input string and reassign the char* to point to new storage to hold the output value. The size of the out string is therefore not limited by the size of the in string. The caller is responsible for freeing the storage for the out.The callee is not allowed to return a null pointer for an inout, out, or return value.<p>
</a>
<tr><td><a name="1946">
 5<p>
</a><td><a name="1948">
 For inout sequences and anys, assignment or modification of the sequence or any may cause deallocation of owned storage before any reallocation occurs, depending upon the state of the boolean release in the sequence or any.<p>
</a>
<tr><td><a name="1905">
 6<p>
</a><td><a name="2749">
 For out parameters, the caller allocates a pointer to an array slice, which has all the same dimensions of the original array except the first, and passes the pointer by reference to the callee. The callee sets the pointer to point to a valid instance of the array. For returns, the callee returns a similar pointer. The callee is not allowed to return a null pointer in either case. In both cases, the caller is responsible for releasing the returned storage. Following the completion of a request, the caller is not allowed to modify any values in the returned storage-to do so, the caller must first copy the returned array instance into a new array instance, then modify the new instance.<p>
</a>

</Table>

<Table>
<tr><td><sup>1</sup><a name="1884">
 As listed in <a href="cmap.html#1864">Table 21 on page 14-19</a><p>
</a>
</Table>
<p>
</a><a name="1194">
<h1>	14.20	 Handling Exceptions</h1>
</a><a name="168">
The CORBA_Environment type is partially opaque; the C declaration contains at least the following:<p>
</a><a name="265">
 typedef struct CORBA_Environment {																				/* C */<p>
</a><a name="266">
 						CORBA_exception_type _major;<p>
</a><a name="268">
 						...<p>
</a><a name="269">
 } CORBA_Environment;<p>
</a><a name="274">
Upon return from an invocation, the _major field indicates whether the invocation terminated successfully; _major can have one of the values CORBA_NO_EXCEPTION, CORBA_USER_EXCEPTION, or CORBA_SYSTEM_EXCEPTION; if the value is one of the latter two, then any exception parameters signalled by the object can be accessed. <p>
</a><a name="277">
Three functions are defined on an CORBA_Environment structure for accessing exception information; their signatures are:<p>
</a><a name="292">
 extern CORBA_char *CORBA_exception_id(CORBA_Environment *ev);																				/* C */<p>
</a><a name="293">
 extern void *CORBA_exception_value(CORBA_Environment *ev);<p>
</a><a name="308">
 extern void CORBA_exception_free(CORBA_Environment *ev);<p>
</a><a name="422">
CORBA_exception_id() returns a pointer to the character string identifying the exception. If invoked on an CORBA_Environment which identifies a non-exception, (_major==CORBA_NO_EXCEPTION) a NULL is returned.<p>
</a><a name="427">
CORBA_exception_value() returns a pointer to the structure corresponding to this exception. If invoked on an CORBA_Environment which identifies a non-exception or an exception for which there is no associated information, a NULL is returned. <p>
</a><a name="431">
CORBA_exception_free() returns any storage which was allocated in the construction of the CORBA_Environment. It is permissible to invoke CORBA_exception_free() regardless of the value of the _major field. <p>
</a><a name="433">
Consider the following example:<p>
</a><a name="435">
 interface exampleX {<p>
</a><a name="436">
<blockquote>						exception BadCall {</blockquote>
</a><a name="437">
<blockquote>						string&lt;80&gt; reason;</blockquote>
</a><a name="438">
<blockquote>						};</blockquote>
</a><a name="439">
<blockquote></blockquote>
</a><a name="440">
<blockquote>						void op() raises(BadCall);</blockquote>
</a><a name="441">
 };<p>
</a><a name="446">
This interface defines a single operation which returns no results and can raise a <strong>BadCall</strong> exception. The following user code shows how to invoke the operation and recover from an exception: <p>
</a><a name="447">
 #include "exampleX.h"																				/* C */<p>
</a><a name="448">
 <p>
</a><a name="512">
 CORBA_Environment ev;<p>
</a><a name="513">
 exampleX obj;<p>
</a><a name="566">
 exampleX_BadCall *bc;<p>
</a><a name="567">
 <p>
</a><a name="568">
 	/*<p>
</a><a name="569">
 	*	some code to initialize obj to a reference to an object<p>
</a><a name="4921">
 *	supporting the exampleX interface<p>
</a><a name="571">
 */<p>
</a><a name="572">
 <p>
</a><a name="573">
 exampleX_op(obj, &amp;ev);<p>
</a><a name="574">
 switch(ev._major) {<p>
</a><a name="575">
 case CORBA_NO_EXCEPTION:			/* successful outcome*/<p>
</a><a name="576">
 						/* process out and inout arguments */<p>
</a><a name="577">
 						break;<p>
</a><a name="578">
 case CORBA_USER_EXCEPTION:	/* a user-defined exception */<p>
</a><a name="579">
 						if (strcmp(ex_exampleX_BadCall,CORBA_exception_id(&amp;ev))<p>
</a><a name="4959">
 								== 0) {<p>
</a><a name="580">
 							bc = (exampleX_BadCall *)CORBA_exception_value(&amp;ev);<p>
</a><a name="581">
 							fprintf(stderr, "exampleX_op() failed - reason: %s\n",<p>
</a><a name="582">
 								bc-&gt;reason);<p>
</a><a name="4960">
 						}<p>
</a><a name="583">
 						else {			/* should never get here ... */<p>
</a><a name="584">
 								fprintf(			stderr, <p>
</a><a name="4967">
 											"unknown user-defined exception -%s\n",<p>
</a><a name="585">
 											CORBA_exception_id(&amp;ev));<p>
</a><a name="586">
 						}<p>
</a><a name="587">
 						break;<p>
</a><a name="588">
 default:			/* standard exception */<p>
</a><a name="589">
 						/* <p>
</a><a name="590">
 	 					 * CORBA_exception_id() can be used to determine<p>
</a><a name="4968">
 						 * which particular	 standard exception was<p>
</a><a name="4998">
 						 * raised; the minor member of the struct<p>
</a><a name="592">
 	 					 * associated with the exception (as yielded by <p>
</a><a name="747">
 	 					 * CORBA_exception_value()) may provide additional <p>
</a><a name="5003">
 						 * system-specific 		information about the exception <p>
</a><a name="593">
 	 					 */<p>
</a><a name="594">
 						break;<p>
</a><a name="278">
 }<p>
</a><a name="715">
 /* free any storage associated with exception */<p>
</a><a name="595">
 CORBA_exception_free(&amp;ev);<p>
</a><a name="596">
<h1>	14.21	 Method Routine Signatures</h1>
</a><a name="279">
 The signatures of the methods used to implement an object depend not only on the language binding, but also on the choice of object adapter. Different object adapters may provide additional parameters to access object adapter-specific features.<p>
</a><a name="143">
Most object adapters are likely to provide method signatures that are similar in most respects to those of the client stubs. In particular, the mapping for the operation parameters expressed in OMG IDL should be the same as for the client side.<p>
</a><a name="144">
See <a href="cmap.html#4707">Section &#32;14.25, "BOA: Mapping for Object Implementations," on page &#32;14-27</a> for the description of method signatures for implementations using the Basic Object Adapter.<p>
</a><a name="284">
<h1>	14.22	 Include Files</h1>
</a><a name="285">
 Multiple interfaces may be defined in a single source file. By convention, each interface is stored in a separate source file. All OMG IDL compilers will, by default, generate a header file named Foo.h from <strong>Foo.idl</strong>. This file should be <strong>#include</strong>d by clients and implementations of the interfaces defined in <strong>Foo.idl</strong>.<p>
</a><a name="286">
Inclusion of Foo.h is sufficient to define all global names associated with the interfaces in <strong>Foo.idl</strong> and any interfaces from which they are derived.<p>
</a><a name="288">
<h1>	14.23	 Pseudo-objects</h1>
</a><a name="503">
In the C language mapping, there are several interfaces that are defined as pseudo-objects; <a href="appxtype.html#330">Table 14 on page A-2</a> lists the pseudo-objects. A client makes calls on a pseudo-object in the same way as an ordinary ORB object. However, the ORB may implement the pseudo-object directly, and there are restrictions on what a client may do with a pseudo-object. <p>
</a><a name="504">
The ORB itself is a pseudo-object with the following partial definition (see <a href="orbif2.html#600">Chapter 7, "ORB Interface"</a> for the complete definition): <p>
</a><a name="505">
 interface ORB {<p>
</a><a name="497">
<blockquote>						string			object_to_string (in Object obj); </blockquote>
</a><a name="498">
<blockquote>						Object			string_to_object (in string str); </blockquote>
</a><a name="499">
 };<p>
</a><a name="506">
This means that a C programmer may convert an object reference into its string form by calling:<p>
</a><a name="507">
 CORBA_Environment ev; 																				/* C */<p>
</a><a name="500">
 CORBA_char *str = CORBA_ORB_object_to_string(orbobj, &amp;ev, obj);<p>
</a><a name="508">
just as if the ORB were an ordinary object. The C library contains the routine CORBA_ORB_object_to_string, and it does not do a real invocation. The orbobj is an object reference that specifies which ORB is of interest, since it is possible to choose which ORB should be used to convert an object reference to a string (see <a href="orbif2.html#600">Chapter 7, "ORB Interface"</a> for details on this specific operation).<p>
</a><a name="509">
Although operations on pseudo-objects are invoked in the usual way defined by the C language mapping, there are restrictions on them. In general, a pseudo-object cannot be specified as a parameter to an operation on an ordinary object. Pseudo-objects are also not accessible using the dynamic invocation interface, and do not have definitions in the interface repository.<p>
</a><a name="510">
Operations on pseudo-objects may take parameters that are not permitted in operations on ordinary objects. For example, the <strong>set_exception</strong> operation on the Basic Object Adapter pseudo-object takes a C (void *) to specify the exception parameters (see <a href="cmap.html#4712">Section &#32;14.25.2, "Method Signatures," on page &#32;14-27</a> for details). Generally, these parameters will be language-mapping specific.<p>
</a><a name="511">
Because the programmer uses pseudo-objects in the same way as ordinary objects, some ORB implementations may choose to implement some pseudo-objects as ordinary objects. For example, assuming it could be efficient enough, a context object might be implemented as an ordinary object.<p>
</a><a name="2993">
<h1>	14.24	 Mapping of the Dynamic Skeleton Interface to C</h1>
</a><a name="4065">
For general information about mapping of the Dyanmic Skeleton Interface to programming languages, refer to <a href="dynskel.html#686">Section &#32;5.3, "Dynamic Skeleton Interface: Language Mapping," on page &#32;5-3</a>.<p>
</a><a name="4134">
This section contains<p>
</a><ul><a name="4139">
<li>A mapping of the Dynamic Skelton Interface's ServerRequest to C
</a><a name="4142">
<li>A mapping of the Basic Object Adapter's Dynamic Implementation Routine to C
</a></ul><a name="4070">
<h2>	14.24.1	 Mapping of ServerRequest to C</h2>
</a><a name="4072">
In the C mapping, a ServerRequest is a pseudo object in the CORBA module that supports the following operations:<p>
</a><a name="4073">
<blockquote></blockquote>
</a><a name="4074">
<blockquote>	CORBA_Identifier										CORBA_ServerRequest_op_name (</blockquote>
</a><a name="4075">
<blockquote>												CORBA_ServerRequest req,</blockquote>
</a><a name="4076">
<blockquote>												CORBA_Environment *env</blockquote>
</a><a name="4077">
<blockquote>						);</blockquote>
</a><a name="4078">
This function returns the name of the operation being performed, as shown in the operation's OMG IDL specification.<p>
</a><a name="4079">
<p>
</a><a name="4080">
<blockquote>		CORBA_Context					CORBA_ServerRequest_ctx (</blockquote>
</a><a name="4081">
<blockquote>							CORBA_ServerRequest req,</blockquote>
</a><a name="4082">
<blockquote>							CORBA_Environment *env</blockquote>
</a><a name="4083">
<blockquote>						);</blockquote>
</a><a name="4084">
This function may be used to determine any context values passed as part of the operation. Context will only be available to the extent defined in the operation's OMG IDL definition; for example, attribute operations have none.<p>
</a><a name="4085">
<p>
</a><a name="4086">
<blockquote>	void					CORBA_ServerRequest_params (</blockquote>
</a><a name="4087">
<blockquote>							CORBA_ServerRequest req,</blockquote>
</a><a name="4088">
<blockquote>							CORBA_NVList parameters,</blockquote>
</a><a name="4089">
<blockquote>							CORBA_Environment *env</blockquote>
</a><a name="4090">
<blockquote>						);</blockquote>
</a><a name="4091">
This function is used to retrieve parameters from the ServerRequest, and to find the addresses used to pass pointers to result values to the ORB. It must always be called by each DIR, even when there are no parameters.<p>
</a><a name="4092">
The caller passes ownership of the <strong>parameters</strong> NVList to the ORB. Before this routine is called, that NVList should be initialized with the TypeCodes for each of the parameters to the operation being implemented: <em>in</em>, <em>out</em>, and <em>inout</em> parameters inclusive. When the call returns, the <strong>parameters</strong> NVList is still usable by the DIR, and all <em>in</em> and <em>inout</em> parameters will have been unmarshaled. Pointers to those parameter values will at that point also be accessible through the <strong>parameters</strong> NVList.<p>
</a><a name="4093">
The implementation routine will then process the call, producing any result values. If the DIR does not need to report an exception, it will replace pointers to <em>inout</em> values in parameters with the values to be returned, and assign pointers to <em>out</em> values in that NVList appropriately as well. When the DIR returns, all the parameter memory is freed as appropriate, and the NVList itself is freed by the ORB.<p>
</a><a name="4094">
<blockquote></blockquote>
</a><a name="4095">
<blockquote>	void						CORBA_ServerRequest_result (</blockquote>
</a><a name="4096">
<blockquote>							CORBA_ServerRequest req,</blockquote>
</a><a name="4097">
<blockquote>							CORBA_Any value,</blockquote>
</a><a name="4098">
<blockquote>							CORBA_Environment *env</blockquote>
</a><a name="4099">
<blockquote>						);</blockquote>
</a><a name="4100">
This function is used to report any result <strong>value</strong> for an operation; if the operation has no result, it must not be called. It also must not be called before the parameters have been retrieved, or if an exception is being reported.<p>
</a><a name="4146">
<p>
</a><a name="4101">
<blockquote>	void						CORBA_ServerRequest_exception (</blockquote>
</a><a name="4102">
<blockquote>							CORBA_ServerRequest req,</blockquote>
</a><a name="4103">
<blockquote>							CORBA_exception_type major,</blockquote>
</a><a name="4104">
<blockquote>							CORBA_Any value,</blockquote>
</a><a name="4105">
<blockquote>							CORBA_Environment *env</blockquote>
</a><a name="4106">
<blockquote>						);</blockquote>
</a><a name="4107">
This function is used to report exceptions, both user and system, to the client who made the original invocation. The parameters are as follows:<p>
</a><a name="4108">
<p>
</a><a name="4109">
 <strong>major</strong> indicates whether the exception is a user exception or system exception<p>
</a><a name="4110">
 <strong>value</strong> this is the value of the exception, including an exceptionTypeCode.<p>
</a><a name="4111">
<h2>	14.24.2	 Mapping of BOA's Dynamic Implementation Routine to C</h2>
</a><a name="4113">
In C, a DIR is a function with this signature:<p>
</a><a name="4114">
<p>
</a><a name="5006">
<blockquote>	typedef void (*DynamicImplementationRoutine) (											/* C */</blockquote>
</a><a name="5007">
<blockquote>						CORBA_Object									target,</blockquote>
</a><a name="5008">
<blockquote>						CORBA_ServerRequest									request,</blockquote>
</a><a name="4118">
<blockquote>						CORBA_Environment									*env</blockquote>
</a><a name="4119">
<blockquote>	); </blockquote>
</a><a name="4120">
Such a function will be invoked by the BOA when an invocation is received on an object reference whose implementation has registered a dynamic skeleton.<p>
</a><a name="4122">
 <strong>target</strong> is the name object reference to which the invocation is directed.<p>
</a><a name="4123">
 <strong>request</strong> is the ServerRequest used to access explicit parameters and report results (and exceptions).<p>
</a><a name="4124">
 <strong>env</strong> may be passed to <strong>CORBA_BOA_get_principal</strong> if desired.<p>
</a><a name="4125">
Unlike other BOA object implementations, the <strong>CORBA_BOA_set_exception</strong><code> </code>API is not used. Instead, <strong>CORBA_ServerRequest_exception</strong> is used; this provides the TypeCode for the exception to the ORB, so it does not need to consult the Interface Repository (or rely on compiled stubs) to marshal the exception value.<p>
</a><a name="4707">
<h1>	14.25	 BOA: Mapping for Object Implementations</h1>
</a><a name="4708">
This section describes the details of the OMG IDL-to-C language mapping that apply specifically to the Basic Object Adapter, such as how the implementation methods are connected to the skeleton.<p>
</a><a name="4709">
<h2>	14.25.1	 Operation-specific Details</h2>
</a><a name="4710">
This chapter defines most of the details of naming of parameter types and parameter passing conventions. Generally, for those parameters that are operation-specific, the method implementing the operation appears to receive the same values that would be passed to the stubs.<p>
</a><a name="4712">
<h2>	14.25.2	 Method Signatures</h2>
</a><a name="4713">
With the BOA, implementation methods have signatures that are identical to the stubs. If the following interface is defined in OMG IDL:<p>
</a><a name="4715">
 interface example4 {												// IDL<p>
</a><a name="4716">
<blockquote>						long op5(in long arg6);</blockquote>
</a><a name="4717">
 };<p>
</a><a name="4718">
a method for the <strong>op5</strong> routine must have the following function signature:<p>
</a><a name="4719">
 CORBA_long example4_op5(																					/* C */<p>
</a><a name="4720">
 						example4 					object, <p>
</a><a name="4721">
 						CORBA_Environment 					*ev, <p>
</a><a name="4722">
 						CORBA_long 					arg6<p>
</a><a name="4723">
 );<p>
</a><a name="4724">
The object parameter is the object reference that was invoked. The method can identify which object was intended by using the <strong>get_id</strong> BOA operation. The ev parameter is used for authentication on the <strong>get_principal</strong> BOA operation, and is used for indicating exceptions.<p>
</a><a name="4725">
The method terminates successfully by executing a return statement returning the declared operation value. Prior to returning the result of a successful invocation, the method code must assign legal values to all <strong>out</strong> and <strong>inout</strong> parameters.<p>
</a><a name="4726">
The method terminates with an error by executing the <strong>set_exception</strong> BOA operation prior to executing a return statement. The <strong>set_exception </strong>operation has the following C language definition:<p>
</a><a name="4727">
 void CORBA_BOA_set_exception 	(																				/* C */<p>
</a><a name="4728">
 						CORBA_Object 							boa, <p>
</a><a name="4729">
 						CORBA_Environment 							*ev, 	<p>
</a><a name="4730">
 						CORBA_exception_type							major, <p>
</a><a name="4731">
 						CORBA_char 							*exceptname, <p>
</a><a name="4732">
 						void 							*param<p>
</a><a name="4733">
 ); <p>
</a><a name="4734">
The ev parameter is the environment parameter passed into the method. The caller must supply a value for the major parameter. The value of the major parameter constrains the other parameters in the call as follows: <p>
</a><ul><a name="4736">
<li>If the major parameter has the value NO_EXCEPTION, then it specifies that this is a normal outcome to the operation. In this case, both exceptname and param must be NULL. Note that it is <em>not</em> necessary to invoke set_exception() to indicate a normal outcome; it is the default behavior if the method simply returns. 
</a><a name="4737">
<li>For any other value of major it specifies either a user-defined or standard exception. The exceptname parameter is a string representing the exception type identifier. If the exception is declared to take parameters, the param parameter must be the address of a struct containing the parameters according to the C language mapping, coerced to a void *; if the exception takes no parameters, param must be NULL. 
</a></ul><a name="4738">
When raising an exception, the method code is <em>not</em> required to assign legal values to any <strong>out</strong> or <strong>inout</strong> parameters. Due to restrictions in C, it must return a legal function value. <p>
</a><a name="4739">
<h2>	14.25.3	 Binding Methods to Skeletons</h2>
</a><a name="4740">
It is not specified as part of the language mapping how the skeletons are connected to the methods. Different means will be used in different environments. For example, the skeletons may make references to the methods that are resolved by the linker or there may be a system-dependent call done at program startup to specify the location of the methods.<p>
</a><a name="4741">
<h2>	14.25.4	 BOA and ORB Operations</h2>
</a><a name="4742">
The operations on the BOA defined earlier in this chapter and the operations on the ORB defined in the ORB Interface chapter are used as if they had the OMG IDL definitions described in the document, and then mapped in the usual way with the C language mapping.<p>
</a><a name="4743">
For example, the <strong>string_to_object</strong> ORB operation has the following signature:<p>
</a><a name="4744">
 CORBA_Object CORBA_ORB_string_to_object (																					/* C */<p>
</a><a name="4745">
 						CORBA_Object 						orb,<p>
</a><a name="4746">
 						CORBA_Environment 					*ev,<p>
</a><a name="4747">
 						CORBA_char 						*objectstring<p>
</a><a name="4748">
 );<p>
</a><a name="4749">
The create BOA operation has the following signature:<p>
</a><a name="4750">
 CORBA_Object CORBA_BOA_create (																					/* C */<p>
</a><a name="4751">
 						CORBA_Object 									boa,<p>
</a><a name="4752">
 						CORBA_Environment 									*ev,<p>
</a><a name="4753">
 						CORBA_ReferenceData 									*id, <p>
</a><a name="4754">
 						CORBA_InterfaceDef 									intf,<p>
</a><a name="4755">
 						CORBA_ImplementationDef 									impl<p>
</a><a name="4756">
 );<p>
</a><a name="4757">
Although in each example, we are using an "object" that is special (an ORB, an object adapter, or an object reference), the method name is generated as interface_operation in the same way as ordinary objects. Also, the signature contains an CORBA_Environment parameter for error indications.<p>
</a><a name="4758">
In the first two cases, the signature calls for an object reference to represent the particular ORB or object adapter being manipulated. Programs may obtain these objects in a variety of ways, for example, in a global variable before program startup if there is only one ORB or BOA that makes sense, or by obtaining them from a name service if more than one is available. In the third case, the object reference being operated on is specified as the first parameter.<p>
</a><a name="4759">
Following the same procedure, the C language binding for the remainder of the ORB, BOA, and object reference operations may be determined.<p>
</a><a name="4760">
<p>
</a><a name="4165">
<h1>	14.26	 ORB and OA/BOA Initialization Operations </h1>
</a><a name="4307">
<h4> ORB Initialization</h4>
</a><a name="4231">
The following PIDL specifies initialization operations for an ORB; this PIDL is part of the CORBA module (not the ORB interface) and is described in <a href="orbif2.html#801">Section &#32;7.4, "ORB Initialization," on page &#32;7-6</a>.<p>
</a><a name="4240">
 // PIDL <p>
</a><a name="4220">
 module CORBA {<p>
</a><a name="4221">
 <p>
</a><a name="4222">
  						typedef string ORBid;<p>
</a><a name="4223">
  						typedef sequence &lt;string&gt; arg_list;<p>
</a><a name="5023">
 <p>
</a><a name="4224">
  						ORB ORB_init (inout arg_list argv, in ORBid orb_identifier);<p>
</a><a name="4225">
 };<p>
</a><a name="4471">
 <p>
</a><a name="4241">
The mapping of the preceding PIDL operations to C is as follows:<p>
</a><a name="5024">
<p>
</a><a name="4198">
 /* C language mapping */<p>
</a><a name="4206">
 typedef CORBA_string CORBA_ORBid;<p>
</a><a name="4208">
 extern CORBA_ORB CORBA_ORB_init (int *argc,<p>
</a><a name="4210">
 															char **argv,<p>
</a><a name="4212">
 															CORBA_ORBid orb_identifier,<p>
</a><a name="4214">
 															CORBA_Environment *env);<p>
</a><a name="4258">
 <p>
</a><a name="4250">
The C mapping for <strong>ORB_init </strong>deviates from the PIDL in its handling of the <strong>arg_list </strong>parameter. This is intended to provide a meaningful PIDL definition of the initialisation interface which has a natural C (and C++) binding. To this end, the <strong>arg_list</strong> structure is replaced with argv and argc parameters. <p>
</a><a name="4252">
The argv parameter is defined as an unbound array of strings (char **) and the number of strings in the array is passed in the int* parameter.<p>
</a><a name="4275">
If a NULL ORBid is used then argv arguments can be used to determine which ORB should be returned. This is achieved by searching the argv parameters for one tagged ORBid, e.g. -ORBid "ORBid_example." <p>
</a><a name="4291">
For C, the order of consumption of argv parameters may be significant to an application. In order to ensure that applications are not required to handle argv parameters they do not recognize the ORB initialization function must be called before the remainder of the parameters are consumed. Therefore, after the ORB_init call the argv and argc parameters will have been modified to remove the ORB understood arguments. It is important to note that the ORB_init call can only reorder or remove references to parameters from the argv list, this restriction is made in order to avoid potential memory management problems caused by trying to free parts of the argv list or extending the argv list of parameters. This is why argv is passed as a char** and not a char***. <p>
</a><a name="4306">
<h4> OA/BOA Initialization</h4>
</a><a name="4528">
The following PIDL specifies the operations (in the ORB interface) that allow applications to get pseudo object references; it is described in detail in <a href="orbif2.html#811">Section &#32;7.5, "OA and BOA Initialization," on page &#32;7-8</a>. <p>
</a><a name="4314">
<p>
</a><a name="4372">
 // PIDL<p>
</a><a name="4554">
 <p>
</a><a name="4556">
 module CORBA {<p>
</a><a name="4373">
 <p>
</a><a name="4374">
 						interface ORB <p>
</a><a name="4375">
 						{<p>
</a><a name="4376">
 <p>
</a><a name="4377">
 							typedef sequence &lt;string&gt; arg_list;<p>
</a><a name="4378">
 							typedef string OAid;<p>
</a><a name="4379">
 <p>
</a><a name="4380">
  							// Template for OA initialization operations<p>
</a><a name="4381">
 							// &lt;OA&gt; &lt;OA&gt;_init (inout arg_list argv, <p>
</a><a name="4382">
 							//                                     in OAid oa_identifier);<p>
</a><a name="4383">
 <p>
</a><a name="4384">
 							BOA BOA_init 					(inout arg_list argv,<p>
</a><a name="4385">
  												in OAid boa_identifier); <p>
</a><a name="4386">
 <p>
</a><a name="4387">
 				 		};<p>
</a><a name="4388">
 <p>
</a><a name="4389">
  } <p>
</a><a name="4399">
The mapping of the <strong>OAinit</strong> (<strong>BOA_ini</strong>t) operation (in the ORB interface) to the C programming language is as follows:<p>
</a><a name="4333">
<p>
</a><a name="4326">
 /* C language mapping */ <p>
</a><a name="4334">
 <p>
</a><a name="4335">
 typedef CORBA_string CORBA_OAid;<p>
</a><a name="4336">
 <p>
</a><a name="4338">
 /* Template C binding for &lt;OA&gt;_init */<p>
</a><a name="4339">
 /*<p>
</a><a name="4341">
 CORBA_&lt;OA&gt; CORBA_ORB_&lt;OA&gt;_init (CORBA_ORB orb,<p>
</a><a name="4343">
 	 			 			int *argc, <p>
</a><a name="4345">
 	 	 					char **argv,<p>
</a><a name="4346">
 	 	 					CORBA_ORB_OAid boa_identifier,<p>
</a><a name="4348">
 	 						CORBA_Environment *env);<p>
</a><a name="4352">
 	 */ <p>
</a><a name="4354">
 <p>
</a><a name="4367">
 CORBA_BOA CORBA_ORB_BOA_init (CORBA_ORB orb,<p>
</a><a name="4355">
 							int *argc, <p>
</a><a name="4357">
 							char **argv,<p>
</a><a name="4358">
 							CORBA_ORB_OAid boa_identifier,<p>
</a><a name="4360">
 							CORBA_Environment *env); <p>
</a><a name="4323">
 <p>
</a><a name="5028">
The <strong>arglist</strong> structure from the PIDL definition is replaced in the C mapping with argv and argc parameters. The argv parameters is an unbound array of strings (char**) and the number of strings in the array is passed in the argc (int*). <p>
</a><a name="4475">
If a NULL OAid is used then argv arguments can be used to determine which OA should be returned. This is achieved by searching the argv<strong> </strong>parameters for one tagged OAid, e.g. -OAid "OAid_example". <p>
</a><a name="4479">
For C, the order of consumption of <strong>argv </strong>parameters may be significant to an application. In order to ensure that applications are not required to handle argv parameters they do not recognize the OA initialisation function must be called before the remainder of the parameters are consumed by the application. Therefore, after the &lt;OA&gt;_init call, the argv and argc parameters will have modified to remove the OA understood arguments. It is important to note that the OA_init call can only reorder or remove references to parameters from the argv list, this restriction is made in order to avoid potential memory management problems caused by trying to free parts of the argv list or extending the argv list of parameters. This is why argv is passed as a char** and not a char***. <p>
</a><a name="4316">
<p>
</a><a name="4318">
<h1>	14.27	 Operations for Obtaining Initial Object References</h1>
</a><a name="4518">
The following PIDL specifies the operations (in the ORB interface) that allow applications to get pseudo object references for the Interface Repository and Object Services. It is described in detail in <a href="orbif2.html#819">Section &#32;7.6, "Obtaining Initial Object References," on page &#32;7-10</a>.<p>
</a><a name="4400">
<p>
</a><a name="4402">
 // PIDL interface for getting initial object references <p>
</a><a name="4538">
 <p>
</a><a name="4403">
 module CORBA { <p>
</a><a name="4404">
 						interface ORB {<p>
</a><a name="4405">
 						typedef string ObjectId;<p>
</a><a name="4406">
 						typedef sequence &lt;ObjectId&gt; ObjectIdList; <p>
</a><a name="4407">
 <p>
</a><a name="4408">
     						exception InvalidName {}; <p>
</a><a name="4409">
 <p>
</a><a name="4410">
    ObjectIdList list_initial_services (); <p>
</a><a name="4411">
 <p>
</a><a name="4412">
   Object resolve_initial_references (in ObjectId identifier)<p>
</a><a name="4413">
      raises (InvalidName); <p>
</a><a name="4414">
    } <p>
</a><a name="4415">
  <p>
</a><a name="4416">
 } <p>
</a><a name="4167">
The mapping of the preceding PIDL to C is as follows:<p>
</a><a name="4539">
<p>
</a><a name="4059">
 /* C Mapping */<p>
</a><a name="4423">
 typedef CORBA_string CORBA_ORB_ObjectId;<p>
</a><a name="4425">
 typedef CORBA_sequence_CORBA_ORB_ObjectId<p>
</a><a name="4464">
 <p>
</a><a name="4466">
 												CORBA_ORB_ObjectIdList;<p>
</a><a name="4427">
 typedef struct CORBA_ORB_InvalidName CORBA_ORB_InvalidName;<p>
</a><a name="4463">
 <p>
</a><a name="4443">
 CORBA_ORB_ObjectIdList CORBA_ORB_list_initial_services ( 						<p>
</a><a name="4451">
 <p>
</a><a name="4454">
 												CORBA_ORB orb,<p>
</a><a name="4444">
 												CORBA_Environment *env);<p>
</a><a name="4457">
 <p>
</a><a name="4437">
 CORBA_Object CORBA_ORB_resolve_initial_references (<p>
</a><a name="4460">
 												CORBA_ORB orb,<p>
</a><a name="4447">
 												CORBA_ORB_ObjectId identifier,<p>
</a><a name="4461">
 												CORBA_Environment *env);<p>
</a><a name="4540">
 <p>
</a><a name="4541">
 <p>
</a>
<hr><br>
 
<a href="cover.html">[Top]</a> <a href="tagapp.html">[Prev]</a> <a href="plusov.html">[Next]</a> <a href="corb2pra.html">[Bottom]</a>
<hr><br>
 
<sup>1</sup><a name="152">
 	 <a href="cmap.html#243">Section &#32;14.15, "Implicit Arguments to Operations," on page &#32;14-16</a> describes the additional arguments added to an operation in the C mapping.<p>
</a><sup>2</sup><a name="2047">
 Transmissible pseudo-objects are listed as "general arguments" in <a href="appxtype.html#330">Table 14 on page A-2</a> .<p>
</a><sup>3</sup><a name="2247">
 For brevity, the "CORBA_" prefix is omitted from type names in the tables shown here.<p>
</a>

<address>
<a href="mailto:pubs@omg.org">pubs@omg.org</a>
</address>

<i>Copyright &#169; 1995, <a href="http://www.omg.org">Object Management Group.</a>  All rights
reserved.</i>

<!-- This file was created with Quadralay WebWorks Publisher 3.0.4 -->
<!-- -->
<!-- For more information on how this document, and how the rest of -->
<!-- this server was created, email pubs@omg.org -->
<!-- -->
<!-- Last updated: 06/10/96 08:49:32 -->

</body>
</html>
