<html><head><title></title></head>
<body bgcolor=#ffffff>
 
<a href="cover.html">[Top]</a> <a href="corb2prf.html">[Prev]</a> <a href="obmod2.html">[Next]</a> <a href="corb2pra.html">[Bottom]</a>
<hr><br>
 
<a name="63">
<h1> <a href=@talk-corb2prb.html target=_top>Preface</a></h1>
</a><a name="773">
<slide id=pre-about cap="About This Document">
<h1>	0.1	 About This Document</h1>
</a><a name="1071">
<p>
Under the terms of the collaboration between OMG and X/Open Co Ltd, this document is a candidate for endorsement by X/Open, initially as a Preliminary Specification and later as a full CAE Specification. The collaboration between OMG and X/Open Co Ltd ensures joint review and cohesive support for emerging object-based specifications. <p>
</a><a name="1077">
X/Open Preliminary Specifications undergo close scrutiny through a review process at X/Open before publication and are inherently stable specifications. Upgrade to full CAE Specification, after a reasonable interval, takes place following further review by X/Open. This further review considers the implementation experience of members and the full implications of conformance and branding.<p>
</a><a name="1068">
</slide>
<slide id=pre-omg cap="Object Management Group">
<h2>	0.1.1	 Object Management Group</h2>
</a><a name="374">
<p>
The Object Management Group, Inc. (OMG) is an international organization supported by over 500 members, including information system vendors, software developers and users.  Founded in 1989, the OMG promotes the theory and practice of object-oriented technology in software development.  The organization's charter includes the establishment of industry guidelines and object management specifications to provide a common framework for application development. Primary goals are the reusability, portability, and interoperability of object-based software in distributed, heterogeneous environments. Conformance to these specifications will make it possible to develop a heterogeneous applications environment across all major hardware platforms and operating systems. <p>
</a><a name="360">
	OMG's objectives are to foster the growth of object technology and influence its direction by establishing the Object Management Architecture (OMA).  The OMA provides the conceptual infrastructure upon which all OMG specifications are based. <p>
</a><a name="451">
</slide>
<slide id=pre-xopen cap="X/Open">
<h2>	0.1.2	 X/Open</h2>
</a><a name="482">
<p>
X/Open is an independent, worldwide, open systems organization supported by most of the world's largest information system suppliers, user organizations and software companies.  Its mission is to bring to users greater value from computing, through the practical implementation of open systems. X/Open's strategy for achieving its mission is to combine existing and emerging standards into a comprehensive, integrated systems environment called the Common Applications Environment (CAE). <p>
</a><a name="1137">
The components of the CAE are defined in X/Open CAE specifications. These contain, among other things, an evolving portfolio of practical application programming interfaces (APIs), which significantly enhance portability of application programs at the source code level. The APIs also enahance the interoperability of applications by providing definitions of, and references to, protocols and protocol profiles. <p>
</a><a name="1138">
The X/Open specifications are also supported by an extensive set of conformance tests and by the X/Open trademark (XPG brand), which is licensed by X/Open and is carried only on products that comply with the CAE specifications. <p>
</a><a name="815">
</slide>
<slide id=pre-audience cap="Intended Audience">
<h1>	0.2	 Intended Audience</h1>
</a><a name="1142">
<p>
The architecture and specifications described in this manual are aimed at software designers and developers who want to produce applications that comply with OMG standards for the Object Request Broker (ORB). The benefit of compliance is, in general, to be able to produce interoperable applications that are based on distributed, interoperating objects. As defined by the Object Management Group (OMG) in the <em>Object Management Architecture Guide, </em>the ORB provides the mechanisms by which objects transparently make requests and receive responses. Hence, the ORB provides interoperability between applications on different machines in heterogeneous distributed environments and seamlessly interconnects multiple object systems. <p>
</a><a name="813">
</slide>
<slide id=pre-corba cap="Context of CORBA">
<h1>	0.3	 Context of CORBA</h1>
</a><a name="747">
<p>
The key to understanding the structure of the CORBA architecture is the Reference Model, which consists of the following components:<p>
</a><ul><a name="446">
<li><strong>Object Request Broker</strong>, which enables objects to transparently make and receive requests and responses in a distributed environment. It is the foundation for building applications from distributed objects and for interoperability between applications in hetero- and homogeneous environments. The architecture and specifications of the Object Request Broker are described in this manual<em>. </em>
</a><a name="457">
<li><strong>Object Services</strong>, a collection of services (interfaces and objects) that support basic functions for using and implementing objects. Services are necessary to construct any distributed application and are always independent of application domains. For example, the Life Cycle Service defines conventions for creating, deleting, copying, and moving objects; it does not dictate how the objects are implemented in an application. Specifications for Object Services are contained in <em>CORBAservices: Common Object Services Specification.</em>
</a><a name="472">
<li><strong>Common Facilities</strong>, a collection of services that many applications may share, but which are not as fundamental as the Object Services. For instance, a system management or electronic mail facility could be classified as a common facility. Information about Common Facilities will be contained in <em>CORBAfacilities: Common Facilities, </em>to be published in mid-1995. 
</a><a name="487">
<li><strong>Application Objects</strong>, which are products of a single vendor on in-house development group which controls their interfaces. Application Objects correspond to the traditional notion of applications, so they are not standardized by OMG. Instead, Application Objects constitute the uppermost layer of the Reference Model.
</a></ul><a name="508">
The Object Request Broker, then, is the core of the Reference Model. It is like a telephone exchange, providing the basic mechanism for making and receiving calls. Combined with the Object Services, it ensures meaningful communication between CORBA-compliant applications. <p>
</a><a name="763">
(For more information about the OMG Reference Model and the OMG Object Model, refer to the <em>Object Management Architecture Guide). </em><p>
</a><a name="502">
</slide>
<slide id=pre-documents cap="Associated Documents">
<h1>	0.4	 Associated Documents</h1>
</a><a name="534">
<p>
The CORBA documentation set includes the following books:<p>
</a><ul><a name="2236">
<li>Object Management Architecture Guide defines the OMG's technical objectives and terminology and describes the conceptual models upon which OMG standards are based. It also provides information about the policies and procedures of OMG, such as how standards are proposed, evaluated, and accepted.
</a><a name="552">
<li>CORBA: Common Object Request Broker Architecture and Specification contains the architecture and specifications for the Object Request Broker. 
</a><a name="553">
<li>CORBAservices: Common Object Services Specification contains specifications for the object services. 
</a><a name="582">
<li>CORBAfacilities: Common Facilities will contain specifications for Common Facilites; it is currently scheduled for publication in mid-1995. 
</a></ul><a name="549">
OMG collects information for each book in the documentation set by issuing Requests for Information, Requests for Proposals, and Requests for Comment and, with its membership, evaluating the responses. Specifications are adopted as standards only when representatives of the OMG membership accept them as such by vote. <p>
</a><a name="551">
To obtain books in the documentation set, or other OMG publications, refer to the enclosed subscription card or contact the Object Management Group, Inc. at: <p>
</a><a name="535">
 OMG Headquarters<p>
</a><a name="536">
 492 Old Connecticut Path<p>
</a><a name="537">
 Framingham, MA 01701<p>
</a><a name="962">
 USA<p>
</a><a name="538">
 Tel: +1-508-820 4300<p>
</a><a name="2241">
 Fax: +1-508-820 4303<p>
</a><a name="539">
 pubs@omg.org<p>
</a><a name="1870">
 http://www.omg.org/<p>
</a><a name="306">
</slide>
<slide id=pre-structure cap="Structure of this Manual">
<h1>	0.5	 Structure of this Manual</h1>
</a><a name="318">
<p>
This manual is divided into the categories of Core, Interoperability, and individual Language Mappings. These divisions reflect the compliance points of CORBA, as explained in <a href="corb2prb.html#1468">Section 0.6, "Definition of CORBA Compliance," on page vii</a>. In addition to this preface, CORBA: Common Object Request Broker Architecture and Specification contains the following chapters:<p>
</a><a name="1198">
Core<p>
</a><a name="317">
<strong>The Object Model </strong>describes the compuation model that underlies the CORBA architecture. <p>
</a><a name="1220">
Architecture describes the overall structure of the ORB architecture and includes information about CORBA interfaces and implmentations. <p>
</a><a name="1221">
OMG IDL Syntax and Semantics describes OMG interface definition language (OMG IDL), which is the language used to describe the interfaces that client objects call and object implementations provide. <p>
</a><a name="1222">
The Dynamic Invocation Interface describes the DII, the client's side of the interface that allows dynamic creation and invocation of request to objects. <p>
</a><a name="1238">
<strong>The Dynamic Skeleton Interface </strong>describes the DSI, the server's-side <em>interface</em> that can deliver requests from an ORB to an object implementation that does not have compile-time knowledge of the type of the object it is implementing. DSI is the server's analogue of the client's <em>Dynamic Invocation Interface</em> (DII).<p>
</a><a name="1223">
Interface Repository describes the component of the ORB that manages and provides access to a collection of object definitions. <p>
</a><a name="1270">
ORB Interface describes the interface to the ORB functions that do not depend on object adapters: these operations are the same for all ORBs and object implementations.<p>
</a><a name="1271">
Basic Object Adapter describes the primary interface than an implementation uses to access ORB functions. <p>
</a><a name="2020">
An <strong>appendix</strong> that contains standard OMG IDL types.<p>
</a><a name="1224">
Interoperability<p>
</a><a name="1225">
<strong>Interoperability</strong> <strong>Overview</strong> explains the interoperability architecture and introduces the subjects pertaining to interoperability: inter-ORB bridges; general and Internet inter-ORB protocols (GIOP and IIOP); and environment-specific, inter-ORB protocols (ESIOPs).<p>
</a><a name="1379">
<strong>Interoperability Architecture</strong> introduces the framework of ORB interoperability, including information about domains; approaches to inter-ORB bridges; what it means to be compliant with ORB interoperability; and ORB Services and Requests. <p>
</a><a name="1380">
Inter-ORB Bridges explains how to build bridges for an implementation of interoperating ORBs. <p>
</a><a name="1381">
Inter-ORB Protocols describes the general inter-ORB protocol (GIOP) and includes information about the GIOP's goals, syntax, format, transport, and object location. This chapter also includes information about the Internet inter-ORB protocol (IIOP). <p>
</a><a name="1715">
Environment-Specific Inter-ORB Protocol (ESIOP) desribes a protocol for the OSF DCE environment. The protocol is called the DCE Environment Inter-ORB Protocol (DCE ESIOP). <p>
</a><a name="2007">
An appendix containing OMG IDL tags that can identify an Object Service, a component, or a profile. <p>
</a><a name="1226">
C Language Mapping <p>
</a><a name="1232">
Mapping of OMG IDL to C maps OMG IDL to the C programming language.<p>
</a><a name="1876">
C++ Language Mapping<p>
</a><a name="1235">
C++ Mapping Overview introduces the mapping of OMG IDL to the C++ programming language.<p>
</a><a name="1885">
Mapping of OMG IDL to C++ maps the constructs of OMG IDL to the C++ programming language. <p>
</a><a name="1990">
Mapping of Pseudo Objects to C++ maps OMG IDL pseudo objects to the C++ programming language.<p>
</a><a name="2033">
Server-Side Mapping explains the portability constraints for an object implementation written in C++. <p>
</a><a name="2005">
The C++ language mapping also includes several appendices. One contains C++ definitions for CORBA, another contains alternate C++ mappings, and another contains C++ keywords.<p>
</a><a name="1991">
Smalltalk Language Mapping<p>
</a><a name="1236">
Smalltalk Mapping Overview introduces the mapping of OMG IDL to the Smalltalk programming language. <p>
</a><a name="1992">
Mapping of OMG IDL to Smalltalk maps the constructs of OMG IDL to the Smalltalk programming language. <p>
</a><a name="2006">
Mapping of Pseudo Objects to Smalltalk maps OMG IDL pseudo objects to Smalltalk. <p>
</a><a name="1468">
</slide>
<slide id=pre-compliance cap="Definition of CORBA Compliance">
<h1>	0.6	 Definition of CORBA Compliance</h1>
</a><a name="1481">
<p>
As described in the <em>OMA Guide</em>, OMG's Core Object Model consists of a core and components. Likewise, the body of <em>CORBA</em> specifications is divided into core and component-like specifications. (The structure of this manual reflects that division.) <p>
</a><a name="2180">
The <em>CORBA</em> family of specifications are as follows:<p>
</a><ul><a name="2181">
<li>CORBA Core, as specified in Chapters 1-8
</a><a name="2183">
<li>CORBA Interoperability, as specified in Chapters 9-13
</a><a name="1579">
<li>Mapping of OMG IDL to C programming language, as specified in Chapter 14
</a><a name="1499">
<li>Mapping of OMG IDL to C++ programming language, as specified in Chapters 15-18
</a><a name="1500">
<li>Mapping of OMG IDL to Smalltalk programming language, as specified in Chapters 19-21
</a></ul><a name="1606">
Additional OMG IDL mappings will be available with future versions of <em>CORBA.</em> <p>
</a><a name="1692">
When compliance branding machinery is in place, each of the CORBA specifications listed here will be associated with a separate branding stamp. <p>
</a><a name="2282">
The minimum required for a CORBA-compliant system is adherence to the specifications in CORBA Core and one mapping. Each additional language mapping is a separate, optional compliance point. Optional means users aren't required to implement these points if they are unnecessary at their site, but if implemented, they must adhere to the <em>CORBA</em> specifications to be called CORBA-compliant. For instance, if a vendor supports C++, their ORB must comply with the OMG IDL to C++ binding specified in this manual. <p>
</a><a name="2285">
Interoperability is a separate compliance point.<p>
</a><a name="1412">
</slide>
<slide id=pre-typo cap="Typographical Conventions">
<h1>	0.7	 Typographical Conventions</h1>
</a><a name="1413">
<p>
The type styles shown below are used in this document to distinguish programming statements from ordinary English. However, these conventions are not used in tables or section headings, where no distinction is necessary, nor are the type styles used in text where their density would be distracting. <p>
</a><a name="1414">
<p>
<strong>Helvetica bold</strong> OMG Interface Definition Language (OMG IDL) language and syntax elements<p>
</a><a name="1415">
<p>
<strong>Times bold</strong> Pseudo-OMG IDL (PIDL) language elements<p>
</a><a name="1416">
<p>
Courier bold Programming language elements<p>
<p>
Courier bold italic Smalltalk protocol descriptions<p>
Code examples written in PIDL and programming languages are further identified by a comment; unidentified examples are written in OMG IDL. <p>
</a><a name="778">
</slide>
<slide id=pre-ack cap="Acknowledgements">
<h1>	0.8	 Acknowledgements</h1>
</a><a name="779">
<p>
The following companies submitted parts of the specifications that were approved by the Object Management Group to become <em>CORBA:</em><p>
</a><ul><a name="1287">
<li>BNR Europe Ltd
</a><a name="1296">
<li>Expersoft Corporation
</a><a name="1298">
<li>IBM Corporation
</a><a name="1300">
<li>ICL plc
</a><a name="1302">
<li>IONA Technologies Ltd
</a><a name="1304">
<li>Digital Equipment Corporation
</a><a name="1306">
<li>Hewlett-Packard Company
</a><a name="1308">
<li>HyperDesk Corporation
</a><a name="1310">
<li>NCR Corporation
</a><a name="1311">
<li>Novell USG
</a><a name="1313">
<li>Object Design, Inc 
</a><a name="781">
<li>Sun Microsystems Inc
</a><a name="1315">
<li>SunSoft, Inc
</a></ul><a name="1866">
<p>
In addition to the preceding contributors, the OMG would like to acknowledge Mark Linton at Silicon Graphics and Doug Lea at the State University of New York at Oswego for their work on the C++ mapping.<p>
</a>
<hr><br>
 
<a href="cover.html">[Top]</a> <a href="corb2prf.html">[Prev]</a> <a href="obmod2.html">[Next]</a> <a href="corb2pra.html">[Bottom]</a>
<hr><br>
</slide>
 


<address>
<a href="mailto:pubs@omg.org
">pubs@omg.org
</a>
</address>

<i>Copyright &#169; 1995, <a href="http://www.omg.org">Object Management Group.  All rights
reserved.</i>

<!-- This file was created with Quadralay WebWorks Publisher 3.0.4 -->
<!-- -->
<!-- For more information on how this document, and how the rest of -->
<!-- this server was created, email pubs@omg.org
 -->
<!-- -->
<!-- Last updated: 06/10/96 08:47:20 -->

</body>
</html>
