<html><head><title></title></head>
<body bgcolor=#ffffff>
 
<a href="cover.html">[Top]</a> <a href="giop.html">[Prev]</a> <a href="tagapp.html">[Next]</a> <a href="corb2pra.html">[Bottom]</a>
<hr><br>
 
<a name="1122">
<h1> The DCE ESIOP</h1>
</a><dl>
<p align=right clear=all>
<b><font size=7>
13 
</font></b>
</p>
<hr></dl>
<a name="1098">
This chapter specifies an Environment Specific Inter-ORB Protocol (ESIOP) for the OSF DCE environment, the DCE Common Inter-ORB Protocol (DCE-CIOP).<p>
</a><a name="1954">
<h1>	13.1	 Goals of the DCE Common Inter-ORB Protocol</h1>
</a><a name="1963">
DCE CIOP was designed to meet the following goals:<p>
</a><ul><a name="1964">
<li>Support multi-vendor, mission-critical, enterprise-wide, ORB-based applications.
</a><a name="2046">
<li>Leverage services provided by DCE wherever appropriate.
</a><a name="1966">
<li>Allow efficient and straightforward implementation using public DCE APIs.
</a><a name="1967">
<li>Preserve ORB implementation freedom.
</a></ul><a name="207">
DCE CIOP achieves these goals by using DCE-RPC to provide message transport, while leaving the ORB responsible for message formatting, data marshaling, and operation dispatch.<p>
</a><a name="1095">
<h1>	13.2	 DCE Common Inter-ORB Protocol Overview</h1>
</a><a name="1779">
The DCE Common Inter-ORB Protocol uses the wire format and RPC packet formats defined by DCE-RPC to enable independently implemented ORBs to communicate. It defines the message formats that are exchanged using DCE-RPC, and specifies how information in object references is used to establish communication between client and server processes.<p>
</a><a name="1173">
The full OMG IDL for the DCE ESIOP specification is shown in <a href="dceciop.html#1132">Section &#32;13.7, "OMG IDL for the DCE CIOP Module," on page &#32;13-24</a>. Fragments are used throughout this chapter as necessary. <p>
</a><a name="1780">
<h2>	13.2.1	 DCE-CIOP RPC</h2>
</a><a name="1781">
DCE-CIOP requires an RPC which is interoperable with the DCE connection-oriented and/or connectionless protocols as specified in the X/Open <em>CAE Specification C309</em> and the OSF <em>AES/Distributed Computing RPC Volume</em>. Some of the features of the DCE-RPC are as follows:<p>
</a><ul><a name="1789">
<li>Defines connection-oriented and connectionless protocols for establishing the communication between a client and server.
</a><a name="1791">
<li>Supports multiple underlying transport protocols including TCP/IP.
</a><a name="1792">
<li>Supports multiple outstanding requests to multiple CORBA objects over the same connection.
</a><a name="1793">
<li>Supports fragmentation of messages. This provides for buffer management by ORBs of CORBA requests which contain a large amount of marshaled data.
</a></ul><a name="1150">
All interactions between ORBs take the form of remote procedure calls on one of two well-known DCE-RPC interfaces. Two DCE operations are provided in each interface:<p>
</a><ul><a name="3685">
<li><em>invoke</em> - for invoking CORBA operation requests, and
</a><a name="3689">
<li><em>locate</em> - for locating server processes.
</a></ul><a name="3687">
Each DCE operation is a synchronous remote procedure call<a href="#5771"><sup>1</sup></a>,<a href="#5819"><sup>2</sup></a>, consisting of a request message being transmitted from the client to the server, followed by a response message being transmitted from the server to the client.<p>
</a><a name="7061">
Using one of the DCE-RPC interfaces, the messages are transmitted as pipes of uninterpreted bytes. By transmitting messages via DCE pipes, the following characteristics are achieved:<p>
</a><ul><a name="1169">
<li>Large amounts of data can be transmitted efficiently.
</a><a name="1170">
<li>Buffering of complete messages is not required.
</a><a name="1171">
<li>Marshaling and demarshaling can take place concurrently with message transmission.
</a><a name="1175">
<li>Encoding of messages and marshaling of data is completely under the control of the ORB.
</a><a name="2065">
<li>DCE client and server stubs can be used to implement DCE-CIOP.
</a></ul><a name="1798">
Using the other DCE-RPC interface, the messages are transmitted as conformant arrays of uninterpreted bytes. This interface does not offer all the advantages of the pipe-based interface, but is provided to enable interoperability with ORBs using DCE-RPC implementations that do not adequately support pipes.<p>
</a><a name="5835">
<h2>	13.2.2	 DCE-CIOP Data Representation</h2>
</a><a name="4419">
DCE-CIOP messages represent OMG IDL types by using the CDR transfer syntax, which is defined in <a href="giop.html#230">"CDR Transfer Syntax" on page &#32;12-4</a>. DCE-CIOP message headers and bodies are specified as OMG IDL types. These are encoded using CDR, and the resulting messages are passed between client and server processes via DCE-RPC pipes or conformant arrays.<p>
</a><a name="4482">
NDR is the transfer syntax used by DCE-RPC for operations defined in DCE IDL. CDR, used to represent messages defined in OMG IDL on top of DCE RPCs, represents the OMG IDL primitive types identically to the NDR representation of corresponding DCE IDL primitive types. The corresponding OMG IDL and DCE IDL primitive types are shown in table <a href="dceciop.html#4482">Table &#32;13-1</a>. 
<Table Border="3">
<caption><a name="4531">
Table 13-1	 Relationship between CDR and NDR primitive data types<p>
</a></caption>
<tr><th><a name="4535">
<h3> OMG IDL type</h3>
</a><th><a name="4537">
<h3> DCE IDL type with NDR representation equivalent to CDR representation of OMG IDL type</h3>
</a>
<tr><td><a name="4539">
 char<p>
</a><td><a name="4541">
 byte<p>
</a>
<tr><td><a name="4543">
 octet<p>
</a><td><a name="4545">
 byte<p>
</a>
<tr><td><a name="4547">
 short<p>
</a><td><a name="4549">
 short<p>
</a>
<tr><td><a name="4551">
 unsigned short<p>
</a><td><a name="4553">
 unsigned short<p>
</a>
<tr><td><a name="4555">
 long<p>
</a><td><a name="4557">
 long<p>
</a>
<tr><td><a name="4559">
 unsigned long<p>
</a><td><a name="4561">
 unsigned long<p>
</a>
<tr><td><a name="4563">
 float<p>
</a><td><a name="4565">
 float<a href="#4569"><sup>1</sup></a><p>
</a>
<tr><td><a name="4575">
 double<p>
</a><td><a name="4577">
 double<a href="#4579"><sup>2</sup></a><p>
</a>
<tr><td><a name="4586">
 boolean<p>
</a><td><a name="4588">
 byte<a href="#4964"><sup>3</sup></a><p>
</a>
<tr><td><a name="4582">
 enum<p>
</a><td><a name="4584">
 unsigned long<p>
</a>

</Table>

<Table>
<tr><td><sup>1</sup><a name="4569">
 Restricted to IEEE format.<p>
</a><sup>2</sup><a name="4579">
 Restricted to IEEE format.<p>
</a><sup>3</sup><a name="4964">
 Values restricted to 0 and 1.<p>
</a>
</Table>
<p>
</a><a name="4602">
The CDR representation of OMG IDL constructed types and pseudo-object types does not correspond to the NDR representation of types describable in DCE IDL. <p>
</a><a name="4614">
As new data types are added to OMG IDL, NDR can be used as a model for their CDR representations.<p>
</a><a name="4524">
<h2>	13.2.3	 DCE-CIOP Messages</h2>
</a><a name="3681">
The following request and response messages are exchanged between ORB clients and servers via the <code>invoke</code> and <code>locate</code> RPCs:<p>
</a><ul><a name="1208">
<li><em>Invoke Request</em> identifies the target object and the operation and contains the principal, the operation context, a <strong>ServiceContext</strong>, and the in and inout parameter values.
</a><a name="1209">
<li><em>Invoke Response</em> indicates whether the operation succeeded, failed, or needs to be reinvoked at another location, and returns a <strong>ServiceContext</strong>. If the operation succeeded, the result and the out and inout parameter values are returned. If it failed, an exception is returned. If the object is at another location, new RPC binding information is returned.
</a><a name="2072">
<li><em>Locate Request</em> identifies the target object and the operation.
</a><a name="1211">
<li><em>Locate Response</em> indicates whether the location is in the current process, is elsewhere, or is unknown. If the object is at another location, new RPC binding information is returned.
</a></ul><a name="1215">
All message formats begin with a field that indicates the byte order used in the CDR encoding of the remainder of the message. The CDR byte order of a message is required to match the NDR byte order used by DCE-RPC to transmit the message.<p>
</a><a name="1196">
<h2>	13.2.4	 Interoperable Object Reference (IOR)</h2>
</a><a name="1232">
For DCE-CIOP to be used to invoke operations on an object, the information necessary to reference an object via DCE-CIOP must be included in an IOR. This information can coexist with the information needed for other protocols such as IIOP. DCE-CIOP information is stored in an IOR as a set of components in a profile identified by <strong>TAG_MULTIPLE_COMPONENTS</strong>. Components are defined for the following purposes:<p>
</a><ul><a name="1262">
<li>To identify a server process via a DCE string binding, which can be either fully or partially bound. This process may be a server process implementing the object, or it may be an agent capable of locating the object implementation.
</a><a name="1264">
<li>To identify a server process via a name that can be resolved using a DCE nameservice. Again, this process may implement the object or may be an agent capable of locating it.
</a><a name="1267">
<li>To identify the target object when request messages are sent to the server.
</a><a name="2076">
<li>To enable a DCE-CIOP client to recognize objects that share an endpoint.
</a><a name="7337">
<li>To indicate whether a DCE-CIOP client should send a locate message or an invoke message.
</a><a name="7338">
<li>To indicate if the pipe-based DCE-RPC interface is not available.
</a></ul><a name="7339">
The IOR is created by the server ORB to provide the information necessary to reference the CORBA object. <p>
</a><a name="2237">
<h1>	13.3	 DCE-CIOP Message Transport</h1>
</a><a name="2238">
DCE-CIOP defines two DCE-RPC interfaces for the transport of messages between client ORBs and server ORBs. One interface uses pipes to convey the messages, while the other uses conformant arrays. <p>
</a><a name="6033">
The pipe-based interface is the preferred interface, since it allows messages to be transmitted without precomputing the message length. But not all DCE-RPC implementations adequately support pipes, so this interface is optional. All client and server ORBs implementing DCE-CIOP must support the array-based interface<a href="#6048"><sup>3</sup></a>.<p>
</a><a name="6096">
While server ORBs may provide both interfaces or just the array-based interface, it is up to the client ORB to decide which to use for an invocation. If a client ORB tries to use the pipe-based interface and receives a <code>rpc_s_unknown_if</code> error, it should fall back to the array-based interface.<p>
</a><a name="5888">
<h2>	13.3.1	 Pipe-based Interface</h2>
</a><a name="5880">
The <code>dce_ciop_pipe</code> interface is defined by the DCE IDL specification shown below:<p>
</a><a name="2239">
<blockquote></blockquote>
</a><a name="5905">
<blockquote>[                       /* DCE IDL */</blockquote>
</a><a name="5907">
<blockquote>uuid(0e07f95c-37b0-11ce-90a7-0800090b5d3e),</blockquote>
</a><a name="5908">
<blockquote>version(1.0)</blockquote>
</a><a name="5909">
<blockquote>]</blockquote>
</a><a name="5910">
<blockquote>interface dce_ciop_pipe</blockquote>
</a><a name="5911">
<blockquote>{</blockquote>
</a><a name="5912">
<blockquote>    typedef pipe byte message_type;</blockquote>
</a><a name="5913">
<blockquote></blockquote>
</a><a name="5914">
<blockquote>    void invoke ([in] handle_t binding_handle,</blockquote>
</a><a name="5915">
<blockquote>                 [in] message_type *request_message,</blockquote>
</a><a name="5916">
<blockquote>                 [out] message_type *response_message);</blockquote>
</a><a name="5917">
<blockquote></blockquote>
</a><a name="5918">
<blockquote>    void locate ([in] handle_t binding_handle,</blockquote>
</a><a name="5919">
<blockquote>                 [in] message_type *request_message,</blockquote>
</a><a name="5920">
<blockquote>                 [out] message_type *response_message);</blockquote>
</a><a name="5921">
<blockquote>}</blockquote>
</a><a name="2255">
ORBs can implement the <code>dce_ciop_pipe</code> interface by using DCE stubs generated from this IDL specification, or by using lower-level APIs provided by a particular DCE-RPC implementation.<p>
</a><a name="2256">
The <code>dce_ciop_pipe</code> interface is identified by the UUID and version number shown. To provide maximal performance, all server ORBs and location agents implementing DCE-CIOP should listen for and handle requests made to this interface. To maximize the chances of interoperating with any DCE-CIOP client, servers should listen for requests arriving via all available DCE protocol sequences.<p>
</a><a name="5752">
Client ORBs can invoke OMG IDL operations over DCE-CIOP by performing DCE RPCs on the <code>dce_ciop_pipe</code> interface.<p>
</a><a name="2257">
The <code>dce_ciop_pipe</code> interface is made up of two DCE-RPC operations, <code>invoke</code> and <code>locate</code>. The first parameter of each of these RPCs is a DCE binding handle, which identifies the server process on which to perform the RPC. See <a href="dceciop.html#6817">"DCE-CIOP String Binding Component" on page &#32;13-16</a>, <a href="dceciop.html#4852">"DCE-CIOP Binding Name Component" on page &#32;13-17</a>, and <a href="dceciop.html#4667">"DCE-CIOP Object Location" on page &#32;13-21</a> for discussion of how these binding handles are obtained. The remaining parameters of the <code>dce_ciop_pipe</code> RPCs are pipes of uninterpreted bytes. These pipes are used to convey messages encoded using CDR. The <code>request_message</code> input parameters send a request message from the client to the server, while the <code>response_message</code> output parameters return a response message from the server to the client.<p>
</a><a name="6428">
<a href="dceciop.html#6432">Figure &#32;13-1 </a>below illustrates the layering of DCE-CIOP messages on the DCE-RPC protocol as NDR pipes:<img src="local/images/dceciopa.gif"><p>
</a><a name="6432">
Figure 13-1	 Pipe-based interface protocol layering.<p>
</a><a name="6433">
The DCE-RPC protocol data unit (PDU) bodies, after any appropriate authentication is performed<a href="#7398"><sup>4</sup></a>, are concatenated by the DCE-RPC runtime to form an NDR stream. This stream is then interpreted as the NDR representation of a DCE IDL pipe.<p>
</a><a name="6776">
A pipe is made up of chunks, where each chunk consists of a chunk length and chunk data. The chunk length is an unsigned long indicating the number of pipe elements that make up the chunk data. The pipe elements are DCE IDL bytes, which are uninterpreted by NDR. A pipe is terminated by a chunk length of zero. The pipe chunks are concatenated to form a DCE-CIOP message. <p>
</a><a name="6763">
<h3>		 Invoke</h3>
</a><a name="2265">
The <code>invoke</code> RPC is used by a DCE-CIOP client process to attempt to invoke a CORBA operation in the server process identified by the <code>binding_handle</code> parameter. The <code>request_message</code> pipe transmits a DCE-CIOP invoke request message, encoded using CDR, from the client to the server. See <a href="dceciop.html#2482">"DCE_CIOP Invoke Request Message" on page &#32;13-10</a> for a description of its format. The <code>response_message</code> pipe transmits a DCE-CIOP invoke response message, also encoded using CDR, from the server to the client. See <a href="dceciop.html#2333">"DCE-CIOP Invoke Response Message" on page &#32;13-11</a> for a description of the response format.<p>
</a><a name="2272">
<h3>		 Locate</h3>
</a><a name="2273">
The <code>locate</code> RPC is used by a DCE-CIOP client process to query the server process identified by the <code>binding_handle</code> parameter for the location of the server process where requests should be sent. The <code>request_message</code> and <code>response_message</code> parameters are used similarly to the parameters of the <code>invoke </code>RPC. See <a href="dceciop.html#6833">"DCE-CIOP Locate Request Message" on page &#32;13-13</a> and <a href="dceciop.html#2399">"DCE-CIOP Locate Response Message" on page &#32;13-14</a> for descriptions of their formats. Use of the <code>locate</code> RPC is described in detail in <a href="dceciop.html#4667">"DCE-CIOP Object Location" on page &#32;13-21</a>.<p>
</a><a name="2286">
<h2>	13.3.2	 Array-based Interface</h2>
</a><a name="6003">
The <code>dce_ciop_array </code>interface is defined by the DCE IDL specification shown below:<p>
</a><a name="6004">
<blockquote></blockquote>
</a><a name="6007">
<blockquote>[                       /* DCE IDL */</blockquote>
</a><a name="6009">
<blockquote>uuid(8108ae54-4cd9-11ce-acca-0800090b5d3e),</blockquote>
</a><a name="6010">
<blockquote>version(1.0)</blockquote>
</a><a name="6011">
<blockquote>]</blockquote>
</a><a name="6012">
<blockquote>interface dce_ciop_array</blockquote>
</a><a name="6013">
<blockquote>{</blockquote>
</a><a name="6014">
<blockquote>    typedef struct {</blockquote>
</a><a name="6015">
<blockquote>        unsigned long length;</blockquote>
</a><a name="6016">
<blockquote> &#32; &#32; &#32; &#32; &#32; &#32; &#32; &#32;[size_is(length),ptr] byte *data;</blockquote>
</a><a name="6017">
<blockquote>    } message_type;</blockquote>
</a><a name="6018">
<blockquote></blockquote>
</a><a name="6019">
<blockquote>    void invoke ([in] handle_t binding_handle,</blockquote>
</a><a name="6020">
<blockquote>                 [in] message_type *request_message,</blockquote>
</a><a name="6021">
<blockquote>                 [out] message_type *response_message);</blockquote>
</a><a name="6022">
<blockquote></blockquote>
</a><a name="6023">
<blockquote>    void locate ([in] handle_t binding_handle,</blockquote>
</a><a name="6024">
<blockquote>                 [in] message_type *request_message,</blockquote>
</a><a name="6025">
<blockquote>                 [out] message_type *response_message);</blockquote>
</a><a name="6026">
<blockquote>}</blockquote>
</a><a name="6124">
ORBs can implement the <code>dce_ciop_array</code> interface, identified by the UUID and version number shown, by using DCE stubs generated from this IDL specification, or by using lower-level APIs provided by a particular DCE-RPC implementation.<p>
</a><a name="6125">
All server ORBs and location agents implementing DCE-CIOP must listen for and handle requests made to the <code>dce_ciop_array</code> interface, and to maximize interoperability, should listen for requests arriving via all available DCE protocol sequences.<p>
</a><a name="6126">
Client ORBs can invoke OMG IDL operations over DCE-CIOP by performing <code>locate</code> and <code>invoke</code> RPCs on the <code>dce_ciop_array</code> interface.<p>
</a><a name="6127">
As with the <code>dce_ciop_pipe</code> interface, the first parameter of each <code>dce_ciop_array</code> RPC is a DCE binding handle that identifies the server process on which to perform the RPC. The remaining parameters are structures containing CDR-encoded messages. The <code>request_message</code> input parameters send a request message from the client to the server, while the <code>response_message</code> output parameters return a response message from the server to the client.<p>
</a><a name="6217">
The <code>message_type</code> structure used to convey messages is made up of a <code>length</code> member and a <code>data</code> member:<p>
</a><ul><a name="6221">
<li><em>length</em> - This member indicates the number of bytes in the message.
</a><a name="6222">
<li><em>data</em> - This member is a full pointer to the first byte of the conformant array containing the message.
</a></ul><a name="6583">
The layering of DCE-CIOP messages on DCE-RPC using NDR arrays is illustrated in <a href="dceciop.html#6652">Figure &#32;13-2 </a>below:<img src="local/images/dcecioa1.gif"><p>
</a><a name="6652">
Figure 13-2	 Array-based interface protocol layering.<p>
</a><a name="6581">
The NDR stream, formed by concatenating the PDU bodies, is interpreted as the NDR representation of the DCE IDL <code>message_type</code> structure. The <code>length</code> member is encoded first, followed by the <code>data</code> member. The <code>data</code> member is a full pointer, which is represented in NDR as a referent ID. In this case, this non-NULL pointer is the first (and only) pointer to the referent, so the referent ID is 1 and it is followed by the representation of the referent. The referent is a conformant array of bytes, which is represented in NDR as an unsigned long indicating the length, followed by that number of bytes. The bytes form the DCE-CIOP message.<p>
</a><a name="6794">
<h3>		 Invoke</h3>
</a><a name="6141">
The <code>invoke</code> RPC is used by a DCE-CIOP client process to attempt to invoke a CORBA operation in the server process identified by the <code>binding_handle</code> parameter. The <code>request_message</code> input parameter contains a DCE-CIOP invoke request message. The <code>response_message</code> output parameter returns a DCE-CIOP invoke response message from the server to the client.<p>
</a><a name="6148">
<h3>		 Locate</h3>
</a><a name="6149">
The <code>locate</code> RPC is used by a DCE-CIOP client process to query the server process identified by the <code>binding_handle</code> parameter for the location of the server process where requests should be sent. The <code>request_message</code> and <code>response_message</code> parameters are used similarly to the parameters of the <code>invoke </code>RPC.<p>
</a><a name="5898">
<h1>	13.4	 DCE-CIOP Message Formats</h1>
</a><a name="2287">
The section defines the message formats used by DCE-CIOP. These message formats are specified in OMG IDL, are encoded using CDR, and are transmitted over DCE-RPC as either pipes or arrays of bytes as described in <a href="dceciop.html#2237">"DCE-CIOP Message Transport" on page &#32;13-5</a>.<p>
</a><a name="2482">
<h2>	13.4.1	 DCE_CIOP Invoke Request Message</h2>
</a><a name="2483">
DCE-CIOP invoke request messages encode CORBA object requests, including attribute accessor operations and <code>CORBA::Object</code> operations such as <code>get_interface</code> and <code>get_implementation</code>. Invoke requests are passed from client to server as the <code>request_message</code> parameter of an <code>invoke</code> RPC.<p>
</a><a name="2690">
A DCE-CIOP invoke request message is made up of a header and a body. The header has a fixed format, while the format of the body is determined by the operation's IDL definition. <p>
</a><a name="2680">
<h3>		 Invoke Request Header</h3>
</a><a name="2681">
DCE-CIOP request headers have the following structure:<p>
</a><a name="4647">
<blockquote></blockquote>
</a><a name="4648">
 module DCE_CIOP {															// IDL<p>
</a><a name="4649">
<blockquote>	struct InvokeRequestHeader {</blockquote>
</a><a name="2298">
<blockquote>		boolean byte_order;</blockquote>
</a><a name="2928">
<blockquote>		IOP::ServiceContextList 	service_context;</blockquote>
</a><a name="2299">
<blockquote>		sequence &lt;octet&gt; object_key;</blockquote>
</a><a name="2300">
<blockquote>		string endpoint_id;</blockquote>
</a><a name="6914">
<blockquote>		string operation;</blockquote>
</a><a name="2301">
<blockquote>		CORBA::Principal principal;</blockquote>
</a><a name="2303">
<blockquote>		sequence &lt;string&gt; client_context;</blockquote>
</a><a name="2305">
<blockquote></blockquote>
</a><a name="2870">
<blockquote>		// in and inout parameters follow</blockquote>
</a><a name="2306">
<blockquote>	};</blockquote>
</a><a name="2307">
 };<p>
</a><a name="2580">
The members have the following definitions:<p>
</a><ul><a name="2874">
<li><strong>byte_order</strong> indicates the byte ordering used in the representation of the remainder of the message. A value of FALSE indicates big-endian byte ordering, and TRUE indicates little-endian byte ordering.
</a><a name="2934">
<li><strong>service_context</strong> contains any ORB service data that needs to be sent from the client to the server.
</a><a name="2535">
<li><strong>object_key</strong> contains opaque data used to identify the object that is the target of the operation. See <a href="dceciop.html#6344">"Object Key Component" on page &#32;13-19</a>.
</a><a name="2311">
<li><strong>endpoint_id </strong>contains an identifier for the endpoint at which the object is located, if this was included in the IOR profile. If not, an empty string is used. See <a href="dceciop.html#1920">"Endpoint ID Component" on page &#32;13-19</a>.
</a><a name="6922">
<li><strong>operation</strong> contains the name of the CORBA operation being invoked. The case of the operation name must match the case of the operation name specified in the OMG IDL source for the interface being used.
</a><a name="3768">
 Attribute accessors have names as follows: <p>
</a><a name="3769">
<li>Attribute selector: operation name is "_get_&lt;attribute&gt;"
</a><a name="3770">
<li>Attribute mutator: operation name is "_set_&lt;attribute&gt;"
</a><a name="2316">
 <strong>CORBA::Object</strong> pseudo-operations have operation names as follows:<p>
</a><a name="2317">
<li><strong>get_interface</strong><code> - </code>operation name is "_interface"
</a><a name="2318">
<li><strong>get_implementation</strong><code> - </code>operation name is "_implementation"
</a><a name="2319">
<li><strong>is_a</strong><code> - </code>operation name is "_is_a"
</a><a name="2618">
<li><strong>non_existent</strong> - operation name is "_non_existent"
</a><a name="2601">
<li><strong>Principal </strong>contains a value identifying the requesting principal. No particular meaning or semantics are associated with this value. It is provided to support the <code>BOA::get_principal</code> operation.
</a><a name="2639">
<li><strong>client_context</strong> contains any context properties associated with the request. Each property is encoded as a pair of strings; the first naming the property and the second containing its value. 
</a><a name="4376">
 Clients are not required to include all properties listed in the context expression of the operation's OMG IDL definition. They are allowed to include properties not listed in the OMG IDL definition. <p>
</a></ul><a name="4378">
<h3>		 Invoke Request Body</h3>
</a><a name="2322">
The invoke request body contains all in and inout parameters, in the order in which they are specified in the operation definition, from left to right.<p>
</a><a name="2333">
<h2>	13.4.2	 DCE-CIOP Invoke Response Message</h2>
</a><a name="2334">
Invoke response messages are returned from servers to clients as the <code>response_message</code> parameter of an <code>invoke</code> RPC.<p>
</a><a name="2337">
Like invoke request messages, an invoke response message is made up of a header and a body. The header has a fixed format, while the format of the body depends on the operation's OMG IDL definition and the outcome of the invocation.<p>
</a><a name="2722">
<h3>		 Invoke Response Header</h3>
</a><a name="2719">
DCE-CIOP invoke response headers have the following structure:<p>
</a><a name="2338">
<blockquote></blockquote>
</a><a name="2898">
 module DCE_CIOP {																// IDL<p>
</a><a name="2339">
<blockquote>	enum InvokeResponseStatus {</blockquote>
</a><a name="2340">
<blockquote>		INVOKE_NO_EXCEPTION,</blockquote>
</a><a name="2341">
<blockquote>		INVOKE_USER_EXCEPTION,</blockquote>
</a><a name="2342">
<blockquote>		INVOKE_SYSTEM_EXCEPTION,</blockquote>
</a><a name="2343">
<blockquote>		INVOKE_LOCATION_FORWARD,</blockquote>
</a><a name="6829">
<blockquote>		INVOKE_TRY_AGAIN</blockquote>
</a><a name="2344">
<blockquote>	};</blockquote>
</a><a name="2345">
<blockquote></blockquote>
</a><a name="2346">
<blockquote>	struct InvokeResponseHeader {</blockquote>
</a><a name="2347">
<blockquote>		boolean byte_order;</blockquote>
</a><a name="2958">
<blockquote>		IOP::ServiceContextList service_context;</blockquote>
</a><a name="2950">
<blockquote>		InvokeResponseStatus status;</blockquote>
</a><a name="2952">
<blockquote></blockquote>
</a><a name="2850">
<blockquote>		// if status = INVOKE_NO_EXCEPTION,</blockquote>
</a><a name="2851">
<blockquote>		// result then inouts and outs follow</blockquote>
</a><a name="2352">
<blockquote></blockquote>
</a><a name="2854">
<blockquote>		// if status = INVOKE_USER_EXCEPTION or</blockquote>
</a><a name="2856">
<blockquote>		// INVOKE_SYSTEM_EXCEPTION, an exception follows</blockquote>
</a><a name="2353">
<blockquote></blockquote>
</a><a name="2863">
<blockquote>		// if status = INVOKE_LOCATION_FORWARD, an </blockquote>
</a><a name="5400">
<blockquote>		// IOP::MultipleComponentsProfile follows</blockquote>
</a><a name="2354">
<blockquote>	};</blockquote>
</a><a name="2355">
 };<p>
</a><a name="2356">
The members have the following definitions:<p>
</a><ul><a name="2880">
<li><strong>byte_order</strong> indicates the byte ordering used in the representation of the remainder of the message. A value of FALSE indicates big-endian byte ordering, and TRUE indicates little-endian byte ordering.
</a><a name="2938">
<li><strong>service_context</strong> contains any ORB service data that needs to be sent from the client to the server.
</a><a name="2907">
<li><strong>status </strong>indicates the completion status of the associated request, and also determines the contents of the body.
</a></ul><a name="2911">
<h3>		 Invoke Response Body</h3>
</a><a name="2363">
The contents of the invoke response body depends on the value of the <code>status</code> member of the invoke response header, as well as the OMG IDL definition of the operation being invoked. Its format is one of the following:<p>
</a><ul><a name="2368">
<li>If the <strong>status</strong> value is <code>INVOKE_NO_EXCEPTION</code>, then the body contains the operation result value (if any), followed by all inout and out parameters, in the order in which they appear in the operation signature, from left to right.
</a><a name="2369">
<li>If the <code>status</code> value is <code>INVOKE_USER_EXCEPTION</code> or <code>INVOKE_SYSTEM_EXCEPTION</code>, then the body contains the exception, encoded as in GIOP.
</a><a name="5405">
<li>If the <code>status</code> value is <code>INVOKE_LOCATION_FORWARD</code>, then the body contains a new <strong>MultipleComponentProfile</strong> structure containing components that can be used to communicate with the object specified in the invoke request message. This profile must provide at least one new DCE-CIOP binding component. The client ORB is responsible for re-sending the request to the server identified by the new profile. This operation should be transparent to the client program making the request. See <a href="dceciop.html#4667">"DCE-CIOP Object Location" on page &#32;13-21</a> for more details.
</a><a name="6835">
<li>If the <code>status</code> value is <code>INVOKE_TRY_AGAIN</code>, then the body is empty and the client should reissue the <code>invoke</code> RPC, possibly after a short delay<a href="#6838"><sup>5</sup></a>.
</a></ul><a name="6833">
<h2>	13.4.3	 DCE-CIOP Locate Request Message</h2>
</a><a name="2377">
Locate request messages may be sent from a client to a server, as the <code>request_message</code> parameter of a <code>locate</code> RPC, to determine the following regarding a specified object reference:<p>
</a><ul><a name="2378">
<li>Whether the object reference is valid
</a><a name="2379">
<li>Whether the current server is capable of directly receiving requests for the object reference
</a><a name="2380">
<li>If not capable, to solicit an address to which requests for the object reference should be sent.
</a></ul><a name="2384">
For details on the usage of the <code>locate</code> RPC, see <a href="dceciop.html#4667">"DCE-CIOP Object Location" on page &#32;13-21</a>.<p>
</a><a name="2992">
Locate request messages contain a fixed-format header, but no body.<p>
</a><a name="2993">
<h3>		 Locate Request Header</h3>
</a><a name="2385">
DCE-CIOP locate request headers have the following format:<p>
</a><a name="2387">
<blockquote></blockquote>
</a><a name="2388">
 module DCE_CIOP {																// IDL<p>
</a><a name="2389">
<blockquote>	struct LocateRequestHeader {</blockquote>
</a><a name="2391">
<blockquote>		boolean byte_order;</blockquote>
</a><a name="3012">
<blockquote>		sequence &lt;octet&gt; object_key;</blockquote>
</a><a name="2392">
<blockquote>		string endpoint_id;</blockquote>
</a><a name="6918">
<blockquote>		string operation;</blockquote>
</a><a name="2393">
<blockquote></blockquote>
</a><a name="3158">
<blockquote>		// no body follows</blockquote>
</a><a name="3157">
<blockquote>	};</blockquote>
</a><a name="2394">
 };<p>
</a><a name="3023">
The members have the following definitions:<p>
</a><ul><a name="3024">
<li><strong>byte_order</strong> indicates the byte ordering used in the representation of the remainder of the message. A value of FALSE indicates big-endian byte ordering, and TRUE indicates little-endian byte ordering.
</a><a name="3026">
<li><strong>object_key</strong> contains opaque data used to identify the object that is the target of the operation. See <a href="dceciop.html#6344">"Object Key Component" on page &#32;13-19</a>.
</a><a name="6937">
<li><strong>endpoint_id </strong>member contains an identifier for the endpoint at which the object is located, if this was included in the IOR profile. If not, an empty string is used. See <a href="dceciop.html#1920">"Endpoint ID Component" on page &#32;13-19</a>.
</a><a name="6935">
<li><strong>operation </strong>contains the name of the CORBA operation being invoked. It is encoded as in the invoke request header.
</a></ul><a name="2399">
<h2>	13.4.4	 DCE-CIOP Locate Response Message</h2>
</a><a name="2400">
Locate response messages are sent from servers to clients as the <code>response_message</code> parameter of a <code>locate</code> RPC.<strong> </strong>They consist of a fixed-format header, and a body whose format depends on information in the header.<p>
</a><a name="3054">
<h3>		 Locate Response Header</h3>
</a><a name="2405">
DCE-CIOP locate response headers have the following format:<p>
</a><a name="2406">
<blockquote></blockquote>
</a><a name="3056">
 module DCE_CIOP {																// IDL<p>
</a><a name="2407">
<blockquote>	enum LocateResponseStatus {</blockquote>
</a><a name="2408">
<blockquote>		LOCATE_UNKNOWN_OBJECT,</blockquote>
</a><a name="2409">
<blockquote>		LOCATE_OBJECT_HERE,</blockquote>
</a><a name="2410">
<blockquote>		LOCATE_LOCATION_FORWARD,</blockquote>
</a><a name="6293">
<blockquote>		LOCATE_TRY_AGAIN</blockquote>
</a><a name="2411">
<blockquote>	};</blockquote>
</a><a name="2412">
<blockquote></blockquote>
</a><a name="2413">
<blockquote>	struct LocateResponseHeader {</blockquote>
</a><a name="2414">
<blockquote>		boolean byte_order;</blockquote>
</a><a name="2415">
<blockquote>		LocateResponseStatus status;</blockquote>
</a><a name="2416">
<blockquote></blockquote>
</a><a name="3072">
<blockquote>		// if status = LOCATE_LOCATION_FORWARD, an</blockquote>
</a><a name="5379">
<blockquote>		// IOP::MultipleComponentProfile follows</blockquote>
</a><a name="2417">
<blockquote>	};</blockquote>
</a><a name="2418">
 };<p>
</a><a name="2419">
The members have the following definitions:<p>
</a><ul><a name="3083">
<li><strong>byte_order</strong> indicates the byte ordering used in the representation of the remainder of the message. A value of FALSE indicates big-endian byte ordering, and TRUE indicates little-endian byte ordering.
</a><a name="3085">
<li><strong>status</strong> indicates whether the object is valid and whether it is located in this server. It determines the contents of the body.
</a></ul><a name="3086">
<h3>		 Locate Response Body</h3>
</a><a name="3114">
The contents of the locate response body depends on the value of the <code>status</code> member of the locate response header. Its format is one of the following:<p>
</a><ul><a name="3116">
<li>If the <code>status</code> value is <code>LOCATE_UNKNOWN_OBJECT</code>, then the object specified in the corresponding locate request message is unknown to the server. The locate reply body is empty in this case.
</a><a name="2422">
<li>If the <code>status</code> value is <code>LOCATE_OBJECT_HERE</code>, then this server (the originator of the locate response message) can directly receive requests for the specified object. The locate response body is also empty in this case.
</a><a name="2423">
<li>If the <code>status</code> value is <code>LOCATE_LOCATION_FORWARD</code>, then the locate response body contains a new <strong>MultipleComponentProfile</strong> structure containing components that can be used to communicate with the object specified in the locate request message. This profile must provide at least one new DCE-CIOP binding component.
</a><a name="2228">
<li>If the status value is <code>LOCATE_TRY_AGAIN</code>, the locate response body is empty and the client should reissue the <code>locate</code> RPC, possibly after a short delay<a href="#6320"><sup>6</sup></a>.
</a></ul><a name="6297">
<h1>	13.5	 DCE-CIOP Object References</h1>
</a><a name="2229">
The information necessary to invoke operations on objects using DCE-CIOP is encoded in an IOR in a profile identified by TAG_MULTIPLE_COMPONENTS. The <code>profile_data</code> for this profile is a CDR encapsulation of the MultipleComponentProfile type, which is a sequence of TaggedComponent structures. These types are described in <a href="inarch.html#3666">"An Information Model for Object References" on page &#32;10-14</a>.<p>
</a><a name="1390">
DCE-CIOP defines a number of IOR components that can be included in a MultipleComponentProfile. Each is identified by a unique tag, and the encoding and semantics of the associated component_data are specified.<p>
</a><a name="1399">
An IOR profile identified by TAG_MULTIPLE_COMPONENTS can contain components for other protocols in addition to DCE-CIOP, and can contain components used by other kinds of ORB services. For example, an ORB vendor can define its own private components within this profile to support the vendor's native protocol. Several of the components defined for DCE-CIOP may be of use to other protocols as well. The following component descriptions will note whether the component is intended solely for DCE-CIOP or can be used by other protocols, whether the component is required or optional for DCE-CIOP, and whether more than one instance of the component can be included in a profile.<p>
</a><a name="1658">
A conforming implementation of DCE-CIOP is only required to generate and recognize the components defined here. Unrecognized components should be preserved but ignored. Implementations should also be prepared to encounter profiles identified by TAG_MULTIPLE_COMPONENTS that do not support DCE-CIOP.<p>
</a><a name="6817">
<h2>	13.5.1	 DCE-CIOP String Binding Component</h2>
</a><a name="1659">
A DCE-CIOP string binding component, identified by <strong>TAG_DCE_STRING_BINDING</strong>, contains a fully or partially bound string binding. A string binding provides the information necessary for DCE-RPC to establish communication with a server process that can either service the client's requests itself, or provide the location of another process that can. The DCE API routine <code>rpc_binding_from_string_binding</code> can be used to convert a string binding to the DCE binding handle required to communicate with a server as described in <a href="dceciop.html#2237">"DCE-CIOP Message Transport" on page &#32;13-5</a>.<p>
</a><a name="1457">
This component is intended to be used only by DCE-CIOP. At least one string binding or binding name component must be present for an IOR profile to support DCE-CIOP.<p>
</a><a name="4842">
Multiple string binding components can be included in a profile to define endpoints for different DCE protocols, or to identify multiple servers or agents capable of servicing the request.<p>
</a><a name="1663">
The string binding component is defined as follows:<p>
</a><a name="1461">
<blockquote></blockquote>
</a><a name="1488">
 module DCE_CIOP {																					\\ IDL<p>
</a><a name="1665">
<blockquote>	const IOP::ComponentId TAG_DCE_STRING_BINDING = 100;</blockquote>
</a><a name="1681">
 };<p>
</a><a name="1415">
A <strong>TaggedComponent </strong>structure is built for the string binding component by setting the <code>tag</code> member to <strong>TAG_DCE_STRING_BINDING</strong>, and setting the <strong>component_data</strong> member to the value of a DCE string binding. The string is represented directly in the sequence of octets, including the terminating NUL, without further encoding. <p>
</a><a name="1688">
The format of a string binding is defined in Chapter 3 of the OSF<em> AES/Distributed Computing RPC Volume</em>. The DCE API function <code>rpc_binding_from_string_binding</code> converts a string binding into a binding handle that can be used by a client ORB as the first parameter to the <code>invoke</code> and <code>locate</code> RPCs.<p>
</a><a name="3271">
A string binding contains:<p>
</a><ul><a name="3238">
<li>A protocol sequence
</a><a name="1425">
<li>A network address
</a><a name="1433">
<li>An optional endpoint
</a><a name="3244">
<li>An optional object UUID
</a></ul><a name="3246">
DCE object UUIDs are used to identify server process endpoints, which can each support any number of CORBA objects. DCE object UUIDs do not necessarily correspond to individual CORBA objects.<p>
</a><a name="4846">
A partially bound string binding does not contain an endpoint. Since the DCE-RPC runtime uses an endpoint mapper to complete a partial binding, and multiple ORB servers might be located on the same host, partially bound string bindings must contain object UUIDs to distinguish different endpoints at the same network address.<p>
</a><a name="4852">
<h2>	13.5.2	 DCE-CIOP Binding Name Component</h2>
</a><a name="1603">
A DCE-CIOP binding name component is identified by <strong>TAG_DCE_BINDING_NAME</strong>. It contains a name that can be used with a DCE nameservice such as CDS or GDS to obtain the binding handle needed to communicate with a server process.<p>
</a><a name="1660">
This component is intended for use only by DCE-CIOP. Multiple binding name components can be included to identify multiple servers or agents capable of handling a request. At least one binding name or string binding component must be present for a profile to support DCE-CIOP.<p>
</a><a name="4889">
The binding name component is defined by the following OMG IDL:<p>
</a><a name="1681">
<blockquote></blockquote>
</a><a name="1682">
 module DCE_CIOP {																						// IDL<p>
</a><a name="1683">
<blockquote>	const IOP::ComponentId TAG_DCE_BINDING_NAME = 101;</blockquote>
</a><a name="1684">
<blockquote></blockquote>
</a><a name="1685">
<blockquote>	struct BindingNameComponent {</blockquote>
</a><a name="1744">
<blockquote>		unsigned long entry_name_syntax;</blockquote>
</a><a name="1745">
<blockquote>		string entry_name;</blockquote>
</a><a name="1749">
<blockquote>		string object_uuid;</blockquote>
</a><a name="1743">
<blockquote>	};</blockquote>
</a><a name="1699">
 };<p>
</a><a name="1700">
A <strong>TaggedComponent </strong>structure is built for the binding name component by setting the <code>tag</code> member to <strong>TAG_DCE_BINDING_NAME</strong>, and setting the <strong>component_data member</strong> to a CDR encapsulation of a <strong>BindingNameComponent </strong>structure.<p>
</a><a name="1679">
<h3>		 BindingNameComponent</h3>
</a><a name="6326">
The <strong>BindingNameComponent</strong> structure contains the information necessary to query a DCE nameservice such as CDS. A client ORB can use the <strong>entry_name_syntax, entry_name,</strong> and <strong>object_uuid</strong> members of the <strong>BindingName</strong> structure with the <code>rpc_ns_binding_import_*</code> or <code>rpc_ns_binding_lookup_*</code> families of DCE API routines to obtain binding handles to communicate with a server. If the <code>object_uuid</code> member is an empty string, a nil object UUID should be passed to these DCE API routines.<p>
</a><a name="6328">
<h2>	13.5.3	 DCE-CIOP No Pipes Component</h2>
</a><a name="6345">
The optional component identified by <strong>TAG_DCE_NO_PIPES</strong> indicates to an ORB client that the server does not support the <code>dce_ciop_pipe</code> DCE-RPC interface. It is only a hint, and can be safely ignored. As described in <a href="dceciop.html#2237">"DCE-CIOP Message Transport" on page &#32;13-5</a>, the client must fall back to the array-based interface if the pipe-based interface is not available in the server.<p>
</a><a name="6346">
<blockquote></blockquote>
</a><a name="6347">
 module DCE_CIOP {<p>
</a><a name="6349">
<blockquote>	const IOP::ComponentId TAG_DCE_NO_PIPES = 102;</blockquote>
</a><a name="6348">
 };<p>
</a><a name="6353">
A <strong>TaggedComponent </strong>structure with a <code>tag</code> member of <strong>TAG_DCE_NO_PIPES</strong> must have an empty <strong>component_data</strong> member.<p>
</a><a name="6354">
This component is intended for use only by DCE-CIOP, and a profile should not contain more than one component with this tag.<p>
</a><a name="6344">
<h2>	13.5.4	 Object Key Component</h2>
</a><a name="6884">
An ORB server must include a single object key component, identified by <strong>TAG_OBJECT_KEY</strong>, in a DCE-CIOP IOR profile to hold the data it uses to identify the object. Its <strong>component_data</strong> value is used as the <strong>object_key</strong> member in invoke and locate request message headers.<p>
</a><a name="6894">
The object key component is available for use by all protocols that use the <strong>TAG_MULTIPLE_COMPONENTS</strong> profile. By sharing this component, protocols can avoid duplicating object identity information.<p>
</a><a name="1477">
<p>
</a><a name="1821">
 module IOP {																		\\ IDL<p>
</a><a name="1822">
<blockquote>	const ComponentId TAG_OBJECT_KEY = 10;</blockquote>
</a><a name="1823">
<blockquote></blockquote>
</a><a name="1800">
<blockquote><code>	</code></blockquote>
</a><a name="1812">
 };<p>
</a><a name="1830">
<p>
</a><a name="1667">
The <strong>component_data </strong>of this component is not interpreted by the client process. Its format only needs to be understood by the server process and any location agent that it uses.<p>
</a><a name="1920">
<h2>	13.5.5	 Endpoint ID Component</h2>
</a><a name="1921">
An optional endpoint ID component can be included in IOR profiles to enable client ORBs to minimize resource utilization and to avoid redundant locate messages. It can be used by other protocols as well as by DCE-CIOP. No more than one endpoint ID component should be included in a profile.<p>
</a><a name="1936">
<blockquote></blockquote>
</a><a name="1937">
 module IOP {																		\\ IDL<p>
</a><a name="1938">
<blockquote>	const ComponentId TAG_ENDPOINT_ID = 11;</blockquote>
</a><a name="1939">
 };<p>
</a><a name="1924">
An endpoint ID component, identified by <strong>TAG_ENDPOINT_ID</strong>, provides an identifier for the endpoint at which operations on an object can be invoked. The component_data is a NUL-terminated globally unique string identifying the endpoint. The recommended format for the <strong>component_data</strong> is a stringified UUID. <p>
</a><a name="4291">
If multiple objects have the same endpoint ID, they can be messaged to at a single endpoint, avoiding the need to locate each object individually. DCE-CIOP clients can use a single binding handle to invoke requests on all of the objects with a common endpoint ID. See <a href="dceciop.html#6975">"Use of the Location Policy and the Endpoint ID" on page &#32;13-23</a>.<p>
</a><a name="867">
The endpoint ID component, if present in the IOR profile, is included in invoke and locate request message headers as the <strong>endpoint_id</strong> member. The server or agent can use the endpoint ID in conjunction with the object key to identify the object and its implementation. If no endpoint ID is included in the profile, an empty string is used as the <code>endpoint_id</code> member of the request messages.<p>
</a><a name="5476">
<h2>	13.5.6	 Location Policy Component</h2>
</a><a name="5457">
An optional location policy component can be included in IOR profiles to specify when a DCE-CIOP client ORB should perform a <code>locate</code> RPC before attempting to perform an <code>invoke</code> RPC. No more than one location policy component should be included in a profile, and it can be used by other protocols that have location algorithms similar to DCE-CIOP.<p>
</a><a name="4670">
<blockquote></blockquote>
</a><a name="5203">
 module IOP {																			\\ IDL<p>
</a><a name="4671">
<blockquote>	const ComponentId TAG_LOCATION_POLICY = 12;</blockquote>
</a><a name="4672">
<blockquote></blockquote>
</a><a name="5216">
<blockquote>	const octet LOCATE_NEVER = 0;</blockquote>
</a><a name="5217">
<blockquote>	const octet LOCATE_OBJECT = 1;</blockquote>
</a><a name="5218">
<blockquote>	const octet LOCATE_OPERATION = 2;</blockquote>
</a><a name="4680">
<blockquote>	const octet LOCATE_ALWAYS = 3;</blockquote>
</a><a name="4687">
 };<p>
</a><a name="4801">
A <strong>TaggedComponent</strong> structure for a location policy component is built by setting the <code>tag</code> member to <strong>TAG_LOCATION_POLICY</strong>, and setting the <strong>component_data</strong> member to a sequence containing a single octet, whose value is <strong>LOCATE_NEVER</strong>, <strong>LOCATE_OBJECT, LOCATE_OPERATION,</strong> or <strong>LOCATE_ALWAYS</strong>.<p>
</a><a name="5244">
If a location policy component is not present in a profile, the client should assume a location policy of<strong> LOCATE_OBJECT</strong>.<p>
</a><a name="4806">
A client should interpret the location policy as follows: <p>
</a><a name="1907">
<p>
</a><ul><a name="1906">
<li><em>LOCATE_NEVER</em> Perform only the <code>invoke</code> RPC. No <code>locate</code> RPC is necessary.
</a><a name="4808">
<li><em>LOCATE_OBJECT</em> Perform a <code>locate</code> RPC once per object. The <code>operation</code> member of the locate request message will be ignored.
</a><a name="4809">
<li><em>LOCATE_OPERATION</em> Perform a separate <code>locate</code> RPC for each distinct operation on the object. This policy can be used when different methods of an object are located in different processes.
</a><a name="4810">
<li><em>LOCATE_ALWAYS</em> Perform a separate <code>locate</code> RPC for each invocation on the object. This policy can be used to support server-per-method activation.
</a></ul><a name="5267">
The location policy is a hint that enables a client to avoid unnecessary <code>locate</code> RPCs and to avoid <code>invoke</code> RPCs that return <strong>INVOKE_LOCATION_FORWARD</strong> status. It is not needed to provide correct semantics, and can be ignored. Even when this hint is utilized, an <code>invoke</code> RPC might result in an <strong>INVOKE_LOCATION_FORWARD</strong> response. See <a href="dceciop.html#4667">"DCE-CIOP Object Location" on page &#32;13-21</a> for more detail.<p>
</a><a name="5295">
A client does not need to implement all location policies to make use of this hint. A location policy with a higher value can be substituted for one with a lower value. For instance, a client might treat <strong>LOCATE_OPERATION</strong> as <strong>LOCATE_ALWAYS</strong> to avoid having to keep track of binding information for each operation on an object.<p>
</a><a name="5299">
When combined with an endpoint ID component, a location policy of <strong>LOCATE_OBJECT</strong> indicates that the client should perform a <code>locate</code> RPC for the first object with a particular endpoint ID, and then just perform an <code>invoke</code> RPC for other objects with the same endpoint ID. When a location policy of <strong>LOCATE_NEVER</strong> is combined with an endpoint ID component, only <code>invoke</code> RPCs need be performed. The <strong>LOCATE_ALWAYS</strong> and <strong>LOCATE_OPERATION</strong> policies should not be combined with an endpoint ID component in a profile.<p>
</a><a name="4667">
<h1>	13.6	 DCE-CIOP Object Location</h1>
</a><a name="3896">
This section describes how DCE-CIOP client ORBs locate the server ORBs that can perform operations on an object via the <code>invoke</code> RPC.<p>
</a><a name="3905">
<h2>	13.6.1	 Location Mechanism Overview</h2>
</a><a name="1618">
DCE-CIOP is defined to support object migration and location services without dictating the existence of specific ORB architectures or features. The protocol features are based on the following observations:<p>
</a><a name="1619">
A given transport address does not necessarily correspond to any specific ORB architectural component (such as an object adapter, server process, ORB process, locator, etc.). It merely implies the existence of some agent to which requests may be sent.<p>
</a><a name="1620">
The "agent" (receiver of an RPC) may have one of the following roles with respect to a particular object reference:<p>
</a><ul><a name="1621">
<li>The agent may be able to accept object requests directly for the object and return replies. The agent may or may not own the actual object implementation; it may be a gateway that transforms the request and passes it on to another process or ORB. From DCE-CIOP's perspective, it is only important that invoke request messages can be sent directly to the agent.
</a><a name="1622">
<li>The agent may not be able to accept direct requests for any objects, but acts instead as a location service. Any invoke request messages sent to the agent would result in either exceptions or replies with <strong>INVOKE_LOCATION_FORWARD</strong> status, providing new addresses to which requests may be sent. Such agents would also respond to locate request messages with appropriate locate response messages.
</a><a name="1623">
<li>The agent may directly respond to some requests (for certain objects) and provide forwarding locations for other objects.
</a><a name="1624">
<li>The agent may directly respond to requests for a particular object at one point in time, and provide a forwarding location at a later time.
</a></ul><a name="1625">
Server ORBs are not required to implement location forwarding mechanisms. An ORB can be implemented with the policy that servers either support direct access to an object, or return exceptions. Such a server ORB would always return locate response messages with either <strong>LOCATE_OBJECT_HERE</strong> or <strong>LOCATE_UNKNOWN_OBJECT </strong>status, and never <strong>LOCATE_LOCATION_FORWARD</strong> status. It would also never return invoke response messages with <strong>INVOKE_LOCATION_FORWARD</strong> status.<p>
</a><a name="1626">
Client ORBs must, however, be able to accept and process invoke response messages with <strong>INVOKE_LOCATION_FORWARD</strong> status, since any server ORB may choose to implement a location service. Whether a client ORB chooses to send locate request messages is at the discretion of the client.<p>
</a><a name="3857">
Client ORBs that send locate request messages can use the location policy component found in DCE-CIOP IOR profiles to decide whether to send a locate request message before sending an invoke request message. See <a href="dceciop.html#5476">"Location Policy Component" on page &#32;13-20</a>. This hint can be safely ignored by a client ORB.<p>
</a><a name="1627">
A client should not make any assumptions about the longevity of addresses returned by location forwarding mechanisms. If a binding handle based on location forwarding information is used successfully, but then fails, subsequent attempts to send requests to the same object should start with the original address specified in the object reference.<p>
</a><a name="1628">
In general, the use of location forwarding mechanisms is at the discretion of ORBs, available to be used for optimization and to support flexible object location and migration behaviors.<p>
</a><a name="3906">
<h2>	13.6.2	 Activation</h2>
</a><a name="4318">
Activation of ORB servers is transparent to ORB clients using DCE-CIOP. Unless an IOR refers to a transient object, the agent addressed by the IOR profile should either be permanently active, or should be activated on demand by DCE's endpoint mapper.<p>
</a><a name="4324">
The current DCE endpoint mapper, rpcd, does not provide activation. In ORB server environments using rpcd, the agent addressed by an IOR must not only be capable of locating the object, it must also be able to activate it if necessary. A future DCE endpoint mapper may provide automatic activation, but client ORB implementations do not need to be aware of this distinction.<p>
</a><a name="4317">
<h2>	13.6.3	 Basic Location Algorithm</h2>
</a><a name="4063">
ORB clients can use the following algorithm to locate the server capable of handling the <code>invoke</code> RPC for a particular operation:<p>
</a><a name="4054">
	1.	 Pick a profile with <strong>TAG_MULTIPLE_COMPONENTS</strong> from the IOR. Make the <strong>MultipleComponentProfile</strong> structure encoded in the <strong>profile_data</strong> of this the <em>original</em> profile and the <em>current</em> profile. If no profiles with <strong>TAG_MULTIPLE_COMPONENTS</strong> are available, operations cannot be invoked using DCE-CIOP with this IOR.<p>
</a><a name="3911">
	2.	 Get a binding handle to try from the <em>current</em> profile. See <a href="dceciop.html#6817">"DCE-CIOP String Binding Component" on page &#32;13-16</a> and <a href="dceciop.html#4852">"DCE-CIOP Binding Name Component" on page &#32;13-17</a>. If no binding handles can be obtained, the server cannot be located using the <em>current</em> profile, so go to step 1.<p>
</a><a name="6968">
	3.	 Perform either a <code>locate</code> or <code>invoke</code> RPC using the <strong>TAG_OBJECT_KEY</strong> component and optional <strong>TAG_ENDPOINT_ID </strong>component from the <em>original</em> profile. <p>
</a><ul><a name="7267">
<li>If the RPC fails, go to step 2 to try a different binding handle.
</a><a name="7268">
<li>If the RPC returns <strong>INVOKE_TRY_AGAIN</strong> or <strong>LOCATE_TRY_AGAIN</strong>, try the same RPC again, possibly after a delay.
</a><a name="6969">
<li>If the RPC returns either <strong>INVOKE_LOCATION_FORWARD</strong> or <strong>LOCATE_LOCATION_FORWARD</strong>, make the new <strong>MultipleComponentProfile</strong> structure returned in the response message body the <em>current</em> profile and go to step 2.
</a><a name="7270">
<li>If the RPC returns <strong>LOCATE_UNKNOWN_OBJECT</strong>, the object no longer exists. 
</a><a name="7272">
<li>Otherwise, the server has been successfully located.
</a></ul><a name="4124">
Any <code>invoke</code> RPC might return <strong>INVOKE_LOCATION_FORWARD</strong>, in which case the client ORB should make the returned <strong>MultipleComponentProfile</strong> structure the <em>current</em> profile, and re-enter the location algorithm at step 2.<p>
</a><a name="4130">
If an RPC on a binding handle fails after it has been used successfully, the client ORB should start over at step 1.<p>
</a><a name="3928">
Note that the <strong>TAG_OBJECT_KEY</strong> and <strong>TAG_ENDPOINT_ID</strong> components for all <code>invoke</code> and <code>locate</code> RPCs are taken from the <em>original</em> profile. These components should not be included in the <strong>MultipleComponentProfile </strong>structure returned in <strong>INVOKE_LOCATION_FORWARD</strong> and <strong>LOCATE_LOCATION_FORWARD</strong> response messages. Only the <strong>TAG_DCE_STRING_BINDING</strong> and <strong>TAG_DCE_BINDING_NAME</strong> components, and possibly the optional <strong>TAG_LOCATION_POLICY</strong> and <strong>TAG_DCE_NO_PIPES</strong> components are taken from the <em>current</em> profile.<p>
</a><a name="6975">
<h2>	13.6.4	 Use of the Location Policy and the Endpoint ID</h2>
</a><a name="4024">
The algorithm above will allow a client ORB to successfully locate a server ORB, if possible, so that operations can be invoked using DCE-CIOP. But unnecessary <code>locate</code> RPCs may be performed, and <code>invoke</code> RPCs may be performed when <code>locate</code> RPCs would be more efficient. The optional location policy and endpoint ID components can be used by the client ORB, if present in the IOR profile, to optimize this algorithm.<p>
</a><a name="5618">
<h3>		 Current Location Policy</h3>
</a><a name="4104">
The client ORB can decide whether to perform a <code>locate</code> RPC or an <code>invoke</code> RPC in step 3 based on the location policy of the <em>current</em> IOR profile. If the <em>current</em> profile has a <strong>TAG_LOCATION_POLICY </strong>component with a value of <strong>LOCATE_NEVER</strong>, the client should perform an <code>invoke</code> RPC. Otherwise, it should perform a <code>locate</code> RPC.<p>
</a><a name="5602">
<h3>		 Original Location Policy</h3>
</a><a name="5630">
The client ORB can use the location policy of the <em>original</em> IOR profile as follows to determine whether it is necessary to perform the location algorithm for a particular invocation:<p>
</a><ul><a name="5638">
<li><em>LOCATE_OBJECT</em> or <em>LOCATE_NEVER</em> A binding handle previously used successfully to invoke an operation on an object can be reused for all operations on the same object. The client only needs to perform the location algorithm once per object.
</a><a name="5639">
<li><em>LOCATE_OPERATION</em> A binding handle previously used successfully to invoke an operation on an object can be reused for that same operation on the same object. The client only needs to perform the location algorithm once per operation.
</a><a name="5656">
<li><em>LOCATE_ALWAYS</em> Binding handles should not be reused. The client needs to perform the location algorithm once per invocation.
</a></ul><a name="5632">
<h3>		 Original Endpoint ID</h3>
</a><a name="5685">
If a component with <strong>TAG_ENDPOINT_ID</strong> is present in the <em>original</em> IOR profile, the client ORB can reuse a binding handle that was successfully used to perform an operation on another object with the same endpoint ID <code>component_data</code> value. The client only needs to perform the location algorithm once per endpoint.<p>
</a><a name="5686">
An endpoint ID component should never be combined in the same profile with a location policy of <strong>LOCATE_OPERATION</strong> or <strong>LOCATE_ALWAYS</strong>.<p>
</a><a name="1131">
<p>
</a><a name="1132">
<h1>	13.7	 OMG IDL for the DCE CIOP Module</h1>
</a><a name="1133">
This section shows the DCE_CIOP module.<p>
</a><a name="1309">
 module DCE_CIOP {<p>
</a><a name="1310">
<blockquote>	struct InvokeRequestHeader {</blockquote>
</a><a name="1311">
<blockquote>		boolean byte_order;</blockquote>
</a><a name="1312">
<blockquote>		IOP::ServiceContextList service_context;</blockquote>
</a><a name="1313">
<blockquote>		sequence &lt;octet&gt; object_key;</blockquote>
</a><a name="1314">
<blockquote>		string endpoint_id;</blockquote>
</a><a name="1315">
<blockquote>		string operation;</blockquote>
</a><a name="1316">
<blockquote>		CORBA::Principal principal;</blockquote>
</a><a name="1317">
<blockquote>		sequence &lt;string&gt; client_context;</blockquote>
</a><a name="1318">
<blockquote></blockquote>
</a><a name="1319">
<blockquote>		// in and inout parameters follow</blockquote>
</a><a name="1320">
<blockquote>	};</blockquote>
</a><a name="1338">
 module DCE_CIOP {<p>
</a><a name="1339">
<blockquote>	enum InvokeResponseStatus {</blockquote>
</a><a name="1340">
<blockquote>		INVOKE_NO_EXCEPTION,</blockquote>
</a><a name="1341">
<blockquote>		INVOKE_USER_EXCEPTION,</blockquote>
</a><a name="1342">
<blockquote>		INVOKE_SYSTEM_EXCEPTION,</blockquote>
</a><a name="1343">
<blockquote>		INVOKE_LOCATION_FORWARD,</blockquote>
</a><a name="1344">
<blockquote>		INVOKE_TRY_AGAIN</blockquote>
</a><a name="1345">
<blockquote>	};</blockquote>
</a><a name="1346">
<blockquote></blockquote>
</a><a name="1347">
<blockquote>	struct InvokeResponseHeader {</blockquote>
</a><a name="1348">
<blockquote>		boolean byte_order;</blockquote>
</a><a name="1349">
<blockquote>		IOP::ServiceContextList service_context;</blockquote>
</a><a name="1350">
<blockquote>		InvokeResponseStatus status;</blockquote>
</a><a name="1351">
<blockquote></blockquote>
</a><a name="1352">
<blockquote>		// if status = INVOKE_NO_EXCEPTION,</blockquote>
</a><a name="1353">
<blockquote>		// result then inouts and outs follow</blockquote>
</a><a name="1354">
<blockquote></blockquote>
</a><a name="1355">
<blockquote>		// if status = INVOKE_USER_EXCEPTION or</blockquote>
</a><a name="1356">
<blockquote>		// INVOKE_SYSTEM_EXCEPTION, an exception follows</blockquote>
</a><a name="1357">
<blockquote></blockquote>
</a><a name="1358">
<blockquote>		// if status = INVOKE_LOCATION_FORWARD, an </blockquote>
</a><a name="1359">
<blockquote>		// IOP::MultipleComponentsProfile follows</blockquote>
</a><a name="1360">
<blockquote>	};</blockquote>
</a><a name="1336">
<blockquote></blockquote>
</a><a name="1378">
 module DCE_CIOP {<p>
</a><a name="1379">
<blockquote>	struct LocateRequestHeader {</blockquote>
</a><a name="1380">
<blockquote>		boolean byte_order;</blockquote>
</a><a name="1381">
<blockquote>		sequence &lt;octet&gt; object_key;</blockquote>
</a><a name="1382">
<blockquote>		string endpoint_id;</blockquote>
</a><a name="1383">
<blockquote>		string operation;</blockquote>
</a><a name="1384">
<blockquote></blockquote>
</a><a name="1385">
<blockquote>		// no body follows</blockquote>
</a><a name="1386">
<blockquote>	};</blockquote>
</a><a name="1387">
 <p>
</a><a name="1439">
 module IOP {<p>
</a><a name="1544">
<blockquote>	const ComponentId TAG_OBJECT_KEY = 10;</blockquote>
</a><a name="1546">
<blockquote>	const ComponentId TAG_ENDPOINT_ID = 11;</blockquote>
</a><a name="1461">
<blockquote>	const ComponentId TAG_LOCATION_POLICY = 12;</blockquote>
</a><a name="1463">
<blockquote>	const octet LOCATE_NEVER = 0;</blockquote>
</a><a name="1464">
<blockquote>	const octet LOCATE_OBJECT = 1;</blockquote>
</a><a name="1465">
<blockquote>	const octet LOCATE_OPERATION = 2;</blockquote>
</a><a name="1466">
<blockquote>	const octet LOCATE_ALWAYS = 3;</blockquote>
</a><a name="1467">
<blockquote>};</blockquote>
</a><a name="1148">
 <p>
</a><a name="1069">
<h1>	13.8	 References for this Chapter</h1>
</a><a name="1072">
<em>AES/Distributed Computing RPC Volume</em>, P T R Prentice Hall, Englewood Cliffs, New Jersey, 1994<p>
</a><a name="1073">
<em>CAE Specification C309 X/Open DCE: Remote Procedure Call</em>, X/Open Company Limited, Reading, UK<p>
</a><a name="1540">
<p>
</a><a name="1070">
<p>
</a>
<hr><br>
 
<a href="cover.html">[Top]</a> <a href="giop.html">[Prev]</a> <a href="tagapp.html">[Next]</a> <a href="corb2pra.html">[Bottom]</a>
<hr><br>
 
<sup>1</sup><a name="5771">
 DCE <em>maybe</em> operation semantics cannot be used for CORBA <em>oneway</em> operations because they are idempotent as opposed to at-most-once.<p>
</a><sup>2</sup><a name="5819">
 The deferred synchronous DII API can be implemented on top of synchronous RPCs by using threads.<p>
</a><a name="5814">
 <p>
</a><sup>3</sup><a name="6048">
 A future DCE-CIOP revision may eliminate the array-based interface and require support of the pipe-based interface.<p>
</a><sup>4</sup><a name="7398">
 The use of authentication, or other DCE security services, has not yet been defined for DCE-CIOP.<p>
</a><sup>5</sup><a name="6838">
 An exponential back-off algorithm is recommended, but not required.<p>
</a><sup>6</sup><a name="6320">
 An exponential back-off algorithm is recommended, but not required.<p>
</a>

<address>
<a href="mailto:pubs@omg.org">pubs@omg.org</a>
</address>

<i>Copyright &#169; 1995, <a href="http://www.omg.org">Object Management Group.</a>  All rights
reserved.</i>

<!-- This file was created with Quadralay WebWorks Publisher 3.0.4 -->
<!-- -->
<!-- For more information on how this document, and how the rest of -->
<!-- this server was created, email pubs@omg.org -->
<!-- -->
<!-- Last updated: 06/10/96 08:49:18 -->

</body>
</html>
