<html><head><title></title></head>
<body bgcolor=#ffffff>
 
<a href="cover.html">[Top]</a> <a href="idlsyn.html">[Prev]</a> <a href="dynskel.html">[Next]</a> <a href="corb2pra.html">[Bottom]</a>
<hr><br>
 
<a name="172">
<h1> Dynamic Invocation Interface</h1>
</a><dl>
<p align=right clear=all>
<b><font size=7>
4 
</font></b>
</p>
<hr></dl>
<a name="757">
<h1>	4.1	 Overview</h1>
</a><a name="108">
The ORB <em>Dynamic Invocation </em>interface allows dynamic creation and invocation of requests to objects. A client using this interface to send a request to an object obtains the same semantics as a client using the operation stub generated from the type specification. <p>
</a><a name="188">
A request consists of an object reference, an operation, and a list of parameters. The ORB applies the implementation-hiding (encapsulation) principle to requests. <p>
</a><a name="193">
In the <em>Dynamic Invocation </em>interface, parameters in a request are supplied as elements of a list. Each element is an instance of a <strong>NamedValue</strong> (see <a href="dii2.html#203">"Common Data Structures" on page 4-1</a>). Each parameter is passed in its native data form.<p>
</a><a name="201">
Parameters supplied to a request may be subject to run-time type checking upon request invocation. Parameters must be supplied in the same order as the parameters defined for the operation in the Interface Repository.<p>
</a><a name="311">
All types defined in this chapter are part of the CORBA module. When referenced in OMG IDL, the type names must be prefixed by "CORBA::".<p>
</a><a name="203">
<h2>	4.1.1	 Common Data Structures</h2>
</a><a name="109">
The type<strong> </strong><strong>NamedValue</strong> is a well-known data type in OMG IDL. It can be used either as a parameter type directly or as a mechanism for describing arguments to a request. The type NVList is a pseudo-object useful for constructing parameter lists. The types are described in OMG IDL and C, respectively, as: <p>
</a><a name="212">
 typedef unsigned long Flags;<p>
</a><a name="213">
<blockquote></blockquote>
</a><a name="214">
<blockquote>struct NamedValue {</blockquote>
</a><a name="216">
<blockquote>	Identifier				name;			// argument name</blockquote>
</a><a name="217">
<blockquote>	any				argument;			// argument</blockquote>
</a><a name="219">
<blockquote>	long				len;			// length/count of argument value</blockquote>
</a><a name="220">
<blockquote>	Flags				arg_modes;			// argument mode flags</blockquote>
</a><a name="221">
 };<p>
</a><a name="195">
 CORBA_NamedValue * CORBA_NVList;																					/* C */<p>
</a><a name="157">
<p>
</a><a name="768">
<strong>NamedValue</strong> and <strong>Flags</strong> are defined in the CORBA module.<p>
</a><a name="766">
The <strong>NamedValue</strong> and NVList structures are used in the request operations to describe arguments and return values. They are also used in the context object routines to pass lists of property names and values. Despite the above declaration for NVList, the NVList structure is partially opaque and may only be created by using the ORB <strong>create_list</strong> operation.<p>
</a><a name="235">
A named value includes an argument name, argument value (as an <strong>any</strong>), length of the argument, and a set of argument mode flags. When named value structures are used to describe arguments to a request, the names are the argument identifiers specified in the OMG IDL definition for a specific operation.<p>
</a><a name="242">
As described in <a href="cmap.html#187">Section &#32;14.7, "Mapping for Basic Data Types," on page &#32;14-8</a>, an <strong>any</strong> consists of a <strong>TypeCode</strong> and a pointer to the data value. The TypeCode is a well-known opaque type that can encode a description of any type specifiable in OMG IDL. A full description of TypeCodes is <a href="cmap.html#187">Section &#32;14.7, "Mapping for Basic Data Types," on page &#32;14-8</a>.<p>
</a><a name="248">
For most datatypes, <strong>len</strong> is the actual number of bytes that the value occupies. For object references, <strong>len</strong> is 1. <a href="dii2.html#248">TABLE 11. on page 4-2</a> shows the length of data values for the C language binding. The behavior of a NamedValue is undefined if the <strong>len</strong> value is inconsistent with the TypeCode.  
<Table Border="3">
<caption><a name="111">
TABLE 11.  C Type Lengths <p>
</a></caption>
<tr><th><a name="114">
 Data type: X<p>
</a><th><a name="115">
 Length (X)<p>
</a>
<tr><td><a name="116">
 short<p>
</a><td><a name="117">
 sizeof (CORBA_short)<p>
</a>
<tr><td><a name="125">
 unsigned short<p>
</a><td><a name="126">
 sizeof (CORBA_unsigned_short)<p>
</a>
<tr><td><a name="127">
 long<p>
</a><td><a name="128">
 sizeof (CORBA_long) <p>
</a>
<tr><td><a name="129">
 unsigned long<p>
</a><td><a name="130">
 sizeof (CORBA_unsigned_long)<p>
</a>
<tr><td><a name="131">
 float<p>
</a><td><a name="133">
 sizeof (CORBA_float)<p>
</a>
<tr><td><a name="134">
 double<p>
</a><td><a name="135">
 sizeof (CORBA_double)<p>
</a>
<tr><td><a name="136">
 char<p>
</a><td><a name="137">
 sizeof (CORBA_char)<p>
</a>
<tr><td><a name="138">
 boolean<p>
</a><td><a name="139">
 sizeof (char)<p>
</a>
<tr><td><a name="140">
 octet<p>
</a><td><a name="141">
 sizeof (CORBA_octet)<p>
</a>
<tr><td><a name="142">
 string<p>
</a><td><a name="143">
 strlen (string) /* does NOT include `\0' byte! */<p>
</a>
<tr><td><a name="144">
 enum E {};<p>
</a><td><a name="146">
 sizeof (CORBA_enum)<p>
</a>
<tr><td><a name="147">
 union U { } ;<p>
</a><td><a name="148">
 sizeof (U)<p>
</a>
<tr><td><a name="149">
 struct S { };<p>
</a><td><a name="150">
 sizeof (S)<p>
</a>
<tr><td><a name="151">
 Object<p>
</a><td><a name="152">
 1<p>
</a>
<tr><td><a name="153">
 array N of type T1<p>
</a><td><a name="154">
 Length (T1) * N<p>
</a>
<tr><td><a name="155">
 sequence V of type T2<p>
</a><td><a name="156">
 Length (T2) * V    /* V is the actual, dynamic, number of elements */<p>
</a>

</Table>

<Table>
<tr><td>
</Table>
 <p>
</a><a name="107">
The <strong>arg_modes</strong> field is defined as a bitmask (long) and may contain the following flag values:<p>
</a><a name="304">
 <strong>CORBA::ARG_IN </strong>	the associated value is an input only argument<p>
</a><a name="306">
 <strong>CORBA::ARG_OUT </strong>	the associated value is an output only argument <p>
</a><a name="310">
 <strong>CORBA::ARG_INOUT </strong>the associated value is an in/out argument <p>
</a><a name="315">
These flag values identify the parameter passing mode for arguments. Additional flag values have specific meanings for request and list routines, and are documented with their associated routines.<p>
</a><a name="196">
All other bits are reserved. The high-order 16 bits are reserved for implementation-specific flags. <p>
</a><a name="317">
<h2>	4.1.2	 Memory Usage</h2>
</a><a name="321">
The values for output argument data types that are unbounded strings or unbounded sequences are returned as pointers to dynamically allocated memory are shown in <a href="cmap.html#1864">Table 21 </a>. In order to facilitate the freeing of all "out-arg memory", the request routines provide a mechanism for grouping, or keeping track of, this memory. If so specified, out-arg memory is associated with the argument list passed to the create request routine. When the list is deleted the associated out-arg memory will automatically be freed.<p>
</a><a name="944">
If the programmer chooses not to associate out-arg memory with an argument list, the programmer is responsible for freeing each out parameter using CORBA_free(), which is discussed in <a href="cmap.html#248">Section &#32;14.17, "Argument Passing Considerations," on page &#32;14-16</a><p>
</a><a name="945">
<h2>	4.1.3	 Return Status and Exceptions</h2>
</a><a name="158">
In the <em>Dynamic Invocation</em> interface, many routines return a <strong>Status</strong> result, which is intended as a status code. <strong>Status</strong> is defined in the CORBA modules as:<p>
</a><a name="782">
<p>
</a><a name="280">
 typedef unsigned long Status;<p>
</a><a name="784">
<p>
</a><a name="785">
<p>
</a><a name="279">
Conforming CORBA implementations are <em>not</em> required to return this status code; instead, the definition <p>
</a><a name="783">
<p>
</a><a name="159">
 typedef void Status;<p>
</a><a name="230">
is a conforming implementation (in which case no status code result is returned, except in the usual <strong>inout Environment</strong> argument). Implementations are required to specify which <strong>Status</strong> behavior is supported. <p>
</a><a name="314">
<h1>	4.2	 Request Operations</h1>
</a><a name="323">
The request operations are defined in terms of the Request pseudo-object. The Request routines use the NVList definition defined in the preceding section.<p>
</a><a name="324">
 		module CORBA {<p>
</a><a name="313">
 			interface Request {																					// PIDL<p>
</a><a name="325">
 <p>
</a><a name="202">
 				Status add_arg (					<p>
</a><a name="204">
 					 in Identifier			 		name,				// argument name<p>
</a><a name="205">
 				 	in TypeCode 					arg_type,				// argument datatype<p>
</a><a name="206">
 				 	in void	 				* value,				// argument value to be added<p>
</a><a name="207">
 				 	in long	 				len,				// length/count of argument value<p>
</a><a name="209">
 				 	in Flags	 				arg_flags				// argument flags<p>
</a><a name="210">
 				);<p>
</a><a name="211">
 				Status invoke (								<p>
</a><a name="215">
 					 in Flags					invoke_flags				// invocation flags<p>
</a><a name="234">
 				);<p>
</a><a name="218">
 				Stat	us delete ();<p>
</a><a name="222">
 				Status send (<p>
</a><a name="226">
 					in Flags					invoke_flags			// invocation flags <p>
</a><a name="236">
 				);<p>
</a><a name="232">
 				Status get_response (						<p>
</a><a name="233">
 					in Flags					response_flags				// response flags<p>
</a><a name="326">
 				);<p>
</a><a name="319">
 			};<p>
</a><a name="327">
 		};<p>
</a><a name="328">
<h2>	4.2.1	 create_request</h2>
</a><a name="110">
Because it creates a pseudo-object, this operation is defined in the Object interface (see <a href="orbif2.html#109">"Object Reference Operations" on page &#32;7-2</a> for the complete interface definition). The <strong>create_request</strong> operation is performed on the Object which is to be invoked. <p>
</a><a name="329">
 		Status create_request (																					// PIDL<p>
</a><a name="330">
 			in Context					ctx,					// context object for operation<p>
</a><a name="331">
 			in Identifier					operation,					// intended operation on object<p>
</a><a name="332">
 			in NVList					arg_list,					// args to operation<p>
</a><a name="333">
 			inout NamedValue					result,					// operation result<p>
</a><a name="334">
 			out Request					request,					// newly created request<p>
</a><a name="335">
 			in Flags					req_flags					// request flags<p>
</a><a name="223">
 		);<p>
</a><a name="336">
This operation creates an ORB request. The actual invocation occurs by calling <strong>invoke</strong> or by using the <strong>send</strong> / <strong>get_response </strong>calls. <p>
</a><a name="337">
The operation name specified on <strong>create_request</strong> is the same operation identifier that is specified in the OMG IDL definition for this operation. In the case of attributes, it is the name as constructed following the rules specified in the ServerRequest interface as described in the DSI in <a href="dynskel.html#654"> Section 5.2</a><p>
</a><a name="338">
The <strong>arg_list</strong>, if specified, contains a list of arguments (input, output, and/or input/output) which become associated with the request. If <strong>arg_list</strong> is omitted (specified as NULL), the arguments (if any) must be specified using the <strong>add_arg</strong> call below.<p>
</a><a name="339">
Arguments may be associated with a request by passing in an argument list or by using repetitive calls to <strong>add_arg</strong>. One mechanism or the other may be used for supplying arguments to a given request; a mixture of the two approaches is not supported.<p>
</a><a name="340">
If specified, the <strong>arg_list</strong> becomes associated with the request; until the <strong>invoke</strong> call has completed (or the request has been deleted), the ORB assumes that <strong>arg_list</strong> (and any values it points to) remains unchanged.<p>
</a><a name="341">
When specifying an argument list, the <strong>value</strong> and <strong>len</strong> for each argument must be specified. An argument's datatype, name, and usage flags (i.e., in, out, inout) may also be specified; if so indicated, arguments are validated for datatype, order, name, and usage correctness against the set of arguments expected for the indicated operation.<p>
</a><a name="342">
An implementation of the request services may relax the order constraint (and allow arguments to be specified out of order) by doing ordering based upon argument name. <p>
</a><a name="343">
The context properties associated with the operation are passed to the object implementation. The object implementation may not modify the context information passed to it. <p>
</a><a name="344">
The operation result is placed in the <strong>result</strong> argument after the invocation completes.<p>
</a><a name="345">
The <strong>req_flags</strong> argument is defined as a bitmask (<strong>long</strong>) that may contain the following flag values:<p>
</a><a name="346">
 CORBA::OUT_LIST_MEMORY											Indicates that any out-arg memory is associated with	 the argument list (NVList).<p>
</a><a name="347">
Setting the OUT_LIST_MEMORY flag controls the memory allocation mechanism for out-arg memory (output arguments, for which memory is dynamically allocated). If OUT_LIST_MEMORY is specified, an argument list must also have been specified on the <strong>create_request</strong> call. When output arguments of this type are allocated, they are associated with the list structure. When the list structure is freed (see below), any associated out-arg memory is also freed.<p>
</a><a name="348">
If OUT_LIST_MEMORY is <em>not</em> specified, then each piece of out-arg memory remains available until the programmer explicitly frees it with procedures provided by the language mappings (See <a href="cmap.html#248">Section &#32;14.17, "Argument Passing Considerations," on page &#32;14-16</a>; <a href="pluspo.html#153">Section &#32;17.6, "NVList," on page &#32;17-5</a>; and <a href="smallma.html#7500">Section &#32;20.19, "Argument Passing Considerations," on page &#32;20-11</a>.)<p>
</a><a name="350">
<h2>	4.2.2	 add_arg</h2>
</a><a name="352">
 		Status add_arg (																			// PIDL<p>
</a><a name="353">
 			 in Identifier		 				name,				// argument name<p>
</a><a name="354">
 			 in TypeCode 						arg_type,				// argument datatype<p>
</a><a name="355">
 			 in void	 					* value,				// argument value to be added<p>
</a><a name="356">
 			 in long	 					len,				// length/count of argument value<p>
</a><a name="357">
 			 in Flags	 					arg_flags				// argument flags<p>
</a><a name="224">
 		);<p>
</a><a name="358">
<strong>add_arg</strong> incrementally adds arguments to the request. <p>
</a><a name="359">
For each argument, minimally its <strong>value</strong> and <strong>len</strong> must be specified. An argument's datatype, name, and usage flags (i.e in, out, inout) may also be specified. If so indicated, arguments are validated for datatype, order, name, and usage correctness against the set of arguments expected for the indicated operation.<p>
</a><a name="360">
An implementation of the request services may relax the order constraint (and allow arguments to be specified out of order) by doing ordering based upon argument name.<p>
</a><a name="361">
The arguments added to the request become associated with the request and are assumed to be unchanged until the invoke has completed (or the request has been deleted).<p>
</a><a name="362">
Arguments may be associated with a request by specifying them on the <strong>create_request</strong> call or by adding them via calls to <strong>add_arg</strong>. Using both methods for specifying arguments, for the same request, is not currently supported.<p>
</a><a name="363">
In addition to the argument modes defined in <a href="dii2.html#203"> Section 4.1.1</a>, <strong>arg_flags</strong> may also take the flag value:IN_COPY_VALUE. The argument passing flags defined in <a href="dii2.html#203"> Section 4.1.1</a> may be used here to indicate the intended parameter passing mode of an argument.<p>
</a><a name="364">
If the IN_COPY_VALUE flag is set, a copy of the argument value is made and used instead. This flag is ignored for inout and out arguments.<p>
</a><a name="365">
<h2>	4.2.3	 invoke</h2>
</a><a name="366">
 		Status invoke (																					// PIDL<p>
</a><a name="367">
 	 		in Flags					invoke_flags					// invocation flags<p>
</a><a name="225">
 );<p>
</a><a name="368">
This operation calls the ORB, which performs method resolution and invokes an appropriate method. If the method returns successfully, its result is placed in the <strong>result</strong> argument specified on cr<strong>eate_request</strong>.<p>
</a><a name="369">
<h2>	4.2.4	 delete</h2>
</a><a name="1451">
 		Status delete ( );																					// PIDL<p>
</a><a name="371">
This operation deletes the request. Any memory associated with the request (i.e. by using the <strong>IN_COPY_VALUE</strong> flag) is also freed.<p>
</a><a name="372">
<h1>	4.3	 Deferred Synchronous Operations</h1>
</a><a name="373">
<h2>	4.3.1	 send</h2>
</a><a name="374">
 		Status send (																		// PIDL<p>
</a><a name="375">
 			in Flags					invoke_flags 						// invocation flags <p>
</a><a name="237">
 );<p>
</a><a name="278">
<strong>send</strong> initiates an operation according to the information in the Request. Unlike <strong>invoke</strong>, <strong>send</strong> returns control to the caller without waiting for the operation to finish. To determine when the operation is done, the caller must use the <strong>get_response</strong> or get_next_response operations described below. The out parameters and return value must not be used until the operation is done. <p>
</a><a name="281">
Although it is possible for some standard exceptions to be raised by the <strong>send</strong> operation, there is no guarantee that all possible errors will be detected. For example, if the object reference is not valid, <strong>send</strong> might detect it and raise an exception, or might return before the object reference is validated, in which case the exception will be raised when <strong>get_response</strong> is called. <p>
</a><a name="282">
If the operation is defined to be <strong>oneway</strong> or if INV_NO_RESPONSE is specified, then <strong>get_response</strong> does not need to be called. In such cases, some errors might go unreported, since if they are not detected before <strong>send</strong> returns there is no way to inform the caller of the error. <p>
</a><a name="376">
The following invocation flags are currently defined for <strong>send</strong>:<p>
</a><a name="377">
 CORBA::INV_NO_RESPONSE 	 Indicates that the invoker does not intend to wait for a response, nor does it expect any of the output arguments (in/out and out) to be updated. This option may be specified even if the operation has not been defined to be <strong>oneway</strong>.<p>
</a><a name="283">
<h2>	4.3.2	 send_multiple_requests</h2>
</a><a name="1377">
 /* C */<p>
</a><a name="1379">
 CORBA_Status CORBA_send_multiple_requests (																					<p>
</a><a name="1380">
 		CORBA_Request						reqs[],					/* array of Requests */<p>
</a><a name="288">
 		CORBA_Environment						*env,<p>
</a><a name="289">
 		CORBA_long						count,					/* number of Requests */<p>
</a><a name="290">
 		CORBA_Flags						invoke_flags<p>
</a><a name="291">
 );<p>
</a><a name="1323">
 <p>
</a><a name="1375">
 // C++<p>
</a><a name="1352">
 <br>class ORB<br>{<br>					public:<br>						typedef sequence&lt;Request_ptr&gt; RequestSeq;<p>
</a><a name="1344">
 ...<p>
</a><a name="1354">
 						Status send_multiple_requests_oneway(const RequestSeq &amp;);<br>						Status send_multiple_requests_deferred(const RequestSeq &amp;);<p>
</a><a name="1405">
 				};<br><p>
</a><a name="1408">
The Smalltalk mapping of send multiple requests is as follows:<p>
</a><a name="1409">
<p>
</a><a name="1406">
 sendMultipleRequests: aCollection<p>
</a><a name="1407">
 sendMultipleRequestOneway: aCollection<p>
</a><a name="1410">
 <p>
</a><a name="292">
send_multiple_requests initiates more than one request in parallel. Like <strong>send</strong>, send_multiple_requests returns to the caller without waiting for the operations to finish. To determine when each operation is done, the caller must use the <strong>get_response</strong> or get_next_response operations described below. <p>
</a><a name="293">
The degree of parallelism in the initiation and execution of the requests is system dependent. There are no guarantees about the order in which the requests are initiated. If INV_TERM_ON_ERR is specified, and the ORB detects an error initiating one of the requests, it will not initiate any further requests from this list. If INV_NO_RESPONSE is specified, it applies to all of the requests in the list. <p>
</a><a name="294">
The following invocation flags are currently defined for <strong>s</strong>end_multiple_requests:<p>
</a><a name="295">
 CORBA::INV_NO_RESPONSE indicates that at the invoker does not intend to wait for a response, nor does it expect any of the output arguments (inout and out) to be updated. This option may be specified even if the operation has not been defined to be <strong>oneway</strong>.<p>
</a><a name="286">
 CORBA::INV_TERM_ON_ERR means that if one of the requests causes an error, the remaining requests are not sent. <p>
</a><a name="1306">
 <p>
</a><a name="227">
<h2>	4.3.3	 get_response</h2>
</a><a name="228">
 		Status get_response (																// PIDL<p>
</a><a name="229">
 	 		in Flags					response_flags						// response flags<p>
</a><a name="238">
 <p>
</a><a name="231">
<strong>get_response</strong> determines whether a request has completed. If <strong>get_response</strong> indicates that the operation is done, the out parameters and return values defined in the Request are valid, and they may be treated as if the Request <strong>invoke</strong> operation had been used to perform the request. <p>
</a><a name="285">
If the RESP_NO_WAIT flag is set, <strong>get_response</strong> returns immediately even if the request is still in progress. Otherwise, <strong>get_response</strong> waits until the request is done before returning. <p>
</a><a name="378">
The following response flags are defined for <strong>get_response</strong>:<p>
</a><a name="379">
 CORBA::RESP_NO_WAIT indicates that the caller does not want to wait for a response.<p>
</a><a name="296">
<h2>	4.3.4	 get_next_response</h2>
</a><a name="1419">
 		/* C */<p>
</a><a name="297">
 		CORBA_Status CORBA_get_next_response (												<p>
</a><a name="298">
 					CORBA_Environment					*env,<p>
</a><a name="308">
 					CORBA_Flags					response_flags,<p>
</a><a name="299">
 					CORBA_Request					*req<p>
</a><a name="300">
 		);<p>
</a><a name="1434">
<p>
</a><a name="1438">
 		// C++<p>
</a><a name="1445">
 class ORB<p>
</a><a name="1446">
 {<br>					public:<br>						Boolean poll_next_response();<br>						Status get_next_response(RequestSeq*&amp;);<p>
</a><a name="1447">
 };<p>
</a><a name="1439">
 <p>
</a><a name="1440">
The Smalltalk mapping of get_next_response is as follows:<p>
</a><a name="1448">
<p>
</a><a name="1443">
 				pollNextResponse<p>
</a><a name="1444">
 				getNextResponse<p>
</a><a name="1413">
<p>
</a><a name="301">
get_next_response returns the next request that completes. Despite the name, there is no guaranteed ordering among the completed requests, so the order in which they are returned from successive get_next_response calls is not necessarily related to the order in which they finished. <p>
</a><a name="302">
If the RESP_NO_WAIT flag is set, and there are no completed requests pending, then get_next_response returns immediately. Otherwise, get_next_response waits until some request finishes. <p>
</a><a name="305">
The following response flags are defined for get_next_response:<p>
</a><a name="307">
 CORBA::RESP_NO_WAIT	 Indicates that the caller does not want to wait for a response.<p>
</a><a name="380">
<h1>	4.4	 List Operations</h1>
</a><a name="381">
The list operations use the named-value structure defined above. <p>
</a><a name="178">
The list operations that create <strong>NVList</strong> objects are defined in the ORB interface described in Chapter <a href="orbif2.html#600">7</a>, but are described in this section. The <strong>NVList</strong> interface is shown below. <p>
</a><a name="382">
 		interface NVList {																					// PIDL<p>
</a><a name="160">
 			Status add_item (																	<p>
</a><a name="161">
 				 in Identifier				item_name,						// name of item<p>
</a><a name="162">
 				 in TypeCode				item_type,						// item datatype<p>
</a><a name="163">
 				 in void				*value,						// item value<p>
</a><a name="164">
 				 in long				value_len,						// length of item value<p>
</a><a name="165">
 				 in Flags	 			item_flags						// item flags<p>
</a><a name="168">
 			);<p>
</a><a name="383">
 			Status free ( );<p>
</a><a name="167">
 			Status free_memory ( );							<p>
</a><a name="169">
 			Status get_count (				<p>
</a><a name="170">
 				out long				 count						// number of entries in the list<p>
</a><a name="171">
 			);<p>
</a><a name="316">
 		};<p>
</a><a name="166">
Interface NVList is defined in the CORBA module. <p>
</a><a name="384">
 <p>
</a><a name="385">
<h2>	4.4.1	 create_list</h2>
</a><a name="174">
This operation, which creates a pseudo-object, is defined in the ORB interface and excerpted below. <p>
</a><a name="386">
 		Status create_list (																					//PIDL<p>
</a><a name="387">
 			in long					count,				// number of items to allocate for list <p>
</a><a name="388">
 			out NVList					new_list				// newly created list <p>
</a><a name="173">
 );<p>
</a><a name="192">
This operation allocates a list of the specified size, and clears it for initial use. List items may be added to the list using the <strong>add_item</strong> routine. Alternatively, they may be added by indexing directly into the list structure. A mixture of the two approaches for initializing a list, however, is not supported.<p>
</a><a name="389">
An <strong>NVList</strong> is a partially opaque structure. It may only be allocated via a call to <strong>create_list</strong>.<p>
</a><a name="390">
<h2>	4.4.2	 add_item</h2>
</a><a name="391">
 		Status add_item (																					// PIDL<p>
</a><a name="392">
 			 in Identifier					item_name,						// name of item<p>
</a><a name="393">
 			 in TypeCode					item_type,						// item datatype<p>
</a><a name="394">
 			 in void					*value,						// item value<p>
</a><a name="395">
 			 in long					value_len,						// length of item value<p>
</a><a name="396">
 			 in Flags	 				item_flags						// item flags<p>
</a><a name="309">
 );<p>
</a><a name="397">
This operation adds a new item to the indicated list. The item is added after the previously added item.<p>
</a><a name="398">
In addition to the argument modes defined in <a href="dii2.html#203"> Section 4.1.1</a>, <strong>item_flags</strong> may also take the following flag values: IN_COPY_VALUE, DEPENDENT_LIST. The argument passing flags defined in <a href="dii2.html#203"> Section 4.1.1</a> may be used here to indicate the intended parameter passing mode of an argument.<p>
</a><a name="399">
If the IN_COPY_VALUE flag is set, a copy of the argument value is made and used instead. <p>
</a><a name="400">
If a list structure is added as an item (e.g. a "sublist") the DEPENDENT_LIST flag may be specified to indicate that the sublist should be freed when the parent list is freed.<p>
</a><a name="401">
<h2>	4.4.3	 free</h2>
</a><a name="402">
 		Status free ( );																						// PIDL<p>
</a><a name="403">
This operation frees the list structure and any associated memory (an implicit call to the list <strong>f</strong><strong>ree_memory</strong> operation is done). <p>
</a><a name="404">
<h2>	4.4.4	 free_memory</h2>
</a><a name="405">
 		Status free_memory ( );																								// PIDL<p>
</a><a name="406">
This operation frees any dynamically allocated out-arg memory associated with the list. The list structure itself is not freed.<p>
</a><a name="407">
<h2>	4.4.5	 get_count</h2>
</a><a name="408">
 		Status get_count (																						// PIDL<p>
</a><a name="409">
 			out long						 count				// number of entries in the list<p>
</a><a name="239">
 );<p>
</a><a name="410">
This operation returns the total number of items allocated for this list.<p>
</a><a name="179">
<h2>	4.4.6	 create_operation_list</h2>
</a><a name="180">
This operation, which creates a pseudo-object, is defined in the ORB interface.<p>
</a><a name="181">
 		Status create_operation_list (																						// PIDL<p>
</a><a name="182">
 			in OperationDef						oper,					// operation<p>
</a><a name="185">
 			out NVList						new_list					// argument definitions<p>
</a><a name="186">
 ); <p>
</a><a name="190">
This operation returns an NVList initialized with the argument descriptions for a given operation. The information is returned in a form that may be used in <em>Dynamic Invocation</em> requests. The arguments are returned in the same order as they were defined for the operation. <p>
</a><a name="191">
The list <strong>free</strong> operation is used to free the returned information. <p>
</a><a name="411">
<h1>	4.5	 Context Objects</h1>
</a><a name="412">
A context object contains a list of properties, each consisting of a name and a string value associated with that name. By convention, context properties represent information about the client, environment, or circumstances of a request that are inconvenient to pass as parameters.<p>
</a><a name="413">
Context properties can represent a portion of a client's or application's environment that is meant be propagated to (and made implicitly part of) a server's environment (for example, a window identifier, or user preference information). Once a server has been invoked (i.e., after the properties are propagated), the server may query its context object for these properties.<p>
</a><a name="414">
In addition, the context associated with a particular operation is passed as a distinguished parameter, allowing particular ORBs to take advantage of context properties, for example, using the values of certain properties to influence method binding behavior, server location, or activation policy. <p>
</a><a name="415">
An operation definition may contain a clause specifying those context properties that may be of interest to a particular operation. These context properties comprise the minimum set of properties that will be propagated to the server's environment (although a specified property may have no value associated with it). The ORB may choose to pass more properties than those specified in the operation declaration. <p>
</a><a name="416">
When a context clause is present on an operation declaration, an additional argument is added to the stub and skeleton interfaces. When an operation invocation occurs via either the stub or <em>Dynamic Invocation</em> interface, the ORB causes the properties which were named in the operation definition in IDL and which are present in the client's context object, to be provided in the context object parameter to the invoked method.<p>
</a><a name="417">
Context property names (which are strings) typically have the form of an OMG IDL identifier, or a series of OMG IDL identifiers separated by periods. A context property name pattern is either a property name, or a property name followed by a single "*". Property name patterns are used in the <strong>context</strong> clause of an operation definition, and in the <strong>get_values</strong> operation (described below). <p>
</a><a name="240">
A property name pattern without a trailing "*" is said to match only itself. A property name pattern of the form "&lt;name&gt;*" matches any property name that starts with &lt;name&gt; and continues with zero or more additional characters. <p>
</a><a name="241">
Context objects may be created and deleted, and individual context properties may be set and retrieved. There will often be context objects associated with particular processes, users, or other things depending on the operating system, and there may be conventions for having them supplied to calls by default.<p>
</a><a name="243">
It may be possible to keep context information in persistent implementations of context objects, while other implementations may be transient. The creation and modification of persistent context objects, however, is not addressed in this specification.<p>
</a><a name="208">
Context objects may be "chained" together to achieve a particular defaulting behavior. <p>
</a><a name="418">
Properties defined in a particular context object effectively override those properties in the next higher level. This searching behavior may be restricted by specifying the appropriate scope and the "restrict scope" option on the Context <strong>get_values</strong> call.<p>
</a><a name="419">
Context objects may be named for purposes of specifying a starting search scope.<p>
</a><a name="420">
<h1>	4.6	 Context Object Operations</h1>
</a><a name="421">
When performing operations on a context object, properties are represented as named value lists. Each property value corresponds to a named value item in the list.<p>
</a><a name="422">
A property name is represented by a string of characters (see <a href="idlsyn.html#325">"Identifiers" on page 3-5</a> for the valid set of characters that are allowed). Property names are stored preserving their case, however names cannot differ simply by their case.<p>
</a><a name="246">
The Context interface is shown below. <p>
</a><a name="244">
 		module CORBA {<p>
</a><a name="318">
 			interface Context {																				// PIDL<p>
</a><a name="250">
 				Status set_one_value (<p>
</a><a name="252">
 					 in Identifier 					prop_name,					// property name to add<p>
</a><a name="253">
 					 in string	 				value					// property value to add<p>
</a><a name="247">
 				);<p>
</a><a name="255">
 				Status set_values (<p>
</a><a name="256">
 					 in NVList					 values					// property values to be changed<p>
</a><a name="259">
 				);<p>
</a><a name="1452">
 				Status get_values (<p>
</a><a name="260">
 					 in Identifier 					start_scope,					// search scope<p>
</a><a name="261">
 		 			in Flags	 				op_flags,					// operation flags<p>
</a><a name="262">
 		 			in Identifier 					prop_name,					// name of property(s) to retrieve<p>
</a><a name="263">
 		 			out NVList	 				values					// requested property(s)<p>
</a><a name="264">
 				);<p>
</a><a name="266">
 				Status delete_values (<p>
</a><a name="267">
 					 in Identifier					prop_name					// name of property(s) to delete<p>
</a><a name="268">
 				);<p>
</a><a name="270">
 				Status create_child (<p>
</a><a name="271">
 					 in Identifier					ctx_name,					// name of context object<p>
</a><a name="272">
 		 			out Context 					child_ctx					// newly created context object<p>
</a><a name="273">
 				);<p>
</a><a name="275">
 				Status delete (<p>
</a><a name="276">
 					 in Flags	 				del_flags					// flags controlling deletion<p>
</a><a name="277">
 				);<p>
</a><a name="320">
 			};<p>
</a><a name="245">
 		};<p>
</a><a name="423">
<h2>	4.6.1	 get_default_context</h2>
</a><a name="249">
This operation, which creates a Context pseudo-object, is defined in the ORB interface (see <a href="orbif2.html#101"> Section 7.1</a> for the complete ORB definition). <p>
</a><a name="424">
 		Status get_default_context (																						// PIDL<p>
</a><a name="425">
 			out Context						ctx					// context object<p>
</a><a name="426">
 );<p>
</a><a name="427">
This operation returns a reference to the default process context object. The default context object may be chained into other context objects. For example, an ORB implementation may chain the default context object into its User, Group, and System context objects.<p>
</a><a name="428">
<h2>	4.6.2	 set_one_value</h2>
</a><a name="429">
 		Status set_one_value (																						// PIDL<p>
</a><a name="430">
 			 in Identifier 						prop_name,					// property name to add<p>
</a><a name="431">
 			 in string	 					value					// property value to add<p>
</a><a name="303">
 );<p>
</a><a name="432">
This operation sets a single context object property.<p>
</a><a name="433">
Currently, only string values are supported by the context object.<p>
</a><a name="434">
<h2>	4.6.3	 set_values</h2>
</a><a name="435">
 		Status set_values (																						// PIDL<p>
</a><a name="436">
 			 in NVList					 values					// property values to be changed<p>
</a><a name="254">
 );<p>
</a><a name="437">
This operation sets one or more property values in the context object. In the NVList, the flags field must be set to zero, and the TypeCode field associated with an attribute value must be TC_string. <p>
</a><a name="438">
Currently, only string values are supported by the context object.<p>
</a><a name="439">
<h2>	4.6.4	 get_values</h2>
</a><a name="440">
 		Status get_values (																						// PIDL<p>
</a><a name="441">
 			 in Identifier		 			start_scope,					// search scope<p>
</a><a name="442">
 			 in Flags	 				op_flags,					// operation flags<p>
</a><a name="443">
 			 in Identifier 					prop_name,					// name of property(s) to retrieve<p>
</a><a name="444">
 			 out NVList	 				values					// requested property(s)<p>
</a><a name="258">
 );<p>
</a><a name="445">
This operation retrieves the specified context property value(s). If <strong>prop_name</strong> has a trailing wildcard character ("*"), then all matching properties and their values are returned. The values returned may be freed by a call to the list <strong>free</strong> operation.<p>
</a><a name="446">
If no properties are found an error is returned, and no property list is returned.<p>
</a><a name="447">
Scope indicates the context object level at which to initiate the search for the specified properties (e.g. "_USER", "_SYSTEM"). If the property is not found at the indicated level, the search continues up the context object tree until a match is found or all context objects in the chain have been exhausted. <p>
</a><a name="448">
Valid scope names are implementation-specific.<p>
</a><a name="449">
If scope name is omitted, the search begins with the specified context object. If the specified scope name is not found, an exception is returned.<p>
</a><a name="450">
The following operation flags may be specified:<p>
</a><a name="451">
 <strong>CORBA::CTX_RESTRICT_SCOPE</strong>	 Searching is limited to the specified search scope or context object.<p>
</a><a name="452">
<h2>	4.6.5	 delete_values</h2>
</a><a name="453">
 		Status delete_values (																					// PIDL<p>
</a><a name="454">
 			 in Identifier					prop_name					// name of property(s) to delete<p>
</a><a name="265">
 );<p>
</a><a name="455">
This operation deletes the specified property value(s) values from the context object. If <strong>prop_name</strong> has a trailing wildcard character ("*"), then all property names that match will be deleted.<p>
</a><a name="456">
Search scope is always limited to the specified context object.<p>
</a><a name="457">
If no matching property is found, an exception is returned. <p>
</a><a name="458">
<h2>	4.6.6	 create_child</h2>
</a><a name="459">
 		Status create_child (																					// PIDL<p>
</a><a name="460">
 			 in Identifier					ctx_name,				// name of context object<p>
</a><a name="461">
 			 out Context 					child_ctx				// newly created context object<p>
</a><a name="269">
 		);<p>
</a><a name="462">
This operation creates a child context object.<p>
</a><a name="463">
The returned context object is chained into its parent context. That is, searches on the child context object will look in the parent context (and so on, up the context tree), if necessary, for matching property names. <p>
</a><a name="464">
Context object names follow the rules for OMG IDL identifiers (see <a href="idlsyn.html#325">"Identifiers" on page 3-5</a>). <p>
</a><a name="465">
<h2>	4.6.7	 delete</h2>
</a><a name="466">
 		Status delete (																					// PIDL<p>
</a><a name="467">
 			 in Flags	 				del_flags						// flags controlling deletion<p>
</a><a name="274">
 		);<p>
</a><a name="468">
This operation deletes the indicated context object.<p>
</a><a name="469">
The following option flags may be specified:<p>
</a><a name="470">
 CORBA::CTX_DELETE_DESCENDENTS	Deletes the indicated context object and all of its descendent context objects, as well. <p>
</a><a name="471">
An exception is returned if there are one or more child context objects and the CTX_DELETE_DESCENDENTS flag was not set.<p>
</a><a name="251">
<h1>	4.7	 Native Data Manipulation</h1>
</a><a name="351">
A future version of this specification will define routines to facilitate the conversion of data between the list layout found in <strong>NVList</strong> structures and the compiler native layout. <p>
</a>
<hr><br>
 
<a href="cover.html">[Top]</a> <a href="idlsyn.html">[Prev]</a> <a href="dynskel.html">[Next]</a> <a href="corb2pra.html">[Bottom]</a>
<hr><br>
 


<address>
<a href="mailto:pubs@omg.org">pubs@omg.org</a>
</address>

<i>Copyright &#169; 1995, <a href="http://www.omg.org">Object Management Group.</a>   All rights
reserved.</i>

<!-- This file was created with Quadralay WebWorks Publisher 3.0.4 -->
<!-- -->
<!-- For more information on how this document, and how the rest of -->
<!-- this server was created, email pubs@omg.org -->
<!-- -->
<!-- Last updated: 06/10/96 08:47:57 -->

</body>
</html>
