<html><head><title></title></head>
<body bgcolor=#ffffff>
 
<a href="cover.html">[Top]</a> <a href="bridge.html">[Prev]</a> <a href="dceciop.html">[Next]</a> <a href="corb2pra.html">[Bottom]</a>
<hr><br>
 
<a name="198">
<h1> General Inter-ORB Protocol</h1>
</a><dl>
<p align=right clear=all>
<b><font size=7>
12 
</font></b>
</p>
<hr><a name="200">
 This chapter specifies a General Inter-ORB Protocol (GIOP) for ORB interoperability, which can be mapped onto any connection-oriented transport protocol that meets a minimal set of assumptions. This chapter also defines a specific mapping of the GIOP which runs directly over TCP/IP connections, called the Internet Inter-ORB Protocol (IIOP). The IIOP must be supported by conforming networked ORB products regardless of other aspects of their implementation. Such support does not require using it internally; conforming ORBs may also provide bridges to this protocol.<p>
</a></dl>
<a name="1435">
<h1>	12.1	 Goals of the General Inter-ORB Protocol</h1>
</a><a name="1388">
The GIOP and IIOP support protocol-level ORB interoperability in a general, low-cost manner. The following objectives were pursued vigorously in the GIOP design:<p>
</a><ul><a name="205">
<li>	Widest possible availability The GIOP and IIOP are based on the most widely-used and flexible communications transport mechanism available (TCP/IP), and defines the minimum additional protocol layers necessary to transfer CORBA requests between ORBs.
</a><a name="526">
<li>	Simplicity<strong> </strong>The GIOP is intended to be as simple as possible, while meeting other design goals. Simplicity is deemed the best approach to ensure a variety of independent, compatible implementations.
</a><a name="2992">
<li>Scalability The GIOP/IIOP protocol should support ORBs, and networks of bridged ORBs, to the size of today's Internet, and beyond.
</a><a name="528">
<li>Low cos<strong>t</strong> Adding support for GIOP/IIOP to an existing or new ORB design should require small engineering investment. Moreover, the run-time costs required to support IIOP in deployed ORBs should be minimal.
</a><a name="529">
<li>	Generality While the IIOP is initially defined for TCP/IP, GIOP message formats are designed to be used with any transport layer that meets a minimal set of assumptions; specifically, the GIOP is designed to be implemented on other connection-oriented transport protocols.
</a><a name="530">
<li>Architectural neutrality<strong> </strong>The GIOP specification makes minimal assumptions about the architecture of agents that will support it. The GIOP specification treats ORBs as opaque entities with unknown architectures.
</a></ul><a name="531">
The approach a particular ORB takes to providing support for the GIOP/IIOP is undefined. For example, an ORB could choose to use the IIOP as its internal protocol, it could choose to externalize IIOP as much as possible by implementing it in a half-bridge, or it could choose a strategy between these two extremes. All that is required of a conforming ORB is that some entity or entities in or associated with the ORB be able to send and receive IIOP messages.<p>
</a><a name="207">
<h1>	12.2	 General Inter-ORB Protocol Overview</h1>
</a><a name="208">
The GIOP specification consists of the following elements:<p>
</a><ul><a name="209">
<li><em>	The Common Data Representation (CDR) definition</em>. CDR is a transfer syntax mapping OMG IDL data types into a bicanonical low-level representation for "on-the-wire" transfer between ORBs and Inter-ORB bridges (agents).
</a><a name="210">
<li>	<em>GIOP Message Formats</em>. GIOP messages are exchanged between agents to facilitate object requests, locate object implementations, and manage communication channels.
</a><a name="1799">
<li><em>GIOP Transport Assumptions</em>. The GIOP specification describes general assumptions made concerning any network transport layer that may be used to transfer GIOP messages. The specification also describes how connections may be managed, and constraints on GIOP message ordering.
</a></ul><a name="1806">
The IIOP specification adds the following element to the GIOP specification:<p>
</a><ul><a name="1802">
<li><em>	Internet IOP Message Transport</em>. The IIOP specification describes how agents open TCP/IP connections and use them to transfer GIOP messages.
</a></ul><a name="1426">
The IIOP is not a separate specification; it is a specialization, or mapping, of the GIOP to a specific transport (TCP/IP). The GIOP specification (without the transport-specific IIOP element) may be considered as a separate conformance point for future mappings to other transport layers. <p>
</a><a name="1974">
The complete OMG IDL specifications for the GIOP and IOP are shown in <a href="giop.html#1844">Section &#32;12.8, "OMG IDL for the GIOP and IIOP Specifications," on page &#32;12-29</a> . Fragments of the specification are used throughout this chapter as necessary. <p>
</a><a name="212">
<h2>	12.2.1	 Common Data Representation (CDR)</h2>
</a><a name="213">
CDR is a transfer syntax, mapping from data types defined in OMG IDL to a bicanonical, low-level representation for transfer between agents. CDR has the following features:<p>
</a><ul><a name="214">
<li>Variable byte ordering. Machines with a common byte order may exchange messages without byte swapping. When communicating machines have different byte order, the message originator determines the message byte order, and the receiver is responsible for swapping bytes to match its native ordering. Each GIOP message (and CDR encapsulation) contains a flag that indicates the appropriate byte order.
</a><a name="215">
<li>Aligned primitive types. Primitive OMG IDL data types are aligned on their natural boundaries within GIOP messages, permitting data to be handled efficiently by architectures that enforce data alignment in memory.
</a><a name="2546">
<li>Complete OMG IDL Mapping. CDR describes representations for all OMG IDL data types, including transferable pseudo-objects such as TypeCodes. Where necessary, CDR defines representations for data types whose representations are undefined or implementation-dependent in the CORBA Core specifications.
</a></ul><a name="2547">
<h2>	12.2.2	 GIOP Message Overview</h2>
</a><a name="218">
The GIOP specifies formats for messages that are exchanged between inter- operating ORBs. GIOP message formats have the following features:<p>
</a><ul><a name="219">
<li>Few, simple messages. With only seven message formats, the GIOP supports full CORBA functionality between ORBs, with extended capabilities supporting object location services, dynamic migration, and efficient management of communication resources. GIOP semantics require no format or binding negotiations. In most cases, clients can send requests to objects immediately upon opening a connection.
</a><a name="220">
<li>Dynamic object location. Many ORBs' architectures allow an object implementation to be activated at different locations during its lifetime, and may allow objects to migrate dynamically. GIOP messages provide support for object location and migration, without requiring ORBs to implement such mechanisms when unnecessary or inappropriate to an ORB's architecture.
</a><a name="222">
<li>Full CORBA support. GIOP messages directly support all functions and behaviors required by CORBA, including exception reporting, passing operation context, and remote object reference operations (such as <strong>CORBA::Object::get_interface</strong>).
</a></ul><a name="527">
GIOP also supports passing service-specific context, such as the transaction context defined by the Transaction Service (the Transaction Service is described in <em>CORBAservices</em>). This mechanism is designed to support any service that requires service related context to be implicitly passed with requests.<p>
</a><a name="223">
<h2>	12.2.3	 GIOP Message Transfer</h2>
</a><a name="224">
The GIOP specification is designed to operate over any connection-oriented transport protocol that meets a minimal set of assumptions (described in <a href="giop.html#1481">"GIOP Message Transport" on page &#32;12-23</a>). GIOP uses underlying transport connections in the following ways:<p>
</a><ul><a name="226">
<li>Asymmetrical connection usage. The GIOP defines two distinct roles with respect to connections, client and server. The client side of a connection originates the connection, and sends object requests over the connection. The server side receives requests and sends replies. The server side of a connection may not send object requests. This restriction allows the GIOP specification to be much simpler and avoids certain race conditions.
</a><a name="227">
<li>Request multiplexing<em>.</em> If desirable, multiple clients within an ORB may share a connection to send requests to a particular ORB or server. Each request uniquely identifies its target object. Multiple independent requests for different objects, or a single object, may be sent on the same connection.
</a><a name="228">
<li>Overlapping requests. In general, GIOP message ordering constraints are minimal. GIOP is designed to allow overlapping asynchronous requests; it does not dictate the relative ordering of requests or replies. Unique request/reply identifiers provide proper correlation of related messages. Implementations are free to impose any internal message ordering constraints required by their ORB architectures.
</a><a name="229">
<li>Connection management. GIOP defines messages for request cancellation and orderly connection shutdown. These features allow ORBs to reclaim and reuse idle connection resources.
</a></ul><a name="230">
<h1>	12.3	 CDR Transfer Syntax</h1>
</a><a name="231">
The Common Data Representation (CDR) transfer syntax is the format in which the GIOP represents OMG IDL data types in an octet stream.<p>
</a><a name="201">
An octet stream is an abstract notion that typically corresponds to a memory buffer that is to be sent to another process or machine over some IPC mechanism or network transport. For the purposes of this discussion, an octet stream is an arbitrarily long (but finite) sequence of eight-bit values (octets) with a well-defined beginning. The octets in the stream are numbered from <em>0</em> to <em>n-1</em>, where <em>n</em> is the size of the stream. The numeric position of an octet in the stream is called its <em>index</em>. Octet indices are used to calculate alignment boundaries, as described in <a href="giop.html#236">"Alignment" on page &#32;12-5</a>.<p>
</a><a name="232">
GIOP defines two distinct kinds of octet streams, messages and encapsulations. Messages are the basic units of information exchange in GIOP, described in detail in <a href="giop.html#350">"GIOP Message Formats" on page &#32;12-15</a>.<p>
</a><a name="533">
Encapsulations are octet streams into which OMG IDL data structures may be marshaled independently, apart from any particular message context. Once a data structure has been encapsulated, the octet stream can be represented as the OMG IDL opaque data type <strong>sequence&lt;octet&gt;</strong>, which can subsequently marshaled into a message or another encapsulation. Encapsulations allow complex constants (such as TypeCode<strong>s</strong>) to be pre-marshaled; they also allow certain message components to be handled without requiring full unmarshaling. Whenever encapsulations are used in CDR or the GIOP, they are clearly noted.<p>
</a><a name="233">
<h2>	12.3.1	 Primitive Types</h2>
</a><a name="234">
Primitive data types are specified for both big-endian and little-endian orderings. The message formats (see <a href="giop.html#350">"GIOP Message Formats" on page &#32;12-15</a>) include tags in message headers that indicate the byte ordering in the message. Encapsulations include an initial flag that indicates the byte ordering within the encapsulation, described in <a href="giop.html#286">"Encapsulation" on page &#32;12-9</a>. The byte ordering of any encapsulation may be different from the message or encapsulation within which it is nested. It is the responsibility of the message recipient to translate byte ordering if necessary.<p>
</a><a name="235">
Primitive data types are encoded in multiples of octets. An octet is an 8-bit value.<p>
</a><a name="236">
<h3>		 Alignment </h3>
</a><a name="237">
In order to allow primitive data to be moved into and out of octet streams with instructions specifically designed for those primitive data types, in CDR all primitive data types must be aligned on their natural boundaries; i.e., the alignment boundary of a primitive datum is equal to the size of the datum in octets. Any primitive of size <em>n</em> octets must start at an octet stream index that is a multiple of <em>n</em>. In CDR, <em>n</em> is one of 1, 2, 4, or 8.<p>
</a><a name="1398">
Where necessary, an alignment gap precedes the representation of a primitive datum. The value of octets in alignment gaps is undefined. A gap must be the minimum size necessary to align the following primitive. <a href="giop.html#1398">Table &#32;12-1</a> gives alignment boundaries for CDR/OMG-IDL primitive types. 
<Table Border="3">
<caption><a name="535">
Table 12-1	 Alignment requirements for OMG IDL primitive data types<p>
</a></caption>
<tr><th><a name="537">
 TYPE<p>
</a><th><a name="538">
 OCTET ALIGNMENT<p>
</a>
<tr><td><a name="539">
 char<p>
</a><td><a name="540">
 1<p>
</a>
<tr><td><a name="541">
 octet<p>
</a><td><a name="542">
 1<p>
</a>
<tr><td><a name="543">
 short<p>
</a><td><a name="544">
 2<p>
</a>
<tr><td><a name="545">
 unsigned short<p>
</a><td><a name="546">
 2<p>
</a>
<tr><td><a name="547">
 long<p>
</a><td><a name="548">
 4<p>
</a>
<tr><td><a name="549">
 unsigned long<p>
</a><td><a name="550">
 4<p>
</a>
<tr><td><a name="551">
 float<p>
</a><td><a name="552">
 4<p>
</a>
<tr><td><a name="553">
 double<p>
</a><td><a name="554">
 8<p>
</a>
<tr><td><a name="555">
 boolean<p>
</a><td><a name="556">
 1<p>
</a>
<tr><td><a name="557">
 enum<p>
</a><td><a name="558">
 4<p>
</a>

</Table>

<Table>
<tr><td>
</Table>
<p>
</a><a name="240">
Alignment is defined above as being relative to the beginning of an octet stream. The first octet of the stream is octet index zero (0); any data type may be stored starting at this index. Such octet streams begin at the start of an GIOP message header (see <a href="giop.html#351">"GIOP Message Header" on page &#32;12-15</a>) and at the beginning of an encapsulation, even if the encapsulation itself is nested in another encapsulation. (See <a href="giop.html#286">"Encapsulation" on page &#32;12-9</a>).<p>
</a><a name="241">
<h3>		 Integer Data Types</h3>
</a><a name="242">
<a href="giop.html#534">Figure &#32;12-1</a> illustrates the representations for OMG IDL integer data types, including the following data types:<p>
</a><ul><a name="243">
<li>short 	
</a><a name="238">
<li>unsigned short
</a><a name="239">
<li>long 	
</a><a name="532">
<li>unsigned long
</a></ul><a name="244">
The figure illustrates bit ordering and size. Signed types (short<strong> </strong>and long) are represented as two's complement numbers; unsigned versions of these types are represented as unsigned binary numbers.<img src="local/images/giopa.gif"><p>
</a><a name="534">
Figure 12-1	 Sizes and bit ordering in big-endian and little-endian encodings of OMG IDL integer data types, both signed and unsigned.<p>
</a><a name="246">
<h3>		 Floating Point Data Types</h3>
</a><a name="1852">
<a href="giop.html#2407">Figure &#32;12-2 on page 7</a> illustrates the representation of floating point numbers. These exactly follow the IEEE standard formats for floating point numbers<a href="#1855"><sup>1</sup></a>, selected parts of which are abstracted here for explanatory purposes. The diagram shows three different components for floating points numbers, the sign bit (s), the exponent (e) and the fractional part (f) of the mantissa. The sign bit has values of 0 or 1, representing positive and negative numbers, respectively.<p>
</a><a name="249">
For single-precision float values the exponent is 8 bits long, comprising e1 and e2 in the figure, where the 7 bits in e1 are most significant. The exponent is represented as excess 127. The fractional mantissa (f1 - f3) is a 23-bit value f where 1.0 &lt;= f &lt; 2.0, f1 being most significant and f3 being least significant. The value of a normalized number is described by:<img src="local/images/giopa1.gif"><p>
</a><a name="1474">
For double-precision values the exponent is 11 bits long, comprising e1 and e2 in the figure, where the 7 bits in e1 are most significant. The exponent is represented as excess 1023. The fractional mantissa (f1 - f7) is a 52-bit value m where 1.0 &lt;= m &lt; 2.0, f1 being most significant and f7 being least significant. The value of a normalized number is described by:<img src="local/images/giopa2.gif"><p>
</a><a name="255">
<h3>		 Octet</h3>
</a><a name="256">
Octets are uninterpreted 8-bit values whose contents are guaranteed not to undergo any conversion during transmission. For the purposes of describing possible octet values in this specification, octets may be considered as unsigned 8-bit integer values.<p>
</a><a name="257">
<h3>		 Boolean</h3>
</a><a name="260">
Boolean values are encoded as single octets, where TRUE is the value 1, and FALSE as 0.<p>
</a><a name="261">
<h3>		 Character Types</h3>
</a><a name="3054">
OMG IDL characters are represented single octets, encoded as defined by ISO Latin-1 (8859.1).<p>
</a><a name="2407">
Figure 12-2	 Sizes and bit ordering in big-endian and little-endian representations of OMG IDL single and double precision floating point numbers. <img src="local/images/giopa3.gif"><p>
</a><a name="3299">
<h2>	12.3.2	 OMG IDL Constructed Types</h2>
</a><a name="3300">
Constructed types are built from OMG IDL's data types using facilities defined by the OMG IDL language.<p>
</a><a name="1375">
<h3>		 Alignment</h3>
</a><a name="1374">
Constructed type have no alignment restrictions beyond those of their primitive components; the alignment of those primitive types is not intended to support use of marshaling buffers as equivalent to the implementation of constructed data types within any particular language environment. GIOP assumes that agents will usually construct structured data types by copying primitive data between the marshaled buffer and the appropriate in-memory data structure layout for the language mapping implementation involved.<p>
</a><a name="1081">
<h3>		 Struct</h3>
</a><a name="267">
The components of a structure are encoded in their order of their declaration in the structure. Each component is encoded as defined for its data type. <p>
</a><a name="268">
<h3>		 Union </h3>
</a><a name="269">
Unions are encoded as the discriminant tag of the type specified in the union declaration, followed by the representation of any selected member, encoded as its type indicates. <p>
</a><a name="272">
<h3>		 Array</h3>
</a><a name="273">
Arrays are encoded as the array elements in sequence. As the array length is fixed, no length values are encoded. Each element is encoded as defined for the type of the array. In multidimensional arrays, the elements are ordered so the index of the first dimension varies most slowly, and the index of the last dimension varies most quickly.<p>
</a><a name="278">
<h3>		 Sequence</h3>
</a><a name="279">
Sequences are encoded as an unsigned long value, followed by the elements of the sequence. The initial unsigned long contains the number of elements in the sequence. The elements of the sequence are encoded as specified for their type.<p>
</a><a name="280">
<h3>		 String</h3>
</a><a name="282">
Strings are encoded as an unsigned long containing the length of the string, followed by the individual characters in the string, encoded in ISO Latin-1 (8859.1). The length (initial unsigned long) and string representation include a terminating null character, so that conventional C-string handling library routines (e.g., <code>strcpy</code>) may be used in the encoded message buffer.<p>
</a><a name="284">
<h3>		 Enum</h3>
</a><a name="285">
Enum values are encoded as unsigned longs. The numeric values associated with enum identifiers are determined by the order in which the identifiers appear in the enum declaration. The first enum identifier has the numeric value zero (0). Successive enum identifiers are take ascending numeric values, in order of declaration from left to right. <p>
</a><a name="286">
<h2>	12.3.3	 Encapsulation</h2>
</a><a name="287">
As described above, OMG IDL data types may be independently marshaled into encapsulation octet streams. The octet stream is represented as the OMG IDL type <strong>sequence&lt;octet&gt;,</strong> which may be subsequently included in a GIOP message or nested in another encapsulation.<p>
</a><a name="1928">
The GIOP and IIOP explicitly use encapsulations in three places: <em>TypeCodes</em> (see <a href="giop.html#291">"TypeCode" on page &#32;12-10</a>), the IIOP protocol profile inside an IOR (see <a href="giop.html#1630">"Object References" on page &#32;12-15</a>), and in service-specific context (see <a href="inarch.html#1338">"Object Service Context" on page &#32;10-18</a>). In addition, some ORBs may use choose to use an encapsulation to hold <strong>Principal</strong> identification information (see <a href="giop.html#306">"Principal" on page &#32;12-14</a>), the object_key (see <a href="giop.html#1846">"IIOP IOR Profiles" on page &#32;12-27</a>), or in other places that a <strong>sequence&lt;octet&gt;</strong> data type is in use.<p>
</a><a name="288">
When encapsulating OMG IDL data types, the first octet in the stream (index 0) contains a boolean value indicating the byte ordering of the encapsulated data. If the value is FALSE (0), the encapsulated data is encoded in big-endian order; if TRUE (1), the data is encoded in little-endian order, exactly like the byte order flag in GIOP message headers (see <a href="giop.html#351">"GIOP Message Header" on page &#32;12-15</a>). This value is not part of the data being encapsulated, but is part of the octet stream holding the encapsulation. Following the byte order flag, the data to be encapsulated is marshaled into the buffer as defined by CDR encoding rules. Marshaled data are aligned relative to the beginning of the octet stream (the first octet of which is occupied by the byte order flag). <p>
</a><a name="289">
When the encapsulation is encoded as type <strong>sequence&lt;octet&gt;</strong> for subsequent marshaling, an unsigned long value containing the sequence length is prefixed to the octet stream, as prescribed for sequences (see <a href="giop.html#278">"Sequence" on page &#32;12-8</a>). The length value is not part of the encapsulation's octet stream, and does not affect alignment of data within the encapsulation. Note that this guarantees a four octet alignment of the start of all encapsulated data within GIOP messages and nested encapsulations.<a href="#1919"><sup>2</sup></a><p>
</a><a name="290">
<h2>	12.3.4	 Pseudo-Object Types</h2>
</a><a name="245">
CORBA defines some kinds of entities that are neither primitive types (integral or floating point) nor constructed ones.<p>
</a><a name="291">
<h3>		 TypeCode</h3>
</a><a name="292">
In general, TypeCodes are encoded as the <strong>TCKind</strong> enum value, potentially followed by values that represent the TypeCode parameters. Unfortunately, TypeCodes cannot be expressed simply in OMG IDL, since their definitions are recursive. The basic TypeCode representations are given in <a href="giop.html#2167">Table &#32;12-2</a>. The enum value column this table gives the TCKind enum value corresponding to the given TypeCode, and lists the parameters associated with such a TypeCode. The rest of this section presents the details of the encoding.<p>
</a><a name="2030">
<h4> Basic TypeCode Encoding Framework</h4>
</a><a name="564">
The encoding of a TypeCode is the <strong>TCKind</strong> enum value (encoded, like all enum values, using four octets), followed by zero or more parameter values. The encodings of the parameter lists fall into three general categories, and differ in order to conserve space and to support efficient traversal of the binary representation:<p>
</a><ul><a name="561">
<li>Typecodes with an <em>empty parameter list </em>are encoded simply as the corresponding <strong>TCKind</strong> enum value.
</a><a name="562">
<li>Ones with <em>simple parameter lists</em> are encoded as the TCKind enum value followed by the parameter value(s), encoded as indicated in <a href="giop.html#2167">Table &#32;12-2</a>. A "simple" parameter list has a fixed number of fixed length entries, or a single parameter which is has its length encoded first. Currently, only the TCKind value tk_string has such a parameter list.
</a><a name="563">
<li>All other typecodes have <em>complex parameter lists</em>, which are encoded as the <strong>TCKind</strong> enum value followed by a CDR encapsulation octet sequence (see <a href="giop.html#286">"Encapsulation" on page &#32;12-9</a>) containing the encapsulated, marshaled parameters. The order of these parameters is shown in the fourth column of <a href="giop.html#2167">Table &#32;12-2</a>.
</a></ul><a name="2048">
The third column of <a href="giop.html#2167">Table &#32;12-2</a> shows whether each parameter list is <em>empty</em>, <em>simple</em>, or <em>complex</em>. Also, note that an internal indirection facility is needed to represent some kinds of typecodes; this is explained in <a href="giop.html#2033">"Indirection: Recursive and Repeated TypeCodes" on page &#32;12-13</a>. This indirection does not need to be exposed to application programmers.<p>
</a><a name="2058">
<h4> TypeCode Parameter Notation</h4>
</a><a name="296">
TypeCode parameters are specified in the fourth column of <a href="giop.html#2167">Table &#32;12-2</a>. The ordering and meaning of parameters is a superset of those given in the Interface Repository specification (Chapter 6); more information is needed by CDR's representation in order to provide the full semantics of TypeCodes as shown by the API.<p>
</a><ul><a name="2066">
<li>Each parameter is written in the form <em>type (name),</em> where <em>type</em> describes the parameter's type, and <em>name</em> describes the parameter's meaning.
</a><a name="297">
<li>The encoding of some parameter lists (specifically, <strong>tk_struct, tk_union, tk_enum, tk_except</strong>) contain a counted sequence of tuples. 
</a><a name="2097">
 Such counted tuple sequences are written in the form <em>count {parameters}</em>, where <em>count</em> is the number of tuples in the encoded form, and the <em>parameters</em> enclosed in braces are available in each tuple instance. First the <em>count</em>, which is an <code>unsigned</code> <code>long</code>, and then each <em>parameter</em> in each tuple (using the noted type), is encoded in the CDR representation of the typecode. Each tuple is encoded, first parameter followed by second etc., before the next tuple is encoded (first, then second, etc.).<p>
</a></ul><a name="2167">
Note that the tuples identifying struct, exception and enum members must be in the order defined in the OMG IDL definition text. Also, that the types of discriminant values in encoded <code>tk_union</code> TypeCodes are established by the second encoded parameter (<em>discriminant type</em>), and cannot be specified except with reference to a specific OMG IDL definition. 
<Table Border="3">
<caption><a name="2194">
Table 12-2	 TypeCode enum values, parameter list types, and parameters<p>
</a></caption>
<tr><th><a name="2202">
<h3> TCKind</h3>
</a><th><a name="2204">
<h3> Integer Value</h3>
</a><th><a name="2206">
<h3> Type</h3>
</a><th><a name="2208">
<h3> Parameters </h3>
</a>
<tr><td><a name="2210">
 <code>tk_null</code><p>
</a><td><a name="2212">
 0<p>
</a><td><a name="2214">
 empty<p>
</a><td><a name="2216">
 - none -<p>
</a>
<tr><td><a name="2218">
 <code>tk_void</code><p>
</a><td><a name="2220">
 1<p>
</a><td><a name="2222">
 empty<p>
</a><td><a name="2224">
 - none -<p>
</a>
<tr><td><a name="2226">
 <code>tk_short</code><p>
</a><td><a name="2228">
 2<p>
</a><td><a name="2230">
 empty<p>
</a><td><a name="2232">
 - none -<p>
</a>
<tr><td><a name="2234">
 <code>tk_long</code><p>
</a><td><a name="2236">
 3<p>
</a><td><a name="2238">
 empty<p>
</a><td><a name="2240">
 - none -<p>
</a>
<tr><td><a name="2242">
 <code>tk_ushort</code><p>
</a><td><a name="2244">
 4<p>
</a><td><a name="2246">
 empty<p>
</a><td><a name="2248">
 - none -<p>
</a>
<tr><td><a name="2250">
 <code>tk_ulong</code><p>
</a><td><a name="2252">
 5<p>
</a><td><a name="2254">
 empty<p>
</a><td><a name="2256">
 - none -<p>
</a>
<tr><td><a name="2258">
 <code>tk_float</code><p>
</a><td><a name="2260">
 6<p>
</a><td><a name="2262">
 empty<p>
</a><td><a name="2264">
 - none - <p>
</a>
<tr><td><a name="2266">
 <code>tk_double</code><p>
</a><td><a name="2268">
 7<p>
</a><td><a name="2270">
 empty<p>
</a><td><a name="2272">
 - none - <p>
</a>
<tr><td><a name="2274">
 <code>tk_boolean</code><p>
</a><td><a name="2276">
 8<p>
</a><td><a name="2278">
 empty<p>
</a><td><a name="2280">
 - none - <p>
</a>
<tr><td><a name="2282">
 <code>tk_char</code><p>
</a><td><a name="2284">
 9<p>
</a><td><a name="2286">
 empty<p>
</a><td><a name="2288">
 - none - <p>
</a>
<tr><td><a name="2290">
 <code>tk_octet</code><p>
</a><td><a name="2292">
 10<p>
</a><td><a name="2294">
 empty<p>
</a><td><a name="2296">
 - none - <p>
</a>
<tr><td><a name="2298">
 <code>tk_any</code><p>
</a><td><a name="2300">
 11<p>
</a><td><a name="2302">
 empty<p>
</a><td><a name="2304">
 - none - <p>
</a>
<tr><td><a name="2306">
 <code>tk_TypeCode</code><p>
</a><td><a name="2308">
 12<p>
</a><td><a name="2310">
 empty<p>
</a><td><a name="2312">
 - none - <p>
</a>
<tr><td><a name="2314">
 <code>tk_Principal</code><p>
</a><td><a name="2316">
 13<p>
</a><td><a name="2318">
 empty<p>
</a><td><a name="2320">
 - none - <p>
</a>
<tr><td><a name="2322">
 <code>tk_objref</code><p>
</a><td><a name="2324">
 14<p>
</a><td><a name="2326">
 complex<p>
</a><td><a name="2328">
 string (repository ID), string(name)<p>
</a>
<tr><td><a name="2330">
 <code>tk_struct</code><p>
</a><td><a name="2332">
 15<p>
</a><td><a name="2334">
 complex<p>
</a><td><a name="2336">
 string (repository ID), string (name), ulong (count) {string (member name), TypeCode (member type)} <p>
</a>
<tr><td><a name="2338">
 <code>tk_union</code><p>
</a><td><a name="2340">
 16<p>
</a><td><a name="2342">
 complex<p>
</a><td><a name="2344">
 string (repository ID), string(name), TypeCode (discriminant type), long (default used), ulong (count) {<em>discriminant type</em><a href="#2347"><sup>1</sup></a> (label value), string (member name), TypeCode (member type)} <p>
</a>
<tr><td><a name="2349">
 <code>tk_enum</code><p>
</a><td><a name="2351">
 17<p>
</a><td><a name="2353">
 complex<p>
</a><td><a name="2355">
 string (repository ID), string (name), ulong (count) {string (member name)} <p>
</a>
<tr><td><a name="2357">
 <code>tk_string</code><p>
</a><td><a name="2359">
 18<p>
</a><td><a name="2361">
 simple<p>
</a><td><a name="2363">
 ulong (max length<a href="#2404"><sup>2</sup></a>) <p>
</a>
<tr><td><a name="2365">
 <code>tk_sequence</code><p>
</a><td><a name="2367">
 19<p>
</a><td><a name="2369">
 complex<p>
</a><td><a name="2371">
 TypeCode (element type), ulong (max length<a href="#1415"><sup>3</sup></a>) <p>
</a>
<tr><td><a name="2373">
 <code>tk_array</code><p>
</a><td><a name="2375">
 20<p>
</a><td><a name="2377">
 complex<p>
</a><td><a name="2379">
 TypeCode (element type), ulong (length) <p>
</a>
<tr><td><a name="1992">
 tk_alias<p>
</a><td><a name="1994">
 21<p>
</a><td><a name="1996">
 complex<p>
</a><td><a name="1998">
 string (repository ID), string (name), TypeCode<p>
</a>
<tr><td><a name="2000">
 tk_except<p>
</a><td><a name="2002">
 22<p>
</a><td><a name="2004">
 complex<p>
</a><td><a name="2008">
 string (repository ID), string (name), ulong (count) {string (member name), TypeCode (member type)} <p>
</a>
<tr><td><a name="2463">
 - none -<p>
</a><td><a name="2465">
 0xffffffff<p>
</a><td><a name="2467">
 simple<p>
</a><td><a name="2469">
 long (indirection<a href="#2471"><sup>4</sup></a>)<p>
</a>

</Table>

<Table>
<tr><td><sup>1</sup><a name="2347">
 The type of union label values is determined by the second parameter, discriminant type.<p>
</a><sup>2</sup><a name="2404">
 For unbounded strings, this value is zero.<p>
</a><sup>3</sup><a name="1415">
 For unbounded sequences, this value is zero.<p>
</a><sup>4</sup><a name="2471">
 See <a href="giop.html#2033">"Indirection: Recursive and Repeated TypeCodes" on page &#32;12-13</a>.<p>
</a>
</Table>
<a href="#2382"><sup>3</sup></a><p>
</a><a name="2031">
<h4> Encoded Identifiers and Names</h4>
</a><a name="298">
The Repository ID parameters in <strong>tk_objref, tk_struct, tk_union, tk_enum, tk_alias</strong>, and <strong>tk_except</strong> TypeCodes are Interface Repository <code>RepositoryId</code> values, whose format is described in the specification of of the Interface Repository. RepositoryId values are required for <strong>tk_objref</strong> and <strong>tk_except</strong> TypeCodes; for other TypeCodes they are optional and are encoded as empty strings if omitted.<p>
</a><a name="1375">
The <strong>name</strong> parameters in <strong>tk_objref, tk_struct, tk_union, tk_enum, tk_alias,</strong> and <strong>tk_except</strong> TypeCodes and the <strong>member name </strong>parameters in <strong>tk_struct, tk_union, tk_enum</strong> and <strong>tk_except </strong>TypeCodes are not specified by (or significant in) GIOP. Agents should not make assumptions about type equivalence based on these name values; only the structural information (including <strong>RepositoryId</strong> values, if provided) is significant. If provided, the strings should be the simple, unscoped names supplied in the OMG IDL definition text. If omitted, they are encoded as empty strings.<p>
</a><a name="2032">
<h4> Encoding the tk_union Default Case</h4>
</a><a name="301">
In <strong>tk_union</strong> TypeCodes, the long <strong>default used</strong> value is used to indicate which tuple in the sequence describes the union's <code>default</code> case. If this value is less than zero, then the union contains no default case. Otherwise, the value contains the zero based index of the default case in the sequence of tuples describing union members.<p>
</a><a name="2067">
<h4> TypeCodes for Multi-Dimensional Arrays</h4>
</a><a name="2068">
The <strong>tk_array</strong> TypeCode only describes a single dimension of any array. TypeCodes for multi-dimensional arrays are constructed by nesting <strong>tk_array</strong> TypeCodes within other <strong>tk_array </strong>TypeCodes, one per array dimension. The outermost (or top-level) <strong>tk_array </strong>TypeCode describes the leftmost array index of the array as defined in IDL; the innermost nested <strong>tk_array</strong> TypeCode describes the rightmost index.<p>
</a><a name="2033">
<h4> Indirection: Recursive and Repeated TypeCodes</h4>
</a><a name="2034">
The typecode representation of OMG IDL data types that can indirectly contain instances of themselves (e.g <strong>struct foo {sequence &lt;foo&gt; bar;}</strong>) must also contain an indirection. Such an indirection is also useful to reduce the size of encodings; for example, unions with many cases sharing the same value.<p>
</a><a name="2430">
CDR provides a constrained indirection to resolve this problem:<p>
</a><ul><a name="2431">
<li>The indirection applies only to TypeCodes nested within some "top level" TypeCode. Indirected TypeCodes are not "freestanding", but only exist inside some other encoded TypeCode.
</a><a name="2410">
<li>Only the second (and subsequent) references to a given TypeCode in that scope may use the indirection facility. The first reference to that TypeCode must be encoded using the normal rules; in the case of a recursive TypeCode, this means that the first instance will not have been fully encoded before a second one must be completely encoded.
</a></ul><a name="2426">
The indirection is a numeric octet offset within the scope of the "top level" TypeCode and points to the TCKind value for the typecode. (Note that the byte order of the TCKind value can be determined by its encoded value.) This indirection may well cross encapsulation boundaries, but this is not problematic because of first constraint identified above. Because of the second constraint, the value of the offset will always be negative.<p>
</a><a name="2488">
The encoding of such an indirection is as a TypeCode with an "TCKind value" that has the special value 232-1 (0xffffffff, all ones). Such typecodes have a single (simple) parameter, which is the <code>long</code> offset (in units of octets) from the simple parameter. (As an example, that this means offset of negative four (-4) is illegal, because it be self-indirecting.)<p>
</a><a name="302">
<h3>		 Any</h3>
</a><a name="305">
Any values are encoded as a TypeCode (encoded as described above) followed by the encoded value.<p>
</a><a name="306">
<h3>		 Principal</h3>
</a><a name="307">
<strong>Principal</strong> pseudo objects are encoded as <strong>sequence&lt;octet&gt;</strong>. In the absence of a Security service specification, <strong>Principal </strong>values have no standard format or interpretation, beyond (as described in the CORBA CORE) serving to identify callers (and potential callers). This specification does not define any inter-ORB security mechanisms, or prescribe any usage of <strong>Principal</strong> values.<p>
</a><a name="521">
By representing Principal values as <strong>sequence&lt;octet&gt;</strong>, GIOP guarantees that ORBs may use domain-specific principal identification schemes; such values undergo no translation or interpretation during transmission. This allows bridges to translate or interpret these identifiers as needed when forwarding requests between different security domains.<p>
</a><a name="308">
<h3>		 Context</h3>
</a><a name="309">
Context pseudo objects are encoded as <strong>sequence&lt;string&gt;</strong>. The strings occur in pairs. The first string in each pair is the context property name, and the second string in each pair is the associated value.<p>
</a><a name="310">
<h3>		 Exception</h3>
</a><a name="311">
Exceptions are encoded as a string followed by exception members, if any. The string contains the RepositoryId for the exception, as defined in the Interface Repository chapter. Exception members (if any) are encoded in the same manner as a struct.<a href="#1427"><sup>4</sup></a><p>
</a><a name="1737">
Note &#175;  A catalog of minor codes for CORBA's System Exceptions will be provided, based on implementers' agreements. Such an agreement is needed to support complete interoperability, since otherwise applications could distinguish ORBs based on the diagnostics they report, and could not reliably assign meanings to system exceptions reported to them.<p>
</a><a name="1630">
<h2>	12.3.5	 Object References</h2>
</a><a name="1633">
Object references are encoded in OMG IDL as described in <a href="inarch.html#3640">"Object Addressing" on page &#32;10-11</a>. IOR profiles contain transport-specific addressing information, so there is no general-purpose IOR profile format defined for GIOP. Instead, this specification describes the general information model for GIOP profiles and provides a specific format for the IIOP (see <a href="giop.html#1846">"IIOP IOR Profiles" on page &#32;12-27</a>). <p>
</a><a name="1641">
In general, GIOP profiles shall include at least these three elements: <p>
</a><ul><a name="1816">
<li>The version number of the transport-specific protocol specification that the server supports, 
</a><a name="1819">
<li>The address of an endpoint for the transport protocol being used, and 
</a><a name="1813">
<li>An opaque datum (an <strong>object_key</strong>, in the form of an octet sequence) used exclusively by the agent at the specified endpoint address to identify the object.
</a></ul><a name="350">
<h1>	12.4	 GIOP Message Formats</h1>
</a><a name="352">
In describing GIOP messages, it is necessary to define client and server roles. For the purpose of this discussion, a client is the agent that opens a connection (see more details in <a href="giop.html#468">"Connection Management" on page &#32;12-24</a>) and originates requests. A server is an agent that accepts connections and receives requests.<p>
</a><a name="353">
GIOP message types are summarized in <a href="giop.html#353">Table &#32;12-3</a>, which lists the message type names, whether the message is originated by client, server, or both, and the value used to identify the message type in GIOP message headers. 
<Table Border="3">
<caption><a name="355">
Table 12-3	 GIOP Message Types and originators<p>
</a></caption>
<tr><th><a name="656">
<h3> Message Type</h3>
</a><th><a name="657">
<h3> Originator</h3>
</a><th><a name="658">
<h3> Value</h3>
</a>
<tr><td><a name="659">
 <code>Request</code><p>
</a><td><a name="660">
Client<p>
</a><td><a name="661">
0<p>
</a>
<tr><td><a name="662">
 <code>Reply</code><p>
</a><td><a name="663">
Server<p>
</a><td><a name="664">
1<p>
</a>
<tr><td><a name="1138">
 CancelRequest<p>
</a><td><a name="1140">
Client<p>
</a><td><a name="1142">
2<p>
</a>
<tr><td><a name="665">
 <code>LocateRequest</code><p>
</a><td><a name="666">
Client<p>
</a><td><a name="667">
3<p>
</a>
<tr><td><a name="668">
 <code>LocateReply</code><p>
</a><td><a name="669">
Server<p>
</a><td><a name="670">
4<p>
</a>
<tr><td><a name="671">
 <code>CloseConnection</code><p>
</a><td><a name="672">
Server<p>
</a><td><a name="673">
5<p>
</a>
<tr><td><a name="677">
 <code>MessageError</code><p>
</a><td><a name="678">
Both<p>
</a><td><a name="679">
6<p>
</a>

</Table>

<Table>
<tr><td>
</Table>
<p>
</a><a name="351">
<h2>	12.4.1	 GIOP Message Header</h2>
</a><a name="357">
All GIOP messages begin with the following header, defined in OMG IDL:<p>
</a><a name="1877">
<p>
</a><a name="358">
<blockquote></blockquote>
</a><a name="354">
 module GIOP {<p>
</a><a name="1482">
<blockquote>						enum MsgType {</blockquote>
</a><a name="1485">
<blockquote>						Request, Reply, CancelRequest,</blockquote>
</a><a name="1486">
<blockquote>						LocateRequest, LocateReply,</blockquote>
</a><a name="1487">
<blockquote>						CloseConnection, MessageError</blockquote>
</a><a name="1483">
<blockquote>						};</blockquote>
</a><a name="1484">
<blockquote></blockquote>
</a><a name="359">
<blockquote>						struct MessageHeader {</blockquote>
</a><a name="356">
<blockquote> 						char					magic [4];</blockquote>
</a><a name="581">
<blockquote>						Version					GIOP_version;</blockquote>
</a><a name="650">
<blockquote> 						boolean					byte_order;</blockquote>
</a><a name="651">
<blockquote> 						octet					message_type;</blockquote>
</a><a name="652">
<blockquote> 						unsigned long					message_size;</blockquote>
</a><a name="653">
<blockquote> 						};</blockquote>
</a><a name="680">
 };<p>
</a><a name="360">
The message header clearly identifies GIOP messages, but is defined to be byte-ordering independent, since the header itself defines the byte ordering of subsequent message elements. The members of the header are:<p>
</a><ul><a name="361">
<li><strong>magic</strong> identifies GIOP messages. The value of this member is always the four (upper case) characters "GIOP", encoded in ISO Latin-1 (8859.1).
</a><a name="362">
<li><strong>GIOP_version</strong> contains the version number of the GIOP protocol being used in the message. The version number applies to the transport-independent elements of this specification (i.e., the CDR and message formats) which constitute the GIOP. This is not equivalent to the IIOP version number as described in <a href="giop.html#1630">"Object References" on page &#32;12-15</a>, though it has the same structure. The major GIOP version number of this specification is one (1); the minor version is zero (0).
</a><a name="364">
<li><strong>byte_order</strong> indicates the byte ordering used in subsequent elements of the message (including <em>message_size</em>). A value of FALSE (0) indicates big-endian byte ordering, and TRUE (1) indicates little-endian byte ordering.
</a><a name="365">
<li><strong>message_type </strong>indicates the type of the message, according to <a href="giop.html#353">Table &#32;12-3</a>; these correspond to enum values of type MsgType.
</a><a name="366">
<li><strong>message_size</strong> contains the length of the message following the message header, in octets. This count includes any alignment gaps. The use of a message size of 0 with a Request, LocateRequest, Reply, or LocateReply message is reserved for future use.
</a></ul><a name="2225">
<h3>		 Request Message</h3>
</a><a name="383">
Request messages encode CORBA object invocations, including attribute accessor operations, and <strong>CORBA::Object</strong> operations <strong>get_interface and get_implementation</strong>. Requests flow from client to server.<p>
</a><a name="384">
<em>Request</em> messages have three elements, encoded in this order:<p>
</a><ul><a name="713">
<li>A GIOP message header
</a><a name="1870">
<li>A Request Header
</a><a name="715">
<li>The Request Body 
</a></ul><a name="385">
<h3>		 Request Header</h3>
</a><a name="386">
The request header is specified as follows:<p>
</a><a name="685">
 module GIOP {																// IDL<p>
</a><a name="388">
<blockquote>						struct RequestHeader {</blockquote>
</a><a name="686">
<blockquote> 						IOP::ServiceContextList								service_context;</blockquote>
</a><a name="2136">
<blockquote>						unsigned long					 			request_id;</blockquote>
</a><a name="687">
<blockquote> 						boolean								response_expected;</blockquote>
</a><a name="688">
<blockquote> 						sequence &lt;octet&gt;								object_key;</blockquote>
</a><a name="689">
<blockquote> 						string								operation;</blockquote>
</a><a name="690">
<blockquote> 						Principal								requesting_principal;</blockquote>
</a><a name="691">
<blockquote> 						};</blockquote>
</a><a name="692">
 };<p>
</a><a name="389">
The members have the following definitions:<p>
</a><ul><a name="390">
<li><strong>service_context</strong> contains ORB service data being passed from the client to the server, encoded as described in <a href="inarch.html#1338">"Object Service Context" on page &#32;10-18</a>.
</a><a name="2137">
<li><strong>request_id </strong>is used to associate reply messages with request messages (including <em>LocateRequest</em> messages). The client (requester) is responsible for generating values so that ambiguity is eliminated; specifically, a client must not re-use request_id values during a connection if: <em>(a)</em> the previous request containing that ID is still pending, or <em>(b)</em> if the previous request containing that ID was canceled and no reply was received. (See the semantics of the <a href="giop.html#422">"CancelRequest Message" on page &#32;12-20</a>). 
</a><a name="393">
<li><strong>response_expected</strong> is set to <code>TRUE</code> if the request is expected to have an associated reply. The value is <code>FALSE</code> if the operation is defined as oneway, or if the operation is invoked with the DII and the invocation flags include the <code>INV_NO_RESPONSE</code> flag.
</a><a name="395">
<li><strong>object_key </strong>identifies the object which is the target of the invocation. It is the object_key field from the transport-specific GIOP profile, e.g. from the encapsulated IIOP profile of the IOR for the target object. This value is only meaningful to the server and is not interpreted or modified by the client.
</a><a name="397">
<li><strong>operation</strong> contains the name of the operation being invoked. In the case of attribute accessors, the names are<code> _get_&lt;attribute&gt;</code> and <code>_set_&lt;attribute&gt;</code>. The case of the operation or attribute name must match the case of the operation name specified in the OMG IDL source for the interface being used.
</a><a name="2671">
 In the case of <code>CORBA::Object</code> operations that are defined in the CORBA Core (<a href="orbif2.html#109">"Object Reference Operations" on page &#32;7-2</a>) and that correspond to GIOP request messages, the operation names are <code>_interface</code>, <code>_implementation<a href="#2681"><sup>5</sup></a></code>, <code>_is_a</code> and <code>_not_existent</code>.<p>
</a><a name="1532">
<li><strong>requesting_principal </strong>contains a value identifying the requesting principal. It is provided to support the <code>BOA::get_principal</code> operation.
</a></ul><a name="401">
<h3>		 Request Body</h3>
</a><a name="402">
The request body includes the following items encoded in this order:<p>
</a><ul><a name="694">
<li>	All<strong> in</strong> and <strong>inout</strong> parameters, in the order in which they are specified in the operation's OMG IDL definition, from left to right. 
</a><a name="695">
<li>An optional <strong>Context</strong> pseudo object, encoded as described in <a href="giop.html#308">"Context" on page &#32;12-14</a>. This item is only included if the operation's OMG IDL definition includes a context expression, and only includes context members as defined in that expression.
</a></ul><a name="1447">
For example, the request body for the following OMG IDL operation<p>
</a><a name="1448">
<blockquote></blockquote>
</a><a name="1454">
<blockquote>	<strong>double example (in short m, out string str, inout Principal p);</strong></blockquote>
</a><a name="1449">
would be equivalent to this structure:<p>
</a><a name="1450">
<blockquote></blockquote>
</a><a name="1460">
 						<strong>struct example_body {</strong><p>
</a><a name="1451">
<blockquote><strong>						short						m;			// leftmost in or inout parameter</strong></blockquote>
</a><a name="1452">
<blockquote><strong>						Principal						p;			// ... to the rightmost</strong></blockquote>
</a><a name="1453">
 <strong>						};</strong><p>
</a><a name="404">
<h2>	12.4.2	 Reply Message</h2>
</a><a name="405">
Reply messages are sent in response to Request messages. Replies include inout and out parameters, operation results, and may include exception values. In addition, Reply messages may provide object location information. Replies flow from server to client.<p>
</a><a name="406">
<em>Reply</em> messages have three elements, encoded in this order:<p>
</a><ul><a name="699">
<li>A GIOP message header
</a><a name="700">
<li>A <em>ReplyHeader structure</em>
</a><a name="701">
<li>The reply body 
</a></ul><a name="407">
<h3>		 Reply Header</h3>
</a><a name="408">
The reply header is defined as follows:<p>
</a><a name="409">
<blockquote></blockquote>
</a><a name="712">
 module GIOP {																// IDL<p>
</a><a name="410">
<blockquote>						enum ReplyStatusType {</blockquote>
</a><a name="702">
<blockquote> 						NO_EXCEPTION,</blockquote>
</a><a name="703">
<blockquote> 						USER_EXCEPTION,</blockquote>
</a><a name="704">
<blockquote> 						SYSTEM_EXCEPTION,</blockquote>
</a><a name="705">
<blockquote> 						LOCATION_FORWARD</blockquote>
</a><a name="706">
<blockquote> 						};</blockquote>
</a><a name="711">
<blockquote></blockquote>
</a><a name="411">
<blockquote>						struct ReplyHeader {</blockquote>
</a><a name="2160">
<blockquote>						IOP::ServiceContextList								service_context;</blockquote>
</a><a name="707">
<blockquote> 						unsigned long 								request_id;</blockquote>
</a><a name="708">
<blockquote> 						ReplyStatusType								reply_status;</blockquote>
</a><a name="709">
<blockquote> 						};</blockquote>
</a><a name="710">
 };<p>
</a><a name="412">
The members have the following definitions:<p>
</a><ul><a name="413">
<li><strong>service_context</strong> contains ORB service data being passed from the server to the client, encoded as described in <a href="giop.html#223">"GIOP Message Transfer" on page &#32;12-3</a>.
</a><a name="2164">
<li><strong>request_id</strong> is used to associate replies with requests. It contains the same request_id value as the corresponding request.
</a><a name="1462">
<li><strong>reply_status</strong> indicates the completion status of the associated request, and also determines part of the reply body contents. If no exception occurred and the operation completed successfully, the value is <strong>NO_EXCEPTION</strong> and the body contains return values. Otherwise the body contains an exception, or else directs the client to reissue the request to an object at some other location.
</a></ul><a name="1463">
<h3>		 Reply Body</h3>
</a><a name="418">
The reply body format is controlled by the value of reply_status. There are three types of reply body:<p>
</a><ul><a name="202">
<li>	If the <strong>reply_status</strong> value is <strong>NO_EXCEPTION</strong>, the body is encoded as if it were a structure holding first any operation return value, then any <code>inout</code> and <code>out</code> parameters in the order in which they appear in the operation's OMG IDL definition, from left to right. (That structure could be empty.)
</a><a name="391">
<li>If the <strong>reply_status</strong> value is <strong>USER_EXCEPTION </strong>or <strong>SYSTEM_EXCEPTION</strong>, then the body contains the exception that was raised by the operation, encoded as described in <a href="giop.html#310">"Exception" on page &#32;12-14</a>. (Only the user defined exceptions listed in the operation's OMG IDL definition may be raised.)
</a><a name="420">
<li>If the <strong>reply_status</strong> value is <strong>LOCATION_FORWARD</strong>, then the body contains an object reference (IOR) encoded as described in <a href="giop.html#1630">"Object References" on page &#32;12-15</a>. The client ORB is responsible for re-sending the original request to that (different) object. This resending is transparent to the client program making the request.
</a></ul><a name="414">
For example, the reply body for a successful response (the value of <strong>reply_status</strong> is <strong>NO_EXCEPTION</strong>) to the <em>Request</em> example shown on <a href="giop.html#1454">page 12-18</a> would be equivalent to the following structure:<p>
</a><a name="1478">
<blockquote></blockquote>
</a><a name="1479">
 	<strong>struct example_reply {</strong><p>
</a><a name="1481">
<blockquote><strong>						double				return_value;					// return value</strong></blockquote>
</a><a name="1482">
<blockquote><strong>						string				str;					// leftmost inout or out 					parameter</strong></blockquote>
</a><a name="1483">
<blockquote><strong>						Principal				p;					// ... to the rightmost</strong></blockquote>
</a><a name="1480">
 <strong>	};</strong><p>
</a><a name="1466">
Note that the <strong>object_key</strong> field in any specific GIOP profile is server-relative, not absolute. Specifically, when a new object reference is received in a <strong>LOCATION_FORWARD</strong> <em>Reply</em> or in a <em>LocateReply</em> message, the <strong>object_key</strong><code> </code>field embedded in the new object reference's GIOP profile may not have the same value as the <strong>object_key</strong> in the GIOP profile of the original object reference. For details on location forwarding, see <a href="giop.html#496">"Object Location" on page &#32;12-25</a>.<p>
</a><a name="422">
<h2>	12.4.3	 CancelRequest Message</h2>
</a><a name="423">
<strong>CancelRequest</strong> messages may be sent from clients to servers. <strong>CancelRequest</strong> messages notify a server that the client is no longer expecting a reply for a specified pending <strong>Request</strong> or <strong>LocateRequest</strong> message.<p>
</a><a name="424">
<strong>CancelRequest</strong> messages have two elements, encoded in this order:<p>
</a><ul><a name="394">
<li>A GIOP message header
</a><a name="1917">
<li>A <em>CancelRequestHeader</em> 
</a></ul><a name="425">
<h3>		 Cancel Request Header</h3>
</a><a name="426">
The cancel request header is defined as follows:<p>
</a><a name="398">
 module GIOP {														// IDL<p>
</a><a name="428">
<blockquote>						struct CancelRequestHeader {</blockquote>
</a><a name="400">
<blockquote> 						unsigned long						request_id;</blockquote>
</a><a name="419">
<blockquote> 						};</blockquote>
</a><a name="698">
 };<p>
</a><a name="429">
The <strong>request_id </strong>member identifies the <strong>Request</strong> or <strong>LocateRequest</strong> message to which the cancel applies. This value is the same as the <strong>request_id</strong> value specified in the original <em>Request</em> or <em>LocateRequest</em> message.<p>
</a><a name="430">
When a client issues a cancel request message, it serves in an advisory capacity only. The server is not required to acknowledge the cancellation, and may subsequently send the corresponding reply. The client should have no expectation about whether a reply (including an exceptional one) arrives.<p>
</a><a name="431">
<h2>	12.4.4	 LocateRequest Message</h2>
</a><a name="432">
<strong>LocateRequest </strong>messages may be sent from a client to a server to determine the following regarding a specified object reference: 	<em>(a)</em> whether the object reference is valid, <code>(b)</code> 	whether the current server is capable of directly receiving requests for the object reference, and 	if not, <em>(c)</em> to what address requests for the object reference should be sent.<p>
</a><a name="1229">
Note that this information is also provided through the <strong>Request</strong> message, but that some clients might prefer not to support retransmission of potentially large messages that might be implied by a <strong>LOCATION_FORWARD</strong> status in a <strong>Reply</strong> message. That is, client use of this represents a potential optimization.<p>
</a><a name="433">
<strong>LocateRequest </strong>messages have two elements, encoded in this order:<p>
</a><ul><a name="716">
<li>A GIOP message header
</a><a name="718">
<li>A <em>LocateRequestHeader</em>
</a></ul><a name="719">
<h3>		 LocateRequest Header.</h3>
</a><a name="717">
The <strong>LocateRequest</strong> header is defined as follows:<p>
</a><a name="724">
 module GIOP {																// IDL<p>
</a><a name="720">
<blockquote>						struct LocateRequestHeader {</blockquote>
</a><a name="721">
<blockquote> 						unsigned long						request_id;</blockquote>
</a><a name="722">
<blockquote> 						sequence &lt;octet&gt;						object_key;</blockquote>
</a><a name="725">
<blockquote>						};</blockquote>
</a><a name="723">
 };<p>
</a><a name="435">
The members are defined as follows:<p>
</a><ul><a name="436">
<li><strong>request_id</strong> is used to associate <em>LocateReply</em> messages with <em>LocateRequest</em> ones. The client (requester) is responsible for generating values; see <a href="giop.html#2225">"Request Message" on page &#32;12-16</a> for the applicable rules.
</a><a name="438">
<li><strong>object_key</strong> identifies the object being located. In an IIOP context, this value is obtained from the <strong>object_key</strong> field from the encapsulated <strong>IIOP::ProfileBody</strong> in the IIOP profile of the IOR for the target object. When GIOP is mapped to other transports, their IOR profiles must also contain an appropriate corresponding value. This value is only meaningful to the server and is not interpreted or modified by the client. 
</a></ul><a name="440">
See <a href="giop.html#496">"Object Location" on page &#32;12-25</a> for details on the use of <strong>LocateRequest.</strong><p>
</a><a name="441">
<h2>	12.4.5	 LocateReply Message</h2>
</a><a name="442">
<strong>LocateReply</strong> messages are sent from servers to clients in response to <strong>LocateRequest</strong> messages.<p>
</a><a name="443">
A LocateReply message has three elements, encoded in this order:<p>
</a><ul><a name="737">
<li>A GIOP message header
</a><a name="1930">
<li>A <em>LocateReplyHeader</em>
</a><a name="1933">
<li>The locate reply body 
</a></ul><a name="444">
<h3>		 Locate Reply Header</h3>
</a><a name="445">
The locate reply header is defined as follows:<p>
</a><a name="726">
 module GIOP {														// IDL<p>
</a><a name="727">
<blockquote> 						enum LocateStatusType {</blockquote>
</a><a name="728">
<blockquote> 							UNKNOWN_OBJECT,</blockquote>
</a><a name="729">
<blockquote> 							OBJECT_HERE,</blockquote>
</a><a name="730">
<blockquote> 							OBJECT_FORWARD</blockquote>
</a><a name="731">
<blockquote> 						};</blockquote>
</a><a name="732">
<blockquote></blockquote>
</a><a name="447">
<blockquote>						struct LocateReplyHeader {</blockquote>
</a><a name="733">
<blockquote> 							unsigned long							request_id;</blockquote>
</a><a name="734">
<blockquote> 							LocateStatusType							locate_status;</blockquote>
</a><a name="735">
<blockquote> 						};</blockquote>
</a><a name="736">
 };<p>
</a><a name="448">
The members have the following definitions:<p>
</a><ul><a name="449">
<li><strong>request_id</strong> is used to associate replies with requests. This member contains the <code>same</code> <code>request_id</code> value as the corresponding <em>LocateRequest</em> message.
</a><a name="451">
<li><strong>locate_status.</strong> The value of this member is used to determine whether a <strong>LocateReply</strong> body exists. Values are:
</a><a name="452">
<li><strong>UNKNOWN_OBJECT </strong>The object specified in the corresponding <strong>LocateRequest</strong> message is unknown to the server; no body exists.
</a><a name="453">
<li><strong>OBJECT_HERE </strong>This server (the originator of the <strong>LocateReply</strong> message) can directly receive requests for the specified object; no body exists.
</a><a name="454">
<li><strong>OBJECT_FORWARD </strong>A <strong>LocateReply</strong> body exists.
</a></ul><a name="740">
<h3>		 LocateReply Body</h3>
</a><a name="741">
The body is empty unless the <strong>LocateStatus</strong> value is <strong>OBJECT_FORWARD</strong>, in which case the body contains an object reference (IOR) that may be used as the target for requests to the object specified in the LocateRequest message.<p>
</a><a name="455">
<h2>	12.4.6	 CloseConnection Message</h2>
</a><a name="456">
<strong>CloseConnection</strong> messages are sent only by servers. They inform clients that the server intends to close the connection and must not be expected to provide further responses. Moreover, clients know that any requests for which they awaiting replies will never be processed, and may safely be reissued (on another connection).<p>
</a><a name="457">
The <strong>CloseConnection </strong>message consists only of the GIOP message header, identifying the message type.<p>
</a><a name="437">
For details on the usage of <strong>CloseConnection </strong>messages, see <a href="giop.html#468">"Connection Management" on page &#32;12-24</a>.<p>
</a><a name="458">
<h2>	12.4.7	 MessageError Message</h2>
</a><a name="459">
The <strong>MessageError </strong>message is sent in response to any GIOP message whose version number or message type is unknown to the recipient, or any message is received whose header is not properly formed (e.g., has the wrong magic value). Error handling is context-specific.<p>
</a><a name="1480">
The <strong>MessageError</strong> message consists only of the GIOP message header, identifying the message type. <p>
</a><a name="1481">
<h1>	12.5	 GIOP Message Transport</h1>
</a><a name="1482">
The GIOP is designed to be implementable on a wide range of transport protocols. The GIOP definition makes the following assumptions regarding transport behavior:<p>
</a><ul><a name="463">
<li>	The transport is connection-oriented. GIOP uses connections to define the scope and extent of request IDs.
</a><a name="464">
<li>	The transport is reliable. Specifically, the transport guarantees that bytes are delivered in the order they are sent, at most once, and that some positive acknowledgment of delivery is available.
</a><a name="465">
<li>	The transport can be viewed as a byte stream. No arbitrary message size limitations, fragmentation, or alignments are enforced.
</a><a name="466">
<li>	The transport provides some reasonable notification of disorderly connection loss. If the peer process aborts, the peer host crashes, or network connectivity is lost, a connection owner should receive some notification of this condition.
</a><a name="467">
<li>	The transport's model for initiating connections can be mapped onto the general connection model of TCP/IP. Specifically, an agent (described herein as a server) publishes a known network address in an IOR, which is used by the client when initiating a connection.
</a></ul><a name="439">
The server does not actively initiate connections, but is prepared to accept requests to connect (i.e., it <em>listens</em> for connections in TCP/IP terms). Another agent that knows the address (called a client) can attempt to initiate connections by sending <em>connect</em> requests to the address. The listening server may <em>accept</em> the request, forming a new, unique connection with the client, or it may <em>reject</em> the request (e.g., due to lack of resources). Once a connection is open, either side may <em>close</em> the connection. (However, see <a href="giop.html#468">"Connection Management" on page &#32;12-24</a> for semantic issues related to connection closure.) A candidate transport might not directly support this specific connection model; it is only necessary that the transport's model can be mapped onto this view.<p>
</a><a name="468">
<h2>	12.5.1	 Connection Management</h2>
</a><a name="469">
For the purposes of this discussion, the roles client and server are defined as follows:<p>
</a><ul><a name="470">
<li>	A client initiates the connection, presumably using addressing information found in an object reference (IOR) for an object to which it intends to send requests. 
</a><a name="471">
<li>	A server accepts connections, but does not initiate them.
</a></ul><a name="472">
These terms only denote roles with respect to a connection. They do not have any implications for ORB or application architectures.<p>
</a><a name="473">
Connections are not symmetrical. Only clients can send <em>Request</em>, <em>LocateRequest</em>, and <em>CancelRequest</em> messages over a connection. Only a server can send <em>Reply, LocateReply</em> and <em>CloseConnection</em> messages over a connection. Either client or server can send <em>MessageError</em> messages.<p>
</a><a name="474">
Only GIOP messages are sent over GIOP connections.<p>
</a><a name="475">
Request IDs must unambiguously associate replies with requests within the scope and lifetime of a connection. Request IDs may be re-used if there is no possibility that the previous request using the ID may still have a pending reply. Note that cancellation does not guarantee no reply will be sent. It is the responsibility of the client to generate and assign request IDs. Request IDs must be unique among both <em>Request</em> and <em>LocateRequest</em> messages.<p>
</a><a name="476">
<h3>		 Connection Closure</h3>
</a><a name="477">
Connections can be closed in two ways: orderly shutdown, or abortive disconnect. Orderly shutdown is initiated by servers reliably sending a <strong>CloseConnection </strong>message, or by clients just closing down a connection. Orderly shutdown may be initiated by the client at any time. If there are pending requests when a client shuts down a connection, the server should consider all such requests canceled. A server may not initiate shutdown if it has begun processing any requests for which it has not either received a <em>CancelRequest</em> or sent a corresponding reply.<p>
</a><a name="478">
If a client receives an <strong>CloseConnection</strong> message from the server, it should assume that any outstanding messages (i.e., without replies) were received after the server sent the <em>CloseConnection</em> message, were not processed, and may be safely resent on a new connection.<p>
</a><a name="479">
After reliably issuing a <strong>CloseConnection</strong> message, the server may close the connection. Some transport protocols (not including TCP) do not provide an "orderly disconnect" capability, guaranteeing reliable delivery of the last message sent. When GIOP is used with such protocols an additional handshake needs to be provided to guarantee that both ends of the connection understand the disposition of any outstanding GIOP requests.<p>
</a><a name="480">
If a client detects connection closure without receiving a <strong>CloseConnection </strong>message, it should assume an abortive disconnect has occurred, and treat the condition as an error. Specifically, it should report COMM_FAILURE exceptions for all pending requests on the connection, with completion_status values set to COMPLETED_MAYBE.<p>
</a><a name="481">
<h3>		 Multiplexing Connections</h3>
</a><a name="482">
A client, if it chooses, may send requests to multiple target objects over the same connection, provided that the connection's server side is capable of responding to requests for the objects. It is the responsibility of the client to optimize resource usage by re-using connections, if it wishes. If not, the client may open a new connection for each active object supported by the server, although this behavior should be avoided. <p>
</a><a name="483">
<h2>	12.5.2	 Message Ordering</h2>
</a><a name="484">
Only the client (connection originator) may send <strong>Request, LocateRequest, and CancelRequest </strong>messages. Connections are not fully symmetrical.<p>
</a><a name="485">
Clients may have multiple pending requests. A client need not wait for a reply from a previous request before sending another request.<p>
</a><a name="486">
Servers may reply to pending requests in any order. <strong>Reply</strong> messages are not required to be in the same order as the corresponding <strong>Requests</strong>.<p>
</a><a name="487">
The ordering restrictions regarding connection closure mentioned in Connection Management, above, are also noted here. Servers may only issue <strong>CloseConnection</strong> messages when <strong>Reply </strong>messages have been sent in response to all received <strong>Request</strong> messages that require replies.<p>
</a><a name="496">
<h1>	12.6	 Object Location</h1>
</a><a name="497">
The GIOP is defined to support object migration and location services without dictating the existence of specific ORB architectures or features. The protocol features are based on the following observations:<p>
</a><a name="498">
A given transport address does not necessarily correspond to any specific ORB architectural component (such as an <em>object adapter</em>, <em>object server process</em>, <em>Inter-ORB bridge</em>, and so forth). It merely implies the existence of some agent with which a connection may be opened, and to which requests may be sent.<p>
</a><a name="499">
The "agent" (owner of the server side of a connection) may have one of the following roles with respect to a particular object reference:<p>
</a><ul><a name="500">
<li>	The agent may be able to accept object requests directly for the object and return replies. The agent may or may not own the actual object implementation; it may be an Inter-ORB bridge that transforms the request and passes it on to another process or ORB. From GIOP's perspective, it is only important that requests can be sent directly to the agent.
</a><a name="501">
<li>	The agent may not be able to accept direct requests for any objects, but acts instead as a location service. Any Request messages sent to the agent would result in either exceptions or replies with LOCATION_FORWARD status, providing new addresses to which requests may be sent. Such agents would also respond to <em>LocateRequest</em> messages with appropriate LocateReply messages.
</a><a name="502">
<li>	The agent may directly respond to some requests (for certain objects) and provide forwarding locations for other objects.
</a><a name="503">
<li>	The agent may directly respond to requests for a particular object at one point in time, and provide a forwarding location at a later time (perhaps during the same connection). 
</a></ul><a name="3001">
Agents are not required to implement location forwarding mechanisms. An agent can be implemented with the policy that a connection either supports direct access to an object, or returns exceptions. Such an ORB (or inter-ORB bridge) always return LocateReply messages with either <strong>OBJECT_HERE</strong> or <strong>UNKNOWN_OBJECT</strong> status, and never <strong>OBJECT_FORWARD</strong><strong> </strong>status.<p>
</a><a name="505">
Clients must, however, be able to accept and process <strong>Reply</strong> messages with <code>LOCATION_FORWARD</code> status, since any ORB may choose to implement a location service. Whether a client chooses to send <em>LocationRequest</em> messages is at the discretion of the client. For example, if the client routinely expected to see <code>LOCATION_FORWARD</code> replies when using the address in an object reference, it might always send <em>LocateRequest</em> messages to objects for which it has no recorded forwarding address. If a client sends <em>LocateRequest</em> messages, it should (obviously) be prepared to accept <em>LocateReply</em> messages.<p>
</a><a name="506">
A client should not make any assumptions about the longevity of object addresses returned by location forwarding mechanisms. Once a connection based on location forwarding information is closed, subsequent attempts to send requests to the same object should start with the original address specified in the initial object reference.<p>
</a><a name="1319">
Even after performing successful invocations using an address, a client should be prepared to be forwarded. The only object address that a client should expect to continue working reliably is the one in the initial object reference. If an invocation using that address returns <strong>UNKNOWN_OBJECT</strong>, the object should be deemed non-existent.<p>
</a><a name="508">
In general, the implementation of location forwarding mechanisms is at the discretion of ORBs, available to be used for optimization and to support flexible object location and migration behaviors.<p>
</a><a name="1825">
<h1>	12.7	 Internet Inter-ORB Protocol (IIOP)</h1>
</a><a name="1829">
The baseline transport specified for GIOP is TCP/IP<a href="#1828"><sup>6</sup></a>. Specific APIs for libraries supporting TCP/IP may vary, so this discussion is limited to an abstract view of TCP/IP and management of its connections. The mapping of GIOP message transfer to TCP/IP connections is called the Internet Inter-ORB Protocol (IIOP).<p>
</a><a name="1841">
<h2>	12.7.1	 TCP/IP Connection Usage</h2>
</a><a name="1830">
Agents that are capable of accepting object requests or providing locations for objects (i.e., servers) publish TCP/IP addresses in IORs, as described in <a href="giop.html#1846">"IIOP IOR Profiles" on page &#32;12-27</a>. A TCP/IP address consists of an IP host address, typically represented by a host name, and a TCP port number. Servers must listen for connection requests.<p>
</a><a name="1834">
A client needing a object's services must initiate a connection with the address specified in the IOR, with a connect request.<p>
</a><a name="1835">
The listening server may accept or reject the connection. In general, servers should accept connection requests if possible, but ORBs are free to establish any desired policy for connection acceptance (e.g., to enforce fairness or optimize resource usage).<p>
</a><a name="1836">
Once a connection is accepted, the client may send <strong>Request, LocateRequest</strong>, or <strong>CancelRequest</strong> messages by writing to the TCP/IP socket it owns for the connection. The server may send <strong>Reply, LocateReply</strong>, and <strong>CloseConnection</strong> messages by writing to its TCP/IP connection.<p>
</a><a name="1837">
After sending (or receiving) a <strong>CloseConnection</strong> message, both client or server must close the TCP/IP connection.<p>
</a><a name="1838">
Given TCP/IP's flow control mechanism, it is possible to create deadlock situations between clients and servers if both sides of a connection send large amounts of data on a connection (or two different connections between the same processes) and do not read incoming data. Both processes may block on write operations, and never resume. It is the responsibility of both clients and servers to avoid creating deadlock by reading incoming messages and avoiding blocking when writing messages, by providing separate threads for reading and writing, or any other workable approach. ORBs are free to adopt any desired implementation strategy, but should provide robust behavior.<p>
</a><a name="1846">
<h2>	12.7.2	 IIOP IOR Profiles</h2>
</a><a name="1871">
IIOP profiles, identifying individual objects accessible through the Internet Inter_ORB Protocol, have the following form:<p>
</a><a name="1848">
 module IIOP {													// IDL<p>
</a><a name="1849">
<blockquote>						struct Version {</blockquote>
</a><a name="1850">
<blockquote> 							char					major;</blockquote>
</a><a name="1851">
<blockquote> 							char					minor;</blockquote>
</a><a name="1852">
<blockquote> 						};</blockquote>
</a><a name="1853">
<blockquote></blockquote>
</a><a name="1854">
<blockquote>						struct ProfileBody {</blockquote>
</a><a name="1855">
<blockquote> 						Version					iiop_version;</blockquote>
</a><a name="1856">
<blockquote>							string					host;</blockquote>
</a><a name="1857">
<blockquote> 							unsigned short					port;</blockquote>
</a><a name="1858">
<blockquote> 							sequence &lt;octet&gt;					object_key;</blockquote>
</a><a name="1859">
<blockquote>					 	};</blockquote>
</a><a name="1860">
 };<p>
</a><a name="1861">
An instance of the <strong>IIOP::ProfileBody</strong> type is marshaled into an encapsulation octet stream. This encapsulation (a <strong>sequence&lt;octet&gt;</strong>) becomes the <strong>profile_data</strong> member of the <strong>IOR::TaggedProfile s</strong>tructure representing the IIOP profile in an IOR, and the <code>tag</code> has the value <strong>TAG_INTERNET_IOP</strong> (as defined earlier).<p>
</a><a name="1862">
The members of <strong>IIOP::ProfileBody </strong>are defined as follows:<p>
</a><ul><a name="1863">
<li><strong>iiop_version </strong>describes the version of IIOP that the agent at the specified address is prepared to receive. When an agent generates IIOP profiles specifying a particular version, it must be able to accept messages complying with the specified version or any previous minor version (i.e., any smaller version number). The major version number of this specification is one (1); the minor version is zero (0). Note that this value is not equivalent to the GIOP version number specified in GIOP message headers. Transport-specific elements of the IIOP specification may change independently from the GIOP specification.
</a><a name="1864">
<li><strong>host</strong> identifies the Internet host to which GIOP messages for the specified object may be sent. In order to promote a very large (Internet-wide) scope for the object reference, this will typically be the fully qualified domain name of the host, rather than an unqualified (or partially qualified) name. However, per Internet standards, the host string may also contain a host address expressed in standard "dotted decimal" form (e.g., "192.231.79.52").
</a><a name="1865">
<li><em></em><strong>port</strong> contains the TCP/IP port number (at the specified host) where the target agent is listening for connection requests. The agent must be ready to process IIOP messages on connections accepted at this port.
</a><a name="1958">
<li><em></em><strong>object_key </strong>is an opaque value supplied by the agent producing the IOR. This value will be used in request messages to identify the object to which the request is directed. An agent that generates an object key value must be able to map the value unambiguously onto the corresponding object when routing requests internally.
</a></ul><a name="1867">
Note that host addresses are restricted in this version of IIOP to be Class A, B, or C Internet addresses. That is, Class D (multi-cast) addresses are not allowed. Such addresses are reserved for use in future versions of IIOP.<p>
</a><a name="1868">
Also, note that at this time no "well known" port number has been allocated, so individual agents will need to assign previously unused ports as part of their installation procedures. IIOP supports multiple such agents per host.<p>
</a><a name="1844">
<h1>	12.8	 OMG IDL for the GIOP and IIOP Specifications</h1>
</a><a name="2165">
This section contains the OMG IDL for the GIOP and IIOP modules.<p>
</a><a name="2169">
<h2>	12.8.1	 GIOP Module</h2>
</a><a name="1995">
 module GIOP {														// IDL<p>
</a><a name="1996">
<blockquote>						enum MsgType {</blockquote>
</a><a name="1997">
<blockquote>								Request, Reply, CancelRequest,</blockquote>
</a><a name="1998">
<blockquote>								LocateRequest, LocateReply,</blockquote>
</a><a name="1999">
<blockquote>								CloseConnection, MessageError</blockquote>
</a><a name="2000">
<blockquote>						};</blockquote>
</a><a name="2001">
<blockquote></blockquote>
</a><a name="2002">
<blockquote>						struct MessageHeader {</blockquote>
</a><a name="2003">
<blockquote>								char								magic [4];</blockquote>
</a><a name="2004">
<blockquote>								Version								GIOP_version;</blockquote>
</a><a name="2005">
<blockquote> 								boolean								byte_order;</blockquote>
</a><a name="2006">
<blockquote> 								octet								message_type;</blockquote>
</a><a name="2007">
<blockquote> 								unsigned long								message_size;</blockquote>
</a><a name="2008">
<blockquote> 						};</blockquote>
</a><a name="2040">
<blockquote></blockquote>
</a><a name="2146">
<blockquote>						struct RequestHeader {</blockquote>
</a><a name="2041">
<blockquote> 								IOP::ServiceContextList								service_context;</blockquote>
</a><a name="2042">
<blockquote>								unsigned long					 			request_id;</blockquote>
</a><a name="2043">
<blockquote> 								boolean								response_expected;</blockquote>
</a><a name="2044">
<blockquote>						 		sequence &lt;octet&gt;								object_key;</blockquote>
</a><a name="2045">
<blockquote> 								string								operation;</blockquote>
</a><a name="2046">
<blockquote>						 		Principal								requesting_principal;</blockquote>
</a><a name="2047">
<blockquote> 						};</blockquote>
</a><a name="2048">
 <p>
</a><a name="2060">
<blockquote>						enum ReplyStatusType {</blockquote>
</a><a name="2061">
<blockquote> 								NO_EXCEPTION,</blockquote>
</a><a name="2062">
<blockquote>								USER_EXCEPTION,</blockquote>
</a><a name="2063">
<blockquote> 								SYSTEM_EXCEPTION,</blockquote>
</a><a name="2064">
<blockquote>						 		LOCATION_FORWARD</blockquote>
</a><a name="2065">
<blockquote> 						};</blockquote>
</a><a name="2066">
<blockquote></blockquote>
</a><a name="2067">
<blockquote>						struct ReplyHeader {</blockquote>
</a><a name="2068">
<blockquote>								IOP::ServiceContextList										service_context;</blockquote>
</a><a name="2069">
<blockquote> 								unsigned long 										request_id;</blockquote>
</a><a name="2070">
<blockquote> 								ReplyStatusType										reply_status;</blockquote>
</a><a name="2071">
<blockquote> 	};</blockquote>
</a><a name="2082">
<blockquote></blockquote>
</a><a name="2155">
<blockquote>						struct CancelRequestHeader {</blockquote>
</a><a name="2083">
<blockquote> 								unsigned long										request_id;</blockquote>
</a><a name="2084">
<blockquote> 	};</blockquote>
</a><a name="2096">
<blockquote></blockquote>
</a><a name="2160">
<blockquote>						struct LocateRequestHeader {</blockquote>
</a><a name="2097">
<blockquote> 								unsigned long										request_id;</blockquote>
</a><a name="2098">
<blockquote> 								sequence &lt;octet&gt;										object_key;</blockquote>
</a><a name="2099">
<blockquote>						};</blockquote>
</a><a name="2117">
<blockquote>						</blockquote>
</a><a name="2164">
<blockquote>						enum LocateStatusType {</blockquote>
</a><a name="2118">
<blockquote> 								UNKNOWN_OBJECT,</blockquote>
</a><a name="2119">
<blockquote> 								OBJECT_HERE,</blockquote>
</a><a name="2120">
<blockquote> 								OBJECT_FORWARD</blockquote>
</a><a name="2121">
<blockquote>					 	};</blockquote>
</a><a name="2122">
<blockquote></blockquote>
</a><a name="2123">
<blockquote>						struct LocateReplyHeader {</blockquote>
</a><a name="2124">
<blockquote> 								unsigned long										request_id;</blockquote>
</a><a name="2125">
<blockquote> 								LocateStatusType										locate_status;</blockquote>
</a><a name="2126">
<blockquote> 						};</blockquote>
</a><a name="2127">
 };<p>
</a><a name="2018">
<p>
</a><a name="2134">
<h2>	12.8.2	 IIOP Module</h2>
</a><a name="2178">
 module IIOP {															\\ IDL<p>
</a><a name="2179">
<blockquote>						struct Version {</blockquote>
</a><a name="2180">
<blockquote> 							char						major;</blockquote>
</a><a name="2181">
<blockquote> 							char						minor;</blockquote>
</a><a name="2182">
<blockquote>					 	};</blockquote>
</a><a name="2183">
<blockquote></blockquote>
</a><a name="2184">
<blockquote>						struct ProfileBody {</blockquote>
</a><a name="2185">
<blockquote> 							Version						iiop_version;</blockquote>
</a><a name="2186">
<blockquote> 							string						host;</blockquote>
</a><a name="2187">
<blockquote> 							unsigned short						port;</blockquote>
</a><a name="2188">
<blockquote> 							sequence &lt;octet&gt;						object_key;</blockquote>
</a><a name="2189">
<blockquote>					 	};</blockquote>
</a><a name="2764">
<blockquote></blockquote>
</a><a name="2765">
<blockquote></blockquote>
</a><a name="2766">
 };<p>
</a><a name="2170">
<p>
</a>
<hr><br>
 
<a href="cover.html">[Top]</a> <a href="bridge.html">[Prev]</a> <a href="dceciop.html">[Next]</a> <a href="corb2pra.html">[Bottom]</a>
<hr><br>
 
<sup>1</sup><a name="1855">
 "IEEE Standard for Binary Floating-Point Arithmetic", ANSI/IEEE Standard 754-1985, Institute of Electrical and Electronics Engineers, August 1985.<p>
</a><sup>2</sup><a name="1919">
 Accordingly, in cases where encapsulated data holds data with natural alignment of greater than four octets, some processors may need to copy the octet data before removing it from the encapsulation. The GIOP protocol itself does not require encapsulation of such data. <p>
</a><sup>3</sup><a name="2382">
 This means that, for example, two OMG IDL unions that are textually equivalent, except that one uses a "char" discriminant, and the other uses a "long" one, would have different size encoded TypeCodes.<p>
</a><sup>4</sup><a name="1427">
 Compiled stubs are guaranteed to know how to unmarshal all exceptions. As of this writing, there are recognized problems with the language mappings for the DII in that they can not provide the ORB core with the same amount of information that can be provided to it by compiled stubs, unless an implementation of the DII consults an Interface Repository. Those mappings are being revised to address this issue.<p>
</a><sup>5</sup><a name="2681">
 Since CORBA::Object::get_implementation is a null interface, clients must narrow the object reference they get to some ORB-specific kind of ImplementationDef.<p>
</a><sup>6</sup><a name="1828">
 Postel, J., "Transmission Control Protocol - DARPA Internet Program Protocol Specification", RFC-793, Information Sciences Institute, September 1981<p>
</a>

<address>
<a href="mailto:pubs@omg.org">pubs@omg.org</a>
</address>

<i>Copyright &#169; 1995, <a href="http://www.omg.org">Object Management Group.</a>  All rights
reserved.</i>

<!-- This file was created with Quadralay WebWorks Publisher 3.0.4 -->
<!-- -->
<!-- For more information on how this document, and how the rest of -->
<!-- this server was created, email pubs@omg.org -->
<!-- -->
<!-- Last updated: 06/10/96 08:49:01 -->

</body>
</html>
