<html><head><title></title></head>
<body bgcolor=#ffffff>
 
<a href="cover.html">[Top]</a> <a href="arch2.html">[Prev]</a> <a href="dii2.html">[Next]</a> <a href="corb2pra.html">[Bottom]</a>
<hr><br>
 
<a name="307">
<h1> OMG IDL Syntax and Semantics</h1>
</a><dl>
<p align=right clear=all>
<b><font size=7>
3 
</font></b>
</p>
<hr><a name="308">
 <p>
</a></dl>
<a name="309">
The OMG Interface Definition Language is the language used to describe the interfaces that client objects call and object implementations provide. An interface definition written in OMG IDL completely defines the interface and fully specifies each operation's parameters. An OMG IDL interface provides the information needed to develop clients that use the interface's operations. Clients are not written in OMG IDL, which is purely a descriptive language, but in languages for which mappings from OMG IDL concepts have been defined. The mapping of an OMG IDL concept to a client language construct will depend on the facilities available in the client language. For example, an OMG IDL exception might be mapped to a structure in a language that has no notion of exception, or to an exception in a language that does. The binding of OMG IDL concepts to the C, C++, and Smalltalk languages are described in this manual.  Bindings from OMG IDL to additional programming languages will be added to future versions of <em>COBRA</em>. <p>
</a><a name="2128">
OMG IDL obeys the same lexical rules as C++<a href="#531"><sup>1</sup></a>, although new keywords are introduced to support distribution concepts. It also provides full support for standard C++ preprocessing features. The OMG IDL specification is expected to track relevant changes to C++ introduced by the ANSI standardization effort. <p>
</a><a name="2159">
<h1>	3.1	 About This Chapter</h1>
</a><a name="786">
The description of OMG IDL's lexical conventions is presented in <a href="idlsyn.html#694">"Lexical Conventions" on page &#32;3-2</a>. A description of OMG IDL preprocessing is presented in <a href="idlsyn.html#354">"Preprocessing" on page &#32;3-8</a>. The scope rules for identifiers in an OMG IDL specification are described in <a href="idlsyn.html#1302">"CORBA Module" on page &#32;3-31</a>.<p>
</a><a name="311">
The OMG IDL grammar is a subset of the proposed ANSI C++ standard, with additional constructs to support the operation invocation mechanism. OMG IDL is a declarative language. It supports C++ syntax for constant, type, and operation declarations; it does not include any algorithmic structures or variables. The grammar is presented in  <a href="idlsyn.html#360">"OMG IDL Grammar" on page &#32;3-9</a>.<p>
</a><a name="312">
OMG IDL-specific pragmas (those not defined for C++) may appear anywhere in a specification; the textual location of these pragmas may be semantically constrained by a particular implementation.<p>
</a><a name="785">
A source file containing interface specifications written in OMG IDL must have an ".idl" extension. The file orb.idl, which contains OMG IDL type definitions and is available on every ORB implementation, is described in Appendix <a href="appxtype.html#916">A</a>. <p>
</a><a name="313">
This chapter describes OMG IDL semantics and gives the syntax for OMG IDL grammatical constructs. The description of OMG IDL grammar uses a syntax notation that is similar to Extended Backus-Naur format (EBNF); <a href="idlsyn.html#313">Figure 1 on page 3-2</a> lists the symbols used in this format and their meaning. 
<Table Border="3">
<caption><a name="295">
TABLE 1.  IDL EBNF Format <p>
</a></caption>
<tr><th><a name="316">
 Symbol<p>
</a><th><a name="505">
 Meaning<p>
</a>
<tr><td><a name="580">
 ::=<p>
</a><td><a name="581">
 Is defined to be<p>
</a>
<tr><td><a name="587">
 |<p>
</a><td><a name="691">
 Alternatively<p>
</a>
<tr><td><a name="692">
 &lt;text&gt;<p>
</a><td><a name="695">
 Non-terminal<p>
</a>
<tr><td><a name="696">
 "text"<p>
</a><td><a name="697">
 Literal<p>
</a>
<tr><td><a name="814">
 *<p>
</a><td><a name="816">
 The preceding syntactic unit can be repeated zero or more times<p>
</a>
<tr><td><a name="817">
 +<p>
</a><td><a name="818">
 The preceding syntactic unit can be repeated one or more times<p>
</a>
<tr><td><a name="821">
 {}<p>
</a><td><a name="822">
 The enclosed syntactic units are grouped as a single syntactic unit<p>
</a>
<tr><td><a name="823">
 []<p>
</a><td><a name="824">
 The enclosed syntactic unit is optional-may occur zero or one time<p>
</a>

</Table>

<Table>
<tr><td>
</Table>
<p>
</a><a name="694">
<h1>	3.2	 Lexical Conventions</h1>
</a><a name="317">
This section<a href="#305"><sup>2</sup></a> presents the lexical conventions of OMG IDL. It defines tokens in an OMG IDL specification and describes comments, identifiers, keywords, and literals-integer, character, and floating point constants and string literals.<p>
</a><a name="318">
An OMG IDL specification logically consists of one or more files. A file is conceptually translated in several phases.<p>
</a><a name="727">
The first phase is preprocessing, which performs file inclusion and macro substitution. Preprocessing is controlled by directives introduced by lines having # as the first character other than white space. The result of preprocessing is a sequence of tokens. Such a sequence of tokens, that is, a file after preprocessing, is called a translation unit.<p>
</a><a name="918">
OMG IDL uses the ISO Latin-1 (8859.1) character set. This character set is divided into alphabetic characters (letters), digits, graphic characters, the space (blank) character and formatting characters. <a href="idlsyn.html#918">Figure 2 on page 3-3</a> shows the OMG IDL alphabetic characters; upper- and lower-case equivalencies are paired.  
<Table Border="3">
<caption><a name="693">
TABLE 2.  The 114 Alphabetic Characters (Letters) <p>
</a></caption>
<tr><th><a name="828">
 Char.<p>
</a><th><a name="829">
 Description<p>
</a><th><a name="830">
 Char.<p>
</a><th><a name="831">
 Description<p>
</a>
<tr><td><a name="832">
 Aa<p>
</a><td><a name="833">
 Upper/Lower-case A <p>
</a><td><a name="840">
 &Agrave;&agrave;<p>
</a><td><a name="841">
 Upper/Lower-case A with grave accent<p>
</a>
<tr><td><a name="843">
 Bb<p>
</a><td><a name="844">
 Upper/Lower-case B <p>
</a><td><a name="846">
 &Aacute;&aacute;<p>
</a><td><a name="848">
 Upper/Lower-case A with acute accent<p>
</a>
<tr><td><a name="849">
 Cc<p>
</a><td><a name="850">
 Upper/Lower-case C<p>
</a><td><a name="851">
 &Acirc;&acirc;<p>
</a><td><a name="852">
 Upper/Lower-case A with circumflex accent<p>
</a>
<tr><td><a name="856">
 Dd<p>
</a><td><a name="857">
 Upper/Lower-case D<p>
</a><td><a name="860">
 &Atilde;&atilde;<p>
</a><td><a name="876">
 Upper/Lower-case A with tilde<p>
</a>
<tr><td><a name="878">
 Ee<p>
</a><td><a name="883">
 Upper/Lower-case E<p>
</a><td><a name="886">
 &Auml;&auml;<p>
</a><td><a name="888">
 Upper/Lower-case A with diaeresis<p>
</a>
<tr><td><a name="890">
 Ff<p>
</a><td><a name="891">
 Upper/Lower-case F<p>
</a><td><a name="893">
 &Aring;&aring;<p>
</a><td><a name="894">
 Upper/Lower-case A with ring above<p>
</a>
<tr><td><a name="896">
 Gg<p>
</a><td><a name="897">
 Upper/Lower-case G<p>
</a><td><a name="899">
 &AElig;&aelig;<p>
</a><td><a name="900">
 Upper/Lower-case dipthong A with E<p>
</a>
<tr><td><a name="901">
 Hh<p>
</a><td><a name="902">
 Upper/Lower-case H<p>
</a><td><a name="903">
 &Ccedil;&ccedil;<p>
</a><td><a name="904">
 Upper/Lower-case C with cedilla<p>
</a>
<tr><td><a name="905">
 Ii<p>
</a><td><a name="906">
 Upper/Lower-case I<p>
</a><td><a name="907">
 &Egrave;&egrave;<p>
</a><td><a name="908">
 Upper/Lower-case E with grave accent<p>
</a>
<tr><td><a name="909">
 Jj<p>
</a><td><a name="910">
 Upper/Lower-case J<p>
</a><td><a name="912">
 &Eacute;&eacute;<p>
</a><td><a name="913">
 Upper/Lower-case E with acute accent<p>
</a>
<tr><td><a name="914">
 Kk<p>
</a><td><a name="915">
 Upper/Lower-case K<p>
</a><td><a name="916">
 &Ecirc;&ecirc;<p>
</a><td><a name="917">
 Upper/Lower-case E with circumflex accent<p>
</a>
<tr><td><a name="919">
 Ll<p>
</a><td><a name="920">
 Upper/Lower-case L<p>
</a><td><a name="921">
 &Euml;&euml;<p>
</a><td><a name="922">
 Upper/Lower-case E with diaeresis<p>
</a>
<tr><td><a name="923">
 Mm<p>
</a><td><a name="924">
 Upper/Lower-case M<p>
</a><td><a name="925">
 &Igrave;&igrave;<p>
</a><td><a name="926">
 Upper/Lower-case I with grave accent<p>
</a>
<tr><td><a name="927">
 Nn<p>
</a><td><a name="928">
 Upper/Lower-case N<p>
</a><td><a name="929">
 &Iacute;&iacute;<p>
</a><td><a name="930">
 Upper/Lower-case I with acute accent<p>
</a>
<tr><td><a name="931">
 Oo<p>
</a><td><a name="932">
 Upper/Lower-case O<p>
</a><td><a name="933">
 &Icirc;&icirc;<p>
</a><td><a name="934">
 Upper/Lower-case I with circumflex accent<p>
</a>
<tr><td><a name="936">
 Pp<p>
</a><td><a name="937">
 Upper/Lower-case P<p>
</a><td><a name="938">
 &Iuml;&iuml;<p>
</a><td><a name="939">
 Upper/Lower-case I with diaeresis<p>
</a>
<tr><td><a name="941">
 Qq<p>
</a><td><a name="942">
 Upper/Lower-case Q<p>
</a><td><a name="943">
 <p>
</a><td><a name="944">
 Upper/Lower-case Icelandic eth<p>
</a>
<tr><td><a name="945">
 Rr<p>
</a><td><a name="946">
 Upper/Lower-case R<p>
</a><td><a name="947">
 &Ntilde;&ntilde;<p>
</a><td><a name="948">
 Upper/Lower-case N with tilde<p>
</a>
<tr><td><a name="949">
 Ss<p>
</a><td><a name="950">
 Upper/Lower-case S<p>
</a><td><a name="951">
 &Ograve;&ograve;<p>
</a><td><a name="952">
 Upper/Lower-case O with grave accent<p>
</a>
<tr><td><a name="953">
 Tt<p>
</a><td><a name="954">
 Upper/Lower-case T<p>
</a><td><a name="955">
 &Oacute;&oacute;<p>
</a><td><a name="956">
 Upper/Lower-case O with acute accent<p>
</a>
<tr><td><a name="957">
 Uu<p>
</a><td><a name="958">
 Upper/Lower-case U<p>
</a><td><a name="959">
 &Ocirc;&ocirc;<p>
</a><td><a name="960">
 Upper/Lower-case O with circumflex accent<p>
</a>
<tr><td><a name="961">
 Vv<p>
</a><td><a name="962">
 Upper/Lower-case V<p>
</a><td><a name="963">
 &Otilde;&otilde;<p>
</a><td><a name="964">
 Upper/Lower-case O with tilde<p>
</a>
<tr><td><a name="965">
 Ww<p>
</a><td><a name="966">
 Upper/Lower-case W<p>
</a><td><a name="967">
 &Ouml;&ouml;<p>
</a><td><a name="969">
 Upper/Lower-case O with diaeresis<p>
</a>
<tr><td><a name="970">
 Xx<p>
</a><td><a name="974">
 Upper/Lower-case X<p>
</a><td><a name="975">
 &Oslash;&oslash;<p>
</a><td><a name="977">
 Upper/Lower-case O with oblique stroke<p>
</a>
<tr><td><a name="978">
 Yy<p>
</a><td><a name="979">
 Upper/Lower-case Y<p>
</a><td><a name="980">
 &Ugrave;&ugrave;<p>
</a><td><a name="1009">
 Upper/Lower-case U with grave accent<p>
</a>
<tr><td><a name="1011">
 Zz<p>
</a><td><a name="1012">
 Upper/Lower-case Z<p>
</a><td><a name="1014">
 &Uacute;&uacute;<p>
</a><td><a name="1023">
 Upper/Lower-case U with acute accent<p>
</a>
<tr><td><a name="1024">
 <p>
</a><td><a name="1025">
 <p>
</a><td><a name="1026">
 &Ucirc;&ucirc;<p>
</a><td><a name="1027">
 Upper/Lower-case U with circumflex accent<p>
</a>
<tr><td><a name="1028">
 <p>
</a><td><a name="1029">
 <p>
</a><td><a name="1030">
 &Uuml;&uuml;<p>
</a><td><a name="1031">
 Upper/Lower-case U with diaeresis<p>
</a>
<tr><td><a name="1032">
 <p>
</a><td><a name="1033">
 <p>
</a><td><a name="1034">
 <p>
</a><td><a name="1035">
 Upper/Lower-case Y with acute accent<p>
</a>
<tr><td><a name="1036">
 <p>
</a><td><a name="1037">
 <p>
</a><td><a name="1038">
 <p>
</a><td><a name="1039">
 Upper/Lower-case Icelandic thorn<p>
</a>
<tr><td><a name="1040">
 <p>
</a><td><a name="1041">
 <p>
</a><td><a name="1042">
  &#223;<p>
</a><td><a name="1043">
 Lower-case German sharp S<p>
</a>
<tr><td><a name="452">
 <p>
</a><td><a name="792">
 <p>
</a><td><a name="793">
  &yuml;<p>
</a><td><a name="1286">
 Lower-case Y with diaeresis<p>
</a>
<tr><td colspan=4 rowspan=1><a name="1045">
 <em></em><p>
</a>

</Table>

<Table>
<tr><td>
</Table>
<p>
</a><a name="971">
<a href="idlsyn.html#971">Figure 3 on page 3-4</a> lists the decimal digit characters.  
<Table Border="3">
<caption><a name="293">
TABLE 3.  Decimal Digits<p>
</a></caption>
<tr><td><a name="306">
 0 1 2 3 4 5 6 7 8 9<p>
</a>

</Table>

<Table>
<tr><td>
</Table>
<p>
</a><a name="735">
<a href="idlsyn.html#735">Figure 4 on page 3-4</a> shows the graphic characters.  
<Table Border="3">
<caption><a name="1187">
TABLE 4.  The 65 Graphic Characters <p>
</a></caption>
<tr><th><a name="319">
 Char.<p>
</a><th><a name="729">
 Description<p>
</a><th><a name="731">
 Char.<p>
</a><th><a name="732">
 Description<p>
</a>
<tr><td><a name="734">
 !<p>
</a><td><a name="968">
 exclamation point<p>
</a><td><a name="972">
 &#161;<p>
</a><td><a name="973">
 inverted exclamation mark<p>
</a>
<tr><td><a name="981">
 "<p>
</a><td><a name="982">
 double quote<p>
</a><td><a name="983">
 &#162;<p>
</a><td><a name="984">
 cent sign<p>
</a>
<tr><td><a name="985">
 #<p>
</a><td><a name="986">
 number sign<p>
</a><td><a name="987">
 &#163;<p>
</a><td><a name="988">
 pound sign<p>
</a>
<tr><td><a name="989">
 $<p>
</a><td><a name="990">
 dollar sign<p>
</a><td><a name="991">
 &#164;<p>
</a><td><a name="992">
 currency sign<p>
</a>
<tr><td><a name="993">
 %<p>
</a><td><a name="994">
 percent sign<p>
</a><td><a name="995">
 &#165;<p>
</a><td><a name="996">
 yen sign<p>
</a>
<tr><td><a name="997">
 &amp;<p>
</a><td><a name="998">
 ampersand<p>
</a><td><a name="999">
 <p>
</a><td><a name="1000">
 broken bar<p>
</a>
<tr><td><a name="1001">
 '<p>
</a><td><a name="1002">
 apostrophe<p>
</a><td><a name="1003">
 &#167;<p>
</a><td><a name="1004">
 section/paragraph sign<p>
</a>
<tr><td><a name="1005">
 (<p>
</a><td><a name="1006">
 left parenthesis<p>
</a><td><a name="1007">
 &#168;<p>
</a><td><a name="1008">
 diaeresis<p>
</a>
<tr><td><a name="1010">
 )<p>
</a><td><a name="1048">
 right parenthesis<p>
</a><td><a name="1049">
 &#169;<p>
</a><td><a name="1050">
 copyright sign<p>
</a>
<tr><td><a name="1051">
 *<p>
</a><td><a name="1052">
 asterisk<p>
</a><td><a name="1053">
 &#170;<p>
</a><td><a name="1054">
 feminine ordinal indicator<p>
</a>
<tr><td><a name="1055">
 +<p>
</a><td><a name="1056">
 plus sign<p>
</a><td><a name="1057">
 &#171;<p>
</a><td><a name="1058">
 left angle quotation mark<p>
</a>
<tr><td><a name="1059">
 ,<p>
</a><td><a name="1060">
 comma<p>
</a><td><a name="1061">
 &#172;<p>
</a><td><a name="1062">
 not sign<p>
</a>
<tr><td><a name="1063">
 -<p>
</a><td><a name="1064">
 hyphen, minus sign<p>
</a><td><a name="1065">
 <p>
</a><td><a name="1066">
 soft hyphen<p>
</a>
<tr><td><a name="1067">
 .<p>
</a><td><a name="1068">
 period, full stop<p>
</a><td><a name="1069">
 &#174;<p>
</a><td><a name="1070">
 registered trade mark sign<p>
</a>
<tr><td><a name="1071">
 /<p>
</a><td><a name="1072">
 solidus<p>
</a><td><a name="1073">
 &#175;<p>
</a><td><a name="1074">
 macron<p>
</a>
<tr><td><a name="1075">
 :<p>
</a><td><a name="1076">
 colon<p>
</a><td><a name="1077">
 &#176;<p>
</a><td><a name="1078">
 ring above, degree sign<p>
</a>
<tr><td><a name="1079">
 ;<p>
</a><td><a name="1080">
 semicolon<p>
</a><td><a name="1081">
 &#177;<p>
</a><td><a name="1082">
 plus-minus sign<p>
</a>
<tr><td><a name="1083">
 &lt;<p>
</a><td><a name="1084">
 less-than sign<p>
</a><td><a name="1085">
 2<p>
</a><td><a name="1086">
 superscript two<p>
</a>
<tr><td><a name="1087">
 =<p>
</a><td><a name="1088">
 equals sign<p>
</a><td><a name="1089">
 3<p>
</a><td><a name="1090">
 superscript three<p>
</a>
<tr><td><a name="1091">
 &gt;<p>
</a><td><a name="1092">
 greater-than sign<p>
</a><td><a name="1093">
 &#180;<p>
</a><td><a name="1094">
 acute<p>
</a>
<tr><td><a name="1095">
 ?<p>
</a><td><a name="1096">
 question mark<p>
</a><td><a name="1097">
 &#181;<p>
</a><td><a name="1098">
 micro<p>
</a>
<tr><td><a name="1099">
 @<p>
</a><td><a name="1100">
 commercial at<p>
</a><td><a name="1101">
 &#182;<p>
</a><td><a name="1102">
 pilcrow<p>
</a>
<tr><td><a name="1103">
 [<p>
</a><td><a name="1104">
 left square bracket<p>
</a><td><a name="1105">
 &#183;<p>
</a><td><a name="1106">
 middle dot<p>
</a>
<tr><td><a name="1107">
 \<p>
</a><td><a name="1108">
 reverse solidus<p>
</a><td><a name="1109">
 &#184;<p>
</a><td><a name="1110">
 cedilla<p>
</a>
<tr><td><a name="1111">
 ]<p>
</a><td><a name="1112">
 right square bracket<p>
</a><td><a name="1113">
 1<p>
</a><td><a name="1114">
 superscript one<p>
</a>
<tr><td><a name="1115">
 ^<p>
</a><td><a name="1116">
 circumflex<p>
</a><td><a name="1117">
 &#186;<p>
</a><td><a name="1118">
 masculine ordinal indicator<p>
</a>
<tr><td><a name="1119">
 _<p>
</a><td><a name="1120">
 low line, underscore<p>
</a><td><a name="1121">
 &#187;<p>
</a><td><a name="1122">
 right angle quotation mark<p>
</a>
<tr><td><a name="1123">
 `<p>
</a><td><a name="1124">
 grave<p>
</a><td><a name="1125">
 <p>
</a><td><a name="1126">
 vulgar fraction 1/4<p>
</a>
<tr><td><a name="1127">
 {<p>
</a><td><a name="1128">
 left curly bracket<p>
</a><td><a name="1129">
 <p>
</a><td><a name="1130">
 vulgar fraction 1/2<p>
</a>
<tr><td><a name="1131">
 |<p>
</a><td><a name="1132">
 vertical line<p>
</a><td><a name="1133">
 <p>
</a><td><a name="1134">
 vulgar fraction 3/4<p>
</a>
<tr><td><a name="1135">
 }<p>
</a><td><a name="1136">
 right curly bracket<p>
</a><td><a name="1137">
 &#191;<p>
</a><td><a name="1138">
 inverted question mark<p>
</a>
<tr><td><a name="1139">
 ~<p>
</a><td><a name="1140">
 tilde<p>
</a><td><a name="1141">
 &#165;<p>
</a><td><a name="1142">
 multiplication sign<p>
</a>
<tr><td><a name="1143">
 <p>
</a><td><a name="1144">
 <p>
</a><td><a name="1145">
 &#247;<p>
</a><td><a name="1146">
 division sign <p>
</a>

</Table>

<Table>
<tr><td>
</Table>
<p>
</a><a name="728">
The formatting characters are shown in <a href="idlsyn.html#728">Figure 5 on page 3-5</a>.  
<Table Border="3">
<caption><a name="1015">
TABLE 5.  The Formatting Characters <p>
</a></caption>
<tr><th><a name="1018">
 Description<p>
</a><th><a name="1019">
 Abbreviation<p>
</a><th><a name="1020">
 ISO 646 Octal Value<p>
</a>
<tr><td><a name="1307">
 alert<p>
</a><td><a name="1044">
 BEL<p>
</a><td><a name="1287">
 007<p>
</a>
<tr><td><a name="1160">
 backspace<p>
</a><td><a name="1161">
 BS<p>
</a><td><a name="1162">
 010<p>
</a>
<tr><td><a name="1154">
 horizontal tab<p>
</a><td><a name="1155">
 HT<p>
</a><td><a name="1156">
 011<p>
</a>
<tr><td><a name="1021">
 newline<p>
</a><td><a name="1022">
 NL, LF<p>
</a><td><a name="1153">
 012<p>
</a>
<tr><td><a name="1157">
 vertical tab<p>
</a><td><a name="1158">
 VT<p>
</a><td><a name="1159">
 013<p>
</a>
<tr><td><a name="1166">
 form feed<p>
</a><td><a name="1167">
 FF<p>
</a><td><a name="1168">
 014<p>
</a>
<tr><td><a name="1163">
 carriage return<p>
</a><td><a name="1164">
 CR<p>
</a><td><a name="1165">
 015<p>
</a>

</Table>

<Table>
<tr><td>
</Table>
<p>
</a><a name="320">
<h2>	3.2.1	 Tokens</h2>
</a><a name="321">
There are five kinds of tokens: identifiers, keywords, literals, operators, and other separators. Blanks, horizontal and vertical tabs, newlines, formfeeds, and comments (collective, "white space"), as described below, are ignored except as they serve to separate tokens. Some white space is required to separate otherwise adjacent identifiers, keywords, and constants.<p>
</a><a name="322">
If the input stream has been parsed into tokens up to a given character, the next token is taken to be the longest string of characters that could possibly constitute a token.<p>
</a><a name="323">
<h2>	3.2.2	 Comments</h2>
</a><a name="324">
The characters /* start a comment, which terminates with the characters */. These comments do not nest. The characters // start a comment, which terminates at the end of the line on which they occur. The comment characters //, /*, and */ have no special meaning within a // comment and are treated just like other characters. Similarly, the comment characters // and /* have no special meaning within a /* comment. Comments may contain alphabetic, digit, graphic, space, horizontal tab, vertical tab, form feed and newline characters. <p>
</a><a name="325">
<h2>	3.2.3	 Identifiers</h2>
</a><a name="326">
An identifier is an arbitrarily long sequence of alphabetic, digit, and underscore ("_") characters. The first character must be an alphabetic character. All characters are significant. <p>
</a><a name="330">
Identifiers that differ only in case collide and yield a compilation error. An identifier for a definition must be spelled consistently (with respect to case) throughout a specification. <p>
</a><a name="766">
When comparing two identifiers to see if they collide: <p>
</a><ul><a name="807">
<li>Upper- and lower-case letters are treated as the same letter. <a href="idlsyn.html#918">Figure 2 on page 3-3</a> defines the equivalence mapping of upper- and lower-case letters.
</a><a name="813">
<li>The comparison does <em>not</em> take into account equivalences between digraphs and pairs of letters (e.g., "&aelig;" and "ae" are not considered equivalent) or equivalences between accented and non-accented letters (e.g., "&Aacute;" and "A" are not considered equivalent).
</a><a name="815">
<li>All characters are significant.
</a></ul><a name="566">
There is only one namespace for OMG IDL identifiers. Using the same identifier for a constant and an interface, for example, produces a compilation error. <p>
</a><a name="327">
<h2>	3.2.4	 Keywords</h2>
</a><a name="328">
The identifiers listed in <a href="idlsyn.html#328">Figure 6 on page 3-6</a> are reserved for use as keywords, and may not be used otherwise<strong>.  
<Table Border="3">
<caption><a name="683">
TABLE 6.  Keywords<p>
</a></caption>
<tr><td><a name="688">
 any<p>
</a><td><a name="745">
 default<p>
</a><td><a name="784">
 inout<p>
</a><td><a name="1200">
 out<p>
</a><td><a name="1201">
 switch<p>
</a>
<tr><td><a name="1202">
 attribute<p>
</a><td><a name="1203">
 double<p>
</a><td><a name="1204">
 interface<p>
</a><td><a name="1205">
 raises<p>
</a><td><a name="1206">
 TRUE<p>
</a>
<tr><td><a name="1207">
 boolean<p>
</a><td><a name="1208">
 enum<p>
</a><td><a name="1209">
 long<p>
</a><td><a name="1210">
 readonly<p>
</a><td><a name="1211">
 typedef<p>
</a>
<tr><td><a name="1212">
 case<p>
</a><td><a name="1213">
 exception<p>
</a><td><a name="1214">
 module<p>
</a><td><a name="1215">
 sequence<p>
</a><td><a name="1216">
 unsigned<p>
</a>
<tr><td><a name="1217">
 char<p>
</a><td><a name="1218">
 FALSE<p>
</a><td><a name="1219">
 Object<p>
</a><td><a name="1220">
 short<p>
</a><td><a name="1221">
 union<p>
</a>
<tr><td><a name="1222">
 const<p>
</a><td><a name="1223">
 float<p>
</a><td><a name="1224">
 octet<p>
</a><td><a name="1225">
 string<p>
</a><td><a name="1226">
 void<p>
</a>
<tr><td><a name="1227">
 context<p>
</a><td><a name="1228">
 in<p>
</a><td><a name="1229">
 oneway<p>
</a><td><a name="1230">
 struct<p>
</a><td><a name="1231">
 <p>
</a>

</Table>

<Table>
<tr><td>
</Table>
</strong><p>
</a><a name="331">
Keywords obey the rules for identifiers (see <a href="idlsyn.html#325"> Section 3.2.3</a>) and must be written exactly as shown in the above list. For example, "<strong>boolean</strong>" is correct; "<strong>Boolean</strong>" produces a compilation error. <p>
</a><a name="787">
OMG IDL specifications use the characters shown in <a href="idlsyn.html#787">Figure 7 on page 3-6</a> as punctuation.  
<Table Border="3">
<caption><a name="329">
TABLE 7.  Punctuation Characters<p>
</a></caption>
<tr><td><a name="1243">
 ;<p>
</a><td><a name="1244">
 {<p>
</a><td><a name="1245">
 }<p>
</a><td><a name="1246">
 :<p>
</a><td><a name="1247">
 ,<p>
</a><td><a name="1248">
 =<p>
</a><td><a name="1249">
 +<p>
</a><td><a name="1250">
 -<p>
</a><td><a name="1251">
 (<p>
</a><td><a name="1252">
 )<p>
</a><td><a name="1253">
 &lt;<p>
</a><td><a name="1254">
 &gt;<p>
</a><td><a name="1255">
 [<p>
</a><td><a name="1256">
 ]<p>
</a>
<tr><td><a name="1257">
 '<p>
</a><td><a name="1258">
 "<p>
</a><td><a name="1259">
 \<p>
</a><td><a name="1260">
 |<p>
</a><td><a name="1261">
 ^<p>
</a><td><a name="1262">
 &amp;<p>
</a><td><a name="1263">
 *<p>
</a><td><a name="1264">
 /<p>
</a><td><a name="1265">
 %<p>
</a><td><a name="1266">
 ~<p>
</a><td><a name="1267">
 <p>
</a><td><a name="1268">
 <p>
</a><td><a name="1269">
 <p>
</a><td><a name="1270">
 <p>
</a>

</Table>

<Table>
<tr><td>
</Table>
<p>
</a><a name="332">
In addition, the tokens listed in <a href="idlsyn.html#332">Figure 8 on page 3-6</a> are used by the preprocessor.  
<Table Border="3">
<caption><a name="333">
TABLE 8.  Preprocessor Tokens<p>
</a></caption>
<tr><td><a name="1275">
 #<p>
</a><td><a name="1276">
 ##<p>
</a><td><a name="1277">
 !<p>
</a><td><a name="1278">
 ||<p>
</a><td><a name="1279">
 &amp;&amp;<p>
</a>

</Table>

<Table>
<tr><td>
</Table>
<p>
</a><a name="334">
<h2>	3.2.5	 Literals</h2>
</a><a name="2160">
This section describes the following literals:<p>
</a><ul><a name="2161">
<li>Integer
</a><a name="2162">
<li>Character
</a><a name="2164">
<li>Floating-point
</a><a name="2165">
<li>String
</a></ul><a name="336">
<h3>		 Integer Literals</h3>
</a><a name="337">
An integer literal consisting of a sequence of digits is taken to be decimal (base ten) unless it begins with 0 (digit zero). A sequence of digits starting with 0 is taken to be an octal integer (base eight). The digits 8 and 9 are not octal digits. A sequence of digits preceded by 0x or 0X is taken to be a hexadecimal integer (base sixteen). The hexadecimal digits include a or A through f or F with decimal values ten through fifteen, respectively. For example, the number twelve can be written 12, 014, or 0XC.<p>
</a><a name="292">
<h3>		 Character Literals</h3>
</a><a name="743">
A character literal is one or more characters enclosed in single quotes, as in 'x'. Character literals have type <strong>char</strong>. <p>
</a><a name="812">
A character is an 8-bit quantity with a numerical value between 0 and 255 (decimal). The value of a space, alphabetic, digit or graphic character literal is the numerical value of the character as defined in the ISO Latin-1 (8859.1) character set standard (See <a href="idlsyn.html#918">Figure 2 on page 3-3</a>, <a href="idlsyn.html#971">Figure 3 on page 3-4</a>, and <a href="idlsyn.html#735">Figure 4 on page 3-4</a>). The value of a null is 0. The value of a formatting character literal is the numerical value of the character as defined in the ISO 646 standard (See <a href="idlsyn.html#728">Figure 5 on page 3-5</a>). The meaning of all other characters is implementation-dependent.<p>
</a><a name="819">
Nongraphic characters must be represented using escape sequences as defined below in <a href="idlsyn.html#819">Figure 9 on page 3-7</a>. Note that escape sequences must be used to represent single quote and backslash characters in character literals.  
<Table Border="3">
<caption><a name="297">
TABLE 9.  Escape Sequences <p>
</a></caption>
<tr><th><a name="299">
 Description<p>
</a><th><a name="300">
 Escape Sequence<p>
</a>
<tr><td><a name="301">
 newline<p>
</a><td><a name="302">
 \n<p>
</a>
<tr><td><a name="303">
 horizontal tab<p>
</a><td><a name="304">
 \t<p>
</a>
<tr><td><a name="314">
 vertical tab<p>
</a><td><a name="698">
 \v<p>
</a>
<tr><td><a name="699">
 backspace<p>
</a><td><a name="845">
 \b<p>
</a>
<tr><td><a name="1013">
 carriage return<p>
</a><td><a name="1172">
 \r<p>
</a>
<tr><td><a name="1173">
 form feed<p>
</a><td><a name="1174">
 \f<p>
</a>
<tr><td><a name="1175">
 alert<p>
</a><td><a name="1176">
 \a<p>
</a>
<tr><td><a name="1177">
 backslash<p>
</a><td><a name="1178">
 \\<p>
</a>
<tr><td><a name="1179">
 question mark<p>
</a><td><a name="1180">
 \?<p>
</a>
<tr><td><a name="1181">
 single quote<p>
</a><td><a name="1182">
 \'<p>
</a>
<tr><td><a name="1183">
 double quote<p>
</a><td><a name="1184">
 \"<p>
</a>
<tr><td><a name="1185">
 octal number<p>
</a><td><a name="1186">
 \ooo<p>
</a>
<tr><td><a name="1191">
 hexadecimal number<p>
</a><td><a name="1192">
 \xhh<p>
</a>

</Table>

<Table>
<tr><td>
</Table>
<p>
</a><a name="343">
If the character following a backslash is not one of those specified, the behavior is undefined. An escape sequence specifies a single character.<p>
</a><a name="344">
The escape \ooo consists of the backslash followed by one, two, or three octal digits that are taken to specify the value of the desired character. The escape \xhh consists of the backslash followed by x followed by one or two hexadecimal digits that are taken to specify the value of the desired character. A sequence of octal or hexadecimal digits is terminated by the first character that is not an octal digit or a hexadecimal digit, respectively. The value of a character constant is implementation dependent if it exceeds that of the largest char.<p>
</a><a name="345">
<h3>		 Floating-point Literals</h3>
</a><a name="346">
A floating-point literal consists of an integer part, a decimal point, a fraction part, an e or E, and an optionally signed integer exponent. The integer and fraction parts both consist of a sequence of decimal (base ten) digits. Either the integer part or the fraction part (but not both) may be missing; either the decimal point or the letter e (or E) and the exponent (but not both) may be missing. <p>
</a><a name="347">
<h3>		 String Literals</h3>
</a><a name="348">
A string literal is a sequence of characters (as defined in <a href="idlsyn.html#292">"Character Literals" on page 3-7</a>) surrounded by double quotes, as in "...". <p>
</a><a name="2188">
Adjacent string literals are concatenated. Characters in concatenated strings are kept distinct. For example,<p>
</a><a name="2192">
<p>
</a><a name="2189">
<blockquote>                              "\xA" "B"</blockquote>
</a><a name="351">
contains the two characters '\xA' and 'B' after concatenation (and not the single hexadecimal character '\xAB').<p>
</a><a name="352">
The size of a string literal is the number of character literals enclosed by the quotes, after concatenation. The size of the literal is associated with the literal. Within a string, the double quote character <strong>"</strong> must be preceded by a \.<p>
</a><a name="353">
A string literal may not contain the character '\0'.<p>
</a><a name="354">
<h1>	3.3	 Preprocessing</h1>
</a><a name="355">
OMG IDL preprocessing, which is based on ANSI C++ preprocessing, provides macro substitution, conditional compilation, and source file inclusion. In addition, directives are provided to control line numbering in diagnostics and for symbolic debugging, to generate a diagnostic message with a given token sequence, and to perform implementation-dependent actions (the <strong>#pragma</strong> directive). Certain predefined names are available. These facilities are conceptually handled by a preprocessor, which may or may not actually be implemented as a separate process.<p>
</a><a name="356">
Lines beginning with # (also called "directives") communicate with this preprocessor. White space may appear before the #. These lines have syntax independent of the rest of OMG IDL; they may appear anywhere and have effects that last (independent of the OMG IDL scoping rules) until the end of the translation unit. The textual location of OMG IDL-specific pragmas may be semantically constrained.<p>
</a><a name="357">
A preprocessing directive (or any line) may be continued on the next line in a source file by placing a backslash character ("\"), immediately before the newline at the end of the line to be continued. The preprocessor effects the continuation by deleting the backslash and the newline before the input sequence is divided into tokens. A backslash character may not be the last character in a source file.<p>
</a><a name="358">
A preprocessing token is an OMG IDL token (<a href="idlsyn.html#320"> Section 3.2.1</a>), a file name as in a <strong>#include</strong> directive, or any single character, other than white space, that does not match another preprocessing token.<p>
</a><a name="359">
The primary use of the preprocessing facilities is to include definitions from other OMG IDL specifications. Text in files included with a <strong>#include</strong> directive is treated as if it appeared in the including file. A complete description of the preprocessing facilities may be found in <em>The Annotated C++ Reference Manual</em>, Chapter 16.  The #pragma directive that is used to include RepositoryIds is described in <a href="intrep2.html#360">Section &#32;6.6, "RepositoryIds," on page &#32;6-30</a>.<p>
</a><a name="360">
<h1>	3.4	 OMG IDL Grammar</h1>
</a><a name="361">
	(1)	 &lt;specification&gt;	::=	&lt;definition&gt;+<p>
</a><a name="788">
	(2)	 &lt;definition&gt;	::=	&lt;type_dcl&gt; ";"<br>			|	&lt;const_dcl&gt; ";"<br>			|	&lt;except_dcl&gt; ";"<br>			|	&lt;interface&gt; ";"<br>			|	&lt;module&gt; ";"<p>
</a><a name="789">
	(3)	 &lt;module&gt;	::=	"module" &lt;identifier&gt; "{" &lt;definition&gt;+ "}"<p>
</a><a name="363">
	(4)	 &lt;interface&gt;	::=	&lt;interface_dcl&gt;<br>			|	&lt;forward_dcl&gt;<p>
</a><a name="364">
	(5)	 &lt;interface_dcl&gt;	::=	&lt;interface_header&gt; "{" &lt;interface_body&gt; "}"<p>
</a><a name="365">
	(6)	 &lt;forward_dcl&gt;	::=	"interface" &lt;identifier&gt;<p>
</a><a name="366">
	(7)	 &lt;interface_header&gt;	::=	"interface" &lt;identifier&gt; [ &lt;inheritance_spec&gt; ]<p>
</a><a name="367">
	(8)	 &lt;interface_body&gt;	::=	&lt;export&gt;*<p>
</a><a name="368">
	(9)	 &lt;export&gt;	::=	&lt;type_dcl&gt; ";"<br>			|	&lt;const_dcl&gt; ";"<br>			|	&lt;except_dcl&gt; ";"<br>			|	&lt;attr_dcl&gt; ";"<br>			|	&lt;op_dcl&gt; ";"<p>
</a><a name="362">
	(10)	 &lt;inheritance_spec&gt;	::=	":" &lt;scoped_name&gt; { "," &lt;scoped_name&gt; }*<p>
</a><a name="369">
	(11)	 &lt;scoped_name&gt;	::=	&lt;identifier&gt;<br>			|	"::" &lt;identifier&gt;<br>			|	&lt;scoped_name&gt; "::" &lt;identifier&gt;<p>
</a><a name="370">
	(12)	 &lt;const_dcl&gt;	::=	"const" &lt;const_type&gt; &lt;identifier&gt; "=" &lt;const_exp&gt;<p>
</a><a name="371">
	(13)	 &lt;const_type&gt;	::=	&lt;integer_type&gt;<br>			|	&lt;char_type&gt;<br>			|	&lt;boolean_type&gt;<br>			|	&lt;floating_pt_type&gt;<br>			|	&lt;string_type&gt;<br>			|	&lt;scoped_name&gt;<p>
</a><a name="372">
	(14)	 &lt;const_exp&gt;	::=	&lt;or_expr&gt;<p>
</a><a name="373">
	(15)	 &lt;or_expr&gt;	::=	&lt;xor_expr&gt;<br>			|	&lt;or_expr&gt; "|" &lt;xor_expr&gt;<p>
</a><a name="374">
	(16)	 &lt;xor_expr&gt;	::=	&lt;and_expr&gt;<br>			|	&lt;xor_expr&gt; "^" &lt;and_expr&gt;<p>
</a><a name="375">
	(17)	 &lt;and_expr&gt;	::=	&lt;shift_expr&gt;<br>			|	&lt;and_expr&gt; "&amp;" &lt;shift_expr&gt;<p>
</a><a name="376">
	(18)	 &lt;shift_expr&gt;	::=	&lt;add_expr&gt;<br>			|	&lt;shift_expr&gt; "&gt;&gt;" &lt;add_expr&gt;<br>			|	&lt;shift_expr&gt; "&lt;&lt;" &lt;add_expr&gt;<p>
</a><a name="377">
	(19)	 &lt;add_expr&gt;	::=	&lt;mult_expr&gt;<br>			|	&lt;add_expr&gt; "+" &lt;mult_expr&gt;<br>			|	&lt;add_expr&gt; "-" &lt;mult_expr&gt;<p>
</a><a name="378">
	(20)	 &lt;mult_expr&gt;	::=	&lt;unary_expr&gt;<br>			|	&lt;mult_expr&gt; "*" &lt;unary_expr&gt;<br>			|	&lt;mult_expr&gt; "/" &lt;unary_expr&gt;<br>			|	&lt;mult_expr&gt; "%" &lt;unary_expr&gt;<p>
</a><a name="379">
	(21)	 &lt;unary_expr&gt;	::=	&lt;unary_operator&gt; &lt;primary_expr&gt;<br>			|	&lt;primary_expr&gt;<p>
</a><a name="380">
	(22)	 &lt;unary_operator&gt;	::=	"-"<br>			|	"+"<br>			|	"~"<p>
</a><a name="381">
	(23)	 &lt;primary_expr&gt;	::=	&lt;scoped_name&gt;<br>			|	&lt;literal&gt;<br>			|	"(" &lt;const_exp&gt; ")"<p>
</a><a name="382">
	(24)	 &lt;literal&gt;	::=	&lt;integer_literal&gt;<br>			|	&lt;string_literal&gt;<br>			|	&lt;character_literal&gt;<br>			|	&lt;floating_pt_literal&gt;<br>			|	&lt;boolean_literal&gt;<p>
</a><a name="383">
	(25)	 &lt;boolean_literal&gt;	::=	"TRUE"<br>			|	"FALSE"<p>
</a><a name="790">
	(26)	 &lt;positive_int_const&gt;	::=	&lt;const_exp&gt;<p>
</a><a name="386">
	(27)	 &lt;type_dcl&gt;	::=	"typedef" &lt;type_declarator&gt;<br>			|	&lt;struct_type&gt;<br>			|	&lt;union_type&gt;<br>			|	&lt;enum_type&gt;<p>
</a><a name="387">
	(28)	 &lt;type_declarator&gt;	::=	&lt;type_spec&gt; &lt;declarators&gt;<p>
</a><a name="388">
	(29)	 &lt;type_spec&gt;	::=	&lt;simple_type_spec&gt;<br>			|	&lt;constr_type_spec&gt;<p>
</a><a name="389">
	(30)	 &lt;simple_type_spec&gt;	::=	&lt;base_type_spec&gt;<br>			|	&lt;template_type_spec&gt;<br>			|	&lt;scoped_name&gt;<p>
</a><a name="390">
	(31)	 &lt;base_type_spec&gt;	::=	&lt;floating_pt_type&gt;<br>			|	&lt;integer_type&gt;<br>			|	&lt;char_type&gt;<br>			|	&lt;boolean_type&gt;<br>			|	&lt;octet_type&gt;<br>			|	&lt;any_type&gt;<p>
</a><a name="335">
	(32)	 &lt;template_type_spec&gt;	::=	&lt;sequence_type&gt;<br>			|	&lt;string_type&gt;<p>
</a><a name="391">
	(33)	 &lt;constr_type_spec&gt;	::=	&lt;struct_type&gt;<br>			|	&lt;union_type&gt;<br>			|	&lt;enum_type&gt;<p>
</a><a name="393">
	(34)	 &lt;declarators&gt;	::=	&lt;declarator&gt; { "," &lt;declarator&gt; }*<p>
</a><a name="394">
	(35)	 &lt;declarator&gt;	::=	&lt;simple_declarator&gt;<br>			|	&lt;complex_declarator&gt;<p>
</a><a name="395">
	(36)	 &lt;simple_declarator&gt;	::=	&lt;identifier&gt;<p>
</a><a name="396">
	(37)	 &lt;complex_declarator&gt;	::=	&lt;array_declarator&gt;<p>
</a><a name="397">
	(38)	 &lt;floating_pt_type&gt;	::=	"float"<br>			|	"double"<p>
</a><a name="398">
	(39)	 &lt;integer_type&gt;	::=	&lt;signed_int&gt;<br>			|	&lt;unsigned_int&gt;<p>
</a><a name="399">
	(40)	 &lt;signed_int&gt;	::=	&lt;signed_long_int&gt;<br>			|	&lt;signed_short_int&gt;<p>
</a><a name="400">
	(41)	 &lt;signed_long_int&gt;	::=	"long"<p>
</a><a name="401">
	(42)	 &lt;signed_short_int&gt;	::=	"short"<p>
</a><a name="402">
	(43)	 &lt;unsigned_int&gt;	::=	&lt;unsigned_long_int&gt;<br>			|	&lt;unsigned_short_int&gt;<p>
</a><a name="403">
	(44)	 &lt;unsigned_long_int&gt;	::=	"unsigned" "long"<p>
</a><a name="404">
	(45)	 &lt;unsigned_short_int&gt;	::=	"unsigned" "short"<p>
</a><a name="405">
	(46)	 &lt;char_type&gt;	::=	"char"<p>
</a><a name="406">
	(47)	 &lt;boolean_type&gt;	::=	"boolean"<p>
</a><a name="407">
	(48)	 &lt;octet_type&gt;	::=	"octet"<p>
</a><a name="338">
	(49)	 &lt;any_type&gt;	::=	"any"<p>
</a><a name="408">
	(50)	 &lt;struct_type&gt;	::=	"struct" &lt;identifier&gt; "{" &lt;member_list&gt; "}"<p>
</a><a name="409">
	(51)	 &lt;member_list&gt;	::=	&lt;member&gt;+<p>
</a><a name="410">
	(52)	 &lt;member&gt;	::=	&lt;type_spec&gt; &lt;declarators&gt; ";"<p>
</a><a name="411">
	(53)	 &lt;union_type&gt;	::=	"union" &lt;identifier&gt; "switch" "(" &lt;switch_type_spec&gt; ")"<br>					"{" &lt;switch_body&gt; "}"<p>
</a><a name="412">
	(54)	 &lt;switch_type_spec&gt;	::=	&lt;integer_type&gt;<br>			|	&lt;char_type&gt;<br>			|	&lt;boolean_type&gt;<br>			|	&lt;enum_type&gt;<br>			|	&lt;scoped_name&gt;<p>
</a><a name="413">
	(55)	 &lt;switch_body&gt;	::=	&lt;case&gt;+<p>
</a><a name="414">
	(56)	 &lt;case&gt;	::=	&lt;case_label&gt;+ &lt;element_spec&gt; ";"<p>
</a><a name="415">
	(57)	 &lt;case_label&gt;	::=	"case" &lt;const_exp&gt; ":"<br>			|	"default" ":"<p>
</a><a name="416">
	(58)	 &lt;element_spec&gt;	::=	&lt;type_spec&gt; &lt;declarator&gt;<p>
</a><a name="417">
	(59)	 &lt;enum_type&gt;	::=	"enum" &lt;identifier&gt; "{" &lt;enumerator&gt; { "," &lt;enumerator&gt; }* "}"<p>
</a><a name="418">
	(60)	 &lt;enumerator&gt;	::=	&lt;identifier&gt;<p>
</a><a name="419">
	(61)	 &lt;sequence_type&gt;	::=	"sequence" "&lt;" &lt;simple_type_spec&gt; ","&lt;positive_int_const&gt;"&gt;"<br>			|	"sequence" "&lt;" &lt;simple_type_spec&gt; "&gt;"<p>
</a><a name="421">
	(62)	 &lt;string_type&gt;	::=	"string" "&lt;" &lt;positive_int_const&gt; "&gt;"<br>			|	"string"<p>
</a><a name="422">
	(63)	 &lt;array_declarator&gt;	::=	&lt;identifier&gt; &lt;fixed_array_size&gt;+<p>
</a><a name="423">
	(64)	 &lt;fixed_array_size&gt;	::=	"[" &lt;positive_int_const&gt; "]"<p>
</a><a name="802">
	(65)	 &lt;attr_dcl&gt;	::=	[ "readonly" ] "attribute" &lt;param_type_spec&gt;<br>				 &lt;simple_declarator&gt; 					{ "," &lt;simple_declarator&gt; }*<p>
</a><a name="425">
	(66)	 &lt;except_dcl&gt;	::=	"exception" &lt;identifier&gt; "{" &lt;member&gt;* "}"<p>
</a><a name="426">
	(67)	 &lt;op_dcl&gt;	::=	[ &lt;op_attribute&gt; ] &lt;op_type_spec&gt; &lt;identifier&gt; &lt;parameter_dcls&gt;<br>					[ &lt;raises_expr&gt; ] [ &lt;context_expr&gt; ]<p>
</a><a name="427">
	(68)	 &lt;op_attribute&gt;	::=	"oneway"<p>
</a><a name="428">
	(69)	 &lt;op_type_spec&gt;	::=	&lt;param_type_spec&gt;<br>			|	"void"<p>
</a><a name="429">
	(70)	 &lt;parameter_dcls&gt;	::=	"(" &lt;param_dcl&gt; { "," &lt;param_dcl&gt; }* ")"<br>			|	"(" ")"<p>
</a><a name="430">
	(71)	 &lt;param_dcl&gt;	::=	&lt;param_attribute&gt; &lt;param_type_spec&gt; &lt;simple_declarator&gt;<p>
</a><a name="431">
	(72)	 &lt;param_attribute&gt;	::=	"in"<br>			|	"out"<br>			|	"inout"<p>
</a><a name="432">
	(73)	 &lt;raises_expr&gt;	::=	"raises" "(" &lt;scoped_name&gt; { "," &lt;scoped_name&gt; }* ")"<p>
</a><a name="433">
	(74)	 &lt;context_expr&gt;	::=	"context" "(" &lt;string_literal&gt; { "," &lt;string_literal&gt; }* ")"<p>
</a><a name="424">
	(75)	 &lt;param_type_spec&gt;	::=	&lt;base_type_spec&gt;<br>			|	&lt;string_type&gt;<br>			|	&lt;scoped_name&gt;<p>
</a><a name="434">
<h1>	3.5	 OMG IDL Specification</h1>
</a><a name="435">
An OMG IDL specification consists of one or more type definitions, constant definitions, exception definitions, or module definitions. The syntax is:<p>
</a><a name="2193">
<p>
</a><a name="436">
 &lt;specification&gt;	::=	&lt;definition&gt;+<p>
</a><a name="384">
 &lt;definition&gt;	::=	&lt;type_dcl&gt; ";"<br>	|	&lt;const_dcl&gt; ";"<br>	|	&lt;except_dcl&gt; ";"<br>	|	&lt;interface&gt; ";"<br>	|	&lt;module&gt; ";"<p>
</a><a name="385">
See <a href="idlsyn.html#470">"Constant Declaration" on page &#32;3-17</a>, <a href="idlsyn.html#496">"Type Declaration" on page &#32;3-19</a>, and , <a href="idlsyn.html#597">"Exception Declaration" on page &#32;3-26</a>,  respectively, for specifications of <strong>&lt;const_dcl&gt;</strong>, <strong>&lt;type_dcl&gt;</strong>, and <strong>&lt;except_dcl&gt;</strong>.<p>
</a><a name="1169">
<h2>	3.5.1	 Module Declaration</h2>
</a><a name="437">
A module definition satisfies the following syntax:<p>
</a><a name="2219">
<p>
</a><a name="438">
 &lt;module&gt;	::=	"module" &lt;identifier&gt; "{" &lt;definition&gt;+ "}"<p>
</a><a name="1170">
The module construct is used to scope OMG IDL identifiers; see <a href="idlsyn.html#1302">"CORBA Module" on page &#32;3-31</a> for details. <p>
</a><a name="1171">
<h2>	3.5.2	 Interface Declaration</h2>
</a><a name="439">
An interface definition satisfies the following syntax:<p>
</a><a name="2220">
<p>
</a><a name="440">
 &lt;interface&gt;	::=	&lt;interface_dcl&gt;<br>	|	&lt;forward_dcl&gt;<p>
</a><a name="441">
 &lt;interface_dcl&gt;	::=	&lt;interface_header&gt; "{" &lt;interface_body&gt; "}"<p>
</a><a name="442">
 &lt;forward_dcl&gt;	::=	"interface" &lt;identifier&gt;<p>
</a><a name="443">
 &lt;interface_header&gt;	::=	"interface" &lt;identifier&gt; [ &lt;inheritance_spec&gt; ]<p>
</a><a name="444">
 &lt;interface_body&gt;	::=	&lt;export&gt;*<p>
</a><a name="445">
 &lt;export&gt;	::=	&lt;type_dcl&gt; ";"<br>	|	&lt;const_dcl&gt; ";"<br>	|	&lt;except_dcl&gt; ";"<br>	|	&lt;attr_dcl&gt; ";"<br>	|	&lt;op_dcl&gt; ";"<p>
</a><a name="446">
<h3>		 Interface Header</h3>
</a><a name="447">
The interface header consists of two elements:<p>
</a><a name="2221">
<p>
</a><ul><a name="448">
<li>The interface name. The name must be preceded by the keyword <strong>interface</strong>, and consists of an identifier that names the interface.
</a><a name="449">
<li>An optional inheritance specification. The inheritance specification is described in the next section.
</a></ul><a name="450">
The <strong>&lt;identifier&gt;</strong> that names an interface defines a legal type name. Such a type name may be used anywhere an <strong>&lt;identifier&gt;</strong> is legal in the grammar, subject to semantic constraints as described in the following sections. Since one can only hold references to an object, the meaning of a parameter or structure member which is an interface type is as a <em>reference</em> to an object supporting that interface. Each language binding describes how the programmer must represent such interface references.<p>
</a><a name="451">
<h3>		 Inheritance Specification</h3>
</a><a name="834">
The syntax for inheritance is as follows: <p>
</a><a name="2222">
<p>
</a><a name="835">
 &lt;inheritance_spec&gt;	::= ":" &lt;scoped_name&gt; {"," &lt;scoped_name&gt;}*<p>
</a><a name="420">
 &lt;scoped_name&gt;	::= &lt;identifier&gt;<br>	| "::" &lt;identifier&gt;<br>	| &lt;scoped_name&gt; "::" &lt;identifier&gt;<p>
</a><a name="842">
Each <strong>&lt;scoped_name&gt;</strong> in an <strong>&lt;inheritance_spec&gt;</strong> must denote a previously defined interface. See <a href="idlsyn.html#853">"Inheritance" on page &#32;3-15</a> for the description of inheritance. <p>
</a><a name="458">
<h3>		 Interface Body</h3>
</a><a name="459">
The interface body contains the following kinds of declarations:<p>
</a><ul><a name="460">
<li>Constant declarations, which specify the constants that the interface exports; constant declaration syntax is described in <a href="idlsyn.html#470">"Constant Declaration" on page 3-17</a>.
</a><a name="461">
<li>Type declarations, which specify the type definitions that the interface exports; type declaration syntax is described in <a href="idlsyn.html#496">"Type Declaration" on page 3-19</a>.
</a><a name="462">
<li>Exception declarations, which specify the exception structures that the interface exports; exception declaration syntax is described in <a href="idlsyn.html#597">"Exception Declaration" on page 3-26</a>.
</a><a name="463">
<li>Attribute declarations, which specify the associated attributes exported by the interface; attribute declaration syntax is described in <a href="idlsyn.html#601">"Attribute Declaration" on page 3-30</a>.
</a><a name="464">
<li>Operation declarations, which specify the operations that the interface exports and the format of each, including operation name, the type of data returned, the types of all parameters of an operation, legal exceptions which may be returned as a result of an invocation, and contextual information which may affect method dispatch; operation declaration syntax is described in <a href="idlsyn.html#610">"Operation Declaration" on page 3-27</a>.
</a></ul><a name="465">
Empty interfaces are permitted (that is,  those containing no declarations).<p>
</a><a name="2229">
Some implementations may require interface-specific pragmas to precede the interface body. <p>
</a><a name="467">
<h3>		 Forward Declaration</h3>
</a><a name="468">
A forward declaration declares the name of an interface without defining it. This permits the definition of interfaces that refer to each other. The syntax consists simply of the keyword <strong>interface</strong> followed by an <strong>&lt;identifier&gt;</strong> that names the interface. The actual definition must follow later in the specification.<p>
</a><a name="469">
Multiple forward declarations of the same interface name are legal.<p>
</a><a name="853">
<h1>	3.6	 Inheritance</h1>
</a><a name="1299">
An interface can be derived from another interface, which is then called a <em>base</em> interface of the derived interface. A derived interface, like all interfaces, may declare new elements (constants, types, attributes, exceptions, and operations). In addition, unless redefined in the derived interface, the elements of a base interface can be referred to as if they were elements of the derived interface. The name resolution operator ("::") may be used to refer to a base element explicitly; this permits reference to a name that has been redefined in the derived interface.<p>
</a><a name="859">
A derived interface may redefine any of the type, constant, and exception names which have been inherited; the scope rules for such names are described in <a href="idlsyn.html#1302">"CORBA Module" on page 3-31</a>. <p>
</a><a name="865">
An interface is called a direct base if it is mentioned in the <strong>&lt;inheritance_spec&gt;</strong> and an indirect base if it is not a direct base but is a base interface of one of the interfaces mentioned in the <strong>&lt;inheritance_spec&gt;</strong>.<p>
</a><a name="870">
An interface may be derived from any number of base interfaces. Such use of more than one direct base interface is often called multiple inheritance. The order of derivation is not significant.<p>
</a><a name="875">
An interface may not be specified as a direct base interface of a derived interface more than once; it may be an indirect base interface more than once. Consider the following example:<p>
</a><a name="392">
 interface A { ... }<p>
</a><a name="880">
<blockquote>interface B: A { ... }</blockquote>
</a><a name="881">
<blockquote>interface C: A { ... }</blockquote>
</a><a name="882">
 interface D: B, C { ... }<p>
</a><a name="885">
The relationships between these interfaces is shown in <a href="idlsyn.html#453">Figure 11 on page 3-16</a>. This "diamond" shape is legal.<p>
</a><a name="453">
FIGURE 11.&#32; Legal Multiple Inheritance Example <img src="local/images/idlsyna.gif"><p>
</a><a name="911">
Reference to base interface elements must be unambiguous. Reference to a base interface element is ambiguous if the expression used refers to a constant, type, or exception in more than one base interface. (It is currently illegal to inherit from two interfaces with the same operation or attribute name, or to redefine an operation or attribute name in the derived interface.) Ambiguities can be resolved by qualifying a name with its interface name (that is, using a <strong>&lt;scoped_name&gt;</strong>).<p>
</a><a name="533">
References to constants, types, and exceptions are bound to an interface when it is defined i.e., replaced with the equivalent global <strong>&lt;scoped_name&gt;</strong>s. This guarantees that the syntax and semantics of an interface are not changed when the interface is a base interface for a derived interface. Consider the following example:<p>
</a><a name="622">
 const long L = 3;<p>
</a><a name="738">
<blockquote></blockquote>
</a><a name="739">
<blockquote>interface A {</blockquote>
</a><a name="742">
<blockquote>						void f (in float s[L]);								// s has 3 floats</blockquote>
</a><a name="746">
<blockquote>};</blockquote>
</a><a name="773">
<blockquote></blockquote>
</a><a name="774">
<blockquote>interface B {</blockquote>
</a><a name="775">
<blockquote>						const long L = 4;</blockquote>
</a><a name="804">
<blockquote>};</blockquote>
</a><a name="805">
<blockquote></blockquote>
</a><a name="808">
 interface C: B, A {			}						// what is f()'s signature?<p>
</a><a name="811">
The early binding of constants, types, and exceptions at interface definition guarantees that the signature of operation <strong>f</strong> in interface <strong>C</strong> is <p>
</a><a name="2232">
<p>
</a><a name="935">
 void f(in float s[3]);<p>
</a><a name="940">
which is identical to that in interface <strong>A</strong>. This rule also prevents redefinition of a constant, type, or exception in the derived interface from affecting the operations and attributes inherited from a base interface.<p>
</a><a name="660">
Interface inheritance causes all identifiers in the closure of the inheritance tree to be imported into the current naming scope. A type name, constant name, enumeration value name, or exception name from an enclosing scope can be redefined in the current scope. An attempt to use an ambiguous name without qualification is a compilation error.<p>
</a><a name="782">
Operation names are used at runtime by both the stub and dynamic interfaces. As a result, all operations that might apply to a particular object must have unique names. This requirement prohibits redefining an operation name in a derived interface, as well as inheriting two operations with the same name. <p>
</a><a name="791">
Note &#175;  It is anticipated that future revisions of the language may relax this rule in some way, perhaps allowing overloading or providing some means to distinguish operations with the same name.<p>
</a><a name="470">
<h1>	3.7	 Constant Declaration</h1>
</a><a name="471">
This section describes the syntax for constant declarations.<p>
</a><a name="472">
<h2>	3.7.1	 Syntax</h2>
</a><a name="473">
The syntax for a constant declaration is:<p>
</a><a name="2233">
<p>
</a><a name="474">
 &lt;const_dcl&gt;	::=	"const" &lt;const_type&gt; &lt;identifier&gt; "=" &lt;const_exp&gt;<p>
</a><a name="475">
 &lt;const_type&gt;	::=	&lt;integer_type&gt;<br>	|	&lt;char_type&gt;<br>	|	&lt;boolean_type&gt;<br>	|	&lt;floating_pt_type&gt;<br>	|	&lt;string_type&gt;<br>	|	&lt;scoped_name&gt;<p>
</a><a name="476">
 &lt;const_exp&gt;	::=	&lt;or_expr&gt;<p>
</a><a name="477">
 &lt;or_expr&gt;	::=	&lt;xor_expr&gt;<br>	|	&lt;or_expr&gt; "|" &lt;xor_expr&gt;<p>
</a><a name="478">
 &lt;xor_expr&gt;	::=	&lt;and_expr&gt;<br>	|	&lt;xor_expr&gt; "^" &lt;and_expr&gt;<p>
</a><a name="479">
 &lt;and_expr&gt;	::=	&lt;shift_expr&gt;<br>	|	&lt;and_expr&gt; "&amp;" &lt;shift_expr&gt;<p>
</a><a name="480">
 &lt;shift_expr&gt;	::=	&lt;add_expr&gt;<br>	|	&lt;shift_expr&gt; "&gt;&gt;" &lt;add_expr&gt;<br>	|	&lt;shift_expr&gt; "&lt;&lt;" &lt;add_expr&gt;<p>
</a><a name="481">
 &lt;add_expr&gt;	::=	&lt;mult_expr&gt;<br>	|	&lt;add_expr&gt; "+" &lt;mult_expr&gt;<br>	|	&lt;add_expr&gt; "-" &lt;mult_expr&gt;<p>
</a><a name="482">
 &lt;mult_expr&gt;	::=	&lt;unary_expr&gt;<br>	|	&lt;mult_expr&gt; "*" &lt;unary_expr&gt;<br>	|	&lt;mult_expr&gt; "/" &lt;unary_expr&gt;<br>	|	&lt;mult_expr&gt; "%" &lt;unary_expr&gt;<p>
</a><a name="483">
 &lt;unary_expr&gt;	::=	&lt;unary_operator&gt; &lt;primary_expr&gt;<br>	|	&lt;primary_expr&gt;<p>
</a><a name="484">
 &lt;unary_operator&gt;	::=	"-"<br>	|	"+"<br>	|	"~"<p>
</a><a name="485">
 &lt;primary_expr&gt;	::=	&lt;scoped_name&gt;<br>	|	&lt;literal&gt;<br>	|	"(" &lt;const_exp&gt; ")"<p>
</a><a name="486">
 &lt;literal&gt;	::=	&lt;integer_literal&gt;<br>	|	&lt;string_literal&gt;<br>	|	&lt;character_literal&gt;<br>	|	&lt;floating_pt_literal&gt;<br>	|	&lt;boolean_literal&gt;<p>
</a><a name="487">
 &lt;boolean_literal&gt;	::=	"TRUE"<br>	|	"FALSE"<p>
</a><a name="489">
 &lt;positive_int_const&gt;	::=	&lt;const_exp&gt;<p>
</a><a name="490">
<h2>	3.7.2	 Semantics</h2>
</a><a name="491">
The <strong>&lt;scoped_name&gt;</strong> in the <strong>&lt;const_type&gt;</strong> production must be a previously defined name of an <strong>&lt;integer_type&gt;</strong>, <strong>&lt;char_type&gt;</strong>, <strong>&lt;boolean_type&gt;</strong>, <strong>&lt;floating_pt_type&gt;</strong>, or  <strong>&lt;string_type&gt;</strong> constant.<p>
</a><a name="839">
No infix operator can combine an integer and a float.  Infix operators are not applicable to types other than integer and float.<p>
</a><a name="862">
An integer constant expression is evaluated as unsigned long unless it contains a negated integer literal or the name of an integer constant with a negative value. In the latter case, the constant expression is evaluated as signed long. The computed value is coerced back to the target type in constant initializers. It is an error if the computed value exceeds the precision of the target type. It is an error if any intermediate value exceeds the range of the evaluated-as type (long or unsigned long). <p>
</a><a name="800">
All floating-point literals are double, all floating-point constants are coerced to double, and all floating-point expressions are computed as doubles. The computed double value is coerced back to the target type in constant initializers. It is an error if this coercion fails or if any intermediate values (when evaluating the expression) exceed the range of double.<p>
</a><a name="866">
 Unary (+   -) and binary (*   /   +   -) operators are applicable in floating-point expressions. Unary (+   -   ~) and binary (*   /   %   +   -   &lt;&lt;   &gt;&gt;   &amp;   |   ^) operators are applicable in integer expressions.<p>
</a><a name="873">
The "~" unary operator indicates that the bit-complement of the expression to which it is applied should be generated. For the purposes of such expressions, the values are 2's complement numbers. As such, the complement can be generated as follows:<p>
</a><a name="455">
 <strong>long</strong>	-(value+1)<p>
</a><a name="457">
 <strong>unsigned long    </strong>	(2**32 - 1) - value<p>
</a><a name="2239">
The "%" binary operator yields the remainder from the division of the first expression by the second. If the second operand of "%" is 0, the result is undefined; otherwise<p>
</a><a name="2240">
                               (a/b)*b + a%b <p>
</a><a name="2241">
is equal to a. If both operands are nonnegative, then the remainder is nonnegative; if not, the sign of the remainder is implementation dependent. <p>
</a><a name="884">
The "&lt;&lt;"binary operator indicates that the value of the left operand should be shifted left the number of bits specified by the right operand, with 0 fill for the vacated bits. The right operand must be in the range 0 &lt;= right operand &lt; 32.<p>
</a><a name="889">
The "&gt;&gt;" binary operator indicates that the value of the left operand should be shifted right the number of bits specified by the right operand, with 0 fill for the vacated bits. The right operand must be in the range 0 &lt;= right operand &lt; 32.<p>
</a><a name="892">
The "&amp;" binary operator indicates that the logical, bitwise AND of the left and right operands should be generated.<p>
</a><a name="895">
The "|" binary operator indicates that the logical, bitwise OR of the left and right operands should be generated.<p>
</a><a name="898">
The "^" binary operator indicates that the logical, bitwise EXCLUSIVE-OR of the left and right operands should be generated.<p>
</a><a name="495">
<strong>&lt;positive_int_const&gt; </strong>must evaluate to a positive integer constant.<p>
</a><a name="496">
<h1>	3.8	 Type Declaration</h1>
</a><a name="497">
OMG IDL provides constructs for naming data types; that is, it provides C language-like declarations that associate an identifier with a type. OMG IDL uses the <strong>typedef</strong> keyword to associate a name with a data type; a name is also associated with a data type via the <strong>struct</strong>, <strong>union</strong>, and <strong>enum</strong> declarations; the syntax is:<p>
</a><a name="2244">
<p>
</a><a name="498">
 &lt;type_dcl&gt;	::=	"typedef" &lt;type_declarator&gt;<br>	|	&lt;struct_type&gt;<br>	|	&lt;union_type&gt;<br>	|	&lt;enum_type&gt;<p>
</a><a name="499">
 &lt;type_declarator&gt;	::=	&lt;type_spec&gt; &lt;declarators&gt;<p>
</a><a name="500">
For type declarations, OMG IDL defines a set of type specifiers to represent typed values. The syntax is as follows:<p>
</a><a name="2245">
<p>
</a><a name="501">
 &lt;type_spec&gt;	::=	&lt;simple_type_spec&gt;<br>	|	&lt;constr_type_spec&gt;<p>
</a><a name="502">
 &lt;simple_type_spec&gt;	::=	&lt;base_type_spec&gt;<br>	|	&lt;template_type_spec&gt;<br>	|	&lt;scoped_name&gt;<p>
</a><a name="503">
 &lt;base_type_spec&gt;	::=	&lt;floating_pt_type&gt;<br>	|	&lt;integer_type&gt;<br>	|	&lt;char_type&gt;<br>	|	&lt;boolean_type&gt;<br>	|	&lt;octet_type&gt;<br>	|	&lt;any_type&gt;<p>
</a><a name="1301">
 &lt;template_type_spec&gt;	::=	&lt;sequence_type&gt;<br>	|	&lt;string_type&gt;<p>
</a><a name="504">
 &lt;constr_type_spec&gt;	::=	&lt;struct_type&gt;<br>	|	&lt;union_type&gt;<br>	|	&lt;enum_type&gt;<p>
</a><a name="506">
 &lt;declarators&gt;	::=	&lt;declarator&gt; { "," &lt;declarator&gt; }*<p>
</a><a name="507">
 &lt;declarator&gt;	::=	&lt;simple_declarator&gt;<br>	|	&lt;complex_declarator&gt;<p>
</a><a name="508">
 &lt;simple_declarator&gt;	::=	&lt;identifier&gt;<p>
</a><a name="509">
 &lt;complex_declarator&gt;	::=	&lt;array_declarator&gt;<p>
</a><a name="510">
The <strong>&lt;scoped_name&gt;</strong> in <strong>&lt;simple_type_spec&gt;</strong> must be a previously defined type.<p>
</a><a name="288">
As seen above, OMG IDL type specifiers consist of scalar data types and type constructors. OMG IDL type specifiers can be used in operation declarations to assign data types to operation parameters. The next sections describe basic and constructed type specifiers.<p>
</a><a name="512">
<h2>	3.8.1	 Basic Types</h2>
</a><a name="513">
The syntax for the supported basic types is as follows:<p>
</a><a name="2246">
<p>
</a><a name="514">
 &lt;floating_pt_type&gt;	::=	"float"<br>	|	"double"<p>
</a><a name="515">
 &lt;integer_type&gt;	::=	&lt;signed_int&gt;<br>	|	&lt;unsigned_int&gt;<p>
</a><a name="516">
 &lt;signed_int&gt;	::=	&lt;signed_long_int&gt;<br>	|	&lt;signed_short_int&gt;<p>
</a><a name="517">
 &lt;signed_long_int&gt;	::=	"long"<p>
</a><a name="518">
 &lt;signed_short_int&gt;	::=	"short"<p>
</a><a name="519">
 &lt;unsigned_int&gt;	::=	&lt;unsigned_long_int&gt;<br>	|	&lt;unsigned_short_int&gt;<p>
</a><a name="520">
 &lt;unsigned_long_int&gt;	::=	"unsigned" "long"<p>
</a><a name="521">
 &lt;unsigned_short_int&gt;	::=	"unsigned" "short"<p>
</a><a name="522">
 &lt;char_type&gt;	::=	"char"<p>
</a><a name="523">
 &lt;boolean_type&gt;	::=	"boolean"<p>
</a><a name="524">
 &lt;octet_type&gt;	::=	"octet"<p>
</a><a name="809">
 &lt;any_type&gt;	::=	"any"<p>
</a><a name="2247">
 <p>
</a><a name="525">
Each OMG IDL data type is mapped to a native data type via the appropriate language mapping. Conversion errors between OMG IDL data types and the native types to which they are mapped can occur during the performance of an operation invocation. The invocation mechanism (client stub, dynamic invocation engine, and skeletons) may signal an exception condition to the client if an attempt is made to convert an illegal value. The standard exceptions which are to be signalled in such situations are defined in <a href="idlsyn.html#690">"Standard Exceptions" on page 3-33</a>. <p>
</a><a name="526">
<h3>		 Integer Types</h3>
</a><a name="527">
OMG IDL supports <strong>long</strong> and <strong>short</strong> signed and <strong>unsigned</strong> integer data types. <strong>long</strong> represents the range -231 &#32;.. &#32;231 &#32;- &#32;1 while <strong>unsigned long</strong> represents the range 0 .. 232 - 1. <strong>short</strong> represents the range -215 .. 215 - 1, while <strong>unsigned</strong> <strong>short </strong>represents the range 0 .. 216 - 1.<p>
</a><a name="528">
<h3>		 Floating-Point Types</h3>
</a><a name="529">
OMG IDL floating-point types are <strong>float</strong> and <strong>double</strong>. The <strong>float</strong> type represents IEEE single-precision floating point numbers; the <strong>double</strong> type represents IEEE double-precision floating point numbers.The IEEE floating point standard specification (<em>IEEE Standard for Binary Floating-Point Arithmetic</em>, ANSI/IEEE Std 754-1985) should be consulted for more information on the precision afforded by these types.<p>
</a><a name="530">
Implementations that do not fully support the value set of the IEEE 754 floating-point standard must completely specify their deviance from the standard. <p>
</a><a name="532">
<h3>		 Char Type</h3>
</a><a name="741">
OMG IDL defines a <strong>char</strong> data type consisting of 8-bit quantities. <p>
</a><a name="810">
The ISO Latin-1 (8859.1) character set standard defines the meaning and representation of all possible graphic characters (i.e., the space, alphabetic, digit and graphic characters defined in <a href="idlsyn.html#918">Figure 2 on page 3-3</a>, <a href="idlsyn.html#971">Figure 3 on page 3-4</a>, and <a href="idlsyn.html#735">Figure 4 on page 3-4</a>). The meaning and representation of the null and formatting characters (see <a href="idlsyn.html#728">Figure 5 on page 3-5</a>) is the numerical value of the character as defined in the ASCII (ISO 646) standard. The meaning of all other characters is implementation-dependent.<p>
</a><a name="820">
During transmission, characters may be converted to other appropriate forms as required by a particular language binding. Such conversions may change the representation of a character but maintain the character's meaning. For example, a character may be converted to and from the appropriate representation in international character sets.<p>
</a><a name="534">
<h3>		 Boolean Type</h3>
</a><a name="535">
The <strong>boolean</strong> data type is used to denote a data item that can only take one of the values TRUE and FALSE.<p>
</a><a name="536">
<h3>		 Octet Type</h3>
</a><a name="537">
The <strong>octet</strong> type is an 8-bit quantity that is guaranteed not to undergo any conversion when transmitted by the communication system.<p>
</a><a name="801">
<h3>		 Any Type</h3>
</a><a name="837">
The <strong>any</strong> type permits the specification of values that can express any OMG IDL type. <p>
</a><a name="538">
<h2>	3.8.2	 Constructed Types</h2>
</a><a name="539">
The constructed types are:<p>
</a><a name="2248">
<p>
</a><a name="540">
 &lt;constr_type_spec&gt;	::=	&lt;struct_type&gt;<br>	|	&lt;union_type&gt;<br>	|	&lt;enum_type&gt;<p>
</a><a name="1280">
Although it is syntactically possible to generate recursive type specifications in OMG IDL, such recursion is semantically constrained. The only permissible form of recursive type specification is through the use of the <strong>sequence</strong> template type. For example, the following is legal:<p>
</a><a name="1281">
 struct foo {<p>
</a><a name="1282">
<blockquote>						long value;</blockquote>
</a><a name="1283">
<blockquote>						sequence&lt;foo&gt; chain;</blockquote>
</a><a name="1284">
<blockquote>}</blockquote>
</a><a name="1285">
See <a href="idlsyn.html#576">"Sequences" on page 3-25</a> for details of the <strong>sequence</strong> template type. <p>
</a><a name="541">
<h3>		 Structures</h3>
</a><a name="542">
The structure syntax is:<p>
</a><a name="2249">
<p>
</a><a name="543">
 &lt;struct_type&gt;	::=	"struct" &lt;identifier&gt; "{" &lt;member_list&gt; "}"<p>
</a><a name="544">
 &lt;member_list&gt;	::=	&lt;member&gt;+<p>
</a><a name="545">
 &lt;member&gt;	::=	&lt;type_spec&gt; &lt;declarators&gt; ";"<p>
</a><a name="2250">
 <p>
</a><a name="546">
The <strong>&lt;identifier&gt;</strong> in <strong>&lt;struct_type&gt;</strong> defines a new legal type. Structure types may also be named using a <strong>typedef</strong> declaration.<p>
</a><a name="547">
Name scoping rules require that the member declarators in a particular structure be unique. The value of a <strong>struct</strong> is the value of all of its members.<p>
</a><a name="548">
<h3>		 Discriminated Unions</h3>
</a><a name="549">
The discriminated <strong>union</strong> syntax is:<p>
</a><a name="2251">
<p>
</a><a name="550">
 &lt;union_type&gt;	::=	"union" &lt;identifier&gt; "switch" "(" &lt;switch_type_spec&gt; ")"<br>					"{" &lt;switch_body&gt; "}"<p>
</a><a name="551">
 &lt;switch_type_spec&gt;	::=	&lt;integer_type&gt;<br>	|	&lt;char_type&gt;<br>	|	&lt;boolean_type&gt;<br>	|	&lt;enum_type&gt;<br>	|	&lt;scoped_name&gt;<p>
</a><a name="552">
 &lt;switch_body&gt;	::=	&lt;case&gt;+<p>
</a><a name="553">
 &lt;case&gt;	::=	&lt;case_label&gt;+ &lt;element_spec&gt; ";"<p>
</a><a name="554">
 &lt;case_label&gt;	::=	"case" &lt;const_exp&gt; ":"<br>	|	"default" ":"<p>
</a><a name="555">
 &lt;element_spec&gt;	::=	&lt;type_spec&gt; &lt;declarator&gt;<p>
</a><a name="556">
OMG IDL unions are a cross between the C union and switch statements. IDL unions must be discriminated; that is, the union header must specify a typed tag field that determines which union member to use for the current instance of a call. The <strong>&lt;identifier&gt;</strong> following the <strong>union</strong> keyword defines a new legal type. Union types may also be named using a <strong>typedef</strong> declaration. The <strong>&lt;const_exp&gt;</strong> in a <strong>&lt;case_label&gt;</strong> must be consistent with the <strong>&lt;switch_type_spec&gt;</strong>. A <strong>default</strong> case can appear at most once. The <strong>&lt;scoped_name&gt;</strong> in the <strong>&lt;switch_type_spec&gt;</strong> production must be a previously defined <strong>integer</strong>, <strong>char</strong>, <strong>boolean</strong> or <strong>enum</strong> type.<p>
</a><a name="557">
Case labels must match or be automatically castable to the defined type of the discriminator. The complete set of matching rules are shown in <a href="idlsyn.html#557">Figure 10 on page 3-24</a>.  
<Table Border="3">
<caption><a name="286">
TABLE 10.  Case Label Matching <p>
</a></caption>
<tr><th><a name="560">
 Discriminator Type<p>
</a><th><a name="561">
 Matched By<p>
</a>
<tr><td><a name="562">
 long<p>
</a><td><a name="563">
 any integer value in the value range of long<p>
</a>
<tr><td><a name="564">
 short<p>
</a><td><a name="565">
 any integer value in the value range of short<p>
</a>
<tr><td><a name="700">
 unsigned long<p>
</a><td><a name="701">
 any integer value in the value range of unsigned long<p>
</a>
<tr><td><a name="736">
 unsigned short<p>
</a><td><a name="1193">
 any integer value in the value range of unsigned short<p>
</a>
<tr><td><a name="1194">
 char<p>
</a><td><a name="1195">
 char<p>
</a>
<tr><td><a name="1196">
 boolean<p>
</a><td><a name="1197">
 TRUE or FALSE<p>
</a>
<tr><td><a name="1198">
 enum<p>
</a><td><a name="1199">
 any enumerator for the discriminator enum type<p>
</a>

</Table>

<Table>
<tr><td>
</Table>
<p>
</a><a name="559">
Name scoping rules require that the element declarators in a particular union be unique. If the <strong>&lt;switch_type_spec&gt;</strong> is an <strong>&lt;enum_type&gt;</strong>, the identifier for the enumeration is in the scope of the union; as a result, it must be distinct from the element declarators. <p>
</a><a name="567">
It is not required that all possible values of the union discriminator be listed in the <strong>&lt;switch_body&gt;</strong>. The value of a union is the value of the discriminator together with one of the following:<p>
</a><a name="2252">
<p>
</a><ul><a name="494">
<li>If the discriminator value was explicitly listed in a <strong>case</strong> statement, the value of the element associated with that <strong>case</strong> statement; 
</a><a name="798">
<li>If a default <strong>case</strong> label was specified, the value of the element associated with the default <strong>case</strong> label;
</a><a name="799">
<li>No additional value.
</a></ul><a name="493">
Access to the discriminator and the related element is language-mapping dependent.<p>
</a><a name="568">
<h3>		 Enumerations</h3>
</a><a name="569">
Enumerated types consist of ordered lists of identifiers. The syntax is:<p>
</a><a name="2253">
<p>
</a><a name="570">
 &lt;enum_type&gt;	::=	"enum" &lt;identifier&gt; "{" &lt;enumerator&gt; { "," &lt;enumerator&gt; }* "}"<p>
</a><a name="571">
 &lt;enumerator&gt;	::=	&lt;identifier&gt;<p>
</a><a name="572">
A maximum of 232 identifiers may be specified in an enumeration; as such, the enumerated names must be mapped to a native data type capable of representing a maximally-sized enumeration. The order in which the identifiers are named in the specification of an enumeration defines the relative order of the identifiers. Any language mapping which permits two enumerators to be compared or defines successor/predecessor functions on enumerators must conform to this ordering relation. The <strong>&lt;identifier&gt;</strong> following the <strong>enum</strong> keyword defines a new legal type. Enumerated types may also be named using a <strong>typedef</strong> declaration.<p>
</a><a name="573">
<h2>	3.8.3	 Template Types</h2>
</a><a name="574">
The template types are:<p>
</a><a name="2254">
<p>
</a><a name="575">
 &lt;template_type_spec&gt;	:   :=	&lt;sequence_type&gt;<br>	|	&lt;string_type&gt;<p>
</a><a name="576">
<h3>		 Sequences</h3>
</a><a name="577">
OMG IDL defines the sequence type <strong>sequence</strong>. A sequence is a one-dimensional array with two characteristics: a maximum size (which is fixed at compile time) and a length (which is determined at run time).<p>
</a><a name="578">
The syntax is:<p>
</a><a name="2255">
<p>
</a><a name="579">
 &lt;sequence_type&gt;	   ::=	"sequence" "&lt;" &lt;simple_type_spec&gt; "," &lt;positive_int_const&gt; "&gt;"<br>	|	"sequence" "&lt;" &lt;simple_type_spec&gt; "&gt;"<p>
</a><a name="582">
The second parameter in a sequence declaration indicates the maximum size of the sequence. If a positive integer constant is specified for the maximum size, the sequence is termed a bounded sequence. Prior to passing a bounded sequence as a function argument (or as a field in a structure or union), the length of the sequence must be set in a language-mapping dependent manner. After receiving a sequence result from an operation invocation, the length of the returned sequence will have been set; this value may be obtained in a language-mapping dependent manner.<p>
</a><a name="583">
If no maximum size is specified, size of the sequence is unspecified (unbounded). Prior to passing such a sequence as a function argument (or as a field in a structure or union), the length of the sequence, the maximum size of the sequence, and the address of a buffer to hold the sequence must be set in a language-mapping dependent manner. After receiving such a sequence result from an operation invocation, the length of the returned sequence will have been set; this value may be obtained in a language-mapping dependent manner. <p>
</a><a name="664">
A sequence type may be used as the type parameter for another sequence type.  For example, the following:<p>
</a><a name="1303">
 typedef sequence&lt; sequence&lt;long&gt; &gt; Fred;<p>
</a><a name="584">
declares Fred to be of type "unbounded sequence of unbounded sequence of long". Note that for nested sequence declarations, white space must be used to separate the two "&gt;" tokens ending the declaration so they are not parsed as a single "&gt;&gt;" token.<p>
</a><a name="747">
<h3>		 Strings</h3>
</a><a name="585">
OMG IDL defines the string type <strong>string</strong> consisting of all possible 8-bit quantities except null. A string is similar to a sequence of char. As with sequences of any type, prior to passing a string as a function argument (or as a field in a structure or union), the length of the string must be set in a language-mapping dependent manner. The syntax is:<p>
</a><a name="2256">
<p>
</a><a name="586">
 	&lt;string_type&gt;	:  :=	"string" "&lt;" &lt;positive_int_const&gt; "&gt;"<br>	|	"string"<p>
</a><a name="588">
The argument to the string declaration is the maximum size of the string. If a positive integer maximum size is specified, the string is termed a bounded string; if no maximum size is specified, the string is termed an unbounded string.<p>
</a><a name="589">
Strings are singled out as a separate type because many languages have special built-in functions or standard library functions for string manipulation. A separate string type may permit substantial optimization in the handling of strings compared to what can be done with sequences of general types.<p>
</a><a name="590">
<h2>	3.8.4	 Complex Declarator</h2>
</a><a name="591">
<h3>		 Arrays</h3>
</a><a name="592">
OMG IDL defines multidimensional, fixed-size arrays. An<strong> </strong>array includes explicit sizes for each dimension.<p>
</a><a name="593">
The syntax for arrays is:<p>
</a><a name="2257">
<p>
</a><a name="594">
 &lt;array_declarator&gt;	   ::=	&lt;identifier&gt; &lt;fixed_array_size&gt;+<p>
</a><a name="595">
 &lt;fixed_array_size&gt;	   ::=	"[" &lt;positive_int_const&gt; "]"<p>
</a><a name="596">
The array size (in each dimension) is fixed at compile time. When an array is passed as a parameter in an operation invocation, all elements of the array are transmitted.<p>
</a><a name="341">
The implementation of array indices is language mapping specific; passing an array index as a parameter may yield incorrect results. <p>
</a><a name="597">
<h1>	3.9	 Exception Declaration</h1>
</a><a name="598">
Exception declarations permit the declaration of struct-like data structures which may be returned to indicate that an exceptional condition has occurred during the performance of a request. The syntax is as follows:<p>
</a><a name="2864">
<p>
</a><a name="599">
 &lt;except_dcl&gt;	:  :=	"exception" &lt;identifier&gt; "{" &lt;member&gt;* "}"<p>
</a><a name="838">
Each exception is characterized by its OMG IDL identifier, an exception type identifier, and the type of the associated return value (as specified by the <strong>&lt;member&gt;</strong>s in its declaration. If an exception is returned as the outcome to a request, then the value of the exception identifier is accessible to the programmer for determining which particular exception was raised. <p>
</a><a name="600">
If an exception is declared with members, a programmer will be able to access the values of those members when an exception is raised. If no members are specified, no additional information is accessible when an exception is raised. <p>
</a><a name="492">
A set of standard exceptions is defined corresponding to standard runtime errors which may occur during the execution of a request. These standard exceptions are documented in <a href="idlsyn.html#690">"Standard Exceptions" on page 3-33</a>.<p>
</a><a name="610">
<h1>	3.10	 Operation Declaration</h1>
</a><a name="611">
Operation declarations in OMG IDL are similar to C function declarations. The syntax is:<p>
</a><a name="2261">
<p>
</a><a name="612">
 &lt;op_dcl&gt;	::=	[ &lt;op_attribute&gt; ] &lt;op_type_spec&gt; &lt;identifier&gt; &lt;parameter_dcls&gt;<br>					[ &lt;raises_expr&gt; ] [ &lt;context_expr&gt; ]<p>
</a><a name="613">
 &lt;op_type_spec&gt;	::=	&lt;param_type_spec&gt;<br>	|	"void"<p>
</a><a name="614">
An operation declaration consists of:<p>
</a><ul><a name="615">
<li>An optional operation attribute that specifies which invocation semantics the communication system should provide when the operation is invoked. Operation attributes are described in <a href="idlsyn.html#623">"Operation Attribute" on page 3-28</a>.
</a><a name="616">
<li>The type of the operation's return result; the type may be any type which can be defined in OMG IDL. Operations that do not return a result must specify the <strong>void</strong> type.
</a><a name="617">
<li>An identifier that names the operation in the scope of the interface in which it is defined.
</a><a name="618">
<li>A parameter list that specifies zero or more parameter declarations for the operation. Parameter declaration is described in <a href="idlsyn.html#628">"Parameter Declarations" on page 3-28</a>.
</a><a name="619">
<li>An optional raises expression which indicates which exceptions may be raised as a result of an invocation of this operation. Raises expressions are described in Section <a href="idlsyn.html#639">"Raises Expressions" on page 3-29</a>.
</a><a name="620">
<li>An optional context expression which indicates which elements of the request context may be consulted by the method that implements the operation. Context expressions are described in <a href="idlsyn.html#645">"Context Expressions" on page 3-29</a>.
</a></ul><a name="621">
Some implementations and/or language mappings may require operation-specific pragmas to immediately precede the affected operation declaration. <p>
</a><a name="623">
<h2>	3.10.1	 Operation Attribute</h2>
</a><a name="624">
The operation attribute specifies which invocation semantics the communication service must provide for invocations of a particular operation. An operation attribute is optional. The syntax for its specification is as follows:<p>
</a><a name="2262">
<p>
</a><a name="625">
 &lt;op_attribute&gt;	::=	"oneway"<p>
</a><a name="626">
When a client invokes an operation with the <strong>oneway</strong> attribute, the invocation semantics are best-effort, which does not guarantee delivery of the call; best-effort implies that the operation will be invoked at most once. An operation with the <strong>oneway</strong> attribute must not contain any output parameters and must specify a <strong>void</strong> return type. An operation defined with the <strong>oneway</strong> attribute may not include a raises expression; invocation of such an operation, however, may raise a standard exception. <p>
</a><a name="627">
If an <strong>&lt;op_attribute&gt;</strong> is not specified, the invocation semantics is at-most-once if an exception is raised; the semantics are exactly-once if the operation invocation returns successfully.<p>
</a><a name="628">
<h2>	3.10.2	 Parameter Declarations</h2>
</a><a name="629">
Parameter declarations in OMG IDL operation declarations have the following syntax:<p>
</a><a name="2263">
<p>
</a><a name="630">
 &lt;parameter_dcls&gt;	::=	"(" &lt;param_dcl&gt; { "," &lt;param_dcl&gt; }* ")"<br>	|	"(" ")"<p>
</a><a name="631">
 &lt;param_dcl&gt;	::=	&lt;param_attribute&gt; &lt;param_type_spec&gt; &lt;simple_declarator&gt;<p>
</a><a name="632">
 &lt;param_attribute&gt;	::=	"in"<br>	|	"out"<br>	|	"inout"<p>
</a><a name="1306">
 &lt;param_type_spec&gt;	::=	&lt;base_type_spec&gt;<br>	|	&lt;string_type&gt;<br>	|	&lt;scoped_name&gt;<p>
</a><a name="1305">
 <p>
</a><a name="633">
A parameter declaration must have a directional attribute that informs the communication service in both the client and the server of the direction in which the parameter is to be passed. The directional attributes are:<p>
</a><a name="2264">
<p>
</a><ul><a name="634">
<li><strong>in</strong> - the parameter is passed from client to server.
</a><a name="635">
<li><strong>out</strong> - the parameter is passed from server to client.
</a><a name="636">
<li><strong>inout</strong> - the parameter is passed in both directions.
</a></ul><a name="637">
It is expected that an implementation will <em>not</em> attempt to modify an <strong>in</strong> parameter. The ability to even attempt to do so is language-mapping specific; the effect of such an action is undefined.<p>
</a><a name="638">
If an exception is raised as a result of an invocation, the values of the return result and any <strong>out</strong> and <strong>inout</strong> parameters are undefined.<p>
</a><a name="1300">
When an unbounded <strong>string</strong> or <strong>sequence</strong> is passed as an <strong>inout</strong> parameter, the returned value cannot be longer than the input value. <p>
</a><a name="639">
<h2>	3.10.3	 Raises Expressions</h2>
</a><a name="640">
A <strong>raises</strong> expression specifies which exceptions may be raised as a result of an invocation of the operation. The syntax for its specification is as follows:<p>
</a><a name="2395">
<p>
</a><a name="641">
 &lt;raises_expr&gt;	::=	"raises" "(" &lt;scoped_name&gt; { "," &lt;scoped_name&gt; }* ")"<p>
</a><a name="2265">
 <p>
</a><a name="642">
The <strong>&lt;scoped_name&gt;</strong>'s in the <strong>raises</strong> expression must be previously defined exceptions.<p>
</a><a name="643">
In addition to any operation-specific exceptions specified in the <strong>raises</strong> expression, there are a standard set of exceptions that may be signalled by the ORB. These standard exceptions are described in <a href="idlsyn.html#690">"Standard Exceptions" on page 3-33</a>. However, standard exceptions may <em>not</em> be listed in a <strong>raises</strong> expression. <p>
</a><a name="644">
The absence of a <strong>raises</strong> expression on an operation implies that there are no operation-specific exceptions. Invocations of such an operation are still liable to receive one of the standard exceptions.<p>
</a><a name="645">
<h2>	3.10.4	 Context Expressions</h2>
</a><a name="646">
A <strong>context</strong> expression specifies which elements of the client's context may affect the performance of a request by the object. The syntax for its specification is as follows:<p>
</a><a name="2266">
<p>
</a><a name="647">
 &lt;context_expr&gt;	::=	"context" "(" &lt;string_literal&gt; { "," &lt;string_literal&gt; }* ")"<p>
</a><a name="648">
The runtime system guarantees to make the value (if any) associated with each <strong>&lt;string_literal&gt;</strong> in the client's context available to the object implementation when the request is delivered. The ORB and/or object is free to use information in this <em>request context</em> during request resolution and performance.<p>
</a><a name="649">
The absence of a context expression indicates that there is no request context associated with requests for this operation. <p>
</a><a name="806">
Each <strong>string_literal</strong> is an arbitrarily long sequence of alphabetic, digit, period ("."), underscore ("_"), and asterisk ("*") characters. The first character of the string must be an alphabetic character. An asterisk may only be used as the last character of the string. Some implementations may use the period character to partition the name space.<p>
</a><a name="650">
The mechanism by which a client associates values with the context identifiers is described in the Dynamic Invocation Interface chapter.<p>
</a><a name="601">
<h1>	3.11	 Attribute Declaration</h1>
</a><a name="602">
An interface can have attributes as well as operations; as such, attributes are defined as part of an interface. An attribute definition is logically equivalent to declaring a pair of accessor functions; one to retrieve the value of the attribute and one to set the value of the attribute.<p>
</a><a name="2810">
 The syntax for <strong>attribute</strong>   declaration is:<p>
</a><a name="2874">
 <p>
</a><a name="2811">
 &lt;attr_dcl&gt;      ::=[ "readonly" ] "attribute" &lt;param_type_spec&gt; &lt;simple_declarator&gt;<br>			{ "," 	&lt;simple_declarator&gt; }*<p>
</a><a name="605">
The optional <strong>readonly</strong> keyword indicates that there is only a single accessor function-the retrieve value function. Consider the following example:<p>
</a><a name="606">
 interface foo {<p>
</a><a name="607">
<blockquote>	enum material_t {rubber, glass};</blockquote>
</a><a name="608">
<blockquote>	struct position_t {</blockquote>
</a><a name="609">
<blockquote>		float x, y;</blockquote>
</a><a name="689">
<blockquote>	};</blockquote>
</a><a name="710">
<blockquote></blockquote>
</a><a name="711">
<blockquote>	attribute float radius;</blockquote>
</a><a name="712">
<blockquote>	attribute material_t material;</blockquote>
</a><a name="713">
<blockquote>	readonly attribute position_t position;</blockquote>
</a><a name="714">
<blockquote></blockquote>
</a><a name="715">
<blockquote>	&#183; &#183; &#183;</blockquote>
</a><a name="717">
 };<p>
</a><a name="718">
The attribute declarations are equivalent to the following pseudo-specification fragment:<p>
</a><a name="719">
 &#183; &#183; &#183;<p>
</a><a name="720">
<blockquote>float 			_get_radius ();</blockquote>
</a><a name="721">
<blockquote>void 			_set_radius (in float r);</blockquote>
</a><a name="722">
<blockquote>material_t 			_get_material ();</blockquote>
</a><a name="723">
<blockquote>void 			_set_material (in material_t m);</blockquote>
</a><a name="724">
<blockquote>position_t 			_get_position ();</blockquote>
</a><a name="725">
 &#183; &#183; &#183;<p>
</a><a name="726">
The actual accessor function names are language-mapping specific.  The C, C++, and Smalltalk  mappings are described in separate chapters. The attribute name is subject to OMG IDL's name scoping rules; the accessor function names are guaranteed <em>not</em> to collide with any legal operation names specifiable in OMG IDL.<p>
</a><a name="783">
Attribute operations return errors by means of standard exceptions. <p>
</a><a name="488">
Attributes are inherited. An attribute name <em>cannot</em> be redefined to be a different type. See <a href="idlsyn.html#1302">"CORBA Module" on page 3-31</a> for more information on redefinition constraints and the handling of ambiguity.<p>
</a><a name="797">
<h1>	3.12	 CORBA Module</h1>
</a><a name="1304">
In order to prevent names defined in the <em>CORBA </em>specification from clashing with names in programming languages and other software systems, all names defined in <em>CORBA</em> are treated as if they were defined within a module named CORBA.  In an OMG IDL specification, however, OMG IDL keywords  such as Object must not be preceded by a "CORBA::" prefix.  Other interface names such as TypeCode are not OMG IDL keywords,  so they must be referred to by their fully scoped names (e.g., CORBA::TypeCode) within an OMG IDL specification.<p>
</a><a name="1302">
<h1>	3.13	 Names and Scoping</h1>
</a><a name="651">
An entire OMG IDL file forms a naming scope. In addition, the following kinds of definitions form nested scopes:<p>
</a><ul><a name="1288">
<li>module
</a><a name="1289">
<li>interface
</a><a name="1290">
<li>structure
</a><a name="1291">
<li>union
</a><a name="1292">
<li>operation
</a><a name="1293">
<li>exception
</a></ul><a name="652">
Identifiers for the following kinds of definitions are scoped:<p>
</a><ul><a name="653">
<li>types
</a><a name="654">
<li>constants
</a><a name="655">
<li>enumeration values
</a><a name="656">
<li>exceptions
</a><a name="795">
<li>interfaces
</a><a name="657">
<li>attributes
</a><a name="658">
<li>operations
</a></ul><a name="2436">
An identifier can only be defined once in a scope. However, identifiers can be redefined in nested scopes. An identifier declaring a module is considered to be defined by its first occurrence in a scope. Subsequent occurrences of a module declaration within the same scope reopen the module allowing additional definitions to be added to it.<p>
</a><a name="776">
Due to possible restrictions imposed by future language bindings, OMG IDL identifiers are case insensitive; that is,  two identifiers that differ only in the case of their characters are considered redefinitions of one another. However, all references to a definition must use the same case as the defining occurrence. (This allows natural mappings to case-sensitive languages.)<p>
</a><a name="662">
Type names defined in a scope are available for immediate use within that scope. In particular, see <a href="idlsyn.html#538">"Constructed Types" on page 3-22</a> on cycles in type definitions. <p>
</a><a name="663">
A name can be used in an unqualified form within a particular scope; it will be resolved by successively searching farther out in enclosing scopes. Once an unqualified name is used in a scope, it cannot be redefined-i.e. if one has used a name defined in an enclosing scope in the current scope, one cannot then redefine a version of the name in the current scope. Such redefinitions yield a compilation error. <p>
</a><a name="1295">
A qualified name (one of the form &lt;scoped-name&gt;::&lt;identifier&gt;) is resolved by first resolving the qualifier &lt;scoped-name&gt; to a scope S, and then locating the definition of &lt;identifier&gt; within S. The identifier must be directly defined in S or (if S is an interface) inherited into S. The &lt;identifier&gt; is not searched for in enclosing scopes. <p>
</a><a name="1296">
When a qualified name begins with "::", the resolution process starts with the file scope and locates  subsequent identifiers in the qualified name by the rule described in the previous paragraph. <p>
</a><a name="1297">
Every OMG IDL definition in a file has a global name within that file. The global name for a definition is constructed as follows. <p>
</a><a name="659">
Prior to starting to scan a file containing an OMG IDL specification, the name of the current root is initially empty ("") and the name of the current scope is initially empty (""). Whenever a <strong>module</strong> keyword is encountered, the string "::" and the associated identifier are appended to the name of the current root; upon detection of the termination of the <strong>module</strong>, the trailing "::" and identifier are deleted from the name of the current root. Whenever an <strong>interface</strong>, <strong>struct</strong>, <strong>union</strong>, or <strong>exception</strong> keyword is encountered, the string "::" and the associated identifier are appended to the name of the current scope; upon detection of the termination of the <strong>interface</strong>, <strong>struct</strong>, <strong>union</strong>, or <strong>exception</strong>, the trailing "::" and identifier are deleted from the name of the current scope. Additionally, a new, unnamed, scope is entered when the parameters of an operation declaration are processed; this allows the parameter names to duplicate other identifiers; when parameter processing has completed, the unnamed scope is exited. <p>
</a><a name="1298">
The global name of an OMG IDL definition is the concatenation of the current root, the current scope, a "::", and the &lt;identifier&gt;,  which is the local name for that definition. <p>
</a><a name="2424">
Note that the global name in an OMG IDL files corresponds to an absolute <strong>ScopedName</strong> in the Interface Repository.  (<a href="intrep2.html#819">See "Supporting Type Definitions" on page 6-8.</a>)  <p>
</a><a name="854">
Inheritance produces shadow copies of the inherited identifiers; that is, it introduces names into the derived interface, but these names are considered to be semantically the same as the original definition. Two shadow copies of the same original (as results from the diamond shape in <a href="idlsyn.html#453">Figure 11 on page 3-16</a>) introduce a single name into the derived interface and don't conflict with each other.<p>
</a><a name="858">
Inheritance introduces multiple global OMG IDL names for the inherited identifiers. Consider the following example:<p>
</a><a name="861">
 interface A {<p>
</a><a name="863">
<blockquote>	exception E {</blockquote>
</a><a name="864">
<blockquote>		long L;</blockquote>
</a><a name="867">
<blockquote>	};</blockquote>
</a><a name="868">
<blockquote>	void f() raises(E);</blockquote>
</a><a name="869">
<blockquote>};</blockquote>
</a><a name="871">
<blockquote></blockquote>
</a><a name="872">
<blockquote>interface B: A {</blockquote>
</a><a name="874">
<blockquote>	void g() raises(E);</blockquote>
</a><a name="877">
 };<p>
</a><a name="887">
In this example, the exception is known by the global names <strong>::A::E</strong> and <strong>::B::E</strong>.<p>
</a><a name="2270">
 <p>
</a><a name="665">
Ambiguity can arise in specifications due to the nested naming scopes. For example:<p>
</a><a name="666">
 interface A {<br>	typedef string&lt;128&gt; string_t;<br>};<br><br>interface B {<br>	typedef string&lt;256&gt; string_t;<br>};<br><br>interface C: A, B {<br>	attribute string_t Title;								/* AMBIGUOUS!!! */<br>};<p>
</a><a name="667">
The attribute declaration in C is ambiguous, since the compiler does not know which <strong>string_t</strong> is desired. Ambiguous declarations yield compilation errors. <p>
</a><a name="668">
<h1>	3.14	 Differences from C++</h1>
</a><a name="669">
The OMG IDL grammar, while attempting to conform to the C++ syntax, is somewhat more restrictive. The current restrictions are as follows:<p>
</a><ul><a name="670">
<li>A function return type is mandatory.
</a><a name="671">
<li>A name must be supplied with each formal parameter to an operation declaration.
</a><a name="672">
<li>A parameter list consisting of the single token <strong>void</strong> is <em>not</em> permitted as a synonym for an empty parameter list.
</a><a name="673">
<li>Tags are required for structures, discriminated unions, and enumerations.
</a><a name="674">
<li>Integer types cannot be defined as simply int or unsigned; they must be declared explicitly as <strong>short</strong> or <strong>long</strong>.
</a><a name="675">
<li><strong>char</strong> cannot be qualified by <strong>signed</strong> or <strong>unsigned</strong> keywords.
</a></ul><a name="690">
<h1>	3.15	 Standard Exceptions</h1>
</a><a name="1942">
This section presents the standard exceptions defined for the ORB. These exception identifiers may be returned as a result of any operation invocation, regardless of the interface specification. Standard exceptions may not be listed in <strong>raises</strong> expressions. <p>
</a><a name="730">
In order to bound the complexity in handling the standard exceptions, the set of standard exceptions should be kept to a tractable size. This constraint forces the definition of equivalence classes of exceptions rather than enumerating many similar exceptions. For example, an operation invocation can fail at many different points due to the inability to allocate dynamic memory. Rather than enumerate several different exceptions corresponding to the different ways that memory allocation failure causes the exception (during marshalling, unmarshalling, in the client, in the object implementation, allocating network packets, ...), a single exception corresponding to dynamic memory allocation failure is defined. Each standard exception includes a minor code to designate the subcategory of the exception; the assignment of values to the minor codes is left to each ORB implementation. <p>
</a><a name="661">
Each standard exception also includes a <strong>completion_status</strong> code which takes one of the values {COMPLETED_YES, COMPLETED_NO, COMPLETED_MAYBE}. These have the following meanings: <p>
</a><a name="716">
 COMPLETED_YES	 The object implementation has completed processing prior to the exception being raised.<p>
</a><a name="733">
 COMPLETED_NO	 The object implementation was never initiated prior to the exception being raised. <p>
</a><a name="740">
 COMPLETED_MAYBE	 The status of implementation completion is indeterminate.<p>
</a><a name="744">
<h2>	3.15.1	  Standard Exceptions Definitions</h2>
</a><a name="1943">
The standard exceptions are defined below. <p>
</a><a name="748">
<blockquote></blockquote>
</a><a name="780">
<blockquote>	#define ex_body {unsigned long minor; completion_status completed;}</blockquote>
</a><a name="750">
<blockquote>	</blockquote>
</a><a name="749">
<blockquote>	enum completion_status {COMPLETED_YES, COMPLETED_NO, COMPLETED_MAYBE};</blockquote>
</a><a name="796">
<blockquote>	enum exception_type {NO_EXCEPTION, USER_EXCEPTION, SYSTEM_EXCEPTION};</blockquote>
</a><a name="836">
<blockquote></blockquote>
</a><a name="752">
<blockquote>	exception UNKNOWN 												ex_body;			// the unknown exception</blockquote>
</a><a name="753">
<blockquote>	exception BAD_PARAM												ex_body; 			// an invalid parameter was</blockquote>
</a><a name="3200">
<blockquote>																// passed</blockquote>
</a><a name="754">
<blockquote>	exception NO_MEMORY												ex_body; 			// dynamic memory allocation</blockquote>
</a><a name="3201">
<blockquote>																// failure	</blockquote>
</a><a name="755">
<blockquote>	exception IMP_LIMIT												ex_body; 			// violated implementation limit</blockquote>
</a><a name="756">
<blockquote>	exception COMM_FAILURE												ex_body; 			// communication failure</blockquote>
</a><a name="757">
<blockquote>	exception INV_OBJREF					 							ex_body; 			// invalid object reference</blockquote>
</a><a name="758">
<blockquote>	exception NO_PERMISSION												ex_body; 			// no permission for attempted op.</blockquote>
</a><a name="759">
<blockquote>	exception INTERNAL												ex_body; 			// ORB internal error</blockquote>
</a><a name="760">
<blockquote>	exception MARSHAL												ex_body; 			// error marshalling param/result</blockquote>
</a><a name="761">
<blockquote>	exception INITIALIZE												ex_body; 			// ORB initialization failure</blockquote>
</a><a name="762">
<blockquote>	exception NO_IMPLEMENT												ex_body; 			// operation implementation</blockquote>
</a><a name="3173">
<blockquote>  																// unavailable</blockquote>
</a><a name="763">
<blockquote>	exception BAD_TYPECODE												ex_body; 			// bad typecode</blockquote>
</a><a name="764">
<blockquote>	exception BAD_OPERATION												ex_body; 			// invalid operation</blockquote>
</a><a name="765">
<blockquote>	exception NO_RESOURCES												ex_body; 			// insufficient resources for req.</blockquote>
</a><a name="767">
<blockquote>	exception NO_RESPONSE												ex_body; 			// response to req. not yet</blockquote>
</a><a name="3179">
<blockquote>																// available</blockquote>
</a><a name="287">
<blockquote>	exception PERSIST_STORE												ex_body; 			// persistent storage failure</blockquote>
</a><a name="768">
<blockquote>	exception BAD_INV_ORDER												ex_body; 			// routine invocations out of order</blockquote>
</a><a name="769">
<blockquote>	exception TRANSIENT												ex_body; 			// transient failure - reissue</blockquote>
</a><a name="3180">
<blockquote>																// request</blockquote>
</a><a name="770">
<blockquote>	exception FREE_MEM												ex_body; 			// cannot free memory</blockquote>
</a><a name="771">
<blockquote>	exception INV_IDENT												ex_body; 			// invalid identifier syntax</blockquote>
</a><a name="772">
<blockquote>	exception INV_FLAG												ex_body; 			// invalid flag was specified</blockquote>
</a><a name="781">
<blockquote>	exception INTF_REPOS												ex_body; 			// error accessing interface</blockquote>
</a><a name="3181">
<blockquote>																// repository</blockquote>
</a><a name="454">
<blockquote>	exception BAD_CONTEXT												ex_body; 			// error processing context object</blockquote>
</a><a name="511">
<blockquote>	exception OBJ_ADAPTER												ex_body; 			// failure detected by object</blockquote>
</a><a name="3182">
<blockquote>																// adapter</blockquote>
</a><a name="751">
<blockquote>	exception DATA_CONVERSION													ex_body; 			// data conversion error</blockquote>
</a><a name="3154">
<blockquote>	exception OBJECT_NOT_EXIST													ex_body; 			// non-existent object, delete</blockquote>
</a><a name="3183">
<blockquote>																	// reference</blockquote>
</a><a name="3155">
<h2>	3.15.2	 Object Non-Existence</h2>
</a><a name="1953">
This standard system exception is raised whenever an invocation on a deleted object was performed. It is an authoritative "hard" fault report. Anyone receiving it is allowed (even expected) to delete all copies of this object reference and to perform other appropriate "final recovery" style procedures.<p>
</a><a name="1954">
Bridges forward this exception to clients, also destroying any records they may hold (for example, proxy objects used in reference translation). The clients could in turn purge any of their own data structures.<p>
</a><a name="803">
<p>
</a>
<hr><br>
 
<a href="cover.html">[Top]</a> <a href="arch2.html">[Prev]</a> <a href="dii2.html">[Next]</a> <a href="corb2pra.html">[Bottom]</a>
<hr><br>
 
<sup>1</sup><a name="531">
 	Ellis, Margaret A. and Bjarne Stroustrup, The Annotated C++ Reference Manual, Addison-Wesley Publishing Company, Reading, Massachusetts, 1990, ISBN 0-201-51459-1<p>
</a><sup>2</sup><a name="305">
 	This section is an adaptation of The Annotated C++ Reference Manual<em>,</em> Chapter 2; it differs in the list of legal keywords and punctuation.<p>
</a>

<address>
<a href="mailto:pubs@omg.org">pubs@omg.org</a>
</address>

<i>Copyright &#169; 1995, <a href="http://www.omg.org">Object Management Group.</a>  All rights
reserved.</i>

<!-- This file was created with Quadralay WebWorks Publisher 3.0.4 -->
<!-- -->
<!-- For more information on how this document, and how the rest of -->
<!-- this server was created, email pubs@omg.org -->
<!-- -->
<!-- Last updated: 06/10/96 08:47:33 -->

</body>
</html>
