<html><head><title></title></head>
<body bgcolor=#ffffff>
 
<a href="cover.html">[Top]</a> <a href="interov.html">[Prev]</a> <a href="bridge.html">[Next]</a> <a href="corb2pra.html">[Bottom]</a>
<hr><br>
 
<a name="275">
<h1> ORB Interoperability Architecture</h1>
</a><dl>
<p align=right clear=all>
<b><font size=7>
10 
</font></b>
</p>
<hr></dl>
<a name="3380">
This chapter provides the architectural framework used in the interoperability specifications (Chapters 9-13).<p>
</a><a name="2874">
<h1>	10.1	 Overview</h1>
</a><a name="298">
The original Request for Proposal on Interoperability (OMG Document 93-9-15) defines interoperability as the ability for a client on ORB A to invoke an OMG IDL-defined operation on an object on ORB B, where ORB A and ORB B are independently developed. It further identifies general requirements including in particular:<p>
</a><ul><a name="301">
<li>Ability for two vendors' ORBs to interoperate without prior knowledge of each other's implementation.
</a><a name="303">
<li>Support of all ORB functionality.
</a><a name="305">
<li>Preservation of content and semantics of ORB-specific information across ORB boundaries (for example, security).
</a></ul><a name="306">
In effect, the requirement is for invocations between client and server objects to be independent of whether they are on the same or different ORBs, and not to mandate fundamental modifications to existing ORB products.<p>
</a><a name="3993">
<h2>	10.1.1	 Domains</h2>
</a><a name="310">
The CORBA Object Model identifies various distribution transparencies that must be supported within a single ORB environment, such as location transparency. Elements of ORB functionality often correspond directly to such transparencies. Interoperability can be viewed as extending transparencies to span multiple ORBs.<p>
</a><a name="2952">
In this architecture a <em>domain</em> is a distinct scope, within which certain common characteristics are exhibited and common rules are observed: over which a distribution transparency is preserved. Thus, interoperability is fundamentally involved with transparently crossing such domain boundaries.<p>
</a><a name="2909">
Domains tend to be either administrative or technological in nature, and need not correspond to the boundaries of an ORB installation. Administrative domains include naming domains, trust groups, resource management domains and other \Qrun-time' characteristics of a system. Technology domains identify common protocols, syntaxes and similar \Qbuild-time' characteristics. In many cases, the need for technology domains derives from basic requirements of administrative domains.<p>
</a><a name="319">
Within a single ORB, most domains are likely to have similar scope to that of the ORB itself: common object references, network addresses, security mechanisms, and more. However, it is possible for there to be multiple domains of the same type supported by a given ORB: internal representation on different machine types, or security domains. Conversely, a domain may span several ORBs: similar network addresses may be used by different ORBs, type identifiers may be shared.<p>
</a><a name="3996">
<h2>	10.1.2	 Bridging Domains</h2>
</a><a name="322">
The abstract architecture describes ORB interoperability in terms of the translation required when an object request traverses domain boundaries. Conceptually, a mapping or <em>bridging mechanism</em> resides at the boundary between the domains, transforming requests expressed in terms of one domain's model into the model of the destination domain.<p>
</a><a name="325">
The concrete architecture identifies two approaches to inter-ORB bridging: <p>
</a><ul><a name="327">
<li>At application level, allowing flexibility and portability
</a><a name="1633">
<li>At ORB level, built into the ORB itself
</a></ul><a name="3374">
<h1>	10.2	 ORBs and ORB Services</h1>
</a><a name="3012">
The ORB Core is that part of the ORB which provides the basic representation of objects and the communication of requests. The ORB Core therefore supports the minimum functionality to enable a client to invoke an operation on a server object, with (some of) the distribution transparencies required by <em>CORBA 2.0</em>. <p>
</a><a name="343">
An object request may have implicit attributes which affect the way in which it is communicated - though not the way in which a client makes the request. These attributes include security, transactional capabilities, recovery and replication. These features are provided by "ORB Services", which will in some ORBs be layered as internal services over the core, or in other cases incorporated directly into an ORB's core. It is an aim of this specification to allow for new ORB Services to be defined in the future, without the need to modify or enhance this architecture.<p>
</a><a name="346">
Within a single ORB, ORB services required to communicate a request will be implemented and (implicitly) invoked in a private manner. For interoperability between ORBs, the ORB services used in the ORBs, and the correspondence between them, must be identified.<p>
</a><a name="349">
<h2>	10.2.1	 The Nature of ORB Services</h2>
</a><a name="351">
ORB Services are invoked implicitly in the course of application-level interactions. ORB Services range from fundamental mechanisms such as reference resolution and message encoding to advanced features such as support for security, transactions or replication. <p>
</a><a name="354">
An ORB Service is often related to a particular transparency. For example, message encoding - the marshaling and unmarshaling of the components of a request into and out of message buffers - provides transparency of the representation of the request. Similarly, reference resolution supports location transparency. Some transparencies, such as security, are supported by a combination of ORB Services and Object Services whilst others, such as replication, may involve interactions between ORB Services themselves. <p>
</a><a name="358">
ORB Services differ from Object Services in that they are positioned below the application and are invoked transparently to the application code. However, many ORB Services include components which correspond to conventional Object Services in that they are invoked explicitly by the application. <p>
</a><a name="360">
Security is an example of service with both ORB Service and normal Object Service components, the ORB components being those associated with transparently authenticating messages and controlling access to objects while the necessary administration and management functions resemble conventional Object Services.<p>
</a><a name="363">
<h2>	10.2.2	 ORB Services and Object Requests</h2>
</a><a name="365">
Interoperability between ORBs extends the scope of distribution transparencies and other request attributes to span multiple ORBs. This requires the establishment of relationships between supporting ORB Services in the different ORBs.<p>
</a><a name="367">
In order to discuss how the relationships between ORB Services are established, it is necessary to describe an abstract view of how an operation invocation is communicated from client to server object. <p>
</a><ul><a name="370">
<li>The client generates an operation request, using a reference to the server object, explicit parameters, and an implicit invocation context. 
</a><a name="372">
<li>This is processed by certain ORB Services on the client path;
</a><a name="374">
<li>On the server side, corresponding ORB Services process the incoming request, transforming it into a form directly suitable for invoking the operation on the server object.
</a><a name="3552">
<li>The server object performs the requested operation.
</a><a name="3553">
<li>Any result of the operation is returned to the client in a similar manner.
</a></ul><a name="376">
The correspondence between client-side and server-side ORB Services need not be one-to-one and in some circumstances may be far more complex. For example, if a client application requests on operation on a replicated server, there may be multiple server-side ORB service instances, possibly interacting with each other. <p>
</a><a name="378">
In other cases, such as security, client-side or server-side ORB Services may interact with Object Services such as authentication servers. <p>
</a><a name="380">
<h2>	10.2.3	 Selection of ORB Services</h2>
</a><a name="382">
The ORB Services used are determined by:<p>
</a><ul><a name="384">
<li>Static properties of both client and server objects; for example, whether a server is replicated;
</a><a name="386">
<li>Dynamic attributes determined by a particular invocation context; for example, whether a request is transactional; 
</a><a name="388">
<li>Administrative policies; for example, security.
</a></ul><a name="389">
Within a single ORB, private mechanisms (and optimizations) can be used to establish which ORB Services are required and how they are provided. Service selection might in general require negotiation to select protocols or protocol options. The same is true between different ORBs: it is necessary to agree which ORB Services are used, and how each transforms the request. Ultimately, these choices become manifest as one or more protocols between the ORBs, or as transformations of requests.<p>
</a><a name="3577">
In principle, agreement on the use of each ORB Service can be independent of the others and, in appropriately constructed ORBs, services could be layered in any order or in any grouping. This potentially allows applications to specify selective transparencies according to their requirements, although at this time CORBA provides no ways to penetrate its transparencies. <p>
</a><a name="393">
A client ORB must be able to determine which ORB Services must be used in order to invoke operations on a server object. Correspondingly, where a client requires dynamic attributes to be associated with specific invocations, or administrative policies dictate, it must be possible to cause the appropriate ORB Services to be used on client and server sides of the invocation path. Where this is not possible - because, for example, one ORB does not support the full set of services required - either the interaction cannot proceed or it can only do so with reduced facilities or transparencies.<p>
</a><a name="398">
<h1>	10.3	 Domains</h1>
</a><a name="400">
From a computational viewpoint, the OMG Object Model identifies various distribution transparencies which ensure that client and server objects are presented with a uniform view of a heterogeneous distributed system. From an engineering viewpoint, however, the system is not wholly uniform. There may be distinctions of location and possibly many others such as processor architecture, networking mechanisms and data representations. Even when a single ORB implementation is used throughout the system, local instances may represent distinct, possibly optimized scopes for some aspects of ORB functionality.<img src="local/images/inarcha.gif"><p>
</a><a name="2219">
Figure 10-1	 Different Kinds of Domains can Coexist.<p>
</a><a name="407">
Interoperability, by definition, introduces further distinctions, notably between the scopes associated with each ORB. To describe both the requirements for interoperability and some of the solutions, this architecture introduces the concept of <em>domains</em> to describe the scopes and their implications.<p>
</a><a name="409">
Informally, a domain is a set of objects sharing a common characteristic or abiding by common rules. It is a powerful modelling concept which can simplify the analysis and description of complex systems. There may be many types of domains, for example, management domains, naming domains, language domains, technology domains.<p>
</a><a name="413">
<h2>	10.3.1	 Definition of a Domain</h2>
</a><a name="415">
Domains allow partitioning of systems into collections of components which have some characteristic in common. In this architecture a domain is a scope in which a collection of objects, said to be members of the domain, is associated with some common characteristic; any object for which the association does not exist, or is undefined, is not a member of the domain. A domain can be modelled as an object and may be itself a member of other domains.<p>
</a><a name="418">
It is the scopes themselves and the object associations or bindings defined within them which characterize a domain.This information is disjoint between domains. However, an object may be a member of several domains, of similar kinds as well as of different kinds, and so the sets of members of domains may overlap. <p>
</a><a name="420">
The concept of a domain boundary is defined as the limit of the scope in which a particular characteristic is valid or meaningful. When a characteristic in one domain is translated to an equivalent in another domain, it is convenient to consider it as traversing the boundary between the two domains.<p>
</a><a name="422">
Domains are generally either administrative or technological in nature. Examples of domains related to ORB interoperability issues are:<p>
</a><ul><a name="423">
<li><em>Referencing domain</em> - the scope of an object reference
</a><a name="424">
<li><em>Representation domain</em> - the scope of a message transfer syntax and protocol
</a><a name="425">
<li><em>Network addressing domain</em> - the scope of a network address
</a><a name="3084">
<li><em>Network connectivity domain</em> - the potential scope of a network message
</a><a name="426">
<li><em>Security domain</em> - the extent of a particular security policy
</a><a name="3364">
<li><em>Type domain</em> - the scope of a particular type identifier
</a><a name="3368">
<li><em>Transaction domain</em> - the scope of a given transaction service
</a></ul><a name="427">
Domains can be related in two ways: containment, where a domain is contained within another domain, and federation, where two domains are joined in a manner agreed and set up by their administrators. <p>
</a><a name="430">
<h2>	10.3.2	 Mapping Between Domains: Bridging</h2>
</a><a name="432">
Interoperability between domains is only possible if there is a well-defined mapping between the behaviors of the domains being joined. Conceptually, a mapping mechanism or bridge resides at the boundary between the domains, transforming requests expressed in terms of one domain's model into the model of the destination domain. Note that the use of the term "bridge" in this context is conceptual and refers only to the functionality which performs the required mappings between distinct domains. There are several implementation options for such bridges and these are discussed elsewhere. <p>
</a><a name="436">
For full interoperability, it is essential that all the concepts used in one domain are transformable into concepts in other domains with which interoperability is required, or that if the bridge mechanism filters such a concept out, nothing is lost as far as the supported objects are concerned. In other words, one domain may support a superior service to others, but such a superior functionality will not be available to an application system spanning those domains.<p>
</a><a name="3435">
A special case of this requirement is that the object models of the two domains need to be compatible. This specification assumes that both domains are strictly compliant with the CORBA Object Model and the <em>CORBA V2.0</em> Core specifications. This includes the use of OMG IDL when defining interfaces, the use of the CORBA Core Interface Repository, and other modifications that were made to <em>CORBA</em> <em>V1.2</em>. Variances from this model could easily compromise some aspects of interoperability.<p>
</a><a name="440">
<h1>	10.4	 Interoperability Between ORBs</h1>
</a><a name="442">
An ORB "provides the mechanisms by which objects transparently make and receive requests and responses. In so doing, the ORB provides interoperability between applications on different machines in heterogeneous distributed environments..." ORB interoperability extends this definition to cases in which client and server objects on different ORBs "transparently make and receive requests..." <p>
</a><a name="3445">
Note that a direct consequence of this transparency requirement is that bridging must be bidirectional: that is, it must work as effectively for object references passed as parameters as for the target of an object invocation. Were bridging unidirectional (e.g. if one ORB could only be a client to another) then transparency would not have been provided, because object references passed as parameters would not work correctly: ones passed as "callback objects", for example, could not be used.<p>
</a><a name="3446">
Without loss of generality, most of this specification focuses on bridging in only one direction. This is purely to simplify discussions, and does not imply that unidirectional connectivity satisfies basic interoperability requirements.<p>
</a><a name="474">
<h2>	10.4.1	 ORB Services and Domains</h2>
</a><a name="476">
In this architecture, different aspects of ORB functionality - ORB Services - can be considered independently and associated with different domain types. The architecture does not, however, prescribe any particular decomposition of ORB functionality and interoperability into ORB Services and corresponding domain types. There is a range of possibilities for such a decomposition:<p>
</a><a name="480">
	1.	 The simplest model, for interoperability, is to treat all objects supported by one ORB (or, alternatively, all ORBs of a given type) as comprising one domain. Interoperability between any pair of different domains (or domain types) is then achieved by a specific all-encompassing bridge between the domains. (This is all <em>CORBA</em> <em>V2.0</em> implies.)<p>
</a><a name="483">
	2.	 More detailed decompositions would identify particular domain types - such as referencing, representation, security and networking. A core set of domain types would be pre-determined and allowance made for additional domain types to be defined as future requirements dictate (e.g. for new ORB Services).<p>
</a><a name="486">
<h2>	10.4.2	 ORBs and Domains</h2>
</a><a name="498">
In many respects, issues of interoperability between ORBs are similar to those which can arise with a single type of ORB (e.g. a product). For example:<p>
</a><ul><a name="2126">
<li>Two installations of the ORB may be installed in different security domains, with different Principal identifiers. Requests crossing those security domain boundaries will need to establish locally meaningful Principals for the caller identity, and for any Principals passed as parameters.
</a><a name="2138">
<li>Different installations might assign different type identifiers for equivalent types, and so requests crossing type domain boundaries would need to establish locally meaningful type identifiers (and perhaps more).
</a></ul><a name="2153">
Conversely, not all of these problems need to appear when connecting two ORBs of a different type (e.g. two different products). Examples include:<p>
</a><ul><a name="2154">
<li>They could be administered to share user visible naming domains, so that naming domains do not need bridging.
</a><a name="2155">
<li>They might reuse the same networking infrastructure, so that messages could be sent without needing to bridge different connectivity domains.
</a></ul><a name="499">
Additional problems can arise with ORBs of different types. In particular, they may support different concepts or models, between which there are no direct or natural mappings. CORBA only specifies the application level view of object interactions, and requires that distribution transparencies conceal a whole range of lower level issues. It follows that within any particular ORB, the mechanisms for supporting transparencies are not visible at the application level and are entirely a matter of implementation choice. So there is no guarantee that any two ORBs support similar internal models or that there is necessarily a straightforward mapping between those models.<p>
</a><a name="504">
These observations suggest that the concept of an ORB (instance) is too coarse or superficial to allow detailed analysis of interoperability issues between ORBs. Indeed, it becomes clear that an ORB instance is an elusive notion: it can perhaps best be characterized as the intersection or coincidence of ORB Service domains.<p>
</a><a name="508">
<h2>	10.4.3	 Interoperability Approaches</h2>
</a><a name="510">
When an interaction takes place across a domain boundary, a mapping mechanism, or bridge, is required to transform relevant elements of the interaction as they traverse the boundary. There are essentially two approaches to achieving this: mediated bridging and immediate bridging. These approaches are described in the following subsections.<img src="local/images/inarcha1.gif"><p>
</a><a name="2215">
Figure 10-2	 Two bridging techniques, different uses of an intermediate form agreed on between the two domains.<p>
</a><a name="516">
<h3>		 Mediated Bridging</h3>
</a><a name="518">
With mediated bridging, elements of the interaction relevant to the domain are transformed, at the boundary of each domain, between the internal form of that domain and an agreed, common form. <p>
</a><a name="520">
Observations on mediated bridging are as follows:<p>
</a><ul><a name="522">
<li>The scope of agreement of a common form can range from a private agreement between two particular ORB/domain implementations to a universal standard;
</a><a name="524">
<li>There can be more than one common form, each oriented or optimized for a different purpose; 
</a><a name="526">
<li>If there is more than one possible common form, then selection of which is used can be static (e.g. administrative policy agreed between ORB vendors, or between system administrators) or dynamic (e.g. established separately for each object, or on each invocation);
</a><a name="529">
<li>Engineering of this approach can range from in-line specifically compiled (compare to stubs) or generic library code (such as encryption routines) code, to intermediate bridges to the common form.
</a></ul><a name="532">
<h3>		 Immediate Bridging</h3>
</a><a name="534">
With immediate bridging, elements of the interaction relevant to the domain are transformed, at the boundary of each domain, directly between the internal form of one domain and the internal form of the other. <p>
</a><a name="536">
Observations on immediate bridging are as follows:<p>
</a><a name="876">
<p>
</a><a name="538">
&#183;	 This approach has the potential to be optimal (in that the interaction is not mediated via a third party, and can be specifically engineered for each pair of domains) but sacrifices flexibility and generality of interoperability to achieve this;<p>
</a><a name="544">
&#183;	 This approach is often applicable when crossing domain boundaries which are purely administrative (i.e. there is no change of technology). For example, when crossing security administration domains between similar ORBs, it is not necessary to use a common intermediate standard.<p>
</a><a name="546">
As a general observation, the two approaches can become almost indistinguishable when private mechanisms are used between ORB/domain implementations. <p>
</a><a name="548">
<h3>		 Location of Inter-Domain Functionality</h3>
</a><a name="550">
Logically, an inter-domain bridge has components in both domains, whether the mediated or immediate bridging approach is used. However, domains can span ORB boundaries and ORBs can span machine and system boundaries; conversely, a machine may support, or a process may have access to more than one ORB (or domain of a given type). From an engineering viewpoint, this means that the components of an inter-domain bridge may be dispersed or co-located, with respect to ORBs or systems. It also means that the distinction between an ORB and a bridge can be a matter of perspective: there is a duality between viewing inter-system messaging as belonging to ORBs, or to bridges.<p>
</a><a name="554">
For example, if a single ORB encompasses two security domains, the inter-domain bridge could be implemented wholly within the ORB and thus be invisible as far as ORB interoperability is concerned. A similar situation arises when a bridge between two ORBs or domains is implemented wholly within a process or system which has access to both. In such cases, the engineering issues of inter-domain bridging are confined, possibly to a single system or process. If it were practical to implement all bridging in this way, then interactions between systems or processes would be solely within a single domain or ORB.<p>
</a><a name="2204">
<h3>		 Bridging Level</h3>
</a><a name="566">
As noted at the start of this section, bridges may be implemented both internally to an ORB and as layers above it. These are called respectively "in-line" and "request-level" bridges.<p>
</a><a name="4318">
Request level bridges use the CORBA APIs, including the Dynamic Skeleton Interface, to receive and issue requests. However, there is an emerging class of "implicit context" which may be associated with some invocations, holding ORB Service information such as transaction and security context information, which is not at this time exposed through general purpose public APIs. (Those APIs expose only OMG IDL-defined operation parameters, not implicit ones.) Rather, the precedent set with the Transaction Service is that special purpose APIs are defined to allow bridging of each kind of context. This means that request level bridges must be built to specifically understand the implications of bridging such ORB Service domains, and to make the appropriate API calls.<p>
</a><a name="3402">
<h2>	10.4.4	 Policy-Mediated Bridging</h2>
</a><a name="3403">
An assumption made through most of this specification is that the existence of domain boundaries should be transparent to requests: that the goal of interoperability is to hide such boundaries. However, if this were always the goal, then there would be no real need for those boundaries in the first place.<p>
</a><a name="3404">
Realistically, administrative domain boundaries exist because they reflect ongoing differences in organizational policies or goals. Bridging the domains will in such cases require <em>policy mediation</em>. That is, inter-domain traffic will need to be constrained, controlled, or monitored; fully transparent bridging may be highly undesirable. Resource management policies may even need to be applied, restricting some kinds of traffic during certain periods.<p>
</a><a name="3405">
Security policies are a particularly rich source of examples: a domain may need to audit external access, or to provide domain-based access control. Only a very few objects, types of objects, or classifications of data might be externally accessible through a "firewall".<p>
</a><a name="3406">
Such policy-mediated bridging requires a bridge that knows something about the traffic being bridged. It could in general be an application-specific policy, and many policy-mediated bridges could be parts of applications. Those might be organization-specific, off-the-shelf, or anywhere in between.<p>
</a><a name="3407">
Request-level bridges, which use only public ORB APIs, easily support the addition of policy mediation components, without loss of access to any other system infrastructure that may be needed to identify or enforce the appropriate policies.<p>
</a><a name="3270">
<h2>	10.4.5	 Configurations of Bridges in Networks</h2>
</a><a name="3271">
In the case of network-aware ORBs, we anticipate that some ORB protocols will be more frequently bridged to than others, and so will begin to serve the role of "backbone ORBs". (This is a role that the IIOP is specifically expected to serve.) This use of "backbone topology" is true both on a large scale and a small scale. While a large scale public data network provider could define its own backbone ORB, on a smaller scale, any given institution will probably designate one commercially available ORB as its backbone.<img src="local/images/inarcha2.gif"><p>
</a><a name="3306">
Figure 10-3	 An ORB chosen as a backbone will connect other ORBs through bridges, both full-bridges and half-bridges.<p>
</a><a name="3307">
Adopting a backbone style architecture is a standard administrative technique for managing networks. It has the consequence of minimizing the number of bridges needed, while at the same time making the ORB topology match typical network organizations. (That is, it allows the number of bridges to be proportional to the number of protocols, rather than combinatorial.)<p>
</a><a name="3308">
In large configurations, it will be common to notice that adding ORB bridges doesn't even add any new "hops" to network routes, because the bridges naturally fit in locations where connectivity was already indirect, and augment or supplant the existing network firewalls.<p>
</a><a name="3640">
<h1>	10.5	 Object Addressing</h1>
</a><a name="3644">
The Object Model, in <a href="obmod2.html#445912">"Requests" on page &#32;1-2</a>, defines an object reference as an object name that reliably denotes a particular object. An object reference identifies the same object each time the reference is used in a request, and an object may be denoted by multiple, distinct references.<p>
</a><a name="3645">
The fundamental ORB interoperability requirement is to allow clients to use such object names to invoke operations on objects in other ORBs. Clients do not need to distinguish between references to objects in a local ORB or in a remote one. Providing this transparency can be quite involved, and naming models are fundamental to it.<p>
</a><a name="3646">
This section of this specification discusses models for naming entities in multiple domains, and transformations of such names as they cross the domain boundaries. That is, it presents transformations of object reference information as it passes through networks of inter-ORB bridges. It uses the word "ORB" as synonymous with referencing domain; this is purely to simplify the discussion. In other contexts, "ORB" can usefully denote other kinds of domain.<p>
</a><a name="3647">
<h2>	10.5.1	 Domain-relative Object Referencing</h2>
</a><a name="3648">
Since CORBA does not require ORBs to understand object references from other ORBs, when discussing object references from multiple ORBs one must always associate the object reference's domain (ORB) with the object reference. We use the notation <em>D0.R0</em> to denote an object reference <em>R0</em> from domain <em>D0</em>; this is itself an object reference. This is called "domain-relative" referencing (or addressing), and need not reflect the implementation of object references within any ORB.<p>
</a><a name="3649">
At an implementation level, associating an object reference with an ORB is only important at an inter-ORB boundary; that is, inside a bridge. This is simple, since the bridge knows from which ORB each request (or response) came, including any object references embedded in it.<p>
</a><a name="3650">
<h2>	10.5.2	 Handling of Referencing Between Domains</h2>
</a><a name="3651">
When a bridge hands an object reference to an ORB, it must do so in a form understood by that ORB: the object reference must be in the recipient ORB's native format. Also, in cases where that object originated from some other ORB, the bridge must associate each newly created "proxy" object reference with (what it sees as) the original object reference.<p>
</a><a name="3652">
Several basic schemes to solve these two problems exist. These all have advantages in some circumstances; all can be used, and in arbitrary combination with each other, since CORBA object references are opaque to applications. The ramifications of each scheme merits attention, with respect to scaling and administration. The schemes include:<p>
</a><a name="3653">
	1.	 	<em>Object Reference Translation Reference Embedding)</em>: The bridge can store the original object reference itself, and pass an entirely different proxy reference into the new domain. The bridge must then manage state on behalf of each bridged object reference, map these references from one ORB's format to the other's, and vice versa.<p>
</a><a name="3654">
	2.	 	<em>Reference Encapsulation:</em> The bridge can avoid holding any state at all by conceptually concatenating a domain identifier to the object name. Thus if a reference <em>D0.R</em>, originating in domain <em>D0</em>, traversed domains <em>D1</em>... <em>D4</em> it could be identified in <em>D4</em> as proxy reference <em>d3.d2.d1.d0.R</em>, where <em>dn</em> is the address of <em>Dn</em> relative to <em>Dn+1</em>.<img src="local/images/inarcha3.gif"><p>
</a><a name="3894">
Figure 10-4	 Reference encapsulation <em>adds domain information</em> during bridging.<p>
</a><a name="3656">
	3.	 	<em>Domain Reference Translation:</em> Like object reference translation, this scheme holds some state in the bridge. However, it supports sharing that state between multiple object references by adding a domain-based route identifier to the proxy (which still holds the original reference, as in the reference encapsulation scheme).<p>
</a><a name="3907">
 It achieves this by providing encoded domain route information each time a domain boundary is traversed; thus if a reference <em>D0.R</em>, originating in domain <em>D0</em>, traversed domains <em>D1...D4</em> it would be identified in <em>D4</em> as <em>(d3, x3).R</em>, and in <em>D2</em> as <em>(d1,x1).R</em>, and so on, where <em>dn</em> is the address of <em>Dn</em> relative to <em>Dn+1</em>, and <em>xn</em> identifies the pair <em>(dn-1, xn-1)</em>.<img src="local/images/inarcha4.gif"><p>
</a><a name="3908">
Figure 10-5	 Domain Reference Translation <em>substitutes domain references</em> during bridging.<p>
</a><a name="3659">
	4.	 		<em>Reference Canonicalization:</em> This scheme is like domain reference translation, except that the proxy uses a "well known" (e.g. global) domain identifier rather than an encoded path. Thus a reference <em>R</em>, originating in domain <em>D0</em> would be identified in other domains as <em>D0.R</em>.<p>
</a><a name="3660">
Observations about these approaches to inter-domain reference handling are as follows:<p>
</a><ul><a name="3661">
<li>	Naive application of reference encapsulation could lead to arbitrarily large references. A "topology service" could optimize cycles within any given encapsulated reference, and eliminate the appearance of references to local objects as alien references.
</a><a name="3662">
<li>	A topology service could also optimize the chains of routes used in the domain reference translation scheme. Since the links in such chains are re-used by any path traversing the same sequence of domains, such optimization has particularly high leverage.
</a><a name="3663">
<li>	With the general purpose APIs defined in <em>CORBA 2.0</em>, object reference translation can be supported even by ORBs not specifically intended to support efficient bridging, but this approach involves the most state in intermediate bridges. As with reference encapsulation, a topology service could optimize individual object references. (APIs are defined by the Dynamic Skeleton Interface, Dynamic Invocation Interface, and by the object identity operations described in Chapter 7.) <strong></strong>
</a><a name="3664">
<li>	The chain of addressing links established with both object and domain reference translation schemes must be represented as state within the network of bridges. There are issues associated with managing this state.
</a><a name="3665">
<li>	Reference canonicalization can also be performed with managed hierarchical namespaces such as those now in use on the Internet, and X.500 naming.
</a></ul><a name="3666">
<h1>	10.6	 An Information Model for Object References</h1>
</a><a name="3667">
This section provides a simple, powerful information model for the information found in an object reference. That model is intended to be used directly by developers of bridging technology, and is used in that role by the IIOP, described in <a href="giop.html#1630">"Object References" on page &#32;12-15</a>.<p>
</a><a name="3668">
<h2>	10.6.1	 What Information do Bridges Need?</h2>
</a><a name="3669">
The following potential information about object references has been identified as critical for use in bridging technologies:<p>
</a><ul><a name="3670">
<li><em>Is it null? </em>Nulls only need to be transmitted, and never support operation invocation.
</a><a name="3671">
<li><em>What type is it?</em> Many ORBs require knowledge of an object's type in order to efficiently preserve the integrity of their type systems.
</a><a name="3672">
<li><em>What protocols are supported? </em>Some ORBs support objrefs that in effect live in multiple referencing domains, to allow clients the choice of the most efficient communications facilities available.
</a><a name="3673">
<li><em>What ORB Services are available?</em> As noted in <a href="inarch.html#380">"Selection of ORB Services" on page &#32;10-4</a>, several different ORB Services might be involved in an invocation, and providing information about those services in a standardized way could in many cases reduce or eliminate negotiation overhead in selecting them.
</a></ul><a name="3674">
<h2>	10.6.2	 Interoperable Object References: IORs</h2>
</a><a name="3675">
To provide the information above, an "Interoperable Object Reference", or IOR, data structure has been provided. This data structure need not be used internally to any given ORB, and is not intended to be visible to application-level ORB programmers. It should be used only when crossing object reference domain boundaries, within bridges.<p>
</a><a name="3676">
This data structure is designed to be efficient in typical single-protocol configurations, while not penalizing multiprotocol ones.<p>
</a><a name="772">
<blockquote></blockquote>
</a><a name="773">
 module IOP{														// IDL<p>
</a><a name="774">
<blockquote>	//</blockquote>
</a><a name="3717">
<blockquote>	// Standard Protocol Profile tag values </blockquote>
</a><a name="3719">
<blockquote>	// </blockquote>
</a><a name="3720">
<blockquote>	typedef unsigned long									ProfileId;</blockquote>
</a><a name="3678">
<blockquote>	const ProfileId									TAG_INTERNET_IOP = 0;</blockquote>
</a><a name="3722">
<blockquote>	const ProfileId									TAG_MULTIPLE_COMPONENTS = 1;</blockquote>
</a><a name="3729">
<blockquote></blockquote>
</a><a name="3767">
<blockquote>	struct TaggedProfile {</blockquote>
</a><a name="3732">
<blockquote>		ProfileId								tag;</blockquote>
</a><a name="3734">
<blockquote>		sequence &lt;octet&gt;								profile_data;</blockquote>
</a><a name="3739">
<blockquote>	};</blockquote>
</a><a name="3768">
<blockquote></blockquote>
</a><a name="3769">
<blockquote>	//</blockquote>
</a><a name="3770">
<blockquote>	// an Interoperable Object Reference is a sequence of</blockquote>
</a><a name="3771">
<blockquote>	// object-specific protocol profiles, plus a type ID.</blockquote>
</a><a name="3772">
<blockquote>	//</blockquote>
</a><a name="3740">
<blockquote>	struct IOR {</blockquote>
</a><a name="3744">
<blockquote>		string								type_id;</blockquote>
</a><a name="3746">
<blockquote>		sequence &lt;TaggedProfile&gt;								profiles;</blockquote>
</a><a name="3748">
<blockquote>	};</blockquote>
</a><a name="3773">
<blockquote></blockquote>
</a><a name="3741">
<blockquote>	//</blockquote>
</a><a name="3756">
<blockquote>	// Standard way of representing multicomponent profiles.</blockquote>
</a><a name="3757">
<blockquote>	// This would be encapsulated in a TaggedProfile.</blockquote>
</a><a name="3758">
<blockquote>	//</blockquote>
</a><a name="3759">
<blockquote>	typedef unsigned long ComponentId;</blockquote>
</a><a name="3682">
<blockquote>	struct TaggedComponent {</blockquote>
</a><a name="3760">
<blockquote>		ComponentId									tag;</blockquote>
</a><a name="3761">
<blockquote>		sequence &lt;octet&gt;								component_data;</blockquote>
</a><a name="3762">
<blockquote>	};</blockquote>
</a><a name="3683">
<blockquote>	typedef sequence &lt;TaggedComponent&gt; 										MultipleComponentProfile;</blockquote>
</a><a name="3763">
 };<p>
</a><a name="3684">
Object references have at least one <em>tagged profile</em> per protocol supported. Those profiles encapsulate all the basic information that protocol needs to identify an object. Any single profile holds enough information to drive a complete invocation using that protocol; the content and structure of those profile entries are wholly specified by that protocol. A bridge between two domains may need to know the detailed content of the profile for those domains' profiles, depending on the technique it uses to bridge the domains<a href="#1573"><sup>1</sup></a>.<p>
</a><a name="3686">
Each profile has a unique numeric tag, assigned by OMG. The ones defined here are for the IIOP (see <a href="giop.html#199">Chapter 12, "General Inter-ORB Protocol"</a>) and for use in "multi component protocol profiles." <p>
</a><a name="626">
The <strong>TAG_MULTIPLE_COMPONENTS</strong> tag indicates that the value encapsulated is of type <strong>MultipleComponentProfile</strong>. In this case, the profile consists of a list of protocol components, indicating ORB services accessible using that protocol. ORB services are assigned component identifiers in a namespace that is distinct from the profile identifiers. Note that protocols may use the <strong>MultipleComponentProfile</strong> data structure to hold profile components even without using <strong>TAG_MULTIPLE_COMPONENTS</strong> to indicate that particular protocol profile, and need not use a <strong>MultipleComponentProfile</strong> to hold sets of profile components.<p>
</a><a name="3688">
Null object references are indicated by an empty set of profiles, and by a Null type ID (a string which contains only a single terminating character). Type IDs may only be Null when the object reference is Null.The type ID is provided to allow ORBs to preserve strong typing; it is further explained in the description in the Interface Repository chapter. This identifier is agreed on within the bridge and, for reasons outside the scope of this interoperability specification, needs to have a much broader scope to address various problems in system evolution and maintenance. Type IDs support detection of type equivalence, and in conjunction with an Interface Repository, allow processes to reason about the relationship of the type of the object referred to and any other type.<p>
</a><a name="1329">
The type ID is provided by the server and indicates the most derived type at the time the reference is generated.<p>
</a><a name="637">
<h2>	10.6.3	 Profile and Component Composition in IORs</h2>
</a><a name="638">
The following rules augment the preceding discussion:<p>
</a><a name="639">
	1.	 Profiles must be independent, complete, and self-contained. Their use shall not depend on information contained in another profile.<p>
</a><a name="640">
	2.	 Any invocation uses information from exactly one profile.<p>
</a><a name="641">
	3.	 Information used to drive multiple inter-ORB protocols may coexist within a single profile, possibly with some information (e.g. components) shared between the protocols, as specified by the specific protocols.<p>
</a><a name="642">
	4.	 Unless otherwise specified in the definition of a particular profile, multiple profiles with the same profile tag may be included in an IOR.<p>
</a><a name="643">
	5.	 Unless otherwise specified in the definition of a particular component, multiple components with the same component tag may be part of a given profile within an IOR.<p>
</a><a name="644">
	6.	 A <strong>TAG_MULTIPLE_COMPONENTS</strong> profile may hold components shared between multiple protocols. Multiple such profiles may exist in an IOR.<p>
</a><a name="645">
	7.	 The definition of each protocol using a <strong>TAG_MULTIPLE_COMPONENTS </strong>profile must specify which components it uses, and how it uses them.<p>
</a><a name="646">
	8.	 Profile and component definitions can be either public or private. Public definitions are those whose tag and data format is specified in OMG documents. For private definitions, only the tag is registered with OMG.<p>
</a><a name="647">
	9.	 Public component definitions shall state whether or not they are intended for use by protocols other than the one(s) for which they were originally defined, and dependencies on other components.<p>
</a><a name="4108">
The OMG is responsible for allocating and registering protocol and component tags. Neither allocation nor registration indicates any "standard" status, only that the tag will not be confused with other tags. Requests to allocate tags should be sent to tag_request@omg.org<p>
</a><a name="660">
<h2>	10.6.4	 IOR Creation and Scope</h2>
</a><a name="4109">
IORs are created from object references when required to cross some kind of referencing domain boundary. ORBs will implement object references in whatever form they find appropriate, including possibly using the IOR structure. Bridges will normally use IORs to mediate transfers where that standard is appropriate.<p>
</a><a name="3690">
<h2>	10.6.5	 Stringified Object References</h2>
</a><a name="3693">
Object references can be "stringified" (turned into an external string form) by the <strong>ORB::object_to_string</strong> operation, and then "destringified" (turned back into a programming environment's object reference representation) using the <strong>ORB::string_to_object</strong> operation.<p>
</a><a name="4177">
There can be a variety of reasons why being able to parse this string form might <em>not</em> help make an invocation on the original object reference:<p>
</a><ul><a name="4146">
<li>Identifiers embedded in the string form can belong to a different domain than the ORB attempting to destringify the object reference.
</a><a name="4147">
<li>The ORBs in question might not share a network protocol, or be connected.
</a><a name="4148">
<li>Security constraints may be placed on object reference destringification.
</a></ul><a name="4132">
Nonetheless, there is utility in having a defined way for ORBs to generate and parse stringified IORs, so that in some cases an object reference stringified by one ORB could be destringified by another.<p>
</a><a name="4172">
To allow a stringified object reference to be internalized by what may be a different ORB, a stringified IOR representation is specified. This representation instead establishes that ORBs could parse stringified object references using that format. This helps address the problem of bootstrapping, allowing programs to obtain and use object references, even from different ORBs.<p>
</a><a name="4409">
The following is the representation of the stringified (externalized) IOR:<p>
</a><a name="3697">
<blockquote>	&lt;oref&gt; 				::= &lt;prefix&gt; &lt;hex_Octets&gt;</blockquote>
</a><a name="3698">
<blockquote>	&lt;prefix&gt; 				::= "IOR:"</blockquote>
</a><a name="3699">
<blockquote>	&lt;hex_Octets&gt; 				::= &lt;hex_Octet&gt; {&lt;hex_Octet&gt;}*</blockquote>
</a><a name="3700">
<blockquote>	&lt;hex_Octet&gt; 				::= &lt;hexDigit&gt; &lt;hexDigit&gt;</blockquote>
</a><a name="3701">
<blockquote>	&lt;hexDigit&gt; 				::= &lt;digit&gt; | &lt;a&gt; | &lt;b&gt; | &lt;c&gt; | &lt;d&gt; | &lt;e&gt; | &lt;f&gt;</blockquote>
</a><a name="3702">
<blockquote>	&lt;digit&gt; 				::= "0" | "1" | "2" | "3" | "4" | "5" |</blockquote>
</a><a name="3703">
<blockquote>						 "6" | "7" | "8" | "9"</blockquote>
</a><a name="3704">
<blockquote>	&lt;a&gt;				::= "a" | "A"</blockquote>
</a><a name="3705">
<blockquote>	&lt;b&gt;				::= "b" | "B"</blockquote>
</a><a name="3706">
<blockquote>	&lt;c&gt;				::= "c" | "C"</blockquote>
</a><a name="3707">
<blockquote>	&lt;d&gt;				::= "d" | "D"</blockquote>
</a><a name="3708">
<blockquote>	&lt;e&gt;				::= "e" | "E"</blockquote>
</a><a name="3709">
<blockquote>	&lt;f&gt;				::= "f" | "F"</blockquote>
</a><a name="3714">
The hexadecimal strings are generated by first turning an object reference into an IOR, and then encapsulating the IOR using the encoding rules of CDR. (See <a href="giop.html#230">"CDR Transfer Syntax" on page &#32;12-4</a> for more information.) The content of the encapsulated IOR is then turned into hexadecimal digit pairs, starting with the first octet in the encapsulation and going until the end. The high four bits of each octet are encoded as a hexadecimal digit, then the low four bits.<p>
</a><a name="1338">
<h2>	10.6.6	 Object Service Context</h2>
</a><a name="1339">
Emerging specifications for Object Services occasionally require service-specific context information to be passed implicitly with requests and replies. (Specifications for OMG's Object Services are contained in <em>CORBAservices:Common Object Service Specifications.</em>) The Interoperability specifications define a mechanism for identifying and passing this service-specific context information as "hidden" parameters. The specification makes the following assumptions:<p>
</a><ul><a name="1340">
<li>	Object Service specifications that need additional context passed will completely specify that context as an OMG IDL data type.
</a><a name="1341">
<li>	ORB APIs will be provided that will allow services to supply and consume context information at appropriate points in the process of sending and receiving requests and replies. <strong></strong>
</a><a name="1342">
<li>	It is an ORB's responsibility to determine when to send service-specific context information, and what to do with such information in incoming messages. It may be possible, for example, for a server receiving a request to be unable to de-encapsulate and use a certain element of service-specific context, but nevertheless still be able to successfully reply to the message. 
</a></ul><a name="1343">
As shown in the following OMG IDL specification, the IOP module provides the mechanism for passing Object Service-specific information. It does not describe any service-specific information. It only describes a mechanism for transmitting it in the most general way possible. The mechanism is currently used by the DCE ESIOP and could also be used by the Internet Inter-ORB protocol (IIOP) General Inter_ORB Protocol (GIOP). <p>
</a><a name="1411">
Each Object Service requiring implicit service-specific context to be passed through GIOP will be allocated a unique service context ID value by OMG. Service context ID values are of type <strong>unsigned long</strong>. Object service specifications are responsible for describing their context information as single OMG IDL data types, one data type associated with each service context ID. <p>
</a><a name="1380">
The marshaling of Object Service data is described by the following OMG IDL: <p>
</a><a name="1346">
 module IOP<code> </code>{																// IDL<p>
</a><a name="1347">
 <p>
</a><a name="1348">
<blockquote><code>	</code>typedef unsigned long									ServiceID;</blockquote>
</a><a name="1349">
<blockquote></blockquote>
</a><a name="1350">
<blockquote>	struct ServiceContext {</blockquote>
</a><a name="1351">
<blockquote> 		ServiceID					context_id;</blockquote>
</a><a name="1352">
<blockquote> 		sequence &lt;octet&gt;					context_data;</blockquote>
</a><a name="1353">
<blockquote> 	};</blockquote>
</a><a name="1354">
<blockquote>	typedef sequence &lt;ServiceContext&gt;									ServiceContextList;</blockquote>
</a><a name="1355">
<blockquote></blockquote>
</a><a name="1356">
<blockquote>	const ServiceID									TransactionService = 0;</blockquote>
</a><a name="1357">
 };<p>
</a><a name="1358">
The context data for a particular service will be encoded as specified for its service-specific OMG IDL definition, and that encoded representation will be encapsulated in the context_data member of <strong>IOP::ServiceContext</strong>. (See <a href="giop.html#286">Section &#32;12.3.3, "Encapsulation," on page &#32;12-9</a>.) The <strong>context_id</strong> member contains the service ID value identifying the service and data format. Context data is encapsulated in octet sequences to permit ORBs to handle context data without unmarshaling, and to handle unknown context data types.<p>
</a><a name="1362">
During request and reply marshaling, ORBs will collect all service context data associated with the <em>Request</em> or <em>Reply</em> in a <strong>ServiceContextList</strong>, and include it in the generated messages. No ordering is specified for service context data within the list. The list is placed at the beginning of those messages to support security policies that may need to apply to the majority of the data in a request (including the message headers).<p>
</a><a name="1363">
Note &#175;  The only <em>ServiceID</em> currently defined is <em>TransactionService</em>, for a CDR encapsulation of the Cos<em>TSInteroperation::PropogationContext</em> defined in <em>CORBAservices</em>, <a href="../../coss/coss1-2/trans/trans.html#">Section &#32;10.5.2, "ORB/TS Implementation Considerations," on page &#32;10-56</a><p>
</a><a name="1335">
<p>
</a>
<hr><br>
 
<a href="cover.html">[Top]</a> <a href="interov.html">[Prev]</a> <a href="bridge.html">[Next]</a> <a href="corb2pra.html">[Bottom]</a>
<hr><br>
 
<sup>1</sup><a name="1573">
 Based on topology and policy information available to it, a bridge may find it prudent to add or remove some profiles as it forwards an object reference. For example, a bridge acting as a firewall might remove all profiles except ones that make such profiles, letting clients that understand the profiles make routing choices.<p>
</a>

<address>
<a href="mailto:pubs@omg.org">pubs@omg.org</a>
</address>

<i>Copyright &#169; 1995, <a href="http://www.omg.org">Object Management Group.</a>  All rights
reserved.</i>

<!-- This file was created with Quadralay WebWorks Publisher 3.0.4 -->
<!-- -->
<!-- For more information on how this document, and how the rest of -->
<!-- this server was created, email pubs@omg.org -->
<!-- -->
<!-- Last updated: 06/10/96 08:48:50 -->

</body>
</html>
