<html><head><title></title></head>
<body bgcolor=#ffffff>
 
<a href="cover.html">[Top]</a> <a href="appxtype.html">[Prev]</a> <a href="inarch.html">[Next]</a> <a href="corb2pra.html">[Bottom]</a>
<hr><br>
 
<a name="62">
<h1>  Interoperability Overview</h1>
</a><dl>
<p align=right clear=all>
<b><font size=7>
9 
</font></b>
</p>
<hr></dl>
<a name="1029">
ORB interoperability specifies a comprehensive, flexible approach to supporting networks of objects that are distributed across and managed by multiple, heterogeneous CORBA-compliant ORBs. The approach to "interORBability" is universal, because its elements can be combined in many ways to satisfy a very broad range of needs. <p>
</a><a name="865">
<h1>	9.1	 Elements of Interoperability</h1>
</a><a name="869">
The elements of interoperability are as follows:<p>
</a><ul><a name="870">
<li>ORB interoperability architecture
</a><a name="871">
<li>Inter-ORB bridge support
</a><a name="872">
<li>General and Internet inter-ORB Protocols (GIOPs and IIOPs)
</a></ul><a name="873">
In addition, the architecture accommodates <strong>environment-specific inter-ORB protocols (ESIOPs)</strong> that are optimized for particular environments such as DCE.<p>
</a><a name="1035">
<h2>	9.1.1	 ORB Interoperability Architecture</h2>
</a><a name="1036">
The ORB Interoperability Architecture provides a conceptual framework for defining the elements of interoperability and for identifying its compliance points. It also characterizes new mechanisms and specifies conventions necessary to achieve interoperability between independently produced ORBs.<p>
</a><a name="766">
Specifically, the architecture introduces the concepts of <em>immediate</em> and <em>mediated</em> <em>bridging</em> of ORB domains. The Internet inter-ORB Protocol (IIOP) forms the common basis for broad-scope mediated bridging. The inter-ORB bridge support can be used to implement both immediate bridges and to build "half-bridges" to mediated bridge domains.<p>
</a><a name="774">
By use of bridging techniques, ORBs can interoperate without knowing any details of that ORB's implementation, such as what particular IPC or protocols (such as ESIOPs) are used to implement the <em>CORBA</em> specification.<p>
</a><a name="775">
The IIOP may be used in bridging two or more ORBs by implementing "half bridges" which communicate using the IIOP. This approach works both for stand-alone ORBs, and for networked ones which use an ESIOP.<p>
</a><a name="776">
The IIOP may also be used to implement an ORB's internal messaging, if desired. Since ORBs are not required to use the IIOP internally, the goal of not requiring prior knowledge of each others' implementation is fully satisfied.<p>
</a><a name="767">
<h2>	9.1.2	 Inter-ORB Bridge Support </h2>
</a><a name="789">
The interoperability architecture clearly identifies the role of different kinds of domains for ORB-specific information. Such domains can include object reference domains, type domains, security domains (e.g. the scope of a <em>Principal</em> identifier), a transaction domain, and more.<p>
</a><a name="795">
Where two ORBs are in the same domain, they can communicate directly. In many cases, this is the preferable approach. This is not always true, however, since organizations often need to establish local control domains.<p>
</a><a name="796">
When information in an invocation must leave its domain, the invocation must traverse a bridge. The role of a bridge is to ensure that content and semantics are mapped from the form appropriate to one ORB to that of another, so that users of any given ORB only see their appropriate content and semantics.<p>
</a><a name="1737">
The inter-ORB bridge support element specifies ORB APIs and conventions to enable the easy construction of interoperability bridges between ORB domains. Such bridge products could be developed by ORB vendors, Sieves, system integrators or other third-parties. <p>
</a><a name="2770">
Because the extensions required to support Inter-ORB Bridges are largely general in nature, do not impact other ORB operation, and can be used for many other purposes besides building bridges, they are appropriate for all ORBs to support. Other applications include debugging, interposing of objects, implementing objects with interpreters and scripting languages and dynamically generating implementations. <p>
</a><a name="2783">
The inter-ORB bridge support can also be used to provide interoperability with non-CORBA systems, such as Microsoft's Component Object Model (COM). The ease of doing this will depend on the extent that those systems conform to the CORBA Object Model.<p>
</a><a name="695">
<h2>	9.1.3	 General Inter-ORB Protocol (GIOP)</h2>
</a><a name="466">
The General Inter-ORB Protocol (GIOP) element specifies a standard transfer syntax (low-level data representation) and a set of message formats for communications between ORBs. The GIOP is specifically built for ORB to ORB interactions and is designed to work directly over any connection-oriented transport protocol that meets a minimal set of assumptions. It does not require or rely on the use of higher level RPC mechanisms. The protocol is simple (as simple as possible, but not simpler), scalable and relatively easy to implement. It is designed to allow portable implementations with small memory footprints and reasonable performance, with minimal dependencies on supporting software other than the underlying transport layer. <p>
</a><a name="473">
While versions of the GIOP running on different transports would not be directly interoperable, their commonality would allow easy and efficient bridging between such networking domains.<p>
</a><a name="471">
<h2>	9.1.4	 Internet Inter-ORB Protocol (IIOP)</h2>
</a><a name="630">
The Internet Inter-ORB Protocol (IIOP) element specifies how GIOP messages are exchanged using TCP/IP connections. The IIOP specifies a standardized interoperability protocol for the Internet, providing "out of the box" interoperation with other compatible ORBs based on the most popular product- and vendor-neutral transport layer. It can also be used as the protocol between half-bridges (see below). <p>
</a><a name="2931">
The protocol is designed to be suitable and appropriate for use by any ORB to interoperate in Internet Protocol domains unless an alternative protocol is necessitated by the specific design center or intended operating environment of the ORB. In that sense it represents the basic inter-ORB protocol for TCP/IP environments, a most pervasive transport layer.<p>
</a><a name="502">
The IIOP's relationship to the GIOP is similar to that of a specific language mapping to OMG IDL; the GIOP may be mapped onto a number of different transports, and specifies the protocol elements that are common to all such mappings. The GIOP by itself, however, does not provide complete interoperability, just as IDL cannot be used to built complete programs. The IIOP, and other similar mappings to different transports, are concrete realizations of the abstract GIOP definitions, as shown in Figure 2-1.<p>
</a><a name="508">
<img src="local/images/interova.gif"><p>
</a><a name="503">
Figure 9-1	 Inter-ORB Protocol Relationships.<p>
</a><a name="657">
<h2>	9.1.5	 Environment-Specific Inter-ORB Protocols (ESIOPs)</h2>
</a><a name="3057">
This specification also makes provision for an open ended set of Environment-Specific Inter-ORB Protocols (ESIOPs) Such protocols would be used for "out of the box" interoperation at user sites where a particular networking or distributing computing infrastructure is already in general use.<p>
</a><a name="2921">
Because of the opportunity to leverage and build on facilities provided by the specific environment, ESIOPs might support specialized capabilities such as those relating to security and administration.<p>
</a><a name="2920">
While ESIOPs may be optimized for particular environments, all ESIOP specifications will be expected to conform to the general ORB interoperability architecture conventions to enable easy bridging. The inter-ORB bridge support enables bridges to be built between ORB domains that use the IIOP and ORB domains that use a particular ESIOP.<p>
</a><a name="749">
<h1>	9.2	 Relationship to Previous Versions of CORBA </h1>
</a><a name="910">
The ORB Interoperability Architecture builds on Common Object Request Broker Architecture by adding the notion of ORB Services, and their domains. (ORB Services are described in <a href="inarch.html#3374">Section &#32;10.2, "ORBs and ORB Services," on page &#32;10-2</a>. The architecture defines the problem of ORB interoperability in terms of bridging between those domains, and defines several ways in which those bridges can be constructed: the bridges can be internal (in-line) and external (request-level) to ORBs.<p>
</a><a name="751">
APIs included in the interoperability specifications include compatible extensions to previous versions of <em>CORBA </em>to support request level bridging:<p>
</a><ul><a name="752">
<li>A Dynamic Skeleton Interface (DSI) is the basic support needed for building request level bridges; it is the server side analogue of the Dynamic Invocation Interface, and in the same way it has general applicability beyond bridging. For information about the Dynamic Skeleton Interface, refer to Chapter 5. 
</a><a name="1468">
<li>APIs for managing object references have been defined, building on the support identified for the Relationship Service. The APIs are defined in <a href="orbif2.html#109">"Object Reference Operations" on page &#32;7-2</a>.<strong> </strong>The Relationship Service is described in <em>CORBAservices: Common Object Service Specifications</em>; refer to <a href="../../coss/coss1-2/relation/relation.html#">Section &#32;9.3.6, "The CosObjectIdentity Module</a>.
</a></ul><a name="3030">
<h1>	9.3	 Examples of Interoperability Solutions</h1>
</a><a name="674">
The elements of interoperability (Inter-ORB Bridges, General and Internet Inter-ORB Protocols, Environment-Specific Inter-ORB Protocols) can be combined in a variety of ways to satisfy particular product and customer needs. This section provides some examples. <p>
</a><a name="676">
<h2>	9.3.1	 Example 1</h2>
</a><a name="607">
ORB product A is designed to support objects distributed across a network and provide "out of the box" interoperability with compatible ORBs from other vendors. In addition it allows for bridges to be built between it and other ORBs that use environment-specific or proprietary protocols. To accomplish this, ORB A uses the IIOP and provides inter-ORB bridge support.<p>
</a><a name="608">
<h2>	9.3.2	 Example 2</h2>
</a><a name="677">
ORB product B is designed to provide highly optimized, very high speed support for objects located on a single machine; for example, to support thousands of Fresco GUI objects operated on at near function-call speeds. In addition, some of the objects will need to be accessible from other machines and objects on other machines will need to be infrequently accessed. To accomplish this, ORB A provides a half-bridge to support the Internet IOP for communication with other "distributed" ORBs.<p>
</a><a name="605">
<h2>	9.3.3	 Example 3</h2>
</a><a name="897">
ORB product C is optimized to work in a particular operating environment. It uses a particular environment-specific protocol based on distributed computing services that are commonly available at the target customer sites. In addition, ORB C is expected to interoperate with arbitrary other ORBs from other vendors. To accomplish this, ORB C provides inter-ORB bridge support and a companion half-bridge product (supplied by the ORB vendor or some third-party) provides the connection to other ORBs. The half-bridge uses the IIOP to enable interoperability with other compatible ORBs.<p>
</a><a name="617">
<h2>	9.3.4	 Interoperability Compliance </h2>
</a><a name="1502">
An ORB is considered to be interoperability-compliant when it meets the following requirements:<p>
</a><ul><a name="1525">
<li>In the CORBA Core part of this specification, standard APIs are provided by an ORB to enable the construction of request level inter-ORB bridges. APIs are defined by the Dynamic Invocation Interface, the Dynamic Skeleton Interface,and by the object identity operations, which are described in Chapter 7. 
</a><a name="1528">
<li>An <em>Internet Inter-ORB Protocol</em> (IIOP) (explained in Chapter 12) defines a transfer syntax and message formats (described independently as the General Inter-ORB Protocol) , and defines how to transfer messages via TCP/IP connections. The IIOP can be supported natively or via a half-bridge.
</a></ul><a name="1541">
Support for additional ESIOPs and other proprietary protocols is optional in a interoperability-compliant system. However, any implementation that chooses to use the other protocols defined by the CORBA interoperability specifications (Chapters 9 - 13) must adhere to those specifications to be compliant with CORBA interoperability. <p>
</a><a name="1509">
The illustration<a href="interov.html#1798"> on page 9-7</a> shows examples of interoperable ORB domains that are CORBA-compliant.<p>
</a><a name="1746">
These compliance points support a range of interoperability solutions. For example, the standard APIs may be used to construct "half bridges" to the IIOP, relying on another "half bridge" to connect to another ORB. The standard APIs also support construction of "full bridges", without using the Internet IOP to mediate between separated bridge components. ORBs may also use the Internet IOP internally. In addition, ORBs may use GIOP messages to communicate over other network protocol families (such as Novell or OSI), and provide transport-level bridges to the IIOP. <p>
</a><a name="1799">
The GIOP is described separately from the IIOP to allow future specifications to treat it as an independent compliance point. For additional information on CORBA compliance, refer to <a href="corb2prb.html#1468">"Definition of CORBA Compliance" on page vii</a>.<p>
</a><a name="1798">
Examples of CORBA Version 2.0 Interoperability<img src="local/images/interoa1.gif"> Compliance<p>
</a><a name="1129">
<h1>	9.4	 Motivating Factors</h1>
</a><a name="1152">
This section explains the factors that motivated the creation of interoperability specifications. <p>
</a><a name="3111">
<h2>	9.4.1	 ORB Implementation Diversity</h2>
</a><a name="2629">
Today, there are many different ORB products that address a variety of user needs. A large diversity of implementation techniques is evident. For example, the time for a request ranges over at least 5 orders of magnitude, from a few microseconds to several seconds. The scope ranges from a single application to enterprise networks. Some ORBs have high levels of security, others are more open. Some ORBs are layered on a particular widely used protocols, others use highly optimized, proprietary protocols.<p>
</a><a name="2630">
The market for object systems and applications that use them will grow as object systems are able to be applied to more kinds computing. From application integration to process control, from loosely coupled operating systems to the information superhighway, CORBA-based object systems can be the common infrastructure.<p>
</a><a name="2653">
<h2>	9.4.2	 ORB Boundaries </h2>
</a><a name="2654">
Even when it is not required by implementation differences, there are other reasons to partition an environment into different ORBs.<p>
</a><a name="2655">
For security reasons, it may be important to know that it not generally possible to access objects in one domain from another. For example, an "internet ORB" may make public information widely available, but a "company ORB" will want to restrict what information can get out. Even if they used the same ORB implementation, these two ORBs would be separate, so that the company could allow access to public objects from inside the company without allowing access to private objects from outside. Even though individual objects should protect themselves, prudent system administrators will want to avoid exposing sensitive objects to attacks from outside the company.<p>
</a><a name="2656">
Supporting multiple ORBs also helps handle the difficult problem of testing and upgrading the object system. It would be unwise to test new infrastructure without limiting the set of objects that might be damaged by bugs, and it may be impractical to replace "the ORB" everywhere simultaneously. A new ORB might be tested and deployed in the same environment, interoperating with the existing ORB until it either a complete switch is made or it incrementally displaces the existing one.<p>
</a><a name="2657">
Management issues may also motivate partitioning an ORB. Just as networks are subdivided into domains to allow decentralized control of databases, configurations, resources, etc., management of the state in an ORB (object reference location and translation information, interface repositories, per-object data, etc.) might also be done by creating sub-ORBs.<p>
</a><a name="2658">
<h2>	9.4.3	 ORBs Vary in Scope, Distance, and Lifetime</h2>
</a><a name="2659">
Even in a single computing environment produced by a single vendor, there are reasons why some of the objects an application might use would be in one ORB, and others in another ORB. Some objects and services are accessed over long distances, with more global visibility, longer delays, and less reliable communication. Other objects are nearby, are not accessed from elsewhere, and provide higher quality service. By deciding which ORB to use, an implementer sets expectations for the clients of the objects.<p>
</a><a name="2660">
One ORB might be used to retain links to information that is expected to accumulate over decades, such as a library archives. Another ORB might be used to manage a distributed chess program in which the objects should all be destroyed when the game is over. Although while it is running, it makes sense for "chess ORB" objects to access the "archives ORB", we would not expect the archives to try to keep a reference to the current board position.<p>
</a><a name="292">
<h1>	9.5	 Interoperability Design Goals</h1>
</a><a name="2603">
Because of the diversity in ORB implementations, multiple approaches to interoperability are required. Options identified in previous versions of <em>CORBA</em> include:<p>
</a><ul><a name="2591">
<li><em>Protocol Translation</em>, where a gateway residing somewhere in the system maps requests from the format used by one ORB to that used by another;
</a><a name="2592">
<li><em>Reference Embedding</em>, where invocation using a native object reference delegates to a special object whose job it is to forward that invocation to another ORB;
</a><a name="2593">
<li><em>Alternative ORBs</em>, where ORB implementations agree to coexist in the same address space so easily that a client or implementation can transparently use any of them, and pass object references created by one ORB to another ORB without losing functionality.
</a></ul><a name="2596">
In general, there is no single protocol that can meet everyone's needs, and there is no single means to interoperate between two different protocols. There are many environments in which multiple protocols exist, and there are ways to bridge between environments that share no protocols. <p>
</a><a name="2597">
This specification adopts a flexible architecture that allows a wide variety of ORB implementations to interoperate and that includes both bridging and common protocol elements.<p>
</a><a name="2600">
The following goals guided the creation of interoperability specifications:<p>
</a><ul><a name="2318">
<li>The architecture and specifications should allow high performance, small footprint, lightweight interoperability solutions. 
</a><a name="2325">
<li>The design should scale, should be not unduly difficult to implement and should not unnecessarily restrict implementation choices.
</a><a name="97">
<li>Interoperability solutions should be able to work with any vendors' existing ORB implementations, with respect to their CORBA compliant core feature set; those implementations are diverse.
</a><a name="98">
<li>All operations implied by the CORBA object model (i.e. the stringify and destringify operations defined on the <code>CORBA::ORB</code> pseudo-object, and all the operations on <code>CORBA::Object</code>) as well as type management (e.g. narrowing, as needed by the C++ mapping) should be supported.
</a></ul><a name="100">
<h2>	9.5.1	 Non-Goals</h2>
</a><a name="2601">
The following were taken into account, but were not goals:<p>
</a><ul><a name="2292">
<li>Support for security
</a><a name="3350">
<li>Support for future ORB Services 
</a></ul>
<hr><br>
 
<a href="cover.html">[Top]</a> <a href="appxtype.html">[Prev]</a> <a href="inarch.html">[Next]</a> <a href="corb2pra.html">[Bottom]</a>
<hr><br>
 


<address>
<a href="mailto:pubs@omg.org">pubs@omg.org</a>
</address>

<i>Copyright &#169; 1995, <a href="http://www.omg.org">Object Management Group.</a>  All rights
reserved.</i>

<!-- This file was created with Quadralay WebWorks Publisher 3.0.4 -->
<!-- -->
<!-- For more information on how this document, and how the rest of -->
<!-- this server was created, email pubs@omg.org -->
<!-- -->
<!-- Last updated: 06/10/96 08:48:47 -->

</body>
</html>
