<html><head><title></title></head>
<body bgcolor=#ffffff>
 
<a href="cover.html">[Top]</a> <a href="dynskel.html">[Prev]</a> <a href="orbif2.html">[Next]</a> <a href="corb2pra.html">[Bottom]</a>
<hr><br>
 
<a name="291">
<h1> The Interface Repository</h1>
</a><dl>
<p align=right clear=all>
<b><font size=7>
6 
</font></b>
</p>
<hr></dl>
<a name="102">
The Interface Repository is the component of the ORB that provides persistent storage of interface definitions-it manages and provides access to a collection of object definitions specified in OMG IDL.<p>
</a><a name="104">
<h1>	6.1	 Overview</h1>
</a><a name="91">
An ORB provides distributed access to a collection of objects using the objects' publicly defined interfaces specified in OMG IDL. The Interface Repository provides for the storage, distribution, and management of a collection of related objects' interface definitions.<p>
</a><a name="106">
For an ORB to correctly process requests, it must have access to the definitions of the objects it is handling. Object definitions can be made available to an ORB in one of two forms:<p>
</a><a name="107">
1.	 By incorporating the information procedurally into stub routines (e.g., as code that maps C language subroutines into communication protocols).<p>
</a><a name="108">
2.	 As objects accessed through the dynamically accessible Interface Repository (i.e., as "interface objects" accessed through OMG IDL-specified interfaces).<p>
</a><a name="109">
In particular, the ORB can use object definitions maintained in the Interface Repository to interpret and handle the values provided in a request:<p>
</a><ul><a name="110">
<li>To provide type-checking of request signatures (whether the request was issued through the DII or through a stub).
</a><a name="111">
<li>To assist in checking the correctness of interface inheritance graphs.
</a><a name="112">
<li>To assist in providing interoperability between different ORB implementations.
</a></ul><a name="113">
As the interface to the object definitions maintained in an Interface Repository is public, the information maintained in the Repository can also be used by clients and services. For example, the Repository can be used:<p>
</a><ul><a name="114">
<li>To manage the installation and distribution of interface definitions.
</a><a name="115">
<li>To provide components of a CASE environment (for example, an interface browser).
</a><a name="116">
<li>To provide interface information to language bindings (such as a compiler).
</a><a name="117">
<li>To provide components of end-user environments (for example, a menu bar constructor).
</a></ul><a name="1936">
The complete OMG IDL specification for the Interface Repository is in <a href="intrep2.html#1938">Section &#32;6.8, "OMG IDL for Interface Repository," on page &#32;6-41</a>. Fragments of the specification are used throughout this chapter as necessary. <p>
</a><a name="120">
<h1>	6.2	 Scope of an Interface Repository</h1>
</a><a name="92">
Interface definitions are maintained in the Interface Repository as a set of objects that are accessible through a set of OMG IDL-specified interface definitions. An interface definition contains a description of the operations it supports, including the types of the parameters, exceptions it may raise, and context information it may use. <p>
</a><a name="121">
In addition, the interface repository stores constant values, which might be used in other interface definitions or might simply be defined for programmer convenience. And it stores typecodes, which are values that describe a type in structural terms.<p>
</a><a name="123">
The Interface Repository uses modules as a way to group interfaces and to navigate through those groups by name. Modules can contain constants, typedefs, exceptions, interface definitions, and other modules. Modules may, for example, correspond to the organization of OMG IDL definitions. They may also be used to represent organizations defined for administration or other purposes. <p>
</a><a name="124">
The Interface Repository is a set of objects that represent the information in it. There are operations that operate on this apparent object structure. It is an implementation's choice whether these objects exist persistently or are created when referenced in an operation on the repository. There are also operations that extract information in an efficient form, obtaining a block of information that describes a whole interface or a whole operation.<p>
</a><a name="125">
An ORB may have access to multiple Interface Repositories. This may occur because two ORBs have different requirements for the implementation of the Interface Repository, because an object implementation (such as an OODB) prefers to provide its own type information, or because it is desired to have different additional information stored in different repositories. The use of typecodes and repository identifiers is intended to allow different repositories to keep their information consistent.<p>
</a><a name="8530">
As shown in <a href="intrep2.html#8570">FIGURE 12.&#32; on page 6-3</a>, the same interface <strong>Doc</strong> is installed in two different repositories, one at SoftCo, Inc., which sells Doc objects, and one at Customer, Inc., which buys Doc objects from SoftCo. SoftCo sets the repository id for the Doc interface when it defines it. Customer might first install the interface in its repository in a module where it could be tested before exposing it for general use. Because it has the same repository id, even though the Doc interface is stored in a different repository and is nested in a different module, it is known to be the same.<p>
</a><a name="8531">
Meanwhile at SoftCo, someone working on a new Doc interface has given it a new repository id 456, which allows the ORBs to distinguish it from the current product Doc interface.<p>
</a><a name="8570">
FIGURE 12.&#32; <img src="local/images/intrep2a.gif">Using Repository IDs to establish correspondence between repositories<p>
</a><a name="8571">
Not all interfaces will be visible in all repositories. For example, Customer employees cannot see the new release of the Doc interface. However, widely used interfaces will generally be visible in most repositories.<p>
</a><a name="8572">
This Interface Repository specification defines operations for retrieving information from the repository as well as creating definitions within it. There may be additional ways to insert information into the repository (for example, compiling OMG IDL definitions, copying objects from one repository to another, etc.).<p>
</a><a name="8573">
A critical use of the interface repository information is for connecting ORBs together. When an object is passed in a request from one ORB to another, it may be necessary to create a new object to represent the passed object in the receiving ORB. This may require locating the interface information in an interface repository in the receiving ORB. By getting the repository id from a repository in the sending ORB, it is possible to look up the interface in a repository in the receiving ORB. To succeed, the interface for that object must be installed in both repositories with the same repository id.<p>
</a><a name="128">
<h1>	6.3	 Implementation Dependencies</h1>
</a><a name="96">
An implementation of an Interface Repository requires some form of persistent object store. Normally the kind of persistent object store used determines how interface definitions are distributed and/or replicated throughout a network domain. For example, if an Interface Repository is implemented using a filing system to provide object storage, there may be only a single copy of a set of interfaces maintained on a single machine. Alternatively, if an OODB is used to provide object storage, multiple copies of interface definitions may be maintained each of which is distributed across several machines to provide both high-availability and load-balancing. <p>
</a><a name="130">
The kind of object store used may determine the scope of interface definitions provided by an implementation of the Interface Repository. For example, it may determine whether each user has a local copy of a set of interfaces or if there is one copy per community of users. The object store may also determine whether or not all clients of an interface set see exactly the same set at any given point in time or whether latency in distributing copies of the set gives different users different views of the set at any point in time.<p>
</a><a name="131">
An implementation of the Interface Repository is also dependent on the security mechanism in use. The security mechanism (usually operating in conjunction with the object store) determines the nature and granularity of access controls available to constrain access to objects in the repository. <p>
</a><a name="8581">
<h2>	6.3.1	 Managing Interface Repositories</h2>
</a><a name="8582">
 Interface Repositories contain the information necessary to allow programs to determine and manipulate the type information at runtime. Programs may attempt to access the interface repository at any time by using the get_interface operation on the object reference. Once information has been installed in the repository, programs, stubs, and objects may depend on it. Updates to the repository must be done with care to avoid disrupting the environment. A variety of techniques are available to help do so.<p>
</a><a name="8583">
A coherent repository is one whose contents can be expressed as a valid collection of OMG IDL definitions. For example, all inherited interfaces exist, there are no duplicate operation names or other name collisions, all parameters have known types, and so forth. As information is added to the repository, it is possible that it may pass through incoherent states. Media failures or communication errors might also cause it to appear incoherent. In general, such problems cannot be completely eliminated.<p>
</a><a name="8584">
Replication is one technique to increase the availability and performance of a shared database. It is likely that the same interface information will be stored in multiple repositories in a computing environment. Using repository IDs, the repositories can establish the identity of the interfaces and other information across the repositories.<p>
</a><a name="8585">
Multiple repositories might also be used to insulate production environments from development activity. Developers might be permitted to make arbitrary updates to their repositories, but administrators may control updates to widely used repositories. Some repository implementations might permit sharing of information, for example, several developers' repositories may refer to parts of a shared repository. Other repository implementations might instead copy the common information. In any case, the result should be a repository facility that creates the impression of a single, coherent repository.<p>
</a><a name="8586">
The interface repository itself cannot make all repositories have coherent information, and it may be possible to enter information that does not make sense. The repository will report errors that it detects, e.g., defining two attributes with the same name, but might not report all errors, for example, adding an attribute to a base interface may or may not detect a name conflict with a derived interface. Despite these limitations, the expectation is that a combination of conventions, administrative controls, and tools that add information to the repository will work to create a coherent view of the repository information.<p>
</a><a name="8587">
Transactions and concurrency control mechanisms defined by the Object Services may be used by some repositories when updating the repository. Those services are designed so that they can be used without changing the operations that update the repository. For example, a repository that supports the Transaction Service would inherit the Repository interface, which contains the update operations, as well as the Transaction interface, which contains the transaction management operations. (For more information about Object Services, including the Transaction and Concurrency Control Services, refer to <em>CORBAservices: Common Object Service Specifications</em>.)<p>
</a><a name="8588">
Often, rather than change the information, new versions will be created, allowing the old version to continue to be valid. The new versions will have distinct repository IDs and be completely different types as far as the repository and the ORBs are concerned. The IR provides storage for version identifiers for named types, but does not specify any additional versioning mechanism or semantics.<p>
</a><a name="135">
<h1>	6.4	 Basics of the Interface Repository Interface</h1>
</a><a name="1818">
This section introduces some basic ideas that are important to understanding the Interface Repository. Topics addressed in this section are:<p>
</a><ul><a name="1819">
<li>Names and IDs
</a><a name="1820">
<li>Types and TypeCodes
</a><a name="1821">
<li>Interface Objects
</a></ul><a name="136">
<h2>	6.4.1	 Names and Identifiers</h2>
</a><a name="137">
 Simple names are not necessarily unique within an Interface Repository; they are always relative to an explicit or implicit module. In this context, interface definitions are considered explicit modules.<p>
</a><a name="681">
Scoped names uniquely identify modules, interfaces, constant, typedefs, exceptions, attributes, and operations in an Interface Repository.<p>
</a><a name="138">
Repository identifiers globally identify modules, interfaces, constants, typedefs, exceptions, attributes, and operations. They can be used to synchronize definitions across multiple ORBs and Repositories.<p>
</a><a name="139">
<h2>	6.4.2	 Types and TypeCodes</h2>
</a><a name="140">
 The Interface Repository stores information about types that are not interfaces in a data value called a TypeCode. From the TypeCode alone it is possible to determine the complete structure of a type. See <a href="intrep2.html#969">"TypeCodes" on page &#32;6-33</a> for more information on the internal structure of TypeCodes.<p>
</a><a name="98">
<h2>	6.4.3	 Interface Objects</h2>
</a><a name="144">
 Each interface managed in an Interface Repository is maintained as a collection of interface objects: <p>
</a><a name="99">
1.	 Repository: the top-level module for the repository name space; it contains constants, typedefs, exceptions, interface definitions, and modules.<p>
</a><a name="145">
2.	 ModuleDef: a logical grouping of interfaces; it contains constants, typedefs, exceptions, interface definitions, and other modules.<p>
</a><a name="146">
3.	 InterfaceDef: an interface definition; it contains lists of constants, types, exceptions, operations, and attributes.<p>
</a><a name="147">
4.	 AttributeDef: the definition of an attribute of the interface.<p>
</a><a name="148">
5.	 OperationDef: the definition of an operation on the interface; it contains lists of parameters and exceptions raised by this operation.<p>
</a><a name="150">
6.	 TypedefDef: base interface for definitions of named types that are not interfaces.<p>
</a><a name="151">
7.	 ConstantDef: the definition of a named constant.<p>
</a><a name="152">
8.	 ExceptionDef: the definition of an exception that can be raised by an operation.<p>
</a><a name="153">
The interface specifications for each interface object lists the attributes maintained by that object (see <a href="intrep2.html#103">"Interface Repository Interfaces" on page &#32;6-7</a>). Many of these attributes correspond directly to OMG IDL statements. An implementation can choose to maintain additional attributes to facilitate managing the Repository or to record additional (proprietary) information about an interface. Implementations that extend the IR interfaces should do so by deriving new interfaces, not by modify the standard interfaces.<p>
</a><a name="155">
The <em>CORBA</em> specification defines a minimal set of operations for interface objects. Additional operations that an implementation of the Interface Repository may provide could include operations that provide for the versioning of interfaces and for the reverse compilation of specifications (i.e., the generation of a file containing an object's OMG IDL specification).<p>
</a><a name="159">
<h2>	6.4.4	 Structure and Navigation of Interface Objects</h2>
</a><a name="160">
 The definitions in the Interface Repository are structured as a set of objects. The objects are structured the same way definitions are structured-some objects (definitions) "contain" other objects.<p>
</a><a name="161">
The containment relationships for the objects in the Interface Repository are shown in <a href="intrep2.html#100">FIGURE 13.&#32; on page 6-7</a>. <p>
</a><a name="100">
FIGURE 13.&#32; Interface Repository Object Containment<img src="local/images/intrepa1.gif"> <p>
</a><a name="1009">
There are three ways to locate an interface in the Interface Repository:<p>
</a><a name="168">
1.	 By obtaining an <strong>InterfaceDef</strong> object directly from the ORB.<p>
</a><a name="169">
2.	 By navigating through the module name space using a sequence of names.<p>
</a><a name="170">
3.	 By locating the <strong>InterfaceDef</strong> object that corresponds to a particular repository identifier.<p>
</a><a name="101">
Obtaining an <strong>InterfaceDef</strong> object directly is useful when an object is encountered whose type was not known at compile time. By using the <strong>get_interface()</strong> operation on the object reference, it is possible to retrieve the Interface Repository information about the object. That information could then be used to perform operations on the object.<p>
</a><a name="171">
Navigating the module name space is useful when information about a particular named interface is desired. Starting at the root module of the repository, it is possible to obtain entries by name.<p>
</a><a name="173">
Locating the <strong>InterfaceDef</strong> object by ID is useful when looking for an entry in one repository that corresponds to another. A repository identifier must be globally unique. By using the same identifier in two repositories, it is possible to obtain the interface identifier for an interface in one repository, and then obtain information about that interface from another repository that may be closer or contain additional information about the interface.<p>
</a><a name="103">
<h1>	6.5	 Interface Repository Interfaces</h1>
</a><a name="1655">
 Several abstract interfaces are used as base interfaces for other objects in the IR.<p>
</a><a name="1659">
A common set of operations is used to locate objects within the Interface Repository. These operations are defined in the abstract interfaces <strong>IRObject</strong>, <strong>Container</strong>, and <strong>Contained</strong> described below. All IR objects inherit from the <strong>IRObject</strong> interface, which provides an operation for identifying the actual type of the object. Objects that are containers inherit navigation operations from the <strong>Container</strong> interface. Objects that are contained by other objects inherit navigation operations from the <strong>Contained</strong> interface. <p>
</a><a name="1661">
The <strong>IDLType</strong> interface is inherited by all IR objects that represent IDL types, including interfaces, typedefs, and anonymous types. The <strong>TypedefDef</strong> interface is inherited by all named non-interface types.<p>
</a><a name="1658">
The <strong>IRObject</strong>, <strong>Contained</strong>, <strong>Container</strong>, <strong>IDLType</strong>, and <strong>TypedefDef</strong> interfaces are not instantiable. <p>
</a><a name="819">
<h2>	6.5.1	 Supporting Type Definitions</h2>
</a><a name="833">
 Several types are used throughout the IR interface definitions.<p>
</a><a name="834">
 module CORBA {<p>
</a><a name="853">
<blockquote>	typedef string							Identifier;</blockquote>
</a><a name="858">
<blockquote>	typedef string							ScopedName;</blockquote>
</a><a name="2887">
<blockquote>	typedef string							RepositoryId;</blockquote>
</a><a name="2888">
<blockquote></blockquote>
</a><a name="2891">
<blockquote>	enum DefinitionKind {<br>		dk_none, dk_all,</blockquote>
</a><a name="2871">
<blockquote>		dk_Attribute, dk_Constant, dk_Exception, dk_Interface,</blockquote>
</a><a name="2874">
<blockquote>		dk_Module, dk_Operation, dk_Typedef,</blockquote>
</a><a name="2875">
<blockquote>		dk_Alias, dk_Struct, dk_Union, dk_Enum,</blockquote>
</a><a name="2876">
<blockquote>		dk_Primitive, dk_String, dk_Sequence, dk_Array,</blockquote>
</a><a name="9704">
<blockquote>		dk_Repository</blockquote>
</a><a name="2854">
<blockquote>	};</blockquote>
</a><a name="2852">
 };<p>
</a><a name="959">
<strong>Identifier</strong>s are the simple names that identify modules, interfaces, constants, typedefs, exceptions, attributes, and operations. They correspond exactly to OMG IDL identifiers. An <strong>Identifier </strong>is not necessarily unique within an entire Interface Repository; it is unique only within a particular <strong>Repository,</strong> <strong>ModuleDef</strong>, <strong>InterfaceDef</strong>, or <strong>OperationDef</strong>.<p>
</a><a name="947">
 A <strong>ScopedName</strong> is a name made up of one or more <strong>Identifier</strong>s separated by the characters "::". They correspond to OMG IDL scoped names.<p>
</a><a name="8072">
An <em>absolute</em> <strong>ScopedName</strong> is one that begins with "::" and unambiguously identifies a definition in a <strong>Repository</strong>. An <em>absolute</em> <strong>ScopedName</strong> in a <strong>Repository</strong> corresponds to a <em>global name</em> in an OMG IDL file (see <a href="idlsyn.html#1302"> Section 3.12</a>). A <em>relative</em> <strong>ScopedName</strong> does not begin with "::" and must be resolved relative to some context.<p>
</a><a name="894">
A <strong>RepositoryId</strong> is an identifier used to uniquely and globally identify a module, interface, constant, typedef, exception, attribute or operation. As <strong>RepositoryId</strong>s are defined as strings, they can be manipulated (e.g., copied and compared) using a language binding's string manipulation routines.<p>
</a><a name="2895">
A <strong>DefinitionKind</strong> identifies the type of an IR object.<p>
</a><a name="830">
<h2>	6.5.2	 IRObject</h2>
</a><a name="815">
 The <strong>IRObject</strong> interface represents the most generic interface from which all other Interface Repository interfaces are derived, even the Repository itself.<p>
</a><a name="1013">
 module CORBA {<p>
</a><a name="1015">
<blockquote>	interface IRObject {</blockquote>
</a><a name="2902">
<blockquote>		// read interface</blockquote>
</a><a name="6156">
<blockquote>		readonly			attribute DefinitionKind							def_kind;</blockquote>
</a><a name="6189">
<blockquote></blockquote>
</a><a name="6190">
<blockquote>		// write interface</blockquote>
</a><a name="6191">
<blockquote>		void	 destroy ();</blockquote>
</a><a name="6157">
<blockquote>	};</blockquote>
</a><a name="1043">
 };<p>
</a><a name="6165">
<h3>		 Read Interface</h3>
</a><a name="6199">
 The <strong>def_kind</strong> attribute identifies the type of the definition.<p>
</a><a name="6200">
<h3>		 Write Interface</h3>
</a><a name="6218">
 The <strong>destroy </strong>operation causes the object to cease to exist. If 	the object is a <strong>Container</strong>, <strong>destroy</strong> is applied to all its contents. If the 	object contains an <strong>IDLType</strong> attribute for an anonymous type, that <strong>IDLType</strong> is destroyed. If the 	object is currently contained in some other object, it is removed. Invoking <strong>destroy</strong> on a <strong>Repository</strong> or on a <strong>PrimitiveDef</strong> is an error. Implementations may very in their handling of references to an object the is being destroyed, but the Repository should not be left in an incoherent state.<p>
</a><a name="7972">
<h2>	6.5.3	 Contained</h2>
</a><a name="7973">
 The <strong>Contained</strong> interface is inherited by all Interface Repository interfaces that are contained by other IR objects. All objects within the Interface Repository, except the root object (<strong>Repository</strong>) and definitions of anonymous (<strong>ArrayDef</strong>, <strong>StringDef</strong>, and <strong>SequenceDef</strong>), and primitive types are contained by other objects.<p>
</a><a name="9177">
 module CORBA {<p>
</a><a name="9178">
<blockquote>	typedef string VersionSpec;</blockquote>
</a><a name="9179">
<blockquote></blockquote>
</a><a name="7975">
<blockquote>	interface Contained : IRObject {</blockquote>
</a><a name="7976">
<blockquote>		// read/write interface</blockquote>
</a><a name="7977">
<blockquote></blockquote>
</a><a name="7978">
<blockquote>					attribute RepositoryId									id;</blockquote>
</a><a name="7979">
<blockquote>					attribute Identifier									name;</blockquote>
</a><a name="8846">
<blockquote>					attribute VersionSpec									version;</blockquote>
</a><a name="7980">
<blockquote></blockquote>
</a><a name="7981">
<blockquote>		// read interface</blockquote>
</a><a name="7982">
<blockquote></blockquote>
</a><a name="7983">
<blockquote>		readonly			attribute Container									defined_in;</blockquote>
</a><a name="7984">
<blockquote>		readonly			attribute ScopedName									absolute_name;</blockquote>
</a><a name="7985">
<blockquote>		readonly			attribute Repository									containing_repository;</blockquote>
</a><a name="7988">
<blockquote></blockquote>
</a><a name="7989">
<blockquote>		struct Description {</blockquote>
</a><a name="7990">
<blockquote>			DefinitionKind					kind;</blockquote>
</a><a name="7992">
<blockquote>			any 					value; </blockquote>
</a><a name="7993">
<blockquote>		};	</blockquote>
</a><a name="7994">
<blockquote></blockquote>
</a><a name="7995">
<blockquote>		Description describe ();</blockquote>
</a><a name="7996">
<blockquote><br>		// write interface</blockquote>
</a><a name="7997">
<blockquote></blockquote>
</a><a name="7998">
<blockquote>		void	 move (</blockquote>
</a><a name="8705">
<blockquote>			in Container					new_container,</blockquote>
</a><a name="8707">
<blockquote>			in Identifier					new_name,</blockquote>
</a><a name="8852">
<blockquote>			in VersionSpec					new_version</blockquote>
</a><a name="8706">
<blockquote>		);</blockquote>
</a><a name="7999">
<blockquote>	};</blockquote>
</a><a name="8000">
 };<p>
</a><a name="8001">
<h3>		 Read Interface</h3>
</a><a name="8857">
 An object that is contained by another object has an <strong>id</strong> attribute that identifies it globally, and a <strong>name</strong> attribute that identifies it uniquely within the enclosing <strong>Container</strong> object. It also has a <strong>version</strong> attribute that distinguishes it from other versioned objects with the same <strong>name</strong>. IRs are not required to support simultaneous containment of multiple versions of the same named object. Supporting multiple versions most likely requires mechanism and policy not specified in this document.<p>
</a><a name="8003">
<strong>Contained</strong> objects also have a <strong>defined_in</strong> attribute that identifies the <strong>Container</strong> within which they are defined. Objects can be contained either because they are defined within the containing object (for example, an interface is defined within a module) or because they are inherited by the containing object (for example, an operation may be contained by an interface because the interface inherits the operation from another interface). If an object is contained through inheritance, the <strong>defined_in</strong> attribute identifies the <strong>InterfaceDef</strong> from which the object is inherited.<p>
</a><a name="8004">
The <strong>absolute_name</strong> attribute is an absolute <strong>ScopedName</strong> that identifies a <strong>Contained</strong> object uniquely within its enclosing <strong>Repository</strong>. If this object's <strong>defined_in</strong> attribute references a <strong>Repository</strong>, the <strong>absolute_name</strong> is formed by concatenating the string "::" and this object's <strong>name</strong> attribute. Otherwise, the <strong>absolute_name</strong> is formed by concatenating the <strong>absolute_name</strong> attribute of the object referenced by this object's <strong>defined_in</strong> attribute, the string "::", and this object's <strong>name</strong> attribute.<p>
</a><a name="8005">
The <strong>containing_repository</strong> attribute identifies the <strong>Repository</strong> that is eventually reached by recursively following the object's <strong>defined_in</strong> attribute.<p>
</a><a name="8007">
The <strong>describe</strong> operation returns a structure containing information about the interface. The description structure associated with each interface is provided below with the interface's definition. The kind of definition described by the structure returned is provided with the returned structure. For example, if the <strong>describe</strong> operation is invoked on an attribute object, the <strong>kind</strong> field contains <strong>dk_Attribute</strong> and the <strong>value</strong> field contains an <strong>any</strong>, which contains the <strong>AttributeDescription</strong> structure. <p>
</a><a name="8008">
<h3>		 Write Interface</h3>
</a><a name="8009">
 Setting the <strong>id</strong> attribute changes the global identity of this definition. An error is returned if an object with the specified <strong>id</strong> attribute already exists within this object's <strong>Repository</strong>. <p>
</a><a name="8010">
Setting the <strong>name</strong> attribute changes the identity of this definition within its <strong>Container</strong>. An error is returned if an object with the specified <strong>name</strong> attribute already exists within the this object's <strong>Container</strong>. The <strong>absolute_name</strong> attribute is also updated, along with any other attributes that reflect the name of the object. If this object is a <strong>Container</strong>, the <strong>absolute_name</strong> attribute of any objects it contains are also updated.<p>
</a><a name="8011">
The <strong>move</strong> operation atomically removes this object from its current <strong>Container</strong>, and adds it to the <strong>Container</strong> specified by <strong>new_container</strong>, which must:<p>
</a><ul><a name="8012">
<li>Be in the same <strong>Repository,</strong>
</a><a name="8016">
<li>Be capable of containing this object's type (see <a href="intrep2.html#100">FIGURE 13.&#32; on page 6-7</a>); and
</a><a name="8017">
<li>Not already contain an object with this object's name (unless multiple versions are supported by the IR). 
</a><a name="8018">
The <strong>name</strong> attribute is changed to <strong>new_name</strong>, and the <strong>version</strong> attribute is changed to <strong>new_version</strong>.<p>
</a><a name="8715">
The <strong>defined_in</strong> and <strong>absolute_name</strong> attributes are updated to reflect the new container and <strong>name</strong>. If this object is also a <strong>Container</strong>, the <strong>absolute_name</strong> attributes of any objects it contains are also updated.<p>
</a></ul><a name="7246">
<h2>	6.5.4	 Container</h2>
</a><a name="7247">
 The <strong>Container</strong> interface is used to form a containment hierarchy in the Interface Repository. A <strong>Container</strong> can contain any number of objects derived from the <strong>Contained</strong> interface. All <strong>Container</strong>s, except for <strong>Repository</strong>, are also derived from <strong>Contained</strong>.<p>
</a><a name="7248">
 module CORBA {<p>
</a><a name="7249">
<blockquote>	typedef sequence &lt;Contained&gt; ContainedSeq;</blockquote>
</a><a name="7250">
<blockquote></blockquote>
</a><a name="7251">
<blockquote>	interface Container : IRObject {</blockquote>
</a><a name="7252">
<blockquote>		// read interface</blockquote>
</a><a name="7253">
<blockquote></blockquote>
</a><a name="7254">
<blockquote>		Contained lookup (	in ScopedName search_name);</blockquote>
</a><a name="7255">
<blockquote></blockquote>
</a><a name="7256">
<blockquote>		ContainedSeq contents (</blockquote>
</a><a name="7257">
<blockquote>			in DefinitionKind						limit_type,</blockquote>
</a><a name="8877">
<blockquote>			in boolean						exclude_inherited</blockquote>
</a><a name="7260">
<blockquote>		);</blockquote>
</a><a name="7261">
<blockquote></blockquote>
</a><a name="7262">
<blockquote>		ContainedSeq lookup_name	 (</blockquote>
</a><a name="7263">
<blockquote>			in Identifier						search_name, </blockquote>
</a><a name="7264">
<blockquote>			in long						levels_to_search, </blockquote>
</a><a name="7265">
<blockquote>			in DefinitionKind						limit_type,</blockquote>
</a><a name="8883">
<blockquote>			in boolean						exclude_inherited</blockquote>
</a><a name="7268">
<blockquote>		);</blockquote>
</a><a name="7269">
<blockquote></blockquote>
</a><a name="7270">
<blockquote>		struct Description {</blockquote>
</a><a name="7271">
<blockquote>			Contained 					contained_object; </blockquote>
</a><a name="7272">
<blockquote>			DefinitionKind					kind;</blockquote>
</a><a name="7274">
<blockquote>			any 					value; </blockquote>
</a><a name="7275">
<blockquote>		};</blockquote>
</a><a name="7276">
<blockquote></blockquote>
</a><a name="7277">
<blockquote>		typedef sequence&lt;Description&gt; DescriptionSeq;</blockquote>
</a><a name="7278">
<blockquote></blockquote>
</a><a name="7279">
<blockquote>		DescriptionSeq describe_contents (</blockquote>
</a><a name="7280">
<blockquote>			in DefinitionKind						limit_type,</blockquote>
</a><a name="7282">
<blockquote>			in boolean 						exclude_inherited,</blockquote>
</a><a name="7283">
<blockquote>			in long 						max_returned_objs</blockquote>
</a><a name="7284">
<blockquote>		);</blockquote>
</a><a name="7285">
<blockquote></blockquote>
</a><a name="7286">
<blockquote>		// write interface</blockquote>
</a><a name="7287">
<blockquote>		</blockquote>
</a><a name="7288">
<blockquote>		ModuleDef create_module (<br>			in RepositoryId						id,<br>			in Identifier						name,</blockquote>
</a><a name="8915">
<blockquote>			in VersionSpec						version</blockquote>
</a><a name="7289">
<blockquote>		);</blockquote>
</a><a name="7290">
<blockquote>		</blockquote>
</a><a name="7291">
<blockquote>		ConstantDef create_constant (<br>			in RepositoryId						id,<br>			in Identifier						name,</blockquote>
</a><a name="8917">
<blockquote>			in VersionSpec						version,</blockquote>
</a><a name="7292">
<blockquote>			in IDLType						type,</blockquote>
</a><a name="7293">
<blockquote>			in any						value</blockquote>
</a><a name="7294">
<blockquote>		);</blockquote>
</a><a name="7295">
<blockquote>		</blockquote>
</a><a name="8924">
<blockquote>		StructDef create_struct (<br>			in RepositoryId						id,<br>			in Identifier						name,</blockquote>
</a><a name="8930">
<blockquote>			in VersionSpec						version,</blockquote>
</a><a name="8925">
<blockquote>			in StructMemberSeq						members</blockquote>
</a><a name="7298">
<blockquote>		);</blockquote>
</a><a name="7299">
<blockquote>		</blockquote>
</a><a name="8938">
<blockquote>		UnionDef create_union (<br>			in RepositoryId						id,<br>			in Identifier						name,</blockquote>
</a><a name="8944">
<blockquote>			in VersionSpec						version,</blockquote>
</a><a name="8939">
<blockquote>			in IDLType						discriminator_type,<br>			in UnionMemberSeq						members</blockquote>
</a><a name="7303">
<blockquote>		);</blockquote>
</a><a name="7304">
<blockquote>		</blockquote>
</a><a name="7305">
<blockquote>		EnumDef create_enum (<br>			in RepositoryId						id,<br>			in Identifier						name,</blockquote>
</a><a name="8956">
<blockquote>			in VersionSpec						version,</blockquote>
</a><a name="7306">
<blockquote>			in EnumMemberSeq						members</blockquote>
</a><a name="7307">
<blockquote>		);</blockquote>
</a><a name="7308">
<blockquote>		</blockquote>
</a><a name="7309">
<blockquote>		AliasDef create_alias (<br>			in RepositoryId						id,<br>			in Identifier						name,</blockquote>
</a><a name="8966">
<blockquote>			in VersionSpec						version,</blockquote>
</a><a name="7310">
<blockquote>			in IDLType						original_type</blockquote>
</a><a name="7311">
<blockquote>		);</blockquote>
</a><a name="7312">
<blockquote>		</blockquote>
</a><a name="7313">
<blockquote>		InterfaceDef create_interface (<br>			in RepositoryId						id,<br>			in Identifier						name,</blockquote>
</a><a name="8974">
<blockquote>			in VersionSpec						version,</blockquote>
</a><a name="7314">
<blockquote>			in InterfaceDefSeq						base_interfaces</blockquote>
</a><a name="7315">
<blockquote>		);</blockquote>
</a><a name="7316">
<blockquote>	};</blockquote>
</a><a name="7317">
 };<p>
</a><a name="7319">
<h3>		 Read Interface</h3>
</a><a name="7320">
 The <strong>lookup</strong> operation locates a definition relative to this container given a scoped name using OMG IDL's name scoping rules. An absolute scoped name (beginning with "::") locates the definition relative to the enclosing <strong>Repository</strong>. If no object is found, a nil object reference is returned.<p>
</a><a name="7322">
The <strong>contents</strong> operation returns the list of objects directly contained by or inherited into the object. The operation is used to navigate through the hierarchy of objects. Starting with the Repository object, a client uses this operation to list all of the objects contained by the Repository, all of the objects contained by the modules within the Repository, and then all of the interfaces within a specific module, and so on.<p>
</a><a name="7323">
 <strong>limit_type</strong>	If <strong>limit_type</strong> is set to <strong>dk_all</strong>, objects of all interface types are returned. For example, if this is an <strong>InterfaceDef</strong>, the attribute, operation, and exception objects are all returned. If <strong>limit_type</strong> is set to a specific interface, only objects of that interface type are returned. For example, only attribute objects are returned if <strong>limit_type</strong> is set to <strong>dk_Attribute</strong>.<p>
</a><a name="8897">
 <strong>exclude_inherited </strong>	If set to TRUE, inherited objects (if there are any) are not returned. If set to FALSE, all contained objects-whether contained due to inheritance or because they were defined within the object-are returned.<p>
</a><a name="7325">
The <strong>lookup_name</strong> operation is used to locate an object by name within a particular object or within the objects contained by that object. <p>
</a><a name="7326">
 <strong>search_name</strong>	 Specifies which name is to be searched for. <p>
</a><a name="7327">
 <strong>levels_to_search</strong>	 Controls whether the lookup is constrained to the object the operation is invoked on or whether it should search through objects contained by the object as well.<p>
</a><a name="7328">
	Setting <strong>levels_to_search</strong> to -1 searches the current object and all contained objects. Setting <strong>levels_to_search</strong> to 1 searches only the current object. <p>
</a><a name="7329">
 <strong>limit_type</strong>	If <strong>limit_type</strong> is set to <strong>dk_all</strong>, objects of all interface types are returned (e.g., attributes, operations, and exceptions are all returned). If <strong>limit_type</strong> is set to a specific interface, only objects of that interface type are returned. For example, only attribute objects are returned if <strong>limit_type</strong> is set to <strong>dk_Attribute</strong>.<p>
</a><a name="7330">
 <strong>exclude_inherited </strong>	If set to TRUE, inherited objects (if there are any) are not returned. If set to FALSE, all contained objects (whether contained due to inheritance or because they were defined within the object) are returned.<p>
</a><a name="7331">
The <strong>describe_contents</strong> operation combines the <strong>contents</strong> operation and the <strong>describe</strong> operation. For each object returned by the <strong>contents</strong> operation, the description of the object is returned (i.e., the object's <strong>describe</strong> operation is invoked and the results returned). <p>
</a><a name="7332">
 <strong>max_returned_objs</strong>	 Limits the number of objects that can be returned in an invocation of the call to the number provided. Setting the parameter to -1 means return all contained objects.<p>
</a><a name="7333">
 <p>
</a><a name="7334">
<h3>		 Write Interface</h3>
</a><a name="7335">
 The <strong>Container</strong> interface provides operations to create <strong>ModuleDef</strong>s, <strong>ConstantDef</strong>s, <strong>StructDef</strong>s, <strong>UnionDef</strong>s, <strong>EnumDef</strong>s, <strong>AliasDef</strong>s, and <strong>InterfaceDef</strong>s as contained objects. The <strong>defined_in</strong> attribute of a definition created with any of these operations is initialized to identify the <strong>Container</strong> on which the operation is invoked, and the <strong>containing_repository</strong> attribute is initialized to its <strong>Repository</strong>.<p>
</a><a name="7336">
The <strong>create_&lt;type&gt;</strong> operations all take <strong>id</strong> and <strong>name</strong> parameters which are used to initialize the identity of the created definition. An error is returned if an object with the specified <strong>id</strong> already exists within this object's <strong>Repository</strong>, or, assuming multiple versions are not supported, if an object with the specified <strong>name</strong> already exists within this <strong>Container</strong>.<p>
</a><a name="7338">
The <strong>create_module</strong> operation returns a new empty <strong>ModuleDef</strong>. Definitions can be added using <strong>Container::create_&lt;type&gt;</strong> operations on the new module, or by using the <strong>Contained::move</strong> operation.<p>
</a><a name="7339">
The <strong>create_constant</strong> operation returns a new <strong>ConstantDef</strong> with the specified <strong>type</strong> and <strong>value</strong>.<p>
</a><a name="7340">
The <strong>create_struct</strong> operation returns a new <strong>StructDef</strong> with the specified <strong>members</strong>. The <strong>type</strong> member of the <strong>StructMember</strong> structures is ignored, and should be set to <strong>TC_void</strong>. See <a href="intrep2.html#346">"StructDef" on page &#32;6-19</a> for more information.<p>
</a><a name="7341">
The <strong>create_union</strong> operation returns a new <strong>UnionDef</strong> with the specified <strong>discriminator_type</strong> and <strong>members</strong>. The <strong>type</strong> member of the <strong>UnionMember</strong> structures is ignored, and should be set to <strong>TC_void</strong>. See <a href="intrep2.html#3601">"UnionDef" on page &#32;6-19</a> for more information.<p>
</a><a name="7342">
The <strong>create_enum</strong> operation returns a new <strong>EnumDef</strong> with the specified <strong>members</strong>. See <a href="intrep2.html#3704">"EnumDef" on page &#32;6-20</a> for more information.<p>
</a><a name="7343">
The <strong>create_alias</strong> operation returns a new <strong>AliasDef</strong> with the specified <strong>original_type</strong>.<p>
</a><a name="7344">
 The <strong>create_interface</strong> operation returns a new empty <strong>InterfaceDef</strong> with the specified <strong>base_interfaces</strong>. Type, exception, and constant definitions can be added using <strong>Container::create_&lt;type&gt;</strong> operations on the new <strong>InterfaceDef</strong>. <strong>OperationDefs</strong> can be added using <strong>InterfaceDef::create_operation</strong> and <strong>AttributeDefs</strong> can be added using <strong>Interface::create_attribute</strong>. Definitions can also be added using the <strong>Contained::move</strong> operation<p>
</a><a name="223">
<h2>	6.5.5	 IDLType</h2>
</a><a name="1663">
 The <strong>IDLType</strong> interface is an abstract interface inherited by all IR objects that represent OMG IDL types. It provides access to the <strong>TypeCode</strong> describing the type, and is used in defining other interfaces wherever definitions of IDL types must be referenced.<p>
</a><a name="1675">
 module CORBA {<p>
</a><a name="1680">
<blockquote>	interface IDLType : IRObject {</blockquote>
</a><a name="1682">
<blockquote>		readonly			attribute TypeCode						type;</blockquote>
</a><a name="1683">
<blockquote>	};</blockquote>
</a><a name="1679">
 };<p>
</a><a name="1702">
The <strong>type</strong> attribute describes the type defined by an object derived from <strong>IDLType</strong>.<p>
</a><a name="7542">
<h2>	6.5.6	 Repository</h2>
</a><a name="7543">
 <strong>Repository</strong> is an interface that provides global access to the Interface Repository. The <strong>Repository</strong> object can contain constants, typedefs, exceptions, interfaces, and modules. As it inherits from <strong>Container</strong>, it can be used to look up any definition (whether globally defined or defined within a module or interface) either by <strong>name</strong> or by <strong>id</strong>.<p>
</a><a name="7544">
There may be more than one Interface Repository in a particular ORB environment (although some ORBs might require that definitions they use be registered with a particular repository). Each ORB environment will provide a means for obtaining object references to the Repositories available within the environment.<p>
</a><a name="7545">
 module CORBA {<p>
</a><a name="7546">
<blockquote>	interface Repository : Container {</blockquote>
</a><a name="7547">
<blockquote>		// read interface</blockquote>
</a><a name="7548">
<blockquote></blockquote>
</a><a name="7549">
<blockquote>		Contained lookup_id (in RepositoryId search_id);</blockquote>
</a><a name="7550">
<blockquote></blockquote>
</a><a name="7551">
<blockquote>		PrimitiveDef get_primitive (in PrimitiveKind kind);</blockquote>
</a><a name="7552">
<blockquote></blockquote>
</a><a name="7553">
<blockquote>		// write interface</blockquote>
</a><a name="7554">
<blockquote></blockquote>
</a><a name="7555">
<blockquote>		StringDef create_string (in unsigned long bound);</blockquote>
</a><a name="7556">
<blockquote></blockquote>
</a><a name="7557">
<blockquote>		SequenceDef create_sequence (</blockquote>
</a><a name="7558">
<blockquote>				in unsigned long					bound,</blockquote>
</a><a name="7559">
<blockquote>				in IDLType					element_type</blockquote>
</a><a name="7560">
<blockquote>		);</blockquote>
</a><a name="7561">
<blockquote></blockquote>
</a><a name="7562">
<blockquote>		ArrayDef create_array (</blockquote>
</a><a name="7563">
<blockquote>				in unsigned long					length,</blockquote>
</a><a name="7564">
<blockquote>				in IDLType					element_type</blockquote>
</a><a name="7565">
<blockquote>		);</blockquote>
</a><a name="7566">
<blockquote>	};</blockquote>
</a><a name="7567">
 };<p>
</a><a name="7568">
<h3>		 Read Interface</h3>
</a><a name="7569">
 The <strong>lookup_id</strong> operation is used to lookup an object in a <strong>Repository</strong> given its <strong>RepositoryId</strong>. If the <strong>Repository</strong> does not contain a definition for <strong>search_id</strong>, a nil object reference is returned.<p>
</a><a name="7570">
The <strong>get_primitive</strong> operation returns a reference to a <strong>PrimitiveDef</strong> with the specified kind attribute. All <strong>PrimitiveDef</strong>s are immutable and owned by the <strong>Repository</strong>.<p>
</a><a name="7571">
<h3>		 Write Interface</h3>
</a><a name="7572">
 The three <strong>create_&lt;type&gt;</strong> operations create new objects defining anonymous types. As these interfaces are not derived from <strong>Contained</strong>, it is the caller's responsibility to invoke <strong>destroy</strong> on the returned object if it is not successfully used in creating a definition that is derived from <strong>Contained</strong>. Each anonymous type definition must be used in defining exactly one other object.<p>
</a><a name="7574">
The <strong>create_string</strong> operation returns a new <strong>StringDef</strong> with the specified <strong>bound</strong>, which must be non-zero. The <strong>get_primitive</strong> operation is used for unbounded strings. <p>
</a><a name="7575">
The <strong>create_sequence</strong> operation returns a new <strong>SequenceDef</strong> with the specified <strong>bound</strong> and <strong>element_type</strong>.<p>
</a><a name="7576">
The <strong>create_array</strong> operation returns a new <strong>ArrayDef</strong> with the specified <strong>length</strong> and <strong>element_type</strong>.<p>
</a><a name="7578">
<h2>	6.5.7	 ModuleDef</h2>
</a><a name="7579">
 A <strong>ModuleDef</strong> can contain constants, typedefs, exceptions, interfaces and other module objects. <p>
</a><a name="7580">
 module CORBA {<p>
</a><a name="7581">
<blockquote>	interface ModuleDef : Container, Contained {</blockquote>
</a><a name="7582">
<blockquote>	};</blockquote>
</a><a name="7583">
<blockquote></blockquote>
</a><a name="7584">
<blockquote>	struct ModuleDescription {</blockquote>
</a><a name="7585">
<blockquote>		Identifier 				name; </blockquote>
</a><a name="7586">
<blockquote>		RepositoryId 				id; </blockquote>
</a><a name="7587">
<blockquote>		RepositoryId 				defined_in;</blockquote>
</a><a name="8980">
<blockquote>		VersionSpec				version;</blockquote>
</a><a name="7588">
<blockquote>	};</blockquote>
</a><a name="7589">
 };<p>
</a><a name="7590">
The inherited <strong>describe</strong> operation for a <strong>ModuleDef</strong> object returns a <strong>ModuleDescription</strong>.<p>
</a><a name="7592">
<h2>	6.5.8	 ConstantDef Interface</h2>
</a><a name="7593">
 A <strong>ConstantDef</strong> object defines a named constant. <p>
</a><a name="7594">
 module CORBA {<p>
</a><a name="7595">
<blockquote>	interface ConstantDef : Contained {</blockquote>
</a><a name="7596">
<blockquote>		readonly			attribute TypeCode						type;</blockquote>
</a><a name="7597">
<blockquote>					attribute IDLType						type_def;</blockquote>
</a><a name="7598">
<blockquote>					attribute any						value;</blockquote>
</a><a name="7599">
<blockquote>	};</blockquote>
</a><a name="7600">
<blockquote></blockquote>
</a><a name="7601">
<blockquote>	struct ConstantDescription {</blockquote>
</a><a name="7602">
<blockquote>		Identifier 					name; </blockquote>
</a><a name="7603">
<blockquote>		RepositoryId 					id; </blockquote>
</a><a name="7604">
<blockquote>		RepositoryId 					defined_in; </blockquote>
</a><a name="8987">
<blockquote>		VersionSpec					version;</blockquote>
</a><a name="7605">
<blockquote>		TypeCode 					type; </blockquote>
</a><a name="7606">
<blockquote>		any 					value; </blockquote>
</a><a name="7607">
<blockquote>	};</blockquote>
</a><a name="7608">
 };<p>
</a><a name="7609">
<h3>		 Read Interface</h3>
</a><a name="7610">
 The <strong>type</strong> attribute specifies the <strong>TypeCode</strong> describing the type of the constant. The type of a constant must be one of the simple types (long, short, float, char, string, octet, etc.). The <strong>type_def</strong> attribute identifies the definition of the type of the constant. <p>
</a><a name="7611">
The <strong>value</strong> attribute contains the value of the constant, not the computation of the value (e.g., the fact that it was defined as "1+2"). <p>
</a><a name="7612">
The <strong>describe</strong> operation for a <strong>ConstantDef</strong> object returns a <strong>ConstantDescription</strong>.<p>
</a><a name="7613">
<h3>		 Write Interface</h3>
</a><a name="7614">
 Setting the <strong>type_def</strong> attribute also updates the <strong>type</strong> attribute. <p>
</a><a name="7615">
When setting the <strong>value</strong> attribute, the <strong>TypeCode</strong> of the supplied any must be equal to the <strong>type</strong> attribute of the <strong>ConstantDef</strong>.<p>
</a><a name="2318">
<h2>	6.5.9	 TypedefDef Interface</h2>
</a><a name="2399">
 <strong>TypedefDef</strong> is an abstract interface used as a base interface for all named non-object types (structures, unions, enumerations, and aliases). The <strong>TypedefDef</strong> interface is not inherited by the definition objects for primitive or anonymous types.<p>
</a><a name="3340">
 module CORBA {<p>
</a><a name="3343">
<blockquote>	interface TypedefDef : Contained, IDLType {</blockquote>
</a><a name="3344">
<blockquote>	};</blockquote>
</a><a name="3372">
<blockquote></blockquote>
</a><a name="3382">
<blockquote>	struct TypeDescription {</blockquote>
</a><a name="3374">
<blockquote>		Identifier 					name; </blockquote>
</a><a name="3375">
<blockquote>		RepositoryId 					id; </blockquote>
</a><a name="3376">
<blockquote>		RepositoryId 					defined_in; </blockquote>
</a><a name="8995">
<blockquote>		VersionSpec					version;</blockquote>
</a><a name="3377">
<blockquote>		TypeCode 					type; </blockquote>
</a><a name="3378">
<blockquote>	};</blockquote>
</a><a name="325">
 };<p>
</a><a name="328">
The inherited <strong>describe</strong> operation for interfaces derived from <strong>TypedefDef</strong> returns a <strong>TypeDescription</strong>.<p>
</a><a name="346">
<h2>	6.5.10	 StructDef</h2>
</a><a name="3548">
 A <strong>StructDef</strong> represents an OMG IDL structure definition.<p>
</a><a name="3549">
 module CORBA {<p>
</a><a name="3553">
<blockquote>	struct StructMember {</blockquote>
</a><a name="3568">
<blockquote>		Identifier				name;</blockquote>
</a><a name="3569">
<blockquote>		TypeCode				type;</blockquote>
</a><a name="3570">
<blockquote>		IDLType				type_def;</blockquote>
</a><a name="3558">
<blockquote>	};</blockquote>
</a><a name="3559">
<blockquote>	typedef sequence &lt;StructMember&gt; StructMemberSeq;</blockquote>
</a><a name="3560">
<blockquote></blockquote>
</a><a name="3561">
<blockquote>	interface StructDef : TypedefDef {</blockquote>
</a><a name="3562">
<blockquote>		attribute StructMemberSeq									members;</blockquote>
</a><a name="3563">
<blockquote>	};</blockquote>
</a><a name="3550">
 };<p>
</a><a name="3988">
<h3>		 Read Interface</h3>
</a><a name="6562">
 The <strong>members</strong> attribute contains a description of each structure member. <p>
</a><a name="6528">
The inherited <strong>type</strong> attribute is a <strong>tk_struct</strong> <strong>TypeCode</strong> describing the structure.<p>
</a><a name="6563">
<h3>		 Write Interface</h3>
</a><a name="6531">
 Setting the <strong>members</strong> attribute also updates the <strong>type</strong> attribute. When setting the <strong>members</strong> attribute, the <strong>type</strong> member of the <strong>StructMember</strong> structure is ignored and should be set to <strong>TC_void</strong>.<p>
</a><a name="3601">
<h2>	6.5.11	 UnionDef</h2>
</a><a name="3602">
 A <strong>UnionDef</strong> represents an OMG IDL union definition.<p>
</a><a name="3648">
 module CORBA {<p>
</a><a name="3653">
<blockquote>	struct UnionMember {</blockquote>
</a><a name="3655">
<blockquote>		Identifier				name;</blockquote>
</a><a name="3656">
<blockquote>		any				label;</blockquote>
</a><a name="3657">
<blockquote>		TypeCode				type;</blockquote>
</a><a name="3658">
<blockquote>		IDLType				type_def;</blockquote>
</a><a name="3659">
<blockquote>	};</blockquote>
</a><a name="3660">
<blockquote>	typedef sequence &lt;UnionMember&gt; UnionMemberSeq;</blockquote>
</a><a name="3661">
<blockquote></blockquote>
</a><a name="3662">
<blockquote>	interface UnionDef : TypedefDef {</blockquote>
</a><a name="3663">
<blockquote>		readonly			attribute TypeCode								discriminator_type;</blockquote>
</a><a name="3664">
<blockquote>					attribute IDLType								discriminator_type_def;</blockquote>
</a><a name="3666">
<blockquote>					attribute UnionMemberSeq								members;</blockquote>
</a><a name="3667">
<blockquote>	};</blockquote>
</a><a name="3649">
 };<p>
</a><a name="3989">
<h3>		 Read Interface</h3>
</a><a name="6564">
 The <strong>discriminator_type</strong> and <strong>discriminator_type_def</strong> attributes describe and identify the union's discriminator type. <p>
</a><a name="3990">
The <strong>members</strong> attribute contains a description of each union member. The <strong>label</strong> of each <strong>UnionMemberDescription</strong> is a distinct value of the <strong>discriminator_type</strong>. Adjacent members can have the same <strong>name</strong>. Members with the same <strong>name</strong> must also have the same <strong>type</strong>. A <strong>label</strong> with type <strong>octet</strong> and value 0 indicates the default union member.<p>
</a><a name="4102">
The inherited <strong>type</strong> attribute is a <strong>tk_union</strong> <strong>TypeCode</strong> describing the union.<p>
</a><a name="6565">
<h3>		 Write Interface</h3>
</a><a name="6536">
 Setting the <strong>discriminator_type_def</strong> attribute also updates the <strong>discriminator_type</strong> attribute and setting the <strong>discriminator_type_def</strong> or <strong>members</strong> attribute also updates the <strong>type</strong> attribute.<p>
</a><a name="6569">
When setting the <strong>members</strong> attribute, the <strong>type</strong> member of the <strong>UnionMember</strong> structure is ignored and should be set to <strong>TC_void</strong>.<p>
</a><a name="3704">
<h2>	6.5.12	 EnumDef</h2>
</a><a name="3530">
 An <strong>EnumDef</strong> represents an OMG IDL enumeration definition.<p>
</a><a name="3531">
 module CORBA {<p>
</a><a name="3713">
<blockquote>	typedef sequence &lt;Identifier&gt; EnumMemberSeq;</blockquote>
</a><a name="3715">
<blockquote></blockquote>
</a><a name="3716">
<blockquote>	interface EnumDef : TypedefDef {</blockquote>
</a><a name="3717">
<blockquote>		attribute EnumMemberSeq								members;</blockquote>
</a><a name="3718">
<blockquote>	};</blockquote>
</a><a name="3710">
 };<p>
</a><a name="4010">
<h3>		 Read Interface</h3>
</a><a name="6571">
 The <strong>members</strong> attribute contains a distinct name for each possible value of the enumeration. <p>
</a><a name="4103">
The inherited <strong>type</strong> attribute is a <strong>tk_enum</strong> <strong>TypeCode</strong> describing the enumeration.<p>
</a><a name="6572">
<h3>		 Write Interface</h3>
</a><a name="6573">
 Setting the <strong>members</strong> attribute also updates the <strong>type</strong> attribute.<p>
</a><a name="3477">
<h2>	6.5.13	 AliasDef</h2>
</a><a name="3537">
 An <strong>AliasDef</strong> represents an OMG IDL typedef that aliases another definition.<p>
</a><a name="3538">
 module CORBA {<p>
</a><a name="3743">
<blockquote>	interface AliasDef : TypedefDef {</blockquote>
</a><a name="3745">
<blockquote>		attribute IDLType					original_type_def;</blockquote>
</a><a name="3746">
<blockquote>	};</blockquote>
</a><a name="3539">
 };<p>
</a><a name="4015">
<h2>	6.5.14	 Read Interface</h2>
</a><a name="6574">
 The <strong>original_type_def</strong> attribute identifies the type being aliased.<p>
</a><a name="4104">
The inherited <strong>type</strong> attribute is a <strong>tk_alias</strong> <strong>TypeCode</strong> describing the alias.<p>
</a><a name="6575">
<h3>		 Write Interface</h3>
</a><a name="6576">
 Setting the <strong>original_type_def</strong> attribute also updates the <strong>type</strong> attribute.<p>
</a><a name="3490">
<h2>	6.5.15	 PrimitiveDef</h2>
</a><a name="3765">
 A <strong>PrimitiveDef</strong> represents one of the IDL primitive types. As primitive types are unnamed, this interface is not derived from <strong>TypedefDef</strong> or <strong>Contained</strong>.<p>
</a><a name="3793">
 module CORBA {<p>
</a><a name="3795">
<blockquote>	enum PrimitiveKind {</blockquote>
</a><a name="3837">
<blockquote>		pk_null, pk_void, pk_short, pk_long, pk_ushort, pk_ulong,</blockquote>
</a><a name="4587">
<blockquote>		pk_float, pk_double, pk_boolean, pk_char, pk_octet,</blockquote>
</a><a name="4591">
<blockquote>		pk_any, pk_TypeCode, pk_Principal, pk_string, pk_objref</blockquote>
</a><a name="3852">
<blockquote>	};</blockquote>
</a><a name="3853">
<blockquote></blockquote>
</a><a name="3854">
<blockquote>	interface PrimitiveDef: IDLType {</blockquote>
</a><a name="3855">
<blockquote>		readonly attribute PrimitiveKind									kind;</blockquote>
</a><a name="3856">
<blockquote>	};</blockquote>
</a><a name="4020">
 };<p>
</a><a name="4042">
The <strong>kind</strong> attribute indicates which primitive type the <strong>PrimitiveDef</strong> represents. There are no <strong>PrimitiveDef</strong>s with kind <strong>pk_null</strong>. A <strong>PrimitiveDef</strong> with kind <strong>pk_string</strong> represents an unbounded string. A <strong>PrimitiveDef</strong> with kind <strong>pk_objref</strong> represents the IDL type <strong>Object</strong>.<p>
</a><a name="4107">
The inherited <strong>type</strong> attribute describes the primitive type.<p>
</a><a name="5944">
All <strong>PrimitiveDef</strong>s are owned by the Repository. References to them are obtained using <strong>Repository::get_primitive</strong>.<p>
</a><a name="4321">
<h2>	6.5.16	 StringDef</h2>
</a><a name="4322">
 A <strong>StringDef</strong> represents an IDL bounded string type. The unbounded string type is represented as a <strong>PrimitiveDef</strong>. As string types are anonymous, this interface is not derived from <strong>TypedefDef</strong> or <strong>Contained</strong>.<p>
</a><a name="4323">
 module CORBA {<p>
</a><a name="4324">
<blockquote>	interface StringDef : IDLType {</blockquote>
</a><a name="4325">
<blockquote>		attribute unsigned long							bound;</blockquote>
</a><a name="4326">
<blockquote>	};</blockquote>
</a><a name="4327">
 };<p>
</a><a name="4328">
The <strong>bound </strong>attribute specifies the maximum number of characters in the string, and must not be zero.<p>
</a><a name="4329">
The inherited <strong>type</strong> attribute is a <strong>tk_string</strong> <strong>TypeCode</strong> describing the string.<p>
</a><a name="3621">
<h2>	6.5.17	 SequenceDef</h2>
</a><a name="3812">
 A <strong>SequenceDef</strong> represents an IDL sequence type. As sequence types are anonymous, this interface is not derived from <strong>TypedefDef</strong> or <strong>Contained</strong>.<p>
</a><a name="3818">
 module CORBA {<p>
</a><a name="3819">
<blockquote>	interface SequenceDef : IDLType {</blockquote>
</a><a name="3931">
<blockquote>					attribute unsigned long							bound;</blockquote>
</a><a name="3932">
<blockquote>		readonly			attribute TypeCode							element_type;</blockquote>
</a><a name="3933">
<blockquote>					attribute IDLType							element_type_def;</blockquote>
</a><a name="3934">
<blockquote>	};</blockquote>
</a><a name="4070">
 };<p>
</a><a name="4071">
<h3>		 Read Interface</h3>
</a><a name="6577">
 The <strong>bound </strong>attribute specifies the maximum number of elements in the sequence. A <strong>bound </strong>of zero indicates an unbounded sequence.<p>
</a><a name="4072">
The type of the elements is described by <strong>element_type</strong> and identified by <strong>element_type_def</strong>.<p>
</a><a name="4112">
The inherited <strong>type</strong> attribute is a <strong>tk_sequence</strong> <strong>TypeCode</strong> describing the sequence.<p>
</a><a name="6578">
<h3>		 Write Interface</h3>
</a><a name="6579">
 Setting the <strong>element_type_def</strong> attribute also updates the <strong>element_type</strong> attribute.<p>
</a><a name="6580">
Setting the <strong>bound</strong> or <strong>element_type_def</strong> attribute also updates the <strong>type</strong> attribute.<p>
</a><a name="4301">
<h2>	6.5.18	 ArrayDef</h2>
</a><a name="4302">
 An <strong>ArrayDef</strong> represents an IDL array type. As array types are anonymous, this interface is not derived from <strong>TypedefDef</strong> or <strong>Contained</strong>.<p>
</a><a name="4303">
 module CORBA {<p>
</a><a name="4304">
<blockquote>	interface ArrayDef : IDLType {</blockquote>
</a><a name="4305">
<blockquote>					attribute unsigned long							length;</blockquote>
</a><a name="4306">
<blockquote>		readonly			attribute TypeCode							element_type;</blockquote>
</a><a name="4307">
<blockquote>					attribute IDLType							element_type_def;</blockquote>
</a><a name="4308">
<blockquote>	};</blockquote>
</a><a name="9606">
 };<p>
</a><a name="9608">
<h3>		 Read Interface</h3>
</a><a name="6581">
 The <strong>length</strong> attribute specifies the number of elements in the array. <p>
</a><a name="9618">
The type of the elements is described by <strong>element_type</strong> and identified by <strong>element_type_def</strong>. Since an <strong>ArrayDef</strong> only represents a single dimension of an array, multi-dimensional IDL arrays are represented by multiple <strong>ArrayDef</strong> objects, one per array dimension. The <strong>element_type_def</strong> attribute of the <strong>ArrayDef</strong> representing the leftmost index of the array, as defined in IDL, will refer to the <strong>ArrayDef</strong> representing the next index to the right, and so on. The innermost <strong>ArrayDef</strong> represents the rightmost index and the element type of the multi-dimensional OMG IDL array.<p>
</a><a name="4312">
The inherited <strong>type</strong> attribute is a <strong>tk_array</strong> <strong>TypeCode</strong> describing the array.<p>
</a><a name="6584">
<h3>		 Write Interface</h3>
</a><a name="6585">
 Setting the <strong>element_type_def</strong> attribute also updates the <strong>element_type</strong> attribute.<p>
</a><a name="6586">
Setting the <strong>bound</strong> or <strong>element_type_def</strong> attribute also updates the <strong>type</strong> attribute.<p>
</a><a name="4116">
<h2>	6.5.19	 ExceptionDef</h2>
</a><a name="2400">
 An <strong>ExceptionDef</strong> represents an exception definition.<p>
</a><a name="3393">
 module CORBA {<p>
</a><a name="3396">
<blockquote>	interface ExceptionDef : Contained {<br>		readonly			attribute TypeCode								type;</blockquote>
</a><a name="3397">
<blockquote>					attribute StructMemberSeq								members;</blockquote>
</a><a name="3460">
<blockquote>	};</blockquote>
</a><a name="3407">
 	struct ExceptionDescription {<p>
</a><a name="3408">
<blockquote>		Identifier 				name; </blockquote>
</a><a name="3409">
<blockquote>		RepositoryId 				id; </blockquote>
</a><a name="3410">
<blockquote>		RepositoryId 				defined_in; </blockquote>
</a><a name="9003">
<blockquote>		VersionSpec				version;</blockquote>
</a><a name="3411">
<blockquote>		TypeCode 				type; </blockquote>
</a><a name="3412">
<blockquote>	};</blockquote>
</a><a name="351">
 };<p>
</a><a name="349">
<h3>		 Read Interface</h3>
</a><a name="6591">
 The <strong>type</strong> attribute is a <strong>tk_except</strong> <strong>TypeCode</strong> describing the exception.<p>
</a><a name="3468">
The members <strong>attribute</strong> describes any exception members.<p>
</a><a name="363">
The <strong>describe</strong> operation for a <strong>ExceptionDef</strong> object returns an <strong>ExceptionDescription</strong>.<p>
</a><a name="6594">
<h3>		 Write Interface</h3>
</a><a name="6595">
 Setting the <strong>members</strong> attribute also updates the <strong>type</strong> attribute. When setting the <strong>members</strong> attribute, the <strong>type</strong> member of the <strong>StructMember</strong> structure is ignored and should be set to <strong>TC_void</strong>.<p>
</a><a name="4199">
<h2>	6.5.20	 AttributeDef</h2>
</a><a name="4200">
 An <strong>AttributeDef</strong> represents the information that defines an attribute of an interface. <p>
</a><a name="4201">
 module CORBA {<p>
</a><a name="4202">
<blockquote>	enum AttributeMode {ATTR_NORMAL, ATTR_READONLY};</blockquote>
</a><a name="4203">
<blockquote></blockquote>
</a><a name="4204">
<blockquote>	interface AttributeDef : Contained {</blockquote>
</a><a name="4205">
<blockquote>		readonly			attribute TypeCode							type;</blockquote>
</a><a name="4206">
<blockquote>					attribute IDLType							type_def;</blockquote>
</a><a name="4207">
<blockquote>					attribute AttributeMode							mode;</blockquote>
</a><a name="4208">
<blockquote>	};</blockquote>
</a><a name="4209">
<blockquote></blockquote>
</a><a name="4210">
<blockquote>	struct AttributeDescription {</blockquote>
</a><a name="4211">
<blockquote>		Identifier 					name; </blockquote>
</a><a name="4212">
<blockquote>		RepositoryId 					id; </blockquote>
</a><a name="4213">
<blockquote>		RepositoryId 					defined_in; </blockquote>
</a><a name="9014">
<blockquote>		VersionSpec					version;</blockquote>
</a><a name="4214">
<blockquote>		TypeCode 					type;</blockquote>
</a><a name="4215">
<blockquote>		AttributeMode 					mode; </blockquote>
</a><a name="4216">
<blockquote>	};</blockquote>
</a><a name="4217">
 };<p>
</a><a name="4218">
<h3>		 Read Interface</h3>
</a><a name="6600">
 The <strong>type</strong> attribute provides the <strong>TypeCode</strong> describing the type of this attribute. The <strong>type_def</strong> attribute identifies the object defining the type of this attribute.<p>
</a><a name="4219">
The <strong>mode</strong> attribute specifies read only or read/write access for this attribute.<p>
</a><a name="6601">
<h3>		 Write Interface</h3>
</a><a name="6602">
 Setting the <strong>type_def</strong> attribute also updates the <strong>type</strong> attribute.<p>
</a><a name="4222">
<h2>	6.5.21	 OperationDef</h2>
</a><a name="3256">
 An <strong>OperationDef</strong> represents the information needed to define an operation of an interface. <p>
</a><a name="3257">
 module CORBA {<p>
</a><a name="4225">
<blockquote>	enum OperationMode {OP_NORMAL, OP_ONEWAY};</blockquote>
</a><a name="4227">
<blockquote></blockquote>
</a><a name="5473">
<blockquote>	enum ParameterMode {PARAM_IN, PARAM_OUT, PARAM_INOUT};</blockquote>
</a><a name="5464">
<blockquote>	struct ParameterDescription {</blockquote>
</a><a name="5411">
<blockquote>		Identifier 					name; </blockquote>
</a><a name="5414">
<blockquote>		TypeCode 					type; </blockquote>
</a><a name="5415">
<blockquote>		IDLType					type_def;</blockquote>
</a><a name="5431">
<blockquote>		ParameterMode 					mode;</blockquote>
</a><a name="5416">
<blockquote>	};</blockquote>
</a><a name="5449">
<blockquote>	typedef sequence &lt;ParameterDescription&gt; ParDescriptionSeq;</blockquote>
</a><a name="5439">
<blockquote></blockquote>
</a><a name="5446">
<blockquote>	typedef Identifier ContextIdentifier;</blockquote>
</a><a name="5440">
<blockquote>	typedef sequence &lt;ContextIdentifier&gt; ContextIdSeq;</blockquote>
</a><a name="5441">
<blockquote></blockquote>
</a><a name="5442">
<blockquote>	typedef sequence &lt;ExceptionDef&gt; ExceptionDefSeq;</blockquote>
</a><a name="4235">
<blockquote>	typedef sequence &lt;ExceptionDescription&gt; ExcDescriptionSeq;</blockquote>
</a><a name="4236">
<blockquote></blockquote>
</a><a name="4237">
<blockquote>	interface OperationDef : Contained {	</blockquote>
</a><a name="4238">
<blockquote>		readonly			attribute TypeCode								result;</blockquote>
</a><a name="4239">
<blockquote>					attribute IDLType								result_def;</blockquote>
</a><a name="4240">
<blockquote>					attribute ParDescriptionSeq								params;</blockquote>
</a><a name="6019">
<blockquote>					attribute OperationMode								mode; </blockquote>
</a><a name="6021">
<blockquote>					attribute ContextIdSeq								contexts;</blockquote>
</a><a name="6022">
<blockquote>					attribute ExceptionDefSeq								exceptions;</blockquote>
</a><a name="4244">
<blockquote>	};</blockquote>
</a><a name="4245">
<blockquote></blockquote>
</a><a name="4246">
<blockquote>	struct OperationDescription {</blockquote>
</a><a name="4247">
<blockquote>		Identifier 						name; </blockquote>
</a><a name="4248">
<blockquote>		RepositoryId 						id; </blockquote>
</a><a name="4249">
<blockquote>		RepositoryId 						defined_in; </blockquote>
</a><a name="9022">
<blockquote>		VersionSpec						version;</blockquote>
</a><a name="4250">
<blockquote>		TypeCode 						result; </blockquote>
</a><a name="4251">
<blockquote>		OperationMode 						mode; </blockquote>
</a><a name="4252">
<blockquote>		ContextIdSeq						contexts; </blockquote>
</a><a name="4253">
<blockquote>		ParDescriptionSeq						parameters;</blockquote>
</a><a name="4254">
<blockquote>		ExcDescriptionSeq						exceptions;</blockquote>
</a><a name="4255">
<blockquote>	};</blockquote>
</a><a name="4256">
 };<p>
</a><a name="5491">
<h3>		 Read Interface</h3>
</a><a name="6603">
 The <strong>result</strong> attribute is a <strong>TypeCode</strong> describing the type of the value returned by the operation. The <strong>result_def</strong> attribute identifies the definition of the returned type.<p>
</a><a name="5497">
The <strong>params</strong> attribute describes the parameters of the operation. It is a sequence of <strong>ParameterDescription</strong> structures. The order of the <strong>ParameterDescription</strong>s in the sequence is significant. The <strong>name</strong> member of each structure provides the parameter name. The <strong>type</strong> member is a <strong>TypeCode</strong> describing the type of the parameter. The <strong>type_def</strong> member identifies the definition of the type of the parameter. The <strong>mode</strong> member indicates whether the parameter is an in, out, or inout parameter.<p>
</a><a name="5493">
The operation's <strong>mode</strong> is either oneway (i.e., no output is returned) or normal. <p>
</a><a name="4260">
The <strong>contexts</strong> attribute specifies the list of context identifiers that apply to the operation.<p>
</a><a name="4261">
The <strong>exceptions</strong> attribute specifies the list of exception types that can be raised by the operation.<p>
</a><a name="4262">
The inherited <strong>describe</strong> operation for an <strong>OperationDef</strong> object returns an <strong>OperationDescription</strong>.<p>
</a><a name="4263">
The inherited <strong>describe_contents</strong> operation provides a complete description of this operation, including a description of each parameter defined for this operation.<p>
</a><a name="6604">
<h3>		 Write Interface</h3>
</a><a name="6605">
 Setting the <strong>result_def</strong> attribute also updates the <strong>result</strong> attribute.<p>
</a><a name="6606">
The <strong>mode</strong> attribute can only be set to <strong>OP_ONEWAY</strong> if the result is <strong>TC_void</strong> and all elements of <strong>params</strong> have a <strong>mode</strong> of <strong>PARAM_IN</strong>.<p>
</a><a name="4144">
<h2>	6.5.22	 InterfaceDef</h2>
</a><a name="4145">
 An <strong>InterfaceDef</strong> object represents an interface definition. It can contain constants, typedefs, exceptions, operations, and attributes.<p>
</a><a name="4146">
 module CORBA {<p>
</a><a name="4147">
<blockquote>	interface InterfaceDef;</blockquote>
</a><a name="4148">
<blockquote>	typedef sequence &lt;InterfaceDef&gt; InterfaceDefSeq;</blockquote>
</a><a name="4150">
<blockquote>	typedef sequence &lt;RepositoryId&gt; RepositoryIdSeq;</blockquote>
</a><a name="4151">
<blockquote>	typedef sequence &lt;OperationDescription&gt; OpDescriptionSeq;</blockquote>
</a><a name="4152">
<blockquote>	typedef sequence &lt;AttributeDescription&gt; AttrDescriptionSeq;</blockquote>
</a><a name="4153">
<blockquote></blockquote>
</a><a name="4154">
<blockquote>	interface InterfaceDef : Container, Contained, IDLType {</blockquote>
</a><a name="4155">
<blockquote>		// read/write interface</blockquote>
</a><a name="6619">
<blockquote></blockquote>
</a><a name="6618">
<blockquote>		attribute InterfaceDefSeq								base_interfaces;</blockquote>
</a><a name="4157">
<blockquote></blockquote>
</a><a name="4158">
<blockquote>		// read interface</blockquote>
</a><a name="6621">
<blockquote></blockquote>
</a><a name="6620">
<blockquote>		boolean is_a (in RepositoryId interface_id);</blockquote>
</a><a name="4159">
<blockquote></blockquote>
</a><a name="4160">
<blockquote>		struct FullInterfaceDescription {</blockquote>
</a><a name="4161">
<blockquote>			Identifier								name;</blockquote>
</a><a name="4162">
<blockquote>			RepositoryId								id;</blockquote>
</a><a name="4163">
<blockquote>			RepositoryId								defined_in;</blockquote>
</a><a name="9030">
<blockquote>			VersionSpec								version;</blockquote>
</a><a name="4164">
<blockquote>			OpDescriptionSeq								operations;</blockquote>
</a><a name="4165">
<blockquote>			AttrDescriptionSeq								attributes;</blockquote>
</a><a name="4166">
<blockquote>			RepositoryIdSeq								base_interfaces;</blockquote>
</a><a name="4168">
<blockquote>			TypeCode								type;</blockquote>
</a><a name="4169">
<blockquote>		};</blockquote>
</a><a name="4170">
<blockquote></blockquote>
</a><a name="4171">
<blockquote>		FullInterfaceDescription describe_interface();</blockquote>
</a><a name="6622">
<blockquote></blockquote>
</a><a name="6623">
<blockquote>		// write interface</blockquote>
</a><a name="6624">
<blockquote></blockquote>
</a><a name="6632">
<blockquote>		AttributeDef create_attribute (</blockquote>
</a><a name="6644">
<blockquote>				in RepositoryId						id,</blockquote>
</a><a name="6638">
<blockquote>				in Identifier						name,</blockquote>
</a><a name="9046">
<blockquote>				in VersionSpec						version,</blockquote>
</a><a name="6639">
<blockquote>				in IDLType						type,</blockquote>
</a><a name="6640">
<blockquote>				in AttributeMode						mode</blockquote>
</a><a name="6634">
<blockquote>		);</blockquote>
</a><a name="6650">
<blockquote></blockquote>
</a><a name="6667">
<blockquote>		OperationDef create_operation (</blockquote>
</a><a name="6654">
<blockquote>				in RepositoryId						id,</blockquote>
</a><a name="6655">
<blockquote>				in Identifier						name,</blockquote>
</a><a name="9054">
<blockquote>				in VersionSpec						version,</blockquote>
</a><a name="6656">
<blockquote>				in IDLType						result,</blockquote>
</a><a name="6657">
<blockquote>				in OperationMode						mode, </blockquote>
</a><a name="6658">
<blockquote>				in ParDescriptionSeq						params,</blockquote>
</a><a name="6659">
<blockquote>				in ExceptionDefSeq						exceptions,</blockquote>
</a><a name="6660">
<blockquote>				in ContextIdSeq						contexts</blockquote>
</a><a name="6661">
<blockquote>		);</blockquote>
</a><a name="4172">
<blockquote>	};</blockquote>
</a><a name="4173">
<blockquote></blockquote>
</a><a name="4174">
<blockquote>	struct InterfaceDescription {</blockquote>
</a><a name="4175">
<blockquote>		Identifier 					name; </blockquote>
</a><a name="4176">
<blockquote>		RepositoryId 					id; </blockquote>
</a><a name="4177">
<blockquote>		RepositoryId 					defined_in; </blockquote>
</a><a name="9038">
<blockquote>		VersionSpec					version;</blockquote>
</a><a name="4178">
<blockquote>		RepositoryIdSeq					base_interfaces;</blockquote>
</a><a name="4180">
<blockquote>	};</blockquote>
</a><a name="4181">
 };<p>
</a><a name="4183">
<h3>		 Read Interface</h3>
</a><a name="6615">
 The <strong>base_interfaces</strong> attribute lists all the interfaces from which this interface inherits. The <strong>is_a</strong> operation returns TRUE if the interface on which it is invoked either is identical to or inherits, directly or indirectly, from the interface identified by its <strong>interface_id</strong> parameter. Otherwise it returns FALSE.<p>
</a><a name="4184">
The <strong>describe_interface</strong> operation returns a <strong>FullInterfaceDescription</strong> describing the interface, including its operations and attributes.<p>
</a><a name="4185">
The inherited <strong>describe</strong> operation for an <strong>InterfaceDef</strong> returns an <strong>InterfaceDescription</strong>.<p>
</a><a name="4186">
The inherited <strong>contents</strong> operation returns the list of constants, typedefs, and exceptions defined in this InterfaceDef and the list of attributes and operations either defined or inherited in this InterfaceDef. If the <strong>exclude_inherited</strong> parameter is set to TRUE, only attributes and operations defined within this interface are returned. If the <strong>exclude_inherited</strong> parameter is set to FALSE, all attributes and operations are returned.<p>
</a><a name="6616">
<h3>		 Write Interface</h3>
</a><a name="6617">
 Setting the <strong>base_interfaces</strong> attribute returns an error if the <strong>name</strong> attribute of any object contained by this <strong>InterfaceDef</strong> conflicts with the <strong>name</strong> attribute of any object contained by any of the specified base <strong>InterfaceDef</strong>s.<p>
</a><a name="6687">
The <strong>create_attribute</strong> operation returns a new <strong>AttributeDef</strong> contained in the <strong>InterfaceDef</strong> on which it is invoked. The <strong>id</strong>, <strong>name</strong>, <strong>version, type_def</strong>, and <strong>mode</strong> attributes are set as specified. The <strong>type</strong> attribute is also set. The <strong>defined_in</strong> attribute is initialized to identify the containing <strong>InterfaceDef</strong>. An error is returned if an object with the specified <strong>id</strong> already exists within this object's <strong>Repository</strong>, or if an object with the specified <strong>name</strong> already exists within this <strong>InterfaceDef</strong>.<p>
</a><a name="6691">
The <strong>create_operation </strong>operation returns a new <strong>OperationDef</strong> contained in the <strong>InterfaceDef</strong> on which it is invoked. The <strong>id</strong>, <strong>name</strong>, <strong>version</strong>, <strong>result_def</strong>, <strong>mode</strong>, <strong>params</strong>, <strong>exceptions</strong>, and <strong>contexts</strong> attributes are set as specified. The <strong>result </strong>attribute is also set. The <strong>defined_in</strong> attribute is initialized to identify the containing <strong>InterfaceDef</strong>. An error is returned if an object with the specified <strong>id</strong> already exists within this object's <strong>Repository</strong>, or if an object with the specified <strong>name</strong> already exists within this <strong>InterfaceDef</strong>.<p>
</a><a name="360">
<h1>	6.6	 RepositoryIds</h1>
</a><a name="8601">
 <strong>RepositoryIds</strong> are values that can be used to establish the identity of information in the repository. A <strong>RepositoryId</strong> is represented as a string, allowing programs to store, copy, and compare them without regard to the structure of the value. It does not matter what format is used for any particular <strong>RepositoryId</strong>. However, conventions are used to manage the name space created by these IDs.<p>
</a><a name="8602">
<strong>RepositoryId</strong>s may be associated with OMG IDL definitions in a variety of ways. Installation tools might generate them, they might be defined with pragmas in OMG IDL source, or they might be supplied with the package to be installed.<p>
</a><a name="3057">
The format of the id is a short format name followed by a colon (":") followed by characters according to the format. This specification defines three formats: one derived from OMG IDL names, one that uses DCE UUIDs, and another intended for short-term use, such as in a development environment.<p>
</a><a name="3058">
<h2>	6.6.1	 OMG IDL Format</h2>
</a><a name="3060">
The OMG IDL format for <strong>RepositoryIds</strong> primarily uses OMG IDL scoped names to distinguish between definitions. It also includes an optional unique prefix, and major and minor version numbers. <p>
</a><a name="3061">
 The <strong>RepositoryId</strong> consist of three components, separated by colons, (":")<p>
</a><a name="3062">
The first component is the format name, "IDL".<p>
</a><a name="3063">
The second component is a list of identifiers, separated by "/" characters. These identifiers are arbitrarily long sequences of alphabetic, digit, underscore ("_"), hyphen ("-"), and period (".") characters. Typically, the first identifier is a unique prefix, and the rest are the OMG IDL Identifiers that make up the scoped name of the definition.<p>
</a><a name="3065">
The third component is made up of major and minor version numbers, in decimal format, separated by a ".". When two interfaces have <strong>RepositoryId</strong>s differing only in minor version number it can be assumed that the definition with the higher version number is upwardly compatible with (i.e. can be treated as derived from) the one with the lower minor version number.<p>
</a><a name="3066">
<p>
</a><a name="8608">
<h2>	6.6.2	 DCE UUID Format</h2>
</a><a name="8609">
 DCE UUID format <strong>RepositoryId</strong>s start with the characters "DCE:" and are followed by the printable form of the UUID, a colon, and a decimal minor version number, for example: "DCE:700dc518-0110-11ce-ac8f-0800090b5d3e:1".<p>
</a><a name="8610">
<h2>	6.6.3	 LOCAL Format</h2>
</a><a name="8611">
 Local format <strong>RepositoryId</strong>s start with the characters "LOCAL:" and are followed by an arbitrary string. Local format IDs are not intended for use outside a particular repository, and thus do not need to conform to any particular convention. Local IDs that are just consecutive integers might be used within a development environment to have a very cheap way to manufacture the IDs while avoiding conflicts with well-known interfaces.<p>
</a><a name="3075">
<h2>	6.6.4	 Pragma Directives for RepositoryId</h2>
</a><a name="3076">
Three pragma directives (id, prefix, and version), are specified accommodate arbitrary <strong>RepositoryId</strong> formats and still support the OMG IDL <strong>RepositoryId</strong> format with minimal annotation. The pragma directives can be used with the OMG IDL, DCE UUID, and LOCAL formats. An IDL compiler must either interpret these annotations as specified, or ignore them completely.<p>
</a><a name="3077">
<h3>		 The ID Pragma</h3>
</a><a name="3078">
An OMG IDL pragma of the format<p>
</a><a name="3079">
 					#pragma ID &lt;name&gt; "&lt;id&gt;"<p>
</a><a name="3080">
associates an arbitrary <strong>RepositoryId</strong> string with a specific OMG IDL name. The <strong>&lt;name&gt;</strong> can be a fully or partially scoped name or a simple identifier, interpreted according to the usual OMG IDL name lookup rules relative to the scope within which the pragma is contained.<p>
</a><a name="3081">
<h3>		 The Prefix Pragma</h3>
</a><a name="3082">
An OMG IDL pragma of the format<p>
</a><a name="3083">
 					#pragma prefix "&lt;string&gt;"<p>
</a><a name="3084">
sets the current prefix used in generating OMG IDL format <strong>RepositoryId</strong>s. The specified prefix applies to <strong>RepositoryId</strong>s generated after the pragma until the end of the current scope is reached or another prefix pragma is encountered.<p>
</a><a name="3085">
For example, the <strong>RepositoryId</strong> for the initial version of interface <strong>Printer</strong> defined on module <strong>Office </strong>by an organization known as "SoftCo" might be "IDL:SoftCo/Office/Printer:1.0".<p>
</a><a name="3086">
This format makes it convenient to generate and manage a set of IDs for a collection of OMG IDL definitions. The person creating the definitions sets a prefix ("SoftCo"), and the IDL compiler or other tool can synthesize all the needed IDs. <p>
</a><a name="3087">
Because <strong>RepositoryId</strong>s may be used in many different computing environments and ORBs, as well as over a long period of time, care must be taken in choosing them. Prefixes that are distinct, such as trademarked names, domain names, UUIDs, and so forth, are preferable to generic names such as "document." <p>
</a><a name="3088">
<h3>		 The Version Pragma</h3>
</a><a name="3089">
An OMG IDL pragma of the format<p>
</a><a name="3090">
 					#pragma version &lt;name&gt; &lt;major&gt;.&lt;minor&gt;<p>
</a><a name="3091">
provides the version specification used in generating an OMG IDL format <strong>RepositoryId</strong> for a specific OMG IDL name. The <strong>&lt;name&gt;</strong> can be a fully or partially scoped name or a simple identifier, interpreted according to the usual OMG IDL name lookup rules relative to the scope within which the pragma is contained. The <strong>&lt;major&gt;</strong> and <strong>&lt;minor&gt;</strong> components are decimal unsigned shorts.<p>
</a><a name="3092">
If no version pragma is supplied for a definition, version 1.0 is assumed.<p>
</a><a name="3094">
<h3>		 Generation of OMG IDL - Format IDs</h3>
</a><a name="3095">
A definition is globally identified by an OMG IDL - format <strong>RepositoryId</strong> if no ID pragma is encountered for it. <p>
</a><a name="3096">
The ID string can be generated by starting with the string "IDL:". Then, if any prefix pragma applies, it is appended, followed by a "/" character. Next, the components of the scoped name of the definition, relative to the scope in which any prefix that applies was encountered, are appended, separated by "/" characters. Finally, a ":" and the version specification are appended.<p>
</a><a name="3097">
For example, the following OMG IDL:<p>
</a><a name="3098">
 					module M1 {<p>
</a><a name="3099">
<blockquote>						typedef long T1;</blockquote>
</a><a name="3100">
<blockquote>						typedef long T2;</blockquote>
</a><a name="3101">
<blockquote>						#pragma ID T2 "DCE:d62207a2-011e-11ce-88b4-0800090b5d3e:3"</blockquote>
</a><a name="3102">
<blockquote>	</blockquote>
</a><a name="3103">
<blockquote>					};</blockquote>
</a><a name="3104">
<blockquote></blockquote>
</a><a name="3105">
<blockquote>					#pragma prefix "P1"</blockquote>
</a><a name="3106">
<blockquote></blockquote>
</a><a name="3107">
<blockquote>					module M2 {</blockquote>
</a><a name="3108">
<blockquote>						module M3 {</blockquote>
</a><a name="3109">
<blockquote>							#pragma prefix "P2"</blockquote>
</a><a name="3110">
<blockquote>							typedef long T3;</blockquote>
</a><a name="3111">
<blockquote>					};</blockquote>
</a><a name="3112">
<blockquote>							typedef long T4;</blockquote>
</a><a name="3113">
<blockquote>					#pragma version T4 2.4</blockquote>
</a><a name="3114">
 					};<p>
</a><a name="3115">
specifies types with the following scoped names and <strong>RepositoryId</strong>s:<p>
</a><a name="3116">
 	::M1::T1			IDL:M1/T1:1.0<p>
</a><a name="3488">
 	::M1::T2																	DCE:d62207a2-011e-11ce-88b4-0800090b5d3e:3<p>
</a><a name="3118">
 	::M2::M3::T3				IDL:P2/T3:1.0<p>
</a><a name="3119">
 	::M2::T4				IDL:P1/M2/T4:2.4<p>
</a><a name="3120">
For this scheme to provide reliable global identity, the prefixes used must be unique. Two non-colliding options are suggested: Internet domain names and DCE UUIDs. <p>
</a><a name="3121">
Furthermore, in a distributed world, where different entities independently evolve types, a convention must be followed to avoid the same <strong>RepositoryId</strong> being used for two different types. Only the entity that created the prefix has authority to create new IDs by simply incrementing the version number. Other entities must use a new prefix, even if they are only making a minor change to an existing type.<p>
</a><a name="3122">
Prefix pragmas can be used to preserve the existing IDs when a module or other container is renamed or moved.<p>
</a><a name="3123">
 					module M4 {<p>
</a><a name="3124">
<blockquote>						#pragma prefix "P1/M2"</blockquote>
</a><a name="3125">
<blockquote>					module M3 {</blockquote>
</a><a name="3126">
<blockquote>						#pragma prefix "P2"</blockquote>
</a><a name="3127">
<blockquote>							typedef long T3;</blockquote>
</a><a name="3128">
<blockquote>								};</blockquote>
</a><a name="3129">
<blockquote>							typedef long T4;</blockquote>
</a><a name="3130">
<blockquote>							#pragma version T4 2.4</blockquote>
</a><a name="3131">
 					};<p>
</a><a name="3132">
This OMG IDL declares types with the same global identities as those declared in module M2 above.<p>
</a><a name="3133">
<h3>		 For More Information</h3>
</a><a name="3137">
<a href="intrep2.html#1938">Section &#32;6.8, "OMG IDL for Interface Repository," on page &#32;6-41</a> shows the OMG IDL specification of the IR, including the #pragma directive; <a href="idlsyn.html#354">Section &#32;3.3, "Preprocessing," on page &#32;3-8</a> contain additional, general information on the pragma directive. <p>
</a><a name="969">
<h1>	6.7	 TypeCodes</h1>
</a><a name="361">
 <strong>TypeCode</strong>s are values that represent invocation argument types and attribute types. They can be obtained from the Interface Repository or from IDL compilers.<p>
</a><a name="362">
<strong>TypeCode</strong>s have a number of uses. They are used in the dynamic invocation interface to indicate the types of the actual arguments. They are used by an Interface Repository to represent the type specifications that are part of many OMG IDL declarations. Finally, they are crucial to the semantics of the <strong>any</strong> type.<p>
</a><a name="364">
<strong>TypeCode</strong>s are themselves values that can be passed as invocation arguments. To allow different ORB implementations to hide extra information in <strong>TypeCode</strong>s, the representation of <strong>TypeCode</strong>s will be opaque (like object references). However, we will assume that the representation is such that <strong>TypeCode</strong> "literals" can be placed in C include files.<p>
</a><a name="365">
Abstractly, <strong>TypeCode</strong>s consist of a "kind" field, and a set of parameters appropriate for that kind. For example, the <strong>TypeCode</strong> describing OMG IDL type <strong>long</strong> has kind <strong>tk_long</strong> and no parameters. The <strong>TypeCode</strong> describing OMG IDL type <strong>sequence&lt;boolean,10&gt;</strong> has kind <strong>tk_sequence</strong> and two parameters: <strong>10</strong> and <strong>boolean</strong>.<p>
</a><a name="367">
<h2>	6.7.1	 The TypeCode Interface</h2>
</a><a name="368">
The PIDL interface for <strong>TypeCodes</strong> is<p>
</a><a name="369">
 module CORBA {<p>
</a><a name="371">
<blockquote>	enum TCKind {				</blockquote>
</a><a name="474">
<blockquote>		tk_null, tk_void, </blockquote>
</a><a name="372">
<blockquote>		tk_short, tk_long, tk_ushort, tk_ulong, </blockquote>
</a><a name="373">
<blockquote>		tk_float, tk_double, tk_boolean, tk_char, </blockquote>
</a><a name="374">
<blockquote>		tk_octet, tk_any, tk_TypeCode, tk_Principal, 	tk_objref, </blockquote>
</a><a name="208">
<blockquote>		tk_struct, tk_union, tk_enum, tk_string, </blockquote>
</a><a name="376">
<blockquote>		tk_sequence, tk_array, tk_alias, tk_except</blockquote>
</a><a name="475">
<blockquote>	};</blockquote>
</a><a name="377">
<blockquote></blockquote>
</a><a name="378">
<blockquote>	interface TypeCode {</blockquote>
</a><a name="401">
<blockquote>		exception				Bounds {};</blockquote>
</a><a name="8146">
<blockquote>		exception				BadKind {};</blockquote>
</a><a name="380">
<blockquote></blockquote>
</a><a name="5903">
<blockquote>		// for all TypeCode kinds</blockquote>
</a><a name="5904">
<blockquote>		boolean				equal (in TypeCode tc);</blockquote>
</a><a name="440">
<blockquote>		TCKind 				kind ();</blockquote>
</a><a name="5893">
<blockquote></blockquote>
</a><a name="5906">
<blockquote>		// for tk_objref, tk_struct, tk_union, tk_enum, tk_alias, and tk_except</blockquote>
</a><a name="5905">
<blockquote>		RepositoryId				id () raises (BadKind);</blockquote>
</a><a name="5896">
<blockquote></blockquote>
</a><a name="5907">
<blockquote>		// for tk_objref, tk_struct, tk_union, tk_enum, tk_alias, and tk_except</blockquote>
</a><a name="5908">
<blockquote>		Identifier				name () raises (BadKind);</blockquote>
</a><a name="5897">
<blockquote></blockquote>
</a><a name="5909">
<blockquote>		// for tk_struct, tk_union, tk_enum, and tk_except</blockquote>
</a><a name="5910">
<blockquote>		unsigned long				member_count () raises (BadKind);</blockquote>
</a><a name="5898">
<blockquote>		Identifier				member_name (in unsigned long index) raises (BadKind, Bounds);</blockquote>
</a><a name="5899">
<blockquote></blockquote>
</a><a name="5912">
<blockquote>		// for tk_struct, tk_union, and tk_except</blockquote>
</a><a name="5911">
<blockquote>		TypeCode				member_type (in unsigned long index) raises (BadKind, Bounds);</blockquote>
</a><a name="5900">
<blockquote></blockquote>
</a><a name="5914">
<blockquote>		// for tk_union</blockquote>
</a><a name="5913">
<blockquote>		any				member_label (in unsigned long index) raises (BadKind, Bounds);</blockquote>
</a><a name="5901">
<blockquote>		TypeCode				discriminator_type () raises (BadKind);</blockquote>
</a><a name="5902">
<blockquote>		long				default_index () raises (BadKind);		</blockquote>
</a><a name="5894">
<blockquote></blockquote>
</a><a name="5895">
<blockquote>		// for tk_string, tk_sequence, and tk_array</blockquote>
</a><a name="5920">
<blockquote>		unsigned long				length () raises (BadKind);</blockquote>
</a><a name="5921">
<blockquote></blockquote>
</a><a name="5922">
<blockquote>		// for tk_sequence, tk_array, and tk_alias</blockquote>
</a><a name="5923">
<blockquote>		TypeCode				content_type () raises (BadKind);</blockquote>
</a><a name="5919">
<blockquote></blockquote>
</a><a name="5918">
<blockquote>		// deprecated interface</blockquote>
</a><a name="441">
<blockquote>		long				param_count (); </blockquote>
</a><a name="443">
<blockquote>		any 				parameter (in long index) raises (Bounds); </blockquote>
</a><a name="408">
<blockquote>	};</blockquote>
</a><a name="447">
 };<p>
</a><a name="2257">
With the above operations, any <strong>TypeCode</strong> can be decomposed into its constituent parts. The <strong>BadKind</strong> exception is raised if an operation is not appropriate for the <strong>TypeCode</strong> kind is invoked.<p>
</a><a name="8211">
The <strong>equal</strong> operation can be invoked on any <strong>TypeCode</strong>. Equal <strong>TypeCode</strong>s are interchangeable, and give identical results when <strong>TypeCode</strong> operations are applied to them.<p>
</a><a name="8196">
The <strong>kind</strong> operation can be invoked on any <strong>TypeCode</strong>. Its result determines what other operations can be invoked on the <strong>TypeCode</strong>.<p>
</a><a name="8231">
The <strong>id</strong> operation can be invoked on object reference, structure, union, enumeration, alias, and exception <strong>TypeCode</strong>s. It returns the <strong>RepositoryId</strong> globally identifying the type. Object reference and exception <strong>TypeCode</strong>s always have a <strong>RepositoryId</strong>. Structure, union, enumeration, and alias <strong>TypeCode</strong>s obtained from the Interface Repository or the <strong>ORB::create_operation_list</strong> operation also always have a <strong>RepositoryId</strong>. Otherwise, the <strong>id</strong> operation can return an empty string. <p>
</a><a name="8239">
The <strong>name</strong> operation can also be invoked on object reference, structure, union, enumeration, alias, and exception <strong>TypeCode</strong>s. It returns the simple name identifying the type within its enclosing scope. Since names are local to a <strong>Repository</strong>, the name returned from a <strong>TypeCode</strong> may not match the name of the type in any particular <strong>Repository</strong>, and may even be an empty string.<p>
</a><a name="8253">
The <strong>member_count</strong> and <strong>member_name</strong> operations can be invoked on structure, union, and enumeration <strong>TypeCode</strong>s. <strong>Member_count</strong> returns the number of members constituting the type. <strong>Member_name</strong> returns the simple name of the member identified by <strong>index</strong>. Since names are local to a <strong>Repository</strong>, the name returned from a <strong>TypeCode</strong> may not match the name of the member in any particular <strong>Repository</strong>, and may even be an empty string.<p>
</a><a name="8240">
The <strong>member_type</strong> operation can be invoked on structure and union <strong>TypeCode</strong>s. It returns the <strong>TypeCode</strong> describing the type of the member identified by <strong>index</strong>.<p>
</a><a name="8261">
The <strong>member_label</strong>, <strong>discriminator_type</strong>, and <strong>default_index</strong> operations can only be invoked on union <strong>TypeCode</strong>s. <strong>Member_label</strong> returns the label of the union member identified by <strong>index</strong>. For the default member, the label is the zero octet. The <strong>discriminator_type</strong> operation returns the type of all non-default member labels. The <strong>default_index</strong> operation returns the index of the default member, or -1 if there is no default member.<p>
</a><a name="8257">
The <strong>member_name</strong>, <strong>member_type</strong>, and <strong>member_label</strong> operations raise <strong>Bounds</strong> if the index parameter is greater than or equal to the number of members constituting the type.<p>
</a><a name="8262">
The <strong>length</strong> operation can be invoked on string, sequence, and array <strong>TypeCode</strong>s. For strings and sequences, it returns the bound, with zero indicating an unbounded string or sequence. For arrays, it returns number of elements in the array.<p>
</a><a name="8263">
The <strong>content_type</strong> operation can be invoked on sequence, array, and alias <strong>TypeCode</strong>s. For sequences and arrays, it returns the element type. For aliases, it returns the original type.<p>
</a><a name="499">
An array <strong>TypeCode</strong> only describes a single dimension of an OMG IDL array. Multi-dimensional arrays are represented by nesting <strong>TypeCode</strong>s, one per dimension. The outermost <strong>tk_array</strong> <strong>Typecode</strong> describes the leftmost array index of the array as defined in IDL. Its <strong>content_type</strong> describes the next index. The innermost nested <strong>tk_array</strong> <strong>TypeCode</strong> describes the rightmost index and the array element type.<p>
</a><a name="9623">
The deprecated <strong>param_count</strong> and <strong>parameter</strong> operations provide access to those parameters that were present in previous versions of <em>CORBA</em>. Some information available via other <strong>TypeCode</strong> operations is not visible via the <strong>parameter</strong> operation. The meaning of the indexed parameters for each <strong>TypeCode</strong> kind are listed in <a href="intrep2.html#9623">TABLE 12. on page 6-37</a>, along with the information that is not visible via the <strong>parameter</strong> operation. 
<Table Border="3">
<caption><a name="449">
TABLE 12.  Legal TypeCode Kinds and Parameters <p>
</a></caption>
<tr><th><a name="451">
 KIND<p>
</a><th><a name="452">
 PARAMETER LIST <p>
</a><th><a name="9639">
 NOT VISIBLE<p>
</a>
<tr><td><a name="453">
 tk_null <p>
</a><td><a name="454">
 *NONE* <p>
</a><td><a name="9641">
 <p>
</a>
<tr><td><a name="455">
 tk_void <p>
</a><td><a name="456">
 *NONE* <p>
</a><td><a name="9643">
 <p>
</a>
<tr><td><a name="457">
 tk_short <p>
</a><td><a name="458">
 *NONE* <p>
</a><td><a name="9645">
 <p>
</a>
<tr><td><a name="459">
 tk_long <p>
</a><td><a name="460">
 *NONE* <p>
</a><td><a name="9647">
 <p>
</a>
<tr><td><a name="461">
 tk_ushort<p>
</a><td><a name="462">
 *NONE* <p>
</a><td><a name="9649">
 <p>
</a>
<tr><td><a name="463">
 tk_ulong<p>
</a><td><a name="464">
 *NONE* <p>
</a><td><a name="9651">
 <p>
</a>
<tr><td><a name="465">
 tk_float<p>
</a><td><a name="466">
 *NONE* <p>
</a><td><a name="9653">
 <p>
</a>
<tr><td><a name="467">
 tk_double<p>
</a><td><a name="468">
 *NONE* <p>
</a><td><a name="9655">
 <p>
</a>
<tr><td><a name="184">
 tk_boolean<p>
</a><td><a name="247">
 *NONE* <p>
</a><td><a name="9657">
 <p>
</a>
<tr><td><a name="284">
 tk_char<p>
</a><td><a name="375">
 *NONE* <p>
</a><td><a name="9659">
 <p>
</a>
<tr><td><a name="469">
 tk_octet<p>
</a><td><a name="470">
 *NONE* <p>
</a><td><a name="9661">
 <p>
</a>
<tr><td><a name="471">
 tk_any<p>
</a><td><a name="480">
 *NONE* <p>
</a><td><a name="9663">
 <p>
</a>
<tr><td><a name="481">
 tk_TypeCode<p>
</a><td><a name="482">
 *NONE* <p>
</a><td><a name="9665">
 <p>
</a>
<tr><td><a name="483">
 tk_Principal<p>
</a><td><a name="484">
 *NONE*<p>
</a><td><a name="9667">
 <p>
</a>
<tr><td><a name="485">
 tk_objref<p>
</a><td><a name="486">
 { interface-id } <p>
</a><td><a name="9669">
 interface name<p>
</a>
<tr><td><a name="487">
 tk_struct<p>
</a><td><a name="488">
 { struct-name, member-name, TypeCode, ... (repeat pairs) } <p>
</a><td><a name="9671">
 RepositoryId<p>
</a>
<tr><td><a name="489">
 tk_union<p>
</a><td><a name="490">
 { union-name, discriminator-TypeCode, label-value, member-name, TypeCode, ... (repeat triples) }<p>
</a><td><a name="9673">
 RepositoryId<p>
</a>
<tr><td><a name="491">
 tk_enum<p>
</a><td><a name="492">
 { enum-name, enumerator-name, ... } <p>
</a><td><a name="9675">
 RepositoryId<p>
</a>
<tr><td><a name="493">
 tk_string<p>
</a><td><a name="494">
 { maxlen-integer } <p>
</a><td><a name="9677">
 <p>
</a>
<tr><td><a name="495">
 tk_sequence<p>
</a><td><a name="496">
 { TypeCode, maxlen-integer } <p>
</a><td><a name="9679">
 <p>
</a>
<tr><td><a name="497">
 tk_array<p>
</a><td><a name="498">
 { TypeCode, length-integer }<p>
</a><td><a name="9681">
 <p>
</a>
<tr><td><a name="2273">
 tk_alias<p>
</a><td><a name="2275">
 { alias-name, TypeCode }<p>
</a><td><a name="9683">
 Repositoryid<p>
</a>
<tr><td><a name="2269">
 tk_except<p>
</a><td><a name="2271">
 { except-name, member-name, TypeCode, ... (repeat pairs) }<p>
</a><td><a name="9685">
 RepositoryId<p>
</a>

</Table>

<Table>
<tr><td>
</Table>
 <p>
</a><a name="446">
The <strong>tk_objref</strong> <strong>TypeCode</strong> represents an interface type. Its parameter is the <strong>RepositoryId</strong> of that interface.<p>
</a><a name="384">
A structure with N members results in a <strong>tk_struct</strong> <strong>TypeCode</strong> with 2N+1 parameters: first, the simple name of the struct; the rest are member names alternating with the corresponding member <strong>TypeCode</strong>. Member names are represented as strings.<p>
</a><a name="385">
A union with N members results in a <strong>tk_union</strong> <strong>TypeCode</strong> with 3N+2 parameters: the simple name of the union, the discriminator <strong>TypeCode</strong> followed by a label value, member name, and member <strong>TypeCode</strong> for each of the N members. The label values are all values of the data type designated by the discriminator <strong>TypeCode</strong>, with one exception. The default member (if present) is marked with a label value consisting of the 0 <strong>octet</strong>. Recall that the operation "parameter(tc,i)" returns an <strong>any</strong>, and that anys themselves carry a <strong>TypeCode</strong> that can distinguish an octet from any of the legal switch types.<p>
</a><a name="386">
The <strong>tk_enum</strong> <strong>TypeCode</strong> has the simple name of the enum followed by the enumerator names as parameters. Enumerator names are represented as strings.<p>
</a><a name="387">
The <strong>tk_string</strong> <strong>TypeCode</strong> has 1 parameter: an integer giving the maximum string length. A maximum of 0 denotes unbounded.<p>
</a><a name="388">
The <strong>tk_sequence</strong> <strong>TypeCode</strong> has 2 parameters: a <strong>TypeCode</strong> for the sequence elements, and an integer giving the maximum sequence. Again, 0 denotes unbounded.<p>
</a><a name="389">
The <strong>tk_array</strong> <strong>TypeCode</strong> has 2 parameters: a <strong>TypeCode</strong> for the array elements, and an integer giving the array length. Arrays are never unbounded.<p>
</a><a name="4539">
The <strong>tk_alias</strong> <strong>TypeCode</strong> has 2 parameters: the name of the alias followed by the <strong>TypeCode</strong> of the type being aliased.<p>
</a><a name="4540">
The <strong>tk_except</strong> <strong>TypeCode</strong> has the same format as the <strong>tk_struct</strong> <strong>TypeCode</strong>, except that exceptions with no members are allowed.<p>
</a><a name="399">
<h2>	6.7.2	 TypeCode Constants</h2>
</a><a name="400">
 If "<strong>typedef ... FOO;</strong>" is an IDL type declaration, the IDL compiler will (if asked) produce a declaration of a <strong>TypeCode</strong> constant named TC_FOO for the C language mapping. In the case of an unnamed, bounded string type used directly in an operation or attribute declaration, a <strong>TypeCode</strong> constant named TC_string_n, where n is the bound of the string is produced. (For example, "string&lt;4&gt; op1();" produces the constant "TC_string_4".) These constants can be used with the dynamic invocation interface, and any other routines that require <strong>TypeCode</strong>s. The predefined <strong>TypeCode</strong> constants, named according to the C language mapping, are:<p>
</a><a name="379">
TC_null<br>TC_void<br>TC_short<br>TC_long<br>TC_ushort<br>TC_ulong<br>TC_float<br>TC_double<br>TC_boolean<br>TC_char<br>TC_octet<br>TC_any<br>TC_TypeCode<br>TC_Principal<br>TC_Object 		= tk_objref { Object }<br>TC_string		= tk_string { 0 }	 // unbounded<br>TC_CORBA_NamedValue		= tk_struct { ... }<br>TC_CORBA_InterfaceDescription		= tk_struct { ... }<br>TC_CORBA_OperationDescription		= tk_struct { ... }<br>TC_CORBA_AttributeDescription		= tk_struct { ... }<br>TC_CORBA_ParameterDescription		= tk_struct { ... }<br>TC_CORBA_ModuleDescription		= tk_struct { ... }<br>TC_CORBA_ConstantDescription		= tk_struct { ... }<br>TC_CORBA_ExceptionDescription		= tk_struct { ... }<br>TC_CORBA_TypeDescription		= tk_struct { ... }<br>TC_CORBA_InterfaceDef_FullInterfaceDescription		= tk_struct { ... }<p>
</a><a name="472">
The exact form for <strong>TypeCode</strong> constants is language mapping, and possibly implementation, specific.<p>
</a><a name="8329">
<h2>	6.7.3	 Creating TypeCodes</h2>
</a><a name="8330">
 When creating type definition objects in an Interface Repository, types are specified in terms of object references, and the <strong>TypeCode</strong>s describing them are generated automatically.<p>
</a><a name="8331">
In some situations, such as bridges between ORBs, <strong>TypeCode</strong>s need to be constructed outside of any Interface Repository. This can be done using operations on the <strong>ORB</strong> pseudo-object.<p>
</a><a name="8332">
 module CORBA {<p>
</a><a name="8333">
<blockquote>	interface ORB {</blockquote>
</a><a name="8334">
<blockquote>		// other operations ...</blockquote>
</a><a name="8335">
<blockquote></blockquote>
</a><a name="8428">
<blockquote>		TypeCode			create_struct_tc (</blockquote>
</a><a name="8337">
<blockquote>				in RepositoryId						id,</blockquote>
</a><a name="8338">
<blockquote>				in Identifier						name,</blockquote>
</a><a name="8339">
<blockquote>				in StructMemberSeq						members</blockquote>
</a><a name="8340">
<blockquote>		);</blockquote>
</a><a name="8341">
<blockquote></blockquote>
</a><a name="8342">
<blockquote>		TypeCode			create_union_tc (</blockquote>
</a><a name="8343">
<blockquote>				in RepositoryId						id,</blockquote>
</a><a name="8344">
<blockquote>				in Identifier						name,</blockquote>
</a><a name="8345">
<blockquote>				in TypeCode						discriminator_type,</blockquote>
</a><a name="8346">
<blockquote>				in UnionMemberSeq						members</blockquote>
</a><a name="8347">
<blockquote>		);</blockquote>
</a><a name="8348">
<blockquote></blockquote>
</a><a name="8349">
<blockquote>		TypeCode			create_enum_tc (</blockquote>
</a><a name="8359">
<blockquote>				in RepositoryId						id,</blockquote>
</a><a name="8360">
<blockquote>				in Identifier						name,</blockquote>
</a><a name="8361">
<blockquote>				in EnumMemberSeq						members</blockquote>
</a><a name="8350">
<blockquote>		);</blockquote>
</a><a name="8364">
<blockquote></blockquote>
</a><a name="8365">
<blockquote>		TypeCode create_alias_tc (</blockquote>
</a><a name="8366">
<blockquote>				in RepositoryId						id,</blockquote>
</a><a name="8368">
<blockquote>				in Identifier						name,</blockquote>
</a><a name="8369">
<blockquote>				in TypeCode						original_type</blockquote>
</a><a name="8367">
<blockquote>		);</blockquote>
</a><a name="8412">
<blockquote></blockquote>
</a><a name="8421">
<blockquote>		TypeCode			create_exception_tc (</blockquote>
</a><a name="8413">
<blockquote>				in RepositoryId						id,</blockquote>
</a><a name="8414">
<blockquote>				in Identifier						name,</blockquote>
</a><a name="8415">
<blockquote>				in StructMemberSeq						members</blockquote>
</a><a name="8416">
<blockquote>		);</blockquote>
</a><a name="8372">
<blockquote></blockquote>
</a><a name="8379">
<blockquote>		TypeCode			create_interface_tc (</blockquote>
</a><a name="8373">
<blockquote>				in RepositoryId						id,</blockquote>
</a><a name="8374">
<blockquote>				in Identifier						name</blockquote>
</a><a name="8376">
<blockquote>		);</blockquote>
</a><a name="8370">
<blockquote></blockquote>
</a><a name="8384">
<blockquote>		TypeCode			create_string_tc (</blockquote>
</a><a name="8393">
<blockquote>				in unsigned long						bound</blockquote>
</a><a name="8394">
<blockquote>		);</blockquote>
</a><a name="8389">
<blockquote></blockquote>
</a><a name="8390">
<blockquote>		TypeCode			create_sequence_tc (</blockquote>
</a><a name="8386">
<blockquote>				in unsigned long						bound,</blockquote>
</a><a name="8392">
<blockquote>				in TypeCode						element_type</blockquote>
</a><a name="8391">
<blockquote>		);</blockquote>
</a><a name="8395">
<blockquote></blockquote>
</a><a name="8396">
<blockquote>		TypeCode			create_recursive_sequence_tc (</blockquote>
</a><a name="8479">
<blockquote>				in unsigned long						bound,</blockquote>
</a><a name="8484">
<blockquote>				in unsigned long						offset</blockquote>
</a><a name="8478">
<blockquote>		);</blockquote>
</a><a name="8476">
<blockquote></blockquote>
</a><a name="8475">
<blockquote>		TypeCode			create_array_tc (</blockquote>
</a><a name="8398">
<blockquote>				in unsigned long						length,</blockquote>
</a><a name="8399">
<blockquote>				in TypeCode						element_type</blockquote>
</a><a name="8397">
<blockquote>		);</blockquote>
</a><a name="8351">
<blockquote>	};</blockquote>
</a><a name="8352">
 };<p>
</a><a name="8404">
Most of these operations are similar to corresponding IR operations for creating type definitions. <strong>TypeCode</strong>s are used here instead of <strong>IDLType</strong> object references to refer to other types. In the <strong>StructMember</strong> and <strong>UnionMember</strong> structures, only the <strong>type</strong> is used, and the <strong>type_def</strong> should be set to nil.<p>
</a><a name="8500">
The <strong>create_recursive_sequence_tc</strong> operation is used to create <strong>TypeCode</strong>s describing recursive sequences (see <a href="idlsyn.html#538">See "Constructed Types" on page &#32;22.</a>) The result of this operation is used in constructing other types, with the <strong>offset</strong> parameter determining which enclosing <strong>TypeCode</strong> describes the elements of this sequence. For instance, to construct a <strong>TypeCode</strong> for the following OMG IDL structure, the offset used when creating its sequence <strong>TypeCode</strong> would be one:<p>
</a><a name="8520">
<blockquote>struct foo {</blockquote>
</a><a name="8521">
<blockquote>	long value;</blockquote>
</a><a name="8522">
<blockquote>	sequence &lt;foo&gt; chain;</blockquote>
</a><a name="8523">
<blockquote>};</blockquote>
</a><a name="8515">
Operations to create primitive <strong>TypeCode</strong>s are not needed, since <strong>TypeCode</strong> constants for these are available.<p>
</a><a name="1937">
<p>
</a><a name="1938">
<h1>	6.8	 OMG IDL for Interface Repository</h1>
</a><a name="2527">
This section contains the complete OMG IDL specification for the Interface Repository.<p>
</a><a name="1941">
<blockquote></blockquote>
</a><a name="1942">
<blockquote>#pragma prefix "omg.org"</blockquote>
</a><a name="1943">
 module CORBA {<p>
</a><a name="1944">
<blockquote>    typedef string Identifier;</blockquote>
</a><a name="1945">
<blockquote>    typedef string ScopedName;</blockquote>
</a><a name="1946">
<blockquote>    typedef string RepositoryId;</blockquote>
</a><a name="1947">
<blockquote></blockquote>
</a><a name="1948">
<blockquote>    enum DefinitionKind {</blockquote>
</a><a name="1949">
<blockquote>	dk_none, dk_all,</blockquote>
</a><a name="1950">
<blockquote>	dk_Attribute, dk_Constant, dk_Exception, dk_Interface,</blockquote>
</a><a name="1951">
<blockquote>	dk_Module, dk_Operation, dk_Typedef,</blockquote>
</a><a name="1952">
<blockquote>	dk_Alias, dk_Struct, dk_Union, dk_Enum,</blockquote>
</a><a name="1953">
<blockquote>	dk_Primitive, dk_String, dk_Sequence, dk_Array,</blockquote>
</a><a name="1954">
<blockquote>	dk_Repository</blockquote>
</a><a name="1955">
<blockquote>    };</blockquote>
</a><a name="1956">
<blockquote></blockquote>
</a><a name="1957">
<blockquote></blockquote>
</a><a name="1958">
<blockquote></blockquote>
</a><a name="1959">
<blockquote>    interface IRObject {</blockquote>
</a><a name="1960">
<blockquote>	// read interface</blockquote>
</a><a name="1961">
<blockquote>	readonly attribute DefinitionKind def_kind;</blockquote>
</a><a name="1962">
<blockquote></blockquote>
</a><a name="1963">
<blockquote>	// write interface</blockquote>
</a><a name="1964">
<blockquote>	void destroy ();</blockquote>
</a><a name="1965">
<blockquote>    };</blockquote>
</a><a name="1966">
<blockquote></blockquote>
</a><a name="1967">
<blockquote></blockquote>
</a><a name="1968">
<blockquote></blockquote>
</a><a name="1969">
<blockquote>    typedef string VersionSpec;</blockquote>
</a><a name="1970">
<blockquote></blockquote>
</a><a name="1971">
<blockquote>    interface Contained;</blockquote>
</a><a name="1972">
<blockquote>    interface Repository;</blockquote>
</a><a name="1973">
<blockquote>    interface Container;</blockquote>
</a><a name="1974">
<blockquote></blockquote>
</a><a name="1975">
<blockquote>    interface Contained : IRObject {</blockquote>
</a><a name="1976">
<blockquote>	// read/write interface</blockquote>
</a><a name="1977">
<blockquote></blockquote>
</a><a name="1978">
<blockquote>	attribute RepositoryId id;</blockquote>
</a><a name="1979">
<blockquote>	attribute Identifier name;</blockquote>
</a><a name="1980">
<blockquote>	attribute VersionSpec version;</blockquote>
</a><a name="1981">
<blockquote></blockquote>
</a><a name="1982">
<blockquote>	// read interface</blockquote>
</a><a name="1983">
<blockquote></blockquote>
</a><a name="1984">
<blockquote>	readonly attribute Container defined_in;</blockquote>
</a><a name="1985">
<blockquote>	readonly attribute ScopedName absolute_name;</blockquote>
</a><a name="1986">
<blockquote>	readonly attribute Repository containing_repository;</blockquote>
</a><a name="1987">
<blockquote></blockquote>
</a><a name="1988">
<blockquote>	struct Description {</blockquote>
</a><a name="1989">
<blockquote>	    DefinitionKind kind;</blockquote>
</a><a name="1990">
<blockquote>	    any value; </blockquote>
</a><a name="1991">
<blockquote>	}; </blockquote>
</a><a name="1992">
<blockquote></blockquote>
</a><a name="1993">
<blockquote>	Description describe ();</blockquote>
</a><a name="1994">
<blockquote></blockquote>
</a><a name="1995">
<blockquote>	// write interface</blockquote>
</a><a name="1996">
<blockquote></blockquote>
</a><a name="1997">
<blockquote>	void move (</blockquote>
</a><a name="1998">
<blockquote>	    in Container new_container,</blockquote>
</a><a name="1999">
<blockquote>	    in Identifier new_name,</blockquote>
</a><a name="2000">
<blockquote>	    in VersionSpec new_version</blockquote>
</a><a name="2001">
<blockquote>	    );</blockquote>
</a><a name="2002">
<blockquote>    };</blockquote>
</a><a name="2003">
<blockquote></blockquote>
</a><a name="2004">
<blockquote></blockquote>
</a><a name="2005">
<blockquote>    interface ModuleDef;</blockquote>
</a><a name="2006">
<blockquote>    interface ConstantDef;</blockquote>
</a><a name="2007">
<blockquote>    interface IDLType;</blockquote>
</a><a name="2008">
<blockquote>    interface StructDef;</blockquote>
</a><a name="2009">
<blockquote>    interface UnionDef;</blockquote>
</a><a name="2010">
<blockquote>    interface EnumDef;</blockquote>
</a><a name="2011">
<blockquote>    interface AliasDef;</blockquote>
</a><a name="2012">
<blockquote>    interface InterfaceDef;</blockquote>
</a><a name="2013">
<blockquote>    typedef sequence &lt;InterfaceDef&gt; InterfaceDefSeq;</blockquote>
</a><a name="2014">
<blockquote></blockquote>
</a><a name="2015">
<blockquote>    typedef sequence &lt;Contained&gt; ContainedSeq;</blockquote>
</a><a name="2016">
<blockquote></blockquote>
</a><a name="2017">
<blockquote>    struct StructMember {</blockquote>
</a><a name="2018">
<blockquote>	Identifier name;</blockquote>
</a><a name="2019">
<blockquote>	TypeCode type;</blockquote>
</a><a name="2020">
<blockquote>	IDLType type_def;</blockquote>
</a><a name="2021">
<blockquote>    };</blockquote>
</a><a name="2022">
<blockquote>    typedef sequence &lt;StructMember&gt; StructMemberSeq;</blockquote>
</a><a name="2023">
<blockquote></blockquote>
</a><a name="2024">
<blockquote>    struct UnionMember {</blockquote>
</a><a name="2025">
<blockquote>	Identifier name;</blockquote>
</a><a name="2026">
<blockquote>	any label;</blockquote>
</a><a name="2027">
<blockquote>	TypeCode type;</blockquote>
</a><a name="2028">
<blockquote>	IDLType type_def;</blockquote>
</a><a name="2029">
<blockquote>    };</blockquote>
</a><a name="2030">
<blockquote>    typedef sequence &lt;UnionMember&gt; UnionMemberSeq;</blockquote>
</a><a name="2031">
<blockquote></blockquote>
</a><a name="2032">
<blockquote>    typedef sequence &lt;Identifier&gt; EnumMemberSeq;</blockquote>
</a><a name="2033">
<blockquote></blockquote>
</a><a name="2034">
<blockquote>    interface Container : IRObject {</blockquote>
</a><a name="2035">
<blockquote>	// read interface</blockquote>
</a><a name="2036">
<blockquote></blockquote>
</a><a name="2037">
<blockquote>	Contained lookup ( in ScopedName search_name);</blockquote>
</a><a name="2038">
<blockquote></blockquote>
</a><a name="2039">
<blockquote>	ContainedSeq contents (</blockquote>
</a><a name="2040">
<blockquote>	    in DefinitionKind limit_type,</blockquote>
</a><a name="2041">
<blockquote>	    in boolean exclude_inherited</blockquote>
</a><a name="2042">
<blockquote>	    );</blockquote>
</a><a name="2043">
<blockquote></blockquote>
</a><a name="2044">
<blockquote>	ContainedSeq lookup_name (</blockquote>
</a><a name="2045">
<blockquote>	    in Identifier search_name, </blockquote>
</a><a name="2046">
<blockquote>	    in long levels_to_search, </blockquote>
</a><a name="2047">
<blockquote>	    in DefinitionKind limit_type,</blockquote>
</a><a name="2048">
<blockquote>	    in boolean exclude_inherited</blockquote>
</a><a name="2049">
<blockquote>	    );</blockquote>
</a><a name="2050">
<blockquote></blockquote>
</a><a name="2051">
<blockquote>	struct Description {</blockquote>
</a><a name="2052">
<blockquote>	    Contained contained_object; </blockquote>
</a><a name="2053">
<blockquote>	    DefinitionKind kind;</blockquote>
</a><a name="2054">
<blockquote>	    any value; </blockquote>
</a><a name="2055">
<blockquote>	};</blockquote>
</a><a name="2056">
<blockquote></blockquote>
</a><a name="2057">
<blockquote>	typedef sequence&lt;Description&gt; DescriptionSeq;</blockquote>
</a><a name="2058">
<blockquote></blockquote>
</a><a name="2059">
<blockquote>	DescriptionSeq describe_contents (</blockquote>
</a><a name="2060">
<blockquote>	    in DefinitionKind limit_type,</blockquote>
</a><a name="2061">
<blockquote>	    in boolean exclude_inherited,</blockquote>
</a><a name="2062">
<blockquote>	    in long max_returned_objs</blockquote>
</a><a name="2063">
<blockquote>	    );</blockquote>
</a><a name="2064">
<blockquote></blockquote>
</a><a name="2065">
<blockquote>	// write interface</blockquote>
</a><a name="2066">
<blockquote> </blockquote>
</a><a name="2067">
<blockquote>	ModuleDef create_module (</blockquote>
</a><a name="2068">
<blockquote>	    in RepositoryId id,</blockquote>
</a><a name="2069">
<blockquote>	    in Identifier name,</blockquote>
</a><a name="2070">
<blockquote>	    in VersionSpec version</blockquote>
</a><a name="2071">
<blockquote>	    );</blockquote>
</a><a name="2072">
<blockquote> </blockquote>
</a><a name="2073">
<blockquote>	ConstantDef create_constant (</blockquote>
</a><a name="2074">
<blockquote>	    in RepositoryId id,</blockquote>
</a><a name="2075">
<blockquote>	    in Identifier name,</blockquote>
</a><a name="2076">
<blockquote>	    in VersionSpec version,</blockquote>
</a><a name="2077">
<blockquote>	    in IDLType type,</blockquote>
</a><a name="2078">
<blockquote>	    in any value</blockquote>
</a><a name="2079">
<blockquote>	    );</blockquote>
</a><a name="2080">
<blockquote> </blockquote>
</a><a name="2081">
<blockquote>	StructDef create_struct (</blockquote>
</a><a name="2082">
<blockquote>	    in RepositoryId id,</blockquote>
</a><a name="2083">
<blockquote>	    in Identifier name,</blockquote>
</a><a name="2084">
<blockquote>	    in VersionSpec version,</blockquote>
</a><a name="2085">
<blockquote>	    in StructMemberSeq members</blockquote>
</a><a name="2086">
<blockquote>	    );</blockquote>
</a><a name="2087">
<blockquote> </blockquote>
</a><a name="2088">
<blockquote>	UnionDef create_union (</blockquote>
</a><a name="2089">
<blockquote>	    in RepositoryId id,</blockquote>
</a><a name="2090">
<blockquote>	    in Identifier name,</blockquote>
</a><a name="2091">
<blockquote>	    in VersionSpec version,</blockquote>
</a><a name="2092">
<blockquote>	    in IDLType discriminator_type,</blockquote>
</a><a name="2093">
<blockquote>	    in UnionMemberSeq members</blockquote>
</a><a name="2094">
<blockquote>	    );</blockquote>
</a><a name="2095">
<blockquote> </blockquote>
</a><a name="2096">
<blockquote>	EnumDef create_enum (</blockquote>
</a><a name="2097">
<blockquote>	    in RepositoryId id,</blockquote>
</a><a name="2098">
<blockquote>	    in Identifier name,</blockquote>
</a><a name="2099">
<blockquote>	    in VersionSpec version,</blockquote>
</a><a name="2100">
<blockquote>	    in EnumMemberSeq members</blockquote>
</a><a name="2101">
<blockquote>	    );</blockquote>
</a><a name="2102">
<blockquote> </blockquote>
</a><a name="2103">
<blockquote>	AliasDef create_alias (</blockquote>
</a><a name="2104">
<blockquote>	    in RepositoryId id,</blockquote>
</a><a name="2105">
<blockquote>	    in Identifier name,</blockquote>
</a><a name="2106">
<blockquote>	    in VersionSpec version,</blockquote>
</a><a name="2107">
<blockquote>	    in IDLType original_type</blockquote>
</a><a name="2108">
<blockquote>	    );</blockquote>
</a><a name="2109">
<blockquote> </blockquote>
</a><a name="2110">
<blockquote>	InterfaceDef create_interface (</blockquote>
</a><a name="2111">
<blockquote>	    in RepositoryId id,</blockquote>
</a><a name="2112">
<blockquote>	    in Identifier name,</blockquote>
</a><a name="2113">
<blockquote>	    in VersionSpec version,</blockquote>
</a><a name="2114">
<blockquote>	    in InterfaceDefSeq base_interfaces</blockquote>
</a><a name="2115">
<blockquote>	    );</blockquote>
</a><a name="2116">
<blockquote>    };</blockquote>
</a><a name="2117">
<blockquote></blockquote>
</a><a name="2118">
<blockquote></blockquote>
</a><a name="2119">
<blockquote></blockquote>
</a><a name="2120">
<blockquote>    interface IDLType : IRObject {</blockquote>
</a><a name="2121">
<blockquote>	readonly attribute TypeCode type;</blockquote>
</a><a name="2122">
<blockquote>    };</blockquote>
</a><a name="2123">
<blockquote></blockquote>
</a><a name="2124">
<blockquote></blockquote>
</a><a name="2125">
<blockquote></blockquote>
</a><a name="2126">
<blockquote>    interface PrimitiveDef;</blockquote>
</a><a name="2127">
<blockquote>    interface StringDef;</blockquote>
</a><a name="2128">
<blockquote>    interface SequenceDef;</blockquote>
</a><a name="2129">
<blockquote>    interface ArrayDef;</blockquote>
</a><a name="2130">
<blockquote></blockquote>
</a><a name="2131">
<blockquote>    enum PrimitiveKind {</blockquote>
</a><a name="2132">
<blockquote>	pk_null, pk_void, pk_short, pk_long, pk_ushort, pk_ulong,</blockquote>
</a><a name="2133">
<blockquote>	pk_float, pk_double, pk_boolean, pk_char, pk_octet,</blockquote>
</a><a name="2134">
<blockquote>	pk_any, pk_TypeCode, pk_Principal, pk_string, pk_objref</blockquote>
</a><a name="2135">
<blockquote>    };</blockquote>
</a><a name="2136">
<blockquote></blockquote>
</a><a name="2137">
<blockquote>    interface Repository : Container {</blockquote>
</a><a name="2138">
<blockquote>	// read interface</blockquote>
</a><a name="2139">
<blockquote></blockquote>
</a><a name="2140">
<blockquote>	Contained lookup_id (in RepositoryId search_id);</blockquote>
</a><a name="2141">
<blockquote></blockquote>
</a><a name="2142">
<blockquote>	PrimitiveDef get_primitive (in PrimitiveKind kind);</blockquote>
</a><a name="2143">
<blockquote></blockquote>
</a><a name="2144">
<blockquote>	// write interface</blockquote>
</a><a name="2145">
<blockquote></blockquote>
</a><a name="2146">
<blockquote>	StringDef create_string (in unsigned long bound);</blockquote>
</a><a name="2147">
<blockquote></blockquote>
</a><a name="2148">
<blockquote>	SequenceDef create_sequence (</blockquote>
</a><a name="2149">
<blockquote>	    in unsigned long bound,</blockquote>
</a><a name="2150">
<blockquote>	    in IDLType element_type</blockquote>
</a><a name="2151">
<blockquote>	    );</blockquote>
</a><a name="2152">
<blockquote></blockquote>
</a><a name="2153">
<blockquote>	ArrayDef create_array (</blockquote>
</a><a name="2154">
<blockquote>	    in unsigned long length,</blockquote>
</a><a name="2155">
<blockquote>	    in IDLType element_type</blockquote>
</a><a name="2156">
<blockquote>	    );</blockquote>
</a><a name="2157">
<blockquote>    };</blockquote>
</a><a name="2158">
<blockquote></blockquote>
</a><a name="2159">
<blockquote></blockquote>
</a><a name="2160">
<blockquote></blockquote>
</a><a name="2161">
<blockquote>    interface ModuleDef : Container, Contained {</blockquote>
</a><a name="2162">
<blockquote>    };</blockquote>
</a><a name="2163">
<blockquote></blockquote>
</a><a name="2164">
<blockquote>    struct ModuleDescription {</blockquote>
</a><a name="2165">
<blockquote>	Identifier name; </blockquote>
</a><a name="2166">
<blockquote>	RepositoryId id; </blockquote>
</a><a name="2167">
<blockquote>	RepositoryId defined_in;</blockquote>
</a><a name="2168">
<blockquote>	VersionSpec version;</blockquote>
</a><a name="2169">
<blockquote>    };</blockquote>
</a><a name="2170">
<blockquote></blockquote>
</a><a name="2171">
<blockquote></blockquote>
</a><a name="2172">
<blockquote></blockquote>
</a><a name="2173">
<blockquote>    interface ConstantDef : Contained {</blockquote>
</a><a name="2174">
<blockquote>	readonly attribute TypeCode type;</blockquote>
</a><a name="2175">
<blockquote>	attribute IDLType type_def;</blockquote>
</a><a name="2176">
<blockquote>	attribute any value;</blockquote>
</a><a name="2177">
<blockquote>    };</blockquote>
</a><a name="2178">
<blockquote></blockquote>
</a><a name="2179">
<blockquote>    struct ConstantDescription {</blockquote>
</a><a name="2180">
<blockquote>	Identifier name; </blockquote>
</a><a name="2181">
<blockquote>	RepositoryId id; </blockquote>
</a><a name="2182">
<blockquote>	RepositoryId defined_in; </blockquote>
</a><a name="2183">
<blockquote>	VersionSpec version;</blockquote>
</a><a name="2184">
<blockquote>	TypeCode type; </blockquote>
</a><a name="2185">
<blockquote>	any value; </blockquote>
</a><a name="2186">
<blockquote>    };</blockquote>
</a><a name="2187">
<blockquote></blockquote>
</a><a name="2188">
<blockquote></blockquote>
</a><a name="2189">
<blockquote></blockquote>
</a><a name="2190">
<blockquote>    interface TypedefDef : Contained, IDLType {</blockquote>
</a><a name="2191">
<blockquote>    };</blockquote>
</a><a name="2192">
<blockquote></blockquote>
</a><a name="2193">
<blockquote>    struct TypeDescription {</blockquote>
</a><a name="2194">
<blockquote>	Identifier name; </blockquote>
</a><a name="2195">
<blockquote>	RepositoryId id; </blockquote>
</a><a name="2196">
<blockquote>	RepositoryId defined_in; </blockquote>
</a><a name="2197">
<blockquote>	VersionSpec version;</blockquote>
</a><a name="2198">
<blockquote>	TypeCode type; </blockquote>
</a><a name="2199">
<blockquote>    };</blockquote>
</a><a name="2200">
<blockquote></blockquote>
</a><a name="2201">
<blockquote></blockquote>
</a><a name="2202">
<blockquote></blockquote>
</a><a name="2203">
<blockquote>    interface StructDef : TypedefDef {</blockquote>
</a><a name="2204">
<blockquote>	attribute StructMemberSeq members;</blockquote>
</a><a name="2205">
<blockquote>    };</blockquote>
</a><a name="2206">
<blockquote></blockquote>
</a><a name="2207">
<blockquote></blockquote>
</a><a name="2208">
<blockquote></blockquote>
</a><a name="2209">
<blockquote>    interface UnionDef : TypedefDef {</blockquote>
</a><a name="2210">
<blockquote>	readonly attribute TypeCode discriminator_type;</blockquote>
</a><a name="2211">
<blockquote>	attribute IDLType discriminator_type_def;</blockquote>
</a><a name="2212">
<blockquote>	attribute UnionMemberSeq members;</blockquote>
</a><a name="2213">
<blockquote>    };</blockquote>
</a><a name="2214">
<blockquote></blockquote>
</a><a name="2215">
<blockquote></blockquote>
</a><a name="2216">
<blockquote></blockquote>
</a><a name="2217">
<blockquote>    interface EnumDef : TypedefDef {</blockquote>
</a><a name="2218">
<blockquote>	attribute EnumMemberSeq members;</blockquote>
</a><a name="2219">
<blockquote>    };</blockquote>
</a><a name="2220">
<blockquote></blockquote>
</a><a name="2221">
<blockquote></blockquote>
</a><a name="2222">
<blockquote></blockquote>
</a><a name="2223">
<blockquote>    interface AliasDef : TypedefDef {</blockquote>
</a><a name="2224">
<blockquote>	attribute IDLType original_type_def;</blockquote>
</a><a name="2225">
<blockquote>    };</blockquote>
</a><a name="2226">
<blockquote></blockquote>
</a><a name="2227">
<blockquote></blockquote>
</a><a name="2228">
<blockquote></blockquote>
</a><a name="2229">
<blockquote>    interface PrimitiveDef: IDLType {</blockquote>
</a><a name="2230">
<blockquote>	readonly attribute PrimitiveKind kind;</blockquote>
</a><a name="2231">
<blockquote>    };</blockquote>
</a><a name="2232">
<blockquote></blockquote>
</a><a name="2233">
<blockquote></blockquote>
</a><a name="2234">
<blockquote></blockquote>
</a><a name="2235">
<blockquote>    interface StringDef : IDLType {</blockquote>
</a><a name="2236">
<blockquote>	attribute unsigned long bound;</blockquote>
</a><a name="2237">
<blockquote>    };</blockquote>
</a><a name="2238">
<blockquote></blockquote>
</a><a name="2239">
<blockquote></blockquote>
</a><a name="2240">
<blockquote></blockquote>
</a><a name="2241">
<blockquote>    interface SequenceDef : IDLType {</blockquote>
</a><a name="2242">
<blockquote>	attribute unsigned long bound;</blockquote>
</a><a name="2243">
<blockquote>	readonly attribute TypeCode element_type;</blockquote>
</a><a name="2244">
<blockquote>	attribute IDLType element_type_def;</blockquote>
</a><a name="2245">
<blockquote>    };</blockquote>
</a><a name="2246">
<blockquote></blockquote>
</a><a name="2247">
<blockquote></blockquote>
</a><a name="2248">
<blockquote></blockquote>
</a><a name="2249">
<blockquote>    interface ArrayDef : IDLType {</blockquote>
</a><a name="2250">
<blockquote>	attribute unsigned long length;</blockquote>
</a><a name="2251">
<blockquote>	readonly attribute TypeCode element_type;</blockquote>
</a><a name="2252">
<blockquote>	attribute IDLType element_type_def;</blockquote>
</a><a name="2253">
<blockquote>    };</blockquote>
</a><a name="2254">
<blockquote></blockquote>
</a><a name="2255">
<blockquote></blockquote>
</a><a name="2256">
<blockquote></blockquote>
</a><a name="2257">
<blockquote>    interface ExceptionDef : Contained {</blockquote>
</a><a name="2258">
<blockquote>	readonly attribute TypeCode type;</blockquote>
</a><a name="2259">
<blockquote>	attribute StructMemberSeq members;</blockquote>
</a><a name="2260">
<blockquote>    };</blockquote>
</a><a name="2261">
<blockquote>    struct ExceptionDescription {</blockquote>
</a><a name="2262">
<blockquote>	Identifier name; </blockquote>
</a><a name="2263">
<blockquote>	RepositoryId id; </blockquote>
</a><a name="2264">
<blockquote>	RepositoryId defined_in; </blockquote>
</a><a name="2265">
<blockquote>	VersionSpec version;</blockquote>
</a><a name="2266">
<blockquote>	TypeCode type; </blockquote>
</a><a name="2267">
<blockquote>    };</blockquote>
</a><a name="2268">
<blockquote></blockquote>
</a><a name="2269">
<blockquote></blockquote>
</a><a name="2270">
<blockquote></blockquote>
</a><a name="2271">
<blockquote>    enum AttributeMode {ATTR_NORMAL, ATTR_READONLY};</blockquote>
</a><a name="2272">
<blockquote></blockquote>
</a><a name="2273">
<blockquote>    interface AttributeDef : Contained {</blockquote>
</a><a name="2274">
<blockquote>	readonly attribute TypeCode type;</blockquote>
</a><a name="2275">
<blockquote>	attribute IDLType type_def;</blockquote>
</a><a name="2276">
<blockquote>	attribute AttributeMode mode;</blockquote>
</a><a name="2277">
<blockquote>    };</blockquote>
</a><a name="2278">
<blockquote></blockquote>
</a><a name="2279">
<blockquote>    struct AttributeDescription {</blockquote>
</a><a name="2280">
<blockquote>	Identifier name; </blockquote>
</a><a name="2281">
<blockquote>	RepositoryId id; </blockquote>
</a><a name="2282">
<blockquote>	RepositoryId defined_in; </blockquote>
</a><a name="2283">
<blockquote>	VersionSpec version;</blockquote>
</a><a name="2284">
<blockquote>	TypeCode type;</blockquote>
</a><a name="2285">
<blockquote>	AttributeMode mode; </blockquote>
</a><a name="2286">
<blockquote>    };</blockquote>
</a><a name="2287">
<blockquote></blockquote>
</a><a name="2288">
<blockquote></blockquote>
</a><a name="2289">
<blockquote></blockquote>
</a><a name="2290">
<blockquote>    enum OperationMode {OP_NORMAL, OP_ONEWAY};</blockquote>
</a><a name="2291">
<blockquote></blockquote>
</a><a name="2292">
<blockquote>    enum ParameterMode {PARAM_IN, PARAM_OUT, PARAM_INOUT};</blockquote>
</a><a name="2293">
<blockquote>    struct ParameterDescription {</blockquote>
</a><a name="2294">
<blockquote>	Identifier name; </blockquote>
</a><a name="2295">
<blockquote>	TypeCode type; </blockquote>
</a><a name="2296">
<blockquote>	IDLType type_def;</blockquote>
</a><a name="2297">
<blockquote>	ParameterMode mode;</blockquote>
</a><a name="2298">
<blockquote>    };</blockquote>
</a><a name="2299">
<blockquote>    typedef sequence &lt;ParameterDescription&gt; ParDescriptionSeq;</blockquote>
</a><a name="2300">
<blockquote></blockquote>
</a><a name="2301">
<blockquote>    typedef Identifier ContextIdentifier;</blockquote>
</a><a name="2302">
<blockquote>    typedef sequence &lt;ContextIdentifier&gt; ContextIdSeq;</blockquote>
</a><a name="2303">
<blockquote></blockquote>
</a><a name="2304">
<blockquote>    typedef sequence &lt;ExceptionDef&gt; ExceptionDefSeq;</blockquote>
</a><a name="2305">
<blockquote>    typedef sequence &lt;ExceptionDescription&gt; ExcDescriptionSeq;</blockquote>
</a><a name="2306">
<blockquote></blockquote>
</a><a name="2307">
<blockquote>    interface OperationDef : Contained { </blockquote>
</a><a name="2308">
<blockquote>	readonly attribute TypeCode result;</blockquote>
</a><a name="2309">
<blockquote>	attribute IDLType result_def;</blockquote>
</a><a name="2310">
<blockquote>	attribute ParDescriptionSeq params;</blockquote>
</a><a name="2311">
<blockquote>	attribute OperationMode mode; </blockquote>
</a><a name="2312">
<blockquote>	attribute ContextIdSeq contexts;</blockquote>
</a><a name="2313">
<blockquote>	attribute ExceptionDefSeq exceptions;</blockquote>
</a><a name="2314">
<blockquote>    };</blockquote>
</a><a name="2315">
<blockquote></blockquote>
</a><a name="2316">
<blockquote>    struct OperationDescription {</blockquote>
</a><a name="2317">
<blockquote>	Identifier name; </blockquote>
</a><a name="2318">
<blockquote>	RepositoryId id; </blockquote>
</a><a name="2319">
<blockquote>	RepositoryId defined_in; </blockquote>
</a><a name="2320">
<blockquote>	VersionSpec version;</blockquote>
</a><a name="2321">
<blockquote>	TypeCode result; </blockquote>
</a><a name="2322">
<blockquote>	OperationMode mode; </blockquote>
</a><a name="2323">
<blockquote>	ContextIdSeq contexts; </blockquote>
</a><a name="2324">
<blockquote>	ParDescriptionSeq parameters;</blockquote>
</a><a name="2325">
<blockquote>	ExcDescriptionSeq exceptions;</blockquote>
</a><a name="2326">
<blockquote>    };</blockquote>
</a><a name="2327">
<blockquote></blockquote>
</a><a name="2328">
<blockquote></blockquote>
</a><a name="2329">
<blockquote></blockquote>
</a><a name="2330">
<blockquote>    typedef sequence &lt;RepositoryId&gt; RepositoryIdSeq;</blockquote>
</a><a name="2331">
<blockquote>    typedef sequence &lt;OperationDescription&gt; OpDescriptionSeq;</blockquote>
</a><a name="2332">
<blockquote>    typedef sequence &lt;AttributeDescription&gt; AttrDescriptionSeq;</blockquote>
</a><a name="2333">
<blockquote></blockquote>
</a><a name="2334">
<blockquote>    interface InterfaceDef : Container, Contained, IDLType {</blockquote>
</a><a name="2335">
<blockquote>	// read/write interface</blockquote>
</a><a name="2336">
<blockquote></blockquote>
</a><a name="2337">
<blockquote>	attribute InterfaceDefSeq base_interfaces;</blockquote>
</a><a name="2338">
<blockquote></blockquote>
</a><a name="2339">
<blockquote>	// read interface</blockquote>
</a><a name="2340">
<blockquote></blockquote>
</a><a name="2341">
<blockquote>	boolean is_a (in RepositoryId interface_id);</blockquote>
</a><a name="2342">
<blockquote></blockquote>
</a><a name="2343">
<blockquote>	struct FullInterfaceDescription {</blockquote>
</a><a name="2344">
<blockquote>	    Identifier name;</blockquote>
</a><a name="2345">
<blockquote>	    RepositoryId id;</blockquote>
</a><a name="2346">
<blockquote>	    RepositoryId defined_in;</blockquote>
</a><a name="2347">
<blockquote>	    VersionSpec version;</blockquote>
</a><a name="2348">
<blockquote>	    OpDescriptionSeq operations;</blockquote>
</a><a name="2349">
<blockquote>	    AttrDescriptionSeq attributes;</blockquote>
</a><a name="2350">
<blockquote>	    RepositoryIdSeq base_interfaces;</blockquote>
</a><a name="2351">
<blockquote>	    TypeCode type;</blockquote>
</a><a name="2352">
<blockquote>	};</blockquote>
</a><a name="2353">
<blockquote></blockquote>
</a><a name="2354">
<blockquote>	FullInterfaceDescription describe_interface();</blockquote>
</a><a name="2355">
<blockquote></blockquote>
</a><a name="2356">
<blockquote>	// write interface</blockquote>
</a><a name="2357">
<blockquote></blockquote>
</a><a name="2358">
<blockquote>	AttributeDef create_attribute (</blockquote>
</a><a name="2359">
<blockquote>	    in RepositoryId id,</blockquote>
</a><a name="2360">
<blockquote>	    in Identifier name,</blockquote>
</a><a name="2361">
<blockquote>	    in VersionSpec version,</blockquote>
</a><a name="2362">
<blockquote>	    in IDLType type,</blockquote>
</a><a name="2363">
<blockquote>	    in AttributeMode mode</blockquote>
</a><a name="2364">
<blockquote>	    );</blockquote>
</a><a name="2365">
<blockquote></blockquote>
</a><a name="2366">
<blockquote>	OperationDef create_operation (</blockquote>
</a><a name="2367">
<blockquote>	    in RepositoryId id,</blockquote>
</a><a name="2368">
<blockquote>	    in Identifier name,</blockquote>
</a><a name="2369">
<blockquote>	    in VersionSpec version,</blockquote>
</a><a name="2370">
<blockquote>	    in IDLType result,</blockquote>
</a><a name="2371">
<blockquote>	    in OperationMode mode, </blockquote>
</a><a name="2372">
<blockquote>	    in ParDescriptionSeq params,</blockquote>
</a><a name="2373">
<blockquote>	    in ExceptionDefSeq exceptions,</blockquote>
</a><a name="2374">
<blockquote>	    in ContextIdSeq contexts</blockquote>
</a><a name="2375">
<blockquote>	    );</blockquote>
</a><a name="2376">
<blockquote>    };</blockquote>
</a><a name="2377">
<blockquote></blockquote>
</a><a name="2378">
<blockquote>    struct InterfaceDescription {</blockquote>
</a><a name="2379">
<blockquote>	Identifier name; </blockquote>
</a><a name="2380">
<blockquote>	RepositoryId id; </blockquote>
</a><a name="2381">
<blockquote>	RepositoryId defined_in; </blockquote>
</a><a name="2382">
<blockquote>	VersionSpec version;</blockquote>
</a><a name="2383">
<blockquote>	RepositoryIdSeq base_interfaces;</blockquote>
</a><a name="2384">
<blockquote>    };</blockquote>
</a><a name="2385">
<blockquote></blockquote>
</a><a name="2386">
<blockquote></blockquote>
</a><a name="2387">
<blockquote></blockquote>
</a><a name="2388">
<blockquote>    enum TCKind { </blockquote>
</a><a name="2389">
<blockquote>	tk_null, tk_void, </blockquote>
</a><a name="2390">
<blockquote>	tk_short, tk_long, tk_ushort, tk_ulong, </blockquote>
</a><a name="2391">
<blockquote>	tk_float, tk_double, tk_boolean, tk_char, </blockquote>
</a><a name="2392">
<blockquote>	tk_octet, tk_any, tk_TypeCode, tk_Principal, tk_objref, </blockquote>
</a><a name="2393">
<blockquote>	tk_struct, tk_union, tk_enum, tk_string, </blockquote>
</a><a name="2394">
<blockquote>	tk_sequence, tk_array, tk_alias, tk_except</blockquote>
</a><a name="2395">
<blockquote>    };</blockquote>
</a><a name="2396">
<blockquote></blockquote>
</a><a name="2397">
<blockquote>    interface TypeCode { // PIDL</blockquote>
</a><a name="2398">
<blockquote>	exception Bounds {};</blockquote>
</a><a name="2399">
<blockquote>	exception BadKind {};</blockquote>
</a><a name="2400">
<blockquote></blockquote>
</a><a name="2401">
<blockquote>	// for all TypeCode kinds</blockquote>
</a><a name="2402">
<blockquote>	boolean equal (in TypeCode tc);</blockquote>
</a><a name="2403">
<blockquote>	TCKind kind ();</blockquote>
</a><a name="2404">
<blockquote></blockquote>
</a><a name="2405">
<blockquote>	// for tk_objref, tk_struct, tk_union, tk_enum, tk_alias, and tk_except</blockquote>
</a><a name="2406">
<blockquote>	RepositoryId id () raises (BadKind);</blockquote>
</a><a name="2407">
<blockquote></blockquote>
</a><a name="2408">
<blockquote>	// for tk_objref, tk_struct, tk_union, tk_enum, tk_alias, and tk_except</blockquote>
</a><a name="2409">
<blockquote>	Identifier name () raises (BadKind);</blockquote>
</a><a name="2410">
<blockquote></blockquote>
</a><a name="2411">
<blockquote>	// for tk_struct, tk_union, tk_enum, and tk_except</blockquote>
</a><a name="2412">
<blockquote>	unsigned long member_count () raises (BadKind);</blockquote>
</a><a name="2413">
<blockquote>	Identifier member_name (in unsigned long index) raises (BadKind, Bounds);</blockquote>
</a><a name="2414">
<blockquote></blockquote>
</a><a name="2415">
<blockquote>	// for tk_struct, tk_union, and tk_except</blockquote>
</a><a name="2416">
<blockquote>	TypeCode member_type (in unsigned long index) raises (BadKind, Bounds);</blockquote>
</a><a name="2417">
<blockquote></blockquote>
</a><a name="2418">
<blockquote>	// for tk_union</blockquote>
</a><a name="2419">
<blockquote>	any member_label (in unsigned long index) raises (BadKind, Bounds);</blockquote>
</a><a name="2420">
<blockquote>	TypeCode discriminator_type () raises (BadKind);</blockquote>
</a><a name="2421">
<blockquote>	long default_index () raises (BadKind); </blockquote>
</a><a name="2422">
<blockquote></blockquote>
</a><a name="2423">
<blockquote>	// for tk_string, tk_sequence, and tk_array</blockquote>
</a><a name="2424">
<blockquote>	unsigned long length () raises (BadKind);</blockquote>
</a><a name="2425">
<blockquote></blockquote>
</a><a name="2426">
<blockquote>	// for tk_sequence, tk_array, and tk_alias</blockquote>
</a><a name="2427">
<blockquote>	TypeCode content_type () raises (BadKind);</blockquote>
</a><a name="2428">
<blockquote></blockquote>
</a><a name="2429">
<blockquote>	// deprecated interface</blockquote>
</a><a name="2430">
<blockquote>	long param_count (); </blockquote>
</a><a name="2431">
<blockquote>	any parameter (in long index) raises (Bounds); </blockquote>
</a><a name="2432">
<blockquote>    };</blockquote>
</a><a name="2433">
<blockquote></blockquote>
</a><a name="2434">
<blockquote></blockquote>
</a><a name="2435">
<blockquote></blockquote>
</a><a name="2436">
<blockquote>    interface ORB {</blockquote>
</a><a name="2437">
<blockquote>	// other operations ...</blockquote>
</a><a name="2438">
<blockquote></blockquote>
</a><a name="2439">
<blockquote>	TypeCode create_struct_tc (</blockquote>
</a><a name="2440">
<blockquote>	    in RepositoryId id,</blockquote>
</a><a name="2441">
<blockquote>	    in Identifier name,</blockquote>
</a><a name="2442">
<blockquote>	    in StructMemberSeq members</blockquote>
</a><a name="2443">
<blockquote>	    );</blockquote>
</a><a name="2444">
<blockquote></blockquote>
</a><a name="2445">
<blockquote>	TypeCode create_union_tc (</blockquote>
</a><a name="2446">
<blockquote>	    in RepositoryId id,</blockquote>
</a><a name="2447">
<blockquote>	    in Identifier name,</blockquote>
</a><a name="2448">
<blockquote>	    in TypeCode discriminator_type,</blockquote>
</a><a name="2449">
<blockquote>	    in UnionMemberSeq members</blockquote>
</a><a name="2450">
<blockquote>	    );</blockquote>
</a><a name="2451">
<blockquote></blockquote>
</a><a name="2452">
<blockquote>	TypeCode create_enum_tc (</blockquote>
</a><a name="2453">
<blockquote>	    in RepositoryId id,</blockquote>
</a><a name="2454">
<blockquote>	    in Identifier name,</blockquote>
</a><a name="2455">
<blockquote>	    in EnumMemberSeq members</blockquote>
</a><a name="2456">
<blockquote>	    );</blockquote>
</a><a name="2457">
<blockquote></blockquote>
</a><a name="2458">
<blockquote>	TypeCode create_alias_tc (</blockquote>
</a><a name="2459">
<blockquote>	    in RepositoryId id,</blockquote>
</a><a name="2460">
<blockquote>	    in Identifier name,</blockquote>
</a><a name="2461">
<blockquote>	    in TypeCode original_type</blockquote>
</a><a name="2462">
<blockquote>	    );</blockquote>
</a><a name="2463">
<blockquote></blockquote>
</a><a name="2464">
<blockquote>	TypeCode create_exception_tc (</blockquote>
</a><a name="2465">
<blockquote>	    in RepositoryId id,</blockquote>
</a><a name="2466">
<blockquote>	    in Identifier name,</blockquote>
</a><a name="2467">
<blockquote>	    in StructMemberSeq members</blockquote>
</a><a name="2468">
<blockquote>	    );</blockquote>
</a><a name="2469">
<blockquote></blockquote>
</a><a name="2470">
<blockquote>	TypeCode create_interface_tc (</blockquote>
</a><a name="2471">
<blockquote>	    in RepositoryId id,</blockquote>
</a><a name="2472">
<blockquote>	    in Identifier name</blockquote>
</a><a name="2473">
<blockquote>	    );</blockquote>
</a><a name="2474">
<blockquote></blockquote>
</a><a name="2475">
<blockquote>	TypeCode create_string_tc (</blockquote>
</a><a name="2476">
<blockquote>	    in unsigned long bound</blockquote>
</a><a name="2477">
<blockquote>	    );</blockquote>
</a><a name="2478">
<blockquote></blockquote>
</a><a name="2479">
<blockquote>	TypeCode create_sequence_tc (</blockquote>
</a><a name="2480">
<blockquote>	    in unsigned long bound,</blockquote>
</a><a name="2481">
<blockquote>	    in TypeCode element_type</blockquote>
</a><a name="2482">
<blockquote>	    );</blockquote>
</a><a name="2483">
<blockquote></blockquote>
</a><a name="2484">
<blockquote>	TypeCode create_recursive_sequence_tc (</blockquote>
</a><a name="2485">
<blockquote>	    in unsigned long bound,</blockquote>
</a><a name="2486">
<blockquote>	    in unsigned long offset</blockquote>
</a><a name="2487">
<blockquote>	    );</blockquote>
</a><a name="2488">
<blockquote></blockquote>
</a><a name="2489">
<blockquote>	TypeCode create_array_tc (</blockquote>
</a><a name="2490">
<blockquote>	    in unsigned long length,</blockquote>
</a><a name="2491">
<blockquote>	    in TypeCode element_type</blockquote>
</a><a name="2492">
<blockquote>	    );</blockquote>
</a><a name="2493">
<blockquote>    };</blockquote>
</a><a name="2494">
 };<p>
</a><a name="1939">
<p>
</a>
<hr><br>
 
<a href="cover.html">[Top]</a> <a href="dynskel.html">[Prev]</a> <a href="orbif2.html">[Next]</a> <a href="corb2pra.html">[Bottom]</a>
<hr><br>
 


<address>
<a href="mailto:pubs@omg.org">pubs@omg.org</a>
</address>

<i>Copyright &#169; 1995, <a href="http://www.omg.org">Object Management Group.</a>  All rights
reserved.</i>

<!-- This file was created with Quadralay WebWorks Publisher 3.0.4 -->
<!-- -->
<!-- For more information on how this document, and how the rest of -->
<!-- this server was created, email pubs@omg.org -->
<!-- -->
<!-- Last updated: 06/10/96 08:48:09 -->

</body>
</html>
