<html><head><title></title></head>
<body bgcolor=#ffffff>
 
<a href="cover.html">[Top]</a> <a href="plusov.html">[Prev]</a> <a href="pluspo.html">[Next]</a> <a href="corb2pra.html">[Bottom]</a>
<hr><br>
 
<a name="513076">
<h1> Mapping of OMG IDL  to C++ </h1>
</a><dl>
<p align=right clear=all>
<b><font size=7>
16 
</font></b>
</p>
<hr></dl>
<a name="513077">
<img src="local/images/pluscona.gif">This chapter explains how OMG IDL constructs are mapped to the constructs of the C++ programming language.  It provides mapping information for:<p>
</a><ul><a name="512647">
<li>Interfaces
</a><a name="510035">
<li>Constants
</a><a name="512657">
<li>Basic data types
</a><a name="512668">
<li>Enums
</a><a name="512670">
<li>Types (string, structure, struct, union, sequence, array, typedefs, any, exception)
</a><a name="512693">
<li>Operations and attributes
</a><a name="512669">
<li>Arguments
</a></ul><a name="512697">
<h1>	16.1	 Preliminary Information</h1>
</a><a name="510037">
<h2>	16.1.1	 Scoped Names</h2>
</a><a name="510038">
<img src="local/images/pluscoa1.gif">Scoped names in OMG IDL are specified by C++ scopes:<p>
</a><ul><a name="510039">
<li>OMG IDL modules are mapped to C++ namespaces.
</a><a name="510043">
<li>OMG IDL interfaces are mapped to C++ classes (as described in <a href="pluscon.html#510119">Section &#32;16.3, "Mapping for Interfaces," on page &#32;16-3</a>).
</a><a name="510045">
<li>All OMG IDL constructs scoped to an interface are accessed via C++ scoped names. For example, if a type <strong>mode</strong> were defined in interface <strong>printer</strong> then the type would be referred to as printer::mode.
</a><a name="510046">
<img src="local/images/pluscoa2.gif">These mappings allow the corresponding mechanisms in OMG IDL and C++ to be used to build scoped names. For instance:<p>
</a><a name="510047">
 // IDL<p>
</a><a name="510048">
<blockquote>module M </blockquote>
</a><a name="510049">
<blockquote>{</blockquote>
</a><a name="510050">
<blockquote>						struct E {</blockquote>
</a><a name="510051">
<blockquote>							long L;</blockquote>
</a><a name="510052">
<blockquote>						};</blockquote>
</a><a name="510053">
 };<p>
</a><a name="510054">
is mapped into:<p>
</a><a name="510055">
 // C++<br>namespace M<br>{<br>						struct E {<br>							Long L;	<br>						};<p>
</a><a name="510059">
 }<p>
</a><a name="510061">
and E can be referred outside of M as M::E. Alternatively, a C++ using statement for namespace M can be used so that E can be referred to simply as E:<p>
</a><a name="510062">
 // C++<br>using namespace M;<br>E e;<br>e.L = 3;<p>
</a><a name="510067">
<img src="local/images/pluscoa3.gif">Another alternative is to employ a using statement only for M::E:<p>
</a><a name="510068">
 // C++<br>using M::E;<br>E e;<br>e.L = 3;<p>
</a><a name="510074">
<img src="local/images/pluscoa4.gif">To avoid C++ compilation problems, every use in OMG IDL of a C++ keyword as an identifier is mapped into the same name preceded by an underscore. The list of C++ keywords from the 05/27/94 working draft of the ANSI/ISO C++ standardization committees (X3J16, WG21) can be found in <a href="94-9-14/pluskey.html#">Appendix C</a>.<p>
</a></ul><a name="510078">
<h2>	16.1.2	 C++ Type Size Requirements</h2>
</a><a name="510083">
 <img src="local/images/pluscoa5.gif">The sizes of the C++ types used to represent OMG IDL types are implementation-dependent. That is, this mapping makes no requirements as to the sizeof(T) for anything except basic types (see <a href="pluscon.html#510355">Section &#32;16.5, "Mapping for Basic Data Types," on page &#32;16-10</a>) and string (see <a href="pluscon.html#510473">Section &#32;16.7, "Mapping For String Types," on page &#32;16-11</a>).<p>
</a><a name="510092">
<h2>	16.1.3	 CORBA Module</h2>
</a><a name="514152">
<img src="local/images/pluscoa6.gif">The mapping relies on some predefined types, classes, and functions that are logically defined in a module named <strong>CORBA. The module</strong> is automatically accessible from a C++ compilation unit that includes a header file generated from an OMG IDL specification. In the examples presented in this document, CORBA definitions are referenced without explicit qualification for simplicity. In practice, fully scoped names or C++ using statements for the CORBA namespace would be required in the application source. Appendix A contains standard OMG IDL types.<p>
</a><a name="514160">
<h1>	16.2	 Mapping for Modules</h1>
</a><a name="510106">
 <img src="local/images/pluscoa7.gif">A shown in <a href="pluscon.html#510037">Section &#32;16.1.1, "Scoped Names," on page &#32;16-1</a>, a module defines a scope, and as such is mapped to a C++ namespace with the same name:<p>
</a><a name="510107">
<blockquote>// IDL<br>module M<br>{<br>						// definitions<br>};</blockquote>
</a><a name="516157">
 // C++<br>namespace M<br>{<br>	// definitions<br>}<p>
</a><a name="510114">
<img src="local/images/pluscoa8.gif">Because namespaces were only recently added to the C++ language, few C++ compilers currently support them. Alternative mappings for OMG IDL modules that do not require C++ namespaces are in the Appendix "Alternative Mappings for C++ Dialects."<p>
</a><a name="510119">
<h1>	16.3	 Mapping for Interfaces</h1>
</a><a name="510125">
 <img src="local/images/pluscoa9.gif">An interface is mapped to a C++ class that contains public definitions of the types, constants, operations, and exceptions defined in the interface.<p>
</a><a name="510131">
<img src="local/images/plusca10.gif">A CORBA-C++-compliant program cannot<p>
</a><ul><a name="510132">
<li>Create or hold an instance of an interface class
</a><a name="510134">
<li>Use a pointer (A*) or a reference (A&amp;) to an interface class.
</a><a name="510139">
<img src="local/images/plusca11.gif">The reason for these restrictions is to allow a wide variety of implementations. For example, interface classes could not be implemented as abstract base classes if programs were allowed to create or hold instances of them. In a sense, the generated class is like a namespace that one cannot enter via a using statement. This example shows the behavior of the mapping of an interface:<p>
</a><a name="510142">
<blockquote>// IDL<br>interface A<br>{<br>						struct S { short field; };<br>};</blockquote>
</a><a name="510143">
 <p>
</a><a name="516593">
 // C++<br>// Conformant uses<br>A::S s; // declare a struct variable<br>s.field = 3; // field access<br><br>// Non-conformant uses:<br>// one cannot declare an instance of an interface class...<br>A a;<br>// ...nor declare a pointer to an interface class...<br>A *p;<br>// ...nor declare a reference to an interface class.<br>void f(A &amp;r);<p>
</a></ul><a name="510146">
<h2>	16.3.1	 Object Reference Types</h2>
</a><a name="510153">
 <img src="local/images/plusca12.gif">The use of an interface type in OMG IDL denotes an object reference. Because of the different ways an object reference can be used and the different possible implementations in C++, an object reference maps to two C++ types. For an interface <strong>A</strong>, these types are named A_var and A_ptr. For historical reasons, the type ARef is defined as a synonym for A_ptr, but usage of the Ref names is deprecated. These types need not be distinct-A_var may be identical to A_ptr, for example-so a compliant program cannot overload operations using these types solely.<p>
</a><a name="510162">
<img src="local/images/plusca13.gif">An operation can be performed on an object by using an arrow ("-&gt;") on a reference to the object. For example, if an interface defines an operation op with no parameters and obj is a reference to the interface type, then a call would be written obj-&gt;op(). The arrow operator is used to invoke operations on both the _ptr and _var object reference types.<p>
</a><a name="510169">
<img src="local/images/plusca14.gif">Client code frequently will use the object reference variable type (A_var) because a variable will automatically release its object reference when it is deallocated or when assigned a new object reference. The pointer type (A_ptr) provides a more primitive object reference, which has similar semantics to a C++ pointer. Indeed, an implementation may choose to define A_ptr as A*, but is not required to. Unlike C++ pointers, however, conversion to void*, arithmetic operations, and relational operations, including test for equality, are all non-coompliant. A compliant implementation need not detect these incorrect uses because requiring detection is not practical.<p>
</a><a name="510182">
<img src="local/images/plusca15.gif">For many operations, mixing data of type A_var and A_ptr is possible without any explicit operations or casts. However, one needs to be careful in doing so because of the implicit release performed when the variable is deallocated. For example, the assignment statement in the code below will result in the object reference held by p to be released at the end of the block containing the declaration of a.<p>
</a><a name="510184">
 // C++<br>A_var a;<br>A_ptr p = // ...somehow obtain an objref...<br>a = p;<p>
</a><a name="510186">
<h2>	16.3.2	 Widening Object References</h2>
</a><a name="510192">
 <img src="local/images/plusca16.gif">OMG IDL interface inheritance does not require that the corresponding C++ classes are related, though that is certainly one possible implementation. However, if interface B inherits from interface A, the following implicit widening operations for B must be supported by a compliant implementation:<p>
</a><ul><a name="510194">
<li>B_ptr to A_ptr
</a><a name="510195">
<li>B_ptr to Object_ptr
</a><a name="510196">
<li>B_var to A_ptr
</a><a name="510197">
<li>B_var to Object_ptr
</a><a name="510202">
<img src="local/images/plusca17.gif">Implicit widening from a B_var to A_var or Object_var need not be supported; instead, widening between _var types for object references requires a call to _duplicate (described in <a href="pluscon.html#510216">Section &#32;16.3.3, "Object Reference Operations," on page &#32;16-5</a>).<a href="#510209"><sup>1</sup></a> An attempt to implicitly widen from one _var type to another must cause a compile-time error.<a href="#510213"><sup>2</sup></a> Assignment between two _var objects of the same type is supported, but widening assignments are not and must cause a compile-time error. Widening assignments may be done using _duplicate.<p>
</a><a name="510214">
 // C++<br>B_ptr bp = ...<br>A_ptr ap = bp;							// implicit widening<br>Object_ptr objp = bp;	// implicit widening<br>objp = ap;							// implicit widening<br><br>B_var bv = bp;							// bv assumes ownership of bp<br>ap = bv;							// implicit widening, bv retains ownership 				// of bp<br>obp = bv;							// implicit widening, bv retains ownership 				// of bp<br><br>A_var av = bv;							// illegal, compile-time error<br>A_var av = B::_duplicate(bv);	// av and bv both refer to bp<br>B_var bv2 = bv;			// implicit _duplicate<br>A_var av2;<br>av2 = av;			// implicit _duplicate<p>
</a></ul><a name="510216">
<h2>	16.3.3	 Object Reference Operations</h2>
</a><a name="510224">
 <img src="local/images/plusca18.gif">Conceptually, the <strong>Object</strong> class in the <strong>CORBA</strong> module is the base interface type for all CORBA objects. Any object reference can therefore be widened to the type Object_ptr. As with other interfaces, the CORBA namespace also defines the type Object_var.<p>
</a><a name="510233">
<img src="local/images/plusca19.gif">CORBA defines three operations on any object reference:<strong>duplicate</strong>, <strong>release</strong>, and <strong>is_nil</strong>. Note that these are operations on the object reference, not the object implementation. Because the mapping does not require object references to themselves be C++ objects, the "-&gt;" syntax cannot be employed to express the usage of these operations. Also, for convenience these operations are allowed to be performed on a nil object reference.<p>
</a><a name="510241">
<img src="local/images/plusca20.gif">The <strong>release</strong> and <strong>is_nil</strong> operations depend only on type <strong>Object</strong>, so they can be expressed as regular functions within the CORBA namespace as follows:<p>
</a><a name="510242">
 // C++<br>void release(Object_ptr obj);<br>Boolean is_nil(Object_ptr obj);<p>
</a><a name="510247">
<img src="local/images/plusca21.gif">The release operation indicates that the caller will no longer access the reference so that associated resources may be deallocated. If the given object reference is nil, release does nothing. The is_nil operation returns TRUE if the object reference contains the special value for a nil object reference as defined by the ORB. Neither the release operation nor the is_nil operation may throw CORBA exceptions.<p>
</a><a name="510253">
<img src="local/images/plusca22.gif">The <strong>duplicate</strong> operation returns a new object reference with the same static type as the given reference. The mapping for an interface therefore includes a static member function named  _duplicate in the generated class. For  example:<p>
</a><a name="510255">
<blockquote>// IDL<br>interface A { };</blockquote>
</a><a name="510257">
 // C++<br>class A<br>{<br> &#32; &#32;public:<br>	static A_ptr _duplicate(A_ptr obj);<br>};<p>
</a><a name="510262">
<img src="local/images/plusca23.gif">If the given object reference is nil, _duplicate will return a nil object reference. The _duplicate operation can throw CORBA system exceptions.<p>
</a><a name="510268">
<h2>	16.3.4	 Narrowing Object References</h2>
</a><a name="510273">
 <img src="local/images/plusca24.gif">The mapping for an interface defines a static member function named _narrow that returns a new object reference given an existing reference. Like _duplicate, the _narrow function returns a nil object reference if the given reference is nil. Unlike _duplicate, the parameter to _narrow is a reference of an object of any interface type (Object_ptr). If the actual (runtime) type of the parameter object can be widened to the requested interface's type, then _narrow will return a valid object reference. Otherwise, _narrow will return a nil object reference. For example, suppose A, B, C, and D are interface types, and D inherits from C, which inherits from B, which in turn inherits from A. If an object reference to a C object is widened to an A_ptr variable called ap, the<p>
</a><ul><a name="516404">
<li>A::_narrow(ap) returns a valid object reference;
</a><a name="516412">
<li>B::_narrow(ap) returns a valid object reference;
</a><a name="516416">
<li>C::_narrow(ap) returns a valid object reference;
</a><a name="516410">
<li>D::_narrow(ap) returns a nil object reference.
</a><a name="516419">
Narrowing to A, B, and C all succeed because the object supports all those interfaces. The D::_narrow returns a nil object reference because the object does not support the D interface.<p>
</a><a name="510279">
<img src="local/images/plusca25.gif">If successful, the _narrow function creates a new object reference and does not consume the given object reference, so the caller is responsible for releasing both the original and new references.<p>
</a><a name="510284">
<img src="local/images/plusca26.gif">For example, suppose A, B, C, and D are interface types. C inherits from B, and both B and D inherit from A. Now suppose that an object of type C is passed to a function as an A. If the function calls B::_narrow or C::_narrow, a new object reference will be returned. A call to D::_narrow will fail and return nil.<p>
</a><a name="516749">
<img src="local/images/plusca27.gif">The _narrow operation can throw CORBA system exceptions.<p>
</a></ul><a name="510285">
<h2>	16.3.5	 Nil Object Reference</h2>
</a><a name="510291">
 <img src="local/images/plusca28.gif">The mapping for an interface defines a static member function named  _nil that returns a nil object reference of that interface type. For each interface A, the following call is guaranteed to return TRUE:<p>
</a><a name="516448">
 // C++<br>Boolean true_result = is_nil(A::_nil());<p>
</a><a name="516453">
<img src="local/images/plusca29.gif">A compliant application need not call release on the object reference returned from the _nil function.<p>
</a><a name="510306">
<img src="local/images/plusca30.gif">As described in <a href="pluscon.html#510146"> Section 16.3.1</a>, object references may not be compared using operator==, so is_nil is the only compliant way an object reference can be checked to see if it is nil.<p>
</a><a name="516731">
<img src="local/images/plusca31.gif">The _nil function may not throw any CORBA exceptions.<p>
</a><a name="516887">
<img src="local/images/plusca32.gif">A compliant program cannot attempt to invoke an operation through a nil object reference, since a valid C++ implementation of a nil object reference is a null pointer.<p>
</a><a name="510307">
<h2>	16.3.6	 Interface Mapping Example</h2>
</a><a name="510313">
 <img src="local/images/plusca33.gif">The example below shows one possible mapping for an interface. Other mappings are also possible, but they must provide the same semantics and usage as this example.<p>
</a><a name="510314">
<blockquote>// IDL<br>interface A<br>{<br>&#32;A op(in A param);<br>};</blockquote>
</a><a name="516152">
 // C++<br>class A;<br>typedef A *A_ptr;<br>typedef A_ptr ARef;<br>class A : public virtual Object<br>{<br> &#32; &#32;public:<br>	static A_ptr _duplicate(A_ptr obj);<br>	static A_ptr _narrow(Object_ptr obj);<br>	static A_ptr _nil();<br><br>	virtual A_ptr op(A_ptr param) = 0;<br><br> &#32; &#32;protected:<br>	A();<br>	virtual ~A();<br><br> &#32; &#32;private:<br>	A(const A&amp;);<br>	void operator=(const A&amp;);<br>};<p>
</a><a name="510317">
 class A_var : public _var<br>{<br>  public:<br>	A_var() : ptr_(A::_nil()) {}<br>	A_var(A_ptr p) : ptr_(p) {}<br>	A_var(const A_var &amp;a) : ptr_(A::_duplicate(A_ptr(a))) {}<br>	~A_var() { free(); }<br><br>	A_var &amp;operator=(A_ptr p) {<br>		reset(p); return *this;<br>	}<br><br>	operator const A_ptr&amp;() const { return ptr_; }<br>	operator A_ptr&amp;() { return ptr_; }<br>	A_ptr operator-&gt;() const { return ptr_; }<br><br> &#32; &#32;protected:<br>	A_ptr ptr_;<br>	void free() { release(ptr_); }<br>	void reset(A_ptr p) { free(); ptr_ = p; }<br><br> &#32; &#32;private:<br>	// hidden assignment operators for var types to<br>	// fulfill the rules specified in<a href="pluscon.html#510186"> Section 16.3.2</a><br>	void operator=(const A_var &amp;);<br>	void operator=(const _var &amp;);<br>};<p>
</a><a name="510329">
<h1>	16.4	 Mapping for Constants</h1>
</a><a name="510335">
 <img src="local/images/plusca34.gif">OMG  IDL constants are mapped directly to a C++ constant definition that may or may not define storage depending on the scope of the declaration. In the example below, a top-level IDL constant maps to a file-scope C++ constant whereas a nested constant maps to a class-scope C++ constant. This inconsistency occurs because C++ file-scope constants may not require storage (or the storage may be replicated in each compilation unit), while class-scope constants always take storage. As a side effect, this difference means that the generated C++ header file might not contain values for constants defined in the OMG IDL file.<p>
</a><a name="510338">
<blockquote>// IDL<br>const string name = "testing";<br><br>interface A<br>{<br>						const float pi = 3.14159;<br>};</blockquote>
</a><a name="516143">
 // C++<br>static const char *const name = "testing";<br><br>class A<br>{<br> &#32; &#32;public:<br>	static const Float pi;<br>};<p>
</a><a name="510346">
<img src="local/images/plusca35.gif">In certain situations, use of a constant in OMG IDL must generate the constant's value instead of the constant's name.<a href="#510350"><sup>3</sup></a> For example,<p>
</a><a name="510351">
<blockquote>// IDL<br>interface A<br>{<br>						const long n = 10;<br>						typedef long V[n];<br>};</blockquote>
</a><a name="516138">
 // C++<br>class A<br>{<br> &#32; &#32;public:<br>	static const long n;<br>	typedef long V[10];<br>};<p>
</a><a name="510355">
<h1>	16.5	 Mapping for Basic Data Types</h1>
</a><a name="510363">
 <img src="local/images/plusca36.gif">The basic data types have the mappings shown in <a href="pluscon.html#510363">Table 23 on page 16-10</a>. Note that the mapping of the OMG IDL <strong>boolean</strong> type defines only the values 1 (TRUE) and 0 (FALSE); other values produce undefined behavior.  
<Table Border="3">
<caption><a name="510373">
TABLE 23.  Basic Data Type Mappings<p>
</a></caption>
<tr><th><a name="510377">
 OMG IDL<p>
</a><th><a name="510379">
 C++<p>
</a>
<tr><td><a name="510381">
 short<p>
</a><td><a name="510384">
 CORBA::Short<p>
</a>
<tr><td><a name="510386">
 long<p>
</a><td><a name="510389">
 CORBA::Long<p>
</a>
<tr><td><a name="510391">
 unsigned short<p>
</a><td><a name="510394">
 CORBA::UShort<p>
</a>
<tr><td><a name="510396">
 unsigned long<p>
</a><td><a name="510399">
 CORBA::ULong<p>
</a>
<tr><td><a name="510401">
 float<p>
</a><td><a name="510404">
 CORBA::Float<p>
</a>
<tr><td><a name="510406">
 double<p>
</a><td><a name="510409">
 CORBA::Double<p>
</a>
<tr><td><a name="510411">
 char<p>
</a><td><a name="510414">
 CORBA::Char<p>
</a>
<tr><td><a name="510416">
 boolean<p>
</a><td><a name="510419">
 CORBA::Boolean<p>
</a>
<tr><td><a name="510421">
 octet<p>
</a><td><a name="510424">
 CORBA::Octet<p>
</a>

</Table>

<Table>
<tr><td>
</Table>
<p>
</a><a name="510429">
<img src="local/images/plusca37.gif">Each OMG IDL basic type is mapped to a typedef in the CORBA module. This is because some types, such as short and long, may have different representations on different platforms, and the CORBA definitions will reflect the appropriate representation. For example, on a 64-bit machine where a long integer is 64 bits, the definition of CORBA::Long would still refer to a 32-bit integer. Requirements for the sizes of basic types are shown  in <a href="idlsyn.html#512">Section &#32;3.8.1, "Basic Types," on page &#32;3-20</a>.<p>
</a><a name="510439">
<img src="local/images/plusca38.gif">Except for <strong>boolean</strong>, <strong>char</strong>, and <strong>octet</strong>, the mappings for basic types must be distinguishable from each other for the purposes of overloading. That is, one can safely write overloaded C++ functions on Short, UShort, Long, ULong, Float, and Double.<p>
</a><a name="510451">
<img src="local/images/plusca39.gif">Programmers concerned with portability should use the CORBA types. However, some may feel that using these types with the CORBA qualification impairs readability. If the <strong>CORBA</strong> module is mapped to a namespace, a C++ using statement may help this problem. On platforms where the C++ data type is guaranteed to be identical to the OMG IDL data type, a compliant implementation therefore may generate the native C++ type.<p>
</a><a name="510456">
<img src="local/images/plusca40.gif">For the Boolean type, only the values 1 (representing <strong>TRUE</strong>) and 0 (representing <strong>FALSE</strong>) are defined; other values produce undefined behavior. Since many existing C++ software packages and libraries already provide their own preprocessor macro definitions of TRUE and FALSE, this mapping does not require that such definitions be provided by a compliant implementation. Requiring definitions for TRUE and FALSE could cause compilation problems for CORBA applications that make use of such packages and libraries. Instead, we recommend that compliant applications simply use the values 1 and 0 directly.<a href="#510459"><sup>4</sup></a> Alternatively, for those C++ compilers that support the new bool type, the keywords true and false may be used.<p>
</a><a name="510460">
<h1>	16.6	 Mapping for Enums</h1>
</a><a name="510466">
 <img src="local/images/plusca41.gif">An OMG IDL <strong>enum</strong> maps directly to the corresponding C++ type definition. The only difference is that the generated C++ type may need an additional constant that is large enough to force the C++ compiler to use exactly 32 bits for values declared to be of the enumerated type.<p>
</a><a name="510470">
<blockquote>// IDL<br>enum Color { red, green, blue };</blockquote>
</a><a name="516133">
 // C++<br>enum Color { red, green, blue };<p>
</a><a name="510473">
<h1>	16.7	 Mapping For String Types</h1>
</a><a name="513151">
 <img src="local/images/plusca42.gif">As in the C mapping, the OMG IDL string type, whether bounded or unbounded, is mapped to char* in C++. String data is null-terminated. In addition, the <strong>CORBA</strong> module defines a class String_var that contains a char* value and automatically frees the pointer when a String_var object is deallocated. When a String_var is constructed or assigned from a char*, the char* is consumed and thus the string data may no longer be accessed through it by the caller. Assignment or construction from a const char* or from another String_var causes a copy. The String_var class also provides operations to convert to and from char* values, as well as subscripting operations to access characters within the string. The full definition of the String_var interface is given in <a href="plusdef.html#85">"String_var Class" on page &#32;C-2</a>.<p>
</a><a name="513158">
<img src="local/images/plusca43.gif">Because its mapping is char*, the OMG IDL string type is the only non-basic type for which this mapping makes size requirements.<p>
</a><a name="510495">
<img src="local/images/plusca44.gif">For dynamic allocation of strings, compliant programs must use the following functions from the CORBA namespace:<p>
</a><a name="510496">
 // C++<br>namespace CORBA {<br>	char *string_alloc(ULong len);<br>	char *string_dup(const char*);<br>	void string_free(char *);<br>	...<br>}<p>
</a><a name="510501">
<img src="local/images/plusca45.gif">The string_alloc function dynamically allocates a string, or returns a null pointer if it cannot perform the allocation. It allocates len+1 characters so that the resulting string has enough space to hold a trailing NUL character. The string_dup function dynamically allocates enough space to hold a copy of its string argument, including the NUL character, copies its string argument into that memory, and returns a pointer to the new string. If allocation fails, a null pointer is returned. The string_free function deallocates a string that was allocated with string_alloc or string_dup. Passing a null pointer to string_free is acceptable and results in no action being performed. These functions allow ORB implementations to use special memory management mechanisms for strings if necessary, without forcing them to replace global operator new and operator new[].<p>
</a><a name="516766">
<img src="local/images/plusca46.gif">The string_alloc, string_dup, and string_free functions may not throw CORBA exceptions.<p>
</a><a name="518936">
<img src="local/images/plusca47.gif">Note that a static array of char in C++ decays to a char*, so care must be taken when assigning one to a String_var, since the String_var will assume the pointer points to data allocated via string_alloc and thus will eventually attempt to string_free it:<p>
</a><a name="518949">
 // C++<br>// The following is an error, since the char* should point to<br>// data allocated via string_alloc so it can be consumed<br>String_var s = "static string";	// error<br><br>// The following are OK, since const char* are copied,<br>// not consume<br>const char* sp = "static string";<br>s = sp;<br>s = (const char*)"static string too";<p>
</a><a name="510503">
<h1>	16.8	 Mapping for Structured Types</h1>
</a><a name="510510">
 <img src="local/images/plusca48.gif">The mapping for  <strong>struct</strong>, <strong>union</strong>, and <strong>sequence</strong> (but not <strong>array</strong>) is a C++ struct or class with a default constructor, a copy constructor, an assignment operator, and a destructor. The default constructor initializes object reference members to appropriately-typed nil object references and string members to NULL; all other members are initialized via their default constructors. The copy constructor performs a deep-copy from the existing structure to create a new structure, including calling _duplicate on all object reference members and performing the necessary heap allocations for all string members. The assignment operator first releases all object reference members and frees all string members, and then performs a deep-copy to create a new structure. The destructor releases all object reference memebrs and frees all string members.<p>
</a><a name="510517">
<img src="local/images/plusca49.gif">The mapping for OMG IDL structured types (structs, unions, arrays, and sequences) can vary slightly depending on whether the data structure is <em>fixed-length</em> or <em>v</em><em>ariable-length</em>. A type is <em>variable-length</em> if it is one of the following types:<p>
</a><ul><a name="510520">
<li>The type <strong>any</strong>
</a><a name="510522">
<li>A bounded or unbounded string
</a><a name="510524">
<li>A bounded or unbounded sequence
</a><a name="510528">
<li>An object reference or reference to a transmissible pseudo-object<a href="#510527"><sup>5</sup></a>
</a><a name="510529">
<li>A struct or union that contains a member whose type is variable-length
</a><a name="510530">
<li>An array with a variable-length element type
</a><a name="510531">
<li>A typedef to a variable-length type
</a><a name="510537">
<img src="local/images/plusca50.gif">The reason for treating fixed- and variable-length data structures differently is to allow more flexibility in the allocation of <strong>out</strong> parameters and return values from an operation. This flexibility allows a client-side stub for an operation that returns a sequence of strings, for example, to allocate all the string storage in one area that is deallocated in a single call.<p>
</a><a name="510543">
<img src="local/images/plusca51.gif">The mapping of a variable-length type as an <strong>out</strong> parameter or operation return value is a pointer to the associated class or array, as shown in <a href="pluscon.html#518293">Table 24 on page 16-44</a>. As a convenience for managing this pointer, the mapping also provides another class for each variable-length type. This type, which is named by adding the suffix "_var" to the original type's name, automatically deletes the pointer when an instance is destroyed. An object of type T_var behaves similarly to the structured type T, except that members must be accessed indirectly. For a struct, this means using an arrow ("-&gt;") instead of a dot (".").<p>
</a><a name="510548">
<blockquote>// IDL<br>struct S { string name; float age; };<br>void f(out S p);</blockquote>
</a><a name="516130">
 // C++<br>S a;<br>S_var b;<br>f(b);<br>a = b; // deep-copy<br>cout &lt;&lt; "names " &lt;&lt; a.name &lt;&lt; ", " &lt;&lt; b-&gt;name &lt;&lt; endl;<p>
</a></ul><a name="510551">
<h2>	16.8.1	 T_var Types</h2>
</a><a name="510556">
 <img src="local/images/plusca52.gif">The general form of the T_var types is shown below.<p>
</a><a name="510557">
 // C++<br>class T_var<br>{<br> &#32; &#32;public:<br>	T_var();<br>	T_var(T *);<br>	T_var(const T_var &amp;);<br>	~T_var();<br><br>	T_var &amp;operator=(T *);<br>	T_var &amp;operator=(const T_var &amp;);<br><br>	T *operator-&gt; const ();<br>	// other conversion operators to support<br>	// parameter passing<br>};<p>
</a><a name="510562">
<img src="local/images/plusca53.gif">The default constructor creates a T_var containing a null T*. Compliant applications may not attempt to convert a T_var created with the default constructor into a T* nor use its overloaded operator-&gt; without first assigning to it a valid T* or another valid T_var. Due to the difficulty of doing so, compliant implementations are not required to detect this error. Conversion of a null T_var to a T*&amp; is allowed, however, so that a T_var can legally be passed as an <strong>out</strong> parameter.<p>
</a><a name="510568">
<img src="local/images/plusca54.gif">The T* constructor creates a T_var that, when destroyed, will delete the storage pointed to by the T* parameter. The parameter to this constructor should never be a null pointer. Compliant implementations are not required to detect null pointers passed to this constructor.<p>
</a><a name="510573">
<img src="local/images/plusca55.gif">The copy constructor deep-copies any data pointed to by the T_var constructor parameter. This copy will be destroyed when the T_var is destroyed or when a new value is assigned to it. Compliant implementations may, but are not required to, utilize some form of reference counting to avoid such copies.<p>
</a><a name="510578">
<img src="local/images/plusca56.gif">The destructor uses delete to deallocate any data pointed to by the T_var, except for strings and array types, which are deallocated using the string_free and T_free (for array type T) deallocation functions, respectively.<p>
</a><a name="510583">
<img src="local/images/plusca57.gif">The T* assignment operator results in the deallocation of any old data pointed to by the T_var before assuming ownership of the T* parameter.<p>
</a><a name="510588">
<img src="local/images/plusca58.gif">The normal assignment operator deep-copies any data pointed to by the T_var assignment parameter. This copy will be destroyed when the T_var is destroyed or when a new value is assigned to it.<p>
</a><a name="510594">
<img src="local/images/plusca59.gif">The overloaded operator-&gt; returns the T* held by the T_var, but retains ownership of it. Coompliant applications may not call this function unless the T_var has been initialized with a valid T* or T_var.<p>
</a><a name="510599">
<img src="local/images/plusca60.gif">In addition to the member functions described above, the T_var types must support conversion functions that allow them to fully support the parameter passing modes shown in <a href="pluscon.html#518293">Table 24 on page 16-44</a>. The form of these conversion functions is not specified so as to allow different implementations, but the conversions must be automatic (i.e., they must require no explicit application code to invoke them).<p>
</a><a name="510607">
<img src="local/images/plusca61.gif">The T_var types are also produced for fixed-length structured types for reasons of consistency. These types have the same semantics as T_var types for variable-length types. This allows applications to be coded in terms of T_var types regardless of whether the underlying types are fixed- or variable-length.<p>
</a><a name="510612">
<img src="local/images/plusca62.gif">Each T_var type must be defined at the same level of nesting as its T type.<p>
</a><a name="510617">
<img src="local/images/plusca63.gif">T_var types do not work with a pointer to constant T, since they provide no constructor nor operator= taking a const T* parameter. Since C++ does not allow delete to be called on a const T*, the T_var object would normally have to copy the const object; instead, the absence of the const T* constructor and assignment operators will result in a compile-time error if such an initialization or assignment is attempted. This allows the application developer to decide if a copy is really wanted or not. Explicit copying of const T* objects into T_var types can be achieved via the copy constructor for T:<p>
</a><a name="510618">
 // C++<br>const T *t = ...;<br>T_var tv = new T(*t);<p>
</a><a name="510619">
<h1>	16.9	 Mapping for Struct Types</h1>
</a><a name="510626">
 <img src="local/images/plusca64.gif">An OMG IDL struct maps to C++ struct, with each OMG IDL struct member mapped to a corresponding member of the C++ struct. This mapping allows simple field access as well as aggregate initialization of most fixed-length structs. To facilitate such initialization, C++ structs must not have user-defined constructors, assignment operators, or destructors, and each struct member must be of  self-managed type. With the exception of strings and object references, the type of a C++ struct member is the normal mapping of the 	OMG IDL member's type.<p>
</a><a name="510633">
<img src="local/images/plusca65.gif">For a string or object reference member, the name of the C++ member's type is not specified by the mapping-a compliant program therefore cannot create an object of that type. The behavior<a href="#510636"><sup>6</sup></a> of the type is the same as the normal mapping (char* for string, A_ptr for an interface A) except the type's copy constructor copies the member's storage and its assignment operator releases the member's old storage.<p>
</a><a name="510641">
<img src="local/images/plusca66.gif">Assignment between a string or object reference member and a corresponding T_var type (String_var or A_var) always results in copying the data, while assignment with a pointer does not. The one exception to the rule for assignment is when a const char* is assigned to a member, in which case the storage is copied.<p>
</a><a name="510646">
<img src="local/images/plusca67.gif">When the old storage must not be freed (for example, it is part of the function's activation record), one can access the member directly as a pointer using the _ptr field accessor. This usage is dangerous and generally should be avoided.<p>
</a><a name="510648">
<blockquote>// IDL<br>struct Fixed{ float x, y, z; };</blockquote>
</a><a name="516118">
 // C++<br>Fixed x1 = {1.2, 2.4, 3.6};<br>Fixed_var x2 = new Fixed;<br>x2-&gt;y = x1.z;<p>
</a><a name="510654">
<img src="local/images/plusca68.gif">The example above shows usage of the T and T_var types for a fixed-length struct. When it goes out of scope, x2 will automatically free the heap-allocated Fixed object using delete.<p>
</a><a name="510659">
<img src="local/images/plusca69.gif">The following examples illustrate mixed usage of T and T_var types for variable-length types, using the following OMG IDL definition:<p>
</a><a name="510660">
<blockquote>// IDL<br>interface A;<br>struct Variable { string name; };</blockquote>
</a><a name="516123">
 // C++<br>Variable str1;											// str1.name is initially NULL<br>Variable_var str2 = new Variable;								// str2-&gt;name is initially NULL<br>char *non_const;<br>const char *const2;<br>String_var string_var;<br>const char *const3 = "string 1";<br>const char *const4 = "string 2";<br><br>str1.name = const3;								// 1: free old storage, copy<br>str2-&gt;name = const4;								// 2: free old storage, copy<p>
</a><a name="510667">
<img src="local/images/plusca70.gif">In the example above, the name components of variables str1 and str2 both start out as null. On the line marked 1, const3 is assigned to the name component of str1; this results in the previous str1.name being freed, and since const3 points to const data, the contents of const3 being copied. In this case, str1.name started out as null, so no previous data needs to be freed before the copying of const3 takes place. Line 2 is similar to line 1, except that str2 is a T_var type.<p>
</a><a name="510672">
<img src="local/images/plusca71.gif">Continuing with the example:<p>
</a><a name="510673">
 // C++<br>non_const = str1.name;								// 3: no free, no copy<br>const2 = str2-&gt;name;								// 4: no free, no copy<p>
</a><a name="510678">
<img src="local/images/plusca72.gif">On the line marked 3, str1.name is assigned to non_const. Since non_const is a pointer type (char*), str1.name is not freed, nor are the data it points to copied. After the assignment, str1.name and non_const effectively point to the same storage, with str1.name retaining ownership of that storage. Line 4 is identical to line 3, even though const2 is a pointer to const char; str2-&gt;name is neither freed nor copied because const2 is a pointer type.<p>
</a><a name="510679">
 // C++<br>str1.name = non_const;								// 5: free, no copy<br>str1.name = const2;								// 6: free old storage, copy<p>
</a><a name="510684">
<img src="local/images/plusca73.gif">Line 5 involves assignment of a char* to str1.name, which results in the old str1.name being freed and the value of the non_const pointer, but not the data it points to, being copied. In other words, after the assignment str1.name points to the same storage as non_const points to. Line 6 is the same as line 5 except that because const2 is a const char*, the data it points to are copied.<p>
</a><a name="510685">
 // C++<br>str2-&gt;name = str1.name;								// 7: free old storage, copy<br>str1.name = string_var;								// 8: free old storage, copy<br>string_var = str2-&gt;name;								// 9: free old storage, copy<p>
</a><a name="510690">
<img src="local/images/plusca74.gif">On line 7, assignment is performed to a member from another member, so the original value is of the left-hand member is freed and the new value is copied. Similarly, lines 8 and 9 involve assignment to or from a String_var, so in both cases the original value of the left-hand side is freed and the new value is copied.<p>
</a><a name="510691">
 // C++<br>str1.name._ptr = str2.name;								// 10: no free, no copy<p>
</a><a name="510696">
<img src="local/images/plusca75.gif">Finally, line 10 uses the _ptr field accessor, so no freeing or copying takes place. Such usage is dangerous and generally should be avoided.<p>
</a><a name="510701">
<img src="local/images/plusca76.gif">ORB implementations concerned with single-process interoperability with the C mapping may overload operator new() and operator delete() for structs so that dynamic allocation uses the same mechanism as the C language dynamic allocation functions. Whether these operators are overloaded by the implementation or not, compliant programs use new to dynamically allocate structs and delete to free them.<p>
</a><a name="512768">
<h1>	16.10	 Mapping for Union Types</h1>
</a><a name="512770">
<img src="local/images/plusca77.gif">Unions map to C++ classes with access functions for the union members and discriminant. The default union constructor performs no application-visible initialization of the union. It does not initialize the discriminator, nor does it initialize any union members to a state useful to an application.  (The implementation of the default constructor can do whatever type of initialization it wants to, but such initialization is implementation-dependent. No compliant application can count on a union ever being properly initialized by the default constructor alone.) <p>
</a><a name="517329">
<img src="local/images/plusca78.gif">It is therefore an error for an application to access the union before setting it, but ORB implementations are not required to detect this error due to the difficulty of doing so. The copy constructor and assignment operator both perform a deep-copy of their parameters, with the assignment operator releasing old storage if necessary. The destructor releases all storage owned by the union.<p>
</a><a name="517335">
<img src="local/images/plusca79.gif">The union discriminant access functions have the name _d to both be brief and avoid name conflicts with the members. The _d discriminator modifier function can only be used to set the discriminant to a value within the same union member. In addition to the _d accessors, a union with an implicit default member provides a _default() member function that sets the discriminant to a legal default value. A union has an implicit default member if it does not have a default case and not all permissible values of the union discriminant are listed.<p>
</a><a name="510725">
<img src="local/images/plusca80.gif">Setting the union value through an access function automatically sets the discriminant and may release the storage associated with the previous value. Attempting to get a value through an access function that does not match the current discriminant results in undefined behavior. If an access function for a union member with multiple legal discriminant values is used to set the value of the discriminant, the union implementation is free to set the discriminant to any one of the legal values for that member. The actual discriminant value chosen under these circumstances is implementation dependent.<p>
</a><a name="510730">
<img src="local/images/plusca81.gif">The following example helps illustrate the mapping for union types:<p>
</a><a name="510731">
<blockquote>// IDL<br>typedef octet Bytes[64];<br>struct S { 	long len; };<br>interface A;<br>union U switch (long) {<br>						case 1: long x;<br>						case 2: Bytes y;<br>						case 3: string z;<br>						case 4:<br>						case 5: S w;<br>						default: A obj;<br>};</blockquote>
</a><a name="510733">
 // C++<br>typedef Octet Bytes[64];<br>typedef Octet Bytes_slice;<br>class Bytes_forany { ... };<br>struct S { Long len; };<br>typedef ... A_ptr;<br>class U<br>{<br> &#32; &#32;public:<br>	U();<br>	U(const U&amp;);<br>	~U();<br>	U &amp;operator=(const U&amp;);<br><br>	void _d(Long);<br>	Long _d() const;<br><br>	void x(Long);<br>	Long x() const;<br><br>	void y(Bytes);<br>	Bytes_slice *y() const;<br><br>	void z(char*);									// free old storage, no copy<br>	void z(const char*);									// free old storage, copy<br>	void z(const String_var &amp;);	// free old storage, copy<br>	const char *z() const;<br><br>	void w(const S &amp;);									// deep copy<br>	const S &amp;w() const;									// read-only access<br>	S &amp;w();									// read-write access<br><br>	void obj(A_ptr);									// release old objref, duplicate<br>	A_ptr obj() const;									// no duplicate<br>};<p>
</a><a name="510739">
<img src="local/images/plusca82.gif">Accessor and modifier functions for union members provide semantics similar to that of struct data members. Modifier functions perform the equivalent of a deep-copy of their parameters, and their parameters should be passed by value (for small types) or by reference to const (for larger types). Accessors that return a reference to a non-const object can be used for read-write access, but such accessors are only provided for the following types: <strong>struct</strong>, <strong>union</strong>, <strong>sequence</strong>, and <strong>any</strong>.<p>
</a><a name="510746">
<img src="local/images/plusca83.gif">For an array union member, the accessor returns a pointer to the array slice, where the slice is an array with all dimensions of the original except the first (array slices are described in detail in <a href="pluscon.html#510942"> Section 16.12</a>). The array slice return type allows for read-write access for array members via regular subscript operators. For members of an anonymous array type, supporting typedefs for the array must be generated directly into the union. For example:<p>
</a><a name="516501">
<blockquote>// IDL</blockquote>
</a><a name="516503">
<blockquote>union U switch (long) {</blockquote>
</a><a name="516504">
<blockquote> &#32; &#32;	default: long array[20][20];</blockquote>
</a><a name="516517">
<blockquote>};</blockquote>
</a><a name="516525">
 // C++<br>class U<br>{<br> &#32; &#32;public:<br>	// ...<br>	void array(long arg[20][20]);<br>	typedef long _array_slice[20];<br>	_array_slice * array();<br>	// ...<br>};<p>
</a><a name="516559">
<img src="local/images/plusca84.gif">The name of the supporting array slice typedef is created by prepending an underscore and appending "_slice" to the union member name. In the example above, the array member named "array" results in an array slice typedef called "_array_slice" nested in the union class.<p>
</a><a name="516531">
<img src="local/images/plusca85.gif">For string union members, the char* modifier results in the freeing of old storage before ownership of the pointer parameter is assumed, while the const char* modifier and the String_var modifier<a href="#516534"><sup>7</sup></a> both result in the freeing of old storage before the parameter's storage is copied. The accessor for a string member returns a const char* to allow examination but not modification of the string storage.<a href="#516537"><sup>8</sup></a><p>
</a><a name="510767">
<img src="local/images/plusca86.gif">For object reference union members, object reference parameters to modifier functions are duplicated after the old object reference is released. An object reference return value from an accessor function is not duplicated because the union retains ownership of the object reference.<p>
</a><a name="517363">
<img src="local/images/plusca87.gif">The restrictions for using the _d discriminator modifier function are shown by the following examples, based on the definition of the union U shown above:<p>
</a><a name="517368">
 // C++<br>S s = {10};<br>U u;<br>u.w(s);			// member w selected<br>u._d(4);			// OK, member w selected<br>u._d(5);			// OK, member w selected<br>u._d(1);			// error, different member selected<br>A_ptr a = ...;<br>u.obj(a);			// member obj selected<br>u._d(7);			// OK, member obj selected<br>u._d(1);			// error, different member selected<p>
</a><a name="517397">
<img src="local/images/plusca88.gif">As shown here, the _d modifier function cannot be used to implicitly switch between different union members. The following shows an example of how the _default() member function is used:<p>
</a><a name="517398">
<blockquote>// IDL<br>union Z switch(boolean) {<br>						case TRUE: short s;<br>};</blockquote>
</a><a name="517404">
 // C++<br>Z z;<br>z._default();				// implicit default member selected<br>Boolean disc = z._d();				// disc == FALSE<br>U u;				// union U from previous example<br>u._default();				// error, no _default() provided<p>
</a><a name="517412">
<img src="local/images/plusca89.gif">For union Z, calling the _default() member function causes the union's value to be composed solely of the discriminator value of FALSE, since there is no explicit default member. For union U, calling _default() causes a compilation error because U has an expliitly declared default case and thus no _default() member function. A _default() member function is only generated for unions with implicit default members.<p>
</a><a name="517373">
<img src="local/images/plusca90.gif">ORB implementations concerned with single-process interoperability with the C mapping may overload operator new() and operator delete() for unions so that dynamic allocation uses the same mechanism as the C language dynamic allocation functions. Whether these operators are overloaded by the implementation or not, compliant programs use new to dynamically allocate unions and delete to free them.<p>
</a><a name="510773">
<h1>	16.11	 Mapping for Sequence Types</h1>
</a><a name="517284">
 <img src="local/images/plusca91.gif">A sequence is mapped to a C++ class that behaves like an array with a current length and a maximum length. For a bounded sequence, the maximum length is implicit in the sequence's type and cannot be explicitly controlled by the programmer. For an unbounded sequence, the initial value of the maximum length can be specified in the sequence constructor to allow control over the size of the initial buffer allocation. The programmer may always explicitly modify the current length of any sequence.<p>
</a><a name="510787">
<img src="local/images/plusca92.gif">For an unbounded sequence, setting the length to a larger value than the current length may reallocate the sequence data. Reallocation is conceptually equivalent to creating a new sequence of the desired new length, copying the old sequence elements <em>zero through</em> <em>length-1</em> into the new sequence, and then assigning the old sequence to be the same as the new sequence. Setting the length to a smaller value than the current length does not affect how the storage associated with the sequence is manipulated. Note, however, that the elements orphaned by this reduction are no longer accessible and that their values cannot be recovered by increasing the sequence length to its original value.<p>
</a><a name="516440">
<img src="local/images/plusca93.gif">For a bounded sequence, attempting to set the current length to a value larger than the maximum length given in the OMG IDL specification produces undefined behavior. <p>
</a><a name="516445">
<img src="local/images/plusca94.gif">For each different named OMG IDL sequence type, a compliant implementation provides a separate C++ sequence type. For example:<p>
</a><a name="510802">
<blockquote>// IDL<br>typedef sequence&lt;long&gt; LongSeq;<br>typedef sequence&lt;LongSeq, 3&gt; LongSeqSeq;</blockquote>
</a><a name="516111">
 // C++<br>class LongSeq										// unbounded sequence<br>{<br> &#32; &#32;public:<br>	LongSeq();									// default constructor<br>	LongSeq(ULong max);									// maximum constructor<br>	LongSeq(									// T *data constructor<br>		ULong max,<br>		ULong length,<br>		Long *value,<br>		Boolean release = FALSE<br>	);<br>	LongSeq(const LongSeq&amp;);<br>	~LongSeq();<br>	...<br>};<br><br>class LongSeqSeq										// bounded sequence<br>{<br> &#32; &#32;public:<br>	LongSeqSeq();									// default constructor<br>	LongSeqSeq(									// T *data constructor<br>		ULong length,<br>		LongSeq *value,<br>		Boolean release = FALSE<br>	);<br>	LongSeqSeq(const LongSeqSeq&amp;);<br>	~LongSeqSeq();<br>	...<br>};<p>
</a><a name="510809">
<img src="local/images/plusca95.gif">For both bounded and unbounded sequences, the default constructor (as shown in the example above) sets the sequence length equal to 0. For bounded sequences, the maximum length is part of the type and cannot be set or modified, while for unbounded sequences, the default constructor also sets the maximum length to 0. The default constructor for a bounded sequence always allocates a contents vector, so it always sets the release flag to TRUE.<p>
</a><a name="510814">
<img src="local/images/plusca96.gif">Unbounded sequences provide a constructor that allows only the initial value of the maximum length to be set (the "maximum constructor" shown in the example above). This allows applications to control how much buffer space is initially allocated by the sequence. This constructor also sets the length to 0 and the release flag to TRUE.<p>
</a><a name="510820">
<img src="local/images/plusca97.gif">The "T *data" constructor (as shown in the example above) allows the length and contents of a bounded or unbounded sequence to be set. For unbounded sequences, it also allows the initial value of the maximum length to be set. For this constructor, ownership of the contents vector is determined by the release parameter-FALSE means the caller owns the storage, while TRUE means that the sequence assumes ownership of the storage. If release is TRUE, the contents vector must have been allocated using the sequence allocbuf function, and the sequence will pass it to freebuf when finished with it. The allocbuf and freebuf functions are described on <a href="pluscon.html#510914">"Additional Memory Management Functions" on page &#32;16-25</a>.<p>
</a><a name="510829">
<img src="local/images/plusca98.gif">The copy constructor creates a new sequence with the same maximum and length as the given sequence, copies each of its current elements (items <em>zero</em> through <em>length-1</em>), and sets the release flag to TRUE.<p>
</a><a name="510834">
<img src="local/images/plusca99.gif">The assignment operator deep-copies its parameter, releasing old storage if necessary. It behaves as if the original sequence is destroyed via its destructor and then the source sequence copied using the copy constructor.<p>
</a><a name="516850">
<img src="local/images/plusa100.gif">If release=TRUE, the destructor destroys each of the current elements (items <em>zero</em> through <em>length-1</em>).<p>
</a><a name="516935">
<img src="local/images/plusa101.gif">For an unbounded sequence, if a reallocation is necessary due to a change in the length and the sequence was created using the release=TRUE parameter in its constructor, the sequence will deallocate the old storage. If release is FALSE under these circumstances, old storage will not be freed before the reallocation is performed. After reallocation, the release flag is always set to TRUE.<p>
</a><a name="516940">
<img src="local/images/plusa102.gif">For an unbounded sequence, the maximum() accessor function returns the total amount of buffer space currently available. This allows applications to know how many items they can insert into an unbounded sequence without causing a reallocation to occur. For a bounded sequence, maximum() always returns the bound of the sequence as given in its OMG IDL type declaration.<p>
</a><a name="510851">
<img src="local/images/plusa103.gif">The overloaded subscript operators (operator[]) return the item at the given index. The non-const version must return something that can serve as an lvalue (i.e., something that allows assignment into the item at the given index), while the const version must allow read-only access to the item at the given index.<p>
</a><a name="510856">
<img src="local/images/plusa104.gif">The overloaded subscript operators may not be used to access or modify any element beyond the current sequence length. Before either form of operator[] is used on a sequence, the length of the sequence must first be set using the length(ULong) modifier function, unless the sequence was constructed using the T *data constructor.<p>
</a><a name="510861">
<img src="local/images/plusa105.gif">For strings and object references, operator[] for a sequence must return a type with the same semantics as the types used for string and object reference members of structs and arrays, so that assignment to the string or object reference sequence member via operator=() will release old storage when appropriate. Note that whatever these special return types are, they must honor the setting of the release parameter in the T *data constructor with respect to releasing old storage.<p>
</a><a name="510866">
<img src="local/images/plusa106.gif">For the T *data sequence constructor, the type of T for strings and object references is char* and T_ptr, respectively. In other words, string buffers are passed as char** and object reference buffers are passed as T_ptr*.<p>
</a><a name="510869">
<h2>	16.11.1	 Sequence Example</h2>
</a><a name="510874">
 <img src="local/images/plusa107.gif">The example below shows full declarations for both a bounded and an unbounded sequence.<p>
</a><a name="510875">
<blockquote>// IDL<br>typedef sequence&lt;T&gt; V1;													// unbounded sequence<br>typedef sequence&lt;T, 2&gt; V2;													// bounded sequence</blockquote>
</a><a name="510877">
 // C++<br>class V1								// unbounded sequence<br>{<br> &#32; &#32;public:<br>	V1();<br>	V1(ULong max);<br>	V1(ULong max, ULong length, T *data,<br>		Boolean release =						FALSE);<br>	V1(const V1&amp;);<br>	~V1();<br>	V1 &amp;operator=(const V1&amp;);<br><br>	ULong maximum() const;<br><br>	void length(ULong);<br>	ULong length() const;<br><br>	T &amp;operator[](ULong index);<br>	const T &amp;operator[](ULong index) const;<br>};<br><br>class V2								// bounded sequence<br>{<br> &#32; &#32;public:<br>	V2();<br>	V2(ULong length, T *data, Boolean release = FALSE);<br>	V2(const V2&amp;);<br>	~V2();<br>	V2 &amp;operator=(const V2&amp;);<br><br>	ULong maximum() const;<br><br>	void length(ULong);<br>	ULong length() const;<br><br>	T &amp;operator[](ULong index);<br>	const T &amp;operator[](ULong index) const;<br>};<p>
</a><a name="510878">
<h2>	16.11.2	 Using the "release" Constructor Parameter</h2>
</a><a name="510883">
 <img src="local/images/plusa108.gif">Consider the following example:<p>
</a><a name="510884">
<blockquote>// IDL<br>typedef sequence&lt;string, 3&gt; StringSeq;</blockquote>
</a><a name="516100">
 // C++<br>char *static_arr[] = {"one", "two", "three"};<br>char **dyn_arr = StringSeq::allocbuf(3);<br>dyn_arr[0] = string_dup("one");<br>dyn_arr[1] = string_dup("two");<br>dyn_arr[2] = string_dup("three");<br><br>StringSeq seq1(3, static_arr);<br>StringSeq seq2(3, dyn_arr, TRUE);<br><br>seq1[1] = "2";						// no free, no copy<br>char *str = string_dup("2");<br>seq2[1] = str;						// free old storage, no copy<p>
</a><a name="510890">
<img src="local/images/plusa109.gif">In this example, both seq1 and seq2 are constructed using user-specified data, but only seq2 is told to assume management of the user memory (because of the release=TRUE parameter in its constructor). When assignment occurs into seq1[1], the right-hand side is not copied, nor is anything freed because the sequence does not manage the user memory. When assignment occurs into seq2[1], however, the old user data must be freed before ownership of the right-hand side can be assumed, since seq2 manages the user memory. When seq2 goes out of scope, it will call string_free for each of its elements and freebuf  on the buffer given to it in its constructor.<p>
</a><a name="510895">
<img src="local/images/plusa110.gif">When the release flag is set to TRUE and the sequence element type is either a string or an object reference type, the sequence will individually release each element before releasing the contents buffer. It will release strings using string_free, and it will release object references using the release function from the CORBA namespace.<p>
</a><a name="510900">
<img src="local/images/plusa111.gif">In general, assignment should never take place into a sequence element via operator[] unless release=TRUE due to the possibility for memory management errors. In particular, a sequence constructed with release=FALSE should never be passed as an <strong>inout</strong> parameter because the callee has no way to determine the setting of the release flag, and thus must always assume that release is set to TRUE. Code that creates a sequence with release=FALSE and then knowingly and correctly manipulates it in that state, as shown with seq1 in the example above, is compliant, but care should always be taken to avoid memory leaks under these circumstances.<p>
</a><a name="510905">
<img src="local/images/plusa112.gif">As with other <strong>out</strong> and return values, <strong>out</strong> and return sequences must not be assigned to by the caller without first copying them. This is more fully explained in <a href="pluscon.html#511674">Section &#32;16.18, "Argument Passing Considerations," on page &#32;16-41</a>.<p>
</a><a name="510913">
<img src="local/images/plusa113.gif">When a sequence is constructed with release=TRUE, a compliant application should make no assumptions about the continued lifetime of the data buffer passed to the constructor, since a compliant sequence implementation is free to copy the buffer and immediately free the original pointer.<p>
</a><a name="510914">
<h2>	16.11.3	 Additional Memory Management Functions</h2>
</a><a name="510919">
 <img src="local/images/plusa114.gif">ORB implementations concerned with single-process interoperability with the C mapping may overload operator new() and operator delete() for sequences so that dynamic allocation uses the same mechanism as the C language dynamic allocation functions. Whether these operators are overloaded by the implementation or not, compliant programs use new to dynamically allocate sequences and delete to free them.<p>
</a><a name="510924">
<img src="local/images/plusa115.gif">Sequences also provide additional memory management functions for their buffers. For a sequence of type T, the following static member functions are provided in the sequence class public interface:<p>
</a><a name="510925">
 // C++<br>static T *allocbuf(ULong nelems);<br>static void freebuf(T *);<p>
</a><a name="510931">
<img src="local/images/plusa116.gif">The allocbuf function allocates a vector of T elements that can be passed to the T *data constructor. The length of the vector is given by the nelems function argument. The allocbuf function initializes each element using its default constructor, except for strings, which are initialized to null pointers, and object references, which are initialized to suitably-typed nil object references. A null pointer is returned if allocbuf for some reason cannot allocate the requested vector. Vectors allocated by allocbuf should be freed using the freebuf function. The freebuf function ensures that the destructor for each element is called before the buffer is destroyed, except for string elements, which are freed using string_free(), and object reference elements, which are freed using release(). The freebuf function will ignore null pointers passed to it. Neither allocbuf nor freebuf may throw CORBA exceptions.<p>
</a><a name="510932">
<h2>	16.11.4	 Sequence T_var Type</h2>
</a><a name="510937">
 <img src="local/images/plusa117.gif">In addition to the regular operations defined for T_var types, the T_var for a sequence type also supports an overloaded operator[] that forwards requests to the operator[] of the underlying sequence.<a href="#510940"><sup>9</sup></a> This subscript operator should have the same return type as that of the corresponding operator on the underlying sequence type.<p>
</a><a name="510942">
<h1>	16.12	 Mapping For Array Types</h1>
</a><a name="510948">
 <img src="local/images/plusa118.gif">Arrays are mapped to the corresponding C++ array definition, which allows the definition of statically-initialized data using the array. If the array element is a string or an object reference, then the mapping uses the same type as for structure members. That is, assignment to an array element will release the storage associated with the old value.<p>
</a><a name="510950">
<blockquote>// IDL<br>typedef float F[10];<br>typedef string V[10];<br>typedef string M[1][2][3];<br>void op(out F p1, out V p2, out M p3);</blockquote>
</a><a name="510951">
<blockquote></blockquote>
</a><a name="510952">
 // C++<br>F f1; F_var f2;<br>V v1; V_var v2;<br>M m1; M_var m2;<p>
</a><a name="510953">
 f(f2, v2, m2);<br>f1[0] = f2[1];<br>v1[1] = v2[1];									// free old storage, copy<br>m1[0][1][2] = m2[0][1][2];									// free old storage, copy<p>
</a><a name="510958">
<img src="local/images/plusa119.gif">In the above example, the last two assignments result in the storage associated with the old value of the left-hand side being automatically released before the value from the right-hand side is copied.<p>
</a><a name="510966">
<img src="local/images/plusa120.gif">As shown in <a href="pluscon.html#518293">Table 24 on page 16-44</a>, <strong>out</strong> and return arrays are handled via pointer to array <em>slice</em>, where a slice is an array with all the dimensions of the original specified except the first one. As a convenience for application declaration of slice types, the mapping also provides a typedef for each array slice type. The name of the slice typedef consists of the name of the array type followed by the suffix  "_slice". For example:<p>
</a><a name="510969">
<blockquote>// IDL<br>typedef long LongArray[4][5];</blockquote>
</a><a name="516097">
 // C++<br>typedef Long LongArray[4][5];<br>typedef Long LongArray_slice[5];<p>
</a><a name="510978">
<img src="local/images/plusa121.gif">A T_var type for an array should overload operator[] instead of operator-&gt;. The use of array slices also means that a T_var type for an array should have a constructor and assignment operator that each take a pointer to array slice as a parameter, rather than T*. The T_var for the previous example would be:<p>
</a><a name="510979">
 // C++<br>class LongArray_var<br>{<br> &#32; &#32;public:<br>	LongArray_var();<br>	LongArray_var(LongArray_slice*);<br>	LongArray_var(const LongArray_var &amp;);<br>	~LongArray_var();<br>	LongArray_var &amp;operator=(LongArray_slice*);<br>	LongArray_var &amp;operator=(const LongArray_var &amp;);<br><br>	LongArray_slice &amp;operator[](ULong index);<br>	const LongArray_slice &amp;operator[](Ulong index) const;<br>	// other conversion operators to support<br>	// parameter passing<br>};<p>
</a><a name="510984">
<img src="local/images/plusa122.gif">Because arrays are mapped into regular C++ arrays, they present special problems for the type-safe <strong>any</strong> mapping described in <a href="pluscon.html#511029"> Section 16.14</a>. To facilitate their use with the <strong>any</strong> mapping, a compliant implementation must also provide for each array type a distinct C++ type whose name consists of the array name followed by the suffix _forany. These types must be distinct so as to allow functions to be overloaded on them. Like Array_var types, Array_forany types allow access to the underlying array type, but unlike Array_var, the Array_forany type does not delete the storage of the underlying array upon its own destruction. This is because the Any mapping retains storage ownership, as described in <a href="pluscon.html#511161"> Section 16.14.3</a>.<p>
</a><a name="519149">
<img src="local/images/plusa123.gif">The interface of the Array_forany type is identical to that of the Array_var type, but it may not be implemented as a typedef to the Array_var type by a compliant implementation since it must be distinguishable from other types for purposes of function overloading. Also, the Array_forany constructor taking an Array_slice* parameter also takes a Boolean <em>nocopy</em> parameter which defaults to FALSE:<p>
</a><a name="518956">
 // C++<br>class Array_forany<br>{<br> &#32; &#32;public:<br>	Array_forany(Array_slice*, Boolean nocopy = FALSE);<br>	...<br>};<p>
</a><a name="518957">
<img src="local/images/plusa124.gif">The <em>nocopy</em> flag allows for a non-copying insertion of an Array_slice* into an Any.<p>
</a><a name="511003">
<img src="local/images/plusa125.gif">Each Array_forany type must be defined at the same level of nesting as its Array type.<p>
</a><a name="511008">
<img src="local/images/plusa126.gif">For dynamic allocation of arrays, compliant programs must use special functions defined at the same scope as the array type. For array T, the following functions will be available to a compliant program:<p>
</a><a name="511009">
 // C++<br>T_slice *T_alloc();<br>T_slice *T_dup(const T_slice*);<br>void T_free(T_slice *);<p>
</a><a name="511014">
<img src="local/images/plusa127.gif">The T_alloc function dynamically allocates an array, or returns a null pointer if it cannot perform the allocation. The T_dup function dynamically allocates a new array with the same size as its array argument, copies each element of the argument array into the new array, and returns a pointer to the new array. If allocation fails, a null pointer is returned. The T_free function deallocates an array that was allocated with T_alloc or T_dup. Passing a null pointer to T_free is acceptable and results in no action being performed. These functions allow ORB implementations to utilize special memory management mechanisms for array types if necessary, without forcing them to replace global operator new and operator new[].<p>
</a><a name="516784">
<img src="local/images/plusa128.gif">The T_alloc, T_dup, and T_free functions may not throw CORBA exceptions.<p>
</a><a name="511015">
<p>
</a><a name="515092">
<h1>	16.13	 Mapping For Typedefs</h1>
</a><a name="515095">
 <img src="local/images/plusa129.gif">A typedef creates an alias for a type. If the original type maps to several types in C++, then the typedef creates the corresponding alias for each type. The example below illustrates the mapping.<p>
</a><a name="511025">
<blockquote>// IDL<br>typedef long T;<br>interface A1;<br>typedef A1 A2;<br>typedef sequence&lt;long&gt; S1;<br>typedef S1 S2;</blockquote>
</a><a name="511027">
 // C++<br>typedef Long T;<br><br>// ...definitions for A1...<br><br>typedef A1 A2;<br>typedef A1_ptr A2_ptr;<br>typedef A1Ref A2Ref;<br>typedef A1_var A2_var;<br><br>// ...definitions for S1...<br><br>typedef S1 S2;<br>typedef S1_var S2_var;<p>
</a><a name="516295">
<img src="local/images/plusa130.gif">For a typedef of an IDL type that maps to multiple C++ types, such as arrays, the typedef maps to all of the same C++ types and functions that its base type requires. For example:<p>
</a><a name="516296">
<blockquote>// IDL<br>typedef long array[10];<br>typedef array another_array;</blockquote>
</a><a name="516299">
 // C++<br>// ...C++ code for array not shown...<br>typedef array another_array;<br>typedef array_var another_array_var;<br>typedef array_slice another_array_slice;<br>typedef array_forany another_array_forany;<p>
</a><a name="516309">
 inline another_array_slice *another_array_alloc() {<br>	return array_alloc();<br>}<br><br>inline another_array_slice* another_array_dup(another_array_slice *a) {<br>	return array_dup(a);<br>}<p>
</a><a name="516310">
 inline void another_array_free(another_array_slice *a) {<br>	array_free(a);<br>}<p>
</a><a name="511029">
<h1>	16.14	 Mapping for the Any Type</h1>
</a><a name="511035">
 <img src="local/images/plusa131.gif">A C++ mapping for the OMG IDL type <strong>any</strong> must fulfill two different requirements:<p>
</a><ul><a name="511037">
<li>Handling C++ types in a type-safe manner.
</a><a name="511038">
<li>Handling values whose types are not known at implementation compile time.
</a><a name="511044">
<img src="local/images/plusa132.gif">The first item covers most normal usage of the <strong>any</strong> type-the conversion of typed values into and out of an <strong>any</strong>. The second item covers situations such as those involving the reception of a request or response containing an <strong>any</strong> that holds data of a type unknown to the receiver when it was created with a C++ compiler.<p>
</a></ul><a name="511046">
<h2>	16.14.1	 	Handling Typed Values</h2>
</a><a name="511052">
 <img src="local/images/plusa133.gif">To decrease the chances of creating an <strong>any</strong> with a mismatched <strong>TypeCode</strong> and value, the C++ function overloading facility is utilized. Specifically, for each distinct type in an OMG IDL specification, overloaded functions to insert and extract values of that type are provided by each ORB implementation. Overloaded operators are used for these functions so as to completely avoid any name space pollution. The nature of these functions, which are described in detail below, is that the appropriate <strong>TypeCode</strong> is implied by the C++ type of the value being inserted into or extracted from the <strong>any</strong>.<p>
</a><a name="511059">
<img src="local/images/plusa134.gif">Since the type-safe <strong>any</strong> interface described below is based upon C++ function overloading, it requires C++ types generated from OMG IDL specifications to be distinct. However, there are special cases in which this requirement is not met:<p>
</a><ul><a name="511063">
<li>As noted in <a href="pluscon.html#510355">Section &#32;16.5, "Mapping for Basic Data Types," on page &#32;16-10</a>, the <strong>boolean</strong>, <strong>octet</strong>, and <strong>char</strong> OMG IDL types are not required to map to distinct C++ types, which means that a separate means of distinguishing them from each other for the purpose of function overloading is necessary. The means of distinguishing these types from each other is described in <a href="pluscon.html#516681">Section &#32;16.14.4, "Distinguishing boolean, octet, char, and bounded string," on page &#32;16-33</a>.
</a><a name="511068">
<li>Since all strings are mapped to char* regardless of whether they are bounded or unbounded, another means of creating or setting an <strong>any</strong> with a bounded string value is necessary. This is described in <a href="pluscon.html#516681">Section &#32;16.14.4, "Distinguishing boolean, octet, char, and bounded string," on page &#32;16-33</a>.
</a><a name="511072">
<li>In C++, arrays within a function argument list decay into pointers to their first elements. This means that function overloading cannot be used to distinguish between arrays of different sizes. The means for creating or setting an <strong>any</strong> when dealing with arrays is described below and in <a href="pluscon.html#510942">Section &#32;16.12, "Mapping For Array Types," on page &#32;16-26</a>.
</a></ul><a name="511076">
<h2>	16.14.2	 	Insertion into Any</h2>
</a><a name="511081">
 <img src="local/images/plusa135.gif">To allow a value to be set in an <strong>any</strong> in a type-safe fashion, an ORB implementation must provide the following overloaded operator function for each separate OMG IDL type T:<p>
</a><a name="511082">
 // C++<br>void operator&lt;&lt;=(Any&amp;, T);<p>
</a><a name="511088">
<img src="local/images/plusa136.gif">This function signature suffices for types that are normally passed by value:<p>
</a><ul><a name="511089">
<li>Short, UShort, Long, ULong, Float, Double
</a><a name="511090">
<li>enumerations
</a><a name="511091">
<li>unbounded strings (char* passed by value)
</a><a name="511092">
<li>object references (T_ptr)
</a><a name="511097">
<img src="local/images/plusa137.gif">For values of type T that are too large to be passed by value efficiently, two forms of the insertion function are provided:<p>
</a><a name="511098">
 // C++<br>void operator&lt;&lt;=(Any&amp;, const T&amp;);					// copying form<br>void operator&lt;&lt;=(Any&amp;, T*);					// non-copying form<p>
</a><a name="511103">
<img src="local/images/plusa138.gif">Note that the copying form is largely equivalent to the first form shown, as far as the caller is concerned.<p>
</a><a name="511109">
<img src="local/images/plusa139.gif">These "left-shift-assign" operators are used to insert a typed value into an <strong>any</strong> as follows:<p>
</a><a name="511110">
 // C++<br>Long value = 42;<br>Any a;<br>a &lt;&lt;= value;<p>
</a><a name="511116">
<img src="local/images/plusa140.gif">In this case, the version of operator&lt;&lt;= overloaded for type Long must be able to set both the value and the TypeCode properly for the Any variable.<p>
</a><a name="511121">
<img src="local/images/plusa141.gif">Setting a value in an <strong>any</strong> using operator&lt;&lt;= means that<p>
</a><a name="511124">
<li>For the copying version of operator&lt;&lt;=, the lifetime of the value in the Any is independent of the lifetime of the value passed to operator&lt;&lt;=. The implementation of the Any may not store its value as a reference or pointer to the value passed to operator&lt;&lt;=.
</a><a name="518994">
<li>For the non-copying version of operator&lt;&lt;=, the inserted T* is consumed by the Any. The caller may not use the T* to access the pointed-to data after insertion since the Any assumes ownership of it, and it may immediately copy the pointed-to data and destroy the original.
</a><a name="511125">
<li>With both the copying and non-copying versions of operator&lt;&lt;=, any previous value held by the Any is properly deallocated. For example, if the Any(TypeCode_ptr,void*,TRUE) constructor (described in <a href="pluscon.html#511282">Section &#32;16.14.6, "Handling Untyped Values," on page &#32;16-36</a>) was called to create the Any, the Any is responsible for deallocating the memory pointed to by the void* before copying the new value.
</a><a name="511134">
<img src="local/images/plusa142.gif">Copying insertion of a string type causes the following function to be invoked:<p>
</a><a name="511135">
 // C++<br>void operator&lt;&lt;=(Any&amp;, const char*);<p>
</a><a name="511140">
<img src="local/images/plusa143.gif">Since all string types are mapped to char*, this insertion function assumes that the value being inserted is an unbounded string. <a href="pluscon.html#516681">Section &#32;16.14.4, "Distinguishing boolean, octet, char, and bounded string," on page &#32;16-33</a> describes how bounded strings may be correctly inserted into an Any. Non-copying insertion of both bounded and unbounded strings can be achieved using of the Any::from_string helper type described in <a href="pluscon.html#516681">Section &#32;16.14.4, "Distinguishing boolean, octet, char, and bounded string," on page &#32;16-34</a>.<p>
</a><a name="511151">
<img src="local/images/plusa144.gif">Type-safe insertion of arrays uses the Array_forany types described in <a href="pluscon.html#510942">Section &#32;16.12, "Mapping For Array Types," on page &#32;16-26</a>. Compliant implementations must provide a version of operator&lt;&lt;= overloaded for each Array_forany type. For example:<p>
</a><a name="511153">
<blockquote>// IDL<br>typedef long LongArray[4][5];</blockquote>
</a><a name="516092">
 // C++<br>typedef Long LongArray[4][5];<br>typedef Long LongArray_slice[5];<br>class LongArray_forany { ... };<br><br>void operator&lt;&lt;=(Any &amp;, const LongArray_forany &amp;);<p>
</a><a name="511159">
<img src="local/images/plusa145.gif">The Array_forany types are always passed to operator&lt;&lt;= by reference to const.<img src="local/images/plusa146.gif"> The <em>nocopy</em> flag in the Array_forany constructor is used to control whether the inserted value is copied (<em>nocopy</em> == FALSE) or consumed (<em>nocopy</em> == TRUE). Because the <em>nocopy</em> flag defaults to FALSE, copying insertion is the default.<p>
</a><a name="519010">
Because of the type ambiguity between an array of T and a T*, it is highly recommended that portable code explicitly<a href="#519017"><sup>10</sup></a> use the appropriate Array_forany type when inserting an array into an Any:<p>
</a><a name="519034">
<blockquote>// IDL<br>struct S {... };<br>typedef S SA[5];</blockquote>
</a><a name="519035">
 // C++<br>struct S { ... };<br>typedef S SA[5];<br>typedef S SA_slice;<br>class SA_forany { ... };<br><br>SA s;<br>// ...initialize s...<br>Any a;<br>a &lt;&lt;= s;				// line 1<br>a &lt;&lt;= SA_forany(s);				// line 2<p>
</a><a name="519042">
<img src="local/images/plusa147.gif">Line 1 results in the invocation of the non-copying operator&lt;&lt;=(Any&amp;, S*) due to the decay of the SA array type into a pointer to its first element, rather than the invocation of the copying SA_forany insertion operator. Line 2 explicitly constructs the SA_forany type and thus results in the desired insertion operator being invoked.<p>
</a><a name="519068">
<img src="local/images/plusa148.gif">The non-copying version of operator&lt;&lt;= for object references takes the address of teh T_ptr type:<p>
</a><a name="519069">
<blockquote>// IDL<br>interface T { ... };</blockquote>
</a><a name="519070">
 // C++<br>void operator&lt;&lt;=(Any&amp;, T_ptr);					// copying<br>void operator&lt;&lt;=(Any&amp;, T_ptr*);					// non-copying<p>
</a><a name="519071">
The non-copying object reference insertion consumes the object reference pointed to by T_ptr*; therefore after insertion the caller may not access the object referred to by T_ptr since the Any may have duplicated and then immediately released the original object reference. The caller maintains ownership of the storage for the T_ptr itself.<p>
</a><a name="516692">
<img src="local/images/plusa149.gif">The copying version of operator&lt;&lt;= is also supported on the Any_var type. Note that due to the conversion operators that convert Any_var to Any&amp; for parameter passing, only those operator&lt;&lt;= functions defined as member function of Any need to be explicitly defined for Any_var.<p>
</a></ul><a name="511161">
<h2>	16.14.3	 	Extraction From Any</h2>
</a><a name="511167">
 <img src="local/images/plusa150.gif">To allow type-safe retrieval of a value from an <strong>any</strong>, the mapping provides the following operators for each OMG IDL type T:<p>
</a><a name="511168">
 // C++<br>Boolean operator&gt;&gt;=(const Any&amp;, T&amp;);<p>
</a><a name="511173">
<img src="local/images/plusa151.gif">This function signature suffices for primitive types that are normally passed by value. For values of type T that are too large to be passed by value efficiently, this function may be prototyped as follows:<p>
</a><a name="511174">
 // C++<br>Boolean operator&gt;&gt;=(const Any&amp;, T*&amp;);<p>
</a><a name="511180">
<img src="local/images/plusa152.gif">The first form of this function is used only for the following types:<p>
</a><ul><a name="511181">
<li>Boolean, Char, Octet, Short, UShort, Long, ULong, Float, Double
</a><a name="511182">
<li>enumerations
</a><a name="511183">
<li>unbounded strings (char* passed by reference, i.e., char*&amp;)
</a><a name="511184">
<li>object references (T_ptr)
</a><a name="511189">
<img src="local/images/plusa153.gif">For all other types, the second form of the function is used.<p>
</a><a name="511195">
<img src="local/images/plusa154.gif">All versions of operator&gt;&gt;= implemented as member functions of class Any, such as those for primitive types, should be marked as const.<p>
</a><a name="511202">
<img src="local/images/plusa155.gif">This "right-shift-assign" operator is used to extract a typed value from an <strong>any</strong> as follows:<p>
</a><a name="511203">
 // C++<br>Long value;<br>Any a;<br>a &lt;&lt;= Long(42);<br>if (a &gt;&gt;= value) {<br>	// ... use the value ...<br>}<p>
</a><a name="511208">
<img src="local/images/plusa156.gif">In this case, the version of operator&gt;&gt;= for type Long must be able to determine whether the Any truly does contain a value of type Long and, if so, copy its value into the reference variable provided by the caller and return TRUE. If the Any does not contain a value of type Long, the value of the caller's reference variable is not changed, and operator&gt;&gt;= returns FALSE.<p>
</a><a name="511214">
<img src="local/images/plusa157.gif">For non-primitive types, extraction is done by pointer. For example, consider the following IDL struct:<p>
</a><a name="511215">
<blockquote>// IDL<br>struct MyStruct {<br>						long lmem;<br>						short smem;<br>};</blockquote>
</a><a name="511220">
<img src="local/images/plusa158.gif">Such a struct could be extracted from an Any as follows:<p>
</a><a name="511221">
 // C++<br>Any a;<br>// ... a is somehow given a value of type MyStruct ...<br>MyStruct *struct_ptr;<br>if (a &gt;&gt;= struct_ptr) {<br>	// ... use the value ...<br>}<p>
</a><a name="511226">
<img src="local/images/plusa159.gif">If the extraction is successful, the caller's pointer will point to storage managed by the Any, and operator&gt;&gt;= will return TRUE. The caller must not try to delete or otherwise release this storage. The caller also should not use the storage after the contents of the Any variable are replaced via assignment, insertion, or the replace function, or after the Any variable is destroyed. Care must be taken to avoid using T_var types with these extraction operators, since they will try to assume responsibility for deleting the storage owned by the Any.<p>
</a><a name="511232">
<img src="local/images/plusa160.gif">If the extraction is not successful, the value of the caller's pointer is set equal to the null pointer, and operator&gt;&gt;= returns FALSE.<p>
</a><a name="511239">
<img src="local/images/plusa161.gif">Correct extraction of array types relies on the Array_forany types described in <a href="pluscon.html#510942">Section &#32;16.12, "Mapping For Array Types," on page &#32;16-26</a>.<p>
</a><a name="511241">
<blockquote>// IDL<br>typedef long A[20];<br>typedef A B[30][40][50];</blockquote>
</a><a name="516089">
 // C++<br>typedef Long A[20];<br>typedef Long A_slice;<br>class A_forany { ... };<br>typedef A B[30][40][50];<br>typedef A B_slice[40][50];<br>class B_forany { ... };<br><br>Boolean operator&gt;&gt;=(const Any &amp;, A_forany&amp;);																		// for type A<br>Boolean operator&gt;&gt;=(const Any &amp;, B_forany&amp;);																		// for type B<p>
</a><a name="511248">
<img src="local/images/plusa162.gif">The Array_forany types are always passed to operator&gt;&gt;= by reference.<p>
</a><a name="516674">
<img src="local/images/plusa163.gif">For strings and arrays, applications are responsible for checking the TypeCode of the Any to be sure that they do not overstep the bounds of the array or string object when using the extracted value.<p>
</a><a name="517520">
<img src="local/images/plusa164.gif"><img src="local/images/plusa165.gif">The operator&gt;&gt;= is also supported on the Any_var type. Note that due to the conversion operators that convert Any_var to const Any&amp; for parameter passing, only those operator&gt;&gt;= functions defined as member function of Any need to be explicitly defined for Any_var.<p>
</a></ul><a name="516681">
<h2>	16.14.4	 	Distinguishing boolean, octet, char, and bounded string</h2>
</a><a name="511260">
 <img src="local/images/plusa166.gif">Since the <strong>boolean</strong>, <strong>octet</strong>, and <strong>char</strong> OMG IDL types are not required to map to distinct C++ types, another means of distinguishing them from each other is necessary so that they can be used with the type-safe Any interface. Similarly, since both bounded and unbounded strings map to char*, another means of distinguishing them must be provided. This is done by introducing several new helper types nested in the Any class interface. For example, this can be accomplished as shown below:<p>
</a><a name="517551">
 // C++<br>class Any<br>{<br> &#32; &#32;public:<br>	// special helper types needed for boolean, octet, char,<br>	// and bounded string insertion<br>	struct from_boolean {<br>		from_boolean(Boolean b) : val(b) {}<br>		Boolean val;<br>	};<br>	struct from_octet {<br>		from_octet(Octet o) : val(o) {}<br>		Octet val;<br>	};<br>	struct from_char {<br>		from_char(Char c) : val(c) {}<br>		Char val;<br>	};<br>	struct from_string {<br>		from_string(char* s, ULong b,<br>				Boolean nocopy = FALSE) :<br>			val(s), bound(b) {}<br>		char *val;<br>		ULong bound;<br>	};<br><br>	void operator&lt;&lt;=(from_boolean);<br>	void operator&lt;&lt;=(from_char);<br>	void operator&lt;&lt;=(from_octet);<br>	void operator&lt;&lt;=(from_string);<br><br>	// special helper types needed for boolean, octet,<br>	// char, and bounded string extraction<br>	struct to_boolean {<br>		to_boolean(Boolean &amp;b) : ref(b) {}<br>		Boolean &amp;ref;<br>	};<br>	struct to_char {<br>		to_char(Char &amp;c) : ref(c) {}<br>		Char &amp;ref;<br>	};<br>	struct to_octet {<br>		to_octet(Octet &amp;o) : ref(o) {}<br>		Octet &amp;ref;<br>	};<br>	struct to_string {<br>		to_string(char *&amp;s, ULong b) : val(s), bound(b) {}<br>		char *&amp;val;<br>		ULong bound;<br>	};<br><br>	Boolean operator&gt;&gt;=(to_boolean) const;<br>	Boolean operator&gt;&gt;=(to_char) const;<br>	Boolean operator&gt;&gt;=(to_octet) const;<br>	Boolean operator&gt;&gt;=(to_string) const;<br><br>	// other public Any details omitted<br><br>private:<br>	// these functions are private and not implemented<br>	// hiding these causes compile-time errors for<br>	// unsigned char<br>	void operator&lt;&lt;=(unsigned char);<br>	Boolean operator&gt;&gt;=(unsigned char &amp;) const;<br>};<p>
</a><a name="511267">
<img src="local/images/plusa167.gif">An ORB implementation provides the overloaded operator&lt;&lt;= and operator&gt;&gt;= functions for these special helper types. These helper types are used as shown here:<p>
</a><a name="511268">
 // C++<br>Boolean b = TRUE;<br>Any any;<br>any &lt;&lt;= Any::from_boolean(b);<br>// ...<br>if (any &gt;&gt;= Any::to_boolean(b)) {<br>	// ...any contained a Boolean...<br>}<br><br>char* p = "bounded";<br>any &lt;&lt;= Any::from_string(p, 8);<br>// ...<br>if (any &gt;&gt;= Any::to_string(p, 8)) {<br>	// ...any contained a string&lt;8&gt;...<br>}<p>
</a><a name="519106">
<img src="local/images/plusa168.gif">A bound value of 0 (zero) indicates an unbounded string.<p>
</a><a name="519097">
<img src="local/images/plusa169.gif">For non-copying insertion of a bounded or unbounded string into an Any, the nocopy flag on the from_string constructor should be set to TRUE:<p>
</a><a name="519118">
 // C++<br>char* p = string_alloc(8);<br>// ...initialize string p...<br>any &lt;&lt;= Any::from_string(p, 8, 1);	// any consumes p<p>
</a><a name="511273">
<img src="local/images/plusa170.gif">Assuming that <strong>boolean</strong>, <strong>char</strong>, and <strong>octet</strong> all map the C++ type unsigned char, the private and unimplemented operator&lt;&lt;= and operator&gt;&gt;= functions for unsigned char will cause a compile-time error if straight insertion or extraction of any of the Boolean, Char, or Octet types is attempted:<p>
</a><a name="511274">
 // C++<br>Octet oct = 040;<br>Any any;<br>any &lt;&lt;= oct;				// this line will not compile<br>any &lt;&lt;= Any::from_octet(oct);				// but this one will<p>
</a><a name="511279">
<img src="local/images/plusa171.gif">It is important to note that the example shown above is only one possible implementation for these helpers, not a mandated one. Other compliant implementations are possible, such as providing them via inlined static Any member functions if <strong>boolean</strong>, <strong>char</strong>, and <strong>octet</strong> are in fact mapped to distinct C++ types. All compliant C++ mapping implementations must provide these helpers, however, for purposes of portability.<p>
</a><a name="517087">
<h2>	16.14.5	 Widening to Object</h2>
</a><a name="517088">
<img src="local/images/plusa172.gif">Sometimes it is desirable to extract an object reference from an Any as the base Object type. This can be accomplished using a helper type similar to those required for extracting Boolean, Char, and Octet:<p>
</a><a name="517089">
 // C++<br>class Any<br>{<br> &#32; &#32;public:<br>	...<br>	struct to_object {<br>		to_object(Object_ptr &amp;obj) : ref(obj) {}<br>		Object_ptr &amp;ref;<br>	};<br>	Boolean operator&gt;&gt;=(to_object) const;<br>	...<br>};<p>
</a><a name="517076">
<img src="local/images/plusa173.gif">The to_object helper type is used to extract an object reference from an Any as the base Object type. If the Any contains a value of an object reference type as indicated by its TypeCode, the extraction function operator&gt;&gt;=(to_object) explicitly widens its contained object reference to Object and returns true, otherwise it returns false. This is the only object reference extraction function that performs widening on the extracted object reference. As with regular object reference extraction, no duplication of the object reference is performed by the to_object extraction operator.<p>
</a><a name="511282">
<h2>	16.14.6	 	Handling Untyped Values</h2>
</a><a name="511287">
 <img src="local/images/plusa174.gif">Under some circumstances the type-safe interface to Any is not sufficient. An example is a situation in which data types are read from a file in binary form and used to create values of type Any. For these cases, the Any class provides a constructor with an explicit <strong>TypeCode</strong> and generic pointer:<p>
</a><a name="511289">
 // C++<br>Any(TypeCode_ptr tc, void *value, Boolean release = FALSE);<p>
</a><a name="516207">
<img src="local/images/plusa175.gif">The constructor is responsible for duplicating the given TypeCode pseudo object reference. If the release parameter is TRUE, then the Any object assumes ownership of the storage pointed to by the value parameter. A compliant application should make no assumptions about the continued lifetime of the value parameter once it has been handed to an Any with release=TRUE, since a compliant Any implementation is allowed to copy the value parameter and immediately free the original pointer. If the release parameter is FALSE (the default case), then the Any object assumes the caller will manage the memory pointed to by value.  The value parameter can be a null pointer.<p>
</a><a name="516213">
<img src="local/images/plusa176.gif">The Any class also defines three unsafe operations:<p>
</a><a name="511303">
 // C++<br>void replace(<br>	TypeCode_ptr,<br>	void *value,<br>	Boolean release = FALSE<br>);<br>TypeCode_ptr type() const;<br>const void *value() const;<p>
</a><a name="511309">
<img src="local/images/plusa177.gif">The replace function is intended to be used with types that cannot be used with the type-safe insertion interface, and so is similar to the constructor described above. The existing <strong>TypeCode</strong> is released and value storage deallocated, if necessary. The <strong>TypeCode </strong>function parameter is duplicated. If the release parameter is TRUE, then the Any object assumes ownership for the storage pointed to by the value parameter. A compliant application should make no assumptions about the continued lifetime of the value parameter once it has been handed to the Any::replace function with release=TRUE, since a compliant Any implementation is allowed to copy the value parameter and immediately free the original pointer. If the release parameter is FALSE (the default case), then the Any object assumes the caller will manage the memory occupied by the value.  The value parameter of the replace function can be a null pointer.<p>
</a><a name="516221">
<img src="local/images/plusa178.gif">For C++ mapping implementations that use <code>Environment</code> parameters to pass exception information, the default release argument can be simulated by providing two overloaded replace functions, one that takes a non-defaulted release parameter and one that takes no release parameter. The second function simply invokes the first with the release parameter set to FALSE.<p>
</a><a name="511314">
<img src="local/images/plusa179.gif">Note that neither the constructor shown above nor the replace function is type-safe. In particular, no guarantees are made by the compiler or runtime as to the consistency between the TypeCode and the actual type of the void* argument. The behavior of an ORB implementation when presented with an Any that is constructed with a mismatched TypeCode and value is not defined.<p>
</a><a name="511320">
<img src="local/images/plusa180.gif">The type function returns a TypeCode_ptr pseudo-object reference to the <strong>TypeCode</strong> associated with the Any. Like all object reference return values, the caller must release the reference when it is no longer needed, or assign it to a TypeCode_var variable for automatic management.<p>
</a><a name="517165">
 <img src="local/images/plusa181.gif">The value function returns a pointer to the data stored in the Any. If the Any has no associated value, the value function returns a null pointer. The type to which the void* returned by the value function may be cast depends on the ORB implementation; thus, use of the value function is not portable across ORB implementations and its usage is therefore deprecated. Note that ORB implementations are allowed to make stronger guarantees about the void* returned from the value function, if so desired. <p>
</a><a name="511485">
<h2>	16.14.7	 Any Constructors, Destructor, Assignment Operator</h2>
</a><a name="511490">
 <img src="local/images/plusa182.gif">The default constructor creates an Any with a <strong>TypeCode</strong> of type <strong>tk_null</strong>, and no value. The copy constructor calls _duplicate on the TypeCode_ptr of its Any parameter and deep-copies the parameter's value. The assignment operator releases its own TypeCode_ptr and deallocates storage for the current value if necessary, then duplicates the TypeCode_ptr of its Any parameter and deep-copies the parameter's value. The destructor calls release on the TypeCode_ptr and deallocates storage for the value, if necessary.<p>
</a><a name="511499">
<img src="local/images/plusa183.gif">Other constructors are described in <a href="pluscon.html#511282">Section &#32;16.14.6, "Handling Untyped Values," on page &#32;16-36</a>.<p>
</a><a name="511504">
<img src="local/images/plusa184.gif">ORB implementations concerned with single-process interoperability with the C mapping may overload operator new() and operator delete() for Anys so that dynamic allocation uses the same mechanism as the C language dynamic allocation functions. Whether these operators are overloaded by the implementation or not, compliant programs use new to dynamically allocate anys and delete to free them.<p>
</a><a name="512949">
<h2>	16.14.8	 The Any Class</h2>
</a><a name="512953">
 <img src="local/images/plusa185.gif">The full definition of the Any class can be found in <a href="plusdef.html#95">"Any Class" on page &#32;C-2</a>.<p>
</a><a name="512954">
<h2>	16.14.9	 The Any_var Class</h2>
</a><a name="511521">
 <img src="local/images/plusa186.gif">Since Anys are returned via pointer as <strong>out</strong> and return parameters (see <a href="pluscon.html#518293">Table 24 on page 16-44</a>), there exists an Any_var class similar to the T_var classes for object references. Any_var obeys the rules for T_var classes described in <a href="pluscon.html#510503"> Section 16.8</a>, calling delete on its Any* when it goes out of scope or is otherwise destroyed. The full interface of the Any_var class is shown in <a href="plusdef.html#54">Section &#32;C.4, "Any_var Class," on page &#32;C-4</a>.<p>
</a><a name="511532">
<h1>	16.15	 Mapping for Exception Types</h1>
</a><a name="511537">
 <img src="local/images/plusa187.gif">An OMG IDL exception is mapped to a C++ class that derives from the standard UserException class defined in the <strong>CORBA</strong> module (see <a href="pluscon.html#510092">Section &#32;16.1.3, "CORBA Module," on page &#32;16-2</a>). The generated class is like a variable-length struct, regardless of whether or not the exception holds any variable-length members. Just as for variable-length structs, each exception member must be self-managing with respect to its storage.<p>
</a><a name="511546">
<img src="local/images/plusa188.gif">The copy constructor, assignment operator, and destructor automatically copy or free the storage associated with the exception. For convenience, the mapping also defines a constructor with one parameter for each exception member-this constructor initializes the exception members to the given values. For exception types that have a string member, this constructor should take a const char* parameter, since the constructor must copy the string argument. Similarly, constructors for exception types that have an object reference member must call _duplicate on the corresponding object reference constructor parameter. The default constructor performs no explicit member initialization.<p>
</a><a name="511552">
<img src="local/images/plusa189.gif">The UserException class is derived from a base Exception class, which is also defined in the <strong>CORBA</strong> module.<p>
</a><a name="511557">
<img src="local/images/plusa190.gif">All standard exceptions are derived from a SystemException class, also defined in the <strong>CORBA</strong> module. Like UserException, SystemException is derived from the base Exception class. The SystemException class interface is shown below.<p>
</a><a name="511559">
 // C++<br>enum CompletionStatus {<br>	COMPLETED_YES,<br>	COMPLETED_NO,<br>	COMPLETED_MAYBE<br>};<br>class SystemException : public Exception<br>{<br> &#32; &#32;public:<br>	SystemException();<br>	SystemException(const SystemException &amp;);<br>	SystemException(ULong minor, CompletionStatus status);<br>	~SystemException();<br>	SystemException &amp;operator=(const SystemException &amp;);<br><br>	ULong minor() const;<br>	void minor(ULong);<br><br>	CompletionStatus completed() const;<br>	void completed(CompletionStatus);<br>};<p>
</a><a name="516574">
<img src="local/images/plusa191.gif">The default constructor for SystemException causes minor() to return 0 and completed() to return COMPLETED_NO.<p>
</a><a name="511568">
<img src="local/images/plusa192.gif">Each specific system exception (described in <a href="cmap.html#484">Section &#32;14.1.6, "Exceptions," on page &#32;14-3</a>) is derived from SystemException:<p>
</a><a name="511569">
 // C++<br>class UNKNOWN : public SystemException { ... };<br>class BAD_PARAM : public SystemException { ... };<br>// etc.<p>
</a><a name="511574">
<img src="local/images/plusa193.gif">All specific system exceptions are defined within the <strong>CORBA</strong> module.<p>
</a><a name="511579">
<img src="local/images/plusa194.gif">This exception hierarchy allows any exception to be caught by simply catching the Exception type:<p>
</a><a name="511580">
 // C++<br>try {<br>	...<br>} catch (const Exception &amp;exc) {<br>	...<br>}<p>
</a><a name="511585">
<img src="local/images/plusa195.gif">Alternatively, all user exceptions can be caught by catching the UserException type, and all system exceptions can be caught by catching the SystemException type:<p>
</a><a name="511586">
 // C++<br>try {<br>	...<br>} catch (const UserException &amp;ue) {<br>	...<br>} catch (const SystemException &amp;se) {<br>	...<br>}<p>
</a><a name="511594">
<img src="local/images/plusa196.gif">Naturally, more specific types can also appear in catch clauses.<p>
</a><a name="511602">
<img src="local/images/plusa197.gif">Exceptions are normally thrown by value and caught by reference. This approach lets the exception destructor release storage automatically.<p>
</a><a name="511609">
<img src="local/images/plusa198.gif">C++ compilers that support official C++ Run Time Type Information (RTTI) need not support narrowing for the Exception hierarchy. RTTI supports, among other things, determination of the run-time type of a C++ object. In particular, the dynamic_cast&lt;T*&gt; operator<a href="#511613"><sup>11</sup></a> allows for narrowing from a base pointer to a more derived pointer if the object pointed to really is of the more derived type. This operator is not useful for narrowing object references, since it cannot determine the actual type of remote objects, but it can be used to narrow within the exception hierarchy. Since catch clauses can catch by type, this feature is mainly of use for narrowing exceptions received via Environments from the DII.<p>
</a><a name="511618">
<img src="local/images/plusa199.gif">For those C++ environments that do not support dynamic_cast&lt;T*&gt;, the exception hierarchy provides a narrowing mechanism. This is described in<a href="plusalt.html#298">"Without Run-Time Type Information (RTTI)" on page &#32;D-3</a>.<p>
</a><a name="516251">
<img src="local/images/plusa200.gif">Request invocations made through the DII may result in user-defined exceptions that cannot be fully represented in the calling program because the specific exception type was not known at compile-time. The mapping provides the UnknownUserException so that such exceptions can be represented in the calling process:<p>
</a><a name="516260">
 // C++<br>class UnknownUserException : public UserException<br>{<br> &#32; &#32;public:<br>	Any &amp;exception();<br>};<p>
</a><a name="516261">
As shown here, UnknownUserException is derived from UserException. It provides the exception() accessor that returns an Any holding the actual exception. Ownership of the returned Any is maintained by the UnknownUserException-the Any merely allows access to the exception data. Conforming applications should never explicitly throw exceptions of type UnknownUserException-it is intended for use with the DII.<p>
</a><a name="511622">
<h1>	16.16	 Mapping For Operations and Attributes</h1>
</a><a name="511627">
 <img src="local/images/plusa201.gif">An operation maps to a C++ function with the same name as the operation. Each read-write attribute maps to a pair of overloaded C++ functions (both with the same name), one to set the attribute's value and one to get the attribute's value. The <em>set</em> function takes an <strong>in</strong> parameter with the same type as the attribute, while the <em>get</em> function takes no parameters and returns the same type as the attribute. An attribute marked <strong>readonly</strong> maps to only one C++ function, to get the attribute's value. Parameters and return types for attribute functions obey the same parameter passing rules as for regular operations.<p>
</a><a name="511638">
<img src="local/images/plusa202.gif">OMG IDL <strong>oneway</strong> operations are mapped the same as other operations; that is, there is no way to know by looking at the C++ whether an operation is <strong>oneway</strong> or not.<p>
</a><a name="511644">
<img src="local/images/plusa203.gif">The mapping does not define whether exceptions specified for an OMG IDL operation are part of the generated operation's type signature or not.<p>
</a><a name="511645">
<blockquote>// IDL<br>interface A<br>{<br>						void f();<br>						oneway void g();<br>						attribute long x;<br>};</blockquote>
</a><a name="511647">
 // C++<br>A_var a;<br>a-&gt;f();<br>a-&gt;g();<br>Long n = a-&gt;x();<br>a-&gt;x(n + 1);<p>
</a><a name="511652">
<img src="local/images/plusa204.gif">Unlike the C mapping, C++ operations do not require an additional <strong>Environment</strong> parameter for passing exception information-real C++ exceptions are used for this purpose. See <a href="pluscon.html#511532">Section &#32;16.15, "Mapping for Exception Types," on page &#32;16-38</a> and <a href="plusalt.html#102">"Without Exception Handling" on page &#32;D-1</a> for more details.<p>
</a><a name="511660">
<h1>	16.17	 Implicit Arguments to Operations</h1>
</a><a name="511665">
 <img src="local/images/plusa205.gif">If an operation in an OMG IDL specification has a context specification, then a Context_ptr input parameter (see <a href="pluspo.html#282">Section &#32;17.8.1, "Context Interface," on page &#32;17-8</a>) follows all operation-specific arguments. In an implementation that does not support real C++ exceptions, an output <strong>Environment</strong> parameter is the last argument, following all operation-specific arguments, and following the context argument if present. The parameter passing mode for <strong>Environment</strong> is described in <a href="plusalt.html#102">"Without Exception Handling" on page &#32;D-1</a>.<p>
</a><a name="511674">
<h1>	16.18	 Argument Passing Considerations</h1>
</a><a name="511681">
 <img src="local/images/plusa206.gif">The mapping of parameter passing modes attempts to balance the need for both efficiency and simplicity. For primitive types, enumerations, and object references, the modes are straightforward, passing the type <em>P</em> for primitives and enumerations and the type A_ptr for an interface type <em>A</em>.<p>
</a><a name="511688">
<img src="local/images/plusa207.gif">Aggregate types are complicated by the question of when and how parameter memory is allocated and deallocated. Mapping <strong>in</strong> parameters is straightforward because the parameter storage is caller-allocated and read-only. The mapping for <strong>out</strong> and <strong>inout</strong> parameters is more problematic. For variable-length types, the callee must allocate some if not all of the storage. For fixed-length types, such as a <em>Point</em> type represented as a struct containing three floating point members, caller allocation is preferable (to allow stack allocation).<p>
</a><a name="511695">
<img src="local/images/plusa208.gif">To accommodate both kinds of allocation, avoid the potential confusion of split allocation, and eliminate confusion with respect to when copying occurs, the mapping is T&amp; for a fixed-length aggregate T and T*&amp; for a variable-length T. This approach has the unfortunate consequence that usage for structs depends on whether the struct is fixed- or variable-length; however, the mapping is consistently T_var&amp; if the caller uses the managed type T_var.<p>
</a><a name="511700">
<img src="local/images/plusa209.gif">The mapping for <strong>out</strong> and <strong>inout</strong> parameters additionally requires support for deallocating any previous variable-length data in the parameter when a T_var is passed. Even though their initial values are not sent to the operation, we include <strong>out</strong> parameters because the parameter could contain the result from a previous call. There are many ways to implement this support. The mapping does not require a specific implementation, but a compliant implementation must free the inaccessible storage associated with a parameter passed as a T_var managed type. The following examples demonstrate the compliant behavior:<p>
</a><a name="511701">
<blockquote>// IDL<br>struct S { string name; float age; };<br>void f(out S p);</blockquote>
</a><a name="511703">
 // C++<br>S_var s;<br>f(s);<br>// use s<br>f(s); // first result will be freed<br><br>S *sp; // need not initialize before passing to out<br>f(sp);<br>// use sp<br>delete sp; // cannot assume next call will free old value<br>f(sp);<p>
</a><a name="516603">
<img src="local/images/plusa210.gif">Note that implicit deallocation of previous values for <strong>out</strong> and <strong>inout</strong> parameters works only with T_var types, not with other types:<p>
</a><a name="516604">
<blockquote>// IDL<br>void q(out string s);</blockquote>
</a><a name="516608">
 // C++<br>char *s;<br>for (int i = 0; i &lt; 10; i++)<br>	q(s);		// memory leak!<p>
</a><a name="516612">
<img src="local/images/plusa211.gif">Each call to the q function in the loop results in a memory leak because the caller is not invoking string_free on the <strong>out</strong> result. There are two ways to fix this, as shown below:<p>
</a><a name="516633">
 // C++<br>char *s;<br>String_var svar;<br>for (int i = 0 ; i &lt; 10; i++) {<br>	q(s);<br>	string_free(s);			// explicit deallocation<br>	// OR:<br>	q(svar);			// implicit deallocation<br>}<p>
</a><a name="516634">
<img src="local/images/plusa212.gif">Using a plain char* for the <strong>out</strong> parameter means that the caller must explicitly deallocate its memory before each reuse of the variable as an <strong>out</strong> parameter, while using a String_var means that any deallocation is performed implicitly upon each use of the variable as an <strong>out</strong> parameter.<p>
</a><a name="511708">
<img src="local/images/plusa213.gif">Variable-length data must be explicitly released before being overwritten. For example, before assigning to an <strong>inout</strong> string parameter, the implementor of an operation may first delete the old character data. Similarly, an <strong>inout</strong> interface parameter should be released before being reassigned. One way to ensure that the parameter storage is released is to assign it to a local T_var variable with an automatic release, as in the following example:<p>
</a><a name="511711">
<blockquote>// IDL<br>interface A;<br>void f(inout string s, inout A obj);</blockquote>
</a><a name="516057">
 // C++<br>void Aimpl::f(char *&amp;s, A_ptr &amp;obj) {<br>	String_var s_tmp = s;<br>	s = /* new data */;<br>	A_var obj_tmp = obj;<br>	obj = /* new reference */<br>}<p>
</a><a name="511720">
<img src="local/images/plusa214.gif">To allow the callee the freedom to allocate a single contiguous area of storage for all the data associated with a parameter, we adopt the policy that the callee-allocated storage is not modifiable by the caller. However, trying to enforce this policy by returning a const type in C++ is problematic, since the caller is required to release the storage, and calling delete on a const object is an error<a href="#518842"><sup>12</sup></a>. A compliant mapping therefore is not required to detect this error.<p>
</a><a name="511727">
<img src="local/images/plusa215.gif">For parameters that are passed or returned as a pointer (T*) or reference to pointer (T*&amp;), a compliant program is not allowed to pass or return a null pointer; the result of doing so is undefined. In particular, a caller may not pass a null pointer under any of the following circumstances:<p>
</a><ul><a name="511729">
<li><strong>in</strong> and <strong>inout</strong> string
</a><a name="511730">
<li><strong>in</strong> and <strong>inout</strong> array (pointer to first element)
</a><a name="511735">
A caller may pass a reference to a pointer with a null value for <strong>out</strong> parameters, however, since the callee does not examine the value but rather just overwrites it. A callee may not return a null pointer under any of the following circumstances:<p>
</a><a name="511736">
<li><strong>out</strong> and return variable-length struct
</a><a name="511737">
<li><strong>out</strong> and return variable-length union
</a><a name="511738">
<li><strong>out</strong> and return string
</a><a name="511739">
<li>	<strong>out</strong> and return sequence
</a><a name="511740">
<li><strong>out</strong> and return variable-length array, return fixed-length array
</a><a name="511741">
<li>	<strong>out</strong> and return any
</a><a name="511746">
<img src="local/images/plusa216.gif">Since OMG IDL has no concept of pointers in general or null pointers in particular, allowing the passage of null pointers to or from an operation would project C++ semantics onto OMG IDL operations.<a href="#511749"><sup>13</sup></a> A compliant implementation is allowed but not required to raise a <strong>BAD_PARAM</strong> exception if it detects such an error.<p>
</a><a name="511761">
<img src="local/images/plusa217.gif"><a href="pluscon.html#518293">Table 24 on page 16-44</a> displays the mapping for the basic OMG IDL parameter passing modes and return type according to the type being passed or returned, while <a href="pluscon.html#518625">Table 25 on page 16-45</a> displays the same information for T_var types. <a href="pluscon.html#518625">Table &#32;25</a> is merely for informational purposes; it is expected that operation signatures will be written in terms of the parameter passing modes shown in <a href="pluscon.html#518293">Table &#32;24</a>, and that T_var types will support the necessary conversion operators to allow them to be passed directly.<p>
</a><a name="518293">
<img src="local/images/plusa218.gif">In <a href="pluscon.html#518293">Table &#32;24</a>, fixed-length arrays are the only case where the type of an <strong>out</strong> parameter differs from a return value, which is necessary because C++ does not allow a function to return an array. The mapping returns a pointer to a <em>slice</em> of the array, where a slice is an array with all the dimensions of the original specified except the first one. 
<Table Border="3">
<caption><a name="518301">
TABLE 24.  Basic Argument and Result Passing<p>
</a></caption>
<tr><th><a name="518311">
 Data Type<p>
</a><th><a name="518313">
 In<p>
</a><th><a name="518315">
 Inout<p>
</a><th><a name="518317">
 Out<p>
</a><th><a name="518319">
 Return<p>
</a>
<tr><td><a name="518321">
 short<p>
</a><td><a name="518323">
 Short<p>
</a><td><a name="518325">
 Short&amp;<p>
</a><td><a name="518327">
 Short&amp;<p>
</a><td><a name="518329">
 Short<p>
</a>
<tr><td><a name="518331">
 long<p>
</a><td><a name="518333">
 Long<p>
</a><td><a name="518335">
 Long&amp;<p>
</a><td><a name="518337">
 Long&amp;<p>
</a><td><a name="518339">
 Long<p>
</a>
<tr><td><a name="518341">
 unsigned short<p>
</a><td><a name="518343">
 UShort<p>
</a><td><a name="518345">
 UShort&amp;<p>
</a><td><a name="518347">
 UShort&amp;<p>
</a><td><a name="518349">
 UShort<p>
</a>
<tr><td><a name="518351">
 unsigned long<p>
</a><td><a name="518353">
 ULong<p>
</a><td><a name="518355">
 ULong&amp;<p>
</a><td><a name="518357">
 ULong&amp;<p>
</a><td><a name="518359">
 ULong<p>
</a>
<tr><td><a name="518361">
 float<p>
</a><td><a name="518363">
 Float<p>
</a><td><a name="518365">
 Float&amp;<p>
</a><td><a name="518367">
 Float&amp;<p>
</a><td><a name="518369">
 Float<p>
</a>
<tr><td><a name="518371">
 double<p>
</a><td><a name="518373">
 Double<p>
</a><td><a name="518375">
 Double&amp;<p>
</a><td><a name="518377">
 Double&amp;<p>
</a><td><a name="518379">
 Double<p>
</a>
<tr><td><a name="518381">
 boolean<p>
</a><td><a name="518383">
 Boolean<p>
</a><td><a name="518385">
 Boolean&amp;<p>
</a><td><a name="518387">
 Boolean&amp;<p>
</a><td><a name="518389">
 Boolean<p>
</a>
<tr><td><a name="518391">
 char<p>
</a><td><a name="518393">
 Char<p>
</a><td><a name="518395">
 Char&amp;<p>
</a><td><a name="518397">
 Char&amp;<p>
</a><td><a name="518399">
 Char<p>
</a>
<tr><td><a name="518401">
 octet<p>
</a><td><a name="518403">
 Octet<p>
</a><td><a name="518405">
 Octet&amp;<p>
</a><td><a name="518407">
 Octet&amp;<p>
</a><td><a name="518409">
 Octet<p>
</a>
<tr><td><a name="518411">
 enum<p>
</a><td><a name="518413">
 enum<p>
</a><td><a name="518415">
 enum&amp;<p>
</a><td><a name="518417">
 enum&amp;<p>
</a><td><a name="518419">
 enum<p>
</a>
<tr><td><a name="518424">
 object reference ptr<a href="#518423"><sup>1</sup></a><p>
</a><td><a name="518426">
 objref_ptr<p>
</a><td><a name="518428">
 objref_ptr&amp;<p>
</a><td><a name="518430">
 objref_ptr&amp;<p>
</a><td><a name="518432">
 objref_ptr<p>
</a>
<tr><td><a name="518434">
 struct, fixed<p>
</a><td><a name="518436">
 const struct&amp;<p>
</a><td><a name="518438">
 struct&amp;<p>
</a><td><a name="518440">
 struct&amp;<p>
</a><td><a name="518442">
 struct<p>
</a>
<tr><td><a name="518444">
 struct, variable<p>
</a><td><a name="518446">
 const struct&amp;<p>
</a><td><a name="518448">
 struct&amp;<p>
</a><td><a name="518450">
 struct*&amp;<p>
</a><td><a name="518452">
 struct*<p>
</a>
<tr><td><a name="518454">
 union, fixed<p>
</a><td><a name="518456">
 const union&amp;<p>
</a><td><a name="518458">
 union&amp;<p>
</a><td><a name="518460">
 union&amp;<p>
</a><td><a name="518462">
 union<p>
</a>
<tr><td><a name="518464">
 union, variable<p>
</a><td><a name="518466">
 const union&amp;<p>
</a><td><a name="518468">
 union&amp;<p>
</a><td><a name="518470">
 union*&amp;<p>
</a><td><a name="518472">
 union*<p>
</a>
<tr><td><a name="518474">
 string<p>
</a><td><a name="518476">
 const char*<p>
</a><td><a name="518478">
 char*&amp;<p>
</a><td><a name="518480">
 char*&amp;<p>
</a><td><a name="518482">
 char*<p>
</a>
<tr><td><a name="518484">
 sequence<p>
</a><td><a name="518486">
 const sequence&amp;<p>
</a><td><a name="518488">
 sequence&amp;<p>
</a><td><a name="518490">
 sequence*&amp;<p>
</a><td><a name="518492">
 sequence*<p>
</a>
<tr><td><a name="518494">
 array, fixed<p>
</a><td><a name="518496">
 const array<p>
</a><td><a name="518498">
 array<p>
</a><td><a name="518500">
 array<p>
</a><td><a name="518505">
 array slice*<a href="#518504"><sup>2</sup></a><p>
</a>
<tr><td><a name="518507">
 array, variable<p>
</a><td><a name="518509">
 const array<p>
</a><td><a name="518511">
 array<p>
</a><td><a name="518513">
 array slice*&amp;2<p>
</a><td><a name="518515">
 array slice*2<p>
</a>
<tr><td><a name="518517">
 any<p>
</a><td><a name="518519">
 const any&amp;<p>
</a><td><a name="518521">
 any&amp;<p>
</a><td><a name="518523">
 any*&amp;<p>
</a><td><a name="518525">
 any*<p>
</a>

</Table>

<Table>
<tr><td><sup>1</sup><a name="518423">
 Including pseudo-object references.<p>
</a><sup>2</sup><a name="518504">
 A slice is an array with all the dimensions of the original except the first one.<p>
</a>
</Table>
<p>
</a><a name="518625">
<img src="local/images/plusa219.gif"> 
<Table Border="3">
<caption><a name="518533">
TABLE 25.  T_var Argument and Result Passing<p>
</a></caption>
<tr><th><a name="518543">
 Data Type<p>
</a><th><a name="518545">
 In<p>
</a><th><a name="518547">
 Inout<p>
</a><th><a name="518549">
 Out<p>
</a><th><a name="518551">
 Return<p>
</a>
<tr><td><a name="518556">
 object reference var<a href="#518555"><sup>1</sup></a><p>
</a><td><a name="518558">
 const objref_var&amp;<p>
</a><td><a name="518560">
 objref_var&amp;<p>
</a><td><a name="518562">
 objref_var&amp;<p>
</a><td><a name="518564">
 objref_var<p>
</a>
<tr><td><a name="518566">
 struct_var<p>
</a><td><a name="518568">
 const struct_var&amp;<p>
</a><td><a name="518570">
 struct_var&amp;<p>
</a><td><a name="518572">
 struct_var&amp;<p>
</a><td><a name="518574">
 struct_var<p>
</a>
<tr><td><a name="518576">
 union_var<p>
</a><td><a name="518578">
 const union_var&amp;<p>
</a><td><a name="518580">
 union_var&amp;<p>
</a><td><a name="518582">
 union_var&amp;<p>
</a><td><a name="518584">
 union_var<p>
</a>
<tr><td><a name="518586">
 string_var<p>
</a><td><a name="518588">
 const string_var&amp;<p>
</a><td><a name="518590">
 string_var&amp;<p>
</a><td><a name="518592">
 string_var&amp;<p>
</a><td><a name="518594">
 string_var<p>
</a>
<tr><td><a name="518596">
 sequence_var<p>
</a><td><a name="518598">
 const sequence_var&amp;<p>
</a><td><a name="518600">
 sequence_var&amp;<p>
</a><td><a name="518602">
 sequence_var&amp;<p>
</a><td><a name="518604">
 sequence_var<p>
</a>
<tr><td><a name="518606">
 array_var<p>
</a><td><a name="518608">
 const array_var&amp;<p>
</a><td><a name="518610">
 array_var&amp;<p>
</a><td><a name="518612">
 array_var&amp;<p>
</a><td><a name="518614">
 array_var<p>
</a>
<tr><td><a name="518616">
 any_var<p>
</a><td><a name="518618">
 const any_var&amp;<p>
</a><td><a name="518620">
 any_var&amp;<p>
</a><td><a name="518622">
 any_var&amp;<p>
</a><td><a name="518624">
 any_var<p>
</a>

</Table>

<Table>
<tr><td><sup>1</sup><a name="518555">
 Including pseudo-object references.<p>
</a>
</Table>
A caller is responsible for providing storage for all arguments passed as <strong>in</strong> arguments. <img src="local/images/plusa220.gif"><a href="pluscon.html#">Table 26 on page 16-45</a> and <a href="pluscon.html#512341">Table 27 on page 16-46</a> describe the caller's responsibility for storage associated with <strong>inout</strong> and <strong>out</strong> parameters and for return results. 
<Table Border="3">
<caption><a name="518641">
TABLE 26.  Caller Argument Storage Responsibilities<p>
</a></caption>
<tr><th><a name="518649">
 Type<p>
</a><th><a name="518651">
 Inout Param<p>
</a><th><a name="518653">
 Out Param<p>
</a><th><a name="518655">
 Return Result<p>
</a>
<tr><td><a name="518657">
 short<p>
</a><td><a name="518659">
 1<p>
</a><td><a name="518661">
 1<p>
</a><td><a name="518663">
 1<p>
</a>
<tr><td><a name="518665">
 long<p>
</a><td><a name="518667">
 1<p>
</a><td><a name="518669">
 1<p>
</a><td><a name="518671">
 1<p>
</a>
<tr><td><a name="518673">
 unsigned short<p>
</a><td><a name="518675">
 1<p>
</a><td><a name="518677">
 1<p>
</a><td><a name="518679">
 1<p>
</a>
<tr><td><a name="518681">
 unsigned long<p>
</a><td><a name="518683">
 1<p>
</a><td><a name="518685">
 1<p>
</a><td><a name="518687">
 1<p>
</a>
<tr><td><a name="518689">
 float<p>
</a><td><a name="518691">
 1<p>
</a><td><a name="518693">
 1<p>
</a><td><a name="518695">
 1<p>
</a>
<tr><td><a name="518697">
 double<p>
</a><td><a name="518699">
 1<p>
</a><td><a name="518701">
 1<p>
</a><td><a name="518703">
 1<p>
</a>
<tr><td><a name="518705">
 boolean<p>
</a><td><a name="518707">
 1<p>
</a><td><a name="518709">
 1<p>
</a><td><a name="518711">
 1<p>
</a>
<tr><td><a name="518713">
 char<p>
</a><td><a name="518715">
 1<p>
</a><td><a name="518717">
 1<p>
</a><td><a name="518719">
 1<p>
</a>
<tr><td><a name="518721">
 octet<p>
</a><td><a name="518723">
 1<p>
</a><td><a name="518725">
 1<p>
</a><td><a name="518727">
 1<p>
</a>
<tr><td><a name="518729">
 enum<p>
</a><td><a name="518731">
 1<p>
</a><td><a name="518733">
 1<p>
</a><td><a name="518735">
 1<p>
</a>
<tr><td><a name="518737">
 object reference ptr<p>
</a><td><a name="518739">
 2<p>
</a><td><a name="518741">
 2<p>
</a><td><a name="518743">
 2<p>
</a>
<tr><td><a name="518745">
 struct, fixed<p>
</a><td><a name="518747">
 1<p>
</a><td><a name="518749">
 1<p>
</a><td><a name="518751">
 1<p>
</a>
<tr><td><a name="518753">
 struct, variable<p>
</a><td><a name="518755">
 1<p>
</a><td><a name="518757">
 3<p>
</a><td><a name="518759">
 3<p>
</a>
<tr><td><a name="518761">
 union, fixed<p>
</a><td><a name="518763">
 1<p>
</a><td><a name="518765">
 1<p>
</a><td><a name="518767">
 1<p>
</a>
<tr><td><a name="518769">
 union, variable<p>
</a><td><a name="518771">
 1<p>
</a><td><a name="518773">
 3<p>
</a><td><a name="518775">
 3<p>
</a>
<tr><td><a name="518777">
 string<p>
</a><td><a name="518779">
 4<p>
</a><td><a name="518781">
 3<p>
</a><td><a name="518783">
 3<p>
</a>
<tr><td><a name="518785">
 sequence<p>
</a><td><a name="518787">
 5<p>
</a><td><a name="518789">
 3<p>
</a><td><a name="518791">
 3<p>
</a>
<tr><td><a name="518793">
 array, fixed<p>
</a><td><a name="518795">
 1<p>
</a><td><a name="518797">
 1<p>
</a><td><a name="518799">
 6<p>
</a>
<tr><td><a name="518801">
 array, variable<p>
</a><td><a name="518803">
 1<p>
</a><td><a name="518805">
 6<p>
</a><td><a name="518807">
 6<p>
</a>
<tr><td><a name="518809">
 any<p>
</a><td><a name="518811">
 5<p>
</a><td><a name="518813">
 3<p>
</a><td><a name="518815">
 3<p>
</a>

</Table>

<Table>
<tr><td>
</Table>
<p>
</a><a name="512341">
 
<Table Border="3">
<caption><a name="512304">
TABLE 27.  Argument Passing Cases<p>
</a></caption>
<tr><th><a name="512314">
 Case<a href="#512313"><sup>1</sup></a><p>
</a><th><a name="512316">
 <p>
</a>
<tr><td><a name="512318">
 1<p>
</a><td><a name="512320">
 Caller allocates all necessary storage, except that which may be encapsulated and managed within the parameter itself. For inout parameters, the caller provides the initial value, and the callee may change that value. For out parameters, the caller allocates the storage but need not initialize it, and the callee sets the value. Function returns are by value.<p>
</a>
<tr><td><a name="512322">
 2<p>
</a><td><a name="512324">
 Caller allocates storage for the object reference. For inout parameters, the caller provides an initial value; if the callee wants to reassign the inout parameter, it will first call CORBA::release on the original input value. To continue to use an object reference passed in as an inout, the caller must first duplicate the reference. The caller is responsible for the release of all out and return object references. Release of all object references embedded in other structures is performed automatically by the structures themselves.<p>
</a>
<tr><td><a name="512326">
 3<p>
</a><td><a name="518860">
 For out parameters, the caller allocates a pointer and passes it by reference to the callee. The callee sets the pointer to point to a valid instance of the parameter's type. For returns, the callee returns a similar pointer. The callee is not allowed to return a null pointer in either case. In both cases, the caller is responsible for releasing the returned storage. To maintain local/remote transparency, the caller must always release the returned storage, regardless of whether the callee is located in the same address space as the caller or is located in a different address space. Following the completion of a request, the caller is not allowed to modify any values in the returned storage-to do so, the caller must first copy the returned instance into a new instance, then modify the new instance.<p>
</a>
<tr><td><a name="512330">
 4<p>
</a><td><a name="512332">
 For inout strings, the caller provides storage for both the input string and the char* pointing to it. Since the callee may deallocate the input string and reassign the char* to point to new storage to hold the output value, the caller should allocate the input string using string_alloc(). The size of the out string is therefore not limited by the size of the in string. The caller is responsible for deleting the storage for the out using string_free(). The callee is not allowed to return a null pointer for an inout, out, or return value.<p>
</a>
<tr><td><a name="512334">
 5<p>
</a><td><a name="512336">
 For inout sequences and anys, assignment or modification of the sequence or any may cause deallocation of owned storage before any reallocation occurs, depending upon the state of the Boolean release parameter with which the sequence or any was constructed.<p>
</a>
<tr><td><a name="512338">
 6<p>
</a><td><a name="512340">
 For out parameters, the caller allocates a pointer to an array slice, which has all the same dimensions of the original array except the first, and passes the pointer by reference to the callee. The callee sets the pointer to point to a valid instance of the array. For returns, the callee returns a similar pointer. The callee is not allowed to return a null pointer in either case. In both cases, the caller is responsible for releasing the returned storage. To maintain local/remote transparency, the caller must always release the returned storage, regardless of whether the callee is located in the same address space as the caller or is located in a different address space. Following completion of a request, the caller is not allowed to modify any values in the returned storage-to do so, the caller must first copy the returned array instance into a new array instance, then modify the new instance.<p>
</a>

</Table>

<Table>
<tr><td><sup>1</sup><a name="512313">
 As listed in <a href="pluscon.html#">Table 26 on page 16-45</a><p>
</a>
</Table>
<p>
</a></ul>
<hr><br>
 
<a href="cover.html">[Top]</a> <a href="plusov.html">[Prev]</a> <a href="pluspo.html">[Next]</a> <a href="corb2pra.html">[Bottom]</a>
<hr><br>
 
<sup>1</sup><a name="510209">
 When T_ptr is mapped to T*, it is impossible in C++ to provide implicit widening between T_var types while also providing the necessary duplication semantics for T_ptr types.<p>
</a><sup>2</sup><a name="510213">
 This can be achieved by deriving all T_var types for object references from a base _var class, then making the assignment operator for _var private within each T_var type.<p>
</a><sup>3</sup><a name="510350">
 A recent change made to the C++ language by the ANSI/ISO C++ standardization committees allows static integer constants to be initialized within the class declaration, so for some C++ compilers, the code generation issues described here may not be a problem.<p>
</a><sup>4</sup><a name="510459">
 Examples and descriptions in this document still use TRUE and FALSE for purposes of clarity.<p>
</a><sup>5</sup><a name="510527">
 Transmissible pseudo-objects are listed as "general arguments" in <a href="appxtype.html#330">Section &#32;TBL. 14, "Pseudo-objects," on page &#32;A-2</a>.<p>
</a><sup>6</sup><a name="510636">
 Those implementations concerned with data layout compatibility with the C mapping in this manual will also want to ensure that the sizes of these members match those of their C mapping counterparts.<p>
</a><sup>7</sup><a name="516534">
 A separate modifier for String_var is needed because it can automatically convert to both a char* and a const char*; since unions provide modifiers for both of these types, an attempt to set a string member of a union from a String_var would otherwise result in an ambiguity error at compile time.<p>
</a><sup>8</sup><a name="516537">
 A return type of char* allowing read-write access could mistakenly be assigned to a String_var, resulting in the String_var and the union both assuming ownership for the string's storage.<p>
</a><sup>9</sup><a name="510940">
 Note that since T_var types do not handle const T*, there is no need to provide the const version of operator[] for Sequence_var types.<p>
</a><sup>10</sup><a name="519017">
 A mapping implementor may use the new C++ keyword "explicit" to prevent implicit conversions through the Array_forany constructor, but this feature is not yet widely available in current C++ compilers.<p>
</a><sup>11</sup><a name="511613">
 It is unlikely that a compiler would support RTTI without supporting exceptions, since much of a C++ exception handling implementation is based on RTTI mechanisms.<p>
</a><sup>12</sup><a name="518842">
 It is very likely that the upcoming ANSI/ISO C++ standard will allow delete on a const object, but many C++ compilers do not yet support this feature.<p>
</a><sup>13</sup><a name="511749">
 When real C++ exceptions are not available, however, it is important that null pointers are returned whenever an Environment containing an exception is returned; see <a href="plusalt.html#102">"Without Exception Handling" on page &#32;D-1</a> for more details.<p>
</a>

<address>
<a href="mailto:pubs@omg.org">pubs@omg.org</a>
</address>

<i>Copyright &#169; 1995, <a href="http://www.omg.org">Object Management Group.</a>  All rights
reserved.</i>

<!-- This file was created with Quadralay WebWorks Publisher 3.0.4 -->
<!-- -->
<!-- For more information on how this document, and how the rest of -->
<!-- this server was created, email pubs@omg.org -->
<!-- -->
<!-- Last updated: 06/10/96 08:49:54 -->

</body>
</html>
