<html><head><title></title></head>
<body bgcolor=#ffffff>
 
<a href="cover.html">[Top]</a> <a href="cmap.html">[Prev]</a> <a href="pluscon.html">[Next]</a> <a href="corb2pra.html">[Bottom]</a>
<hr><br>
 
<a name="6919">
<h1> C++ Mapping Overview</h1>
</a><dl>
<p align=right clear=all>
<b><font size=7>
15 
</font></b>
</p>
<hr></dl>
<a name="6920">
This chapter explains how:<p>
</a><ul><a name="6242">
<li>The C++ mapping was designed
</a><a name="6966">
<li>The C++ mapping is organized in this manual
</a></ul><a name="6644">
<h1>	15.1	 Key Design Decisions</h1>
</a><a name="6115">
The design of the C++ mapping was driven by a number of considerations, including a design that achieves reasonable performance, portability, efficiency, and usability for OMG IDL-to-C++ implementations. Several other considerations are outlined in this section. <p>
</a><a name="6926">
For more information about the general requirements of a mapping from OMG IDL to any programming language, refer to <a href="cmap.html#2981">Section &#32;14.1, "Requirements for a Language Mapping," on page &#32;14-1</a>.<p>
</a><a name="6927">
<h2>	15.1.1	 Compliance</h2>
</a><a name="5855">
The C++ mapping tries to avoid limiting the implementation freedoms of ORB developers. For each OMG IDL and CORBA construct, the C++ mapping explains the syntax and semantics of using the construct from C++. A client or server program <em>conforms</em> to this mapping-is CORBA-C++ compliant-if it uses the constructs as described in the C++ mapping chapters. An implementation <em>conforms</em> to this mapping if it correctly executes any conforming client or server program. A conforming client or server program is therefore portable across all conforming implementations. For more information about CORBA compliance, refer to <a href="corb2prb.html#1468">Section 0.6, "Definition of CORBA Compliance"</a>.<p>
</a><a name="5857">
<h2>	15.1.2	 C++ Implementation Requirements</h2>
</a><a name="5862">
The mapping proposed here assumes that the target C++ environment supports all the features described in <em>The Annotated C++ Reference Manual</em> (ARM) by Ellis and Stroustrup as adopted by the ANSI/ISO C++ standardization committees, including exception handling. In addition, it assumes that the C++ environment supports the namespace construct recently adopted into the language. Because C++ implementations vary widely in the quality of their support for templates, this mapping does not explicitly require their use, nor does it disallow their use as part of a CORBA-compliant implementation.<p>
</a><a name="5866">
<h2>	15.1.3	 C Data Layout Compatibility</h2>
</a><a name="5871">
Some ORB vendors feel strongly that the C++ mapping should be able to work directly with the CORBA C mapping. This mapping makes every attempt to ensure compatibility between the C and C++ mappings, but it does not mandate such compatibility. In addition to providing better interoperability and portability, the C++ call style solves the memory management problems seen by C programmers who use the C call style. Therefore, the OMG has adopted the C++ call style for OMG IDL. However, to provide continuity for earlier applications, an implementation might choose to support the C call style as an option. If an implementation supports both call styles, it is recommended that the C call style be phased out. <p>
</a><a name="6167">
Note that the mapping in <a href="cmap.html#2968">Chapter 14, "C Language Mapping"</a> has been modified from <em>CORBA V1.2</em> to achieve compatibility between the C and C++ mappings. <p>
</a><a name="7204">
<h2>	15.1.4	 No Implementation Descriptions</h2>
</a><a name="5922">
This mapping does not contain implementation descriptions. It avoids details that would constrain implementations, but still allows clients to be fully source compatible with any compliant implementation. Some examples show possible implementations, but these are not required implementations.<p>
</a><a name="6240">
<h1>	15.2	 Organization of the C++ Mapping</h1>
</a><a name="6230">
In addition to this overview, the mapping of OMG IDL to the C++ programming language is divided into the following chapters: <p>
</a><ul><a name="6231">
<li>Mapping of all OMG IDL constructs (as defined in <a href="idlsyn.html#2451">Chapter 3, "OMG IDL Syntax and Semantics"</a>) to C++ constructs
</a><a name="6232">
<li>Mapping of OMG IDL pseudo objects to C++
</a><a name="6233">
<li>Server-side mapping, which refers to the portability constraints for an object implementation written in C++
</a></ul><a name="6234">
Three appendices are also included at the end of the C++ chapters. One appendix contains C++ definitions for the CORBA module; another contains C++ keywords for the CORBA module; and another contains workarounds for C++ dialects that do not match the assumptions specified in <a href="plusov.html#5857">Section &#32;15.1.2, "C++ Implementation Requirements," on page &#32;15-2</a>. <p>
</a>
<hr><br>
 
<a href="cover.html">[Top]</a> <a href="cmap.html">[Prev]</a> <a href="pluscon.html">[Next]</a> <a href="corb2pra.html">[Bottom]</a>
<hr><br>
 


<address>
<a href="mailto:pubs@omg.org">pubs@omg.org</a>
</address>

<i>Copyright &#169; 1995, <a href="http://www.omg.org">Object Management Group.</a>  All rights
reserved.</i>

<!-- This file was created with Quadralay WebWorks Publisher 3.0.4 -->
<!-- -->
<!-- For more information on how this document, and how the rest of -->
<!-- this server was created, email pubs@omg.org -->
<!-- -->
<!-- Last updated: 06/10/96 08:49:52 -->

</body>
</html>
