<html><head><title></title></head>
<body bgcolor=#ffffff>
 
<a href="cover.html">[Top]</a> <a href="smallov.html">[Prev]</a> <a href="smallpo.html">[Next]</a> <a href="corb2pra.html">[Bottom]</a>
<hr><br>
 
<a name="652">
<h1>  Mapping of OMG IDL to Smalltalk</h1>
</a><dl>
<p align=right clear=all>
<b><font size=7>
20 
</font></b>
</p>
<hr></dl>
<a name="668">
This chapter describes the mapping of OMG IDL constructs to Smalltalk constructs. <p>
</a><a name="9983">
<h1>	20.1	 Mapping Summary</h1>
</a><a name="9988">
<a href="smallma.html#10044">TABLE 30. on page 20-1</a> provides a brief description of the mapping of OMG IDL constructs to the Smalltalk language, and where in this chapter they are discussed.<p>
</a><a name="10044">
 
<Table Border="3">
<caption><a name="11206">
TABLE 30.  Summary of this Chapter<p>
</a></caption>
<tr><th><a name="10404">
 OMG IDL Construct<p>
</a><th><a name="10406">
 Smalltalk Mapping<p>
</a><th><a name="10408">
 Where Discussed<p>
</a>
<tr><td><a name="10410">
 Interface<p>
</a><td><a name="10412">
 Set of messages that Smalltalk objects which represent object references must respond to. The set of messages corresponds to the attributes and operations defined in the interface and inherited interfaces. <p>
</a><a name="10413">
 <p>
</a><td><a name="10418">
 <a href="smallma.html#9985">Section &#32;20.3, "Mapping for Interfaces," on page &#32;20-3</a><p>
</a>
<tr><td><a name="10420">
 Object Reference<p>
</a><td><a name="10614">
 Smalltalk object that represents a CORBA object. The Smalltalk object must respond to all messages defined by a CORBA object's interface. <p>
</a><a name="10422">
 <p>
</a><td><a name="10424">
 <a href="smallma.html#649">Section &#32;20.5, "Mapping for Objects," on page &#32;20-3</a><p>
</a>
<tr><td><a name="10426">
 Operation<p>
</a><td><a name="10645">
 Smalltalk message. <p>
</a><a name="10428">
 <p>
</a><td><a name="10430">
 <a href="smallma.html#7275">Section &#32;20.17, "Mapping for Operations," on page &#32;20-10</a><p>
</a>
<tr><td><a name="10432">
 Attribute <p>
</a><td><a name="10434">
 Smalltalk message.<p>
</a><td><a name="10436">
 <a href="smallma.html#651">Section &#32;20.7, "Mapping for Attributes," on page &#32;20-4</a><p>
</a>
<tr><td><a name="10438">
 Constant<p>
</a><td><a name="10440">
 Smalltalk objects available in the CORBAConstants dictionary. <p>
</a><td><a name="10442">
 <a href="smallma.html#787">Section &#32;20.7.1, "Mapping for Constants," on page &#32;20-5</a><p>
</a>
<tr><td><a name="10444">
 Integral Type <p>
</a><td><a name="10446">
 Smalltalk objects that conform to the Integer class.<p>
</a><td><a name="10448">
 <a href="smallma.html#806">Section &#32;20.8, "Mapping for Basic Data Types," on page &#32;20-5</a><p>
</a>
<tr><td><a name="10450">
 Floating Point Type<p>
</a><td><a name="10452">
 Smalltalk objects which conform to the Float class. <p>
</a><td><a name="10454">
 Described in <a href="smallma.html#806">Section &#32;20.8, "Mapping for Basic Data Types," on page &#32;20-5</a><p>
</a>
<tr><td><a name="10456">
 Boolean Type<p>
</a><td><a name="10743">
 Smalltalk true or false objects. <p>
</a><td><a name="10749">
 Described in <a href="smallma.html#806">Section &#32;20.8, "Mapping for Basic Data Types," on page &#32;20-5</a>.<p>
</a><a name="10460">
 <p>
</a>
<tr><td><a name="10462">
 Enumeration Type<p>
</a><td><a name="10464">
 Smalltalk objects which conform to the CORBAEnum protocol. <p>
</a><td><a name="10466">
  <a href="smallma.html#9148">Section &#32;20.10, "Mapping for Enums," on page &#32;20-7</a><p>
</a>
<tr><td><a name="10468">
 Any Type<p>
</a><td><a name="10470">
 Smalltalk objects that can be mapped into an OMG IDL type. <p>
</a><td><a name="10789">
  <a href="smallma.html#8025">Section &#32;20.9, "Mapping for the Any Type," on page &#32;20-7</a><p>
</a><a name="10472">
 <p>
</a>
<tr><td><a name="10474">
 Structure Type<p>
</a><td><a name="10798">
 Smalltalk object that conforms to the Dictionary class. <p>
</a><td><a name="10806">
 <a href="smallma.html#9011">Section &#32;20.11, "Mapping for Struct Types," on page &#32;20-8</a>.<p>
</a><a name="10478">
 <p>
</a>
<tr><td><a name="10480">
 Union Type<p>
</a><td><a name="10819">
 Smalltalk object that maps to the possible value types of the OMG IDL union or that conform to the CORBAUnion protocol. <p>
</a><td><a name="10838">
  <a href="smallma.html#8888">Section &#32;20.12, "Mapping for Union Types," on page &#32;20-8</a>.<p>
</a><a name="10484">
 <p>
</a>
<tr><td><a name="10486">
 Sequence Type<p>
</a><td><a name="10488">
 Smalltalk object that conforms to the OrderedCollection class. <p>
</a><td><a name="10490">
 <a href="smallma.html#8227">Section &#32;20.13, "Mapping for Sequence Types," on page &#32;20-10</a><p>
</a>
<tr><td><a name="10492">
 String Type<p>
</a><td><a name="10494">
 Smalltalk object that conforms to the String class. <p>
</a><td><a name="10496">
 <a href="smallma.html#8014">Section &#32;20.14, "Mapping for String Types," on page &#32;20-10</a><p>
</a>
<tr><td><a name="10498">
 Array Type<p>
</a><td><a name="10937">
 Smalltalk object that conforms to the Array class. <p>
</a><a name="10500">
 <p>
</a><td><a name="10502">
  <a href="smallma.html#811">Section &#32;20.15, "Mapping for Array Types," on page &#32;20-10</a><p>
</a>
<tr><td><a name="10504">
 Exception Type<p>
</a><td><a name="10506">
 Smalltalk object that conforms to the Dictionary class. <p>
</a><td><a name="10975">
 <a href="smallma.html#979">Section &#32;20.16, "Mapping for Exception Types," on page &#32;20-10</a><p>
</a><a name="10508">
 <p>
</a>

</Table>

<Table>
<tr><td>
</Table>
<p>
</a><a name="11288">
<h1>	20.2	 Conversion of Names to Smalltalk Identifiers</h1>
</a><a name="9119">
 The use of underscore characters in OMG IDL identifiers is not allowed in all Smalltalk language implementations. Thus, a conversion algorithm is required to convert names used in OMG IDL to valid Smalltalk identifiers.<p>
</a><a name="6016">
To convert an OMG IDL identifier to a Smalltalk identifier, remove each underscore and capitalize the following letter (if it exists). In order to eliminate possible ambiguities which may result from these conventions, an explicit naming mechanism must also be provided by the implementation. For example, the <strong>#pragma</strong> directive could be used.<p>
</a><a name="8143">
For example, the OMG IDL identifiers:<p>
</a><a name="6024">
 <strong>add_to_copy_map<br>describe_contents</strong><p>
</a><a name="6028">
become Smalltalk identifiers<p>
</a><a name="6067">
 addToCopyMap<br>describeContents<p>
</a><a name="6080">
Smalltalk implementations generally require that class names and global variables have an uppercase first letter, while other names have a lowercase first letter.<p>
</a><a name="9985">
<h1>	20.3	 Mapping for Interfaces</h1>
</a><a name="6087">
 Each OMG IDL interface defines the operations that object references with that interface must support. In Smalltalk, each OMG IDL interface defines the methods that object references with that interface must respond to.<p>
</a><a name="6091">
Implementations are free to map each OMG IDL interface to a separate Smalltalk class, map all OMG IDL interfaces to a single Smalltalk class, or map arbitrary Smalltalk classes to OMG IDL interfaces.<p>
</a><a name="11269">
<h1>	20.4	 Memory Usage</h1>
</a><a name="11273">
 One of the design goals is to make every Smalltalk object used in the mapping a pure Smalltalk object: namely datatypes used in mappings do not point to operating system defined memory. This design goal permits the mapping and users of the mapping to ignore memory management issues, since Smalltalk handles this itself (via garbage collection). Smalltalk objects which are used as object references may contain pointers to operating system memory, and so must be freed in an explicit manner.<p>
</a><a name="649">
<h1>	20.5	 Mapping for Objects</h1>
</a><a name="6109">
A CORBA object is represented in Smalltalk as a Smalltalk object called an <em>object reference</em>. The object must respond to all messages defined by that CORBA object's interface.<p>
</a><a name="6113">
An object reference can have a value which indicates that it represents no CORBA object. This value is the standard Smalltalk value nil.<p>
</a><a name="6136">
<h1>	20.6	 Invocation of Operations</h1>
</a><a name="6140">
 OMG IDL and Smalltalk message syntaxes both allow zero or more input parameters to be supplied in a request. For return values, Smalltalk methods yield a single result object, whereas OMG IDL allows an optional result and zero or more out or inout parameters to be returned from an invocation. In this binding, the non-void result of an operation is returned as the result of the corresponding Smalltalk method, whereas out and inout parameters are to be communicated back to the caller via instances of a class conforming to the CORBAParameter protocol, passed as explicit parameters.<p>
</a><a name="6151">
For example, the following operations in OMG IDL: <p>
</a><a name="11294">
<blockquote>boolean definesProperty(in string key);</blockquote>
</a><a name="6155">
<blockquote>						void defines_property(<br>						in string key,<br>						out boolean is_defined);</blockquote>
</a><a name="6160">
are used as follows in the Smalltalk language: <p>
</a><a name="6162">
 aBool := self definesProperty: aString.<p>
</a><a name="6373">
 																						self <br>		definesProperty: aString <br>													isDefined: (aBool := nil asCORBAParameter).<p>
</a><a name="6166">
As another example, these OMG IDL operations:<p>
</a><a name="6168">
 boolean has_property_protection(in string key,<br>out Protection pval);<p>
</a><a name="6172">
 ORBStatus create_request (in Context ctx,<br>in Identifier operation,<br>in NVList arg_list,<br>inout DynamicInvocation::NamedValue result,<br>out Request request,<br>in Flags req_flags);<p>
</a><a name="6180">
would be invoked in the Smalltalk language as:<p>
</a><a name="6182">
 aBool := self<br>	hasPropertyProtection: aString<br>	pval: (protection := nil asCORBAParameter).<p>
</a><a name="11313">
 																																									aStatus := ORBObject<br>		createRequest: aContext<br>		operation: anIdentifier<br>		argList: anNVList<br>		result: (result := aNamedValue asCORBAParameter)<br>		request: (request := nil asCORBAParameter)<br>		reqFlags: aFlags.<p>
</a><a name="6195">
 The return value of OMG IDL operations that are specified with a <strong>void</strong> return type is undefined.<p>
</a><a name="651">
<h1>	20.7	 Mapping for Attributes</h1>
</a><a name="6378">
 OMG IDL attribute declarations are a shorthand mechanism to define pairs of simple accessing operations; one to get the value of the attribute and one to set it. Such accessing methods are common in Smalltalk programs as well, thus attribute declarations are mapped to standard methods to get and set the named attribute value, respectively.<p>
</a><a name="6384">
For example:<p>
</a><a name="6386">
<blockquote>attribute 						string 	title;</blockquote>
</a><a name="11329">
<blockquote>readonly attribute 	string my_name;</blockquote>
</a><a name="6390">
means that Smalltalk programmers can expect to use title and title: methods to get and set the <strong>title</strong> attribute of the CORBA object, and the myName method to retrieve the <strong>my_name</strong> attribute.<p>
</a><a name="787">
<h2>	20.7.1	 Mapping for Constants</h2>
</a><a name="6446">
 OMG IDL allows constant expressions to be declared globally as well as in interface and module definitions. OMG IDL constant values are stored in a dictionary named CORBAConstants under the fully qualified name of the constant, not subject to the name conversion algorithm. The constants are accessed by sending the at: message to the dictionary with an instance of a String whose value is the fully qualified name.<p>
</a><a name="6454">
For example, given the following OMG IDL specification,<p>
</a><a name="6457">
 module ApplicationBasics{<br>const CopyDepth shallow_cpy = 4;<br>};<p>
</a><a name="6462">
 the <strong>ApplicationBasics::shallow_cpy</strong> constant can be accessed with the following Smalltalk code<p>
</a><a name="6466">
 					value := CORBAConstants at:<p>
</a><a name="11323">
 						'::ApplicationBasics::shallow_cpy'.<p>
</a><a name="6469">
After this call, the value variable will contain the integral value 4.<p>
</a><a name="806">
<h1>	20.8	 Mapping for Basic Data Types</h1>
</a><a name="6535">
 The following basic datatypes are mapped into existing Smalltalk classes. In the case of <strong>short</strong>, <strong>unsigned short</strong>, <strong>long</strong>, <strong>unsigned long</strong>, <strong>float</strong>, <strong>double</strong>, and <strong>octet</strong>, the actual class used is left up to the implementation, for the following reasons:<p>
</a><ul><a name="6542">
<li>There is no standard for Smalltalk that specifies integral and floating point classes and the valid ranges of their instances.
</a><a name="6544">
<li>The classes themselves are rarely used in Smalltalk. Instances of the classes are made available as constants included in code, or as the result of computation.
</a><a name="6549">
The basic datatypes are mapped as follows:<p>
</a></ul><a name="6630">
<h3>		 short </h3>
</a><a name="10002">
An OMG IDL <strong>short</strong> integer falls in the range [-215,215-1]. In Smalltalk, a short is represented as an instance of an appropriate integral class.<p>
</a><a name="6553">
<h3>		 long</h3>
</a><a name="10003">
An OMG IDL <strong>long</strong> integer falls in the range [-231,231-1]. In Smalltalk, a long is represented as an instance of an appropriate integral class.<p>
</a><a name="6557">
<h3>		 unsigned short</h3>
</a><a name="10006">
An OMG IDL <strong>unsigned short</strong> integer falls in the range [0,216-1]. In Smalltalk, an unsigned short is represented as an instance of an appropriate integral class.<p>
</a><a name="6561">
<h3>		 unsigned long</h3>
</a><a name="10009">
An OMG IDL <strong>unsigned long</strong> integer falls in the range [0,232-1]. In Smalltalk, an unsigned long is represented as an instance of an appropriate integral class.<p>
</a><a name="6565">
<h3>		 float</h3>
</a><a name="10012">
An OMG IDL <strong>float</strong> conforms to the IEEE single-precision (32-bit) floating point standard (ANSI/IEEE Std 754-1985). In Smalltalk, a float is represented as an instance of an appropriate floating point class.<p>
</a><a name="6570">
<h3>		 double</h3>
</a><a name="10015">
An OMG IDL <strong>double</strong> conforms to the IEEE double-precision (64-bit) floating point standard (ANSI/IEEE Std 754-1985). In Smalltalk, a double is represented as an instance of an appropriate floating point class.<p>
</a><a name="6575">
<h3>		 char</h3>
</a><a name="10018">
An OMG IDL <strong>character</strong> holds an 8-bit quantity mapping to the ISO Latin-1 (8859.1) character set. In Smalltalk, a character is represented as an instance of Character.<p>
</a><a name="6579">
<h3>		 boolean</h3>
</a><a name="10021">
<br>An OMG IDL <strong>boolean</strong> may hold one of two values: TRUE or FALSE. In Smalltalk, a boolean is represented by the values true or false, respectively.<p>
</a><a name="6583">
<h3>		 octet</h3>
</a><a name="10022">
An OMG IDL <strong>octet</strong> is an 8-bit quantity that undergoes no conversion during transmission. In Smalltalk, an octet is represented as an instance of an appropriate integral class with a value in the range [0,255].<p>
</a><a name="8025">
<h1>	20.9	 Mapping for the Any Type</h1>
</a><a name="8026">
 Due to the dynamic nature of Smalltalk, where the class of objects can be determined at runtime, an explicit mapping of the <strong>any</strong> type to a particular Smalltalk class is not required. Instead, wherever an <strong>any</strong> is required, the user may pass any Smalltalk object which can be mapped into an OMG IDL type. For instance, if an OMG IDL structure type is defined in an interface, a Dictionary for that structure type will be mapped. Instances of this class can be used wherever an <strong>any</strong> is expected, since that Smalltalk object can be mapped to the OMG IDL structure.<p>
</a><a name="9143">
Likewise, when an <strong>any</strong> is returned as the result of an operation, the actual Smalltalk object which represents the value of the any data structure will be returned.<p>
</a><a name="9148">
<h1>	20.10	 Mapping for Enums</h1>
</a><a name="9161">
 OMG IDL enumerators are stored in a dictionary named CORBAConstants under the fully qualified name of the enumerator, not subject to the name conversion algorithm. The enumerators are accessed by sending the at: message to the dictionary with an instance of a String whose value is the fully qualified name.<p>
</a><a name="9162">
These enumerator Smalltalk objects must support the CORBAEnum protocol, to allow enumerators of the same type to be compared. The order in which the enumerators are named in the specification of an enumeration defines the relative order of the enumerators. The protocol must support the following instance methods:<p>
</a><a name="9308">
 					&lt; aCORBAEnum<p>
</a><a name="11016">
Answers true if the receiver is less than aCORBAEnum, otherwise answers false.<p>
</a><a name="9313">
 					&lt;= aCORBAEnum<p>
</a><a name="11032">
Answers true if the receiver is less than or equal to aCORBAEnum, otherwise answers false.<p>
</a><a name="6777">
					= aCORBAEnum<br>Answers true if the receiver is equal to aCORBAEnum, otherwise answers false.<p>
</a><a name="11029">
					&gt; aCORBAEnum<br>Answers true if the receiver is greater than aCORBAEnum, otherwise answers false.<p>
</a><a name="9299">
					<strong>&gt;= aCORBAEnum<br></strong>Answers true if the receiver is greater than or equal to aCORBAEnum, otherwise answers false.<p>
</a><a name="6782">
For example, given the following OMG IDL specification,<p>
</a><a name="6784">
<blockquote>		module Graphics{ <br>						enum ChartStyle<br>							{lineChart, barChart, stackedBarChart, pieChart};<br>						};	</blockquote>
</a><a name="6790">
the <strong>Graphics::lineChart</strong> enumeration value can be accessed with the following Smalltalk code<p>
</a><a name="6793">
 value := CORBAConstants at: '::Graphics::lineChart'.<p>
</a><a name="9077">
After this call, the value variable is assigned to a Smalltalk object that can be compared with other enumeration values.<p>
</a><a name="9011">
<h1>	20.11	 Mapping for Struct Types</h1>
</a><a name="9012">
 An OMG IDL struct is mapped to an instance of the Dictionary class. The key for each OMG IDL struct member is an instance of Symbol whose value is the name of the element converted according to the algorithm in <a href="smallma.html#11288"> Section 20.2</a>. For example, a structure with a field of <strong>my_field</strong> would be accessed by sending the at: message with the key #myField. <p>
</a><a name="9272">
For example, given the following OMG IDL declaration:<p>
</a><a name="9247">
<blockquote>struct  Binding {<br>						Name binding_name; <br>						BindingType binding_type; <br>						};</blockquote>
</a><a name="9245">
the binding_name element can be accessed as follows:<p>
</a><a name="9261">
 	aBindingStruct at: #bindingName<p>
</a><a name="9265">
and set as follows:<p>
</a><a name="9266">
 	aBindingStruct at: #bindingName put: aName<p>
</a><a name="8888">
<h1>	20.12	 Mapping for Union Types</h1>
</a><a name="8889">
For OMG IDL union types, two binding mechanisms are provided: an <em>implicit</em> binding and an <em>explicit</em> binding.<a href="#8968"><sup>1</sup></a> The implicit binding takes maximum advantage of the dynamic nature of Smalltalk and is the least intrusive binding for the Smalltalk programmer. The explicit binding retains the value of the discriminator and provides greater control for the programmer.<p>
</a><a name="8890">
Although the particular mechanism for choosing implicit vs. explicit binding semantics is implementation specific, all implementations must provide both mechanisms. Binding semantics is expected to be specifiable on a per-union declaration basis, for example using the <strong>#pragma directive</strong>.<p>
</a><a name="8891">
<h2>	20.12.1	 Implicit Binding</h2>
</a><a name="8892">
 Wherever a <strong>union</strong> is required, the user may pass any Smalltalk object that can be mapped to an OMG IDL type, and whose type matches one of the types of the values in the union. Consider the following example:<p>
</a><a name="8893">
 structure S { long x; long y; };<p>
</a><a name="9214">
 union U switch (short) {<br>case 1: S s;<br>case 2: long l;<br>default: char c;<br>};<p>
</a><a name="8895">
In the example above, a Dictionary for structure S will be mapped. Instances of Dictionary with runtime elements as defined in structure <strong>S</strong>, integral numbers, or characters can be used wherever a union of type <strong>U</strong> is expected. In this example, instances of these classes can be mapped into one of the <strong>S,</strong> <strong>long,</strong> or <strong>char</strong> types, and an appropriate discriminator value can be determined at runtime.<p>
</a><a name="8896">
Likewise, when an <strong>union</strong> is returned as the result of an operation, the actual Smalltalk object which represents the value of the <strong>union</strong> will be returned.<p>
</a><a name="8897">
<h2>	20.12.2	 Explicit Binding</h2>
</a><a name="8898">
 Use of the explicit binding will result in specific Smalltalk classes being accepted and returned by the ORB. Each union object must conform to the CORBAUnion protocol. This protocol must support the following instance methods:<p>
</a><a name="8899">
discriminator<br>Answers the discriminator associated with the instance.<p>
</a><a name="8900">
								discriminator: anObject<br>Sets the discriminator associated with the instance.<p>
</a><a name="8901">
value<br>Answers the value associated with the instance.<p>
</a><a name="8902">
value: anObject	<br>Sets the value associated with the instance<p>
</a><a name="9492">
To create an object that supports the CORBAUnion protocol, the instance method asCORBAUnion: aDiscriminator can be invoked by any Smalltalk object. This method will return a Smalltalk object conforming to the CORBAUnion protocol, whose discriminator will be set to aDiscriminator and whose value will be set to the receiver of the message.<p>
</a><a name="8227">
<h1>	20.13	 Mapping for Sequence Types</h1>
</a><a name="7112">
 Instances of the OrderedCollection class are used to represent OMG IDL elements with the <strong>sequence</strong> type.<p>
</a><a name="8014">
<h1>	20.14	 Mapping for String Types</h1>
</a><a name="8015">
 Instances of the Smalltalk String class are used to represent OMG IDL elements with the <strong>string</strong> type.<p>
</a><a name="811">
<h1>	20.15	 Mapping for Array Types</h1>
</a><a name="7135">
 Instances of the Smalltalk Array class are used to represent OMG IDL elements with the <strong>array</strong> type.<p>
</a><a name="979">
<h1>	20.16	 Mapping for Exception Types</h1>
</a><a name="7274">
 Each defined exception type is mapped to an instance of the Dictionary class. See <a href="smallma.html#7590"> Section 20.20.1</a> for a complete description.<p>
</a><a name="7275">
<h1>	20.17	 Mapping for Operations</h1>
</a><a name="7154">
 OMG IDL operations having zero parameters map directly to Smalltalk unary messages, while OMG IDL operations having one or more parameters correspond to Smalltalk keyword messages. To determine the default selector for such an operation, begin with the OMG IDL operation identifier and concatenate the parameter name of each parameter followed by a colon, ignoring the first parameter. The mapped selector is subject to the identifier conversion algorithm.<p>
</a><a name="7163">
 For example, the following OMG IDL operations:<p>
</a><a name="7165">
 void add_to_copy_map( <br>in CORBA::ORBId id, <br>in LinkSet link_set);<p>
</a><a name="7169">
 void connect_push_supplier( <br>in EventComm::PushSupplier push_supplier);<p>
</a><a name="7172">
 void add_to_delete_map( <br>in CORBA::ORBId id, <br>in LinkSet link_set);<p>
</a><a name="7176">
become selectors:<p>
</a><a name="7178">
 	addToCopyMap:linkSet:<br>		connectPushSupplier:<br>		addToDeleteMap:linkSet:<p>
</a><a name="2821">
<h1>	20.18	 Implicit Arguments to Operations</h1>
</a><a name="7283">
 Unlike the C mapping, where an object reference, environment, and optional context must be passed as parameters to each operation, this Smalltalk mapping does not require these parameters to be passed to each operation.<p>
</a><a name="7288">
The object reference is provided in the client code as the receiver of a message. So although it is not a parameter on the operation, it is a required part of the operation invocation.<p>
</a><a name="9489">
This mapping defines the CORBAExceptionEvent protocol to convey exception information in place of the environment used in the C mapping. This protocol can either be mapped into native Smalltalk exceptions or used in cases where native Smalltalk exception handling is unavailable. <p>
</a><a name="7292">
A context expression can be associated with the current Smalltalk process by sending the message corbaContext: to the current process, along with a valid context parameter. The current context can be retrieved by sending the corbaContext message to the current process.<p>
</a><a name="9330">
The current process may be obtained by sending the message activeProcess to the Smalltalk global variable named Processor.<p>
</a><a name="7500">
<h1>	20.19	 Argument Passing Considerations</h1>
</a><a name="7501">
 All parameters passed into and returned from the Smalltalk methods used to invoke operations are allocated in memory maintained by the Smalltalk virtual machine. Thus, explicit <strong>free()</strong>ing of the memory is not required. The memory will be garbage collected when it is no longer referenced.<p>
</a><a name="7395">
The only exception is object references. Since object references may contain pointers to memory allocated by the operating system, it is necessary for the user to explicitly free them when no longer needed. This is accomplished by using the operation <strong>release</strong> of the <strong>CORBA::Object</strong> interface.<p>
</a><a name="7518">
<h1>	20.20	 Handling Exceptions</h1>
</a><a name="7525">
 OMG IDL allows each operation definition to include information about the kinds of run-time errors which may be encountered. These are specified in an exception definition which declares an optional error structure which will be returned by the operation should an error be detected. Since Smalltalk exception handling classes are not yet standardized between existing implementations, a generalized mapping is provided.<p>
</a><a name="7532">
In this binding, an IDL compiler creates exception objects and populates the CORBAConstants dictionary. These exception objects are accessed from the CORBAConstants dictionary by sending the at: message with an instance of a String whose value is the fully qualified name. Each exception object must conform to the CORBAExceptionEvent protocol. This protocol must support the following instance methods:<p>
</a><a name="11336">
<p>
</a><a name="7541">
corbaHandle: aHandlerBlock do: aBlock<p>
</a><a name="11041">
Exceptions may be handled by sending an exception object the message corbaHandle:do: with appropriate handler and scoping blocks as parameters. The aBlock parameter is the Smalltalk block to evaluate. It is passed no parameters. The aHandlerBlock parameter is a block to evaluate when an exception occurs. It has one parameter: a Smalltalk object which conforms to the CORBAExceptionValue protocol.<p>
</a><a name="7778">
corbaRaise<p>
</a><a name="11061">
Exceptions may be raised by sending an exception object the message corbaRaise.<p>
</a><a name="7555">
corbaRaiseWith: aDictionary<p>
</a><a name="11053">
Exceptions may be raised by sending an exception object the message corbaRaiseWith:. The parameter is expected to be an instance of the Smalltalk Dictionary class, as described below.<p>
</a><a name="7791">
For example, given the following OMG IDL specification,<p>
</a><a name="7800">
<blockquote>interface NamingContext {<br>						...<br><br>						exception NotEmpty {};</blockquote>
</a><a name="7568">
<blockquote>						void destroy ()<br>							raises (NotEmpty);<br>						...<br>};</blockquote>
</a><a name="7991">
<p>
</a><a name="7574">
the <strong>NamingContext::NotEmpty</strong> exception can be raised as follows:<p>
</a><a name="7577">
 					(CORBAConstants at: '::NamingContext::NotEmpty')<p>
</a><a name="11337">
 						corbaRaise.<p>
</a><a name="7581">
The exception can be handled in Smalltalk as follows:<p>
</a><a name="7584">
 (CORBAConstants at: '::NamingContext::NotEmpty')<br>	corbaHandle: [:ev | "error handling logic here" ]<br>	do: [aNamingContext destroy].<p>
</a><a name="7590">
<h2>	20.20.1	 Exception Values</h2>
</a><a name="7592">
 OMG IDL allows values to be returned as part of the exception. Exception values are constructed using instances of the Smalltalk Dictionary class. The keys of the dictionary are the names of the elements of the exception, the names of which are converted using the algorithm in <a href="smallma.html#11288">Section &#32;20.2, "Conversion of Names to Smalltalk Identifiers," on page &#32;20-2</a>. The following example illustrates how exception values are used:<p>
</a><a name="7808">
 interface NamingContext {<p>
</a><a name="7602">
    ...<p>
</a><a name="7603">
    exception CannotProceed {<br>		NamingContext cxt;<br>		Name rest_of_name;<br>	};<p>
</a><a name="7608">
 	Object resolve (in Name n)<br>			raises (CannotProceed);<p>
</a><a name="7610">
    ...<p>
</a><a name="7611">
 };<p>
</a><a name="7613">
 <p>
</a><a name="7614">
would be raised in Smalltalk as follows:<p>
</a><a name="7817">
 <p>
</a><a name="11340">
 (CORBAConstants at: '::NamingContext::CannotProceed')<br>						corbaRaiseWith: (Dictionary<br>							with: (Association key: #cxt value:<p>
</a><a name="11345">
 										aNamingContext)<br>							with: (Association key: #restOfName value:<p>
</a><a name="11351">
 										aName)).<p>
</a><a name="7622">
<h2>	20.20.2	 The CORBAExceptionValue protocol</h2>
</a><a name="7624">
 When an exception is raised, the exception block is evaluated, passing it one argument which conforms to the CORBAExceptionValue protocol. This protocol must support the following instance messages:<p>
</a><a name="7628">
corbaExceptionValue <br>Answers the Dictionary the exception was raised with.<p>
</a><a name="11364">
Given the <strong>NamingContext</strong> interface defined in the previous section, the following code illustrates how exceptions are handled:<p>
</a><a name="11365">
 					(CORBAConstants at: '::NamingContext::NotEmpty')<p>
</a><a name="11368">
 						corbaHandle:[:ev |<p>
</a><a name="11369">
 							cxt:=ev corbaExceptionValue at: #cxt.<p>
</a><a name="11371">
 							restOfName :=ev corbaExceptionValue at:<p>
</a><a name="11372">
 											#restOfName]<p>
</a><a name="11370">
 						do:[aNamingContext destroy].<p>
</a><a name="11376">
In this example, the cxt and restOfName variables will be set to the respective values from the exception structure, if the exception is raised. <p>
</a><a name="11069">
<p>
</a>
<hr><br>
 
<a href="cover.html">[Top]</a> <a href="smallov.html">[Prev]</a> <a href="smallpo.html">[Next]</a> <a href="corb2pra.html">[Bottom]</a>
<hr><br>
 
<sup>1</sup><a name="8968">
 Although not required, implementations may choose to provide both implicit and explicit mappings for other OMG IDL types, such as structs and sequences. In the explicit mapping, the OMG IDL type is mapped to a user specified Smalltalk class.<p>
</a>

<address>
<a href="mailto:pubs@omg.org">pubs@omg.org</a>
</address>

<i>Copyright &#169; 1995, <a href="http://www.omg.org">Object Management Group.</a>  All rights
reserved.</i>

<!-- This file was created with Quadralay WebWorks Publisher 3.0.4 -->
<!-- -->
<!-- For more information on how this document, and how the rest of -->
<!-- this server was created, email pubs@omg.org -->
<!-- -->
<!-- Last updated: 06/10/96 09:21:03 -->

</body>
</html>
