<html><head><title></title></head>
<body bgcolor=#ffffff>
 
<a href="cover.html">[Top]</a> <a href="smallma.html">[Prev]</a> <a href="glos2.html">[Next]</a> <a href="corb2pra.html">[Bottom]</a>
<hr><br>
 
<a name="3082">
<h1> Mapping of Pseudo Objects to Smalltalk</h1>
</a><dl>
<p align=right clear=all>
<b><font size=7>
21 
</font></b>
</p>
<hr></dl>
<a name="3088">
<p>
</a><a name="1135">
CORBA defines a small set of standard interfaces which define types and operations for manipulating object references, for accessing the Interface Repository, and for Dynamic Invocation of operations. Other interfaces are defined in pseudo OMG IDL (PIDL) to represent in a more abstract manner programmer access to ORB services which are provided locally. These PIDL interfaces sometimes resort to non-OMG IDL constructs, such as pointers, which have no meaning to the Smalltalk programmer. This chapter specifies the minimal requirements for the Smalltalk mapping for PIDL interfaces. The operations are specified below as protocol descriptions.<p>
</a><a name="1145">
Parameters with the name aCORBAObject are expected to be Smalltalk objects which can be mapped to an OMG IDL interface or data type. <p>
</a><a name="2253">
Unless otherwise specified, all messages are defined to return undefined objects.<p>
</a><a name="95">
<h1>	21.1	 CORBA::Request</h1>
</a><a name="1194">
The CORBA::Request interface is mapped to the CORBARequest protocol, which must include the following instance methods:<p>
</a><a name="1199">
<strong>addArg: aCORBANamedValue<br></strong>Corresponds to the <strong>add_arg</strong> operation.<p>
</a><a name="1272">
<strong>invoke<br></strong>Corresponds to the <strong>invoke</strong> operation with the <strong>invoke_flags</strong> set to 0.<p>
</a><a name="1277">
<strong>invokeOneway<br></strong>Corresponds to the <strong>invoke</strong> operation with the <strong>invoke_flags</strong> set to CORBA::INV_NO_RESPONSE.<p>
</a><a name="1210">
<strong>send<br></strong>Corresponds to the <strong>send</strong> operation with the <strong>invoke_flags </strong>set to 0.<p>
</a><a name="1214">
<strong>sendOneway<br></strong>Corresponds to the <strong>send</strong> operation with the <strong>invoke_flags</strong> set to CORBA::INV_NO_RESPONSE.<p>
</a><a name="1218">
<strong>pollResponse<br></strong>Corresponds to the <strong>get_response</strong> operation, with the <strong>response_flags</strong> set to CORBA::RESP_NO_WAIT. Answers true if the response is complete, false otherwise.<p>
</a><a name="1224">
<strong>getResponse<br></strong>Corresponds to the <strong>get_response </strong>operation, with the <strong>response_flags</strong> set to 0.<p>
</a><a name="104">
<h1>	21.2	 CORBA::Context</h1>
</a><a name="1384">
 The CORBA::Context interface is mapped to the CORBAContext protocol, which must include the following instance methods:<p>
</a><a name="1389">
<strong>setOneValue: anAssociation<br></strong>Corresponds to the <strong>set_one_value </strong>operation.<p>
</a><a name="1392">
<strong>setValues: aCollection<br></strong>Corresponds to the <strong>set_values</strong> operation. The parameter passed in should be a collection of Associations.<p>
</a><a name="1396">
<strong>getValues: aString <br></strong>Corresponds to the <strong>get_values</strong> operation without a scope name and op_flags = CXT_RESTRICT_SCOPE. Answers a collection of Associations.<p>
</a><a name="2521">
<strong>getValues: aString propName: aString<br></strong>Corresponds to the <strong>get_values</strong> operation with op_flags set to CXT_RESTRICT_SCOPE. Answers a collection of Associations.<p>
</a><a name="2767">
<strong>getValuesInTree: aString propName: aString<br></strong>Corresponds to the <strong>get_values</strong> operation with op_flags set to <strong>0</strong>. Answers a collection of Associations.<p>
</a><a name="1402">
<strong>deleteValues: aString<br></strong>Corresponds to the <strong>delete_values </strong>operation.<p>
</a><a name="2514">
<strong>createChild: aString<br></strong>Corresponds to the <strong>create_child</strong> operation. Answers a Smalltalk object conforming to the CORBAContext protocol.<p>
</a><a name="1409">
dele<strong>te<br></strong>Corresponds to the <strong>delete</strong> operation with flags set to 0.<p>
</a><a name="2094">
<strong>deleteTree<br></strong>Corresponds to the <strong>delete</strong> operation with flags set to CTX_DELETE_DESCENDENTS.<p>
</a><a name="141">
<h1>	21.3	 CORBA::Object</h1>
</a><a name="1513">
 The CORBA::Object interface is mapped to the CORBAObject protocol, which must include the following instance methods:<p>
</a><a name="1518">
<strong>getImplementation<br></strong>Corresponds to the <strong>get_implementation</strong> operation. Answers a Smalltalk object conforming to the CORBAImplementationDef protocol.<p>
</a><a name="1522">
ge<strong>tInterfac</strong>e<br>Corresponds to the <strong>get_interface</strong> operation. Answers a Smalltalk object conforming to the CORBAInterfaceDef protocol.<p>
</a><a name="1526">
<strong>isNil<br></strong>Corresponds to the <strong>is_nil </strong>operation. Answers true or false indicating whether or not the object reference represents an object.<p>
</a><a name="1539">
 createRequest: aCORBAContext<p>
</a><a name="1619">
 																					o			peration: aCORBAIdentifier <p>
</a><a name="1620">
 											argList: aCORBANVListOrNil<p>
</a><a name="1621">
 		result: aCORBAParameter <p>
</a><a name="1622">
 	request: aCORBAParameter <p>
</a><a name="2303">
 	reqFlags: flags<p>
</a><a name="3166">
<strong><br></strong>	Corresponds to the <strong>create_request</strong> operation.<p>
</a><a name="2152">
 <p>
</a><a name="2498">
<strong>duplicate<br></strong>Corresponds to the <strong>duplicate</strong> operation. Answers a Smalltalk object representing an object reference, conforming to the interface of the CORBA object.<p>
</a><a name="2123">
<strong>release</strong><a href="#2483"><sup>1</sup></a><br>Corresponds to the<strong> release</strong> operation.<p>
</a><a name="2043">
<h1>	21.4	 CORBA::ORB</h1>
</a><a name="1637">
 The CORBA::ORB interface is mapped to the CORBAORB protocol, which must include the following instance methods:<p>
</a><a name="1642">
<strong>objectToString: aCORBAObject<br></strong>Corresponds to the <strong>object_to_string</strong> operation. Answers an instance of the String class.<p>
</a><a name="1646">
<strong>stringToObject: aString<br></strong>Corresponds to the <strong>string_to_object</strong> operation. Answers an object reference, which will be an instance of a class which corresponds to the <strong>InterfaceDef</strong> of the CORBA object.<p>
</a><a name="2329">
<strong>createOperationList: aCORBAOperationDef<br></strong>Corresponds to the <strong>create_operation_list </strong>operation. Answers an instance of OrderedCollection of Smalltalk objects conforming to the CORBANamedValue protocol.<p>
</a><a name="1659">
<strong>getDefaultContext<br></strong>Corresponds to the <strong>get_default_context</strong> operation. Answers a Smalltalk object conforming to the CORBAContext protocol.<p>
</a><a name="2541">
<strong>sendMultipleRequests: aCollection<br></strong>Corresponds to the <strong>send_multiple_requests</strong> operation with the <strong>invoke_flags</strong> set to <strong>0.</strong>The parameter passed in should be a collection of Smalltalk objects conforming to the CORBARequest protocol. <p>
</a><a name="2546">
<strong>sendMultipleRequestsOneway: aCollection<br></strong>Corresponds to the <strong>send_multiple_requests</strong> operation with the<strong> invoke_flags</strong> set to CORBA::INV_NO_RESPONSE<strong>.</strong>The parameter passed in should be a collection of Smalltalk objects conforming to the CORBARequest protocol. <p>
</a><a name="2544">
<strong>pollNextResponse<br></strong>Corresponds to the <strong>get_next_response</strong> operation, with the <strong>response_flags</strong> set to CORBA::RESP_NO_WAIT. Answers true if there are completed requests pending, false otherwise.<p>
</a><a name="2549">
<strong>getNextResponse<br></strong>Corresponds to the <strong>get_next_response</strong> operation, with the <strong>response_flags</strong> set to 0. <p>
</a><a name="2586">
<h1>	21.5	 CORBA::NamedValue</h1>
</a><a name="2591">
 PIDL for C defines <strong>CORBA::NamedValue</strong> as a struct while C++-PIDL specifies it as an interface. <strong>CORBA::NamedValue </strong>in this mapping is specified as an interface that conforms to the CORBANamedValue protocol. This protocol must include the following instance methods:<p>
</a><a name="2630">
<strong>name<br></strong>Answers the name associated with the instance. <p>
</a><a name="2631">
<strong>name: aString<br></strong>Resets the name associated with instance to aString.<p>
</a><a name="2684">
<strong>value<br></strong>Answers the value associated with the instance.<p>
</a><a name="2688">
<strong>value: aCORBAObject<br></strong>Resets the value associated with instance to aCORBAObject.<p>
</a><a name="2682">
<strong>flags<br></strong>Answers the flags associated with the instance.<p>
</a><a name="2628">
<strong>flags: argModeFlags<br></strong>Resets the flags associated with instance to argModeFlags.<p>
</a><a name="2865">
To create an object that supports the CORBANamedValue protocol, the instance method asCORBANamedValue: aName flags: argModeFlags can be invoked by any Smalltalk object. This method will return a Smalltalk object conforming to the CORBANamedValue protocol, whose attributes associated with the instance will be set appropriately.<p>
</a><a name="2679">
<h1>	21.6	 CORBA::NVList</h1>
</a><a name="2575">
 The <strong>CORBA::NVList </strong>interface is mapped to the equivalent of the OMG IDL definition<p>
</a><a name="1750">
 					typedef sequence&lt;NamedValue&gt; NVList;<p>
</a><a name="2270">
Thus, Smalltalk objects representing the <strong>NVList</strong> type should be instances of the OrderedCollection class, whose elements are Smalltalk objects conforming to the CORBANamedValue protocol.<p>
</a>
<hr><br>
 
<a href="cover.html">[Top]</a> <a href="smallma.html">[Prev]</a> <a href="glos2.html">[Next]</a> <a href="corb2pra.html">[Bottom]</a>
<hr><br>
 
<sup>1</sup><a name="2483">
 The semantics of this operation will have no meaning for those implementations that rely exclusively on the Smalltalk memory manager. <p>
</a>

<address>
<a href="mailto:pubs@omg.org">pubs@omg.org</a>
</address>

<i>Copyright &#169; 1995, <a href="http://www.omg.org">Object Management Group.</a>  All rights
reserved.</i>

<!-- This file was created with Quadralay WebWorks Publisher 3.0.4 -->
<!-- -->
<!-- For more information on how this document, and how the rest of -->
<!-- this server was created, email pubs@omg.org -->
<!-- -->
<!-- Last updated: 06/10/96 09:21:10 -->

</body>
</html>
