<HTML>
<HEAD>
<META HTTP-EQUIV="Content-Type" CONTENT="text/html; charset=windows-1252">
<META NAME="Generator" CONTENT="Microsoft Word 97">
<TITLE>Extra Chapter 3: HTML Reference</TITLE>
</HEAD>
<BODY bgcolor="#ffffff">

<B><FONT FACE="Chicago,Arial" SIZE=6>
@* <a href=@talk-html.html target=_top>Extra Chapter 3</a>
<P>HTML Reference</P>
<I><U><P>HTML </P>
</B></I></U></FONT><FONT FACE="New York,Times New Roman" SIZE=3><P>HTML is a relatively easy language to learn.  It consists of a set of tags (a tag is a command enclosed in angular brackets &lt;&gt;) which are used to indicate what operation the browser is to perform on the text, or other piece of information, associated with the tag.</P>
<P>It is important to remember that many tags need a closing tag, i.e. a tag like &lt;H2&gt; needs a tag like &lt;/H2&gt; to indicate the end of the passage of text which is being made into a heading.</P>
<P>Some browsers have their own unique HTML tags, the ones seen here will work with most modern browsers such as Microsoft Internet Explorer and Netscape Navigator.</P>
<P>One other point about HTML, HTML is not case sensitive, i.e. it doesn't matter whether you write tags using upper or lowercase letters, however the convention is to write tags in upper case.</P>
<P>Note: This is a very rough guide to HTML intended only as the briefest of reference works.  For a good guide to HTML see:</P><DIR>
<slide id=html-resources cap="HTML Resources">
@ HTML Resources
<DIR>
<DIR>

<P><a href="http://www.htmlhelp.com/">http://www.htmlhelp.com/</a></P>
<P><a href="http://www.sun.com/styleguide/">http://www.sun.com/styleguide/</a></P>
<P><a href="http://www.webmonkey.com/webmonkey/teachingtool/index.html">http://www.webmonkey.com/webmonkey/teachingtool/index.html</a></P>
<P><a href="http://www.cnet.com/Content/Features/Howto/Basics/index.html">http://www.cnet.com/Content/Features/Howto/Basics/index.html</a></P>
</FONT><FONT SIZE=3><P>&nbsp;</P></DIR>
</DIR>
</DIR>

</FONT>
</slide>
<B><I><U><FONT FACE="Chicago,Arial" SIZE=6><P>HTML guide</P>
</B></I></FONT>
<slide id=html-comments cap="Comments">
<FONT FACE="Chicago,Arial" SIZE=6><P>Comments</P>
</U></FONT><FONT FACE="New York,Times New Roman" SIZE=3><P>Comments can be put anywhere in your HTML document.  Anything enclosed in the tags which denote a comment will not be displayed by a browser:</P>
</FONT><FONT SIZE=3><P>&lt;!--&#9;indicates the start of a comment</P>
<P>--&gt;&#9;indicates the end of a comment.</P>
<P>For example,</P>
<P>&lt;!-- This is a comment and will not be displayed by the browser --&gt;</P>
<P>&nbsp;</P>
</FONT>
</slide>
<slide id=html-structure cap="Structure">
<U><FONT FACE="Chicago,Arial" SIZE=6><P>Document structure</P>
</U></FONT><FONT SIZE=3><P>&lt;HTML&gt; Every HTML document should start with this tag.</P>
<P>&lt;/HTML&gt; Every HTML document should end with this tag.</P>
<P>&lt;BODY&gt; .. &lt;/BODY&gt; The body of the document is where all the information that the browser will display is placed.</P>
<P>Within the body tag can go the following</P>
<P>BGCOLOR=colorname : The color of the background.  Alternatively you can specify that an image should be used for the background by typing BACKGROUND=&quot;url&quot; where url gives the URL for an image.</P>
<P>TEXT=colorname : The color text should appear in.</P>
<P>LINK = colorname : The color an unvisited link should appear as.</P>
<P>VLINK=colorname : The color a visited link should appear as.</P>
<P>&nbsp;</P>
<P>For example to get a document which has a blue background and where the text was colored yellow you would type:</P>
<P>&lt;BODY BGCOLOR=Blue TEXT=Yellow&gt; </P>
<P>Note: most browsers will allow you to supply the names of colors, the older method was to supply colors in the form of a code which indicates the proportions of red, blue and green which were mixed.</P>
<P>For example for some older browsers the above would appear as:</P>
<P>&lt;BODY bgcolor="#10299C" text="#ffff00" &gt;</P>
</FONT>
</slide>
<slide id=html-header cap=Header>
<U><FONT FACE="Chicago,Arial" SIZE=6><P>Document Header</P>
</U></FONT><FONT SIZE=3><P>The document header contains information used for titling and indexing the document.  It comes before the body of the document.</P>
<P>&lt;HEAD&gt; .. &lt;/HEAD&gt; The start and end of the header section of the document.</P>
<P>&lt;BASE HREF=&quot;url&quot;&gt; This tag indicates that this url is to be placed before any implied reference in the document, for example if a base href was set as follows: &lt;BASE HREF=&quot;http://machine/main/&quot;&gt; then a link which has been written: &lt;A HREF=&quot;first.html&quot;&gt;First page&lt;/a&gt; will go to the URL http://machine/main/first.html.</P>
<P>&lt;META&gt; The META tag is used to provide extra information about the document. The most common use of the META tag is to load another page at a predefined interval.</P>
<P>To do this the entry is of the form</P>
<P>&lt;META HTTP-EQUIV=&quot;Refresh&quot; CONTENT=&quot;10; http://machine/page.html&quot;&gt;</P>
<P>This will load the page found at the URL http://machine/page.html into the browser window after 10 seconds have elapsed since the page containing this tag was loaded into the browser.</P>
</FONT>
</slide>
<slide id=html-styles cap="Paragraph Styles">
<U><FONT FACE="Chicago,Arial" SIZE=6><P>Paragraph styles</P>
</U></FONT><FONT SIZE=3><P>All of the tags of the form &lt;H?&gt;..&lt;/H?&gt; will create a heading for the text they enclose.  The size of the font used for the heading will be greatest for lower numbers, e.g. &lt;H1&gt; is usually used to indicate the title of the document.</P>
<P>&lt;H1&gt;..&lt;/H1&gt;</P>
<P>&lt;H2&gt;..&lt;/H2&gt;</P>
<P>&lt;H3&gt;..&lt;/H3&gt;</P>
<P>&lt;H4&gt;..&lt;/H4&gt;</P>
<P>&lt;H5&gt;..&lt;/H5&gt;</P>
<P>&lt;H6&gt;..&lt;/H6&gt;</P>
<P>&lt;P&gt; The start of a new paragraph. This tag will create a space between the end of the previous paragraph and the start of the information following the &lt;P&gt; tag. </P>
<P>&lt;BR&gt; Insert a line break (a return).</P>
<P>&lt;HR&gt; Draw a line (called a Horizontal Rule).</P>
<P>&lt;BLOCKQUOTES&gt;..&lt;/BLOCKQUOTES&gt;&#9;Used for quoted text.</P>
<P>&lt;PRE&gt;..&lt;/PRE&gt;&#9;Allow the use of formatted text between these tags.</P>
<P>&lt;LISTING&gt;..&lt;/LISTING&gt;&#9;Used for listing, e.g. section of computer code.</P>
<P>&lt;CENTER&gt;..&lt;/CENTER&gt; Center any text or images which these tags enclose in the browser display.</P>
</FONT>
</slide>
<slide id=html-lists cap=Lists>
<U><FONT FACE="Chicago,Arial" SIZE=6><P>Lists</P>
</U></FONT><FONT SIZE=3><P>Lists are ordered collections of elements.  You can nest lists inside each other to create a hierarchy of elements.</P>
<P>&lt;OL&gt;..&lt;/OL&gt; The start and end of an ordered list. An ordered list is one which automatically numbers each list element in the list 1,2,3,4...</P>
<P>&lt;UL&gt;..&lt;/UL&gt; The start and end of unordered list. An unordered list is one which puts symbols, known as bullets, in front of each of the list elements. You can specify the type of the bullet by placing TYPE =&quot;disc', &quot;circle&quot; or &quot;square&quot; inside the &lt;UL&gt; tag, e.g. for a list which begins with bullets put &lt;UL TYPE=&quot;disc&quot;&gt;</P>
<P>&lt;LI&gt; Element of a list.  You must put this before any element of an ordered or unordered list.</P>
</FONT>
</slide>
<slide id=html-definitions cap=Definitions>
<U><FONT FACE="Chicago,Arial" SIZE=6><P>Definitions</P>
</U></FONT><FONT SIZE=3><P>You can format a definition so that it appears in a distinct font and layout when displayed in a browser.</P>
<P>&lt;DL&gt;..&lt;/DL&gt; Start and end of a definition.</P>
<P>&lt;DT&gt; Definition part of a definition</P>
<P>&lt;DD&gt; The body part of a definition.</P>
<P>So for example if I wanted to give the definition of a light bulb I would say:</P>
<P>&lt;DL&gt;</P>
<P>&lt;DT&gt;Lightbulb</P>
<P>&lt;DD&gt;Device which uses a metal filament and electricity to emit light.</P>
<P>&lt;/DL&gt;</P>
</FONT>
</slide>
<slide id=html-character cap="Character styles">
<U><FONT FACE="Chicago,Arial" SIZE=6><P>Character Styles</P>
</U></FONT><FONT SIZE=3><P>&lt;ADDRESS&gt;..&lt;/ADDRESS&gt; Places the text it encloses in a different font.  It is usually used to emphasize a postal address.</P>
<P>&lt;STRONG&gt; &lt;/STRONG&gt; Emphasizes or emboldens text.</P>
<P>&lt;EM&gt;..&lt;/EM&gt; Emphasizes or emboldens text.</P>
<P>&lt;CITE&gt;..&lt;/CITE&gt;  Used to denote a citation.</P>
<P>&lt;I&gt;..&lt;/I&gt;  Italicize the enclosed text.</P>
<P>&lt;B&gt;..&lt;/B&gt; The enclosed text appears in bold.</P>
<P>&lt;U&gt;..&lt;/U&gt; The enclosed text appears underlined.</P>
<P>&lt;CODE&gt;..&lt;/CODE&gt; Used to emphasize text that is made up of computer code.</P>
<P>&lt;FONT SIZE=&quot;X&quot; COLOR=&quot;colorname&quot;&gt;..&lt;/FONT&gt; Used to control the size of the font used to display the text enclosed between the &lt;FONT&gt; and &lt;/FONT&gt; tags.  The size of a font, X, can vary between 1 and 7.  You can also set the color of the font using the COLOR attribute.</P>
</FONT>
</slide>
<slide id=html-links cap="Links and inline images">
<FONT FACE="Chicago,Arial" SIZE=6><P>Links and inline images</P>
</U></FONT><FONT SIZE=3><P>&lt;A HREF=&quot;url&quot;&gt;..&lt;/A&gt; The enclosed text will form a link to the URL given in quotes.</P>
<P>&lt;A NAME=&quot;name&quot;&gt;..&lt;/A&gt; The enclosed text is defined as an anchor, the name of the anchor is given in quotes. A link to this anchor is of the form &lt;A HREF=&quot;#name&quot;&gt;..&lt;/A&gt;, where name is the name of the anchor and it is preceeded by a '#'.</P>
<P>&lt;IMG SRC = &quot;url&quot; &gt; An image whose source is specified by 'url' is displayed.</P>
<P>The IMG tag can also contain the following options.</P>
<P>ALIGN= MIDDLE : This aligns any text to the middle of the image.</P>
<P>&#9;TOP : This aligns any text to the top of the image.</P>
<P>&#9;BOTTOM: This aligns any text to the top of the image.</P>
<P>ALT=&quot;description&quot; : provides a description for the image in case the users browser cannot display images.</P>
<P>So an inline image of a house which aligns text to the middle would appear as follows:</P>
<P>&lt;IMG SRC = &quot;pic.gif&quot; ALIGN=&quot;MIDDLE&quot; ALT=&quot;Picture of a house&quot; &gt;</P>
</FONT>
</slide>
<slide id=html-forms cap=Forms>
<U><FONT FACE="Chicago,Arial" SIZE=6><P>Forms</P>
</U></FONT><FONT SIZE=3><P>&lt;FORM &gt;..&lt;/FORM&gt; The form tags indicates that the elements contained within them will be passed to another program for processing. Before using any of the form options given below you must start the form section with a &lt;FORM&gt; tag. A document can contain a number of form sections.</P>
<P>The FORM tag can contain a number of attributes.</P>
<P>NAME=&quot;name&quot; : The name of the form.</P>
<P>ACTION=&quot;url&quot; : This indicates the action that is to be performed when the user submits the form (i.e. they select the submit button).  This action can involve calling a cgi program with the contents of the form in which case you would give the URL of the cgi program, or it could involve sending the contents of a form via email.  For example</P>
<P>&lt;form action="mailto:user@machine.domain?subject=(none)" ENCTYPE = "text/plain"&gt;</P>
<P>will send the contents of this form to the email address user@machine.domain.</P>
<P>METHOD=value The method which is used to submit the form for processing. The method can be either POST (the usual method used and the default if the method isn't specified) or GET.</P>
<P>&nbsp;</P>
<P>&lt;INPUT&gt; The INPUT tag defines what type of input is to be expected.  To declare the input type use TYPE=&quot;typename&quot;.  You could set the typename equal to any of the following:</P>
<P>TEXT : This will create a textbox field which you can type text into.  The length of the textbox can be adjusted using SIZE=XX where XX is the number of characters you can fit into the text box.</P>
<P>PASSWORD : The only difference between this and a textbox form element is that characters typed into a box of type PASSWORD are not displayed.</P>
<P>RADIO : Shows a radio button.</P>
<P>CHECKBOX : Shows a box which will display an X or a tick if clicked on.</P>
<P>HIDDEN : This will cause the element which would normally be displayed to be hidden.  This field is used to send information which the user cannot see.</P>
<P>IMAGE : Will use an image which is specified using SRC as a method of obtaining input.  A click on any part of the image will send the X and Y co-ordinates of the click to be processed along with the form.</P>
<P>SUBMIT : This displays a button whose title is specified by the NAME option, when the button is pressed it will carry out the action specified in the main FORM tag.</P>
<P>RESET : This button, when pressed, will reset or clear all the fields of the form.</P>
<P>NAME=&quot;name&quot; : This is a common attribute for all the above which assigns each form input a name.</P>
<P>VALUE=&quot;value&quot; : This gives a value to each form element. The way this works is that, when an element is selected or indicated, like clicking on a checkbox, the VALUE defined for that element is passed off to whatever action is associated with the form.</P>
<P>&nbsp;</P>
<P>CHECKED : This is used for radio and checkbox elements to denote that they should appear to be 'on' when the form is first printed.</P>
<P>&nbsp;</P>
<P>Sometimes you may need to supply a large text area to type information into. You can use a TEXTAREA tag to denote that the browser should draw a box for the user to type in information or paste information in from other applications.</P>
<P>&lt;TEXTAREA&gt; This indicates that the text area starts, it can contain the following attributes.</P>
<P>ROWS=XX : This dictates how many rows will be displayed for the text box.</P>
<P>COLS=XX : This dictates how many columns will be displayed for the text box.</P>
<P>After the &lt;TEXTAREA&gt; tag and before the end of the textarea you can place information that you want to appear in the textbox,  for example you may require that the user alter some information that you place in the text box.</P>
<P>&lt;/TEXTAREA&gt; : Marks the end of the text box.</P>
<P>For example, the HTML code below will place a textbox 25 columns wide and three rows deep on the page.  It will also place the words 'Remove the verb from this sentence' in the box.</P>
<P>&lt;TEXTAREA ROWS=3 COLS=25&gt;</P>
<P>Remove the verb from this sentence</P>
<P>&lt;/TEXTAREA&gt;</P>
<P>&nbsp;</P>
<P>&lt;SELECT&gt;..&lt;/SELECT&gt; The select tag will allow you to display a menu of choices.  It can contain a number of attributes:</P>
<P>SIZE=XX : Dictates how many of the options will be displayed.</P>
<P>MULTIPLE : Indicates that more than one option may be selected.</P>
<P>Each option in the select list will be preceded by &lt;OPTION&gt; Which can contain a value for each option VALUE=&quot;value&quot;.</P>
<P>So for example the following HTML will create a list of colors, displaying two at a time, from which you can select only one color.</P>
<P>&lt;SELECT SIZE=2&gt;</P>
<P>&lt;OPTION VALUE=&quot;Color1&quot;&gt; Blue</P>
<P>&lt;OPTION VALUE=&quot;Color2&quot;&gt; Red</P>
<P>&lt;OPTION VALUE=&quot;Color3&quot;&gt; Grey</P>
<P>&lt;/SELECT&gt;</P>
<P>&nbsp;</P>
<P>For an example of a form look at the last section of chapter 7.</P>
<P>&nbsp;</P>
</FONT>
</slide>
<slide id=html-scripts cap=Scripts>
<U><FONT FACE="Chicago,Arial" SIZE=6><P>Scripts</P>
</U></FONT><FONT SIZE=3><P>&lt;SCRIPT&gt;..&lt;/SCRIPT&gt;  Used to enclose code that the browser will attempt to execute. As an option you can define the language that the script is written in by using the LANGUAGE attribute, e.g.</P>
<P>&lt;SCRIPT LANGUAGE=&quot;JavaScript&quot;&gt;  will indicate that the enclosed script is written in JavaScript. </P>
<P>&nbsp;</P></FONT>
</slide>
<slide id=html-special cap="Special characters">


<U><FONT FACE="Chicago,Arial" SIZE=6><P>Special characters</P>
</U></FONT><FONT SIZE=3><P>How do you include characters in your HTML page which are not part of the normal character set, characters like <FONT FACE="Courier New">&#252;</FONT>
, <FONT FACE="Courier New">&#233;</FONT>
, etc. ? Many foreign and other characters are defined in the ISO-8859-1 character set and most browsers can display characters which belong to this set.  To indicate that you want to display a character from this set you need to type '&amp;#' and the number of the character followed by a ';' (e.g. if I wanted <FONT FACE="Courier New">&#252;</FONT>
 I would type &amp;#252;).  The browser would replace this instruction by a <FONT FACE="Courier New">&#252;</FONT>
.  All the characters in the ISO-8859-1 character set also have names which can be used instead of their number. For example I could type &amp;uuml; instead of &amp;#252;. Note that you have to use this system when you want your browser to print out an example of HTML code.</P>
<P>For example if I wanted the browser to print out:</P>
<P>&lt;html&gt;</P>
<P>Hello there</P>
<P>&lt;/html&gt;</P>
<P>I would had to have typed:</P>
<P>&amp;lt; html &amp;gt;</P>
<P>Hello there</P>
<P>&amp;lt; /html &amp;gt;</P>
<P>This stops the browser from interpreting and displaying the HTML 'code' you want to print out.  A table which shows the character codes and the characters they produce is shown below.</P>
<P>&nbsp;</P></FONT>
<TABLE BORDER CELLSPACING=1 CELLPADDING=6 WIDTH=581 ALIGN="LEFT" HSPACE=12>
<TR><TD WIDTH="25%" VALIGN="TOP">
<B><FONT SIZE=3><P ALIGN="CENTER">Description</B></FONT></TD>
<TD WIDTH="25%" VALIGN="TOP">
<B><FONT SIZE=3><P ALIGN="CENTER">Code</B></FONT></TD>
<TD WIDTH="25%" VALIGN="TOP">
<B><FONT SIZE=3><P ALIGN="CENTER">Name </B></FONT></TD>
<TD WIDTH="25%" VALIGN="TOP">
<B><FONT SIZE=3><P>Character Displayed</B></FONT></TD>
</TR>
<TR><TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P>quotation mark</FONT></TD>
<TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P>&amp;#34;</FONT></TD>
<TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P>&amp;quot;</FONT></TD>
<TD WIDTH="25%" VALIGN="TOP">
<B><FONT SIZE=3><P>&quot;</B></FONT></TD>
</TR>
<TR><TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P>ampersand</FONT></TD>
<TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P>&amp;#38;</FONT></TD>
<TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P>&amp;amp;</FONT></TD>
<TD WIDTH="25%" VALIGN="TOP">
<B><FONT SIZE=3><P>&amp;</B></FONT></TD>
</TR>
<TR><TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P>less-than sign</FONT></TD>
<TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P>&amp;#60;</FONT></TD>
<TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P>&amp;lt;</FONT></TD>
<TD WIDTH="25%" VALIGN="TOP">
<PRE>&lt;</PRE></TD>
</TR>
<TR><TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P>greater-than sign</FONT></TD>
<TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P>&amp;#62;</FONT></TD>
<TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P>&amp;gt;</FONT></TD>
<TD WIDTH="25%" VALIGN="TOP">
<PRE>&gt;</PRE></TD>
</TR>
<TR><TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P>non-breaking space</FONT></TD>
<TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P>&amp;#160;</FONT></TD>
<TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P>&amp;nbsp;</FONT></TD>
<TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P>&nbsp;</FONT></TD>
</TR>
<TR><TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P>inverted exclamation mark</FONT></TD>
<TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P>&amp;#161;</FONT></TD>
<TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P>&amp;iexcl;</FONT></TD>
<TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P></FONT></TD>
</TR>
<TR><TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P>cent sign</FONT></TD>
<TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P>&amp;#162;</FONT></TD>
<TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P>&amp;cent;</FONT></TD>
<TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P></FONT></TD>
</TR>
<TR><TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P>pound sign</FONT></TD>
<TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P>&amp;#163;</FONT></TD>
<TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P>&amp;pound;</FONT></TD>
<TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P></FONT></TD>
</TR>
<TR><TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P>currency sign</FONT></TD>
<TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P>&amp;#164;</FONT></TD>
<TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P>&amp;curren;</FONT></TD>
<TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P></FONT></TD>
</TR>
<TR><TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P>yen sign</FONT></TD>
<TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P>&amp;#165;</FONT></TD>
<TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P>&amp;yen;</FONT></TD>
<TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P></FONT></TD>
</TR>
<TR><TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P>broken vertical bar</FONT></TD>
<TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P>&amp;#166;</FONT></TD>
<TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P>&amp;brvbar;</FONT></TD>
<TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P></FONT></TD>
</TR>
<TR><TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P>section sign</FONT></TD>
<TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P>&amp;#167;</FONT></TD>
<TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P>&amp;sect;</FONT></TD>
<TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P></FONT></TD>
</TR>
<TR><TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P>spacing diaresis</FONT></TD>
<TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P>&amp;#168;</FONT></TD>
<TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P>&amp;uml;</FONT></TD>
<TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P></FONT></TD>
</TR>
<TR><TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P>copyright sign</FONT></TD>
<TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P>&amp;#169;</FONT></TD>
<TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P>&amp;copy;</FONT></TD>
<TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P>&copy;</FONT></TD>
</TR>
<TR><TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P>feminine ordinal indicator</FONT></TD>
<TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P>&amp;#170;</FONT></TD>
<TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P>&amp;ordf;</FONT></TD>
<TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P></FONT></TD>
</TR>
<TR><TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P>angle quotation mark, left</FONT></TD>
<TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P>&amp;#171;</FONT></TD>
<TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P>&amp;laquo;</FONT></TD>
<TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P></FONT></TD>
</TR>
<TR><TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P>negation sign</FONT></TD>
<TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P>&amp;#172;</FONT></TD>
<TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P>&amp;not;</FONT></TD>
<TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P></FONT></TD>
</TR>
<TR><TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P>soft hyphen</FONT></TD>
<TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P>&amp;#173;</FONT></TD>
<TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P>&amp;shy;</FONT></TD>
<TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P></FONT></TD>
</TR>
<TR><TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P>circled R registered sign</FONT></TD>
<TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P>&amp;#174;</FONT></TD>
<TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P>&amp;reg;</FONT></TD>
<TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P>&reg;</FONT></TD>
</TR>
<TR><TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P>spacing macron</FONT></TD>
<TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P>&amp;#175;</FONT></TD>
<TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P>&amp;hibar;</FONT></TD>
<TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P></FONT></TD>
</TR>
<TR><TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P>degree sign</FONT></TD>
<TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P>&amp;#176;</FONT></TD>
<TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P>&amp;deg;</FONT></TD>
<TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P></FONT></TD>
</TR>
<TR><TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P>plus-or-minus sign</FONT></TD>
<TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P>&amp;#177;</FONT></TD>
<TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P>&amp;plusmn;</FONT></TD>
<TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P></FONT></TD>
</TR>
<TR><TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P>superscript 2</FONT></TD>
<TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P>&amp;#178;</FONT></TD>
<TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P>&amp;sup2;</FONT></TD>
<TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P></FONT></TD>
</TR>
<TR><TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P>superscript 3</FONT></TD>
<TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P>&amp;#179;</FONT></TD>
<TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P>&amp;sup3;</FONT></TD>
<TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P></FONT></TD>
</TR>
<TR><TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P>spacing acute</FONT></TD>
<TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P>&amp;#180;</FONT></TD>
<TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P>&amp;acute;</FONT></TD>
<TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P></FONT></TD>
</TR>
<TR><TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P>micro sign</FONT></TD>
<TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P>&amp;#181;</FONT></TD>
<TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P>&amp;micro;</FONT></TD>
<TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P></FONT></TD>
</TR>
<TR><TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P>paragraph sign</FONT></TD>
<TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P>&amp;#182;</FONT></TD>
<TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P>&amp;para;</FONT></TD>
<TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P></FONT></TD>
</TR>
<TR><TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P>middle dot</FONT></TD>
<TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P>&amp;#183;</FONT></TD>
<TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P>&amp;middot;</FONT></TD>
<TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P></FONT></TD>
</TR>
<TR><TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P>spacing cedilla</FONT></TD>
<TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P>&amp;#184;</FONT></TD>
<TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P>&amp;cedil;</FONT></TD>
<TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P></FONT></TD>
</TR>
<TR><TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P>superscript 1</FONT></TD>
<TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P>&amp;#185;</FONT></TD>
<TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P>&amp;sup1;</FONT></TD>
<TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P></FONT></TD>
</TR>
<TR><TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P>masculine ordinal indicator</FONT></TD>
<TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P>&amp;#186;</FONT></TD>
<TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P>&amp;ordm;</FONT></TD>
<TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P></FONT></TD>
</TR>
<TR><TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P>angle quotation mark, right</FONT></TD>
<TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P>&amp;#187;</FONT></TD>
<TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P>&amp;raquo;</FONT></TD>
<TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P></FONT></TD>
</TR>
<TR><TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P>fraction </FONT></TD>
<TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P>&amp;#188;</FONT></TD>
<TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P>&amp;frac14;</FONT></TD>
<TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P></FONT></TD>
</TR>
<TR><TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P>fraction </FONT></TD>
<TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P>&amp;#189;</FONT></TD>
<TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P>&amp;frac12;</FONT></TD>
<TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P></FONT></TD>
</TR>
<TR><TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P>fraction </FONT></TD>
<TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P>&amp;#190;</FONT></TD>
<TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P>&amp;frac34;</FONT></TD>
<TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P></FONT></TD>
</TR>
<TR><TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P>inverted question mark</FONT></TD>
<TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P>&amp;#191;</FONT></TD>
<TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P>&amp;iquest;</FONT></TD>
<TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P></FONT></TD>
</TR>
<TR><TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P>capital A, grave accent</FONT></TD>
<TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P>&amp;#192;</FONT></TD>
<TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P>&amp;Agrave;</FONT></TD>
<TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P>&Agrave;</FONT></TD>
</TR>
<TR><TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P>capital A, acute accent</FONT></TD>
<TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P>&amp;#193;</FONT></TD>
<TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P>&amp;Aacute;</FONT></TD>
<TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P>&Aacute;</FONT></TD>
</TR>
<TR><TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P>capital A, circumflex accent</FONT></TD>
<TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P>&amp;#194;</FONT></TD>
<TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P>&amp;Acirc;</FONT></TD>
<TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P>&Acirc;</FONT></TD>
</TR>
<TR><TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P>capital A, tilde</FONT></TD>
<TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P>&amp;#195;</FONT></TD>
<TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P>&amp;Atilde;</FONT></TD>
<TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P>&Atilde;</FONT></TD>
</TR>
<TR><TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P>capital A, dieresis / umlaut mark</FONT></TD>
<TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P>&amp;#196;</FONT></TD>
<TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P>&amp;Auml;</FONT></TD>
<TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P>&Auml;</FONT></TD>
</TR>
<TR><TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P>capital A, ring</FONT></TD>
<TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P>&amp;#197;</FONT></TD>
<TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P>&amp;Aring;</FONT></TD>
<TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P>&Aring;</FONT></TD>
</TR>
<TR><TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P>capital AE diphthong (ligature)</FONT></TD>
<TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P>&amp;#198;</FONT></TD>
<TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P>&amp;AElig;</FONT></TD>
<TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P>&AElig;</FONT></TD>
</TR>
<TR><TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P>capital C, cedilla</FONT></TD>
<TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P>&amp;#199;</FONT></TD>
<TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P>&amp;Ccedil;</FONT></TD>
<TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P>&Ccedil;</FONT></TD>
</TR>
<TR><TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P>capital E, grave accent</FONT></TD>
<TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P>&amp;#200;</FONT></TD>
<TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P>&amp;Egrave;</FONT></TD>
<TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P>&Egrave;</FONT></TD>
</TR>
<TR><TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P>capital E, acute accent</FONT></TD>
<TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P>&amp;#201;</FONT></TD>
<TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P>&amp;Eacute;</FONT></TD>
<TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P>&Eacute;</FONT></TD>
</TR>
<TR><TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P>capital E, circumflex accent</FONT></TD>
<TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P>&amp;#202;</FONT></TD>
<TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P>&amp;Ecirc;</FONT></TD>
<TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P>&Ecirc;</FONT></TD>
</TR>
<TR><TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P>capital E, dieresis / umlaut mark</FONT></TD>
<TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P>&amp;#203;</FONT></TD>
<TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P>&amp;Euml;</FONT></TD>
<TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P>&Euml;</FONT></TD>
</TR>
<TR><TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P>capital I, grave accent</FONT></TD>
<TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P>&amp;#204;</FONT></TD>
<TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P>&amp;Igrave;</FONT></TD>
<TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P>&Igrave;</FONT></TD>
</TR>
<TR><TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P>capital I, acute accent</FONT></TD>
<TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P>&amp;#205;</FONT></TD>
<TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P>&amp;Iacute;</FONT></TD>
<TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P>&Iacute;</FONT></TD>
</TR>
<TR><TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P>capital I, circumflex accent</FONT></TD>
<TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P>&amp;#206;</FONT></TD>
<TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P>&amp;Icirc;</FONT></TD>
<TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P>&Icirc;</FONT></TD>
</TR>
<TR><TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P>capital I, dieresis / umlaut mark</FONT></TD>
<TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P>&amp;#207;</FONT></TD>
<TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P>&amp;Iuml;</FONT></TD>
<TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P>&Iuml;</FONT></TD>
</TR>
<TR><TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P>capital Eth, Icelandic</FONT></TD>
<TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P>&amp;#208;</FONT></TD>
<TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P>&amp;ETH;</FONT></TD>
<TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P>&ETH;</FONT></TD>
</TR>
<TR><TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P>capital Eth, Icelandic</FONT></TD>
<TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P>&amp;#208;</FONT></TD>
<TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P>&amp;Dstrok;</FONT></TD>
<TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P>&ETH;</FONT></TD>
</TR>
<TR><TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P>capital N, tilde</FONT></TD>
<TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P>&amp;#209;</FONT></TD>
<TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P>&amp;Ntilde;</FONT></TD>
<TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P>&Ntilde;</FONT></TD>
</TR>
<TR><TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P>capital O, grave accent</FONT></TD>
<TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P>&amp;#210;</FONT></TD>
<TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P>&amp;Ograve;</FONT></TD>
<TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P>&Ograve;</FONT></TD>
</TR>
<TR><TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P>capital O, acute accent</FONT></TD>
<TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P>&amp;#211;</FONT></TD>
<TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P>&amp;Oacute;</FONT></TD>
<TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P>&Oacute;</FONT></TD>
</TR>
<TR><TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P>capital O, circumflex accent</FONT></TD>
<TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P>&amp;#212;</FONT></TD>
<TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P>&amp;Ocirc;</FONT></TD>
<TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P>&Ocirc;</FONT></TD>
</TR>
<TR><TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P>capital O, tilde</FONT></TD>
<TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P>&amp;#213;</FONT></TD>
<TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P>&amp;Otilde;</FONT></TD>
<TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P>&Otilde;</FONT></TD>
</TR>
<TR><TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P>capital O, dieresis / umlaut mark</FONT></TD>
<TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P>&amp;#214;</FONT></TD>
<TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P>&amp;Ouml;</FONT></TD>
<TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P>&Ouml;</FONT></TD>
</TR>
<TR><TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P>multiplication sign</FONT></TD>
<TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P>&amp;#215;</FONT></TD>
<TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P>&amp;times;</FONT></TD>
<TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P></FONT></TD>
</TR>
<TR><TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P>capital O, slash</FONT></TD>
<TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P>&amp;#216;</FONT></TD>
<TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P>&amp;Oslash;</FONT></TD>
<TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P>&Oslash;</FONT></TD>
</TR>
<TR><TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P>capital U, grave accent</FONT></TD>
<TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P>&amp;#217;</FONT></TD>
<TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P>&amp;Ugrave;</FONT></TD>
<TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P>&Ugrave;</FONT></TD>
</TR>
<TR><TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P>capital U, acute accent</FONT></TD>
<TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P>&amp;#218;</FONT></TD>
<TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P>&amp;Uacute;</FONT></TD>
<TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P>&Uacute;</FONT></TD>
</TR>
<TR><TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P>capital U, circumflex accent</FONT></TD>
<TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P>&amp;#219;</FONT></TD>
<TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P>&amp;Ucirc;</FONT></TD>
<TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P>&Ucirc;</FONT></TD>
</TR>
<TR><TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P>capital U, dieresis / umlaut mark</FONT></TD>
<TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P>&amp;#220;</FONT></TD>
<TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P>&amp;Uuml;</FONT></TD>
<TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P>&Uuml;</FONT></TD>
</TR>
<TR><TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P>capital Y, acute accent</FONT></TD>
<TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P>&amp;#221;</FONT></TD>
<TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P>&amp;Yacute;</FONT></TD>
<TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P>&Yacute;</FONT></TD>
</TR>
<TR><TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P>capital THORN, Icelandic</FONT></TD>
<TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P>&amp;#222;</FONT></TD>
<TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P>&amp;THORN;</FONT></TD>
<TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P>&THORN;</FONT></TD>
</TR>
<TR><TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P>small sharp s, German (sz ligature)</FONT></TD>
<TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P>&amp;#223;</FONT></TD>
<TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P>&amp;szlig;</FONT></TD>
<TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P>&szlig;</FONT></TD>
</TR>
<TR><TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P>small a, grave accent</FONT></TD>
<TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P>&amp;#224;</FONT></TD>
<TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P>&amp;agrave;</FONT></TD>
<TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P>&agrave;</FONT></TD>
</TR>
<TR><TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P>small a, acute accent</FONT></TD>
<TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P>&amp;#225;</FONT></TD>
<TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P>&amp;aacute;</FONT></TD>
<TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P>&aacute;</FONT></TD>
</TR>
<TR><TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P>small a, circumflex accent</FONT></TD>
<TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P>&amp;#226;</FONT></TD>
<TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P>&amp;acirc;</FONT></TD>
<TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P>&acirc;</FONT></TD>
</TR>
<TR><TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P>small a, tilde</FONT></TD>
<TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P>&amp;#227;</FONT></TD>
<TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P>&amp;atilde;</FONT></TD>
<TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P>&atilde;</FONT></TD>
</TR>
<TR><TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P>small a, dieresis / umlaut mark</FONT></TD>
<TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P>&amp;#228;</FONT></TD>
<TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P>&amp;auml;</FONT></TD>
<TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P>&auml;</FONT></TD>
</TR>
<TR><TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P>small a, ring</FONT></TD>
<TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P>&amp;#229;</FONT></TD>
<TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P>&amp;aring;</FONT></TD>
<TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P>&aring;</FONT></TD>
</TR>
<TR><TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P>small ae diphthong (ligature)</FONT></TD>
<TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P>&amp;#230;</FONT></TD>
<TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P>&amp;aelig;</FONT></TD>
<TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P>&aelig;</FONT></TD>
</TR>
<TR><TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P>small c, cedilla</FONT></TD>
<TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P>&amp;#231;</FONT></TD>
<TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P>&amp;ccedil;</FONT></TD>
<TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P>&ccedil;</FONT></TD>
</TR>
<TR><TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P>small e, grave accent</FONT></TD>
<TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P>&amp;#232;</FONT></TD>
<TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P>&amp;egrave;</FONT></TD>
<TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P>&egrave;</FONT></TD>
</TR>
<TR><TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P>small e, acute accent</FONT></TD>
<TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P>&amp;#233;</FONT></TD>
<TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P>&amp;eacute;</FONT></TD>
<TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P>&eacute;</FONT></TD>
</TR>
<TR><TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P>small e, circumflex accent</FONT></TD>
<TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P>&amp;#234;</FONT></TD>
<TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P>&amp;ecirc;</FONT></TD>
<TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P>&ecirc;</FONT></TD>
</TR>
<TR><TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P>small e, dieresis / umlaut mark</FONT></TD>
<TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P>&amp;#235;</FONT></TD>
<TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P>&amp;euml;</FONT></TD>
<TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P>&euml;</FONT></TD>
</TR>
<TR><TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P>small i, grave accent</FONT></TD>
<TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P>&amp;#236;</FONT></TD>
<TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P>&amp;igrave;</FONT></TD>
<TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P>&igrave;</FONT></TD>
</TR>
<TR><TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P>small i, acute accent</FONT></TD>
<TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P>&amp;#237;</FONT></TD>
<TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P>&amp;iacute;</FONT></TD>
<TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P>&iacute;</FONT></TD>
</TR>
<TR><TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P>small i, circumflex accent</FONT></TD>
<TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P>&amp;#238;</FONT></TD>
<TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P>&amp;icirc;</FONT></TD>
<TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P>&icirc;</FONT></TD>
</TR>
<TR><TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P>small i, dieresis / umlaut mark</FONT></TD>
<TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P>&amp;#239;</FONT></TD>
<TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P>&amp;iuml;</FONT></TD>
<TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P>&iuml;</FONT></TD>
</TR>
<TR><TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P>small eth, Icelandic</FONT></TD>
<TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P>&amp;#240;</FONT></TD>
<TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P>&amp;eth;</FONT></TD>
<TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P>&eth;</FONT></TD>
</TR>
<TR><TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P>small n, tilde</FONT></TD>
<TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P>&amp;#241;</FONT></TD>
<TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P>&amp;ntilde;</FONT></TD>
<TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P>&ntilde;</FONT></TD>
</TR>
<TR><TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P>small o, grave accent</FONT></TD>
<TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P>&amp;#242;</FONT></TD>
<TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P>&amp;ograve;</FONT></TD>
<TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P>&ograve;</FONT></TD>
</TR>
<TR><TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P>small o, acute accent</FONT></TD>
<TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P>&amp;#243;</FONT></TD>
<TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P>&amp;oacute;</FONT></TD>
<TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P>&oacute;</FONT></TD>
</TR>
<TR><TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P>small o, circumflex accent</FONT></TD>
<TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P>&amp;#244;</FONT></TD>
<TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P>&amp;ocirc;</FONT></TD>
<TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P>&ocirc;</FONT></TD>
</TR>
<TR><TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P>small o, tilde</FONT></TD>
<TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P>&amp;#245;</FONT></TD>
<TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P>&amp;otilde;</FONT></TD>
<TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P>&otilde;</FONT></TD>
</TR>
<TR><TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P>small o, dieresis / umlaut mark</FONT></TD>
<TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P>&amp;#246;</FONT></TD>
<TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P>&amp;ouml;</FONT></TD>
<TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P>&ouml;</FONT></TD>
</TR>
<TR><TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P>division sign</FONT></TD>
<TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P>&amp;#247;</FONT></TD>
<TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P>&amp;divide;</FONT></TD>
<TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P></FONT></TD>
</TR>
<TR><TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P>small o, slash</FONT></TD>
<TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P>&amp;#248;</FONT></TD>
<TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P>&amp;oslash;</FONT></TD>
<TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P>&oslash;</FONT></TD>
</TR>
<TR><TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P>small u, grave accent</FONT></TD>
<TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P>&amp;#249;</FONT></TD>
<TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P>&amp;ugrave;</FONT></TD>
<TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P>&ugrave;</FONT></TD>
</TR>
<TR><TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P>small u, acute accent</FONT></TD>
<TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P>&amp;#250;</FONT></TD>
<TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P>&amp;uacute;</FONT></TD>
<TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P>&uacute;</FONT></TD>
</TR>
<TR><TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P>small u, circumflex accent</FONT></TD>
<TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P>&amp;#251;</FONT></TD>
<TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P>&amp;ucirc;</FONT></TD>
<TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P>&ucirc;</FONT></TD>
</TR>
<TR><TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P>small u, dieresis / umlaut mark</FONT></TD>
<TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P>&amp;#252;</FONT></TD>
<TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P>&amp;uuml;</FONT></TD>
<TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P>&uuml;</FONT></TD>
</TR>
<TR><TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P>small y, acute accent</FONT></TD>
<TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P>&amp;#253;</FONT></TD>
<TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P>&amp;yacute;</FONT></TD>
<TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P>&yacute;</FONT></TD>
</TR>
<TR><TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P>small thorn, Icelandic</FONT></TD>
<TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P>&amp;#254;</FONT></TD>
<TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P>&amp;thorn;</FONT></TD>
<TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P>&thorn;</FONT></TD>
</TR>
<TR><TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P>small y, dieresis/ umlaut mark</FONT></TD>
<TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P>&amp;#255;</FONT></TD>
<TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P>&amp;yuml;</FONT></TD>
<TD WIDTH="25%" VALIGN="TOP">
<FONT SIZE=3><P>&yuml;</FONT></TD>
</TR>
</TABLE>
</slide>
</BODY>
</HTML>

