<slide id=plugins cap="Netscape Navigator Unix Plugin Architecture">
@* <a href=@talk-plugins.html target=_top>Netscape Navigator Unix Plugin Architecture V 0.9</a>
<p>
Wed May 15 23:28:24 PDT 1996				dp@netscape.com
<br>
adapted for presentation by A. Eliens (VU)
<br>
See also: <a href=@online/hush/sources/plugins/index.html><i>hush</i> plugins</a>
<p>

This document describes the architecture of the unix plugins.
This would help developers write their own plugins and interface them
with netscape.
<p>
@ Intended Audience
<ul>
        <li> Plugin developers on unix platforms
</ul>
<p>
This assumes that the developer is aware of when and why a plugin is
required.
</slide>


<slide id=plugins-platforms cap="Platforms">
@ Platforms currently supported
<ul>
        <li> SunOS 4.1.3 and above
        <li> Solaris 5.3
        <li> Solaris 5.4
        <li> IRIX 5.2 and above
        <li> OSF1 V2.0 alpha and above
	<li> HPUX 09.* 10.*
</ul>
Plugins require one of the following versions of the a unix navigator
<ul>
	<li> Atlas Release
	<li> 3.0 browser
</ul>
</slide>



<slide id=plugins-contents cap="Contents">
@ Contents
<ul>
        <li> General architecture of Netscape Unix Plugins SDK
        <li> How to write a plugin
        <li> Sample Text plugin
        <li> Do's and Dont's
</ul>
</slide>

<slide id=plugins-architecture cap="General architecture of Netscape Unix Plugins SDK">
@ General architecture of Netscape Unix Plugins SDK
<display>
----------------------------------------------------------------------
               |                         |
               |                         |
Netscape       |         Wrapper         |             Plugin Developer
Navigator      |         npunix.c        |             npshell.c
               |                         |
Talks with the | Implements function     |  Can ignore the existence of
the plugin via | tables as required      |  functions tables and call NPN_*()
wrapper code   | by the navigator's      |  functions to call the navigator
in npunix.c    | plugin interface and    |  and implement NPP_* functions
               | provides plugin         |  to hookup to the navigator.
               | developers with a       |
               | std. set of functions   |
               |                         |
               | WONT NEED TO EDIT THIS. | FILL UP functions in npshell.c
               | NEED TO COMPILE WITH    | and write many more...
               | THIS.                   |
----------------------------------------------------------------------
</display>
</slide>
<slide id=plugins-arch2 cap="Architecture (2)">
<p>
The plugin in the unix platform is implemented as a dynamically loadable
module (.so) The navigator searches for these dynamically loadable modules
in the list of directories as specified by the environment variable
NPX_PLUGIN_PATH. This variable can be set to a ':' separated list of
directories. The default path if this environment variable is not set
is "/usr/local/lib/netscape/plugins/:$HOME/.netscape/plugins/"
<pre>
        NOTE: On SunOS4.1.3, if there are any non-loadable modules in
              any of the directories specified by NPX_PLUGIN_PATH, then
              the dlopen() library call exits rather than giving an error.
              thus causing the navigator to terminate.
</pre>
<p>
The navigator detect which MIME types are recognized by a plugin by calling
NPP_GetMIMEDescription() in npshell.c (via NP_GetMIMEDescription() in
npunix.c). From then on, whenever it detect data of the
particular MIME type, it loads the plugin and creates instances of the
corresponding plugin object. Before creating the first plugin instance
the navigator will call NPP_Initialize() in npshell.c (via NP_Initialize()
in npunix.c). Also after the last plugin instance has been destroyed,
the navigator will call NPP_Shutdown() in npshell.c (via NP_Shutdown()
in npunix.c)
</slide>


<slide id=plugins-how cap="How to write a plugin">
@ How to write a plugin
<ol>
        <li> Fill up all the necessary functions in npshell.c
           To hook up and talk with the navigator. Refer to
           "The plugin API" for more information on these
           functions.

        <li> Add new functions/files as required by your plugin.
           Use npapi.h for a description of data structures passed
           between the navigator and the plugin code.

        <li> Compile the plugin code with npunix.c, npshell.c into
           a platform specific dynamically loadable module.

        <li> Install the dynamically loadable module in NPX_PLUGIN_PATH,
	   "/usr/local/lib/netscape/plugins/:$HOME/.netscape/plugins/"
	   by default.

        <li> Start the navigator. From now on, whenever the MIME type
           of interest to the plugin is encountered, the navigator
           will call the appropriate functions in the plugin.
</ol>
</slide>

<slide id=plugins-sample cap="Sample Text plugin">
@ Sample Text plugin
<p>
As an example, here is a text plugin. This plugin is intended only to
demonstrate how plugin developers can write plugins. The text plugin
operates on MIME type and extension "text/plain;.txt"
So whenever the navigator gets data with mime type "text/plain"
(or) needs to display a file with the extension ".txt", it passes the
data over to the plugin code as discussed by the Plugin API. The text
plugin creates a scrolled window using motif and displays the data
it received in the window. All code that is specific to the text
plugin is ifdeffed TEXT_PLUGIN in npshell.c
</slide>


<slide id=plugins-run cap="How to run the sample text plugin">
@ How to run the sample text plugin
<ol>
        <li> Compile the text plugin code to get a libtextplugin.so
        <li> Make a directory say, $HOME/.netscape/plugins
	<display>
                mkdir $HOME/.netscape/plugins
	</display>
        <li> Copy the libtextplugin.so to that directory
        <display>
                cp libtextplugin.so $HOME/.netscape/plugins
        </display>
        <li> Set NPX_PLUGIN_PATH to that directory
        <display>
            for csh:
                setenv NPX_PLUGIN_PATH $HOME/.netscape/plugins
            for ksh/sh:
                NPX_PLUGIN_PATH=$HOME/.netscape/plugins; export NPX_PLUGIN_PATH
        </display>
        <li> Invoke the netscape that is plugin enabled. In the location
           field type in the file URL address of Test1.html
            e.g if Test1.html was found in /home/dp/plugins/SDK/Test.html
                the URL to use would be
                file:/home/dp/plugins/SDK/Test1.html
</ol>
</slide>
<slide id=plugins-result cap="Result">
@ Result:
<p>
		You will see a page with a motif Multiline Text Widget
		that shows the contents of file Test.txt
<p>
		You might get some debug prints in stderr. To turn them
		off, compile your plugin without defining PLUGIN_TRACE.
		This change can be made in the makefile.

</slide>
<slide id=plugins-trouble cap="Trouble Shooting">
@ Trouble Shooting:
<p> If you dont see the text plugin,
<ul>
<li>        (a) See if the file Test1.txt is accessible using a http address
<li>        (b) Check if the server returns "text/plain" as the mime type for
            http access to Test1.txt
<li>	(c) Select Options->General Preferences->Helpers (if available)
	    in the browser and ensure that for the mime-type text/plain,
	    the Sample Text Plugin is enabled.
</ul>
<p>
	The test/ directory has a few plugin tests that you could run
	to verify if things are ok. Each test is a html file and explains
	how to run the test and verify the result.
</slide>
            

<slide id=plugins-dodos cap="Do's and Dont's">
@ Do's and Dont's
<ul>
        <li> INSTALL YOUR OWN EVENT HANDLERS FOR THE PLUGIN WINDOW TO
          GET EVENTS.
          Netscape Navigator uses Xt/Motif for its display. Plugins
          can use them and install their own event handlers for their
          window.

        <li> DONT USE WorkProcs IN Xt.
          WorkProcs will not be called.

        <li> USE THE X RESOURCE NAME SPACE WITH CARE.
          plugins and netscape share the same X resources space.
          So be sure your plugin gets it resources separately.
          The navigator resources do not follow a pattern although
          we eventually will. Until then, chose unique names that
          are not used by the navigator for its X resources for
          X resources and names of widgets used by plugins.

        <li> TAKE CARE WHEN INSTALLING TIMERS TO GET IDLE CYCLES.
          Plugins installing TIMERS to get idle cycles (e.g for doing
          some animation as long as the plugin is in view) by using the
          XtAppAddTimeOut() should take care to not install 0 interval
          timer callbacks. If they do, then the network events will never
          happen.
</ul>
<slide>



<slide id=plugins-resources cap="Resources">
@ Resources
<p>
A collection of resources that will be helpful in plugin development.
This collection is as of 15 May 1996.
<p>
http://home.netscape.com/comprod/development_partners/plugin_api/index.html
<p>
ftp://ftp.netscape.com/pub/navigator/sdk/
	- SDK is available here.
<p>
http://home.netscape.com/eng/mozilla/2.0/handbook/plugins/index.html
	- Plugin development handbook.
<p>
http://cgi.netscape.com/eng/mozilla/2.0/extensions/info.cgi
	- Default plugin will take you here.
<p>
snews://secnews.netscape.com/netscape.devs-plugins
	- Secure news group for netscape developement partners. All plugin
	  related discussion happens here. To enroll into this contact
	  developer relations at http://developer.netscape.com
</slide>
