<document>
<h1>Introduction</h1>
<include file=navigate>
The <i>hush</i> toolkit has been developed at the
Vrije Universiteit, Amsterdam, as part of the DejaVu project.
It provides a C++ interface to Tcl/Tk as well as
packages for developing distributed Web-aware
hypermedia applications.
It includes the functionality needed for business process
model simulations, real sound-synthesis
and TCP/IP based client/server programming.
<p>
With the availability of industrial strength
distributed object technology such as Orbix/CORBA,
it seems natural to extend <i>hush</i>
with the functionality needed to develop distributed
CORBA-based <i>hush</i> components.
<p>
However, extending a given framework is not as straightforward
as it may seem.
First of all, one has to decide which interfaces
may become public, that is may be exported as
IDL interfaces.
Secondly,
one has to decide how object references become known
to clients, and what rights clients have
to create objects within a particular server.
The most important problem, however, concerns
the type clash between the CORBA classes
implementing the IDL interfaces
and the 'native' class hierarchy
offered by the framework itself.
<p>
This paper gives an overview of the effort of
extending <i>hush</i> with CORBA.
In section 2,
the various issues involved in extending a given
framework or toolkit will be discussed in somewhat
more detail.
In section 3,
the IDL interfaces for <i>hush</i> and the <i>widgets</i>
will be described.
In section 4, some examples are given of how
to use <i>hush</i> in a CORBA environment.
Finally, in section 5,
we will discuss what further research is needed
to make <i>hush</i> fully 'CORBA-compliant'.
<include file=navigate>
</document>
