<document>
<!-- %% AUXILIARY


\setcounter{figure}{0}
-->

<!--\title{--><control><center><h1></control>
Crush -- CORBA for <i>hush</i>
<control></center></h1></control><!--}-->

<!--
\author{
Anton Eli\"{e}ns\\

{\footnotesize \sl Vrije Universiteit,}
{\footnotesize \sl Department of Mathematics and Computer Science} \\
{\footnotesize \sl De Boelelaan 1081, 1081 HV Amsterdam}
{\footnotesize \sl The Netherlands}\\
{\footnotesize \sl email: eliens@cs.vu.nl}
} \date{}\maketitle
\def\thefootnote{}
\setcounter{page}{1}
-->

<!--\date{}\maketitle
\def\thefootnote{}
\setcounter{page}{1}
-->

<control>
<center>
Anton Eli&euml;ns
<br>
Vrije Universiteit, Department of Mathematics and Computer Science,
<br>
De Boelelaan 1081, 1081 HV Amsterdam, The Netherlands
<br>
eliens@cs.vu.nl,
<br>
fax: +31.20.4447653
</center>
</control>

<abstract>
This paper describes how the <i>hush</i> toolkit
has been extended with CORBA functionality.
The major problem that arises when extending
a given toolkit or framework, such as <i>hush</i>,
with CORBA IDL interfaces and classes to
implement these interfaces is to provide for
a seamless integration of the already existing
code with the CORBA-based extensions.
In <i>crush</i> we have included facilities
for object creation and access, as well as client-side
adaptors for the <i>hush</i> CORBA objects,
to resolve the type clash between the original <i>hush</i> 
class hierarchy and the <i>hush</i> CORBA object classes.
</abstract>


<document>
<h1>Introduction</h1>
<control>
<!--
<navigate level=1 back=index root=index up=index next=index>
-->
<hr>
<a href=contents.html>[]</a>
<a href=intro.html>introduction</a>,
<a href=problem.html>legacy</a>,
<a href=idl.html>interfaces</a>,
<a href=examples.html>examples</a>,
<a href=conc.html>conclusions</a>,
<a href=refs.html>references</a>,
<a href=appendix.html>appendix</a>
<hr>
</control>

The <i>hush</i> toolkit has been developed at the
Vrije Universiteit, Amsterdam, as part of the DejaVu project.
It provides a C++ interface to Tcl/Tk as well as
packages for developing distributed Web-aware
hypermedia applications.
It includes the functionality needed for business process
model simulations, real sound-synthesis
and TCP/IP based client/server programming.
<p>
With the availability of industrial strength
distributed object technology such as Orbix/CORBA,
it seems natural to extend <i>hush</i>
with the functionality needed to develop distributed
CORBA-based <i>hush</i> components.
<p>
However, extending a given framework is not as straightforward
as it may seem.
First of all, one has to decide which interfaces
may become public, that is may be exported as
IDL interfaces.
Secondly,
one has to decide how object references become known
to clients, and what rights clients have
to create objects within a particular server.
The most important problem, however, concerns
the type clash between the CORBA classes
implementing the IDL interfaces
and the 'native' class hierarchy
offered by the framework itself.
<p>
This paper gives an overview of the effort of
extending <i>hush</i> with CORBA.
In section 2,
the various issues involved in extending a given
framework or toolkit will be discussed in somewhat
more detail.
In section 3,
the IDL interfaces for <i>hush</i> and the <i>widgets</i>
will be described.
In section 4, some examples are given of how
to use <i>hush</i> in a CORBA environment.
Finally, in section 5,
we will discuss what further research is needed
to make <i>hush</i> fully 'CORBA-compliant'.
<control>
<!--
<navigate level=1 back=index root=index up=index next=index>
-->
<hr>
<a href=contents.html>[]</a>
<a href=intro.html>introduction</a>,
<a href=problem.html>legacy</a>,
<a href=idl.html>interfaces</a>,
<a href=examples.html>examples</a>,
<a href=conc.html>conclusions</a>,
<a href=refs.html>references</a>,
<a href=appendix.html>appendix</a>
<hr>
</control>

</document>
<document>
@* The legacy problem -- integrating CORBA
<control>
<!--
<navigate level=1 back=index root=index up=index next=index>
-->
<hr>
<a href=contents.html>[]</a>
<a href=intro.html>introduction</a>,
<a href=problem.html>legacy</a>,
<a href=idl.html>interfaces</a>,
<a href=examples.html>examples</a>,
<a href=conc.html>conclusions</a>,
<a href=refs.html>references</a>,
<a href=appendix.html>appendix</a>
<hr>
</control>


CORBA technology is well-suited to develop
distributed applications.
For new projects, the restrictions imposed by
CORBA can be taken into consideration from the start.
For projects that carry the legacy of existing code,
a decision must be made to what extent the
CORBA functionality is integrated with the legacy code.
On one side of the spectrum,
CORBA technology can be used simply for wrapping the legacy
code.
For example a database may be embedded
in a CORBA server, without affecting the database itself.
However, for an object-oriented framework such as <i>hush</i>
such a solution is not very satisfying.
Instead, one would like to have the basic
interfaces of <i>hush</i> available to develop
distributed components of arbitrary granularity.
In this section, we will discuss some of the issues
that arise when extending a given (GUI or hypermedia)
framework with CORBA IDL interfaces reflecting
the functionality of the original framework.


@+ Object creation and access

The CORBA Naming Service may be used to provide access to
an object residing somewhere on a server.
Alternatively, the server may export a reference to
a factory object that allows the client to create objects within the
server.
<p>
For giving access to objects within a particular <i>hush</i>
component, we have provided <i>dots</i> (distributed object tables)
for both <i>hush</i> and <i>widgets</i> components.
Using the <i>dot</i> the client can access an object of a given type by
the name it is given by the server.
The object must already exist in the server.
<p>
In case clients are allowed to create objects within
the server, a <i>factory</i> is provided for creating <i>hush</i>
or <i>widget</i> objects.

@+ Client-side adaptors

The intermediary between clients and servers in a CORBA-based system
are the CORBA IDL classes generated by the <i>idl</i> compiler
from the IDL interfaces.
These classes (using the C++ language binding)
inherit directly from the CORBA::Object class and hence 
do not fit within the given class hierarchy.
<p>
To allow clients the use of CORBA IDL classes wherever one
of the original <i>hush</i> classes is expected,
client-side adaptors have been provided for each of the <i>hush</i>
or <i>widgets</i> IDL classes.
An additional advantage of client-side adpators is that
they allow for overcoming the
'weaknesses' of IDL with respect to
overloading member functions,
parametrized types and operator definitions.
<p>
Typically, client-side adaptors have their corresponding <i>hush</i> class
as a base class and simply delegate method invocations
to the CORBA object they encapsulate.

@+ Events versus object method invocation

Since GUI components are in some way typically
event-driven, one may be inclined to limit
the communication between such components to exchanging events.
The CORBA Event Service would suffice for such communications.
<p>
Nevertheless, in our opinion events should be used in a very restricted manner.
Events tend to break the 'crisp' object interfaces that
are one of the benefits of an object-oriented
approach to design.
<p>
For the <i>hush</i> CORBA extensions, we have chosen for retaining the original <i>hush</i>
object interfaces.
Note however that the IDL interfaces are somewhat more
abstract than the corresponding C++ interfaces.
Nevertheless, the <i>event</i> interface is part
of the <i>hush</i> module.
Together with the <i>dispatch</i> function of 
the <i>handler</i> interface incoming events resulting from user 
actions may be dispatched directly to
remote components. See the <ref file=examples>Canvas</ref> example.

<control>
<!--
<navigate level=1 back=index root=index up=index next=index>
-->
<hr>
<a href=contents.html>[]</a>
<a href=intro.html>introduction</a>,
<a href=problem.html>legacy</a>,
<a href=idl.html>interfaces</a>,
<a href=examples.html>examples</a>,
<a href=conc.html>conclusions</a>,
<a href=refs.html>references</a>,
<a href=appendix.html>appendix</a>
<hr>
</control>

</document>
<document class=article packages="a4wide,epsfig,verbatim">
@* <a href=@talk-idl.html target=_top>Interfaces</a>
<control>
<!--
<navigate level=1 back=index root=index up=index next=index>
-->
<hr>
<a href=contents.html>[]</a>
<a href=intro.html>introduction</a>,
<a href=problem.html>legacy</a>,
<a href=idl.html>interfaces</a>,
<a href=examples.html>examples</a>,
<a href=conc.html>conclusions</a>,
<a href=refs.html>references</a>,
<a href=appendix.html>appendix</a>
<hr>
</control>


The IDL interfaces reflect to a large extent the functionality of
the original <i>hush</i> and <i>widgets</i> interfaces.
See <cite>Hush</cite>.
In this section a partial listing of the interfaces will be given.
Note that, in comparison with the corresponding C++ classes,
the IDL interfaces are much more abstract in the sense of omitting
many member functions that are required 
for the implementation of the actual <i>hush</i> framework.

<h2>The <i>hush</i> module</h2>

The <i>hush</i> module contains interfaces corresponding to
the basic <i>hush</i> classes,
<i>handler</i>, <i>event</i>, <i>kit</i>, <i>widget</i>
and <i>item</i>, as well as the auxiliary classes
for iterators and containers.

<slide id=idl-handler cap="handler">
<program>
interface handler {
        event dispatch( in event data );
	};
</program>
</slide>

The <i>handler</i> interface provides only a method
for dispatching events. It may be extended in the
future though.
In <i>hush</i> almost every class is derived from <i>handler</i>.
This is directly reflected in the <i>hush</i> IDL interfaces.

<slide id=idl-event cap="event">
<program>
interface event : handler {

	attribute long type;

	attribute long x;
	attribute long y;
	};
</program>
</slide>

The <i>event</i> interface offers attributes to
determine the type of event and its location.
Also the <i>event</i> interface will very likely be extended in
the future, to allow for a greater variety of events.

<slide id=idl-kit cap="kit">
<program>
interface kit : handler {

	void source(in string file);
	void eval(in string command);
	term result();

	widget root();
	};
</program>
</slide>

In <i>hush</i>, a <i>kit</i> provides an interface to
some embedded interpreter, such as a Tcl interpreter
or a logic engine as provided by BinProlog.
The <i>kit</i> gives also access to the underlying window environment,
in particular it may be asked to provide a reference to
the root window.

<slide id=idl-widget cap="widget">
<program>
interface widget : handler {

   string path();

   void eval( in string cmd );

   void configure( in string options );
   void pack( in string options );
};
</program>
</slide>

A widget is a user interface gadget.
The <i>widget</i> interface collects the functions that
all these gadgets have in common.

<slide id=idl-item cap="item">
<program>
interface item : handler {

        void move( in long x, in long y );
	};
</program>
</slide>

An <i>item</i> is obtained when creating a graphical
object for a canvas. Subsequently, the item reference
suffices to manipulate such objects.
Also the <i>item</i> interface will very likely
be extended in the future.


@ Iterators and lists

As an alternative for
CORBA arrays and sequences, the <i>hush</i>
module offers interfaces for iterators, containers and 
syntactic objects called <i>terms</i>.

<slide id=idl-iter cap="iterator">
<program>
interface iterator {
        Object next();
	};
</program>
</slide>

From a client's perspective, an <i>iterator</i>
is a data generator.
To deal with typed iterators, the <i>hush</i>
C++ library offers template client-side adaptor classes
encapsulating the untyped CORBA iterators.
See section <ref file=examples>Items</ref> and the code
in <ref file=code>Iter</ref>.

<slide id=idl-container cap="container">
<program>
interface container {

        long length();

        Object first();
        Object next();
        Object current();

        iterator walk();
	};
</program>
</slide>

The <i>container</i> interface offers access
to the famous <i>hush</i> list class.
It offers functions for cursor-based list traversal
as well as the <i>walk</i> function that may be used to obtain an iterator.

<slide id=idl-term cap="term">
<program>
interface term {

        string next();

};
</program>
</slide>

Currently, the <i>term</i> interface offers only the
functionality to use a term as an iterator
for strings.
The idea is that one can obtain strings from a term
as long as the term, for example the result of a logic query,
still contains information.

@ Factories and distributed object tables

To obtain references to objects, clients may use
either factory object or distributed object tables.

<slide id=idl-factory cap="factory">
<program>
interface factory {
        hush::kit kit(in string name);
        hush::event event(in long type);
};
</program>
</slide>

The <i>factory</i> interface allows only for creating 
a <i>kit</i> and for creating an <i>event</i>.
Note that <i>handler</i> objects may not be created directly.

<slide id=idl-dot cap="dot">
<program>
interface dot {

        hush::kit kit(in string name);

        hush::container container(in string name);
        hush::iterator iterator(in string name);

        hush::factory hush(in string name);
};
</program>
</slide>

Apart from giving access to a <i>hush</i> factory, 
the <i>dot</i> interface allows for getting access to
a <i>kit</i>, a <i>container</i> and
an <i>iterator</i>.
When obtaining references through a <i>dot</i> object,
these objects are assumed to exist within the server.


<h2>The <i>widgets</i> module</h2>

The <i>widgets</i> module provides the actual user interface
gadgets for <i>hush</i>.
Below we have  included only the (partial) interfaces for
a <i>canvas</i> and a <i>message</i> widget.

<slide id-idl-widgets cap="module widgets">
<program>
module widgets {

interface canvas : hush::widget {

	widgets::canvas create( in hush::widget anc, in string path );

	hush::item circle( in long x, in long y, in long radius, in string options );
	// other items ...
	};


interface message : hush::widget {
	message create( in hush::widget anc, in string path );
	void text(in string txt);
	};


interface factory : hush::factory {

 	widgets::canvas  canvas(in string name, in string options);
 	widgets::message message(in string name, in string options);
	};

interface dot : hush::dot {

	widgets::canvas  canvas(in string name);
 	widgets::message message(in string name);

	widgets::factory widgets(in string name);
	};


};
</program>
</slide>

Note that each widget type has a method <i>create</i>,
with which  an actual widget of that type can be created.
In effect this means that each widget object may act as a factory
for widget objects of that type.
(The server may however refuse to create such objects!)
In addition to the specific gadget interfaces, the <i>widgets</i> module
provides a <i>factory</i> and <i>dot</i> interface,
extending the respective <i>hush</i> interfaces.
<control>
<!--
<navigate level=1 back=index root=index up=index next=index>
-->
<hr>
<a href=contents.html>[]</a>
<a href=intro.html>introduction</a>,
<a href=problem.html>legacy</a>,
<a href=idl.html>interfaces</a>,
<a href=examples.html>examples</a>,
<a href=conc.html>conclusions</a>,
<a href=refs.html>references</a>,
<a href=appendix.html>appendix</a>
<hr>
</control>

</document>
<document>
@* <a href=@talk-examples.html target=_top>Examples of using crush</a>
<control>
<!--
<navigate level=1 back=index root=index up=index next=index>
-->
<hr>
<a href=contents.html>[]</a>
<a href=intro.html>introduction</a>,
<a href=problem.html>legacy</a>,
<a href=idl.html>interfaces</a>,
<a href=examples.html>examples</a>,
<a href=conc.html>conclusions</a>,
<a href=refs.html>references</a>,
<a href=appendix.html>appendix</a>
<hr>
</control>


The <i>hush</i> CORBA extensions may be used in a number of ways.
For example, the client does not need to be linked with <i>hush</i>
when only the server side is given a graphical user interface.
In case also the client has a graphical user interface,
the client side may dispatch incoming events to the server,
as illustrated in the <ref>Canvas</ref> example.
The communication between server and clients can be arbitrarily complex.
The final example shows how to employ iterators and containers
to give clients access to collections of information.

@+ A remote interpreter kit

This example uses a remote kit. It shows how to get access to a message widget and a kit via a dot
(which is a distributed object table). The client access the kit and the message widget by using a name
(hello for the message widget and tk for the kit). 
The client can send Tcl/Tk interpreter commands to the
kit. 

<slide id=exampel-tk-client cap="A tk client">
@ A <i>tk</i> client

<program>
    hush::dot*      hush;      // (distributed) object tables
    widgets::dot*   widgets;   // widgets contains hush

    hush::kit* tk;             // remote objects, these must exist!
    widgets::message* banner;

    try {
        hush = widgets = widgets::dot::_bind (DOT, argv[1]);

        tk = hush->kit("tk");
        banner = widgets->message("hello"); // must exist

    } catch (...) {
         cerr << "Unexpected exception ..." << endl;
         return -1;
    }

    while (1) {
	char text = readtext(); // from stdin
	
	banner->text( text );  // display text
	tk->eval(text);
        }
</program>
</slide>

This fragment shows how a distributed object table is obtained
via the <i>bind</i> function.
From this table, the client obtains a kit and a message area.
Queries are read in from standard input, displayed in the message area and 
evaluated.
Queries may be arbitrary Tcl/Tk commands.
In this way the client may even construct a complete user interface
through Tk commands.

<slide id=example-tk-server cap="The <i>tk</i> server">
@ The <i>tk</i> server

<program>
class application : public session {
public:
application(int argc, char* argv[]) : session(argc,argv,"hello") {
}
void corba();
int main() {
    tk->trace();
    kit::declare("tk",tk);

    message* m = new hello(".hello"); 
    m->pack();

    message::declare("hello",m);

    corba(); // make yourself available as a server

    return OK;
    }
};
</program>
</slide>

The server is realized as a standard <i>hush</i> program,
except for the call to <i>corba</i> (for which the code is given below).
Note that the calls to <i>declare</i> for both the <i>kit</i>
and <i>message</i> objects is needed to make these objects
accessible via the <i>dot</i>.


<slide id=example-tk-application cap="A tk application">
@ A tk application
<program>
void application::corba() {

widgets::dot* dw = new widgets_dot_srv(); // create dot for widgets

try {
 CORBA::Orbix.registerIOCallback(it_orbix_fd_open, FD_OPEN_CALLBACK);
 CORBA::Orbix.registerIOCallback(it_orbix_fd_close, FD_CLOSE_CALLBACK);

 CORBA::Orbix.impl_is_ready(DOT,0);
 CORBA::Orbix.processEvents(0);
 }
catch (...) {
     cout << "apparently something went wrong" << endl;
   }
</program>
</slide>

In <i>application::corba()</i> a distributed object table is created.
This object is exported as a server by a call to
<i>Orbix.impl_is_ready(DOT,0)</i>,
where DOT is a macro defining the name of the server.
Calling <i>registerIOCallback</i> is needed to
merge the CORBA server event loop with the window event loop
for <i>hush</i>.


@ Evaluating logical queries
With a few minor changes, the client program can be adapted
for accessing a logical query evaluator. 

<slide id=example-logical cap="Evaluating logical queries">
@ Evaluating logical queries
<program>
    try {

        tk = hush->kit("bp");       // A kit for BinProlog
        tk->eval("consult(facts)");
        }
    catch(...) {
        cout << "An exception ... " << endl;
    }

    while (1) {
    	char* text = readtext();
        tk->eval(text);
        hush::term* t = tk->result();
        char* q = 0;
        while ( (q = t->next()) )
                cout << "Result: " << q << endl;
	}
</program>
</slide>

This fragment show how to obtain a kit for BinProlog and
consult a <i>facts</i> database.
Since queries may produce multiple answers
the client must iterate over the term resulting
from the query.

@+ A remote canvas
<a name=Canvas>

This example shows how a client canvas can be used to draw on a remote canvas. For the Orbix 1.3 version
there are still several bugs. Events do not work as they should, and 
quitting the remote application also
does not work. 

<slide id=example-canvas-client cap="A (remote) canvas client">
@ A canvas client

<program>
class draw_clt : public canvas {  /// [2]
public:

void plug(widgets::canvas* x) { draw = x; }

int operator()() {
        hush::event* e = hush->event(_event->type());
        cerr << "Getting event " << e->type() << endl;
        e->x(_event->x()+10);
        e->y(_event->y()+10);
        //hush::event::_duplicate(e);  // CORBA 2.0
        e->_duplicate();
        hush::event* res = draw->dispatch(e);
        return canvas::operator()();
        }

draw_clt(const widget* w,  char* path ) : canvas(w,path) {  
        configure("-background white");
        geometry(200,100);
        self()->bind(this);
        dragging = 0;
}

draw_clt(char* path ) : canvas(path) { 
        configure("-background white");
        geometry(200,100);
        self()->bind(this);
        dragging = 0;
}

void press( event& ) { dragging = 1; }

void motion( event& e) { 
        if (dragging) {
                self()->circle(e.x(),e.y(),2,"-fill black");
                draw->circle(e.x(),e.y(),3,"-fill yellow");
                }
}

void release( event&  ) { dragging = 0; }

protected:
int dragging;
widgets::canvas* draw;
};
</program>
</slide>

This fragmemt shows the implementation of
a canvas which is simultaneously the client side of a remote canvas. 
The method <i>plug</i> allows for declaring the remote canvas,
which is accessed via the instance variable <i>draw</i> in
both the <i>operator</i> method and
the <i>motion</i> method (whent dragging).
In the <i>operator()</i> an event is created which is dispatched to
the remote canvas.
Note that this is possible since a canvas is a handler.
In the <i>motion</i> method, a large yellow dot is drawn
on the remote canvas, whereas the local canvas draws a black dot.
Combined, the actions on the remote canvas result in 
drawing parallel yellow and black dots.


@ The server

<slide id=example-canvas-server cap="A canvas server">
@ A canvas server
<program>
class draw_srv : public canvas {  
public:

draw_srv( const widget* w,  char* path ) : canvas(w,path) {  /// (a)
        geometry(200,100);
        self()->bind(this);
        dragging = 0;
}

void press( event& ) { dragging = 1; }

void motion( event& e) { 
        if (dragging) circle(e.x(),e.y(),10,"-fill black");
}

void release( event&  ) { dragging = 0; }

protected:
int dragging;
};
</program>
</slide>

The canvas implementation on the server side straightforwardly
implements a <i>hush</i> canvas.
It is embedded in a CORBA server when an object reference
is given to it via the distributed object table.

@+ Moving items
<a name=Items>

This example is similar to the <ref file=examples>Canvas</ref> example, but shows some additional features, such as how to
manipulate a list of items.

<slide id=example-items cap="Moving items">
@ Moving items
<program>
    list<hush::item>* rlist =  new list<hush::item>;
    item* it = draw->circle(40,40,10,"-fill yellow");
    hush::item* rit = new item_srv(it);
    rlist->insert(rit);
    it = draw->circle(30,30,10,"-fill red");
    rit = new item_srv(it);
    rlist->insert(rit);

    hush::container* rx = new list_srv<hush::item>(rlist);
    list<hush::item>::declare("items",rx); // store server

    iter<hush::item>* riter = rlist->walk();
    iter<hush::item>::declare("riter",riter);
</program>
</slide>

The fragment above illustrates the creation of a list
of items.
In addition it shows how to obtain an iterator and 
how the iterator may be declared to make it accessible
via the distributed object table.
<control>
<!--
<navigate level=1 back=index root=index up=index next=index>
-->
<hr>
<a href=contents.html>[]</a>
<a href=intro.html>introduction</a>,
<a href=problem.html>legacy</a>,
<a href=idl.html>interfaces</a>,
<a href=examples.html>examples</a>,
<a href=conc.html>conclusions</a>,
<a href=refs.html>references</a>,
<a href=appendix.html>appendix</a>
<hr>
</control>

</document>
<document>
<h1>Conclusions</h1>
<control>
<!--
<navigate level=1 back=index root=index up=index next=index>
-->
<hr>
<a href=contents.html>[]</a>
<a href=intro.html>introduction</a>,
<a href=problem.html>legacy</a>,
<a href=idl.html>interfaces</a>,
<a href=examples.html>examples</a>,
<a href=conc.html>conclusions</a>,
<a href=refs.html>references</a>,
<a href=appendix.html>appendix</a>
<hr>
</control>

Extending <i>hush</i> with CORBA was an 
an excellent exercise to get acquainted with
Orbix/CORBA technology.
From a designer's point of view,
the <i>hush</i> framework proved to be
sufficiently abstract to allow for
recapturing its design by means of IDL interfaces.
Lacking in the current realization of <i>crush</i> though,
are proper exceptions to indicate possible error conditions.
For making <i>hush</i> CORBA-compliant, we have made a
first step.
To complete the job, however, we need to
explore in what way <i>crush</i> components can be employed
in actual applications.
<p>
Evidently, the contribution of this work is
that it shows how to integrate CORBA functionality
with an already existing framework.
In particular the need for client-side adaptors
for resolving the type clash between the 'native' classes
and the CORBA IDL classes has been amply demonstrated.
Enriching <i>hush</i> with CORBA makes <i>crush</i>
a potential competitor of Fresco, the CORBA based GUI toolkit
derived from the Interviews library.
<control>
<!--
<navigate level=1 back=index root=index up=index next=index>
-->
<hr>
<a href=contents.html>[]</a>
<a href=intro.html>introduction</a>,
<a href=problem.html>legacy</a>,
<a href=idl.html>interfaces</a>,
<a href=examples.html>examples</a>,
<a href=conc.html>conclusions</a>,
<a href=refs.html>references</a>,
<a href=appendix.html>appendix</a>
<hr>
</control>

</document>
<document>
@* References
<control>
<!--
<navigate level=1 back=index root=index up=index next=index>
-->
<hr>
<a href=contents.html>[]</a>
<a href=intro.html>introduction</a>,
<a href=problem.html>legacy</a>,
<a href=idl.html>interfaces</a>,
<a href=examples.html>examples</a>,
<a href=conc.html>conclusions</a>,
<a href=refs.html>references</a>,
<a href=appendix.html>appendix</a>
<hr>
</control>

<bibliography>

%K Applications
%A M. van Doorn and A. Eliens,
%T <a href=@online/papers/www3/index.html>Integrating WWW and Applications</a>,
%O Proc. of the 3th Int. World Wide Web Conf. --
Technology, Tools and Applications,
Computer Networks and ISDN systems,
Vol 27. No 6, Elsevier, 1995, pp. 1105-1110,
Also at
http://www.igd.fhg.de/www/www95/proceedings/papers/48/main.html

%K Hush
%A A. Eliens,
%T <a href=http://www.cs.vu.nl/~eliens/hush/>
Hush -- a C++ API for Tcl/Tk</a>,
%O The X Resource, Issue 14, April 1995, pp. 111-155

%K Animate
%A A. Eliens, J.R. van Ossenbruggen, S.P.C. Sch\"onhage,
%T <a href=@online/papers/animate/contents.html>Animating the Web -- an SGML-based approach</a>
%O Proc. Int. Conf. on 3D and Multimedia on the Internet, WWW and Network,
Bradford, 17-18 April 1996, Britisch Computer Society

%K Hypermedia
%A J. van Ossenbruggen en A. Eliens,
Music in Time-based Hypermedia,
%O Proc. European Conference on Hypermedia Technology 1994,
pp. 224-227

%K Music
%A J.R. van Ossenbruggen and A. Eliens,
%T <a href=@online/papers/www4/index.html>Bringing Music to the Web</a>,
%O Proc. of the 4th Int. World Wide Web Conference '95 --
The Web revolution,
World Wide Web Journal, O'Reilly and Assoc., Inc., pp. 309-314,

%K Chatting
%A M. van Welie and A. Eliens,
%T <a href=@online/papers/chatting/index.html>Chatting on the Web</a>,
%O ERCIM W4G Workshop, 7-9 febr 1996, GMD St Augustin, Germany

%K Jamming
%A A. Eliens, M. van Welie, J. van Ossenbruggen, S.P.C. Schonhage,
%T <a href=@online/papers/www6/index.html>Jamming (on) the Web</a>.
%O Proc. of the 6th Int. World Wide Web Conference '97,

%K Isis
%A J. Caspers and A. Eliens,
%T <a href=@online/tutorials/corba/isis/contents.html>Using CORBA for Internet-Based Workgroup Applications</a>,
%O Master Thesis, VU

%K Crush
%A A. Eliens,
%T Crush - examples.
%O //link:@online/hush/examples/corba/index.html

</bibliography>
<control>
<!--
<navigate level=1 back=index root=index up=index next=index>
-->
<hr>
<a href=contents.html>[]</a>
<a href=intro.html>introduction</a>,
<a href=problem.html>legacy</a>,
<a href=idl.html>interfaces</a>,
<a href=examples.html>examples</a>,
<a href=conc.html>conclusions</a>,
<a href=refs.html>references</a>,
<a href=appendix.html>appendix</a>
<hr>
</control>

</document>
<control>
<slide id=app cap="Appendix">
@* <a href=@talk-appendix.html target=_top>Appendix</a>
<ul>
<li> <a href=common.html>Common definitions</a>
<li> <a href=code.html>Selected code fragments</a>
</ul>
</slide>
</control>
<document>
@* Common definitions
<control>
<!--
<navigate level=1 back=index root=index up=index next=index>
-->
<hr>
<a href=contents.html>[]</a>
<a href=intro.html>introduction</a>,
<a href=problem.html>legacy</a>,
<a href=idl.html>interfaces</a>,
<a href=examples.html>examples</a>,
<a href=conc.html>conclusions</a>,
<a href=refs.html>references</a>,
<a href=appendix.html>appendix</a>
<hr>
</control>

The macros in <i>common.h</i> have been introduced
to allow for multiple CORBA implementations.

<slide id=common-defs cap="Common definitions">
@ Common definitions
<program>
#ifndef _orb_common_h
#define _orb_common_h

#ifndef ENV
#define ENV CORBA::Environment&
#endif
#ifndef _sk
#define _sk(X) X##BOAImpl
#endif
#ifndef _msk
#define _msk(M,X) M::_sk(X)
#endif
#ifndef _crob
#define _crob(M,X) public virtual _msk(M,X) 
#endif

#endif
</program>
</slide>
These macros as well as a number of other technical solutions have been
inspired by the work of John Caspers as described in 
<cite file=refs>Isis</cite>.
<control>
<!--
<navigate level=1 back=index root=index up=index next=index>
-->
<hr>
<a href=contents.html>[]</a>
<a href=intro.html>introduction</a>,
<a href=problem.html>legacy</a>,
<a href=idl.html>interfaces</a>,
<a href=examples.html>examples</a>,
<a href=conc.html>conclusions</a>,
<a href=refs.html>references</a>,
<a href=appendix.html>appendix</a>
<hr>
</control>

</document>

<document>
@* <a href=@talk-code.html target=_top>Selected source code fragments</a>
<control>
<!--
<navigate level=1 back=index root=index up=index next=index>
-->
<hr>
<a href=contents.html>[]</a>
<a href=intro.html>introduction</a>,
<a href=problem.html>legacy</a>,
<a href=idl.html>interfaces</a>,
<a href=examples.html>examples</a>,
<a href=conc.html>conclusions</a>,
<a href=refs.html>references</a>,
<a href=appendix.html>appendix</a>
<hr>
</control>


This section presents selected samples of the code
implementing server-side code for the CORBA IDL
classes as well as the client-side adaptors for integrating these classes
in the <i>hush</i> class hierarchy.

@+ Handlers

The <i>handler</i> class may be considered the most important
class of <i>hush</i> since almost every other class, including
the <i>event</i>, <i>widget</i> and <i>item</i> classes
are derived from <i>handler</i>. See <cite file=refs>Hush</cite>.
<control>
</slide>
</control>

<slide id=code-server cap="Server code">
@ Server code - handler

<program>
class handler_srv : _crob(hush,handler) {
public:
    handler_srv(const handler* x = 0) : _bdy((handler*)x) { }
protected:
    void  set_body(const handler* x) { _bdy = (handler*) x; } 
    handler* _body() const { 
        return (handler*) _bdy;
        }

    virtual hush::event* dispatch(hush::event* e, ENV);

private:
handler* _bdy;
};
</program>
</slide>

<slide id=code-client cap="Client adaptor">
@ Client adaptor - handler
<program>
class handler_clt : public handler {
protected:
    handler_clt(handler_srv* x) : _bdy(x) { }
    void  set_body(void* x) { _bdy = x; } 
    handler* _body() { 
        if (!_bdy) throw "handler has no body";
        return (handler*) _bdy;
        }
private:
void* _bdy;
};
</program>
</slide>

@+ Events

The implementation of the <i>event_srv</i> class
uses the functionality of <i>handler_srv</i>
of which this class is derived.
The <i>event_clt</i> (adaptor) class on the other hand
is directly derived from the <i>hush</i> <i>event</i> class.

<slide id=code-event-server cap="Server code - event">
@ Server code -- event
<program>
class event_srv : public handler_srv, _crob(hush,event) {
public:
    event_srv(event* e) : handler_srv(e) { }

    event_srv() { _type = 0; _x = 0; _y = 0; } 

    virtual void type( long t, ENV ) { _type = t; }
    virtual long type( ENV ) { return _type; }

    virtual void x( long t, ENV ) { _x = t; }
    virtual long x( ENV ) { return _x; }

    virtual void y( long t, ENV ) { _y = t; }
    virtual long y( ENV ) { return _y; }

protected:
    event* _body() { return (event*) handler_srv::_body(); }
    long _type, _x, _y;
};
</program>
</slide>

<slide id=code-event-client cap="Client adaptor - event">
@ Client adaptor - event
<program>
class event_clt : public event {
public:
    event_clt(hush::event* x) : _bdy(x), event(this)  { }

    hush::event* operator->() { return _body(); }

    virtual int type() const { return (int) _body()->type(); }
    virtual int x() const { return (int) _body()->x(); }
    virtual int y() const { return (int) _body()->y(); }

    virtual void type(int n) { _body()->type( (long) n ); }
    virtual void x(int n) { _body()->x( (long) n ); }
    virtual void y(int n) { _body()->y( (long) n ); }

    /* Orbix 2.0
    virtual void type(int n) { _body()->type( (CORBA::Long) n ); }
    virtual void x(int n) { _body()->x( (CORBA::Long) n ); }
    virtual void y(int n) { _body()->y( (CORBA::Long) n ); }
    */

private:
    void* _bdy;
    hush::event* _body() const { return (hush::event*) _bdy; }
};
</program>
</slide>

@+ The <i>kit</i>

Both the server and client-side implementations of
<i>kit</i> delegate the calls to their embedded objects,
respectively a <i>hush</i> <i>kit</i> object and a CORBA IDL 
<i>kit</i> object.

<slide id=code-kit-server cap="Server code - kit">
@ Server code - kit
<program>
class kit_srv : public handler_srv, _crob(hush,kit) {
public:
    kit_srv(kit* tk) : handler_srv(tk) { }

    virtual void source( const char* s, ENV ) {
        char* p = new char[strlen(s)+1]; strcpy(p,s);
        _body()->source(p);
        }
    virtual void eval( const char* s, ENV ) {
        _body()->eval(s); 
        }
    virtual hush::term* result( ENV ) { 
        term* x = (term*) _body()->result(); 
        hush::term* res = new term_srv(x);
        res->_duplicate(); // orbix 1.3
        return res;
        }
    virtual void update( ENV ) { _body()->update(); }

    virtual hush::widget* root( ENV );

protected:
    kit* _body() { return (kit*) handler_srv::_body(); }
};

</program>
</slide>

<slide id=code-kit-client cap="Client-adaptor - kit">
@ Client adaptor
<program>
class kit_clt : public kit {
public:
    kit_clt(hush::kit* x) : _bdy(x)  { }

    virtual int eval( const char* s ) { _body()->eval(s); return 0; }

    virtual widget* root( ) const; 

private:
    void* _bdy;
    hush::kit* _body() const { return (hush::kit*) _bdy; }
};

</program>
</slide>

@+ Lists

The implementation of lists and iterators as template
C++ classes are taken from the work by John Caspers,
reported in <cite file=refs>Isis</cite>.

<slide id=code-list-server cap="Server code -- list">
@ Server code -- list
<program>
template<class T>
class list_srv : _crob(hush,container) {
public:
    list_srv(list<T>* it = 0) : _bdy(it) {
        this->_duplicate();
        }

    hush::iterator* walk( ENV ) {
        iter<void>* it = ((list<void>*) _body())->walk();
        iter_srv* x = new iter_srv(it);
        x->_duplicate();
        return x;
        }

    long length( ENV ) {
        return (long)  _body()->length();
        }

    CORBA::Object* first( ENV ) {
        T* x = _body()->first();
        //dummy->_duplicate(x); // Orbix 2.0
        x->_duplicate();
        return x;
        }

    CORBA::Object* current( ENV ) {
        T* x = _body()->current();
	x->_duplicate();
	return x;
        }

    CORBA::Object* next( ENV ) {
        T* x = _body()->next();
        x->_duplicate();
        return x;
        }

protected:
    T* dummy; // for duplication in 2.0
    list<T>* _bdy;
    list<T>* _body() const { return (list<T>*) _bdy; }
};

</program>
</slide>

<slide id=code-list-client cap="Client adaptor - list">
@ Client adaptor - list
<program>
template<class T>
class list_clt : public list<T> {
public:
    list_clt(hush::container* it = 0, T* = 0) : _bdy(it) { }

    list_clt<T>* operator->() { return this; }

    void operator=(hush::container* it) { _bdy = it; }

    T* first() {
        CORBA::Object* x = _body()->first();
        if (x)
                return (T*) dummy->_narrow(x);
        else return 0;
        }

    T* next() {
        CORBA::Object* x = _body()->next();
        if (x)
                return (T*) dummy->_narrow(x);
        else return 0;
        }

protected:
    hush::container* _bdy;
    hush::container* _body() const { return (hush::container*) _bdy; }
private:
    static T* dummy;
};

};
</program>
</slide>

<a name=Iter>
@+ Iterators

The implementation of the <i>iter</i> class follows
the same schema as the <i>list</i> implementation.
In particular for narrowing CORBA Objects to the actual
type T of the template client adaptor a static instance variable
dummy has been introduced.
This solution is again due to John Caspers.

<slide id=code-iter-server cap="Server code - iter">
@ Server code - iter
<program>
class iter_srv : _crob(hush,iterator) {
public:
    iter_srv(void* it) : _bdy(it) { }

    CORBA::Object* next( ENV ) {
        return _body()->operator()();
        }

protected:
    void* _bdy;
    iter<CORBA::Object>* _body() const { return (iter<CORBA::Object>*) _bdy; }
};
</program>
</slide>

<slide id=code-iter-client cap="Client adaptor - iter">
@ Client adaptor - iter
<program>
class iter_clt : public iter<T> {
public:
    iter_clt(hush::iterator* it = 0, T* = 0) : _bdy(it) { }

    hush::iterator* operator->() { return _body(); }

    void operator=(hush::iterator* it) { _bdy = it; }

    T* operator()() {
        CORBA::Object* x = _body()->next();
        if (x)
                return (T*) dummy._narrow(x);
        else return 0;
        }

protected:
    hush::iterator* _bdy;
    hush::iterator* _body() const { return (hush::iterator*) _bdy; }
private:
    static T dummy;
};
</program>
</slide>

<control>
<!--
<navigate level=1 back=index root=index up=index next=index>
-->
<hr>
<a href=contents.html>[]</a>
<a href=intro.html>introduction</a>,
<a href=problem.html>legacy</a>,
<a href=idl.html>interfaces</a>,
<a href=examples.html>examples</a>,
<a href=conc.html>conclusions</a>,
<a href=refs.html>references</a>,
<a href=appendix.html>appendix</a>
<hr>
</control>

</document>



</document>
