<HTML>

<HEAD>
<TITLE>Overvew of CORBA</TITLE>
<HEAD>      

<BODY text = "#000000"
link="#000fff"
vlink="#ff0f0f"
bgcolor="#ffffff">

<slide id=overview cap=Overview>
@* <a href=@talk-overview.html target=_top>Overview of CORBA</a>
written by
<a HREF=mailto:schmidt@cs.wustl.edu">D. Schmidt</a>
adapted by <a href=mailto:eliens@cs.vu.nl>A. Eliens</a>
<p>
The Common Object Request Broker Architecture (CORBA)
<A HREF="#OMG:95a">[OMG:95a]</A> is an emerging open distributed object
computing infrastructure being standardized by the Object Management
Group (<A HREF="http://www.omg.org">OMG</a>).  CORBA automates many
common network programming tasks such as object registration,
location, and activation; request demultiplexing; framing and
error-handling; parameter marshalling and demarshalling; and operation
dispatching. <P>
</slide>

The following figure illustrates the primary components in the OMG
Reference Model architecture.  Descriptions of these components are
available further below.  Portions of these descriptions are based on
material from <A HREF="#Vinoski">[Vinoski]</A>.

<slide id=overview-model cap="OMG Reference Model Architecture">
<center><table cellpadding=10 border=0 cellspacing=5>
<tr><td>
<center>
<image src=local/images/corba2.gif>
</center>
<tr><td align=center>
Figure 1. OMG Reference Model Architecture
</table></center>
<p>
</slide>

<slide id=overview-services cap="Services">
<UL>
<LI> <B>Object Services</B> -- These are
domain-independent interfaces that are used by many distributed object
programs.  For example, a service providing for the discovery of other
available services is almost always necessary regardless of the
application domain.  Two examples of Object Services that fulfill this
role are: <P>

<UL>
<LI> The Naming Service -- which allows clients to find
objects based on names; <P>
<LI> The Trading Service -- which allows clients
to find objects based on their properties.<P>
</UL>

There are also Object Service specifications for lifecycle management,
security, transactions, and event notification, as well as many others
<A HREF="#OMG:95b">[OMG:95b]</A>.<P>

<LI> <B>Common Facilities </B> -- Like Object Service interfaces,
these interfaces are also horizontally-oriented, but unlike Object
Services they are oriented towards end-user applications.  An example
of such a facility is the <EM>Distributed Document Component
Facility</EM> (DDCF), a compound document Common Facility based on
OpenDoc.  DDCF allows for the presentation and interchange of objects
based on a document model, for example, facilitating the linking of a
spreadsheet object into a report document. <P>

<LI> <B>Domain Interfaces </B> -- These interfaces fill roles similar
to Object Services and Common Facilities but are oriented towards
specific application domains.  For example, one of the first OMG RFPs
issued for Domain Interfaces is for Product Data Management (PDM)
Enablers for the manufacturing domain.  Other OMG RFPs will soon be
issued in the telecommunications, medical, and financial domains.  <P>

<LI> <B>Application Interfaces </B> - These are
interfaces developed specifically for a given application.  Because
they are application-specific, and because the OMG does not develop
applications (only specifications), these interfaces are not
standardized.  However, if over time it appears that certain broadly
useful services emerge out of a particular application domain, they
might become candidates for future OMG standardization. <P>
</UL>
</slide>

<HR>
<H3>CORBA ORB Architecture</H3>

<!-- To locate more information about CORBA components, please click in the
appropriate rectangle in the following figure.  Additional information
about these components is available further below. -->

The following figure illustrates the primary components in the CORBA
ORB architecture.  Descriptions of these components are available
below the figure. <P>

<slide id=overview-orb cap="CORBA ORB Architecture">
<center><table cellpadding=10 border=0 cellspacing=5>
<tr><td>
<center>
<image src="local/images/corba5.gif">
</center>
<tr><td align=center>
Figure 2. CORBA ORB Architecture
</table></center>
<p>
</slide>

<slide id=overview-architecture cap="CORBA Architecture">
<UL>
<LI> <B>Object Implementation</B> -- This defines
operations that implement a CORBA IDL interface.  Object
implementations can be written in a variety of languages including C,
C++, Java, Smalltalk, and Ada. <P>

<LI> <B>Client</B> -- This is the program entity that invokes an
operation on an object implementation.  Accessing the services of a
remote object should be transparent to the caller.  Ideally, it should
be as simple as calling a method on an object, i.e.,
<CODE>obj->op(args)</CODE>.  The remaining components in Figure 2 help
to support this level of transparency. <P>

<LI> <B>Object Request Broker (ORB)</B> -- The ORB provides a
mechanism for transparently communicating client requests to target
object implementations.  The ORB simplifies distributed programming by
decoupling the client from the details of the method invocations.
This makes client requests appear to be local procedure calls.  When a
client invokes an operation, the ORB is responsible for finding the
object implementation, transparently activating it if necessary,
delivering the request to the object, and returning any response to
the caller. <P>

<LI> <B>ORB Interface</B> -- An ORB is a logical entity that may be
implemented in various ways (such as one or more processes or a set of
libraries).  To decouple applications from implementation details, the
CORBA specification defines an abstract interface for an ORB.  This
interface provides various helper functions such as converting object
references to strings and vice versa, and creating argument lists for
requests made through the dynamic invocation interface described
below. <P>

<LI> <B>CORBA IDL stubs and skeletons</B> -- CORBA IDL stubs and
skeletons serve as the ``glue'' between the client and server
applications, respectively, and the ORB.  The transformation between
CORBA IDL definitions and the target programming language is automated
by a CORBA IDL compiler.  The use of a compiler reduces the potential
for inconsistencies between client stubs and server skeletons and
increases opportunities for automated compiler optimizations. <P>
 
<LI> <B>Dynamic Invocation Interface (DII)</B> -- This interface
allows a client to directly access the underlying request mechanisms
provided by an ORB.  Applications use the DII to dynamically issue
requests to objects without requiring IDL interface-specific stubs to
be linked in.  Unlike IDL stubs (which only allow RPC-style requests),
the DII also allows clients to make non-blocking <EM>deferred
synchronous</EM> (separate send and receive operations) and <EM>
oneway</EM> (send-only) calls. <P>

<LI> <B>Dynamic Skeleton Interface (DSI)</B> -- This is the server
side's analogue to the client side's DII. The DSI allows an ORB to
deliver requests to an object implementation that does not have
compile-time knowledge of the type of the object it is
implementing. The client making the request has no idea whether the
implementation is using the type-specific IDL skeletons or is using
the dynamic skeletons. <P>

<LI> <B>Object Adapter </B> -- This assists the ORB with delivering
requests to the object and with activating the object.  More
importantly, an object adapter associates object implementations with
the ORB.  Object adapters can be specialized to provide support for
certain object implementation styles (such as OODB object adapters for
persistence and library object adapters for non-remote objects). <P>
</UL>
</slide>

<HR>
<slide id=overview-references cap=References>
<H3>References</H3>
<p>
<A NAME="OMG:95a"><STRONG>[OMG:95a]</STRONG> <A
HREF="http://www.cs.wustl.edu/~schmidt/CORBA-docs/corba2.0.ps.gz">Common
Object Request Broker Archictecture</A>, OMG, July, 1995.<p>

<A NAME="OMG:95b"><STRONG>[OMG:95b]</STRONG> <A
HREF="http://www.cs.wustl.edu/~schmidt/CORBA-docs/coss.ps.gz">Common Object Services Specification</A>, OMG 95-3-31, 1995<p>

<A NAME="Vinoski"><STRONG>[Vinoski]</STRONG> <A
HREF="http://www.iona.com/hyplan/vinoski/">Steve Vinoski</a>, <A
HREF="vinoski.ps.gz">CORBA: Integrating Diverse Applications Within
Distributed Heterogeneous Environments,</A> <EM>IEEE Communications
Magazine</EM>, February, 1997.</A>

<P><HR><P>
Back to my <A HREF="http://www.cs.wustl.edu/~schmidt/corba.html">CORBA</A> home page.
</slide>



<P>
<!--<EM>
Visitor #
from 
<EM><br> -->
<I> Last modified 20:04:55 CST 08 November 1997 </I>
