<HTML>
<HEAD>
<TITLE></TITLE>
</HEAD>
<BODY>

<A NAME="Top"><H1>Appendix A: Aws++ API</H1></A>
<H2>aws_balloon widget</H2>
<CODE><PRE> 
#include &lt;Aws/aws_balloon.h&gt;

<B>class	aws_balloon: public</B> toplevel
{
<B>public:</B>
	aws_balloon();
	aws_balloon(<B>char</B>* p, <B>char</B>* options = <B>""</B>);
	aws_balloon(widget* w, <B>char</B>* p, <B>char</B>* options = <B>""</B>);

	label	*subLabel(<B>const</B> <B>char</B> *opt = NULL) <B>const</B>;
	frame	*subFrame(<B>const</B> <B>char</B> *opt = NULL) <B>const</B>;

	<B>void</B>	statusBar(label *statusLabel);
	<B>void</B>	statusBar(message *statusMessage);

	// 'popup' may be "" if you only want to set a statusmessage
	<B>void</B>	bind(widget *w, <B>const</B> <B>char</B> *popup, <B>const</B> <B>char</B> *msg = "");
};
</PRE><CODE>
<H4>Constructors</H4>
<DL>
<DT> awsballoon();
<DD> System level constructor
<DT> aws_balloon(<B>char</B>* p, <B>char</B>* options = <B>""</B>);
<DD> Create an aws_balloon with path <B>p</B> and the specified options <B>options</B>
<DT> aws_balloon(widget* w, <B>char</B>* p, <B>char</B>* options = <B>""</B>);
<DD> Create an aws_balloon as a child of <B>w</B>, with path <B>p</B> and the specified options <B>options</B>
</DL>

<H4>Methods</H4>
<DL>
<DT> label	*subLabel(<B>const</B> <B>char</B> *opt = NULL) <B>const</B>;
<DD> Returns the aws_balloons label-subwidget, and optionaly configures the widget with the
<DD> specified options (if any).
<DT> frame	*subFrame(<B>const</B> <B>char</B> *opt = NULL) <B>const</B>;
<DD> Returns the aws_balloons frame-subwidget, and optionaly configures the widget with the
     specified options (if any).
<DT> <B>void</B>	statusBar(label *statusLabel);
<DD> Configures a label-type widget as statusbar for the aws_balloon. The statusbar is used to display
     a message when the mousepointer enters a widget.
<DT> <B>void</B>	statusBar(message *statusMessage);
<DD> Configures a message-type widget as statusbar for the aws_balloon. The statusbar is used to display
     a message when the mousepointer enters a widget.
<DT> <B>void</B>	bind(widget *w, <B>const</B> <B>char</B> *popup, <B>const</B> <B>char</B> *msg = "");
<DD> Bind the aws_balloon to a widget witth the specified popup message (shown 500 msec after the mouse
     enters the widget), and the (opional) statusmessage (shown immediately after the mouse enters the
     widget). Both message can be empty ("").
</DL>

<P>
<H2>aws_combobox Widget</H2>
<P>
<CODE><PRE>
#include &lt;Aws/aws_combobox.h&gt;

<B>class	aws_combobox: public</B> frame
{
public:
	aws_combobox();
	aws_combobox(<B>char</B>* p, <B>char</B> * options = <B>""</B>);
	aws_combobox(widget* w, <B>char</B>* p, <B>char</B> * options = <B>""</B>);

	frame		*subFrame(<B>const</B> <B>char</B> *opt = NULL) <B>const</B>;
	entry		*subEntry(<B>const</B> <B>char</B> *opt = NULL) <B>const</B>;
	button		*subButton(<B>const</B> <B>char</B> *opt = NULL) <B>const</B>;
	toplevel 	*subToplevel(<B>const</B> <B>char</B> *opt = NULL) <B>const</B>;
	listbox		*subListbox(<B>const</B> <B>char</B> *opt = NULL) <B>const</B>;
	
	// entry 
	<B>void</B>		insert(<B>const</B> <B>char</B> *txt);
	<B>void</B>		del(<B>void</B>);

	// listbox
	<B>void</B>		insert(<B>int</B> index, <B>const</B> <B>char</B> *txt);
	<B>void</B>		del(<B>int</B> entry);
	<B>void</B>		del(<B>int</B> begin, <B>int</B> end);

	// retrieval of selections/entries
	<B>char</B>		*get(<B>void</B>);
	<B>int</B>		curselection(<B>void</B>);
	<B>char</B>		*selection(<B>int</B> index = -1);
	<B>int</B>		size(<B>void</B>);

	// bindings
	<B>int</B>		bind(handler *h, <B>const</B> <B>char</B> *arg);
};
</CODE></PRE>
<P>
<H4>Constructors</H4>
<DL> 
<DT> aws_combobox();
<DD> System level constructor
<DT> aws_combobox(<B>char</B>* p, <B>char</B> * options = <B>""</B>);
<DD> Create an aws_combobox with path <B>p</B> and the specified options <B>options</B>
<DT> aws_combobox(widget* w, <B>char</B>* p, <B>char</B> * options = <B>""</B>);
<DD> Create an Combobox as a child of <B>w</B>, with path <B>p</B> and the specified options <B>options</B>
</DL>

<H4>Methods</H4>
<DL>
<DT> frame		*subFrame(<B>const</B> <B>char</B> *opt = NULL) <B>const</B>;
<DT> entry		*subEntry(<B>const</B> <B>char</B> *opt = NULL) <B>const</B>;
<DT> button		*subButton(<B>const</B> <B>char</B> *opt = NULL) <B>const</B>;
<DT> toplevel 	*subToplevel(<B>const</B> <B>char</B> *opt = NULL) <B>const</B>;
<DT> listbox		*subListbox(<B>const</B> <B>char</B> *opt = NULL) <B>const</B>;
<DD> Return the aws_combobox' subwidgets, and optionally configures the widget with the specified options (if any).
<DT><B>void</B>		insert(<B>const</B> <B>char</B> *txt);
<DD> Insert <B>txt</B> into the aws_combobox' text entry.
<DT><B>void</B>		del(<B>void</B>);
<DD> Erase the text in the aws_combobox' text entry.
<DT><B>void</B>		insert(<B>int</B> index, <B>const</B> <B>char</B> *txt);
<DD> Insert <B>txt</B> at position <B>index</B> in the aws_combobox' pulldown listbox.
<DT><B>void</B>		del(<B>int</B> entry);
<DD> Erase the entry at position <B>entry</B> in the aws_combobox' pulldown listbox.
<DT><B>void</B>		del(<B>int</B> begin, <B>int</B> end);
<DD> Erase the entry in the range <B>begin</B>-<B>end</B> in the aws_combobox' pulldown listbox.
<DT><B>char</B>		*get(<B>void</B>);
<DD> Return the text in the aws_combobox' text entry.
<DT><B>int</B>		curselection(<B>void</B>);
<DD> Return the current selection in the aws_combobox' pulldown listbox.
<DT><B>char</B>		*selection(<B>int</B> index = -1);
<DD> Return the entry in the aws_combobox' pulldown listbox at position <B>index</B> 
     if <B>index</B> &gt; 0 else the current selection
<DT><B>int</B>		size(<B>void</B>);
<DD> Return the number of entries in the aws_combobox' pulldown listbox.
<DT><B>int</B>		bind(handler *h, <B>const</B> <B>char</B> *arg);
<DD> Install a handler <B>h</B> for this aws_combobox. This handler must dispatch the events
     <B>ListSelected</B> (selection made in the pulldown listbox) and <B>EntrySelected</B>
     (<I>Return</I> typed in the text entry).
</DL>

<CODE><PRE>
#include &lt;Aws/aws_dialog.h&gt;

<B>class	aws_dialog: public</B> toplevel
{
<B>public:</B>
	aws_dialog();
	aws_dialog(<B>char</B>* p, <B>char</B>* options = <B>""</B>);
	aws_dialog(widget* w, <B>char</B>* p, <B>char</B>* options = <B>""</B>);

	~aws_dialog();

	// Access to internals
	label	*subMessageLabel(<B>const</B> <B>char</B> *opt = NULL) <B>const</B>;
	label	*subImageLabel(<B>const</B> <B>char</B> *opt = NULL) <B>const</B>;
	frame	*subWidgetFrame(<B>const</B> <B>char</B> *opt = NULL) <B>const</B>;

	<B>void</B>	text(<B>const</B> <B>char</B> *txt);
	<B>void</B>	image(<B>const</B> <B>char</B> *img);
	
	<B>void</B>	show(<B>void</B>);
	<B>char</B>	*getChoice(bool doGrab = true);

	// handler for buttons, either intern or extern
	button	*addButton(<B>const</B> <B>char</B> *txt, <B>const</B> <B>char</B> *arg = <B>""</B>, 
			   <B>const</B> <B>char</B> *opts = <B>""</B>);
	button	*addButton(handler *h, <B>const</B> <B>char</B> *txt, <B>const</B> <B>char</B> *arg = <B>""</B>,
			   <B>const</B> <B>char</B> *opts = <B>""</B>);

};
</PRE><CODE>
<P>
<H4>Constructors</H4>
<DL> 
<DT> aws_combobox();
<DD> System level constructor
<DT> aws_combobox(<B>char</B>* p, <B>char</B> * options = <B>""</B>);
<DD> Create an aws_combobox with path <B>p</B> and the specified options <B>options</B>
<DT> aws_combobox(widget* w, <B>char</B>* p, <B>char</B> * options = <B>""</B>);
<DD> Create a Combobox as a child of <B>w</B>, with path <B>p</B> and the specified options <B>options</B>
</DL>

<H4>Methods</H4>
<DL>
<DT> label	*subMessageLabel(<B>const</B> <B>char</B> *opt = NULL) <B>const</B>;
<DT> label	*subImageLabel(<B>const</B> <B>char</B> *opt = NULL) <B>const</B>;
<DT> frame	*subWidgetFrame(<B>const</B> <B>char</B> *opt = NULL) <B>const</B>;
<DD> Provide direct (by passing options to <B>opt</B>) and indirect (by manipulating the returned widget)
     access to the aws_dialog's internal widgets. The frame returned by <B>subWidgetFrame</B> can be used
     to add widgets and functionality to the aws_dialog. These widgets will be garbagecollected by the
     aws_dialog, but not managed, handled, etc. 
<DT> <B>void</B>	text(<B>const</B> <B>char</B> *txt);
<DD> Sets the text for the aws_dialog's message;
<DT> <B>void</B>	image(<B>const</B> <B>char</B> *img);
<DD> Sets the picture for the aws_dialog's image;
<DT> <B>void</B>	show(<B>void</B>);
<DD> Shows the aws_dialog on the screen.
<DT> <B>char</B>	*getChoice(bool doGrab = true);
<DD> Passes control to the aws_dialog, it won't return until one of the internally handled buttons
     has been pressed, and returns the value associated with this button. <B>doGrab</B> specified whether
     the aws_dialog should do a (local) grab on the mousepointer.
<DT> button	*addButton(<B>const</B> <B>char</B> *txt, <B>const</B> <B>char</B> *arg = <B>""</B>, 
			   <B>const</B> <B>char</B> *opts = <B>""</B>);
<DD> Add a button to the aws_dialog. No handler is specified so the aws_dialog will handle the button
     internally by returning from <B>getChoice</B>, returning <B>arg</B> or <B>txt</B> if <B>arg</B>
     is not specified. This method is usually used for <I>"Ok"</I>, <I>"Cancel"</I> buttons etc.
<DT> button	*addButton(handler *h, <B>const</B> <B>char</B> *txt, <B>const</B> <B>char</B> *arg = <B>""</B>,
			   <B>const</B> <B>char</B> *opts = <B>""</B>);
<DD> Add a button like above, but with it's own handler. This method is used for buttons that, for example,
     update the widgets in the widgetFrame, or for <I>"Help"</I> buttons.
</DL>
<P>
<CODE><PRE>
#include &lt;Aws/aws_dialog.h&gt;

<B>class	awsYesNoDialog: public</B> aws_dialog
{
<B>public:</B>
	awsYesNoDialog(); 
	awsYesNoDialog(<B>char</B>* p, <B>char</B>* options = <B>""</B>);
	awsYesNoDialog(widget* w, <B>char</B>* p, <B>char</B>* options = <B>""</B>);
	~awsYesNoDialog();
};
</PRE><CODE>
<P>
<H4>Constructors</H4>
<DL> 
<DT> awsYesNoDialog();
<DD> System level constructor
<DT> awsYesNoDialog(<B>char</B>* p, <B>char</B> * options = <B>""</B>);
<DD> Create an awsYesNoDialog with path <B>p</B> and the specified options <B>options</B>
<DT> awsYesNoDialog(widget* w, <B>char</B>* p, <B>char</B> * options = <B>""</B>);
<DD> Create an YesNoDialog as a child of <B>w</B>, with path <B>p</B> and the specified options <B>options</B>
</DL>

<H4>Methods</H4>
(See aws_dialog)
<HR>
<A HREF="Conclusion.html">&lt;&lt; [Prev]</A>
<A HREF="#top"> [Top] </A>
<A HREF="AppendixB.html">[Next] &gt;&gt;</A>
</BODY>
</HTML>
