<HTML>
<HEAD>
<TITLE>Appendix B. Missing Functionality</TITLE>
</HEAD>
<BODY>
<A NAME="Top"><H1>Appendix B. Missing Functionality</H1> </A>

The following statements (they're a result of grepping 'sprintf' and 'eval'
on the aws' *.cpp files) suggest some sort of possible implementation of the
missing commands.
<P>

<H2>Missing WM methods</H2>
These are the WM commands used in <I>AWS</I>

<DL>
<DT> sprintf(buf, "wm withdraw %s", path());
<DD> <I>AWS</I> uses wm withdraw to temporarily hide the aws_combobox'
     popup-listbox and to hide the aws_balloons popup-toplevel
<DT> sprintf(buf, "wm overrideredirect %s 1", path());
<DD> This causes the window to be ignored by the windowmanager, so it won't
     appear in iconlists, etc.
<DT> sprintf(buf, "wm deiconify %s;raise %s", 
<DD> This is used to make a window re-appear in it's normal form, i.e. after 
     it's been withdrawn.
<DT> sprintf(buf, "wm resizable %s false false", path());
<DD> This disables the possibility to resize awsDialog windows.
</DL>
<P>
Of course, users of the <I>Hush</I> toolkit might also need to use any
of the other <A HREF="http://sunscript.sun.com/man/tcl8.0/TkCmd/wm.htm">wm</A>
commands.
<P>
These commands could be best implemented in the toplevel widget, as they 
always operate on toplevel windows.

<H2>Missing WINFO methods</H2>

<DL>
<DT> sprintf(buf, "winfo rootx %s", cbEntry-&gt;path());
<DD> This is used to determine a widgets X position.
<DT> sprintf(buf, "winfo rooty %s", cbEntry-&gt;path());
<DD> This is used to determine a widgets Y position.
<DT> sprintf(buf, "winfo height %s", cbEntry-&gt;path());
<DD> This is used to determine a widgets height.
<DT> sprintf(buf, "winfo width %s", cbEntry-&gt;path());
<DD> This is used to determine a widgets width.
</DL>
<P>
Of course, users of the <I>Hush</I> toolkit might also need to use any
of the other <A HREF="http://sunscript.sun.com/man/tcl8.0/TkCmd/winfo.htm">
winfo</A> commands.
<P>
These commands could be best implemented in the widget-class, as they 
can operate on any widget.


<H2>Missing GRAB methods</H2>
<DL>
<DT> sprintf(buf, "grab -global %s", path());
<DT> sprintf(buf, "grab release %s", path());
<DD> <I>Hush</I> provides a grab() method in the kit-class, but it doesn't
     accept a parameter, so these grabs are always local and not global
     (which was definately required for the aws_combobox)
<DT> currentGrab = tk-&gt;evaluate("grab current");
<DT> statusGrab = tk-&gt;evaluate("grab status " + currentGrab);
<DD> <I>Hush</I> also does not provide a way to query the current grab
     status, which is required when a grabbing awsDialog wants opens a
     new awsDialog (that will take over this grab) (i.e. when a Help button
     is pressed), or if an awsDialog has an aws_combobox as internal widget,
     which also grabs the cursor.
</DL>
<P>
Grabbing is totally unsupported in <I>Hush</I>, eventhough it can be very
usefull if the user has to choose (i.e. in a dialog) before continuing.
<P>
The grab statement should probably be implemented as part of the kit-class,
as it doesn't operate on a specific widget.

<H2>Missing Misc. methods</H2>

<DL>
<DT> sprintf(buf, "%s activate 0", cbListbox-&gt;path());
<DD> <I>Hush</I> doesn't provide a way to activate a specific listboxentry.
<DT> sprintf(buf, "%s curselection", cbListbox-&gt;path());
<DD> <I>Hush</I> does provide a listbox::selection(), but it doesn't return
     a special value (i.e. -1) if no selection is made.
<DT> sprintf(buf, "tkwait variable %s", dialogVar);
<DT> sprintf(buf, "set %s 1;wm withdraw %s", dialogVar, path());
<DD> <I>Hush</I> provides a wait() method in the kit-class, but it doesn't
     accept a parameter, so the window is always until a window is destroyed.
     Sometimes you only want to withdraw the window (so it's childwidgets aren't
     immediately destroyed), and use tkwait with a variable.
     (which was definately required for the aws_combobox)
<DT> sprintf(buf, "after 500 {wm deiconify %s;raise %s}", path(), path());
<DT> tk-&gt;eval("after cancel " + after_id);
<DD> <I>Hush</I> does provide a kit::after, but it doesn't return a timer-id.
     <I>AWS</I> requires this Id to be able to cancle the after-timer (in this
     specific case, when the mouse leaves a widget before the timer expired
     to show the aws_balloon-tip)

</DL>


<HR>
<A HREF="AppendixA.html">&lt;&lt; [Prev]</A>
<A HREF="#top"> [Top] </A>
<A HREF="AppendixC.html">[Next] &gt;&gt;</A>
</BODY>
</HTML>
