<HTML>
<HEAD>
<TITLE>1. Introduction</TITLE>
</HEAD>
<BODY>
<CENTER>
<A NAME="Top"><H1>Writing Compound Widgets With HUSH</H1></A>
 <BR>
 <H3>or</H3>
 <BR>
 <H2>How Extendible is the Hush Hypermedia Toolkit?</H2>
 <P>
 <FONT SIZE=1>
 <I> Ivo van der Wijk</I>,
 <BR>
 Vrije Universiteit, Amsterdam
 </FONT>
</CENTER>

<B>Abstract</B>
<P>

<FONT SIZE=2>
<I>Hush</I> is Hypermedia toolkit designed for rapid application prototyping 
and implementation. It's core functionality is is sufficient for writing
simple graphical applications, but it lacks some of the more complex widgets
used in more advanced programs. This paper describes the implementation of
<I>AWS</I>, the <B>A</B>dvanced <B>W</B>idget <B>S</B>et, a set of compound
widgets built on top of <I>Hush</I>, implementing some of <I>Hush</I>' missing
features.

</FONT>

<!-- Split into two parts - Cover.html and Introduction.html? -->

<H1>1. Introduction</H1>

GUI Toolkits ease the burden of programming graphical userinterfaces for
programmers by providing standard widgets (grpahical userinterface components)
such as buttons, labels, toplevels, textarea's, etc.
<P>
Examples of such toolkits are Java's <I>AWT</I> (<B>A</B>bstract <B>W</B>idget
<B>T</B>oolkit) (<A HREF="AppendixC.html#l6">[6]</A>), the commercial 
<I>Motif</I> widget toolkit, tcl's <I>Tk</I> (<A HREF="AppendixC.html#l1">[1]</A>),
and <I>Hush</I>, the <B>H</B>yper <B>U</B>tility <B>SH</B>ell, a C++ toolkit
built (<A HREF="AppendixC.html#l1">[1]</A>) upon <I>Tcl/Tk</I>
(<A HREF="AppendixC.html#l4">[4]</A>. 
(Hush provides more than just a C++ api for tcl/tk - it provides CORBA, 
Web/HTML tools and more, but that's beyond the scope of this paper).
<P>
Eventough <I>Hush</I> is a very powerfull and complete toolkit, it's not perfect.
Standard user interface components that are not supplied by <I>Tk</I> are also
not available in <I>Hush</I>. Examples of such missing components are Balloons
(also known as Window Tips), Dialog boxes (and editors!), Advanced Tree Widgets
(i.e. to display Filesystems/Directory structures), Comboboxes, Buttons containing
both Text and Images, etc.
<P>
Is it possible to add these components to <I>Hush</I> using the api offered by <I>Hush</I>?
How well will they perform? What will their api look like? Does <I>Hush</I> provides
sufficient functionality? I will try to answer these questions in this paper by describing
(shortly) how three of these 'missing components' (a balloon widget, a combobox widget
and a dialog widget) were added to <I>Hush</I>, which problems I encountered and how
these were solved. All of this is explained in the following paragraphs:

<UL>
<LI> 1 <A HREF="Introduction.html">Introdution (what you're reading now)</A>
<LI> 2 <A HREF="Semantics.html">Semantics of Widgets</A>
 <UL>
 <LI> 2.1 <A HREF="Semantics.html#aws_balloon">aws_balloon</A>
 <LI> 2.2 <A HREF="Semantics.html#aws_combobox">aws_combobox</A>
 <LI> 2.3 <A HREF="Semantics.html#aws_dialog">aws_dialog</A>
 </UL>
<LI> 3 <A HREF="Implementation.html">Implementation of Widgets in Hush</A>
 <UL>
 <LI> <A HREF="Implementation.html#aws_balloon">3.1 aws_balloon</A>
 <LI> <A HREF="Implementation.html#aws_combobox">3.2 aws_combobox</A>
 <LI> <A HREF="Implementation.html#aws_dialog">3.3 aws_dialog</A>
 <LI> <A HREF="Implementation.html#problems">Problems with hush (short)</A>
 <LI> <A HREF="Implementation.html#Bugs">List of known bugs</A>
 </UL>
<LI> 4 <A HREF="Conclusion.html">Conclusion</A>
<LI> Appendix A <A HREF="AppendixA.html">Widget API</A>
<LI> Appendix B <A HREF="AppendixB.html">Overview of missing Hush functionality + proposed fixes</A>
<LI> Appendix C <A HREF="AppendixC.html">Literature, References, Links</A>
</UL>
<P>
This added set of widgets is named <I>AWS</I>, short for <B>A</B>dvanced <B>W</B>idget 
<B>S</B>et.
<HR>
&lt;&lt; [Prev]
<A HREF="#top"> [Top] </A>
<A HREF="Semantics.html">[Next] &gt;&gt;</A>

</BODY>
</HTML>
