<HTML>
<HEAD>
<TITLE>2. Widget Semantics</TITLE>
</HEAD>
<BODY>
<A NAME="Top"><H1>2. Widgets - Semantics</H1></A>

Widget semantics means the behaviour, look and feel of the widgets. It does
not mean the implementation of specific classes (see 
<A HREF="Implementation.html">The Implementation of Widgets in Hush</A>
for implementation details.
<P>
<A NAME="aws_balloon"><H2>2.1 aws_balloon </H2></A>
An aws_balloon is a small 'floating' label (better known as <I>Window Tip</I> or
<I>Balloon</I>) that pops up when a widget has had focus for some amount of
time (i.e. 500 msec). It contains context-sensitive help, explaining what the
use is of the widget is. 
<P>
<IMG SRC="local/aws_balloon.gif">
<P>
<I>Fig 1. aws_balloon with Tip and Messagebar</I>

<P>
Another function of the aws_balloon is to display (optionally) a (separate) 
message in a pre-configured label- or messagewidget, immediately when the
mousecursor enters a widget, which allows a less intrusive form of context-
sensitive help.
<P>
<A NAME="aws_combobox"><H2>2.2 aws_combobox </H2></A>

An aws_combobox is a combination of a textentry where the user can type 
input, and a listbox from which several pre-defined options can be chosen.
<P>
Next to the input entry is a small button with a down-arrow (or more a triangle)
which can be used to pull down the listbox. The user clicks on one of the 
options, and the option will be inserted into the textentry, and it will be
moved to the top of the listbox.
<P>
<IMG SRC="local/aws_combobox1.gif"> 
<P>
<I>Fig 2. aws_combobox</I>
<P>
<IMG SRC="local/aws_combobox2.gif">
<P>
<I>Fig 3. aws_combobox with pulldown listbox</I>
<P>
<A NAME="aws_dialog"><H2>2.3 aws_dialog </H2></A>
aws_dialogs are toplevel windows, usually containing a bitmap, a message
and 2 or three buttons (Ok, Cancel, Help). They are design for simple 
interaction with the user such as asking Yes/No questions, Confirming steps,
or simply displaying a message and waiting until the user presses the Done
button.
<P>
<IMG SRC="local/yesNoDialog.gif">
<P>
<I>Fig 4. A simple aws_dialog</I>
<P>
aws_dialogs can also be extended with user-defined widgets. The basic building
blocks will still be available but the programmer gets access to a small piece
of space (a frame) in which widgets can be packed.
<P>
<IMG SRC="local/awsCustomDialog.gif">
<P>
<I>Fig 5. A more complex Dialog containing entries, comboboxes, etc.</I>
<P>

<HR>
<A HREF="Introduction.html">&lt;&lt; [Prev]</A>
<A HREF="#top"> [Top] </A>
<A HREF="Implementation.html">[Next] &gt;&gt;</A>
</BODY>
</HTML>
