<!DOCTYPE HTML PUBLIC "-//W3O//DTD W3 HTML 2.0//EN">
<!Converted with LaTeX2HTML 95.1 (Fri Jan 20 1995) by Nikos Drakos (nikos@cbl.leeds.ac.uk), CBLU, University of Leeds >
<HEAD>
<TITLE> The class data</TITLE>
</HEAD>
<BODY>
<meta name="description" value=" The class data">
<meta name="keywords" value="guide">
<meta name="resource-type" value="document">
<meta name="distribution" value="global">
<P>
 <BR> <HR><A NAME=tex2html308 HREF="node13.html"><IMG ALIGN=BOTTOM ALT="next" SRC="http://www.cs.vu.nl/images/latex2html//next_motif.gif"></A>   <A NAME=tex2html306 HREF="node11.html"><IMG ALIGN=BOTTOM ALT="up" SRC="http://www.cs.vu.nl/images/latex2html//up_motif.gif"></A>   <A NAME=tex2html300 HREF="node11.html"><IMG ALIGN=BOTTOM ALT="previous" SRC="http://www.cs.vu.nl/images/latex2html//previous_motif.gif"></A>   <A NAME=tex2html310 HREF="node1.html"><IMG ALIGN=BOTTOM ALT="contents" SRC="http://www.cs.vu.nl/images/latex2html//contents_motif.gif"></A>   <A NAME=tex2html311 HREF="node27.html"><IMG ALIGN=BOTTOM ALT="index" SRC="http://www.cs.vu.nl/images/latex2html//index_motif.gif"></A>   <BR>
<B> Next:</B> <A NAME=tex2html309 HREF="node13.html"> The class datahandler</A>
<B>Up:</B> <A NAME=tex2html307 HREF="node11.html"> Base classes</A>
<B> Previous:</B> <A NAME=tex2html301 HREF="node11.html"> Base classes</A>
<BR> <HR> <P>
<H3><A NAME=SECTION00071100000000000000> The class data</A></H3>
<P>
The class <em> data</em><A NAME=262>&#160;</A> can be used to model the information that 
flows through
the process being modelled. The class is derived from <em> event</em> to make it
possible to gather information about it with the SIM class <em> histogram</em>.
So, although strictly spoken <em> data</em> is an <em> event</em>, it will not be
activated. Or so to speak, `it will never happen.'
<P>
<PRE>interface data : public event
{
public:
  data(int kf = FALSE);                     // constructor 
  virtual data* new_data(int kf = FALSE);   // virtual constructor

  void currenthandler(datahandler* dh);     // set current datahandler
  datahandler* currenthandler();            // get current datahandler

  data* source();                           // belongs to?
  void source(data* d);                     // set source

  int killflag();                           // get killflag;
};
</PRE>
<P>
The contructor takes a boolean to set the killflag (see also [<A HREF="node26.html#bolier">1</A>]). 
If the killflag is <em> OK</em> the number of terminated data objects will be 
counted. This is useful
when one wants to run the simulation for a fixed number of data objects.
The procedure <em> new_data</em> is a virtual 
constructor<A NAME=270>&#160;</A>, meaning that when
called, it will return a pointer to a new object of the same class as the
object whose virtual constructor was called. This is mainly important when one
wants to derive a new class from <em> data</em>. 
Every class, derived from <em> data</em>, should implement its virtual 
constructor as follows:
<PRE>derived_from_data::new_data(int kf = FALSE) 
{
  return new derived_from_data(kf);
}
</PRE>
This way, when the generating agent creates a new object, that object will be
of the type <em> derived_from_data</em> and not of the class <em> data</em>. If the 
class <em> derived_class</em> would not
implement the virtual constructor, the agent would create objects of the type
<em> data</em>, which is clearly not what was meant to happen.
<P>
The <em> currenthandler</em> members are used by datahandlers to set and get the
location of the data object. The <em> source</em> members are used to specify
that some data object belongs to some other data object. Take, for example,
the process from figure <A HREF="node7.html#fiexample1">4</A> on page <A HREF="node7.html#fiexample1"><IMG ALIGN=BOTTOM ALT="gif" SRC="http://www.cs.vu.nl/images/latex2html//cross_ref_motif.gif"></A>.
The process needs some
information from the other department and so the first operation requests that
information. The second operation cannot continue unless the information is
received. To accomplish this the first operation creates a new data object 
which gets passed on to the other department (an <em> external agent</em>).
The first operation sets the source of this new data object to be the original
data to ensure that the waitqueue can recognize when both the original data 
and the new data object have arrived at the wait queue.
The member function <em> killflag</em> is used to create multiple data objects
with the same killflag as the first one.
<P>
<BR> <HR><A NAME=tex2html308 HREF="node13.html"><IMG ALIGN=BOTTOM ALT="next" SRC="http://www.cs.vu.nl/images/latex2html//next_motif.gif"></A>   <A NAME=tex2html306 HREF="node11.html"><IMG ALIGN=BOTTOM ALT="up" SRC="http://www.cs.vu.nl/images/latex2html//up_motif.gif"></A>   <A NAME=tex2html300 HREF="node11.html"><IMG ALIGN=BOTTOM ALT="previous" SRC="http://www.cs.vu.nl/images/latex2html//previous_motif.gif"></A>   <A NAME=tex2html310 HREF="node1.html"><IMG ALIGN=BOTTOM ALT="contents" SRC="http://www.cs.vu.nl/images/latex2html//contents_motif.gif"></A>   <A NAME=tex2html311 HREF="node27.html"><IMG ALIGN=BOTTOM ALT="index" SRC="http://www.cs.vu.nl/images/latex2html//index_motif.gif"></A>   <BR>
<B> Next:</B> <A NAME=tex2html309 HREF="node13.html"> The class datahandler</A>
<B>Up:</B> <A NAME=tex2html307 HREF="node11.html"> Base classes</A>
<B> Previous:</B> <A NAME=tex2html301 HREF="node11.html"> Base classes</A>
<BR> <HR> <P>
<BR> <HR>
<P><ADDRESS>
<I>A Eliens <BR>
Mon Jun  1 11:51:50 MET DST 1998</I>
</ADDRESS>
</BODY>
