<!DOCTYPE HTML PUBLIC "-//W3O//DTD W3 HTML 2.0//EN">
<!Converted with LaTeX2HTML 95.1 (Fri Jan 20 1995) by Nikos Drakos (nikos@cbl.leeds.ac.uk), CBLU, University of Leeds >
<HEAD>
<TITLE> The class datahandler</TITLE>
</HEAD>
<BODY>
<meta name="description" value=" The class datahandler">
<meta name="keywords" value="guide">
<meta name="resource-type" value="document">
<meta name="distribution" value="global">
<P>
 <BR> <HR><A NAME=tex2html318 HREF="node14.html"><IMG ALIGN=BOTTOM ALT="next" SRC="http://www.cs.vu.nl/images/latex2html//next_motif.gif"></A>   <A NAME=tex2html316 HREF="node11.html"><IMG ALIGN=BOTTOM ALT="up" SRC="http://www.cs.vu.nl/images/latex2html//up_motif.gif"></A>   <A NAME=tex2html312 HREF="node12.html"><IMG ALIGN=BOTTOM ALT="previous" SRC="http://www.cs.vu.nl/images/latex2html//previous_motif.gif"></A>   <A NAME=tex2html320 HREF="node1.html"><IMG ALIGN=BOTTOM ALT="contents" SRC="http://www.cs.vu.nl/images/latex2html//contents_motif.gif"></A>   <A NAME=tex2html321 HREF="node27.html"><IMG ALIGN=BOTTOM ALT="index" SRC="http://www.cs.vu.nl/images/latex2html//index_motif.gif"></A>   <BR>
<B> Next:</B> <A NAME=tex2html319 HREF="node14.html"> Datahandlers</A>
<B>Up:</B> <A NAME=tex2html317 HREF="node11.html"> Base classes</A>
<B> Previous:</B> <A NAME=tex2html313 HREF="node12.html"> The class data</A>
<BR> <HR> <P>
<H3><A NAME=SECTION00071200000000000000> The class datahandler</A></H3>
<P>
The abstract class <em> datahandler</em><A NAME=285>&#160;</A> forms the basis for 
all objects that
influence the flow of information in some way. The time a datahandler needs to
perform its action is specified by its distribution<A NAME=286>&#160;</A> and 
distribution-parameters.
<P>
<PRE>interface datahandler
{
protected:
  datahandler();                                // constructor

public:
  virtual int accept(data* d);                  // do we accept the data
  virtual void pass(data* d);                   // offer d to next datahandler
  virtual void next(datahandler* dh);           // set next handler
  virtual datahandler* next();                  // get next handler
  virtual void previous(datahandler* dh);       // set previous handler
  virtual double duration();                    // get a duration 
  virtual void duration(double a, generator* g = NULL, 
                        distribution db = EXACT, double b = 0);
                                                // set duration
};
</PRE>
<P>
A datahandler should be created by means of the constructor, and be given a 
successor datahandler using the <em> next</em> member. The member <em> next</em> will
call the member <em> previous</em> of the successor, so the successor has a way of
knowing its precessor. This is mainly important with the class <em> waitqueue</em>.
An object of class <em> waitqueue</em><A NAME=292>&#160;</A> need to know 
whether it has one precessor -- so it is a regular queue -- or whether it has 
two precessors -- and it will function as a waitqueue.  See also
section <A HREF="node17.html#sewaitqueue">6.2.3</A>.
<P>
A distribution according to
which duration times are generated can be specified with the 
<em> duration</em><A NAME=295>&#160;</A> member. Some examples of how to specify the 
duration:
<PRE>// random number generator with seed 1
bpgenerator* g = new bpgenerator(1);

// duration allways 5.0, no generator needed
handler -&gt; duration(5.0);      

// duration is normal distributed, mean 5.0, standard deviation 2.0
handler -&gt; duration(5.0, g, NORMAL, 2.0);

// duration with poisson distribution, mean 5.0
handler -&gt; duration(5.0, g, POISSON);
</PRE>
<P>
The distribution<A NAME=296>&#160;</A> type looks as follows:
<PRE>enum distribution {EXACT, UNIFORM, EXPONENTIAL, LAPLACE, NORMAL, CHISQUARE, 
                   STUDENT, LOGNORMAL, ERLANG, GAMMA, BETA, FDISTRIBUTION, 
                   POISSON, GEOMETRIC, WEIBULL, BINOMIAL, NEGATIVEBINOMIAL, 
                   TRIANGULAR};
</PRE>
<P>
The datahandler receives data when
the member function <em> accept</em> gets called by another datahandler. 
The function <em> accept</em> should return <em> OK</em> if the datahandler is able to 
handle the data, <em> FALSE</em> otherwise. Classes that are derived from <em>
datahandler</em> should override this member if they do not allways accept the
data, for instance when they have to acquire some resources. 
If the <em> datahandler</em> is able to accept the <em> data</em> it schedules an 
event to become active after a timeperiod,
determined by <em> duration</em>. When that event gets activated it will 
pass the data to the next datahandler, using the <em> datahandler</em>-members 
<em> next</em>, to find out which, and <em> pass</em> to offer the data to the next 
handler.
<P>
<BR> <HR>
<P><ADDRESS>
<I>A Eliens <BR>
Mon Jun  1 11:51:50 MET DST 1998</I>
</ADDRESS>
</BODY>
