<!DOCTYPE HTML PUBLIC "-//W3O//DTD W3 HTML 2.0//EN">
<!Converted with LaTeX2HTML 95.1 (Fri Jan 20 1995) by Nikos Drakos (nikos@cbl.leeds.ac.uk), CBLU, University of Leeds >
<HEAD>
<TITLE> The class operation</TITLE>
</HEAD>
<BODY>
<meta name="description" value=" The class operation">
<meta name="keywords" value="guide">
<meta name="resource-type" value="document">
<meta name="distribution" value="global">
<P>
 <BR> <HR><A NAME=tex2html348 HREF="node16.html"><IMG ALIGN=BOTTOM ALT="next" SRC="http://www.cs.vu.nl/images/latex2html//next_motif.gif"></A>   <A NAME=tex2html346 HREF="node14.html"><IMG ALIGN=BOTTOM ALT="up" SRC="http://www.cs.vu.nl/images/latex2html//up_motif.gif"></A>   <A NAME=tex2html340 HREF="node14.html"><IMG ALIGN=BOTTOM ALT="previous" SRC="http://www.cs.vu.nl/images/latex2html//previous_motif.gif"></A>   <A NAME=tex2html350 HREF="node1.html"><IMG ALIGN=BOTTOM ALT="contents" SRC="http://www.cs.vu.nl/images/latex2html//contents_motif.gif"></A>   <A NAME=tex2html351 HREF="node27.html"><IMG ALIGN=BOTTOM ALT="index" SRC="http://www.cs.vu.nl/images/latex2html//index_motif.gif"></A>   <BR>
<B> Next:</B> <A NAME=tex2html349 HREF="node16.html"> The class transport</A>
<B>Up:</B> <A NAME=tex2html347 HREF="node14.html"> Datahandlers</A>
<B> Previous:</B> <A NAME=tex2html341 HREF="node14.html"> Datahandlers</A>
<BR> <HR> <P>
<H3><A NAME=SECTION00072100000000000000> The class operation</A></H3>
<P>
The class <em> operation</em><A NAME=318>&#160;</A> represents the work done in a 
process. It needs an employee to perform the work. The interface looks 
as follows:
<P>
<PRE>interface operation : public datahandler
{
public:
  operation(employee* e);                  // constructor

  int accept(data* d);                     // try to handle data
  void pass(data* d);                      // pass the data to the next handler
  virtual int acquire();                   // try to acquire resources
  virtual void release();                  // release acquired resources
  virtual void next(datahandler* dh1, datahandler* dh2 = NULL, data* d = NULL); 
                                           // pass data to dh1 and to dh2
};
</PRE>
<P>
The constructor takes the employee that will perform the operation. The member
<em> accept</em> overrides <em> datahandler::accept</em> to take 
care of the acquiring of the employee. It uses the member <em> acquire</em> to try
to aqcuire the employee. If <em> acquire</em> fails to get the employee it will
return <em> FALSE</em>, and <em> accept</em> will return <em> FALSE</em> too, thus 
informing the previous <em> datahandler</em> that the operation could not be 
executed at that time. The member <em> pass</em> will be called when the operation 
finishes. It will use <em> release</em> to free the employee and will pass 
the data object to the next handler.
<P>
In some cases an operation will produce extra information, for instance when
an operation will request extra information from another department. See also
section <A HREF="node6.html#seprogram">5</A>. In that case the member function <em> next</em> should
be used to specify both the successor datahandlers. If the parameter <em>
data</em> is not
provided, <em> operation</em> will simply make a copy of the received data and 
pass the copy on to the second datahandler (<em> dh2</em>). If another <em> data</em>
object is provided by means of the <em> next</em> member, copies of that object 
will be passed to the second datahandler, with its <em> source</em> set to the 
original <em> data</em>.
<P>
<BR> <HR>
<P><ADDRESS>
<I>A Eliens <BR>
Mon Jun  1 11:51:50 MET DST 1998</I>
</ADDRESS>
</BODY>
