<!DOCTYPE HTML PUBLIC "-//W3O//DTD W3 HTML 2.0//EN">
<!Converted with LaTeX2HTML 95.1 (Fri Jan 20 1995) by Nikos Drakos (nikos@cbl.leeds.ac.uk), CBLU, University of Leeds >
<HEAD>
<TITLE> The class waitqueue</TITLE>
</HEAD>
<BODY>
<meta name="description" value=" The class waitqueue">
<meta name="keywords" value="guide">
<meta name="resource-type" value="document">
<meta name="distribution" value="global">
<P>
 <BR> <HR><A NAME=tex2html372 HREF="node18.html"><IMG ALIGN=BOTTOM ALT="next" SRC="http://www.cs.vu.nl/images/latex2html//next_motif.gif"></A>   <A NAME=tex2html370 HREF="node14.html"><IMG ALIGN=BOTTOM ALT="up" SRC="http://www.cs.vu.nl/images/latex2html//up_motif.gif"></A>   <A NAME=tex2html364 HREF="node16.html"><IMG ALIGN=BOTTOM ALT="previous" SRC="http://www.cs.vu.nl/images/latex2html//previous_motif.gif"></A>   <A NAME=tex2html374 HREF="node1.html"><IMG ALIGN=BOTTOM ALT="contents" SRC="http://www.cs.vu.nl/images/latex2html//contents_motif.gif"></A>   <A NAME=tex2html375 HREF="node27.html"><IMG ALIGN=BOTTOM ALT="index" SRC="http://www.cs.vu.nl/images/latex2html//index_motif.gif"></A>   <BR>
<B> Next:</B> <A NAME=tex2html373 HREF="node18.html"> The class choice</A>
<B>Up:</B> <A NAME=tex2html371 HREF="node14.html"> Datahandlers</A>
<B> Previous:</B> <A NAME=tex2html365 HREF="node16.html"> The class transport</A>
<BR> <HR> <P>
<H3><A NAME=SECTION00072300000000000000> The class waitqueue</A></H3>
<P>
The class <em> waitqueue</em><A NAME=350>&#160;</A> can be used to hold data objects 
until an operation
is ready to process the data. It can also hold data that has to wait for 
another data object before it is ready to be processed by an operation.
<P>
<PRE>interface waitqueue : public event, public queue, public datahandler
{
public:
  waitqueue();                                  // constructor
  waitqueue(histogram* h1, histogram* h2);      // constructor with histograms

  int operator()();                             // application operator
  int accept(data* d);                          // put the data in the waitqueue
  void previous(datahandler* dh);               // set up to 2 previous handlers
};
</PRE>
<P>
A <em> waitqueue</em> is created using one of the two contructors. If one wants
to gather information about the queue length and waiting times, the second
constructor should be used. The first histogram should be of type 
<em> WEIGTHED</em>, the second of type <em> FREQUENCY</em>.
<P>
When the processmodel is
being created, at most two other <em> datahandlers</em> will have there successor
set to one waitqueue. Because those handlers call <em> waitqueue::previous</em>, the
<em> waitqueue</em> knows its precessors. This way the <em> waitqueue</em> knows
whether it is an ordinary queue with one precessor, or a waitqueue, with two
previous <em> datahandlers</em>. Note that the <em> waitqueue</em> will assume that
the first call of <em> previous</em> sets the <em> datahandler</em> that provides the
original data objects, and that the second call of <em> previous</em> specifies the
handler that provides the copies.
<P>
When being created, the <em> waitqueue</em> will put itself on the conditional 
list to ensure its
application operator is called each time something changes in the
simulation. When the application operator gets called it will look in the
waitqueue to see whether there are some data objects that are ready to be 
processed. If there are such objects, the <em> waitqueue</em> will try to pass 
them, one at a time, to the next <em> datahandler</em> until the next handler does
not accept any more data objects.
<P>
The member <em> accept</em> will allways accept the data objects it gets offered.
If the object is not a copy it will simply be added to the queue. If it is 
a copy of another data object (the <em> source</em>), the copy will directly be 
terminated. If the source is already in the queue, the
source will have its queuingpriority increased. That way it will move to the
front of the queue. If the source is not yet in the <em> waitqueue</em> an event
will be made conditional to watch for it. If the source arrives at the queue 
the event will raise the queuingpriority of the source.
<P>
<BR> <HR><A NAME=tex2html372 HREF="node18.html"><IMG ALIGN=BOTTOM ALT="next" SRC="http://www.cs.vu.nl/images/latex2html//next_motif.gif"></A>   <A NAME=tex2html370 HREF="node14.html"><IMG ALIGN=BOTTOM ALT="up" SRC="http://www.cs.vu.nl/images/latex2html//up_motif.gif"></A>   <A NAME=tex2html364 HREF="node16.html"><IMG ALIGN=BOTTOM ALT="previous" SRC="http://www.cs.vu.nl/images/latex2html//previous_motif.gif"></A>   <A NAME=tex2html374 HREF="node1.html"><IMG ALIGN=BOTTOM ALT="contents" SRC="http://www.cs.vu.nl/images/latex2html//contents_motif.gif"></A>   <A NAME=tex2html375 HREF="node27.html"><IMG ALIGN=BOTTOM ALT="index" SRC="http://www.cs.vu.nl/images/latex2html//index_motif.gif"></A>   <BR>
<B> Next:</B> <A NAME=tex2html373 HREF="node18.html"> The class choice</A>
<B>Up:</B> <A NAME=tex2html371 HREF="node14.html"> Datahandlers</A>
<B> Previous:</B> <A NAME=tex2html365 HREF="node16.html"> The class transport</A>
<BR> <HR> <P>
<BR> <HR>
<P><ADDRESS>
<I>A Eliens <BR>
Mon Jun  1 11:51:50 MET DST 1998</I>
</ADDRESS>
</BODY>
