<!DOCTYPE HTML PUBLIC "-//W3O//DTD W3 HTML 2.0//EN">
<!Converted with LaTeX2HTML 95.1 (Fri Jan 20 1995) by Nikos Drakos (nikos@cbl.leeds.ac.uk), CBLU, University of Leeds >
<HEAD>
<TITLE> The class choice</TITLE>
</HEAD>
<BODY>
<meta name="description" value=" The class choice">
<meta name="keywords" value="guide">
<meta name="resource-type" value="document">
<meta name="distribution" value="global">
<P>
 <BR> <HR><A NAME=tex2html384 HREF="node19.html"><IMG ALIGN=BOTTOM ALT="next" SRC="http://www.cs.vu.nl/images/latex2html//next_motif.gif"></A>   <A NAME=tex2html382 HREF="node14.html"><IMG ALIGN=BOTTOM ALT="up" SRC="http://www.cs.vu.nl/images/latex2html//up_motif.gif"></A>   <A NAME=tex2html376 HREF="node17.html"><IMG ALIGN=BOTTOM ALT="previous" SRC="http://www.cs.vu.nl/images/latex2html//previous_motif.gif"></A>   <A NAME=tex2html386 HREF="node1.html"><IMG ALIGN=BOTTOM ALT="contents" SRC="http://www.cs.vu.nl/images/latex2html//contents_motif.gif"></A>   <A NAME=tex2html387 HREF="node27.html"><IMG ALIGN=BOTTOM ALT="index" SRC="http://www.cs.vu.nl/images/latex2html//index_motif.gif"></A>   <BR>
<B> Next:</B> <A NAME=tex2html385 HREF="node19.html"> The class agent</A>
<B>Up:</B> <A NAME=tex2html383 HREF="node14.html"> Datahandlers</A>
<B> Previous:</B> <A NAME=tex2html377 HREF="node17.html"> The class waitqueue</A>
<BR> <HR> <P>
<H3><A NAME=SECTION00072400000000000000> The class choice</A></H3>
<P>
The class <em> choice</em><A NAME=371>&#160;</A> will pass data it receives to one of 
two datahandlers. The interface looks as follows:
<P>
<PRE>interface choice : public datahandler
{
protected:
  choice();

public:
  choice(bpgenerator* g, double p);                // constructor

  void next(datahandler* dh1, datahandler* dh2);   // set next handlers
  datahandler* next();                             // get 1 of the 2 handlers
  int makechoice();                                // return OK or FALSE
};
</PRE>
<P>
The member <em> next</em> chooses one of the two possible next handlers 
based on the result of <em> makechoice</em>.
If <em> makechoice</em> returns <em> OK</em>, <em> next</em> will 
return <em> datahandler</em> 1, otherwise it will return <em> datahandler</em> 2.
The member <em> makechoice</em> returns <em> OK</em> with a chance 
specified by means of the generator and the parameter <em> p</em>, where <em> p</em>
represents the chance that a data object is passed to the first datahandler.
<P>
When one wants to base the decision on something else than pure chance,
one should override <em> makechoice</em>. Say we have two kinds of data 
objects, <em> simple</em> and <em> complex</em>. We could derive a new class from
<em> data</em>, say <em> complexdata</em>, with a member function returning the
complexity:  
<PRE>  int complex();                  // OK if complex, FALSE otherwise
</PRE>
<P>
Now we can derive a new class from <em> choice</em>, say <em> complex_choice</em>,
that looks as follows:
<PRE>interface complex_choice : public choice
{
private:
  data* current_data;

public:
  complex_choice();
  void pass(data* d);
  int makechoice();
};
</PRE>
<P>
The constructor looks as follows:
<PRE>complex_choice::complex_choice() : choice()
{
}
</PRE>
We implement its member <em> makechoice</em> as follows:
<PRE>int complex_choice::makechoice()
{
  return (((complexdata*)current_data) -&gt; complex());
}
</PRE>
<P>
And we override the member <em> pass</em> to set the new local variable <em>
current_data</em>:
<PRE>void complex_choice::pass(data* d)
{
  current_data = d;
  choice::pass(d);
}
</PRE>
<P>
So, when <em> complex_choice</em> has to pass a complex data object, <em>
makechoice</em> will return <em> OK</em> so <em> next</em> will return the first 
<em> datahandler</em>. If the data object is simple, <em> makechoice</em> returns 
<em> FALSE</em> and the second <em> datahandler</em> will receive the data.
<P>
<BR> <HR>
<P><ADDRESS>
<I>A Eliens <BR>
Mon Jun  1 11:51:50 MET DST 1998</I>
</ADDRESS>
</BODY>
