<!DOCTYPE HTML PUBLIC "-//W3O//DTD W3 HTML 2.0//EN">
<!Converted with LaTeX2HTML 95.1 (Fri Jan 20 1995) by Nikos Drakos (nikos@cbl.leeds.ac.uk), CBLU, University of Leeds >
<HEAD>
<TITLE> The class agent</TITLE>
</HEAD>
<BODY>
<meta name="description" value=" The class agent">
<meta name="keywords" value="guide">
<meta name="resource-type" value="document">
<meta name="distribution" value="global">
<P>
 <BR> <HR><A NAME=tex2html396 HREF="node20.html"><IMG ALIGN=BOTTOM ALT="next" SRC="http://www.cs.vu.nl/images/latex2html//next_motif.gif"></A>   <A NAME=tex2html394 HREF="node14.html"><IMG ALIGN=BOTTOM ALT="up" SRC="http://www.cs.vu.nl/images/latex2html//up_motif.gif"></A>   <A NAME=tex2html388 HREF="node18.html"><IMG ALIGN=BOTTOM ALT="previous" SRC="http://www.cs.vu.nl/images/latex2html//previous_motif.gif"></A>   <A NAME=tex2html398 HREF="node1.html"><IMG ALIGN=BOTTOM ALT="contents" SRC="http://www.cs.vu.nl/images/latex2html//contents_motif.gif"></A>   <A NAME=tex2html399 HREF="node27.html"><IMG ALIGN=BOTTOM ALT="index" SRC="http://www.cs.vu.nl/images/latex2html//index_motif.gif"></A>   <BR>
<B> Next:</B> <A NAME=tex2html397 HREF="node20.html"> The class archive</A>
<B>Up:</B> <A NAME=tex2html395 HREF="node14.html"> Datahandlers</A>
<B> Previous:</B> <A NAME=tex2html389 HREF="node18.html"> The class choice</A>
<BR> <HR> <P>
<H3><A NAME=SECTION00072500000000000000> The class agent</A></H3>
<P>
External agents<A NAME=402>&#160;</A><A NAME=403>&#160;</A> can have two roles 
in <em> Logistics Based Business
Modelling</em>. An external agent either produces data on its own initiative --
a generating agent<A NAME=405>&#160;</A> -- or it only processes data it 
receives -- a non-generating agent<A NAME=406>&#160;</A>. The 
interface for <em> agent</em> looks as follows:
<P>
<PRE>class agent : public event, public datahandler
{
public:
  agent(int generate = FALSE, histogram* h = NULL, data * d = NULL);
                                                  // constructor
  virtual int operator()();                       // application operator
  int accept(data* d);                            // arrival of data
};
</PRE>
<P>
The constructor takes a flag that sets whether the <em> agent</em> should generate
data or not. The user can also provide a histogram to gather information on
the lifetime of the generated data. If the user does not provide a data object
the <em> agent</em> will use objects of class <em> data</em>. If the constructor gets
called with a data object, or an object derived from data -- the <em> agent</em>
will generate copies of that object.
<P>
If the <em> agent</em> is set to generate data objects, the <em> agent</em> will 
be activated at the start of the simulation, it will generate a <em> data</em> 
object, pass it to its successor, and schedule itself after a time determined 
by <em> datahandler::duration</em>. If it gets activated again the same sequence of
actions is taken.
<P>
The member <em> accept</em> has been overridden to take care of the two different
roles an <em> agent</em> can play: if the <em> agent</em> is generating, it will
terminate objects it receives. This way objects that are generated by the <em>
agent</em> can be handled by a series of datahandlers and then be passed back to
the <em> agent</em>. If the <em> agent</em> is a non-generating <em> agent</em> it will
accept the data object, and behave as a normal <em> datahandler</em>.
<P>
<BR> <HR>
<P><ADDRESS>
<I>A Eliens <BR>
Mon Jun  1 11:51:50 MET DST 1998</I>
</ADDRESS>
</BODY>
