<!DOCTYPE HTML PUBLIC "-//W3O//DTD W3 HTML 2.0//EN">
<!Converted with LaTeX2HTML 95.1 (Fri Jan 20 1995) by Nikos Drakos (nikos@cbl.leeds.ac.uk), CBLU, University of Leeds >
<HEAD>
<TITLE> Logistics Based Business Modelling</TITLE>
</HEAD>
<BODY>
<meta name="description" value=" Logistics Based Business Modelling">
<meta name="keywords" value="guide">
<meta name="resource-type" value="document">
<meta name="distribution" value="global">
<P>
 <BR> <HR><A NAME=tex2html183 HREF="node4.html"><IMG ALIGN=BOTTOM ALT="next" SRC="http://www.cs.vu.nl/images/latex2html//next_motif.gif"></A>   <A NAME=tex2html181 HREF="guide.html"><IMG ALIGN=BOTTOM ALT="up" SRC="http://www.cs.vu.nl/images/latex2html//up_motif.gif"></A>   <A NAME=tex2html175 HREF="node2.html"><IMG ALIGN=BOTTOM ALT="previous" SRC="http://www.cs.vu.nl/images/latex2html//previous_motif.gif"></A>   <A NAME=tex2html185 HREF="node1.html"><IMG ALIGN=BOTTOM ALT="contents" SRC="http://www.cs.vu.nl/images/latex2html//contents_motif.gif"></A>   <A NAME=tex2html186 HREF="node27.html"><IMG ALIGN=BOTTOM ALT="index" SRC="http://www.cs.vu.nl/images/latex2html//index_motif.gif"></A>   <BR>
<B> Next:</B> <A NAME=tex2html184 HREF="node4.html"> The simulation library </A>
<B>Up:</B> <A NAME=tex2html182 HREF="guide.html">No Title</A>
<B> Previous:</B> <A NAME=tex2html176 HREF="node2.html"> Introduction</A>
<BR> <HR> <P>
<H1><A NAME=SECTION00030000000000000000> Logistics Based Business Modelling</A></H1>
<P>
To understand and measure existing processes and to design the new processes 
<em> Logistics Based Business Modelling</em> (LBBM<A NAME=36>&#160;</A>) can be used 
(Gerrits [<A HREF="node26.html#gerrits94">4</A>]). 
LBBM takes a time based view of business processes, focusing on showing 
the <em> product lead time</em><A NAME=39>&#160;</A> in information 
processing production processes.
Gerrits defines <em> product lead time</em> as `the time that passes between the
moment a customer orders a product and the moment the product is delivered'. 
A process is composed of operations<A NAME=41>&#160;</A>. Each operation 
executes (sequentially<A NAME=42>&#160;</A> or
parallel<A NAME=43>&#160;</A>) a part of the process. 
Operations need resources<A NAME=44>&#160;</A> to be executed. These
resources, like employee's, computers, etc. have a limited capacity.
<P>
The production lead time consists of the following components:
<UL><LI> <em> processing time</em><A NAME=47>&#160;</A>, the time actually 
worked on a job, i.e. a customer order;
<LI> <em> queue time</em><A NAME=49>&#160;</A>, the time a job waits for a 
resource to become
available. Gerrits distinguishes two kinds of queue time: (1) capacity
oriented queue time and (2) batch oriented queue time. The first is caused by
the unbalance of demand and supply of capacity, the second by the periodic
availability of resources that are operated in batch mode;
<LI> <em> setup time</em><A NAME=51>&#160;</A>, the 
time that passes between the moment a resource
comes available and the moment it is able to start the next job. When the
setup time is relatively large it becomes efficient to combine similar jobs
into larger jobs, leading to batch production. In information production
the setup time of machines is much less important than the setup times of
employees, that is, the employee needs time to assimilate to the case at hand; 
<LI> <em> wait time</em><A NAME=53>&#160;</A>, wait time occurs in processes with 
parallel operations<A NAME=54>&#160;</A>
that at some point have to synchronize;
<LI> <em> transport time</em><A NAME=56>&#160;</A>, time needed to move a 
job from a resource at a
certain location to another resource at another location.
</UL>
<P>
The modelling language of LBBM<A NAME=58>&#160;</A> uses the following objects to 
model business processes:
<UL><P><A NAME=63>&#160;</A><A NAME=fibm1>&#160;</A><IMG  ALIGN=BOTTOM ALT="" SRC="img1.gif">
<BR><STRONG>Figure 1:</STRONG> Operation, task and transport<BR>
<P>
<P>
<LI> <em> operation</em>,
an <em> operation</em><A NAME=69>&#160;</A> processes data, it reflects the 
processing component of an
information production process. An operation is atomic in the sense that wait
time, queue time and transport time may not be part of an operation. Only
setup time and process time are part of an operation. Furthermore, it
is possible to define the pre- and post-conditions of an operation.  The
pre-condition describes the needed input data, the post-condition describes
the produced output. Operations are represented as in 
figure <A HREF="node3.html#fibm1">1</A>;
<P>
<LI> <em> task</em>,
a <em> task</em><A NAME=73>&#160;</A> is a series of consecutive operations that are 
executed by the same employee. 
Note that there is no wait time, queue time or transport time between the
operations. The name or the function of the employee is written in the lower
right corner of the rectangle. See figure <A HREF="node3.html#fibm1">1</A>;
<P>
<LI> <em> transport</em>,
<em> information transport</em><A NAME=77>&#160;</A> between resources 
is denoted as in figure
<A HREF="node3.html#fibm1">1</A>. Data flows are needed when information flows from one
resource to another. The flow of data depicts the determinants of transport
time and defines the sequence of operations in a process. 
Duplication<A NAME=79>&#160;</A> of data is denoted by splitting the arrow;
<P>
<P><A NAME=83>&#160;</A><A NAME=fibm2>&#160;</A><IMG  ALIGN=BOTTOM ALT="" SRC="img2.gif">
<BR><STRONG>Figure 2:</STRONG> Queue and wait time and organization unit<BR>
<P>
<P>
<LI> <em> queue and wait time</em>,
the same symbol for <em> queue time</em><A NAME=89>&#160;</A> and 
<em> wait time</em><A NAME=91>&#160;</A> is used, see figure <A HREF="node3.html#fibm2">2</A>. 
Conceptually, both
represent a state of non-activity: no work is done on the case. If one
information flow comes into a triangle, it is a queue, otherwise it is a
combination of wait time and queue time.
<P>
<LI> <em> organization unit</em>,
figure <A HREF="node3.html#fibm2">2</A> depicts the grouping of employees in <em> organization
units</em><A NAME=96>&#160;</A>. This makes it possible to depict the 
different departments, involved in the execution of the process. That way
boundaries between departments, often responsible for extra transport time, 
become visible;
<P>
<P><A NAME=100>&#160;</A><A NAME=fibm3>&#160;</A><IMG  ALIGN=BOTTOM ALT="" SRC="img3.gif">
<BR><STRONG>Figure 3:</STRONG> Choice, external agent, means and archive<BR>
<P>
<P>
<LI> <em> choice</em>,
points in the process where decisions<A NAME=105>&#160;</A> are made that result in 
different
information flows are depicted as in figure <A HREF="node3.html#fibm3">3</A>;
<P>
<LI> <em> external agent</em>,
an <em> external agent</em><A NAME=109>&#160;</A><A NAME=110>&#160;</A> is an 
external organization 
or person that acts as source or destination of data. Agents can either be 
external to the organization or to the business process at hand. Agents are 
denoted as in figure <A HREF="node3.html#fibm3">3</A>;
<P>
<LI> <em> means</em>,
<em> means</em><A NAME=114>&#160;</A> are used by employees to perform operations. They 
are depicted because
they influence the queue and set up times. Each time an employee has to change
means to handle the case, a new operation is performed. See
figure <A HREF="node3.html#fibm3">3</A>;
<P>
<LI> <em> archive</em>,
especially for describing paper flow processes, the 
<em> archive</em><A NAME=118>&#160;</A> 
symbol is necessary. The availability of data is one of the sources of 
wait time<A NAME=119>&#160;</A>. See figure <A HREF="node3.html#fibm3">3</A>;
</UL><BR> <HR><A NAME=tex2html183 HREF="node4.html"><IMG ALIGN=BOTTOM ALT="next" SRC="http://www.cs.vu.nl/images/latex2html//next_motif.gif"></A>   <A NAME=tex2html181 HREF="guide.html"><IMG ALIGN=BOTTOM ALT="up" SRC="http://www.cs.vu.nl/images/latex2html//up_motif.gif"></A>   <A NAME=tex2html175 HREF="node2.html"><IMG ALIGN=BOTTOM ALT="previous" SRC="http://www.cs.vu.nl/images/latex2html//previous_motif.gif"></A>   <A NAME=tex2html185 HREF="node1.html"><IMG ALIGN=BOTTOM ALT="contents" SRC="http://www.cs.vu.nl/images/latex2html//contents_motif.gif"></A>   <A NAME=tex2html186 HREF="node27.html"><IMG ALIGN=BOTTOM ALT="index" SRC="http://www.cs.vu.nl/images/latex2html//index_motif.gif"></A>   <BR>
<B> Next:</B> <A NAME=tex2html184 HREF="node4.html"> The simulation library </A>
<B>Up:</B> <A NAME=tex2html182 HREF="guide.html">No Title</A>
<B> Previous:</B> <A NAME=tex2html176 HREF="node2.html"> Introduction</A>
<BR> <HR> <P>
<BR> <HR>
<P><ADDRESS>
<I>A Eliens <BR>
Mon Jun  1 11:51:50 MET DST 1998</I>
</ADDRESS>
</BODY>
