<!DOCTYPE HTML PUBLIC "-//W3O//DTD W3 HTML 2.0//EN">
<!Converted with LaTeX2HTML 95.1 (Fri Jan 20 1995) by Nikos Drakos (nikos@cbl.leeds.ac.uk), CBLU, University of Leeds >
<HEAD>
<TITLE> The library BPSIM</TITLE>
</HEAD>
<BODY>
<meta name="description" value=" The library BPSIM">
<meta name="keywords" value="guide">
<meta name="resource-type" value="document">
<meta name="distribution" value="global">
<P>
 <BR> <HR><A NAME=tex2html207 HREF="node6.html"><IMG ALIGN=BOTTOM ALT="next" SRC="http://www.cs.vu.nl/images/latex2html//next_motif.gif"></A>   <A NAME=tex2html205 HREF="guide.html"><IMG ALIGN=BOTTOM ALT="up" SRC="http://www.cs.vu.nl/images/latex2html//up_motif.gif"></A>   <A NAME=tex2html199 HREF="node4.html"><IMG ALIGN=BOTTOM ALT="previous" SRC="http://www.cs.vu.nl/images/latex2html//previous_motif.gif"></A>   <A NAME=tex2html209 HREF="node1.html"><IMG ALIGN=BOTTOM ALT="contents" SRC="http://www.cs.vu.nl/images/latex2html//contents_motif.gif"></A>   <A NAME=tex2html210 HREF="node27.html"><IMG ALIGN=BOTTOM ALT="index" SRC="http://www.cs.vu.nl/images/latex2html//index_motif.gif"></A>   <BR>
<B> Next:</B> <A NAME=tex2html208 HREF="node6.html"> Program structure</A>
<B>Up:</B> <A NAME=tex2html206 HREF="guide.html">No Title</A>
<B> Previous:</B> <A NAME=tex2html200 HREF="node4.html"> The simulation library </A>
<BR> <HR> <P>
<H1><A NAME=SECTION00050000000000000000> The library BPSIM</A></H1>
<P>
The simulation library BPSIM provides a number of C++ classes to enable the
programming and simulation of process models designed and/or modelled with 
<em> Logistics Based Business Modelling</em>. The concepts <em> operation</em>, 
<em> external agent</em>, <em> transport</em>, <em> waitqueue</em>, <em> choice</em>, 
<em> archive</em>, <em> means</em> and <em> employee</em> all have their counterpart in 
BPSIM-classes. The library consists of the following classes: 
<UL><LI> <em> data</em><A NAME=166>&#160;</A>, the class <em> data</em> represents the product 
or case, i.e.
the information, that flows through the process. Note that Logistics Based
Business Modelling contains no symbol for data as it only depicts the objects
that handle the information; 
<LI> <em> datahandler</em><A NAME=169>&#160;</A>, this abstract class is the basis 
for all classes that
handle information. The following classes are derived from it: <em> operation,
transport, waitqueue, choice, archive</em>, and <em> external agent</em>;
<LI> <em> operation</em><A NAME=173>&#160;</A>, the class <em> operation</em>, derived 
from <em> datahandler</em>, represents the work done 
on the data. Operations take time, and are executed by employee's. Sometimes 
operations result in more than one outgoing dataflow, for instance when an 
operation issues a request for additional information from a different 
department;
<LI> <em> agent</em>, the class <em> agent</em><A NAME=178>&#160;</A><A NAME=179>&#160;</A> 
represents external agents, for instance clients or other organizations or 
other departments. An agent can either <em>
generate</em> data according to some random number distribution, or take
data, process it and pass it on to the next datahandler. In the latter 
case the agent functions as a black box<A NAME=181>&#160;</A>: we only
care how long the processing takes, not how it is exactly performed. The class
<em> agent</em> is derived from <em> datahandler</em> and the SIM class <em> event</em>;
<LI> <em> transport</em>, this class, derived from <em> datahandler</em>, represents 
the flow of data from one 
datahandler to another and the time it takes to transport the data from one
datahandler to the next one;
<LI> <em> waitqueue</em><A NAME=188>&#160;</A>, the class <em> waitqueue</em> is derived 
from the SIM-classes <em> event</em> and <em> queue</em> and from the class 
<em> datahandler</em>. A <em> waitqueue</em> functions as a regular queue if 
it has one incoming dataflow, i.e. transport. When there are more incoming
flows, it functions as a waitqueue. Data from one flow is not passed on to the
next datahandler until the data from the other flow has arrived. This happens
for instance when work on a case cannot continue until additional information
has arrived;
<LI> <em> choice</em><A NAME=195>&#160;</A>, a <em> choice</em> is a <em> datahandler</em> that 
passes data on
to one from two possible datahandlers, based on some condition;
<LI> <em> archive</em><A NAME=199>&#160;</A>, the class <em> archive</em> models the storage
of information;
<LI> <em> means</em><A NAME=202>&#160;</A>, this class can be used to model resources 
that are necessary to perform certain operations;
<LI> <em> employee</em><A NAME=204>&#160;</A>, the class <em> employee</em> models the 
different people that perform the operations.
</UL>
<P>
As one can see, the objects <em> task</em> and <em> organization unit</em> 
from LBBM<A NAME=209>&#160;</A> have no specific counterpart in BPSIM. The reason for 
this is 
that having no other datahandler between two operations already implies those
operations belong to the same task. Consequently they are
executed with no time in between and by the same employee. Also, the fact 
that tasks are executed in
different <em> organization units</em><A NAME=211>&#160;</A> does not add any 
information that changes
the behaviour of the simulation. If it takes time to transport
information between different units, then that time can be represented by 
the object of class <em> transport</em> between those units.
<P>
For the gathering and analyzing of results the SIM classes 
<em> histogram</em><A NAME=214>&#160;</A> and
<em> analysis</em><A NAME=216>&#160;</A> are used. The class <em> agent</em>, for example, 
can be given a 
histogram to track the lead time of data it has generated. After the
simulation has finished the results are printed to standard output.
<P>
<BR> <HR><A NAME=tex2html207 HREF="node6.html"><IMG ALIGN=BOTTOM ALT="next" SRC="http://www.cs.vu.nl/images/latex2html//next_motif.gif"></A>   <A NAME=tex2html205 HREF="guide.html"><IMG ALIGN=BOTTOM ALT="up" SRC="http://www.cs.vu.nl/images/latex2html//up_motif.gif"></A>   <A NAME=tex2html199 HREF="node4.html"><IMG ALIGN=BOTTOM ALT="previous" SRC="http://www.cs.vu.nl/images/latex2html//previous_motif.gif"></A>   <A NAME=tex2html209 HREF="node1.html"><IMG ALIGN=BOTTOM ALT="contents" SRC="http://www.cs.vu.nl/images/latex2html//contents_motif.gif"></A>   <A NAME=tex2html210 HREF="node27.html"><IMG ALIGN=BOTTOM ALT="index" SRC="http://www.cs.vu.nl/images/latex2html//index_motif.gif"></A>   <BR>
<B> Next:</B> <A NAME=tex2html208 HREF="node6.html"> Program structure</A>
<B>Up:</B> <A NAME=tex2html206 HREF="guide.html">No Title</A>
<B> Previous:</B> <A NAME=tex2html200 HREF="node4.html"> The simulation library </A>
<BR> <HR> <P>
<BR> <HR>
<P><ADDRESS>
<I>A Eliens <BR>
Mon Jun  1 11:51:50 MET DST 1998</I>
</ADDRESS>
</BODY>
