<!DOCTYPE HTML PUBLIC "-//W3O//DTD W3 HTML 2.0//EN">
<!Converted with LaTeX2HTML 95.1 (Fri Jan 20 1995) by Nikos Drakos (nikos@cbl.leeds.ac.uk), CBLU, University of Leeds >
<HEAD>
<TITLE> The program</TITLE>
</HEAD>
<BODY>
<meta name="description" value=" The program">
<meta name="keywords" value="guide">
<meta name="resource-type" value="document">
<meta name="distribution" value="global">
<P>
 <BR> <HR><A NAME=tex2html246 HREF="node9.html"><IMG ALIGN=BOTTOM ALT="next" SRC="http://www.cs.vu.nl/images/latex2html//next_motif.gif"></A>   <A NAME=tex2html244 HREF="node6.html"><IMG ALIGN=BOTTOM ALT="up" SRC="http://www.cs.vu.nl/images/latex2html//up_motif.gif"></A>   <A NAME=tex2html238 HREF="node7.html"><IMG ALIGN=BOTTOM ALT="previous" SRC="http://www.cs.vu.nl/images/latex2html//previous_motif.gif"></A>   <A NAME=tex2html248 HREF="node1.html"><IMG ALIGN=BOTTOM ALT="contents" SRC="http://www.cs.vu.nl/images/latex2html//contents_motif.gif"></A>   <A NAME=tex2html249 HREF="node27.html"><IMG ALIGN=BOTTOM ALT="index" SRC="http://www.cs.vu.nl/images/latex2html//index_motif.gif"></A>   <BR>
<B> Next:</B> <A NAME=tex2html247 HREF="node9.html"> Some results</A>
<B>Up:</B> <A NAME=tex2html245 HREF="node6.html"> Program structure</A>
<B> Previous:</B> <A NAME=tex2html239 HREF="node7.html"> Example process</A>
<BR> <HR> <P>
<H2><A NAME=SECTION00062000000000000000> The program</A></H2>
<P>
The general outline for simulation programs using BPSIM (or SIM) is to first 
create all the necessary objects and then run the simulation for a certain
amount of time or for a certain amount of terminated events.
The program to simulate this example process from figure <A HREF="node7.html#fiexample1">4</A> 
will look as follows.
<PRE>#include &lt;bpsim/bpsim.h&gt;

main()
{
</PRE>
First, the simulation object and a random number generator are created. 
Note that it is necessary to create the simulation object before creating any
BPSIM or SIM objects, because these objects will possibly need to call the
simulation object to register themselves.
<PRE>  simulation* sim = new simulation();            // the simulation object
  bpgenerator* g = new bpgenerator(1);           // random generator with seed
</PRE>
This process is carried out by two employee's who perform the same tasks. 
Therefor we only have to create one employee, with capacity two. The histogram
is used to collect information about the usage of the employee's.
<PRE>  histogram* he = new histogram(0,2,10,WEIGHTED,STATISTICS,&quot;employee usage&quot;);
  employee* e = new employee(he, 2);
</PRE>
The client, of class agent, is created together with a histogram 
to collect information about
the lifetime of the generated data objects. It will generate objects because
the generate flag, the first parameter, has been set to <em> OK</em>. The client 
will generate objects
of class data according to a poisson distribution with mean 60 as has been set
by means of the <em> duration</em> memberfunction.
<P>
Note that only one client is needed, though two clients (boxes) are depicted in
figure <A HREF="node7.html#fiexample1">4</A>. The client of class agent can both produce the data
objects and receive them after they have been handled by the process.
<PRE>  histogram* hc = new histogram(0,40,10,FREQUENCY,GRAPH,&quot;case lifetime&quot;);
  agent* client = new agent(OK, hc);
  client -&gt; duration(60.0, g, POISSON);
</PRE>
The first datahandler to receive data from the client is the <em> waitqueue</em>,
<em> w1</em>. The two histograms collect information about the length of the
queue and the waiting times. The waitqueue holds the data that it receives
until the first operation, <em> o1</em>, is ready to process it. Whether operation
<em> o1</em> is ready
depends on the availability of an employee to execute the operation. When <em>
o1</em> finishes it will pass its data on to waitqueue <em> w2</em> and pass a copy of
the data on to the other department, <em> otherdep</em>. This represents the
request for extra information that is needed later on in the process.
<PRE>  histogram* hw1a = new histogram(0,1,10,WEIGHTED,GRAPH,&quot;queue o1 length&quot;);
  histogram* hw1b = new histogram(0,10,10,FREQUENCY,GRAPH,&quot;queue o1 waiting&quot;);
  waitqueue* w1 = new waitqueue(hw1a, hw1b);

  operation* o1 = new operation(e);
  o1 -&gt; duration(10.0, g, NORMAL, 3.0);
</PRE>
The other department is created with its generate flag set to <em> FALSE</em>,
which is the default value. That way the -- non-generating -- agent will
simply pass the received data from <em> o1</em> on after a certain amount of time.
So, though in the real world the other department will pass some extra
information to the process under investigation, the simulation model will
simply pass the copy via <em> otherdep</em> to <em> w2</em>.
<PRE>  agent* otherdep = new agent(); 
  otherdep -&gt; duration(120.0, g, NORMAL, 60.0);
</PRE>
The next waitqueue, <em> w2</em>, needs to know it has two incoming data flows, 
so it can hold the original data until the copy has arrived, or the other way 
round. It will know it has two incoming flows, because two objects will have 
their successor datahandler set to <em> w2</em>. See below where the process 
structure is specified.
<PRE>  histogram* hw2a = new histogram(0,1,10,WEIGHTED,GRAPH,&quot;queue o2 length&quot;);
  histogram* hw2b = new histogram(0,30,10,FREQUENCY,GRAPH,&quot;queue o2 waiting&quot;);
  waitqueue* w2 = new waitqueue(hw2a, hw2b);
</PRE>
Finally, operation 2 and 3, <em> o2</em> and <em> o3</em>, are created.
<PRE>  operation* o2 = new operation(e);
  o2 -&gt; duration(20.0, g, NORMAL, 6.0);

  operation* o3 = new operation(e);
  o3 -&gt; duration(30.0, g, NORMAL, 10.0);
</PRE>
Now the process structure can be specified by means of the <em> next</em>
members.
<PRE>  client -&gt; next(w1);
  w1 -&gt; next(o1);
  o1 -&gt; next(w2, otherdep);
  otherdep -&gt; next(w2);
  w2 -&gt; next(o2);
  o2 -&gt; next(o3);
  o3 -&gt; next(client);
</PRE>
And the simulation is run for 10.000 generated data objects. After
finishing the simulation run, the results are printed to standard output.
See for an example the next section.
<PRE>  sim -&gt; run(10000);
 
  exit(0);
}
</PRE>
<P>
Note that to construct this -- simple -- processmodel only the constructors and
the member functions <em> duration</em> and <em> next</em> are needed.
<P>
<BR> <HR><A NAME=tex2html246 HREF="node9.html"><IMG ALIGN=BOTTOM ALT="next" SRC="http://www.cs.vu.nl/images/latex2html//next_motif.gif"></A>   <A NAME=tex2html244 HREF="node6.html"><IMG ALIGN=BOTTOM ALT="up" SRC="http://www.cs.vu.nl/images/latex2html//up_motif.gif"></A>   <A NAME=tex2html238 HREF="node7.html"><IMG ALIGN=BOTTOM ALT="previous" SRC="http://www.cs.vu.nl/images/latex2html//previous_motif.gif"></A>   <A NAME=tex2html248 HREF="node1.html"><IMG ALIGN=BOTTOM ALT="contents" SRC="http://www.cs.vu.nl/images/latex2html//contents_motif.gif"></A>   <A NAME=tex2html249 HREF="node27.html"><IMG ALIGN=BOTTOM ALT="index" SRC="http://www.cs.vu.nl/images/latex2html//index_motif.gif"></A>   <BR>
<B> Next:</B> <A NAME=tex2html247 HREF="node9.html"> Some results</A>
<B>Up:</B> <A NAME=tex2html245 HREF="node6.html"> Program structure</A>
<B> Previous:</B> <A NAME=tex2html239 HREF="node7.html"> Example process</A>
<BR> <HR> <P>
<BR> <HR>
<P><ADDRESS>
<I>A Eliens <BR>
Mon Jun  1 11:51:50 MET DST 1998</I>
</ADDRESS>
</BODY>
