<!DOCTYPE HTML PUBLIC "-//W3O//DTD W3 HTML 2.0//EN">
<!Converted with LaTeX2HTML 95.1 (Fri Jan 20 1995) by Nikos Drakos (nikos@cbl.leeds.ac.uk), CBLU, University of Leeds >
<HEAD>
<TITLE> Defining the implementation</TITLE>
</HEAD>
<BODY>
<meta name="description" value=" Defining the implementation">
<meta name="keywords" value="class-adt-www">
<meta name="resource-type" value="document">
<meta name="distribution" value="global">
<P>
 <BR> <HR><A NAME=tex2html53 HREF="node5.html"><IMG ALIGN=BOTTOM ALT="next" SRC="http://www.cs.vu.nl/images/latex2html//next_motif.gif"></A>   <A NAME=tex2html51 HREF="class-adt-www.html"><IMG ALIGN=BOTTOM ALT="up" SRC="http://www.cs.vu.nl/images/latex2html//up_motif.gif"></A>   <A NAME=tex2html45 HREF="node3.html"><IMG ALIGN=BOTTOM ALT="previous" SRC="http://www.cs.vu.nl/images/latex2html//previous_motif.gif"></A>         <BR>
<B> Next:</B> <A NAME=tex2html54 HREF="node5.html"> Some notes</A>
<B>Up:</B> <A NAME=tex2html52 HREF="class-adt-www.html">From Modula-2 ADT's to </A>
<B> Previous:</B> <A NAME=tex2html46 HREF="node3.html"> Defining the interface</A>
<BR> <HR> <P>
<H1><A NAME=SECTION00040000000000000000> Defining the implementation</A></H1>
<P>
In Modula-2, the implementation of the stack class could look like:
<P>
<PRE>IMPLEMENTATION MODULE IntStacks;
(* IntStacks; array implementation *)

FROM  Storage IMPORT
    Available,
    Allocate, Deallocate;

CONST 
    MaxSize      = 10;

TYPE 
    IntStack         = POINTER TO IntStackInstance;
    IntStackInstance = RECORD
                           top  : CARDINAL [0..MaxSize];
                           stack: ARRAY [1..MaxSize] OF INTEGER;
                       END;

PROCEDURE Push(VAR S: IntStack; e: INTEGER);
BEGIN
    WITH S^ DO
        INC(top);
        stack[top] := e
    END
END Push;

PROCEDURE Pop(VAR S: IntStack; VAR e: INTEGER);
BEGIN
    WITH S^ DO
        e := stack[top];
        DEC(top)
    END
END Pop;

PROCEDURE Empty(S: IntStack): BOOLEAN;
BEGIN
    RETURN (S^.top = 0)
END Empty;

PROCEDURE Full(S: IntStack): BOOLEAN;
BEGIN
    RETURN (S^.top = MaxSize)
END Full;

PROCEDURE Create(VAR S: IntStack): BOOLEAN;
BEGIN
    IF Available(SIZE(IntStackInstance)) THEN
        Allocate(S, SIZE(IntStackInstance));
        S^.top := 0;
        RETURN TRUE
    ELSE
        RETURN FALSE
    END
END Create;

PROCEDURE Terminate(VAR S: IntStack);
BEGIN
    Deallocate(S, SIZE(IntStackInstance));
END Terminate;

END IntStacks.
</PRE>
<P>
In C++, the implementation could look like:
<P>
<PRE>// intstack.cc

#include &quot;intstack.h&quot;

const int maxsize = 10;

intstack::intstack()
{
    top_ = 0;
    stack_ = new int[maxsize];
}

intstack::~intstack()
{
    top_ = 0;
    delete[] stack_;
}

void intstack::push(int element)
{
    stack_[top_] = element;
    top_++;
}

void intstack::pop(int&amp; element)
{
    top_--;
    element = stack_[top_];
}

bool intstack::empty()
{
    return (top_ == 0);
}

bool intstack::full()
{
    return (top_ == maxsize);
}
</PRE>
<P>
The <code>#include &quot;intstack.h&quot;</code> is needed because a class has to be defined
before the implementation can be understood by the compiler.
The rest of the implementation is just C++ code.
<P>
Any program that wants to use the stack class, has to include the header
file in the source and has to link in the object file of the stack
implementation.
<P>
<BR> <HR>
<UL> 
<LI> <A NAME=tex2html55 HREF="node5.html#SECTION00041000000000000000"> Some notes</A>
</UL>
<BR> <HR>
<P><ADDRESS>
<I>SE Praktikum <BR>
Tue Aug 13 13:10:22 MET DST 1996</I>
</ADDRESS>
</BODY>
