<!DOCTYPE HTML PUBLIC "-//W3O//DTD W3 HTML 2.0//EN">
<!Converted with LaTeX2HTML 95.1 (Fri Jan 20 1995) by Nikos Drakos (nikos@cbl.leeds.ac.uk), CBLU, University of Leeds >
<HEAD>
<TITLE> Using assertions</TITLE>
</HEAD>
<BODY>
<meta name="description" value=" Using assertions">
<meta name="keywords" value="debug">
<meta name="resource-type" value="document">
<meta name="distribution" value="global">
<P>
 <BR> <HR><A NAME=tex2html182 HREF="node15.html"><IMG ALIGN=BOTTOM ALT="next" SRC="http://www.cs.vu.nl/images/latex2html//next_motif.gif"></A>   <A NAME=tex2html180 HREF="node9.html"><IMG ALIGN=BOTTOM ALT="up" SRC="http://www.cs.vu.nl/images/latex2html//up_motif.gif"></A>   <A NAME=tex2html174 HREF="node13.html"><IMG ALIGN=BOTTOM ALT="previous" SRC="http://www.cs.vu.nl/images/latex2html//previous_motif.gif"></A>         <BR>
<B> Next:</B> <A NAME=tex2html183 HREF="node15.html"> Isolating the bug</A>
<B>Up:</B> <A NAME=tex2html181 HREF="node9.html"> Debugging a compiled </A>
<B> Previous:</B> <A NAME=tex2html175 HREF="node13.html"> Producing debug-output</A>
<BR> <HR> <P>
<H2><A NAME=SECTION00035000000000000000> Using assertions</A></H2>
<P>
Another possibility is to insert <em>assertions</em> in your code that check
if the assumptions of your code are valid. An example:
<PRE>#include &lt;assert.h&gt;

int mydivision(int numerator, int divisor)
{
    assert(divisor != 0);

    return numerator / divisor;
}
</PRE>
If <em>divisor</em> is not equal to 0, the assert will do nothing, but when
<em>divisor</em> is 0 for some reason, the program will halt with a message
like:
<PRE>assertion.cc:8: failed assertion `divisor != 0'
IOT trap - core dumped
</PRE>
This can be very useful while debugging, but asserting every assumption in
your code will require a huge amount of asserts and furthermore, it can be
argued that it will <em>not</em> result in robust programs; a program that
halts as soon as something is wrong can not be said to be very robust.
<P>
<BR> <HR>
<P><ADDRESS>
<I>SE Praktikum <BR>
Tue Aug 13 11:13:23 MET DST 1996</I>
</ADDRESS>
</BODY>
