<!DOCTYPE HTML PUBLIC "-//W3O//DTD W3 HTML 2.0//EN">
<!Converted with LaTeX2HTML 95.1 (Fri Jan 20 1995) by Nikos Drakos (nikos@cbl.leeds.ac.uk), CBLU, University of Leeds >
<HEAD>
<TITLE> Memory faults</TITLE>
</HEAD>
<BODY>
<meta name="description" value=" Memory faults">
<meta name="keywords" value="debug">
<meta name="resource-type" value="document">
<meta name="distribution" value="global">
<P>
 <BR> <HR><A NAME=tex2html215 HREF="node18.html"><IMG ALIGN=BOTTOM ALT="next" SRC="http://www.cs.vu.nl/images/latex2html//next_motif.gif"></A>   <A NAME=tex2html213 HREF="node16.html"><IMG ALIGN=BOTTOM ALT="up" SRC="http://www.cs.vu.nl/images/latex2html//up_motif.gif"></A>   <A NAME=tex2html207 HREF="node16.html"><IMG ALIGN=BOTTOM ALT="previous" SRC="http://www.cs.vu.nl/images/latex2html//previous_motif.gif"></A>         <BR>
<B> Next:</B> <A NAME=tex2html216 HREF="node18.html"> Debugginga core </A>
<B>Up:</B> <A NAME=tex2html214 HREF="node16.html"> Using a debugger</A>
<B> Previous:</B> <A NAME=tex2html208 HREF="node16.html"> Using a debugger</A>
<BR> <HR> <P>
<H3><A NAME=SECTION00037100000000000000> Memory faults</A></H3>
<P>
A memory fault occurs when a program is trying to
read from or write to memory that does not belong to that program. A
standard example is reading/writing address 0 (ie. a NULL-pointer), this
will always result in a memory fault. A debugger can catch a memory
fault and is therefore a useful tool to quickly
determine where in your program the memory fault occurs.
<P>
Suppose we have a very small program (<code>bug.c</code>) with a (obvious) bug:
<PRE>/* simple buggy program to demonstrate GDB */

#include &lt;stdio.h&gt;


void printptr(int* iptr)
{
    printf(&quot;%d\n&quot;, *iptr);
}


int main()
{
    int a = 5;
    int* ptr = 0;

    printptr(&amp;a);
    printptr(ptr);
}
</PRE>
After compiling and running, it will generate a memory fault:
<PRE>$ gcc -o bug bug.c
$ bug
5
Memory fault - core dumped
$
</PRE>
How to find the bug with a debugger? First, make sure the executable
contains debug
information. This is done by providing some special flag (<code>-g</code>) 
to the compiler: <BR> 
<PRE>$ gcc -g -o bug bug.c
</PRE>
Next, run the debugger with the executable as argument:
<PRE>$ gdb bug
GDB is free software and you are welcome to distribute copies of it
 under certain conditions; type &quot;show copying&quot; to see the conditions.
There is absolutely no warranty for GDB; type &quot;show warranty&quot; for details.
GDB 4.13 (sparc-sun-solaris2.3), 
Copyright 1994 Free Software Foundation, Inc...
(gdb)
</PRE>
<code>(gdb)</code> is the prompt of the debugger; you have to type the commands
you want to give at the prompt.
<P>
Now tell the debugger to run the loaded program:
<PRE>(gdb) run
Starting program: /home/se/doc/debug/source/bug 
5
 
Program received signal SIGSEGV, Segmentation fault.
0x106b4 in printptr (iptr=0x0) at bug.c:8
8           printf(&quot;%d\n&quot;, *iptr);
(gdb)
</PRE>
The debugger stops at the offending instruction, here 
<code>printf(&quot;%d\n&quot;, *iptr);</code>. It states in which function the statement
resides and with what arguments that function was called. It's immediately
clear what the problem is: iptr is a null-pointer. This can be verified by
telling the debugger to print the value of iptr:
<PRE>(gdb) print iptr
$1 = (int *) 0x0
(gdb)
</PRE>
<P>
When the offending statement is in some function that's deeply nested, it
can be useful to know the calling sequence from main to the that
function. This is done by giving the command <code>backtrace</code> (abbreviated
to <code>bt</code>):
<PRE>(gdb) bt
#0  0x106b4 in printptr (iptr=0x0) at bug.c:8
#1  0x106f4 in main () at bug.c:18
(gdb)
</PRE>
<P>
<BR> <HR>
<P><ADDRESS>
<I>SE Praktikum <BR>
Tue Aug 13 11:13:23 MET DST 1996</I>
</ADDRESS>
</BODY>
