<!DOCTYPE HTML PUBLIC "-//W3O//DTD W3 HTML 2.0//EN">
<!Converted with LaTeX2HTML 95.1 (Fri Jan 20 1995) by Nikos Drakos (nikos@cbl.leeds.ac.uk), CBLU, University of Leeds >
<HEAD>
<TITLE> C/C++</TITLE>
</HEAD>
<BODY>
<meta name="description" value=" C/C++">
<meta name="keywords" value="debug">
<meta name="resource-type" value="document">
<meta name="distribution" value="global">
<P>
 <BR> <HR><A NAME=tex2html74 HREF="node5.html"><IMG ALIGN=BOTTOM ALT="next" SRC="http://www.cs.vu.nl/images/latex2html//next_motif.gif"></A>   <A NAME=tex2html72 HREF="node3.html"><IMG ALIGN=BOTTOM ALT="up" SRC="http://www.cs.vu.nl/images/latex2html//up_motif.gif"></A>   <A NAME=tex2html66 HREF="node3.html"><IMG ALIGN=BOTTOM ALT="previous" SRC="http://www.cs.vu.nl/images/latex2html//previous_motif.gif"></A>         <BR>
<B> Next:</B> <A NAME=tex2html75 HREF="node5.html"> C++</A>
<B>Up:</B> <A NAME=tex2html73 HREF="node3.html"> Syntactic mistakes</A>
<B> Previous:</B> <A NAME=tex2html67 HREF="node3.html"> Syntactic mistakes</A>
<BR> <HR> <P>
<H3><A NAME=SECTION00021100000000000000> C/C++</A></H3>
<P>
<UL><LI> Forgetting a semicolon at the end of the line. Can cause various strange
compile errors.
<P>
<LI> Putting a semicolon after the function header of the implementation of
a function:
<PRE>void foo();
{
    cout &lt;&lt; &quot;foo&quot; &lt;&lt; endl;
}
</PRE>
This will result in an error like
<code>test.cc:2: parse error before `{'</code>.
<P>
<LI> Forgetting to terminate a string constant, for example
<PRE>void foo()
{
    cout &lt;&lt; &quot;hello world! &lt;&lt; endl;
}
</PRE>
This will result in an error like
<PRE>string.cc:5: unterminated string or character constant
string.cc:5: possible real start of unterminated constant
</PRE>
<P>
<LI> No <code>;</code> at the end of an enum/union/struct definition. Can result
in lots of compile errors.
<P>
<LI> Entering too many or too few <code>(</code>, <code>)</code>, <code>{</code> or <code>}</code>.
This will also produce lots of compiler errors.
A possible solution is using an editor with the ability to match <code>()</code>
and <code>{}</code>, like vi and emacs.
<P>
<LI> Recursive including of <code>.h</code> files. Will generate an error like <BR> 
<code>header.h:1: macro or `#include' recursion too deep</code>. <BR> 
Solution: put the
contents of each header file between a <code>#ifndef</code> command, like <BR> 
 <BR> 
<code>#ifndef _</code><em>filename</em><code>_H_</code> <BR> 
<code>#define _</code><em>filename</em><code>_H_</code> <BR> 
   : <BR> 
contents of .h file <BR> 
   : <BR> 
<code>#endif</code>
<P>
<LI> Including a header file multiple times. This can sometimes lead to
warnings or errors. Solution: same as with recursive including.
<P>
<LI> Defining functions without an explicit return type. Functions and
variables that are declared without a type default to <code>int</code>, not to
<code>void</code>.
<P>
<LI> Defining functions and implementing them with some other return type.
For example defining a function in a header file like this:
<PRE>    int the_answer();
</PRE>
and implementing it like this:
<PRE>    unsigned int the_answer()
    {
        return 42;
    }
</PRE>
This will result in an error like:
<PRE>return.c:10: conflicting types for `the_answer'
return.c:5: previous declaration of `the_answer'
</PRE>
The solution is to make the two return types the same.
<P>
</UL><BR> <HR>
<P><ADDRESS>
<I>SE Praktikum <BR>
Tue Aug 13 11:13:23 MET DST 1996</I>
</ADDRESS>
</BODY>
