<!DOCTYPE HTML PUBLIC "-//W3O//DTD W3 HTML 2.0//EN">
<!Converted with LaTeX2HTML 95.1 (Fri Jan 20 1995) by Nikos Drakos (nikos@cbl.leeds.ac.uk), CBLU, University of Leeds >
<HEAD>
<TITLE> C++</TITLE>
</HEAD>
<BODY>
<meta name="description" value=" C++">
<meta name="keywords" value="debug">
<meta name="resource-type" value="document">
<meta name="distribution" value="global">
<P>
 <BR> <HR><A NAME=tex2html110 HREF="node9.html"><IMG ALIGN=BOTTOM ALT="next" SRC="http://www.cs.vu.nl/images/latex2html//next_motif.gif"></A>   <A NAME=tex2html108 HREF="node6.html"><IMG ALIGN=BOTTOM ALT="up" SRC="http://www.cs.vu.nl/images/latex2html//up_motif.gif"></A>   <A NAME=tex2html104 HREF="node7.html"><IMG ALIGN=BOTTOM ALT="previous" SRC="http://www.cs.vu.nl/images/latex2html//previous_motif.gif"></A>         <BR>
<B> Next:</B> <A NAME=tex2html111 HREF="node9.html"> Debugging a compiled </A>
<B>Up:</B> <A NAME=tex2html109 HREF="node6.html"> Semantic errors</A>
<B> Previous:</B> <A NAME=tex2html105 HREF="node7.html"> C/C++</A>
<BR> <HR> <P>
<H3><A NAME=SECTION00022200000000000000> C++</A></H3>
<P>
<UL><LI> Not making a member function virtual when it should be. This will
result in always calling the member function of the superclass.
<P>
<LI> Not making a destructor virtual when using polymorphism, for example:
<PRE>#include &lt;stream.h&gt;

class A
{
public:
    A() { cout &lt;&lt; &quot;A::A()&quot; &lt;&lt; endl; }
    ~A() { cout &lt;&lt; &quot;A::~A()&quot; &lt;&lt; endl; }
};

class B: public A
{
public:
    B() { cout &lt;&lt; &quot;B::B()&quot; &lt;&lt; endl; }
    ~B() { cout &lt;&lt; &quot;B::~B()&quot; &lt;&lt; endl; }
};

int main()
{
    A* a = new B;
    delete a;
}
</PRE>
will result in:
<PRE>A::A()
B::B()
A::~A()
</PRE>
When class B needs to do something in its destructor (for example cleaning
up some variables), this is definitely not what you want. Declaring <code>~A</code>
as virtual will result in:
<PRE>A::A()
B::B()
B::~B()
A::~A()
</PRE>
<P>
<LI> Hiding a member variable in a member function. For example
<P>
<PRE>class A
{
public:
    A() { int i = 3; }
    int geti() { return i; }

private:
    int i;
};
</PRE>
<P>
When an instance of class <code>A</code> is initialized, calling <code>geti</code> will
most certainly <em>not</em> return 3, since it's not the member variable
<code>i</code> that is set in the constructor, but a <em>local</em> variable
<code>i</code>. Declaring a variable <code>int i</code> will hide the member variable
<code>i</code>. A solution to this is to append or prepend an underscore
'<code>_</code>' to each member variable and only to member variables; <code>i_</code>
will not clash with <code>i</code>.
<P>
<LI> Forgetting to initialize an object-pointer. This may have strange
effects: as long as no member variables are accessed, everything will be ok:
<P>
<PRE>#include &lt;stream.h&gt;

class A
{
public:
    void func1() { cout &lt;&lt; &quot;A::func1, no problem&quot; &lt;&lt; endl; }
    void func2(int newa) { a = newa; }
private:
    int a;
};

int main()
{
    A* aptr = 0;

    aptr -&gt; func1();
    aptr -&gt; func2(27);

    return 0;
}
</PRE>
<P>
When the program is run, the output will be:
<PRE>A::func1, no problem
Memory fault - core dumped
</PRE>
<P>
The example shown here is bit more extreme than just not initializing; the
object-pointer is a NULL-pointer. When the initialization of <b>aptr</b>
to 0 is removed, the resulting behaviour is unpredictable; the program may
or may not crash, depending on the value of the uninitialized pointer.
<P>
The solution to this problem is to <em>always</em> initialize object-pointers.
If an object-pointer can not have a `decent' value (an allocated object)
assigned to it, assign 0 to it; this will at least detect unauthorized
access to the object-pointer.
<P>
</UL><BR> <HR>
<P><ADDRESS>
<I>SE Praktikum <BR>
Tue Aug 13 11:13:23 MET DST 1996</I>
</ADDRESS>
</BODY>
