<!DOCTYPE HTML PUBLIC "-//IETF//DTD HTML 3.0//EN">
 <title>Class definition of the fileselector</title>
   <h2>Class definition of the fileselector</h2>
   <p>Author: martijn, bastiaan, jrvosse
   <i>Warning: This fileselector may change your applications current working 
   directory!</i>
   <ignore><pre class=program lang="C++">
  #ifndef HUSH_FILECHOOSER_H
  #define HUSH_FILECHOOSER_H

  </pre> </ignore><pre class=program lang="C++">
  #include &lt;hush/bool.h&gt; 
  #include &lt;widgets/widgets.h&gt; <i class=comment>// We need al lot of widgets </i>
  class fileselector: public frame {
    public:
      <i class=comment>// Typical hush stuff:</i>
      char* type() const { return "fileselector"; }
      fileselector(const char *p, const char* options="", 
                                          int istop=true);  <i class=comment>// make widget</i>
      fileselector(const widget* w, const char *p, 
                  const char* options="", int istop=true);  <i class=comment>// make widget</i>
      fileselector();             <i class=comment>// make handler for tcl command "filechooser"</i>
      virtual ~fileselector();            <i class=comment>// destruct C++ object (not window!)</i>
      virtual int operator()();           <i class=comment>// handle events</i>
      <i class=comment>// Typical fileselector stuff:</i>
      virtual void mask(const char *m);   <i class=comment>// set filename mask (default "*")</i>
      virtual const char* mask() const;   <i class=comment>// get    ,,      ,,</i>
      virtual int dirpath(const char* path); <i class=comment>// set current dir path</i>
      virtual const char* dirpath() const ;  <i class=comment>// get current dir</i>
      virtual void rescan();              <i class=comment>// rescan & display current dir</i>
      virtual const char* get();          <i class=comment>// get (and wait for) filename</i>
                                          <i class=comment>// returns 0 on cancel</i>
    protected:    <i class=comment>// Derived classes can redefine these: </i>
      virtual widget* create(int argc, char* argv[]);     <i class=comment>// create new widget</i>
      virtual void build_gui(widget* top, const char* opts =""); <i class=comment>// set up GUI</i>
      virtual void bindings();                            <i class=comment>// install bindings</i>
      virtual void options(const char* opts);             <i class=comment>// process options</i>
      virtual int usage(const char* msg) const;           <i class=comment>// print usage</i>
      
    private:      <i class=comment>// I hate to have this private stuff in my header files:</i>
      listbox *_listbox;
      button  *_okbutton,  *_cancelbutton;
      entry   *_fileentry, *_maskentry, *_pathentry;
      char    _filename[100], _pathname[100], _mask[100];
  };

  </pre><ignore>
  #endif
  </ignore>
  