<!DOCTYPE HTML PUBLIC "-//W3O//DTD W3 HTML 2.0//EN">
<!Converted with LaTeX2HTML 95.1 (Fri Jan 20 1995) by Nikos Drakos (nikos@cbl.leeds.ac.uk), CBLU, University of Leeds >
<HEAD>
<TITLE> Unordered lists</TITLE>
</HEAD>
<BODY>
<meta name="description" value=" Unordered lists">
<meta name="keywords" value="hushadts-www">
<meta name="resource-type" value="document">
<meta name="distribution" value="global">
<P>
 <BR> <HR><A NAME=tex2html47 HREF="node5.html"><IMG ALIGN=BOTTOM ALT="next" SRC="http://www.cs.vu.nl/images/latex2html//next_motif.gif"></A>   <A NAME=tex2html45 HREF="hushadts-www.html"><IMG ALIGN=BOTTOM ALT="up" SRC="http://www.cs.vu.nl/images/latex2html//up_motif.gif"></A>   <A NAME=tex2html39 HREF="node3.html"><IMG ALIGN=BOTTOM ALT="previous" SRC="http://www.cs.vu.nl/images/latex2html//previous_motif.gif"></A>         <BR>
<B> Next:</B> <A NAME=tex2html48 HREF="node5.html"> Ordered lists</A>
<B>Up:</B> <A NAME=tex2html46 HREF="hushadts-www.html">Using the hush ADT's</A>
<B> Previous:</B> <A NAME=tex2html40 HREF="node3.html"> Iterators</A>
<BR> <HR> <P>
<H1><A NAME=SECTION00030000000000000000> Unordered lists</A></H1>
<P>
The example:
<P>
<PRE>// list.cc
// Example of use of list

#include &lt;hush/list.h&gt;
#include &lt;iostream.h&gt;


// ALWAYS pass complex value parameters with const&amp; !
void printlist(const list&lt;int&gt;&amp; l)
{
    iter&lt;int&gt; listiter = l;             // see explanation in main
    int* intptr = 0;

    while (intptr = listiter())
    {
        cout &lt;&lt; *intptr &lt;&lt; &quot; &quot;;
    }
    cout &lt;&lt; endl;
}


int main()
{
    list&lt;int&gt; l1;                       // create an empty list of ints
    int i1 = 27, i2 = 3, i3 = 81;       // some integers

    cout &lt;&lt; &quot;length of l1 is &quot; &lt;&lt; l1.length() &lt;&lt; endl;
                                        // retrieving the length of a list

// insert some elements
    l1.insert(&amp;i1);                     // IMPORTANT: list stores only
                                        // POINTERS to elements, so something
                                        // like l1.insert(3) won't work!
                                        // see the effect of this later on
    l1.insert(&amp;i2);
    l1.insert(&amp;i3);

    cout &lt;&lt; &quot;length of l1 is &quot; &lt;&lt; l1.length() &lt;&lt; endl;

// now we will iterate over the whole list:
    iter&lt;int&gt; listiter = l1;            // create an iterator for a list, more
                                        // specifically, an iterator for our
                                        // created list
    int* intptr = 0;                    // this POINTER to an integer will
                                        // be used for the iteration
    while (intptr = listiter())
    {
        cout &lt;&lt; &quot;item = &quot; &lt;&lt; *intptr &lt;&lt; endl;
    }

    cout &lt;&lt; &quot;2nd element of l1 = &quot; &lt;&lt; *(l1[1]) &lt;&lt; endl;
                                        // retrieving an element by index

// an example of datastructure sharing between lists:
    list&lt;int&gt; l2 = l1;                  // creates an alias of l1

    printlist(l2);

    int* eltptr = l2.head();            // retrieve the first element
    *eltptr = 7;                        // change it
    printlist(l2);                      // of course, l2 has changed, but
    printlist(l1);                      // the elements in l1 have changed too!

// since lists only store POINTERS to elements, the elements that were added
// will be changed:
    cout &lt;&lt; &quot;i1 is now &quot; &lt;&lt; i1 &lt;&lt; endl;

// and vice versa:
    i2 = 128;
    printlist(l1);

// show effect of aliasing:
    l1.remove(l1.head());               // remove some elements
    l1.remove(l1.head());
    printlist(l1);                      // l1 is a lot shorter
    printlist(l2);                      // l2 changes too

    return 0;
}
</PRE>
<P>
<BR> <HR>
<P><ADDRESS>
<I>SE Praktikum <BR>
Tue Aug 13 13:18:42 MET DST 1996</I>
</ADDRESS>
</BODY>
