<!DOCTYPE HTML PUBLIC "-//W3O//DTD W3 HTML 2.0//EN">
<!Converted with LaTeX2HTML 95.1 (Fri Jan 20 1995) by Nikos Drakos (nikos@cbl.leeds.ac.uk), CBLU, University of Leeds >
<HEAD>
<TITLE> Ordered lists</TITLE>
</HEAD>
<BODY>
<meta name="description" value=" Ordered lists">
<meta name="keywords" value="hushadts-www">
<meta name="resource-type" value="document">
<meta name="distribution" value="global">
<P>
 <BR> <HR><A NAME=tex2html57 HREF="node6.html"><IMG ALIGN=BOTTOM ALT="next" SRC="http://www.cs.vu.nl/images/latex2html//next_motif.gif"></A>   <A NAME=tex2html55 HREF="hushadts-www.html"><IMG ALIGN=BOTTOM ALT="up" SRC="http://www.cs.vu.nl/images/latex2html//up_motif.gif"></A>   <A NAME=tex2html49 HREF="node4.html"><IMG ALIGN=BOTTOM ALT="previous" SRC="http://www.cs.vu.nl/images/latex2html//previous_motif.gif"></A>         <BR>
<B> Next:</B> <A NAME=tex2html58 HREF="node6.html"> Dictionaries</A>
<B>Up:</B> <A NAME=tex2html56 HREF="hushadts-www.html">Using the hush ADT's</A>
<B> Previous:</B> <A NAME=tex2html50 HREF="node4.html"> Unordered lists</A>
<BR> <HR> <P>
<H1><A NAME=SECTION00040000000000000000> Ordered lists</A></H1>
<P>
Ordered lists have the same member functions as unordered lists, but
elements are inserted in some (user-defined) order. Because some ordering is
required, you have to provide member functions to enforce an ordering
if you want to use your own elements in an ordered list. These functions are
<code>operator&lt;</code> and <code>operator==</code>. Some other `external' functions has
to be provided also to print an element to a stream, see the
<code>operator&lt;&lt;</code> in the example.
<P>
The example:
<P>
<PRE>// olist.cc

#include &lt;hush/list.h&gt;
#include &lt;iostream.h&gt;


// define our own class which can be used in the ordered list
class myclass
{
public:
    myclass(int i) { i_ = i; }
    int value() const { return i_; }
    int operator&lt;(const myclass&amp; m) const { return (i_ &lt; m.value()); }
    int operator==(const myclass&amp; m) const { return (i_ == m.value()); }

private:
    int i_;
};

// you MUST define a stream-operator for your own class (but it's only used
// when you evoke 'print' on an ordered list):
ostream&amp; operator&lt;&lt;(ostream&amp; os, const myclass&amp; mc)
{
    os &lt;&lt; mc.value();
    return os;
}

int main()
{
    myclass a(27), b(3), c(72);
    olist&lt;myclass&gt; l1;                  // create an ordered list with
                                        // elements of our own class

    l1.insert(&amp;a);                      // add elements in unsorted order
    l1.insert(&amp;b);
    l1.insert(&amp;c);

    iter&lt;myclass&gt; mciter = l1;
    myclass* mcptr = 0;

    while (mcptr = mciter())
    {
        cout &lt;&lt; &quot;item = &quot; &lt;&lt; mcptr -&gt; value() &lt;&lt; endl;
    }

    l1.print(cout);                     // print the entire list on cout,
                                        // great for debugging

    return 0;
}
</PRE>
<P>
<BR> <HR>
<P><ADDRESS>
<I>SE Praktikum <BR>
Tue Aug 13 13:18:42 MET DST 1996</I>
</ADDRESS>
</BODY>
