<!DOCTYPE HTML PUBLIC "-//W3O//DTD W3 HTML 2.0//EN">
<!Converted with LaTeX2HTML 95.1 (Fri Jan 20 1995) by Nikos Drakos (nikos@cbl.leeds.ac.uk), CBLU, University of Leeds >
<HEAD>
<TITLE> Dictionaries</TITLE>
</HEAD>
<BODY>
<meta name="description" value=" Dictionaries">
<meta name="keywords" value="hushadts-www">
<meta name="resource-type" value="document">
<meta name="distribution" value="global">
<P>
 <BR> <HR><A NAME=tex2html67 HREF="node7.html"><IMG ALIGN=BOTTOM ALT="next" SRC="http://www.cs.vu.nl/images/latex2html//next_motif.gif"></A>   <A NAME=tex2html65 HREF="hushadts-www.html"><IMG ALIGN=BOTTOM ALT="up" SRC="http://www.cs.vu.nl/images/latex2html//up_motif.gif"></A>   <A NAME=tex2html59 HREF="node5.html"><IMG ALIGN=BOTTOM ALT="previous" SRC="http://www.cs.vu.nl/images/latex2html//previous_motif.gif"></A>         <BR>
<B> Next:</B> <A NAME=tex2html68 HREF="node7.html">   About this document </A>
<B>Up:</B> <A NAME=tex2html66 HREF="hushadts-www.html">Using the hush ADT's</A>
<B> Previous:</B> <A NAME=tex2html60 HREF="node5.html"> Ordered lists</A>
<BR> <HR> <P>
<H1><A NAME=SECTION00050000000000000000> Dictionaries</A></H1>
<P>
A dictionary is a mapping between strings (<code>char*</code>) and some
(user-defined) type. An instance of a type is stored with a string as
`index' and retrieved with that string. Dictionaries are very handy for
storing objects by tags. The example should speak for itself.
<P>
The example:
<P>
<PRE>// dictionary.cc

#include &lt;hush/dictionary.h&gt;
#include &lt;hush/string.h&gt;
#include &lt;iostream.h&gt;

// define our own class which can be used in the dictionary
class myclass
{
public:
    myclass(int i) { i_ = i; }
    int value() const { return i_; }

private:
    int i_;
};


int main()
{
    myclass a(27), b(3), c(72);         // create some instances of myclass

    dictionary&lt;myclass&gt; dict;           // create an empty dictionary that
                                        // will contain instances of myclass

// store some objects (only POINTERS are stored!)
    dict[&quot;foo&quot;] = &amp;a;
    dict[&quot;bar&quot;] = &amp;b;
    dict[&quot;cow&quot;] = &amp;c;

    if (!dict[&quot;apple&quot;]) 
        cout &lt;&lt; &quot;no such thing&quot; &lt;&lt; endl;

    dict[&quot;apple&quot;] = &amp;c;
    dict[&quot;car&quot;]   = &amp;b;
    dict[&quot;event&quot;] = &amp;a;

    myclass* mcptr1 = dict[&quot;foo&quot;];
    myclass* mcptr2 = dict[&quot;bar&quot;];

// retrieve some objects by name:
    cout &lt;&lt; &quot;foo: &quot; &lt;&lt; mcptr1 -&gt; value() &lt;&lt; endl;
    cout &lt;&lt; &quot;bar: &quot; &lt;&lt; mcptr2 -&gt; value() &lt;&lt; endl;

// print the complete dictionary:
    iter&lt;string&gt; it = dict;             // create an iterator over strings
    string* strptr = 0;                 // pointer to myclass for iteration
    myclass* mcptr = 0;

    while(strptr = it())
    {
        mcptr = dict[*strptr];
        cout &lt;&lt; *strptr &lt;&lt; &quot; = &quot; &lt;&lt; mcptr -&gt; value() &lt;&lt; endl;
    }

    return 0;
}
</PRE>
<P>
<BR> <HR>
<P><ADDRESS>
<I>SE Praktikum <BR>
Tue Aug 13 13:18:42 MET DST 1996</I>
</ADDRESS>
</BODY>
