<!DOCTYPE HTML PUBLIC "-//W3O//DTD W3 HTML 2.0//EN">
<!Converted with LaTeX2HTML 95.1 (Fri Jan 20 1995) by Nikos Drakos (nikos@cbl.leeds.ac.uk), CBLU, University of Leeds >
<HEAD>
<TITLE> Introduction</TITLE>
</HEAD>
<BODY>
<meta name="description" value=" Introduction">
<meta name="keywords" value="make">
<meta name="resource-type" value="document">
<meta name="distribution" value="global">
<P>
 <BR> <HR><A NAME=tex2html49 HREF="node2.html"><IMG ALIGN=BOTTOM ALT="next" SRC="http://www.cs.vu.nl/images/latex2html//next_motif.gif"></A>   <A NAME=tex2html47 HREF="make.html"><IMG ALIGN=BOTTOM ALT="up" SRC="http://www.cs.vu.nl/images/latex2html//up_motif.gif"></A>   <A NAME=tex2html41 HREF="make.html"><IMG ALIGN=BOTTOM ALT="previous" SRC="http://www.cs.vu.nl/images/latex2html//previous_motif.gif"></A>         <BR>
<B> Next:</B> <A NAME=tex2html50 HREF="node2.html"> What you need </A>
<B>Up:</B> <A NAME=tex2html48 HREF="make.html">How to make a </A>
<B> Previous:</B> <A NAME=tex2html42 HREF="make.html">How to make a </A>
<BR> <HR> <P>
<H1><A NAME=SECTION00010000000000000000> Introduction</A></H1>
<P>
Large programs usually consist of several components, structured in a
modular way.
A module has an interface part and an implementation part.
Modern languages like C, C++ and Modula-2 provide mechanisms to specify the
interface of a module in one file and its implementation in another file.
If module B is built upon module A, i.e. uses functions exported by module A,
module B merely needs to import module A's interface, but not its
implementation.
<P>
Compiling a large program costs a lot of time.
Fortunately, each module can be compiled separately.
The advantage is that we merely have to recompile module A if we change
something to the <em> implementation</em> of module A, other modules need not be
recompiled.
This can save a lot of time.
If we change something to the <em> interface</em> of module A, we have to
recompile all modules that use the interface of module A.
<P>
Each module's implementation is compiled to a so called <em> object file</em>.
An object file contains a.o. binary machine instructions for the functions
that are exported by the module.
All object files that form a program must be linked together to create an
<em> executable</em>.
The executable can be loaded into the computer's memory and executed.
<P>
<i> Make</i> helps us to keep the object files and executables up to date.
We describe in a <code>Makefile</code> how the modules are built upon each other,
and how we can generate the object files from the source files, and the
executable from the object files.
Each time we type ``<code>make</code>'', <i> make</i> checks whether the executable
and object files exist, and if they do exist, it checks the timestamps
of the files to see if they are still up to date with respect to the sources.
If this is not the case, <i> make</i> concludes that the sources have been
changed since the last time the programmer typed ``<code>make</code>'', and it takes
the appropriate actions to recompile the necessary modules, and link the
objects to a new executable.
<P>
Another very important advantage of using a <code>Makefile</code> is that it
eases the distribution of your program.
Somebody who wants to recompile your program on his system merely needs to
type ``<code>make</code>'', and an executable is generated that can be run
on his or her system.
<P>
<BR> <HR><A NAME=tex2html49 HREF="node2.html"><IMG ALIGN=BOTTOM ALT="next" SRC="http://www.cs.vu.nl/images/latex2html//next_motif.gif"></A>   <A NAME=tex2html47 HREF="make.html"><IMG ALIGN=BOTTOM ALT="up" SRC="http://www.cs.vu.nl/images/latex2html//up_motif.gif"></A>   <A NAME=tex2html41 HREF="make.html"><IMG ALIGN=BOTTOM ALT="previous" SRC="http://www.cs.vu.nl/images/latex2html//previous_motif.gif"></A>         <BR>
<B> Next:</B> <A NAME=tex2html50 HREF="node2.html"> What you need </A>
<B>Up:</B> <A NAME=tex2html48 HREF="make.html">How to make a </A>
<B> Previous:</B> <A NAME=tex2html42 HREF="make.html">How to make a </A>
<BR> <HR> <P>
<BR> <HR>
<P><ADDRESS>
<I>Megens SA <BR>
Thu Jun 20 11:26:28 MET DST 1996</I>
</ADDRESS>
</BODY>
