<!DOCTYPE HTML PUBLIC "-//W3O//DTD W3 HTML 2.0//EN">
<!Converted with LaTeX2HTML 95.1 (Fri Jan 20 1995) by Nikos Drakos (nikos@cbl.leeds.ac.uk), CBLU, University of Leeds >
<HEAD>
<TITLE> Let make do the work</TITLE>
</HEAD>
<BODY>
<meta name="description" value=" Let make do the work">
<meta name="keywords" value="make">
<meta name="resource-type" value="document">
<meta name="distribution" value="global">
<P>
 <BR> <HR><A NAME=tex2html150 HREF="node11.html"><IMG ALIGN=BOTTOM ALT="next" SRC="http://www.cs.vu.nl/images/latex2html//next_motif.gif"></A>   <A NAME=tex2html148 HREF="node7.html"><IMG ALIGN=BOTTOM ALT="up" SRC="http://www.cs.vu.nl/images/latex2html//up_motif.gif"></A>   <A NAME=tex2html142 HREF="node9.html"><IMG ALIGN=BOTTOM ALT="previous" SRC="http://www.cs.vu.nl/images/latex2html//previous_motif.gif"></A>         <BR>
<B> Next:</B> <A NAME=tex2html151 HREF="node11.html"> Using macro's</A>
<B>Up:</B> <A NAME=tex2html149 HREF="node7.html"> A simple Makefile</A>
<B> Previous:</B> <A NAME=tex2html143 HREF="node9.html"> Finding the dependencies</A>
<BR> <HR> <P>
<H2><A NAME=SECTION00033000000000000000> Let make do the work</A></H2>
<P>
We can automate this process by writing a <code>Makefile</code> for our program.
A sample <code>Makefile</code> is shown in Figure <A HREF="node10.html#Makefile1">7</A>.
<P>
<P><A NAME=232>&#160;</A><A NAME=Makefile1>&#160;</A><IMG  ALIGN=BOTTOM ALT="" SRC="img15.gif">
<BR><STRONG>Figure 7:</STRONG> An example <tt> Makefile</tt>.<BR>
<P>
<P>
 This <code>Makefile</code> is very simple.
Three <b>rules</b> are shown for the files that must be generated.
Each file name at the left hand side of a colon is called a <b>target</b>;
after the colon the target's <b>dependencies</b> are specified.
<i>Make</i> rebuilds a target whenever it does not exist or when it is
out-of-date with respect to one of its dependencies.
For example, after we rewrote our <code>my_math.c</code> implementation,
<code>my_math.o</code> and <code>facfib</code> are out-of-date with respect to
<code>my_math.c</code>.
<P>
Rebuilding is done according to the <b> commands</b> that are specified on the
subsequent lines.
Note that a command must start with a TAB character, and not with a SPACE.
The order in which entries appear is unimportant, except that <i> make</i>
builds the first target (in this case <code>facfib</code>) if no target is
specified on the command line.
So always write the rule that builds the executable of your program as
first rule. Multiple commands may span consecutive lines; the command line is
terminated by a blank line. A line that is terminated by a backslash ('<BR> ')
character is continued on the next line.
<P>
Dependencies are checked <em>recursively</em>.
A dependency might be target of another entry.
So is <code>my_math.o</code> both dependency in the first rule and target in the
second rule.
Before <i>make</i> decides whether or not to update <code>facfib</code>, it
checks if it is necessary to update <code>my_math.o</code> and <code>main.o</code>.
<P>
After entering the <code>Makefile</code>, we can run <i> make</i> to generate
an executable named <code>facfib</code>.
Unless we tell <i> make</i> to be silent, <i> make</i> tells what it is doing.
Let us see what happens if we simply type ``<code>make</code>'' (after deleting
<code>my_math.o</code>, <code>main.o</code> and <code>facfib</code>).
<P>
 
<PRE>$ make
gcc -c -O2 -ansi -pedantic -Wall my_math.c
gcc -c -O2 -ansi -pedantic -Wall main.c
gcc my_math.o main.o
$ make
make: `facfib' is up to date.
$ touch my_math.c
$ make
gcc -c -O2 -ansi -pedantic -Wall my_math.c
gcc my_math.o main.o
$
</PRE>
 
<P>
The first time we run <i> make</i>, it builds the targets as specified by
the rules.
The second time, <i> make</i> responds that <code>facfib</code> is up to date.
If we touch (i.e. modify) <code>my_math.c</code> and rerun <i> make</i>, it decides to
rebuild the targets <code>my_math.o</code> and <code>facfib</code>.
<P>
<BR> <HR><A NAME=tex2html150 HREF="node11.html"><IMG ALIGN=BOTTOM ALT="next" SRC="http://www.cs.vu.nl/images/latex2html//next_motif.gif"></A>   <A NAME=tex2html148 HREF="node7.html"><IMG ALIGN=BOTTOM ALT="up" SRC="http://www.cs.vu.nl/images/latex2html//up_motif.gif"></A>   <A NAME=tex2html142 HREF="node9.html"><IMG ALIGN=BOTTOM ALT="previous" SRC="http://www.cs.vu.nl/images/latex2html//previous_motif.gif"></A>         <BR>
<B> Next:</B> <A NAME=tex2html151 HREF="node11.html"> Using macro's</A>
<B>Up:</B> <A NAME=tex2html149 HREF="node7.html"> A simple Makefile</A>
<B> Previous:</B> <A NAME=tex2html143 HREF="node9.html"> Finding the dependencies</A>
<BR> <HR> <P>
<BR> <HR>
<P><ADDRESS>
<I>Megens SA <BR>
Thu Jun 20 11:26:28 MET DST 1996</I>
</ADDRESS>
</BODY>
