<!DOCTYPE HTML PUBLIC "-//W3O//DTD W3 HTML 2.0//EN">
<!Converted with LaTeX2HTML 95.1 (Fri Jan 20 1995) by Nikos Drakos (nikos@cbl.leeds.ac.uk), CBLU, University of Leeds >
<HEAD>
<TITLE> Generating dependencies</TITLE>
</HEAD>
<BODY>
<meta name="description" value=" Generating dependencies">
<meta name="keywords" value="make">
<meta name="resource-type" value="document">
<meta name="distribution" value="global">
<P>
 <BR> <HR><A NAME=tex2html218 HREF="node18.html"><IMG ALIGN=BOTTOM ALT="next" SRC="http://www.cs.vu.nl/images/latex2html//next_motif.gif"></A>   <A NAME=tex2html216 HREF="make.html"><IMG ALIGN=BOTTOM ALT="up" SRC="http://www.cs.vu.nl/images/latex2html//up_motif.gif"></A>   <A NAME=tex2html210 HREF="node16.html"><IMG ALIGN=BOTTOM ALT="previous" SRC="http://www.cs.vu.nl/images/latex2html//previous_motif.gif"></A>         <BR>
<B> Next:</B> <A NAME=tex2html219 HREF="node18.html"> Useful to know </A>
<B>Up:</B> <A NAME=tex2html217 HREF="make.html">How to make a </A>
<B> Previous:</B> <A NAME=tex2html211 HREF="node16.html"> Compilation failures</A>
<BR> <HR> <P>
<H1><A NAME=SECTION00040000000000000000> Generating dependencies</A></H1>
<P>
The last few lines in figure <A HREF="node12.html#Makefile4">10</A> were used to declare
the dependencies.
For programs with less than five source files, this is manageable, but
for larger programs it is not.
Each time the <code>#include</code> structure of a program changes, the
dependencies change and the
<code>Makefile</code> has to be changed by hand, which is a nuisance for the
programmer and extremely error-prone.
<P>
Basically, there are a number of  ways to automate the process of keeping
dependencies up to date. The one most easy to use (although not very
flexible) will be explained in this section.
There is a tool <code>makedepend</code> that automatically updates the dependencies
in our <code>Makefile</code>.
<P>
<P><A NAME=237>&#160;</A><A NAME=makedepend>&#160;</A><IMG  ALIGN=BOTTOM ALT="" SRC="img20.gif">
<BR><STRONG>Figure 12:</STRONG> A modified <tt> Makefile</tt> that uses <tt> makedepend</tt>.<BR>
<P>
<P>
In Figure <A HREF="node17.html#makedepend">12</A> we specify another target <code>depend</code> and
omit the hand written dependencies at the bottom lines.
If the user types <code>make depend</code>, the program <code>makedepend</code>
runs the preprocessor to find out which dependencies exists for each object
file.
It keeps a copy of our original <code>Makefile</code> in <code>Makefile.bak</code>
and appends the dependencies to our <code>Makefile</code>.
Each time we change our <code>#include</code> structure, we should run
``<code>make depend</code>'' prior to doing a plain ``<code>make</code>''.
An example of what is appended is shown in Figure <A HREF="node17.html#appended">13</A>.
<P>
<P><A NAME=238>&#160;</A><A NAME=appended>&#160;</A><IMG  ALIGN=BOTTOM ALT="" SRC="img21.gif">
<BR><STRONG>Figure 13:</STRONG> A modified <tt> Makefile</tt> that uses <tt> makedepend</tt>.<BR>
<P><BR> <HR>
<P><ADDRESS>
<I>Megens SA <BR>
Thu Jun 20 11:26:28 MET DST 1996</I>
</ADDRESS>
</BODY>
