<!DOCTYPE HTML PUBLIC "-//W3O//DTD W3 HTML 2.0//EN">
<!Converted with LaTeX2HTML 95.1 (Fri Jan 20 1995) by Nikos Drakos (nikos@cbl.leeds.ac.uk), CBLU, University of Leeds >
<HEAD>
<TITLE> Doing it all by hand</TITLE>
</HEAD>
<BODY>
<meta name="description" value=" Doing it all by hand">
<meta name="keywords" value="make">
<meta name="resource-type" value="document">
<meta name="distribution" value="global">
<P>
 <BR> <HR><A NAME=tex2html130 HREF="node9.html"><IMG ALIGN=BOTTOM ALT="next" SRC="http://www.cs.vu.nl/images/latex2html//next_motif.gif"></A>   <A NAME=tex2html128 HREF="node7.html"><IMG ALIGN=BOTTOM ALT="up" SRC="http://www.cs.vu.nl/images/latex2html//up_motif.gif"></A>   <A NAME=tex2html122 HREF="node7.html"><IMG ALIGN=BOTTOM ALT="previous" SRC="http://www.cs.vu.nl/images/latex2html//previous_motif.gif"></A>         <BR>
<B> Next:</B> <A NAME=tex2html131 HREF="node9.html"> Finding the dependencies</A>
<B>Up:</B> <A NAME=tex2html129 HREF="node7.html"> A simple Makefile</A>
<B> Previous:</B> <A NAME=tex2html123 HREF="node7.html"> A simple Makefile</A>
<BR> <HR> <P>
<H2><A NAME=SECTION00031000000000000000> Doing it all by hand</A></H2>
<P>
Suppose we want to write a module <i> my_math</i> that exports the functions
<tt> fac()</tt> and <tt> fib()</tt> to compute the faculty and the fibonacci number.
We write an interface for <i> my_math</i> in the file <code>my_math.h</code>,
as shown in Figure <A HREF="node8.html#my_mathh">2</A>.
<P>
<P><A NAME=227>&#160;</A><A NAME=my_mathh>&#160;</A><IMG  ALIGN=BOTTOM ALT="" SRC="img9.gif">
<BR><STRONG>Figure 2:</STRONG> <tt> my_math.h</tt>: interface of the module <i> my_math</i>.<BR>
<P>
<P>
It is a good habit to protect all the declarations in a <code>.h</code> file 
by <code>#ifndef</code> constructs.
Now this file can be included as often as a user wants, without having
the compiler complain about illegal redeclarations.
<P>
After we defined an interface for the module, we implement the functions
in <code>my_math.c</code> (see Figure <A HREF="node8.html#my_mathc">3</A>).
<P>
<P><A NAME=228>&#160;</A><A NAME=my_mathc>&#160;</A><IMG  ALIGN=BOTTOM ALT="" SRC="img10.gif">
<BR><STRONG>Figure 3:</STRONG> <tt> my_math.c</tt>: implementation of the module <i> my_math</i>.<BR>
<P>
<P>
Now we want to write a program that reads unsigned integers, and prints
its faculty and fibonacci number, until we read something other than a
number.
We write a separate implementation for this in <code>main.c</code>.
<code>main.c</code> includes <code>my_math.h</code>, the interface of the module
<i> my_math</i>.
<P>
<P><A NAME=229>&#160;</A><IMG  ALIGN=BOTTOM ALT="" SRC="img11.gif">
<BR><STRONG>Figure 4:</STRONG> <tt> main.c</tt>: main routine.<BR>
<P>
<P>
To compile the program, we need an ANSI-C compiler, e.g. <code>gcc</code>.
We can compile the program with the following command line:
<P>
 
<PRE>$ gcc -O2 -ansi -pedantic -Wall main.c my_math.c -o facfib
$
</PRE>
 
<P>
 This produces a file <code>facfib</code> which can be executed directly.
The default name of an executable is <code>a.out</code>, but it can be overridden
by specifing <code>-o</code> <i> file</i>.
<P>
We can also compile the modules separately.
The <code>-c</code> flag tells the compiler to generate an object file, and then
stop.
<P>
 
<PRE>$ gcc -O2 -ansi -pedantic -Wall -c main.c
$ gcc -O2 -ansi -pedantic -Wall -c my_math.c
$ gcc main.o my_math.o -o facfib
$
</PRE>
 
<P>
The first command tells <code>gcc</code> to create <code>main.o</code>, the second
command creates <code>my_math.o</code> and the last command links the two
files to create the executable <code>facfib</code>.
<P>
<BR> <HR>
<P><ADDRESS>
<I>Megens SA <BR>
Thu Jun 20 11:26:28 MET DST 1996</I>
</ADDRESS>
</BODY>
