<!DOCTYPE HTML PUBLIC "-//W3O//DTD W3 HTML 2.0//EN">
<!Converted with LaTeX2HTML 95.1 (Fri Jan 20 1995) by Nikos Drakos (nikos@cbl.leeds.ac.uk), CBLU, University of Leeds >
<HEAD>
<TITLE> Finding the dependencies</TITLE>
</HEAD>
<BODY>
<meta name="description" value=" Finding the dependencies">
<meta name="keywords" value="make">
<meta name="resource-type" value="document">
<meta name="distribution" value="global">
<P>
 <BR> <HR><A NAME=tex2html140 HREF="node10.html"><IMG ALIGN=BOTTOM ALT="next" SRC="http://www.cs.vu.nl/images/latex2html//next_motif.gif"></A>   <A NAME=tex2html138 HREF="node7.html"><IMG ALIGN=BOTTOM ALT="up" SRC="http://www.cs.vu.nl/images/latex2html//up_motif.gif"></A>   <A NAME=tex2html132 HREF="node8.html"><IMG ALIGN=BOTTOM ALT="previous" SRC="http://www.cs.vu.nl/images/latex2html//previous_motif.gif"></A>         <BR>
<B> Next:</B> <A NAME=tex2html141 HREF="node10.html"> Let make do </A>
<B>Up:</B> <A NAME=tex2html139 HREF="node7.html"> A simple Makefile</A>
<B> Previous:</B> <A NAME=tex2html133 HREF="node8.html"> Doing it all </A>
<BR> <HR> <P>
<H2><A NAME=SECTION00032000000000000000> Finding the dependencies</A></H2>
<P>
Now assume that we want to change the implementation of the faculty and
fibonacci functions so that the computations are done iteratively instead
of recursively.
<P>
<P><A NAME=230>&#160;</A><IMG  ALIGN=BOTTOM ALT="" SRC="img12.gif">
<BR><STRONG>Figure 5:</STRONG> <tt> my_math.c</tt>: iterative implementation of the module
<i> my_math</i>.<BR>
<P>
<P>
 Now we want to compile as few source files as possible.
We therefore draw a dependency graph as shown in Figure <A HREF="node9.html#Dependency">6</A>.
<P>
<P><A NAME=114>&#160;</A><A NAME=Dependency>&#160;</A><IMG  ALIGN=BOTTOM ALT="" SRC="img13.gif">
<BR><STRONG>Figure 6:</STRONG> Dependencies in our example.  White boxes are source files, black
boxes are generated files.<BR>
<P>
<P>
 The dependency graph shows which file should be regenerated
if one or more header or implementation files change.
It matches the <code>#include</code> structure of our program very closely.
Only the <code>#include &lt;stdio.h&gt;</code> is omitted, as is the dependency
<code>a.out</code> <IMG  ALIGN=BOTTOM ALT="" SRC="img14.gif"> <code>libc.a</code>, while we assume that the standard
library and include files seldom change.
<P>
From the graph we derive that changing <code>my_math.c</code> affects
<code>my_math.o</code> and <code>facfib</code>.
We therefore have to recompile <code>my_math.c</code> and relink the object
files.
It is not necessary to recompile <code>main.c</code>, because <code>main.o</code>
does not depend on <code>my_math.c</code>.
We can do this manually by typing:
<P>
 
<PRE>$ gcc -O2 -ansi -pedantic -Wall -c my_math.c
$ gcc main.o my_math.o -o facfib
$
</PRE>
 
<P>
<BR> <HR>
<P><ADDRESS>
<I>Megens SA <BR>
Thu Jun 20 11:26:28 MET DST 1996</I>
</ADDRESS>
</BODY>
