<!DOCTYPE HTML PUBLIC "-//W3O//DTD W3 HTML 2.0//EN">
<!Converted with LaTeX2HTML 95.1 (Fri Jan 20 1995) by Nikos Drakos (nikos@cbl.leeds.ac.uk), CBLU, University of Leeds >
<HEAD>
<TITLE> Option-parameters</TITLE>
</HEAD>
<BODY>
<meta name="description" value=" Option-parameters">
<meta name="keywords" value="packer">
<meta name="resource-type" value="document">
<meta name="distribution" value="global">
<P>
 <BR> <HR><A NAME=tex2html38 HREF="node4.html"><IMG ALIGN=BOTTOM ALT="next" SRC="http://www.cs.vu.nl/images/latex2html//next_motif.gif"></A>   <A NAME=tex2html36 HREF="packer.html"><IMG ALIGN=BOTTOM ALT="up" SRC="http://www.cs.vu.nl/images/latex2html//up_motif.gif"></A>   <A NAME=tex2html30 HREF="node2.html"><IMG ALIGN=BOTTOM ALT="previous" SRC="http://www.cs.vu.nl/images/latex2html//previous_motif.gif"></A>         <BR>
<B> Next:</B> <A NAME=tex2html39 HREF="node4.html"> Using frames</A>
<B>Up:</B> <A NAME=tex2html37 HREF="packer.html">The Tk Packer</A>
<B> Previous:</B> <A NAME=tex2html31 HREF="node2.html"> Some basics</A>
<BR> <HR> <P>
<H1><A NAME=SECTION00030000000000000000> Option-parameters</A></H1>
<P>
Parameters can be passed to pack-functions for changing the way widgets are
packed. One example of this is the parameter '-side XXX', as shown in the
examples above. This parameter will tell on which side of the remaining 
rectangle a smaller rectangle will contain the new widget. Possible sides
are 'top', 'bottom', 'left' and 'right'.
<P>
Furthermore, a '-fill' parameter can be passed. This parameter tells the
packer to expand the widget if pieces of the rectangle are not filled by the
widget.
Some examples:
<P>
Without any filling:
<P>
<IMG  ALIGN=BOTTOM ALT="" SRC="img5.gif">
<P>
With '-fill x':
<P>
<IMG  ALIGN=BOTTOM ALT="" SRC="img6.gif">
<P>
With '-fill y':
<P>
<IMG  ALIGN=BOTTOM ALT="" SRC="img7.gif">
<P>
With '-fill both':
<P>
<IMG  ALIGN=BOTTOM ALT="" SRC="img8.gif">
<P>
Another parameter is '-expand'. This parameter is similar to '-fill'.
The difference between '-expand' en '-fill' becomes clear when some small
wish-scripts are executed. Wish should be started anew for every script.
<P>
Script 1:
<P>
<PRE>button .b1 -text hi
button .b2 -text helloworld
pack .b1 ; pack .b2
</PRE>
<P>
After the script is executed, there are two buttons in the wish-window.
The upper button is a lot smaller than the lower one. Resizing the window
has a limited effect: when the window is broadened, the buttons will shift to
the middle of the window; when the window is heightened, the buttons will stay
where they are.
<P>
Script 2:
<P>
<PRE>button .b1 -text hi
button .b2 -text helloworld
pack .b1 -fill both ; pack .b2 -fill both
</PRE>
<P>
After the script has been executed, there are again two buttons in the 
wish-window,
but this time, both buttons have the same size. The Packer has filled the
upper button to contain the space that was left with script 1.
Resizing the window has a somewhat different effect: when the window is
broadened, the buttons will become as broad as the window; they will fill the
available space in the rectangle. When the window is heightened, the buttons
will not become any higher. This is because buttons are packed at the top
by default and the areas containing the buttons will not become larger when
the window is heightened; only the space that was left after the buttons were
packed will become larger:
<P>
<IMG  ALIGN=BOTTOM ALT="" SRC="img9.gif">
<P>
The strip of space left in the left part of the picture is not 
visible when the buttons are packed, but it <b>is</b> there.
<P>
Script 3:
<P>
<PRE>button .b1 -text hi
button .b2 -text helloworld
pack .b1 -expand true -fill both ; pack .b2 -expand true -fill both
</PRE>
<P>
The buttons are of the same proportions as with script 2. When the window is
resized now, the buttons will also grow in height. This is a result of
the expand parameter: if the available space is enlarged (even if everything
is already packed), widgets that are packed with '-expand true' will expand
to contain the added space.
<P>
Script 4:
<P>
<PRE>button .b1 -text hi
button .b2 -text helloworld
pack .b1 -expand true ; pack .b2 -expand true
</PRE>
<P>
The window now looks the same as after running script 1. Resizing the window
has a peculiar effect: the buttons will end up in the middle of the available
space. But because none of the buttons has been packed with a fill-parameter,
the buttons are not enlarged. The difference between expand en fill should
be clear now: 'expand' divides new available space between all widgets, 'fill'
makes the widgets grow to fill the available space.
<P>
<BR> <HR><A NAME=tex2html38 HREF="node4.html"><IMG ALIGN=BOTTOM ALT="next" SRC="http://www.cs.vu.nl/images/latex2html//next_motif.gif"></A>   <A NAME=tex2html36 HREF="packer.html"><IMG ALIGN=BOTTOM ALT="up" SRC="http://www.cs.vu.nl/images/latex2html//up_motif.gif"></A>   <A NAME=tex2html30 HREF="node2.html"><IMG ALIGN=BOTTOM ALT="previous" SRC="http://www.cs.vu.nl/images/latex2html//previous_motif.gif"></A>         <BR>
<B> Next:</B> <A NAME=tex2html39 HREF="node4.html"> Using frames</A>
<B>Up:</B> <A NAME=tex2html37 HREF="packer.html">The Tk Packer</A>
<B> Previous:</B> <A NAME=tex2html31 HREF="node2.html"> Some basics</A>
<BR> <HR> <P>
<BR> <HR>
<P><ADDRESS>
<I>Megens SA <BR>
Thu Jun 20 11:34:42 MET DST 1996</I>
</ADDRESS>
</BODY>
