<!DOCTYPE HTML PUBLIC "-//W3O//DTD W3 HTML 2.0//EN">
<!Converted with LaTeX2HTML 95.1 (Fri Jan 20 1995) by Nikos Drakos (nikos@cbl.leeds.ac.uk), CBLU, University of Leeds >
<HEAD>
<TITLE> Adding some functionality</TITLE>
</HEAD>
<BODY>
<meta name="description" value=" Adding some functionality">
<meta name="keywords" value="prototyping-www">
<meta name="resource-type" value="document">
<meta name="distribution" value="global">
<P>
 <BR> <HR><A NAME=tex2html333 HREF="node28.html"><IMG ALIGN=BOTTOM ALT="next" SRC="http://www.cs.vu.nl/images/latex2html//next_motif.gif"></A>   <A NAME=tex2html331 HREF="node23.html"><IMG ALIGN=BOTTOM ALT="up" SRC="http://www.cs.vu.nl/images/latex2html//up_motif.gif"></A>   <A NAME=tex2html325 HREF="node26.html"><IMG ALIGN=BOTTOM ALT="previous" SRC="http://www.cs.vu.nl/images/latex2html//previous_motif.gif"></A>         <BR>
<B> Next:</B> <A NAME=tex2html334 HREF="node28.html"> Building the interface</A>
<B>Up:</B> <A NAME=tex2html332 HREF="node23.html"> Building the interface</A>
<B> Previous:</B> <A NAME=tex2html326 HREF="node26.html"> The basic interface</A>
<BR> <HR> <P>
<H2><A NAME=SECTION00044000000000000000> Adding some functionality</A></H2>
<P>
The building blocks of the interface are now in place, but it would be nice
if some basic behavior can be specified; for example, we would like to see
the scrollbar in action or be able to make a real selection from the list.
<P>
With the final file-selector (of which this is the prototype), files can be
selected in two ways. The first way is to select a file from the list and
click <b>OK</b>, the second is to enter a filename in the entry-box and click
'OK'. If <b>CANCEL</b> is chosen, nothing should be selected. When either
button is pressed, the file-selector should vanish. In the prototype, when
<b>OK</b> is pressed, the selected file will be printed on stdout, so we
can check if the file-selector is functioning properly.
<P>
Since this is a prototype, it doesn't really matter if we create a real list
of files or make one up. The first is certainly not impossible in Tcl, but
for simplicity's sake, we'll take the latter approach. First, we associate
the scrollbar with the listbox and vise versa:
<P>
<PRE>.fileselect.files.scrolly configure -command {.fileselect.files.list yview}
.fileselect.files.list configure -yscrollcommand \
    {.fileselect.files.scrolly set}
</PRE>
<P>
The first command tells Tcl that if the scrollbar is changed (for example by
clicking on one of the arrows), that the changes are passed to the listbox,
which will then update its contents.
The second command states that if the contents of the listbox are scrolled
up or down, the change should be reflected by the position of the slider.
<P>
Next, some data is added to the listbox:
<P>
<PRE>.fileselect.files.list 999 file0
.fileselect.files.list 999 file1
  :
.fileselect.files.list 999 file18
.fileselect.files.list 999 file19
</PRE>
<P>
The listbox now shows a list of 20 filenames and the contents of this
listbox can be scrolled by using the scrollbar.
<P>
We now define the procedures that are called when a button is pressed:
<P>
<PRE>proc do_ok {} {
    if [expr [ llength [ .fileselect.files.list curselection ] ] &gt; 0 ] then \
    { \
        puts [ .fileselect.files.list get \
                [ .fileselect.files.list curselection ] ] \
    } \
    else \
    { \
        puts [ .fileselect.entry get ] \
    }
    destroy .fileselect
}

proc do_cancel {} {
    puts &quot;File selection canceled&quot;
    destroy .fileselect
}
</PRE>
<P>
The first procedure should be called when the <b>OK</b> button is pressed.
It checks if there is some selection made in the listbox and if there is,
prints the selected item. It there is no selection made, the contents of the
entry are printed. Either way, the file-selector window is removed.
The second procedure should be called when the <b>CANCEL</b> button is
pressed. It just prints a message that the selection is canceled and
destroys the window.
<P>
These procedures can now be bound to the buttons:
<P>
<PRE>.fileselect.buttons.ok configure -command do_ok
.fileselect.buttons.cancel configure -command do_cancel
</PRE>
<P>
This will complete the file-selector. Of course, the final version must have
much more functionality, but this is only a prototype; it shows how the
file-selector will 'look and feel'. See figure <A HREF="node27.html#figFileselector">8</A> for the
'look'. The final script can be found in
<code>/home/se/doc/tcltk/source/fileselector.tcl</code>.
<P>
<P><A NAME=179>&#160;</A><A NAME=figFileselector>&#160;</A><IMG  ALIGN=BOTTOM ALT="" SRC="img8.gif">
<BR><STRONG>Figure 8:</STRONG> The file-selector prototype in action<BR>
<P><BR> <HR><A NAME=tex2html333 HREF="node28.html"><IMG ALIGN=BOTTOM ALT="next" SRC="http://www.cs.vu.nl/images/latex2html//next_motif.gif"></A>   <A NAME=tex2html331 HREF="node23.html"><IMG ALIGN=BOTTOM ALT="up" SRC="http://www.cs.vu.nl/images/latex2html//up_motif.gif"></A>   <A NAME=tex2html325 HREF="node26.html"><IMG ALIGN=BOTTOM ALT="previous" SRC="http://www.cs.vu.nl/images/latex2html//previous_motif.gif"></A>         <BR>
<B> Next:</B> <A NAME=tex2html334 HREF="node28.html"> Building the interface</A>
<B>Up:</B> <A NAME=tex2html332 HREF="node23.html"> Building the interface</A>
<B> Previous:</B> <A NAME=tex2html326 HREF="node26.html"> The basic interface</A>
<BR> <HR> <P>
<BR> <HR>
<P><ADDRESS>
<I>SE Praktikum <BR>
Tue Aug 13 13:33:30 MET DST 1996</I>
</ADDRESS>
</BODY>
