<!DOCTYPE HTML PUBLIC "-//W3O//DTD W3 HTML 2.0//EN">
<!Converted with LaTeX2HTML 95.1 (Fri Jan 20 1995) by Nikos Drakos (nikos@cbl.leeds.ac.uk), CBLU, University of Leeds >
<HEAD>
<TITLE> Control flow</TITLE>
</HEAD>
<BODY>
<meta name="description" value=" Control flow">
<meta name="keywords" value="prototyping-www">
<meta name="resource-type" value="document">
<meta name="distribution" value="global">
<P>
 <BR> <HR><A NAME=tex2html142 HREF="node10.html"><IMG ALIGN=BOTTOM ALT="next" SRC="http://www.cs.vu.nl/images/latex2html//next_motif.gif"></A>   <A NAME=tex2html140 HREF="node2.html"><IMG ALIGN=BOTTOM ALT="up" SRC="http://www.cs.vu.nl/images/latex2html//up_motif.gif"></A>   <A NAME=tex2html134 HREF="node8.html"><IMG ALIGN=BOTTOM ALT="previous" SRC="http://www.cs.vu.nl/images/latex2html//previous_motif.gif"></A>         <BR>
<B> Next:</B> <A NAME=tex2html143 HREF="node10.html"> Executing Tcl-source</A>
<B>Up:</B> <A NAME=tex2html141 HREF="node2.html"> An introduction to </A>
<B> Previous:</B> <A NAME=tex2html135 HREF="node8.html"> Procedures</A>
<BR> <HR> <P>
<H2><A NAME=SECTION00027000000000000000> Control flow</A></H2>
<P>
The most commonly used control flow constructs of Tcl:
<P>
<DL ><DT><DD> <b>break</b> <BR> 
    Abort innermost containing loop command.
<DT><DD> <b>continue</b> <BR> 
    Skip to the next iteration of innermost containing loop command.
<DT><DD> <b>exit</b> [ <i>returnCode</i> ] <BR> 
    Terminate the process, returning <i>returnCode</i> (an integer which
    defaults to 0) to the system as the exit status.
<DT><DD> <b>for</b> <i>start test next body</i> <BR> 
    Looping command where <i>start</i>, <i>next</i>, and <i>body</i>
    are Tcl command strings and test is an expression string to be passed to
    <b>expr</b> command. <BR> 
    Example: <BR> 
    <code>  for {set i 0} {$i &lt; 10} {incr i} {puts $i}</code> <BR> 
    (This example makes use of <em>deferred substitution</em>; everything
    between {} is passed unsubstituted to the <b>for</b> command.)
<DT><DD> <b>if</b> <i>expr1</i> <b>then</b> <i>body1</i> [
    <b>elsif</b> <i>expr2</i> <b>then</b> <i>body2</i> ... ] [
    <b>else</b> <i>body2</i> ] <BR> 
    If expression string <i>exptr1</i> evaluates to true, Tcl command
    string <i>body1</i> is evaluated. Otherwise if <i>expr2</i> is true,
    <i>body2</i> is evaluated, and so on. If none of the expressions
    evaluate to true then <i>bodyN</i> is executed. <BR> 
    Example: <BR> 
    <code>  if [expr $i == 27] then {puts &quot;i = 27&quot;} else {puts &quot;i != 27&quot;}</code>
<DT><DD> <b>return</b> [<i>string</i>] <BR> 
    Return immediately from current procedure with <i>string</i> as return
    value.
<DT><DD> <b>while</b> <i>test body</i> <BR> 
    Evaluates the Tcl command string <i>body</i> as long as the expression
    string <i>test</i> evaluates to true. <BR> 
    Example: <BR> 
    <code>  set i 0</code><BR> 
    <code>  while {$i &lt; 10} {incr i; puts $i}</code> <BR> 
    (This is another example of using deferred substitution.)
<P>
 </DL><BR> <HR>
<P><ADDRESS>
<I>SE Praktikum <BR>
Tue Aug 13 13:33:30 MET DST 1996</I>
</ADDRESS>
</BODY>
