<!doctype html public "-//W3C//DTD HTML 3.2//EN">
<title>SE documentation</title>

<h1 align=center>SE Documentation</h1>

<DL>
<DT><a href = "class-adt/class-adt-www.html">
    From Modula-2 ADT's to C++ classes</a> 
<DD> The step from Modula-2 to C++ is a rather big one. One important part
     of this step is applying your knowledge about abstract data types
     learned in Modula-2 to C++. This document offers some clues on how
     you can apply that knowledge to create classes in C++ that act as
     ADT's.
     <br>
     The PostScript version can be found 
     <a href = "class-adt/class-adt.ps">here.</a>
<DT><a href = "debug/debug.html">
    Introduction to debugging a C/C++ program
    </a>
<DD> C and C++ are very sharp tools; when used correctly, they can be used
     to do good work. But as with all sharp tools, it's easy to cut
     yourself.  This document describes how to debug an application
     written in C or C++. Most of this document is not C/C++ specific, so
     the techniques described can be used with other languages as well.
     <br>
     The PostScript version can be found 
     <a href = "debug/debug.ps">here.</a>
<DT> <a href = "make/make.html"> How to make a Makefile </a>
<DD> <I>Make</I> is a program that is commonly used to build and maintain
     large programs.  Although very useful, it is not user-friendly.  This
     tutorial tries to explain how <I>make</I> works, and how to write a
     Makefile.
     <br>
     The PostScript version can be found 
     <a href = "make/make.ps">here.</a>
<DT> <a href = "prototyping/prototyping-www.html"> 
     Prototyping in Tcl/Tk </a>
<DD> This document gives an introduction to Tcl and Tk and will show how
     Tcl/Tk can be used for creating a simple prototype.
     <br>
     The PostScript version can be found 
     <a href = "prototyping/prototyping.ps">here.</a>
<DT> <a href = "packer/packer.html"> The Tk Packer </a>
<DD> Every time a pack-function in Hush is called, the Packer of the
     underlying Tk window toolkit is activated.  The Packer takes care of
     adding (child) widgets to other (parent) widgets.  How the Packer
     exactly functions is not very obvious at first sight.  This document
     tries to shed some light on the Packer.
     <br>
     The PostScript version can be found 
     <a href = "packer/packer.ps">here.</a>
<DT> <a href = "hushadts/hushadts-www.html"> 
     Using the hush ADT's </a>
<DD> This document explains the basic usage of the most useful hush
     ADT's: strings, lists and dictionaries. Every ADT is explained using an
     example that will show the usage of the most common member functions.  
     <br>
     The PostScript version can be found
     <a href = "hushadts/hushadts.ps">here.</a>
<DT> <a href = "fileselector/index.html">Fileselector - A Widget Cookbook</a>
<DD> 
     How to cook your own widget: an extensive example of a 
     fileselector widget.
     <br>
     The PostScript version can be found
     <a href = "fileselector/fileselector.ps">here.</a>
<DT> <a href = "garbage.html">Garbage - How to clean up your memory</a>
<DD> 
     Deleting objects allocated on the heap (with <tt>new</tt>) is a delicate
     issue... This tells you all about hush garbage collection, _register, etc. 
<DT> <a href = "checklist.html">Checklist - error checking</a>
<DD> 
     A list of frequently made errors. Use it!
</DL>
