// intstack.h

#ifndef _INTSTACK_H_
#define _INTSTACK_H_

class intstack
{
public:
    intstack();
        // post - The stack has been created, the stack is empty
    ~intstack();
        // post - The stack-pre does not exist

    void push(int e);
        // pre  - The stack is not full.
        // post - The stack includes e as its most recently arrived element.
    void pop(int& e);
        // pre  - The stack is not empty.
        // post - e is the most recently arrived element of the stack-pre;
        //        the stack no longer contains e.
    bool empty();
        // post - true : The stack has no elements.
        //        false: The stack has at least one element.
    bool full();
        // post - true : The stack has reached its bound.
        //        false: The stack can at least contain one more element.

private:
    int* stack_;
    int  top_;
};

#endif
