IMPLEMENTATION MODULE IntStacks;
(* IntStacks; array implementation *)

FROM  Storage IMPORT
    Available,
    Allocate, Deallocate;

CONST 
    MaxSize      = 10;

TYPE 
    IntStack         = POINTER TO IntStackInstance;
    IntStackInstance = RECORD
                           top  : CARDINAL [0..MaxSize];
                           stack: ARRAY [1..MaxSize] OF INTEGER;
                       END;

PROCEDURE Push(VAR S: IntStack; e: INTEGER);
BEGIN
    WITH S^ DO
        INC(top);
        stack[top] := e
    END
END Push;

PROCEDURE Pop(VAR S: IntStack; VAR e: INTEGER);
BEGIN
    WITH S^ DO
        e := stack[top];
        DEC(top)
    END
END Pop;

PROCEDURE Empty(S: IntStack): BOOLEAN;
BEGIN
    RETURN (S^.top = 0)
END Empty;

PROCEDURE Full(S: IntStack): BOOLEAN;
BEGIN
    RETURN (S^.top = MaxSize)
END Full;

PROCEDURE Create(VAR S: IntStack): BOOLEAN;
BEGIN
    IF Available(SIZE(IntStackInstance)) THEN
        Allocate(S, SIZE(IntStackInstance));
        S^.top := 0;
        RETURN TRUE
    ELSE
        RETURN FALSE
    END
END Create;

PROCEDURE Terminate(VAR S: IntStack);
BEGIN
    Deallocate(S, SIZE(IntStackInstance));
END Terminate;

END IntStacks.
