<title>The use of virtual functions in constructors</title>
<h1>The use of virtual functions in constructors</h1>
<p>
Be careful with the use of virtual functions in
constructors (ctors) and destructors (dtors).
<p>
The following program defines a base class and a derived class. 
The derived class redefines a virtual member function f.
This member is called by the ctor and dtor of the base class, and
by another memebr g of the base class.
<p>
The creation of an instance of the derived class will yield
a call to base::f() because no virtual table of the derived
object is created.

this yields:
     base::f         // f called by ctor of a
     derived::f      // f callled gy g member of a
     base::f         // f called by dtor of a

#include <iostream.h>
 
class base {
  public:
        base();
        virtual ~base();
        virtual void f();
        virtual void g();
};
 
class derived: public base {
  public:
        virtual void f();
};
 
base::base()            { f(); }
base::~base()           { f(); }
void base::g()          { f(); }
void base::f()          { cout << "base::f"     << endl; }
void derived::f()       { cout << "derived::f"  << endl; }
 
main() {
        derived d;
        d.g();
}

