// string.cc
// Example of use of class string

#include <hush/string.h>
#include <iostream.h>
#include <stdio.h>


int main() 
{
    char buf[128];                  // buffer used for sprintf
    string s1;                      // creating an empty string

    s1 = "hello world!";            // setting a string
    cout << "s1 = " << s1 << endl;  // printing a string

    sprintf(buf, "s1 as char*: %s", (char*) s1);    
                                    // casting to (char*) (can also
                                    // be done with (const char*))
    cout << buf << endl;

    string s2;                      // another empty string

    s2 = s1;                        // copying a string

    cout << "s1 = " << s1 << ", s2 = " << s2 << endl;

    cout << "length of s1 = " << s1.length() << endl;
                                    // retrieving the length of a string

    char ch = s1[5];
    cout << "the 6th character of s1 = " << ch << endl;
                                    // character indexing

    if (s1 == s2)                   // comparison between 2 strings
        cout << "s1 is equal to s2" << endl;
    else
        cout << "s1 is not equal to s2" << endl;

    if (s1 == "Hello World!!")      // comparison between string and char*
        cout << "s1 is equal to Hello World!!" << endl;
    else
        cout << "s1 is not equal to Hello World!!" << endl;

// suppose we got a list of something contained in a string:

    string stritems = "item1 item2 item3 item4 item5";

    cout << "stritems = " << stritems << endl;

// we can iterate over this list in the following way:

    stritems.split(" ");            // split the string in seperate substrings,
                                    // using ' ' (space) as separator
    cout << "stritems = " << stritems << endl;
                                    // string stays the same
    iter<string> striter = stritems;// create an itererator over strings, more
                                    // specifically, the list we just declared
    string* strptr = 0;             // IMPORTANT!!! this is A POINTER to a
                                    // string that will be used for iteration
    while (strptr = striter())
    {
        cout << "item: " << *strptr << endl;
    }

    return 0;
}
