<!DOCTYPE HTML PUBLIC "-//W3O//DTD W3 HTML 2.0//EN">
<!Converted with LaTeX2HTML 95.1 (Fri Jan 20 1995) by Nikos Drakos (nikos@cbl.leeds.ac.uk), CBLU, University of Leeds >
<HEAD>
<TITLE> The entity philosopher</TITLE>
</HEAD>
<BODY>
<meta name="description" value=" The entity philosopher">
<meta name="keywords" value="sim">
<meta name="resource-type" value="document">
<meta name="distribution" value="global">
<P>
 <BR> <HR><A NAME=tex2html241 HREF="node11.html"><IMG ALIGN=BOTTOM ALT="next" SRC="http://www.cs.vu.nl/images/latex2html//next_motif.gif"></A>   <A NAME=tex2html239 HREF="node9.html"><IMG ALIGN=BOTTOM ALT="up" SRC="http://www.cs.vu.nl/images/latex2html//up_motif.gif"></A>   <A NAME=tex2html233 HREF="node9.html"><IMG ALIGN=BOTTOM ALT="previous" SRC="http://www.cs.vu.nl/images/latex2html//previous_motif.gif"></A>   <A NAME=tex2html243 HREF="node1.html"><IMG ALIGN=BOTTOM ALT="contents" SRC="http://www.cs.vu.nl/images/latex2html//contents_motif.gif"></A>      <BR>
<B> Next:</B> <A NAME=tex2html242 HREF="node11.html"> The entity class</A>
<B>Up:</B> <A NAME=tex2html240 HREF="node9.html"> The process-oriented approach</A>
<B> Previous:</B> <A NAME=tex2html234 HREF="node9.html"> The process-oriented approach</A>
<BR> <HR> <P>
<H3><A NAME=SECTION00034100000000000000> The entity philosopher</A></H3>
<P>
Consider the following definition and implementation of the entity philosopher
<PRE> 
   enum {EATING,THINKING,WAITING};      // phases of a philosopher
  
   class philosopher : public entity
   {
   public :
     philosopher(int ph,int i);  // constructor, taking phase and id
     virtual int operator()();   // function operator
     int eat();                  // eat event
     int think();                // think event
     int await();                // await event
   private :
     int id;
     generator* g;
   };
  
   philosopher::philosopher(int ph,int i) : entity(ph)
   {
     id = i;                  // set phase and identity
     g = new generator(20,10,999);
   }
  
   int philosopher::operator()()
   {
     switch (phase())         // what phase is the philosopher in ?
     {
     case EATING :
       return eat();          // the philosopher eats
     case THINKING :
       return think();        // the philosopher thinks
     case WAITING :
       return await();        // the philosopher waits
     }
     return FALSE;
   }
  
   int philosopher::eat()
   {
     double t = g -&gt; exponential(eatingtime);    // determine eating time
     sim -&gt; wait(t);            // schedule this philosopher thinking
     phase(THINKING);                   // set phase to thinking
     return OK;
   }
  
   int philosopher::think()
   {
     chopstick[id] -&gt; release();            // release left chopstick
     chopstick[(id+1)%number] -&gt; release(); // release right
     double t = g -&gt; exponential(thinkingtime);   // determine thinking time
     thinking -&gt; sample(id,t/duration*100);       // sample (%)
     sim -&gt; wait(t);              // schedule this philosopher waiting
     phase(WAITING);                        // set phase on waiting
     return OK;
   }
 
   int philosopher::await()
   {
     if ( (chopstick[id] -&gt; available()) &amp;&amp;    // available ?
        (chopstick[(id+1)%number] -&gt; available()) )
     {
       chopstick[id] -&gt; acquire();          // acquire left chopstick
       chopstick[(id+1)%number] -&gt; acquire();      // acquire right
       sim -&gt; passivate(this);         // make passive
       sim -&gt; activate(this);          // activate as eating
       phase(EATING);                  // set phase on eating
     }
     else if (!conditional())       
       sim -&gt; hold(this);                  // add to conditional
     return OK;
   }
</PRE>
<P>
Dependent on the phase the philosopher is in, the appropriate action on the 
simulation environment is taken. These actions closely resemble the events, 
described in the event-based approach of this problem.
The main difference is in the use of <i> phase</i>. If, for example, a
philosopher finishes eating, his/her phase is set to THINKING and s/he is
scheduled after <i> t</i> time units, whereas in the event-based approach a 
think event is scheduled and the eat event is explicitly terminated.
So, in the process-oriented solution a philosopher exists for the entire
simulation. 
In the <i> session::main</i> function the simulation is set up by
scheduling the five philosophers, initially waiting, instead of
scheduling five <i> await</i> events.
<P>
<BR> <HR>
<P><ADDRESS>
<I>A Eliens <BR>
Tue Oct 31 09:27:21 MET 1995</I>
</ADDRESS>
</BODY>
