<!DOCTYPE HTML PUBLIC "-//W3O//DTD W3 HTML 2.0//EN">
<!Converted with LaTeX2HTML 95.1 (Fri Jan 20 1995) by Nikos Drakos (nikos@cbl.leeds.ac.uk), CBLU, University of Leeds >
<HEAD>
<TITLE> The simulation class</TITLE>
</HEAD>
<BODY>
<meta name="description" value=" The simulation class">
<meta name="keywords" value="sim">
<meta name="resource-type" value="document">
<meta name="distribution" value="global">
<P>
 <BR> <HR><A NAME=tex2html261 HREF="node13.html"><IMG ALIGN=BOTTOM ALT="next" SRC="http://www.cs.vu.nl/images/latex2html//next_motif.gif"></A>   <A NAME=tex2html259 HREF="node3.html"><IMG ALIGN=BOTTOM ALT="up" SRC="http://www.cs.vu.nl/images/latex2html//up_motif.gif"></A>   <A NAME=tex2html253 HREF="node11.html"><IMG ALIGN=BOTTOM ALT="previous" SRC="http://www.cs.vu.nl/images/latex2html//previous_motif.gif"></A>   <A NAME=tex2html263 HREF="node1.html"><IMG ALIGN=BOTTOM ALT="contents" SRC="http://www.cs.vu.nl/images/latex2html//contents_motif.gif"></A>      <BR>
<B> Next:</B> <A NAME=tex2html262 HREF="node13.html"> The generator class</A>
<B>Up:</B> <A NAME=tex2html260 HREF="node3.html"> Program structure</A>
<B> Previous:</B> <A NAME=tex2html254 HREF="node11.html"> The entity class</A>
<BR> <HR> <P>
<H2><A NAME=SECTION00035000000000000000> The simulation class</A></H2>
<P>
The primitives and methods for running and ending the simulation are
provided by the <i> simulation</i> class.
The <i> simulation</i> class has the following interface :
<PRE>   interface simulation 
   {
      simulation();
      virtual ~simulation();   
   
      void run();                      // run until no events left
      void run(double t);              // run for t time units
      void run(int count);             // run for count terminated events
   
      void quit();                     // quit simulation
   
      void terminate(event* e);        // terminate e
   
      int schedule(event* e,double t); // schedule e at t
      int wait(double t);              // schedule current
      int passivate(event* e);         // passivate e
      int activate(event* e);          // activate e
      int hold(event* e);              // add e to conditional
      int withdraw(event* e);          // put e on closed
      int reinstate(event* e);         // put e on conditional

      void reset();                    // reset the simulation

      double clock();                  // return clock

      void init(char* options = &quot;&quot;);   // initialize

      int cancel();                    // cancel events

      screen* format(char* p,char* options = &quot;&quot;);  // statistics
      screen* format(widget* w,char* p,char* options = &quot;&quot;);
 
      void postscript(char* fn);       // generate postscript
   
      friend ostream&amp; operator&lt;&lt;(ostream&amp; os,simulation&amp; s);
   };
</PRE>
<P>
The simulation object should be created before
other objects participating in the program are created.
The method <i> run</i> is used to run the simulation for <i> t</i> time units,
for <i> count</i> terminated events or until no scheduled events are left.
The simulation can be stopped by calling <i> quit</i>.
The primitives are described in section 3.2.
<i> Reset</i> clears the scheduler and conditional list, resets the clock
to 0 and resets the reports and widgets (if set) to their original state.
The function <i> clock</i> returns the current simulation time. 
The <i> init</i> method handles the following options :
<UL><LI>  -realtime (double) - default 0
<LI>  -scan (yes,no) - default no
<LI>  -suppress (none,reports,statistics,both) - default none
</UL>
If the constructor takes the <i> -realtime</i> argument the library runs in real
time mode. A run then ends if the simulation time divided by the double
is greater then the actual time (in seconds) that elapsed.
If the <i> -scan</i> option is set to yes, the list with the 
conditional events is traversed, even between events with the same activation time.
Setting <i> -suppress</i> has as effect that generated reports and/or statistics are not printed after a run.
The method <i> cancel</i> removes and deletes every event from the 
scheduler and conditional list that receives FALSE from its 
<i> event::verify</i> method. This method can be used to model the
breakdown of a server for example, departure events should be canceled
then.
The <i> format</i> method creates a screen with the
specified path for the statistics and handles the following options :
<UL><LI>  -foreground (color) - default black
<LI>  -background (color) - default white
<LI>  -width (int) - default 400
<LI>  -height (int) - default 120
</UL>
The size can be adjusted but the pre condition is that width/400 is
equal to height/120. If <i> format</i> is not used the statistics are
printed on a default toplevel screen (if in <i> hush</i> mode).
The function <i> postscript</i> writes the window of the simulation
object (if created) in postscript format to the specified file.
The <i> operator<b>&lt;&lt;</b></i> function can be used when debugging a program.
It prints the contents of the scheduler and conditional list.
<P>
<BR> <HR><A NAME=tex2html261 HREF="node13.html"><IMG ALIGN=BOTTOM ALT="next" SRC="http://www.cs.vu.nl/images/latex2html//next_motif.gif"></A>   <A NAME=tex2html259 HREF="node3.html"><IMG ALIGN=BOTTOM ALT="up" SRC="http://www.cs.vu.nl/images/latex2html//up_motif.gif"></A>   <A NAME=tex2html253 HREF="node11.html"><IMG ALIGN=BOTTOM ALT="previous" SRC="http://www.cs.vu.nl/images/latex2html//previous_motif.gif"></A>   <A NAME=tex2html263 HREF="node1.html"><IMG ALIGN=BOTTOM ALT="contents" SRC="http://www.cs.vu.nl/images/latex2html//contents_motif.gif"></A>      <BR>
<B> Next:</B> <A NAME=tex2html262 HREF="node13.html"> The generator class</A>
<B>Up:</B> <A NAME=tex2html260 HREF="node3.html"> Program structure</A>
<B> Previous:</B> <A NAME=tex2html254 HREF="node11.html"> The entity class</A>
<BR> <HR> <P>
<BR> <HR>
<P><ADDRESS>
<I>A Eliens <BR>
Tue Oct 31 09:27:21 MET 1995</I>
</ADDRESS>
</BODY>
