<!DOCTYPE HTML PUBLIC "-//W3O//DTD W3 HTML 2.0//EN">
<!Converted with LaTeX2HTML 95.1 (Fri Jan 20 1995) by Nikos Drakos (nikos@cbl.leeds.ac.uk), CBLU, University of Leeds >
<HEAD>
<TITLE> The generator class</TITLE>
</HEAD>
<BODY>
<meta name="description" value=" The generator class">
<meta name="keywords" value="sim">
<meta name="resource-type" value="document">
<meta name="distribution" value="global">
<P>
 <BR> <HR><A NAME=tex2html272 HREF="node14.html"><IMG ALIGN=BOTTOM ALT="next" SRC="http://www.cs.vu.nl/images/latex2html//next_motif.gif"></A>   <A NAME=tex2html270 HREF="node3.html"><IMG ALIGN=BOTTOM ALT="up" SRC="http://www.cs.vu.nl/images/latex2html//up_motif.gif"></A>   <A NAME=tex2html264 HREF="node12.html"><IMG ALIGN=BOTTOM ALT="previous" SRC="http://www.cs.vu.nl/images/latex2html//previous_motif.gif"></A>   <A NAME=tex2html274 HREF="node1.html"><IMG ALIGN=BOTTOM ALT="contents" SRC="http://www.cs.vu.nl/images/latex2html//contents_motif.gif"></A>      <BR>
<B> Next:</B> <A NAME=tex2html273 HREF="node14.html"> Hush classes</A>
<B>Up:</B> <A NAME=tex2html271 HREF="node3.html"> Program structure</A>
<B> Previous:</B> <A NAME=tex2html265 HREF="node12.html"> The simulation class</A>
<BR> <HR> <P>
<H2><A NAME=SECTION00036000000000000000> The generator class</A></H2>
<P>
The class <i> generator</i> represents the random number generator. 
The generator is used to get the randomized activation times of the
various events. It gets three positive seeds <IMG  ALIGN=MIDDLE ALT="" SRC="img3.gif"> and creates
a random number stream, according to the method described in appendix A.
<P>
Each time a member of the generator is invoked to get a random number, the next
number from the stream is calculated and is transformed, according to the 
probability distribution belonging to that member. Refer to appendix B
for the definitions. This number is returned and can be used in the
simulation. If, for example, a <i> normal</i> distribution with 10 as mean and 1 as
standard deviation is specified to transform the random number stream,
the generated numbers have 10 as mean and show little variation
because of the low standard deviation.
<P>
The class <i> generator</i> has the following interface :
<PRE>   interface generator 
   {
    public :
      generator(unsigned int s1,unsigned int s2 = 0,unsigned int s3 = 0);
      
      void antithetic(); // use 1-random()
   
      void reset();      // reset random number stream
   
      int probability(double p = 0.5); // OK with prob. p     
   
      double uniform(double a,double b);
      double exponential(double a);
      double hyperexponential(double p,double a,double b);
      double laplace(double a);
      double normal(double a,double b);
      double chisquare(unsigned int n);
      double student(unsigned int n);
      double lognormal(double a,double b);
      double erlang(unsigned int n,double a);
      double gamma(double a,double b);
      double beta(double a,double b);
      double fdistribution(unsigned int n,unsigned int m);
      double poisson(double a);
      double geometric(double p);
      double hypergeometric(unsigned int m,unsigned int n,double p);
      double weibull(double a,double b);
      double binomial(double p,unsigned int n);
      double negativebinomial(double p,unsigned int n);
      double triangular(double a);

    protected :
      double random();    // produces a random number between 0 and 1
   };
</PRE>
<P>
A generator, with given seeds, produces the same random number stream every time, it
is created with those seeds. 
If the defaults are chosen the last two seeds are equal to the first one.
One should fluctuate seeds to get reliable random numbers.
<P>
If the method <i> antithetic</i> is invoked, the inverse of the current
stream is used, i.e. instead of the generated random number, say <i> x</i>, <i> 1-x</i> is used. This method can be used when the variance of the
samples made is too high.
<P>
The function <i> reset</i> resets the random number stream, as if
no random number was generated from this stream.
The member <i> probability</i> returns OK with probability p 
and FALSE with probability 1-p.  The <i> distribution</i> functions all return a random
number from the stream, following the belonging probability distribution.
The method <i> random</i> produces a new variate (between 0 and 1) from
the random number stream. It is made protected so a derived generator 
can use this stream and add new distributions to the existing ones.
<P>
<BR> <HR><A NAME=tex2html272 HREF="node14.html"><IMG ALIGN=BOTTOM ALT="next" SRC="http://www.cs.vu.nl/images/latex2html//next_motif.gif"></A>   <A NAME=tex2html270 HREF="node3.html"><IMG ALIGN=BOTTOM ALT="up" SRC="http://www.cs.vu.nl/images/latex2html//up_motif.gif"></A>   <A NAME=tex2html264 HREF="node12.html"><IMG ALIGN=BOTTOM ALT="previous" SRC="http://www.cs.vu.nl/images/latex2html//previous_motif.gif"></A>   <A NAME=tex2html274 HREF="node1.html"><IMG ALIGN=BOTTOM ALT="contents" SRC="http://www.cs.vu.nl/images/latex2html//contents_motif.gif"></A>      <BR>
<B> Next:</B> <A NAME=tex2html273 HREF="node14.html"> Hush classes</A>
<B>Up:</B> <A NAME=tex2html271 HREF="node3.html"> Program structure</A>
<B> Previous:</B> <A NAME=tex2html265 HREF="node12.html"> The simulation class</A>
<BR> <HR> <P>
<BR> <HR>
<P><ADDRESS>
<I>A Eliens <BR>
Tue Oct 31 09:27:21 MET 1995</I>
</ADDRESS>
</BODY>
