<!DOCTYPE HTML PUBLIC "-//W3O//DTD W3 HTML 2.0//EN">
<!Converted with LaTeX2HTML 95.1 (Fri Jan 20 1995) by Nikos Drakos (nikos@cbl.leeds.ac.uk), CBLU, University of Leeds >
<HEAD>
<TITLE> Batch means and repetition</TITLE>
</HEAD>
<BODY>
<meta name="description" value=" Batch means and repetition">
<meta name="keywords" value="sim">
<meta name="resource-type" value="document">
<meta name="distribution" value="global">
<P>
 <BR> <HR><A NAME=tex2html484 HREF="node32.html"><IMG ALIGN=BOTTOM ALT="next" SRC="http://www.cs.vu.nl/images/latex2html//next_motif.gif"></A>   <A NAME=tex2html482 HREF="node30.html"><IMG ALIGN=BOTTOM ALT="up" SRC="http://www.cs.vu.nl/images/latex2html//up_motif.gif"></A>   <A NAME=tex2html478 HREF="node30.html"><IMG ALIGN=BOTTOM ALT="previous" SRC="http://www.cs.vu.nl/images/latex2html//previous_motif.gif"></A>   <A NAME=tex2html486 HREF="node1.html"><IMG ALIGN=BOTTOM ALT="contents" SRC="http://www.cs.vu.nl/images/latex2html//contents_motif.gif"></A>      <BR>
<B> Next:</B> <A NAME=tex2html485 HREF="node32.html"> Analyzing the results</A>
<B>Up:</B> <A NAME=tex2html483 HREF="node30.html"> Realizing accuracy goals</A>
<B> Previous:</B> <A NAME=tex2html479 HREF="node30.html"> Realizing accuracy goals</A>
<BR> <HR> <P>
<H3><A NAME=SECTION00052100000000000000> Batch means and repetition</A></H3>
<P>
The method of batch means splits a run into several subruns. It records
the means of each subrun. 
The following code fragment uses this method to
obtain the mean of the queue size for the M/M/1 queue.
<P>
<PRE>    
   histogram* h3 = new histogram(&quot;.h3&quot;,&quot;-title meansizes&quot;);
   tk -&gt; pack(h3);
   tk -&gt; update();

   for (int i=0;i&lt;100;i++)
   {
     sim -&gt; run(10000.0);
     h3 -&gt; sample(h1 -&gt; mean());        // sample the mean
     h1 -&gt; reset();                     // reset for the next subrun
   }
   cout &lt;&lt; (*h3);
</PRE>
<P>
After sampling the mean of each subrun, the histograms are reset, so
the results only cover a single subrun.
<P>
The method of repeating a single run has the disadvantage that on each run
we have an initial transient phase. It can be implemented as follows :
<P>
<PRE>    
   histogram* h3 = new histogram(&quot;.h3&quot;,&quot;-title meansizes&quot;);
   tk -&gt; pack(h3);
   tk -&gt; update();

   for (int i=0;i&lt;100;i++)
   {
     sim -&gt; run(10000.0);
     h3 -&gt; sample(h1 -&gt; mean());         // sample the mean
     h1 -&gt; reset();                      // reset objects
     r -&gt; reset();
     q -&gt; reset();
     sim -&gt; reset();               
     customer* c = new customer(ARRIVAL); // set up again
     sim -&gt; schedule(c,0.0);
     s = new server();
     sim -&gt; hold(s);
   }
   cout &lt;&lt; (*h3);
</PRE>
<P>
In this case we also reset the resource, queue and simulation object so
we have several independent runs. The simulation is set up at the
beginning of each run by scheduling an arrival and making the server
conditional.
<P>
The <i> reset</i> methods can also be used when running the simulation for an
initial transient phase or when designing experiments.
<P>
<BR> <HR>
<P><ADDRESS>
<I>A Eliens <BR>
Tue Oct 31 09:27:21 MET 1995</I>
</ADDRESS>
</BODY>
