<!DOCTYPE HTML PUBLIC "-//W3O//DTD W3 HTML 2.0//EN">
<!Converted with LaTeX2HTML 95.1 (Fri Jan 20 1995) by Nikos Drakos (nikos@cbl.leeds.ac.uk), CBLU, University of Leeds >
<HEAD>
<TITLE> Primitives and event states</TITLE>
</HEAD>
<BODY>
<meta name="description" value=" Primitives and event states">
<meta name="keywords" value="sim">
<meta name="resource-type" value="document">
<meta name="distribution" value="global">
<P>
 <BR> <HR><A NAME=tex2html184 HREF="node6.html"><IMG ALIGN=BOTTOM ALT="next" SRC="http://www.cs.vu.nl/images/latex2html//next_motif.gif"></A>   <A NAME=tex2html182 HREF="node3.html"><IMG ALIGN=BOTTOM ALT="up" SRC="http://www.cs.vu.nl/images/latex2html//up_motif.gif"></A>   <A NAME=tex2html176 HREF="node4.html"><IMG ALIGN=BOTTOM ALT="previous" SRC="http://www.cs.vu.nl/images/latex2html//previous_motif.gif"></A>   <A NAME=tex2html186 HREF="node1.html"><IMG ALIGN=BOTTOM ALT="contents" SRC="http://www.cs.vu.nl/images/latex2html//contents_motif.gif"></A>      <BR>
<B> Next:</B> <A NAME=tex2html185 HREF="node6.html"> The event-based approach</A>
<B>Up:</B> <A NAME=tex2html183 HREF="node3.html"> Program structure</A>
<B> Previous:</B> <A NAME=tex2html177 HREF="node4.html"> The event scheduling </A>
<BR> <HR> <P>
<H2><A NAME=SECTION00032000000000000000> Primitives and event states</A></H2>
<P>
When an event is activated it can be manipulated in various ways. The
event can be appended to a queue, it can be put back in the scheduler and
so on. On its way it changes state. We identify the following states
an event can be in (based on the simula states) :
<P>
<UL><LI>  <i> passive</i> -
indicating that the event is currently not available
for any processing.
<LI>  <i> active</i> - indicating that this is the event currently being
processed.
<LI>  <i> queued</i> - the event is in a queue.
<LI>  <i> pending</i> - the event is in the scheduler.
<LI>  <i> conditional</i> - indicating the event is on the conditional list.
<LI>  <i> closed</i> - the event is on the conditional list but unavailable.
</UL>
<P>
The various primitives that manipulate the event and cause the change
of state are then:
<P>
<UL><LI> <i> passivate</i> - which takes an event out of the simulation but does not
destroy the event.
<LI> <i> hold</i> - which takes a passive or active event and adds it to the conditional
list. This event then fires after each activated event.
<LI> <i> schedule</i> - which takes a passive event and adds it to the scheduler.
This event then executes after a specified period.
<LI> <i> wait</i> - which puts the event currently executing on the scheduler.
<LI> <i> activate</i> - which takes a passive, pending or conditional event
and schedules it to become active at the current simulation time.
A typical use is to bring forward the activation of an event at present time.
<LI> <i> terminate</i> - which terminates an active or passive event.
<LI> <i> append, prepend</i> - which add passive and active events to a
queue.
<LI> <i> extract, removefront, removeback</i> - these functions obtain events
from the queue.
<LI> <i> withdraw, reinstate</i> - which respectively prevent a conditional event from executing
by changing its state to closed and put a closed event back in its conditional state.
</UL>
<P>
The invoking of a primitive has not always effect.
The event should be in the correct state first. The invoking of the
<i> hold</i> primitive for example assumes a passive or active event. This
state can be obtained by first passivating or activating the event.
<P>
Consider the following transition diagram that shows the different states
an event can be in, in relationship with the different functions, that
manipulate them. 
The central state of an event is the <i> passive</i> state. 
Most events should first be passivated before they continue.
Notice that an event also changes state if it is <i> pending</i>
and is due to execute.
This event (the first event in the scheduler) is
extracted from the scheduler and becomes <i> active</i>. An event
that is on the conditional list stays <i> conditional</i> 
while executing until it is explicitly passivated.
<P>
<P><A NAME=States>&#160;</A><IMG  ALIGN=BOTTOM ALT="" SRC="img2.gif"><P><H4><A NAME=SECTION00032010000000000000> Entities</A></H4>
<P>
An entity (that combines several related events) has the same states
and primitives as an event. The difference is in the use of an additional phase,
as is explained in section 3.4.
<P>
<BR> <HR><A NAME=tex2html184 HREF="node6.html"><IMG ALIGN=BOTTOM ALT="next" SRC="http://www.cs.vu.nl/images/latex2html//next_motif.gif"></A>   <A NAME=tex2html182 HREF="node3.html"><IMG ALIGN=BOTTOM ALT="up" SRC="http://www.cs.vu.nl/images/latex2html//up_motif.gif"></A>   <A NAME=tex2html176 HREF="node4.html"><IMG ALIGN=BOTTOM ALT="previous" SRC="http://www.cs.vu.nl/images/latex2html//previous_motif.gif"></A>   <A NAME=tex2html186 HREF="node1.html"><IMG ALIGN=BOTTOM ALT="contents" SRC="http://www.cs.vu.nl/images/latex2html//contents_motif.gif"></A>      <BR>
<B> Next:</B> <A NAME=tex2html185 HREF="node6.html"> The event-based approach</A>
<B>Up:</B> <A NAME=tex2html183 HREF="node3.html"> Program structure</A>
<B> Previous:</B> <A NAME=tex2html177 HREF="node4.html"> The event scheduling </A>
<BR> <HR> <P>
<BR> <HR>
<P><ADDRESS>
<I>A Eliens <BR>
Tue Oct 31 09:27:21 MET 1995</I>
</ADDRESS>
</BODY>
