<!DOCTYPE HTML PUBLIC "-//W3O//DTD W3 HTML 2.0//EN">
<!Converted with LaTeX2HTML 95.1 (Fri Jan 20 1995) by Nikos Drakos (nikos@cbl.leeds.ac.uk), CBLU, University of Leeds >
<HEAD>
<TITLE> The analysis class</TITLE>
</HEAD>
<BODY>
<meta name="description" value=" The analysis class">
<meta name="keywords" value="sushi">
<meta name="resource-type" value="document">
<meta name="distribution" value="global">
<P>
 <BR> <HR><A NAME=tex2html890 HREF="node60.html"><IMG ALIGN=BOTTOM ALT="next" SRC="http://www.cs.vu.nl/images/latex2html//next_motif.gif"></A>   <A NAME=tex2html888 HREF="sushi.html"><IMG ALIGN=BOTTOM ALT="up" SRC="http://www.cs.vu.nl/images/latex2html//up_motif.gif"></A>   <A NAME=tex2html882 HREF="node58.html"><IMG ALIGN=BOTTOM ALT="previous" SRC="http://www.cs.vu.nl/images/latex2html//previous_motif.gif"></A>   <A NAME=tex2html892 HREF="node1.html"><IMG ALIGN=BOTTOM ALT="contents" SRC="http://www.cs.vu.nl/images/latex2html//contents_motif.gif"></A>   <A NAME=tex2html893 HREF="node60.html"><IMG ALIGN=BOTTOM ALT="index" SRC="http://www.cs.vu.nl/images/latex2html//index_motif.gif"></A>   <BR>
<B> Next:</B> <A NAME=tex2html891 HREF="node60.html">Index</A>
<B>Up:</B> <A NAME=tex2html889 HREF="sushi.html">SIM : a C++ </A>
<B> Previous:</B> <A NAME=tex2html883 HREF="node58.html"> Probability distributions</A>
<BR> <HR> <P>
<H1><A NAME=SECTION000120000000000000000> The analysis class</A></H1>
<P>
The complete interface of the analysis class :
<PRE>   interface analysis 
   {
     analysis(histogram* h); // taking histogram to analyze
     virtual ~analysis();    // destructor
   
     screen* format(char* p,char* options = &quot;&quot;);
     screen* format(widget* w,char* p,char* options = &quot;&quot;);

     double confidence(char* options = &quot;&quot;); // confidence interval of mean
     double confidence(histogram* h,char* options = &quot;&quot;); // difference

     double covariance(histogram* h2);  // covariance h and h2
     double correlation(histogram* h2); // correlation h and h2
   
     double chisquaretest(double* expected); // chi-square test
   
     double linear();                    // linear fit, return chi-square
     double linear(double a,double b);   
     double quadratic();                 // quadratic fit, return chi-square
     double quadratic(double a,double b,double c);
   
     double uniform();            // uniform fit, return chi-square
     double uniform(double a,double b);     
     double exponential();        // exponential fit, return chi-square
     double exponential(double a);  
     double hyperexponential(double p);  // hyperexponential fit, return chi-square
     double hyperexponential(double p,double a,double b);  
     double gamma();              // gamma fit, return chi-square
     double gamma(double a,double b); 
     double erlang();             // erlang fit, return chi-square
     double erlang(unsigned int n,double a); 
     double binomial();           // binomial fit, return chi-square
     double binomial(double p,unsigned int n);
     double geometric();          // geometric fit, return chi-square
     double geometric(double p);   
     double hypergeometric(unsigned int n); // hypergeometric, return chi-square
     double hypergeometric(unsigned int m,unsigned int n,double p);   
     double negativebinomial();   // neg. binomial fit, return chi-square
     double negativebinomial(double p,unsigned int n);
     double poisson();            // poisson fit, return chi-square
     double poisson(double a);      
     double normal();             // normal fit, return chi-square
     double normal(double a,double b);
     double lognormal();          // lognormal fit, return chi-square
     double lognormal(double a,double b); 
     double chisquare();          // chisquare fit, return chi-square
     double chisquare(unsigned int n);   
     double student();            // students' t fit, return chi-square
     double student(unsigned int n);    
     double fdistribution();      // F distribution fit, return chi-square
     double fdistribution(unsigned int n,unsigned int m); 
     double beta();               // beta fit, return chi-square
     double beta(double a,double b);   
     double weibull();            // weibull fit, return chi-square
     double weibull(double a,double b);
     double triangular();         // triangular fit, return chi-square
     double triangular(double a);  
     double laplace();            // laplace fit, return chi-square
     double laplace(double a); 
   
     int behavior(histogram* h,int n);  // report behavior

     // compare sizes and waiting times for various queues
     int MM1size(double lb,double mu);   
     int MM1waitingtime(double lb,double mu);
     int MMcsize(double lb,double mu,unsigned int c);
     int MMcwaitingtime(double lb,double mu,unsigned int c);
     int MD1size(double lb,double mu);
     int MD1waitingtime(double lb,double mu);

     void postscript(char* fn);   // generate postscript
   };
</PRE>
fig C.1. The interface of the class analysis
<P>
Notice that the <i> hypergeometric</i> fit in both cases requires the <i> n</i>
value. This value represents the number of items drawn from the population
and therefore should be known. The <i> hyperexponential</i> fit
always takes the chance of the first exponential distribution.
<P>
<BR> <HR>
<P><ADDRESS>
<I>D Bolier <BR>
Fri Sep  8 15:07:53 MET DST 1995</I>
</ADDRESS>
</BODY>
