<!DOCTYPE HTML PUBLIC "-//W3O//DTD W3 HTML 2.0//EN">
<!Converted with LaTeX2HTML 95.1 (Fri Jan 20 1995) by Nikos Drakos (nikos@cbl.leeds.ac.uk), CBLU, University of Leeds >
<HEAD>
<TITLE>SIM : a C++ library for Discrete Event Simulation</TITLE>
</HEAD>
<BODY>
<meta name="description" value="SIM : a C++ library for Discrete Event Simulation">
<meta name="keywords" value="sushi">
<meta name="resource-type" value="document">
<meta name="distribution" value="global">
<P>
 <BR> <HR><A NAME=tex2html1 HREF="node1.html"><IMG ALIGN=BOTTOM ALT="next" SRC="http://www.cs.vu.nl/images/latex2html//next_motif.gif"></A>   <IMG ALIGN=BOTTOM ALT="up" SRC="http://www.cs.vu.nl/images/latex2html//up_motif_gr.gif">   <IMG ALIGN=BOTTOM ALT="previous" SRC="http://www.cs.vu.nl/images/latex2html//previous_motif_gr.gif">   <A NAME=tex2html3 HREF="node1.html"><IMG ALIGN=BOTTOM ALT="contents" SRC="http://www.cs.vu.nl/images/latex2html//contents_motif.gif"></A>   <A NAME=tex2html4 HREF="node60.html"><IMG ALIGN=BOTTOM ALT="index" SRC="http://www.cs.vu.nl/images/latex2html//index_motif.gif"></A>   <BR>
<B> Next:</B> <A NAME=tex2html2 HREF="node1.html">Contents</A>
<BR> <HR> <P>
<P>
<H1>SIM : a C++ library for Discrete Event Simulation</H1>
<P><STRONG> Dirk Bolier - Anton Eli&#235;ns<BR> 
<em> Vrije Universiteit, Department of Mathematics and Computer Science <BR> 
<em> De Boelelaan 1081, 1081 HV Amsterdam, The Netherlands <BR> 
<em> email: dbolier@cs.vu.nl - eliens@cs.vu.nl</em></em></em></STRONG><P>
<P>
<H3>Abstract:</H3>
<EM><A NAME=Abstract>&#160;</A>
<P>
In this report we give a full 
description of <i> sim</i>,
a C++ library for discrete event simulation.
The <i> sim</i> library supports both
an <i> event</i> and <i> process-oriented</i>
approach to developing simulations.
Events as well as entities (which may be considered
as objects in the simulation combining several related events and having 
an additional phase signifying episodes in its
life-time) are provided as abstract classes
that must be refined by the application programmer
to define the actual events and entities
participating in the simulation.
<P>
The <i> sim</i> library is integrated with the
<i> hush</i> library, thus offering powerful
graphic and animation facilities.
However, the <i> sim</i> library may also be used
independently, on both Unix and MS-Dos platforms.
<P>
This report presents an overview of the classes
constituting the <i> sim</i> library
as well as two standard examples and various code fragments illustrating
the deployment of the classes in writing
simulation programs.
<P>
Keywords: discrete event simulation, events, entities,
modeling, simulation experiments, simulation animation, simulation analysis
</EM><P>
<P>

<P>
<BR> <HR>
<UL> 
<LI> <A NAME=tex2html5 HREF="node1.html#SECTION00010000000000000000">Contents</A>
<LI> <A NAME=tex2html6 HREF="node2.html#SECTION00020000000000000000"> Introduction</A>
<LI> <A NAME=tex2html7 HREF="node3.html#SECTION00030000000000000000"> The library SIM</A>
<LI> <A NAME=tex2html8 HREF="node4.html#SECTION00040000000000000000"> Program structure</A>
<UL> 
<LI> <A NAME=tex2html9 HREF="node5.html#SECTION00041000000000000000"> The event scheduling strategy</A>
<LI> <A NAME=tex2html10 HREF="node6.html#SECTION00042000000000000000"> Primitives and event states</A>
<LI> <A NAME=tex2html11 HREF="node7.html#SECTION00043000000000000000"> The event-based approach</A>
<UL> 
<LI> <A NAME=tex2html12 HREF="node8.html#SECTION00043100000000000000"> The Dining Philosophers</A>
<LI> <A NAME=tex2html13 HREF="node9.html#SECTION00043200000000000000"> The event class</A>
</UL> 
<LI> <A NAME=tex2html14 HREF="node10.html#SECTION00044000000000000000"> The process-oriented approach</A>
<UL> 
<LI> <A NAME=tex2html15 HREF="node11.html#SECTION00044100000000000000"> The entity philosopher</A>
<LI> <A NAME=tex2html16 HREF="node12.html#SECTION00044200000000000000"> The entity class</A>
</UL> 
<LI> <A NAME=tex2html17 HREF="node13.html#SECTION00045000000000000000"> The simulation class</A>
<LI> <A NAME=tex2html18 HREF="node14.html#SECTION00046000000000000000"> The generator class</A>
<LI> <A NAME=tex2html19 HREF="node15.html#SECTION00047000000000000000"> Hush classes</A>
<UL> 
<LI> <A NAME=tex2html20 HREF="node16.html#SECTION00047100000000000000"> The session class</A>
<LI> <A NAME=tex2html21 HREF="node17.html#SECTION00047200000000000000"> The kit class</A>
<LI> <A NAME=tex2html22 HREF="node18.html#SECTION00047300000000000000"> The widget class</A>
<LI> <A NAME=tex2html23 HREF="node19.html#SECTION00047400000000000000"> The toplevel widget</A>
</UL> 
</UL> 
<LI> <A NAME=tex2html24 HREF="node20.html#SECTION00050000000000000000"> Queuing events</A>
<UL> 
<LI> <A NAME=tex2html25 HREF="node21.html#SECTION00051000000000000000"> Queues and resources</A>
<LI> <A NAME=tex2html26 HREF="node22.html#SECTION00052000000000000000"> A M/M/1 Queue</A>
<LI> <A NAME=tex2html27 HREF="node23.html#SECTION00053000000000000000"> Queue behavior</A>
<LI> <A NAME=tex2html28 HREF="node24.html#SECTION00054000000000000000"> The resource class</A>
<LI> <A NAME=tex2html29 HREF="node25.html#SECTION00055000000000000000"> The queue class</A>
</UL> 
<LI> <A NAME=tex2html30 HREF="node26.html#SECTION00060000000000000000"> Gathering and analyzing results</A>
<UL> 
<LI> <A NAME=tex2html31 HREF="node27.html#SECTION00061000000000000000"> Gathering results with histograms</A>
<UL> 
<LI> <A NAME=tex2html32 HREF="node28.html#SECTION00061100000000000000"> Histogram options</A>
<LI> <A NAME=tex2html33 HREF="node29.html#SECTION00061200000000000000"> Samples and reports</A>
<LI> <A NAME=tex2html34 HREF="node30.html#SECTION00061300000000000000"> Mean and variance</A>
<LI> <A NAME=tex2html35 HREF="node31.html#SECTION00061400000000000000"> Printing a histogram</A>
<LI> <A NAME=tex2html36 HREF="node32.html#SECTION00061500000000000000"> The histogram widget</A>
</UL> 
<LI> <A NAME=tex2html37 HREF="node33.html#SECTION00062000000000000000"> Realizing accuracy goals</A>
<UL> 
<LI> <A NAME=tex2html38 HREF="node34.html#SECTION00062100000000000000"> Batch means and repetition</A>
<LI> <A NAME=tex2html39 HREF="node35.html#SECTION00062200000000000000"> Antithetic variates</A>
</UL> 
<LI> <A NAME=tex2html40 HREF="node36.html#SECTION00063000000000000000"> Analyzing the results</A>
<UL> 
<LI> <A NAME=tex2html41 HREF="node37.html#SECTION00063100000000000000"> Confidence intervals</A>
<LI> <A NAME=tex2html42 HREF="node38.html#SECTION00063200000000000000"> Covariance and correlation</A>
<LI> <A NAME=tex2html43 HREF="node39.html#SECTION00063300000000000000"> Fitting curves and distributions</A>
<LI> <A NAME=tex2html44 HREF="node40.html#SECTION00063400000000000000"> The behavior of the simulation</A>
<LI> <A NAME=tex2html45 HREF="node41.html#SECTION00063500000000000000"> The design of experiments</A>
<LI> <A NAME=tex2html46 HREF="node42.html#SECTION00063600000000000000"> Formatting the output</A>
<LI> <A NAME=tex2html47 HREF="node43.html#SECTION00063700000000000000"> The analysis class</A>
</UL> 
</UL> 
<LI> <A NAME=tex2html48 HREF="node44.html#SECTION00070000000000000000"> Graphics</A>
<UL> 
<LI> <A NAME=tex2html49 HREF="node45.html#SECTION00071000000000000000">  A graphical interface for the Dining Philosophers Problem</A>
<LI> <A NAME=tex2html50 HREF="node46.html#SECTION00072000000000000000"> Graphical widgets</A>
<UL> 
<LI> <A NAME=tex2html51 HREF="node47.html#SECTION00072100000000000000"> The screen widget</A>
<LI> <A NAME=tex2html52 HREF="node48.html#SECTION00072200000000000000"> The control widget</A>
<LI> <A NAME=tex2html53 HREF="node49.html#SECTION00072300000000000000"> The simulationclock widget</A>
<LI> <A NAME=tex2html54 HREF="node50.html#SECTION00072400000000000000"> The query widget</A>
</UL> 
</UL> 
<LI> <A NAME=tex2html55 HREF="node51.html#SECTION00080000000000000000"> Conclusions</A>
<LI> <A NAME=tex2html56 HREF="node52.html#SECTION00090000000000000000">References</A>
<LI> <A NAME=tex2html57 HREF="node53.html#SECTION000100000000000000000"> The generator and some tests</A>
<UL> 
<LI> <A NAME=tex2html58 HREF="node54.html#SECTION000101000000000000000"> The linear congruential generator</A>
<LI> <A NAME=tex2html59 HREF="node55.html#SECTION000102000000000000000"> Tests on the random number stream</A>
<LI> <A NAME=tex2html60 HREF="node56.html#SECTION000103000000000000000"> A test on the distributions</A>
<LI> <A NAME=tex2html61 HREF="node57.html#SECTION000104000000000000000"> A test on the event scheduling strategy</A>
</UL> 
<LI> <A NAME=tex2html62 HREF="node58.html#SECTION000110000000000000000"> Probability distributions</A>
<LI> <A NAME=tex2html63 HREF="node59.html#SECTION000120000000000000000"> The analysis class</A>
<LI> <A NAME=tex2html64 HREF="node60.html#SECTION000130000000000000000">Index</A>
<LI> <A NAME=tex2html65 HREF="node61.html#SECTION000140000000000000000">   About this document ... </A>
</UL>
<BR> <HR>
<P><ADDRESS>
<I>D Bolier <BR>
Fri Sep  8 15:07:53 MET DST 1995</I>
</ADDRESS>
</BODY>
