<document>
<h4>
DejaVu -- een component-gebaseerde benadering van hypermedia
</h4>

<pre>

  Anton Eliens (eliens@cs.vu.nl),
  Matthijs van Doorn (thijs@cs.vu.nl),
  Jacco van Ossenbruggen (jrvosse@cs.vu.nl)

  Vrije Universiteit, Amsterdam
</pre>
<p>
Een object-georienteerde benaderingswijze
wordt in toenemende mate als een adequaat middel
gezien om de problemen die zich voordoen bij
het ontwikkelen van complexe programmas het hoofd te
bieden.

In het DejaVu project is van een object-georienteerde
benadering gebruik gemaakt voor de ontwikkeling van een
raamwerk voor gedistribueerde hypermedia systemen.
Het resultaat van onze inspanningen is een collectie
software bibliotheken die de functionaliteit leveren
voor de ontwikkeling van hypermedia applicaties
en multimedia gebruikersinterfaces.

In de voordracht wordt ingegaan op de organisatie-
en modelleringsprincipes die ten grondslag liggen
aan de hush (hyper utility shell) bibliotheek.
Ook komen enkele uitbreidingen van hush aan de orde,
te weten hymne (waarin faciliteiten voor realtime
soundsynthese en muziek geboden worden) en web
(waarin de aansluiting op het World Wide Web gerealizeerd is).

Centraal in de in het DejaVu project gekozen aanpak
staat een meertalige benadering.
In het bijzonder ondersteunen hush en de uitbreidingen
daarop een nauwe koppeling tussen C++ en diverse script-talen
(waaronder Tcl).
Als voorbeeld van deze aanpak zal getoond worden hoe
een tweezijdige wisselwerking tussen applicaties
en het Web gerealiseerd kan worden.
Op deze wijze kunnen actieve of dynamische documenten
gerealiseerd worden, waardoor bijvoorbeeld
een effectieve integratie van simulatie en hypermedia
tot de mogelijkheden gaat behoren.

De voordracht is gebaseerd op een reeds gepubliceerd
artikel over hush, alsmede presentaties op
de ECHT94 Hypermedia Conferentie en de WWW95 conferentie
in Darmstadt.


<h4>Achtergrond</h4>
Het DejaVu: OOP/Hypermedia project (onder dagelijkse leiding 
van A. Eliens) beoogt de formulering van een (object-georienteerd)
raamwerk voor de ontwikkeling van intelligente, gedistribueerde
hypermedia applicaties.
Het onderzoek heeft tot nu toe geresulteerd
in een aantal publicaties, alsmede software bibliotheken
ten behoeve van de ontwikkeling van (multimedia) gebruikersinterfaces
en simulaties (zie referenties).
In het project zijn een tweetal AIO's werkzaam
(M. van Doorn, J. van Ossenbruggen),
alsmede een programmeur (C. Visser, gedetacheerd) en
een tijdelijk onderzoeker (D. Bolier).
Aandachtspunten in het onderzoek zijn:
object orientatie,
declaratieve markup,
time-based media,
active documents,
simulatie,
en
multiparadigm software omgevingen.
Ondermeer wordt in het DejaVu project technologie ontwikkeld
die inspeelt op de (client/server gebaseerde) informatievoorziening
via het Web, en als uitbreiding daarop 'actieve documenten'
toelaat waarmee client-specifieke berekeningen uitgevoerd
kunnen worden.


<control>
<h4>Referenties</h4>
</control>
<references>
<dl>
<dt> Eliens92
<dd> A. Eliens,
DLP - A language for distributed logic programming,
Wiley (1992)
<dt> Eliens95
<dd> A. Eliens,
Principles of Object-Oriented Software Development,
Addison-Wesley (1995)
<dt> Eliens95b
<dd> A. Eliens,
Hush -- a C++ API for Tcl/Tk, 
The X Resource, Issue 11, April 1995
<dt> BolEl94
<dd> D. Bolier en A. Eliens,
Sim -- a C++ simulation library, IR-367,
Vrije Universiteit (1994)
<dt> OssEl94
<dd> J. van Ossenbruggen en A. Eliens,
Music in Time-based Hypermedia,
Proc. European Conference on Hypermedia Technology 1994,
pp. 224-227
<dt> DoornEl94
<dd> M. van Doorn en A. Eliens,
Integrating WWW and Applications,
ERCIM W4G
Int. Workshop on WWW Design Issues '94,
Amsterdam, Nov 29- Dec. 1
<dt> DoornEl95a
<dd> M. van Doorn en A. Eliens
Information management, SGML and active documents,
ERCIM W4G,
Int. Workshop on WWW Design Issues '95,
Paris Feb. 8-10
<dt> VisserEl95
<dd> C. Visser en A. Eliens,
A Language System Architecture for the Interoperability of
Distributed Multi-Paradigm Objects,
European Research Seminar on Advances in Distributed Systems,
L'Alpe d'Huez, April 3-7, 1995
<dt> DoornEl95b
<dd> M. van Doorn en A. Eliens,
Integrating WWW and Applications,
Third Int. World Wide Web Conf. --
Technology, Tools and Applications,
April 10-14, 1995, Darmstadt 
</dl>
</references>
</document>
