<h4>Software sound facilities</h4>
<include file=navigate>
Sound facilities are an essential ingredient
of a framework supporting multimedia.
Sound may be produced from a stored audio file or,
provided that real-time sound synthesis facilities
are available, from some high level representation
in a sound or music description language.
Apart from a reduction in the storage capacity needed
(and correspondingly, the network traffic load
in a distributed environment),
employing a high level music/sound description language
has as an additional advantage that improved
synchronization and linking facilities may be offered.
<p>
The DejaVu framework supports both MIDI and the
sound synthesis facilities offered by Csound [XX].
When creating an instance of the <i>icsound</i> class
a process is created
which is capable of receiving sound events,
as defined by the Csound numerical score language, and
converting these events to data for the audio device.
(The <i>icsound</i> class inherits from
a <i>wrapper</i> class providing the functionality
for spawning of a new process that communicates with
the original process via pipes.)
Care is taken that the audio device is connected only once.
However, multiple instances of the <i>icsound</i>
class may exist.
<p>
In addition to the <i>icsound</i> class, which accepts
only low level sound events, instances of <i>player</i>
may be used which accept musical events defined in
the high level music description language Scot,
that comes with Csound.
The <i>player</i> class is also an <i>event</i>.
This allows instances of <i>player</i> to be embedded
in scripts, as well as being activated
as user-defined events.
<include file=navigate>
