<h4>The hush API</h4>
As explained in the previous section, the
<i>hush</i> library contains the classes
providing the interface to the embedded script
interpreter(s) and the classes allowing for
a smooth interaction with the underlying window
system.
(Currently, only X-windows is supported.
An MS-windows implementation is on its way.)
<p>
The <i>hush</i> library contains the classes
<i>kit</i>, <i>event</i>, <i>handler</i>,
<i>widget</i> and <i>item</i>.
In addition to these, <i>hush</i> provides
the class <i>session</i>, of which the public
interface is shown below:
<pre>
  interface session : event {
	...
	void prelude(kit* tk, int argc, char* argv[]);
	void main(kit* tk, int argc, char* argv[]);
	int run();		// to start the main loop
	...
	int loop(int flag);
	int step(int flag);
	...
  };
</pre>
Application programmers are minimally required
to derive a class, say <i>application</i>,
from <i>session</i> and redefine the function <i>main</i>.
When the program is to be used as a script interpreter,
the function <i>prelude</i> may be redefined
to allow for initializing external packages or other
components of the DejaVu framework.
When the function <i>run</i> is called, as for example
in the following code fragment:
<pre>
  session* s = new application();
  s->run();
</pre>
the function <i>application::main</i> is called
(by <i>run</i>) and the main loop is started,
which results in dispatching user actions to the
appropriate handlers.
In case the standard main loop is not satisfactory,
either the function <i>session::loop</i>
may be redefined or for each iteration
an application-defined <i>step</i> may be inserted.
Notice that a <i>session</i> inherits from <i>event</i>,
which means that a particular session object may be scheduled
under explicit programmer's control.
<p>
As a comment, the <i>hush</i> library originated
as a collection of classes
giving the C++ programmer convenient access
to the Tcl/Tk window programming toolkit.
Its design has been inspired by the Interviews library.
However, although less powerful wit respect
to device-independent graphics,
its class structure is less complex
and, as experience shows, much easier to employ
by undergraduate students.
In addition, it offers a rich collection of
user interface widgets.
