<h4>Connecting to the WWW</h4>

In addition to the basic hypertext facility mentioned before,
the DejaVu framework also provides support
(in the form of the <i>web</i> widget)
for hypertext files written in HTML.
The <i>web</i> widget displays HTML files and allows for 
following links defined by URLs.
The public interface of the <i>web</i> widget
looks as follows:
<pre>
  interface web : widget {
    ...
    void loadhome(char *url);
  };
</pre>
In addition to the standard widget functions,
it offers a function <i>loadhome</i>, to load
a home page.
Using the <i>web</i> widget in a (Tcl) script is
illustrated by the following fragment:
<pre>
  web .w
  .w loadhome http://www.cs.vu.nl/~se/demo.html
</pre>
In a similar way as the basic hypertext widget,
the <i>web</i> widget allows for embedding
(Tcl) script code, by using the
special (non-HTML) tag <i>hush</i>,
as illustrated below:
<pre>
 &lt;h1&gt;Digital video for HushWWW&lt;/h1&gt;
 &lt;hush tcl=source [urlfile http://www.cs.vu.nl/~se/mpeg.tcl&gt;
 You need the hush browser to play this MPEG demo 
 &lt/hush&gt;
</pre>
The actual script code itself may be obtained
from some site by using the special command
<i>urlfile</i>.
The text inbetween the <i>hush</i> begin and end tag
will be displayed by 'ordinary' browsers, such as Mosaic
and Netscape.
Evaluating the script code may, similar as
for the hypertext widget, result in packing
additional widgets to the browser (widget),
as for example a video widget showing an mpeg movie.
