<document[a4,epsf]{article}>
<!-- %% AUXILIARY
\def\figbox#1{\begin{minipage}[t]{12cm}\input #1\end{minipage}}
\newcommand{\zline}[1]{\hspace*{\fill}\nolinebreak {\footnotesize #1} }
\setcounter{figure}{0}
-->

<!--
\title{DejaVu -- a component-based approach to hypermedia}
\author{A. Eli\"{e}ns \& 
J.R. van Ossenbruggen \\
{\footnotesize \sl Vrije Universiteit,}
{\footnotesize \sl Department of Mathematics and Computer Science} \\
{\footnotesize \sl De Boelelaan 1081, 1081 HV Amsterdam}
{\footnotesize \sl The Netherlands}\\
{\footnotesize \sl email: \{eliens,jrvosse\}@cs.vu.nl}
} \date{}\maketitle
\def\thefootnote{}
\setcounter{page}{1}
-->


<control>
<h1>DejaVu -- a component-based approach to hypermedia</h1>
<hr>
<a href=title.ps>Postscript</a>
<hr>
</control>



<abstract>
Object-technology offers promising means to cope
with the problems that occur when developing complex programs.
The DejaVu project employs an object-oriented approach
to formulate a framework for the development of
distributed, intelligent hypermedia systems.
The result of our efforts is a collection of libraries
and tools providing the functionality needed for developing
hypermedia applications and multimedia user interfaces.

In this paper, we will discuss the organisation and modeling
principles underlying the <em>hush</em> (hyper utility shell)
library.
In addition some extensions to <em>hush</em> will be described,
including <em>hymne</em> (offering facilities for realtime
soundsynthesis and music), <em>web</em> (which realizes
the connection to the World Wide Web)
and <em>sima</em> (offering user-definable events and
soft realtime scheduling facilities).

A central theme in the DejaVu project is to support
a multi-lingual software development platform.
In effect, <em>hush</em> and its extensions
allow for a close coupling between C++, a distributed
logic programming language and a variety of script languages
(including Tcl).

As an example of our approach we will illustrate how
to embed a distributed simulation in a collection of
web pages.

</abstract>
</document>
