<h1>Conclusions</h1>
<include file=navigate>
<include file=rf>

Our involvement with patterns and idioms 
came naturally from our concern to develop a
flexible and easy-to-use framework.
From its inception we applied idioms
(called <i>composition mechanisms</i> in 
[_Eliens95]) in the realization of the <i>hush</i> library.
Reflecting on the design of <i>hush</i> we identified
two recurrent patterns,
the <i>nested component</i> pattern and the <i>actor</i>
pattern,
which may be regarded as design level generalizations of their
associated idioms.
<p>
With respect to meeting the requirements of
flexibility and extensibility, our approach 
has proved its worth.
However with respect to the software development
efforts involved, the systematic application of
the idioms described has drawbacks as well.
For example, we found that applying (the naive version of)
the <i>handle/body</i> idiom led to disrupting the
virtual function call mechanism
and hence to inconsistencies in the class hierarchy
and additional coding effort.
Our improved version solved the first two of these problems.
Also, we found that the use of separate
body implementation classes gave rise to the
introduction of many additional classes.
To avoid a pollution of the class name space,
we decided to export only a limited number
of classes and to employ a suitable idiom for hiding
the concrete subclasses.
<p>
To evaluate, our experiences are positive, but we had to pay a price.
First of all, applying the idioms led to a
significantly increased design effort,
and secondly, additional coding effort (and discipline)
is needed for implementing system level components.
In the table below we
give a qualitative assessment of how the use of idioms
may affect, in our experience, aspects such
as <i>reliability</i>,
<i>adaptability</i>, <i>maintainability</i> 
and <i>performance</i> [_Ramp,Eliens95].




<center>
<table><!--{|l|c|c|c|}-->
<tr><td>Requirement		<td>body/handle	<td>virtual self<td>role-switching
<tr><td><b>R</b>eliability	<td>+/$-$		<td>$-$		<td>$-$
<tr><td><b>A</b>daptability	<td>+		<td>+/$-$		<td>++
<tr><td><b>M</b>aintainability	<td>+		<td>+		<td>$-$
<tr><td><b>P</b>erformance	<td>$-$		<td>$-$		<td>$--$
</table>
</center>


With respect to <i>reliability</i>
the <i>handle/body</i> idiom may be considered neutral,
whereas both the <i>virtual self</i> and <i>role-switching</i>
idiom may introduce errors due to their complexity.
<p>
No doubt, <i>adaptability</i> is improved by employing
the <i>handle/body</i> idiom and even more by employing
the <i>role-switching</i> idiom.
<p>
The aspect of <i>maintainability</i>
is positively affected by applying the
<i>handle/body</i> and <i>virtual self</i> idiom,
yet moderately negative by
<i>role-switching</i>.
<p>
In terms of both memory usage and
run-time efficiency, loss of <i>performance</i>
will result from applying idioms.
Apart from the creation and deletion of additional
objects,
additional object references are required
as well as additional de-referencing
and, in the case of <i>role-switching</i>,
array indexing or hash table search.
Nevertheless, the performance loss is certainly not dramatic,
in particular with regard to the benefits of
having a single uniform interface for the application programmer
and at the same time the flexibility needed
in a research environment.
<p>
Concluding, we have stated our experiences which indicate
that patterns are profitable but also that
<i>"patterns do not come for free"</i>.
On the contrary, the employment of patterns
and their associated idioms incur significant
costs in terms of software development efforts
and, in addition, may affect the quality of
the software with respect to aspects such as
reliability, maintainability and performance.
<p>
<include file=navigate>
