<include file=rf>

<h1>Introduction</h1>
<include file=navigate>
For both users and developers,
delineating the patterns and idioms underlying
the realization of an object-oriented framework
is slowly being recognized to be of critical
importance for understanding the inherent complexity
of the framework.
<p>
The DejaVu framework, that we are developing,
is meant to provide a flexible and
easy-to-use
environment for intelligent,
distributed hypermedia applications.
In particular, the <i>hush</i>
(<i>hyper utility shell</i>) library
and its extensions offer support for the
development of multimedia user interfaces,
and is used in practical CS2 and CS3 software
engineering assignments.
The focus of our research has recently shifted towards
Web-integrated applications,
that allow for including Web-aware
widgets as a (GUI) component in an application.
In order to realize the functionality of <i>hush</i>
in a flexible fashion,
a systematic use has been made of a limited number
of patterns,
namely the <i>nested components</i> pattern and
the <i>actor</i> pattern.
For the actual implementation <i>hush</i> we employed
an improved version of the <i>handle/body</i> idiom,
and the derived
<i>virtual self-reference</i> and
<i>dynamic role-switching</i> idioms that underly
the patterns mentioned.
<p>
To clarify the distinction between patterns and idioms
we emphasize that the patterns
provide a solution to a problem of design,
whereas idioms are to be regarded as a convenient
implementation technique.


<h4>Related work</h4>
Clearly, a rich variety
of patterns and idioms has already been
extracted from the development of GUI toolkits
as testified by the collection in [_GOF],
which is primarily drawn from the experience
of developing Interviews [_Interviews]
and ET++ [_ET].
Nevertheless,
our work shows a flaw in one of the commonly used
idioms, notably the <i>handle/body</i> idiom,
and may further be considered of interest
due to our approach of realizing
the <i>handle/body</i> idiom and idioms derived from it.
Our <i>actor</i> pattern
and associated <i>dynamic role switching</i> idiom,
moreover, seem to be more powerful
than similar patterns known from the literature.

<h4>Structure</h4>
The structure of this paper is as follows.
First, we will give a brief overview of
the DejaVu framework and the basic concepts of
the <i>hush</i> library.
Then we will characterize the patterns and idioms
employed in developing hush and its extensions.
As an illustration of our approach,
we will discuss the design of the Web-related
components of our framework.
And finally, we will discuss the relative merits
of the patterns and idioms employed.
<include file=navigate>
