class BodyOfA: public A {
  public:
    BodyOfA(char *id, A*);
    ~BodyOfA() { delete _id; }
    A* self() { return _self ? _self->self() : handle; }
    char* id(){ return _id; }
    void become(A* role) { Role[Default] = role; }
    void become(repertoire* role);

    void f1() { cout << "A::f1() for "<< self()->id() << endl; }
    void f2() { 
	cout << "A::f2() for "<< self()->id();
	cout << " calling f1() for delegate:" << endl << "\t"; 
	self()->f1();  
	cout << " and calling f1() for handle: "<< endl << "\t"; 
	handle->f1();
    }
  protected:
    void redirect(A* r) { _self = r; }
  private:
    A* handle, *_self; char *_id; A* roles[MaxRoles];
};

BodyOfA::BodyOfA(char* id, A* h) : handle(h), _self(0), A(666) { 
	strcpy(_id=new char[strlen(id)+1], id);
	for(int i = Default; i<= MaxRoles; i++) role[i] = this;
    	become(Default);
};

A::A(char* id) { body = new BodyOfA(id, this); }
A::A(int dummy) { body = 0; }

void BodyOfA::become(repertoire r) {
    if (exists()) self()->become(r);
    else {
        _role = r;
        if (role[r] == this) {
            switch(r) {
              case Default:
                break;
              case Role1:
                role[r] = new Role1Body; break;
              case Employer:
                role[r] = new Role2Body; break;
            }
        }
    }
}
