<h1>The rules of the game</h1>

<h2>The handle/body idiom -- invocation context</h2>

<h4>Problem</h4>
<h4>Background</h4>
<h4>Realization</h4>
<h4>Usage</h4>

<h2>Virtual self-reference</h2>

<h2>Dynamic role-switching</h2>


  ------------
<h2>The handle/body idiom</h2>
<h4>When and how to use this idiom?</h4>
The basic handle/body idiom can be used to implement relatively simple classes
whose instances should share the same (memory) resources
or to let the class interface and implementation vary independently.
The actual type (class name) of the body class can be hidden by deriving
the body class of the handle. In that case, a recursive dependency between
the constructors of the handle and body can be avoided by the use of a dummy constructor.

As shown above, the basic handle/body idiom should not be used to implement 
base classes whose member functions make calls to other virtual members.
In the next section we discuss an improved version of the handle/body 
idiom which can be applied to avoid these virtual function anomalies.


<h2>Dynamic invocation context</h2>
<h4>When and how to use this idiom?</h4>
Use the explicit invocation context idiom if a member function
needs the services of another virtual member function, which
might be redefined by subclasses of the handle. 
This can be achieved by an explicit reference to the original 
invocation context, which can be represented by pointer to the handle object.
To enable the body object to call such a possibly redefined function correctly, 
it makes these calls via the handle.

Subclasses may apply the handle/body idiom in the same way as base classes do.
However, a (system) programmer implementing the body of the derived class 
should be aware of the three access methods to the body of its handle's base class:
via its invocation context (by calling member functions via the handle pointer),
via direct inheritance (by subclassing directly from {\tt BodyOfA}),
and via indirect inheritance (by subclassing from its handle C).
The latter method can be avoided by use of dummy constructors.


<h2>Virtual self-reference</h2>

<h2>Dynamic role-switching</h2>
