<document opt=[aw,a4,epsf] style=awart >
<!-- %% AUXILIARY


\setcounter{figure}{0}
-->

<!--
\title{Patterns and Idioms in the DejaVu Framework}
\author{Anton Eli\"{e}ns, 
Jacco van Ossenbruggen and  \\
Bastiaan Sch\"onhage \\
{\footnotesize \sl Vrije Universiteit,}
{\footnotesize \sl Department of Mathematics and Computer Science} \\
{\footnotesize \sl De Boelelaan 1081, 1081 HV Amsterdam,}
{\footnotesize \sl The Netherlands}\\
{\footnotesize \sl email: \{eliens,jrvosse,bastiaan\}@cs.vu.nl}
} \date{}\maketitle
\def\thefootnote{}
\setcounter{page}{1}

\date{}\maketitle
\def\thefootnote{}
\setcounter{page}{1}
-->

<control>
<h1>Patterns and Idioms in the DejaVu Framework</h1>

<center>
Anton Eli&euml;ns,
Jacco van Ossenbruggen  &amp;
Bastiaan Sch&ouml;nhage
<br>
Vrije Universiteit, Department of Mathematics and Computer Science,
<br>
De Boelelaan 1081, 1081 HV Amsterdam, The Netherlands
<br>
email: {eliens,jrvosse,bastiaan}@cs.vu.nl, fax: +31.20.4447653
</center>
</control>

<control><h4>Abstract</h4></control>

<abstract>
The DejaVu framework,  in particular  the <i>hush</i> 
(<em>hyper utility shell</em>) library
and its extensions,
aims at providing an easy-to-use
and flexible, multi-paradigm environment
for developing distributed hypermedia and web-based applications.
Our framework is object-oriented in that it allows
for a component-wise approach to developing applications.
Yet, in addition to object class interfaces, it
offers the opportunity to employ a script language
to develop applications and prototypes as well.
It is multi-paradigm, not only by supporting a
multi-lingual approach, but also by providing support
for distributed client/server solutions in a transparent manner.
<p>
In this paper we will discuss our experiences in
developing the framework with regard to the method
of software development employed,
recurrent patterns in the design of components,
and, on an architectural level, the problems in
supporting multiple languages and distribution.
<p>
We will discuss the scope of
our framework and the approach taken in its realization
as a collection of classes.
In particular we will delineate the recurrent 
patterns that we employed in its design and,
on an architectural level, the idioms we employed
for the concrete realization of the basic concepts
underlying the framework.
To illustrate the role of the
patterns and their associated idioms in our framework,
we will discuss the construction of
our Web components. 
<p>
We observe that there 
is a tension between
defining a clean object model and providing the flexibility
needed to support a multiparadigm approach.
We resolved this tension by choosing to differentiate
between the object model (that is class interfaces)
offered to the average user of the framework and
the object model offered to advanced users
and system-level developers.
<p>
In our work, idioms play a central role,
that is we achieved the desired flexibility by
systematically employing a limited number of basic idioms.
We succeeded in hiding these idioms from the average
user of the framework.
However, the simplicity of our original object model
is only apparent.
Advanced or system-level developers who intend to define
extensions to the framework must be well aware
of the patterns underlying the basic concepts,
that is the functionality requirements of the classes involved,
and the idioms employed in realizing these requirements.
<p>
Patterns and their associated idioms have guided
us in defining an architecture that allows for
transparently extending the functionality of our framework.
However, with respect to issues of distribution,
the idioms employed provide only a partial solution.
To realize a framework for distributed applications,
we have felt the need to provide additional language
support as well, that is by extending existing
O-O languages with support for parallelism and distribution.
<p>
Our framework has evolved gradually over the years.
Reflecting on the approach we have taken and the problems 
encountered, 
we will evaluate the relative merits of employing patterns
and indicate the costs, in terms of development efforts,
incurred by using them in the realization
of our framework.
<p>
Keywords and phrases:
<i>
object-oriented framework, multiparadigm,
distributed hypermedia, web-based applications,
patterns, idioms, languages, development costs</i>

</abstract>





<control><p></control>
<footnotetext>
Part of the material presented here has been
adapted from <a href=http://www.cs.vu.nl/~eliens/ftp/book/poosd.html>
Principles of Object-Oriented Software Development </a>
by Anton Eli&euml;ns, (c) 1995 Addison-Wesley Publishing Co. Inc.
</footnotetext>
<!--\def\thefootnote{\arabic{footnote}}-->


<control>
<!-- <cite file=refs>XX</cite> -->
</control>



<h1>Introduction</h1>
<control>
<!--
<navigate level=1 back=index root=index up=index next=index>
-->
<hr>
<a href=intro.html>introduction </a>
<a href=dejavu.html>framework </a>
<a href=rules.html>patterns</a>
<a href=design.html>components</a>
<a href=conc.html>conclusions</a>
<a href=refs.html>references </a>
<a href=appendix.html>appendix</a>
<a href=10.html>experience</a>
</control>
<hr>
</control>

For both users and developers,
delineating the patterns and idioms underlying
the realization of an object-oriented framework
is slowly being recognized to be of critical
importance for understanding the inherent complexity
of the framework.
<p>
The DejaVu framework, that we are developing,
is meant to provide a flexible and
easy-to-use
environment for intelligent,
distributed hypermedia applications.
In particular, the <i>hush</i>
(<i>hyper utility shell</i>) library
and its extensions offer support for the
development of multimedia user interfaces,
and is used in practical CS2 and CS3 software
engineering assignments.
The focus of our research has recently shifted towards
Web-integrated applications,
that allow for including Web-aware
widgets as a (GUI) component in an application.
In order to realize the functionality of <i>hush</i>
in a flexible fashion,
a systematic use has been made of a limited number
of patterns,
namely the <i>nested components</i> pattern and
the <i>actor</i> pattern.
For the actual implementation <i>hush</i> we employed
an improved version of the <i>handle/body</i> idiom,
and the derived
<i>virtual self-reference</i> and
<i>dynamic role-switching</i> idioms that underly
the patterns mentioned.
<p>
To clarify the distinction between patterns and idioms
we emphasize that the patterns
provide a solution to a problem of design,
whereas idioms are to be regarded as a convenient
implementation technique.


<h4>Related work</h4>
Clearly, a rich variety
of patterns and idioms has already been
extracted from the development of GUI toolkits
as testified by the collection in [_GOF],
which is primarily drawn from the experience
of developing Interviews [_Interviews]
and ET++ [_ET].
Nevertheless,
our work shows a flaw in one of the commonly used
idioms, notably the <i>handle/body</i> idiom,
and may further be considered of interest
due to our approach of realizing
the <i>handle/body</i> idiom and idioms derived from it.
Our <i>actor</i> pattern
and associated <i>dynamic role switching</i> idiom,
moreover, seem to be more powerful
than similar patterns known from the literature.

<h4>Structure</h4>
The structure of this paper is as follows.
First, we will give a brief overview of
the DejaVu framework and the basic concepts of
the <i>hush</i> library.
Then we will characterize the patterns and idioms
employed in developing hush and its extensions.
As an illustration of our approach,
we will discuss the design of the Web-related
components of our framework.
And finally, we will discuss the relative merits
of the patterns and idioms employed.
<control>
<!--
<navigate level=1 back=index root=index up=index next=index>
-->
<hr>
<a href=intro.html>introduction </a>
<a href=dejavu.html>framework </a>
<a href=rules.html>patterns</a>
<a href=design.html>components</a>
<a href=conc.html>conclusions</a>
<a href=refs.html>references </a>
<a href=appendix.html>appendix</a>
<a href=10.html>experience</a>
</control>
<hr>
</control>

<h1>The DejaVu framework</h1>
<control>
<!-- <cite file=refs>XX</cite> -->
</control>


<control>
<!--
<navigate level=1 back=index root=index up=index next=index>
-->
<hr>
<a href=intro.html>introduction </a>
<a href=dejavu.html>framework </a>
<a href=rules.html>patterns</a>
<a href=design.html>components</a>
<a href=conc.html>conclusions</a>
<a href=refs.html>references </a>
<a href=appendix.html>appendix</a>
<a href=10.html>experience</a>
</control>
<hr>
</control>


The problem addressed in the DejaVu project
is essentially to provide support for the
software engineering of (moderately complex)
applications that require, apart from other
functionality, multimedia interfaces and associative 
online help.
Such support is primarily offered in the form
of class libraries, most of which are written in C++.
The language C++ was chosen for pragmatic reasons,
since it allows for easily wrapping public
domain software written in C in classes with a 
more user-friendly interface.
Another reason was that C++ seemed to be 
the right vehicle for programming assignments,
with regard to its ever more widespread use.
<p>
Application development
generally encompasses a variety of programming tasks,
including system-level software development
(for example for networking or multimedia functionality),
programming the user interface
(including the definition of screen layout
and the responsivity of the interface widgets to user
actions),
and the definition of (high-level) application-specific
functionality.
Each of these kinds of tasks may require
a different approach and possibly
a different application programming language.
For example, the development of the user interface
is often more conveniently done
using a scripting language,
to avoid the waiting times involved
in compiling and linking.
Similarly, defining knowledge-level
application-specific functionality may
benefit from the use of a declarative
or logic programming language [_VE95].
<p>
In our project, we decided from the start to
support a multiparadigm approach to software
development and consequently we had to
define the mutual interaction between the
various language paradigms, as for example 
the interaction between C++ and a scripting language,
such as Tcl [_Tcl].
Current scripting languages, including Python [_Python] and Tcl,
provide facilities for being embedded in C and C++,
but extending these languages with functionality defined
in C or C++ and employing the language
from within C/C++ is rather cumbersome.
The <i>hush</i> library offers a uniform
interface to a number of script languages,
and
in addition, it
offers a variety of widgets and multimedia
extensions, that are accessible through
any of the script interpreters as well
as the C++ interface.

<h4>Basic concepts</h4>
These concepts are embodied in (pseudo) abstract
classes that are realized by employing patterns
based on idioms
extending the <i>handle/body</i>
idiom, as explained later on.

<ul>
<li> <i>session</i> -- to manage (parts of) the application
<li> <i>kit</i> -- to provide access to the underlying system and interpreter
<li> <i>handler</i> -- to bind C++ functionality to events
<li> <i>event</i> -- stores information concerning user actions or system events
 
<li> <i>action</i> -- stores information of the binding of a handler
 
<li> <i>widget</i> -- to display information on a screen
<li> <i>item</i> -- represents an element of a widget
</ul>

Programming a <i>hush</i> application requires the
definition of an application class
derived from <i>session</i> to initialize
the application and start the (window environment)
main loop.
In addition, one may bind (C++) <i>handler</i> objects
to script commands by invoking the <i>kit::bind</i>
function.
Handler objects are to be considered
an object realization of callback functions,
with the advantage that client data may be
accessed in a type-secure way
(that is either by resources stored when creating the
handler object or by information that is passed via events).
When invoked, a handler object receives a pointer to
an <i>event</i>
(that is, either an X event or an event related to
the evaluation of a script command).
The information that results from binding
a handler to a script command
is stored in an <i>action</i> object,
that is used by both widgets and (graphical) items
to bind window events (resulting from user actions)
to the handler (callback) objects.
Both the <i>widget</i> and <i>item</i> class are
derived from <i>handler</i> to
allow for declaring widgets and items to be their own handler.


<h4>The art of hush programming</h4>
In fact, every class in the <i>hush</i> library
(except for the <i>handler</i> class itself)
is derived from the <i>handler</i> class,
to allow for defining a script interface for
these classes.
In a similar way, the extensions to <i>hush</i> are
required to define appropriate widget classes,
and possibly specialized <i>handler</i> classes and
<i>event</i> classes dealing with particular
events
(such as for example file descriptor events
for communicating via sockets or notification
events resulting from joining a ToolTalk session [_ToolTalk]).
The extensions include
<ul>
<li> <i>sim</i>   -- for discrete event simulation
<li> <i>hymne</i> -- for sound synthesis and music
<li> <i>web</i>   -- for connecting to the Web
<li> <i>video</i> -- for digital video
<li> <i>vr</i> -- for the OpenGL-based VRML extension
</ul>
For the average user, programming in <i>hush</i>
amounts (in general) to instantiating widgets and
appropriate handler classes,
or derived widget classes that define their own
<i>handler</i>.
However, advanced users and system-level programmers
developing extensions are required to comply
with the constraints resulting 
the patterns underlying the design of <i>hush</i>
and the application of their associated idioms
in the realization of the library.
In the next section, we will outline the rules
of the game.
<control>
<!--
<navigate level=1 back=index root=index up=index next=index>
-->
<hr>
<a href=intro.html>introduction </a>
<a href=dejavu.html>framework </a>
<a href=rules.html>patterns</a>
<a href=design.html>components</a>
<a href=conc.html>conclusions</a>
<a href=refs.html>references </a>
<a href=appendix.html>appendix</a>
<a href=10.html>experience</a>
</control>
<hr>
</control>

<h1>The rules of the game -- patterns and idioms</h1>
<control>
<!--
<navigate level=1 back=index root=index up=index next=index>
-->
<hr>
<a href=intro.html>introduction </a>
<a href=dejavu.html>framework </a>
<a href=rules.html>patterns</a>
<a href=design.html>components</a>
<a href=conc.html>conclusions</a>
<a href=refs.html>references </a>
<a href=appendix.html>appendix</a>
<a href=10.html>experience</a>
</control>
<hr>
</control>


The design of <i>hush</i> and its extensions can be understood 
by a consideration of two basic patterns
and their associated idioms,
that is the <i>nested-component</i> pattern
(which allows for nesting components that have a similar interface)
and the <i>actor</i> pattern
(which allows for attributing different modes or roles
to objects).

The realizations of these patterns are based on idioms
extending an improved version of the familiar
<i>handle/body</i> idiom.
Our improvement concerns the introduction of
an <i>explicit invocation context</i> which is needed to
repair the disruption of the virtual function call mechanism
caused by the delegation to 'body implementation' objects.

<p>
In this section, we will first discuss the <i>handle/body</i> idiom
and its improvement.
Then we will discuss the two basic patterns underlying
the design of <i>hush</i>
and we will briefly sketch their realization by extensions of
the (improved) <i>handle/body</i> idiom.


<h2>The handle/body idiom -- invocation context</h2>

The <i>handle/body</i> idiom 
allows for
separating the definition of a component's
interface (the handle class) from its
realization (the body class). All intelligence is
located in the body, and (most) requests to the handle object
are delegated to its implementation.

In order to optimize the creation and destruction of dynamically
allocated objects, one may use techniques such as
<em>representation or resource sharing</em> 
and <em>reference counting</em>.
However, the use of these techniques can put a heavy burden on
the application programmer.
The <i>handle/body</i> idiom was 
introduced in [_Coplien] as a means to hide the use 
of such low-level issues
from the application programmer,
by adding a level of indirection,
that is delegation to a 'body' implementation
object.
An additional advantage of applying the idiom is that
it allows interface classes to become stable
while improving on the realization.
In practice, by applying the idiom one may avoid
recompilation of dependent code as long as the interface class
does not change.


<h4>Invocation context</h4>
The <i>handle/body</i> idiom is one of the most popular idioms
[_Coplien,Eliens95,GOF,Stroustrup,Pree].
It underlies 
several other idioms and patterns
(e.g. the envelope/letter idiom [_Coplien], the Bridge and Proxy
patterns [_GOF]).
However, despite the fact that it is well-documented
there seems to be a major flaw in its realization. 
Its deficiency lies in the fact that the
dynamic binding mechanism is disrupted by introducing
an additional level of indirection
(by delegating to the 'body' object),
since it is not possible to make calls to member functions which
are refined by subclasses of the (visible) handle class in the
implementation of the (hidden) body class.  We restored the working of
the normal virtual function mechanism by introducing the notion of
<em>explicit invocation context</em>.  In this way, the handle/body
idiom can be applied completely transparently, even for
programmers of subclasses of the handle.
<p>
In our realization of the <i>handle/body</i> idiom
the handle class is used both as the interface class
to access functionality
implemented by its body, and as a semi-abstract base class, defining
the interface of the body classes which are derived from the handle.
The body object is typically instantiated directly by the
constructor of the handle, but this action may be deferred to the
moment of first use, or may be done indirectly by using an abstract
object factory [_GOF].
To be able to make calls to member functions redefined by user-defined
subclasses of the handle class, the body class must make such calls
via the handle class as well. 
See <a href="handle.html">appendix A</a> for a detailed 
treatment of the idiom and its improvement.

<h4>Usage</h4>
The (improved version of) the idiom is frequently used
in the <i>hush</i> class library. 
The widget library is build of a stable
interface hierarchy, offering several common GUI widgets classes like
buttons, menus and scrollbars.  The widget (handle) classes are
implemented by a separate, hidden implementation hierarchy, which
allows for changing the implementation of the widget library, without the
need to recompile dependent applications.  Additionally, the idiom
helps us to ensure that the various widget implementations are used in
a consistent manner (e.g. to prevent simultaneous use of Motif buttons and
OpenLook scrollbars)

<h2>The nested component pattern</h2>

The <i>nested component</i> pattern has been introduced
to support the development of compound widgets.
It allows for (re)using the script and C++ interface
of possibly compound widgets, by employing explicit redirection to
an inner or primary component.

<h4>Problem</h4>
Inheritance is not always a suitable technique for code sharing
and object composition. A familiar example is the combination of a
Text object and two scrollbars into a ScrollableText object.
In that case, most of the functionality of ScrollableText will
be equal to that of the Text object.
This problem may be dealt with by employing multiple
inheritance.
Using single inheritance, it may be hard to
inherit this functionality directly and add extra functionality
by attaching the scrollbars,
especially when interface inheritance and implementation inheritance
coincide.

<h4>Background</h4>
The <i>nested component</i> pattern is closely
related to the Decorator pattern [_GOF] and InterViews notion of
MonoGlyph [_Interviews]. Additionally, by using explicit delegation
it provides an alternative form of code sharing than inheritance
as can be found in languages supporting <em>prototypes</em> or 
<em>exemplars</em> such as Self [_Ungar92].

<h4>Realization</h4>
The <i>nested component</i> pattern is realized by
applying the <i>virtual self-reference</i> idiom.
Key to the implementation of that idiom is the virtual
<i>self()</i> member of a component. The <i>self()</i>
member returns a
reference to the object itself (e.g. <i>this</i> in C++) by default,
but returns the inner component if the outer object explicitly
delegated its functionality by using the <i>redirect()</i> member.
Note that chasing for <i>self()</i> is recursive,
that is (widget) components can be nested to arbitrary depth.
The <i>self()</i> member must be used to access the functionality
that may be realized by the inner component.
Note that the realization of the idiom uses inheritance primarily for
interface sharing, and not for code sharing and object composition.
See <a href="widget.html">appendix B</a> for a detailed code example.

<h4>Usage</h4>
The <i>nested component</i> pattern is employed
in designing the <i>hush</i> widget hierarchy.
Every (compound) widget
can delegate part of its functionality to an inner component.
It is common practice to derive a compound widget from another
widget by using interface inheritance only, and to delegate
functionality to an inner component by explicit redirection.

<h2>The actor pattern</h2>

The <i>actor</i> pattern provides
a means to offer a multitude of functional modes
simultaneously.
For example, a single <i>kit</i> object gives access to
multiple (embedded) script interpreters,
as well as (possibly) a remote kit.


<h4>Problem</h4>
For many applications, static type hierarchies do not provide the
flexibility needed to model dynamically changing roles. For example we
may wish to consider a person as an actor capable of various roles
during his lifetime, some of which may even coexist concurrently.
The characteristic feature of the actor
pattern is that it allows us to regard a particular entity
as being attributed various roles or modes
and that the behavior of that entity changes
accordingly. 

<h4>Background</h4>
Changing roles or modes can be regarded
as some kind of state transition, and
indeed the actor pattern 
(and its associated <i>dynamic role-switching</i> idiom)
is closely related to the
State pattern [_GOF]. In both cases, a single object is used to
access the current role (or state) of a set of several role (or
state) classes.
In combination with the <i>virtual self-reference</i>
idiom, our realization of
the <i>actor</i> pattern allows for changing
the role by installing a new actor.

<h4>Realization</h4> 
The realization of the actor pattern employs the
<i>dynamic role-switching</i> idiom,
which is implemented by extending the handle class
with a set of several bodies instead of only one.
To enable role-switching,
some kind of indexing is needed. Usually, a dictionairy
or a simple array of roles will be sufficient.
See <a href="actor.html">appendix C</a> for a detailed code example.

<h4>Usage</h4>
In the <i>hush</i> library the actor pattern is used
to give access to multiple
interpreters via the same interface class (i.e. the <i>kit</i> class).
The pattern is essential in supporting the multi-paradigm nature
of the DejaVu framework.
In our description of the design of the Web components
in section <ref file=design>Design</ref>, 
we will show how <i>dynamic role-switching</i> is employed
for using
various network protocols via the same <i>(net)client</i> class.
The actor pattern is also used to define a (single)
viewer class that is
capable of displaying documents of various MIME-types
(including SGML, HTML, VRML).
<control>
<!--
<navigate level=1 back=index root=index up=index next=index>
-->
<hr>
<a href=intro.html>introduction </a>
<a href=dejavu.html>framework </a>
<a href=rules.html>patterns</a>
<a href=design.html>components</a>
<a href=conc.html>conclusions</a>
<a href=refs.html>references </a>
<a href=appendix.html>appendix</a>
<a href=10.html>experience</a>
</control>
<hr>
</control>

      <h1>Design of Web Components --- an example</h1> 
<control>
<!--
<navigate level=1 back=index root=index up=index next=index>
-->
<hr>
<a href=intro.html>introduction </a>
<a href=dejavu.html>framework </a>
<a href=rules.html>patterns</a>
<a href=design.html>components</a>
<a href=conc.html>conclusions</a>
<a href=refs.html>references </a>
<a href=appendix.html>appendix</a>
<a href=10.html>experience</a>
</control>
<hr>
</control>

      <!--\label{Design}-->
      
      <p>As an illustration of our approach, we will discuss the
	design of the Web-related components [_WWW95b] of our framework.
	The design has been influenced by the following requirements:
      <ul>
	<li><i>Communication protocols</i> -- 
	The dominant communication protocol of the Web is currently
	HTTP. New or enhanced communication [_Chatting] and network
	transfer protocols will be needed.
	  
	<li><i>Client-side computing</i> --  With the announcement of Java
	  and the realization of the HotJava [_Java]
	  browser, client-side computing by means of high-level
	  scripting languages has been accepted as a powerful and
	  flexible means to enhance the dynamic capabilities of
	  Web-browsers.
	  
	<li><i>Document formats</i> --
	  While HTML is well suited as a general purpose mark-up
	  language, more domain specific and more powerful document
	  formats will be needed, especially when more sophisticated
	  multimedia structures have to be encoded. 
      </ul>
      
      <!-- \begin{figure}
      \vspace{0.8cm}\epsfig{file=web.eps,width=\linewidth}
      \caption{Relationships between the Web components}
      \label{fig:web} 
      \end{figure} -->
      
      <h4>The Web Components</h4> 

      <p>Figure 1 shows the design of the basic Web-related components
	of the hush class library.  The <i>browser</i> provides the
	toplevel user interface for all Web components, including a
	viewer, scrollbars, navigation buttons (back, forward, home,
	reload) and an entry box to enter URLs.  The <i>client</i>,
	<i>web</i> and <i>viewer</i> components form the conceptual
	base of our approach of viewing the Web. Each component can be
	extended in a simple way, due to a systematic application of the
	idioms discussed previously. 

      
      <p>Multiple <i>viewers</i> are accessible via the <i>MIMEviewer</i>
	which employs the actor pattern to be able to display various
	types of MIME-encoded data (e.g. HTML, SGML combined with Tcl
	style sheets, VRML).  The viewer contains a dictionary of
	several viewer actors, that is indexed on the associated
	MIME-types. In this way, new viewers can be easily added, even
	dynamically.  The viewer implementation classes can make use
	of existing widgets to display parts of structured documents,
	which simplifies their implementation.  Another advantage of
	this design is the fact that whenever a viewer for a new MIME
	type has been added, it is possible to inline this data type
	in an SGML or extended-HTML document, via recursive usage of a
	viewer widget in another viewer.  In other words, it is
	possible to inline VRML or video into an HTML document, or
	even to insert an HTML-page into another HTML-page.  The
	SGML-viewer uses an SGML-compliant [_SGML] validating parser
	[_SP] and an (experimental) style sheet mechanism based
	on the Tcl scripting language. This approach allows for
	experimenting with new (multimedia) document formats.  
	Since the viewer provides no network functionality at all, it
	generates an event whenever it needs to retrieve data pointed
	to by a URL. Such events are generated as a response to user
	interaction (e.g. clicking an anchor) or to fetch inline data
	during the parsing process.  These events (realized by the
	hidden urlevent class) are typically handled by a <i>web</i>
	component.
	

      
      <p>The <i>client</i> component provides an abstraction of network
	(file) access and transport protocols.
	An important consideration in the design of this component was the
	requirement to allow for new network transfer protocols.
	This requirement has been met by employing the actor
	pattern. The client component implicitly changes its role,
	depending on the protocol required for fetching the data.  When the
	client component gets the instruction to retrieve a URL, it inspects
	the URL, decides what role it needs and switches to the
	appropriate role.
	
      
      <p>The <i>web</i> component combines the functionality of the
	viewer and client components.  It is able to follow links by
	retrieving data via several protocols (e.g. HTTP, files, FTP),
	a task delegated to its <i>client</i> component.
	Additionally, the <i>web</i> component adds a history and caching
	mechanism to the <i>MIMEviewer</i>. The <i>web</i> widget uses the
	nested component pattern described in section 3.  This means
	that <i>web</i> inherits the interface of the MIMEviewer and
	delegates its (viewer) functionality to a inner viewer
	component.  The <i>web</i> component's behavior is similar to the
	standard widgets of the framework, and can be conveniently
	used as a part of an application's GUI.  Because the <i>web</i>
	widget has both a C++ interface and a Tcl interface, it
	is easy to create, or extend, applications with Web
	functionality.
<control>
<!--
<navigate level=1 back=index root=index up=index next=index>
-->
<hr>
<a href=intro.html>introduction </a>
<a href=dejavu.html>framework </a>
<a href=rules.html>patterns</a>
<a href=design.html>components</a>
<a href=conc.html>conclusions</a>
<a href=refs.html>references </a>
<a href=appendix.html>appendix</a>
<a href=10.html>experience</a>
</control>
<hr>
</control>
	
<h1>Conclusions</h1>
<control>
<!--
<navigate level=1 back=index root=index up=index next=index>
-->
<hr>
<a href=intro.html>introduction </a>
<a href=dejavu.html>framework </a>
<a href=rules.html>patterns</a>
<a href=design.html>components</a>
<a href=conc.html>conclusions</a>
<a href=refs.html>references </a>
<a href=appendix.html>appendix</a>
<a href=10.html>experience</a>
</control>
<hr>
</control>

<control>
<!-- <cite file=refs>XX</cite> -->
</control>



Our involvement with patterns and idioms 
came naturally from our concern to develop a
flexible and easy-to-use framework.
From its inception we applied idioms
(called <i>composition mechanisms</i> in 
[_Eliens95]) in the realization of the <i>hush</i> library.
Reflecting on the design of <i>hush</i> we identified
two recurrent patterns,
the <i>nested component</i> pattern and the <i>actor</i>
pattern,
which may be regarded as design level generalizations of their
associated idioms.
<p>
With respect to meeting the requirements of
flexibility and extensibility, our approach 
has proved its worth.
However with respect to the software development
efforts involved, the systematic application of
the idioms described has drawbacks as well.
For example, we found that applying (the naive version of)
the <i>handle/body</i> idiom led to disrupting the
virtual function call mechanism
and hence to inconsistencies in the class hierarchy
and additional coding effort.
Our improved version solved the first two of these problems.
Also, we found that the use of separate
body implementation classes gave rise to the
introduction of many additional classes.
To avoid a pollution of the class name space,
we decided to export only a limited number
of classes and to employ a suitable idiom for hiding
the concrete subclasses.
<p>
To evaluate, our experiences are positive, but we had to pay a price.
First of all, applying the idioms led to a
significantly increased design effort,
and secondly, additional coding effort (and discipline)
is needed for implementing system level components.
In the table below we
give a qualitative assessment of how the use of idioms
may affect, in our experience, aspects such
as <i>reliability</i>,
<i>adaptability</i>, <i>maintainability</i> 
and <i>performance</i> [_Ramp,Eliens95].




<center>
<table><!--{|l|c|c|c|}-->
<tr><td>Requirement		<td>body/handle	<td>virtual self<td>role-switching
<tr><td><b>R</b>eliability	<td>+/$-$		<td>$-$		<td>$-$
<tr><td><b>A</b>daptability	<td>+		<td>+/$-$		<td>++
<tr><td><b>M</b>aintainability	<td>+		<td>+		<td>$-$
<tr><td><b>P</b>erformance	<td>$-$		<td>$-$		<td>$--$
</table>
</center>


With respect to <i>reliability</i>
the <i>handle/body</i> idiom may be considered neutral,
whereas both the <i>virtual self</i> and <i>role-switching</i>
idiom may introduce errors due to their complexity.
<p>
No doubt, <i>adaptability</i> is improved by employing
the <i>handle/body</i> idiom and even more by employing
the <i>role-switching</i> idiom.
<p>
The aspect of <i>maintainability</i>
is positively affected by applying the
<i>handle/body</i> and <i>virtual self</i> idiom,
yet moderately negative by
<i>role-switching</i>.
<p>
In terms of both memory usage and
run-time efficiency, loss of <i>performance</i>
will result from applying idioms.
Apart from the creation and deletion of additional
objects,
additional object references are required
as well as additional de-referencing
and, in the case of <i>role-switching</i>,
array indexing or hash table search.
Nevertheless, the performance loss is certainly not dramatic,
in particular with regard to the benefits of
having a single uniform interface for the application programmer
and at the same time the flexibility needed
in a research environment.
<p>
Concluding, we have stated our experiences which indicate
that patterns are profitable but also that
<i>"patterns do not come for free"</i>.
On the contrary, the employment of patterns
and their associated idioms incur significant
costs in terms of software development efforts
and, in addition, may affect the quality of
the software with respect to aspects such as
reliability, maintainability and performance.
<p>
<control>
<!--
<navigate level=1 back=index root=index up=index next=index>
-->
<hr>
<a href=intro.html>introduction </a>
<a href=dejavu.html>framework </a>
<a href=rules.html>patterns</a>
<a href=design.html>components</a>
<a href=conc.html>conclusions</a>
<a href=refs.html>references </a>
<a href=appendix.html>appendix</a>
<a href=10.html>experience</a>
</control>
<hr>
</control>

<document[slides]{style}>

<bibliography>
<control>
<!--
<navigate level=1 back=index root=index up=index next=index>
-->
<hr>
<a href=intro.html>introduction </a>
<a href=dejavu.html>framework </a>
<a href=rules.html>patterns</a>
<a href=design.html>components</a>
<a href=conc.html>conclusions</a>
<a href=refs.html>references </a>
<a href=appendix.html>appendix</a>
<a href=10.html>experience</a>
</control>
<hr>
</control>


%K Ramp
%A E.H. Bersoff and A.M. Davis,
%T Impacts of a life cycle models on software configuration managment
%O CACM 34(8), pp. 105-117

%K SP
%A J. Clark,
%T SP --- An SGML parser
%O Available at http://www.jclark.com/sp.html, October 1995

%K Coplien
%A J. Coplien,
%B Advanced C++ Programming Styles and Idioms
%O Addison-Wesley (1992) 

%K DoornEl95b
%A M. van Doorn and A. Eliens,
%T Integrating WWW and Applications,
%O Third Int. World Wide Web Conf. --
Technology, Tools and Applications,
April 10-14, 1995, Darmstadt 

%K DLP
%A A. Eliens,
%B <a href=http://www.cs.vu.nl/~eliens/books/dlp>
DLP - A language for distributed logic programming</a>,
%O Wiley (1992)

%K Eliens95
%A A. Eliens,
%B <a href=http://www.cs.vu.nl/~eliens/book/poosd.html>
Principles of Object-Oriented Software Development</a>,
%O Addison-Wesley (1995)

%K Eliens95b
%A A. Eliens,
%T <a href=http://www.cs.vu.nl/~eliens/hush/>
Hush -- a C++ API for Tcl/Tk</a>, 
%O The X Resource, Issue 14, April 1995, pp. 111-155

%K GOF
%A E. Gamma, R. Helm, R. Johnson and J. Vlissides
%B Design Patterns -- Elements of reusable object-oriented software
%O Addison-Wesley (1994)

%K Java
%A J. Gosling and H. McGilton
%T The Java(tm) Language Environment: A White Paper
%O Sun Microsystems, available at <a href=http://java.sun.com/whitePaper/java-whitepaper-1.html>
http://java.sun.com/whitePaper/java-whitepaper-1.html</a>

%K ToolTalk
%A A.M. Julienne and B. Holtz,
%B ToolTalk & Open Protocols --- Inter-Application Communication
%O SunSoft Press/Prentice Hall 1994

%K Interviews
%A M. Linton, J. Vlissides and P. Calder, 
%T Composing user interfaces with Interviews,
%O IEEE Computer 22(2), 1989, pp. 8-22

%K SGML
%A ISO 8879:1986,
%T Information Processing --- Text and Office Information Systems --- Standard
Generalized Markup Language,
%O International Organization for Standardization, 1986

%K WWW95b
%A J.R. van Ossenbruggen and A. Eliens,
%T Bringing Music to the Web
%O Proc. WWW95, Boston

%K Tcl
%A J. Ousterhout,
%B Tcl and the Tk Toolkit
%O Addison-Wesley, 1995

%K Pree
%A Wolfgang Pree,
%B Design Patterns for Object-Oriented Software Development,
%O ACM Press Books. Addison-Wesley, 1995

%K Python
%A G. van Rossum,
%T Python
%O See <a href="http://www.python.org/">http://www.python.org/</a>

%K Stroustrup
%A B. Stroustrup,
%B The C++ Programming Language,
%O Addison-Wesley, 2 edition, 1991

%K Ungar92
%A D. Ungar, B.S. Smith, C. Chambers and U. H\"olze,
%T Object, message and performance: How they coexist in Self
%O <i>IEEE Computer</i> 25(10), pp. 53-63

%K VE95
%A C. Visser and A. Eliens,
%T A Language System Architecture for the Interoperability of
Distributed Multi-Paradigm Objects,
%O European Research Seminar on Advances in Distributed Systems,
L'Alpe d'Huez, April 3-7, 1995

%K ET
%A A .Weinand, E. Gamma and R. Marty,
%T ET++, an object-oriented application framework in C++,
%O In {\it Proc. OOPSLA'88}, pp.46-57

%K Chatting
%A M. van Welie and A. Eliens,
%T <a href=http://www.cs.vu.nl/~martijn/chatting.html>Chatting on the Web</a>
%O ERCIM W4G Workshop, 7-9 febr 1996, GMD St Augustin, Germany 
(availble at http://www.cs.vu.nl/~martijn/chatting.html)

<control>
<!--
<navigate level=1 back=index root=index up=index next=index>
-->
<hr>
<a href=intro.html>introduction </a>
<a href=dejavu.html>framework </a>
<a href=rules.html>patterns</a>
<a href=design.html>components</a>
<a href=conc.html>conclusions</a>
<a href=refs.html>references </a>
<a href=appendix.html>appendix</a>
<a href=10.html>experience</a>
</control>
<hr>
</control>

</bibliography>
</document>
<document class=article opt="a4,epsfig">
<control>
<!-- <cite file=refs>XX</cite> -->
</control>


<control>
<h1>Appendix</h1>
<control>
<!--
<navigate level=1 back=index root=index up=index next=index>
-->
<hr>
<a href=intro.html>introduction </a>
<a href=dejavu.html>framework </a>
<a href=rules.html>patterns</a>
<a href=design.html>components</a>
<a href=conc.html>conclusions</a>
<a href=refs.html>references </a>
<a href=appendix.html>appendix</a>
<a href=10.html>experience</a>
</control>
<hr>
</control>

</control>
<!-- \appendix \section*{Appendix} -->

<control>
<slide id=app cap="Appendix">
@ <a href=@talk-appendix.html target=_top>Appendix</a>
<ul>
<li> <a href=handle.html>The handle/body idiom</a>
<li> <a href=widget.html>Virtual self-reference</a>
<li> <a href=actor.html>The actor pattern</i>
</ul>
</slide>
</control>

<document>
<control>
<!-- <cite file=refs>XX</cite> -->
</control>



<h1>The Handle/Body Idiom</h1><!--\label{idiom}-->
<control>
<!--
<navigate level=1 back=index root=index up=index next=index>
-->
<hr>
<a href=intro.html>introduction </a>
<a href=dejavu.html>framework </a>
<a href=rules.html>patterns</a>
<a href=design.html>components</a>
<a href=conc.html>conclusions</a>
<a href=refs.html>references </a>
<a href=appendix.html>appendix</a>
<a href=10.html>experience</a>
</control>
<hr>
</control>

The handle/body class
idiom [_Coplien,Eliens95,GOF,Stroustrup,Pree] separates the class defining a component's
abstract interface (the handle class) from its
hidden implementation (the body class). All intelligence is
located in the body, and (most) requests to the handle object
are delegated to its implementation.


In order to illustrate the several idioms,
we use the following class as a running example:
<program><pre>
  class A { 
    public:
      virtual void f1()  { cout << "A::f1() "; f2(); }
      virtual void f2()  { cout << "A::f2()" << endl; }
  };
</pre></program>
<!-- %% \Ccode{a.cc} -->
The implementation of A is straightforward and does not 
make use of the handle/body idiom.
A call to the {\tt f1()} member function of A will print a message and
make a subsequent call to {\tt f2()}.

Without any modification in the behavior of A's instances, it is possible
to re-implement A using the handle/body idiom. The member functions of
class A are implemented by its body, and A is reduced to a simple
interface class:
<program><pre>
  class A {  // Handle class delegating to its body
    public:
      A();  // defined later
      virtual ~A() { delete body; }
      virtual void f1() { body->f1(); }
      virtual void f2() { body->f2(); }
    private: A* body;
    protected: A(int dummy);  // used by body
  };
</pre></program>
<!-- %% \Ccode{a_handle.cc} -->
Note that the implementation of A's body
can be completely hidden from the application programmer.
In fact, by declaring A to be the superclass of its body class,
even the existence of a body class can be hidden. If A is a class
provided by a shared library, new implementations of its body class
can be plugged in, without the need to recompile dependent applications:
<program><pre>
  class BodyOfA: public A { 
    public:
      BodyOfA();
      void f1()  { cout << "A::f1() "; f2(); }
      void f2()  { cout << "A::f2()" << endl; }
  };
</pre></program>
<!-- %% \Ccode{a_body.cc} -->
In this example, the application of the idiom has only two
minor drawbacks. First, in the implementation below, 
the main constructor of A
makes an explicit call to the constructor of its body class. 
As a result, A's constructor 
needs to be changed whenever an alternative implementation of the
body is required. The {\em Abstract Factory\/} pattern described in 
[_GOF].
may be used to solve this problem in a generic
and elegant way.
Another (esthetic) problem is the need for the dummy constructor
to prevent a recursive chain of constructor calls:
<program><pre>
  BodyOfA::BodyOfA(): A(911) { }  // Call dummy constructor of A
  A::A(int dummy) { body = 0; }   // to build an abstract instance of A
  A::A() { body = new BodyOfA; }  // to build a concrete instance of A
</pre></program>
<!--%%\Ccode{a_ctor.cc} ->
But the major drawback of the handle/body idiom occurs when deriving a
subclass of A which partially redefines A's virtual member functions.
Consider this definition of a derived class C:
<program><pre>
  class C: public A {
    public:
      void f2()  { cout << "C::f2()" << endl; }
  };
</pre></program>
<!-- %%\Ccode{c.cc} -->
Try to predict the output of a code fragment like:
<program><pre>
  C* c = new C; c->f1();    
</pre></program>
<!-- %%\Ccode{c_usage.cc} -->
The behavior of instances of C does indeed depend on whether
the hidden implementation of its base class A applies the 
handle/body idiom or not! If it does, the output will be {\tt A::f1() A::f2()}
because the indirect call to {\tt f2()} in
{\tt f1()} will (unexpectedly) not call the redefined version of {\tt f2()}.
The original definition of A would of course 
yield {\tt A::f1() C::f2()}.
%but this can only be obtained by deriving C directly from the (hidden) body class.

Note that this is a special case
of one of the main drawbacks of the OOP paradigm: the inability
to change base classes at the top of a 
hierarchy without introducing errors in derived classes.


<h4>Explicit Invocation Context</h4><!--\label{context}-->
In both implementations of A, 
the call to {\tt f2()} in {\tt f1()} is an abbreviation of
{\tt this->f2()}.
However, in the first, straightforward implementation of A, 
the implicit {\tt this} pointer
refers to the handle object (which can be an instance of a derived class).
In contrast, {\tt this} in the {\tt BodyOfA}
will refer to the body object.
As a consequence, the body object is
unable to make calls to functions redefined by classes derived from 
the base class A.

We use the term {\em invocation context\/} to denote a reference to the context
in which the original request for a specific service is made, and 
represent this by a pointer to the handle object.
In other words, 
the handle object needs a pointer to its body to be able to 
delegate its functionality, and, symmetrically, 
the body needs a pointer to the handle
in order to be able to use any redefined virtual functions.

The body can be redefined as:
<program><pre>
  class BodyOfA: public A {
    public:
      BodyOfA(A* h): A(911) { handle = h; }
      void f1() { cout << "A::f1() "; handle->f2(); }
      void f2() { cout << "A::f2()" << endl; }
    private:
      A* handle;	// reference to invocation context
  };
</pre></program>
<!-- %%\Ccode{a_body2.cc} -->
The new body class is aware of the fact that it
is implementing services which are accessed via the handle object.
Consequently, it can use this information and is able to make calls
to functions which might be redefined by descendents of A.

Note that this solution does require some programming discipline:
all (implicit) references to the body object should be changed into a
reference to the invocation context.
Fortunately, this discipline is only required in the body classes of the
implementation hierarchy.

Descendents of the handle classes in the public interface
hierarchy can share and redefine code implemented by the hidden
body classes in a completely transparent way, because all code sharing
takes place indirectly, via the interface provided by the handle classes.
However, even other body classes will typically share code via the 
handle classes.

Suppose the class C presented above delegates the implementation
of the {\tt f2()} member to its own body class, {\tt BodyOfC}. 
This body class may have access to the functionality offered by the body of A
in three different ways. First of all, it can call members which
are not redefined by C via its handle pointer. 

This will generally be the prefered method since it will correctly
call virtual functions, even for subclasses of C. 
<!--\begin{figure}-->
<hr>
<!-- \vspace{0.8cm}\hspace*{1cm}\epsfig{file=dual.eps,width=10cm} -->
<caption>Separating interface hierarchy and implementation.
Note that the arrow representing a handle/body bridge 
is a class/subclass relation as well.
</caption><!--\label{fig:dual}-->
<!-- \end{figure} -->
However, since {\tt BodyOfC} will typically be derived from its handle class C 
(figure~\ref{fig:dual}), it may consequently use
the services implemented by the body of A in another way: 
via the inheritance mechanism.
An instance of {\tt BodyOfC} contains a (non accessible) pointer to
its own, private instance of a {\tt BodyOfA}. However, by calling functions
inherited from A it makes use of this object indirectly.
We discuss an application of this mechanism in the next section. 
In most cases however, the existence of such a spurious body object is not desirable and
should be avoided. Note that the handle/body variant does already require 
a special constructor for C in order to prevent the recursive constructor chain, 
so we can use this constructor to prevent the creation of an extra body of A 
by calling the dummy constructor of A:
<program><pre>
  C::C(int dummy): A(dummy) { body = 0; } // avoid creation of bodies
</pre></program>
<!-- %%\Ccode{c_dummy.cc} -->

Since there is no inheritance relation between
the two body classes, access to the functionality implemented by the body of A 
will always be indirect.
However, in some cases it is useful to allow a third, direct, access method to the body 
of the base class. For example, alternative body classes for the same handle
can be defined to be direct subclasses of the original body.

<control>
<!--
<navigate level=1 back=index root=index up=index next=index>
-->
<hr>
<a href=intro.html>introduction </a>
<a href=dejavu.html>framework </a>
<a href=rules.html>patterns</a>
<a href=design.html>components</a>
<a href=conc.html>conclusions</a>
<a href=refs.html>references </a>
<a href=appendix.html>appendix</a>
<a href=10.html>experience</a>
</control>
<hr>
</control>

</document>
<h1><a name=Drawtool>Virtual self-reference</a></h1>
<control>
<!--
<navigate level=1 back=index root=index up=index next=index>
-->
<hr>
<a href=intro.html>introduction </a>
<a href=dejavu.html>framework </a>
<a href=rules.html>patterns</a>
<a href=design.html>components</a>
<a href=conc.html>conclusions</a>
<a href=refs.html>references </a>
<a href=appendix.html>appendix</a>
<a href=10.html>experience</a>
</control>
<hr>
</control>

<control>
<!-- <cite file=refs>XX</cite> -->
</control>


A special feature of the <i>hush</i> widget class
library is its support for the definition of
new composite widgets, which provide to the application
programmer the interface of a built-in (or possibly
other composite) widget.
To realize this flexibility, we introduced 
a <i>self()</i> function that adds
another level of indirection to self-reference.
For example, we may define a <i>drawtool</i> widget,
which provides for both the C++ programmer and
the (Tcl) script programmer the interface of an
ordinary (built-in) <i>canvas</i>:
<program><pre>
  class drawtool: public canvas {
    public:
      drawtool() { }                  // to declare drawtool
      drawtool(char* path) {
	initialize(path);             // constructs the components
	redirect(_canvas);            // delegate to _canvas component
      }
      int operator()() {              // interface to Tcl
	if (!strcmp("drawtool",argv[1])) return create(argc, argv);
	else return self()->eval( flatten(argc, argv) );
      }
    private:
      void initialize(char* path); 
      int create(int argc, char* argv[]);
      canvas* _canvas;
  };
</pre></program>
For completeness, the first constructor is only used
to define the script command <i>drawtool</i> as in
<program><pre>
  tk->bind("drawtool", new drawtool);
</pre></program>
which may occur in <i>main</i> or <i>prelude</i>
of the application class.
<p>
The call <i>redirect(_canvas)</i> in the regular constructor
results in delegating both member function calls
and script commands addressed at the <i>drawtool</i> widget
to the <i>canvas</i> widget pointed to by <i>_canvas</i>,
which is assumed to be created in <i>initialize</i>.
The <i>_canvas</i> widget acts, so to speak,
as the primary component of <i>drawtool</i>
in that it receives all bindings and (configuration) commands.
Actual redirection occurs by calling <i>self()</i>.
The definition of <i>widget::self()</i> is simply:
<program><pre>
  widget* self() { return _self?_self->self():this; }
</pre></program>
In other words, it checks the private <i>_self</i>
variable of the widget,
which may be given a value by <i>widget::_redirect</i>,
until <i>_self</i> is undefined (zero),
in which case the <i>this</i> pointer is returned.
In this way primary widget components can be embedded
at arbitrary depth within a composite widget,
without any need to adapt the interface of the
embedding (composite) widget.

Those well-versed in design patterns will recognize the <i>Decorator</i>
patterns (as applied in the Interviews <i>MonoGlyph</i> class
[_Interviews]).
<control>
<!--
<navigate level=1 back=index root=index up=index next=index>
-->
<hr>
<a href=intro.html>introduction </a>
<a href=dejavu.html>framework </a>
<a href=rules.html>patterns</a>
<a href=design.html>components</a>
<a href=conc.html>conclusions</a>
<a href=refs.html>references </a>
<a href=appendix.html>appendix</a>
<a href=10.html>experience</a>
</control>
<hr>
</control>

<document>
<control>
<!-- <cite file=refs>XX</cite> -->
</control>


<h1>Dynamic role-switching</h1>
<control>
<!--
<navigate level=1 back=index root=index up=index next=index>
-->
<hr>
<a href=intro.html>introduction </a>
<a href=dejavu.html>framework </a>
<a href=rules.html>patterns</a>
<a href=design.html>components</a>
<a href=conc.html>conclusions</a>
<a href=refs.html>references </a>
<a href=appendix.html>appendix</a>
<a href=10.html>experience</a>
</control>
<hr>
</control>

For many applications static type hierarchies
do not provide the flexibility needed
to model dynamically changing roles.
For example we may wish to consider a person
as an actor capable of various roles during his lifetime,
some of which may even coexist concurrently.
The characteristic feature of the
<i>dynamic role switching</i> idiom underlying the
<i>actor</i> pattern is that it
allows us regard a particular entity from multiple
perspectives
and that the behavior of that entity changes accordingly.
We will look at a possible realization of the idiom below.
<p>
Taking our view of a person as an actor
as a starting point, 
we need first to establish the repertoire of possible behavior.

<program><pre>
  enum Role { Person = 0 , Student, Employer, Final };
  
  class actor {                      // defines the repertoire
    public:
      actor() { } 
      virtual void walk()  { if (exists()) self()->walk();  }
      virtual void talk()  { if (exists()) self()->talk();  } 
      virtual void think() { if (exists()) self()->think(); }
      virtual void act()   { if (exists()) self()->act();   }
  
      virtual void become(Role) { }               // only for a person
      virtual void become(actor*) { }
  
      virtual actor* self() { return this; }         // an empty self
      int exists() { return self() != this; }        // who am I
    };
</pre></program>
Apart from the repertoire of possible behavior,
which consists of the ability to <i>walk</i>, <i>talk</i>,
<i>think</i> and <i>act</i>,
an actor has the ability to establish its own
identity (<i>self</i>) and to check whether it exists
as an actor, which is true only if it has become another self.
However, an actor is not able to assume a different role
or to become another self. We need a <i>person</i> for that!
<p>
Next, we may wish to refine the behavior of an actor
for certain roles, such as for example the <i>student</i>
and <i>employer</i> roles, which are among the many roles
a person can play.

<program><pre>
  class student : public actor {
    public:
      void talk()  { cout << "OOP" << endl; }
      void think() { cout <<  "Z"  << endl; }
  };
  
  class employer : public actor {
    public:
      void talk() { cout << "\$\$" << endl; }
      void act()  { cout << "business" << endl; }
  };
</pre></program>

Only a <i>person</i> has the ability
to assume a different role or to assume a different identity.
Apart from becoming a <i>Student</i> or <i>Employer</i>,
a person may for example become an <i>adult_person</i>
and in that capacity again assume a variety of roles.

<program><pre>
  class person : public actor {
    public:
      person();                         // to create a person
  
      void become(Role r);              // to become a ...
      void become(actor* p);            // change identity
  
      int exists() { return role[Person] != this; }
      actor* self() { return exists()?role[Person]->self():role[_role]; }
    private:
      int _role;
      actor* role[Final+1];             // the repertoire
    };
</pre></program>

A person may check whether he exists as a <i>Person</i>,
that is whether the <i>Person</i> role differs from the person's
own identity.
A person's <i>self</i> may be characterized as the actor
belonging to the role the person is playing,
taking a possible change of identity into account.

When a person is created, his repertoire is still empy.

<program><pre>
  person::person() {
     for (int i=Person; i <= Final; i++) role[i] = this;
     become(Person);
  }
</pre></program>
Only when a person changes identity by becoming
a different actor (or person) or by assuming
one of his (fixed) roles, he is capable of displaying
actual behavior.

<program><pre>
  void person::become(actor* p) { role[Person] = p; } ///// permanent

  void person::become(Role r) {
   require( Person <= r && r <= Final );
   if (exists()) self()->become(r);
   else {
     _role = r;
     if ( role[_role] == this ) {
       switch (_role) {
        case Person:  break;                  ///// nothing changes
        case Student: role[_role] = new student; break;
        case Employer: role[_role] = new employer; break;
        case Final: role[_role] = new actor; break;
       };
     }
   }
  }
</pre></program>

Assuming or 'becoming' a role results in creating
a role instance if none exists and setting the <i>_role</i>
instance variable to that particular role.
When a person's identity has been changed,
assuming a role takes effect for the actor that
replaced the person's original identity.
(However, only a person can change roles!)

The ability to become an actor allows us to model
the various phases of a person's lifetime
by different classes, as illustrated by
the <i>adult_person</i> class.

<program><pre>
  class adult_person: public person {
    public:
      void talk() { cout << "interesting" << endl; }
  };
</pre></program>

In the example code below we have a person
talking while assuming different roles.
Note that the person's identity may be restored
by letting the person become its original self.

<program><pre>
  person p; p.talk();                    ///// empty
  p.become(Student); p.talk();           ///// OOP
  p.become(Employer); p.talk();          ///// \$\$
  p.become(new adult_person); p.talk();  ///// interesting
  p.become(Student); p.talk();           ///// OOP (new student)
  p.become(&p); p.talk();                ///// \$\$ (old role)
  p.become(Person);  // initial state
</pre></program>

The <i>dynamic role switching</i> idiom
can be used in any situation where we wish
to change the functionality of
an object dynamically.
It may for example be used to incorporate
a variety of tools in a drawing editor,
as illustrated in [_Eliens95b].
<control>
<!--
<navigate level=1 back=index root=index up=index next=index>
-->
<hr>
<a href=intro.html>introduction </a>
<a href=dejavu.html>framework </a>
<a href=rules.html>patterns</a>
<a href=design.html>components</a>
<a href=conc.html>conclusions</a>
<a href=refs.html>references </a>
<a href=appendix.html>appendix</a>
<a href=10.html>experience</a>
</control>
<hr>
</control>

</document>

<control>
<!--
<navigate level=1 back=index root=index up=index next=index>
-->
<hr>
<a href=intro.html>introduction </a>
<a href=dejavu.html>framework </a>
<a href=rules.html>patterns</a>
<a href=design.html>components</a>
<a href=conc.html>conclusions</a>
<a href=refs.html>references </a>
<a href=appendix.html>appendix</a>
<a href=10.html>experience</a>
</control>
<hr>
</control>

</document>

</document>
