<slide id=www5-discussion cap="Discussion - What are APIs?">
<h2>Discussion - What are APIs?</h2>
<p>
The application areas and solutions, whether object-oriented
or not, covered a wide range of interests and
did not suggest a canonical approach to the
definition and development of APIs.
In particular, as has been mentioned before,
the somewhat blurry demarcation between
computation models, languages and APIs seem to confuse
all of us.
Moreover, a <a href=catalogue.html>catalogue of APIs</a>
seemed to be beyond our reach.
<p>
An attempt to overcome the confusion by
restricting ourselves to discussing the
requirements for the (future) Java class libraries
failed, surprisingly, because the majority felt
that the restriction to a particular (!)
language was not appropriate.
<p>
So the workshop was in danger of being halted,
with a number of questions unanswered.
What actions should we take in terms of recommendations
to the W3C?
What perspectives can we (meaningfully) distinguish?
And, what (exactly) are our areas of interest?
For example, although many of the solutions
proposed were object-oriented in spirit,
only few were so in the flesh.
</slide>

<slide id=www5-API cap="Dimensions of APIs">

<dl>
<dt><b>A</b>ctions
<dd><ul>
    <li>Define a distributed model of computation
	that suits the Web.
    <li>Define canonical (language-independent?) 
	object models for ... resources, application domains ...
    </ul>
<dt><b>P</b>erspectives
<dd><ul>
    <li> servers - extensions
    <li> browsers - clients, viewers, configuration
    <li> agents  - e.g. payment
    </ul>
<dt><b>I</b>nterests
<dd><ul>
    <li> distributed objects
    <li> plug-in components
    <li> formalization of requirements and solutions
    </ul>
</dl>
<p>
Nevertheless, we managed to break out of this impasse,
by reconsidering what APIs are meant for,
the development of Web-aware applications,
and we made a start of listing our basic <a href=needs.html>needs</a>.
</slide>
