.SUFFIXES: .t .c .tex .html .ps .gif

DISTRIB = .

LATEX = latex2e

.t.html:; ht-ml.flt < $*.t > $*.html
.c.html:; cc-ml.flt < $*.c > $*.html

TPS = ht-ml.flt -latex | html-latex.flt

default: all

trans:
	giftrans -t \#FFFFFF web-1.gif > web-comp.gif
 
index.html: index       
	ht-ml.flt < index > index.html
	cp index.html $(NAME).html
	touch index

.t.ps:
	cat $*.t | $(TPS) > $*.tex
	$(LATEX) $*.tex
	dvips < $*.dvi > $*.ps
	touch $*.t

.html.ps:
	html-latex.flt < $*.html > $*.tex
	$(LATEX) $*.tex
	dvips < $*.dvi > $*.ps

.tex.ps:
	$(LATEX) $*
	dvips < $*.dvi > $*.ps

.html.gif:
	html-latex.flt < $*.html > $*.tex
	$(LATEX) $*.tex
	dvips < $*.dvi > $*.ps
	convert $*.ps $*.gif

.eps.gif:
	convert $*.eps $*.gif


pack:
	@echo ---- Start distribution $(PACK) -----------
	@if [ ! -d $(DISTRIB) ]; then mkdir $(DISTRIB); fi
	@$(MAKE) clean
	@rm -f $(DISTRIB)/$(PACK).tar.Z $(DISTRIB)/$(PACK).uu;
	@set -x; tar cvf - $(SOURCE) > $(DISTRIB)/$(PACK).tar;
	@echo ---- Compressing $(PACK)
	@cd $(DISTRIB); compress $(PACK).tar; 
	@echo ==== Distribution $(PACK) completed ================


try:
	rm -f -r tmp
	mkdir tmp
	cp $(DISTRIB)/$(PACK).tar.Z tmp
	cd tmp; uncompress $(PACK).tar.Z
	cd tmp; tar xvf $(PACK).tar
