<body bgcolor="#FFFFFF" text="#000000">
<h1><a href=@talk-report.html target=_top>Workshop report</a> --
<a href=http://www.w3.org/pub/Conferences/WWW5/>WWW5</a>,
6 May 1996</h1>

Status: <a href=changes.html>20/5/96</a>
<br>
<a href=program.html>Program</a>

<hr>
<h1><a href=workshop.html>Programming the Web - a search for APIs</a></h1>
<a href=participants.html>Participants</a>,
<a href=keynote.html>Keynote</a>,
<a href=local/papers/index.html>Papers</a>,
<a href=refs.html>References</a>,
<a href=local/talk/war.html>Wrap-up</a>,
<a href=local/comments/index.html>Comments</a>,
<a href=local/adm/mailing.txt>Mailing list</a>
<hr>

<slide id=www5-intro cap="Introduction">
<h1>Introduction</h1>
<p>
There is  a trend towards replacing
monolithic general-purpose Web browsers
by more finely-tuned Web applications
enhanced with user-specific functionality,
such as for example applets that allow
for user-interaction or
the display of dynamic information.
<P>
This raises the issue of what support should be
provided for developing such applications.
So a workshop was organized for the WWW5
entitled <i>Programming the Web - a search for APIs</i>
with the goal of
defining  requirements for high-level APIs
and frameworks for Web programming, 
and characterizing suitable components
for Web-aware applications.
</slide>
<h2>Rationale</h2>
<p>
The workshop was intended to focus on
concepts and requirements for high-level API
suitable for developing Web-aware applications.
An explicit goal of the workshop was to publish
state of the art references to existing APIs.
<p>
The papers that were submitted covered a wide range of interests,
including computation models, applications and user
requirements, software architectures and libraries
as well as heuristics and guidelines for API developers.

<slide id=www5-rationale cap="Rationale">
@ Rationale
<dl>
<dt> <b>C</b>omputation Models  
<dd>
[_Model], [_DOOWWW], [_CAMEO], [_HIPPO], [_V6]
<dt> <b>A</b>pplications and Users
<dd>
[_Meta], [_UOD], [_URA], [_VAPIS], [_VEMMI] , [_Tele]
<dt> <b>S</b>oftware Architecture 
<dd>
[_W3CReference], [_V6],
[_Broker], [_CAMEO], [_DejaVu], [_Jigsaw], [_FastCGI]
<dt> <b>H</b>euristics and Guidelines
<dd>
[_W3CReference], [_Configure], [_VAPIS]
</dl>
</slide>

As can be expected opinions diverged
on many of the issues, even the need for APIs
to exist at all.
To get the flavor of the positions presented
by the participants, some of the points put forward
are listed below:
<slide id=www5-positions cap="Positions">
<ul>
    <li>APIs should be layered, open-ended, thread-safe,
        platform-independent, ...
    <li>Configuration must be part of API.
    <li>APIs must provide support for monitoring, notification 
        and triggering.
    <li>APIs should be avoided -- instead filter composition
        devices should be used.
    <li>APIs should provide for callbacks, plug-ins, ...
</ul>
</slide>

A summary of the papers can be found
together with the list of
<a href=participants.html#Positions>participants</a>.



<slide id=www5-organisations cap="Organisation">
<h2>Organisation</h2>
<p>
Apart from a keynote speech, the workshop
<a href=program.html>program</a>
consisted of four rounds:
<ol>
<li> <a href=round1.html>Round 1</a>:
Reference libraries -- configuration and composition
<li> <a href=round2.html>Round 2</a>: Objects and abstractions
<li> <a href=round3.html>Round 3</a>: Virtual APIs and Users
<li> <a href=round4.html>Round 4</a>: Objects and more objects
</ol>
and two discussion sessions
<ol>
<li> <a href=requirements.html>Requirements for APIs</a>
<li> <a href=discussion.html>A catalogue of state of the art APIs</a>
</ol>
</slide>
The discussions were lively, but did not result in a consensus
concerning requirements for APIs.
This remains a topic for further discussion.
Nevertheless, a wealth of material was presented,
some of which is reflected in the
<a href=catalogue.html>catalogue of APIs</a>.
This catalogue needs to be extended.
Also, what we need is an evaluation of the APIs listed there.
<p>
Note:
This report reflects my personal view of the workshop and its outcomes.
Look at the <a href=local/comments/index.html>comments</a> for an assesment
from the point of view of the participants.

<h2>Keynote -- What is the Web's model of computation? </h2>
The keynote was given by
Luca Cardelli.
As testified by a summary of the main points below
(recorded by Dave de Roure)
it is not altogether clear what exactly is
the Web's model of computation, nor what support should be provided
on a language level or API level.
 
<slide id=www5-keynote cap="Keynote -- What is the Web's model of computation?">
@ Keynote -- What is the Web's model of computation?
<ul>
<li> There is concept of "global computation" (eg crawlers) but...
<li> Web is not uniform (except HTTP)
<li> Speed of light is finite => mobility a necessity
<li> Single global structure not enough, view as multiple "global computers"
  ("intrawebs", maybe non<li>HTTP, non-Java-VM) each with some guarantees
<li> model of computation = language independent model for APIs
                       + model on which to base language constructs
<li> turn web into uniform structure or "program the complexity" (yes)?
<li> existing programming models don't capture locality
<li> observables like referential integrity and QoS not in trad. models
<li> Different languages may be appropriate for different
  "global computers" e.g. Telescript, Obliq, Java
<li> Semantics needed to understand computational assumptions and requirements, 
  answer important security questions, reason about programs
<li> Issues: Typing (MIME is a mechanism...?), security, reliability,
  modularity, resource management
</ul>
<p>
See http://www.research.digital.com/SRC/personal/Luca_Cardelli/home.html
for more material.
</slide>
<hr>
The slides are available at
(A4) http://www.research.digital.com/SRC/personal/Luca_Cardelli/Slides/WWW5APITalk.A4.ps
<br> 
(USLetter) http://www.research.digital.com/SRC/personal/Luca_Cardelli/Slides/WWW5APITalk.ps
<hr>
<p>
In particular, Cardelli's speech made clear
that the distinction between API, languages and
computation models is not clear cut.
<slide id=1 cap="Round 1">
<h2>Round 1: Reference libraries - configuration and composition</h2>
<p>
Frystik Nielsen [_W3CReference] presented
an overview of the LibWWW reference library,
featuring stream and channels, and offering support for 
plug-ins.
The LibWWW is an application-independent light-weight Web API.
Lessons learned from a previous version were that
APIs should be layered, open-ended and thread-safe.
Robert Thau [_Configure] stressed the importance of configuration.
He discussed some of the configuration options
available for the Apache server [_Apache].
In particular, configuration through an RPC-like mechanism,
or CORBA interface, needs to be studied.
</slide>
<slide id=2 cap="Round 2">
<h2>Round 2: Objects and abstractions</h2>
<p>
A variety of abstractions was presented, all intended
to facilitate the development of Web applications.
Bernard Lang [_V6] presented the <i>filter composition</i>
model underlying the V6 engine, which in a sense eliminates
the need for explicit APIs.
Mike Spreitzer [_DOOWWW] discussed a language-independent
mechanism for the realization of Web applications
employing distrubuted object [_ILU].
Finally, Richard Connor [_HIPPO] explored the idea
of using persistent objects.
</slide>

<h1>Requirements for APIs</h1>

To open the discussion about requirements
for APIs, an inventory was presented encompassing
complaints about the functionality of the Web,
observations concerning its 'nature',
general requirements for open systems development,
a wish-list of desired behavioral characteristics
and potential (technological) answers.

<slide id=www5-reqs cap="Requirements for APIs">
<dl>
<dt><b>C</b>omplaints
<dd><ul>
    <li>lack of referential integrity
    <li>undetected failures
    <li>no control over Quality of Service
    </ul>
<dt><b>O</b>bservations
<dd><ul>
    <li>dynamic quality of services
    <li>complex interaction
    </ul>
<dt><b>R</b>equirements
<dd><ul>
    <li>uniformity, openness, flexibility,
    orthogonality, layered, platform-independent
    </ul>
<dt><b>B</b>ehavior
<dd><ul>
    <li> reliable, configurable, monitoring, notification,
    triggering, thread-safe
    </ul>
<dt><b>A</b>nswers
<dd><ul>
    <li> object-oriented, components, virtual APIs, callbacks, plug-ins
    </ul>
</dl>
</slide>

It was observed by Mark Brown that requirements could
not be stated without an explicit indication of
a <b>perspective</b>, that is the kind of application
for which the API is intended.
In contrast, the [_W3Creference] library makes no such distinction,
but tries to provide a platform for a variety of applications.


<slide id=3 cap="Round 3">
<h2>Round 3: Applications and Users</h2>
<p>
In contrast to the previous rounds, which were
primarily technology-oriented,
in this round the focus of attention lay on the
needs of particular areas of application.
Ian Palmer [_VAPIS] presented an exhaustive overview
of APIs for 3D and Virtual Reality applications, and proposed
the notion of <i>virtual APIs</i>.
Pierre Wellner [_Tele] discussed the requirements
APIs should meet  to enable resellable services.
Thomas Koch [_Meta] discussed the needs for
group-aware Web applications.
Daniel Mavrakis [_VEMMI] presented a protocol
allowing for the integration of Tele-services
with the Web.
And finally, Mark Brown [_FastCGI] discussed the employment
of FastCGI to improve the server-side generation of
documents. (See also his <a href=comments/mbrown.html>comments</a>
on the workshop.)
</slide>
<slide id=4 cap="Round 4">
<h2>Round 4: Objects and more objects</h2>
<p>
The last round was devoted to the employment
of object technology and interfacing the Web with
data repositories.
Bastiaan Sch&ouml;nhage [_DejaVu] discussed the Web components
of the DejaVu framework.
Anselm Baird-Smith [_Jigsaw] presented the design
and realization of Jigsaw, a Java-based server.
Mala Anand [_Broker] presented Oracle's solution
to server-side plug-ins.
Finally, replacing Andy Wood [_CAMEO],
Benjamin Renaud
from the Java Team discussed the new releases
of the Java libraries, providing APIs for
2D/3D graphics, security, mobile methods,
persistence and database access.
</slide>

<slide id=www5-discussion cap="Discussion - What are APIs?">
<h2>Discussion - What are APIs?</h2>
<p>
The application areas and solutions, whether object-oriented
or not, covered a wide range of interests and
did not suggest a canonical approach to the
definition and development of APIs.
In particular, as has been mentioned before,
the somewhat blurry demarcation between
computation models, languages and APIs seem to confuse
all of us.
Moreover, a <a href=catalogue.html>catalogue of APIs</a>
seemed to be beyond our reach.
<p>
An attempt to overcome the confusion by
restricting ourselves to discussing the
requirements for the (future) Java class libraries
failed, surprisingly, because the majority felt
that the restriction to a particular (!)
language was not appropriate.
<p>
So the workshop was in danger of being halted,
with a number of questions unanswered.
What actions should we take in terms of recommendations
to the W3C?
What perspectives can we (meaningfully) distinguish?
And, what (exactly) are our areas of interest?
For example, although many of the solutions
proposed were object-oriented in spirit,
only few were so in the flesh.
</slide>

<slide id=www5-API cap="Dimensions of APIs">

<dl>
<dt><b>A</b>ctions
<dd><ul>
    <li>Define a distributed model of computation
	that suits the Web.
    <li>Define canonical (language-independent?) 
	object models for ... resources, application domains ...
    </ul>
<dt><b>P</b>erspectives
<dd><ul>
    <li> servers - extensions
    <li> browsers - clients, viewers, configuration
    <li> agents  - e.g. payment
    </ul>
<dt><b>I</b>nterests
<dd><ul>
    <li> distributed objects
    <li> plug-in components
    <li> formalization of requirements and solutions
    </ul>
</dl>
<p>
Nevertheless, we managed to break out of this impasse,
by reconsidering what APIs are meant for,
the development of Web-aware applications,
and we made a start of listing our basic <a href=needs.html>needs</a>.
</slide>

<slide id=www5-needs cap="Basic needs">
<h2>Basic needs</h2>
In the discussion we came up with the following list
of basic needs, that is functionality required
by application developers:
<ol>
<li> resolving URLs
<li> authentication of users
<li> communication (and negotiation)
<li> distribution - eg. applets accross sites
<li> security - authentication of network identity
<li> configuration - also the delegation of configuration
<li> billing and payment
<li> application persistence - i.e. states
<li> QOS and QOT demands - e.g. bandwidth
<li> notification and monitoring
</ol>
<p>
An additional need that was mentioned later on is
support for multiple (natural) languages, see [_MAITS].
</slide>
Admittedly, in this list of basic needs,
no distinction is made between the various possible
perspectives, server-side, client-side, or what have you.
The best we can do, as was suggested by Frystik Nielsen,
is to gain experience with existing APIs
(such as the ones listed in the <a href=catalogue.html>catalogue</a>
and share these with the community.

<slide id=catalogue cap="A catalogue of state of the art APIs">
<h2>A catalogue of state of the art APIs</h2>

<h4>Language support</h4>

<ul>
<li> [_ILU]
</ul>

<h4>General</h4>

<ul>
<li> [_W3Reference]
</ul>

<h4>Server-side</h4>

<ul>
<li> [_ISAPI] documentation,
Microsoft Corporation, in ActiveX Alpha SDK,
http://www.msn.com/download/sdk/msactivedk.zip, 1996 

<li> 
NCSA server documentation,
http://hoohoo.ncsa.uiuc.edu 1995

<li> [_NSAPI],
Netscape server API documentation
http://home.netscape.com/newsref/std/server_api.html, 1995
ftp://ftp.netscape.com/server/fasttrack/unix/, 1996 

<li> [_Apache]
<li> [_FastCGI]
<li> [_Broker]

</ul>

<h4>Client-side</h4>
<ul>
<li> [_DejaVu]
</ul>
</slide>



<slide id=www5-conc cap="Conclusions">
<h1>Conclusions</h1>
<p>
Conclusions, at this stage, seem to be premature.

<h4>Recommendations to W3C</h4>
<ol>
<li> Develop Corba compliant API for LibWWW?
<li> Define formalized object models for the Web?
</ol>
<p>
As concerns (1), the general feeling was
that in its current state CORBA does not provide
an answer.
As an alternative, ILU was mentioned.
<p>
Very surprisingly, a vote on (2) resulted
in a majority in favor of a more formal approach.
However, not in a prescriptive fashion but rather to better understand
the nature of the Web and the basic needs of
application developers.
</slide>
<p>
Hopefully, this is not the end of the discussion.
To the participants, thanks for your contribution.

Anton Eliens


<h2>References</h2>

<bibliography>

%K Apache
%A Robert Thau,
%T Design considerations for the Apache Server API,
%O //link:local/papers/extra/Apache.html

%K ApacheServer
%T Apache server documentation,
%O http://www.apache.org 1995

%K Broker
%A Seshu Adunuthula &amp; Mala Anand,
%T Web Request Broker API,
%O //link:local/papers/Broker.html

%K CAMEO
%A Andy Wood,
%T CAMEO: Supporting Observable APIs.
%O //link:local/papers/CAMEO.html

%K Configure
%A Robert Thau,
%T API support for Delegating Control over Server Configuration.
%O //link:local/papers/Configure.html

%K DejaVu
%A Anton Eli&euml;ns, Jacco van Ossenbruggen & Bastiaan Sch&ouml;nhage,
%T The DejaVu framework -- a software architecture for Web
%O //link:local/papers/DejaVu/index.html

%K DOOWWW
%A Bill Janssen &amp; Mike Spreitzer,
%T A Distributed-Object-Oriented World Wide Web
%O //link:local/papers/DOOWWW.html

%K FastCGI
%A Mark Brown
%T FastCGI: A High-Performance Gateway Interface
%O //link:local/papers/FastCGI.html

%K HIPPO
%A Richard Connor
%T HIPPO: High-level Internet Programming with Persistent Objects
%O //link:local/papers/HIPPO.html

%K Hyperspace
%A Advanced Interaction Group, Birmingham
%T Hyperspace 
%O http://www.cs.bham.ac.uk/~amw/hyperspace/

%K ISAPI
%T ISAPI documentation,
%O Microsoft Corporation, in ActiveX Alpha SDK,
http://www.msn.com/download/sdk/msactivedk.zip, 1996 

%K Infomaster
%A Logic Group at Stanford
%T Infomaster
%O http://logic.stanford.edu/ http://infomaster.stanford.edu/

%K Interactive
%A Paul Burchard
%T Towards an Interactive Web
%O http://www.cs.princeton.edu/~burchard/www/interactive/embed.html
http://www.geom.umn.edu/hypernews/get/interactive/index.html

%K Jewels
%A D.L. Parnas
%T Why software jewels are rare
%O IEEE Computer 29(2), 1996, pp.57-60

%K Jigsaw
%A Anselm Baird-Smith,
%T Jigsaw, An Object-Oriented Web server
%O //link:local/papers/Jigsaw.html

%K MAITS
%A Keld Simonsen
%T Specifications and inplementation of APIs for multilingual telematic
services
%O http://www.dkuug.dk/maits/

%K Meta
%A Thomas Koch,
%T MetaWeb -- a general purpose interface to shared interactive
applications in the World-Wide Web.
%O //link:local/papers/Meta.html

%K Model
%A  Luca Cardelli,
%T What is the Web's Model of Computation?
%O //link:local/papers/Model.html

%K NCSA
%T NCSA server documentation,
%O http://hoohoo.ncsa.uiuc.edu 1995

%K NSAPI
%T Netscape server API documentation
%O http://home.netscape.com/newsref/std/server_api.html, 1995
ftp://ftp.netscape.com/server/fasttrack/unix/, 1996 

%K Obliq
%A Luca Cardelli,
%T Obliq,
%O http://www.research.digital.com/SRC/Obliq/Obliq.html

%K Tele
%A Pierre Welner
%T A Web-based API for Teleconferencing
%O //link:local/papers/Tele.html

%K UOD
%A Joakim Eriksson, Niclas Finne &amp; Sverker Janson,
%T Surfing the market and making sense of the web:
Interfacing the web to an open agent-based market infrastructure.
%O //link:local/papers/UOD.html

%K URA
%A Leslie L. Daigle &amp; Sandro Mazzucato,
%T Building Specialized Web Services -- Where to Put the API,
%O //link:local/papers/URA.html

%K V6
%A Bernard Lang and Fran\147ois Rouaix,
%T The V6 Engine.
%O //link:local/papers/V6/index.html

%K VAPIS
%A I.J.Palmer, N.Chilton &amp; R.A.Earnshaw,
%T Web Programming Environments: Towards a Virtual API.
%O //link:local/papers/VAPIS/index.html

%K VEMMI
%A Daniel Mavrakis,
%T VEMMI: a new On-line Client/Server Multimedia
Protocol for the Internet.
%O //link:local/papers/VEMMI.html

%K VIM
%A University of Southhamptoon,
%T The HCM Virtual Multicomputer Project,
%O http://vim.ecs.soton.ac.uk/

%K WNAPI
%T WN server documentation,
%O http://hopf.math.nwu.edu, 1995


%K WVDL
%A <a href=mailto:techno@sound.net>Jon Backy</a>,
%T The WDVL Journal,
%O http://www.stars.com/Spectrum/

%K W3CActivity
%A W3C,
%T W3C Activity areas,
%O http://www.w3.org/pub/WWW/Consortium/Prospectus/ActivityList

%K W3COOP
%A W3C,
%T WWW and OOP,
%O http://www.w3.org/pub/WWW/OOP/

%K W3CReference
%A Henrik Frystyk Nielsen,
%T Libwww API
%O //link:local/papers/W3C.html

</bibliography>


<hr>
<a href=mailto:eliens@cs.vu.nl>eliens@cs.vu.nl</a>
