Workshop Proposal

Logic Programming and the Web

Goals:
Logic programming has proven its merits in a variety of
application areas including diagnostic expert systems, natural language
processing and agent-based control systems.
The goal of the workshop is to assess whether and in what way
logic programming language constructs and programming techniques
may be applied to profit from a knowledge-based
approach to developing applications for the Web.
Potential advantages of such an approach include knowledge-level
reasoning about resources and user models and the application of
logic-based inference techniques to information filtering.

Recently several implementation of Prolog in Java
have been announced. Another goal of the workshop is to
discuss the merits of the various implementations of Prolog for the Web,
and to assess the criteria that must be met to adopt a
logic programming language as a mature vehicle for the development 
of Web applications.

In particular agent applications may benefit from a high level 
formalism as offered by logic-based programming languages.
Currently there seems to be a gap between the primarily logic-based
models of cooperating agents and the realization of agents in a variety
of primarily imperative programming languages, a gap that
may be bridged by applying declarative logic-based programming
languages for the realization of software agents.

Issues include:

* Language constructs -- failure, backtracking, concurrency
* APIs and Utilities -- Web access, document type support
* Applications -- search, agents, intelligent interfaces

Persons to contact:

Michael Winikoff  -- author of W-Prolog
Paul Tarau and Bart Demoen -- developers of Prolog interpreter of Java

References:

<ul>
<li> W-Prolog http://munkora.cs.mu.oz.au/%7Ewinikoff/wp/ 
<li> jProlog  http://www.cs.kuleuven.ac.be/~bmd/PrologInJava/
<li> Prolog for Servers -- http://www.amzi.com/prolog.htm
<li> WebLS -- http://www.amzi.com/webtech.htm
<li> Shareware Repository -- http://www-cgi.cs.cmu.edu/afs/cs/project/ai-repository/ai/lang/prolog/impl/0.html
</ul>


Workshop Chairman and Organizer:


Anton Eliens
Vrije Universiteit,
De Boelelaan 1081,
1081 HV Amsterdam
The Netherlands

eliens@cs.vu.nl
www.cs.vu.nl/~eliens
