<document>

<h1> Workshop: Logic Programming and the Web</h1>

Anton Eliens, eliens@cs.vu.nl, Vrije Universiteit. Amsterdam
<hr>
<a href=http://www.cs.vu.nl/~eliens/WWW6/index.html>Workshop Proceedings</a>
<hr>

<h4>Abstract</h4> 
Logic programming has proven its merits in a variety of
application areas including diagnostic expert systems, natural language
processing and agent-based control systems. The goal of the workshop is to
assess whether and in what way logic programming language constructs and
programming techniques may be applied to profit from a knowledge-based
approach to developing applications for the Web. Potential advantages of
such an approach include knowledge-level reasoning about resources and user
models and the application of logic-based inference techniques to
information filtering.
 
Recently several implementations of Prolog in Java have been announced.
Another goal of the workshop is to discuss the merits of the various
implementations of Prolog for the Web, and to assess the criteria that must
be met to adopt a logic programming language as a mature vehicle for the
development of Web applications.

In particular agent applications may benefit from a high level
formalism as offered by logic-based programming languages.
Currently there seems to be a gap between the primarily logic-based
models of cooperating agents and the realization of agents in a variety
of primarily imperative programming languages, a gap that
may be bridged by applying declarative logic-based programming
languages for the realization of software agents.
 
Issues include:

<ul>
<li> Language constructs -- failure, backtracking, concurrency
<li> APIs and Utilities -- Web access, document type support
<li> Applications -- search, agents, intelligent interfaces
</ul>

<h3>Related Material</h3>
<ul>
<li>Compulog Net Workshop: <a href=http://www-lp.doc.ic.ac.uk/lp-internet.html>
Logic Programming and the Internet</a>
<li>Repository: <a href=http://www.clip.dia.fi.upm.es/logic_programming_repositories.html>Logic Programming on the WWW</a>
<li>Clip/CompuLog-Net Page:
<a href=http://www.clip.dia.fi.upm.es/lpnet/index.html>Internet and WWW programming using LP and CLP</a>
</ul>

<hr>

<so wasp>
</document>
