%%@ community.pl - a Prolog rendering

community(W,N):-
	world(W,Rw,Nw),
	people(Rw,_,Nw,Np),
	company(Np,N).

world(casa).
world(vu).
world(cwi).


world([H|T],T,[world(H)]) :-
	world(H).

people(L,R,W,N):-
	people(L,R,S),
	append(W,S,N).

people([],_,[]).
people([H|T],R,[person(H)|N]) :-
	person(H),
	people(T,R,N).
people([H|T],[H|R],N) :-
	people(T,R,N).

person(joe).
person(marilyn).
person(bill).
person(marcel).

company(W,[company(X)|W]) :-
	member(world(X), W),
	member(person(P1),W),
	member(person(P2),W),
	not( P1 = P2 ).


go :- community([casa,joe,marcel],W), write(W), nl.

%%</>
