<HTML><HEAD><TITLE>SWI-Prolog Reference Manual: Section 1.1</TITLE><LINK REL=home HREF="Title.html">
<LINK REL=contents HREF="Contents.html">
<LINK REL=index HREF="Index.html">
<LINK REL=summary HREF="sec-B.html">
<LINK REL=previous HREF="sec-1.html">
<LINK REL=next HREF="sec-1.2.html">
</HEAD>

<BODY>

<HR><CENTER><A HREF="Title.html">Home</A>
<A HREF="Contents.html">Contents</A>
<A HREF="Index.html">Index</A>
<A HREF="sec-B.html">Summary</A>
<A HREF="sec-1.html">Previous</A>
<A HREF="sec-1.2.html">Next</A>
</CENTER>

<HR>

<H2><A NAME="sec:1.1">1.1 SWI-Prolog</A></H2>

<P>SWI-Prolog has been designed and implemented to get a Prolog 
implementation which can be used for experiments with logic programming 
and the relation to other programming paradigms. The intention was to 
build a Prolog environment which offers enough power and flexibility to 
write substantial applications, but is straightforward enough to be 
modified for experiments with debugging, optimisation or the 
introduction of non-standard data types. Performance optimisation is 
limited due to the main objectives: portability (SWI-Prolog is entirely 
written in C and Prolog) and modifiability.

<P>SWI-Prolog is based on a very restricted form of the WAM (Warren 
Abstract Machine) described in <CITE><A HREF="sec-C.html#Bowen:83">Bowen &amp; 
Byrd, 1983</A></CITE> which defines only 7 instructions. Prolog can 
easily be compiled into this language and the abstract machine code is 
easily decompiled back into Prolog. As it is also possible to wire a 
standard 4-port debugger in the WAM interpreter there is no need for a 
distinction between compiled and interpreted code. Besides simplifying 
the design of the Prolog system itself this approach has advantages for 
program development: the compiler is simple and fast, the user does not 
have to decide in advance whether debugging is required and the system 
only runs slightly slower when in debug mode. The price we have to pay 
is some performance degradation (taking out the debugger from the WAM 
interpreter improves performance by about 20%) and somewhat additional 
memory usage to help the decompiler and debugger.

<P>SWI-Prolog extends the minimal set of instructions described in
<CITE><A HREF="sec-C.html#Bowen:83">Bowen &amp; Byrd, 1983</A></CITE> to 
improve performance. While extending this set care has been taken to 
maintain the advantages of decompilation and tracing of compiled code. 
The extensions include specialised instructions for unification, 
predicate invocation, some frequently used built-in predicates, 
arithmetic, and control (<A HREF="sec-3.6.html#;/2">;/2</A>, <A HREF="sec-3.6.html#|/2">|/2</A>), 
if-then (<A HREF="sec-3.6.html#->/2">-&gt;/2</A>) and not (<A HREF="sec-3.6.html#\+/1">\+/1</A>).

<P>This manual does not describe the full syntax and semantics of 
Prolog, nor how one should write a program in Prolog. These subjects 
have been described extensively in the literature. See <CITE><A HREF="sec-C.html#Bratko:86">Bratko, 
1986</A></CITE>,
<CITE><A HREF="sec-C.html#Sterling:86">Sterling &amp; Shapiro, 1986</A></CITE>, 
and <CITE><A HREF="sec-C.html#Clocksin:87">Clocksin &amp; Melish, 1987</A></CITE>. 
For more advanced Prolog material see <CITE><A HREF="sec-C.html#Keefe:90">OKeefe, 
1990</A></CITE>. Syntax and standard operator declarations confirm to 
the `Edinburgh standard'. Most built in predicates are compatible with 
those described in <CITE><A HREF="sec-C.html#Clocksin:87">Clocksin &amp; 
Melish, 1987</A></CITE>. SWI-Prolog also offers a number of primitive 
predicates compatible with Quintus Prolog<A NAME=back-to-note-1 HREF="Notes.html#note-1"> (1)</A>
<CITE><A HREF="sec-C.html#QUINTUS:manual">Qui, 1997</A></CITE> and 
BIM_Prolog<A NAME=back-to-note-2 HREF="Notes.html#note-2"> (2)</A>
<CITE><A HREF="sec-C.html#BIMPROLOG:manual">BIM, 1989</A></CITE>.

<P>ISO compliant predicates are based on ``Prolog: The Standard'',
<CITE><A HREF="sec-C.html#Deransart:96">Deransart </EM><EM>et al.</EM>, 
1996</A></CITE>.

