<document>
@+ <a href=@talk-visualize-example.html target=_top>Example --  re-designing business processes</a>

<slide type=fig id=screenshot cap="Screenshot">
<image name=@figures/vis/screenshot>
</slide>

Our example concerns the GAK (Gemeenschappelijk Administratie Kantoor), which is the largest provider of social
security in the Netherlands. The GAK organization's main services are the registration and collection of insurance
premiums, and the payment of social security benefits. 

ASZ, which is the IT company of the GAK Group, builds and maintains the information systems that the GAK is using.
Currently, the information infrastructure consists of several large databases, hundreds of separate applications and little
integration. To improve this, ASZ is investigating a software architecture that combines the databases, legacy software and
new applications into a highly integrated system. 

This development will certainly have an impact on the business processes at the GAK. The company will be able to
improve current services and to offer new ones. However, deciding how the new business processes must be organized
and what the consequences of some decisions will be is not at all trivial. 

To assist the managers in studying the alternatives we create business-process simulations to execute the re-design
alternatives (Eli&#235;ns et al., 1996). The managers are now able to run the simulations and experiment with the
re-design alternatives themselves. To fully exploit the potential of business simulations we allow the managers to visualize
and discuss both the results of the simulation, e.g. the costs and profits, and the running simulation itself, e.g. to illustrate the
activities in the re-designed alternative. 




%%@ Example: registration of new companies 

As a concrete example, consider the process of registering the employees of a newly established company for social
security. In the past, the employer had to go to a number of counters to fill in the required forms. When the client had
forgotten something needed for the registration, he had to go back to get it and start the whole procedure again. 

As a re-designed alternative we want to explore two options. First, all the paper forms could be combined into a single
computer application. All forms could then be filled in at once, in dialogue with a single GAK employee. Second, a GAK
employee might be able to go to the newly established company. There, using a laptop, she could fill in all of the needed
information by asking it directly to the client on the spot. 

To decide which alternative is preferable, we have to consider a number of aspects including the cost of the alternative, the
satisfaction of the clients, and the time needed to register the company. 

A visualization of the business process flow is useful in explaining the business process alternatives, . This illustrates who is
performing which tasks and how the information flows through the model. Additionally, a geographical visualization shows
how far and how often clients and employees of the GAK have to travel. The costs, waiting times and other statistical
information of the re-designed alternatives can be presented using statistical visualizations, such as charts and
histograms. 

The decision makers, who are spread out over the country, plan to make the definitive decision at a meeting. However,
before that, they want to prepare and discuss several alternatives. The above mentioned visualizations offer the decision
makers (and other interested employees) a common ground for discussion. 

Essentially, we want to support two forms of collaboration: synchronous distributed and face to face (Ellis et al., 1991). In
order to help the participants prepare for the meeting, we first support synchronous distributed collaboration where the
users cooperate at the same time but in different places. Secondly, at the meeting, where the decisions are made, the
decision makers will discuss the selected alternatives face to face, i.e. same time, same place. 


:@ Running simulations
In \sliref{screenshot} a screenshot is displayed of the desktop of a decision maker participating in a collaborative session as described in the
example of Section 2. We describe a scenario of how the user gets to this display. 

The decision maker starts a Java and VRML enabled Web-browser and follows a link pointing to a DIVA server. The
resulting HTML file will setup the user environment. First, the user has to log in, making available her name and network
address, and after that she can choose from one or more sessions to join. Once the user enters a session, she will be
assigned a role and then gets a default or enforced perspective. The VRML world showing her view is embedded in the
Web page. Two Java applets will contain the session interface and the collaboration interface (these are not shown in the
screenshot). 
<p>

With a push on a button she is able to request a remote control, which will arrive at her environment (assuming that she is
allowed to do so). Once the remote control arrives in the form of a mobile object, this object pops up a remote control user
interface on the display. The user is then able to control the simulation that is associated with the remote control. In Figure 4
the remote control can be used to run, stop and reset the simulation. In addition, the speed of the simulation as well as three
parameters can be changed. Changes to the simulation will accordingly appear in the visualization in the browser window. 

</document>
