<document>

@* <a href=g-gen.html>Generic types</a>
<hr><a href=@talk-generic.html target=_top>slides</a><hr>

\label{generic}


Reuse of software is one of the ways in which to produce reliable systems,
that is, the reuse of reliable software.
Many of the data types that are used to specify software systems
have a lot in common.
For instance, there is little difference between
a stack of integers or a stack of strings,
or a stack for any other data type.
So it would be more convenient to have a generic stack,
which may be used as or instantiated to a stack of integers, strings
or whatever.
Evidently, the various container types
such as $stack$, $list$, $bag$ and $set$ are
likely candidates for being realized by generic types.

\vfig{0.5}
<slide id=2-generic caption="Generic types">
@ Generic types
\ifsli{\vspace{-0.5cm}}{}
<I
- {\em polymorphic types} -- pointers, $void*$ 
- {\em parametrized types} -- template classes
I>
Generic types are essential for {\em programming in the large}
</slide>
\vstr{0.5}

The C++ language supports two kinds of generic types,
{\em polymorphic} (pointer) and {\em parametrized}.
\see{2-generic}
In section \ref{inheritance} we have already seen that an abstract
or generic shape type may be specified and later refined into concrete types,
giving rise to a polymorphic hierarchy.
The base class from which this hierarchy is
derived may be regarded as a constraint
with respect to the possible element types 
of a generic container.
A similar notion of type hierarchy is exploited in the solution of
generic types involving $void$ pointers.
The use of $void*$ was one of the two ways
to deal with unconstrained generic types in C++ before
templates were introduced in version 3.0.
The other way was the use of equally error-prone
macro definitions.
The use of $void*$ will be illustrated as a warning;
this is how it should $not$ be done.
The preferred
way in which to specify generic types in C++ is to employ
the template construct, which allows the programmer
to parametrize a class or function definition
with a type parameter.

<so gen-base>
<so gen-temp>

</document>
