@+ Program structure 
\label{Structure}

\nop{
The {\em hush} library is intended
to provide a convenient way
to program window-based applications in C++.
As a first example of using {\em hush},
we will look at a simple program 
written in C++ that uses a graphical
interface defined by a Tcl/Tk script.
}

\c{
The {\em hush} library is intended to
provide a convenient way to program window-based applications in C++.
Basically, there are two considerations
that may lead you to employ
the {\em hush} library.
When you are familiar with Tcl/Tk and you need
to combine Tcl scripts with C++ code,
you may use {\em handler} classes to
do so in a relatively type-secure way.
On the other hand, when you want to program
graphical user interfaces in C++,
you may employ the {\em hush} widget
classes.
In the latter case, you may
choose to remain ignorant of
the underlying Tcl/Tk implementation
or exploit the Tcl script facility
to the extent you wish.
\nop{
Whether you choose to use Tcl scripts
or not, the structure of the program
is to a large extent the same.
}
}

\nop{
As an illustration of the structure of a program
using {\em hush},
we will look at a simple program written in C++
that uses a graphical interface defined
by a Tcl/Tk script.

After discussing the example,
we will look at
a brief overview of the classes
that constitute the {\em hush} library.
A more detailed description will
be given of the {\em kit} class,
that encapsulates the embedded Tcl interpreter,
and the {\em session} class, that shields
of the details of the window environment.
}

."so example
.so overview
.so kit
.so session
