<document class=article>
@ Comments on referee-reports WASP -- Web Agent Support Program

Our comments primarily address the comments made
by the referees, i.e. Referee \#1 A.1.2, D.6 and Referee \#2 C.

@ A SCIENTIFIC QUALITY -- originality

Referee \#1 remarks that, in the proposal, there is <i>little indication of
exact technology and architectures</i>:
<ul>
<li> As concerns technology, the realization of WASP
(and in particular Pamela) is based on the programming
language DLP (extended with Internet capability),
and the facilities provided by the <i>hush</i> library
and its extensions (both developed by SE/VU,
see refs [17,19,20] of the proposal).
<li> In addition, at the level of design, we exploit
DESIRE (developed by AI/VU, see refs [1,2,16,22] of the proposal).
In effect, the integration these technologies (DESIRE and DLP)
contributes, as rightly observed by Referee \#2, to the originality
of our approach.
<li> From an architectural point of view our approach
is basically a client-server architecture, with <i>agents</i>
as user-dedicated clients.
For the communication and Internet capabilities
we exploit existing technology (TCP/IP, HTTP, CORBA).
As regards the integration of the various components, this will
be done along the lines of the <i>handler/event</i> mechanism employed
in the <i>hush</i> library and its extensions.
</ul>

@ B RELEVANCE TO SOCIETY -- technology transfer

Referee \#1 remarks that the technology transfer should be made clear.
<ul>
<li> 
Apart from scientific publications (in conferences and journals) the aim of WASP
is to create a prototype information discovery agent, Pamela.
As is often the case with technology developed for Internet, we will make
this prototype tool available through Internet, and announce it through
both the publications, mailing lists, netnews and our informal contacts with
colleagues. Feedback from early users will guide the development of subsequent
versions of Pamela.
Contacts with industry exist for applying the technology to be developed in
commercial and competitive environments. The contact with Rabo, mentioned in the
Appendix to the WASP proposal, has already resulted in a contract
between Rabo and
the VU for the application of agent technology in banking.
</ul>

Referee \#2 remarks that the social significance
of the WASP proposal is strongly
dependent on the social significance of the Web.
<ul>
<li> It is difficult to predict whether the popularity and social significance of the
Web will continue to increase,
or whether the Web will be replaced by a different
architecture.
The one thing which is certain is that world-wide global networking
will play an ever more important role in both the economic and social aspects
of society. As is evident from the listed publications, the applicants monitor
these evolutions closely, and take active part in them. In the architecture of
the tool to be developed, the existence of information items which are uniquely
addressable is important, but the exact data representation and the protocol for
accessing the objects are of little importance. The extraction of information from
objects, and the access routines, will be embedded in separate modules, which can
be replaced should the Web be superseded by another technology. The core of Pamela
would not be affected by such a change, making the WASP research effectively
independent of whether the global networking environment of the future will be
the Web as we know it, or a different network architecture.
</ul>



@ C (4)  COMPETENCE -- project groups

Referee \#1 remarks that there is little evidence
that the existing competence will be integrated in an effective way.
<ul>
<li> Our answer to this remark can be found under <i>D (6) PLANNING</i>,
where the scientific coordination is outlined in more detail.
In addition, the intended post-doc (J. Engelfriet, see below)
will have such coordination as one of his tasks.
</ul>

<p>
Referee \#2 places some doubts on the theoretical competence
of the participants.
<ul>
<li> Apart from the theoretical expertise of the VU/AI group,
as detailed below, it may be remarked that the project leader
(Eliens) worked in the area of formal semantics
(during his thesis, supervised by prof. dr. J.W. de Bakker).
The CV of de Bra also shows an interest and expertise
in foundational research. 
<li>
Actually, both referees \#1 and \#2 have been unable to accurately evaluate
the theoretical competence
of the research groups participating in WASP, or even of just the applicants,
because the WASP proposal does not provide this information.

The list of publications attached to the WASP proposal only mentions those
selected publications which the applicants considered most relevant to WASP.
These publications do not describe the whole research area of the applicants,
let alone of their whole research groups.
Therefore, a short description of the areas of competence of the applicants is
given below, as well as a description of the competence of their research groups.
See appendix I. 
It goes without saying that where needed or useful, other members of the
applicants' research groups will assist in the WASP project.

<li>
Candidate for the postdoc position:
The main candidate for the postdoc position in the project is J.
Engelfriet. He is an excellent AIO researcher with both formal and 
applied interests and capabilities. His Ph.D. Thesis will be finished 
within one and a half year and he is highly
interested in participating in this project.
</ul>

@ C (5) COMPETENCE -- project leader(s)

Referee \#1 remarks that the managerial
capacity of the project leader
has not been demonstrated in the proposal.
<ul>
<li>
The proposal format does not distinguish between project management and coordination
and scientific leadership.

The selection of a single "project leader" is intended to keep the project
management and coordination centralized. The coordinating project leader will
organize and supervise the frequent meetings of the researchers involved in WASP.
He will ensure that the different researchers communicate frequently and
collaborate actively on both the fundamental aspects of WASP and in the development
of the tool Pamela.

<li>
Scientific guidance and leadership will come from all four applicants,
without predefined hierarchy.
In this sense they will act as a scientific management board
with meetings on a regular basis. See <i>D (6) PLANNING</i>.

<li>
With respect to the managerial capability of the
project leader, it can be remarked that he has been chairman
of the Facultaire Onderwijscommissie for two years.
In addition, he has gained experience as leader and coordinator
of the DejaVu project group at the section Software Engineering
of the Vrije Universiteit.
</ul>


@ D(6) PLANNING -- activity and coordination

Referee \#1 comments that the tasks involved are not well-defined
and that the coordination between the groups not made clear.
In addition, the features of Pamela have not been made 
sufficiently explicit.
<ul>
<li> First of all, it must be remarked that the target
system <i>Pamela</i> itself is explicitly intended to stimulate and 
regulate the cooperation between the participating
research groups.
<li> In the design and development of <i>Pamela</i>
the following phases can be distinguished:
  <ol>
  <li> Functional Design (Year 1..2)
  <li> Prototype Realization (Year 2)
  <li> Evaluation  (Year 2..3)
  <li> Final Design and Realization (Year 3..4)
  </ol>
We will specify the functional design
in DESIRE.
Also in the first year, work will be done on
components for the realization of the prototype,
in particular for retrieval capability, Internet access,
and presentation facilities.
The evaluation of the prototype realization
will be done in cooperation with the ASZ-GAK group
and Rabofacet.
<li> Periodically (every three months), meetings will be held
in which the OIO researchers (and later the post-doc)
and the scientific management team participate,
to ensure the coordination of ideas and activities.
Also, in the second and third year there will be frequent
(bi-monthly) meetings between the OIOs and the post-doc.
<li> As concerns its functionality,
the final version of <i>Pamela</i> should include
 <ul>
 <li> search capability,
 <li> modifiable user preferences, and
 <li> (multimedia) presentation facilities.
 </ul>
A more detailed specification of its functionality, however,
must be considered as one of the tasks of the project.
</ul>
</document>
