<document>
<h1>Development of intelligent agents on the World Wide Web</h1>

Department of Computer Science, Sections Software Engineering (contact 
person A. Eliens: eliens@cs.vu.nl), and Artificial Intelligence (contact 
person J. Treur: treur@cs.vu.nl)
<p>
This project for students in Software Engineering or in Artificial 
Intelligence is part of the larger research project
<a href=http://www.cs.vu.nl/~eliens/dv/projects/wasp.html>WASP</a>
(Web Agent 
Support Program), which concerns the development of Web Agent Support to 
enable average users to keep track of relevant information on the Web. 
<p>
In a relatively short time, the Web has become a de facto standard for 
the dissemination and retrieval of information. Due to the exponential 
growth of the Web and the information that it provides, finding relevant 
information has become more and more difficult. In particular, browsing 
is in most cases no longer appropriate for the user who is searching for 
particular pieces of information.
<p>
It is our view that, in the near future, access to the Web will 
increasingly be mediated by intelligent
helper applications, software agents, that assist the user in finding 
relevant and interesting
information, and in announcing newly contributed information for a 
selective group of interested users.

<h4>WASP</h4>
The goal of the project WASP as a whole is envisaged to result in a 
framework providing support for: 
<ul>
<li>       intelligent navigation and information retrieval, 
<li>       information and document maintenance, 
<li>       user interfaces for Web-aware applications, 
<li>       dynamic documents with user-defined applets, 
<li>       declarative descriptions of agent-behavior based on 
user-preferences, 
<li>       declarative modeling of coordinated and cooperative behavior of 
software agents, and 
<li>       programming single and multi-agent systems. 
</ul>


<h4> Pamela </h4>

As one of the sub-tasks within the WASP project, Pamela (Personal 
Assistant for Maintaining Electronic Archives) will be developed. For a 
selected domain, a Personal Agent for Maintaining Electronic Archives 
will be developed that assists the human user in gathering material for 
which a preference has been indicated. Gathering information will be 
done in cooperation with personal assistants defined for other human 
users. Pamela will be able to notify the human user about the discovery 
of any relevant material and will provide for multimedia facilities to 
present the material and to browse related information.

<h4> Functionality </h4>

As concerns its functionality, the final version of Pamela should 
include 
<ul>
<li>   autonomous and on-demand search capabilities 
<li>   capabilities to announce new information to a selective group other 
Personal Assistants that are known to have interest in the type of 
information 
<li>   (user- and system) modifiable user preferences, and 
<li>   (multimedia) presentation facilities 
</ul>

<h4> Technology</h4>

As concerns implementation technology, the realization of WASP (and in 
particular Pamela) is based on the distributed logic programming
language DLP (developed by SE/VU)
and the Java Internet Platform (being developed also by SE/VU).
<p>
At the level of design, the compositional multi-agent design method 
DESIRE (developed by AI/VU) will be exploited. In effect, the 
integration these technologies (DESIRE and DLP) is one of the aims of 
the project. 
<p>
From an architectural point of view our approach is basically a 
client-server architecture, with
agents as user-dedicated clients. For the communication and Internet 
capabilities existing technology (TCP/IP, HTTP, CORBA) will be 
exploited. 

<h4>Contact</h4>

More information can be acquired at 
http://www.cs.vu.nl/~eliens/dv/projects/wasp/wasp.html or by contacting  
A. Eliens: eliens@cs.vu.nl (SE), or J. Treur: treur@cs.vu.nl (AI)
</document>
